/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 152;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(1),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 63,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 151,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 137,
  Feature_HasMMXBit = 109,
  Feature_HasSSE1Bit = 49,
  Feature_UseSSE1Bit = 56,
  Feature_HasSSE2Bit = 48,
  Feature_UseSSE2Bit = 57,
  Feature_HasSSE3Bit = 40,
  Feature_UseSSE3Bit = 66,
  Feature_HasSSSE3Bit = 110,
  Feature_UseSSSE3Bit = 67,
  Feature_UseSSE41Bit = 64,
  Feature_UseSSE42Bit = 71,
  Feature_HasSSE4ABit = 81,
  Feature_NoAVXBit = 77,
  Feature_HasAVXBit = 58,
  Feature_HasAVX2Bit = 52,
  Feature_HasAVX1OnlyBit = 50,
  Feature_HasEVEX512Bit = 144,
  Feature_HasAVX10_2Bit = 108,
  Feature_HasAVX10_2_512Bit = 107,
  Feature_NoAVX10_2Bit = 70,
  Feature_HasAVX512Bit = 94,
  Feature_UseAVXBit = 54,
  Feature_NoAVX512Bit = 45,
  Feature_HasCDIBit = 98,
  Feature_HasVPOPCNTDQBit = 102,
  Feature_HasDQIBit = 96,
  Feature_NoDQIBit = 68,
  Feature_HasBWIBit = 97,
  Feature_NoBWIBit = 65,
  Feature_HasVLXBit = 95,
  Feature_NoVLXBit = 44,
  Feature_NoVLX_Or_NoBWIBit = 62,
  Feature_HasVNNIBit = 104,
  Feature_HasVP2INTERSECTBit = 106,
  Feature_HasFP16Bit = 100,
  Feature_HasAVXVNNIINT16Bit = 93,
  Feature_HasAVXVNNIINT8Bit = 88,
  Feature_HasAVXVNNIBit = 82,
  Feature_NoVLX_Or_NoVNNIBit = 83,
  Feature_HasBITALGBit = 105,
  Feature_HasPOPCNTBit = 69,
  Feature_HasAESBit = 74,
  Feature_HasVAESBit = 76,
  Feature_NoVLX_Or_NoVAESBit = 75,
  Feature_HasFXSRBit = 41,
  Feature_HasX87Bit = 39,
  Feature_HasXSAVEBit = 126,
  Feature_HasXSAVEOPTBit = 127,
  Feature_HasXSAVECBit = 128,
  Feature_HasXSAVESBit = 129,
  Feature_HasPCLMULBit = 78,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 79,
  Feature_HasVPCLMULQDQBit = 80,
  Feature_HasGFNIBit = 85,
  Feature_HasFMABit = 42,
  Feature_HasFMA4Bit = 46,
  Feature_NoFMA4Bit = 43,
  Feature_HasXOPBit = 47,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 142,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 84,
  Feature_HasFSGSBaseBit = 130,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 141,
  Feature_HasVBMIBit = 99,
  Feature_HasVBMI2Bit = 103,
  Feature_HasIFMABit = 101,
  Feature_HasAVXIFMABit = 86,
  Feature_NoVLX_Or_NoIFMABit = 87,
  Feature_HasRTMBit = 112,
  Feature_HasSHABit = 73,
  Feature_HasSHA512Bit = 90,
  Feature_HasSM3Bit = 91,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 59,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 111,
  Feature_HasMWAITXBit = 140,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 133,
  Feature_FPStackf32Bit = 37,
  Feature_FPStackf64Bit = 38,
  Feature_HasSM4Bit = 92,
  Feature_HasCLFLUSHBit = 60,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 125,
  Feature_HasRDPIDBit = 132,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 131,
  Feature_HasCX8Bit = 138,
  Feature_HasCX16Bit = 139,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 117,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 89,
  Feature_HasKLBit = 113,
  Feature_HasRAOINTBit = 123,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 114,
  Feature_HasAMXBF16Bit = 116,
  Feature_HasAMXINT8Bit = 115,
  Feature_HasAMXCOMPLEXBit = 118,
  Feature_HasAMXFP8Bit = 119,
  Feature_HasAMXTRANSPOSEBit = 120,
  Feature_HasAMXAVX512Bit = 121,
  Feature_HasAMXTF32Bit = 122,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 124,
  Feature_HasCRC32Bit = 72,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 135,
  Feature_NotLP64Bit = 134,
  Feature_NotWin64WithoutFPBit = 136,
  Feature_IsPSBit = 146,
  Feature_NotPSBit = 145,
  Feature_KernelCodeBit = 147,
  Feature_NearDataBit = 149,
  Feature_IsNotPICBit = 148,
  Feature_OptForSizeBit = 53,
  Feature_OptForMinSizeBit = 51,
  Feature_OptForSpeedBit = 143,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 55,
  Feature_ImportCallOptimizationEnabledBit = 35,
  Feature_ImportCallOptimizationDisabledBit = 33,
  Feature_CallImmAddrBit = 150,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 36,
  Feature_HasMFenceBit = 61,
  Feature_UseIndirectThunkCallsBit = 34,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  if (MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationEnabledBit);
  if (!MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationDisabledBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasAVXNECONVERT,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasCLDEMOTE,
  GIFBS_HasCLFLUSH,
  GIFBS_HasCLFLUSHOPT,
  GIFBS_HasCLWB,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFXSR,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMOVRS,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasPrefetchW,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasSSEPrefetch,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasXSAVE,
  GIFBS_HasXSAVEC,
  GIFBS_HasXSAVEOPT,
  GIFBS_HasXSAVES,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoAVX,
  GIFBS_NoDQI,
  GIFBS_NoEGPR,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseIncDec,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE3,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasAVX512_NoEGPR,
  GIFBS_HasAVX512_OptForSize,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasBWI_NoEGPR,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasDQI_NoEGPR,
  GIFBS_HasEGPR_HasINVPCID,
  GIFBS_HasEGPR_In64BitMode,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFP16_In64BitMode,
  GIFBS_HasFP16_OptForSize,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasFXSR_In64BitMode,
  GIFBS_HasINVPCID_NoEGPR,
  GIFBS_HasINVPCID_Not64BitMode,
  GIFBS_HasMOVBE_NoEGPR,
  GIFBS_HasMOVDIR64B_NoEGPR,
  GIFBS_HasMOVDIRI_NoEGPR,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPREFETCHI_In64BitMode,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_HasXSAVE_In64BitMode,
  GIFBS_HasXSAVEC_In64BitMode,
  GIFBS_HasXSAVEOPT_In64BitMode,
  GIFBS_HasXSAVES_In64BitMode,
  GIFBS_In64BitMode_UseIncDec,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_OptForSize_UseAVX,
  GIFBS_OptForSize_UseSSE1,
  GIFBS_OptForSize_UseSSE2,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTILE_HasEGPR_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode_NoEGPR,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX10_2_HasMOVRS_In64BitMode,
  GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode,
  GIFBS_HasAVX512_HasEGPR_In64BitMode,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEGPR_In64BitMode,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasMOVBE_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIRI_In64BitMode,
  GIFBS_HasEGPR_HasMOVRS_In64BitMode,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
  GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR,
  GIFBS_HasMOVDIRI_In64BitMode_NoEGPR,
  GIFBS_HasMOVRS_In64BitMode_NoEGPR,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasAVXNECONVERTBit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasCLDEMOTEBit, },
  {Feature_HasCLFLUSHBit, },
  {Feature_HasCLFLUSHOPTBit, },
  {Feature_HasCLWBBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFXSRBit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMOVRSBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasPrefetchWBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasSSEPrefetchBit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasXSAVEBit, },
  {Feature_HasXSAVECBit, },
  {Feature_HasXSAVEOPTBit, },
  {Feature_HasXSAVESBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoAVXBit, },
  {Feature_NoDQIBit, },
  {Feature_NoEGPRBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseIncDecBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE3Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasAVX512Bit, Feature_NoEGPRBit, },
  {Feature_HasAVX512Bit, Feature_OptForSizeBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasBWIBit, Feature_NoEGPRBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasDQIBit, Feature_NoEGPRBit, },
  {Feature_HasEGPRBit, Feature_HasINVPCIDBit, },
  {Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasFP16Bit, Feature_OptForSizeBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasFXSRBit, Feature_In64BitModeBit, },
  {Feature_HasINVPCIDBit, Feature_NoEGPRBit, },
  {Feature_HasINVPCIDBit, Feature_Not64BitModeBit, },
  {Feature_HasMOVBEBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIR64BBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_NoEGPRBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPREFETCHIBit, Feature_In64BitModeBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_HasXSAVEBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVECBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVEOPTBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVESBit, Feature_In64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseIncDecBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_OptForSizeBit, Feature_UseAVXBit, },
  {Feature_OptForSizeBit, Feature_UseSSE1Bit, },
  {Feature_OptForSizeBit, Feature_UseSSE2Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX10_2Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasMOVBEBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIRIBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVRSBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addr,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &X86InstructionSelector::selectAddr, // gi_addr
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_alignedload = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_alignedstore,
  GICXXPred_MI_Predicate_imm_su,
  GICXXPred_MI_Predicate_loadi8,
  GICXXPred_MI_Predicate_loadi16,
  GICXXPred_MI_Predicate_loadi32,
};
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_alignedload: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedload should have returned");
  }
  case GICXXPred_MI_Predicate_alignedstore: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedstore should have returned");
  }
  case GICXXPred_MI_Predicate_imm_su: {
     return true; 
  }
  case GICXXPred_MI_Predicate_loadi8: {
     return isa<GLoad>(MI); 
  }
  case GICXXPred_MI_Predicate_loadi16: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 2 && Load.isSimple();
      
    llvm_unreachable("loadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_loadi32: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 4 && Load.isSimple();
      
    llvm_unreachable("loadi32 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(291), /*)*//*default:*//*Label 77*/ GIMT_Encode4(229164),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(962),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(7195),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(10731), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(14514),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(25106),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(33510), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(46211), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(46378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(48668),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(51846), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 10*/ GIMT_Encode4(53066),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 11*/ GIMT_Encode4(59291),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 12*/ GIMT_Encode4(59624), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 13*/ GIMT_Encode4(60279), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 14*/ GIMT_Encode4(85742),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 15*/ GIMT_Encode4(85978), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    298 */ /*TargetOpcode::G_PREFETCH*//*Label 16*/ GIMT_Encode4(86226), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 17*/ GIMT_Encode4(86545),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 18*/ GIMT_Encode4(100371), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 19*/ GIMT_Encode4(109446),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 20*/ GIMT_Encode4(109881),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 21*/ GIMT_Encode4(110970),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 22*/ GIMT_Encode4(111576), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 23*/ GIMT_Encode4(112029),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 24*/ GIMT_Encode4(113701),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 25*/ GIMT_Encode4(113943),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 26*/ GIMT_Encode4(115927),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 27*/ GIMT_Encode4(118211),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 28*/ GIMT_Encode4(120255),
     /*    378 */ /*TargetOpcode::G_FSHL*//*Label 29*/ GIMT_Encode4(122299),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 30*/ GIMT_Encode4(123027),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 31*/ GIMT_Encode4(123715),
     /*    390 */ /*TargetOpcode::G_ROTL*//*Label 32*/ GIMT_Encode4(127213),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 33*/ GIMT_Encode4(130933), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 34*/ GIMT_Encode4(132590), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 35*/ GIMT_Encode4(140256),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 36*/ GIMT_Encode4(141121),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 37*/ GIMT_Encode4(141986),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 38*/ GIMT_Encode4(143672),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 39*/ GIMT_Encode4(145358),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 40*/ GIMT_Encode4(146424), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 41*/ GIMT_Encode4(147490),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 42*/ GIMT_Encode4(152640),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 43*/ GIMT_Encode4(156058),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 44*/ GIMT_Encode4(161208), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 45*/ GIMT_Encode4(167196), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 46*/ GIMT_Encode4(170614),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 47*/ GIMT_Encode4(170737),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 48*/ GIMT_Encode4(171669),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 49*/ GIMT_Encode4(172055),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 50*/ GIMT_Encode4(173436),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 51*/ GIMT_Encode4(173992),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 52*/ GIMT_Encode4(177368), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 53*/ GIMT_Encode4(179615), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(179738),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(183059),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(186380),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(189701),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(193022), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(194903), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 60*/ GIMT_Encode4(194919), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    770 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 61*/ GIMT_Encode4(197848),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 62*/ GIMT_Encode4(199830),
     /*    778 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 63*/ GIMT_Encode4(200136),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 64*/ GIMT_Encode4(200523), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 65*/ GIMT_Encode4(201827),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 66*/ GIMT_Encode4(204089), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(204589), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 68*/ GIMT_Encode4(206758),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 69*/ GIMT_Encode4(210924),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 70*/ GIMT_Encode4(213850),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 71*/ GIMT_Encode4(218016), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 72*/ GIMT_Encode4(220942),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 73*/ GIMT_Encode4(226930), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 74*/ GIMT_Encode4(229099),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 75*/ GIMT_Encode4(229112),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 76*/ GIMT_Encode4(229148),
     /*    962 */ // Label 0: @962
     /*    962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 94*/ GIMT_Encode4(7194),
     /*    973 */ /*GILLT_s8*//*Label 78*/ GIMT_Encode4(1069),
     /*    977 */ /*GILLT_s16*//*Label 79*/ GIMT_Encode4(1574),
     /*    981 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(2224),
     /*    985 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(2874), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1001 */ /*GILLT_v2s64*//*Label 82*/ GIMT_Encode4(3698), GIMT_Encode4(0),
     /*   1009 */ /*GILLT_v4s32*//*Label 83*/ GIMT_Encode4(4040),
     /*   1013 */ /*GILLT_v4s64*//*Label 84*/ GIMT_Encode4(4504), GIMT_Encode4(0),
     /*   1021 */ /*GILLT_v8s16*//*Label 85*/ GIMT_Encode4(4819),
     /*   1025 */ /*GILLT_v8s32*//*Label 86*/ GIMT_Encode4(5283),
     /*   1029 */ /*GILLT_v8s64*//*Label 87*/ GIMT_Encode4(5598), GIMT_Encode4(0),
     /*   1037 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(5754),
     /*   1041 */ /*GILLT_v16s16*//*Label 89*/ GIMT_Encode4(6096),
     /*   1045 */ /*GILLT_v16s32*//*Label 90*/ GIMT_Encode4(6411), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v32s8*//*Label 91*/ GIMT_Encode4(6567),
     /*   1057 */ /*GILLT_v32s16*//*Label 92*/ GIMT_Encode4(6882), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v64s8*//*Label 93*/ GIMT_Encode4(7038),
     /*   1069 */ // Label 78: @1069
     /*   1069 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1573),
     /*   1074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   1077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   1080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1084 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1145), // Rule ID 26054 //
     /*   1089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1107 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1124 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1129 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1143 */     GIR_RootConstrainSelectedInstOperands,
     /*   1144 */     // GIR_Coverage, 26054,
     /*   1144 */     GIR_EraseRootFromParent_Done,
     /*   1145 */   // Label 96: @1145
     /*   1145 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1206), // Rule ID 26073 //
     /*   1150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1168 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1185 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1204 */     GIR_RootConstrainSelectedInstOperands,
     /*   1205 */     // GIR_Coverage, 26073,
     /*   1205 */     GIR_EraseRootFromParent_Done,
     /*   1206 */   // Label 97: @1206
     /*   1206 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1267), // Rule ID 22796 //
     /*   1211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1233 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1246 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1265 */     GIR_RootConstrainSelectedInstOperands,
     /*   1266 */     // GIR_Coverage, 22796,
     /*   1266 */     GIR_EraseRootFromParent_Done,
     /*   1267 */   // Label 98: @1267
     /*   1267 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1328), // Rule ID 22886 //
     /*   1272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1287 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1290 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1294 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1307 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1326 */     GIR_RootConstrainSelectedInstOperands,
     /*   1327 */     // GIR_Coverage, 22886,
     /*   1327 */     GIR_EraseRootFromParent_Done,
     /*   1328 */   // Label 99: @1328
     /*   1328 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1356), // Rule ID 22862 //
     /*   1333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1344 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*   1347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1354 */     GIR_RootConstrainSelectedInstOperands,
     /*   1355 */     // GIR_Coverage, 22862,
     /*   1355 */     GIR_EraseRootFromParent_Done,
     /*   1356 */   // Label 100: @1356
     /*   1356 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1384), // Rule ID 22866 //
     /*   1361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1372 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*   1375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1377 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1382 */     GIR_RootConstrainSelectedInstOperands,
     /*   1383 */     // GIR_Coverage, 22866,
     /*   1383 */     GIR_EraseRootFromParent_Done,
     /*   1384 */   // Label 101: @1384
     /*   1384 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1412), // Rule ID 22952 //
     /*   1389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1400 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*   1403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 22952,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 102: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1440), // Rule ID 22956 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1428 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*   1431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1433 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1438 */     GIR_RootConstrainSelectedInstOperands,
     /*   1439 */     // GIR_Coverage, 22956,
     /*   1439 */     GIR_EraseRootFromParent_Done,
     /*   1440 */   // Label 103: @1440
     /*   1440 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1477), // Rule ID 22800 //
     /*   1445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1460 */     // MIs[1] Operand 1
     /*   1460 */     // No operand predicates
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1475 */     GIR_RootConstrainSelectedInstOperands,
     /*   1476 */     // GIR_Coverage, 22800,
     /*   1476 */     GIR_EraseRootFromParent_Done,
     /*   1477 */   // Label 104: @1477
     /*   1477 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1514), // Rule ID 22890 //
     /*   1482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1497 */     // MIs[1] Operand 1
     /*   1497 */     // No operand predicates
     /*   1497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1499 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*   1502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1512 */     GIR_RootConstrainSelectedInstOperands,
     /*   1513 */     // GIR_Coverage, 22890,
     /*   1513 */     GIR_EraseRootFromParent_Done,
     /*   1514 */   // Label 105: @1514
     /*   1514 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1543), // Rule ID 22792 //
     /*   1519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1530 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*   1535 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1541 */     GIR_RootConstrainSelectedInstOperands,
     /*   1542 */     // GIR_Coverage, 22792,
     /*   1542 */     GIR_Done,
     /*   1543 */   // Label 106: @1543
     /*   1543 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1572), // Rule ID 22882 //
     /*   1548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1559 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*   1564 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1570 */     GIR_RootConstrainSelectedInstOperands,
     /*   1571 */     // GIR_Coverage, 22882,
     /*   1571 */     GIR_Done,
     /*   1572 */   // Label 107: @1572
     /*   1572 */   GIM_Reject,
     /*   1573 */ // Label 95: @1573
     /*   1573 */ GIM_Reject,
     /*   1574 */ // Label 79: @1574
     /*   1574 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2223),
     /*   1579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   1582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   1585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1589 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1658), // Rule ID 22617 //
     /*   1594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1612 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1636 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] })  =>  (SUB16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i16] })
     /*   1636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi_ND),
     /*   1639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   1645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1656 */     GIR_RootConstrainSelectedInstOperands,
     /*   1657 */     // GIR_Coverage, 22617,
     /*   1657 */     GIR_EraseRootFromParent_Done,
     /*   1658 */   // Label 109: @1658
     /*   1658 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1719), // Rule ID 26055 //
     /*   1663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1674 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1677 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1681 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1698 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1703 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1717 */     GIR_RootConstrainSelectedInstOperands,
     /*   1718 */     // GIR_Coverage, 26055,
     /*   1718 */     GIR_EraseRootFromParent_Done,
     /*   1719 */   // Label 110: @1719
     /*   1719 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1780), // Rule ID 26074 //
     /*   1724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1738 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1742 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1759 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1778 */     GIR_RootConstrainSelectedInstOperands,
     /*   1779 */     // GIR_Coverage, 26074,
     /*   1779 */     GIR_EraseRootFromParent_Done,
     /*   1780 */   // Label 111: @1780
     /*   1780 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1841), // Rule ID 22797 //
     /*   1785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1807 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1820 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1839 */     GIR_RootConstrainSelectedInstOperands,
     /*   1840 */     // GIR_Coverage, 22797,
     /*   1840 */     GIR_EraseRootFromParent_Done,
     /*   1841 */   // Label 112: @1841
     /*   1841 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1902), // Rule ID 22887 //
     /*   1846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1868 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1881 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1900 */     GIR_RootConstrainSelectedInstOperands,
     /*   1901 */     // GIR_Coverage, 22887,
     /*   1901 */     GIR_EraseRootFromParent_Done,
     /*   1902 */   // Label 113: @1902
     /*   1902 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1940), // Rule ID 22602 //
     /*   1907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1914 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1925 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   1925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   1928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1938 */     GIR_RootConstrainSelectedInstOperands,
     /*   1939 */     // GIR_Coverage, 22602,
     /*   1939 */     GIR_EraseRootFromParent_Done,
     /*   1940 */   // Label 114: @1940
     /*   1940 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1978), // Rule ID 22608 //
     /*   1945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1952 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1963 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   1963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   1966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1976 */     GIR_RootConstrainSelectedInstOperands,
     /*   1977 */     // GIR_Coverage, 22608,
     /*   1977 */     GIR_EraseRootFromParent_Done,
     /*   1978 */   // Label 115: @1978
     /*   1978 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2006), // Rule ID 22863 //
     /*   1983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1994 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   1994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*   1997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2004 */     GIR_RootConstrainSelectedInstOperands,
     /*   2005 */     // GIR_Coverage, 22863,
     /*   2005 */     GIR_EraseRootFromParent_Done,
     /*   2006 */   // Label 116: @2006
     /*   2006 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2034), // Rule ID 22867 //
     /*   2011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2022 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*   2025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2032 */     GIR_RootConstrainSelectedInstOperands,
     /*   2033 */     // GIR_Coverage, 22867,
     /*   2033 */     GIR_EraseRootFromParent_Done,
     /*   2034 */   // Label 117: @2034
     /*   2034 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2062), // Rule ID 22953 //
     /*   2039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2050 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*   2053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2055 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2060 */     GIR_RootConstrainSelectedInstOperands,
     /*   2061 */     // GIR_Coverage, 22953,
     /*   2061 */     GIR_EraseRootFromParent_Done,
     /*   2062 */   // Label 118: @2062
     /*   2062 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2090), // Rule ID 22957 //
     /*   2067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2078 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*   2081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2088 */     GIR_RootConstrainSelectedInstOperands,
     /*   2089 */     // GIR_Coverage, 22957,
     /*   2089 */     GIR_EraseRootFromParent_Done,
     /*   2090 */   // Label 119: @2090
     /*   2090 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2127), // Rule ID 22801 //
     /*   2095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2110 */     // MIs[1] Operand 1
     /*   2110 */     // No operand predicates
     /*   2110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2112 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*   2115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2125 */     GIR_RootConstrainSelectedInstOperands,
     /*   2126 */     // GIR_Coverage, 22801,
     /*   2126 */     GIR_EraseRootFromParent_Done,
     /*   2127 */   // Label 120: @2127
     /*   2127 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2164), // Rule ID 22891 //
     /*   2132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2147 */     // MIs[1] Operand 1
     /*   2147 */     // No operand predicates
     /*   2147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2149 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*   2152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2162 */     GIR_RootConstrainSelectedInstOperands,
     /*   2163 */     // GIR_Coverage, 22891,
     /*   2163 */     GIR_EraseRootFromParent_Done,
     /*   2164 */   // Label 121: @2164
     /*   2164 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2193), // Rule ID 22793 //
     /*   2169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2180 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*   2185 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2191 */     GIR_RootConstrainSelectedInstOperands,
     /*   2192 */     // GIR_Coverage, 22793,
     /*   2192 */     GIR_Done,
     /*   2193 */   // Label 122: @2193
     /*   2193 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2222), // Rule ID 22883 //
     /*   2198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2209 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*   2214 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2220 */     GIR_RootConstrainSelectedInstOperands,
     /*   2221 */     // GIR_Coverage, 22883,
     /*   2221 */     GIR_Done,
     /*   2222 */   // Label 123: @2222
     /*   2222 */   GIM_Reject,
     /*   2223 */ // Label 108: @2223
     /*   2223 */ GIM_Reject,
     /*   2224 */ // Label 80: @2224
     /*   2224 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2873),
     /*   2229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2239 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2308), // Rule ID 22618 //
     /*   2244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2262 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2266 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2286 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] })  =>  (SUB32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i32] })
     /*   2286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi_ND),
     /*   2289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2306 */     GIR_RootConstrainSelectedInstOperands,
     /*   2307 */     // GIR_Coverage, 22618,
     /*   2307 */     GIR_EraseRootFromParent_Done,
     /*   2308 */   // Label 125: @2308
     /*   2308 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(2369), // Rule ID 26056 //
     /*   2313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2331 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2348 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2367 */     GIR_RootConstrainSelectedInstOperands,
     /*   2368 */     // GIR_Coverage, 26056,
     /*   2368 */     GIR_EraseRootFromParent_Done,
     /*   2369 */   // Label 126: @2369
     /*   2369 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2430), // Rule ID 26075 //
     /*   2374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2392 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2409 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2414 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2428 */     GIR_RootConstrainSelectedInstOperands,
     /*   2429 */     // GIR_Coverage, 26075,
     /*   2429 */     GIR_EraseRootFromParent_Done,
     /*   2430 */   // Label 127: @2430
     /*   2430 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2491), // Rule ID 22798 //
     /*   2435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2457 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2470 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2475 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2489 */     GIR_RootConstrainSelectedInstOperands,
     /*   2490 */     // GIR_Coverage, 22798,
     /*   2490 */     GIR_EraseRootFromParent_Done,
     /*   2491 */   // Label 128: @2491
     /*   2491 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2552), // Rule ID 22888 //
     /*   2496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2518 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2531 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2550 */     GIR_RootConstrainSelectedInstOperands,
     /*   2551 */     // GIR_Coverage, 22888,
     /*   2551 */     GIR_EraseRootFromParent_Done,
     /*   2552 */   // Label 129: @2552
     /*   2552 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2590), // Rule ID 22603 //
     /*   2557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2564 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2575 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   2578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2580 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2588 */     GIR_RootConstrainSelectedInstOperands,
     /*   2589 */     // GIR_Coverage, 22603,
     /*   2589 */     GIR_EraseRootFromParent_Done,
     /*   2590 */   // Label 130: @2590
     /*   2590 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2628), // Rule ID 22609 //
     /*   2595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2602 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2613 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   2616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2626 */     GIR_RootConstrainSelectedInstOperands,
     /*   2627 */     // GIR_Coverage, 22609,
     /*   2627 */     GIR_EraseRootFromParent_Done,
     /*   2628 */   // Label 131: @2628
     /*   2628 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2656), // Rule ID 22864 //
     /*   2633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2644 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*   2647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2654 */     GIR_RootConstrainSelectedInstOperands,
     /*   2655 */     // GIR_Coverage, 22864,
     /*   2655 */     GIR_EraseRootFromParent_Done,
     /*   2656 */   // Label 132: @2656
     /*   2656 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2684), // Rule ID 22868 //
     /*   2661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2672 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*   2675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2682 */     GIR_RootConstrainSelectedInstOperands,
     /*   2683 */     // GIR_Coverage, 22868,
     /*   2683 */     GIR_EraseRootFromParent_Done,
     /*   2684 */   // Label 133: @2684
     /*   2684 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2712), // Rule ID 22954 //
     /*   2689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2700 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*   2703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2710 */     GIR_RootConstrainSelectedInstOperands,
     /*   2711 */     // GIR_Coverage, 22954,
     /*   2711 */     GIR_EraseRootFromParent_Done,
     /*   2712 */   // Label 134: @2712
     /*   2712 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2740), // Rule ID 22958 //
     /*   2717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2728 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*   2731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2738 */     GIR_RootConstrainSelectedInstOperands,
     /*   2739 */     // GIR_Coverage, 22958,
     /*   2739 */     GIR_EraseRootFromParent_Done,
     /*   2740 */   // Label 135: @2740
     /*   2740 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2777), // Rule ID 22802 //
     /*   2745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2760 */     // MIs[1] Operand 1
     /*   2760 */     // No operand predicates
     /*   2760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2762 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*   2765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 22802,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 136: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2814), // Rule ID 22892 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2797 */     // MIs[1] Operand 1
     /*   2797 */     // No operand predicates
     /*   2797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2799 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*   2802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2804 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2812 */     GIR_RootConstrainSelectedInstOperands,
     /*   2813 */     // GIR_Coverage, 22892,
     /*   2813 */     GIR_EraseRootFromParent_Done,
     /*   2814 */   // Label 137: @2814
     /*   2814 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2843), // Rule ID 22794 //
     /*   2819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2830 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   2830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*   2835 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2841 */     GIR_RootConstrainSelectedInstOperands,
     /*   2842 */     // GIR_Coverage, 22794,
     /*   2842 */     GIR_Done,
     /*   2843 */   // Label 138: @2843
     /*   2843 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2872), // Rule ID 22884 //
     /*   2848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2859 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   2859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*   2864 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2870 */     GIR_RootConstrainSelectedInstOperands,
     /*   2871 */     // GIR_Coverage, 22884,
     /*   2871 */     GIR_Done,
     /*   2872 */   // Label 139: @2872
     /*   2872 */   GIM_Reject,
     /*   2873 */ // Label 124: @2873
     /*   2873 */ GIM_Reject,
     /*   2874 */ // Label 81: @2874
     /*   2874 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(3697),
     /*   2879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   2889 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2958), // Rule ID 22619 //
     /*   2894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   2912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2916 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2936 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i64] })
     /*   2936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   2939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2956 */     GIR_RootConstrainSelectedInstOperands,
     /*   2957 */     // GIR_Coverage, 22619,
     /*   2957 */     GIR_EraseRootFromParent_Done,
     /*   2958 */   // Label 141: @2958
     /*   2958 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3034), // Rule ID 22625 //
     /*   2963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   2981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2985 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   2996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3005 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -2147483648:{ *:[i64] })
     /*   3005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3014 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3032 */     GIR_RootConstrainSelectedInstOperands,
     /*   3033 */     // GIR_Coverage, 22625,
     /*   3033 */     GIR_EraseRootFromParent_Done,
     /*   3034 */   // Label 142: @3034
     /*   3034 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(3095), // Rule ID 26057 //
     /*   3039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3050 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3057 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3074 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3079 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3093 */     GIR_RootConstrainSelectedInstOperands,
     /*   3094 */     // GIR_Coverage, 26057,
     /*   3094 */     GIR_EraseRootFromParent_Done,
     /*   3095 */   // Label 143: @3095
     /*   3095 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(3156), // Rule ID 26076 //
     /*   3100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3135 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3154 */     GIR_RootConstrainSelectedInstOperands,
     /*   3155 */     // GIR_Coverage, 26076,
     /*   3155 */     GIR_EraseRootFromParent_Done,
     /*   3156 */   // Label 144: @3156
     /*   3156 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(3217), // Rule ID 22799 //
     /*   3161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3196 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3215 */     GIR_RootConstrainSelectedInstOperands,
     /*   3216 */     // GIR_Coverage, 22799,
     /*   3216 */     GIR_EraseRootFromParent_Done,
     /*   3217 */   // Label 145: @3217
     /*   3217 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(3278), // Rule ID 22889 //
     /*   3222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3237 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3244 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3257 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3276 */     GIR_RootConstrainSelectedInstOperands,
     /*   3277 */     // GIR_Coverage, 22889,
     /*   3277 */     GIR_EraseRootFromParent_Done,
     /*   3278 */   // Label 146: @3278
     /*   3278 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3316), // Rule ID 22604 //
     /*   3283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3290 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3301 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3306 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3314 */     GIR_RootConstrainSelectedInstOperands,
     /*   3315 */     // GIR_Coverage, 22604,
     /*   3315 */     GIR_EraseRootFromParent_Done,
     /*   3316 */   // Label 147: @3316
     /*   3316 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3354), // Rule ID 22610 //
     /*   3321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3328 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3339 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3352 */     GIR_RootConstrainSelectedInstOperands,
     /*   3353 */     // GIR_Coverage, 22610,
     /*   3353 */     GIR_EraseRootFromParent_Done,
     /*   3354 */   // Label 148: @3354
     /*   3354 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(3399), // Rule ID 22620 //
     /*   3359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3366 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3377 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3384 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3397 */     GIR_RootConstrainSelectedInstOperands,
     /*   3398 */     // GIR_Coverage, 22620,
     /*   3398 */     GIR_EraseRootFromParent_Done,
     /*   3399 */   // Label 149: @3399
     /*   3399 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(3444), // Rule ID 22622 //
     /*   3404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3411 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3422 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3429 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3442 */     GIR_RootConstrainSelectedInstOperands,
     /*   3443 */     // GIR_Coverage, 22622,
     /*   3443 */     GIR_EraseRootFromParent_Done,
     /*   3444 */   // Label 150: @3444
     /*   3444 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3472), // Rule ID 22865 //
     /*   3449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3460 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*   3463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3470 */     GIR_RootConstrainSelectedInstOperands,
     /*   3471 */     // GIR_Coverage, 22865,
     /*   3471 */     GIR_EraseRootFromParent_Done,
     /*   3472 */   // Label 151: @3472
     /*   3472 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3500), // Rule ID 22869 //
     /*   3477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3488 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*   3491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3498 */     GIR_RootConstrainSelectedInstOperands,
     /*   3499 */     // GIR_Coverage, 22869,
     /*   3499 */     GIR_EraseRootFromParent_Done,
     /*   3500 */   // Label 152: @3500
     /*   3500 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3528), // Rule ID 22955 //
     /*   3505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3516 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*   3519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3526 */     GIR_RootConstrainSelectedInstOperands,
     /*   3527 */     // GIR_Coverage, 22955,
     /*   3527 */     GIR_EraseRootFromParent_Done,
     /*   3528 */   // Label 153: @3528
     /*   3528 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3556), // Rule ID 22959 //
     /*   3533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3544 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*   3547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3554 */     GIR_RootConstrainSelectedInstOperands,
     /*   3555 */     // GIR_Coverage, 22959,
     /*   3555 */     GIR_EraseRootFromParent_Done,
     /*   3556 */   // Label 154: @3556
     /*   3556 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3597), // Rule ID 22803 //
     /*   3561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3580 */     // MIs[1] Operand 1
     /*   3580 */     // No operand predicates
     /*   3580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3582 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*   3585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3595 */     GIR_RootConstrainSelectedInstOperands,
     /*   3596 */     // GIR_Coverage, 22803,
     /*   3596 */     GIR_EraseRootFromParent_Done,
     /*   3597 */   // Label 155: @3597
     /*   3597 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3638), // Rule ID 22893 //
     /*   3602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3621 */     // MIs[1] Operand 1
     /*   3621 */     // No operand predicates
     /*   3621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3623 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*   3626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3636 */     GIR_RootConstrainSelectedInstOperands,
     /*   3637 */     // GIR_Coverage, 22893,
     /*   3637 */     GIR_EraseRootFromParent_Done,
     /*   3638 */   // Label 156: @3638
     /*   3638 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3667), // Rule ID 22795 //
     /*   3643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3654 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*   3659 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3665 */     GIR_RootConstrainSelectedInstOperands,
     /*   3666 */     // GIR_Coverage, 22795,
     /*   3666 */     GIR_Done,
     /*   3667 */   // Label 157: @3667
     /*   3667 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3696), // Rule ID 22885 //
     /*   3672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3683 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*   3688 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3694 */     GIR_RootConstrainSelectedInstOperands,
     /*   3695 */     // GIR_Coverage, 22885,
     /*   3695 */     GIR_Done,
     /*   3696 */   // Label 158: @3696
     /*   3696 */   GIM_Reject,
     /*   3697 */ // Label 140: @3697
     /*   3697 */ GIM_Reject,
     /*   3698 */ // Label 82: @3698
     /*   3698 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(4039),
     /*   3703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   3706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   3709 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3771), // Rule ID 23438 //
     /*   3714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3729 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3736 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3753 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3769 */     GIR_RootConstrainSelectedInstOperands,
     /*   3770 */     // GIR_Coverage, 23438,
     /*   3770 */     GIR_EraseRootFromParent_Done,
     /*   3771 */   // Label 160: @3771
     /*   3771 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3833), // Rule ID 23708 //
     /*   3776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3791 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3794 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3798 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3815 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   3818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3820 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3831 */     GIR_RootConstrainSelectedInstOperands,
     /*   3832 */     // GIR_Coverage, 23708,
     /*   3832 */     GIR_EraseRootFromParent_Done,
     /*   3833 */   // Label 161: @3833
     /*   3833 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3895), // Rule ID 2541 //
     /*   3838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3877 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3882 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3893 */     GIR_RootConstrainSelectedInstOperands,
     /*   3894 */     // GIR_Coverage, 2541,
     /*   3894 */     GIR_EraseRootFromParent_Done,
     /*   3895 */   // Label 162: @3895
     /*   3895 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3957), // Rule ID 4654 //
     /*   3900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3919 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3922 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3926 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3939 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   3942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3955 */     GIR_RootConstrainSelectedInstOperands,
     /*   3956 */     // GIR_Coverage, 4654,
     /*   3956 */     GIR_EraseRootFromParent_Done,
     /*   3957 */   // Label 163: @3957
     /*   3957 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3984), // Rule ID 2540 //
     /*   3962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3977 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   3977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*   3982 */     GIR_RootConstrainSelectedInstOperands,
     /*   3983 */     // GIR_Coverage, 2540,
     /*   3983 */     GIR_Done,
     /*   3984 */   // Label 164: @3984
     /*   3984 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(4011), // Rule ID 2542 //
     /*   3989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   3992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4004 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   4004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*   4009 */     GIR_RootConstrainSelectedInstOperands,
     /*   4010 */     // GIR_Coverage, 2542,
     /*   4010 */     GIR_Done,
     /*   4011 */   // Label 165: @4011
     /*   4011 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4038), // Rule ID 4651 //
     /*   4016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4031 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   4031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*   4036 */     GIR_RootConstrainSelectedInstOperands,
     /*   4037 */     // GIR_Coverage, 4651,
     /*   4037 */     GIR_Done,
     /*   4038 */   // Label 166: @4038
     /*   4038 */   GIM_Reject,
     /*   4039 */ // Label 159: @4039
     /*   4039 */ GIM_Reject,
     /*   4040 */ // Label 83: @4040
     /*   4040 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(4503),
     /*   4045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4051 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(4113), // Rule ID 23435 //
     /*   4056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4095 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4111 */     GIR_RootConstrainSelectedInstOperands,
     /*   4112 */     // GIR_Coverage, 23435,
     /*   4112 */     GIR_EraseRootFromParent_Done,
     /*   4113 */   // Label 168: @4113
     /*   4113 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4175), // Rule ID 23726 //
     /*   4118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4157 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4173 */     GIR_RootConstrainSelectedInstOperands,
     /*   4174 */     // GIR_Coverage, 23726,
     /*   4174 */     GIR_EraseRootFromParent_Done,
     /*   4175 */   // Label 169: @4175
     /*   4175 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(4237), // Rule ID 2535 //
     /*   4180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4199 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4206 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4219 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4224 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4235 */     GIR_RootConstrainSelectedInstOperands,
     /*   4236 */     // GIR_Coverage, 2535,
     /*   4236 */     GIR_EraseRootFromParent_Done,
     /*   4237 */   // Label 170: @4237
     /*   4237 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(4299), // Rule ID 4681 //
     /*   4242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4281 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4286 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4297 */     GIR_RootConstrainSelectedInstOperands,
     /*   4298 */     // GIR_Coverage, 4681,
     /*   4298 */     GIR_EraseRootFromParent_Done,
     /*   4299 */   // Label 171: @4299
     /*   4299 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4360), // Rule ID 17867 //
     /*   4304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4343 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4358 */     GIR_RootConstrainSelectedInstOperands,
     /*   4359 */     // GIR_Coverage, 17867,
     /*   4359 */     GIR_EraseRootFromParent_Done,
     /*   4360 */   // Label 172: @4360
     /*   4360 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4421), // Rule ID 25190 //
     /*   4365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4404 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4417 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4419 */     GIR_RootConstrainSelectedInstOperands,
     /*   4420 */     // GIR_Coverage, 25190,
     /*   4420 */     GIR_EraseRootFromParent_Done,
     /*   4421 */   // Label 173: @4421
     /*   4421 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4448), // Rule ID 2534 //
     /*   4426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4441 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*   4446 */     GIR_RootConstrainSelectedInstOperands,
     /*   4447 */     // GIR_Coverage, 2534,
     /*   4447 */     GIR_Done,
     /*   4448 */   // Label 174: @4448
     /*   4448 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4475), // Rule ID 2536 //
     /*   4453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4468 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*   4473 */     GIR_RootConstrainSelectedInstOperands,
     /*   4474 */     // GIR_Coverage, 2536,
     /*   4474 */     GIR_Done,
     /*   4475 */   // Label 175: @4475
     /*   4475 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4502), // Rule ID 4678 //
     /*   4480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4495 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   4495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*   4500 */     GIR_RootConstrainSelectedInstOperands,
     /*   4501 */     // GIR_Coverage, 4678,
     /*   4501 */     GIR_Done,
     /*   4502 */   // Label 176: @4502
     /*   4502 */   GIM_Reject,
     /*   4503 */ // Label 167: @4503
     /*   4503 */ GIM_Reject,
     /*   4504 */ // Label 84: @4504
     /*   4504 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4818),
     /*   4509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   4512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   4515 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4577), // Rule ID 23440 //
     /*   4520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4535 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4542 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4559 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4575 */     GIR_RootConstrainSelectedInstOperands,
     /*   4576 */     // GIR_Coverage, 23440,
     /*   4576 */     GIR_EraseRootFromParent_Done,
     /*   4577 */   // Label 178: @4577
     /*   4577 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4639), // Rule ID 23702 //
     /*   4582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4597 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4600 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4621 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4637 */     GIR_RootConstrainSelectedInstOperands,
     /*   4638 */     // GIR_Coverage, 23702,
     /*   4638 */     GIR_EraseRootFromParent_Done,
     /*   4639 */   // Label 179: @4639
     /*   4639 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4701), // Rule ID 2545 //
     /*   4644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4683 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4699 */     GIR_RootConstrainSelectedInstOperands,
     /*   4700 */     // GIR_Coverage, 2545,
     /*   4700 */     GIR_EraseRootFromParent_Done,
     /*   4701 */   // Label 180: @4701
     /*   4701 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4763), // Rule ID 4645 //
     /*   4706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4725 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4728 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4732 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4745 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4761 */     GIR_RootConstrainSelectedInstOperands,
     /*   4762 */     // GIR_Coverage, 4645,
     /*   4762 */     GIR_EraseRootFromParent_Done,
     /*   4763 */   // Label 181: @4763
     /*   4763 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4790), // Rule ID 2544 //
     /*   4768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4783 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   4783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*   4788 */     GIR_RootConstrainSelectedInstOperands,
     /*   4789 */     // GIR_Coverage, 2544,
     /*   4789 */     GIR_Done,
     /*   4790 */   // Label 182: @4790
     /*   4790 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4817), // Rule ID 4642 //
     /*   4795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4810 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   4810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*   4815 */     GIR_RootConstrainSelectedInstOperands,
     /*   4816 */     // GIR_Coverage, 4642,
     /*   4816 */     GIR_Done,
     /*   4817 */   // Label 183: @4817
     /*   4817 */   GIM_Reject,
     /*   4818 */ // Label 177: @4818
     /*   4818 */ GIM_Reject,
     /*   4819 */ // Label 85: @4819
     /*   4819 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5282),
     /*   4824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4830 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4892), // Rule ID 23432 //
     /*   4835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   4838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4850 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4853 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4874 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   4877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4879 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4890 */     GIR_RootConstrainSelectedInstOperands,
     /*   4891 */     // GIR_Coverage, 23432,
     /*   4891 */     GIR_EraseRootFromParent_Done,
     /*   4892 */   // Label 185: @4892
     /*   4892 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4954), // Rule ID 23738 //
     /*   4897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   4900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4936 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4952 */     GIR_RootConstrainSelectedInstOperands,
     /*   4953 */     // GIR_Coverage, 23738,
     /*   4953 */     GIR_EraseRootFromParent_Done,
     /*   4954 */   // Label 186: @4954
     /*   4954 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5016), // Rule ID 2529 //
     /*   4959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   4962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4978 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4998 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   5001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5014 */     GIR_RootConstrainSelectedInstOperands,
     /*   5015 */     // GIR_Coverage, 2529,
     /*   5015 */     GIR_EraseRootFromParent_Done,
     /*   5016 */   // Label 187: @5016
     /*   5016 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5078), // Rule ID 4702 //
     /*   5021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5060 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5076 */     GIR_RootConstrainSelectedInstOperands,
     /*   5077 */     // GIR_Coverage, 4702,
     /*   5077 */     GIR_EraseRootFromParent_Done,
     /*   5078 */   // Label 188: @5078
     /*   5078 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5139), // Rule ID 17866 //
     /*   5083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5122 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   5137 */     GIR_RootConstrainSelectedInstOperands,
     /*   5138 */     // GIR_Coverage, 17866,
     /*   5138 */     GIR_EraseRootFromParent_Done,
     /*   5139 */   // Label 189: @5139
     /*   5139 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5200), // Rule ID 25189 //
     /*   5144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5183 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   5198 */     GIR_RootConstrainSelectedInstOperands,
     /*   5199 */     // GIR_Coverage, 25189,
     /*   5199 */     GIR_EraseRootFromParent_Done,
     /*   5200 */   // Label 190: @5200
     /*   5200 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5227), // Rule ID 2528 //
     /*   5205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5220 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*   5225 */     GIR_RootConstrainSelectedInstOperands,
     /*   5226 */     // GIR_Coverage, 2528,
     /*   5226 */     GIR_Done,
     /*   5227 */   // Label 191: @5227
     /*   5227 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5254), // Rule ID 2530 //
     /*   5232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   5235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5247 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*   5252 */     GIR_RootConstrainSelectedInstOperands,
     /*   5253 */     // GIR_Coverage, 2530,
     /*   5253 */     GIR_Done,
     /*   5254 */   // Label 192: @5254
     /*   5254 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5281), // Rule ID 4699 //
     /*   5259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5274 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   5274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*   5279 */     GIR_RootConstrainSelectedInstOperands,
     /*   5280 */     // GIR_Coverage, 4699,
     /*   5280 */     GIR_Done,
     /*   5281 */   // Label 193: @5281
     /*   5281 */   GIM_Reject,
     /*   5282 */ // Label 184: @5282
     /*   5282 */ GIM_Reject,
     /*   5283 */ // Label 86: @5283
     /*   5283 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5597),
     /*   5288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   5291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   5294 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5356), // Rule ID 23437 //
     /*   5299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5338 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5354 */     GIR_RootConstrainSelectedInstOperands,
     /*   5355 */     // GIR_Coverage, 23437,
     /*   5355 */     GIR_EraseRootFromParent_Done,
     /*   5356 */   // Label 195: @5356
     /*   5356 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5418), // Rule ID 23720 //
     /*   5361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5400 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5405 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5416 */     GIR_RootConstrainSelectedInstOperands,
     /*   5417 */     // GIR_Coverage, 23720,
     /*   5417 */     GIR_EraseRootFromParent_Done,
     /*   5418 */   // Label 196: @5418
     /*   5418 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5480), // Rule ID 2539 //
     /*   5423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5462 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5478 */     GIR_RootConstrainSelectedInstOperands,
     /*   5479 */     // GIR_Coverage, 2539,
     /*   5479 */     GIR_EraseRootFromParent_Done,
     /*   5480 */   // Label 197: @5480
     /*   5480 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5542), // Rule ID 4672 //
     /*   5485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5524 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5540 */     GIR_RootConstrainSelectedInstOperands,
     /*   5541 */     // GIR_Coverage, 4672,
     /*   5541 */     GIR_EraseRootFromParent_Done,
     /*   5542 */   // Label 198: @5542
     /*   5542 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5569), // Rule ID 2538 //
     /*   5547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5562 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   5562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*   5567 */     GIR_RootConstrainSelectedInstOperands,
     /*   5568 */     // GIR_Coverage, 2538,
     /*   5568 */     GIR_Done,
     /*   5569 */   // Label 199: @5569
     /*   5569 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(5596), // Rule ID 4669 //
     /*   5574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5589 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   5589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*   5594 */     GIR_RootConstrainSelectedInstOperands,
     /*   5595 */     // GIR_Coverage, 4669,
     /*   5595 */     GIR_Done,
     /*   5596 */   // Label 200: @5596
     /*   5596 */   GIM_Reject,
     /*   5597 */ // Label 194: @5597
     /*   5597 */ GIM_Reject,
     /*   5598 */ // Label 87: @5598
     /*   5598 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(5753),
     /*   5603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   5606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   5609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5613 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(5671), // Rule ID 23696 //
     /*   5618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5653 */     // (add:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5669 */     GIR_RootConstrainSelectedInstOperands,
     /*   5670 */     // GIR_Coverage, 23696,
     /*   5670 */     GIR_EraseRootFromParent_Done,
     /*   5671 */   // Label 202: @5671
     /*   5671 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(5729), // Rule ID 4636 //
     /*   5676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5691 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5694 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5698 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5711 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5727 */     GIR_RootConstrainSelectedInstOperands,
     /*   5728 */     // GIR_Coverage, 4636,
     /*   5728 */     GIR_EraseRootFromParent_Done,
     /*   5729 */   // Label 203: @5729
     /*   5729 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(5752), // Rule ID 4633 //
     /*   5734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5745 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   5745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*   5750 */     GIR_RootConstrainSelectedInstOperands,
     /*   5751 */     // GIR_Coverage, 4633,
     /*   5751 */     GIR_Done,
     /*   5752 */   // Label 204: @5752
     /*   5752 */   GIM_Reject,
     /*   5753 */ // Label 201: @5753
     /*   5753 */ GIM_Reject,
     /*   5754 */ // Label 88: @5754
     /*   5754 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6095),
     /*   5759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   5765 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(5827), // Rule ID 23429 //
     /*   5770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5809 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   5812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5825 */     GIR_RootConstrainSelectedInstOperands,
     /*   5826 */     // GIR_Coverage, 23429,
     /*   5826 */     GIR_EraseRootFromParent_Done,
     /*   5827 */   // Label 206: @5827
     /*   5827 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(5889), // Rule ID 23747 //
     /*   5832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5847 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5850 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5871 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   5874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5887 */     GIR_RootConstrainSelectedInstOperands,
     /*   5888 */     // GIR_Coverage, 23747,
     /*   5888 */     GIR_EraseRootFromParent_Done,
     /*   5889 */   // Label 207: @5889
     /*   5889 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5951), // Rule ID 2523 //
     /*   5894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5933 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   5936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5949 */     GIR_RootConstrainSelectedInstOperands,
     /*   5950 */     // GIR_Coverage, 2523,
     /*   5950 */     GIR_EraseRootFromParent_Done,
     /*   5951 */   // Label 208: @5951
     /*   5951 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6013), // Rule ID 4720 //
     /*   5956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5995 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   5998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6011 */     GIR_RootConstrainSelectedInstOperands,
     /*   6012 */     // GIR_Coverage, 4720,
     /*   6012 */     GIR_EraseRootFromParent_Done,
     /*   6013 */   // Label 209: @6013
     /*   6013 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6040), // Rule ID 2522 //
     /*   6018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6033 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*   6038 */     GIR_RootConstrainSelectedInstOperands,
     /*   6039 */     // GIR_Coverage, 2522,
     /*   6039 */     GIR_Done,
     /*   6040 */   // Label 210: @6040
     /*   6040 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6067), // Rule ID 2524 //
     /*   6045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   6048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6060 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*   6065 */     GIR_RootConstrainSelectedInstOperands,
     /*   6066 */     // GIR_Coverage, 2524,
     /*   6066 */     GIR_Done,
     /*   6067 */   // Label 211: @6067
     /*   6067 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6094), // Rule ID 4717 //
     /*   6072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6087 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*   6087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*   6092 */     GIR_RootConstrainSelectedInstOperands,
     /*   6093 */     // GIR_Coverage, 4717,
     /*   6093 */     GIR_Done,
     /*   6094 */   // Label 212: @6094
     /*   6094 */   GIM_Reject,
     /*   6095 */ // Label 205: @6095
     /*   6095 */ GIM_Reject,
     /*   6096 */ // Label 89: @6096
     /*   6096 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6410),
     /*   6101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*   6104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*   6107 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(6169), // Rule ID 23434 //
     /*   6112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6151 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6167 */     GIR_RootConstrainSelectedInstOperands,
     /*   6168 */     // GIR_Coverage, 23434,
     /*   6168 */     GIR_EraseRootFromParent_Done,
     /*   6169 */   // Label 214: @6169
     /*   6169 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(6231), // Rule ID 23735 //
     /*   6174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6213 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6229 */     GIR_RootConstrainSelectedInstOperands,
     /*   6230 */     // GIR_Coverage, 23735,
     /*   6230 */     GIR_EraseRootFromParent_Done,
     /*   6231 */   // Label 215: @6231
     /*   6231 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(6293), // Rule ID 2533 //
     /*   6236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6258 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6275 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6280 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6282 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6291 */     GIR_RootConstrainSelectedInstOperands,
     /*   6292 */     // GIR_Coverage, 2533,
     /*   6292 */     GIR_EraseRootFromParent_Done,
     /*   6293 */   // Label 216: @6293
     /*   6293 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(6355), // Rule ID 4696 //
     /*   6298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6337 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6353 */     GIR_RootConstrainSelectedInstOperands,
     /*   6354 */     // GIR_Coverage, 4696,
     /*   6354 */     GIR_EraseRootFromParent_Done,
     /*   6355 */   // Label 217: @6355
     /*   6355 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(6382), // Rule ID 2532 //
     /*   6360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6375 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*   6375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*   6380 */     GIR_RootConstrainSelectedInstOperands,
     /*   6381 */     // GIR_Coverage, 2532,
     /*   6381 */     GIR_Done,
     /*   6382 */   // Label 218: @6382
     /*   6382 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6409), // Rule ID 4693 //
     /*   6387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6402 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*   6402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*   6407 */     GIR_RootConstrainSelectedInstOperands,
     /*   6408 */     // GIR_Coverage, 4693,
     /*   6408 */     GIR_Done,
     /*   6409 */   // Label 219: @6409
     /*   6409 */   GIM_Reject,
     /*   6410 */ // Label 213: @6410
     /*   6410 */ GIM_Reject,
     /*   6411 */ // Label 90: @6411
     /*   6411 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6566),
     /*   6416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*   6419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*   6422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6426 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6484), // Rule ID 23714 //
     /*   6431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6466 */     // (add:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6471 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6482 */     GIR_RootConstrainSelectedInstOperands,
     /*   6483 */     // GIR_Coverage, 23714,
     /*   6483 */     GIR_EraseRootFromParent_Done,
     /*   6484 */   // Label 221: @6484
     /*   6484 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6542), // Rule ID 4663 //
     /*   6489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6524 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6540 */     GIR_RootConstrainSelectedInstOperands,
     /*   6541 */     // GIR_Coverage, 4663,
     /*   6541 */     GIR_EraseRootFromParent_Done,
     /*   6542 */   // Label 222: @6542
     /*   6542 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6565), // Rule ID 4660 //
     /*   6547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6558 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*   6558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 4660,
     /*   6564 */     GIR_Done,
     /*   6565 */   // Label 223: @6565
     /*   6565 */   GIM_Reject,
     /*   6566 */ // Label 220: @6566
     /*   6566 */ GIM_Reject,
     /*   6567 */ // Label 91: @6567
     /*   6567 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6881),
     /*   6572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*   6575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*   6578 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6640), // Rule ID 23431 //
     /*   6583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6622 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6627 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6629 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6638 */     GIR_RootConstrainSelectedInstOperands,
     /*   6639 */     // GIR_Coverage, 23431,
     /*   6639 */     GIR_EraseRootFromParent_Done,
     /*   6640 */   // Label 225: @6640
     /*   6640 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6702), // Rule ID 23744 //
     /*   6645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6684 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6700 */     GIR_RootConstrainSelectedInstOperands,
     /*   6701 */     // GIR_Coverage, 23744,
     /*   6701 */     GIR_EraseRootFromParent_Done,
     /*   6702 */   // Label 226: @6702
     /*   6702 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6764), // Rule ID 2527 //
     /*   6707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6726 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6729 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6733 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6746 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6762 */     GIR_RootConstrainSelectedInstOperands,
     /*   6763 */     // GIR_Coverage, 2527,
     /*   6763 */     GIR_EraseRootFromParent_Done,
     /*   6764 */   // Label 227: @6764
     /*   6764 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6826), // Rule ID 4714 //
     /*   6769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6788 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6808 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6824 */     GIR_RootConstrainSelectedInstOperands,
     /*   6825 */     // GIR_Coverage, 4714,
     /*   6825 */     GIR_EraseRootFromParent_Done,
     /*   6826 */   // Label 228: @6826
     /*   6826 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6853), // Rule ID 2526 //
     /*   6831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6846 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*   6846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*   6851 */     GIR_RootConstrainSelectedInstOperands,
     /*   6852 */     // GIR_Coverage, 2526,
     /*   6852 */     GIR_Done,
     /*   6853 */   // Label 229: @6853
     /*   6853 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6880), // Rule ID 4711 //
     /*   6858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6873 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*   6873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*   6878 */     GIR_RootConstrainSelectedInstOperands,
     /*   6879 */     // GIR_Coverage, 4711,
     /*   6879 */     GIR_Done,
     /*   6880 */   // Label 230: @6880
     /*   6880 */   GIM_Reject,
     /*   6881 */ // Label 224: @6881
     /*   6881 */ GIM_Reject,
     /*   6882 */ // Label 92: @6882
     /*   6882 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(7037),
     /*   6887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*   6890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*   6893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6897 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6955), // Rule ID 23732 //
     /*   6902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   6905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6937 */     // (add:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   6940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6953 */     GIR_RootConstrainSelectedInstOperands,
     /*   6954 */     // GIR_Coverage, 23732,
     /*   6954 */     GIR_EraseRootFromParent_Done,
     /*   6955 */   // Label 232: @6955
     /*   6955 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(7013), // Rule ID 4690 //
     /*   6960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   6963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6995 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   6998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7011 */     GIR_RootConstrainSelectedInstOperands,
     /*   7012 */     // GIR_Coverage, 4690,
     /*   7012 */     GIR_EraseRootFromParent_Done,
     /*   7013 */   // Label 233: @7013
     /*   7013 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7036), // Rule ID 4687 //
     /*   7018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7029 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*   7029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*   7034 */     GIR_RootConstrainSelectedInstOperands,
     /*   7035 */     // GIR_Coverage, 4687,
     /*   7035 */     GIR_Done,
     /*   7036 */   // Label 234: @7036
     /*   7036 */   GIM_Reject,
     /*   7037 */ // Label 231: @7037
     /*   7037 */ GIM_Reject,
     /*   7038 */ // Label 93: @7038
     /*   7038 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7193),
     /*   7043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*   7046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*   7049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7053 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7111), // Rule ID 23741 //
     /*   7058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7093 */     // (add:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7098 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7109 */     GIR_RootConstrainSelectedInstOperands,
     /*   7110 */     // GIR_Coverage, 23741,
     /*   7110 */     GIR_EraseRootFromParent_Done,
     /*   7111 */   // Label 236: @7111
     /*   7111 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7169), // Rule ID 4708 //
     /*   7116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7131 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7151 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7167 */     GIR_RootConstrainSelectedInstOperands,
     /*   7168 */     // GIR_Coverage, 4708,
     /*   7168 */     GIR_EraseRootFromParent_Done,
     /*   7169 */   // Label 237: @7169
     /*   7169 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7192), // Rule ID 4705 //
     /*   7174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7185 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*   7185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 4705,
     /*   7191 */     GIR_Done,
     /*   7192 */   // Label 238: @7192
     /*   7192 */   GIM_Reject,
     /*   7193 */ // Label 235: @7193
     /*   7193 */ GIM_Reject,
     /*   7194 */ // Label 94: @7194
     /*   7194 */ GIM_Reject,
     /*   7195 */ // Label 1: @7195
     /*   7195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 255*/ GIMT_Encode4(10730),
     /*   7206 */ /*GILLT_s8*//*Label 239*/ GIMT_Encode4(7302),
     /*   7210 */ /*GILLT_s16*//*Label 240*/ GIMT_Encode4(7654),
     /*   7214 */ /*GILLT_s32*//*Label 241*/ GIMT_Encode4(8006),
     /*   7218 */ /*GILLT_s64*//*Label 242*/ GIMT_Encode4(8358), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   7234 */ /*GILLT_v2s64*//*Label 243*/ GIMT_Encode4(8718), GIMT_Encode4(0),
     /*   7242 */ /*GILLT_v4s32*//*Label 244*/ GIMT_Encode4(8936),
     /*   7246 */ /*GILLT_v4s64*//*Label 245*/ GIMT_Encode4(9154), GIMT_Encode4(0),
     /*   7254 */ /*GILLT_v8s16*//*Label 246*/ GIMT_Encode4(9345),
     /*   7258 */ /*GILLT_v8s32*//*Label 247*/ GIMT_Encode4(9563),
     /*   7262 */ /*GILLT_v8s64*//*Label 248*/ GIMT_Encode4(9754), GIMT_Encode4(0),
     /*   7270 */ /*GILLT_v16s8*//*Label 249*/ GIMT_Encode4(9848),
     /*   7274 */ /*GILLT_v16s16*//*Label 250*/ GIMT_Encode4(10066),
     /*   7278 */ /*GILLT_v16s32*//*Label 251*/ GIMT_Encode4(10257), GIMT_Encode4(0),
     /*   7286 */ /*GILLT_v32s8*//*Label 252*/ GIMT_Encode4(10351),
     /*   7290 */ /*GILLT_v32s16*//*Label 253*/ GIMT_Encode4(10542), GIMT_Encode4(0),
     /*   7298 */ /*GILLT_v64s8*//*Label 254*/ GIMT_Encode4(10636),
     /*   7302 */ // Label 239: @7302
     /*   7302 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(7653),
     /*   7307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   7310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   7313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7317 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(7378), // Rule ID 22808 //
     /*   7322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7344 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7357 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm),
     /*   7360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7376 */     GIR_RootConstrainSelectedInstOperands,
     /*   7377 */     // GIR_Coverage, 22808,
     /*   7377 */     GIR_EraseRootFromParent_Done,
     /*   7378 */   // Label 257: @7378
     /*   7378 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(7439), // Rule ID 22898 //
     /*   7383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7405 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7418 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm_ND),
     /*   7421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7437 */     GIR_RootConstrainSelectedInstOperands,
     /*   7438 */     // GIR_Coverage, 22898,
     /*   7438 */     GIR_EraseRootFromParent_Done,
     /*   7439 */   // Label 258: @7439
     /*   7439 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(7467), // Rule ID 241 //
     /*   7444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7455 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7465 */     GIR_RootConstrainSelectedInstOperands,
     /*   7466 */     // GIR_Coverage, 241,
     /*   7466 */     GIR_EraseRootFromParent_Done,
     /*   7467 */   // Label 259: @7467
     /*   7467 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(7495), // Rule ID 249 //
     /*   7472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7483 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*   7486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7493 */     GIR_RootConstrainSelectedInstOperands,
     /*   7494 */     // GIR_Coverage, 249,
     /*   7494 */     GIR_EraseRootFromParent_Done,
     /*   7495 */   // Label 260: @7495
     /*   7495 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(7520), // Rule ID 257 //
     /*   7500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7511 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*   7511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*   7514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7518 */     GIR_RootConstrainSelectedInstOperands,
     /*   7519 */     // GIR_Coverage, 257,
     /*   7519 */     GIR_EraseRootFromParent_Done,
     /*   7520 */   // Label 261: @7520
     /*   7520 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(7557), // Rule ID 22812 //
     /*   7525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7540 */     // MIs[1] Operand 1
     /*   7540 */     // No operand predicates
     /*   7540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7542 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*   7545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7547 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7555 */     GIR_RootConstrainSelectedInstOperands,
     /*   7556 */     // GIR_Coverage, 22812,
     /*   7556 */     GIR_EraseRootFromParent_Done,
     /*   7557 */   // Label 262: @7557
     /*   7557 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(7594), // Rule ID 22902 //
     /*   7562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7577 */     // MIs[1] Operand 1
     /*   7577 */     // No operand predicates
     /*   7577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7579 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*   7582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7584 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7592 */     GIR_RootConstrainSelectedInstOperands,
     /*   7593 */     // GIR_Coverage, 22902,
     /*   7593 */     GIR_EraseRootFromParent_Done,
     /*   7594 */   // Label 263: @7594
     /*   7594 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(7623), // Rule ID 22804 //
     /*   7599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7610 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*   7615 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 22804,
     /*   7622 */     GIR_Done,
     /*   7623 */   // Label 264: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(7652), // Rule ID 22894 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7639 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*   7644 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7650 */     GIR_RootConstrainSelectedInstOperands,
     /*   7651 */     // GIR_Coverage, 22894,
     /*   7651 */     GIR_Done,
     /*   7652 */   // Label 265: @7652
     /*   7652 */   GIM_Reject,
     /*   7653 */ // Label 256: @7653
     /*   7653 */ GIM_Reject,
     /*   7654 */ // Label 240: @7654
     /*   7654 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8005),
     /*   7659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   7662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   7665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7669 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(7730), // Rule ID 22809 //
     /*   7674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7696 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7709 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm),
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7728 */     GIR_RootConstrainSelectedInstOperands,
     /*   7729 */     // GIR_Coverage, 22809,
     /*   7729 */     GIR_EraseRootFromParent_Done,
     /*   7730 */   // Label 267: @7730
     /*   7730 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(7791), // Rule ID 22899 //
     /*   7735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7757 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7770 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm_ND),
     /*   7773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7789 */     GIR_RootConstrainSelectedInstOperands,
     /*   7790 */     // GIR_Coverage, 22899,
     /*   7790 */     GIR_EraseRootFromParent_Done,
     /*   7791 */   // Label 268: @7791
     /*   7791 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(7819), // Rule ID 242 //
     /*   7796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7807 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   7807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*   7810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7817 */     GIR_RootConstrainSelectedInstOperands,
     /*   7818 */     // GIR_Coverage, 242,
     /*   7818 */     GIR_EraseRootFromParent_Done,
     /*   7819 */   // Label 269: @7819
     /*   7819 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(7847), // Rule ID 250 //
     /*   7824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7835 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   7835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*   7838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7845 */     GIR_RootConstrainSelectedInstOperands,
     /*   7846 */     // GIR_Coverage, 250,
     /*   7846 */     GIR_EraseRootFromParent_Done,
     /*   7847 */   // Label 270: @7847
     /*   7847 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(7872), // Rule ID 258 //
     /*   7852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7863 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*   7863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*   7866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7870 */     GIR_RootConstrainSelectedInstOperands,
     /*   7871 */     // GIR_Coverage, 258,
     /*   7871 */     GIR_EraseRootFromParent_Done,
     /*   7872 */   // Label 271: @7872
     /*   7872 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(7909), // Rule ID 22813 //
     /*   7877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7892 */     // MIs[1] Operand 1
     /*   7892 */     // No operand predicates
     /*   7892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7894 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   7894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   7897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7899 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 22813,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 272: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(7946), // Rule ID 22903 //
     /*   7914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7929 */     // MIs[1] Operand 1
     /*   7929 */     // No operand predicates
     /*   7929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7931 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   7931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   7934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7944 */     GIR_RootConstrainSelectedInstOperands,
     /*   7945 */     // GIR_Coverage, 22903,
     /*   7945 */     GIR_EraseRootFromParent_Done,
     /*   7946 */   // Label 273: @7946
     /*   7946 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7975), // Rule ID 22805 //
     /*   7951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7962 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   7962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*   7967 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7973 */     GIR_RootConstrainSelectedInstOperands,
     /*   7974 */     // GIR_Coverage, 22805,
     /*   7974 */     GIR_Done,
     /*   7975 */   // Label 274: @7975
     /*   7975 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(8004), // Rule ID 22895 //
     /*   7980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7991 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   7991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*   7996 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8002 */     GIR_RootConstrainSelectedInstOperands,
     /*   8003 */     // GIR_Coverage, 22895,
     /*   8003 */     GIR_Done,
     /*   8004 */   // Label 275: @8004
     /*   8004 */   GIM_Reject,
     /*   8005 */ // Label 266: @8005
     /*   8005 */ GIM_Reject,
     /*   8006 */ // Label 241: @8006
     /*   8006 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8357),
     /*   8011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   8014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   8017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8021 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8082), // Rule ID 22810 //
     /*   8026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8041 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8048 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8061 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm),
     /*   8064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8066 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8080 */     GIR_RootConstrainSelectedInstOperands,
     /*   8081 */     // GIR_Coverage, 22810,
     /*   8081 */     GIR_EraseRootFromParent_Done,
     /*   8082 */   // Label 277: @8082
     /*   8082 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8143), // Rule ID 22900 //
     /*   8087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8109 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8122 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm_ND),
     /*   8125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8127 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8141 */     GIR_RootConstrainSelectedInstOperands,
     /*   8142 */     // GIR_Coverage, 22900,
     /*   8142 */     GIR_EraseRootFromParent_Done,
     /*   8143 */   // Label 278: @8143
     /*   8143 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8171), // Rule ID 243 //
     /*   8148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8159 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*   8162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8169 */     GIR_RootConstrainSelectedInstOperands,
     /*   8170 */     // GIR_Coverage, 243,
     /*   8170 */     GIR_EraseRootFromParent_Done,
     /*   8171 */   // Label 279: @8171
     /*   8171 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8199), // Rule ID 251 //
     /*   8176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8187 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*   8190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8197 */     GIR_RootConstrainSelectedInstOperands,
     /*   8198 */     // GIR_Coverage, 251,
     /*   8198 */     GIR_EraseRootFromParent_Done,
     /*   8199 */   // Label 280: @8199
     /*   8199 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8224), // Rule ID 259 //
     /*   8204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8215 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*   8218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8220 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8222 */     GIR_RootConstrainSelectedInstOperands,
     /*   8223 */     // GIR_Coverage, 259,
     /*   8223 */     GIR_EraseRootFromParent_Done,
     /*   8224 */   // Label 281: @8224
     /*   8224 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8261), // Rule ID 22814 //
     /*   8229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8244 */     // MIs[1] Operand 1
     /*   8244 */     // No operand predicates
     /*   8244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8246 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   8249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8259 */     GIR_RootConstrainSelectedInstOperands,
     /*   8260 */     // GIR_Coverage, 22814,
     /*   8260 */     GIR_EraseRootFromParent_Done,
     /*   8261 */   // Label 282: @8261
     /*   8261 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8298), // Rule ID 22904 //
     /*   8266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8281 */     // MIs[1] Operand 1
     /*   8281 */     // No operand predicates
     /*   8281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8283 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   8286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8288 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8296 */     GIR_RootConstrainSelectedInstOperands,
     /*   8297 */     // GIR_Coverage, 22904,
     /*   8297 */     GIR_EraseRootFromParent_Done,
     /*   8298 */   // Label 283: @8298
     /*   8298 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8327), // Rule ID 22806 //
     /*   8303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8314 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*   8319 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8325 */     GIR_RootConstrainSelectedInstOperands,
     /*   8326 */     // GIR_Coverage, 22806,
     /*   8326 */     GIR_Done,
     /*   8327 */   // Label 284: @8327
     /*   8327 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8356), // Rule ID 22896 //
     /*   8332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8343 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*   8348 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8354 */     GIR_RootConstrainSelectedInstOperands,
     /*   8355 */     // GIR_Coverage, 22896,
     /*   8355 */     GIR_Done,
     /*   8356 */   // Label 285: @8356
     /*   8356 */   GIM_Reject,
     /*   8357 */ // Label 276: @8357
     /*   8357 */ GIM_Reject,
     /*   8358 */ // Label 242: @8358
     /*   8358 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8717),
     /*   8363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   8366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   8369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8373 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8434), // Rule ID 22811 //
     /*   8378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8393 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8396 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8400 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8413 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm),
     /*   8416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8432 */     GIR_RootConstrainSelectedInstOperands,
     /*   8433 */     // GIR_Coverage, 22811,
     /*   8433 */     GIR_EraseRootFromParent_Done,
     /*   8434 */   // Label 287: @8434
     /*   8434 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8495), // Rule ID 22901 //
     /*   8439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8454 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8474 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm_ND),
     /*   8477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8479 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8493 */     GIR_RootConstrainSelectedInstOperands,
     /*   8494 */     // GIR_Coverage, 22901,
     /*   8494 */     GIR_EraseRootFromParent_Done,
     /*   8495 */   // Label 288: @8495
     /*   8495 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(8523), // Rule ID 244 //
     /*   8500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8511 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*   8514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8521 */     GIR_RootConstrainSelectedInstOperands,
     /*   8522 */     // GIR_Coverage, 244,
     /*   8522 */     GIR_EraseRootFromParent_Done,
     /*   8523 */   // Label 289: @8523
     /*   8523 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(8551), // Rule ID 252 //
     /*   8528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8539 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*   8542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8549 */     GIR_RootConstrainSelectedInstOperands,
     /*   8550 */     // GIR_Coverage, 252,
     /*   8550 */     GIR_EraseRootFromParent_Done,
     /*   8551 */   // Label 290: @8551
     /*   8551 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(8576), // Rule ID 260 //
     /*   8556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8567 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*   8567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*   8570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8574 */     GIR_RootConstrainSelectedInstOperands,
     /*   8575 */     // GIR_Coverage, 260,
     /*   8575 */     GIR_EraseRootFromParent_Done,
     /*   8576 */   // Label 291: @8576
     /*   8576 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(8617), // Rule ID 22815 //
     /*   8581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8600 */     // MIs[1] Operand 1
     /*   8600 */     // No operand predicates
     /*   8600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8602 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   8605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 22815,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 292: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(8658), // Rule ID 22905 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8641 */     // MIs[1] Operand 1
     /*   8641 */     // No operand predicates
     /*   8641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8643 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   8646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8656 */     GIR_RootConstrainSelectedInstOperands,
     /*   8657 */     // GIR_Coverage, 22905,
     /*   8657 */     GIR_EraseRootFromParent_Done,
     /*   8658 */   // Label 293: @8658
     /*   8658 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(8687), // Rule ID 22807 //
     /*   8663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8674 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*   8679 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 22807,
     /*   8686 */     GIR_Done,
     /*   8687 */   // Label 294: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(8716), // Rule ID 22897 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8703 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*   8708 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8714 */     GIR_RootConstrainSelectedInstOperands,
     /*   8715 */     // GIR_Coverage, 22897,
     /*   8715 */     GIR_Done,
     /*   8716 */   // Label 295: @8716
     /*   8716 */   GIM_Reject,
     /*   8717 */ // Label 286: @8717
     /*   8717 */ GIM_Reject,
     /*   8718 */ // Label 243: @8718
     /*   8718 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(8935),
     /*   8723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   8729 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(8791), // Rule ID 2607 //
     /*   8734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8773 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQrm),
     /*   8776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8789 */     GIR_RootConstrainSelectedInstOperands,
     /*   8790 */     // GIR_Coverage, 2607,
     /*   8790 */     GIR_EraseRootFromParent_Done,
     /*   8791 */   // Label 297: @8791
     /*   8791 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(8853), // Rule ID 4744 //
     /*   8796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   8799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8835 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rm),
     /*   8838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8851 */     GIR_RootConstrainSelectedInstOperands,
     /*   8852 */     // GIR_Coverage, 4744,
     /*   8852 */     GIR_EraseRootFromParent_Done,
     /*   8853 */   // Label 298: @8853
     /*   8853 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(8880), // Rule ID 2606 //
     /*   8858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8873 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   8873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*   8878 */     GIR_RootConstrainSelectedInstOperands,
     /*   8879 */     // GIR_Coverage, 2606,
     /*   8879 */     GIR_Done,
     /*   8880 */   // Label 299: @8880
     /*   8880 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(8907), // Rule ID 2608 //
     /*   8885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   8888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8900 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   8900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*   8905 */     GIR_RootConstrainSelectedInstOperands,
     /*   8906 */     // GIR_Coverage, 2608,
     /*   8906 */     GIR_Done,
     /*   8907 */   // Label 300: @8907
     /*   8907 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(8934), // Rule ID 4741 //
     /*   8912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   8915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8927 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   8927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*   8932 */     GIR_RootConstrainSelectedInstOperands,
     /*   8933 */     // GIR_Coverage, 4741,
     /*   8933 */     GIR_Done,
     /*   8934 */   // Label 301: @8934
     /*   8934 */   GIM_Reject,
     /*   8935 */ // Label 296: @8935
     /*   8935 */ GIM_Reject,
     /*   8936 */ // Label 244: @8936
     /*   8936 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(9153),
     /*   8941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8947 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(9009), // Rule ID 2601 //
     /*   8952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8991 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDrm),
     /*   8994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8996 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8998 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9007 */     GIR_RootConstrainSelectedInstOperands,
     /*   9008 */     // GIR_Coverage, 2601,
     /*   9008 */     GIR_EraseRootFromParent_Done,
     /*   9009 */   // Label 303: @9009
     /*   9009 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(9071), // Rule ID 4771 //
     /*   9014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9040 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9053 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rm),
     /*   9056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9069 */     GIR_RootConstrainSelectedInstOperands,
     /*   9070 */     // GIR_Coverage, 4771,
     /*   9070 */     GIR_EraseRootFromParent_Done,
     /*   9071 */   // Label 304: @9071
     /*   9071 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(9098), // Rule ID 2600 //
     /*   9076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9091 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*   9096 */     GIR_RootConstrainSelectedInstOperands,
     /*   9097 */     // GIR_Coverage, 2600,
     /*   9097 */     GIR_Done,
     /*   9098 */   // Label 305: @9098
     /*   9098 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(9125), // Rule ID 2602 //
     /*   9103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9118 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*   9123 */     GIR_RootConstrainSelectedInstOperands,
     /*   9124 */     // GIR_Coverage, 2602,
     /*   9124 */     GIR_Done,
     /*   9125 */   // Label 306: @9125
     /*   9125 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(9152), // Rule ID 4768 //
     /*   9130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9145 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   9145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*   9150 */     GIR_RootConstrainSelectedInstOperands,
     /*   9151 */     // GIR_Coverage, 4768,
     /*   9151 */     GIR_Done,
     /*   9152 */   // Label 307: @9152
     /*   9152 */   GIM_Reject,
     /*   9153 */ // Label 302: @9153
     /*   9153 */ GIM_Reject,
     /*   9154 */ // Label 245: @9154
     /*   9154 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(9344),
     /*   9159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   9162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   9165 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(9227), // Rule ID 2611 //
     /*   9170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9209 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrm),
     /*   9212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9225 */     GIR_RootConstrainSelectedInstOperands,
     /*   9226 */     // GIR_Coverage, 2611,
     /*   9226 */     GIR_EraseRootFromParent_Done,
     /*   9227 */   // Label 309: @9227
     /*   9227 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(9289), // Rule ID 4735 //
     /*   9232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9251 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9254 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9271 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rm),
     /*   9274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9287 */     GIR_RootConstrainSelectedInstOperands,
     /*   9288 */     // GIR_Coverage, 4735,
     /*   9288 */     GIR_EraseRootFromParent_Done,
     /*   9289 */   // Label 310: @9289
     /*   9289 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(9316), // Rule ID 2610 //
     /*   9294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9309 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   9309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*   9314 */     GIR_RootConstrainSelectedInstOperands,
     /*   9315 */     // GIR_Coverage, 2610,
     /*   9315 */     GIR_Done,
     /*   9316 */   // Label 311: @9316
     /*   9316 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(9343), // Rule ID 4732 //
     /*   9321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9336 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   9336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*   9341 */     GIR_RootConstrainSelectedInstOperands,
     /*   9342 */     // GIR_Coverage, 4732,
     /*   9342 */     GIR_Done,
     /*   9343 */   // Label 312: @9343
     /*   9343 */   GIM_Reject,
     /*   9344 */ // Label 308: @9344
     /*   9344 */ GIM_Reject,
     /*   9345 */ // Label 246: @9345
     /*   9345 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(9562),
     /*   9350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9356 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(9418), // Rule ID 2595 //
     /*   9361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9400 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWrm),
     /*   9403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9416 */     GIR_RootConstrainSelectedInstOperands,
     /*   9417 */     // GIR_Coverage, 2595,
     /*   9417 */     GIR_EraseRootFromParent_Done,
     /*   9418 */   // Label 314: @9418
     /*   9418 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(9480), // Rule ID 4792 //
     /*   9423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9462 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rm),
     /*   9465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9478 */     GIR_RootConstrainSelectedInstOperands,
     /*   9479 */     // GIR_Coverage, 4792,
     /*   9479 */     GIR_EraseRootFromParent_Done,
     /*   9480 */   // Label 315: @9480
     /*   9480 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(9507), // Rule ID 2594 //
     /*   9485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9500 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*   9505 */     GIR_RootConstrainSelectedInstOperands,
     /*   9506 */     // GIR_Coverage, 2594,
     /*   9506 */     GIR_Done,
     /*   9507 */   // Label 316: @9507
     /*   9507 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(9534), // Rule ID 2596 //
     /*   9512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9527 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*   9532 */     GIR_RootConstrainSelectedInstOperands,
     /*   9533 */     // GIR_Coverage, 2596,
     /*   9533 */     GIR_Done,
     /*   9534 */   // Label 317: @9534
     /*   9534 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(9561), // Rule ID 4789 //
     /*   9539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9554 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   9554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*   9559 */     GIR_RootConstrainSelectedInstOperands,
     /*   9560 */     // GIR_Coverage, 4789,
     /*   9560 */     GIR_Done,
     /*   9561 */   // Label 318: @9561
     /*   9561 */   GIM_Reject,
     /*   9562 */ // Label 313: @9562
     /*   9562 */ GIM_Reject,
     /*   9563 */ // Label 247: @9563
     /*   9563 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(9753),
     /*   9568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   9571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   9574 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(9636), // Rule ID 2605 //
     /*   9579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9618 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrm),
     /*   9621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9634 */     GIR_RootConstrainSelectedInstOperands,
     /*   9635 */     // GIR_Coverage, 2605,
     /*   9635 */     GIR_EraseRootFromParent_Done,
     /*   9636 */   // Label 320: @9636
     /*   9636 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(9698), // Rule ID 4762 //
     /*   9641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9680 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rm),
     /*   9683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9696 */     GIR_RootConstrainSelectedInstOperands,
     /*   9697 */     // GIR_Coverage, 4762,
     /*   9697 */     GIR_EraseRootFromParent_Done,
     /*   9698 */   // Label 321: @9698
     /*   9698 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(9725), // Rule ID 2604 //
     /*   9703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9718 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   9718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*   9723 */     GIR_RootConstrainSelectedInstOperands,
     /*   9724 */     // GIR_Coverage, 2604,
     /*   9724 */     GIR_Done,
     /*   9725 */   // Label 322: @9725
     /*   9725 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(9752), // Rule ID 4759 //
     /*   9730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9745 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   9745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*   9750 */     GIR_RootConstrainSelectedInstOperands,
     /*   9751 */     // GIR_Coverage, 4759,
     /*   9751 */     GIR_Done,
     /*   9752 */   // Label 323: @9752
     /*   9752 */   GIM_Reject,
     /*   9753 */ // Label 319: @9753
     /*   9753 */ GIM_Reject,
     /*   9754 */ // Label 248: @9754
     /*   9754 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(9847),
     /*   9759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   9762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   9765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9773 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(9827), // Rule ID 4726 //
     /*   9778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9789 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9796 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9809 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrm),
     /*   9812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9814 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9825 */     GIR_RootConstrainSelectedInstOperands,
     /*   9826 */     // GIR_Coverage, 4726,
     /*   9826 */     GIR_EraseRootFromParent_Done,
     /*   9827 */   // Label 325: @9827
     /*   9827 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(9846), // Rule ID 4723 //
     /*   9832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9839 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   9839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*   9844 */     GIR_RootConstrainSelectedInstOperands,
     /*   9845 */     // GIR_Coverage, 4723,
     /*   9845 */     GIR_Done,
     /*   9846 */   // Label 326: @9846
     /*   9846 */   GIM_Reject,
     /*   9847 */ // Label 324: @9847
     /*   9847 */ GIM_Reject,
     /*   9848 */ // Label 249: @9848
     /*   9848 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(10065),
     /*   9853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   9856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   9859 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(9921), // Rule ID 2589 //
     /*   9864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9903 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBrm),
     /*   9906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9919 */     GIR_RootConstrainSelectedInstOperands,
     /*   9920 */     // GIR_Coverage, 2589,
     /*   9920 */     GIR_EraseRootFromParent_Done,
     /*   9921 */   // Label 328: @9921
     /*   9921 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(9983), // Rule ID 4810 //
     /*   9926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9945 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9952 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9965 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rm),
     /*   9968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9981 */     GIR_RootConstrainSelectedInstOperands,
     /*   9982 */     // GIR_Coverage, 4810,
     /*   9982 */     GIR_EraseRootFromParent_Done,
     /*   9983 */   // Label 329: @9983
     /*   9983 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(10010), // Rule ID 2588 //
     /*   9988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10003 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*  10008 */     GIR_RootConstrainSelectedInstOperands,
     /*  10009 */     // GIR_Coverage, 2588,
     /*  10009 */     GIR_Done,
     /*  10010 */   // Label 330: @10010
     /*  10010 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(10037), // Rule ID 2590 //
     /*  10015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  10018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10030 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  10035 */     GIR_RootConstrainSelectedInstOperands,
     /*  10036 */     // GIR_Coverage, 2590,
     /*  10036 */     GIR_Done,
     /*  10037 */   // Label 331: @10037
     /*  10037 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(10064), // Rule ID 4807 //
     /*  10042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10057 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  10057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  10062 */     GIR_RootConstrainSelectedInstOperands,
     /*  10063 */     // GIR_Coverage, 4807,
     /*  10063 */     GIR_Done,
     /*  10064 */   // Label 332: @10064
     /*  10064 */   GIM_Reject,
     /*  10065 */ // Label 327: @10065
     /*  10065 */ GIM_Reject,
     /*  10066 */ // Label 250: @10066
     /*  10066 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10256),
     /*  10071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  10074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  10077 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(10139), // Rule ID 2599 //
     /*  10082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10121 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrm),
     /*  10124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10126 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10137 */     GIR_RootConstrainSelectedInstOperands,
     /*  10138 */     // GIR_Coverage, 2599,
     /*  10138 */     GIR_EraseRootFromParent_Done,
     /*  10139 */   // Label 334: @10139
     /*  10139 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10201), // Rule ID 4786 //
     /*  10144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10183 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rm),
     /*  10186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10199 */     GIR_RootConstrainSelectedInstOperands,
     /*  10200 */     // GIR_Coverage, 4786,
     /*  10200 */     GIR_EraseRootFromParent_Done,
     /*  10201 */   // Label 335: @10201
     /*  10201 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10228), // Rule ID 2598 //
     /*  10206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10221 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  10221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  10226 */     GIR_RootConstrainSelectedInstOperands,
     /*  10227 */     // GIR_Coverage, 2598,
     /*  10227 */     GIR_Done,
     /*  10228 */   // Label 336: @10228
     /*  10228 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10255), // Rule ID 4783 //
     /*  10233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10248 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  10248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  10253 */     GIR_RootConstrainSelectedInstOperands,
     /*  10254 */     // GIR_Coverage, 4783,
     /*  10254 */     GIR_Done,
     /*  10255 */   // Label 337: @10255
     /*  10255 */   GIM_Reject,
     /*  10256 */ // Label 333: @10256
     /*  10256 */ GIM_Reject,
     /*  10257 */ // Label 251: @10257
     /*  10257 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10350),
     /*  10262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  10265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  10268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10276 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10330), // Rule ID 4753 //
     /*  10281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10312 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrm),
     /*  10315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10328 */     GIR_RootConstrainSelectedInstOperands,
     /*  10329 */     // GIR_Coverage, 4753,
     /*  10329 */     GIR_EraseRootFromParent_Done,
     /*  10330 */   // Label 339: @10330
     /*  10330 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10349), // Rule ID 4750 //
     /*  10335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10342 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  10342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  10347 */     GIR_RootConstrainSelectedInstOperands,
     /*  10348 */     // GIR_Coverage, 4750,
     /*  10348 */     GIR_Done,
     /*  10349 */   // Label 340: @10349
     /*  10349 */   GIM_Reject,
     /*  10350 */ // Label 338: @10350
     /*  10350 */ GIM_Reject,
     /*  10351 */ // Label 252: @10351
     /*  10351 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10541),
     /*  10356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  10359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  10362 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10424), // Rule ID 2593 //
     /*  10367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10406 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrm),
     /*  10409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10422 */     GIR_RootConstrainSelectedInstOperands,
     /*  10423 */     // GIR_Coverage, 2593,
     /*  10423 */     GIR_EraseRootFromParent_Done,
     /*  10424 */   // Label 342: @10424
     /*  10424 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10486), // Rule ID 4804 //
     /*  10429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10468 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rm),
     /*  10471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10484 */     GIR_RootConstrainSelectedInstOperands,
     /*  10485 */     // GIR_Coverage, 4804,
     /*  10485 */     GIR_EraseRootFromParent_Done,
     /*  10486 */   // Label 343: @10486
     /*  10486 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10513), // Rule ID 2592 //
     /*  10491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10506 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  10506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  10511 */     GIR_RootConstrainSelectedInstOperands,
     /*  10512 */     // GIR_Coverage, 2592,
     /*  10512 */     GIR_Done,
     /*  10513 */   // Label 344: @10513
     /*  10513 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10540), // Rule ID 4801 //
     /*  10518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10533 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  10533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 4801,
     /*  10539 */     GIR_Done,
     /*  10540 */   // Label 345: @10540
     /*  10540 */   GIM_Reject,
     /*  10541 */ // Label 341: @10541
     /*  10541 */ GIM_Reject,
     /*  10542 */ // Label 253: @10542
     /*  10542 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10635),
     /*  10547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  10550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  10553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10561 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10615), // Rule ID 4780 //
     /*  10566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10597 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrm),
     /*  10600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10604 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10613 */     GIR_RootConstrainSelectedInstOperands,
     /*  10614 */     // GIR_Coverage, 4780,
     /*  10614 */     GIR_EraseRootFromParent_Done,
     /*  10615 */   // Label 347: @10615
     /*  10615 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10634), // Rule ID 4777 //
     /*  10620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10627 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  10627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  10632 */     GIR_RootConstrainSelectedInstOperands,
     /*  10633 */     // GIR_Coverage, 4777,
     /*  10633 */     GIR_Done,
     /*  10634 */   // Label 348: @10634
     /*  10634 */   GIM_Reject,
     /*  10635 */ // Label 346: @10635
     /*  10635 */ GIM_Reject,
     /*  10636 */ // Label 254: @10636
     /*  10636 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10729),
     /*  10641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  10644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  10647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10655 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10709), // Rule ID 4798 //
     /*  10660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10671 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10691 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrm),
     /*  10694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10707 */     GIR_RootConstrainSelectedInstOperands,
     /*  10708 */     // GIR_Coverage, 4798,
     /*  10708 */     GIR_EraseRootFromParent_Done,
     /*  10709 */   // Label 350: @10709
     /*  10709 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10728), // Rule ID 4795 //
     /*  10714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10721 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  10721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  10726 */     GIR_RootConstrainSelectedInstOperands,
     /*  10727 */     // GIR_Coverage, 4795,
     /*  10727 */     GIR_Done,
     /*  10728 */   // Label 351: @10728
     /*  10728 */   GIM_Reject,
     /*  10729 */ // Label 349: @10729
     /*  10729 */ GIM_Reject,
     /*  10730 */ // Label 255: @10730
     /*  10730 */ GIM_Reject,
     /*  10731 */ // Label 2: @10731
     /*  10731 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 364*/ GIMT_Encode4(14513),
     /*  10742 */ /*GILLT_s16*//*Label 352*/ GIMT_Encode4(10826),
     /*  10746 */ /*GILLT_s32*//*Label 353*/ GIMT_Encode4(11243),
     /*  10750 */ /*GILLT_s64*//*Label 354*/ GIMT_Encode4(11660), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10766 */ /*GILLT_v2s64*//*Label 355*/ GIMT_Encode4(12085), GIMT_Encode4(0),
     /*  10774 */ /*GILLT_v4s32*//*Label 356*/ GIMT_Encode4(12414),
     /*  10778 */ /*GILLT_v4s64*//*Label 357*/ GIMT_Encode4(12756), GIMT_Encode4(0),
     /*  10786 */ /*GILLT_v8s16*//*Label 358*/ GIMT_Encode4(13073),
     /*  10790 */ /*GILLT_v8s32*//*Label 359*/ GIMT_Encode4(13415),
     /*  10794 */ /*GILLT_v8s64*//*Label 360*/ GIMT_Encode4(13730), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10806 */ /*GILLT_v16s16*//*Label 361*/ GIMT_Encode4(13886),
     /*  10810 */ /*GILLT_v16s32*//*Label 362*/ GIMT_Encode4(14201), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10822 */ /*GILLT_v32s16*//*Label 363*/ GIMT_Encode4(14357),
     /*  10826 */ // Label 352: @10826
     /*  10826 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(11242),
     /*  10831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  10834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  10837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10841 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(10905), // Rule ID 22979 //
     /*  10846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10861 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  10869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10873 */     // MIs[2] Operand 1
     /*  10873 */     // No operand predicates
     /*  10873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10882 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  10882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rmi),
     /*  10885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  10891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  10894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  10897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  10903 */     GIR_RootConstrainSelectedInstOperands,
     /*  10904 */     // GIR_Coverage, 22979,
     /*  10904 */     GIR_EraseRootFromParent_Done,
     /*  10905 */   // Label 366: @10905
     /*  10905 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(10966), // Rule ID 26058 //
     /*  10910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  10913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10928 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10945 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  10948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10950 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10952 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  10959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10964 */     GIR_RootConstrainSelectedInstOperands,
     /*  10965 */     // GIR_Coverage, 26058,
     /*  10965 */     GIR_EraseRootFromParent_Done,
     /*  10966 */   // Label 367: @10966
     /*  10966 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11027), // Rule ID 26077 //
     /*  10971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  10974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10989 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11006 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11011 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11025 */     GIR_RootConstrainSelectedInstOperands,
     /*  11026 */     // GIR_Coverage, 26077,
     /*  11026 */     GIR_EraseRootFromParent_Done,
     /*  11027 */   // Label 368: @11027
     /*  11027 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11088), // Rule ID 22823 //
     /*  11032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11047 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11054 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11067 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11072 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11086 */     GIR_RootConstrainSelectedInstOperands,
     /*  11087 */     // GIR_Coverage, 22823,
     /*  11087 */     GIR_EraseRootFromParent_Done,
     /*  11088 */   // Label 369: @11088
     /*  11088 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11149), // Rule ID 22913 //
     /*  11093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11115 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11128 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11147 */     GIR_RootConstrainSelectedInstOperands,
     /*  11148 */     // GIR_Coverage, 22913,
     /*  11148 */     GIR_EraseRootFromParent_Done,
     /*  11149 */   // Label 370: @11149
     /*  11149 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11183), // Rule ID 22976 //
     /*  11154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11166 */     // MIs[1] Operand 1
     /*  11166 */     // No operand predicates
     /*  11166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11168 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11181 */     GIR_RootConstrainSelectedInstOperands,
     /*  11182 */     // GIR_Coverage, 22976,
     /*  11182 */     GIR_EraseRootFromParent_Done,
     /*  11183 */   // Label 371: @11183
     /*  11183 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11212), // Rule ID 22820 //
     /*  11188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11199 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  11204 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11210 */     GIR_RootConstrainSelectedInstOperands,
     /*  11211 */     // GIR_Coverage, 22820,
     /*  11211 */     GIR_Done,
     /*  11212 */   // Label 372: @11212
     /*  11212 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11241), // Rule ID 22910 //
     /*  11217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11228 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  11233 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11239 */     GIR_RootConstrainSelectedInstOperands,
     /*  11240 */     // GIR_Coverage, 22910,
     /*  11240 */     GIR_Done,
     /*  11241 */   // Label 373: @11241
     /*  11241 */   GIM_Reject,
     /*  11242 */ // Label 365: @11242
     /*  11242 */ GIM_Reject,
     /*  11243 */ // Label 353: @11243
     /*  11243 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11659),
     /*  11248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  11251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  11254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11258 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11322), // Rule ID 22980 //
     /*  11263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11271 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11278 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11290 */     // MIs[2] Operand 1
     /*  11290 */     // No operand predicates
     /*  11290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11299 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rmi:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rmi),
     /*  11302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11320 */     GIR_RootConstrainSelectedInstOperands,
     /*  11321 */     // GIR_Coverage, 22980,
     /*  11321 */     GIR_EraseRootFromParent_Done,
     /*  11322 */   // Label 375: @11322
     /*  11322 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11383), // Rule ID 26059 //
     /*  11327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11345 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11362 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11381 */     GIR_RootConstrainSelectedInstOperands,
     /*  11382 */     // GIR_Coverage, 26059,
     /*  11382 */     GIR_EraseRootFromParent_Done,
     /*  11383 */   // Label 376: @11383
     /*  11383 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11444), // Rule ID 26078 //
     /*  11388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11399 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11406 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11423 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11428 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11442 */     GIR_RootConstrainSelectedInstOperands,
     /*  11443 */     // GIR_Coverage, 26078,
     /*  11443 */     GIR_EraseRootFromParent_Done,
     /*  11444 */   // Label 377: @11444
     /*  11444 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11505), // Rule ID 22824 //
     /*  11449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11471 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11484 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11489 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11503 */     GIR_RootConstrainSelectedInstOperands,
     /*  11504 */     // GIR_Coverage, 22824,
     /*  11504 */     GIR_EraseRootFromParent_Done,
     /*  11505 */   // Label 378: @11505
     /*  11505 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11566), // Rule ID 22914 //
     /*  11510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11525 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11528 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11532 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11545 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11550 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11552 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11564 */     GIR_RootConstrainSelectedInstOperands,
     /*  11565 */     // GIR_Coverage, 22914,
     /*  11565 */     GIR_EraseRootFromParent_Done,
     /*  11566 */   // Label 379: @11566
     /*  11566 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11600), // Rule ID 22977 //
     /*  11571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11583 */     // MIs[1] Operand 1
     /*  11583 */     // No operand predicates
     /*  11583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11585 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  11588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11590 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11598 */     GIR_RootConstrainSelectedInstOperands,
     /*  11599 */     // GIR_Coverage, 22977,
     /*  11599 */     GIR_EraseRootFromParent_Done,
     /*  11600 */   // Label 380: @11600
     /*  11600 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11629), // Rule ID 22821 //
     /*  11605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11616 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  11621 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11627 */     GIR_RootConstrainSelectedInstOperands,
     /*  11628 */     // GIR_Coverage, 22821,
     /*  11628 */     GIR_Done,
     /*  11629 */   // Label 381: @11629
     /*  11629 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(11658), // Rule ID 22911 //
     /*  11634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11645 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  11650 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11656 */     GIR_RootConstrainSelectedInstOperands,
     /*  11657 */     // GIR_Coverage, 22911,
     /*  11657 */     GIR_Done,
     /*  11658 */   // Label 382: @11658
     /*  11658 */   GIM_Reject,
     /*  11659 */ // Label 374: @11659
     /*  11659 */ GIM_Reject,
     /*  11660 */ // Label 354: @11660
     /*  11660 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(12084),
     /*  11665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11675 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(11743), // Rule ID 22981 //
     /*  11680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  11711 */     // MIs[2] Operand 1
     /*  11711 */     // No operand predicates
     /*  11711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11720 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rmi32:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  11720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rmi32),
     /*  11723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11741 */     GIR_RootConstrainSelectedInstOperands,
     /*  11742 */     // GIR_Coverage, 22981,
     /*  11742 */     GIR_EraseRootFromParent_Done,
     /*  11743 */   // Label 384: @11743
     /*  11743 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(11804), // Rule ID 26060 //
     /*  11748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11783 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11802 */     GIR_RootConstrainSelectedInstOperands,
     /*  11803 */     // GIR_Coverage, 26060,
     /*  11803 */     GIR_EraseRootFromParent_Done,
     /*  11804 */   // Label 385: @11804
     /*  11804 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(11865), // Rule ID 26079 //
     /*  11809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11844 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  11847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11849 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11863 */     GIR_RootConstrainSelectedInstOperands,
     /*  11864 */     // GIR_Coverage, 26079,
     /*  11864 */     GIR_EraseRootFromParent_Done,
     /*  11865 */   // Label 386: @11865
     /*  11865 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(11926), // Rule ID 22825 //
     /*  11870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11885 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11905 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11924 */     GIR_RootConstrainSelectedInstOperands,
     /*  11925 */     // GIR_Coverage, 22825,
     /*  11925 */     GIR_EraseRootFromParent_Done,
     /*  11926 */   // Label 387: @11926
     /*  11926 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(11987), // Rule ID 22915 //
     /*  11931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11966 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  11969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11985 */     GIR_RootConstrainSelectedInstOperands,
     /*  11986 */     // GIR_Coverage, 22915,
     /*  11986 */     GIR_EraseRootFromParent_Done,
     /*  11987 */   // Label 388: @11987
     /*  11987 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12025), // Rule ID 22978 //
     /*  11992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  12008 */     // MIs[1] Operand 1
     /*  12008 */     // No operand predicates
     /*  12008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12010 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  12010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  12013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  12020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12023 */     GIR_RootConstrainSelectedInstOperands,
     /*  12024 */     // GIR_Coverage, 22978,
     /*  12024 */     GIR_EraseRootFromParent_Done,
     /*  12025 */   // Label 389: @12025
     /*  12025 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12054), // Rule ID 22822 //
     /*  12030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12041 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  12046 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12052 */     GIR_RootConstrainSelectedInstOperands,
     /*  12053 */     // GIR_Coverage, 22822,
     /*  12053 */     GIR_Done,
     /*  12054 */   // Label 390: @12054
     /*  12054 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12083), // Rule ID 22912 //
     /*  12059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12070 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  12075 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12081 */     GIR_RootConstrainSelectedInstOperands,
     /*  12082 */     // GIR_Coverage, 22912,
     /*  12082 */     GIR_Done,
     /*  12083 */   // Label 391: @12083
     /*  12083 */   GIM_Reject,
     /*  12084 */ // Label 383: @12084
     /*  12084 */ GIM_Reject,
     /*  12085 */ // Label 355: @12085
     /*  12085 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12413),
     /*  12090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  12093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  12096 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12158), // Rule ID 23825 //
     /*  12101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12116 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12140 */     // (mul:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12156 */     GIR_RootConstrainSelectedInstOperands,
     /*  12157 */     // GIR_Coverage, 23825,
     /*  12157 */     GIR_EraseRootFromParent_Done,
     /*  12158 */   // Label 393: @12158
     /*  12158 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12220), // Rule ID 5023 //
     /*  12163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12202 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12218 */     GIR_RootConstrainSelectedInstOperands,
     /*  12219 */     // GIR_Coverage, 5023,
     /*  12219 */     GIR_EraseRootFromParent_Done,
     /*  12220 */   // Label 394: @12220
     /*  12220 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12247), // Rule ID 5020 //
     /*  12225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12240 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  12240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  12245 */     GIR_RootConstrainSelectedInstOperands,
     /*  12246 */     // GIR_Coverage, 5020,
     /*  12246 */     GIR_Done,
     /*  12247 */   // Label 395: @12247
     /*  12247 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(12412), // Rule ID 19998 //
     /*  12252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  12259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12267 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  12267 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12270 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12274 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12281 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12284 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12288 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12293 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12296 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12300 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  12303 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12308 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12313 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12344 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  12351 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  12354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12359 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  12372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  12376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12384 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  12387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12394 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  12401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  12406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12411 */     // GIR_Coverage, 19998,
     /*  12411 */     GIR_EraseRootFromParent_Done,
     /*  12412 */   // Label 396: @12412
     /*  12412 */   GIM_Reject,
     /*  12413 */ // Label 392: @12413
     /*  12413 */ GIM_Reject,
     /*  12414 */ // Label 356: @12414
     /*  12414 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(12755),
     /*  12419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12425 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(12487), // Rule ID 23528 //
     /*  12430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12469 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12485 */     GIR_RootConstrainSelectedInstOperands,
     /*  12486 */     // GIR_Coverage, 23528,
     /*  12486 */     GIR_EraseRootFromParent_Done,
     /*  12487 */   // Label 398: @12487
     /*  12487 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(12549), // Rule ID 23798 //
     /*  12492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12531 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12547 */     GIR_RootConstrainSelectedInstOperands,
     /*  12548 */     // GIR_Coverage, 23798,
     /*  12548 */     GIR_EraseRootFromParent_Done,
     /*  12549 */   // Label 399: @12549
     /*  12549 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(12611), // Rule ID 3240 //
     /*  12554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12573 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12580 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12593 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12609 */     GIR_RootConstrainSelectedInstOperands,
     /*  12610 */     // GIR_Coverage, 3240,
     /*  12610 */     GIR_EraseRootFromParent_Done,
     /*  12611 */   // Label 400: @12611
     /*  12611 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(12673), // Rule ID 4978 //
     /*  12616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12635 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12655 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12662 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12671 */     GIR_RootConstrainSelectedInstOperands,
     /*  12672 */     // GIR_Coverage, 4978,
     /*  12672 */     GIR_EraseRootFromParent_Done,
     /*  12673 */   // Label 401: @12673
     /*  12673 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(12700), // Rule ID 3239 //
     /*  12678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12693 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  12698 */     GIR_RootConstrainSelectedInstOperands,
     /*  12699 */     // GIR_Coverage, 3239,
     /*  12699 */     GIR_Done,
     /*  12700 */   // Label 402: @12700
     /*  12700 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(12727), // Rule ID 3247 //
     /*  12705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  12708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12720 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  12725 */     GIR_RootConstrainSelectedInstOperands,
     /*  12726 */     // GIR_Coverage, 3247,
     /*  12726 */     GIR_Done,
     /*  12727 */   // Label 403: @12727
     /*  12727 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(12754), // Rule ID 4975 //
     /*  12732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12747 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  12747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  12752 */     GIR_RootConstrainSelectedInstOperands,
     /*  12753 */     // GIR_Coverage, 4975,
     /*  12753 */     GIR_Done,
     /*  12754 */   // Label 404: @12754
     /*  12754 */   GIM_Reject,
     /*  12755 */ // Label 397: @12755
     /*  12755 */ GIM_Reject,
     /*  12756 */ // Label 357: @12756
     /*  12756 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(13072),
     /*  12761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  12764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  12767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12771 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(12829), // Rule ID 23819 //
     /*  12776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12811 */     // (mul:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  12814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12827 */     GIR_RootConstrainSelectedInstOperands,
     /*  12828 */     // GIR_Coverage, 23819,
     /*  12828 */     GIR_EraseRootFromParent_Done,
     /*  12829 */   // Label 406: @12829
     /*  12829 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(12887), // Rule ID 5014 //
     /*  12834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12869 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  12872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12885 */     GIR_RootConstrainSelectedInstOperands,
     /*  12886 */     // GIR_Coverage, 5014,
     /*  12886 */     GIR_EraseRootFromParent_Done,
     /*  12887 */   // Label 407: @12887
     /*  12887 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(12910), // Rule ID 5011 //
     /*  12892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12903 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  12903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  12908 */     GIR_RootConstrainSelectedInstOperands,
     /*  12909 */     // GIR_Coverage, 5011,
     /*  12909 */     GIR_Done,
     /*  12910 */   // Label 408: @12910
     /*  12910 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(13071), // Rule ID 19996 //
     /*  12915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12926 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  12926 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12929 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12933 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12940 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12943 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12947 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12952 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12955 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12959 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  12962 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12967 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12972 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  12977 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12980 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12984 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13003 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  13010 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  13013 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13018 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  13031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  13046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  13060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13070 */     // GIR_Coverage, 19996,
     /*  13070 */     GIR_EraseRootFromParent_Done,
     /*  13071 */   // Label 409: @13071
     /*  13071 */   GIM_Reject,
     /*  13072 */ // Label 405: @13072
     /*  13072 */ GIM_Reject,
     /*  13073 */ // Label 358: @13073
     /*  13073 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(13414),
     /*  13078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13084 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(13146), // Rule ID 23453 //
     /*  13089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13128 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13144 */     GIR_RootConstrainSelectedInstOperands,
     /*  13145 */     // GIR_Coverage, 23453,
     /*  13145 */     GIR_EraseRootFromParent_Done,
     /*  13146 */   // Label 411: @13146
     /*  13146 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(13208), // Rule ID 23810 //
     /*  13151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13190 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13206 */     GIR_RootConstrainSelectedInstOperands,
     /*  13207 */     // GIR_Coverage, 23810,
     /*  13207 */     GIR_EraseRootFromParent_Done,
     /*  13208 */   // Label 412: @13208
     /*  13208 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(13270), // Rule ID 2571 //
     /*  13213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13252 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13268 */     GIR_RootConstrainSelectedInstOperands,
     /*  13269 */     // GIR_Coverage, 2571,
     /*  13269 */     GIR_EraseRootFromParent_Done,
     /*  13270 */   // Label 413: @13270
     /*  13270 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(13332), // Rule ID 4999 //
     /*  13275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13314 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13330 */     GIR_RootConstrainSelectedInstOperands,
     /*  13331 */     // GIR_Coverage, 4999,
     /*  13331 */     GIR_EraseRootFromParent_Done,
     /*  13332 */   // Label 414: @13332
     /*  13332 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(13359), // Rule ID 2570 //
     /*  13337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13352 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  13357 */     GIR_RootConstrainSelectedInstOperands,
     /*  13358 */     // GIR_Coverage, 2570,
     /*  13358 */     GIR_Done,
     /*  13359 */   // Label 415: @13359
     /*  13359 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(13386), // Rule ID 2572 //
     /*  13364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  13367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13379 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  13384 */     GIR_RootConstrainSelectedInstOperands,
     /*  13385 */     // GIR_Coverage, 2572,
     /*  13385 */     GIR_Done,
     /*  13386 */   // Label 416: @13386
     /*  13386 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(13413), // Rule ID 4996 //
     /*  13391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13406 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  13406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  13411 */     GIR_RootConstrainSelectedInstOperands,
     /*  13412 */     // GIR_Coverage, 4996,
     /*  13412 */     GIR_Done,
     /*  13413 */   // Label 417: @13413
     /*  13413 */   GIM_Reject,
     /*  13414 */ // Label 410: @13414
     /*  13414 */ GIM_Reject,
     /*  13415 */ // Label 359: @13415
     /*  13415 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(13729),
     /*  13420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  13423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  13426 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(13488), // Rule ID 23530 //
     /*  13431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13470 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13486 */     GIR_RootConstrainSelectedInstOperands,
     /*  13487 */     // GIR_Coverage, 23530,
     /*  13487 */     GIR_EraseRootFromParent_Done,
     /*  13488 */   // Label 419: @13488
     /*  13488 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(13550), // Rule ID 23792 //
     /*  13493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13532 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13548 */     GIR_RootConstrainSelectedInstOperands,
     /*  13549 */     // GIR_Coverage, 23792,
     /*  13549 */     GIR_EraseRootFromParent_Done,
     /*  13550 */   // Label 420: @13550
     /*  13550 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(13612), // Rule ID 3244 //
     /*  13555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13594 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13610 */     GIR_RootConstrainSelectedInstOperands,
     /*  13611 */     // GIR_Coverage, 3244,
     /*  13611 */     GIR_EraseRootFromParent_Done,
     /*  13612 */   // Label 421: @13612
     /*  13612 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(13674), // Rule ID 4969 //
     /*  13617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13656 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13672 */     GIR_RootConstrainSelectedInstOperands,
     /*  13673 */     // GIR_Coverage, 4969,
     /*  13673 */     GIR_EraseRootFromParent_Done,
     /*  13674 */   // Label 422: @13674
     /*  13674 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(13701), // Rule ID 3243 //
     /*  13679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13694 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  13694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  13699 */     GIR_RootConstrainSelectedInstOperands,
     /*  13700 */     // GIR_Coverage, 3243,
     /*  13700 */     GIR_Done,
     /*  13701 */   // Label 423: @13701
     /*  13701 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(13728), // Rule ID 4966 //
     /*  13706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13721 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  13721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  13726 */     GIR_RootConstrainSelectedInstOperands,
     /*  13727 */     // GIR_Coverage, 4966,
     /*  13727 */     GIR_Done,
     /*  13728 */   // Label 424: @13728
     /*  13728 */   GIM_Reject,
     /*  13729 */ // Label 418: @13729
     /*  13729 */ GIM_Reject,
     /*  13730 */ // Label 360: @13730
     /*  13730 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(13885),
     /*  13735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  13738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  13741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13745 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(13803), // Rule ID 23813 //
     /*  13750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13785 */     // (mul:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  13788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13801 */     GIR_RootConstrainSelectedInstOperands,
     /*  13802 */     // GIR_Coverage, 23813,
     /*  13802 */     GIR_EraseRootFromParent_Done,
     /*  13803 */   // Label 426: @13803
     /*  13803 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(13861), // Rule ID 5005 //
     /*  13808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13843 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  13846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13859 */     GIR_RootConstrainSelectedInstOperands,
     /*  13860 */     // GIR_Coverage, 5005,
     /*  13860 */     GIR_EraseRootFromParent_Done,
     /*  13861 */   // Label 427: @13861
     /*  13861 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(13884), // Rule ID 5002 //
     /*  13866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13877 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  13877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13882 */     GIR_RootConstrainSelectedInstOperands,
     /*  13883 */     // GIR_Coverage, 5002,
     /*  13883 */     GIR_Done,
     /*  13884 */   // Label 428: @13884
     /*  13884 */   GIM_Reject,
     /*  13885 */ // Label 425: @13885
     /*  13885 */ GIM_Reject,
     /*  13886 */ // Label 361: @13886
     /*  13886 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(14200),
     /*  13891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  13894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  13897 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(13959), // Rule ID 23455 //
     /*  13902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  13905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13941 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  13944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13957 */     GIR_RootConstrainSelectedInstOperands,
     /*  13958 */     // GIR_Coverage, 23455,
     /*  13958 */     GIR_EraseRootFromParent_Done,
     /*  13959 */   // Label 430: @13959
     /*  13959 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(14021), // Rule ID 23807 //
     /*  13964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14003 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14019 */     GIR_RootConstrainSelectedInstOperands,
     /*  14020 */     // GIR_Coverage, 23807,
     /*  14020 */     GIR_EraseRootFromParent_Done,
     /*  14021 */   // Label 431: @14021
     /*  14021 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(14083), // Rule ID 2575 //
     /*  14026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14065 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14081 */     GIR_RootConstrainSelectedInstOperands,
     /*  14082 */     // GIR_Coverage, 2575,
     /*  14082 */     GIR_EraseRootFromParent_Done,
     /*  14083 */   // Label 432: @14083
     /*  14083 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(14145), // Rule ID 4993 //
     /*  14088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14127 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14143 */     GIR_RootConstrainSelectedInstOperands,
     /*  14144 */     // GIR_Coverage, 4993,
     /*  14144 */     GIR_EraseRootFromParent_Done,
     /*  14145 */   // Label 433: @14145
     /*  14145 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(14172), // Rule ID 2574 //
     /*  14150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14165 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  14165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  14170 */     GIR_RootConstrainSelectedInstOperands,
     /*  14171 */     // GIR_Coverage, 2574,
     /*  14171 */     GIR_Done,
     /*  14172 */   // Label 434: @14172
     /*  14172 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(14199), // Rule ID 4990 //
     /*  14177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14192 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  14192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  14197 */     GIR_RootConstrainSelectedInstOperands,
     /*  14198 */     // GIR_Coverage, 4990,
     /*  14198 */     GIR_Done,
     /*  14199 */   // Label 435: @14199
     /*  14199 */   GIM_Reject,
     /*  14200 */ // Label 429: @14200
     /*  14200 */ GIM_Reject,
     /*  14201 */ // Label 362: @14201
     /*  14201 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(14356),
     /*  14206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  14209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  14212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14216 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(14274), // Rule ID 23786 //
     /*  14221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14256 */     // (mul:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14272 */     GIR_RootConstrainSelectedInstOperands,
     /*  14273 */     // GIR_Coverage, 23786,
     /*  14273 */     GIR_EraseRootFromParent_Done,
     /*  14274 */   // Label 437: @14274
     /*  14274 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(14332), // Rule ID 4960 //
     /*  14279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14314 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14330 */     GIR_RootConstrainSelectedInstOperands,
     /*  14331 */     // GIR_Coverage, 4960,
     /*  14331 */     GIR_EraseRootFromParent_Done,
     /*  14332 */   // Label 438: @14332
     /*  14332 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(14355), // Rule ID 4957 //
     /*  14337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14348 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  14348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  14353 */     GIR_RootConstrainSelectedInstOperands,
     /*  14354 */     // GIR_Coverage, 4957,
     /*  14354 */     GIR_Done,
     /*  14355 */   // Label 439: @14355
     /*  14355 */   GIM_Reject,
     /*  14356 */ // Label 436: @14356
     /*  14356 */ GIM_Reject,
     /*  14357 */ // Label 363: @14357
     /*  14357 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(14512),
     /*  14362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  14365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  14368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14372 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(14430), // Rule ID 23804 //
     /*  14377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14412 */     // (mul:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14417 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14419 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14428 */     GIR_RootConstrainSelectedInstOperands,
     /*  14429 */     // GIR_Coverage, 23804,
     /*  14429 */     GIR_EraseRootFromParent_Done,
     /*  14430 */   // Label 441: @14430
     /*  14430 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(14488), // Rule ID 4987 //
     /*  14435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14457 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14470 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14475 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14486 */     GIR_RootConstrainSelectedInstOperands,
     /*  14487 */     // GIR_Coverage, 4987,
     /*  14487 */     GIR_EraseRootFromParent_Done,
     /*  14488 */   // Label 442: @14488
     /*  14488 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(14511), // Rule ID 4984 //
     /*  14493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14504 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  14504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  14509 */     GIR_RootConstrainSelectedInstOperands,
     /*  14510 */     // GIR_Coverage, 4984,
     /*  14510 */     GIR_Done,
     /*  14511 */   // Label 443: @14511
     /*  14511 */   GIM_Reject,
     /*  14512 */ // Label 440: @14512
     /*  14512 */ GIM_Reject,
     /*  14513 */ // Label 364: @14513
     /*  14513 */ GIM_Reject,
     /*  14514 */ // Label 3: @14514
     /*  14514 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 467*/ GIMT_Encode4(25105),
     /*  14525 */ /*GILLT_s1*//*Label 444*/ GIMT_Encode4(14625),
     /*  14529 */ /*GILLT_s8*//*Label 445*/ GIMT_Encode4(14971),
     /*  14533 */ /*GILLT_s16*//*Label 446*/ GIMT_Encode4(15364),
     /*  14537 */ /*GILLT_s32*//*Label 447*/ GIMT_Encode4(16049),
     /*  14541 */ /*GILLT_s64*//*Label 448*/ GIMT_Encode4(17875), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14553 */ /*GILLT_v2s1*//*Label 449*/ GIMT_Encode4(19579),
     /*  14557 */ /*GILLT_v2s64*//*Label 450*/ GIMT_Encode4(19925),
     /*  14561 */ /*GILLT_v4s1*//*Label 451*/ GIMT_Encode4(20267),
     /*  14565 */ /*GILLT_v4s32*//*Label 452*/ GIMT_Encode4(20613),
     /*  14569 */ /*GILLT_v4s64*//*Label 453*/ GIMT_Encode4(20955),
     /*  14573 */ /*GILLT_v8s1*//*Label 454*/ GIMT_Encode4(21421),
     /*  14577 */ /*GILLT_v8s16*//*Label 455*/ GIMT_Encode4(21919),
     /*  14581 */ /*GILLT_v8s32*//*Label 456*/ GIMT_Encode4(22261),
     /*  14585 */ /*GILLT_v8s64*//*Label 457*/ GIMT_Encode4(22727),
     /*  14589 */ /*GILLT_v16s1*//*Label 458*/ GIMT_Encode4(22883),
     /*  14593 */ /*GILLT_v16s8*//*Label 459*/ GIMT_Encode4(23043),
     /*  14597 */ /*GILLT_v16s16*//*Label 460*/ GIMT_Encode4(23385),
     /*  14601 */ /*GILLT_v16s32*//*Label 461*/ GIMT_Encode4(23851),
     /*  14605 */ /*GILLT_v32s1*//*Label 462*/ GIMT_Encode4(24007),
     /*  14609 */ /*GILLT_v32s8*//*Label 463*/ GIMT_Encode4(24167),
     /*  14613 */ /*GILLT_v32s16*//*Label 464*/ GIMT_Encode4(24633),
     /*  14617 */ /*GILLT_v64s1*//*Label 465*/ GIMT_Encode4(24789),
     /*  14621 */ /*GILLT_v64s8*//*Label 466*/ GIMT_Encode4(24949),
     /*  14625 */ // Label 444: @14625
     /*  14625 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(14970),
     /*  14630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14640 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(14760), // Rule ID 19488 //
     /*  14645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14670 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14676 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14684 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14684 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14687 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14691 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14700 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14741 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14759 */     // GIR_Coverage, 19488,
     /*  14759 */     GIR_EraseRootFromParent_Done,
     /*  14760 */   // Label 469: @14760
     /*  14760 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(14880), // Rule ID 25367 //
     /*  14765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14794 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14804 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14804 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14807 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14811 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14816 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  14820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14861 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14879 */     // GIR_Coverage, 25367,
     /*  14879 */     GIR_EraseRootFromParent_Done,
     /*  14880 */   // Label 470: @14880
     /*  14880 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(14969), // Rule ID 19484 //
     /*  14885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14893 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14893 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14896 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14900 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14905 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14909 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14914 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14917 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14921 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14926 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  14930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  14942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14968 */     // GIR_Coverage, 19484,
     /*  14968 */     GIR_EraseRootFromParent_Done,
     /*  14969 */   // Label 471: @14969
     /*  14969 */   GIM_Reject,
     /*  14970 */ // Label 468: @14970
     /*  14970 */ GIM_Reject,
     /*  14971 */ // Label 445: @14971
     /*  14971 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(15363),
     /*  14976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  14979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  14982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  14986 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(15047), // Rule ID 26069 //
     /*  14991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  14994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15009 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15026 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15045 */     GIR_RootConstrainSelectedInstOperands,
     /*  15046 */     // GIR_Coverage, 26069,
     /*  15046 */     GIR_EraseRootFromParent_Done,
     /*  15047 */   // Label 473: @15047
     /*  15047 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(15108), // Rule ID 26088 //
     /*  15052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15063 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15070 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15087 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15106 */     GIR_RootConstrainSelectedInstOperands,
     /*  15107 */     // GIR_Coverage, 26088,
     /*  15107 */     GIR_EraseRootFromParent_Done,
     /*  15108 */   // Label 474: @15108
     /*  15108 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(15169), // Rule ID 22854 //
     /*  15113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15135 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15148 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15167 */     GIR_RootConstrainSelectedInstOperands,
     /*  15168 */     // GIR_Coverage, 22854,
     /*  15168 */     GIR_EraseRootFromParent_Done,
     /*  15169 */   // Label 475: @15169
     /*  15169 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(15230), // Rule ID 22944 //
     /*  15174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15192 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15196 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15209 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15228 */     GIR_RootConstrainSelectedInstOperands,
     /*  15229 */     // GIR_Coverage, 22944,
     /*  15229 */     GIR_EraseRootFromParent_Done,
     /*  15230 */   // Label 476: @15230
     /*  15230 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(15267), // Rule ID 22858 //
     /*  15235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15250 */     // MIs[1] Operand 1
     /*  15250 */     // No operand predicates
     /*  15250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15252 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  15255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15265 */     GIR_RootConstrainSelectedInstOperands,
     /*  15266 */     // GIR_Coverage, 22858,
     /*  15266 */     GIR_EraseRootFromParent_Done,
     /*  15267 */   // Label 477: @15267
     /*  15267 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(15304), // Rule ID 22948 //
     /*  15272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15287 */     // MIs[1] Operand 1
     /*  15287 */     // No operand predicates
     /*  15287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15289 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  15292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15302 */     GIR_RootConstrainSelectedInstOperands,
     /*  15303 */     // GIR_Coverage, 22948,
     /*  15303 */     GIR_EraseRootFromParent_Done,
     /*  15304 */   // Label 478: @15304
     /*  15304 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(15333), // Rule ID 22850 //
     /*  15309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15320 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  15325 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15331 */     GIR_RootConstrainSelectedInstOperands,
     /*  15332 */     // GIR_Coverage, 22850,
     /*  15332 */     GIR_Done,
     /*  15333 */   // Label 479: @15333
     /*  15333 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(15362), // Rule ID 22940 //
     /*  15338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15349 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  15354 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15360 */     GIR_RootConstrainSelectedInstOperands,
     /*  15361 */     // GIR_Coverage, 22940,
     /*  15361 */     GIR_Done,
     /*  15362 */   // Label 480: @15362
     /*  15362 */   GIM_Reject,
     /*  15363 */ // Label 472: @15363
     /*  15363 */ GIM_Reject,
     /*  15364 */ // Label 446: @15364
     /*  15364 */ GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(16048),
     /*  15369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  15372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  15375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15379 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(15440), // Rule ID 26070 //
     /*  15384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15402 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15419 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15438 */     GIR_RootConstrainSelectedInstOperands,
     /*  15439 */     // GIR_Coverage, 26070,
     /*  15439 */     GIR_EraseRootFromParent_Done,
     /*  15440 */   // Label 482: @15440
     /*  15440 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(15501), // Rule ID 26089 //
     /*  15445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15463 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15480 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15499 */     GIR_RootConstrainSelectedInstOperands,
     /*  15500 */     // GIR_Coverage, 26089,
     /*  15500 */     GIR_EraseRootFromParent_Done,
     /*  15501 */   // Label 483: @15501
     /*  15501 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(15562), // Rule ID 22855 //
     /*  15506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15521 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15524 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15528 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15541 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15548 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15560 */     GIR_RootConstrainSelectedInstOperands,
     /*  15561 */     // GIR_Coverage, 22855,
     /*  15561 */     GIR_EraseRootFromParent_Done,
     /*  15562 */   // Label 484: @15562
     /*  15562 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15623), // Rule ID 22945 //
     /*  15567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15585 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15589 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15602 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15621 */     GIR_RootConstrainSelectedInstOperands,
     /*  15622 */     // GIR_Coverage, 22945,
     /*  15622 */     GIR_EraseRootFromParent_Done,
     /*  15623 */   // Label 485: @15623
     /*  15623 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15725), // Rule ID 26036 //
     /*  15628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15644 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15659 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 26036,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 486: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15827), // Rule ID 22774 //
     /*  15730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15750 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15761 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15825 */     GIR_RootConstrainSelectedInstOperands,
     /*  15826 */     // GIR_Coverage, 22774,
     /*  15826 */     GIR_EraseRootFromParent_Done,
     /*  15827 */   // Label 487: @15827
     /*  15827 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15915), // Rule ID 22634 //
     /*  15832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15836 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15847 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  15847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  15850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15859 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  15865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  15870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  15878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  15882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  15904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  15914 */     // GIR_Coverage, 22634,
     /*  15914 */     GIR_EraseRootFromParent_Done,
     /*  15915 */   // Label 488: @15915
     /*  15915 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(15952), // Rule ID 22859 //
     /*  15920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15935 */     // MIs[1] Operand 1
     /*  15935 */     // No operand predicates
     /*  15935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15937 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  15937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  15940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15942 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15950 */     GIR_RootConstrainSelectedInstOperands,
     /*  15951 */     // GIR_Coverage, 22859,
     /*  15951 */     GIR_EraseRootFromParent_Done,
     /*  15952 */   // Label 489: @15952
     /*  15952 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(15989), // Rule ID 22949 //
     /*  15957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15972 */     // MIs[1] Operand 1
     /*  15972 */     // No operand predicates
     /*  15972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15974 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  15974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  15977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15987 */     GIR_RootConstrainSelectedInstOperands,
     /*  15988 */     // GIR_Coverage, 22949,
     /*  15988 */     GIR_EraseRootFromParent_Done,
     /*  15989 */   // Label 490: @15989
     /*  15989 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(16018), // Rule ID 22851 //
     /*  15994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16005 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  16010 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16016 */     GIR_RootConstrainSelectedInstOperands,
     /*  16017 */     // GIR_Coverage, 22851,
     /*  16017 */     GIR_Done,
     /*  16018 */   // Label 491: @16018
     /*  16018 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(16047), // Rule ID 22941 //
     /*  16023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16034 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  16039 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16045 */     GIR_RootConstrainSelectedInstOperands,
     /*  16046 */     // GIR_Coverage, 22941,
     /*  16046 */     GIR_Done,
     /*  16047 */   // Label 492: @16047
     /*  16047 */   GIM_Reject,
     /*  16048 */ // Label 481: @16048
     /*  16048 */ GIM_Reject,
     /*  16049 */ // Label 447: @16049
     /*  16049 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(17874),
     /*  16054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  16057 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(16149), // Rule ID 17546 //
     /*  16062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16108 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16112 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16125 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16147 */     GIR_RootConstrainSelectedInstOperands,
     /*  16148 */     // GIR_Coverage, 17546,
     /*  16148 */     GIR_EraseRootFromParent_Done,
     /*  16149 */   // Label 494: @16149
     /*  16149 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(16241), // Rule ID 17550 //
     /*  16154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16185 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16197 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16200 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16204 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16239 */     GIR_RootConstrainSelectedInstOperands,
     /*  16240 */     // GIR_Coverage, 17550,
     /*  16240 */     GIR_EraseRootFromParent_Done,
     /*  16241 */   // Label 495: @16241
     /*  16241 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(16333), // Rule ID 25103 //
     /*  16246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16271 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16296 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16309 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16331 */     GIR_RootConstrainSelectedInstOperands,
     /*  16332 */     // GIR_Coverage, 25103,
     /*  16332 */     GIR_EraseRootFromParent_Done,
     /*  16333 */   // Label 496: @16333
     /*  16333 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(16425), // Rule ID 25107 //
     /*  16338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16359 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16363 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16388 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16401 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16423 */     GIR_RootConstrainSelectedInstOperands,
     /*  16424 */     // GIR_Coverage, 25107,
     /*  16424 */     GIR_EraseRootFromParent_Done,
     /*  16425 */   // Label 497: @16425
     /*  16425 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(16493), // Rule ID 26071 //
     /*  16430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16455 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16472 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16491 */     GIR_RootConstrainSelectedInstOperands,
     /*  16492 */     // GIR_Coverage, 26071,
     /*  16492 */     GIR_EraseRootFromParent_Done,
     /*  16493 */   // Label 498: @16493
     /*  16493 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(16561), // Rule ID 26090 //
     /*  16498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16523 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16540 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16559 */     GIR_RootConstrainSelectedInstOperands,
     /*  16560 */     // GIR_Coverage, 26090,
     /*  16560 */     GIR_EraseRootFromParent_Done,
     /*  16561 */   // Label 499: @16561
     /*  16561 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(16629), // Rule ID 22856 //
     /*  16566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16595 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16608 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 22856,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 500: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(16697), // Rule ID 22946 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16663 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16676 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16695 */     GIR_RootConstrainSelectedInstOperands,
     /*  16696 */     // GIR_Coverage, 22946,
     /*  16696 */     GIR_EraseRootFromParent_Done,
     /*  16697 */   // Label 501: @16697
     /*  16697 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(16774), // Rule ID 24995 //
     /*  16702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  16737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16749 */     // MIs[2] src
     /*  16749 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16754 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16760 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16772 */     GIR_RootConstrainSelectedInstOperands,
     /*  16773 */     // GIR_Coverage, 24995,
     /*  16773 */     GIR_EraseRootFromParent_Done,
     /*  16774 */   // Label 502: @16774
     /*  16774 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(16851), // Rule ID 25007 //
     /*  16779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16810 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16826 */     // MIs[2] src
     /*  16826 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16831 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16837 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  16840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16849 */     GIR_RootConstrainSelectedInstOperands,
     /*  16850 */     // GIR_Coverage, 25007,
     /*  16850 */     GIR_EraseRootFromParent_Done,
     /*  16851 */   // Label 503: @16851
     /*  16851 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(16928), // Rule ID 17356 //
     /*  16856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16903 */     // MIs[2] src
     /*  16903 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16908 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  16912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16914 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16926 */     GIR_RootConstrainSelectedInstOperands,
     /*  16927 */     // GIR_Coverage, 17356,
     /*  16927 */     GIR_EraseRootFromParent_Done,
     /*  16928 */   // Label 504: @16928
     /*  16928 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(17005), // Rule ID 17368 //
     /*  16933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16964 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16980 */     // MIs[2] src
     /*  16980 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16985 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16991 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  16994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17003 */     GIR_RootConstrainSelectedInstOperands,
     /*  17004 */     // GIR_Coverage, 17368,
     /*  17004 */     GIR_EraseRootFromParent_Done,
     /*  17005 */   // Label 505: @17005
     /*  17005 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(17063), // Rule ID 24989 //
     /*  17010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17038 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17042 */     // MIs[0] src
     /*  17042 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17049 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17061 */     GIR_RootConstrainSelectedInstOperands,
     /*  17062 */     // GIR_Coverage, 24989,
     /*  17062 */     GIR_EraseRootFromParent_Done,
     /*  17063 */   // Label 506: @17063
     /*  17063 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(17172), // Rule ID 26042 //
     /*  17068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17091 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17106 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17139 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  17164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17170 */     GIR_RootConstrainSelectedInstOperands,
     /*  17171 */     // GIR_Coverage, 26042,
     /*  17171 */     GIR_EraseRootFromParent_Done,
     /*  17172 */   // Label 507: @17172
     /*  17172 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(17226), // Rule ID 17350 //
     /*  17177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17203 */     // MIs[1] src
     /*  17203 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  17208 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17214 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17224 */     GIR_RootConstrainSelectedInstOperands,
     /*  17225 */     // GIR_Coverage, 17350,
     /*  17225 */     GIR_EraseRootFromParent_Done,
     /*  17226 */   // Label 508: @17226
     /*  17226 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(17335), // Rule ID 22780 //
     /*  17231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17269 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17302 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17333 */     GIR_RootConstrainSelectedInstOperands,
     /*  17334 */     // GIR_Coverage, 22780,
     /*  17334 */     GIR_EraseRootFromParent_Done,
     /*  17335 */   // Label 509: @17335
     /*  17335 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(17400), // Rule ID 22632 //
     /*  17340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17351 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17362 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  17362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  17365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17374 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  17380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  17385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  17393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17398 */     GIR_RootConstrainSelectedInstOperands,
     /*  17399 */     // GIR_Coverage, 22632,
     /*  17399 */     GIR_EraseRootFromParent_Done,
     /*  17400 */   // Label 510: @17400
     /*  17400 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(17465), // Rule ID 22633 //
     /*  17405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17416 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17427 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  17427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  17430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  17445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  17450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  17458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17463 */     GIR_RootConstrainSelectedInstOperands,
     /*  17464 */     // GIR_Coverage, 22633,
     /*  17464 */     GIR_EraseRootFromParent_Done,
     /*  17465 */   // Label 511: @17465
     /*  17465 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(17509), // Rule ID 22860 //
     /*  17470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17492 */     // MIs[1] Operand 1
     /*  17492 */     // No operand predicates
     /*  17492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17494 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17507 */     GIR_RootConstrainSelectedInstOperands,
     /*  17508 */     // GIR_Coverage, 22860,
     /*  17508 */     GIR_EraseRootFromParent_Done,
     /*  17509 */   // Label 512: @17509
     /*  17509 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(17553), // Rule ID 22950 //
     /*  17514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17536 */     // MIs[1] Operand 1
     /*  17536 */     // No operand predicates
     /*  17536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17538 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  17541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17551 */     GIR_RootConstrainSelectedInstOperands,
     /*  17552 */     // GIR_Coverage, 22950,
     /*  17552 */     GIR_EraseRootFromParent_Done,
     /*  17553 */   // Label 513: @17553
     /*  17553 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(17615), // Rule ID 17544 //
     /*  17558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17589 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17599 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17613 */     GIR_RootConstrainSelectedInstOperands,
     /*  17614 */     // GIR_Coverage, 17544,
     /*  17614 */     GIR_EraseRootFromParent_Done,
     /*  17615 */   // Label 514: @17615
     /*  17615 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(17677), // Rule ID 17548 //
     /*  17620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17651 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17661 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17675 */     GIR_RootConstrainSelectedInstOperands,
     /*  17676 */     // GIR_Coverage, 17548,
     /*  17676 */     GIR_EraseRootFromParent_Done,
     /*  17677 */   // Label 515: @17677
     /*  17677 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(17739), // Rule ID 25101 //
     /*  17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17717 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17723 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17737 */     GIR_RootConstrainSelectedInstOperands,
     /*  17738 */     // GIR_Coverage, 25101,
     /*  17738 */     GIR_EraseRootFromParent_Done,
     /*  17739 */   // Label 516: @17739
     /*  17739 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(17801), // Rule ID 25105 //
     /*  17744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17785 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17799 */     GIR_RootConstrainSelectedInstOperands,
     /*  17800 */     // GIR_Coverage, 25105,
     /*  17800 */     GIR_EraseRootFromParent_Done,
     /*  17801 */   // Label 517: @17801
     /*  17801 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(17837), // Rule ID 22852 //
     /*  17806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17824 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  17829 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  17835 */     GIR_RootConstrainSelectedInstOperands,
     /*  17836 */     // GIR_Coverage, 22852,
     /*  17836 */     GIR_Done,
     /*  17837 */   // Label 518: @17837
     /*  17837 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(17873), // Rule ID 22942 //
     /*  17842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17860 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  17865 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  17871 */     GIR_RootConstrainSelectedInstOperands,
     /*  17872 */     // GIR_Coverage, 22942,
     /*  17872 */     GIR_Done,
     /*  17873 */   // Label 519: @17873
     /*  17873 */   GIM_Reject,
     /*  17874 */ // Label 493: @17874
     /*  17874 */ GIM_Reject,
     /*  17875 */ // Label 448: @17875
     /*  17875 */ GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(19578),
     /*  17880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17883 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(17975), // Rule ID 17547 //
     /*  17888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  17910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  17914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17919 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  17931 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  17934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  17938 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  17942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  17951 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  17951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  17954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  17964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  17973 */     GIR_RootConstrainSelectedInstOperands,
     /*  17974 */     // GIR_Coverage, 17547,
     /*  17974 */     GIR_EraseRootFromParent_Done,
     /*  17975 */   // Label 521: @17975
     /*  17975 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(18067), // Rule ID 17551 //
     /*  17980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18023 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18030 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18043 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18065 */     GIR_RootConstrainSelectedInstOperands,
     /*  18066 */     // GIR_Coverage, 17551,
     /*  18066 */     GIR_EraseRootFromParent_Done,
     /*  18067 */   // Label 522: @18067
     /*  18067 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(18159), // Rule ID 25104 //
     /*  18072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18122 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18135 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18157 */     GIR_RootConstrainSelectedInstOperands,
     /*  18158 */     // GIR_Coverage, 25104,
     /*  18158 */     GIR_EraseRootFromParent_Done,
     /*  18159 */   // Label 523: @18159
     /*  18159 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(18251), // Rule ID 25108 //
     /*  18164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18214 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18227 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18249 */     GIR_RootConstrainSelectedInstOperands,
     /*  18250 */     // GIR_Coverage, 25108,
     /*  18250 */     GIR_EraseRootFromParent_Done,
     /*  18251 */   // Label 524: @18251
     /*  18251 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(18319), // Rule ID 26072 //
     /*  18256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18298 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18317 */     GIR_RootConstrainSelectedInstOperands,
     /*  18318 */     // GIR_Coverage, 26072,
     /*  18318 */     GIR_EraseRootFromParent_Done,
     /*  18319 */   // Label 525: @18319
     /*  18319 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(18387), // Rule ID 26091 //
     /*  18324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18349 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18366 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18385 */     GIR_RootConstrainSelectedInstOperands,
     /*  18386 */     // GIR_Coverage, 26091,
     /*  18386 */     GIR_EraseRootFromParent_Done,
     /*  18387 */   // Label 526: @18387
     /*  18387 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(18455), // Rule ID 22857 //
     /*  18392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18434 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18453 */     GIR_RootConstrainSelectedInstOperands,
     /*  18454 */     // GIR_Coverage, 22857,
     /*  18454 */     GIR_EraseRootFromParent_Done,
     /*  18455 */   // Label 527: @18455
     /*  18455 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(18523), // Rule ID 22947 //
     /*  18460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18502 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18521 */     GIR_RootConstrainSelectedInstOperands,
     /*  18522 */     // GIR_Coverage, 22947,
     /*  18522 */     GIR_EraseRootFromParent_Done,
     /*  18523 */   // Label 528: @18523
     /*  18523 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(18600), // Rule ID 24996 //
     /*  18528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18559 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18575 */     // MIs[2] src
     /*  18575 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18580 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18586 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18598 */     GIR_RootConstrainSelectedInstOperands,
     /*  18599 */     // GIR_Coverage, 24996,
     /*  18599 */     GIR_EraseRootFromParent_Done,
     /*  18600 */   // Label 529: @18600
     /*  18600 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(18677), // Rule ID 25008 //
     /*  18605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18636 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18652 */     // MIs[2] src
     /*  18652 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18657 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18663 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18675 */     GIR_RootConstrainSelectedInstOperands,
     /*  18676 */     // GIR_Coverage, 25008,
     /*  18676 */     GIR_EraseRootFromParent_Done,
     /*  18677 */   // Label 530: @18677
     /*  18677 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(18754), // Rule ID 17357 //
     /*  18682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18713 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18729 */     // MIs[2] src
     /*  18729 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18734 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  18738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18740 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18752 */     GIR_RootConstrainSelectedInstOperands,
     /*  18753 */     // GIR_Coverage, 17357,
     /*  18753 */     GIR_EraseRootFromParent_Done,
     /*  18754 */   // Label 531: @18754
     /*  18754 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(18831), // Rule ID 17369 //
     /*  18759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18790 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18806 */     // MIs[2] src
     /*  18806 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18811 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18817 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18829 */     GIR_RootConstrainSelectedInstOperands,
     /*  18830 */     // GIR_Coverage, 17369,
     /*  18830 */     GIR_EraseRootFromParent_Done,
     /*  18831 */   // Label 532: @18831
     /*  18831 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(18889), // Rule ID 24990 //
     /*  18836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18864 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18868 */     // MIs[0] src
     /*  18868 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18875 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  18878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18887 */     GIR_RootConstrainSelectedInstOperands,
     /*  18888 */     // GIR_Coverage, 24990,
     /*  18888 */     GIR_EraseRootFromParent_Done,
     /*  18889 */   // Label 533: @18889
     /*  18889 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(18998), // Rule ID 26048 //
     /*  18894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  18909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  18917 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  18921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  18926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18932 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  18932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  18935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  18946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  18949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  18953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  18965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  18968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  18973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  18978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  18983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  18986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18996 */     GIR_RootConstrainSelectedInstOperands,
     /*  18997 */     // GIR_Coverage, 26048,
     /*  18997 */     GIR_EraseRootFromParent_Done,
     /*  18998 */   // Label 534: @18998
     /*  18998 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(19052), // Rule ID 17351 //
     /*  19003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  19006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19029 */     // MIs[1] src
     /*  19029 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  19034 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19040 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  19047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19050 */     GIR_RootConstrainSelectedInstOperands,
     /*  19051 */     // GIR_Coverage, 17351,
     /*  19051 */     GIR_EraseRootFromParent_Done,
     /*  19052 */   // Label 535: @19052
     /*  19052 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(19161), // Rule ID 22786 //
     /*  19057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19084 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19095 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19095 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19098 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19102 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19121 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19128 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19151 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19159 */     GIR_RootConstrainSelectedInstOperands,
     /*  19160 */     // GIR_Coverage, 22786,
     /*  19160 */     GIR_EraseRootFromParent_Done,
     /*  19161 */   // Label 536: @19161
     /*  19161 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(19209), // Rule ID 22861 //
     /*  19166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19192 */     // MIs[1] Operand 1
     /*  19192 */     // No operand predicates
     /*  19192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19194 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  19197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19207 */     GIR_RootConstrainSelectedInstOperands,
     /*  19208 */     // GIR_Coverage, 22861,
     /*  19208 */     GIR_EraseRootFromParent_Done,
     /*  19209 */   // Label 537: @19209
     /*  19209 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(19257), // Rule ID 22951 //
     /*  19214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19240 */     // MIs[1] Operand 1
     /*  19240 */     // No operand predicates
     /*  19240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19242 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  19245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19255 */     GIR_RootConstrainSelectedInstOperands,
     /*  19256 */     // GIR_Coverage, 22951,
     /*  19256 */     GIR_EraseRootFromParent_Done,
     /*  19257 */   // Label 538: @19257
     /*  19257 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(19319), // Rule ID 17545 //
     /*  19262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19293 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19303 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19312 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19317 */     GIR_RootConstrainSelectedInstOperands,
     /*  19318 */     // GIR_Coverage, 17545,
     /*  19318 */     GIR_EraseRootFromParent_Done,
     /*  19319 */   // Label 539: @19319
     /*  19319 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(19381), // Rule ID 17549 //
     /*  19324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19355 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19365 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19379 */     GIR_RootConstrainSelectedInstOperands,
     /*  19380 */     // GIR_Coverage, 17549,
     /*  19380 */     GIR_EraseRootFromParent_Done,
     /*  19381 */   // Label 540: @19381
     /*  19381 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(19443), // Rule ID 25102 //
     /*  19386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19427 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19441 */     GIR_RootConstrainSelectedInstOperands,
     /*  19442 */     // GIR_Coverage, 25102,
     /*  19442 */     GIR_EraseRootFromParent_Done,
     /*  19443 */   // Label 541: @19443
     /*  19443 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(19505), // Rule ID 25106 //
     /*  19448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19483 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19489 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19503 */     GIR_RootConstrainSelectedInstOperands,
     /*  19504 */     // GIR_Coverage, 25106,
     /*  19504 */     GIR_EraseRootFromParent_Done,
     /*  19505 */   // Label 542: @19505
     /*  19505 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(19541), // Rule ID 22853 //
     /*  19510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19528 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  19533 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19539 */     GIR_RootConstrainSelectedInstOperands,
     /*  19540 */     // GIR_Coverage, 22853,
     /*  19540 */     GIR_Done,
     /*  19541 */   // Label 543: @19541
     /*  19541 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(19577), // Rule ID 22943 //
     /*  19546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19564 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  19569 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19575 */     GIR_RootConstrainSelectedInstOperands,
     /*  19576 */     // GIR_Coverage, 22943,
     /*  19576 */     GIR_Done,
     /*  19577 */   // Label 544: @19577
     /*  19577 */   GIM_Reject,
     /*  19578 */ // Label 520: @19578
     /*  19578 */ GIM_Reject,
     /*  19579 */ // Label 449: @19579
     /*  19579 */ GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(19924),
     /*  19584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19594 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(19714), // Rule ID 19489 //
     /*  19599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19624 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19630 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19638 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19638 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19641 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19645 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19650 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19654 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19671 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19675 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19713 */     // GIR_Coverage, 19489,
     /*  19713 */     GIR_EraseRootFromParent_Done,
     /*  19714 */   // Label 546: @19714
     /*  19714 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(19834), // Rule ID 25368 //
     /*  19719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19748 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19758 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19758 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19761 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19765 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19770 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  19774 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19779 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19782 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19786 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19791 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19812 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19833 */     // GIR_Coverage, 25368,
     /*  19833 */     GIR_EraseRootFromParent_Done,
     /*  19834 */   // Label 547: @19834
     /*  19834 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(19923), // Rule ID 19485 //
     /*  19839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19847 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19847 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19850 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19854 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19859 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19863 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19868 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19871 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19875 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19880 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  19884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  19896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19904 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19922 */     // GIR_Coverage, 19485,
     /*  19922 */     GIR_EraseRootFromParent_Done,
     /*  19923 */   // Label 548: @19923
     /*  19923 */   GIM_Reject,
     /*  19924 */ // Label 545: @19924
     /*  19924 */ GIM_Reject,
     /*  19925 */ // Label 450: @19925
     /*  19925 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(20266),
     /*  19930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19936 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(19998), // Rule ID 23360 //
     /*  19941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  19944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  19948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  19956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  19959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  19963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  19967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  19971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  19980 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  19980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  19983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  19987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  19991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  19996 */     GIR_RootConstrainSelectedInstOperands,
     /*  19997 */     // GIR_Coverage, 23360,
     /*  19997 */     GIR_EraseRootFromParent_Done,
     /*  19998 */   // Label 550: @19998
     /*  19998 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(20060), // Rule ID 24149 //
     /*  20003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20018 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20025 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20042 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20047 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20049 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20058 */     GIR_RootConstrainSelectedInstOperands,
     /*  20059 */     // GIR_Coverage, 24149,
     /*  20059 */     GIR_EraseRootFromParent_Done,
     /*  20060 */   // Label 551: @20060
     /*  20060 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(20122), // Rule ID 2111 //
     /*  20065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20084 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20091 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20104 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20120 */     GIR_RootConstrainSelectedInstOperands,
     /*  20121 */     // GIR_Coverage, 2111,
     /*  20121 */     GIR_EraseRootFromParent_Done,
     /*  20122 */   // Label 552: @20122
     /*  20122 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(20184), // Rule ID 5707 //
     /*  20127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20166 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20171 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20182 */     GIR_RootConstrainSelectedInstOperands,
     /*  20183 */     // GIR_Coverage, 5707,
     /*  20183 */     GIR_EraseRootFromParent_Done,
     /*  20184 */   // Label 553: @20184
     /*  20184 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(20211), // Rule ID 2110 //
     /*  20189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20204 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20209 */     GIR_RootConstrainSelectedInstOperands,
     /*  20210 */     // GIR_Coverage, 2110,
     /*  20210 */     GIR_Done,
     /*  20211 */   // Label 554: @20211
     /*  20211 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(20238), // Rule ID 2112 //
     /*  20216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20231 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20236 */     GIR_RootConstrainSelectedInstOperands,
     /*  20237 */     // GIR_Coverage, 2112,
     /*  20237 */     GIR_Done,
     /*  20238 */   // Label 555: @20238
     /*  20238 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(20265), // Rule ID 5704 //
     /*  20243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20258 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  20258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  20263 */     GIR_RootConstrainSelectedInstOperands,
     /*  20264 */     // GIR_Coverage, 5704,
     /*  20264 */     GIR_Done,
     /*  20265 */   // Label 556: @20265
     /*  20265 */   GIM_Reject,
     /*  20266 */ // Label 549: @20266
     /*  20266 */ GIM_Reject,
     /*  20267 */ // Label 451: @20267
     /*  20267 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(20612),
     /*  20272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20282 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(20402), // Rule ID 19490 //
     /*  20287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20312 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20318 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20326 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20326 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20329 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20333 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20338 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20342 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20380 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20383 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20401 */     // GIR_Coverage, 19490,
     /*  20401 */     GIR_EraseRootFromParent_Done,
     /*  20402 */   // Label 558: @20402
     /*  20402 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(20522), // Rule ID 25369 //
     /*  20407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20436 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20446 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20446 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20449 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20453 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20458 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  20462 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20500 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20521 */     // GIR_Coverage, 25369,
     /*  20521 */     GIR_EraseRootFromParent_Done,
     /*  20522 */   // Label 559: @20522
     /*  20522 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(20611), // Rule ID 19486 //
     /*  20527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20535 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20547 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20551 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20610 */     // GIR_Coverage, 19486,
     /*  20610 */     GIR_EraseRootFromParent_Done,
     /*  20611 */   // Label 560: @20611
     /*  20611 */   GIM_Reject,
     /*  20612 */ // Label 557: @20612
     /*  20612 */ GIM_Reject,
     /*  20613 */ // Label 452: @20613
     /*  20613 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(20954),
     /*  20618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20624 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(20686), // Rule ID 24167 //
     /*  20629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20668 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20684 */     GIR_RootConstrainSelectedInstOperands,
     /*  20685 */     // GIR_Coverage, 24167,
     /*  20685 */     GIR_EraseRootFromParent_Done,
     /*  20686 */   // Label 562: @20686
     /*  20686 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(20748), // Rule ID 25253 //
     /*  20691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20730 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20735 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20737 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20746 */     GIR_RootConstrainSelectedInstOperands,
     /*  20747 */     // GIR_Coverage, 25253,
     /*  20747 */     GIR_EraseRootFromParent_Done,
     /*  20748 */   // Label 563: @20748
     /*  20748 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(20810), // Rule ID 5734 //
     /*  20753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20792 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20808 */     GIR_RootConstrainSelectedInstOperands,
     /*  20809 */     // GIR_Coverage, 5734,
     /*  20809 */     GIR_EraseRootFromParent_Done,
     /*  20810 */   // Label 564: @20810
     /*  20810 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(20872), // Rule ID 18160 //
     /*  20815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20854 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20870 */     GIR_RootConstrainSelectedInstOperands,
     /*  20871 */     // GIR_Coverage, 18160,
     /*  20871 */     GIR_EraseRootFromParent_Done,
     /*  20872 */   // Label 565: @20872
     /*  20872 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(20899), // Rule ID 5731 //
     /*  20877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20892 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  20892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /*  20897 */     GIR_RootConstrainSelectedInstOperands,
     /*  20898 */     // GIR_Coverage, 5731,
     /*  20898 */     GIR_Done,
     /*  20899 */   // Label 566: @20899
     /*  20899 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(20926), // Rule ID 18148 //
     /*  20904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20919 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  20919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20924 */     GIR_RootConstrainSelectedInstOperands,
     /*  20925 */     // GIR_Coverage, 18148,
     /*  20925 */     GIR_Done,
     /*  20926 */   // Label 567: @20926
     /*  20926 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(20953), // Rule ID 18172 //
     /*  20931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20946 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  20946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20951 */     GIR_RootConstrainSelectedInstOperands,
     /*  20952 */     // GIR_Coverage, 18172,
     /*  20952 */     GIR_Done,
     /*  20953 */   // Label 568: @20953
     /*  20953 */   GIM_Reject,
     /*  20954 */ // Label 561: @20954
     /*  20954 */ GIM_Reject,
     /*  20955 */ // Label 453: @20955
     /*  20955 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(21420),
     /*  20960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  20963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  20966 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(21028), // Rule ID 23362 //
     /*  20971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  20974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  20978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21010 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21026 */     GIR_RootConstrainSelectedInstOperands,
     /*  21027 */     // GIR_Coverage, 23362,
     /*  21027 */     GIR_EraseRootFromParent_Done,
     /*  21028 */   // Label 570: @21028
     /*  21028 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(21090), // Rule ID 24143 //
     /*  21033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21048 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21072 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21077 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21088 */     GIR_RootConstrainSelectedInstOperands,
     /*  21089 */     // GIR_Coverage, 24143,
     /*  21089 */     GIR_EraseRootFromParent_Done,
     /*  21090 */   // Label 571: @21090
     /*  21090 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(21152), // Rule ID 25242 //
     /*  21095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21134 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21150 */     GIR_RootConstrainSelectedInstOperands,
     /*  21151 */     // GIR_Coverage, 25242,
     /*  21151 */     GIR_EraseRootFromParent_Done,
     /*  21152 */   // Label 572: @21152
     /*  21152 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(21214), // Rule ID 2115 //
     /*  21157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21196 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21212 */     GIR_RootConstrainSelectedInstOperands,
     /*  21213 */     // GIR_Coverage, 2115,
     /*  21213 */     GIR_EraseRootFromParent_Done,
     /*  21214 */   // Label 573: @21214
     /*  21214 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(21276), // Rule ID 5698 //
     /*  21219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21258 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21274 */     GIR_RootConstrainSelectedInstOperands,
     /*  21275 */     // GIR_Coverage, 5698,
     /*  21275 */     GIR_EraseRootFromParent_Done,
     /*  21276 */   // Label 574: @21276
     /*  21276 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(21338), // Rule ID 18133 //
     /*  21281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21320 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21336 */     GIR_RootConstrainSelectedInstOperands,
     /*  21337 */     // GIR_Coverage, 18133,
     /*  21337 */     GIR_EraseRootFromParent_Done,
     /*  21338 */   // Label 575: @21338
     /*  21338 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(21365), // Rule ID 2114 //
     /*  21343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21358 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  21363 */     GIR_RootConstrainSelectedInstOperands,
     /*  21364 */     // GIR_Coverage, 2114,
     /*  21364 */     GIR_Done,
     /*  21365 */   // Label 576: @21365
     /*  21365 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(21392), // Rule ID 5695 //
     /*  21370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21385 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  21385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  21390 */     GIR_RootConstrainSelectedInstOperands,
     /*  21391 */     // GIR_Coverage, 5695,
     /*  21391 */     GIR_Done,
     /*  21392 */   // Label 577: @21392
     /*  21392 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(21419), // Rule ID 18117 //
     /*  21397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21412 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  21417 */     GIR_RootConstrainSelectedInstOperands,
     /*  21418 */     // GIR_Coverage, 18117,
     /*  21418 */     GIR_Done,
     /*  21419 */   // Label 578: @21419
     /*  21419 */   GIM_Reject,
     /*  21420 */ // Label 569: @21420
     /*  21420 */ GIM_Reject,
     /*  21421 */ // Label 454: @21421
     /*  21421 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(21918),
     /*  21426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21436 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(21496), // Rule ID 4431 //
     /*  21441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21469 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21475 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21483 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21492 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  21494 */     GIR_RootConstrainSelectedInstOperands,
     /*  21495 */     // GIR_Coverage, 4431,
     /*  21495 */     GIR_EraseRootFromParent_Done,
     /*  21496 */   // Label 580: @21496
     /*  21496 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(21619), // Rule ID 19487 //
     /*  21501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21529 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21535 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21543 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21543 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21546 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21550 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21555 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21559 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21564 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21567 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21571 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21576 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21580 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21597 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21600 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21618 */     // GIR_Coverage, 19487,
     /*  21618 */     GIR_EraseRootFromParent_Done,
     /*  21619 */   // Label 581: @21619
     /*  21619 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(21679), // Rule ID 23692 //
     /*  21624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21656 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21666 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  21677 */     GIR_RootConstrainSelectedInstOperands,
     /*  21678 */     // GIR_Coverage, 23692,
     /*  21678 */     GIR_EraseRootFromParent_Done,
     /*  21679 */   // Label 582: @21679
     /*  21679 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(21802), // Rule ID 25366 //
     /*  21684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21716 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21726 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21738 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  21742 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21801 */     // GIR_Coverage, 25366,
     /*  21801 */     GIR_EraseRootFromParent_Done,
     /*  21802 */   // Label 583: @21802
     /*  21802 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(21825), // Rule ID 4415 //
     /*  21807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21818 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /*  21823 */     GIR_RootConstrainSelectedInstOperands,
     /*  21824 */     // GIR_Coverage, 4415,
     /*  21824 */     GIR_Done,
     /*  21825 */   // Label 584: @21825
     /*  21825 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(21917), // Rule ID 19483 //
     /*  21830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21841 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21841 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21844 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21848 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21853 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21857 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21874 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  21878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  21890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21916 */     // GIR_Coverage, 19483,
     /*  21916 */     GIR_EraseRootFromParent_Done,
     /*  21917 */   // Label 585: @21917
     /*  21917 */   GIM_Reject,
     /*  21918 */ // Label 579: @21918
     /*  21918 */ GIM_Reject,
     /*  21919 */ // Label 455: @21919
     /*  21919 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(22260),
     /*  21924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21930 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(21992), // Rule ID 25252 //
     /*  21935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21974 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  21977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21990 */     GIR_RootConstrainSelectedInstOperands,
     /*  21991 */     // GIR_Coverage, 25252,
     /*  21991 */     GIR_EraseRootFromParent_Done,
     /*  21992 */   // Label 587: @21992
     /*  21992 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(22054), // Rule ID 25433 //
     /*  21997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22019 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22036 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22052 */     GIR_RootConstrainSelectedInstOperands,
     /*  22053 */     // GIR_Coverage, 25433,
     /*  22053 */     GIR_EraseRootFromParent_Done,
     /*  22054 */   // Label 588: @22054
     /*  22054 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(22116), // Rule ID 18159 //
     /*  22059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22098 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22114 */     GIR_RootConstrainSelectedInstOperands,
     /*  22115 */     // GIR_Coverage, 18159,
     /*  22115 */     GIR_EraseRootFromParent_Done,
     /*  22116 */   // Label 589: @22116
     /*  22116 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(22178), // Rule ID 20025 //
     /*  22121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22160 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22176 */     GIR_RootConstrainSelectedInstOperands,
     /*  22177 */     // GIR_Coverage, 20025,
     /*  22177 */     GIR_EraseRootFromParent_Done,
     /*  22178 */   // Label 590: @22178
     /*  22178 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(22205), // Rule ID 18147 //
     /*  22183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22198 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  22203 */     GIR_RootConstrainSelectedInstOperands,
     /*  22204 */     // GIR_Coverage, 18147,
     /*  22204 */     GIR_Done,
     /*  22205 */   // Label 591: @22205
     /*  22205 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(22232), // Rule ID 18171 //
     /*  22210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  22213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22225 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  22230 */     GIR_RootConstrainSelectedInstOperands,
     /*  22231 */     // GIR_Coverage, 18171,
     /*  22231 */     GIR_Done,
     /*  22232 */   // Label 592: @22232
     /*  22232 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(22259), // Rule ID 20017 //
     /*  22237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22252 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  22252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  22257 */     GIR_RootConstrainSelectedInstOperands,
     /*  22258 */     // GIR_Coverage, 20017,
     /*  22258 */     GIR_Done,
     /*  22259 */   // Label 593: @22259
     /*  22259 */   GIM_Reject,
     /*  22260 */ // Label 586: @22260
     /*  22260 */ GIM_Reject,
     /*  22261 */ // Label 456: @22261
     /*  22261 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(22726),
     /*  22266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  22269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  22272 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(22334), // Rule ID 24161 //
     /*  22277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22316 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22332 */     GIR_RootConstrainSelectedInstOperands,
     /*  22333 */     // GIR_Coverage, 24161,
     /*  22333 */     GIR_EraseRootFromParent_Done,
     /*  22334 */   // Label 595: @22334
     /*  22334 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(22396), // Rule ID 25232 //
     /*  22339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22378 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22394 */     GIR_RootConstrainSelectedInstOperands,
     /*  22395 */     // GIR_Coverage, 25232,
     /*  22395 */     GIR_EraseRootFromParent_Done,
     /*  22396 */   // Label 596: @22396
     /*  22396 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(22458), // Rule ID 25241 //
     /*  22401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22440 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22456 */     GIR_RootConstrainSelectedInstOperands,
     /*  22457 */     // GIR_Coverage, 25241,
     /*  22457 */     GIR_EraseRootFromParent_Done,
     /*  22458 */   // Label 597: @22458
     /*  22458 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(22520), // Rule ID 5725 //
     /*  22463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22502 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22518 */     GIR_RootConstrainSelectedInstOperands,
     /*  22519 */     // GIR_Coverage, 5725,
     /*  22519 */     GIR_EraseRootFromParent_Done,
     /*  22520 */   // Label 598: @22520
     /*  22520 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(22582), // Rule ID 18104 //
     /*  22525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22564 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22580 */     GIR_RootConstrainSelectedInstOperands,
     /*  22581 */     // GIR_Coverage, 18104,
     /*  22581 */     GIR_EraseRootFromParent_Done,
     /*  22582 */   // Label 599: @22582
     /*  22582 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(22644), // Rule ID 18132 //
     /*  22587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22626 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22642 */     GIR_RootConstrainSelectedInstOperands,
     /*  22643 */     // GIR_Coverage, 18132,
     /*  22643 */     GIR_EraseRootFromParent_Done,
     /*  22644 */   // Label 600: @22644
     /*  22644 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(22671), // Rule ID 5722 //
     /*  22649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22664 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  22664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /*  22669 */     GIR_RootConstrainSelectedInstOperands,
     /*  22670 */     // GIR_Coverage, 5722,
     /*  22670 */     GIR_Done,
     /*  22671 */   // Label 601: @22671
     /*  22671 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(22698), // Rule ID 18092 //
     /*  22676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22691 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  22696 */     GIR_RootConstrainSelectedInstOperands,
     /*  22697 */     // GIR_Coverage, 18092,
     /*  22697 */     GIR_Done,
     /*  22698 */   // Label 602: @22698
     /*  22698 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(22725), // Rule ID 18116 //
     /*  22703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22718 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  22723 */     GIR_RootConstrainSelectedInstOperands,
     /*  22724 */     // GIR_Coverage, 18116,
     /*  22724 */     GIR_Done,
     /*  22725 */   // Label 603: @22725
     /*  22725 */   GIM_Reject,
     /*  22726 */ // Label 594: @22726
     /*  22726 */ GIM_Reject,
     /*  22727 */ // Label 457: @22727
     /*  22727 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(22882),
     /*  22732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  22735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  22738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22742 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(22800), // Rule ID 24137 //
     /*  22747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22782 */     // (and:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22798 */     GIR_RootConstrainSelectedInstOperands,
     /*  22799 */     // GIR_Coverage, 24137,
     /*  22799 */     GIR_EraseRootFromParent_Done,
     /*  22800 */   // Label 605: @22800
     /*  22800 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(22858), // Rule ID 5689 //
     /*  22805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22840 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22856 */     GIR_RootConstrainSelectedInstOperands,
     /*  22857 */     // GIR_Coverage, 5689,
     /*  22857 */     GIR_EraseRootFromParent_Done,
     /*  22858 */   // Label 606: @22858
     /*  22858 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(22881), // Rule ID 5686 //
     /*  22863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22874 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  22874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  22879 */     GIR_RootConstrainSelectedInstOperands,
     /*  22880 */     // GIR_Coverage, 5686,
     /*  22880 */     GIR_Done,
     /*  22881 */   // Label 607: @22881
     /*  22881 */   GIM_Reject,
     /*  22882 */ // Label 604: @22882
     /*  22882 */ GIM_Reject,
     /*  22883 */ // Label 458: @22883
     /*  22883 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(23042),
     /*  22888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22898 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(22958), // Rule ID 4432 //
     /*  22903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22931 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  22939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22945 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  22945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  22948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  22954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  22956 */     GIR_RootConstrainSelectedInstOperands,
     /*  22957 */     // GIR_Coverage, 4432,
     /*  22957 */     GIR_EraseRootFromParent_Done,
     /*  22958 */   // Label 609: @22958
     /*  22958 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(23018), // Rule ID 23693 //
     /*  22963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22995 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23001 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  23003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23005 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23014 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  23016 */     GIR_RootConstrainSelectedInstOperands,
     /*  23017 */     // GIR_Coverage, 23693,
     /*  23017 */     GIR_EraseRootFromParent_Done,
     /*  23018 */   // Label 610: @23018
     /*  23018 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(23041), // Rule ID 4416 //
     /*  23023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23034 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  23039 */     GIR_RootConstrainSelectedInstOperands,
     /*  23040 */     // GIR_Coverage, 4416,
     /*  23040 */     GIR_Done,
     /*  23041 */   // Label 611: @23041
     /*  23041 */   GIM_Reject,
     /*  23042 */ // Label 608: @23042
     /*  23042 */ GIM_Reject,
     /*  23043 */ // Label 459: @23043
     /*  23043 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(23384),
     /*  23048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  23051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  23054 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(23116), // Rule ID 25251 //
     /*  23059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23098 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23114 */     GIR_RootConstrainSelectedInstOperands,
     /*  23115 */     // GIR_Coverage, 25251,
     /*  23115 */     GIR_EraseRootFromParent_Done,
     /*  23116 */   // Label 613: @23116
     /*  23116 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(23178), // Rule ID 25432 //
     /*  23121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23136 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23160 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23165 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23176 */     GIR_RootConstrainSelectedInstOperands,
     /*  23177 */     // GIR_Coverage, 25432,
     /*  23177 */     GIR_EraseRootFromParent_Done,
     /*  23178 */   // Label 614: @23178
     /*  23178 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(23240), // Rule ID 18158 //
     /*  23183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23222 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23238 */     GIR_RootConstrainSelectedInstOperands,
     /*  23239 */     // GIR_Coverage, 18158,
     /*  23239 */     GIR_EraseRootFromParent_Done,
     /*  23240 */   // Label 615: @23240
     /*  23240 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(23302), // Rule ID 20024 //
     /*  23245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23284 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23289 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23300 */     GIR_RootConstrainSelectedInstOperands,
     /*  23301 */     // GIR_Coverage, 20024,
     /*  23301 */     GIR_EraseRootFromParent_Done,
     /*  23302 */   // Label 616: @23302
     /*  23302 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(23329), // Rule ID 18146 //
     /*  23307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23322 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  23327 */     GIR_RootConstrainSelectedInstOperands,
     /*  23328 */     // GIR_Coverage, 18146,
     /*  23328 */     GIR_Done,
     /*  23329 */   // Label 617: @23329
     /*  23329 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(23356), // Rule ID 18170 //
     /*  23334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23349 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  23354 */     GIR_RootConstrainSelectedInstOperands,
     /*  23355 */     // GIR_Coverage, 18170,
     /*  23355 */     GIR_Done,
     /*  23356 */   // Label 618: @23356
     /*  23356 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(23383), // Rule ID 20016 //
     /*  23361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23376 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  23376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  23381 */     GIR_RootConstrainSelectedInstOperands,
     /*  23382 */     // GIR_Coverage, 20016,
     /*  23382 */     GIR_Done,
     /*  23383 */   // Label 619: @23383
     /*  23383 */   GIM_Reject,
     /*  23384 */ // Label 612: @23384
     /*  23384 */ GIM_Reject,
     /*  23385 */ // Label 460: @23385
     /*  23385 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(23850),
     /*  23390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  23393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  23396 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(23458), // Rule ID 25231 //
     /*  23401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23440 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23456 */     GIR_RootConstrainSelectedInstOperands,
     /*  23457 */     // GIR_Coverage, 25231,
     /*  23457 */     GIR_EraseRootFromParent_Done,
     /*  23458 */   // Label 621: @23458
     /*  23458 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(23520), // Rule ID 25240 //
     /*  23463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23502 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23507 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23518 */     GIR_RootConstrainSelectedInstOperands,
     /*  23519 */     // GIR_Coverage, 25240,
     /*  23519 */     GIR_EraseRootFromParent_Done,
     /*  23520 */   // Label 622: @23520
     /*  23520 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(23582), // Rule ID 25439 //
     /*  23525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23564 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23580 */     GIR_RootConstrainSelectedInstOperands,
     /*  23581 */     // GIR_Coverage, 25439,
     /*  23581 */     GIR_EraseRootFromParent_Done,
     /*  23582 */   // Label 623: @23582
     /*  23582 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(23644), // Rule ID 18103 //
     /*  23587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23626 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23642 */     GIR_RootConstrainSelectedInstOperands,
     /*  23643 */     // GIR_Coverage, 18103,
     /*  23643 */     GIR_EraseRootFromParent_Done,
     /*  23644 */   // Label 624: @23644
     /*  23644 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(23706), // Rule ID 18131 //
     /*  23649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23688 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23704 */     GIR_RootConstrainSelectedInstOperands,
     /*  23705 */     // GIR_Coverage, 18131,
     /*  23705 */     GIR_EraseRootFromParent_Done,
     /*  23706 */   // Label 625: @23706
     /*  23706 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(23768), // Rule ID 20041 //
     /*  23711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23750 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23766 */     GIR_RootConstrainSelectedInstOperands,
     /*  23767 */     // GIR_Coverage, 20041,
     /*  23767 */     GIR_EraseRootFromParent_Done,
     /*  23768 */   // Label 626: @23768
     /*  23768 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(23795), // Rule ID 18091 //
     /*  23773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23788 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  23788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  23793 */     GIR_RootConstrainSelectedInstOperands,
     /*  23794 */     // GIR_Coverage, 18091,
     /*  23794 */     GIR_Done,
     /*  23795 */   // Label 627: @23795
     /*  23795 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(23822), // Rule ID 18115 //
     /*  23800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23815 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  23815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  23820 */     GIR_RootConstrainSelectedInstOperands,
     /*  23821 */     // GIR_Coverage, 18115,
     /*  23821 */     GIR_Done,
     /*  23822 */   // Label 628: @23822
     /*  23822 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(23849), // Rule ID 20033 //
     /*  23827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23842 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  23842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  23847 */     GIR_RootConstrainSelectedInstOperands,
     /*  23848 */     // GIR_Coverage, 20033,
     /*  23848 */     GIR_Done,
     /*  23849 */   // Label 629: @23849
     /*  23849 */   GIM_Reject,
     /*  23850 */ // Label 620: @23850
     /*  23850 */ GIM_Reject,
     /*  23851 */ // Label 461: @23851
     /*  23851 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(24006),
     /*  23856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  23859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  23862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23866 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(23924), // Rule ID 24155 //
     /*  23871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23882 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23906 */     // (and:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  23909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23913 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23922 */     GIR_RootConstrainSelectedInstOperands,
     /*  23923 */     // GIR_Coverage, 24155,
     /*  23923 */     GIR_EraseRootFromParent_Done,
     /*  23924 */   // Label 631: @23924
     /*  23924 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(23982), // Rule ID 5716 //
     /*  23929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23964 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  23967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23980 */     GIR_RootConstrainSelectedInstOperands,
     /*  23981 */     // GIR_Coverage, 5716,
     /*  23981 */     GIR_EraseRootFromParent_Done,
     /*  23982 */   // Label 632: @23982
     /*  23982 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(24005), // Rule ID 5713 //
     /*  23987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23998 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  23998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /*  24003 */     GIR_RootConstrainSelectedInstOperands,
     /*  24004 */     // GIR_Coverage, 5713,
     /*  24004 */     GIR_Done,
     /*  24005 */   // Label 633: @24005
     /*  24005 */   GIM_Reject,
     /*  24006 */ // Label 630: @24006
     /*  24006 */ GIM_Reject,
     /*  24007 */ // Label 462: @24007
     /*  24007 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(24166),
     /*  24012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24022 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(24082), // Rule ID 4433 //
     /*  24027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24055 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24061 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24069 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24078 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24080 */     GIR_RootConstrainSelectedInstOperands,
     /*  24081 */     // GIR_Coverage, 4433,
     /*  24081 */     GIR_EraseRootFromParent_Done,
     /*  24082 */   // Label 635: @24082
     /*  24082 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(24142), // Rule ID 23694 //
     /*  24087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24119 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24129 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24140 */     GIR_RootConstrainSelectedInstOperands,
     /*  24141 */     // GIR_Coverage, 23694,
     /*  24141 */     GIR_EraseRootFromParent_Done,
     /*  24142 */   // Label 636: @24142
     /*  24142 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(24165), // Rule ID 4417 //
     /*  24147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24158 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /*  24163 */     GIR_RootConstrainSelectedInstOperands,
     /*  24164 */     // GIR_Coverage, 4417,
     /*  24164 */     GIR_Done,
     /*  24165 */   // Label 637: @24165
     /*  24165 */   GIM_Reject,
     /*  24166 */ // Label 634: @24166
     /*  24166 */ GIM_Reject,
     /*  24167 */ // Label 463: @24167
     /*  24167 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(24632),
     /*  24172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  24175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  24178 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(24240), // Rule ID 25230 //
     /*  24183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24198 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24222 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24238 */     GIR_RootConstrainSelectedInstOperands,
     /*  24239 */     // GIR_Coverage, 25230,
     /*  24239 */     GIR_EraseRootFromParent_Done,
     /*  24240 */   // Label 639: @24240
     /*  24240 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(24302), // Rule ID 25239 //
     /*  24245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24284 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24300 */     GIR_RootConstrainSelectedInstOperands,
     /*  24301 */     // GIR_Coverage, 25239,
     /*  24301 */     GIR_EraseRootFromParent_Done,
     /*  24302 */   // Label 640: @24302
     /*  24302 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(24364), // Rule ID 25438 //
     /*  24307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24346 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24362 */     GIR_RootConstrainSelectedInstOperands,
     /*  24363 */     // GIR_Coverage, 25438,
     /*  24363 */     GIR_EraseRootFromParent_Done,
     /*  24364 */   // Label 641: @24364
     /*  24364 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(24426), // Rule ID 18102 //
     /*  24369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24408 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24424 */     GIR_RootConstrainSelectedInstOperands,
     /*  24425 */     // GIR_Coverage, 18102,
     /*  24425 */     GIR_EraseRootFromParent_Done,
     /*  24426 */   // Label 642: @24426
     /*  24426 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(24488), // Rule ID 18130 //
     /*  24431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24457 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24470 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24475 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24486 */     GIR_RootConstrainSelectedInstOperands,
     /*  24487 */     // GIR_Coverage, 18130,
     /*  24487 */     GIR_EraseRootFromParent_Done,
     /*  24488 */   // Label 643: @24488
     /*  24488 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(24550), // Rule ID 20040 //
     /*  24493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24532 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24548 */     GIR_RootConstrainSelectedInstOperands,
     /*  24549 */     // GIR_Coverage, 20040,
     /*  24549 */     GIR_EraseRootFromParent_Done,
     /*  24550 */   // Label 644: @24550
     /*  24550 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(24577), // Rule ID 18090 //
     /*  24555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24570 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24575 */     GIR_RootConstrainSelectedInstOperands,
     /*  24576 */     // GIR_Coverage, 18090,
     /*  24576 */     GIR_Done,
     /*  24577 */   // Label 645: @24577
     /*  24577 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(24604), // Rule ID 18114 //
     /*  24582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24597 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24602 */     GIR_RootConstrainSelectedInstOperands,
     /*  24603 */     // GIR_Coverage, 18114,
     /*  24603 */     GIR_Done,
     /*  24604 */   // Label 646: @24604
     /*  24604 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(24631), // Rule ID 20032 //
     /*  24609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24624 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  24624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24629 */     GIR_RootConstrainSelectedInstOperands,
     /*  24630 */     // GIR_Coverage, 20032,
     /*  24630 */     GIR_Done,
     /*  24631 */   // Label 647: @24631
     /*  24631 */   GIM_Reject,
     /*  24632 */ // Label 638: @24632
     /*  24632 */ GIM_Reject,
     /*  24633 */ // Label 464: @24633
     /*  24633 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(24788),
     /*  24638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  24641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  24644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24648 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(24706), // Rule ID 25445 //
     /*  24653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24688 */     // (and:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24704 */     GIR_RootConstrainSelectedInstOperands,
     /*  24705 */     // GIR_Coverage, 25445,
     /*  24705 */     GIR_EraseRootFromParent_Done,
     /*  24706 */   // Label 649: @24706
     /*  24706 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(24764), // Rule ID 20057 //
     /*  24711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24726 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24729 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24733 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24746 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24762 */     GIR_RootConstrainSelectedInstOperands,
     /*  24763 */     // GIR_Coverage, 20057,
     /*  24763 */     GIR_EraseRootFromParent_Done,
     /*  24764 */   // Label 650: @24764
     /*  24764 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(24787), // Rule ID 20049 //
     /*  24769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24780 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  24780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  24785 */     GIR_RootConstrainSelectedInstOperands,
     /*  24786 */     // GIR_Coverage, 20049,
     /*  24786 */     GIR_Done,
     /*  24787 */   // Label 651: @24787
     /*  24787 */   GIM_Reject,
     /*  24788 */ // Label 648: @24788
     /*  24788 */ GIM_Reject,
     /*  24789 */ // Label 465: @24789
     /*  24789 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(24948),
     /*  24794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24804 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(24864), // Rule ID 4434 //
     /*  24809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24837 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24851 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  24854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24862 */     GIR_RootConstrainSelectedInstOperands,
     /*  24863 */     // GIR_Coverage, 4434,
     /*  24863 */     GIR_EraseRootFromParent_Done,
     /*  24864 */   // Label 653: @24864
     /*  24864 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(24924), // Rule ID 23695 //
     /*  24869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24901 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24911 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  24914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 23695,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 654: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(24947), // Rule ID 4418 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24940 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /*  24945 */     GIR_RootConstrainSelectedInstOperands,
     /*  24946 */     // GIR_Coverage, 4418,
     /*  24946 */     GIR_Done,
     /*  24947 */   // Label 655: @24947
     /*  24947 */   GIM_Reject,
     /*  24948 */ // Label 652: @24948
     /*  24948 */ GIM_Reject,
     /*  24949 */ // Label 466: @24949
     /*  24949 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(25104),
     /*  24954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  24957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  24960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24964 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(25022), // Rule ID 25444 //
     /*  24969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25004 */     // (and:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25020 */     GIR_RootConstrainSelectedInstOperands,
     /*  25021 */     // GIR_Coverage, 25444,
     /*  25021 */     GIR_EraseRootFromParent_Done,
     /*  25022 */   // Label 657: @25022
     /*  25022 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(25080), // Rule ID 20056 //
     /*  25027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25062 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25078 */     GIR_RootConstrainSelectedInstOperands,
     /*  25079 */     // GIR_Coverage, 20056,
     /*  25079 */     GIR_EraseRootFromParent_Done,
     /*  25080 */   // Label 658: @25080
     /*  25080 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(25103), // Rule ID 20048 //
     /*  25085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25096 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  25096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  25101 */     GIR_RootConstrainSelectedInstOperands,
     /*  25102 */     // GIR_Coverage, 20048,
     /*  25102 */     GIR_Done,
     /*  25103 */   // Label 659: @25103
     /*  25103 */   GIM_Reject,
     /*  25104 */ // Label 656: @25104
     /*  25104 */ GIM_Reject,
     /*  25105 */ // Label 467: @25105
     /*  25105 */ GIM_Reject,
     /*  25106 */ // Label 4: @25106
     /*  25106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 683*/ GIMT_Encode4(33509),
     /*  25117 */ /*GILLT_s1*//*Label 660*/ GIMT_Encode4(25217),
     /*  25121 */ /*GILLT_s8*//*Label 661*/ GIMT_Encode4(25317),
     /*  25125 */ /*GILLT_s16*//*Label 662*/ GIMT_Encode4(25710),
     /*  25129 */ /*GILLT_s32*//*Label 663*/ GIMT_Encode4(26307),
     /*  25133 */ /*GILLT_s64*//*Label 664*/ GIMT_Encode4(27763), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  25145 */ /*GILLT_v2s1*//*Label 665*/ GIMT_Encode4(29227),
     /*  25149 */ /*GILLT_v2s64*//*Label 666*/ GIMT_Encode4(29327),
     /*  25153 */ /*GILLT_v4s1*//*Label 667*/ GIMT_Encode4(29669),
     /*  25157 */ /*GILLT_v4s32*//*Label 668*/ GIMT_Encode4(29769),
     /*  25161 */ /*GILLT_v4s64*//*Label 669*/ GIMT_Encode4(30111),
     /*  25165 */ /*GILLT_v8s1*//*Label 670*/ GIMT_Encode4(30577),
     /*  25169 */ /*GILLT_v8s16*//*Label 671*/ GIMT_Encode4(30701),
     /*  25173 */ /*GILLT_v8s32*//*Label 672*/ GIMT_Encode4(31043),
     /*  25177 */ /*GILLT_v8s64*//*Label 673*/ GIMT_Encode4(31509),
     /*  25181 */ /*GILLT_v16s1*//*Label 674*/ GIMT_Encode4(31665),
     /*  25185 */ /*GILLT_v16s8*//*Label 675*/ GIMT_Encode4(31699),
     /*  25189 */ /*GILLT_v16s16*//*Label 676*/ GIMT_Encode4(32041),
     /*  25193 */ /*GILLT_v16s32*//*Label 677*/ GIMT_Encode4(32507),
     /*  25197 */ /*GILLT_v32s1*//*Label 678*/ GIMT_Encode4(32663),
     /*  25201 */ /*GILLT_v32s8*//*Label 679*/ GIMT_Encode4(32697),
     /*  25205 */ /*GILLT_v32s16*//*Label 680*/ GIMT_Encode4(33163),
     /*  25209 */ /*GILLT_v64s1*//*Label 681*/ GIMT_Encode4(33319),
     /*  25213 */ /*GILLT_v64s8*//*Label 682*/ GIMT_Encode4(33353),
     /*  25217 */ // Label 660: @25217
     /*  25217 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(25316), // Rule ID 19492 //
     /*  25222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  25225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  25228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25240 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  25240 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  25243 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25247 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25252 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  25256 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25261 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  25264 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25268 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25273 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  25277 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  25285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  25289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25294 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25297 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25310 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  25315 */   // GIR_Coverage, 19492,
     /*  25315 */   GIR_EraseRootFromParent_Done,
     /*  25316 */ // Label 684: @25316
     /*  25316 */ GIM_Reject,
     /*  25317 */ // Label 661: @25317
     /*  25317 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(25709),
     /*  25322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  25325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  25328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25332 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(25393), // Rule ID 26061 //
     /*  25337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25355 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25372 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25391 */     GIR_RootConstrainSelectedInstOperands,
     /*  25392 */     // GIR_Coverage, 26061,
     /*  25392 */     GIR_EraseRootFromParent_Done,
     /*  25393 */   // Label 686: @25393
     /*  25393 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(25454), // Rule ID 26080 //
     /*  25398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25412 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25416 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25433 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25452 */     GIR_RootConstrainSelectedInstOperands,
     /*  25453 */     // GIR_Coverage, 26080,
     /*  25453 */     GIR_EraseRootFromParent_Done,
     /*  25454 */   // Label 687: @25454
     /*  25454 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(25515), // Rule ID 22830 //
     /*  25459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25481 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25494 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25513 */     GIR_RootConstrainSelectedInstOperands,
     /*  25514 */     // GIR_Coverage, 22830,
     /*  25514 */     GIR_EraseRootFromParent_Done,
     /*  25515 */   // Label 688: @25515
     /*  25515 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(25576), // Rule ID 22920 //
     /*  25520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25535 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25538 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25542 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25555 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25574 */     GIR_RootConstrainSelectedInstOperands,
     /*  25575 */     // GIR_Coverage, 22920,
     /*  25575 */     GIR_EraseRootFromParent_Done,
     /*  25576 */   // Label 689: @25576
     /*  25576 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(25613), // Rule ID 22834 //
     /*  25581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25596 */     // MIs[1] Operand 1
     /*  25596 */     // No operand predicates
     /*  25596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25598 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /*  25601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25603 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25611 */     GIR_RootConstrainSelectedInstOperands,
     /*  25612 */     // GIR_Coverage, 22834,
     /*  25612 */     GIR_EraseRootFromParent_Done,
     /*  25613 */   // Label 690: @25613
     /*  25613 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(25650), // Rule ID 22924 //
     /*  25618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25633 */     // MIs[1] Operand 1
     /*  25633 */     // No operand predicates
     /*  25633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25635 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /*  25638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25648 */     GIR_RootConstrainSelectedInstOperands,
     /*  25649 */     // GIR_Coverage, 22924,
     /*  25649 */     GIR_EraseRootFromParent_Done,
     /*  25650 */   // Label 691: @25650
     /*  25650 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(25679), // Rule ID 22826 //
     /*  25655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25666 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /*  25671 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25677 */     GIR_RootConstrainSelectedInstOperands,
     /*  25678 */     // GIR_Coverage, 22826,
     /*  25678 */     GIR_Done,
     /*  25679 */   // Label 692: @25679
     /*  25679 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(25708), // Rule ID 22916 //
     /*  25684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25695 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /*  25700 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25706 */     GIR_RootConstrainSelectedInstOperands,
     /*  25707 */     // GIR_Coverage, 22916,
     /*  25707 */     GIR_Done,
     /*  25708 */   // Label 693: @25708
     /*  25708 */   GIM_Reject,
     /*  25709 */ // Label 685: @25709
     /*  25709 */ GIM_Reject,
     /*  25710 */ // Label 662: @25710
     /*  25710 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(26306),
     /*  25715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  25718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  25721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25725 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(25786), // Rule ID 26062 //
     /*  25730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25741 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25748 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25765 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25770 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25784 */     GIR_RootConstrainSelectedInstOperands,
     /*  25785 */     // GIR_Coverage, 26062,
     /*  25785 */     GIR_EraseRootFromParent_Done,
     /*  25786 */   // Label 695: @25786
     /*  25786 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(25847), // Rule ID 26081 //
     /*  25791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25802 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25809 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25826 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  25829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25831 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25845 */     GIR_RootConstrainSelectedInstOperands,
     /*  25846 */     // GIR_Coverage, 26081,
     /*  25846 */     GIR_EraseRootFromParent_Done,
     /*  25847 */   // Label 696: @25847
     /*  25847 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(25908), // Rule ID 22831 //
     /*  25852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25867 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25874 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25887 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25894 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25906 */     GIR_RootConstrainSelectedInstOperands,
     /*  25907 */     // GIR_Coverage, 22831,
     /*  25907 */     GIR_EraseRootFromParent_Done,
     /*  25908 */   // Label 697: @25908
     /*  25908 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(25969), // Rule ID 22921 //
     /*  25913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25935 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25948 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  25951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25967 */     GIR_RootConstrainSelectedInstOperands,
     /*  25968 */     // GIR_Coverage, 22921,
     /*  25968 */     GIR_EraseRootFromParent_Done,
     /*  25969 */   // Label 698: @25969
     /*  25969 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(26071), // Rule ID 26037 //
     /*  25974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  25982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  25986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  25990 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  25994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26005 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26005 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26008 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26012 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26031 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26038 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26069 */     GIR_RootConstrainSelectedInstOperands,
     /*  26070 */     // GIR_Coverage, 26037,
     /*  26070 */     GIR_EraseRootFromParent_Done,
     /*  26071 */   // Label 699: @26071
     /*  26071 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(26173), // Rule ID 22775 //
     /*  26076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26096 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26107 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26171 */     GIR_RootConstrainSelectedInstOperands,
     /*  26172 */     // GIR_Coverage, 22775,
     /*  26172 */     GIR_EraseRootFromParent_Done,
     /*  26173 */   // Label 700: @26173
     /*  26173 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(26210), // Rule ID 22835 //
     /*  26178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26193 */     // MIs[1] Operand 1
     /*  26193 */     // No operand predicates
     /*  26193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26195 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /*  26198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26208 */     GIR_RootConstrainSelectedInstOperands,
     /*  26209 */     // GIR_Coverage, 22835,
     /*  26209 */     GIR_EraseRootFromParent_Done,
     /*  26210 */   // Label 701: @26210
     /*  26210 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(26247), // Rule ID 22925 //
     /*  26215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26230 */     // MIs[1] Operand 1
     /*  26230 */     // No operand predicates
     /*  26230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26232 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /*  26235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26237 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26245 */     GIR_RootConstrainSelectedInstOperands,
     /*  26246 */     // GIR_Coverage, 22925,
     /*  26246 */     GIR_EraseRootFromParent_Done,
     /*  26247 */   // Label 702: @26247
     /*  26247 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(26276), // Rule ID 22827 //
     /*  26252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26263 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /*  26268 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26274 */     GIR_RootConstrainSelectedInstOperands,
     /*  26275 */     // GIR_Coverage, 22827,
     /*  26275 */     GIR_Done,
     /*  26276 */   // Label 703: @26276
     /*  26276 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(26305), // Rule ID 22917 //
     /*  26281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26292 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /*  26297 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26303 */     GIR_RootConstrainSelectedInstOperands,
     /*  26304 */     // GIR_Coverage, 22917,
     /*  26304 */     GIR_Done,
     /*  26305 */   // Label 704: @26305
     /*  26305 */   GIM_Reject,
     /*  26306 */ // Label 694: @26306
     /*  26306 */ GIM_Reject,
     /*  26307 */ // Label 663: @26307
     /*  26307 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(27762),
     /*  26312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26315 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(26383), // Rule ID 26063 //
     /*  26320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26345 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26362 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26381 */     GIR_RootConstrainSelectedInstOperands,
     /*  26382 */     // GIR_Coverage, 26063,
     /*  26382 */     GIR_EraseRootFromParent_Done,
     /*  26383 */   // Label 706: @26383
     /*  26383 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(26451), // Rule ID 26082 //
     /*  26388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26409 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26413 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26430 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26435 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26437 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26449 */     GIR_RootConstrainSelectedInstOperands,
     /*  26450 */     // GIR_Coverage, 26082,
     /*  26450 */     GIR_EraseRootFromParent_Done,
     /*  26451 */   // Label 707: @26451
     /*  26451 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(26519), // Rule ID 22832 //
     /*  26456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26485 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26498 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26503 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26517 */     GIR_RootConstrainSelectedInstOperands,
     /*  26518 */     // GIR_Coverage, 22832,
     /*  26518 */     GIR_EraseRootFromParent_Done,
     /*  26519 */   // Label 708: @26519
     /*  26519 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(26587), // Rule ID 22922 //
     /*  26524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26553 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26566 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26585 */     GIR_RootConstrainSelectedInstOperands,
     /*  26586 */     // GIR_Coverage, 22922,
     /*  26586 */     GIR_EraseRootFromParent_Done,
     /*  26587 */   // Label 709: @26587
     /*  26587 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(26664), // Rule ID 25003 //
     /*  26592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26623 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26639 */     // MIs[2] src
     /*  26639 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26644 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26650 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26662 */     GIR_RootConstrainSelectedInstOperands,
     /*  26663 */     // GIR_Coverage, 25003,
     /*  26663 */     GIR_EraseRootFromParent_Done,
     /*  26664 */   // Label 710: @26664
     /*  26664 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(26741), // Rule ID 25005 //
     /*  26669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26700 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  26704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26716 */     // MIs[2] src
     /*  26716 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26721 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26727 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26739 */     GIR_RootConstrainSelectedInstOperands,
     /*  26740 */     // GIR_Coverage, 25005,
     /*  26740 */     GIR_EraseRootFromParent_Done,
     /*  26741 */   // Label 711: @26741
     /*  26741 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(26819), // Rule ID 24991 //
     /*  26746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  26794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26798 */     // MIs[0] src
     /*  26798 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26805 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  26808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  26814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26817 */     GIR_RootConstrainSelectedInstOperands,
     /*  26818 */     // GIR_Coverage, 24991,
     /*  26818 */     GIR_EraseRootFromParent_Done,
     /*  26819 */   // Label 712: @26819
     /*  26819 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(26896), // Rule ID 17364 //
     /*  26824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26855 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26871 */     // MIs[2] src
     /*  26871 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26876 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26882 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26894 */     GIR_RootConstrainSelectedInstOperands,
     /*  26895 */     // GIR_Coverage, 17364,
     /*  26895 */     GIR_EraseRootFromParent_Done,
     /*  26896 */   // Label 713: @26896
     /*  26896 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(26973), // Rule ID 17366 //
     /*  26901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26932 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26948 */     // MIs[2] src
     /*  26948 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26953 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  26957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26959 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26971 */     GIR_RootConstrainSelectedInstOperands,
     /*  26972 */     // GIR_Coverage, 17366,
     /*  26972 */     GIR_EraseRootFromParent_Done,
     /*  26973 */   // Label 714: @26973
     /*  26973 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(27047), // Rule ID 17352 //
     /*  26978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27020 */     // MIs[2] src
     /*  27020 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27025 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27035 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27045 */     GIR_RootConstrainSelectedInstOperands,
     /*  27046 */     // GIR_Coverage, 17352,
     /*  27046 */     GIR_EraseRootFromParent_Done,
     /*  27047 */   // Label 715: @27047
     /*  27047 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(27105), // Rule ID 24999 //
     /*  27052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27084 */     // MIs[0] src
     /*  27084 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27091 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27103 */     GIR_RootConstrainSelectedInstOperands,
     /*  27104 */     // GIR_Coverage, 24999,
     /*  27104 */     GIR_EraseRootFromParent_Done,
     /*  27105 */   // Label 716: @27105
     /*  27105 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(27163), // Rule ID 25001 //
     /*  27110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27138 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27142 */     // MIs[0] src
     /*  27142 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27149 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27161 */     GIR_RootConstrainSelectedInstOperands,
     /*  27162 */     // GIR_Coverage, 25001,
     /*  27162 */     GIR_EraseRootFromParent_Done,
     /*  27163 */   // Label 717: @27163
     /*  27163 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(27272), // Rule ID 26043 //
     /*  27168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27206 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27232 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27262 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27270 */     GIR_RootConstrainSelectedInstOperands,
     /*  27271 */     // GIR_Coverage, 26043,
     /*  27271 */     GIR_EraseRootFromParent_Done,
     /*  27272 */   // Label 718: @27272
     /*  27272 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(27330), // Rule ID 24993 //
     /*  27277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27300 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27309 */     // MIs[0] src
     /*  27309 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27316 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  27325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27328 */     GIR_RootConstrainSelectedInstOperands,
     /*  27329 */     // GIR_Coverage, 24993,
     /*  27329 */     GIR_EraseRootFromParent_Done,
     /*  27330 */   // Label 719: @27330
     /*  27330 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(27384), // Rule ID 17360 //
     /*  27335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27361 */     // MIs[1] src
     /*  27361 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27372 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27377 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27382 */     GIR_RootConstrainSelectedInstOperands,
     /*  27383 */     // GIR_Coverage, 17360,
     /*  27383 */     GIR_EraseRootFromParent_Done,
     /*  27384 */   // Label 720: @27384
     /*  27384 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(27438), // Rule ID 17362 //
     /*  27389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27415 */     // MIs[1] src
     /*  27415 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27420 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27426 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27436 */     GIR_RootConstrainSelectedInstOperands,
     /*  27437 */     // GIR_Coverage, 17362,
     /*  27437 */     GIR_EraseRootFromParent_Done,
     /*  27438 */   // Label 721: @27438
     /*  27438 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(27547), // Rule ID 22781 //
     /*  27443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27481 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27481 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27484 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27488 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27507 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27514 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27545 */     GIR_RootConstrainSelectedInstOperands,
     /*  27546 */     // GIR_Coverage, 22781,
     /*  27546 */     GIR_EraseRootFromParent_Done,
     /*  27547 */   // Label 722: @27547
     /*  27547 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(27601), // Rule ID 17354 //
     /*  27552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27582 */     // MIs[1] src
     /*  27582 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27589 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27599 */     GIR_RootConstrainSelectedInstOperands,
     /*  27600 */     // GIR_Coverage, 17354,
     /*  27600 */     GIR_EraseRootFromParent_Done,
     /*  27601 */   // Label 723: @27601
     /*  27601 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(27645), // Rule ID 22836 //
     /*  27606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27628 */     // MIs[1] Operand 1
     /*  27628 */     // No operand predicates
     /*  27628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27630 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /*  27633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27635 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27643 */     GIR_RootConstrainSelectedInstOperands,
     /*  27644 */     // GIR_Coverage, 22836,
     /*  27644 */     GIR_EraseRootFromParent_Done,
     /*  27645 */   // Label 724: @27645
     /*  27645 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(27689), // Rule ID 22926 //
     /*  27650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27672 */     // MIs[1] Operand 1
     /*  27672 */     // No operand predicates
     /*  27672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27674 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /*  27677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27687 */     GIR_RootConstrainSelectedInstOperands,
     /*  27688 */     // GIR_Coverage, 22926,
     /*  27688 */     GIR_EraseRootFromParent_Done,
     /*  27689 */   // Label 725: @27689
     /*  27689 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(27725), // Rule ID 22828 //
     /*  27694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27712 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /*  27717 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27723 */     GIR_RootConstrainSelectedInstOperands,
     /*  27724 */     // GIR_Coverage, 22828,
     /*  27724 */     GIR_Done,
     /*  27725 */   // Label 726: @27725
     /*  27725 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(27761), // Rule ID 22918 //
     /*  27730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27748 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /*  27753 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27759 */     GIR_RootConstrainSelectedInstOperands,
     /*  27760 */     // GIR_Coverage, 22918,
     /*  27760 */     GIR_Done,
     /*  27761 */   // Label 727: @27761
     /*  27761 */   GIM_Reject,
     /*  27762 */ // Label 705: @27762
     /*  27762 */ GIM_Reject,
     /*  27763 */ // Label 664: @27763
     /*  27763 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(29226),
     /*  27768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27771 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(27839), // Rule ID 26064 //
     /*  27776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27818 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  27821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27837 */     GIR_RootConstrainSelectedInstOperands,
     /*  27838 */     // GIR_Coverage, 26064,
     /*  27838 */     GIR_EraseRootFromParent_Done,
     /*  27839 */   // Label 729: @27839
     /*  27839 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(27907), // Rule ID 26083 //
     /*  27844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27886 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  27889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27905 */     GIR_RootConstrainSelectedInstOperands,
     /*  27906 */     // GIR_Coverage, 26083,
     /*  27906 */     GIR_EraseRootFromParent_Done,
     /*  27907 */   // Label 730: @27907
     /*  27907 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(27975), // Rule ID 22833 //
     /*  27912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27934 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27937 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27941 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27954 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  27957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27973 */     GIR_RootConstrainSelectedInstOperands,
     /*  27974 */     // GIR_Coverage, 22833,
     /*  27974 */     GIR_EraseRootFromParent_Done,
     /*  27975 */   // Label 731: @27975
     /*  27975 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(28043), // Rule ID 22923 //
     /*  27980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28022 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28041 */     GIR_RootConstrainSelectedInstOperands,
     /*  28042 */     // GIR_Coverage, 22923,
     /*  28042 */     GIR_EraseRootFromParent_Done,
     /*  28043 */   // Label 732: @28043
     /*  28043 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(28120), // Rule ID 25004 //
     /*  28048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28079 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28095 */     // MIs[2] src
     /*  28095 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28100 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28106 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28118 */     GIR_RootConstrainSelectedInstOperands,
     /*  28119 */     // GIR_Coverage, 25004,
     /*  28119 */     GIR_EraseRootFromParent_Done,
     /*  28120 */   // Label 733: @28120
     /*  28120 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(28197), // Rule ID 25006 //
     /*  28125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28156 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28172 */     // MIs[2] src
     /*  28172 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28177 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28183 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28195 */     GIR_RootConstrainSelectedInstOperands,
     /*  28196 */     // GIR_Coverage, 25006,
     /*  28196 */     GIR_EraseRootFromParent_Done,
     /*  28197 */   // Label 734: @28197
     /*  28197 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(28275), // Rule ID 24992 //
     /*  28202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  28237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28254 */     // MIs[0] src
     /*  28254 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  28259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28261 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  28270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28273 */     GIR_RootConstrainSelectedInstOperands,
     /*  28274 */     // GIR_Coverage, 24992,
     /*  28274 */     GIR_EraseRootFromParent_Done,
     /*  28275 */   // Label 735: @28275
     /*  28275 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(28352), // Rule ID 17365 //
     /*  28280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28311 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28327 */     // MIs[2] src
     /*  28327 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28332 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28338 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28350 */     GIR_RootConstrainSelectedInstOperands,
     /*  28351 */     // GIR_Coverage, 17365,
     /*  28351 */     GIR_EraseRootFromParent_Done,
     /*  28352 */   // Label 736: @28352
     /*  28352 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(28429), // Rule ID 17367 //
     /*  28357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28388 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28404 */     // MIs[2] src
     /*  28404 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28409 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28415 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28427 */     GIR_RootConstrainSelectedInstOperands,
     /*  28428 */     // GIR_Coverage, 17367,
     /*  28428 */     GIR_EraseRootFromParent_Done,
     /*  28429 */   // Label 737: @28429
     /*  28429 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(28503), // Rule ID 17353 //
     /*  28434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28476 */     // MIs[2] src
     /*  28476 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28485 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28491 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28501 */     GIR_RootConstrainSelectedInstOperands,
     /*  28502 */     // GIR_Coverage, 17353,
     /*  28502 */     GIR_EraseRootFromParent_Done,
     /*  28503 */   // Label 738: @28503
     /*  28503 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(28561), // Rule ID 25000 //
     /*  28508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28536 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28540 */     // MIs[0] src
     /*  28540 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28547 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28559 */     GIR_RootConstrainSelectedInstOperands,
     /*  28560 */     // GIR_Coverage, 25000,
     /*  28560 */     GIR_EraseRootFromParent_Done,
     /*  28561 */   // Label 739: @28561
     /*  28561 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(28619), // Rule ID 25002 //
     /*  28566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28594 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28598 */     // MIs[0] src
     /*  28598 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28605 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28617 */     GIR_RootConstrainSelectedInstOperands,
     /*  28618 */     // GIR_Coverage, 25002,
     /*  28618 */     GIR_EraseRootFromParent_Done,
     /*  28619 */   // Label 740: @28619
     /*  28619 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(28728), // Rule ID 26049 //
     /*  28624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28647 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28662 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28688 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28695 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28718 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28726 */     GIR_RootConstrainSelectedInstOperands,
     /*  28727 */     // GIR_Coverage, 26049,
     /*  28727 */     GIR_EraseRootFromParent_Done,
     /*  28728 */   // Label 741: @28728
     /*  28728 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(28786), // Rule ID 24994 //
     /*  28733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  28748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28756 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  28760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28765 */     // MIs[0] src
     /*  28765 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  28770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28772 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  28781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28784 */     GIR_RootConstrainSelectedInstOperands,
     /*  28785 */     // GIR_Coverage, 24994,
     /*  28785 */     GIR_EraseRootFromParent_Done,
     /*  28786 */   // Label 742: @28786
     /*  28786 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(28840), // Rule ID 17361 //
     /*  28791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28817 */     // MIs[1] src
     /*  28817 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28822 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28828 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28838 */     GIR_RootConstrainSelectedInstOperands,
     /*  28839 */     // GIR_Coverage, 17361,
     /*  28839 */     GIR_EraseRootFromParent_Done,
     /*  28840 */   // Label 743: @28840
     /*  28840 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(28894), // Rule ID 17363 //
     /*  28845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28871 */     // MIs[1] src
     /*  28871 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28876 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28882 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28892 */     GIR_RootConstrainSelectedInstOperands,
     /*  28893 */     // GIR_Coverage, 17363,
     /*  28893 */     GIR_EraseRootFromParent_Done,
     /*  28894 */   // Label 744: @28894
     /*  28894 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(29003), // Rule ID 22787 //
     /*  28899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28926 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28937 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28993 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29001 */     GIR_RootConstrainSelectedInstOperands,
     /*  29002 */     // GIR_Coverage, 22787,
     /*  29002 */     GIR_EraseRootFromParent_Done,
     /*  29003 */   // Label 745: @29003
     /*  29003 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(29057), // Rule ID 17355 //
     /*  29008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  29030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29034 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  29038 */     // MIs[1] src
     /*  29038 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29045 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  29048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29055 */     GIR_RootConstrainSelectedInstOperands,
     /*  29056 */     // GIR_Coverage, 17355,
     /*  29056 */     GIR_EraseRootFromParent_Done,
     /*  29057 */   // Label 746: @29057
     /*  29057 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(29105), // Rule ID 22837 //
     /*  29062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29088 */     // MIs[1] Operand 1
     /*  29088 */     // No operand predicates
     /*  29088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29090 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /*  29093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29103 */     GIR_RootConstrainSelectedInstOperands,
     /*  29104 */     // GIR_Coverage, 22837,
     /*  29104 */     GIR_EraseRootFromParent_Done,
     /*  29105 */   // Label 747: @29105
     /*  29105 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(29153), // Rule ID 22927 //
     /*  29110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29136 */     // MIs[1] Operand 1
     /*  29136 */     // No operand predicates
     /*  29136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29138 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /*  29141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29151 */     GIR_RootConstrainSelectedInstOperands,
     /*  29152 */     // GIR_Coverage, 22927,
     /*  29152 */     GIR_EraseRootFromParent_Done,
     /*  29153 */   // Label 748: @29153
     /*  29153 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(29189), // Rule ID 22829 //
     /*  29158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29176 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /*  29181 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29187 */     GIR_RootConstrainSelectedInstOperands,
     /*  29188 */     // GIR_Coverage, 22829,
     /*  29188 */     GIR_Done,
     /*  29189 */   // Label 749: @29189
     /*  29189 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(29225), // Rule ID 22919 //
     /*  29194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29212 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /*  29217 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29223 */     GIR_RootConstrainSelectedInstOperands,
     /*  29224 */     // GIR_Coverage, 22919,
     /*  29224 */     GIR_Done,
     /*  29225 */   // Label 750: @29225
     /*  29225 */   GIM_Reject,
     /*  29226 */ // Label 728: @29226
     /*  29226 */ GIM_Reject,
     /*  29227 */ // Label 665: @29227
     /*  29227 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(29326), // Rule ID 19493 //
     /*  29232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  29235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  29238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29250 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  29250 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29253 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29257 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29262 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29266 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29271 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29274 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29278 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29283 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29287 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29304 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29307 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  29325 */   // GIR_Coverage, 19493,
     /*  29325 */   GIR_EraseRootFromParent_Done,
     /*  29326 */ // Label 751: @29326
     /*  29326 */ GIM_Reject,
     /*  29327 */ // Label 666: @29327
     /*  29327 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(29668),
     /*  29332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  29338 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(29400), // Rule ID 23363 //
     /*  29343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29382 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29389 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29398 */     GIR_RootConstrainSelectedInstOperands,
     /*  29399 */     // GIR_Coverage, 23363,
     /*  29399 */     GIR_EraseRootFromParent_Done,
     /*  29400 */   // Label 753: @29400
     /*  29400 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(29462), // Rule ID 24185 //
     /*  29405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29444 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29460 */     GIR_RootConstrainSelectedInstOperands,
     /*  29461 */     // GIR_Coverage, 24185,
     /*  29461 */     GIR_EraseRootFromParent_Done,
     /*  29462 */   // Label 754: @29462
     /*  29462 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(29524), // Rule ID 2117 //
     /*  29467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29506 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29522 */     GIR_RootConstrainSelectedInstOperands,
     /*  29523 */     // GIR_Coverage, 2117,
     /*  29523 */     GIR_EraseRootFromParent_Done,
     /*  29524 */   // Label 755: @29524
     /*  29524 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(29586), // Rule ID 5761 //
     /*  29529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29568 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29584 */     GIR_RootConstrainSelectedInstOperands,
     /*  29585 */     // GIR_Coverage, 5761,
     /*  29585 */     GIR_EraseRootFromParent_Done,
     /*  29586 */   // Label 756: @29586
     /*  29586 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(29613), // Rule ID 2116 //
     /*  29591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29606 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  29611 */     GIR_RootConstrainSelectedInstOperands,
     /*  29612 */     // GIR_Coverage, 2116,
     /*  29612 */     GIR_Done,
     /*  29613 */   // Label 757: @29613
     /*  29613 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(29640), // Rule ID 2118 //
     /*  29618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  29621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29633 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  29638 */     GIR_RootConstrainSelectedInstOperands,
     /*  29639 */     // GIR_Coverage, 2118,
     /*  29639 */     GIR_Done,
     /*  29640 */   // Label 758: @29640
     /*  29640 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(29667), // Rule ID 5758 //
     /*  29645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29660 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  29660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  29665 */     GIR_RootConstrainSelectedInstOperands,
     /*  29666 */     // GIR_Coverage, 5758,
     /*  29666 */     GIR_Done,
     /*  29667 */   // Label 759: @29667
     /*  29667 */   GIM_Reject,
     /*  29668 */ // Label 752: @29668
     /*  29668 */ GIM_Reject,
     /*  29669 */ // Label 667: @29669
     /*  29669 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(29768), // Rule ID 19494 //
     /*  29674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  29677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  29680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29692 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  29692 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29695 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29699 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29704 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29708 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29713 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29716 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29720 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29725 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29729 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29746 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29762 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  29767 */   // GIR_Coverage, 19494,
     /*  29767 */   GIR_EraseRootFromParent_Done,
     /*  29768 */ // Label 760: @29768
     /*  29768 */ GIM_Reject,
     /*  29769 */ // Label 668: @29769
     /*  29769 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(30110),
     /*  29774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29780 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(29842), // Rule ID 24203 //
     /*  29785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29824 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  29827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29840 */     GIR_RootConstrainSelectedInstOperands,
     /*  29841 */     // GIR_Coverage, 24203,
     /*  29841 */     GIR_EraseRootFromParent_Done,
     /*  29842 */   // Label 762: @29842
     /*  29842 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(29904), // Rule ID 25256 //
     /*  29847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29886 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29902 */     GIR_RootConstrainSelectedInstOperands,
     /*  29903 */     // GIR_Coverage, 25256,
     /*  29903 */     GIR_EraseRootFromParent_Done,
     /*  29904 */   // Label 763: @29904
     /*  29904 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(29966), // Rule ID 5788 //
     /*  29909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29948 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  29951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29964 */     GIR_RootConstrainSelectedInstOperands,
     /*  29965 */     // GIR_Coverage, 5788,
     /*  29965 */     GIR_EraseRootFromParent_Done,
     /*  29966 */   // Label 764: @29966
     /*  29966 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(30028), // Rule ID 18163 //
     /*  29971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30010 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30026 */     GIR_RootConstrainSelectedInstOperands,
     /*  30027 */     // GIR_Coverage, 18163,
     /*  30027 */     GIR_EraseRootFromParent_Done,
     /*  30028 */   // Label 765: @30028
     /*  30028 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(30055), // Rule ID 5785 //
     /*  30033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30048 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  30048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /*  30053 */     GIR_RootConstrainSelectedInstOperands,
     /*  30054 */     // GIR_Coverage, 5785,
     /*  30054 */     GIR_Done,
     /*  30055 */   // Label 766: @30055
     /*  30055 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(30082), // Rule ID 18151 //
     /*  30060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30075 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30080 */     GIR_RootConstrainSelectedInstOperands,
     /*  30081 */     // GIR_Coverage, 18151,
     /*  30081 */     GIR_Done,
     /*  30082 */   // Label 767: @30082
     /*  30082 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(30109), // Rule ID 18175 //
     /*  30087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30102 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  30107 */     GIR_RootConstrainSelectedInstOperands,
     /*  30108 */     // GIR_Coverage, 18175,
     /*  30108 */     GIR_Done,
     /*  30109 */   // Label 768: @30109
     /*  30109 */   GIM_Reject,
     /*  30110 */ // Label 761: @30110
     /*  30110 */ GIM_Reject,
     /*  30111 */ // Label 669: @30111
     /*  30111 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(30576),
     /*  30116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  30119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  30122 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(30184), // Rule ID 23365 //
     /*  30127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30149 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30166 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30171 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30182 */     GIR_RootConstrainSelectedInstOperands,
     /*  30183 */     // GIR_Coverage, 23365,
     /*  30183 */     GIR_EraseRootFromParent_Done,
     /*  30184 */   // Label 770: @30184
     /*  30184 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(30246), // Rule ID 24179 //
     /*  30189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30228 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30233 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30235 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30244 */     GIR_RootConstrainSelectedInstOperands,
     /*  30245 */     // GIR_Coverage, 24179,
     /*  30245 */     GIR_EraseRootFromParent_Done,
     /*  30246 */   // Label 771: @30246
     /*  30246 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(30308), // Rule ID 25246 //
     /*  30251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30290 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30295 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30306 */     GIR_RootConstrainSelectedInstOperands,
     /*  30307 */     // GIR_Coverage, 25246,
     /*  30307 */     GIR_EraseRootFromParent_Done,
     /*  30308 */   // Label 772: @30308
     /*  30308 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(30370), // Rule ID 2121 //
     /*  30313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30352 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30357 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30368 */     GIR_RootConstrainSelectedInstOperands,
     /*  30369 */     // GIR_Coverage, 2121,
     /*  30369 */     GIR_EraseRootFromParent_Done,
     /*  30370 */   // Label 773: @30370
     /*  30370 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(30432), // Rule ID 5752 //
     /*  30375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30414 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30430 */     GIR_RootConstrainSelectedInstOperands,
     /*  30431 */     // GIR_Coverage, 5752,
     /*  30431 */     GIR_EraseRootFromParent_Done,
     /*  30432 */   // Label 774: @30432
     /*  30432 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(30494), // Rule ID 18137 //
     /*  30437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30476 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30492 */     GIR_RootConstrainSelectedInstOperands,
     /*  30493 */     // GIR_Coverage, 18137,
     /*  30493 */     GIR_EraseRootFromParent_Done,
     /*  30494 */   // Label 775: @30494
     /*  30494 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(30521), // Rule ID 2120 //
     /*  30499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30514 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  30519 */     GIR_RootConstrainSelectedInstOperands,
     /*  30520 */     // GIR_Coverage, 2120,
     /*  30520 */     GIR_Done,
     /*  30521 */   // Label 776: @30521
     /*  30521 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(30548), // Rule ID 5749 //
     /*  30526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30541 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  30541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  30546 */     GIR_RootConstrainSelectedInstOperands,
     /*  30547 */     // GIR_Coverage, 5749,
     /*  30547 */     GIR_Done,
     /*  30548 */   // Label 777: @30548
     /*  30548 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(30575), // Rule ID 18121 //
     /*  30553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30568 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  30573 */     GIR_RootConstrainSelectedInstOperands,
     /*  30574 */     // GIR_Coverage, 18121,
     /*  30574 */     GIR_Done,
     /*  30575 */   // Label 778: @30575
     /*  30575 */   GIM_Reject,
     /*  30576 */ // Label 769: @30576
     /*  30576 */ GIM_Reject,
     /*  30577 */ // Label 670: @30577
     /*  30577 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(30700),
     /*  30582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  30585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  30588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30600 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(30615), // Rule ID 4419 //
     /*  30605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  30608 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  30608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /*  30613 */     GIR_RootConstrainSelectedInstOperands,
     /*  30614 */     // GIR_Coverage, 4419,
     /*  30614 */     GIR_Done,
     /*  30615 */   // Label 780: @30615
     /*  30615 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(30699), // Rule ID 19491 //
     /*  30620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  30623 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  30623 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  30626 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30630 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30635 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  30639 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  30647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  30660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  30668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  30672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  30680 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  30683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  30698 */     // GIR_Coverage, 19491,
     /*  30698 */     GIR_EraseRootFromParent_Done,
     /*  30699 */   // Label 781: @30699
     /*  30699 */   GIM_Reject,
     /*  30700 */ // Label 779: @30700
     /*  30700 */ GIM_Reject,
     /*  30701 */ // Label 671: @30701
     /*  30701 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(31042),
     /*  30706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30712 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(30774), // Rule ID 25255 //
     /*  30717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30756 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30772 */     GIR_RootConstrainSelectedInstOperands,
     /*  30773 */     // GIR_Coverage, 25255,
     /*  30773 */     GIR_EraseRootFromParent_Done,
     /*  30774 */   // Label 783: @30774
     /*  30774 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(30836), // Rule ID 25435 //
     /*  30779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30818 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  30821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30834 */     GIR_RootConstrainSelectedInstOperands,
     /*  30835 */     // GIR_Coverage, 25435,
     /*  30835 */     GIR_EraseRootFromParent_Done,
     /*  30836 */   // Label 784: @30836
     /*  30836 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(30898), // Rule ID 18162 //
     /*  30841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30880 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30896 */     GIR_RootConstrainSelectedInstOperands,
     /*  30897 */     // GIR_Coverage, 18162,
     /*  30897 */     GIR_EraseRootFromParent_Done,
     /*  30898 */   // Label 785: @30898
     /*  30898 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(30960), // Rule ID 20027 //
     /*  30903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30922 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30925 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30929 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30942 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  30945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30958 */     GIR_RootConstrainSelectedInstOperands,
     /*  30959 */     // GIR_Coverage, 20027,
     /*  30959 */     GIR_EraseRootFromParent_Done,
     /*  30960 */   // Label 786: @30960
     /*  30960 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(30987), // Rule ID 18150 //
     /*  30965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30980 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  30980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30985 */     GIR_RootConstrainSelectedInstOperands,
     /*  30986 */     // GIR_Coverage, 18150,
     /*  30986 */     GIR_Done,
     /*  30987 */   // Label 787: @30987
     /*  30987 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(31014), // Rule ID 18174 //
     /*  30992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31007 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  31007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  31012 */     GIR_RootConstrainSelectedInstOperands,
     /*  31013 */     // GIR_Coverage, 18174,
     /*  31013 */     GIR_Done,
     /*  31014 */   // Label 788: @31014
     /*  31014 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(31041), // Rule ID 20019 //
     /*  31019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31034 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  31034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  31039 */     GIR_RootConstrainSelectedInstOperands,
     /*  31040 */     // GIR_Coverage, 20019,
     /*  31040 */     GIR_Done,
     /*  31041 */   // Label 789: @31041
     /*  31041 */   GIM_Reject,
     /*  31042 */ // Label 782: @31042
     /*  31042 */ GIM_Reject,
     /*  31043 */ // Label 672: @31043
     /*  31043 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(31508),
     /*  31048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  31051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  31054 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(31116), // Rule ID 24197 //
     /*  31059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31098 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31114 */     GIR_RootConstrainSelectedInstOperands,
     /*  31115 */     // GIR_Coverage, 24197,
     /*  31115 */     GIR_EraseRootFromParent_Done,
     /*  31116 */   // Label 791: @31116
     /*  31116 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(31178), // Rule ID 25235 //
     /*  31121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31136 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31160 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31165 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31176 */     GIR_RootConstrainSelectedInstOperands,
     /*  31177 */     // GIR_Coverage, 25235,
     /*  31177 */     GIR_EraseRootFromParent_Done,
     /*  31178 */   // Label 792: @31178
     /*  31178 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(31240), // Rule ID 25245 //
     /*  31183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31198 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31222 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31227 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31238 */     GIR_RootConstrainSelectedInstOperands,
     /*  31239 */     // GIR_Coverage, 25245,
     /*  31239 */     GIR_EraseRootFromParent_Done,
     /*  31240 */   // Label 793: @31240
     /*  31240 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(31302), // Rule ID 5779 //
     /*  31245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31284 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31289 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31300 */     GIR_RootConstrainSelectedInstOperands,
     /*  31301 */     // GIR_Coverage, 5779,
     /*  31301 */     GIR_EraseRootFromParent_Done,
     /*  31302 */   // Label 794: @31302
     /*  31302 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(31364), // Rule ID 18107 //
     /*  31307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31346 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31362 */     GIR_RootConstrainSelectedInstOperands,
     /*  31363 */     // GIR_Coverage, 18107,
     /*  31363 */     GIR_EraseRootFromParent_Done,
     /*  31364 */   // Label 795: @31364
     /*  31364 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(31426), // Rule ID 18136 //
     /*  31369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31408 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31424 */     GIR_RootConstrainSelectedInstOperands,
     /*  31425 */     // GIR_Coverage, 18136,
     /*  31425 */     GIR_EraseRootFromParent_Done,
     /*  31426 */   // Label 796: @31426
     /*  31426 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(31453), // Rule ID 5776 //
     /*  31431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31446 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  31446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /*  31451 */     GIR_RootConstrainSelectedInstOperands,
     /*  31452 */     // GIR_Coverage, 5776,
     /*  31452 */     GIR_Done,
     /*  31453 */   // Label 797: @31453
     /*  31453 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(31480), // Rule ID 18095 //
     /*  31458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31473 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  31478 */     GIR_RootConstrainSelectedInstOperands,
     /*  31479 */     // GIR_Coverage, 18095,
     /*  31479 */     GIR_Done,
     /*  31480 */   // Label 798: @31480
     /*  31480 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(31507), // Rule ID 18120 //
     /*  31485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31500 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  31505 */     GIR_RootConstrainSelectedInstOperands,
     /*  31506 */     // GIR_Coverage, 18120,
     /*  31506 */     GIR_Done,
     /*  31507 */   // Label 799: @31507
     /*  31507 */   GIM_Reject,
     /*  31508 */ // Label 790: @31508
     /*  31508 */ GIM_Reject,
     /*  31509 */ // Label 673: @31509
     /*  31509 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(31664),
     /*  31514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  31517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  31520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31524 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(31582), // Rule ID 24173 //
     /*  31529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31564 */     // (or:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31580 */     GIR_RootConstrainSelectedInstOperands,
     /*  31581 */     // GIR_Coverage, 24173,
     /*  31581 */     GIR_EraseRootFromParent_Done,
     /*  31582 */   // Label 801: @31582
     /*  31582 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(31640), // Rule ID 5743 //
     /*  31587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31602 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31605 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31609 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31622 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31629 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31638 */     GIR_RootConstrainSelectedInstOperands,
     /*  31639 */     // GIR_Coverage, 5743,
     /*  31639 */     GIR_EraseRootFromParent_Done,
     /*  31640 */   // Label 802: @31640
     /*  31640 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(31663), // Rule ID 5740 //
     /*  31645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31656 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  31656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  31661 */     GIR_RootConstrainSelectedInstOperands,
     /*  31662 */     // GIR_Coverage, 5740,
     /*  31662 */     GIR_Done,
     /*  31663 */   // Label 803: @31663
     /*  31663 */   GIM_Reject,
     /*  31664 */ // Label 800: @31664
     /*  31664 */ GIM_Reject,
     /*  31665 */ // Label 674: @31665
     /*  31665 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(31698), // Rule ID 4420 //
     /*  31670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  31676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  31679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31691 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  31691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  31696 */   GIR_RootConstrainSelectedInstOperands,
     /*  31697 */   // GIR_Coverage, 4420,
     /*  31697 */   GIR_Done,
     /*  31698 */ // Label 804: @31698
     /*  31698 */ GIM_Reject,
     /*  31699 */ // Label 675: @31699
     /*  31699 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(32040),
     /*  31704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31710 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(31772), // Rule ID 25254 //
     /*  31715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31754 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31759 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31770 */     GIR_RootConstrainSelectedInstOperands,
     /*  31771 */     // GIR_Coverage, 25254,
     /*  31771 */     GIR_EraseRootFromParent_Done,
     /*  31772 */   // Label 806: @31772
     /*  31772 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(31834), // Rule ID 25434 //
     /*  31777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31816 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31832 */     GIR_RootConstrainSelectedInstOperands,
     /*  31833 */     // GIR_Coverage, 25434,
     /*  31833 */     GIR_EraseRootFromParent_Done,
     /*  31834 */   // Label 807: @31834
     /*  31834 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(31896), // Rule ID 18161 //
     /*  31839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31878 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31894 */     GIR_RootConstrainSelectedInstOperands,
     /*  31895 */     // GIR_Coverage, 18161,
     /*  31895 */     GIR_EraseRootFromParent_Done,
     /*  31896 */   // Label 808: @31896
     /*  31896 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(31958), // Rule ID 20026 //
     /*  31901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31940 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31956 */     GIR_RootConstrainSelectedInstOperands,
     /*  31957 */     // GIR_Coverage, 20026,
     /*  31957 */     GIR_EraseRootFromParent_Done,
     /*  31958 */   // Label 809: @31958
     /*  31958 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(31985), // Rule ID 18149 //
     /*  31963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31978 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  31978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  31983 */     GIR_RootConstrainSelectedInstOperands,
     /*  31984 */     // GIR_Coverage, 18149,
     /*  31984 */     GIR_Done,
     /*  31985 */   // Label 810: @31985
     /*  31985 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(32012), // Rule ID 18173 //
     /*  31990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  31993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32005 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  32005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  32010 */     GIR_RootConstrainSelectedInstOperands,
     /*  32011 */     // GIR_Coverage, 18173,
     /*  32011 */     GIR_Done,
     /*  32012 */   // Label 811: @32012
     /*  32012 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(32039), // Rule ID 20018 //
     /*  32017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32032 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  32032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  32037 */     GIR_RootConstrainSelectedInstOperands,
     /*  32038 */     // GIR_Coverage, 20018,
     /*  32038 */     GIR_Done,
     /*  32039 */   // Label 812: @32039
     /*  32039 */   GIM_Reject,
     /*  32040 */ // Label 805: @32040
     /*  32040 */ GIM_Reject,
     /*  32041 */ // Label 676: @32041
     /*  32041 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(32506),
     /*  32046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  32049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  32052 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(32114), // Rule ID 25234 //
     /*  32057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32096 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32101 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32112 */     GIR_RootConstrainSelectedInstOperands,
     /*  32113 */     // GIR_Coverage, 25234,
     /*  32113 */     GIR_EraseRootFromParent_Done,
     /*  32114 */   // Label 814: @32114
     /*  32114 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(32176), // Rule ID 25244 //
     /*  32119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32158 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32163 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32174 */     GIR_RootConstrainSelectedInstOperands,
     /*  32175 */     // GIR_Coverage, 25244,
     /*  32175 */     GIR_EraseRootFromParent_Done,
     /*  32176 */   // Label 815: @32176
     /*  32176 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(32238), // Rule ID 25441 //
     /*  32181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32220 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32236 */     GIR_RootConstrainSelectedInstOperands,
     /*  32237 */     // GIR_Coverage, 25441,
     /*  32237 */     GIR_EraseRootFromParent_Done,
     /*  32238 */   // Label 816: @32238
     /*  32238 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(32300), // Rule ID 18106 //
     /*  32243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32282 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32298 */     GIR_RootConstrainSelectedInstOperands,
     /*  32299 */     // GIR_Coverage, 18106,
     /*  32299 */     GIR_EraseRootFromParent_Done,
     /*  32300 */   // Label 817: @32300
     /*  32300 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(32362), // Rule ID 18135 //
     /*  32305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32344 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32360 */     GIR_RootConstrainSelectedInstOperands,
     /*  32361 */     // GIR_Coverage, 18135,
     /*  32361 */     GIR_EraseRootFromParent_Done,
     /*  32362 */   // Label 818: @32362
     /*  32362 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(32424), // Rule ID 20043 //
     /*  32367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32406 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32422 */     GIR_RootConstrainSelectedInstOperands,
     /*  32423 */     // GIR_Coverage, 20043,
     /*  32423 */     GIR_EraseRootFromParent_Done,
     /*  32424 */   // Label 819: @32424
     /*  32424 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(32451), // Rule ID 18094 //
     /*  32429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32444 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  32449 */     GIR_RootConstrainSelectedInstOperands,
     /*  32450 */     // GIR_Coverage, 18094,
     /*  32450 */     GIR_Done,
     /*  32451 */   // Label 820: @32451
     /*  32451 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(32478), // Rule ID 18119 //
     /*  32456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32471 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  32476 */     GIR_RootConstrainSelectedInstOperands,
     /*  32477 */     // GIR_Coverage, 18119,
     /*  32477 */     GIR_Done,
     /*  32478 */   // Label 821: @32478
     /*  32478 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(32505), // Rule ID 20035 //
     /*  32483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32498 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  32498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  32503 */     GIR_RootConstrainSelectedInstOperands,
     /*  32504 */     // GIR_Coverage, 20035,
     /*  32504 */     GIR_Done,
     /*  32505 */   // Label 822: @32505
     /*  32505 */   GIM_Reject,
     /*  32506 */ // Label 813: @32506
     /*  32506 */ GIM_Reject,
     /*  32507 */ // Label 677: @32507
     /*  32507 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(32662),
     /*  32512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  32515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  32518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32522 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(32580), // Rule ID 24191 //
     /*  32527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32562 */     // (or:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32578 */     GIR_RootConstrainSelectedInstOperands,
     /*  32579 */     // GIR_Coverage, 24191,
     /*  32579 */     GIR_EraseRootFromParent_Done,
     /*  32580 */   // Label 824: @32580
     /*  32580 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(32638), // Rule ID 5770 //
     /*  32585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32620 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32636 */     GIR_RootConstrainSelectedInstOperands,
     /*  32637 */     // GIR_Coverage, 5770,
     /*  32637 */     GIR_EraseRootFromParent_Done,
     /*  32638 */   // Label 825: @32638
     /*  32638 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(32661), // Rule ID 5767 //
     /*  32643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32654 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  32654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /*  32659 */     GIR_RootConstrainSelectedInstOperands,
     /*  32660 */     // GIR_Coverage, 5767,
     /*  32660 */     GIR_Done,
     /*  32661 */   // Label 826: @32661
     /*  32661 */   GIM_Reject,
     /*  32662 */ // Label 823: @32662
     /*  32662 */ GIM_Reject,
     /*  32663 */ // Label 678: @32663
     /*  32663 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(32696), // Rule ID 4421 //
     /*  32668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  32671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  32674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  32677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32689 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  32689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /*  32694 */   GIR_RootConstrainSelectedInstOperands,
     /*  32695 */   // GIR_Coverage, 4421,
     /*  32695 */   GIR_Done,
     /*  32696 */ // Label 827: @32696
     /*  32696 */ GIM_Reject,
     /*  32697 */ // Label 679: @32697
     /*  32697 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(33162),
     /*  32702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  32705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  32708 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(32770), // Rule ID 25233 //
     /*  32713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32752 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32768 */     GIR_RootConstrainSelectedInstOperands,
     /*  32769 */     // GIR_Coverage, 25233,
     /*  32769 */     GIR_EraseRootFromParent_Done,
     /*  32770 */   // Label 829: @32770
     /*  32770 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(32832), // Rule ID 25243 //
     /*  32775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32814 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32830 */     GIR_RootConstrainSelectedInstOperands,
     /*  32831 */     // GIR_Coverage, 25243,
     /*  32831 */     GIR_EraseRootFromParent_Done,
     /*  32832 */   // Label 830: @32832
     /*  32832 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(32894), // Rule ID 25440 //
     /*  32837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32876 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32892 */     GIR_RootConstrainSelectedInstOperands,
     /*  32893 */     // GIR_Coverage, 25440,
     /*  32893 */     GIR_EraseRootFromParent_Done,
     /*  32894 */   // Label 831: @32894
     /*  32894 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(32956), // Rule ID 18105 //
     /*  32899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32938 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32943 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32954 */     GIR_RootConstrainSelectedInstOperands,
     /*  32955 */     // GIR_Coverage, 18105,
     /*  32955 */     GIR_EraseRootFromParent_Done,
     /*  32956 */   // Label 832: @32956
     /*  32956 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(33018), // Rule ID 18134 //
     /*  32961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33000 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  33003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33016 */     GIR_RootConstrainSelectedInstOperands,
     /*  33017 */     // GIR_Coverage, 18134,
     /*  33017 */     GIR_EraseRootFromParent_Done,
     /*  33018 */   // Label 833: @33018
     /*  33018 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(33080), // Rule ID 20042 //
     /*  33023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33062 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33078 */     GIR_RootConstrainSelectedInstOperands,
     /*  33079 */     // GIR_Coverage, 20042,
     /*  33079 */     GIR_EraseRootFromParent_Done,
     /*  33080 */   // Label 834: @33080
     /*  33080 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(33107), // Rule ID 18093 //
     /*  33085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33100 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  33105 */     GIR_RootConstrainSelectedInstOperands,
     /*  33106 */     // GIR_Coverage, 18093,
     /*  33106 */     GIR_Done,
     /*  33107 */   // Label 835: @33107
     /*  33107 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(33134), // Rule ID 18118 //
     /*  33112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33127 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  33132 */     GIR_RootConstrainSelectedInstOperands,
     /*  33133 */     // GIR_Coverage, 18118,
     /*  33133 */     GIR_Done,
     /*  33134 */   // Label 836: @33134
     /*  33134 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(33161), // Rule ID 20034 //
     /*  33139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33154 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  33154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  33159 */     GIR_RootConstrainSelectedInstOperands,
     /*  33160 */     // GIR_Coverage, 20034,
     /*  33160 */     GIR_Done,
     /*  33161 */   // Label 837: @33161
     /*  33161 */   GIM_Reject,
     /*  33162 */ // Label 828: @33162
     /*  33162 */ GIM_Reject,
     /*  33163 */ // Label 680: @33163
     /*  33163 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(33318),
     /*  33168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  33171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  33174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33178 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(33236), // Rule ID 25447 //
     /*  33183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33218 */     // (or:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33225 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33234 */     GIR_RootConstrainSelectedInstOperands,
     /*  33235 */     // GIR_Coverage, 25447,
     /*  33235 */     GIR_EraseRootFromParent_Done,
     /*  33236 */   // Label 839: @33236
     /*  33236 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(33294), // Rule ID 20059 //
     /*  33241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33276 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33292 */     GIR_RootConstrainSelectedInstOperands,
     /*  33293 */     // GIR_Coverage, 20059,
     /*  33293 */     GIR_EraseRootFromParent_Done,
     /*  33294 */   // Label 840: @33294
     /*  33294 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(33317), // Rule ID 20051 //
     /*  33299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33310 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  33310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33315 */     GIR_RootConstrainSelectedInstOperands,
     /*  33316 */     // GIR_Coverage, 20051,
     /*  33316 */     GIR_Done,
     /*  33317 */   // Label 841: @33317
     /*  33317 */   GIM_Reject,
     /*  33318 */ // Label 838: @33318
     /*  33318 */ GIM_Reject,
     /*  33319 */ // Label 681: @33319
     /*  33319 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(33352), // Rule ID 4422 //
     /*  33324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  33327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  33330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  33333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33345 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  33345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /*  33350 */   GIR_RootConstrainSelectedInstOperands,
     /*  33351 */   // GIR_Coverage, 4422,
     /*  33351 */   GIR_Done,
     /*  33352 */ // Label 842: @33352
     /*  33352 */ GIM_Reject,
     /*  33353 */ // Label 682: @33353
     /*  33353 */ GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(33508),
     /*  33358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  33361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  33364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33368 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(33426), // Rule ID 25446 //
     /*  33373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33384 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33391 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33408 */     // (or:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33413 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33424 */     GIR_RootConstrainSelectedInstOperands,
     /*  33425 */     // GIR_Coverage, 25446,
     /*  33425 */     GIR_EraseRootFromParent_Done,
     /*  33426 */   // Label 844: @33426
     /*  33426 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(33484), // Rule ID 20058 //
     /*  33431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33466 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33471 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33482 */     GIR_RootConstrainSelectedInstOperands,
     /*  33483 */     // GIR_Coverage, 20058,
     /*  33483 */     GIR_EraseRootFromParent_Done,
     /*  33484 */   // Label 845: @33484
     /*  33484 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(33507), // Rule ID 20050 //
     /*  33489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33500 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  33500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33505 */     GIR_RootConstrainSelectedInstOperands,
     /*  33506 */     // GIR_Coverage, 20050,
     /*  33506 */     GIR_Done,
     /*  33507 */   // Label 846: @33507
     /*  33507 */   GIM_Reject,
     /*  33508 */ // Label 843: @33508
     /*  33508 */ GIM_Reject,
     /*  33509 */ // Label 683: @33509
     /*  33509 */ GIM_Reject,
     /*  33510 */ // Label 5: @33510
     /*  33510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 870*/ GIMT_Encode4(46210),
     /*  33521 */ /*GILLT_s1*//*Label 847*/ GIMT_Encode4(33621),
     /*  33525 */ /*GILLT_s8*//*Label 848*/ GIMT_Encode4(34179),
     /*  33529 */ /*GILLT_s16*//*Label 849*/ GIMT_Encode4(34706),
     /*  33533 */ /*GILLT_s32*//*Label 850*/ GIMT_Encode4(35451),
     /*  33537 */ /*GILLT_s64*//*Label 851*/ GIMT_Encode4(36399), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  33549 */ /*GILLT_v2s1*//*Label 852*/ GIMT_Encode4(37306),
     /*  33553 */ /*GILLT_v2s64*//*Label 853*/ GIMT_Encode4(37848),
     /*  33557 */ /*GILLT_v4s1*//*Label 854*/ GIMT_Encode4(38468),
     /*  33561 */ /*GILLT_v4s32*//*Label 855*/ GIMT_Encode4(39010),
     /*  33565 */ /*GILLT_v4s64*//*Label 856*/ GIMT_Encode4(39630),
     /*  33569 */ /*GILLT_v8s1*//*Label 857*/ GIMT_Encode4(40374),
     /*  33573 */ /*GILLT_v8s16*//*Label 858*/ GIMT_Encode4(41172),
     /*  33577 */ /*GILLT_v8s32*//*Label 859*/ GIMT_Encode4(41792),
     /*  33581 */ /*GILLT_v8s64*//*Label 860*/ GIMT_Encode4(42536),
     /*  33585 */ /*GILLT_v16s1*//*Label 861*/ GIMT_Encode4(42734),
     /*  33589 */ /*GILLT_v16s8*//*Label 862*/ GIMT_Encode4(42992),
     /*  33593 */ /*GILLT_v16s16*//*Label 863*/ GIMT_Encode4(43612),
     /*  33597 */ /*GILLT_v16s32*//*Label 864*/ GIMT_Encode4(44356),
     /*  33601 */ /*GILLT_v32s1*//*Label 865*/ GIMT_Encode4(44554),
     /*  33605 */ /*GILLT_v32s8*//*Label 866*/ GIMT_Encode4(44812),
     /*  33609 */ /*GILLT_v32s16*//*Label 867*/ GIMT_Encode4(45556),
     /*  33613 */ /*GILLT_v64s1*//*Label 868*/ GIMT_Encode4(45754),
     /*  33617 */ /*GILLT_v64s8*//*Label 869*/ GIMT_Encode4(46012),
     /*  33621 */ // Label 847: @33621
     /*  33621 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(34178),
     /*  33626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  33629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  33632 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(33756), // Rule ID 25372 //
     /*  33637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33666 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33680 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33680 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33683 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33687 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33692 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  33696 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33713 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33755 */     // GIR_Coverage, 25372,
     /*  33755 */     GIR_EraseRootFromParent_Done,
     /*  33756 */   // Label 872: @33756
     /*  33756 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(33881), // Rule ID 19496 //
     /*  33761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  33795 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33805 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33805 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33808 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33812 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33817 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  33821 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33862 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33880 */     // GIR_Coverage, 19496,
     /*  33880 */     GIR_EraseRootFromParent_Done,
     /*  33881 */   // Label 873: @33881
     /*  33881 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(34005), // Rule ID 25373 //
     /*  33886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33919 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33929 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33929 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33932 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33936 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33941 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  33945 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34004 */     // GIR_Coverage, 25373,
     /*  34004 */     GIR_EraseRootFromParent_Done,
     /*  34005 */   // Label 874: @34005
     /*  34005 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(34084), // Rule ID 19482 //
     /*  34010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  34014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34022 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34028 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  34030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34032 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  34032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34044 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  34048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  34060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  34083 */     // GIR_Coverage, 19482,
     /*  34083 */     GIR_EraseRootFromParent_Done,
     /*  34084 */   // Label 875: @34084
     /*  34084 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(34177), // Rule ID 19500 //
     /*  34089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34101 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34101 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34104 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34108 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34113 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  34117 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  34138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  34150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34155 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34176 */     // GIR_Coverage, 19500,
     /*  34176 */     GIR_EraseRootFromParent_Done,
     /*  34177 */   // Label 876: @34177
     /*  34177 */   GIM_Reject,
     /*  34178 */ // Label 871: @34178
     /*  34178 */ GIM_Reject,
     /*  34179 */ // Label 848: @34179
     /*  34179 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(34705),
     /*  34184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  34187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  34190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34194 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(34250), // Rule ID 273 //
     /*  34199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34217 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34234 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] })  =>  (NOT8m_ND:{ *:[i8] } addr:{ *:[iPTR] }:$src1)
     /*  34234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m_ND),
     /*  34237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34248 */     GIR_RootConstrainSelectedInstOperands,
     /*  34249 */     // GIR_Coverage, 273,
     /*  34249 */     GIR_EraseRootFromParent_Done,
     /*  34250 */   // Label 878: @34250
     /*  34250 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(34311), // Rule ID 26065 //
     /*  34255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34273 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34290 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34295 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34309 */     GIR_RootConstrainSelectedInstOperands,
     /*  34310 */     // GIR_Coverage, 26065,
     /*  34310 */     GIR_EraseRootFromParent_Done,
     /*  34311 */   // Label 879: @34311
     /*  34311 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(34372), // Rule ID 26084 //
     /*  34316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34327 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34334 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34351 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34370 */     GIR_RootConstrainSelectedInstOperands,
     /*  34371 */     // GIR_Coverage, 26084,
     /*  34371 */     GIR_EraseRootFromParent_Done,
     /*  34372 */   // Label 880: @34372
     /*  34372 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(34433), // Rule ID 22842 //
     /*  34377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34392 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34399 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34412 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34417 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34419 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34431 */     GIR_RootConstrainSelectedInstOperands,
     /*  34432 */     // GIR_Coverage, 22842,
     /*  34432 */     GIR_EraseRootFromParent_Done,
     /*  34433 */   // Label 881: @34433
     /*  34433 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(34494), // Rule ID 22932 //
     /*  34438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34460 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34473 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34492 */     GIR_RootConstrainSelectedInstOperands,
     /*  34493 */     // GIR_Coverage, 22932,
     /*  34493 */     GIR_EraseRootFromParent_Done,
     /*  34494 */   // Label 882: @34494
     /*  34494 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(34522), // Rule ID 22599 //
     /*  34499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /*  34507 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /*  34507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  34510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  34517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34520 */     GIR_RootConstrainSelectedInstOperands,
     /*  34521 */     // GIR_Coverage, 22599,
     /*  34521 */     GIR_EraseRootFromParent_Done,
     /*  34522 */   // Label 883: @34522
     /*  34522 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(34547), // Rule ID 245 //
     /*  34527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34538 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /*  34541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34545 */     GIR_RootConstrainSelectedInstOperands,
     /*  34546 */     // GIR_Coverage, 245,
     /*  34546 */     GIR_EraseRootFromParent_Done,
     /*  34547 */   // Label 884: @34547
     /*  34547 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(34572), // Rule ID 253 //
     /*  34552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34563 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /*  34566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34570 */     GIR_RootConstrainSelectedInstOperands,
     /*  34571 */     // GIR_Coverage, 253,
     /*  34571 */     GIR_EraseRootFromParent_Done,
     /*  34572 */   // Label 885: @34572
     /*  34572 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(34609), // Rule ID 22846 //
     /*  34577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34592 */     // MIs[1] Operand 1
     /*  34592 */     // No operand predicates
     /*  34592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34594 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /*  34597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34607 */     GIR_RootConstrainSelectedInstOperands,
     /*  34608 */     // GIR_Coverage, 22846,
     /*  34608 */     GIR_EraseRootFromParent_Done,
     /*  34609 */   // Label 886: @34609
     /*  34609 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(34646), // Rule ID 22936 //
     /*  34614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34629 */     // MIs[1] Operand 1
     /*  34629 */     // No operand predicates
     /*  34629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34631 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /*  34634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34644 */     GIR_RootConstrainSelectedInstOperands,
     /*  34645 */     // GIR_Coverage, 22936,
     /*  34645 */     GIR_EraseRootFromParent_Done,
     /*  34646 */   // Label 887: @34646
     /*  34646 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(34675), // Rule ID 22838 //
     /*  34651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34662 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /*  34667 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34673 */     GIR_RootConstrainSelectedInstOperands,
     /*  34674 */     // GIR_Coverage, 22838,
     /*  34674 */     GIR_Done,
     /*  34675 */   // Label 888: @34675
     /*  34675 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(34704), // Rule ID 22928 //
     /*  34680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34691 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /*  34696 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34702 */     GIR_RootConstrainSelectedInstOperands,
     /*  34703 */     // GIR_Coverage, 22928,
     /*  34703 */     GIR_Done,
     /*  34704 */   // Label 889: @34704
     /*  34704 */   GIM_Reject,
     /*  34705 */ // Label 877: @34705
     /*  34705 */ GIM_Reject,
     /*  34706 */ // Label 849: @34706
     /*  34706 */ GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(35450),
     /*  34711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  34714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  34717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34721 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(34777), // Rule ID 274 //
     /*  34726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34740 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34744 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34761 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] })  =>  (NOT16m_ND:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /*  34761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m_ND),
     /*  34764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34775 */     GIR_RootConstrainSelectedInstOperands,
     /*  34776 */     // GIR_Coverage, 274,
     /*  34776 */     GIR_EraseRootFromParent_Done,
     /*  34777 */   // Label 891: @34777
     /*  34777 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(34838), // Rule ID 26066 //
     /*  34782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34793 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34796 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34800 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34817 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  34820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34836 */     GIR_RootConstrainSelectedInstOperands,
     /*  34837 */     // GIR_Coverage, 26066,
     /*  34837 */     GIR_EraseRootFromParent_Done,
     /*  34838 */   // Label 892: @34838
     /*  34838 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(34899), // Rule ID 26085 //
     /*  34843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34861 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34878 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  34881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34897 */     GIR_RootConstrainSelectedInstOperands,
     /*  34898 */     // GIR_Coverage, 26085,
     /*  34898 */     GIR_EraseRootFromParent_Done,
     /*  34899 */   // Label 893: @34899
     /*  34899 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(34960), // Rule ID 22843 //
     /*  34904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34919 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34922 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34926 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34939 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  34942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34958 */     GIR_RootConstrainSelectedInstOperands,
     /*  34959 */     // GIR_Coverage, 22843,
     /*  34959 */     GIR_EraseRootFromParent_Done,
     /*  34960 */   // Label 894: @34960
     /*  34960 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(35021), // Rule ID 22933 //
     /*  34965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34983 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34987 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35000 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  35003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35019 */     GIR_RootConstrainSelectedInstOperands,
     /*  35020 */     // GIR_Coverage, 22933,
     /*  35020 */     GIR_EraseRootFromParent_Done,
     /*  35021 */   // Label 895: @35021
     /*  35021 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(35063), // Rule ID 22600 //
     /*  35026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35030 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /*  35041 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /*  35041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  35044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35046 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35048 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /*  35058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35061 */     GIR_RootConstrainSelectedInstOperands,
     /*  35062 */     // GIR_Coverage, 22600,
     /*  35062 */     GIR_EraseRootFromParent_Done,
     /*  35063 */   // Label 896: @35063
     /*  35063 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(35165), // Rule ID 26038 //
     /*  35068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35084 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35099 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35125 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35163 */     GIR_RootConstrainSelectedInstOperands,
     /*  35164 */     // GIR_Coverage, 26038,
     /*  35164 */     GIR_EraseRootFromParent_Done,
     /*  35165 */   // Label 897: @35165
     /*  35165 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(35267), // Rule ID 22776 //
     /*  35170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35190 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35201 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35227 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35234 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35265 */     GIR_RootConstrainSelectedInstOperands,
     /*  35266 */     // GIR_Coverage, 22776,
     /*  35266 */     GIR_EraseRootFromParent_Done,
     /*  35267 */   // Label 898: @35267
     /*  35267 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(35292), // Rule ID 246 //
     /*  35272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35283 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /*  35286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35288 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35290 */     GIR_RootConstrainSelectedInstOperands,
     /*  35291 */     // GIR_Coverage, 246,
     /*  35291 */     GIR_EraseRootFromParent_Done,
     /*  35292 */   // Label 899: @35292
     /*  35292 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(35317), // Rule ID 254 //
     /*  35297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35308 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /*  35311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35315 */     GIR_RootConstrainSelectedInstOperands,
     /*  35316 */     // GIR_Coverage, 254,
     /*  35316 */     GIR_EraseRootFromParent_Done,
     /*  35317 */   // Label 900: @35317
     /*  35317 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(35354), // Rule ID 22847 //
     /*  35322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35337 */     // MIs[1] Operand 1
     /*  35337 */     // No operand predicates
     /*  35337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35339 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /*  35342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35352 */     GIR_RootConstrainSelectedInstOperands,
     /*  35353 */     // GIR_Coverage, 22847,
     /*  35353 */     GIR_EraseRootFromParent_Done,
     /*  35354 */   // Label 901: @35354
     /*  35354 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(35391), // Rule ID 22937 //
     /*  35359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35374 */     // MIs[1] Operand 1
     /*  35374 */     // No operand predicates
     /*  35374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35376 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /*  35379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35389 */     GIR_RootConstrainSelectedInstOperands,
     /*  35390 */     // GIR_Coverage, 22937,
     /*  35390 */     GIR_EraseRootFromParent_Done,
     /*  35391 */   // Label 902: @35391
     /*  35391 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(35420), // Rule ID 22839 //
     /*  35396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35407 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /*  35412 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35418 */     GIR_RootConstrainSelectedInstOperands,
     /*  35419 */     // GIR_Coverage, 22839,
     /*  35419 */     GIR_Done,
     /*  35420 */   // Label 903: @35420
     /*  35420 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(35449), // Rule ID 22929 //
     /*  35425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35436 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /*  35441 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35447 */     GIR_RootConstrainSelectedInstOperands,
     /*  35448 */     // GIR_Coverage, 22929,
     /*  35448 */     GIR_Done,
     /*  35449 */   // Label 904: @35449
     /*  35449 */   GIM_Reject,
     /*  35450 */ // Label 890: @35450
     /*  35450 */ GIM_Reject,
     /*  35451 */ // Label 850: @35451
     /*  35451 */ GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(36398),
     /*  35456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35459 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(35522), // Rule ID 275 //
     /*  35464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35489 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35506 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] })  =>  (NOT32m_ND:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  35506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m_ND),
     /*  35509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  35515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35520 */     GIR_RootConstrainSelectedInstOperands,
     /*  35521 */     // GIR_Coverage, 275,
     /*  35521 */     GIR_EraseRootFromParent_Done,
     /*  35522 */   // Label 906: @35522
     /*  35522 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(35590), // Rule ID 26067 //
     /*  35527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35548 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35552 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35569 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35588 */     GIR_RootConstrainSelectedInstOperands,
     /*  35589 */     // GIR_Coverage, 26067,
     /*  35589 */     GIR_EraseRootFromParent_Done,
     /*  35590 */   // Label 907: @35590
     /*  35590 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(35658), // Rule ID 26086 //
     /*  35595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35620 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35637 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35642 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35656 */     GIR_RootConstrainSelectedInstOperands,
     /*  35657 */     // GIR_Coverage, 26086,
     /*  35657 */     GIR_EraseRootFromParent_Done,
     /*  35658 */   // Label 908: @35658
     /*  35658 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(35726), // Rule ID 22844 //
     /*  35663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35705 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35724 */     GIR_RootConstrainSelectedInstOperands,
     /*  35725 */     // GIR_Coverage, 22844,
     /*  35725 */     GIR_EraseRootFromParent_Done,
     /*  35726 */   // Label 909: @35726
     /*  35726 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(35794), // Rule ID 22934 //
     /*  35731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35756 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35760 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35773 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35792 */     GIR_RootConstrainSelectedInstOperands,
     /*  35793 */     // GIR_Coverage, 22934,
     /*  35793 */     GIR_EraseRootFromParent_Done,
     /*  35794 */   // Label 910: @35794
     /*  35794 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(35843), // Rule ID 22601 //
     /*  35799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35810 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /*  35821 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /*  35821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  35824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35826 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35828 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  35838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35841 */     GIR_RootConstrainSelectedInstOperands,
     /*  35842 */     // GIR_Coverage, 22601,
     /*  35842 */     GIR_EraseRootFromParent_Done,
     /*  35843 */   // Label 911: @35843
     /*  35843 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(35901), // Rule ID 24997 //
     /*  35848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  35851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  35863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35876 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  35880 */     // MIs[0] src
     /*  35880 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35887 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  35887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  35890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  35896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35899 */     GIR_RootConstrainSelectedInstOperands,
     /*  35900 */     // GIR_Coverage, 24997,
     /*  35900 */     GIR_EraseRootFromParent_Done,
     /*  35901 */   // Label 912: @35901
     /*  35901 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(36010), // Rule ID 26044 //
     /*  35906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35929 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35944 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  35947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  35961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  35985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  35990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  35998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36008 */     GIR_RootConstrainSelectedInstOperands,
     /*  36009 */     // GIR_Coverage, 26044,
     /*  36009 */     GIR_EraseRootFromParent_Done,
     /*  36010 */   // Label 913: @36010
     /*  36010 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(36064), // Rule ID 17358 //
     /*  36015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36041 */     // MIs[1] src
     /*  36041 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36046 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36052 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36062 */     GIR_RootConstrainSelectedInstOperands,
     /*  36063 */     // GIR_Coverage, 17358,
     /*  36063 */     GIR_EraseRootFromParent_Done,
     /*  36064 */   // Label 914: @36064
     /*  36064 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(36173), // Rule ID 22782 //
     /*  36069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36096 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36107 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36171 */     GIR_RootConstrainSelectedInstOperands,
     /*  36172 */     // GIR_Coverage, 22782,
     /*  36172 */     GIR_EraseRootFromParent_Done,
     /*  36173 */   // Label 915: @36173
     /*  36173 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(36205), // Rule ID 247 //
     /*  36178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36196 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /*  36199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36203 */     GIR_RootConstrainSelectedInstOperands,
     /*  36204 */     // GIR_Coverage, 247,
     /*  36204 */     GIR_EraseRootFromParent_Done,
     /*  36205 */   // Label 916: @36205
     /*  36205 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(36237), // Rule ID 255 //
     /*  36210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36228 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /*  36231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36233 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36235 */     GIR_RootConstrainSelectedInstOperands,
     /*  36236 */     // GIR_Coverage, 255,
     /*  36236 */     GIR_EraseRootFromParent_Done,
     /*  36237 */   // Label 917: @36237
     /*  36237 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(36281), // Rule ID 22848 //
     /*  36242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36264 */     // MIs[1] Operand 1
     /*  36264 */     // No operand predicates
     /*  36264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36266 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /*  36269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36279 */     GIR_RootConstrainSelectedInstOperands,
     /*  36280 */     // GIR_Coverage, 22848,
     /*  36280 */     GIR_EraseRootFromParent_Done,
     /*  36281 */   // Label 918: @36281
     /*  36281 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(36325), // Rule ID 22938 //
     /*  36286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36308 */     // MIs[1] Operand 1
     /*  36308 */     // No operand predicates
     /*  36308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36310 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /*  36313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36315 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36323 */     GIR_RootConstrainSelectedInstOperands,
     /*  36324 */     // GIR_Coverage, 22938,
     /*  36324 */     GIR_EraseRootFromParent_Done,
     /*  36325 */   // Label 919: @36325
     /*  36325 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(36361), // Rule ID 22840 //
     /*  36330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36348 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /*  36353 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36359 */     GIR_RootConstrainSelectedInstOperands,
     /*  36360 */     // GIR_Coverage, 22840,
     /*  36360 */     GIR_Done,
     /*  36361 */   // Label 920: @36361
     /*  36361 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(36397), // Rule ID 22930 //
     /*  36366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36384 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /*  36389 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36395 */     GIR_RootConstrainSelectedInstOperands,
     /*  36396 */     // GIR_Coverage, 22930,
     /*  36396 */     GIR_Done,
     /*  36397 */   // Label 921: @36397
     /*  36397 */   GIM_Reject,
     /*  36398 */ // Label 905: @36398
     /*  36398 */ GIM_Reject,
     /*  36399 */ // Label 851: @36399
     /*  36399 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(37305),
     /*  36404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36407 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(36470), // Rule ID 276 //
     /*  36412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36454 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] })  =>  (NOT64m_ND:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /*  36454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m_ND),
     /*  36457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  36463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36468 */     GIR_RootConstrainSelectedInstOperands,
     /*  36469 */     // GIR_Coverage, 276,
     /*  36469 */     GIR_EraseRootFromParent_Done,
     /*  36470 */   // Label 923: @36470
     /*  36470 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(36538), // Rule ID 26068 //
     /*  36475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36493 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36517 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36536 */     GIR_RootConstrainSelectedInstOperands,
     /*  36537 */     // GIR_Coverage, 26068,
     /*  36537 */     GIR_EraseRootFromParent_Done,
     /*  36538 */   // Label 924: @36538
     /*  36538 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(36606), // Rule ID 26087 //
     /*  36543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36585 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36590 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36604 */     GIR_RootConstrainSelectedInstOperands,
     /*  36605 */     // GIR_Coverage, 26087,
     /*  36605 */     GIR_EraseRootFromParent_Done,
     /*  36606 */   // Label 925: @36606
     /*  36606 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(36674), // Rule ID 22845 //
     /*  36611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36633 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36640 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36653 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36672 */     GIR_RootConstrainSelectedInstOperands,
     /*  36673 */     // GIR_Coverage, 22845,
     /*  36673 */     GIR_EraseRootFromParent_Done,
     /*  36674 */   // Label 926: @36674
     /*  36674 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(36742), // Rule ID 22935 //
     /*  36679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36701 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36708 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36721 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36726 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36728 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36740 */     GIR_RootConstrainSelectedInstOperands,
     /*  36741 */     // GIR_Coverage, 22935,
     /*  36741 */     GIR_EraseRootFromParent_Done,
     /*  36742 */   // Label 927: @36742
     /*  36742 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(36800), // Rule ID 24998 //
     /*  36747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36775 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36779 */     // MIs[0] src
     /*  36779 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36786 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  36789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  36795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36798 */     GIR_RootConstrainSelectedInstOperands,
     /*  36799 */     // GIR_Coverage, 24998,
     /*  36799 */     GIR_EraseRootFromParent_Done,
     /*  36800 */   // Label 928: @36800
     /*  36800 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(36909), // Rule ID 26050 //
     /*  36805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36828 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36843 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36869 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36876 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  36884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  36889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  36897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36899 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36907 */     GIR_RootConstrainSelectedInstOperands,
     /*  36908 */     // GIR_Coverage, 26050,
     /*  36908 */     GIR_EraseRootFromParent_Done,
     /*  36909 */   // Label 929: @36909
     /*  36909 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(36963), // Rule ID 17359 //
     /*  36914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36940 */     // MIs[1] src
     /*  36940 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36945 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36951 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  36954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36961 */     GIR_RootConstrainSelectedInstOperands,
     /*  36962 */     // GIR_Coverage, 17359,
     /*  36962 */     GIR_EraseRootFromParent_Done,
     /*  36963 */   // Label 930: @36963
     /*  36963 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37072), // Rule ID 22788 //
     /*  36968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  37004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37006 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  37006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37070 */     GIR_RootConstrainSelectedInstOperands,
     /*  37071 */     // GIR_Coverage, 22788,
     /*  37071 */     GIR_EraseRootFromParent_Done,
     /*  37072 */   // Label 931: @37072
     /*  37072 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(37104), // Rule ID 248 //
     /*  37077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37095 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /*  37098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37102 */     GIR_RootConstrainSelectedInstOperands,
     /*  37103 */     // GIR_Coverage, 248,
     /*  37103 */     GIR_EraseRootFromParent_Done,
     /*  37104 */   // Label 932: @37104
     /*  37104 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37136), // Rule ID 256 //
     /*  37109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  37112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37127 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /*  37130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37134 */     GIR_RootConstrainSelectedInstOperands,
     /*  37135 */     // GIR_Coverage, 256,
     /*  37135 */     GIR_EraseRootFromParent_Done,
     /*  37136 */   // Label 933: @37136
     /*  37136 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(37184), // Rule ID 22849 //
     /*  37141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37167 */     // MIs[1] Operand 1
     /*  37167 */     // No operand predicates
     /*  37167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37169 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /*  37172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37174 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37182 */     GIR_RootConstrainSelectedInstOperands,
     /*  37183 */     // GIR_Coverage, 22849,
     /*  37183 */     GIR_EraseRootFromParent_Done,
     /*  37184 */   // Label 934: @37184
     /*  37184 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(37232), // Rule ID 22939 //
     /*  37189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37215 */     // MIs[1] Operand 1
     /*  37215 */     // No operand predicates
     /*  37215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37217 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /*  37220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37230 */     GIR_RootConstrainSelectedInstOperands,
     /*  37231 */     // GIR_Coverage, 22939,
     /*  37231 */     GIR_EraseRootFromParent_Done,
     /*  37232 */   // Label 935: @37232
     /*  37232 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(37268), // Rule ID 22841 //
     /*  37237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37255 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /*  37260 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37266 */     GIR_RootConstrainSelectedInstOperands,
     /*  37267 */     // GIR_Coverage, 22841,
     /*  37267 */     GIR_Done,
     /*  37268 */   // Label 936: @37268
     /*  37268 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(37304), // Rule ID 22931 //
     /*  37273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37291 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /*  37296 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37302 */     GIR_RootConstrainSelectedInstOperands,
     /*  37303 */     // GIR_Coverage, 22931,
     /*  37303 */     GIR_Done,
     /*  37304 */   // Label 937: @37304
     /*  37304 */   GIM_Reject,
     /*  37305 */ // Label 922: @37305
     /*  37305 */ GIM_Reject,
     /*  37306 */ // Label 852: @37306
     /*  37306 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(37847),
     /*  37311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37321 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(37441), // Rule ID 25374 //
     /*  37326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37351 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37365 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37365 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37368 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37372 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37377 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37381 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37386 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37389 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37393 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37398 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37402 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37440 */     // GIR_Coverage, 25374,
     /*  37440 */     GIR_EraseRootFromParent_Done,
     /*  37441 */   // Label 939: @37441
     /*  37441 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(37562), // Rule ID 19497 //
     /*  37446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  37476 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37482 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37486 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37486 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37489 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37493 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37498 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37502 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37507 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37510 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37514 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37519 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37523 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37540 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37561 */     // GIR_Coverage, 19497,
     /*  37561 */     GIR_EraseRootFromParent_Done,
     /*  37562 */   // Label 940: @37562
     /*  37562 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(37682), // Rule ID 25375 //
     /*  37567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37596 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37606 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37606 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37609 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37613 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37618 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  37622 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37663 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37681 */     // GIR_Coverage, 25375,
     /*  37681 */     GIR_EraseRootFromParent_Done,
     /*  37682 */   // Label 941: @37682
     /*  37682 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(37757), // Rule ID 19481 //
     /*  37687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37701 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  37703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37705 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  37721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  37733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37756 */     // GIR_Coverage, 19481,
     /*  37756 */     GIR_EraseRootFromParent_Done,
     /*  37757 */   // Label 942: @37757
     /*  37757 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(37846), // Rule ID 19501 //
     /*  37762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37770 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37782 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37786 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37791 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37794 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37798 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  37807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  37819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37824 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37845 */     // GIR_Coverage, 19501,
     /*  37845 */     GIR_EraseRootFromParent_Done,
     /*  37846 */   // Label 943: @37846
     /*  37846 */   GIM_Reject,
     /*  37847 */ // Label 938: @37847
     /*  37847 */ GIM_Reject,
     /*  37848 */ // Label 853: @37848
     /*  37848 */ GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(38467),
     /*  37853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  37859 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(37921), // Rule ID 23366 //
     /*  37864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  37867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37879 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  37882 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  37886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  37890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  37903 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  37903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  37906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37908 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  37914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  37919 */     GIR_RootConstrainSelectedInstOperands,
     /*  37920 */     // GIR_Coverage, 23366,
     /*  37920 */     GIR_EraseRootFromParent_Done,
     /*  37921 */   // Label 945: @37921
     /*  37921 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(37983), // Rule ID 24221 //
     /*  37926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  37929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  37933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  37944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  37948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  37952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  37956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  37965 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  37965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  37968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37970 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  37976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  37981 */     GIR_RootConstrainSelectedInstOperands,
     /*  37982 */     // GIR_Coverage, 24221,
     /*  37982 */     GIR_EraseRootFromParent_Done,
     /*  37983 */   // Label 946: @37983
     /*  37983 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(38045), // Rule ID 2123 //
     /*  37988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  37991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38007 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38014 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38027 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38034 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38043 */     GIR_RootConstrainSelectedInstOperands,
     /*  38044 */     // GIR_Coverage, 2123,
     /*  38044 */     GIR_EraseRootFromParent_Done,
     /*  38045 */   // Label 947: @38045
     /*  38045 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(38107), // Rule ID 5815 //
     /*  38050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38089 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38094 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38096 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38105 */     GIR_RootConstrainSelectedInstOperands,
     /*  38106 */     // GIR_Coverage, 5815,
     /*  38106 */     GIR_EraseRootFromParent_Done,
     /*  38107 */   // Label 948: @38107
     /*  38107 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(38339), // Rule ID 21946 //
     /*  38112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  38115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  38119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38127 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38137 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  38137 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  38140 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38144 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  38151 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  38154 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38158 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38163 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  38166 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38170 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  38173 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38178 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38183 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38188 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  38191 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38195 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  38202 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  38205 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38209 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38214 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  38217 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38221 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  38224 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38229 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38234 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38239 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  38242 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38246 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  38256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38265 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38272 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  38275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  38293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  38297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38302 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38305 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  38308 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  38311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  38314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  38328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  38333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38338 */     // GIR_Coverage, 21946,
     /*  38338 */     GIR_EraseRootFromParent_Done,
     /*  38339 */   // Label 949: @38339
     /*  38339 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(38385), // Rule ID 21954 //
     /*  38344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  38347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38359 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38365 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38369 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /*  38369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  38372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  38383 */     GIR_RootConstrainSelectedInstOperands,
     /*  38384 */     // GIR_Coverage, 21954,
     /*  38384 */     GIR_EraseRootFromParent_Done,
     /*  38385 */   // Label 950: @38385
     /*  38385 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(38412), // Rule ID 2122 //
     /*  38390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38405 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  38410 */     GIR_RootConstrainSelectedInstOperands,
     /*  38411 */     // GIR_Coverage, 2122,
     /*  38411 */     GIR_Done,
     /*  38412 */   // Label 951: @38412
     /*  38412 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(38439), // Rule ID 2124 //
     /*  38417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  38420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38432 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  38437 */     GIR_RootConstrainSelectedInstOperands,
     /*  38438 */     // GIR_Coverage, 2124,
     /*  38438 */     GIR_Done,
     /*  38439 */   // Label 952: @38439
     /*  38439 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(38466), // Rule ID 5812 //
     /*  38444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38459 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  38459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  38464 */     GIR_RootConstrainSelectedInstOperands,
     /*  38465 */     // GIR_Coverage, 5812,
     /*  38465 */     GIR_Done,
     /*  38466 */   // Label 953: @38466
     /*  38466 */   GIM_Reject,
     /*  38467 */ // Label 944: @38467
     /*  38467 */ GIM_Reject,
     /*  38468 */ // Label 854: @38468
     /*  38468 */ GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(39009),
     /*  38473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38483 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(38603), // Rule ID 25376 //
     /*  38488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38513 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38527 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38539 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38543 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38551 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38555 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38560 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38602 */     // GIR_Coverage, 25376,
     /*  38602 */     GIR_EraseRootFromParent_Done,
     /*  38603 */   // Label 955: @38603
     /*  38603 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(38724), // Rule ID 19498 //
     /*  38608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  38638 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38644 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38648 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38660 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  38664 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38702 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38723 */     // GIR_Coverage, 19498,
     /*  38723 */     GIR_EraseRootFromParent_Done,
     /*  38724 */   // Label 956: @38724
     /*  38724 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(38844), // Rule ID 25377 //
     /*  38729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38758 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38768 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38768 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38771 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38775 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38780 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  38784 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38801 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38843 */     // GIR_Coverage, 25377,
     /*  38843 */     GIR_EraseRootFromParent_Done,
     /*  38844 */   // Label 957: @38844
     /*  38844 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(38919), // Rule ID 19480 //
     /*  38849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38857 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38863 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38867 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38867 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38870 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38874 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38879 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  38895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38918 */     // GIR_Coverage, 19480,
     /*  38918 */     GIR_EraseRootFromParent_Done,
     /*  38919 */   // Label 958: @38919
     /*  38919 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(39008), // Rule ID 19502 //
     /*  38924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38932 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38932 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38935 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38939 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38944 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38948 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38953 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38956 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38960 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38965 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  38969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  38981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39007 */     // GIR_Coverage, 19502,
     /*  39007 */     GIR_EraseRootFromParent_Done,
     /*  39008 */   // Label 959: @39008
     /*  39008 */   GIM_Reject,
     /*  39009 */ // Label 954: @39009
     /*  39009 */ GIM_Reject,
     /*  39010 */ // Label 855: @39010
     /*  39010 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(39629),
     /*  39015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39021 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(39083), // Rule ID 24239 //
     /*  39026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39041 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39048 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39065 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39081 */     GIR_RootConstrainSelectedInstOperands,
     /*  39082 */     // GIR_Coverage, 24239,
     /*  39082 */     GIR_EraseRootFromParent_Done,
     /*  39083 */   // Label 961: @39083
     /*  39083 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(39145), // Rule ID 25259 //
     /*  39088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39103 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39110 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39127 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39132 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39143 */     GIR_RootConstrainSelectedInstOperands,
     /*  39144 */     // GIR_Coverage, 25259,
     /*  39144 */     GIR_EraseRootFromParent_Done,
     /*  39145 */   // Label 962: @39145
     /*  39145 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(39207), // Rule ID 5842 //
     /*  39150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39189 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39205 */     GIR_RootConstrainSelectedInstOperands,
     /*  39206 */     // GIR_Coverage, 5842,
     /*  39206 */     GIR_EraseRootFromParent_Done,
     /*  39207 */   // Label 963: @39207
     /*  39207 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(39269), // Rule ID 18166 //
     /*  39212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39231 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39238 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39251 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39256 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39267 */     GIR_RootConstrainSelectedInstOperands,
     /*  39268 */     // GIR_Coverage, 18166,
     /*  39268 */     GIR_EraseRootFromParent_Done,
     /*  39269 */   // Label 964: @39269
     /*  39269 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(39501), // Rule ID 21945 //
     /*  39274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  39277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  39281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39289 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39295 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39299 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  39299 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  39302 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39306 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  39313 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  39316 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39320 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39325 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  39328 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39332 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  39335 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39340 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39345 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39350 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  39353 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39357 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  39364 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  39367 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39371 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39376 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  39379 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39383 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  39386 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39391 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39396 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39401 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  39404 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39408 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  39418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39427 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39430 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39434 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  39437 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  39455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  39459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39464 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  39470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  39473 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  39476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39483 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  39490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  39495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39500 */     // GIR_Coverage, 21945,
     /*  39500 */     GIR_EraseRootFromParent_Done,
     /*  39501 */   // Label 965: @39501
     /*  39501 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(39547), // Rule ID 21953 //
     /*  39506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  39509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39531 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /*  39531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  39534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39538 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39540 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  39545 */     GIR_RootConstrainSelectedInstOperands,
     /*  39546 */     // GIR_Coverage, 21953,
     /*  39546 */     GIR_EraseRootFromParent_Done,
     /*  39547 */   // Label 966: @39547
     /*  39547 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(39574), // Rule ID 5839 //
     /*  39552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39567 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  39567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /*  39572 */     GIR_RootConstrainSelectedInstOperands,
     /*  39573 */     // GIR_Coverage, 5839,
     /*  39573 */     GIR_Done,
     /*  39574 */   // Label 967: @39574
     /*  39574 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(39601), // Rule ID 18154 //
     /*  39579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39594 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  39599 */     GIR_RootConstrainSelectedInstOperands,
     /*  39600 */     // GIR_Coverage, 18154,
     /*  39600 */     GIR_Done,
     /*  39601 */   // Label 968: @39601
     /*  39601 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(39628), // Rule ID 18178 //
     /*  39606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  39609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39621 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  39626 */     GIR_RootConstrainSelectedInstOperands,
     /*  39627 */     // GIR_Coverage, 18178,
     /*  39627 */     GIR_Done,
     /*  39628 */   // Label 969: @39628
     /*  39628 */   GIM_Reject,
     /*  39629 */ // Label 960: @39629
     /*  39629 */ GIM_Reject,
     /*  39630 */ // Label 856: @39630
     /*  39630 */ GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(40373),
     /*  39635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  39638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  39641 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(39703), // Rule ID 23368 //
     /*  39646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39685 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39690 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39701 */     GIR_RootConstrainSelectedInstOperands,
     /*  39702 */     // GIR_Coverage, 23368,
     /*  39702 */     GIR_EraseRootFromParent_Done,
     /*  39703 */   // Label 971: @39703
     /*  39703 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(39765), // Rule ID 24215 //
     /*  39708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39747 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39752 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39763 */     GIR_RootConstrainSelectedInstOperands,
     /*  39764 */     // GIR_Coverage, 24215,
     /*  39764 */     GIR_EraseRootFromParent_Done,
     /*  39765 */   // Label 972: @39765
     /*  39765 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(39827), // Rule ID 25250 //
     /*  39770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39809 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  39812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39825 */     GIR_RootConstrainSelectedInstOperands,
     /*  39826 */     // GIR_Coverage, 25250,
     /*  39826 */     GIR_EraseRootFromParent_Done,
     /*  39827 */   // Label 973: @39827
     /*  39827 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(39889), // Rule ID 2127 //
     /*  39832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39871 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39876 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39887 */     GIR_RootConstrainSelectedInstOperands,
     /*  39888 */     // GIR_Coverage, 2127,
     /*  39888 */     GIR_EraseRootFromParent_Done,
     /*  39889 */   // Label 974: @39889
     /*  39889 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(39951), // Rule ID 5806 //
     /*  39894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39933 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39949 */     GIR_RootConstrainSelectedInstOperands,
     /*  39950 */     // GIR_Coverage, 5806,
     /*  39950 */     GIR_EraseRootFromParent_Done,
     /*  39951 */   // Label 975: @39951
     /*  39951 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(40013), // Rule ID 18141 //
     /*  39956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39995 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  39998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40011 */     GIR_RootConstrainSelectedInstOperands,
     /*  40012 */     // GIR_Coverage, 18141,
     /*  40012 */     GIR_EraseRootFromParent_Done,
     /*  40013 */   // Label 976: @40013
     /*  40013 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(40245), // Rule ID 21950 //
     /*  40018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  40021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40033 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40043 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  40043 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  40046 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40050 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  40057 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  40060 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40064 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40069 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  40072 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40076 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  40079 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40084 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40089 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40094 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  40097 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40101 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  40108 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  40111 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40115 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40120 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  40123 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40127 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  40130 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40135 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40140 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40145 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  40148 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40152 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  40162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40171 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40174 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40178 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  40181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  40199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  40203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40208 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40211 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  40214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  40217 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  40220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  40234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40244 */     // GIR_Coverage, 21950,
     /*  40244 */     GIR_EraseRootFromParent_Done,
     /*  40245 */   // Label 977: @40245
     /*  40245 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(40291), // Rule ID 21958 //
     /*  40250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  40253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40265 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40275 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /*  40275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  40278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40280 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  40289 */     GIR_RootConstrainSelectedInstOperands,
     /*  40290 */     // GIR_Coverage, 21958,
     /*  40290 */     GIR_EraseRootFromParent_Done,
     /*  40291 */   // Label 978: @40291
     /*  40291 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(40318), // Rule ID 2126 //
     /*  40296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40311 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  40316 */     GIR_RootConstrainSelectedInstOperands,
     /*  40317 */     // GIR_Coverage, 2126,
     /*  40317 */     GIR_Done,
     /*  40318 */   // Label 979: @40318
     /*  40318 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(40345), // Rule ID 5803 //
     /*  40323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40338 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  40338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  40343 */     GIR_RootConstrainSelectedInstOperands,
     /*  40344 */     // GIR_Coverage, 5803,
     /*  40344 */     GIR_Done,
     /*  40345 */   // Label 980: @40345
     /*  40345 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(40372), // Rule ID 18125 //
     /*  40350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40365 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  40370 */     GIR_RootConstrainSelectedInstOperands,
     /*  40371 */     // GIR_Coverage, 18125,
     /*  40371 */     GIR_Done,
     /*  40372 */   // Label 981: @40372
     /*  40372 */   GIM_Reject,
     /*  40373 */ // Label 970: @40373
     /*  40373 */ GIM_Reject,
     /*  40374 */ // Label 857: @40374
     /*  40374 */ GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(41171),
     /*  40379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40389 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(40449), // Rule ID 23684 //
     /*  40394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40436 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  40447 */     GIR_RootConstrainSelectedInstOperands,
     /*  40448 */     // GIR_Coverage, 23684,
     /*  40448 */     GIR_EraseRootFromParent_Done,
     /*  40449 */   // Label 983: @40449
     /*  40449 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(40572), // Rule ID 25370 //
     /*  40454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40482 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40496 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40508 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  40512 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40529 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40550 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40553 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40571 */     // GIR_Coverage, 25370,
     /*  40571 */     GIR_EraseRootFromParent_Done,
     /*  40572 */   // Label 984: @40572
     /*  40572 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(40635), // Rule ID 4423 //
     /*  40577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40610 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40620 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40633 */     GIR_RootConstrainSelectedInstOperands,
     /*  40634 */     // GIR_Coverage, 4423,
     /*  40634 */     GIR_EraseRootFromParent_Done,
     /*  40635 */   // Label 985: @40635
     /*  40635 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(40759), // Rule ID 19495 //
     /*  40640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40673 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40683 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40695 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40699 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40704 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40707 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40711 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40716 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40720 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40758 */     // GIR_Coverage, 19495,
     /*  40758 */     GIR_EraseRootFromParent_Done,
     /*  40759 */   // Label 986: @40759
     /*  40759 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(40819), // Rule ID 23685 //
     /*  40764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40796 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40806 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  40817 */     GIR_RootConstrainSelectedInstOperands,
     /*  40818 */     // GIR_Coverage, 23685,
     /*  40818 */     GIR_EraseRootFromParent_Done,
     /*  40819 */   // Label 987: @40819
     /*  40819 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(40942), // Rule ID 25371 //
     /*  40824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40856 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40866 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40866 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40869 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40873 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40878 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  40882 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40923 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40941 */     // GIR_Coverage, 25371,
     /*  40941 */     GIR_EraseRootFromParent_Done,
     /*  40942 */   // Label 988: @40942
     /*  40942 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(40977), // Rule ID 4411 //
     /*  40947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40958 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40968 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /*  40968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /*  40971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40975 */     GIR_RootConstrainSelectedInstOperands,
     /*  40976 */     // GIR_Coverage, 4411,
     /*  40976 */     GIR_EraseRootFromParent_Done,
     /*  40977 */   // Label 989: @40977
     /*  40977 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(41055), // Rule ID 19479 //
     /*  40982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /*  40985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40993 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41003 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  41031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41054 */     // GIR_Coverage, 19479,
     /*  41054 */     GIR_EraseRootFromParent_Done,
     /*  41055 */   // Label 990: @41055
     /*  41055 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(41078), // Rule ID 4427 //
     /*  41060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41071 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /*  41076 */     GIR_RootConstrainSelectedInstOperands,
     /*  41077 */     // GIR_Coverage, 4427,
     /*  41077 */     GIR_Done,
     /*  41078 */   // Label 991: @41078
     /*  41078 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(41170), // Rule ID 19499 //
     /*  41083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41094 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41094 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41097 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41101 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41106 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  41110 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41127 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  41131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  41143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41169 */     // GIR_Coverage, 19499,
     /*  41169 */     GIR_EraseRootFromParent_Done,
     /*  41170 */   // Label 992: @41170
     /*  41170 */   GIM_Reject,
     /*  41171 */ // Label 982: @41171
     /*  41171 */ GIM_Reject,
     /*  41172 */ // Label 858: @41172
     /*  41172 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(41791),
     /*  41177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  41180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41183 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(41245), // Rule ID 25258 //
     /*  41188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41227 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41243 */     GIR_RootConstrainSelectedInstOperands,
     /*  41244 */     // GIR_Coverage, 25258,
     /*  41244 */     GIR_EraseRootFromParent_Done,
     /*  41245 */   // Label 994: @41245
     /*  41245 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(41307), // Rule ID 25437 //
     /*  41250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41289 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41294 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41305 */     GIR_RootConstrainSelectedInstOperands,
     /*  41306 */     // GIR_Coverage, 25437,
     /*  41306 */     GIR_EraseRootFromParent_Done,
     /*  41307 */   // Label 995: @41307
     /*  41307 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(41369), // Rule ID 18165 //
     /*  41312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41351 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41367 */     GIR_RootConstrainSelectedInstOperands,
     /*  41368 */     // GIR_Coverage, 18165,
     /*  41368 */     GIR_EraseRootFromParent_Done,
     /*  41369 */   // Label 996: @41369
     /*  41369 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(41431), // Rule ID 20029 //
     /*  41374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41393 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41396 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41400 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41413 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41429 */     GIR_RootConstrainSelectedInstOperands,
     /*  41430 */     // GIR_Coverage, 20029,
     /*  41430 */     GIR_EraseRootFromParent_Done,
     /*  41431 */   // Label 997: @41431
     /*  41431 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(41663), // Rule ID 21944 //
     /*  41436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  41439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  41443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41461 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  41461 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  41464 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41468 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  41475 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  41478 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41482 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41487 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  41490 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41494 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  41497 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41502 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41507 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41512 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  41515 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41519 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  41526 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  41529 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41533 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41538 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  41541 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41545 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  41548 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41553 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41558 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41563 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  41566 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41570 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  41580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41589 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41592 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41596 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  41599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41609 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  41617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  41621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  41632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  41635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  41638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41645 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  41652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  41657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41662 */     // GIR_Coverage, 21944,
     /*  41662 */     GIR_EraseRootFromParent_Done,
     /*  41663 */   // Label 998: @41663
     /*  41663 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(41709), // Rule ID 21952 //
     /*  41668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41683 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41693 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /*  41693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  41696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41700 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  41707 */     GIR_RootConstrainSelectedInstOperands,
     /*  41708 */     // GIR_Coverage, 21952,
     /*  41708 */     GIR_EraseRootFromParent_Done,
     /*  41709 */   // Label 999: @41709
     /*  41709 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(41736), // Rule ID 18153 //
     /*  41714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41729 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  41734 */     GIR_RootConstrainSelectedInstOperands,
     /*  41735 */     // GIR_Coverage, 18153,
     /*  41735 */     GIR_Done,
     /*  41736 */   // Label 1000: @41736
     /*  41736 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(41763), // Rule ID 18177 //
     /*  41741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  41744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41756 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  41761 */     GIR_RootConstrainSelectedInstOperands,
     /*  41762 */     // GIR_Coverage, 18177,
     /*  41762 */     GIR_Done,
     /*  41763 */   // Label 1001: @41763
     /*  41763 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(41790), // Rule ID 20021 //
     /*  41768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41783 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  41783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  41788 */     GIR_RootConstrainSelectedInstOperands,
     /*  41789 */     // GIR_Coverage, 20021,
     /*  41789 */     GIR_Done,
     /*  41790 */   // Label 1002: @41790
     /*  41790 */   GIM_Reject,
     /*  41791 */ // Label 993: @41791
     /*  41791 */ GIM_Reject,
     /*  41792 */ // Label 859: @41792
     /*  41792 */ GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(42535),
     /*  41797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  41800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  41803 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(41865), // Rule ID 24233 //
     /*  41808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  41811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41847 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  41850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41863 */     GIR_RootConstrainSelectedInstOperands,
     /*  41864 */     // GIR_Coverage, 24233,
     /*  41864 */     GIR_EraseRootFromParent_Done,
     /*  41865 */   // Label 1004: @41865
     /*  41865 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(41927), // Rule ID 25238 //
     /*  41870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  41873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41885 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41909 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  41912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41925 */     GIR_RootConstrainSelectedInstOperands,
     /*  41926 */     // GIR_Coverage, 25238,
     /*  41926 */     GIR_EraseRootFromParent_Done,
     /*  41927 */   // Label 1005: @41927
     /*  41927 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(41989), // Rule ID 25249 //
     /*  41932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  41935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41950 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41971 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  41974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41987 */     GIR_RootConstrainSelectedInstOperands,
     /*  41988 */     // GIR_Coverage, 25249,
     /*  41988 */     GIR_EraseRootFromParent_Done,
     /*  41989 */   // Label 1006: @41989
     /*  41989 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(42051), // Rule ID 5833 //
     /*  41994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  41997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42013 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42016 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42020 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42033 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42038 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42049 */     GIR_RootConstrainSelectedInstOperands,
     /*  42050 */     // GIR_Coverage, 5833,
     /*  42050 */     GIR_EraseRootFromParent_Done,
     /*  42051 */   // Label 1007: @42051
     /*  42051 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(42113), // Rule ID 18110 //
     /*  42056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42095 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42111 */     GIR_RootConstrainSelectedInstOperands,
     /*  42112 */     // GIR_Coverage, 18110,
     /*  42112 */     GIR_EraseRootFromParent_Done,
     /*  42113 */   // Label 1008: @42113
     /*  42113 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(42175), // Rule ID 18140 //
     /*  42118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42157 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42173 */     GIR_RootConstrainSelectedInstOperands,
     /*  42174 */     // GIR_Coverage, 18140,
     /*  42174 */     GIR_EraseRootFromParent_Done,
     /*  42175 */   // Label 1009: @42175
     /*  42175 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(42407), // Rule ID 21949 //
     /*  42180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  42183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42195 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42205 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  42205 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  42208 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42212 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  42219 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  42222 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42226 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42231 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  42234 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42238 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  42241 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42246 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42251 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42256 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  42259 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42263 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  42270 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  42273 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42277 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42282 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  42285 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42289 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  42292 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42297 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42302 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42307 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  42310 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42314 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  42324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42333 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42336 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42340 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  42343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  42361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  42376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  42379 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  42382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  42396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42406 */     // GIR_Coverage, 21949,
     /*  42406 */     GIR_EraseRootFromParent_Done,
     /*  42407 */   // Label 1010: @42407
     /*  42407 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(42453), // Rule ID 21957 //
     /*  42412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  42415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42437 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /*  42437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  42440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42451 */     GIR_RootConstrainSelectedInstOperands,
     /*  42452 */     // GIR_Coverage, 21957,
     /*  42452 */     GIR_EraseRootFromParent_Done,
     /*  42453 */   // Label 1011: @42453
     /*  42453 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(42480), // Rule ID 5830 //
     /*  42458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42473 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  42473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /*  42478 */     GIR_RootConstrainSelectedInstOperands,
     /*  42479 */     // GIR_Coverage, 5830,
     /*  42479 */     GIR_Done,
     /*  42480 */   // Label 1012: @42480
     /*  42480 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(42507), // Rule ID 18098 //
     /*  42485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42500 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  42505 */     GIR_RootConstrainSelectedInstOperands,
     /*  42506 */     // GIR_Coverage, 18098,
     /*  42506 */     GIR_Done,
     /*  42507 */   // Label 1013: @42507
     /*  42507 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(42534), // Rule ID 18124 //
     /*  42512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42527 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  42532 */     GIR_RootConstrainSelectedInstOperands,
     /*  42533 */     // GIR_Coverage, 18124,
     /*  42533 */     GIR_Done,
     /*  42534 */   // Label 1014: @42534
     /*  42534 */   GIM_Reject,
     /*  42535 */ // Label 1003: @42535
     /*  42535 */ GIM_Reject,
     /*  42536 */ // Label 860: @42536
     /*  42536 */ GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(42733),
     /*  42541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  42544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  42547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42551 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(42609), // Rule ID 24209 //
     /*  42556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42567 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42591 */     // (xor:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42607 */     GIR_RootConstrainSelectedInstOperands,
     /*  42608 */     // GIR_Coverage, 24209,
     /*  42608 */     GIR_EraseRootFromParent_Done,
     /*  42609 */   // Label 1016: @42609
     /*  42609 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(42667), // Rule ID 5797 //
     /*  42614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42649 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42665 */     GIR_RootConstrainSelectedInstOperands,
     /*  42666 */     // GIR_Coverage, 5797,
     /*  42666 */     GIR_EraseRootFromParent_Done,
     /*  42667 */   // Label 1017: @42667
     /*  42667 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(42709), // Rule ID 21942 //
     /*  42672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42683 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42693 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /*  42693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42700 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42707 */     GIR_RootConstrainSelectedInstOperands,
     /*  42708 */     // GIR_Coverage, 21942,
     /*  42708 */     GIR_EraseRootFromParent_Done,
     /*  42709 */   // Label 1018: @42709
     /*  42709 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(42732), // Rule ID 5794 //
     /*  42714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42725 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  42725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  42730 */     GIR_RootConstrainSelectedInstOperands,
     /*  42731 */     // GIR_Coverage, 5794,
     /*  42731 */     GIR_Done,
     /*  42732 */   // Label 1019: @42732
     /*  42732 */   GIM_Reject,
     /*  42733 */ // Label 1015: @42733
     /*  42733 */ GIM_Reject,
     /*  42734 */ // Label 861: @42734
     /*  42734 */ GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(42991),
     /*  42739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42749 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(42809), // Rule ID 23686 //
     /*  42754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42796 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  42807 */     GIR_RootConstrainSelectedInstOperands,
     /*  42808 */     // GIR_Coverage, 23686,
     /*  42808 */     GIR_EraseRootFromParent_Done,
     /*  42809 */   // Label 1021: @42809
     /*  42809 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(42872), // Rule ID 4424 //
     /*  42814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42847 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42857 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  42870 */     GIR_RootConstrainSelectedInstOperands,
     /*  42871 */     // GIR_Coverage, 4424,
     /*  42871 */     GIR_EraseRootFromParent_Done,
     /*  42872 */   // Label 1022: @42872
     /*  42872 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(42932), // Rule ID 23687 //
     /*  42877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42909 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42915 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42919 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  42930 */     GIR_RootConstrainSelectedInstOperands,
     /*  42931 */     // GIR_Coverage, 23687,
     /*  42931 */     GIR_EraseRootFromParent_Done,
     /*  42932 */   // Label 1023: @42932
     /*  42932 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(42967), // Rule ID 4412 //
     /*  42937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42954 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42958 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /*  42958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  42961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42965 */     GIR_RootConstrainSelectedInstOperands,
     /*  42966 */     // GIR_Coverage, 4412,
     /*  42966 */     GIR_EraseRootFromParent_Done,
     /*  42967 */   // Label 1024: @42967
     /*  42967 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(42990), // Rule ID 4428 //
     /*  42972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42983 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  42988 */     GIR_RootConstrainSelectedInstOperands,
     /*  42989 */     // GIR_Coverage, 4428,
     /*  42989 */     GIR_Done,
     /*  42990 */   // Label 1025: @42990
     /*  42990 */   GIM_Reject,
     /*  42991 */ // Label 1020: @42991
     /*  42991 */ GIM_Reject,
     /*  42992 */ // Label 862: @42992
     /*  42992 */ GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(43611),
     /*  42997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  43000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  43003 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(43065), // Rule ID 25257 //
     /*  43008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43047 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43063 */     GIR_RootConstrainSelectedInstOperands,
     /*  43064 */     // GIR_Coverage, 25257,
     /*  43064 */     GIR_EraseRootFromParent_Done,
     /*  43065 */   // Label 1027: @43065
     /*  43065 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(43127), // Rule ID 25436 //
     /*  43070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43085 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43109 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43114 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43125 */     GIR_RootConstrainSelectedInstOperands,
     /*  43126 */     // GIR_Coverage, 25436,
     /*  43126 */     GIR_EraseRootFromParent_Done,
     /*  43127 */   // Label 1028: @43127
     /*  43127 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(43189), // Rule ID 18164 //
     /*  43132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43151 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43171 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43187 */     GIR_RootConstrainSelectedInstOperands,
     /*  43188 */     // GIR_Coverage, 18164,
     /*  43188 */     GIR_EraseRootFromParent_Done,
     /*  43189 */   // Label 1029: @43189
     /*  43189 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(43251), // Rule ID 20028 //
     /*  43194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43213 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43220 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43233 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43249 */     GIR_RootConstrainSelectedInstOperands,
     /*  43250 */     // GIR_Coverage, 20028,
     /*  43250 */     GIR_EraseRootFromParent_Done,
     /*  43251 */   // Label 1030: @43251
     /*  43251 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(43483), // Rule ID 21943 //
     /*  43256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  43263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43271 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43277 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43281 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  43281 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  43284 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43288 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  43295 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  43298 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43302 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43307 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  43310 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43314 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  43317 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43322 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43327 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43332 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  43335 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43339 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  43346 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  43349 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43353 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43358 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  43361 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43365 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  43368 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43373 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43378 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  43386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  43400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43409 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43412 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43416 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  43419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  43437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  43441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43449 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  43452 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  43455 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  43458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  43472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  43477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43482 */     // GIR_Coverage, 21943,
     /*  43482 */     GIR_EraseRootFromParent_Done,
     /*  43483 */   // Label 1031: @43483
     /*  43483 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(43529), // Rule ID 21951 //
     /*  43488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43513 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /*  43513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  43516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  43527 */     GIR_RootConstrainSelectedInstOperands,
     /*  43528 */     // GIR_Coverage, 21951,
     /*  43528 */     GIR_EraseRootFromParent_Done,
     /*  43529 */   // Label 1032: @43529
     /*  43529 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(43556), // Rule ID 18152 //
     /*  43534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43549 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  43554 */     GIR_RootConstrainSelectedInstOperands,
     /*  43555 */     // GIR_Coverage, 18152,
     /*  43555 */     GIR_Done,
     /*  43556 */   // Label 1033: @43556
     /*  43556 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(43583), // Rule ID 18176 //
     /*  43561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  43564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43576 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  43581 */     GIR_RootConstrainSelectedInstOperands,
     /*  43582 */     // GIR_Coverage, 18176,
     /*  43582 */     GIR_Done,
     /*  43583 */   // Label 1034: @43583
     /*  43583 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(43610), // Rule ID 20020 //
     /*  43588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43603 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  43603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  43608 */     GIR_RootConstrainSelectedInstOperands,
     /*  43609 */     // GIR_Coverage, 20020,
     /*  43609 */     GIR_Done,
     /*  43610 */   // Label 1035: @43610
     /*  43610 */   GIM_Reject,
     /*  43611 */ // Label 1026: @43611
     /*  43611 */ GIM_Reject,
     /*  43612 */ // Label 863: @43612
     /*  43612 */ GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(44355),
     /*  43617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  43620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  43623 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(43685), // Rule ID 25237 //
     /*  43628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43643 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43650 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43667 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43674 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43683 */     GIR_RootConstrainSelectedInstOperands,
     /*  43684 */     // GIR_Coverage, 25237,
     /*  43684 */     GIR_EraseRootFromParent_Done,
     /*  43685 */   // Label 1037: @43685
     /*  43685 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(43747), // Rule ID 25248 //
     /*  43690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43729 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43745 */     GIR_RootConstrainSelectedInstOperands,
     /*  43746 */     // GIR_Coverage, 25248,
     /*  43746 */     GIR_EraseRootFromParent_Done,
     /*  43747 */   // Label 1038: @43747
     /*  43747 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(43809), // Rule ID 25443 //
     /*  43752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43767 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43791 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  43794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43807 */     GIR_RootConstrainSelectedInstOperands,
     /*  43808 */     // GIR_Coverage, 25443,
     /*  43808 */     GIR_EraseRootFromParent_Done,
     /*  43809 */   // Label 1039: @43809
     /*  43809 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(43871), // Rule ID 18109 //
     /*  43814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43853 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43869 */     GIR_RootConstrainSelectedInstOperands,
     /*  43870 */     // GIR_Coverage, 18109,
     /*  43870 */     GIR_EraseRootFromParent_Done,
     /*  43871 */   // Label 1040: @43871
     /*  43871 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(43933), // Rule ID 18139 //
     /*  43876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43915 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43931 */     GIR_RootConstrainSelectedInstOperands,
     /*  43932 */     // GIR_Coverage, 18139,
     /*  43932 */     GIR_EraseRootFromParent_Done,
     /*  43933 */   // Label 1041: @43933
     /*  43933 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(43995), // Rule ID 20045 //
     /*  43938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43957 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43977 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  43980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43993 */     GIR_RootConstrainSelectedInstOperands,
     /*  43994 */     // GIR_Coverage, 20045,
     /*  43994 */     GIR_EraseRootFromParent_Done,
     /*  43995 */   // Label 1042: @43995
     /*  43995 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(44227), // Rule ID 21948 //
     /*  44000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  44003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44015 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44025 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  44025 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  44028 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44032 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  44039 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  44042 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44046 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44051 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  44054 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44058 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  44061 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44066 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44071 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44076 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  44079 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44083 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  44090 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  44093 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44097 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44102 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  44105 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44109 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  44112 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44117 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44122 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44127 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  44130 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44134 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  44141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  44144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44153 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  44156 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44160 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  44163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  44181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44190 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44193 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  44196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  44199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  44202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44209 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  44216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44226 */     // GIR_Coverage, 21948,
     /*  44226 */     GIR_EraseRootFromParent_Done,
     /*  44227 */   // Label 1043: @44227
     /*  44227 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(44273), // Rule ID 21956 //
     /*  44232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44247 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44253 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44257 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /*  44257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  44260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44271 */     GIR_RootConstrainSelectedInstOperands,
     /*  44272 */     // GIR_Coverage, 21956,
     /*  44272 */     GIR_EraseRootFromParent_Done,
     /*  44273 */   // Label 1044: @44273
     /*  44273 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(44300), // Rule ID 18097 //
     /*  44278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44293 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  44298 */     GIR_RootConstrainSelectedInstOperands,
     /*  44299 */     // GIR_Coverage, 18097,
     /*  44299 */     GIR_Done,
     /*  44300 */   // Label 1045: @44300
     /*  44300 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(44327), // Rule ID 18123 //
     /*  44305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44320 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  44325 */     GIR_RootConstrainSelectedInstOperands,
     /*  44326 */     // GIR_Coverage, 18123,
     /*  44326 */     GIR_Done,
     /*  44327 */   // Label 1046: @44327
     /*  44327 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(44354), // Rule ID 20037 //
     /*  44332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44347 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  44347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  44352 */     GIR_RootConstrainSelectedInstOperands,
     /*  44353 */     // GIR_Coverage, 20037,
     /*  44353 */     GIR_Done,
     /*  44354 */   // Label 1047: @44354
     /*  44354 */   GIM_Reject,
     /*  44355 */ // Label 1036: @44355
     /*  44355 */ GIM_Reject,
     /*  44356 */ // Label 864: @44356
     /*  44356 */ GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(44553),
     /*  44361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  44364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  44367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44371 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(44429), // Rule ID 24227 //
     /*  44376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44411 */     // (xor:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44427 */     GIR_RootConstrainSelectedInstOperands,
     /*  44428 */     // GIR_Coverage, 24227,
     /*  44428 */     GIR_EraseRootFromParent_Done,
     /*  44429 */   // Label 1049: @44429
     /*  44429 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(44487), // Rule ID 5824 //
     /*  44434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44469 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44485 */     GIR_RootConstrainSelectedInstOperands,
     /*  44486 */     // GIR_Coverage, 5824,
     /*  44486 */     GIR_EraseRootFromParent_Done,
     /*  44487 */   // Label 1050: @44487
     /*  44487 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(44529), // Rule ID 21941 //
     /*  44492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44513 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /*  44513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44527 */     GIR_RootConstrainSelectedInstOperands,
     /*  44528 */     // GIR_Coverage, 21941,
     /*  44528 */     GIR_EraseRootFromParent_Done,
     /*  44529 */   // Label 1051: @44529
     /*  44529 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(44552), // Rule ID 5821 //
     /*  44534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44545 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  44545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /*  44550 */     GIR_RootConstrainSelectedInstOperands,
     /*  44551 */     // GIR_Coverage, 5821,
     /*  44551 */     GIR_Done,
     /*  44552 */   // Label 1052: @44552
     /*  44552 */   GIM_Reject,
     /*  44553 */ // Label 1048: @44553
     /*  44553 */ GIM_Reject,
     /*  44554 */ // Label 865: @44554
     /*  44554 */ GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(44811),
     /*  44559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44569 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(44629), // Rule ID 23688 //
     /*  44574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44616 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  44627 */     GIR_RootConstrainSelectedInstOperands,
     /*  44628 */     // GIR_Coverage, 23688,
     /*  44628 */     GIR_EraseRootFromParent_Done,
     /*  44629 */   // Label 1054: @44629
     /*  44629 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(44692), // Rule ID 4425 //
     /*  44634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44667 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44677 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  44690 */     GIR_RootConstrainSelectedInstOperands,
     /*  44691 */     // GIR_Coverage, 4425,
     /*  44691 */     GIR_EraseRootFromParent_Done,
     /*  44692 */   // Label 1055: @44692
     /*  44692 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(44752), // Rule ID 23689 //
     /*  44697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44729 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44739 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  44750 */     GIR_RootConstrainSelectedInstOperands,
     /*  44751 */     // GIR_Coverage, 23689,
     /*  44751 */     GIR_EraseRootFromParent_Done,
     /*  44752 */   // Label 1056: @44752
     /*  44752 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(44787), // Rule ID 4413 //
     /*  44757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44768 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44778 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /*  44778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /*  44781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44785 */     GIR_RootConstrainSelectedInstOperands,
     /*  44786 */     // GIR_Coverage, 4413,
     /*  44786 */     GIR_EraseRootFromParent_Done,
     /*  44787 */   // Label 1057: @44787
     /*  44787 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(44810), // Rule ID 4429 //
     /*  44792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44803 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /*  44808 */     GIR_RootConstrainSelectedInstOperands,
     /*  44809 */     // GIR_Coverage, 4429,
     /*  44809 */     GIR_Done,
     /*  44810 */   // Label 1058: @44810
     /*  44810 */   GIM_Reject,
     /*  44811 */ // Label 1053: @44811
     /*  44811 */ GIM_Reject,
     /*  44812 */ // Label 866: @44812
     /*  44812 */ GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(45555),
     /*  44817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  44820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  44823 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(44885), // Rule ID 25236 //
     /*  44828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44867 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  44870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44872 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44883 */     GIR_RootConstrainSelectedInstOperands,
     /*  44884 */     // GIR_Coverage, 25236,
     /*  44884 */     GIR_EraseRootFromParent_Done,
     /*  44885 */   // Label 1060: @44885
     /*  44885 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(44947), // Rule ID 25247 //
     /*  44890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44929 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  44932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44945 */     GIR_RootConstrainSelectedInstOperands,
     /*  44946 */     // GIR_Coverage, 25247,
     /*  44946 */     GIR_EraseRootFromParent_Done,
     /*  44947 */   // Label 1061: @44947
     /*  44947 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(45009), // Rule ID 25442 //
     /*  44952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44991 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44998 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45007 */     GIR_RootConstrainSelectedInstOperands,
     /*  45008 */     // GIR_Coverage, 25442,
     /*  45008 */     GIR_EraseRootFromParent_Done,
     /*  45009 */   // Label 1062: @45009
     /*  45009 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(45071), // Rule ID 18108 //
     /*  45014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45040 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45053 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45069 */     GIR_RootConstrainSelectedInstOperands,
     /*  45070 */     // GIR_Coverage, 18108,
     /*  45070 */     GIR_EraseRootFromParent_Done,
     /*  45071 */   // Label 1063: @45071
     /*  45071 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(45133), // Rule ID 18138 //
     /*  45076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45115 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45131 */     GIR_RootConstrainSelectedInstOperands,
     /*  45132 */     // GIR_Coverage, 18138,
     /*  45132 */     GIR_EraseRootFromParent_Done,
     /*  45133 */   // Label 1064: @45133
     /*  45133 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(45195), // Rule ID 20044 //
     /*  45138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45177 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45182 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45193 */     GIR_RootConstrainSelectedInstOperands,
     /*  45194 */     // GIR_Coverage, 20044,
     /*  45194 */     GIR_EraseRootFromParent_Done,
     /*  45195 */   // Label 1065: @45195
     /*  45195 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(45427), // Rule ID 21947 //
     /*  45200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  45203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45221 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45225 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  45225 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  45228 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45232 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  45239 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  45242 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45246 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45251 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  45254 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45258 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  45261 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45266 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45271 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45276 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  45279 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45283 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  45290 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  45293 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45297 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45302 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  45305 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45309 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  45312 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45317 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45322 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45327 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  45330 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45334 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  45344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45353 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45356 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45360 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  45363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  45381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  45396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  45399 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  45402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  45416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45426 */     // GIR_Coverage, 21947,
     /*  45426 */     GIR_EraseRootFromParent_Done,
     /*  45427 */   // Label 1066: @45427
     /*  45427 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(45473), // Rule ID 21955 //
     /*  45432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45457 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /*  45457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  45460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45464 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45471 */     GIR_RootConstrainSelectedInstOperands,
     /*  45472 */     // GIR_Coverage, 21955,
     /*  45472 */     GIR_EraseRootFromParent_Done,
     /*  45473 */   // Label 1067: @45473
     /*  45473 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(45500), // Rule ID 18096 //
     /*  45478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45493 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  45498 */     GIR_RootConstrainSelectedInstOperands,
     /*  45499 */     // GIR_Coverage, 18096,
     /*  45499 */     GIR_Done,
     /*  45500 */   // Label 1068: @45500
     /*  45500 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(45527), // Rule ID 18122 //
     /*  45505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45520 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  45525 */     GIR_RootConstrainSelectedInstOperands,
     /*  45526 */     // GIR_Coverage, 18122,
     /*  45526 */     GIR_Done,
     /*  45527 */   // Label 1069: @45527
     /*  45527 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(45554), // Rule ID 20036 //
     /*  45532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45547 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  45547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  45552 */     GIR_RootConstrainSelectedInstOperands,
     /*  45553 */     // GIR_Coverage, 20036,
     /*  45553 */     GIR_Done,
     /*  45554 */   // Label 1070: @45554
     /*  45554 */   GIM_Reject,
     /*  45555 */ // Label 1059: @45555
     /*  45555 */ GIM_Reject,
     /*  45556 */ // Label 867: @45556
     /*  45556 */ GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(45753),
     /*  45561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  45564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  45567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45571 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(45629), // Rule ID 25449 //
     /*  45576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45611 */     // (xor:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45627 */     GIR_RootConstrainSelectedInstOperands,
     /*  45628 */     // GIR_Coverage, 25449,
     /*  45628 */     GIR_EraseRootFromParent_Done,
     /*  45629 */   // Label 1072: @45629
     /*  45629 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(45687), // Rule ID 20061 //
     /*  45634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45669 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45685 */     GIR_RootConstrainSelectedInstOperands,
     /*  45686 */     // GIR_Coverage, 20061,
     /*  45686 */     GIR_EraseRootFromParent_Done,
     /*  45687 */   // Label 1073: @45687
     /*  45687 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(45729), // Rule ID 21940 //
     /*  45692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45713 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /*  45713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45727 */     GIR_RootConstrainSelectedInstOperands,
     /*  45728 */     // GIR_Coverage, 21940,
     /*  45728 */     GIR_EraseRootFromParent_Done,
     /*  45729 */   // Label 1074: @45729
     /*  45729 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(45752), // Rule ID 20053 //
     /*  45734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45745 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  45745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  45750 */     GIR_RootConstrainSelectedInstOperands,
     /*  45751 */     // GIR_Coverage, 20053,
     /*  45751 */     GIR_Done,
     /*  45752 */   // Label 1075: @45752
     /*  45752 */   GIM_Reject,
     /*  45753 */ // Label 1071: @45753
     /*  45753 */ GIM_Reject,
     /*  45754 */ // Label 868: @45754
     /*  45754 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(46011),
     /*  45759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45769 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(45829), // Rule ID 23690 //
     /*  45774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45802 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45816 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45825 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45827 */     GIR_RootConstrainSelectedInstOperands,
     /*  45828 */     // GIR_Coverage, 23690,
     /*  45828 */     GIR_EraseRootFromParent_Done,
     /*  45829 */   // Label 1077: @45829
     /*  45829 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(45892), // Rule ID 4426 //
     /*  45834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45867 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45877 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  45890 */     GIR_RootConstrainSelectedInstOperands,
     /*  45891 */     // GIR_Coverage, 4426,
     /*  45891 */     GIR_EraseRootFromParent_Done,
     /*  45892 */   // Label 1078: @45892
     /*  45892 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(45952), // Rule ID 23691 //
     /*  45897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45929 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45939 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  45950 */     GIR_RootConstrainSelectedInstOperands,
     /*  45951 */     // GIR_Coverage, 23691,
     /*  45951 */     GIR_EraseRootFromParent_Done,
     /*  45952 */   // Label 1079: @45952
     /*  45952 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(45987), // Rule ID 4414 //
     /*  45957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45974 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45978 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /*  45978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /*  45981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45983 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45985 */     GIR_RootConstrainSelectedInstOperands,
     /*  45986 */     // GIR_Coverage, 4414,
     /*  45986 */     GIR_EraseRootFromParent_Done,
     /*  45987 */   // Label 1080: @45987
     /*  45987 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(46010), // Rule ID 4430 //
     /*  45992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46003 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /*  46008 */     GIR_RootConstrainSelectedInstOperands,
     /*  46009 */     // GIR_Coverage, 4430,
     /*  46009 */     GIR_Done,
     /*  46010 */   // Label 1081: @46010
     /*  46010 */   GIM_Reject,
     /*  46011 */ // Label 1076: @46011
     /*  46011 */ GIM_Reject,
     /*  46012 */ // Label 869: @46012
     /*  46012 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(46209),
     /*  46017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  46020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  46023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46027 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(46085), // Rule ID 25448 //
     /*  46032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46067 */     // (xor:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  46074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46083 */     GIR_RootConstrainSelectedInstOperands,
     /*  46084 */     // GIR_Coverage, 25448,
     /*  46084 */     GIR_EraseRootFromParent_Done,
     /*  46085 */   // Label 1083: @46085
     /*  46085 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(46143), // Rule ID 20060 //
     /*  46090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46105 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46112 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46125 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46141 */     GIR_RootConstrainSelectedInstOperands,
     /*  46142 */     // GIR_Coverage, 20060,
     /*  46142 */     GIR_EraseRootFromParent_Done,
     /*  46143 */   // Label 1084: @46143
     /*  46143 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(46185), // Rule ID 21939 //
     /*  46148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46169 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /*  46169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  46172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46174 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  46183 */     GIR_RootConstrainSelectedInstOperands,
     /*  46184 */     // GIR_Coverage, 21939,
     /*  46184 */     GIR_EraseRootFromParent_Done,
     /*  46185 */   // Label 1085: @46185
     /*  46185 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(46208), // Rule ID 20052 //
     /*  46190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46201 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  46201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  46206 */     GIR_RootConstrainSelectedInstOperands,
     /*  46207 */     // GIR_Coverage, 20052,
     /*  46207 */     GIR_Done,
     /*  46208 */   // Label 1086: @46208
     /*  46208 */   GIM_Reject,
     /*  46209 */ // Label 1082: @46209
     /*  46209 */ GIM_Reject,
     /*  46210 */ // Label 870: @46210
     /*  46210 */ GIM_Reject,
     /*  46211 */ // Label 6: @46211
     /*  46211 */ GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(46377),
     /*  46216 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  46219 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 1091*/ GIMT_Encode4(46376),
     /*  46230 */   /*GILLT_v16s1*//*Label 1088*/ GIMT_Encode4(46262), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46246 */   /*GILLT_v32s1*//*Label 1089*/ GIMT_Encode4(46300), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46258 */   /*GILLT_v64s1*//*Label 1090*/ GIMT_Encode4(46338),
     /*  46262 */   // Label 1088: @46262
     /*  46262 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(46299), // Rule ID 19503 //
     /*  46267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46270 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  46276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46288 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /*  46288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /*  46291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46297 */     GIR_RootConstrainSelectedInstOperands,
     /*  46298 */     // GIR_Coverage, 19503,
     /*  46298 */     GIR_EraseRootFromParent_Done,
     /*  46299 */   // Label 1092: @46299
     /*  46299 */   GIM_Reject,
     /*  46300 */   // Label 1089: @46300
     /*  46300 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(46337), // Rule ID 19504 //
     /*  46305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46308 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  46314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46326 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /*  46326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /*  46329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46331 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46335 */     GIR_RootConstrainSelectedInstOperands,
     /*  46336 */     // GIR_Coverage, 19504,
     /*  46336 */     GIR_EraseRootFromParent_Done,
     /*  46337 */   // Label 1093: @46337
     /*  46337 */   GIM_Reject,
     /*  46338 */   // Label 1090: @46338
     /*  46338 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(46375), // Rule ID 19505 //
     /*  46343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46346 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  46349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  46352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46364 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /*  46364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /*  46367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46373 */     GIR_RootConstrainSelectedInstOperands,
     /*  46374 */     // GIR_Coverage, 19505,
     /*  46374 */     GIR_EraseRootFromParent_Done,
     /*  46375 */   // Label 1094: @46375
     /*  46375 */   GIM_Reject,
     /*  46376 */   // Label 1091: @46376
     /*  46376 */   GIM_Reject,
     /*  46377 */ // Label 1087: @46377
     /*  46377 */ GIM_Reject,
     /*  46378 */ // Label 7: @46378
     /*  46378 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1103*/ GIMT_Encode4(48667),
     /*  46389 */ /*GILLT_s8*//*Label 1095*/ GIMT_Encode4(46481),
     /*  46393 */ /*GILLT_s16*//*Label 1096*/ GIMT_Encode4(46542),
     /*  46397 */ /*GILLT_s32*//*Label 1097*/ GIMT_Encode4(47372),
     /*  46401 */ /*GILLT_s64*//*Label 1098*/ GIMT_Encode4(47798), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46433 */ /*GILLT_v8s1*//*Label 1099*/ GIMT_Encode4(48224), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46449 */ /*GILLT_v16s1*//*Label 1100*/ GIMT_Encode4(48385), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46465 */ /*GILLT_v32s1*//*Label 1101*/ GIMT_Encode4(48525), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46477 */ /*GILLT_v64s1*//*Label 1102*/ GIMT_Encode4(48596),
     /*  46481 */ // Label 1095: @46481
     /*  46481 */ GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(46541), // Rule ID 19434 //
     /*  46486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  46493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46497 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /*  46497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46523 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /*  46530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  46535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46540 */   // GIR_Coverage, 19434,
     /*  46540 */   GIR_EraseRootFromParent_Done,
     /*  46541 */ // Label 1104: @46541
     /*  46541 */ GIM_Reject,
     /*  46542 */ // Label 1096: @46542
     /*  46542 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(46602), // Rule ID 19431 //
     /*  46547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46558 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /*  46558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46584 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46601 */   // GIR_Coverage, 19431,
     /*  46601 */   GIR_EraseRootFromParent_Done,
     /*  46602 */ // Label 1105: @46602
     /*  46602 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(46703), // Rule ID 22140 //
     /*  46607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46621 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /*  46621 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46624 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46628 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46635 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46638 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46642 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46647 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46650 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46654 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /*  46657 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46662 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46667 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /*  46679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46684 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  46702 */   // GIR_Coverage, 22140,
     /*  46702 */   GIR_EraseRootFromParent_Done,
     /*  46703 */ // Label 1106: @46703
     /*  46703 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(46783), // Rule ID 22153 //
     /*  46708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46722 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  46722 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  46725 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46729 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46734 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46738 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  46743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /*  46750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46755 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46765 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46782 */   // GIR_Coverage, 22153,
     /*  46782 */   GIR_EraseRootFromParent_Done,
     /*  46783 */ // Label 1107: @46783
     /*  46783 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(46862), // Rule ID 18340 //
     /*  46788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  46791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46798 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  46798 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46801 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46805 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46810 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46814 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  46819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /*  46826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46831 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46834 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  46837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46844 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46861 */   // GIR_Coverage, 18340,
     /*  46861 */   GIR_EraseRootFromParent_Done,
     /*  46862 */ // Label 1108: @46862
     /*  46862 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(46979), // Rule ID 18341 //
     /*  46867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  46870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  46877 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  46877 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46880 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46884 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  46891 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46894 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46898 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46903 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  46906 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46910 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  46913 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46918 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46923 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46928 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46931 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46935 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  46942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /*  46949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46954 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46957 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46960 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  46963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  46978 */   // GIR_Coverage, 18341,
     /*  46978 */   GIR_EraseRootFromParent_Done,
     /*  46979 */ // Label 1109: @46979
     /*  46979 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(47058), // Rule ID 18337 //
     /*  46984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  46987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46994 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  46994 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46997 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47001 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47006 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47010 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  47022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47027 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47030 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47040 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47057 */   // GIR_Coverage, 18337,
     /*  47057 */   GIR_EraseRootFromParent_Done,
     /*  47058 */ // Label 1110: @47058
     /*  47058 */ GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(47175), // Rule ID 18338 //
     /*  47063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47073 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47073 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47076 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47080 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47087 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47090 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47094 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47099 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47102 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47106 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47109 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47114 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47119 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47124 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47127 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47131 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /*  47145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47150 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47153 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47156 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47174 */   // GIR_Coverage, 18338,
     /*  47174 */   GIR_EraseRootFromParent_Done,
     /*  47175 */ // Label 1111: @47175
     /*  47175 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(47254), // Rule ID 21841 //
     /*  47180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47190 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47190 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47193 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47197 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47202 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47206 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  47211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /*  47218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47223 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47226 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47236 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47253 */   // GIR_Coverage, 21841,
     /*  47253 */   GIR_EraseRootFromParent_Done,
     /*  47254 */ // Label 1112: @47254
     /*  47254 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(47371), // Rule ID 21842 //
     /*  47259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  47269 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  47269 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47272 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47276 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47283 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47286 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47290 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47295 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47298 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47302 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47305 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47310 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47315 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47320 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47323 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47327 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /*  47341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47346 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47349 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47352 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  47370 */   // GIR_Coverage, 21842,
     /*  47370 */   GIR_EraseRootFromParent_Done,
     /*  47371 */ // Label 1113: @47371
     /*  47371 */ GIM_Reject,
     /*  47372 */ // Label 1097: @47372
     /*  47372 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(47438), // Rule ID 22525 //
     /*  47377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  47380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47395 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47402 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47409 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47413 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47415 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47422 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  47425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47427 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47436 */   GIR_RootConstrainSelectedInstOperands,
     /*  47437 */   // GIR_Coverage, 22525,
     /*  47437 */   GIR_EraseRootFromParent_Done,
     /*  47438 */ // Label 1114: @47438
     /*  47438 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(47504), // Rule ID 22526 //
     /*  47443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47461 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47464 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47468 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47475 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47481 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47488 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  47491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47493 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47502 */   GIR_RootConstrainSelectedInstOperands,
     /*  47503 */   // GIR_Coverage, 22526,
     /*  47503 */   GIR_EraseRootFromParent_Done,
     /*  47504 */ // Label 1115: @47504
     /*  47504 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(47570), // Rule ID 22527 //
     /*  47509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47527 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47530 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47534 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47541 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47545 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47547 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47554 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  47557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47559 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47568 */   GIR_RootConstrainSelectedInstOperands,
     /*  47569 */   // GIR_Coverage, 22527,
     /*  47569 */   GIR_EraseRootFromParent_Done,
     /*  47570 */ // Label 1116: @47570
     /*  47570 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(47596), // Rule ID 2915 //
     /*  47575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47589 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /*  47594 */   GIR_RootConstrainSelectedInstOperands,
     /*  47595 */   // GIR_Coverage, 2915,
     /*  47595 */   GIR_Done,
     /*  47596 */ // Label 1117: @47596
     /*  47596 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(47622), // Rule ID 2916 //
     /*  47601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47615 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /*  47620 */   GIR_RootConstrainSelectedInstOperands,
     /*  47621 */   // GIR_Coverage, 2916,
     /*  47621 */   GIR_Done,
     /*  47622 */ // Label 1118: @47622
     /*  47622 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(47648), // Rule ID 2925 //
     /*  47627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47641 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /*  47646 */   GIR_RootConstrainSelectedInstOperands,
     /*  47647 */   // GIR_Coverage, 2925,
     /*  47647 */   GIR_Done,
     /*  47648 */ // Label 1119: @47648
     /*  47648 */ GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(47674), // Rule ID 2926 //
     /*  47653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47667 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /*  47672 */   GIR_RootConstrainSelectedInstOperands,
     /*  47673 */   // GIR_Coverage, 2926,
     /*  47673 */   GIR_Done,
     /*  47674 */ // Label 1120: @47674
     /*  47674 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(47700), // Rule ID 4598 //
     /*  47679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47693 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47698 */   GIR_RootConstrainSelectedInstOperands,
     /*  47699 */   // GIR_Coverage, 4598,
     /*  47699 */   GIR_Done,
     /*  47700 */ // Label 1121: @47700
     /*  47700 */ GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(47726), // Rule ID 4603 //
     /*  47705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47719 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  47719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  47724 */   GIR_RootConstrainSelectedInstOperands,
     /*  47725 */   // GIR_Coverage, 4603,
     /*  47725 */   GIR_Done,
     /*  47726 */ // Label 1122: @47726
     /*  47726 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(47753), // Rule ID 19442 //
     /*  47731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47742 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /*  47742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  47752 */   // GIR_Coverage, 19442,
     /*  47752 */   GIR_Done,
     /*  47753 */ // Label 1123: @47753
     /*  47753 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(47797), // Rule ID 19876 //
     /*  47758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47769 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /*  47769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /*  47776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47795 */   GIR_RootConstrainSelectedInstOperands,
     /*  47796 */   // GIR_Coverage, 19876,
     /*  47796 */   GIR_EraseRootFromParent_Done,
     /*  47797 */ // Label 1124: @47797
     /*  47797 */ GIM_Reject,
     /*  47798 */ // Label 1098: @47798
     /*  47798 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(47864), // Rule ID 22528 //
     /*  47803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47821 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47824 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47828 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47835 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47841 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47848 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  47851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47853 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47857 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47862 */   GIR_RootConstrainSelectedInstOperands,
     /*  47863 */   // GIR_Coverage, 22528,
     /*  47863 */   GIR_EraseRootFromParent_Done,
     /*  47864 */ // Label 1125: @47864
     /*  47864 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(47930), // Rule ID 22529 //
     /*  47869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47879 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47887 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47890 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47894 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47901 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47907 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47914 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  47917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47919 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47928 */   GIR_RootConstrainSelectedInstOperands,
     /*  47929 */   // GIR_Coverage, 22529,
     /*  47929 */   GIR_EraseRootFromParent_Done,
     /*  47930 */ // Label 1126: @47930
     /*  47930 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(47996), // Rule ID 22530 //
     /*  47935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  47945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47953 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47956 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47960 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47967 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47973 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47980 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  47983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47985 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47994 */   GIR_RootConstrainSelectedInstOperands,
     /*  47995 */   // GIR_Coverage, 22530,
     /*  47995 */   GIR_EraseRootFromParent_Done,
     /*  47996 */ // Label 1127: @47996
     /*  47996 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(48022), // Rule ID 2910 //
     /*  48001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48015 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /*  48020 */   GIR_RootConstrainSelectedInstOperands,
     /*  48021 */   // GIR_Coverage, 2910,
     /*  48021 */   GIR_Done,
     /*  48022 */ // Label 1128: @48022
     /*  48022 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(48048), // Rule ID 2914 //
     /*  48027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48041 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /*  48046 */   GIR_RootConstrainSelectedInstOperands,
     /*  48047 */   // GIR_Coverage, 2914,
     /*  48047 */   GIR_Done,
     /*  48048 */ // Label 1129: @48048
     /*  48048 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(48074), // Rule ID 2923 //
     /*  48053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48067 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /*  48072 */   GIR_RootConstrainSelectedInstOperands,
     /*  48073 */   // GIR_Coverage, 2923,
     /*  48073 */   GIR_Done,
     /*  48074 */ // Label 1130: @48074
     /*  48074 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(48100), // Rule ID 2924 //
     /*  48079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48093 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /*  48098 */   GIR_RootConstrainSelectedInstOperands,
     /*  48099 */   // GIR_Coverage, 2924,
     /*  48099 */   GIR_Done,
     /*  48100 */ // Label 1131: @48100
     /*  48100 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(48126), // Rule ID 4596 //
     /*  48105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48119 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48124 */   GIR_RootConstrainSelectedInstOperands,
     /*  48125 */   // GIR_Coverage, 4596,
     /*  48125 */   GIR_Done,
     /*  48126 */ // Label 1132: @48126
     /*  48126 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(48152), // Rule ID 4597 //
     /*  48131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48145 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  48145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48150 */   GIR_RootConstrainSelectedInstOperands,
     /*  48151 */   // GIR_Coverage, 4597,
     /*  48151 */   GIR_Done,
     /*  48152 */ // Label 1133: @48152
     /*  48152 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(48179), // Rule ID 19444 //
     /*  48157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48168 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /*  48168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  48178 */   // GIR_Coverage, 19444,
     /*  48178 */   GIR_Done,
     /*  48179 */ // Label 1134: @48179
     /*  48179 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(48223), // Rule ID 19878 //
     /*  48184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48195 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /*  48195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /*  48202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48221 */   GIR_RootConstrainSelectedInstOperands,
     /*  48222 */   // GIR_Coverage, 19878,
     /*  48222 */   GIR_EraseRootFromParent_Done,
     /*  48223 */ // Label 1135: @48223
     /*  48223 */ GIM_Reject,
     /*  48224 */ // Label 1099: @48224
     /*  48224 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(48384),
     /*  48229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  48232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  48236 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(48309), // Rule ID 19448 //
     /*  48241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48272 */     // (bitconvert:{ *:[v8i1] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), VK8:{ *:[i32] })
     /*  48272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  48279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48284 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  48288 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48308 */     // GIR_Coverage, 19448,
     /*  48308 */     GIR_EraseRootFromParent_Done,
     /*  48309 */   // Label 1137: @48309
     /*  48309 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(48383), // Rule ID 19433 //
     /*  48314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  48318 */     // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /*  48318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  48354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  48369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48382 */     // GIR_Coverage, 19433,
     /*  48382 */     GIR_EraseRootFromParent_Done,
     /*  48383 */   // Label 1138: @48383
     /*  48383 */   GIM_Reject,
     /*  48384 */ // Label 1136: @48384
     /*  48384 */ GIM_Reject,
     /*  48385 */ // Label 1100: @48385
     /*  48385 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(48524),
     /*  48390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  48397 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(48449), // Rule ID 19449 //
     /*  48402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48416 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48420 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  48424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48433 */     // (bitconvert:{ *:[v16i1] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  48433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  48436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48447 */     GIR_RootConstrainSelectedInstOperands,
     /*  48448 */     // GIR_Coverage, 19449,
     /*  48448 */     GIR_EraseRootFromParent_Done,
     /*  48449 */   // Label 1140: @48449
     /*  48449 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(48523), // Rule ID 19430 //
     /*  48454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48458 */     // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /*  48458 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48461 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48465 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /*  48494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  48509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  48522 */     // GIR_Coverage, 19430,
     /*  48522 */     GIR_EraseRootFromParent_Done,
     /*  48523 */   // Label 1141: @48523
     /*  48523 */   GIM_Reject,
     /*  48524 */ // Label 1139: @48524
     /*  48524 */ GIM_Reject,
     /*  48525 */ // Label 1101: @48525
     /*  48525 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(48595),
     /*  48530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  48537 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(48557), // Rule ID 19441 //
     /*  48542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48546 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /*  48546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /*  48556 */     // GIR_Coverage, 19441,
     /*  48556 */     GIR_Done,
     /*  48557 */   // Label 1143: @48557
     /*  48557 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(48594), // Rule ID 19875 //
     /*  48562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  48566 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /*  48566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  48573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /*  48587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48592 */     GIR_RootConstrainSelectedInstOperands,
     /*  48593 */     // GIR_Coverage, 19875,
     /*  48593 */     GIR_EraseRootFromParent_Done,
     /*  48594 */   // Label 1144: @48594
     /*  48594 */   GIM_Reject,
     /*  48595 */ // Label 1142: @48595
     /*  48595 */ GIM_Reject,
     /*  48596 */ // Label 1102: @48596
     /*  48596 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(48666),
     /*  48601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48608 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(48628), // Rule ID 19443 //
     /*  48613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48617 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /*  48617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /*  48627 */     // GIR_Coverage, 19443,
     /*  48627 */     GIR_Done,
     /*  48628 */   // Label 1146: @48628
     /*  48628 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(48665), // Rule ID 19877 //
     /*  48633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48637 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /*  48637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /*  48658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48663 */     GIR_RootConstrainSelectedInstOperands,
     /*  48664 */     // GIR_Coverage, 19877,
     /*  48664 */     GIR_EraseRootFromParent_Done,
     /*  48665 */   // Label 1147: @48665
     /*  48665 */   GIM_Reject,
     /*  48666 */ // Label 1145: @48666
     /*  48666 */ GIM_Reject,
     /*  48667 */ // Label 1103: @48667
     /*  48667 */ GIM_Reject,
     /*  48668 */ // Label 8: @48668
     /*  48668 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1160*/ GIMT_Encode4(51845),
     /*  48679 */ /*GILLT_s16*//*Label 1148*/ GIMT_Encode4(48763),
     /*  48683 */ /*GILLT_s32*//*Label 1149*/ GIMT_Encode4(48824),
     /*  48687 */ /*GILLT_s64*//*Label 1150*/ GIMT_Encode4(49448), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48703 */ /*GILLT_v2s64*//*Label 1151*/ GIMT_Encode4(50072), GIMT_Encode4(0),
     /*  48711 */ /*GILLT_v4s32*//*Label 1152*/ GIMT_Encode4(50161),
     /*  48715 */ /*GILLT_v4s64*//*Label 1153*/ GIMT_Encode4(50607), GIMT_Encode4(0),
     /*  48723 */ /*GILLT_v8s16*//*Label 1154*/ GIMT_Encode4(50786),
     /*  48727 */ /*GILLT_v8s32*//*Label 1155*/ GIMT_Encode4(50875),
     /*  48731 */ /*GILLT_v8s64*//*Label 1156*/ GIMT_Encode4(51226), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48743 */ /*GILLT_v16s16*//*Label 1157*/ GIMT_Encode4(51494),
     /*  48747 */ /*GILLT_v16s32*//*Label 1158*/ GIMT_Encode4(51583), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48759 */ /*GILLT_v32s16*//*Label 1159*/ GIMT_Encode4(51756),
     /*  48763 */ // Label 1148: @48763
     /*  48763 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(48823), // Rule ID 22169 //
     /*  48768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  48771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  48782 */   // (lrint:{ *:[i16] } FR16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src), sub_16bit:{ *:[i32] })
     /*  48782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  48789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48794 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48805 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  48812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  48817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  48822 */   // GIR_Coverage, 22169,
     /*  48822 */   GIR_EraseRootFromParent_Done,
     /*  48823 */ // Label 1161: @48823
     /*  48823 */ GIM_Reject,
     /*  48824 */ // Label 1149: @48824
     /*  48824 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(48883), // Rule ID 1756 //
     /*  48829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48847 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48854 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48858 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48860 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48867 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrm),
     /*  48870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48872 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48881 */   GIR_RootConstrainSelectedInstOperands,
     /*  48882 */   // GIR_Coverage, 1756,
     /*  48882 */   GIR_EraseRootFromParent_Done,
     /*  48883 */ // Label 1162: @48883
     /*  48883 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(48942), // Rule ID 1760 //
     /*  48888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48906 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48909 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48913 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48919 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48926 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrm),
     /*  48929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48931 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48940 */   GIR_RootConstrainSelectedInstOperands,
     /*  48941 */   // GIR_Coverage, 1760,
     /*  48941 */   GIR_EraseRootFromParent_Done,
     /*  48942 */ // Label 1163: @48942
     /*  48942 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(49001), // Rule ID 1780 //
     /*  48947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  48950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48965 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48972 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48978 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48985 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrm),
     /*  48988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48990 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48999 */   GIR_RootConstrainSelectedInstOperands,
     /*  49000 */   // GIR_Coverage, 1780,
     /*  49000 */   GIR_EraseRootFromParent_Done,
     /*  49001 */ // Label 1164: @49001
     /*  49001 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(49060), // Rule ID 1784 //
     /*  49006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49024 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49027 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49031 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49037 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49044 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrm),
     /*  49047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49049 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49053 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49058 */   GIR_RootConstrainSelectedInstOperands,
     /*  49059 */   // GIR_Coverage, 1784,
     /*  49059 */   GIR_EraseRootFromParent_Done,
     /*  49060 */ // Label 1165: @49060
     /*  49060 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(49119), // Rule ID 10353 //
     /*  49065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49083 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49086 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49090 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49094 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49096 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49103 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrm),
     /*  49106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49108 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49117 */   GIR_RootConstrainSelectedInstOperands,
     /*  49118 */   // GIR_Coverage, 10353,
     /*  49118 */   GIR_EraseRootFromParent_Done,
     /*  49119 */ // Label 1166: @49119
     /*  49119 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(49178), // Rule ID 10357 //
     /*  49124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49142 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49145 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49149 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49155 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49162 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrm),
     /*  49165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49167 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49176 */   GIR_RootConstrainSelectedInstOperands,
     /*  49177 */   // GIR_Coverage, 10357,
     /*  49177 */   GIR_EraseRootFromParent_Done,
     /*  49178 */ // Label 1167: @49178
     /*  49178 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(49237), // Rule ID 22171 //
     /*  49183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49193 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49201 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49204 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49208 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49214 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49221 */   // (lrint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /*  49224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49226 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49235 */   GIR_RootConstrainSelectedInstOperands,
     /*  49236 */   // GIR_Coverage, 22171,
     /*  49236 */   GIR_EraseRootFromParent_Done,
     /*  49237 */ // Label 1168: @49237
     /*  49237 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(49267), // Rule ID 1755 //
     /*  49242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49256 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /*  49261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49265 */   GIR_RootConstrainSelectedInstOperands,
     /*  49266 */   // GIR_Coverage, 1755,
     /*  49266 */   GIR_Done,
     /*  49267 */ // Label 1169: @49267
     /*  49267 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(49297), // Rule ID 1759 //
     /*  49272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49286 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /*  49291 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49295 */   GIR_RootConstrainSelectedInstOperands,
     /*  49296 */   // GIR_Coverage, 1759,
     /*  49296 */   GIR_Done,
     /*  49297 */ // Label 1170: @49297
     /*  49297 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(49327), // Rule ID 1779 //
     /*  49302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49316 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /*  49321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49325 */   GIR_RootConstrainSelectedInstOperands,
     /*  49326 */   // GIR_Coverage, 1779,
     /*  49326 */   GIR_Done,
     /*  49327 */ // Label 1171: @49327
     /*  49327 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(49357), // Rule ID 1783 //
     /*  49332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49346 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /*  49351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49355 */   GIR_RootConstrainSelectedInstOperands,
     /*  49356 */   // GIR_Coverage, 1783,
     /*  49356 */   GIR_Done,
     /*  49357 */ // Label 1172: @49357
     /*  49357 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(49387), // Rule ID 10352 //
     /*  49362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  49376 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  49376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /*  49381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49385 */   GIR_RootConstrainSelectedInstOperands,
     /*  49386 */   // GIR_Coverage, 10352,
     /*  49386 */   GIR_Done,
     /*  49387 */ // Label 1173: @49387
     /*  49387 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(49417), // Rule ID 10356 //
     /*  49392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  49406 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /*  49406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /*  49411 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49415 */   GIR_RootConstrainSelectedInstOperands,
     /*  49416 */   // GIR_Coverage, 10356,
     /*  49416 */   GIR_Done,
     /*  49417 */ // Label 1174: @49417
     /*  49417 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(49447), // Rule ID 22170 //
     /*  49422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  49436 */   // (lrint:{ *:[i32] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src)
     /*  49436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49441 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49445 */   GIR_RootConstrainSelectedInstOperands,
     /*  49446 */   // GIR_Coverage, 22170,
     /*  49446 */   GIR_Done,
     /*  49447 */ // Label 1175: @49447
     /*  49447 */ GIM_Reject,
     /*  49448 */ // Label 1150: @49448
     /*  49448 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(49507), // Rule ID 17990 //
     /*  49453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49471 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49474 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49478 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49484 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49491 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  49494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49496 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49505 */   GIR_RootConstrainSelectedInstOperands,
     /*  49506 */   // GIR_Coverage, 17990,
     /*  49506 */   GIR_EraseRootFromParent_Done,
     /*  49507 */ // Label 1176: @49507
     /*  49507 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(49566), // Rule ID 17992 //
     /*  49512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49530 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49533 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49537 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49543 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49550 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  49553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49555 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49564 */   GIR_RootConstrainSelectedInstOperands,
     /*  49565 */   // GIR_Coverage, 17992,
     /*  49565 */   GIR_EraseRootFromParent_Done,
     /*  49566 */ // Label 1177: @49566
     /*  49566 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(49625), // Rule ID 17994 //
     /*  49571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49589 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49596 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49602 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49609 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  49612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49614 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49623 */   GIR_RootConstrainSelectedInstOperands,
     /*  49624 */   // GIR_Coverage, 17994,
     /*  49624 */   GIR_EraseRootFromParent_Done,
     /*  49625 */ // Label 1178: @49625
     /*  49625 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(49684), // Rule ID 17996 //
     /*  49630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49640 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49644 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49648 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49651 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49655 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49661 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49668 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  49671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49673 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49682 */   GIR_RootConstrainSelectedInstOperands,
     /*  49683 */   // GIR_Coverage, 17996,
     /*  49683 */   GIR_EraseRootFromParent_Done,
     /*  49684 */ // Label 1179: @49684
     /*  49684 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(49743), // Rule ID 21160 //
     /*  49689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49699 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49703 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49707 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49710 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49714 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49718 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49720 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49727 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  49730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49732 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49741 */   GIR_RootConstrainSelectedInstOperands,
     /*  49742 */   // GIR_Coverage, 21160,
     /*  49742 */   GIR_EraseRootFromParent_Done,
     /*  49743 */ // Label 1180: @49743
     /*  49743 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(49802), // Rule ID 21162 //
     /*  49748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49766 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49773 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49779 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49786 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  49789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49791 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49800 */   GIR_RootConstrainSelectedInstOperands,
     /*  49801 */   // GIR_Coverage, 21162,
     /*  49801 */   GIR_EraseRootFromParent_Done,
     /*  49802 */ // Label 1181: @49802
     /*  49802 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(49861), // Rule ID 22173 //
     /*  49807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  49810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49817 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49825 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49828 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49832 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49838 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49845 */   // (lrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  49848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49850 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49859 */   GIR_RootConstrainSelectedInstOperands,
     /*  49860 */   // GIR_Coverage, 22173,
     /*  49860 */   GIR_EraseRootFromParent_Done,
     /*  49861 */ // Label 1182: @49861
     /*  49861 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(49891), // Rule ID 17989 //
     /*  49866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49880 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  49885 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49889 */   GIR_RootConstrainSelectedInstOperands,
     /*  49890 */   // GIR_Coverage, 17989,
     /*  49890 */   GIR_Done,
     /*  49891 */ // Label 1183: @49891
     /*  49891 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(49921), // Rule ID 17991 //
     /*  49896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49910 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  49910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  49915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49919 */   GIR_RootConstrainSelectedInstOperands,
     /*  49920 */   // GIR_Coverage, 17991,
     /*  49920 */   GIR_Done,
     /*  49921 */ // Label 1184: @49921
     /*  49921 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(49951), // Rule ID 17993 //
     /*  49926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49940 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  49945 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49949 */   GIR_RootConstrainSelectedInstOperands,
     /*  49950 */   // GIR_Coverage, 17993,
     /*  49950 */   GIR_Done,
     /*  49951 */ // Label 1185: @49951
     /*  49951 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(49981), // Rule ID 17995 //
     /*  49956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49970 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  49970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  49975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49979 */   GIR_RootConstrainSelectedInstOperands,
     /*  49980 */   // GIR_Coverage, 17995,
     /*  49980 */   GIR_Done,
     /*  49981 */ // Label 1186: @49981
     /*  49981 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(50011), // Rule ID 21159 //
     /*  49986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50000 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  50005 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50009 */   GIR_RootConstrainSelectedInstOperands,
     /*  50010 */   // GIR_Coverage, 21159,
     /*  50010 */   GIR_Done,
     /*  50011 */ // Label 1187: @50011
     /*  50011 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(50041), // Rule ID 21161 //
     /*  50016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50030 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  50035 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50039 */   GIR_RootConstrainSelectedInstOperands,
     /*  50040 */   // GIR_Coverage, 21161,
     /*  50040 */   GIR_Done,
     /*  50041 */ // Label 1188: @50041
     /*  50041 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(50071), // Rule ID 22172 //
     /*  50046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  50060 */   // (lrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  50060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  50065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50069 */   GIR_RootConstrainSelectedInstOperands,
     /*  50070 */   // GIR_Coverage, 22172,
     /*  50070 */   GIR_Done,
     /*  50071 */ // Label 1189: @50071
     /*  50071 */ GIM_Reject,
     /*  50072 */ // Label 1151: @50072
     /*  50072 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(50160),
     /*  50077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  50080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50084 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(50136), // Rule ID 21385 //
     /*  50089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50120 */     // (lrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  50120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  50123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50134 */     GIR_RootConstrainSelectedInstOperands,
     /*  50135 */     // GIR_Coverage, 21385,
     /*  50135 */     GIR_EraseRootFromParent_Done,
     /*  50136 */   // Label 1191: @50136
     /*  50136 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(50159), // Rule ID 21384 //
     /*  50141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50148 */     // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  50148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  50153 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50157 */     GIR_RootConstrainSelectedInstOperands,
     /*  50158 */     // GIR_Coverage, 21384,
     /*  50158 */     GIR_Done,
     /*  50159 */   // Label 1192: @50159
     /*  50159 */   GIM_Reject,
     /*  50160 */ // Label 1190: @50160
     /*  50160 */ GIM_Reject,
     /*  50161 */ // Label 1152: @50161
     /*  50161 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(50220), // Rule ID 18044 //
     /*  50166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50176 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50180 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50184 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50187 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50191 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50197 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50204 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrm),
     /*  50207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50209 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50218 */   GIR_RootConstrainSelectedInstOperands,
     /*  50219 */   // GIR_Coverage, 18044,
     /*  50219 */   GIR_EraseRootFromParent_Done,
     /*  50220 */ // Label 1193: @50220
     /*  50220 */ GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(50279), // Rule ID 18048 //
     /*  50225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50235 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50243 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50250 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50254 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50256 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50263 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrm),
     /*  50266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50268 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50277 */   GIR_RootConstrainSelectedInstOperands,
     /*  50278 */   // GIR_Coverage, 18048,
     /*  50278 */   GIR_EraseRootFromParent_Done,
     /*  50279 */ // Label 1194: @50279
     /*  50279 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(50338), // Rule ID 18050 //
     /*  50284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50302 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50305 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50309 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50313 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50315 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50322 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrm),
     /*  50325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50327 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50331 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50336 */   GIR_RootConstrainSelectedInstOperands,
     /*  50337 */   // GIR_Coverage, 18050,
     /*  50337 */   GIR_EraseRootFromParent_Done,
     /*  50338 */ // Label 1195: @50338
     /*  50338 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(50397), // Rule ID 21357 //
     /*  50343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50353 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50361 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50364 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50368 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50374 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50381 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rm),
     /*  50384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50386 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50395 */   GIR_RootConstrainSelectedInstOperands,
     /*  50396 */   // GIR_Coverage, 21357,
     /*  50396 */   GIR_EraseRootFromParent_Done,
     /*  50397 */ // Label 1196: @50397
     /*  50397 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(50456), // Rule ID 21361 //
     /*  50402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50420 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50423 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50427 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50433 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50440 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZ256rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rm),
     /*  50443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50445 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50449 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50454 */   GIR_RootConstrainSelectedInstOperands,
     /*  50455 */   // GIR_Coverage, 21361,
     /*  50455 */   GIR_EraseRootFromParent_Done,
     /*  50456 */ // Label 1197: @50456
     /*  50456 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(50486), // Rule ID 18043 //
     /*  50461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50475 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /*  50480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50484 */   GIR_RootConstrainSelectedInstOperands,
     /*  50485 */   // GIR_Coverage, 18043,
     /*  50485 */   GIR_Done,
     /*  50486 */ // Label 1198: @50486
     /*  50486 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(50516), // Rule ID 18047 //
     /*  50491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50505 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /*  50505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /*  50510 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50514 */   GIR_RootConstrainSelectedInstOperands,
     /*  50515 */   // GIR_Coverage, 18047,
     /*  50515 */   GIR_Done,
     /*  50516 */ // Label 1199: @50516
     /*  50516 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(50546), // Rule ID 18049 //
     /*  50521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50535 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /*  50540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50544 */   GIR_RootConstrainSelectedInstOperands,
     /*  50545 */   // GIR_Coverage, 18049,
     /*  50545 */   GIR_Done,
     /*  50546 */ // Label 1200: @50546
     /*  50546 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(50576), // Rule ID 21356 //
     /*  50551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50565 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /*  50565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /*  50570 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50574 */   GIR_RootConstrainSelectedInstOperands,
     /*  50575 */   // GIR_Coverage, 21356,
     /*  50575 */   GIR_Done,
     /*  50576 */ // Label 1201: @50576
     /*  50576 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(50606), // Rule ID 21360 //
     /*  50581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50595 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /*  50595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /*  50600 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50604 */   GIR_RootConstrainSelectedInstOperands,
     /*  50605 */   // GIR_Coverage, 21360,
     /*  50605 */   GIR_Done,
     /*  50606 */ // Label 1202: @50606
     /*  50606 */ GIM_Reject,
     /*  50607 */ // Label 1153: @50607
     /*  50607 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(50666), // Rule ID 21381 //
     /*  50612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50622 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50630 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50637 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50643 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50650 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  50653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50655 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50664 */   GIR_RootConstrainSelectedInstOperands,
     /*  50665 */   // GIR_Coverage, 21381,
     /*  50665 */   GIR_EraseRootFromParent_Done,
     /*  50666 */ // Label 1203: @50666
     /*  50666 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(50725), // Rule ID 21387 //
     /*  50671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50689 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50696 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50702 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50709 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  50712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50714 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50723 */   GIR_RootConstrainSelectedInstOperands,
     /*  50724 */   // GIR_Coverage, 21387,
     /*  50724 */   GIR_EraseRootFromParent_Done,
     /*  50725 */ // Label 1204: @50725
     /*  50725 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(50755), // Rule ID 21380 //
     /*  50730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50744 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  50744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  50749 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50753 */   GIR_RootConstrainSelectedInstOperands,
     /*  50754 */   // GIR_Coverage, 21380,
     /*  50754 */   GIR_Done,
     /*  50755 */ // Label 1205: @50755
     /*  50755 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(50785), // Rule ID 21386 //
     /*  50760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50774 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  50774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  50779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50783 */   GIR_RootConstrainSelectedInstOperands,
     /*  50784 */   // GIR_Coverage, 21386,
     /*  50784 */   GIR_Done,
     /*  50785 */ // Label 1206: @50785
     /*  50785 */ GIM_Reject,
     /*  50786 */ // Label 1154: @50786
     /*  50786 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(50874),
     /*  50791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50798 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(50850), // Rule ID 22156 //
     /*  50803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  50806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50834 */     // (lrint:{ *:[v8i16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  50834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rm),
     /*  50837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50848 */     GIR_RootConstrainSelectedInstOperands,
     /*  50849 */     // GIR_Coverage, 22156,
     /*  50849 */     GIR_EraseRootFromParent_Done,
     /*  50850 */   // Label 1208: @50850
     /*  50850 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(50873), // Rule ID 22155 //
     /*  50855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  50858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50862 */     // (lrint:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2WZ128rr:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)
     /*  50862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rr),
     /*  50867 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50871 */     GIR_RootConstrainSelectedInstOperands,
     /*  50872 */     // GIR_Coverage, 22155,
     /*  50872 */     GIR_Done,
     /*  50873 */   // Label 1209: @50873
     /*  50873 */   GIM_Reject,
     /*  50874 */ // Label 1207: @50874
     /*  50874 */ GIM_Reject,
     /*  50875 */ // Label 1155: @50875
     /*  50875 */ GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(50934), // Rule ID 18046 //
     /*  50880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  50886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50898 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50905 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50911 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50918 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  50918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrm),
     /*  50921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50923 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50932 */   GIR_RootConstrainSelectedInstOperands,
     /*  50933 */   // GIR_Coverage, 18046,
     /*  50933 */   GIR_EraseRootFromParent_Done,
     /*  50934 */ // Label 1210: @50934
     /*  50934 */ GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(50993), // Rule ID 21359 //
     /*  50939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  50945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50957 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50960 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50964 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50970 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50977 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  50977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rm),
     /*  50980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50982 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50991 */   GIR_RootConstrainSelectedInstOperands,
     /*  50992 */   // GIR_Coverage, 21359,
     /*  50992 */   GIR_EraseRootFromParent_Done,
     /*  50993 */ // Label 1211: @50993
     /*  50993 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(51049), // Rule ID 21365 //
     /*  50998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51013 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51020 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51026 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51033 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrm),
     /*  51036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51038 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51047 */   GIR_RootConstrainSelectedInstOperands,
     /*  51048 */   // GIR_Coverage, 21365,
     /*  51048 */   GIR_EraseRootFromParent_Done,
     /*  51049 */ // Label 1212: @51049
     /*  51049 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(51108), // Rule ID 22160 //
     /*  51054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51072 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51079 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51085 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51092 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rm),
     /*  51095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51097 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51106 */   GIR_RootConstrainSelectedInstOperands,
     /*  51107 */   // GIR_Coverage, 22160,
     /*  51107 */   GIR_EraseRootFromParent_Done,
     /*  51108 */ // Label 1213: @51108
     /*  51108 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(51138), // Rule ID 18045 //
     /*  51113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51127 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /*  51127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /*  51132 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51136 */   GIR_RootConstrainSelectedInstOperands,
     /*  51137 */   // GIR_Coverage, 18045,
     /*  51137 */   GIR_Done,
     /*  51138 */ // Label 1214: @51138
     /*  51138 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(51168), // Rule ID 21358 //
     /*  51143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51157 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /*  51157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /*  51162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51166 */   GIR_RootConstrainSelectedInstOperands,
     /*  51167 */   // GIR_Coverage, 21358,
     /*  51167 */   GIR_Done,
     /*  51168 */ // Label 1215: @51168
     /*  51168 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(51195), // Rule ID 21364 //
     /*  51173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51184 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /*  51184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /*  51189 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51193 */   GIR_RootConstrainSelectedInstOperands,
     /*  51194 */   // GIR_Coverage, 21364,
     /*  51194 */   GIR_Done,
     /*  51195 */ // Label 1216: @51195
     /*  51195 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(51225), // Rule ID 22159 //
     /*  51200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51214 */   // (lrint:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2DQZ256rr:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)
     /*  51214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rr),
     /*  51219 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51223 */   GIR_RootConstrainSelectedInstOperands,
     /*  51224 */   // GIR_Coverage, 22159,
     /*  51224 */   GIR_Done,
     /*  51225 */ // Label 1217: @51225
     /*  51225 */ GIM_Reject,
     /*  51226 */ // Label 1156: @51226
     /*  51226 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(51285), // Rule ID 21393 //
     /*  51231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51249 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51252 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51256 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51262 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51269 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  51272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51274 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51283 */   GIR_RootConstrainSelectedInstOperands,
     /*  51284 */   // GIR_Coverage, 21393,
     /*  51284 */   GIR_EraseRootFromParent_Done,
     /*  51285 */ // Label 1218: @51285
     /*  51285 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(51344), // Rule ID 21397 //
     /*  51290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51308 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51315 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51321 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51328 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  51331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51333 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51337 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51342 */   GIR_RootConstrainSelectedInstOperands,
     /*  51343 */   // GIR_Coverage, 21397,
     /*  51343 */   GIR_EraseRootFromParent_Done,
     /*  51344 */ // Label 1219: @51344
     /*  51344 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(51403), // Rule ID 22166 //
     /*  51349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51367 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51370 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51374 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51378 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51380 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51387 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  51390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51392 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51401 */   GIR_RootConstrainSelectedInstOperands,
     /*  51402 */   // GIR_Coverage, 22166,
     /*  51402 */   GIR_EraseRootFromParent_Done,
     /*  51403 */ // Label 1220: @51403
     /*  51403 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(51433), // Rule ID 21392 //
     /*  51408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51422 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  51422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  51427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51431 */   GIR_RootConstrainSelectedInstOperands,
     /*  51432 */   // GIR_Coverage, 21392,
     /*  51432 */   GIR_Done,
     /*  51433 */ // Label 1221: @51433
     /*  51433 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(51463), // Rule ID 21396 //
     /*  51438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51452 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  51452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  51457 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51461 */   GIR_RootConstrainSelectedInstOperands,
     /*  51462 */   // GIR_Coverage, 21396,
     /*  51462 */   GIR_Done,
     /*  51463 */ // Label 1222: @51463
     /*  51463 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(51493), // Rule ID 22165 //
     /*  51468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51482 */   // (lrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  51482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  51487 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51491 */   GIR_RootConstrainSelectedInstOperands,
     /*  51492 */   // GIR_Coverage, 22165,
     /*  51492 */   GIR_Done,
     /*  51493 */ // Label 1223: @51493
     /*  51493 */ GIM_Reject,
     /*  51494 */ // Label 1157: @51494
     /*  51494 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(51582),
     /*  51499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51506 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(51558), // Rule ID 22158 //
     /*  51511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51542 */     // (lrint:{ *:[v16i16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  51542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rm),
     /*  51545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51556 */     GIR_RootConstrainSelectedInstOperands,
     /*  51557 */     // GIR_Coverage, 22158,
     /*  51557 */     GIR_EraseRootFromParent_Done,
     /*  51558 */   // Label 1225: @51558
     /*  51558 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(51581), // Rule ID 22157 //
     /*  51563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51570 */     // (lrint:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2WZ256rr:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)
     /*  51570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rr),
     /*  51575 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51579 */     GIR_RootConstrainSelectedInstOperands,
     /*  51580 */     // GIR_Coverage, 22157,
     /*  51580 */     GIR_Done,
     /*  51581 */   // Label 1226: @51581
     /*  51581 */   GIM_Reject,
     /*  51582 */ // Label 1224: @51582
     /*  51582 */ GIM_Reject,
     /*  51583 */ // Label 1158: @51583
     /*  51583 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(51639), // Rule ID 21363 //
     /*  51588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51603 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51610 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51614 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51616 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51623 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrm),
     /*  51626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51628 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51637 */   GIR_RootConstrainSelectedInstOperands,
     /*  51638 */   // GIR_Coverage, 21363,
     /*  51638 */   GIR_EraseRootFromParent_Done,
     /*  51639 */ // Label 1227: @51639
     /*  51639 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(51698), // Rule ID 22164 //
     /*  51644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51654 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51658 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51662 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51665 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51669 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51675 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51682 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrm),
     /*  51685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51687 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51696 */   GIR_RootConstrainSelectedInstOperands,
     /*  51697 */   // GIR_Coverage, 22164,
     /*  51697 */   GIR_EraseRootFromParent_Done,
     /*  51698 */ // Label 1228: @51698
     /*  51698 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(51725), // Rule ID 21362 //
     /*  51703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51714 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /*  51714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /*  51719 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51723 */   GIR_RootConstrainSelectedInstOperands,
     /*  51724 */   // GIR_Coverage, 21362,
     /*  51724 */   GIR_Done,
     /*  51725 */ // Label 1229: @51725
     /*  51725 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(51755), // Rule ID 22163 //
     /*  51730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51744 */   // (lrint:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2DQZrr:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)
     /*  51744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrr),
     /*  51749 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51753 */   GIR_RootConstrainSelectedInstOperands,
     /*  51754 */   // GIR_Coverage, 22163,
     /*  51754 */   GIR_Done,
     /*  51755 */ // Label 1230: @51755
     /*  51755 */ GIM_Reject,
     /*  51756 */ // Label 1159: @51756
     /*  51756 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(51844),
     /*  51761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  51764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51768 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(51820), // Rule ID 22162 //
     /*  51773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51804 */     // (lrint:{ *:[v32i16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  51804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrm),
     /*  51807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51818 */     GIR_RootConstrainSelectedInstOperands,
     /*  51819 */     // GIR_Coverage, 22162,
     /*  51819 */     GIR_EraseRootFromParent_Done,
     /*  51820 */   // Label 1232: @51820
     /*  51820 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(51843), // Rule ID 22161 //
     /*  51825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51832 */     // (lrint:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)  =>  (VCVTPH2WZrr:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)
     /*  51832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrr),
     /*  51837 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51841 */     GIR_RootConstrainSelectedInstOperands,
     /*  51842 */     // GIR_Coverage, 22161,
     /*  51842 */     GIR_Done,
     /*  51843 */   // Label 1233: @51843
     /*  51843 */   GIM_Reject,
     /*  51844 */ // Label 1231: @51844
     /*  51844 */ GIM_Reject,
     /*  51845 */ // Label 1160: @51845
     /*  51845 */ GIM_Reject,
     /*  51846 */ // Label 9: @51846
     /*  51846 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 1238*/ GIMT_Encode4(53065),
     /*  51857 */ /*GILLT_s64*//*Label 1234*/ GIMT_Encode4(51905), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51873 */ /*GILLT_v2s64*//*Label 1235*/ GIMT_Encode4(52529), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51885 */ /*GILLT_v4s64*//*Label 1236*/ GIMT_Encode4(52618), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51901 */ /*GILLT_v8s64*//*Label 1237*/ GIMT_Encode4(52797),
     /*  51905 */ // Label 1234: @51905
     /*  51905 */ GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(51964), // Rule ID 1758 //
     /*  51910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  51913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  51920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51928 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51931 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51935 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51939 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51941 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51948 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  51948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  51951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51953 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51962 */   GIR_RootConstrainSelectedInstOperands,
     /*  51963 */   // GIR_Coverage, 1758,
     /*  51963 */   GIR_EraseRootFromParent_Done,
     /*  51964 */ // Label 1239: @51964
     /*  51964 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(52023), // Rule ID 1762 //
     /*  51969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  51972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  51975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  51979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51987 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51990 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51994 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52000 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52007 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  52010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52012 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52021 */   GIR_RootConstrainSelectedInstOperands,
     /*  52022 */   // GIR_Coverage, 1762,
     /*  52022 */   GIR_EraseRootFromParent_Done,
     /*  52023 */ // Label 1240: @52023
     /*  52023 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(52082), // Rule ID 1782 //
     /*  52028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52046 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52049 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52053 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52059 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52066 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  52069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52071 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52075 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52080 */   GIR_RootConstrainSelectedInstOperands,
     /*  52081 */   // GIR_Coverage, 1782,
     /*  52081 */   GIR_EraseRootFromParent_Done,
     /*  52082 */ // Label 1241: @52082
     /*  52082 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(52141), // Rule ID 1786 //
     /*  52087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52097 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52101 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52105 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52108 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52112 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52118 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52125 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  52128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52130 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52139 */   GIR_RootConstrainSelectedInstOperands,
     /*  52140 */   // GIR_Coverage, 1786,
     /*  52140 */   GIR_EraseRootFromParent_Done,
     /*  52141 */ // Label 1242: @52141
     /*  52141 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(52200), // Rule ID 10355 //
     /*  52146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52156 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52164 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52171 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52177 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52184 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  52187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52189 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52193 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52198 */   GIR_RootConstrainSelectedInstOperands,
     /*  52199 */   // GIR_Coverage, 10355,
     /*  52199 */   GIR_EraseRootFromParent_Done,
     /*  52200 */ // Label 1243: @52200
     /*  52200 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(52259), // Rule ID 10359 //
     /*  52205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52215 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52219 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52223 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52230 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52236 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52243 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  52246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52248 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52257 */   GIR_RootConstrainSelectedInstOperands,
     /*  52258 */   // GIR_Coverage, 10359,
     /*  52258 */   GIR_EraseRootFromParent_Done,
     /*  52259 */ // Label 1244: @52259
     /*  52259 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(52318), // Rule ID 22175 //
     /*  52264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52282 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52285 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52289 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52295 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52302 */   // (llrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  52305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52307 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52316 */   GIR_RootConstrainSelectedInstOperands,
     /*  52317 */   // GIR_Coverage, 22175,
     /*  52317 */   GIR_EraseRootFromParent_Done,
     /*  52318 */ // Label 1245: @52318
     /*  52318 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(52348), // Rule ID 1757 //
     /*  52323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52337 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  52342 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52346 */   GIR_RootConstrainSelectedInstOperands,
     /*  52347 */   // GIR_Coverage, 1757,
     /*  52347 */   GIR_Done,
     /*  52348 */ // Label 1246: @52348
     /*  52348 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(52378), // Rule ID 1761 //
     /*  52353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52367 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  52372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52376 */   GIR_RootConstrainSelectedInstOperands,
     /*  52377 */   // GIR_Coverage, 1761,
     /*  52377 */   GIR_Done,
     /*  52378 */ // Label 1247: @52378
     /*  52378 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(52408), // Rule ID 1781 //
     /*  52383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52397 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  52402 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52406 */   GIR_RootConstrainSelectedInstOperands,
     /*  52407 */   // GIR_Coverage, 1781,
     /*  52407 */   GIR_Done,
     /*  52408 */ // Label 1248: @52408
     /*  52408 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(52438), // Rule ID 1785 //
     /*  52413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52427 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  52432 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52436 */   GIR_RootConstrainSelectedInstOperands,
     /*  52437 */   // GIR_Coverage, 1785,
     /*  52437 */   GIR_Done,
     /*  52438 */ // Label 1249: @52438
     /*  52438 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(52468), // Rule ID 10354 //
     /*  52443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  52457 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /*  52457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  52462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52466 */   GIR_RootConstrainSelectedInstOperands,
     /*  52467 */   // GIR_Coverage, 10354,
     /*  52467 */   GIR_Done,
     /*  52468 */ // Label 1250: @52468
     /*  52468 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(52498), // Rule ID 10358 //
     /*  52473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  52487 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  52487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  52492 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52496 */   GIR_RootConstrainSelectedInstOperands,
     /*  52497 */   // GIR_Coverage, 10358,
     /*  52497 */   GIR_Done,
     /*  52498 */ // Label 1251: @52498
     /*  52498 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(52528), // Rule ID 22174 //
     /*  52503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  52517 */   // (llrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  52517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  52522 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52526 */   GIR_RootConstrainSelectedInstOperands,
     /*  52527 */   // GIR_Coverage, 22174,
     /*  52527 */   GIR_Done,
     /*  52528 */ // Label 1252: @52528
     /*  52528 */ GIM_Reject,
     /*  52529 */ // Label 1235: @52529
     /*  52529 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(52617),
     /*  52534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52541 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(52593), // Rule ID 21389 //
     /*  52546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52557 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52564 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52577 */     // (llrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  52577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  52580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52591 */     GIR_RootConstrainSelectedInstOperands,
     /*  52592 */     // GIR_Coverage, 21389,
     /*  52592 */     GIR_EraseRootFromParent_Done,
     /*  52593 */   // Label 1254: @52593
     /*  52593 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(52616), // Rule ID 21388 //
     /*  52598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52605 */     // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  52605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  52610 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52614 */     GIR_RootConstrainSelectedInstOperands,
     /*  52615 */     // GIR_Coverage, 21388,
     /*  52615 */     GIR_Done,
     /*  52616 */   // Label 1255: @52616
     /*  52616 */   GIM_Reject,
     /*  52617 */ // Label 1253: @52617
     /*  52617 */ GIM_Reject,
     /*  52618 */ // Label 1236: @52618
     /*  52618 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(52677), // Rule ID 21383 //
     /*  52623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52641 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52644 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52648 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52654 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52661 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  52664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52666 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52670 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52675 */   GIR_RootConstrainSelectedInstOperands,
     /*  52676 */   // GIR_Coverage, 21383,
     /*  52676 */   GIR_EraseRootFromParent_Done,
     /*  52677 */ // Label 1256: @52677
     /*  52677 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(52736), // Rule ID 21391 //
     /*  52682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52700 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52707 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52713 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52720 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  52723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52725 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52734 */   GIR_RootConstrainSelectedInstOperands,
     /*  52735 */   // GIR_Coverage, 21391,
     /*  52735 */   GIR_EraseRootFromParent_Done,
     /*  52736 */ // Label 1257: @52736
     /*  52736 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(52766), // Rule ID 21382 //
     /*  52741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52755 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  52755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  52760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52764 */   GIR_RootConstrainSelectedInstOperands,
     /*  52765 */   // GIR_Coverage, 21382,
     /*  52765 */   GIR_Done,
     /*  52766 */ // Label 1258: @52766
     /*  52766 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(52796), // Rule ID 21390 //
     /*  52771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52785 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  52785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  52790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52794 */   GIR_RootConstrainSelectedInstOperands,
     /*  52795 */   // GIR_Coverage, 21390,
     /*  52795 */   GIR_Done,
     /*  52796 */ // Label 1259: @52796
     /*  52796 */ GIM_Reject,
     /*  52797 */ // Label 1237: @52797
     /*  52797 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(52856), // Rule ID 21395 //
     /*  52802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  52808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52820 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52827 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52833 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52840 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  52843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52845 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52854 */   GIR_RootConstrainSelectedInstOperands,
     /*  52855 */   // GIR_Coverage, 21395,
     /*  52855 */   GIR_EraseRootFromParent_Done,
     /*  52856 */ // Label 1260: @52856
     /*  52856 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(52915), // Rule ID 21399 //
     /*  52861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  52867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52879 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52882 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52886 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52892 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52899 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  52902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52904 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52913 */   GIR_RootConstrainSelectedInstOperands,
     /*  52914 */   // GIR_Coverage, 21399,
     /*  52914 */   GIR_EraseRootFromParent_Done,
     /*  52915 */ // Label 1261: @52915
     /*  52915 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(52974), // Rule ID 22168 //
     /*  52920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  52923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52930 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52934 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52938 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52941 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52945 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52951 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52958 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  52961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52963 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52972 */   GIR_RootConstrainSelectedInstOperands,
     /*  52973 */   // GIR_Coverage, 22168,
     /*  52973 */   GIR_EraseRootFromParent_Done,
     /*  52974 */ // Label 1262: @52974
     /*  52974 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(53004), // Rule ID 21394 //
     /*  52979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  52985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52993 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  52993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  52998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53002 */   GIR_RootConstrainSelectedInstOperands,
     /*  53003 */   // GIR_Coverage, 21394,
     /*  53003 */   GIR_Done,
     /*  53004 */ // Label 1263: @53004
     /*  53004 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(53034), // Rule ID 21398 //
     /*  53009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53023 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  53023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  53028 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53032 */   GIR_RootConstrainSelectedInstOperands,
     /*  53033 */   // GIR_Coverage, 21398,
     /*  53033 */   GIR_Done,
     /*  53034 */ // Label 1264: @53034
     /*  53034 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(53064), // Rule ID 22167 //
     /*  53039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  53053 */   // (llrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  53053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  53058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53062 */   GIR_RootConstrainSelectedInstOperands,
     /*  53063 */   // GIR_Coverage, 22167,
     /*  53063 */   GIR_Done,
     /*  53064 */ // Label 1265: @53064
     /*  53064 */ GIM_Reject,
     /*  53065 */ // Label 1238: @53065
     /*  53065 */ GIM_Reject,
     /*  53066 */ // Label 10: @53066
     /*  53066 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 1291*/ GIMT_Encode4(59290),
     /*  53077 */ /*GILLT_s1*//*Label 1266*/ GIMT_Encode4(53177),
     /*  53081 */ /*GILLT_s8*//*Label 1267*/ GIMT_Encode4(53244),
     /*  53085 */ /*GILLT_s16*//*Label 1268*/ GIMT_Encode4(53385),
     /*  53089 */ /*GILLT_s32*//*Label 1269*/ GIMT_Encode4(53938),
     /*  53093 */ /*GILLT_s64*//*Label 1270*/ GIMT_Encode4(54360),
     /*  53097 */ /*GILLT_s80*//*Label 1271*/ GIMT_Encode4(54933),
     /*  53101 */ /*GILLT_s128*//*Label 1272*/ GIMT_Encode4(55092),
     /*  53105 */ /*GILLT_v2s1*//*Label 1273*/ GIMT_Encode4(55220),
     /*  53109 */ /*GILLT_v2s64*//*Label 1274*/ GIMT_Encode4(55287),
     /*  53113 */ /*GILLT_v4s1*//*Label 1275*/ GIMT_Encode4(55781),
     /*  53117 */ /*GILLT_v4s32*//*Label 1276*/ GIMT_Encode4(55848),
     /*  53121 */ /*GILLT_v4s64*//*Label 1277*/ GIMT_Encode4(56342),
     /*  53125 */ /*GILLT_v8s1*//*Label 1278*/ GIMT_Encode4(56676),
     /*  53129 */ /*GILLT_v8s16*//*Label 1279*/ GIMT_Encode4(56758),
     /*  53133 */ /*GILLT_v8s32*//*Label 1280*/ GIMT_Encode4(57332),
     /*  53137 */ /*GILLT_v8s64*//*Label 1281*/ GIMT_Encode4(57666),
     /*  53141 */ /*GILLT_v16s1*//*Label 1282*/ GIMT_Encode4(57840),
     /*  53145 */ /*GILLT_v16s8*//*Label 1283*/ GIMT_Encode4(57922),
     /*  53149 */ /*GILLT_v16s16*//*Label 1284*/ GIMT_Encode4(58176),
     /*  53153 */ /*GILLT_v16s32*//*Label 1285*/ GIMT_Encode4(58510),
     /*  53157 */ /*GILLT_v32s1*//*Label 1286*/ GIMT_Encode4(58684),
     /*  53161 */ /*GILLT_v32s8*//*Label 1287*/ GIMT_Encode4(58766),
     /*  53165 */ /*GILLT_v32s16*//*Label 1288*/ GIMT_Encode4(58940),
     /*  53169 */ /*GILLT_v64s1*//*Label 1289*/ GIMT_Encode4(59114),
     /*  53173 */ /*GILLT_v64s8*//*Label 1290*/ GIMT_Encode4(59196),
     /*  53177 */ // Label 1266: @53177
     /*  53177 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(53243), // Rule ID 19445 //
     /*  53182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53185 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  53196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53207 */   // (ld:{ *:[v1i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK1:{ *:[i32] })
     /*  53207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  53210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  53214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53219 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53223 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  53242 */   // GIR_Coverage, 19445,
     /*  53242 */   GIR_EraseRootFromParent_Done,
     /*  53243 */ // Label 1292: @53243
     /*  53243 */ GIM_Reject,
     /*  53244 */ // Label 1267: @53244
     /*  53244 */ GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(53293), // Rule ID 22515 //
     /*  53249 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53252 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53267 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53278 */   // (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53283 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53291 */   GIR_RootConstrainSelectedInstOperands,
     /*  53292 */   // GIR_Coverage, 22515,
     /*  53292 */   GIR_EraseRootFromParent_Done,
     /*  53293 */ // Label 1293: @53293
     /*  53293 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(53342), // Rule ID 22580 //
     /*  53298 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53301 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53305 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53320 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53327 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53332 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53336 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53340 */   GIR_RootConstrainSelectedInstOperands,
     /*  53341 */   // GIR_Coverage, 22580,
     /*  53341 */   GIR_EraseRootFromParent_Done,
     /*  53342 */ // Label 1294: @53342
     /*  53342 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(53384), // Rule ID 28 //
     /*  53347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53358 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  53362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53369 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53374 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53382 */   GIR_RootConstrainSelectedInstOperands,
     /*  53383 */   // GIR_Coverage, 28,
     /*  53383 */   GIR_EraseRootFromParent_Done,
     /*  53384 */ // Label 1295: @53384
     /*  53384 */ GIM_Reject,
     /*  53385 */ // Label 1268: @53385
     /*  53385 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(53430), // Rule ID 4621 //
     /*  53390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53415 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSHZrm_alt:{ *:[f16] } addr:{ *:[iPTR] }:$src)
     /*  53415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZrm_alt),
     /*  53418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53420 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53428 */   GIR_RootConstrainSelectedInstOperands,
     /*  53429 */   // GIR_Coverage, 4621,
     /*  53429 */   GIR_EraseRootFromParent_Done,
     /*  53430 */ // Label 1296: @53430
     /*  53430 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(53479), // Rule ID 22516 //
     /*  53435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53442 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  53449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53453 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53457 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53464 */   // (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53469 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53477 */   GIR_RootConstrainSelectedInstOperands,
     /*  53478 */   // GIR_Coverage, 22516,
     /*  53478 */   GIR_EraseRootFromParent_Done,
     /*  53479 */ // Label 1297: @53479
     /*  53479 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(53558), // Rule ID 22581 //
     /*  53484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53487 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53491 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53506 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53513 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53525 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53529 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53540 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53557 */   // GIR_Coverage, 22581,
     /*  53557 */   GIR_EraseRootFromParent_Done,
     /*  53558 */ // Label 1298: @53558
     /*  53558 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(53637), // Rule ID 22583 //
     /*  53563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53566 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53592 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53604 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53608 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53619 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53626 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53636 */   // GIR_Coverage, 22583,
     /*  53636 */   GIR_EraseRootFromParent_Done,
     /*  53637 */ // Label 1299: @53637
     /*  53637 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(53723), // Rule ID 18339 //
     /*  53642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  53645 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53656 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53660 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53667 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53667 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53670 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53674 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrmi),
     /*  53688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53693 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53696 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53700 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53703 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53722 */   // GIR_Coverage, 18339,
     /*  53722 */   GIR_EraseRootFromParent_Done,
     /*  53723 */ // Label 1300: @53723
     /*  53723 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(53765), // Rule ID 29 //
     /*  53728 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53739 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  53743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53750 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53755 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53759 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53763 */   GIR_RootConstrainSelectedInstOperands,
     /*  53764 */   // GIR_Coverage, 29,
     /*  53764 */   GIR_EraseRootFromParent_Done,
     /*  53765 */ // Label 1301: @53765
     /*  53765 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(53851), // Rule ID 18335 //
     /*  53770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  53773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53788 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53795 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53795 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53798 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53802 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrmi),
     /*  53816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53821 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53824 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53828 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53831 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53850 */   // GIR_Coverage, 18335,
     /*  53850 */   GIR_EraseRootFromParent_Done,
     /*  53851 */ // Label 1302: @53851
     /*  53851 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(53937), // Rule ID 21839 //
     /*  53856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  53859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53881 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  53881 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53884 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53888 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrmi),
     /*  53902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53907 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53910 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53914 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53917 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  53936 */   // GIR_Coverage, 21839,
     /*  53936 */   GIR_EraseRootFromParent_Done,
     /*  53937 */ // Label 1303: @53937
     /*  53937 */ GIM_Reject,
     /*  53938 */ // Label 1269: @53938
     /*  53938 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(53986), // Rule ID 1080 //
     /*  53943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  53946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53949 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  53957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53968 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp32m:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m),
     /*  53971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53973 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53977 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  53980 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53984 */   GIR_RootConstrainSelectedInstOperands,
     /*  53985 */   // GIR_Coverage, 1080,
     /*  53985 */   GIR_EraseRootFromParent_Done,
     /*  53986 */ // Label 1304: @53986
     /*  53986 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(54031), // Rule ID 1697 //
     /*  53991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  53994 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53997 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54016 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  54019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54021 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54029 */   GIR_RootConstrainSelectedInstOperands,
     /*  54030 */   // GIR_Coverage, 1697,
     /*  54030 */   GIR_EraseRootFromParent_Done,
     /*  54031 */ // Label 1305: @54031
     /*  54031 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(54076), // Rule ID 1698 //
     /*  54036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  54039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54061 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  54064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54066 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54070 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54074 */   GIR_RootConstrainSelectedInstOperands,
     /*  54075 */   // GIR_Coverage, 1698,
     /*  54075 */   GIR_EraseRootFromParent_Done,
     /*  54076 */ // Label 1306: @54076
     /*  54076 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(54121), // Rule ID 4609 //
     /*  54081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54087 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  54095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54106 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  54109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54111 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54119 */   GIR_RootConstrainSelectedInstOperands,
     /*  54120 */   // GIR_Coverage, 4609,
     /*  54120 */   GIR_EraseRootFromParent_Done,
     /*  54121 */ // Label 1307: @54121
     /*  54121 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(54170), // Rule ID 22517 //
     /*  54126 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54133 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54155 */   // (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54160 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54164 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54168 */   GIR_RootConstrainSelectedInstOperands,
     /*  54169 */   // GIR_Coverage, 22517,
     /*  54169 */   GIR_EraseRootFromParent_Done,
     /*  54170 */ // Label 1308: @54170
     /*  54170 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(54219), // Rule ID 22582 //
     /*  54175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54178 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54204 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54209 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54217 */   GIR_RootConstrainSelectedInstOperands,
     /*  54218 */   // GIR_Coverage, 22582,
     /*  54218 */   GIR_EraseRootFromParent_Done,
     /*  54219 */ // Label 1309: @54219
     /*  54219 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(54268), // Rule ID 22584 //
     /*  54224 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54227 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54231 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54253 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54258 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54266 */   GIR_RootConstrainSelectedInstOperands,
     /*  54267 */   // GIR_Coverage, 22584,
     /*  54267 */   GIR_EraseRootFromParent_Done,
     /*  54268 */ // Label 1310: @54268
     /*  54268 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(54317), // Rule ID 22585 //
     /*  54273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54276 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54295 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54302 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54307 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54315 */   GIR_RootConstrainSelectedInstOperands,
     /*  54316 */   // GIR_Coverage, 22585,
     /*  54316 */   GIR_EraseRootFromParent_Done,
     /*  54317 */ // Label 1311: @54317
     /*  54317 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(54359), // Rule ID 30 //
     /*  54322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54329 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54333 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  54337 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54344 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54349 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54353 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54357 */   GIR_RootConstrainSelectedInstOperands,
     /*  54358 */   // GIR_Coverage, 30,
     /*  54358 */   GIR_EraseRootFromParent_Done,
     /*  54359 */ // Label 1312: @54359
     /*  54359 */ GIM_Reject,
     /*  54360 */ // Label 1270: @54360
     /*  54360 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(54402), // Rule ID 31 //
     /*  54365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54368 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54380 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54387 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54392 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54400 */   GIR_RootConstrainSelectedInstOperands,
     /*  54401 */   // GIR_Coverage, 31,
     /*  54401 */   GIR_EraseRootFromParent_Done,
     /*  54402 */ // Label 1313: @54402
     /*  54402 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(54450), // Rule ID 1081 //
     /*  54407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54413 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54421 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54425 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54432 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp64m:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m),
     /*  54435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54437 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54441 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54448 */   GIR_RootConstrainSelectedInstOperands,
     /*  54449 */   // GIR_Coverage, 1081,
     /*  54449 */   GIR_EraseRootFromParent_Done,
     /*  54450 */ // Label 1314: @54450
     /*  54450 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(54505), // Rule ID 1083 //
     /*  54455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54461 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54465 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54487 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m64),
     /*  54490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54492 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54496 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54499 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54503 */   GIR_RootConstrainSelectedInstOperands,
     /*  54504 */   // GIR_Coverage, 1083,
     /*  54504 */   GIR_EraseRootFromParent_Done,
     /*  54505 */ // Label 1315: @54505
     /*  54505 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(54550), // Rule ID 1701 //
     /*  54510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54516 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54535 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  54538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54540 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54548 */   GIR_RootConstrainSelectedInstOperands,
     /*  54549 */   // GIR_Coverage, 1701,
     /*  54549 */   GIR_EraseRootFromParent_Done,
     /*  54550 */ // Label 1316: @54550
     /*  54550 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(54595), // Rule ID 1702 //
     /*  54555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  54558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54580 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  54583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54585 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54593 */   GIR_RootConstrainSelectedInstOperands,
     /*  54594 */   // GIR_Coverage, 1702,
     /*  54594 */   GIR_EraseRootFromParent_Done,
     /*  54595 */ // Label 1317: @54595
     /*  54595 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(54640), // Rule ID 4615 //
     /*  54600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  54614 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54618 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54625 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  54628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54630 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54638 */   GIR_RootConstrainSelectedInstOperands,
     /*  54639 */   // GIR_Coverage, 4615,
     /*  54639 */   GIR_EraseRootFromParent_Done,
     /*  54640 */ // Label 1318: @54640
     /*  54640 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(54689), // Rule ID 22518 //
     /*  54645 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54663 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54667 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54674 */   // (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54679 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54687 */   GIR_RootConstrainSelectedInstOperands,
     /*  54688 */   // GIR_Coverage, 22518,
     /*  54688 */   GIR_EraseRootFromParent_Done,
     /*  54689 */ // Label 1319: @54689
     /*  54689 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(54770), // Rule ID 22587 //
     /*  54694 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54697 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54701 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54723 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54735 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54739 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54769 */   // GIR_Coverage, 22587,
     /*  54769 */   GIR_EraseRootFromParent_Done,
     /*  54770 */ // Label 1320: @54770
     /*  54770 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(54851), // Rule ID 22588 //
     /*  54775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54804 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54816 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54820 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54850 */   // GIR_Coverage, 22588,
     /*  54850 */   GIR_EraseRootFromParent_Done,
     /*  54851 */ // Label 1321: @54851
     /*  54851 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(54932), // Rule ID 22589 //
     /*  54856 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54859 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54885 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54897 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54901 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54931 */   // GIR_Coverage, 22589,
     /*  54931 */   GIR_EraseRootFromParent_Done,
     /*  54932 */ // Label 1322: @54932
     /*  54932 */ GIM_Reject,
     /*  54933 */ // Label 1271: @54933
     /*  54933 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(55091),
     /*  54938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54941 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(54986), // Rule ID 1082 //
     /*  54946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  54949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  54957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54968 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp80m:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp80m),
     /*  54971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54984 */     GIR_RootConstrainSelectedInstOperands,
     /*  54985 */     // GIR_Coverage, 1082,
     /*  54985 */     GIR_EraseRootFromParent_Done,
     /*  54986 */   // Label 1324: @54986
     /*  54986 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(55038), // Rule ID 1084 //
     /*  54991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  54994 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  55005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55020 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>  =>  (LD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m80),
     /*  55023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55036 */     GIR_RootConstrainSelectedInstOperands,
     /*  55037 */     // GIR_Coverage, 1084,
     /*  55037 */     GIR_EraseRootFromParent_Done,
     /*  55038 */   // Label 1325: @55038
     /*  55038 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(55090), // Rule ID 1085 //
     /*  55043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55046 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  55057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55072 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m80),
     /*  55075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55088 */     GIR_RootConstrainSelectedInstOperands,
     /*  55089 */     // GIR_Coverage, 1085,
     /*  55089 */     GIR_EraseRootFromParent_Done,
     /*  55090 */   // Label 1326: @55090
     /*  55090 */   GIM_Reject,
     /*  55091 */ // Label 1323: @55091
     /*  55091 */ GIM_Reject,
     /*  55092 */ // Label 1272: @55092
     /*  55092 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(55219),
     /*  55097 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55100 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55104 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(55142), // Rule ID 23145 //
     /*  55109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  55112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55127 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55140 */     GIR_RootConstrainSelectedInstOperands,
     /*  55141 */     // GIR_Coverage, 23145,
     /*  55141 */     GIR_EraseRootFromParent_Done,
     /*  55142 */   // Label 1328: @55142
     /*  55142 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(55180), // Rule ID 23149 //
     /*  55147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55165 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55178 */     GIR_RootConstrainSelectedInstOperands,
     /*  55179 */     // GIR_Coverage, 23149,
     /*  55179 */     GIR_EraseRootFromParent_Done,
     /*  55180 */   // Label 1329: @55180
     /*  55180 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(55218), // Rule ID 23153 //
     /*  55185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  55188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55203 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  55206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55216 */     GIR_RootConstrainSelectedInstOperands,
     /*  55217 */     // GIR_Coverage, 23153,
     /*  55217 */     GIR_EraseRootFromParent_Done,
     /*  55218 */   // Label 1330: @55218
     /*  55218 */   GIM_Reject,
     /*  55219 */ // Label 1327: @55219
     /*  55219 */ GIM_Reject,
     /*  55220 */ // Label 1273: @55220
     /*  55220 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(55286), // Rule ID 19446 //
     /*  55225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55231 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  55239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55250 */   // (ld:{ *:[v2i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK2:{ *:[i32] })
     /*  55250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55262 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55266 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55280 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  55285 */   // GIR_Coverage, 19446,
     /*  55285 */   GIR_EraseRootFromParent_Done,
     /*  55286 */ // Label 1331: @55286
     /*  55286 */ GIM_Reject,
     /*  55287 */ // Label 1274: @55287
     /*  55287 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(55780),
     /*  55292 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55295 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55299 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(55341), // Rule ID 1704 //
     /*  55304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55326 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDrm),
     /*  55329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55339 */     GIR_RootConstrainSelectedInstOperands,
     /*  55340 */     // GIR_Coverage, 1704,
     /*  55340 */     GIR_EraseRootFromParent_Done,
     /*  55341 */   // Label 1333: @55341
     /*  55341 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(55379), // Rule ID 1706 //
     /*  55346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55364 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDrm),
     /*  55367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55377 */     GIR_RootConstrainSelectedInstOperands,
     /*  55378 */     // GIR_Coverage, 1706,
     /*  55378 */     GIR_EraseRootFromParent_Done,
     /*  55379 */   // Label 1334: @55379
     /*  55379 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(55421), // Rule ID 1713 //
     /*  55384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55406 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDrm),
     /*  55409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55419 */     GIR_RootConstrainSelectedInstOperands,
     /*  55420 */     // GIR_Coverage, 1713,
     /*  55420 */     GIR_EraseRootFromParent_Done,
     /*  55421 */   // Label 1335: @55421
     /*  55421 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(55459), // Rule ID 1714 //
     /*  55426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55444 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDrm),
     /*  55447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55457 */     GIR_RootConstrainSelectedInstOperands,
     /*  55458 */     // GIR_Coverage, 1714,
     /*  55458 */     GIR_EraseRootFromParent_Done,
     /*  55459 */   // Label 1336: @55459
     /*  55459 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(55501), // Rule ID 2518 //
     /*  55464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55486 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  55489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55499 */     GIR_RootConstrainSelectedInstOperands,
     /*  55500 */     // GIR_Coverage, 2518,
     /*  55500 */     GIR_EraseRootFromParent_Done,
     /*  55501 */   // Label 1337: @55501
     /*  55501 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(55539), // Rule ID 2519 //
     /*  55506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55524 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  55527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55537 */     GIR_RootConstrainSelectedInstOperands,
     /*  55538 */     // GIR_Coverage, 2519,
     /*  55538 */     GIR_EraseRootFromParent_Done,
     /*  55539 */   // Label 1338: @55539
     /*  55539 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(55581), // Rule ID 4490 //
     /*  55544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55566 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rm),
     /*  55569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55579 */     GIR_RootConstrainSelectedInstOperands,
     /*  55580 */     // GIR_Coverage, 4490,
     /*  55580 */     GIR_EraseRootFromParent_Done,
     /*  55581 */   // Label 1339: @55581
     /*  55581 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(55619), // Rule ID 4515 //
     /*  55586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55604 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128rm),
     /*  55607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55617 */     GIR_RootConstrainSelectedInstOperands,
     /*  55618 */     // GIR_Coverage, 4515,
     /*  55618 */     GIR_EraseRootFromParent_Done,
     /*  55619 */   // Label 1340: @55619
     /*  55619 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(55661), // Rule ID 4544 //
     /*  55624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55646 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  55649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55659 */     GIR_RootConstrainSelectedInstOperands,
     /*  55660 */     // GIR_Coverage, 4544,
     /*  55660 */     GIR_EraseRootFromParent_Done,
     /*  55661 */   // Label 1341: @55661
     /*  55661 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(55699), // Rule ID 4587 //
     /*  55666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55684 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  55687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55697 */     GIR_RootConstrainSelectedInstOperands,
     /*  55698 */     // GIR_Coverage, 4587,
     /*  55698 */     GIR_EraseRootFromParent_Done,
     /*  55699 */   // Label 1342: @55699
     /*  55699 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(55741), // Rule ID 17939 //
     /*  55704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55726 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55739 */     GIR_RootConstrainSelectedInstOperands,
     /*  55740 */     // GIR_Coverage, 17939,
     /*  55740 */     GIR_EraseRootFromParent_Done,
     /*  55741 */   // Label 1343: @55741
     /*  55741 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(55779), // Rule ID 17943 //
     /*  55746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55764 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55777 */     GIR_RootConstrainSelectedInstOperands,
     /*  55778 */     // GIR_Coverage, 17943,
     /*  55778 */     GIR_EraseRootFromParent_Done,
     /*  55779 */   // Label 1344: @55779
     /*  55779 */   GIM_Reject,
     /*  55780 */ // Label 1332: @55780
     /*  55780 */ GIM_Reject,
     /*  55781 */ // Label 1275: @55781
     /*  55781 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(55847), // Rule ID 19447 //
     /*  55786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  55800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55811 */   // (ld:{ *:[v4i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK4:{ *:[i32] })
     /*  55811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55823 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55827 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  55846 */   // GIR_Coverage, 19447,
     /*  55846 */   GIR_EraseRootFromParent_Done,
     /*  55847 */ // Label 1345: @55847
     /*  55847 */ GIM_Reject,
     /*  55848 */ // Label 1276: @55848
     /*  55848 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(56341),
     /*  55853 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55856 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55860 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(55902), // Rule ID 1703 //
     /*  55865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55887 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  55890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55900 */     GIR_RootConstrainSelectedInstOperands,
     /*  55901 */     // GIR_Coverage, 1703,
     /*  55901 */     GIR_EraseRootFromParent_Done,
     /*  55902 */   // Label 1347: @55902
     /*  55902 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(55940), // Rule ID 1705 //
     /*  55907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55925 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55938 */     GIR_RootConstrainSelectedInstOperands,
     /*  55939 */     // GIR_Coverage, 1705,
     /*  55939 */     GIR_EraseRootFromParent_Done,
     /*  55940 */   // Label 1348: @55940
     /*  55940 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(55982), // Rule ID 1711 //
     /*  55945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55967 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55980 */     GIR_RootConstrainSelectedInstOperands,
     /*  55981 */     // GIR_Coverage, 1711,
     /*  55981 */     GIR_EraseRootFromParent_Done,
     /*  55982 */   // Label 1349: @55982
     /*  55982 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(56020), // Rule ID 1712 //
     /*  55987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56005 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56018 */     GIR_RootConstrainSelectedInstOperands,
     /*  56019 */     // GIR_Coverage, 1712,
     /*  56019 */     GIR_EraseRootFromParent_Done,
     /*  56020 */   // Label 1350: @56020
     /*  56020 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(56062), // Rule ID 4472 //
     /*  56025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56047 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  56050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56060 */     GIR_RootConstrainSelectedInstOperands,
     /*  56061 */     // GIR_Coverage, 4472,
     /*  56061 */     GIR_EraseRootFromParent_Done,
     /*  56062 */   // Label 1351: @56062
     /*  56062 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(56100), // Rule ID 4503 //
     /*  56067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56085 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  56088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56098 */     GIR_RootConstrainSelectedInstOperands,
     /*  56099 */     // GIR_Coverage, 4503,
     /*  56099 */     GIR_EraseRootFromParent_Done,
     /*  56100 */   // Label 1352: @56100
     /*  56100 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(56142), // Rule ID 17940 //
     /*  56105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56127 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56140 */     GIR_RootConstrainSelectedInstOperands,
     /*  56141 */     // GIR_Coverage, 17940,
     /*  56141 */     GIR_EraseRootFromParent_Done,
     /*  56142 */   // Label 1353: @56142
     /*  56142 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(56180), // Rule ID 17944 //
     /*  56147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56165 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56178 */     GIR_RootConstrainSelectedInstOperands,
     /*  56179 */     // GIR_Coverage, 17944,
     /*  56179 */     GIR_EraseRootFromParent_Done,
     /*  56180 */   // Label 1354: @56180
     /*  56180 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(56222), // Rule ID 18319 //
     /*  56185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56207 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  56210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56220 */     GIR_RootConstrainSelectedInstOperands,
     /*  56221 */     // GIR_Coverage, 18319,
     /*  56221 */     GIR_EraseRootFromParent_Done,
     /*  56222 */   // Label 1355: @56222
     /*  56222 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(56260), // Rule ID 18323 //
     /*  56227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56245 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  56248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56258 */     GIR_RootConstrainSelectedInstOperands,
     /*  56259 */     // GIR_Coverage, 18323,
     /*  56259 */     GIR_EraseRootFromParent_Done,
     /*  56260 */   // Label 1356: @56260
     /*  56260 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(56302), // Rule ID 19812 //
     /*  56265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56287 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  56290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56300 */     GIR_RootConstrainSelectedInstOperands,
     /*  56301 */     // GIR_Coverage, 19812,
     /*  56301 */     GIR_EraseRootFromParent_Done,
     /*  56302 */   // Label 1357: @56302
     /*  56302 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(56340), // Rule ID 19816 //
     /*  56307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56325 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  56328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56338 */     GIR_RootConstrainSelectedInstOperands,
     /*  56339 */     // GIR_Coverage, 19816,
     /*  56339 */     GIR_EraseRootFromParent_Done,
     /*  56340 */   // Label 1358: @56340
     /*  56340 */   GIM_Reject,
     /*  56341 */ // Label 1346: @56341
     /*  56341 */ GIM_Reject,
     /*  56342 */ // Label 1277: @56342
     /*  56342 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(56675),
     /*  56347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56354 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(56396), // Rule ID 1708 //
     /*  56359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56381 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYrm),
     /*  56384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56394 */     GIR_RootConstrainSelectedInstOperands,
     /*  56395 */     // GIR_Coverage, 1708,
     /*  56395 */     GIR_EraseRootFromParent_Done,
     /*  56396 */   // Label 1360: @56396
     /*  56396 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(56434), // Rule ID 1710 //
     /*  56401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56419 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYrm),
     /*  56422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56432 */     GIR_RootConstrainSelectedInstOperands,
     /*  56433 */     // GIR_Coverage, 1710,
     /*  56433 */     GIR_EraseRootFromParent_Done,
     /*  56434 */   // Label 1361: @56434
     /*  56434 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(56476), // Rule ID 4485 //
     /*  56439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56461 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rm),
     /*  56464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56474 */     GIR_RootConstrainSelectedInstOperands,
     /*  56475 */     // GIR_Coverage, 4485,
     /*  56475 */     GIR_EraseRootFromParent_Done,
     /*  56476 */   // Label 1362: @56476
     /*  56476 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(56514), // Rule ID 4512 //
     /*  56481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56499 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256rm),
     /*  56502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56512 */     GIR_RootConstrainSelectedInstOperands,
     /*  56513 */     // GIR_Coverage, 4512,
     /*  56513 */     GIR_EraseRootFromParent_Done,
     /*  56514 */   // Label 1363: @56514
     /*  56514 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(56556), // Rule ID 4539 //
     /*  56519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56541 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  56544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56554 */     GIR_RootConstrainSelectedInstOperands,
     /*  56555 */     // GIR_Coverage, 4539,
     /*  56555 */     GIR_EraseRootFromParent_Done,
     /*  56556 */   // Label 1364: @56556
     /*  56556 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(56594), // Rule ID 4584 //
     /*  56561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56579 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  56582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56592 */     GIR_RootConstrainSelectedInstOperands,
     /*  56593 */     // GIR_Coverage, 4584,
     /*  56593 */     GIR_EraseRootFromParent_Done,
     /*  56594 */   // Label 1365: @56594
     /*  56594 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(56636), // Rule ID 17915 //
     /*  56599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56621 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  56624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56634 */     GIR_RootConstrainSelectedInstOperands,
     /*  56635 */     // GIR_Coverage, 17915,
     /*  56635 */     GIR_EraseRootFromParent_Done,
     /*  56636 */   // Label 1366: @56636
     /*  56636 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(56674), // Rule ID 17919 //
     /*  56641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56659 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  56662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56664 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56672 */     GIR_RootConstrainSelectedInstOperands,
     /*  56673 */     // GIR_Coverage, 17919,
     /*  56673 */     GIR_EraseRootFromParent_Done,
     /*  56674 */   // Label 1367: @56674
     /*  56674 */   GIM_Reject,
     /*  56675 */ // Label 1359: @56675
     /*  56675 */ GIM_Reject,
     /*  56676 */ // Label 1278: @56676
     /*  56676 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(56757),
     /*  56681 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  56692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56696 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(56726), // Rule ID 4395 //
     /*  56701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  56704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56711 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56724 */     GIR_RootConstrainSelectedInstOperands,
     /*  56725 */     // GIR_Coverage, 4395,
     /*  56725 */     GIR_EraseRootFromParent_Done,
     /*  56726 */   // Label 1369: @56726
     /*  56726 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(56756), // Rule ID 4397 //
     /*  56731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  56734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56741 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm_EVEX:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm_EVEX),
     /*  56744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56754 */     GIR_RootConstrainSelectedInstOperands,
     /*  56755 */     // GIR_Coverage, 4397,
     /*  56755 */     GIR_EraseRootFromParent_Done,
     /*  56756 */   // Label 1370: @56756
     /*  56756 */   GIM_Reject,
     /*  56757 */ // Label 1368: @56757
     /*  56757 */ GIM_Reject,
     /*  56758 */ // Label 1279: @56758
     /*  56758 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(57331),
     /*  56763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56770 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56812), // Rule ID 17931 //
     /*  56775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56797 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  56800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56810 */     GIR_RootConstrainSelectedInstOperands,
     /*  56811 */     // GIR_Coverage, 17931,
     /*  56811 */     GIR_EraseRootFromParent_Done,
     /*  56812 */   // Label 1372: @56812
     /*  56812 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56850), // Rule ID 17932 //
     /*  56817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56835 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  56838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56848 */     GIR_RootConstrainSelectedInstOperands,
     /*  56849 */     // GIR_Coverage, 17932,
     /*  56849 */     GIR_EraseRootFromParent_Done,
     /*  56850 */   // Label 1373: @56850
     /*  56850 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(56892), // Rule ID 17941 //
     /*  56855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56877 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  56877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56890 */     GIR_RootConstrainSelectedInstOperands,
     /*  56891 */     // GIR_Coverage, 17941,
     /*  56891 */     GIR_EraseRootFromParent_Done,
     /*  56892 */   // Label 1374: @56892
     /*  56892 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(56930), // Rule ID 17945 //
     /*  56897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56915 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  56915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56928 */     GIR_RootConstrainSelectedInstOperands,
     /*  56929 */     // GIR_Coverage, 17945,
     /*  56929 */     GIR_EraseRootFromParent_Done,
     /*  56930 */   // Label 1375: @56930
     /*  56930 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(56972), // Rule ID 17955 //
     /*  56935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  56938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56957 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56962 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56970 */     GIR_RootConstrainSelectedInstOperands,
     /*  56971 */     // GIR_Coverage, 17955,
     /*  56971 */     GIR_EraseRootFromParent_Done,
     /*  56972 */   // Label 1376: @56972
     /*  56972 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(57010), // Rule ID 17956 //
     /*  56977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  56980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56995 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57008 */     GIR_RootConstrainSelectedInstOperands,
     /*  57009 */     // GIR_Coverage, 17956,
     /*  57009 */     GIR_EraseRootFromParent_Done,
     /*  57010 */   // Label 1377: @57010
     /*  57010 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(57052), // Rule ID 18320 //
     /*  57015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57037 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57050 */     GIR_RootConstrainSelectedInstOperands,
     /*  57051 */     // GIR_Coverage, 18320,
     /*  57051 */     GIR_EraseRootFromParent_Done,
     /*  57052 */   // Label 1378: @57052
     /*  57052 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(57094), // Rule ID 18321 //
     /*  57057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57079 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57092 */     GIR_RootConstrainSelectedInstOperands,
     /*  57093 */     // GIR_Coverage, 18321,
     /*  57093 */     GIR_EraseRootFromParent_Done,
     /*  57094 */   // Label 1379: @57094
     /*  57094 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(57132), // Rule ID 18324 //
     /*  57099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57117 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57130 */     GIR_RootConstrainSelectedInstOperands,
     /*  57131 */     // GIR_Coverage, 18324,
     /*  57131 */     GIR_EraseRootFromParent_Done,
     /*  57132 */   // Label 1380: @57132
     /*  57132 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(57170), // Rule ID 18325 //
     /*  57137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57155 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57168 */     GIR_RootConstrainSelectedInstOperands,
     /*  57169 */     // GIR_Coverage, 18325,
     /*  57169 */     GIR_EraseRootFromParent_Done,
     /*  57170 */   // Label 1381: @57170
     /*  57170 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(57212), // Rule ID 19813 //
     /*  57175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57197 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  57200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57210 */     GIR_RootConstrainSelectedInstOperands,
     /*  57211 */     // GIR_Coverage, 19813,
     /*  57211 */     GIR_EraseRootFromParent_Done,
     /*  57212 */   // Label 1382: @57212
     /*  57212 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(57254), // Rule ID 19814 //
     /*  57217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57239 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57252 */     GIR_RootConstrainSelectedInstOperands,
     /*  57253 */     // GIR_Coverage, 19814,
     /*  57253 */     GIR_EraseRootFromParent_Done,
     /*  57254 */   // Label 1383: @57254
     /*  57254 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57292), // Rule ID 19817 //
     /*  57259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57277 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  57280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57282 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57290 */     GIR_RootConstrainSelectedInstOperands,
     /*  57291 */     // GIR_Coverage, 19817,
     /*  57291 */     GIR_EraseRootFromParent_Done,
     /*  57292 */   // Label 1384: @57292
     /*  57292 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57330), // Rule ID 19818 //
     /*  57297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57315 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  57318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57328 */     GIR_RootConstrainSelectedInstOperands,
     /*  57329 */     // GIR_Coverage, 19818,
     /*  57329 */     GIR_EraseRootFromParent_Done,
     /*  57330 */   // Label 1385: @57330
     /*  57330 */   GIM_Reject,
     /*  57331 */ // Label 1371: @57331
     /*  57331 */ GIM_Reject,
     /*  57332 */ // Label 1280: @57332
     /*  57332 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57665),
     /*  57337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57344 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57386), // Rule ID 1707 //
     /*  57349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57371 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57384 */     GIR_RootConstrainSelectedInstOperands,
     /*  57385 */     // GIR_Coverage, 1707,
     /*  57385 */     GIR_EraseRootFromParent_Done,
     /*  57386 */   // Label 1387: @57386
     /*  57386 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57424), // Rule ID 1709 //
     /*  57391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57409 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57422 */     GIR_RootConstrainSelectedInstOperands,
     /*  57423 */     // GIR_Coverage, 1709,
     /*  57423 */     GIR_EraseRootFromParent_Done,
     /*  57424 */   // Label 1388: @57424
     /*  57424 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57466), // Rule ID 4467 //
     /*  57429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57451 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  57454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57464 */     GIR_RootConstrainSelectedInstOperands,
     /*  57465 */     // GIR_Coverage, 4467,
     /*  57465 */     GIR_EraseRootFromParent_Done,
     /*  57466 */   // Label 1389: @57466
     /*  57466 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57504), // Rule ID 4500 //
     /*  57471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57489 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  57492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57502 */     GIR_RootConstrainSelectedInstOperands,
     /*  57503 */     // GIR_Coverage, 4500,
     /*  57503 */     GIR_EraseRootFromParent_Done,
     /*  57504 */   // Label 1390: @57504
     /*  57504 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57546), // Rule ID 17916 //
     /*  57509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57531 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57544 */     GIR_RootConstrainSelectedInstOperands,
     /*  57545 */     // GIR_Coverage, 17916,
     /*  57545 */     GIR_EraseRootFromParent_Done,
     /*  57546 */   // Label 1391: @57546
     /*  57546 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57584), // Rule ID 17920 //
     /*  57551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57569 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57582 */     GIR_RootConstrainSelectedInstOperands,
     /*  57583 */     // GIR_Coverage, 17920,
     /*  57583 */     GIR_EraseRootFromParent_Done,
     /*  57584 */   // Label 1392: @57584
     /*  57584 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57626), // Rule ID 19828 //
     /*  57589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57611 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57624 */     GIR_RootConstrainSelectedInstOperands,
     /*  57625 */     // GIR_Coverage, 19828,
     /*  57625 */     GIR_EraseRootFromParent_Done,
     /*  57626 */   // Label 1393: @57626
     /*  57626 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57664), // Rule ID 19832 //
     /*  57631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57649 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  57652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57654 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57662 */     GIR_RootConstrainSelectedInstOperands,
     /*  57663 */     // GIR_Coverage, 19832,
     /*  57663 */     GIR_EraseRootFromParent_Done,
     /*  57664 */   // Label 1394: @57664
     /*  57664 */   GIM_Reject,
     /*  57665 */ // Label 1386: @57665
     /*  57665 */ GIM_Reject,
     /*  57666 */ // Label 1281: @57666
     /*  57666 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57839),
     /*  57671 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57674 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57678 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(57720), // Rule ID 4480 //
     /*  57683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57705 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrm),
     /*  57708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57710 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57718 */     GIR_RootConstrainSelectedInstOperands,
     /*  57719 */     // GIR_Coverage, 4480,
     /*  57719 */     GIR_EraseRootFromParent_Done,
     /*  57720 */   // Label 1396: @57720
     /*  57720 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(57758), // Rule ID 4509 //
     /*  57725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57743 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZrm),
     /*  57746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57756 */     GIR_RootConstrainSelectedInstOperands,
     /*  57757 */     // GIR_Coverage, 4509,
     /*  57757 */     GIR_EraseRootFromParent_Done,
     /*  57758 */   // Label 1397: @57758
     /*  57758 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(57800), // Rule ID 4534 //
     /*  57763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57785 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  57788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57798 */     GIR_RootConstrainSelectedInstOperands,
     /*  57799 */     // GIR_Coverage, 4534,
     /*  57799 */     GIR_EraseRootFromParent_Done,
     /*  57800 */   // Label 1398: @57800
     /*  57800 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(57838), // Rule ID 4581 //
     /*  57805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57823 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  57826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57836 */     GIR_RootConstrainSelectedInstOperands,
     /*  57837 */     // GIR_Coverage, 4581,
     /*  57837 */     GIR_EraseRootFromParent_Done,
     /*  57838 */   // Label 1399: @57838
     /*  57838 */   GIM_Reject,
     /*  57839 */ // Label 1395: @57839
     /*  57839 */ GIM_Reject,
     /*  57840 */ // Label 1282: @57840
     /*  57840 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(57921),
     /*  57845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  57856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57860 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(57890), // Rule ID 4399 //
     /*  57865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  57868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57875 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  57875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  57878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57888 */     GIR_RootConstrainSelectedInstOperands,
     /*  57889 */     // GIR_Coverage, 4399,
     /*  57889 */     GIR_EraseRootFromParent_Done,
     /*  57890 */   // Label 1401: @57890
     /*  57890 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(57920), // Rule ID 4401 //
     /*  57895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  57898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57905 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm_EVEX:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  57905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm_EVEX),
     /*  57908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57918 */     GIR_RootConstrainSelectedInstOperands,
     /*  57919 */     // GIR_Coverage, 4401,
     /*  57919 */     GIR_EraseRootFromParent_Done,
     /*  57920 */   // Label 1402: @57920
     /*  57920 */   GIM_Reject,
     /*  57921 */ // Label 1400: @57921
     /*  57921 */ GIM_Reject,
     /*  57922 */ // Label 1283: @57922
     /*  57922 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58175),
     /*  57927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57934 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(57976), // Rule ID 17942 //
     /*  57939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57961 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  57961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57974 */     GIR_RootConstrainSelectedInstOperands,
     /*  57975 */     // GIR_Coverage, 17942,
     /*  57975 */     GIR_EraseRootFromParent_Done,
     /*  57976 */   // Label 1404: @57976
     /*  57976 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(58014), // Rule ID 17946 //
     /*  57981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57999 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  57999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  58002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58012 */     GIR_RootConstrainSelectedInstOperands,
     /*  58013 */     // GIR_Coverage, 17946,
     /*  58013 */     GIR_EraseRootFromParent_Done,
     /*  58014 */   // Label 1405: @58014
     /*  58014 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(58056), // Rule ID 18322 //
     /*  58019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58041 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  58044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58054 */     GIR_RootConstrainSelectedInstOperands,
     /*  58055 */     // GIR_Coverage, 18322,
     /*  58055 */     GIR_EraseRootFromParent_Done,
     /*  58056 */   // Label 1406: @58056
     /*  58056 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(58094), // Rule ID 18326 //
     /*  58061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58079 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  58082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58092 */     GIR_RootConstrainSelectedInstOperands,
     /*  58093 */     // GIR_Coverage, 18326,
     /*  58093 */     GIR_EraseRootFromParent_Done,
     /*  58094 */   // Label 1407: @58094
     /*  58094 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(58136), // Rule ID 19815 //
     /*  58099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58121 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58134 */     GIR_RootConstrainSelectedInstOperands,
     /*  58135 */     // GIR_Coverage, 19815,
     /*  58135 */     GIR_EraseRootFromParent_Done,
     /*  58136 */   // Label 1408: @58136
     /*  58136 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(58174), // Rule ID 19819 //
     /*  58141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58159 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  58162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58172 */     GIR_RootConstrainSelectedInstOperands,
     /*  58173 */     // GIR_Coverage, 19819,
     /*  58173 */     GIR_EraseRootFromParent_Done,
     /*  58174 */   // Label 1409: @58174
     /*  58174 */   GIM_Reject,
     /*  58175 */ // Label 1403: @58175
     /*  58175 */ GIM_Reject,
     /*  58176 */ // Label 1284: @58176
     /*  58176 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(58509),
     /*  58181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58188 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(58230), // Rule ID 17917 //
     /*  58193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58215 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58228 */     GIR_RootConstrainSelectedInstOperands,
     /*  58229 */     // GIR_Coverage, 17917,
     /*  58229 */     GIR_EraseRootFromParent_Done,
     /*  58230 */   // Label 1411: @58230
     /*  58230 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(58268), // Rule ID 17921 //
     /*  58235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58253 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58266 */     GIR_RootConstrainSelectedInstOperands,
     /*  58267 */     // GIR_Coverage, 17921,
     /*  58267 */     GIR_EraseRootFromParent_Done,
     /*  58268 */   // Label 1412: @58268
     /*  58268 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(58310), // Rule ID 17935 //
     /*  58273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58295 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58308 */     GIR_RootConstrainSelectedInstOperands,
     /*  58309 */     // GIR_Coverage, 17935,
     /*  58309 */     GIR_EraseRootFromParent_Done,
     /*  58310 */   // Label 1413: @58310
     /*  58310 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(58348), // Rule ID 17936 //
     /*  58315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58333 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58346 */     GIR_RootConstrainSelectedInstOperands,
     /*  58347 */     // GIR_Coverage, 17936,
     /*  58347 */     GIR_EraseRootFromParent_Done,
     /*  58348 */   // Label 1414: @58348
     /*  58348 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(58390), // Rule ID 19829 //
     /*  58353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58375 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58388 */     GIR_RootConstrainSelectedInstOperands,
     /*  58389 */     // GIR_Coverage, 19829,
     /*  58389 */     GIR_EraseRootFromParent_Done,
     /*  58390 */   // Label 1415: @58390
     /*  58390 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(58432), // Rule ID 19830 //
     /*  58395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58417 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  58420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58430 */     GIR_RootConstrainSelectedInstOperands,
     /*  58431 */     // GIR_Coverage, 19830,
     /*  58431 */     GIR_EraseRootFromParent_Done,
     /*  58432 */   // Label 1416: @58432
     /*  58432 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(58470), // Rule ID 19833 //
     /*  58437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58455 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58468 */     GIR_RootConstrainSelectedInstOperands,
     /*  58469 */     // GIR_Coverage, 19833,
     /*  58469 */     GIR_EraseRootFromParent_Done,
     /*  58470 */   // Label 1417: @58470
     /*  58470 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(58508), // Rule ID 19834 //
     /*  58475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58493 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  58496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58506 */     GIR_RootConstrainSelectedInstOperands,
     /*  58507 */     // GIR_Coverage, 19834,
     /*  58507 */     GIR_EraseRootFromParent_Done,
     /*  58508 */   // Label 1418: @58508
     /*  58508 */   GIM_Reject,
     /*  58509 */ // Label 1410: @58509
     /*  58509 */ GIM_Reject,
     /*  58510 */ // Label 1285: @58510
     /*  58510 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(58683),
     /*  58515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58518 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58522 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(58564), // Rule ID 4462 //
     /*  58527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58549 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  58552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58562 */     GIR_RootConstrainSelectedInstOperands,
     /*  58563 */     // GIR_Coverage, 4462,
     /*  58563 */     GIR_EraseRootFromParent_Done,
     /*  58564 */   // Label 1420: @58564
     /*  58564 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(58602), // Rule ID 4497 //
     /*  58569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58587 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  58590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58600 */     GIR_RootConstrainSelectedInstOperands,
     /*  58601 */     // GIR_Coverage, 4497,
     /*  58601 */     GIR_EraseRootFromParent_Done,
     /*  58602 */   // Label 1421: @58602
     /*  58602 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(58644), // Rule ID 19796 //
     /*  58607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58629 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58642 */     GIR_RootConstrainSelectedInstOperands,
     /*  58643 */     // GIR_Coverage, 19796,
     /*  58643 */     GIR_EraseRootFromParent_Done,
     /*  58644 */   // Label 1422: @58644
     /*  58644 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(58682), // Rule ID 19800 //
     /*  58649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58667 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58680 */     GIR_RootConstrainSelectedInstOperands,
     /*  58681 */     // GIR_Coverage, 19800,
     /*  58681 */     GIR_EraseRootFromParent_Done,
     /*  58682 */   // Label 1423: @58682
     /*  58682 */   GIM_Reject,
     /*  58683 */ // Label 1419: @58683
     /*  58683 */ GIM_Reject,
     /*  58684 */ // Label 1286: @58684
     /*  58684 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(58765),
     /*  58689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  58700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58704 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(58734), // Rule ID 4403 //
     /*  58709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  58712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58719 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm),
     /*  58722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58732 */     GIR_RootConstrainSelectedInstOperands,
     /*  58733 */     // GIR_Coverage, 4403,
     /*  58733 */     GIR_EraseRootFromParent_Done,
     /*  58734 */   // Label 1425: @58734
     /*  58734 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(58764), // Rule ID 4407 //
     /*  58739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  58742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58749 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm_EVEX:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm_EVEX),
     /*  58752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58762 */     GIR_RootConstrainSelectedInstOperands,
     /*  58763 */     // GIR_Coverage, 4407,
     /*  58763 */     GIR_EraseRootFromParent_Done,
     /*  58764 */   // Label 1426: @58764
     /*  58764 */   GIM_Reject,
     /*  58765 */ // Label 1424: @58765
     /*  58765 */ GIM_Reject,
     /*  58766 */ // Label 1287: @58766
     /*  58766 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(58939),
     /*  58771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58774 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58778 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(58820), // Rule ID 17918 //
     /*  58783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58805 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58818 */     GIR_RootConstrainSelectedInstOperands,
     /*  58819 */     // GIR_Coverage, 17918,
     /*  58819 */     GIR_EraseRootFromParent_Done,
     /*  58820 */   // Label 1428: @58820
     /*  58820 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(58858), // Rule ID 17922 //
     /*  58825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58843 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58856 */     GIR_RootConstrainSelectedInstOperands,
     /*  58857 */     // GIR_Coverage, 17922,
     /*  58857 */     GIR_EraseRootFromParent_Done,
     /*  58858 */   // Label 1429: @58858
     /*  58858 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(58900), // Rule ID 19831 //
     /*  58863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58885 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58898 */     GIR_RootConstrainSelectedInstOperands,
     /*  58899 */     // GIR_Coverage, 19831,
     /*  58899 */     GIR_EraseRootFromParent_Done,
     /*  58900 */   // Label 1430: @58900
     /*  58900 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(58938), // Rule ID 19835 //
     /*  58905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58923 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58936 */     GIR_RootConstrainSelectedInstOperands,
     /*  58937 */     // GIR_Coverage, 19835,
     /*  58937 */     GIR_EraseRootFromParent_Done,
     /*  58938 */   // Label 1431: @58938
     /*  58938 */   GIM_Reject,
     /*  58939 */ // Label 1427: @58939
     /*  58939 */ GIM_Reject,
     /*  58940 */ // Label 1288: @58940
     /*  58940 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(59113),
     /*  58945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58948 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58952 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(58994), // Rule ID 19797 //
     /*  58957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58979 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  58979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58992 */     GIR_RootConstrainSelectedInstOperands,
     /*  58993 */     // GIR_Coverage, 19797,
     /*  58993 */     GIR_EraseRootFromParent_Done,
     /*  58994 */   // Label 1433: @58994
     /*  58994 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(59036), // Rule ID 19798 //
     /*  58999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59021 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  59024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59034 */     GIR_RootConstrainSelectedInstOperands,
     /*  59035 */     // GIR_Coverage, 19798,
     /*  59035 */     GIR_EraseRootFromParent_Done,
     /*  59036 */   // Label 1434: @59036
     /*  59036 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(59074), // Rule ID 19801 //
     /*  59041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59059 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59072 */     GIR_RootConstrainSelectedInstOperands,
     /*  59073 */     // GIR_Coverage, 19801,
     /*  59073 */     GIR_EraseRootFromParent_Done,
     /*  59074 */   // Label 1435: @59074
     /*  59074 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(59112), // Rule ID 19802 //
     /*  59079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59097 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  59100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59110 */     GIR_RootConstrainSelectedInstOperands,
     /*  59111 */     // GIR_Coverage, 19802,
     /*  59111 */     GIR_EraseRootFromParent_Done,
     /*  59112 */   // Label 1436: @59112
     /*  59112 */   GIM_Reject,
     /*  59113 */ // Label 1432: @59113
     /*  59113 */ GIM_Reject,
     /*  59114 */ // Label 1289: @59114
     /*  59114 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(59195),
     /*  59119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  59130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59134 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(59164), // Rule ID 4405 //
     /*  59139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  59142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59149 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm),
     /*  59152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59162 */     GIR_RootConstrainSelectedInstOperands,
     /*  59163 */     // GIR_Coverage, 4405,
     /*  59163 */     GIR_EraseRootFromParent_Done,
     /*  59164 */   // Label 1438: @59164
     /*  59164 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(59194), // Rule ID 4409 //
     /*  59169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  59172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59179 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm_EVEX:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm_EVEX),
     /*  59182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59192 */     GIR_RootConstrainSelectedInstOperands,
     /*  59193 */     // GIR_Coverage, 4409,
     /*  59193 */     GIR_EraseRootFromParent_Done,
     /*  59194 */   // Label 1439: @59194
     /*  59194 */   GIM_Reject,
     /*  59195 */ // Label 1437: @59195
     /*  59195 */ GIM_Reject,
     /*  59196 */ // Label 1290: @59196
     /*  59196 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(59289),
     /*  59201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59204 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59208 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(59250), // Rule ID 19799 //
     /*  59213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59235 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59248 */     GIR_RootConstrainSelectedInstOperands,
     /*  59249 */     // GIR_Coverage, 19799,
     /*  59249 */     GIR_EraseRootFromParent_Done,
     /*  59250 */   // Label 1441: @59250
     /*  59250 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(59288), // Rule ID 19803 //
     /*  59255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59273 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59286 */     GIR_RootConstrainSelectedInstOperands,
     /*  59287 */     // GIR_Coverage, 19803,
     /*  59287 */     GIR_EraseRootFromParent_Done,
     /*  59288 */   // Label 1442: @59288
     /*  59288 */   GIM_Reject,
     /*  59289 */ // Label 1440: @59289
     /*  59289 */ GIM_Reject,
     /*  59290 */ // Label 1291: @59290
     /*  59290 */ GIM_Reject,
     /*  59291 */ // Label 11: @59291
     /*  59291 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1446*/ GIMT_Encode4(59623),
     /*  59302 */ /*GILLT_s16*//*Label 1443*/ GIMT_Encode4(59314),
     /*  59306 */ /*GILLT_s32*//*Label 1444*/ GIMT_Encode4(59390),
     /*  59310 */ /*GILLT_s64*//*Label 1445*/ GIMT_Encode4(59484),
     /*  59314 */ // Label 1443: @59314
     /*  59314 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(59389), // Rule ID 22648 //
     /*  59319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59322 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59333 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59337 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59344 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59356 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59360 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59371 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59388 */   // GIR_Coverage, 22648,
     /*  59388 */   GIR_EraseRootFromParent_Done,
     /*  59389 */ // Label 1447: @59389
     /*  59389 */ GIM_Reject,
     /*  59390 */ // Label 1444: @59390
     /*  59390 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(59483),
     /*  59395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59398 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(59440), // Rule ID 615 //
     /*  59403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59425 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59438 */     GIR_RootConstrainSelectedInstOperands,
     /*  59439 */     // GIR_Coverage, 615,
     /*  59439 */     GIR_EraseRootFromParent_Done,
     /*  59440 */   // Label 1449: @59440
     /*  59440 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(59482), // Rule ID 617 //
     /*  59445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59467 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm16),
     /*  59470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59480 */     GIR_RootConstrainSelectedInstOperands,
     /*  59481 */     // GIR_Coverage, 617,
     /*  59481 */     GIR_EraseRootFromParent_Done,
     /*  59482 */   // Label 1450: @59482
     /*  59482 */   GIM_Reject,
     /*  59483 */ // Label 1448: @59483
     /*  59483 */ GIM_Reject,
     /*  59484 */ // Label 1445: @59484
     /*  59484 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(59622),
     /*  59489 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59492 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(59534), // Rule ID 623 //
     /*  59497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59519 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX64rm8:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm8),
     /*  59522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59532 */     GIR_RootConstrainSelectedInstOperands,
     /*  59533 */     // GIR_Coverage, 623,
     /*  59533 */     GIR_EraseRootFromParent_Done,
     /*  59534 */   // Label 1452: @59534
     /*  59534 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(59576), // Rule ID 625 //
     /*  59539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59561 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX64rm16:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm16),
     /*  59564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 625,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 1453: @59576
     /*  59576 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(59621), // Rule ID 627 //
     /*  59581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  59584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  59591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59606 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (MOVSX64rm32:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm32),
     /*  59609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59619 */     GIR_RootConstrainSelectedInstOperands,
     /*  59620 */     // GIR_Coverage, 627,
     /*  59620 */     GIR_EraseRootFromParent_Done,
     /*  59621 */   // Label 1454: @59621
     /*  59621 */   GIM_Reject,
     /*  59622 */ // Label 1451: @59622
     /*  59622 */ GIM_Reject,
     /*  59623 */ // Label 1446: @59623
     /*  59623 */ GIM_Reject,
     /*  59624 */ // Label 12: @59624
     /*  59624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1459*/ GIMT_Encode4(60278),
     /*  59635 */ /*GILLT_s8*//*Label 1455*/ GIMT_Encode4(59651),
     /*  59639 */ /*GILLT_s16*//*Label 1456*/ GIMT_Encode4(59697),
     /*  59643 */ /*GILLT_s32*//*Label 1457*/ GIMT_Encode4(59836),
     /*  59647 */ /*GILLT_s64*//*Label 1458*/ GIMT_Encode4(59972),
     /*  59651 */ // Label 1455: @59651
     /*  59651 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(59696), // Rule ID 22576 //
     /*  59656 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  59670 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59674 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59681 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  59681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  59684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59686 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59694 */   GIR_RootConstrainSelectedInstOperands,
     /*  59695 */   // GIR_Coverage, 22576,
     /*  59695 */   GIR_EraseRootFromParent_Done,
     /*  59696 */ // Label 1460: @59696
     /*  59696 */ GIM_Reject,
     /*  59697 */ // Label 1456: @59697
     /*  59697 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(59835),
     /*  59702 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59705 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59720 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(59777), // Rule ID 22577 //
     /*  59725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59732 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59744 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59748 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59759 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59776 */     // GIR_Coverage, 22577,
     /*  59776 */     GIR_EraseRootFromParent_Done,
     /*  59777 */   // Label 1462: @59777
     /*  59777 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(59834), // Rule ID 22650 //
     /*  59782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59789 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59801 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59805 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59816 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59833 */     // GIR_Coverage, 22650,
     /*  59833 */     GIR_EraseRootFromParent_Done,
     /*  59834 */   // Label 1463: @59834
     /*  59834 */   GIM_Reject,
     /*  59835 */ // Label 1461: @59835
     /*  59835 */ GIM_Reject,
     /*  59836 */ // Label 1457: @59836
     /*  59836 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(59971),
     /*  59841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59844 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(59886), // Rule ID 619 //
     /*  59849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59871 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59884 */     GIR_RootConstrainSelectedInstOperands,
     /*  59885 */     // GIR_Coverage, 619,
     /*  59885 */     GIR_EraseRootFromParent_Done,
     /*  59886 */   // Label 1465: @59886
     /*  59886 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(59928), // Rule ID 621 //
     /*  59891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59913 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  59916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59926 */     GIR_RootConstrainSelectedInstOperands,
     /*  59927 */     // GIR_Coverage, 621,
     /*  59927 */     GIR_EraseRootFromParent_Done,
     /*  59928 */   // Label 1466: @59928
     /*  59928 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(59970), // Rule ID 22578 //
     /*  59933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59955 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59968 */     GIR_RootConstrainSelectedInstOperands,
     /*  59969 */     // GIR_Coverage, 22578,
     /*  59969 */     GIR_EraseRootFromParent_Done,
     /*  59970 */   // Label 1467: @59970
     /*  59970 */   GIM_Reject,
     /*  59971 */ // Label 1464: @59971
     /*  59971 */ GIM_Reject,
     /*  59972 */ // Label 1458: @59972
     /*  59972 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(60277),
     /*  59977 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59980 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(60054), // Rule ID 17591 //
     /*  59985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60007 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60019 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60023 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60053 */     // GIR_Coverage, 17591,
     /*  60053 */     GIR_EraseRootFromParent_Done,
     /*  60054 */   // Label 1469: @60054
     /*  60054 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(60128), // Rule ID 17593 //
     /*  60059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60081 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60093 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60097 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60127 */     // GIR_Coverage, 17593,
     /*  60127 */     GIR_EraseRootFromParent_Done,
     /*  60128 */   // Label 1470: @60128
     /*  60128 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(60202), // Rule ID 17595 //
     /*  60133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  60140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60155 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  60162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60167 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60171 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60201 */     // GIR_Coverage, 17595,
     /*  60201 */     GIR_EraseRootFromParent_Done,
     /*  60202 */   // Label 1471: @60202
     /*  60202 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(60276), // Rule ID 22579 //
     /*  60207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60229 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60241 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60245 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60275 */     // GIR_Coverage, 22579,
     /*  60275 */     GIR_EraseRootFromParent_Done,
     /*  60276 */   // Label 1472: @60276
     /*  60276 */   GIM_Reject,
     /*  60277 */ // Label 1468: @60277
     /*  60277 */ GIM_Reject,
     /*  60278 */ // Label 1459: @60278
     /*  60278 */ GIM_Reject,
     /*  60279 */ // Label 13: @60279
     /*  60279 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 1495*/ GIMT_Encode4(85741),
     /*  60290 */ /*GILLT_s8*//*Label 1473*/ GIMT_Encode4(60386),
     /*  60294 */ /*GILLT_s16*//*Label 1474*/ GIMT_Encode4(65056),
     /*  60298 */ /*GILLT_s32*//*Label 1475*/ GIMT_Encode4(70300),
     /*  60302 */ /*GILLT_s64*//*Label 1476*/ GIMT_Encode4(76000),
     /*  60306 */ /*GILLT_s80*//*Label 1477*/ GIMT_Encode4(81392),
     /*  60310 */ /*GILLT_s128*//*Label 1478*/ GIMT_Encode4(81551), GIMT_Encode4(0),
     /*  60318 */ /*GILLT_v2s64*//*Label 1479*/ GIMT_Encode4(81805), GIMT_Encode4(0),
     /*  60326 */ /*GILLT_v4s32*//*Label 1480*/ GIMT_Encode4(82299),
     /*  60330 */ /*GILLT_v4s64*//*Label 1481*/ GIMT_Encode4(82793),
     /*  60334 */ /*GILLT_v8s1*//*Label 1482*/ GIMT_Encode4(83127),
     /*  60338 */ /*GILLT_v8s16*//*Label 1483*/ GIMT_Encode4(83209),
     /*  60342 */ /*GILLT_v8s32*//*Label 1484*/ GIMT_Encode4(83783),
     /*  60346 */ /*GILLT_v8s64*//*Label 1485*/ GIMT_Encode4(84117),
     /*  60350 */ /*GILLT_v16s1*//*Label 1486*/ GIMT_Encode4(84291),
     /*  60354 */ /*GILLT_v16s8*//*Label 1487*/ GIMT_Encode4(84373),
     /*  60358 */ /*GILLT_v16s16*//*Label 1488*/ GIMT_Encode4(84627),
     /*  60362 */ /*GILLT_v16s32*//*Label 1489*/ GIMT_Encode4(84961),
     /*  60366 */ /*GILLT_v32s1*//*Label 1490*/ GIMT_Encode4(85135),
     /*  60370 */ /*GILLT_v32s8*//*Label 1491*/ GIMT_Encode4(85217),
     /*  60374 */ /*GILLT_v32s16*//*Label 1492*/ GIMT_Encode4(85391),
     /*  60378 */ /*GILLT_v64s1*//*Label 1493*/ GIMT_Encode4(85565),
     /*  60382 */ /*GILLT_v64s8*//*Label 1494*/ GIMT_Encode4(85647),
     /*  60386 */ // Label 1473: @60386
     /*  60386 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(60482), // Rule ID 22491 //
     /*  60391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60394 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60412 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60416 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60420 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60424 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60435 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60442 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60446 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60450 */   // MIs[0] dst
     /*  60450 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60455 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60457 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60464 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60467 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60471 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60474 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60480 */   GIR_RootConstrainSelectedInstOperands,
     /*  60481 */   // GIR_Coverage, 22491,
     /*  60481 */   GIR_EraseRootFromParent_Done,
     /*  60482 */ // Label 1496: @60482
     /*  60482 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(60578), // Rule ID 22495 //
     /*  60487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60490 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60493 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60508 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60512 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60516 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60520 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60527 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60531 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60538 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60542 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60546 */   // MIs[0] dst
     /*  60546 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60551 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60553 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60560 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60563 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60567 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60576 */   GIR_RootConstrainSelectedInstOperands,
     /*  60577 */   // GIR_Coverage, 22495,
     /*  60577 */   GIR_EraseRootFromParent_Done,
     /*  60578 */ // Label 1497: @60578
     /*  60578 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(60671), // Rule ID 22499 //
     /*  60583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  60601 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60605 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60609 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  60613 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60621 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60624 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60628 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60635 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60639 */   // MIs[0] dst
     /*  60639 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60644 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60646 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60653 */   // (atomic_store (sub:{ *:[i8] } 0:{ *:[i8] }, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  60656 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60660 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60669 */   GIR_RootConstrainSelectedInstOperands,
     /*  60670 */   // GIR_Coverage, 22499,
     /*  60670 */   GIR_EraseRootFromParent_Done,
     /*  60671 */ // Label 1498: @60671
     /*  60671 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(60761), // Rule ID 22503 //
     /*  60676 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60679 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60686 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60690 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60694 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60698 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60702 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60706 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60710 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60717 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60724 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60728 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60732 */   // MIs[0] dst
     /*  60732 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60737 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60739 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60746 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NOT8m addr:{ *:[iPTR] }:$dst)
     /*  60746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  60749 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60753 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60759 */   GIR_RootConstrainSelectedInstOperands,
     /*  60760 */   // GIR_Coverage, 22503,
     /*  60760 */   GIR_EraseRootFromParent_Done,
     /*  60761 */ // Label 1499: @60761
     /*  60761 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(60847), // Rule ID 225 //
     /*  60766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60784 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60788 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60792 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60796 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60800 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60803 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60807 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60811 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60815 */   // MIs[0] src1
     /*  60815 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60820 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60822 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60829 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  60829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60832 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  60836 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60845 */   GIR_RootConstrainSelectedInstOperands,
     /*  60846 */   // GIR_Coverage, 225,
     /*  60846 */   GIR_EraseRootFromParent_Done,
     /*  60847 */ // Label 1500: @60847
     /*  60847 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(60933), // Rule ID 228 //
     /*  60852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60858 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60878 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60882 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60886 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60889 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60893 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60897 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60901 */   // MIs[0] src1
     /*  60901 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60906 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60908 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60915 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  60915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60918 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  60922 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60931 */   GIR_RootConstrainSelectedInstOperands,
     /*  60932 */   // GIR_Coverage, 228,
     /*  60932 */   GIR_EraseRootFromParent_Done,
     /*  60933 */ // Label 1501: @60933
     /*  60933 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(61016), // Rule ID 17612 //
     /*  60938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60941 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  60953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60961 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60965 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60969 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60972 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60976 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60980 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  60984 */   // MIs[0] dst
     /*  60984 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60989 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60991 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60998 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1),
     /*  61001 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61005 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61014 */   GIR_RootConstrainSelectedInstOperands,
     /*  61015 */   // GIR_Coverage, 17612,
     /*  61015 */   GIR_EraseRootFromParent_Done,
     /*  61016 */ // Label 1502: @61016
     /*  61016 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(61099), // Rule ID 17616 //
     /*  61021 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61028 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  61036 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61040 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61044 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61048 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61052 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61055 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61059 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61063 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61067 */   // MIs[0] dst
     /*  61067 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61072 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61074 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61081 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1),
     /*  61084 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61088 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61097 */   GIR_RootConstrainSelectedInstOperands,
     /*  61098 */   // GIR_Coverage, 17616,
     /*  61098 */   GIR_EraseRootFromParent_Done,
     /*  61099 */ // Label 1503: @61099
     /*  61099 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(61182), // Rule ID 261 //
     /*  61104 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61107 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61119 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61123 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61127 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  61131 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61135 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61139 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61142 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61146 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61150 */   // MIs[0] src1
     /*  61150 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61155 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61157 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61164 */   // (st (sub:{ *:[i8] } 0:{ *:[i8] }, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  61167 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61171 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61174 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61180 */   GIR_RootConstrainSelectedInstOperands,
     /*  61181 */   // GIR_Coverage, 261,
     /*  61181 */   GIR_EraseRootFromParent_Done,
     /*  61182 */ // Label 1504: @61182
     /*  61182 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(61262), // Rule ID 269 //
     /*  61187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61190 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61194 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61202 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61206 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61210 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61214 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61218 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61221 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61225 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61229 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61233 */   // MIs[0] src1
     /*  61233 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61238 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61240 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61247 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT8m addr:{ *:[iPTR] }:$src1)
     /*  61247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  61250 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61260 */   GIR_RootConstrainSelectedInstOperands,
     /*  61261 */   // GIR_Coverage, 269,
     /*  61261 */   GIR_EraseRootFromParent_Done,
     /*  61262 */ // Label 1505: @61262
     /*  61262 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(61357), // Rule ID 413 //
     /*  61267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61270 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61290 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61294 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61298 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61301 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61305 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61309 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61313 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61317 */   // MIs[3] Operand 1
     /*  61317 */   // No operand predicates
     /*  61317 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61321 */   // MIs[0] src1
     /*  61321 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61326 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61328 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61335 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61338 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61342 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61345 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61355 */   GIR_RootConstrainSelectedInstOperands,
     /*  61356 */   // GIR_Coverage, 413,
     /*  61356 */   GIR_EraseRootFromParent_Done,
     /*  61357 */ // Label 1506: @61357
     /*  61357 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(61452), // Rule ID 305 //
     /*  61362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61365 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61377 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61381 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61385 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61389 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61393 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61400 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61404 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61408 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61412 */   // MIs[3] Operand 1
     /*  61412 */   // No operand predicates
     /*  61412 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61416 */   // MIs[0] src1
     /*  61416 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61421 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61423 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61430 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61433 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61437 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61440 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61450 */   GIR_RootConstrainSelectedInstOperands,
     /*  61451 */   // GIR_Coverage, 305,
     /*  61451 */   GIR_EraseRootFromParent_Done,
     /*  61452 */ // Label 1507: @61452
     /*  61452 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(61547), // Rule ID 341 //
     /*  61457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61464 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61472 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61476 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61480 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61484 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61488 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61491 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61495 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61499 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61503 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61507 */   // MIs[3] Operand 1
     /*  61507 */   // No operand predicates
     /*  61507 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61511 */   // MIs[0] src1
     /*  61511 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61516 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61518 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61525 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  61528 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61532 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61535 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61545 */   GIR_RootConstrainSelectedInstOperands,
     /*  61546 */   // GIR_Coverage, 341,
     /*  61546 */   GIR_EraseRootFromParent_Done,
     /*  61547 */ // Label 1508: @61547
     /*  61547 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(61642), // Rule ID 453 //
     /*  61552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61555 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61567 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61571 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61575 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61579 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61583 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61586 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61590 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61594 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61598 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61602 */   // MIs[3] Operand 1
     /*  61602 */   // No operand predicates
     /*  61602 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61606 */   // MIs[0] src1
     /*  61606 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61611 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61613 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61620 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  61623 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61627 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61630 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61640 */   GIR_RootConstrainSelectedInstOperands,
     /*  61641 */   // GIR_Coverage, 453,
     /*  61641 */   GIR_EraseRootFromParent_Done,
     /*  61642 */ // Label 1509: @61642
     /*  61642 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(61737), // Rule ID 377 //
     /*  61647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61654 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61658 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61662 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61666 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61670 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61674 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61678 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61681 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61685 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61689 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61693 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61697 */   // MIs[3] Operand 1
     /*  61697 */   // No operand predicates
     /*  61697 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61701 */   // MIs[0] src1
     /*  61701 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61706 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61708 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61715 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  61718 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61722 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61725 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61735 */   GIR_RootConstrainSelectedInstOperands,
     /*  61736 */   // GIR_Coverage, 377,
     /*  61736 */   GIR_EraseRootFromParent_Done,
     /*  61737 */ // Label 1510: @61737
     /*  61737 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(61838), // Rule ID 22427 //
     /*  61742 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61745 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61760 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61764 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61768 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61772 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61776 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61783 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61790 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61794 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61798 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61802 */   // MIs[3] Operand 1
     /*  61802 */   // No operand predicates
     /*  61802 */   // MIs[0] dst
     /*  61802 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61807 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61809 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61816 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  61816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61819 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61823 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  61826 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61829 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61836 */   GIR_RootConstrainSelectedInstOperands,
     /*  61837 */   // GIR_Coverage, 22427,
     /*  61837 */   GIR_EraseRootFromParent_Done,
     /*  61838 */ // Label 1511: @61838
     /*  61838 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(61939), // Rule ID 22435 //
     /*  61843 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61861 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61865 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61869 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61873 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61877 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61880 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61884 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61891 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61895 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61899 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61903 */   // MIs[3] Operand 1
     /*  61903 */   // No operand predicates
     /*  61903 */   // MIs[0] dst
     /*  61903 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61908 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61910 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61917 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  61917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61920 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61924 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  61927 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61930 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61937 */   GIR_RootConstrainSelectedInstOperands,
     /*  61938 */   // GIR_Coverage, 22435,
     /*  61938 */   GIR_EraseRootFromParent_Done,
     /*  61939 */ // Label 1512: @61939
     /*  61939 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(62040), // Rule ID 22443 //
     /*  61944 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61947 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61962 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61970 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61974 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61978 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61985 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61992 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61996 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62000 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62004 */   // MIs[3] Operand 1
     /*  62004 */   // No operand predicates
     /*  62004 */   // MIs[0] dst
     /*  62004 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62009 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62011 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62018 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  62021 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62025 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62028 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62038 */   GIR_RootConstrainSelectedInstOperands,
     /*  62039 */   // GIR_Coverage, 22443,
     /*  62039 */   GIR_EraseRootFromParent_Done,
     /*  62040 */ // Label 1513: @62040
     /*  62040 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(62141), // Rule ID 22459 //
     /*  62045 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  62063 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62067 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62071 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62075 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62086 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62093 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62097 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62101 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62105 */   // MIs[3] Operand 1
     /*  62105 */   // No operand predicates
     /*  62105 */   // MIs[0] dst
     /*  62105 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62110 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62112 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62119 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  62122 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62126 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62129 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62139 */   GIR_RootConstrainSelectedInstOperands,
     /*  62140 */   // GIR_Coverage, 22459,
     /*  62140 */   GIR_EraseRootFromParent_Done,
     /*  62141 */ // Label 1514: @62141
     /*  62141 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(62242), // Rule ID 22451 //
     /*  62146 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62149 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62156 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62164 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62168 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62172 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62176 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62180 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62187 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62194 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62198 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62202 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62206 */   // MIs[3] Operand 1
     /*  62206 */   // No operand predicates
     /*  62206 */   // MIs[0] dst
     /*  62206 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62211 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62213 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62220 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  62223 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62227 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62230 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62240 */   GIR_RootConstrainSelectedInstOperands,
     /*  62241 */   // GIR_Coverage, 22451,
     /*  62241 */   GIR_EraseRootFromParent_Done,
     /*  62242 */ // Label 1515: @62242
     /*  62242 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(62333), // Rule ID 733 //
     /*  62247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  62262 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62266 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62270 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62274 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62278 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62281 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62285 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62289 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62293 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62297 */   // MIs[3] Operand 1
     /*  62297 */   // No operand predicates
     /*  62297 */   // MIs[0] src1
     /*  62297 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62302 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62304 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62311 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi),
     /*  62314 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62318 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62321 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62331 */   GIR_RootConstrainSelectedInstOperands,
     /*  62332 */   // GIR_Coverage, 733,
     /*  62332 */   GIR_EraseRootFromParent_Done,
     /*  62333 */ // Label 1516: @62333
     /*  62333 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(62424), // Rule ID 701 //
     /*  62338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62353 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62357 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62361 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62365 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62369 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62372 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62376 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62380 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62384 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62388 */   // MIs[3] Operand 1
     /*  62388 */   // No operand predicates
     /*  62388 */   // MIs[0] src1
     /*  62388 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62393 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62395 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62402 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi),
     /*  62405 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62409 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62412 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62422 */   GIR_RootConstrainSelectedInstOperands,
     /*  62423 */   // GIR_Coverage, 701,
     /*  62423 */   GIR_EraseRootFromParent_Done,
     /*  62424 */ // Label 1517: @62424
     /*  62424 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(62515), // Rule ID 765 //
     /*  62429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  62444 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62448 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62452 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62456 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62460 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62463 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62467 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62471 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62475 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62479 */   // MIs[3] Operand 1
     /*  62479 */   // No operand predicates
     /*  62479 */   // MIs[0] src1
     /*  62479 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62484 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62486 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62493 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi),
     /*  62496 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62500 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62503 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62513 */   GIR_RootConstrainSelectedInstOperands,
     /*  62514 */   // GIR_Coverage, 765,
     /*  62514 */   GIR_EraseRootFromParent_Done,
     /*  62515 */ // Label 1518: @62515
     /*  62515 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(62606), // Rule ID 797 //
     /*  62520 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62523 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  62535 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62539 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62543 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62547 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62551 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62554 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62558 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62562 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62566 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62570 */   // MIs[3] Operand 1
     /*  62570 */   // No operand predicates
     /*  62570 */   // MIs[0] src1
     /*  62570 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62575 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62577 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62584 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi),
     /*  62587 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62591 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62594 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62604 */   GIR_RootConstrainSelectedInstOperands,
     /*  62605 */   // GIR_Coverage, 797,
     /*  62605 */   GIR_EraseRootFromParent_Done,
     /*  62606 */ // Label 1519: @62606
     /*  62606 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(62697), // Rule ID 669 //
     /*  62611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62614 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  62626 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62634 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62638 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62642 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62645 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62649 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62653 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62657 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62661 */   // MIs[3] Operand 1
     /*  62661 */   // No operand predicates
     /*  62661 */   // MIs[0] src1
     /*  62661 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62666 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62668 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62675 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi),
     /*  62678 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62682 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62685 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62688 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62695 */   GIR_RootConstrainSelectedInstOperands,
     /*  62696 */   // GIR_Coverage, 669,
     /*  62696 */   GIR_EraseRootFromParent_Done,
     /*  62697 */ // Label 1520: @62697
     /*  62697 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(62795), // Rule ID 22431 //
     /*  62702 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62705 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62712 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62720 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62724 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62728 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62732 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62736 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62739 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62743 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62750 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62759 */   // MIs[0] dst
     /*  62759 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62764 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62766 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62773 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62776 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62780 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62784 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62793 */   GIR_RootConstrainSelectedInstOperands,
     /*  62794 */   // GIR_Coverage, 22431,
     /*  62794 */   GIR_EraseRootFromParent_Done,
     /*  62795 */ // Label 1521: @62795
     /*  62795 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(62893), // Rule ID 26002 //
     /*  62800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62818 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62826 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62831 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62835 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62839 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62842 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62846 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62853 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62857 */   // MIs[0] dst
     /*  62857 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62862 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62864 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62871 */   // (atomic_store (add:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62874 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62878 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  62882 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62891 */   GIR_RootConstrainSelectedInstOperands,
     /*  62892 */   // GIR_Coverage, 26002,
     /*  62892 */   GIR_EraseRootFromParent_Done,
     /*  62893 */ // Label 1522: @62893
     /*  62893 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(62991), // Rule ID 22439 //
     /*  62898 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62901 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62916 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62920 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62924 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62928 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62939 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62946 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62955 */   // MIs[0] dst
     /*  62955 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62960 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62962 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62969 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  62972 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62976 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62980 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62989 */   GIR_RootConstrainSelectedInstOperands,
     /*  62990 */   // GIR_Coverage, 22439,
     /*  62990 */   GIR_EraseRootFromParent_Done,
     /*  62991 */ // Label 1523: @62991
     /*  62991 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63089), // Rule ID 26006 //
     /*  62996 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63014 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63018 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63027 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63031 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63035 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63042 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63049 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63053 */   // MIs[0] dst
     /*  63053 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63058 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63060 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63067 */   // (atomic_store (and:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63070 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63074 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63078 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63087 */   GIR_RootConstrainSelectedInstOperands,
     /*  63088 */   // GIR_Coverage, 26006,
     /*  63088 */   GIR_EraseRootFromParent_Done,
     /*  63089 */ // Label 1524: @63089
     /*  63089 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63187), // Rule ID 22447 //
     /*  63094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63104 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63112 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63116 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63120 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63124 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63128 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63131 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63135 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63142 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63146 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63151 */   // MIs[0] dst
     /*  63151 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63156 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63158 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63165 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63168 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63172 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63176 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63185 */   GIR_RootConstrainSelectedInstOperands,
     /*  63186 */   // GIR_Coverage, 22447,
     /*  63186 */   GIR_EraseRootFromParent_Done,
     /*  63187 */ // Label 1525: @63187
     /*  63187 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63285), // Rule ID 26010 //
     /*  63192 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63195 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63210 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63214 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63218 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63223 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63227 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63231 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63238 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63245 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63249 */   // MIs[0] dst
     /*  63249 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63254 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63256 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63263 */   // (atomic_store (or:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63266 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63270 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63274 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63283 */   GIR_RootConstrainSelectedInstOperands,
     /*  63284 */   // GIR_Coverage, 26010,
     /*  63284 */   GIR_EraseRootFromParent_Done,
     /*  63285 */ // Label 1526: @63285
     /*  63285 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63383), // Rule ID 22463 //
     /*  63290 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63293 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  63308 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63312 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63316 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63320 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63324 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63331 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63338 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63342 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63347 */   // MIs[0] dst
     /*  63347 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63352 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63354 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63361 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  63364 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63368 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63372 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63381 */   GIR_RootConstrainSelectedInstOperands,
     /*  63382 */   // GIR_Coverage, 22463,
     /*  63382 */   GIR_EraseRootFromParent_Done,
     /*  63383 */ // Label 1527: @63383
     /*  63383 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63481), // Rule ID 22455 //
     /*  63388 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63391 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63398 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63402 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63406 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63410 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63414 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63418 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63422 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63425 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63429 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63436 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63440 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63445 */   // MIs[0] dst
     /*  63445 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63450 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63452 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63459 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63462 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63466 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63470 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63479 */   GIR_RootConstrainSelectedInstOperands,
     /*  63480 */   // GIR_Coverage, 22455,
     /*  63480 */   GIR_EraseRootFromParent_Done,
     /*  63481 */ // Label 1528: @63481
     /*  63481 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63579), // Rule ID 26014 //
     /*  63486 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63496 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63504 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63508 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63512 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63517 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63521 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63525 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63528 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63532 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63539 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63543 */   // MIs[0] dst
     /*  63543 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63548 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63550 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63557 */   // (atomic_store (xor:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63560 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63564 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63568 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63571 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63577 */   GIR_RootConstrainSelectedInstOperands,
     /*  63578 */   // GIR_Coverage, 26014,
     /*  63578 */   GIR_EraseRootFromParent_Done,
     /*  63579 */ // Label 1529: @63579
     /*  63579 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63667), // Rule ID 409 //
     /*  63584 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63587 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63591 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63599 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63603 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63607 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63611 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63615 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63622 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63626 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63631 */   // MIs[0] src1
     /*  63631 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63636 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63638 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63645 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63648 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63652 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63656 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63665 */   GIR_RootConstrainSelectedInstOperands,
     /*  63666 */   // GIR_Coverage, 409,
     /*  63666 */   GIR_EraseRootFromParent_Done,
     /*  63667 */ // Label 1530: @63667
     /*  63667 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63755), // Rule ID 23222 //
     /*  63672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63675 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63679 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63683 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63687 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63691 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63695 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63700 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63704 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63708 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63711 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63715 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63719 */   // MIs[0] src1
     /*  63719 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63724 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63726 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63733 */   // (st (add:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63736 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63740 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63744 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63753 */   GIR_RootConstrainSelectedInstOperands,
     /*  63754 */   // GIR_Coverage, 23222,
     /*  63754 */   GIR_EraseRootFromParent_Done,
     /*  63755 */ // Label 1531: @63755
     /*  63755 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63843), // Rule ID 301 //
     /*  63760 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63763 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63775 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63779 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63783 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63787 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63791 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63794 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63798 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63807 */   // MIs[0] src1
     /*  63807 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63812 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63814 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63821 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63824 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63828 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63832 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63841 */   GIR_RootConstrainSelectedInstOperands,
     /*  63842 */   // GIR_Coverage, 301,
     /*  63842 */   GIR_EraseRootFromParent_Done,
     /*  63843 */ // Label 1532: @63843
     /*  63843 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(63931), // Rule ID 23186 //
     /*  63848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63851 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63855 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63863 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63867 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63871 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63876 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63880 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63884 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63891 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63895 */   // MIs[0] src1
     /*  63895 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63900 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63902 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63909 */   // (st (and:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63912 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63916 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63920 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63929 */   GIR_RootConstrainSelectedInstOperands,
     /*  63930 */   // GIR_Coverage, 23186,
     /*  63930 */   GIR_EraseRootFromParent_Done,
     /*  63931 */ // Label 1533: @63931
     /*  63931 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(64029), // Rule ID 749 //
     /*  63936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  63951 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63955 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63959 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63963 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63967 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63970 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63974 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  63978 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  63983 */   // MIs[0] src1
     /*  63983 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63988 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63990 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63997 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  63997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64001 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64007 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL),
     /*  64014 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64018 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64027 */   GIR_RootConstrainSelectedInstOperands,
     /*  64028 */   // GIR_Coverage, 749,
     /*  64028 */   GIR_EraseRootFromParent_Done,
     /*  64029 */ // Label 1534: @64029
     /*  64029 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(64127), // Rule ID 717 //
     /*  64034 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64037 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64041 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64045 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64049 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64053 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64057 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64061 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64065 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64068 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64072 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64076 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64081 */   // MIs[0] src1
     /*  64081 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64086 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64088 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64095 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64099 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL),
     /*  64112 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64116 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64125 */   GIR_RootConstrainSelectedInstOperands,
     /*  64126 */   // GIR_Coverage, 717,
     /*  64126 */   GIR_EraseRootFromParent_Done,
     /*  64127 */ // Label 1535: @64127
     /*  64127 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(64215), // Rule ID 337 //
     /*  64132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64139 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64143 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64147 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64155 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64159 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64163 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64170 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64174 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64179 */   // MIs[0] src1
     /*  64179 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64184 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64186 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64193 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64196 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64200 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64204 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64213 */   GIR_RootConstrainSelectedInstOperands,
     /*  64214 */   // GIR_Coverage, 337,
     /*  64214 */   GIR_EraseRootFromParent_Done,
     /*  64215 */ // Label 1536: @64215
     /*  64215 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(64303), // Rule ID 23198 //
     /*  64220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64223 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64235 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64239 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64243 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64248 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64252 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64256 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64259 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64263 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64267 */   // MIs[0] src1
     /*  64267 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64272 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64274 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64281 */   // (st (or:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64284 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64292 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64301 */   GIR_RootConstrainSelectedInstOperands,
     /*  64302 */   // GIR_Coverage, 23198,
     /*  64302 */   GIR_EraseRootFromParent_Done,
     /*  64303 */ // Label 1537: @64303
     /*  64303 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(64401), // Rule ID 781 //
     /*  64308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64315 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64319 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  64323 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64327 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64331 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64335 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64339 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64342 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64346 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64350 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64355 */   // MIs[0] src1
     /*  64355 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64360 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64362 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64369 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64373 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64379 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL),
     /*  64386 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64390 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64399 */   GIR_RootConstrainSelectedInstOperands,
     /*  64400 */   // GIR_Coverage, 781,
     /*  64400 */   GIR_EraseRootFromParent_Done,
     /*  64401 */ // Label 1538: @64401
     /*  64401 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(64499), // Rule ID 813 //
     /*  64406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  64421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64429 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64433 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64437 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64440 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64444 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64448 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64453 */   // MIs[0] src1
     /*  64453 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64458 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64460 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64467 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64471 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64477 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL),
     /*  64484 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64488 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64497 */   GIR_RootConstrainSelectedInstOperands,
     /*  64498 */   // GIR_Coverage, 813,
     /*  64498 */   GIR_EraseRootFromParent_Done,
     /*  64499 */ // Label 1539: @64499
     /*  64499 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(64597), // Rule ID 685 //
     /*  64504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64507 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  64519 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64523 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64527 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64531 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64535 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64538 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64542 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64546 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64551 */   // MIs[0] src1
     /*  64551 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64556 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64558 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64565 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64569 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64575 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL),
     /*  64582 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64586 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64595 */   GIR_RootConstrainSelectedInstOperands,
     /*  64596 */   // GIR_Coverage, 685,
     /*  64596 */   GIR_EraseRootFromParent_Done,
     /*  64597 */ // Label 1540: @64597
     /*  64597 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(64685), // Rule ID 445 //
     /*  64602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64605 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  64617 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64625 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64629 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64633 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64640 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64644 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64649 */   // MIs[0] src1
     /*  64649 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64654 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64656 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64663 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  64666 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64670 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64674 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64683 */   GIR_RootConstrainSelectedInstOperands,
     /*  64684 */   // GIR_Coverage, 445,
     /*  64684 */   GIR_EraseRootFromParent_Done,
     /*  64685 */ // Label 1541: @64685
     /*  64685 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(64773), // Rule ID 373 //
     /*  64690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64693 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64697 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64705 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64709 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64713 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64717 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64721 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64728 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64737 */   // MIs[0] src1
     /*  64737 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64742 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64744 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64751 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64754 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64758 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64762 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64765 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64771 */   GIR_RootConstrainSelectedInstOperands,
     /*  64772 */   // GIR_Coverage, 373,
     /*  64772 */   GIR_EraseRootFromParent_Done,
     /*  64773 */ // Label 1542: @64773
     /*  64773 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(64861), // Rule ID 23210 //
     /*  64778 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64781 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64793 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64797 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64801 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64806 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64810 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64814 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64821 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64825 */   // MIs[0] src1
     /*  64825 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64830 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64832 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64839 */   // (st (xor:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64842 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64846 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64850 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64859 */   GIR_RootConstrainSelectedInstOperands,
     /*  64860 */   // GIR_Coverage, 23210,
     /*  64860 */   GIR_EraseRootFromParent_Done,
     /*  64861 */ // Label 1543: @64861
     /*  64861 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(64915), // Rule ID 24 //
     /*  64866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64881 */   // MIs[1] Operand 1
     /*  64881 */   // No operand predicates
     /*  64881 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  64885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64898 */   // (st (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  64898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  64901 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64905 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  64908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  64913 */   GIR_RootConstrainSelectedInstOperands,
     /*  64914 */   // GIR_Coverage, 24,
     /*  64914 */   GIR_EraseRootFromParent_Done,
     /*  64915 */ // Label 1544: @64915
     /*  64915 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(64968), // Rule ID 22507 //
     /*  64920 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  64930 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64934 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64938 */   // MIs[1] Operand 1
     /*  64938 */   // No operand predicates
     /*  64938 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64944 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64951 */   // (atomic_store (imm:{ *:[i8] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  64951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  64954 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64958 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  64961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  64966 */   GIR_RootConstrainSelectedInstOperands,
     /*  64967 */   // GIR_Coverage, 22507,
     /*  64967 */   GIR_EraseRootFromParent_Done,
     /*  64968 */ // Label 1545: @64968
     /*  64968 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(65013), // Rule ID 22511 //
     /*  64973 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64976 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  64983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64987 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64998 */   // (atomic_store GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  64998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65001 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65005 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65011 */   GIR_RootConstrainSelectedInstOperands,
     /*  65012 */   // GIR_Coverage, 22511,
     /*  65012 */   GIR_EraseRootFromParent_Done,
     /*  65013 */ // Label 1546: @65013
     /*  65013 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(65055), // Rule ID 32 //
     /*  65018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65040 */   // (st GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65043 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65047 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65053 */   GIR_RootConstrainSelectedInstOperands,
     /*  65054 */   // GIR_Coverage, 32,
     /*  65054 */   GIR_EraseRootFromParent_Done,
     /*  65055 */ // Label 1547: @65055
     /*  65055 */ GIM_Reject,
     /*  65056 */ // Label 1474: @65056
     /*  65056 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(65152), // Rule ID 22492 //
     /*  65061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65064 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65067 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65082 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65086 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65090 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65094 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65101 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65105 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65112 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65116 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65120 */   // MIs[0] dst
     /*  65120 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65125 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65127 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65134 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65137 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65141 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65150 */   GIR_RootConstrainSelectedInstOperands,
     /*  65151 */   // GIR_Coverage, 22492,
     /*  65151 */   GIR_EraseRootFromParent_Done,
     /*  65152 */ // Label 1548: @65152
     /*  65152 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(65248), // Rule ID 22496 //
     /*  65157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65160 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65178 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65182 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65186 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65190 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65201 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65208 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65212 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65216 */   // MIs[0] dst
     /*  65216 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65221 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65223 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65230 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65233 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65237 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65246 */   GIR_RootConstrainSelectedInstOperands,
     /*  65247 */   // GIR_Coverage, 22496,
     /*  65247 */   GIR_EraseRootFromParent_Done,
     /*  65248 */ // Label 1549: @65248
     /*  65248 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(65341), // Rule ID 22500 //
     /*  65253 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65263 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65271 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65275 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65279 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65283 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65287 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65291 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65294 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65298 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65305 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65309 */   // MIs[0] dst
     /*  65309 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65314 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65316 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65323 */   // (atomic_store (sub:{ *:[i16] } 0:{ *:[i16] }, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65326 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65330 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65339 */   GIR_RootConstrainSelectedInstOperands,
     /*  65340 */   // GIR_Coverage, 22500,
     /*  65340 */   GIR_EraseRootFromParent_Done,
     /*  65341 */ // Label 1550: @65341
     /*  65341 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(65431), // Rule ID 22504 //
     /*  65346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65364 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65368 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65372 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65376 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65380 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65383 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65387 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65394 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65398 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65402 */   // MIs[0] dst
     /*  65402 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65407 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65409 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65416 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NOT16m addr:{ *:[iPTR] }:$dst)
     /*  65416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  65419 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65429 */   GIR_RootConstrainSelectedInstOperands,
     /*  65430 */   // GIR_Coverage, 22504,
     /*  65430 */   GIR_EraseRootFromParent_Done,
     /*  65431 */ // Label 1551: @65431
     /*  65431 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(65517), // Rule ID 226 //
     /*  65436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65442 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65454 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65462 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65466 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65470 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65473 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65477 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65481 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65485 */   // MIs[0] src1
     /*  65485 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65490 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65492 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65499 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65502 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65506 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65515 */   GIR_RootConstrainSelectedInstOperands,
     /*  65516 */   // GIR_Coverage, 226,
     /*  65516 */   GIR_EraseRootFromParent_Done,
     /*  65517 */ // Label 1552: @65517
     /*  65517 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(65603), // Rule ID 229 //
     /*  65522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65525 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65528 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65540 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65544 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65548 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65552 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65556 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65559 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65563 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65567 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65571 */   // MIs[0] src1
     /*  65571 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65576 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65578 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65585 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65588 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65592 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65601 */   GIR_RootConstrainSelectedInstOperands,
     /*  65602 */   // GIR_Coverage, 229,
     /*  65602 */   GIR_EraseRootFromParent_Done,
     /*  65603 */ // Label 1553: @65603
     /*  65603 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(65696), // Rule ID 22614 //
     /*  65608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65623 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65627 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65631 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65635 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65639 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65642 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65646 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65650 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  65661 */   // MIs[0] dst
     /*  65661 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65666 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65668 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65675 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i16] })
     /*  65675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  65678 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  65685 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65688 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65694 */   GIR_RootConstrainSelectedInstOperands,
     /*  65695 */   // GIR_Coverage, 22614,
     /*  65695 */   GIR_EraseRootFromParent_Done,
     /*  65696 */ // Label 1554: @65696
     /*  65696 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(65779), // Rule ID 17613 //
     /*  65701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  65716 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65720 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65724 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65728 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65732 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65735 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65739 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65743 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65747 */   // MIs[0] dst
     /*  65747 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65752 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65754 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65761 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1),
     /*  65764 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65768 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65777 */   GIR_RootConstrainSelectedInstOperands,
     /*  65778 */   // GIR_Coverage, 17613,
     /*  65778 */   GIR_EraseRootFromParent_Done,
     /*  65779 */ // Label 1555: @65779
     /*  65779 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(65862), // Rule ID 17617 //
     /*  65784 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65787 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65791 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  65799 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65803 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65807 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65811 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65815 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65818 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65822 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65826 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65830 */   // MIs[0] dst
     /*  65830 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65835 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65837 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65844 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1),
     /*  65847 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65851 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65860 */   GIR_RootConstrainSelectedInstOperands,
     /*  65861 */   // GIR_Coverage, 17617,
     /*  65861 */   GIR_EraseRootFromParent_Done,
     /*  65862 */ // Label 1556: @65862
     /*  65862 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(65945), // Rule ID 262 //
     /*  65867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65870 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65890 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65894 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65898 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65902 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65905 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65909 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65913 */   // MIs[0] src1
     /*  65913 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65918 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65920 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65927 */   // (st (sub:{ *:[i16] } 0:{ *:[i16] }, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65930 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65934 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65943 */   GIR_RootConstrainSelectedInstOperands,
     /*  65944 */   // GIR_Coverage, 262,
     /*  65944 */   GIR_EraseRootFromParent_Done,
     /*  65945 */ // Label 1557: @65945
     /*  65945 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(66025), // Rule ID 270 //
     /*  65950 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65953 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65965 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65969 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65973 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65977 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65981 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65984 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65988 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65992 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65996 */   // MIs[0] src1
     /*  65996 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66001 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66003 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66010 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT16m addr:{ *:[iPTR] }:$src1)
     /*  66010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  66013 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66023 */   GIR_RootConstrainSelectedInstOperands,
     /*  66024 */   // GIR_Coverage, 270,
     /*  66024 */   GIR_EraseRootFromParent_Done,
     /*  66025 */ // Label 1558: @66025
     /*  66025 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(66120), // Rule ID 414 //
     /*  66030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66045 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66049 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66053 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66057 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66061 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66068 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66072 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66076 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66080 */   // MIs[3] Operand 1
     /*  66080 */   // No operand predicates
     /*  66080 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66084 */   // MIs[0] src1
     /*  66084 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66089 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66091 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66098 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66101 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66105 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66108 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66118 */   GIR_RootConstrainSelectedInstOperands,
     /*  66119 */   // GIR_Coverage, 414,
     /*  66119 */   GIR_EraseRootFromParent_Done,
     /*  66120 */ // Label 1559: @66120
     /*  66120 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(66215), // Rule ID 306 //
     /*  66125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66128 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66140 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66144 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66148 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66152 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66156 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66159 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66163 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66167 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66171 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66175 */   // MIs[3] Operand 1
     /*  66175 */   // No operand predicates
     /*  66175 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66179 */   // MIs[0] src1
     /*  66179 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66184 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66186 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66193 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66196 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66200 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66203 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66213 */   GIR_RootConstrainSelectedInstOperands,
     /*  66214 */   // GIR_Coverage, 306,
     /*  66214 */   GIR_EraseRootFromParent_Done,
     /*  66215 */ // Label 1560: @66215
     /*  66215 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(66310), // Rule ID 342 //
     /*  66220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66223 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66235 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66239 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66243 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66247 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66251 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66254 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66258 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66262 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66266 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66270 */   // MIs[3] Operand 1
     /*  66270 */   // No operand predicates
     /*  66270 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66274 */   // MIs[0] src1
     /*  66274 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66279 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66281 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66288 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66291 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66295 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66298 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66308 */   GIR_RootConstrainSelectedInstOperands,
     /*  66309 */   // GIR_Coverage, 342,
     /*  66309 */   GIR_EraseRootFromParent_Done,
     /*  66310 */ // Label 1561: @66310
     /*  66310 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(66405), // Rule ID 454 //
     /*  66315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66330 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66334 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66338 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66342 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66346 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66353 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66357 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66361 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66365 */   // MIs[3] Operand 1
     /*  66365 */   // No operand predicates
     /*  66365 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66369 */   // MIs[0] src1
     /*  66369 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66374 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66376 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66383 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66386 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66390 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66393 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66403 */   GIR_RootConstrainSelectedInstOperands,
     /*  66404 */   // GIR_Coverage, 454,
     /*  66404 */   GIR_EraseRootFromParent_Done,
     /*  66405 */ // Label 1562: @66405
     /*  66405 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(66500), // Rule ID 378 //
     /*  66410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66413 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66417 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66425 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66429 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66433 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66437 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66441 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66448 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66452 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66456 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66460 */   // MIs[3] Operand 1
     /*  66460 */   // No operand predicates
     /*  66460 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66464 */   // MIs[0] src1
     /*  66464 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66469 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66471 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66478 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66481 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66485 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66488 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66498 */   GIR_RootConstrainSelectedInstOperands,
     /*  66499 */   // GIR_Coverage, 378,
     /*  66499 */   GIR_EraseRootFromParent_Done,
     /*  66500 */ // Label 1563: @66500
     /*  66500 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(66601), // Rule ID 22428 //
     /*  66505 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66523 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66527 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66539 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66546 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66553 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66557 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66561 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66565 */   // MIs[3] Operand 1
     /*  66565 */   // No operand predicates
     /*  66565 */   // MIs[0] dst
     /*  66565 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66570 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66572 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66579 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66582 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66586 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66589 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66599 */   GIR_RootConstrainSelectedInstOperands,
     /*  66600 */   // GIR_Coverage, 22428,
     /*  66600 */   GIR_EraseRootFromParent_Done,
     /*  66601 */ // Label 1564: @66601
     /*  66601 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(66702), // Rule ID 22436 //
     /*  66606 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66624 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66628 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66632 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66636 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66640 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66647 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66654 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66658 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66662 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66666 */   // MIs[3] Operand 1
     /*  66666 */   // No operand predicates
     /*  66666 */   // MIs[0] dst
     /*  66666 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66671 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66673 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66680 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66683 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66687 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66690 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66700 */   GIR_RootConstrainSelectedInstOperands,
     /*  66701 */   // GIR_Coverage, 22436,
     /*  66701 */   GIR_EraseRootFromParent_Done,
     /*  66702 */ // Label 1565: @66702
     /*  66702 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(66803), // Rule ID 22444 //
     /*  66707 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66710 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66717 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66725 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66729 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66733 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66737 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66744 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66748 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66755 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66759 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66763 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66767 */   // MIs[3] Operand 1
     /*  66767 */   // No operand predicates
     /*  66767 */   // MIs[0] dst
     /*  66767 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66772 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66774 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66781 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66784 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66788 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66791 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66801 */   GIR_RootConstrainSelectedInstOperands,
     /*  66802 */   // GIR_Coverage, 22444,
     /*  66802 */   GIR_EraseRootFromParent_Done,
     /*  66803 */ // Label 1566: @66803
     /*  66803 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(66904), // Rule ID 22460 //
     /*  66808 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66811 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66834 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66838 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66842 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66849 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66856 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66860 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66864 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66868 */   // MIs[3] Operand 1
     /*  66868 */   // No operand predicates
     /*  66868 */   // MIs[0] dst
     /*  66868 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66873 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66875 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66882 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66885 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66889 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66892 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66902 */   GIR_RootConstrainSelectedInstOperands,
     /*  66903 */   // GIR_Coverage, 22460,
     /*  66903 */   GIR_EraseRootFromParent_Done,
     /*  66904 */ // Label 1567: @66904
     /*  66904 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(67005), // Rule ID 22452 //
     /*  66909 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66927 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66931 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66935 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66939 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66943 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66950 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66957 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66961 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66965 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66969 */   // MIs[3] Operand 1
     /*  66969 */   // No operand predicates
     /*  66969 */   // MIs[0] dst
     /*  66969 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66974 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66976 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66983 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66986 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66990 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66993 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67003 */   GIR_RootConstrainSelectedInstOperands,
     /*  67004 */   // GIR_Coverage, 22452,
     /*  67004 */   GIR_EraseRootFromParent_Done,
     /*  67005 */ // Label 1568: @67005
     /*  67005 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(67096), // Rule ID 734 //
     /*  67010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67013 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  67025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67029 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67033 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67037 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67041 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67044 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67048 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67052 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67056 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67060 */   // MIs[3] Operand 1
     /*  67060 */   // No operand predicates
     /*  67060 */   // MIs[0] src1
     /*  67060 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67065 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67067 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67074 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi),
     /*  67077 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67081 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67084 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67094 */   GIR_RootConstrainSelectedInstOperands,
     /*  67095 */   // GIR_Coverage, 734,
     /*  67095 */   GIR_EraseRootFromParent_Done,
     /*  67096 */ // Label 1569: @67096
     /*  67096 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(67187), // Rule ID 702 //
     /*  67101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  67116 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67120 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67124 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67128 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67132 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67135 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67139 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67143 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67147 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67151 */   // MIs[3] Operand 1
     /*  67151 */   // No operand predicates
     /*  67151 */   // MIs[0] src1
     /*  67151 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67156 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67158 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67165 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi),
     /*  67168 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67172 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67175 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67178 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67185 */   GIR_RootConstrainSelectedInstOperands,
     /*  67186 */   // GIR_Coverage, 702,
     /*  67186 */   GIR_EraseRootFromParent_Done,
     /*  67187 */ // Label 1570: @67187
     /*  67187 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(67278), // Rule ID 766 //
     /*  67192 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67195 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67199 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  67207 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67211 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67215 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67219 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67223 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67226 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67230 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67234 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67238 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67242 */   // MIs[3] Operand 1
     /*  67242 */   // No operand predicates
     /*  67242 */   // MIs[0] src1
     /*  67242 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67247 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67249 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67256 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi),
     /*  67259 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67263 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67266 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67276 */   GIR_RootConstrainSelectedInstOperands,
     /*  67277 */   // GIR_Coverage, 766,
     /*  67277 */   GIR_EraseRootFromParent_Done,
     /*  67278 */ // Label 1571: @67278
     /*  67278 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(67369), // Rule ID 798 //
     /*  67283 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67286 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67290 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67294 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  67298 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67302 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67306 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67310 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67314 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67317 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67321 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67325 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67329 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67333 */   // MIs[3] Operand 1
     /*  67333 */   // No operand predicates
     /*  67333 */   // MIs[0] src1
     /*  67333 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67338 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67340 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67347 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi),
     /*  67350 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67354 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67357 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67367 */   GIR_RootConstrainSelectedInstOperands,
     /*  67368 */   // GIR_Coverage, 798,
     /*  67368 */   GIR_EraseRootFromParent_Done,
     /*  67369 */ // Label 1572: @67369
     /*  67369 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(67460), // Rule ID 670 //
     /*  67374 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67377 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  67389 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67397 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67401 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67405 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67408 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67412 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67416 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67420 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67424 */   // MIs[3] Operand 1
     /*  67424 */   // No operand predicates
     /*  67424 */   // MIs[0] src1
     /*  67424 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67429 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67431 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67438 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi),
     /*  67441 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67445 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67448 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67458 */   GIR_RootConstrainSelectedInstOperands,
     /*  67459 */   // GIR_Coverage, 670,
     /*  67459 */   GIR_EraseRootFromParent_Done,
     /*  67460 */ // Label 1573: @67460
     /*  67460 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(67558), // Rule ID 22432 //
     /*  67465 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67483 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67487 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67491 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67495 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67499 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67502 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67506 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67513 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67517 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67522 */   // MIs[0] dst
     /*  67522 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67527 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67529 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67536 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67539 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67543 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67547 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67550 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67556 */   GIR_RootConstrainSelectedInstOperands,
     /*  67557 */   // GIR_Coverage, 22432,
     /*  67557 */   GIR_EraseRootFromParent_Done,
     /*  67558 */ // Label 1574: @67558
     /*  67558 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(67656), // Rule ID 26003 //
     /*  67563 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67566 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67581 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67585 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67589 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67594 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67598 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67602 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67605 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67609 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67616 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67620 */   // MIs[0] dst
     /*  67620 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67625 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67627 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67634 */   // (atomic_store (add:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67637 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67641 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67645 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67654 */   GIR_RootConstrainSelectedInstOperands,
     /*  67655 */   // GIR_Coverage, 26003,
     /*  67655 */   GIR_EraseRootFromParent_Done,
     /*  67656 */ // Label 1575: @67656
     /*  67656 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(67754), // Rule ID 22440 //
     /*  67661 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67664 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67687 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67691 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67695 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67702 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67709 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67713 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67718 */   // MIs[0] dst
     /*  67718 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67723 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67725 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67732 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67735 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67739 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67743 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67746 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67752 */   GIR_RootConstrainSelectedInstOperands,
     /*  67753 */   // GIR_Coverage, 22440,
     /*  67753 */   GIR_EraseRootFromParent_Done,
     /*  67754 */ // Label 1576: @67754
     /*  67754 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(67852), // Rule ID 26007 //
     /*  67759 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67762 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67777 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67781 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67785 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67790 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67794 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67798 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67805 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67812 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67816 */   // MIs[0] dst
     /*  67816 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67821 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67823 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67830 */   // (atomic_store (and:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67833 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67841 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67850 */   GIR_RootConstrainSelectedInstOperands,
     /*  67851 */   // GIR_Coverage, 26007,
     /*  67851 */   GIR_EraseRootFromParent_Done,
     /*  67852 */ // Label 1577: @67852
     /*  67852 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(67950), // Rule ID 22448 //
     /*  67857 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67867 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67871 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  67875 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67879 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67883 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67887 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67898 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67905 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67909 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67914 */   // MIs[0] dst
     /*  67914 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67919 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67921 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67928 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  67931 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67935 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67939 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67948 */   GIR_RootConstrainSelectedInstOperands,
     /*  67949 */   // GIR_Coverage, 22448,
     /*  67949 */   GIR_EraseRootFromParent_Done,
     /*  67950 */ // Label 1578: @67950
     /*  67950 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(68048), // Rule ID 26011 //
     /*  67955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  67973 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67977 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67986 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67990 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67997 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68001 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68008 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68012 */   // MIs[0] dst
     /*  68012 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68017 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68019 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68026 */   // (atomic_store (or:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68029 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68033 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68037 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68040 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68046 */   GIR_RootConstrainSelectedInstOperands,
     /*  68047 */   // GIR_Coverage, 26011,
     /*  68047 */   GIR_EraseRootFromParent_Done,
     /*  68048 */ // Label 1579: @68048
     /*  68048 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(68146), // Rule ID 22464 //
     /*  68053 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68056 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  68071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68079 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68083 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68087 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68090 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68094 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68101 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68110 */   // MIs[0] dst
     /*  68110 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68115 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68117 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68124 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  68127 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68131 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68135 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68144 */   GIR_RootConstrainSelectedInstOperands,
     /*  68145 */   // GIR_Coverage, 22464,
     /*  68145 */   GIR_EraseRootFromParent_Done,
     /*  68146 */ // Label 1580: @68146
     /*  68146 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(68244), // Rule ID 22456 //
     /*  68151 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68161 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68169 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68177 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68181 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68185 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68192 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68199 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68208 */   // MIs[0] dst
     /*  68208 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68213 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68215 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68222 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68225 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68229 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68233 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68242 */   GIR_RootConstrainSelectedInstOperands,
     /*  68243 */   // GIR_Coverage, 22456,
     /*  68243 */   GIR_EraseRootFromParent_Done,
     /*  68244 */ // Label 1581: @68244
     /*  68244 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(68342), // Rule ID 26015 //
     /*  68249 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68252 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68267 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68271 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68275 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68280 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68284 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68288 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68291 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68295 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68302 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68306 */   // MIs[0] dst
     /*  68306 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68311 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68313 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68320 */   // (atomic_store (xor:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68323 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68327 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68331 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68340 */   GIR_RootConstrainSelectedInstOperands,
     /*  68341 */   // GIR_Coverage, 26015,
     /*  68341 */   GIR_EraseRootFromParent_Done,
     /*  68342 */ // Label 1582: @68342
     /*  68342 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(68430), // Rule ID 410 //
     /*  68347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68362 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68370 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68374 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68378 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68385 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68389 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68394 */   // MIs[0] src1
     /*  68394 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68399 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68401 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68408 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68411 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68415 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68419 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68428 */   GIR_RootConstrainSelectedInstOperands,
     /*  68429 */   // GIR_Coverage, 410,
     /*  68429 */   GIR_EraseRootFromParent_Done,
     /*  68430 */ // Label 1583: @68430
     /*  68430 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(68518), // Rule ID 23223 //
     /*  68435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68450 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68454 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68458 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68463 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68467 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68471 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68474 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68478 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68482 */   // MIs[0] src1
     /*  68482 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68487 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68489 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68496 */   // (st (add:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68499 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68503 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68507 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68516 */   GIR_RootConstrainSelectedInstOperands,
     /*  68517 */   // GIR_Coverage, 23223,
     /*  68517 */   GIR_EraseRootFromParent_Done,
     /*  68518 */ // Label 1584: @68518
     /*  68518 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(68606), // Rule ID 302 //
     /*  68523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68530 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68534 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68538 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68542 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68546 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68550 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68554 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68557 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68561 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68565 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68570 */   // MIs[0] src1
     /*  68570 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68575 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68577 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68584 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68587 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68591 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68595 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68604 */   GIR_RootConstrainSelectedInstOperands,
     /*  68605 */   // GIR_Coverage, 302,
     /*  68605 */   GIR_EraseRootFromParent_Done,
     /*  68606 */ // Label 1585: @68606
     /*  68606 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(68694), // Rule ID 23187 //
     /*  68611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68614 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68626 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68634 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68639 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68643 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68647 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68654 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68658 */   // MIs[0] src1
     /*  68658 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68663 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68665 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68672 */   // (st (and:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68675 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68679 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68683 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68692 */   GIR_RootConstrainSelectedInstOperands,
     /*  68693 */   // GIR_Coverage, 23187,
     /*  68693 */   GIR_EraseRootFromParent_Done,
     /*  68694 */ // Label 1586: @68694
     /*  68694 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(68792), // Rule ID 750 //
     /*  68699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68706 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  68714 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68718 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68722 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68726 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68730 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68733 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68737 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68741 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68746 */   // MIs[0] src1
     /*  68746 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68751 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68753 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68760 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68770 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL),
     /*  68777 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68781 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68784 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68790 */   GIR_RootConstrainSelectedInstOperands,
     /*  68791 */   // GIR_Coverage, 750,
     /*  68791 */   GIR_EraseRootFromParent_Done,
     /*  68792 */ // Label 1587: @68792
     /*  68792 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(68890), // Rule ID 718 //
     /*  68797 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68800 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  68812 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68816 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68820 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68824 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68828 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68831 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68835 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68839 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68844 */   // MIs[0] src1
     /*  68844 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68849 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68851 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68858 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68862 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68868 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL),
     /*  68875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68879 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68888 */   GIR_RootConstrainSelectedInstOperands,
     /*  68889 */   // GIR_Coverage, 718,
     /*  68889 */   GIR_EraseRootFromParent_Done,
     /*  68890 */ // Label 1588: @68890
     /*  68890 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(68978), // Rule ID 338 //
     /*  68895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68910 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68918 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68922 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68926 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68929 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68933 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68937 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68942 */   // MIs[0] src1
     /*  68942 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68947 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68949 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68956 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68959 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68963 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68967 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68976 */   GIR_RootConstrainSelectedInstOperands,
     /*  68977 */   // GIR_Coverage, 338,
     /*  68977 */   GIR_EraseRootFromParent_Done,
     /*  68978 */ // Label 1589: @68978
     /*  68978 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(69066), // Rule ID 23199 //
     /*  68983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68990 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68998 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69002 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69006 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69011 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69015 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69019 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69022 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69026 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69030 */   // MIs[0] src1
     /*  69030 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69035 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69037 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69044 */   // (st (or:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69047 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69051 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69055 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69064 */   GIR_RootConstrainSelectedInstOperands,
     /*  69065 */   // GIR_Coverage, 23199,
     /*  69065 */   GIR_EraseRootFromParent_Done,
     /*  69066 */ // Label 1590: @69066
     /*  69066 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(69164), // Rule ID 782 //
     /*  69071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69078 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69082 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  69086 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69090 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69094 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69098 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69102 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69105 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69109 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69113 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69118 */   // MIs[0] src1
     /*  69118 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69123 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69125 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69132 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69136 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69142 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL),
     /*  69149 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69153 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69162 */   GIR_RootConstrainSelectedInstOperands,
     /*  69163 */   // GIR_Coverage, 782,
     /*  69163 */   GIR_EraseRootFromParent_Done,
     /*  69164 */ // Label 1591: @69164
     /*  69164 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(69262), // Rule ID 814 //
     /*  69169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69172 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69176 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69180 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  69184 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69188 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69192 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69196 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69200 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69203 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69207 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69211 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69216 */   // MIs[0] src1
     /*  69216 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69221 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69223 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69230 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69234 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69240 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL),
     /*  69247 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69251 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69260 */   GIR_RootConstrainSelectedInstOperands,
     /*  69261 */   // GIR_Coverage, 814,
     /*  69261 */   GIR_EraseRootFromParent_Done,
     /*  69262 */ // Label 1592: @69262
     /*  69262 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(69360), // Rule ID 686 //
     /*  69267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69270 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  69282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69290 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69294 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69298 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69301 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69305 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69309 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69314 */   // MIs[0] src1
     /*  69314 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69319 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69321 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69328 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69332 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69338 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL),
     /*  69345 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69349 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69358 */   GIR_RootConstrainSelectedInstOperands,
     /*  69359 */   // GIR_Coverage, 686,
     /*  69359 */   GIR_EraseRootFromParent_Done,
     /*  69360 */ // Label 1593: @69360
     /*  69360 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(69448), // Rule ID 446 //
     /*  69365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69368 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  69380 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69384 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69388 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69392 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69396 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69399 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69403 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69407 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69412 */   // MIs[0] src1
     /*  69412 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69417 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69419 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69426 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  69429 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69433 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69437 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69446 */   GIR_RootConstrainSelectedInstOperands,
     /*  69447 */   // GIR_Coverage, 446,
     /*  69447 */   GIR_EraseRootFromParent_Done,
     /*  69448 */ // Label 1594: @69448
     /*  69448 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(69536), // Rule ID 374 //
     /*  69453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69456 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69468 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69472 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69476 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69480 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69484 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69487 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69491 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69495 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69500 */   // MIs[0] src1
     /*  69500 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69505 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69507 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69514 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69517 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69521 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69525 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69534 */   GIR_RootConstrainSelectedInstOperands,
     /*  69535 */   // GIR_Coverage, 374,
     /*  69535 */   GIR_EraseRootFromParent_Done,
     /*  69536 */ // Label 1595: @69536
     /*  69536 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(69624), // Rule ID 23211 //
     /*  69541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69556 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69560 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69564 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69569 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69573 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69577 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69580 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69584 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69588 */   // MIs[0] src1
     /*  69588 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69593 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69595 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69602 */   // (st (xor:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69605 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69609 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69613 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69622 */   GIR_RootConstrainSelectedInstOperands,
     /*  69623 */   // GIR_Coverage, 23211,
     /*  69623 */   GIR_EraseRootFromParent_Done,
     /*  69624 */ // Label 1596: @69624
     /*  69624 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(69678), // Rule ID 25 //
     /*  69629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69644 */   // MIs[1] Operand 1
     /*  69644 */   // No operand predicates
     /*  69644 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  69648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69661 */   // (st (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69664 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69668 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69676 */   GIR_RootConstrainSelectedInstOperands,
     /*  69677 */   // GIR_Coverage, 25,
     /*  69677 */   GIR_EraseRootFromParent_Done,
     /*  69678 */ // Label 1597: @69678
     /*  69678 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(69731), // Rule ID 22508 //
     /*  69683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69686 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69701 */   // MIs[1] Operand 1
     /*  69701 */   // No operand predicates
     /*  69701 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69714 */   // (atomic_store (imm:{ *:[i16] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69717 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69721 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69729 */   GIR_RootConstrainSelectedInstOperands,
     /*  69730 */   // GIR_Coverage, 22508,
     /*  69730 */   GIR_EraseRootFromParent_Done,
     /*  69731 */ // Label 1598: @69731
     /*  69731 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(69794), // Rule ID 50 //
     /*  69736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  69739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69754 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69767 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69776 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr),
     /*  69779 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69792 */   GIR_RootConstrainSelectedInstOperands,
     /*  69793 */   // GIR_Coverage, 50,
     /*  69793 */   GIR_EraseRootFromParent_Done,
     /*  69794 */ // Label 1599: @69794
     /*  69794 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(69857), // Rule ID 56 //
     /*  69799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  69802 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69817 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69821 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69839 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr_EVEX addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr_EVEX),
     /*  69842 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69846 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69855 */   GIR_RootConstrainSelectedInstOperands,
     /*  69856 */   // GIR_Coverage, 56,
     /*  69856 */   GIR_EraseRootFromParent_Done,
     /*  69857 */ // Label 1600: @69857
     /*  69857 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(69902), // Rule ID 22512 //
     /*  69862 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69865 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69887 */   // (atomic_store GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  69887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  69890 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69894 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69900 */   GIR_RootConstrainSelectedInstOperands,
     /*  69901 */   // GIR_Coverage, 22512,
     /*  69901 */   GIR_EraseRootFromParent_Done,
     /*  69902 */ // Label 1601: @69902
     /*  69902 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(69944), // Rule ID 33 //
     /*  69907 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69922 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69929 */   // (st GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  69929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  69932 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69936 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69942 */   GIR_RootConstrainSelectedInstOperands,
     /*  69943 */   // GIR_Coverage, 33,
     /*  69943 */   GIR_EraseRootFromParent_Done,
     /*  69944 */ // Label 1602: @69944
     /*  69944 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(69989), // Rule ID 4622 //
     /*  69949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  69952 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69955 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  69963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69974 */   // (st FR16X:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSHZmr addr:{ *:[iPTR] }:$dst, FR16X:{ *:[f16] }:$src)
     /*  69974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZmr),
     /*  69977 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69981 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69987 */   GIR_RootConstrainSelectedInstOperands,
     /*  69988 */   // GIR_Coverage, 4622,
     /*  69988 */   GIR_EraseRootFromParent_Done,
     /*  69989 */ // Label 1603: @69989
     /*  69989 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(70055), // Rule ID 18547 //
     /*  69994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  69997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70015 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70027 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PEXTRWmri),
     /*  70039 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70053 */   GIR_RootConstrainSelectedInstOperands,
     /*  70054 */   // GIR_Coverage, 18547,
     /*  70054 */   GIR_EraseRootFromParent_Done,
     /*  70055 */ // Label 1604: @70055
     /*  70055 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(70121), // Rule ID 18548 //
     /*  70060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  70063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70081 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70093 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70097 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWmri),
     /*  70105 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70119 */   GIR_RootConstrainSelectedInstOperands,
     /*  70120 */   // GIR_Coverage, 18548,
     /*  70120 */   GIR_EraseRootFromParent_Done,
     /*  70121 */ // Label 1605: @70121
     /*  70121 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(70233), // Rule ID 18336 //
     /*  70126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  70129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70136 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70140 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70147 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] }))
     /*  70147 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  70150 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70154 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70159 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70163 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70168 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  70171 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  70175 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70180 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  70183 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  70186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  70188 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  70191 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70195 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70200 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  70207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  70212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  70217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70220 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70231 */   GIR_RootConstrainSelectedInstOperands,
     /*  70232 */   // GIR_Coverage, 18336,
     /*  70232 */   GIR_EraseRootFromParent_Done,
     /*  70233 */ // Label 1606: @70233
     /*  70233 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(70299), // Rule ID 21840 //
     /*  70238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  70241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70252 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70259 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWZmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70271 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70275 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZmri),
     /*  70283 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70297 */   GIR_RootConstrainSelectedInstOperands,
     /*  70298 */   // GIR_Coverage, 21840,
     /*  70298 */   GIR_EraseRootFromParent_Done,
     /*  70299 */ // Label 1607: @70299
     /*  70299 */ GIM_Reject,
     /*  70300 */ // Label 1475: @70300
     /*  70300 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(70396), // Rule ID 22493 //
     /*  70305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70308 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70311 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70318 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70326 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70330 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70334 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70338 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70342 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70345 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70349 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70356 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70360 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70364 */   // MIs[0] dst
     /*  70364 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70369 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70371 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70378 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70381 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70385 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70394 */   GIR_RootConstrainSelectedInstOperands,
     /*  70395 */   // GIR_Coverage, 22493,
     /*  70395 */   GIR_EraseRootFromParent_Done,
     /*  70396 */ // Label 1608: @70396
     /*  70396 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(70492), // Rule ID 22497 //
     /*  70401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70404 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70407 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70430 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70434 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70438 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70445 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70452 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70456 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70460 */   // MIs[0] dst
     /*  70460 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70465 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70467 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70474 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70477 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70481 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70490 */   GIR_RootConstrainSelectedInstOperands,
     /*  70491 */   // GIR_Coverage, 22497,
     /*  70491 */   GIR_EraseRootFromParent_Done,
     /*  70492 */ // Label 1609: @70492
     /*  70492 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(70585), // Rule ID 22501 //
     /*  70497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  70515 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70523 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  70527 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70531 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70535 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70542 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70549 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70553 */   // MIs[0] dst
     /*  70553 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70558 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70560 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70567 */   // (atomic_store (sub:{ *:[i32] } 0:{ *:[i32] }, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  70570 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70574 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70583 */   GIR_RootConstrainSelectedInstOperands,
     /*  70584 */   // GIR_Coverage, 22501,
     /*  70584 */   GIR_EraseRootFromParent_Done,
     /*  70585 */ // Label 1610: @70585
     /*  70585 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(70675), // Rule ID 22505 //
     /*  70590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70608 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70612 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70616 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70620 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70624 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70627 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70631 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70638 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70642 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70646 */   // MIs[0] dst
     /*  70646 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70651 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70653 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70660 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NOT32m addr:{ *:[iPTR] }:$dst)
     /*  70660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  70663 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70673 */   GIR_RootConstrainSelectedInstOperands,
     /*  70674 */   // GIR_Coverage, 22505,
     /*  70674 */   GIR_EraseRootFromParent_Done,
     /*  70675 */ // Label 1611: @70675
     /*  70675 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(70761), // Rule ID 227 //
     /*  70680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70686 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70690 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70694 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70698 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70702 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70706 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70710 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70714 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70717 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70721 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70729 */   // MIs[0] src1
     /*  70729 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70734 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70736 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70743 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70746 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70750 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70753 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70759 */   GIR_RootConstrainSelectedInstOperands,
     /*  70760 */   // GIR_Coverage, 227,
     /*  70760 */   GIR_EraseRootFromParent_Done,
     /*  70761 */ // Label 1612: @70761
     /*  70761 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(70847), // Rule ID 230 //
     /*  70766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70784 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70788 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70792 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70796 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70800 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70803 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70807 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70811 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70815 */   // MIs[0] src1
     /*  70815 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70820 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70822 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70829 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70832 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70836 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70845 */   GIR_RootConstrainSelectedInstOperands,
     /*  70846 */   // GIR_Coverage, 230,
     /*  70846 */   GIR_EraseRootFromParent_Done,
     /*  70847 */ // Label 1613: @70847
     /*  70847 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(70940), // Rule ID 22615 //
     /*  70852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70859 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70867 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70871 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70875 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70879 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70883 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70886 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70890 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70894 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  70905 */   // MIs[0] dst
     /*  70905 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70910 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70912 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70919 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i32] })
     /*  70919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  70922 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  70929 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70938 */   GIR_RootConstrainSelectedInstOperands,
     /*  70939 */   // GIR_Coverage, 22615,
     /*  70939 */   GIR_EraseRootFromParent_Done,
     /*  70940 */ // Label 1614: @70940
     /*  70940 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(71023), // Rule ID 17614 //
     /*  70945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70948 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  70960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70964 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  70968 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70972 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70976 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70979 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70983 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70987 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  70991 */   // MIs[0] dst
     /*  70991 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70996 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70998 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71005 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1),
     /*  71008 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71012 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71021 */   GIR_RootConstrainSelectedInstOperands,
     /*  71022 */   // GIR_Coverage, 17614,
     /*  71022 */   GIR_EraseRootFromParent_Done,
     /*  71023 */ // Label 1615: @71023
     /*  71023 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(71106), // Rule ID 17618 //
     /*  71028 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71031 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  71043 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71047 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71051 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71055 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71059 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71062 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71066 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71070 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71074 */   // MIs[0] dst
     /*  71074 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71079 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71081 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71088 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1),
     /*  71091 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71095 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71104 */   GIR_RootConstrainSelectedInstOperands,
     /*  71105 */   // GIR_Coverage, 17618,
     /*  71105 */   GIR_EraseRootFromParent_Done,
     /*  71106 */ // Label 1616: @71106
     /*  71106 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(71189), // Rule ID 263 //
     /*  71111 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71126 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71130 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71134 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  71138 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71142 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71146 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71149 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71153 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71157 */   // MIs[0] src1
     /*  71157 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71162 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71164 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71171 */   // (st (sub:{ *:[i32] } 0:{ *:[i32] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  71174 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71178 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71187 */   GIR_RootConstrainSelectedInstOperands,
     /*  71188 */   // GIR_Coverage, 263,
     /*  71188 */   GIR_EraseRootFromParent_Done,
     /*  71189 */ // Label 1617: @71189
     /*  71189 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(71269), // Rule ID 271 //
     /*  71194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71209 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71213 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71217 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71221 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71225 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71228 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71232 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71236 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71240 */   // MIs[0] src1
     /*  71240 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71245 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71247 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71254 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT32m addr:{ *:[iPTR] }:$src1)
     /*  71254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  71257 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71261 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71267 */   GIR_RootConstrainSelectedInstOperands,
     /*  71268 */   // GIR_Coverage, 271,
     /*  71268 */   GIR_EraseRootFromParent_Done,
     /*  71269 */ // Label 1618: @71269
     /*  71269 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(71364), // Rule ID 415 //
     /*  71274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71277 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71281 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71289 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71293 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71297 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71301 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71305 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71308 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71312 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71316 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71320 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71324 */   // MIs[3] Operand 1
     /*  71324 */   // No operand predicates
     /*  71324 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71328 */   // MIs[0] src1
     /*  71328 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71333 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71335 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71342 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71345 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71349 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71352 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71355 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71362 */   GIR_RootConstrainSelectedInstOperands,
     /*  71363 */   // GIR_Coverage, 415,
     /*  71363 */   GIR_EraseRootFromParent_Done,
     /*  71364 */ // Label 1619: @71364
     /*  71364 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(71459), // Rule ID 307 //
     /*  71369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71372 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71384 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71388 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71392 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71396 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71400 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71403 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71407 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71411 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71415 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71419 */   // MIs[3] Operand 1
     /*  71419 */   // No operand predicates
     /*  71419 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71423 */   // MIs[0] src1
     /*  71423 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71428 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71430 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71437 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71440 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71444 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71447 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71457 */   GIR_RootConstrainSelectedInstOperands,
     /*  71458 */   // GIR_Coverage, 307,
     /*  71458 */   GIR_EraseRootFromParent_Done,
     /*  71459 */ // Label 1620: @71459
     /*  71459 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(71554), // Rule ID 343 //
     /*  71464 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71467 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71479 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71483 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71487 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71491 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71495 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71502 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71506 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71510 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71514 */   // MIs[3] Operand 1
     /*  71514 */   // No operand predicates
     /*  71514 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71518 */   // MIs[0] src1
     /*  71518 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71523 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71525 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71532 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  71535 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71539 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71542 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71552 */   GIR_RootConstrainSelectedInstOperands,
     /*  71553 */   // GIR_Coverage, 343,
     /*  71553 */   GIR_EraseRootFromParent_Done,
     /*  71554 */ // Label 1621: @71554
     /*  71554 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(71649), // Rule ID 455 //
     /*  71559 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71562 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71566 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71574 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71578 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71582 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71586 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71590 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71597 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71601 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71605 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71609 */   // MIs[3] Operand 1
     /*  71609 */   // No operand predicates
     /*  71609 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71613 */   // MIs[0] src1
     /*  71613 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71618 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71620 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71627 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71630 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71634 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71637 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71647 */   GIR_RootConstrainSelectedInstOperands,
     /*  71648 */   // GIR_Coverage, 455,
     /*  71648 */   GIR_EraseRootFromParent_Done,
     /*  71649 */ // Label 1622: @71649
     /*  71649 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(71744), // Rule ID 379 //
     /*  71654 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71657 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71669 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71673 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71677 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71681 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71685 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71692 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71696 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71700 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71704 */   // MIs[3] Operand 1
     /*  71704 */   // No operand predicates
     /*  71704 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71708 */   // MIs[0] src1
     /*  71708 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71713 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71715 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71722 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  71725 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71729 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71732 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71742 */   GIR_RootConstrainSelectedInstOperands,
     /*  71743 */   // GIR_Coverage, 379,
     /*  71743 */   GIR_EraseRootFromParent_Done,
     /*  71744 */ // Label 1623: @71744
     /*  71744 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(71845), // Rule ID 22429 //
     /*  71749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71775 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71779 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71783 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71790 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71797 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71801 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71805 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71809 */   // MIs[3] Operand 1
     /*  71809 */   // No operand predicates
     /*  71809 */   // MIs[0] dst
     /*  71809 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71814 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71816 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71823 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71826 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71830 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71833 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71843 */   GIR_RootConstrainSelectedInstOperands,
     /*  71844 */   // GIR_Coverage, 22429,
     /*  71844 */   GIR_EraseRootFromParent_Done,
     /*  71845 */ // Label 1624: @71845
     /*  71845 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(71946), // Rule ID 22437 //
     /*  71850 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71853 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71860 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71868 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71872 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71876 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71880 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71884 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71891 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71898 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71902 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71906 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71910 */   // MIs[3] Operand 1
     /*  71910 */   // No operand predicates
     /*  71910 */   // MIs[0] dst
     /*  71910 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71915 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71917 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71924 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71927 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71931 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71934 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71944 */   GIR_RootConstrainSelectedInstOperands,
     /*  71945 */   // GIR_Coverage, 22437,
     /*  71945 */   GIR_EraseRootFromParent_Done,
     /*  71946 */ // Label 1625: @71946
     /*  71946 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(72047), // Rule ID 22445 //
     /*  71951 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71969 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71973 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71977 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71981 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71985 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71992 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71999 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72003 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72007 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72011 */   // MIs[3] Operand 1
     /*  72011 */   // No operand predicates
     /*  72011 */   // MIs[0] dst
     /*  72011 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72016 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72018 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72025 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  72028 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72032 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72035 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72045 */   GIR_RootConstrainSelectedInstOperands,
     /*  72046 */   // GIR_Coverage, 22445,
     /*  72046 */   GIR_EraseRootFromParent_Done,
     /*  72047 */ // Label 1626: @72047
     /*  72047 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(72148), // Rule ID 22461 //
     /*  72052 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72062 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  72070 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72074 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72078 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72082 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72086 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72089 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72093 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72100 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72104 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72108 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72112 */   // MIs[3] Operand 1
     /*  72112 */   // No operand predicates
     /*  72112 */   // MIs[0] dst
     /*  72112 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72117 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72119 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72126 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  72129 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72133 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72136 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72146 */   GIR_RootConstrainSelectedInstOperands,
     /*  72147 */   // GIR_Coverage, 22461,
     /*  72147 */   GIR_EraseRootFromParent_Done,
     /*  72148 */ // Label 1627: @72148
     /*  72148 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(72249), // Rule ID 22453 //
     /*  72153 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72171 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72175 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72179 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72183 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72187 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72190 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72194 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72201 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72205 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72209 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72213 */   // MIs[3] Operand 1
     /*  72213 */   // No operand predicates
     /*  72213 */   // MIs[0] dst
     /*  72213 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72218 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72220 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72227 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  72230 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72234 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72237 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72247 */   GIR_RootConstrainSelectedInstOperands,
     /*  72248 */   // GIR_Coverage, 22453,
     /*  72248 */   GIR_EraseRootFromParent_Done,
     /*  72249 */ // Label 1628: @72249
     /*  72249 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(72353), // Rule ID 834 //
     /*  72254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72257 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  72269 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72273 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72277 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72281 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72285 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72289 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72292 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72296 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72300 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72305 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72309 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72313 */   // MIs[3] Operand 1
     /*  72313 */   // No operand predicates
     /*  72313 */   // MIs[0] src1
     /*  72313 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72318 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72320 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72327 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8),
     /*  72330 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72334 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  72338 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72341 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72351 */   GIR_RootConstrainSelectedInstOperands,
     /*  72352 */   // GIR_Coverage, 834,
     /*  72352 */   GIR_EraseRootFromParent_Done,
     /*  72353 */ // Label 1629: @72353
     /*  72353 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(72457), // Rule ID 858 //
     /*  72358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72361 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  72373 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72377 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72381 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72385 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72390 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72394 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72398 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72401 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72405 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72409 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72413 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72417 */   // MIs[3] Operand 1
     /*  72417 */   // No operand predicates
     /*  72417 */   // MIs[0] src1
     /*  72417 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72422 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72424 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72431 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8),
     /*  72434 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72438 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  72442 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72445 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72455 */   GIR_RootConstrainSelectedInstOperands,
     /*  72456 */   // GIR_Coverage, 858,
     /*  72456 */   GIR_EraseRootFromParent_Done,
     /*  72457 */ // Label 1630: @72457
     /*  72457 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(72548), // Rule ID 735 //
     /*  72462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72465 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  72477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72481 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72485 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72489 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72493 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72496 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72500 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72504 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72508 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72512 */   // MIs[3] Operand 1
     /*  72512 */   // No operand predicates
     /*  72512 */   // MIs[0] src1
     /*  72512 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72517 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72519 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72526 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi),
     /*  72529 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72533 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72536 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72546 */   GIR_RootConstrainSelectedInstOperands,
     /*  72547 */   // GIR_Coverage, 735,
     /*  72547 */   GIR_EraseRootFromParent_Done,
     /*  72548 */ // Label 1631: @72548
     /*  72548 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(72639), // Rule ID 703 //
     /*  72553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  72568 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72576 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72580 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72584 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72587 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72591 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72595 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72599 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72603 */   // MIs[3] Operand 1
     /*  72603 */   // No operand predicates
     /*  72603 */   // MIs[0] src1
     /*  72603 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72608 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72610 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72617 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi),
     /*  72620 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72624 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72627 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72637 */   GIR_RootConstrainSelectedInstOperands,
     /*  72638 */   // GIR_Coverage, 703,
     /*  72638 */   GIR_EraseRootFromParent_Done,
     /*  72639 */ // Label 1632: @72639
     /*  72639 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(72730), // Rule ID 767 //
     /*  72644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  72659 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72663 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72667 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72671 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72675 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72678 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72682 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72686 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72690 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72694 */   // MIs[3] Operand 1
     /*  72694 */   // No operand predicates
     /*  72694 */   // MIs[0] src1
     /*  72694 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72699 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72701 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72708 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi),
     /*  72711 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72715 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72718 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72728 */   GIR_RootConstrainSelectedInstOperands,
     /*  72729 */   // GIR_Coverage, 767,
     /*  72729 */   GIR_EraseRootFromParent_Done,
     /*  72730 */ // Label 1633: @72730
     /*  72730 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(72821), // Rule ID 799 //
     /*  72735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  72750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72754 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72758 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72762 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72766 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72769 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72773 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72777 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72781 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72785 */   // MIs[3] Operand 1
     /*  72785 */   // No operand predicates
     /*  72785 */   // MIs[0] src1
     /*  72785 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72790 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72792 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72799 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi),
     /*  72802 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72806 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72809 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72812 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72819 */   GIR_RootConstrainSelectedInstOperands,
     /*  72820 */   // GIR_Coverage, 799,
     /*  72820 */   GIR_EraseRootFromParent_Done,
     /*  72821 */ // Label 1634: @72821
     /*  72821 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(72912), // Rule ID 671 //
     /*  72826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72829 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72833 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72837 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  72841 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72845 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72849 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72853 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72857 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72860 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72864 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72868 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72872 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72876 */   // MIs[3] Operand 1
     /*  72876 */   // No operand predicates
     /*  72876 */   // MIs[0] src1
     /*  72876 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72881 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72883 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72890 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi),
     /*  72893 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72897 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72900 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72910 */   GIR_RootConstrainSelectedInstOperands,
     /*  72911 */   // GIR_Coverage, 671,
     /*  72911 */   GIR_EraseRootFromParent_Done,
     /*  72912 */ // Label 1635: @72912
     /*  72912 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(73010), // Rule ID 22433 //
     /*  72917 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72920 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  72935 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72939 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72943 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72947 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72951 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72954 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72958 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72965 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72969 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72974 */   // MIs[0] dst
     /*  72974 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72979 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72981 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72988 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  72988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  72991 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72995 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  72999 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73008 */   GIR_RootConstrainSelectedInstOperands,
     /*  73009 */   // GIR_Coverage, 22433,
     /*  73009 */   GIR_EraseRootFromParent_Done,
     /*  73010 */ // Label 1636: @73010
     /*  73010 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(73108), // Rule ID 26004 //
     /*  73015 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73018 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73033 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73037 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73041 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73046 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73050 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73054 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73057 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73061 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73068 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73072 */   // MIs[0] dst
     /*  73072 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73077 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73079 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73086 */   // (atomic_store (add:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73089 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73093 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73097 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73106 */   GIR_RootConstrainSelectedInstOperands,
     /*  73107 */   // GIR_Coverage, 26004,
     /*  73107 */   GIR_EraseRootFromParent_Done,
     /*  73108 */ // Label 1637: @73108
     /*  73108 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(73206), // Rule ID 22441 //
     /*  73113 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73116 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73131 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73135 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73139 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73143 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73147 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73154 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73161 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73165 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73170 */   // MIs[0] dst
     /*  73170 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73175 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73177 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73184 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73187 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73191 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73195 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73198 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73204 */   GIR_RootConstrainSelectedInstOperands,
     /*  73205 */   // GIR_Coverage, 22441,
     /*  73205 */   GIR_EraseRootFromParent_Done,
     /*  73206 */ // Label 1638: @73206
     /*  73206 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(73304), // Rule ID 26008 //
     /*  73211 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73214 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73229 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73233 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73237 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73242 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73246 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73250 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73257 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73264 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73268 */   // MIs[0] dst
     /*  73268 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73273 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73275 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73282 */   // (atomic_store (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73285 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73289 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73293 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73296 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73302 */   GIR_RootConstrainSelectedInstOperands,
     /*  73303 */   // GIR_Coverage, 26008,
     /*  73303 */   GIR_EraseRootFromParent_Done,
     /*  73304 */ // Label 1639: @73304
     /*  73304 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(73402), // Rule ID 22449 //
     /*  73309 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73312 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73327 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73331 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73335 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73339 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73343 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73350 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73357 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73361 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73366 */   // MIs[0] dst
     /*  73366 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73371 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73373 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73380 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73383 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73387 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73391 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73400 */   GIR_RootConstrainSelectedInstOperands,
     /*  73401 */   // GIR_Coverage, 22449,
     /*  73401 */   GIR_EraseRootFromParent_Done,
     /*  73402 */ // Label 1640: @73402
     /*  73402 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(73500), // Rule ID 26012 //
     /*  73407 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73410 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73417 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73425 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73429 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73433 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73438 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73442 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73446 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73449 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73453 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73460 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73464 */   // MIs[0] dst
     /*  73464 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73469 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73471 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73478 */   // (atomic_store (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73481 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73485 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73489 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73498 */   GIR_RootConstrainSelectedInstOperands,
     /*  73499 */   // GIR_Coverage, 26012,
     /*  73499 */   GIR_EraseRootFromParent_Done,
     /*  73500 */ // Label 1641: @73500
     /*  73500 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(73598), // Rule ID 22465 //
     /*  73505 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  73523 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73527 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73539 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73546 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73553 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73557 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73562 */   // MIs[0] dst
     /*  73562 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73567 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73569 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73576 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  73579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73583 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73587 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73596 */   GIR_RootConstrainSelectedInstOperands,
     /*  73597 */   // GIR_Coverage, 22465,
     /*  73597 */   GIR_EraseRootFromParent_Done,
     /*  73598 */ // Label 1642: @73598
     /*  73598 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(73696), // Rule ID 22457 //
     /*  73603 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73621 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73625 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73629 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73633 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73637 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73644 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73651 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73655 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73660 */   // MIs[0] dst
     /*  73660 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73665 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73667 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73674 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73677 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73681 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73685 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73688 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73694 */   GIR_RootConstrainSelectedInstOperands,
     /*  73695 */   // GIR_Coverage, 22457,
     /*  73695 */   GIR_EraseRootFromParent_Done,
     /*  73696 */ // Label 1643: @73696
     /*  73696 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(73794), // Rule ID 26016 //
     /*  73701 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73719 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73723 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73727 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73732 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73736 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73740 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73747 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73754 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73758 */   // MIs[0] dst
     /*  73758 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73763 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73765 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73772 */   // (atomic_store (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73775 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73779 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73783 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73792 */   GIR_RootConstrainSelectedInstOperands,
     /*  73793 */   // GIR_Coverage, 26016,
     /*  73793 */   GIR_EraseRootFromParent_Done,
     /*  73794 */ // Label 1644: @73794
     /*  73794 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(73905), // Rule ID 837 //
     /*  73799 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73802 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73806 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73810 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  73814 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73818 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73822 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  73826 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73830 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73834 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73837 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73841 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73845 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73850 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  73855 */   // MIs[0] src1
     /*  73855 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73860 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73862 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73869 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73873 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  73883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL),
     /*  73886 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  73894 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73903 */   GIR_RootConstrainSelectedInstOperands,
     /*  73904 */   // GIR_Coverage, 837,
     /*  73904 */   GIR_EraseRootFromParent_Done,
     /*  73905 */ // Label 1645: @73905
     /*  73905 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(74016), // Rule ID 861 //
     /*  73910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73913 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  73925 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73929 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73933 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  73937 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73942 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73946 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73950 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73953 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73957 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  73966 */   // MIs[0] src1
     /*  73966 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73971 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73973 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73980 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73984 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73990 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  73994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL),
     /*  73997 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74005 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74014 */   GIR_RootConstrainSelectedInstOperands,
     /*  74015 */   // GIR_Coverage, 861,
     /*  74015 */   GIR_EraseRootFromParent_Done,
     /*  74016 */ // Label 1646: @74016
     /*  74016 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(74104), // Rule ID 411 //
     /*  74021 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74028 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74036 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74040 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74044 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74048 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74052 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74055 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74059 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74063 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74068 */   // MIs[0] src1
     /*  74068 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74073 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74075 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74082 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74085 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74089 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74093 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74096 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74102 */   GIR_RootConstrainSelectedInstOperands,
     /*  74103 */   // GIR_Coverage, 411,
     /*  74103 */   GIR_EraseRootFromParent_Done,
     /*  74104 */ // Label 1647: @74104
     /*  74104 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(74192), // Rule ID 23224 //
     /*  74109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74124 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74132 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74137 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74141 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74145 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74152 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74156 */   // MIs[0] src1
     /*  74156 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74161 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74163 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74170 */   // (st (add:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74173 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74177 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74181 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74190 */   GIR_RootConstrainSelectedInstOperands,
     /*  74191 */   // GIR_Coverage, 23224,
     /*  74191 */   GIR_EraseRootFromParent_Done,
     /*  74192 */ // Label 1648: @74192
     /*  74192 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(74280), // Rule ID 303 //
     /*  74197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74200 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74212 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74216 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74220 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74224 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74228 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74231 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74235 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74244 */   // MIs[0] src1
     /*  74244 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74249 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74251 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74258 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74261 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74265 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74269 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74278 */   GIR_RootConstrainSelectedInstOperands,
     /*  74279 */   // GIR_Coverage, 303,
     /*  74279 */   GIR_EraseRootFromParent_Done,
     /*  74280 */ // Label 1649: @74280
     /*  74280 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(74368), // Rule ID 23188 //
     /*  74285 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74288 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74300 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74304 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74308 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74313 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74317 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74321 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74324 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74328 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74332 */   // MIs[0] src1
     /*  74332 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74337 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74339 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74346 */   // (st (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74349 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74353 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74357 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74366 */   GIR_RootConstrainSelectedInstOperands,
     /*  74367 */   // GIR_Coverage, 23188,
     /*  74367 */   GIR_EraseRootFromParent_Done,
     /*  74368 */ // Label 1650: @74368
     /*  74368 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(74466), // Rule ID 751 //
     /*  74373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74376 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74380 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  74388 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74392 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74396 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74400 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74404 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74407 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74411 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74415 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74420 */   // MIs[0] src1
     /*  74420 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74425 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74427 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74434 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74438 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74444 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL),
     /*  74451 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74455 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74464 */   GIR_RootConstrainSelectedInstOperands,
     /*  74465 */   // GIR_Coverage, 751,
     /*  74465 */   GIR_EraseRootFromParent_Done,
     /*  74466 */ // Label 1651: @74466
     /*  74466 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(74564), // Rule ID 719 //
     /*  74471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74474 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  74486 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74490 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74494 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74498 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74502 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74505 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74509 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74513 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74518 */   // MIs[0] src1
     /*  74518 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74523 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74525 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74532 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74532 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74536 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74542 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL),
     /*  74549 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74553 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74562 */   GIR_RootConstrainSelectedInstOperands,
     /*  74563 */   // GIR_Coverage, 719,
     /*  74563 */   GIR_EraseRootFromParent_Done,
     /*  74564 */ // Label 1652: @74564
     /*  74564 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(74652), // Rule ID 339 //
     /*  74569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74572 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74576 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74584 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74588 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74592 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74596 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74600 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74607 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74611 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74616 */   // MIs[0] src1
     /*  74616 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74621 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74623 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74630 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74633 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74637 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74641 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74650 */   GIR_RootConstrainSelectedInstOperands,
     /*  74651 */   // GIR_Coverage, 339,
     /*  74651 */   GIR_EraseRootFromParent_Done,
     /*  74652 */ // Label 1653: @74652
     /*  74652 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(74740), // Rule ID 23200 //
     /*  74657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74672 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74676 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74680 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74685 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74689 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74693 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74700 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74704 */   // MIs[0] src1
     /*  74704 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74709 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74711 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74718 */   // (st (or:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74721 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74725 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74729 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74738 */   GIR_RootConstrainSelectedInstOperands,
     /*  74739 */   // GIR_Coverage, 23200,
     /*  74739 */   GIR_EraseRootFromParent_Done,
     /*  74740 */ // Label 1654: @74740
     /*  74740 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(74838), // Rule ID 783 //
     /*  74745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  74760 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74764 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74768 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74772 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74776 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74779 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74783 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74787 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74792 */   // MIs[0] src1
     /*  74792 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74797 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74799 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74806 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74810 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74816 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL),
     /*  74823 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74827 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74836 */   GIR_RootConstrainSelectedInstOperands,
     /*  74837 */   // GIR_Coverage, 783,
     /*  74837 */   GIR_EraseRootFromParent_Done,
     /*  74838 */ // Label 1655: @74838
     /*  74838 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(74936), // Rule ID 815 //
     /*  74843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74846 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  74858 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74862 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74866 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74870 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74874 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74877 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74881 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74885 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74890 */   // MIs[0] src1
     /*  74890 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74895 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74897 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74904 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74908 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74914 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL),
     /*  74921 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74925 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74928 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74934 */   GIR_RootConstrainSelectedInstOperands,
     /*  74935 */   // GIR_Coverage, 815,
     /*  74935 */   GIR_EraseRootFromParent_Done,
     /*  74936 */ // Label 1656: @74936
     /*  74936 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(75034), // Rule ID 687 //
     /*  74941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74948 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  74956 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74960 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74964 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74968 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74972 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74975 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74979 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74983 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74988 */   // MIs[0] src1
     /*  74988 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74993 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74995 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75002 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75006 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75012 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL),
     /*  75019 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75023 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75032 */   GIR_RootConstrainSelectedInstOperands,
     /*  75033 */   // GIR_Coverage, 687,
     /*  75033 */   GIR_EraseRootFromParent_Done,
     /*  75034 */ // Label 1657: @75034
     /*  75034 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(75122), // Rule ID 447 //
     /*  75039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  75054 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75058 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75062 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75066 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75070 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75077 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75081 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75086 */   // MIs[0] src1
     /*  75086 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75091 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75093 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75100 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  75103 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75107 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75111 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75114 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75120 */   GIR_RootConstrainSelectedInstOperands,
     /*  75121 */   // GIR_Coverage, 447,
     /*  75121 */   GIR_EraseRootFromParent_Done,
     /*  75122 */ // Label 1658: @75122
     /*  75122 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(75210), // Rule ID 375 //
     /*  75127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75142 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75146 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75150 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75154 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75158 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75161 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75165 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75174 */   // MIs[0] src1
     /*  75174 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75179 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75181 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75188 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75191 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75195 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75199 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75208 */   GIR_RootConstrainSelectedInstOperands,
     /*  75209 */   // GIR_Coverage, 375,
     /*  75209 */   GIR_EraseRootFromParent_Done,
     /*  75210 */ // Label 1659: @75210
     /*  75210 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(75298), // Rule ID 23212 //
     /*  75215 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75218 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75222 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75230 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75234 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75238 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75243 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75247 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75251 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75254 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75258 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75262 */   // MIs[0] src1
     /*  75262 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75267 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75269 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75276 */   // (st (xor:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75279 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75283 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  75287 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75296 */   GIR_RootConstrainSelectedInstOperands,
     /*  75297 */   // GIR_Coverage, 23212,
     /*  75297 */   GIR_EraseRootFromParent_Done,
     /*  75298 */ // Label 1660: @75298
     /*  75298 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(75352), // Rule ID 26 //
     /*  75303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75318 */   // MIs[1] Operand 1
     /*  75318 */   // No operand predicates
     /*  75318 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  75322 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75326 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75335 */   // (st (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75338 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75342 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75350 */   GIR_RootConstrainSelectedInstOperands,
     /*  75351 */   // GIR_Coverage, 26,
     /*  75351 */   GIR_EraseRootFromParent_Done,
     /*  75352 */ // Label 1661: @75352
     /*  75352 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(75418), // Rule ID 22519 //
     /*  75357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75360 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75363 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75378 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75382 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75387 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75400 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75403 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75407 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75416 */   GIR_RootConstrainSelectedInstOperands,
     /*  75417 */   // GIR_Coverage, 22519,
     /*  75417 */   GIR_EraseRootFromParent_Done,
     /*  75418 */ // Label 1662: @75418
     /*  75418 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(75484), // Rule ID 22520 //
     /*  75423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75426 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75429 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75444 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75448 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75453 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75466 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75469 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75473 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75482 */   GIR_RootConstrainSelectedInstOperands,
     /*  75483 */   // GIR_Coverage, 22520,
     /*  75483 */   GIR_EraseRootFromParent_Done,
     /*  75484 */ // Label 1663: @75484
     /*  75484 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(75550), // Rule ID 22521 //
     /*  75489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75492 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75495 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75510 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75514 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75525 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75532 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75535 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75539 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75548 */   GIR_RootConstrainSelectedInstOperands,
     /*  75549 */   // GIR_Coverage, 22521,
     /*  75549 */   GIR_EraseRootFromParent_Done,
     /*  75550 */ // Label 1664: @75550
     /*  75550 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(75603), // Rule ID 22509 //
     /*  75555 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75558 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75573 */   // MIs[1] Operand 1
     /*  75573 */   // No operand predicates
     /*  75573 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75579 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75586 */   // (atomic_store (imm:{ *:[i32] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75589 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75593 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75601 */   GIR_RootConstrainSelectedInstOperands,
     /*  75602 */   // GIR_Coverage, 22509,
     /*  75602 */   GIR_EraseRootFromParent_Done,
     /*  75603 */ // Label 1665: @75603
     /*  75603 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(75666), // Rule ID 52 //
     /*  75608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  75611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75614 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75626 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75630 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75639 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75641 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75648 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr),
     /*  75651 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75655 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75664 */   GIR_RootConstrainSelectedInstOperands,
     /*  75665 */   // GIR_Coverage, 52,
     /*  75665 */   GIR_EraseRootFromParent_Done,
     /*  75666 */ // Label 1666: @75666
     /*  75666 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(75729), // Rule ID 58 //
     /*  75671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  75674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75677 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75689 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75698 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75711 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr_EVEX),
     /*  75714 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75718 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75727 */   GIR_RootConstrainSelectedInstOperands,
     /*  75728 */   // GIR_Coverage, 58,
     /*  75728 */   GIR_EraseRootFromParent_Done,
     /*  75729 */ // Label 1667: @75729
     /*  75729 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(75774), // Rule ID 22513 //
     /*  75734 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75752 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75759 */   // (atomic_store GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75762 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75766 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75772 */   GIR_RootConstrainSelectedInstOperands,
     /*  75773 */   // GIR_Coverage, 22513,
     /*  75773 */   GIR_EraseRootFromParent_Done,
     /*  75774 */ // Label 1668: @75774
     /*  75774 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(75816), // Rule ID 34 //
     /*  75779 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75801 */   // (st GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75804 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75808 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75814 */   GIR_RootConstrainSelectedInstOperands,
     /*  75815 */   // GIR_Coverage, 34,
     /*  75815 */   GIR_EraseRootFromParent_Done,
     /*  75816 */ // Label 1669: @75816
     /*  75816 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(75864), // Rule ID 1095 //
     /*  75821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  75824 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75827 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  75835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75846 */   // (st RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp32m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /*  75846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp32m),
     /*  75849 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  75853 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75855 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  75858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75862 */   GIR_RootConstrainSelectedInstOperands,
     /*  75863 */   // GIR_Coverage, 1095,
     /*  75863 */   GIR_EraseRootFromParent_Done,
     /*  75864 */ // Label 1670: @75864
     /*  75864 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(75909), // Rule ID 1688 //
     /*  75869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75887 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75894 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75897 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75901 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75907 */   GIR_RootConstrainSelectedInstOperands,
     /*  75908 */   // GIR_Coverage, 1688,
     /*  75908 */   GIR_EraseRootFromParent_Done,
     /*  75909 */ // Label 1671: @75909
     /*  75909 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(75954), // Rule ID 1690 //
     /*  75914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75939 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75942 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75946 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75952 */   GIR_RootConstrainSelectedInstOperands,
     /*  75953 */   // GIR_Coverage, 1690,
     /*  75953 */   GIR_EraseRootFromParent_Done,
     /*  75954 */ // Label 1672: @75954
     /*  75954 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(75999), // Rule ID 4610 //
     /*  75959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75962 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75965 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  75973 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75977 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75984 */   // (st FR32X:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32X:{ *:[f32] }:$src)
     /*  75984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75987 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75991 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75997 */   GIR_RootConstrainSelectedInstOperands,
     /*  75998 */   // GIR_Coverage, 4610,
     /*  75998 */   GIR_EraseRootFromParent_Done,
     /*  75999 */ // Label 1673: @75999
     /*  75999 */ GIM_Reject,
     /*  76000 */ // Label 1476: @76000
     /*  76000 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(76096), // Rule ID 22494 //
     /*  76005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76008 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76011 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76026 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76030 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76034 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76038 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76042 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76045 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76049 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76056 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76060 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76064 */   // MIs[0] dst
     /*  76064 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76069 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76071 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76078 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76081 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76085 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76094 */   GIR_RootConstrainSelectedInstOperands,
     /*  76095 */   // GIR_Coverage, 22494,
     /*  76095 */   GIR_EraseRootFromParent_Done,
     /*  76096 */ // Label 1674: @76096
     /*  76096 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(76192), // Rule ID 22498 //
     /*  76101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76104 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76107 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76114 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76118 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76122 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76126 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76130 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76134 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76138 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76141 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76145 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76152 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76156 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76160 */   // MIs[0] dst
     /*  76160 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76165 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76167 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76174 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76177 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76181 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76190 */   GIR_RootConstrainSelectedInstOperands,
     /*  76191 */   // GIR_Coverage, 22498,
     /*  76191 */   GIR_EraseRootFromParent_Done,
     /*  76192 */ // Label 1675: @76192
     /*  76192 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(76285), // Rule ID 22502 //
     /*  76197 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76207 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76211 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76215 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76219 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76223 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76227 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76231 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76235 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76242 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76249 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76253 */   // MIs[0] dst
     /*  76253 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76258 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76260 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76267 */   // (atomic_store (sub:{ *:[i64] } 0:{ *:[i64] }, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76270 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76274 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76283 */   GIR_RootConstrainSelectedInstOperands,
     /*  76284 */   // GIR_Coverage, 22502,
     /*  76284 */   GIR_EraseRootFromParent_Done,
     /*  76285 */ // Label 1676: @76285
     /*  76285 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(76375), // Rule ID 22506 //
     /*  76290 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76293 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76308 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76312 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76316 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76320 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76324 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76331 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76338 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76342 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76346 */   // MIs[0] dst
     /*  76346 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76351 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76353 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76360 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NOT64m addr:{ *:[iPTR] }:$dst)
     /*  76360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  76363 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76373 */   GIR_RootConstrainSelectedInstOperands,
     /*  76374 */   // GIR_Coverage, 22506,
     /*  76374 */   GIR_EraseRootFromParent_Done,
     /*  76375 */ // Label 1677: @76375
     /*  76375 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(76461), // Rule ID 231 //
     /*  76380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76386 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76398 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76406 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76410 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76414 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76417 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76421 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76425 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76429 */   // MIs[0] src1
     /*  76429 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76434 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76436 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76443 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76446 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76450 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76459 */   GIR_RootConstrainSelectedInstOperands,
     /*  76460 */   // GIR_Coverage, 231,
     /*  76460 */   GIR_EraseRootFromParent_Done,
     /*  76461 */ // Label 1678: @76461
     /*  76461 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(76547), // Rule ID 232 //
     /*  76466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76484 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76488 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76492 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76496 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76500 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76507 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76511 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76515 */   // MIs[0] src1
     /*  76515 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76520 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76522 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76529 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76532 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76536 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76545 */   GIR_RootConstrainSelectedInstOperands,
     /*  76546 */   // GIR_Coverage, 232,
     /*  76546 */   GIR_EraseRootFromParent_Done,
     /*  76547 */ // Label 1679: @76547
     /*  76547 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(76640), // Rule ID 22616 //
     /*  76552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76555 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76567 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76571 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76575 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76579 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76583 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76586 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76590 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76594 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  76605 */   // MIs[0] dst
     /*  76605 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76610 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76612 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76619 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i64] })
     /*  76619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76622 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  76629 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76638 */   GIR_RootConstrainSelectedInstOperands,
     /*  76639 */   // GIR_Coverage, 22616,
     /*  76639 */   GIR_EraseRootFromParent_Done,
     /*  76640 */ // Label 1680: @76640
     /*  76640 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(76740), // Rule ID 22624 //
     /*  76645 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76660 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76664 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76668 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76672 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76676 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76683 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76687 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2147483648),
     /*  76698 */   // MIs[0] dst
     /*  76698 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76703 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76705 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76712 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -2147483648:{ *:[i64] })
     /*  76712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76715 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76719 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  76729 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76738 */   GIR_RootConstrainSelectedInstOperands,
     /*  76739 */   // GIR_Coverage, 22624,
     /*  76739 */   GIR_EraseRootFromParent_Done,
     /*  76740 */ // Label 1681: @76740
     /*  76740 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(76826), // Rule ID 17615 //
     /*  76745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76748 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76751 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  76763 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76767 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76771 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76775 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76779 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76786 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76790 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  76794 */   // MIs[0] dst
     /*  76794 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76799 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76801 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76808 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1),
     /*  76811 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76815 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76824 */   GIR_RootConstrainSelectedInstOperands,
     /*  76825 */   // GIR_Coverage, 17615,
     /*  76825 */   GIR_EraseRootFromParent_Done,
     /*  76826 */ // Label 1682: @76826
     /*  76826 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(76912), // Rule ID 17619 //
     /*  76831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76834 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76837 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76841 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  76849 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76853 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76857 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76861 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76865 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76872 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76876 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  76880 */   // MIs[0] dst
     /*  76880 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76885 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76887 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76894 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1),
     /*  76897 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76901 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76910 */   GIR_RootConstrainSelectedInstOperands,
     /*  76911 */   // GIR_Coverage, 17619,
     /*  76911 */   GIR_EraseRootFromParent_Done,
     /*  76912 */ // Label 1683: @76912
     /*  76912 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(76998), // Rule ID 264 //
     /*  76917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76935 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76939 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76947 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76955 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76962 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76966 */   // MIs[0] src1
     /*  76966 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76971 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76973 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76980 */   // (st (sub:{ *:[i64] } 0:{ *:[i64] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76983 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76987 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76990 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76996 */   GIR_RootConstrainSelectedInstOperands,
     /*  76997 */   // GIR_Coverage, 264,
     /*  76997 */   GIR_EraseRootFromParent_Done,
     /*  76998 */ // Label 1684: @76998
     /*  76998 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(77081), // Rule ID 272 //
     /*  77003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77006 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77009 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77021 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77025 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77029 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77033 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77037 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77040 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77044 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77048 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  77052 */   // MIs[0] src1
     /*  77052 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77057 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77059 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77066 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT64m addr:{ *:[iPTR] }:$src1)
     /*  77066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  77069 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77079 */   GIR_RootConstrainSelectedInstOperands,
     /*  77080 */   // GIR_Coverage, 272,
     /*  77080 */   GIR_EraseRootFromParent_Done,
     /*  77081 */ // Label 1685: @77081
     /*  77081 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(77186), // Rule ID 22430 //
     /*  77086 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77096 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77100 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  77104 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77108 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77112 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77116 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77120 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77123 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77127 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77134 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77138 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77142 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77146 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77150 */   // MIs[3] Operand 1
     /*  77150 */   // No operand predicates
     /*  77150 */   // MIs[0] dst
     /*  77150 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77155 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77157 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77164 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mi32),
     /*  77167 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77171 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77174 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77177 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77184 */   GIR_RootConstrainSelectedInstOperands,
     /*  77185 */   // GIR_Coverage, 22430,
     /*  77185 */   GIR_EraseRootFromParent_Done,
     /*  77186 */ // Label 1686: @77186
     /*  77186 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(77291), // Rule ID 22438 //
     /*  77191 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77209 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77213 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77217 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77221 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77225 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77232 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77239 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77243 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77247 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77251 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77255 */   // MIs[3] Operand 1
     /*  77255 */   // No operand predicates
     /*  77255 */   // MIs[0] dst
     /*  77255 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77260 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77262 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77269 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mi32),
     /*  77272 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77276 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77279 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77289 */   GIR_RootConstrainSelectedInstOperands,
     /*  77290 */   // GIR_Coverage, 22438,
     /*  77290 */   GIR_EraseRootFromParent_Done,
     /*  77291 */ // Label 1687: @77291
     /*  77291 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(77396), // Rule ID 22446 //
     /*  77296 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77314 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77318 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77322 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77326 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77337 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77344 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77348 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77352 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77356 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77360 */   // MIs[3] Operand 1
     /*  77360 */   // No operand predicates
     /*  77360 */   // MIs[0] dst
     /*  77360 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77365 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77367 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77374 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mi32),
     /*  77377 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77381 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77384 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77387 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77394 */   GIR_RootConstrainSelectedInstOperands,
     /*  77395 */   // GIR_Coverage, 22446,
     /*  77395 */   GIR_EraseRootFromParent_Done,
     /*  77396 */ // Label 1688: @77396
     /*  77396 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(77501), // Rule ID 22462 //
     /*  77401 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77419 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77442 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77449 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77453 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77457 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77461 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77465 */   // MIs[3] Operand 1
     /*  77465 */   // No operand predicates
     /*  77465 */   // MIs[0] dst
     /*  77465 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77470 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77472 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77479 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  77482 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77486 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77489 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77499 */   GIR_RootConstrainSelectedInstOperands,
     /*  77500 */   // GIR_Coverage, 22462,
     /*  77500 */   GIR_EraseRootFromParent_Done,
     /*  77501 */ // Label 1689: @77501
     /*  77501 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(77606), // Rule ID 22454 //
     /*  77506 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77509 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77516 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77520 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77524 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77528 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77532 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77536 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77540 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77543 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77547 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77554 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77558 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77562 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77566 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77570 */   // MIs[3] Operand 1
     /*  77570 */   // No operand predicates
     /*  77570 */   // MIs[0] dst
     /*  77570 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77575 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77577 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77584 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mi32),
     /*  77587 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77591 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77594 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77604 */   GIR_RootConstrainSelectedInstOperands,
     /*  77605 */   // GIR_Coverage, 22454,
     /*  77605 */   GIR_EraseRootFromParent_Done,
     /*  77606 */ // Label 1690: @77606
     /*  77606 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(77710), // Rule ID 835 //
     /*  77611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77614 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  77626 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77634 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77638 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77642 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77646 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77653 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77657 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77662 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77666 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77670 */   // MIs[3] Operand 1
     /*  77670 */   // No operand predicates
     /*  77670 */   // MIs[0] src1
     /*  77670 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77675 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77677 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77684 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8),
     /*  77687 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77691 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  77695 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77698 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77708 */   GIR_RootConstrainSelectedInstOperands,
     /*  77709 */   // GIR_Coverage, 835,
     /*  77709 */   GIR_EraseRootFromParent_Done,
     /*  77710 */ // Label 1691: @77710
     /*  77710 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(77814), // Rule ID 859 //
     /*  77715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77718 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  77730 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77734 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77738 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77742 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77747 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77751 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77755 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77762 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77766 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77770 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77774 */   // MIs[3] Operand 1
     /*  77774 */   // No operand predicates
     /*  77774 */   // MIs[0] src1
     /*  77774 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77779 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77781 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77788 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8),
     /*  77791 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77795 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  77799 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77802 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77812 */   GIR_RootConstrainSelectedInstOperands,
     /*  77813 */   // GIR_Coverage, 859,
     /*  77813 */   GIR_EraseRootFromParent_Done,
     /*  77814 */ // Label 1692: @77814
     /*  77814 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(77908), // Rule ID 736 //
     /*  77819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  77837 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77841 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77845 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77849 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77853 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77856 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77860 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77864 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77868 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77872 */   // MIs[3] Operand 1
     /*  77872 */   // No operand predicates
     /*  77872 */   // MIs[0] src1
     /*  77872 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77877 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77879 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77886 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi),
     /*  77889 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77893 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77896 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77899 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77906 */   GIR_RootConstrainSelectedInstOperands,
     /*  77907 */   // GIR_Coverage, 736,
     /*  77907 */   GIR_EraseRootFromParent_Done,
     /*  77908 */ // Label 1693: @77908
     /*  77908 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(78002), // Rule ID 704 //
     /*  77913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77919 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  77931 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77939 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77943 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77947 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77954 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77958 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77962 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77966 */   // MIs[3] Operand 1
     /*  77966 */   // No operand predicates
     /*  77966 */   // MIs[0] src1
     /*  77966 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77971 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77973 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77980 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi),
     /*  77983 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77987 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77990 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78000 */   GIR_RootConstrainSelectedInstOperands,
     /*  78001 */   // GIR_Coverage, 704,
     /*  78001 */   GIR_EraseRootFromParent_Done,
     /*  78002 */ // Label 1694: @78002
     /*  78002 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(78096), // Rule ID 768 //
     /*  78007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78013 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  78025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78029 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78033 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78037 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78041 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78048 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78052 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78056 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78060 */   // MIs[3] Operand 1
     /*  78060 */   // No operand predicates
     /*  78060 */   // MIs[0] src1
     /*  78060 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78065 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78067 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78074 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi),
     /*  78077 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78081 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78084 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78094 */   GIR_RootConstrainSelectedInstOperands,
     /*  78095 */   // GIR_Coverage, 768,
     /*  78095 */   GIR_EraseRootFromParent_Done,
     /*  78096 */ // Label 1695: @78096
     /*  78096 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(78190), // Rule ID 800 //
     /*  78101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78104 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78107 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  78119 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78123 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78127 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78131 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78135 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78138 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78142 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78146 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78150 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78154 */   // MIs[3] Operand 1
     /*  78154 */   // No operand predicates
     /*  78154 */   // MIs[0] src1
     /*  78154 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78159 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78161 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78168 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi),
     /*  78171 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78175 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78178 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78188 */   GIR_RootConstrainSelectedInstOperands,
     /*  78189 */   // GIR_Coverage, 800,
     /*  78189 */   GIR_EraseRootFromParent_Done,
     /*  78190 */ // Label 1696: @78190
     /*  78190 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(78284), // Rule ID 672 //
     /*  78195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78198 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78201 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78209 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  78213 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78217 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78221 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78225 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78229 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78232 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78236 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78240 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78244 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78248 */   // MIs[3] Operand 1
     /*  78248 */   // No operand predicates
     /*  78248 */   // MIs[0] src1
     /*  78248 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78253 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78255 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78262 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi),
     /*  78265 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78269 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78272 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78282 */   GIR_RootConstrainSelectedInstOperands,
     /*  78283 */   // GIR_Coverage, 672,
     /*  78283 */   GIR_EraseRootFromParent_Done,
     /*  78284 */ // Label 1697: @78284
     /*  78284 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(78382), // Rule ID 22434 //
     /*  78289 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78307 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78311 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78315 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78319 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78323 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78326 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78330 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78337 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78341 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78346 */   // MIs[0] dst
     /*  78346 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78351 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78353 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78360 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78363 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78367 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78371 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78374 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78380 */   GIR_RootConstrainSelectedInstOperands,
     /*  78381 */   // GIR_Coverage, 22434,
     /*  78381 */   GIR_EraseRootFromParent_Done,
     /*  78382 */ // Label 1698: @78382
     /*  78382 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(78480), // Rule ID 26005 //
     /*  78387 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78390 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78405 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78409 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78413 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78418 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78422 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78426 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78433 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78440 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78444 */   // MIs[0] dst
     /*  78444 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78449 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78451 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78458 */   // (atomic_store (add:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78465 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78469 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78478 */   GIR_RootConstrainSelectedInstOperands,
     /*  78479 */   // GIR_Coverage, 26005,
     /*  78479 */   GIR_EraseRootFromParent_Done,
     /*  78480 */ // Label 1699: @78480
     /*  78480 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(78578), // Rule ID 22442 //
     /*  78485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78503 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78507 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78511 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78515 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78519 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78526 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78533 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78537 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78542 */   // MIs[0] dst
     /*  78542 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78547 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78549 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78556 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78559 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78563 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78567 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78576 */   GIR_RootConstrainSelectedInstOperands,
     /*  78577 */   // GIR_Coverage, 22442,
     /*  78577 */   GIR_EraseRootFromParent_Done,
     /*  78578 */ // Label 1700: @78578
     /*  78578 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(78676), // Rule ID 26009 //
     /*  78583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78601 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78605 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78609 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78614 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78618 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78622 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78629 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78636 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78640 */   // MIs[0] dst
     /*  78640 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78645 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78647 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78654 */   // (atomic_store (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78657 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78661 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78665 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78674 */   GIR_RootConstrainSelectedInstOperands,
     /*  78675 */   // GIR_Coverage, 26009,
     /*  78675 */   GIR_EraseRootFromParent_Done,
     /*  78676 */ // Label 1701: @78676
     /*  78676 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(78774), // Rule ID 22450 //
     /*  78681 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78684 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78699 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78703 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78707 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78711 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78715 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78718 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78722 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78729 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78733 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78738 */   // MIs[0] dst
     /*  78738 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78743 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78745 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78752 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78755 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78759 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78763 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78772 */   GIR_RootConstrainSelectedInstOperands,
     /*  78773 */   // GIR_Coverage, 22450,
     /*  78773 */   GIR_EraseRootFromParent_Done,
     /*  78774 */ // Label 1702: @78774
     /*  78774 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(78872), // Rule ID 26013 //
     /*  78779 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78810 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78814 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78821 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78825 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78832 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78836 */   // MIs[0] dst
     /*  78836 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78841 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78843 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78850 */   // (atomic_store (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78853 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78857 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78861 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78870 */   GIR_RootConstrainSelectedInstOperands,
     /*  78871 */   // GIR_Coverage, 26013,
     /*  78871 */   GIR_EraseRootFromParent_Done,
     /*  78872 */ // Label 1703: @78872
     /*  78872 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(78970), // Rule ID 22466 //
     /*  78877 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78880 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78887 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  78895 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78899 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78903 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78907 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78911 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78914 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78918 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78925 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78929 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78934 */   // MIs[0] dst
     /*  78934 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78939 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78941 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78948 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  78951 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78955 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78959 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78968 */   GIR_RootConstrainSelectedInstOperands,
     /*  78969 */   // GIR_Coverage, 22466,
     /*  78969 */   GIR_EraseRootFromParent_Done,
     /*  78970 */ // Label 1704: @78970
     /*  78970 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(79068), // Rule ID 22458 //
     /*  78975 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78993 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78997 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79001 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79005 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79009 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79012 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79016 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79023 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79032 */   // MIs[0] dst
     /*  79032 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79037 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79039 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79046 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79049 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79053 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79057 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79060 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79066 */   GIR_RootConstrainSelectedInstOperands,
     /*  79067 */   // GIR_Coverage, 22458,
     /*  79067 */   GIR_EraseRootFromParent_Done,
     /*  79068 */ // Label 1705: @79068
     /*  79068 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(79166), // Rule ID 26017 //
     /*  79073 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79076 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79091 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79099 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79104 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79108 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79112 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79115 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79119 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79126 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79130 */   // MIs[0] dst
     /*  79130 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79135 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79137 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79144 */   // (atomic_store (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79147 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79151 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79155 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79158 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79164 */   GIR_RootConstrainSelectedInstOperands,
     /*  79165 */   // GIR_Coverage, 26017,
     /*  79165 */   GIR_EraseRootFromParent_Done,
     /*  79166 */ // Label 1706: @79166
     /*  79166 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(79277), // Rule ID 838 //
     /*  79171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79174 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  79186 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79194 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79198 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79202 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79206 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79213 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79217 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79222 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79227 */   // MIs[0] src1
     /*  79227 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79232 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79234 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79241 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79245 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79251 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL),
     /*  79258 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79262 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79266 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79275 */   GIR_RootConstrainSelectedInstOperands,
     /*  79276 */   // GIR_Coverage, 838,
     /*  79276 */   GIR_EraseRootFromParent_Done,
     /*  79277 */ // Label 1707: @79277
     /*  79277 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(79388), // Rule ID 862 //
     /*  79282 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79285 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79289 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79293 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  79297 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79301 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79305 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79309 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79314 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79318 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79322 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79325 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79329 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79338 */   // MIs[0] src1
     /*  79338 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79343 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79345 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79352 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79356 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79362 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL),
     /*  79369 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79373 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79377 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79386 */   GIR_RootConstrainSelectedInstOperands,
     /*  79387 */   // GIR_Coverage, 862,
     /*  79387 */   GIR_EraseRootFromParent_Done,
     /*  79388 */ // Label 1708: @79388
     /*  79388 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(79476), // Rule ID 412 //
     /*  79393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79408 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79412 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79416 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79420 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79424 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79427 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79431 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79435 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79440 */   // MIs[0] src1
     /*  79440 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79445 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79447 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79454 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79457 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79461 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79465 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79474 */   GIR_RootConstrainSelectedInstOperands,
     /*  79475 */   // GIR_Coverage, 412,
     /*  79475 */   GIR_EraseRootFromParent_Done,
     /*  79476 */ // Label 1709: @79476
     /*  79476 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(79564), // Rule ID 23225 //
     /*  79481 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79484 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79496 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79500 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79504 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79509 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79513 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79517 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79524 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79528 */   // MIs[0] src1
     /*  79528 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79533 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79535 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79542 */   // (st (add:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79545 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79549 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79553 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79562 */   GIR_RootConstrainSelectedInstOperands,
     /*  79563 */   // GIR_Coverage, 23225,
     /*  79563 */   GIR_EraseRootFromParent_Done,
     /*  79564 */ // Label 1710: @79564
     /*  79564 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(79652), // Rule ID 304 //
     /*  79569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79572 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79576 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79584 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79588 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79592 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79596 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79600 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79607 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79611 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79616 */   // MIs[0] src1
     /*  79616 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79621 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79623 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79630 */   // (st (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79633 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79637 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79641 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79650 */   GIR_RootConstrainSelectedInstOperands,
     /*  79651 */   // GIR_Coverage, 304,
     /*  79651 */   GIR_EraseRootFromParent_Done,
     /*  79652 */ // Label 1711: @79652
     /*  79652 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(79740), // Rule ID 23189 //
     /*  79657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79672 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79676 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79680 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79685 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79689 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79693 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79700 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79704 */   // MIs[0] src1
     /*  79704 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79709 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79711 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79718 */   // (st (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79721 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79725 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79729 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79738 */   GIR_RootConstrainSelectedInstOperands,
     /*  79739 */   // GIR_Coverage, 23189,
     /*  79739 */   GIR_EraseRootFromParent_Done,
     /*  79740 */ // Label 1712: @79740
     /*  79740 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(79841), // Rule ID 752 //
     /*  79745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79748 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79751 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  79763 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79767 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79771 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79775 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79779 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79786 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79790 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79795 */   // MIs[0] src1
     /*  79795 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79800 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79802 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79809 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79813 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL),
     /*  79826 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79830 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79839 */   GIR_RootConstrainSelectedInstOperands,
     /*  79840 */   // GIR_Coverage, 752,
     /*  79840 */   GIR_EraseRootFromParent_Done,
     /*  79841 */ // Label 1713: @79841
     /*  79841 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(79942), // Rule ID 720 //
     /*  79846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79852 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  79864 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79868 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79872 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79876 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79880 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79883 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79887 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79896 */   // MIs[0] src1
     /*  79896 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79901 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79903 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79910 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79914 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79920 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL),
     /*  79927 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79931 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79940 */   GIR_RootConstrainSelectedInstOperands,
     /*  79941 */   // GIR_Coverage, 720,
     /*  79941 */   GIR_EraseRootFromParent_Done,
     /*  79942 */ // Label 1714: @79942
     /*  79942 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(80030), // Rule ID 340 //
     /*  79947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79962 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79970 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79974 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79978 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79985 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79989 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79994 */   // MIs[0] src1
     /*  79994 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79999 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80001 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80008 */   // (st (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80011 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80015 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80019 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80022 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80028 */   GIR_RootConstrainSelectedInstOperands,
     /*  80029 */   // GIR_Coverage, 340,
     /*  80029 */   GIR_EraseRootFromParent_Done,
     /*  80030 */ // Label 1715: @80030
     /*  80030 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(80118), // Rule ID 23201 //
     /*  80035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80050 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80054 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80058 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80063 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80067 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80071 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80078 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80082 */   // MIs[0] src1
     /*  80082 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80087 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80089 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80096 */   // (st (or:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80099 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80103 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80107 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80116 */   GIR_RootConstrainSelectedInstOperands,
     /*  80117 */   // GIR_Coverage, 23201,
     /*  80117 */   GIR_EraseRootFromParent_Done,
     /*  80118 */ // Label 1716: @80118
     /*  80118 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(80219), // Rule ID 784 //
     /*  80123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  80141 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80145 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80149 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80153 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80157 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80160 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80164 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80168 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80173 */   // MIs[0] src1
     /*  80173 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80178 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80180 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80187 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80191 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80197 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL),
     /*  80204 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80208 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80217 */   GIR_RootConstrainSelectedInstOperands,
     /*  80218 */   // GIR_Coverage, 784,
     /*  80218 */   GIR_EraseRootFromParent_Done,
     /*  80219 */ // Label 1717: @80219
     /*  80219 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(80320), // Rule ID 816 //
     /*  80224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  80242 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80246 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80250 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80254 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80258 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80261 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80265 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80274 */   // MIs[0] src1
     /*  80274 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80279 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80281 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80288 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80292 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80298 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL),
     /*  80305 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80309 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80318 */   GIR_RootConstrainSelectedInstOperands,
     /*  80319 */   // GIR_Coverage, 816,
     /*  80319 */   GIR_EraseRootFromParent_Done,
     /*  80320 */ // Label 1718: @80320
     /*  80320 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(80421), // Rule ID 688 //
     /*  80325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80328 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80335 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80339 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  80343 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80347 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80351 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80355 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80359 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80362 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80366 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80370 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80375 */   // MIs[0] src1
     /*  80375 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80380 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80382 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80389 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80393 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80399 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL),
     /*  80406 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80410 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80419 */   GIR_RootConstrainSelectedInstOperands,
     /*  80420 */   // GIR_Coverage, 688,
     /*  80420 */   GIR_EraseRootFromParent_Done,
     /*  80421 */ // Label 1719: @80421
     /*  80421 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(80509), // Rule ID 448 //
     /*  80426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80437 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80441 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80445 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80449 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80453 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80457 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80464 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80468 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80473 */   // MIs[0] src1
     /*  80473 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80478 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80480 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80487 */   // (st (sub:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  80490 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80494 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80498 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80507 */   GIR_RootConstrainSelectedInstOperands,
     /*  80508 */   // GIR_Coverage, 448,
     /*  80508 */   GIR_EraseRootFromParent_Done,
     /*  80509 */ // Label 1720: @80509
     /*  80509 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(80597), // Rule ID 376 //
     /*  80514 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80517 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80521 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80529 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80533 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80537 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80541 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80545 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80548 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80552 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80556 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80561 */   // MIs[0] src1
     /*  80561 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80566 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80568 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80575 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80578 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80582 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80586 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80595 */   GIR_RootConstrainSelectedInstOperands,
     /*  80596 */   // GIR_Coverage, 376,
     /*  80596 */   GIR_EraseRootFromParent_Done,
     /*  80597 */ // Label 1721: @80597
     /*  80597 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(80685), // Rule ID 23213 //
     /*  80602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80605 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80617 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80625 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80630 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80634 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80638 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80645 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80649 */   // MIs[0] src1
     /*  80649 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80654 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80656 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80663 */   // (st (xor:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80666 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80670 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80674 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80683 */   GIR_RootConstrainSelectedInstOperands,
     /*  80684 */   // GIR_Coverage, 23213,
     /*  80684 */   GIR_EraseRootFromParent_Done,
     /*  80685 */ // Label 1722: @80685
     /*  80685 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(80742), // Rule ID 22510 //
     /*  80690 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80708 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  80712 */   // MIs[1] Operand 1
     /*  80712 */   // No operand predicates
     /*  80712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80725 */   // (atomic_store (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mi32 addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  80725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mi32),
     /*  80728 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80732 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  80735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80740 */   GIR_RootConstrainSelectedInstOperands,
     /*  80741 */   // GIR_Coverage, 22510,
     /*  80741 */   GIR_EraseRootFromParent_Done,
     /*  80742 */ // Label 1723: @80742
     /*  80742 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(80808), // Rule ID 22522 //
     /*  80747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  80750 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80753 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80760 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80768 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80772 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80790 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  80793 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80797 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80806 */   GIR_RootConstrainSelectedInstOperands,
     /*  80807 */   // GIR_Coverage, 22522,
     /*  80807 */   GIR_EraseRootFromParent_Done,
     /*  80808 */ // Label 1724: @80808
     /*  80808 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(80874), // Rule ID 22523 //
     /*  80813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  80816 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80826 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80830 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80834 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80838 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80843 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80849 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80856 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  80859 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80863 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80872 */   GIR_RootConstrainSelectedInstOperands,
     /*  80873 */   // GIR_Coverage, 22523,
     /*  80873 */   GIR_EraseRootFromParent_Done,
     /*  80874 */ // Label 1725: @80874
     /*  80874 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(80940), // Rule ID 22524 //
     /*  80879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  80882 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80885 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80892 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80896 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80900 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80904 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80913 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80915 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80922 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  80925 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80929 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80938 */   GIR_RootConstrainSelectedInstOperands,
     /*  80939 */   // GIR_Coverage, 22524,
     /*  80939 */   GIR_EraseRootFromParent_Done,
     /*  80940 */ // Label 1726: @80940
     /*  80940 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(81003), // Rule ID 54 //
     /*  80945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  80948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80951 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80955 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  80963 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80967 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80972 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80978 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80985 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  80985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr),
     /*  80988 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  80996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81001 */   GIR_RootConstrainSelectedInstOperands,
     /*  81002 */   // GIR_Coverage, 54,
     /*  81002 */   GIR_EraseRootFromParent_Done,
     /*  81003 */ // Label 1727: @81003
     /*  81003 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(81066), // Rule ID 60 //
     /*  81008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  81011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81026 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81030 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81048 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr_EVEX),
     /*  81051 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81055 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81064 */   GIR_RootConstrainSelectedInstOperands,
     /*  81065 */   // GIR_Coverage, 60,
     /*  81065 */   GIR_EraseRootFromParent_Done,
     /*  81066 */ // Label 1728: @81066
     /*  81066 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(81111), // Rule ID 22514 //
     /*  81071 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81074 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81085 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81089 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81096 */   // (atomic_store GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81099 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81103 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81109 */   GIR_RootConstrainSelectedInstOperands,
     /*  81110 */   // GIR_Coverage, 22514,
     /*  81110 */   GIR_EraseRootFromParent_Done,
     /*  81111 */ // Label 1729: @81111
     /*  81111 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(81153), // Rule ID 35 //
     /*  81116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81119 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81138 */   // (st GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81141 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81145 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81151 */   GIR_RootConstrainSelectedInstOperands,
     /*  81152 */   // GIR_Coverage, 35,
     /*  81152 */   GIR_EraseRootFromParent_Done,
     /*  81153 */ // Label 1730: @81153
     /*  81153 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(81208), // Rule ID 1096 //
     /*  81158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81164 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81183 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81190 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m32),
     /*  81193 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81197 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81199 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81206 */   GIR_RootConstrainSelectedInstOperands,
     /*  81207 */   // GIR_Coverage, 1096,
     /*  81207 */   GIR_EraseRootFromParent_Done,
     /*  81208 */ // Label 1731: @81208
     /*  81208 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(81256), // Rule ID 1097 //
     /*  81213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81238 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp64m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m),
     /*  81241 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81245 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81247 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81254 */   GIR_RootConstrainSelectedInstOperands,
     /*  81255 */   // GIR_Coverage, 1097,
     /*  81255 */   GIR_EraseRootFromParent_Done,
     /*  81256 */ // Label 1732: @81256
     /*  81256 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(81301), // Rule ID 1692 //
     /*  81261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81264 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81267 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81279 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81286 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81289 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81293 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81299 */   GIR_RootConstrainSelectedInstOperands,
     /*  81300 */   // GIR_Coverage, 1692,
     /*  81300 */   GIR_EraseRootFromParent_Done,
     /*  81301 */ // Label 1733: @81301
     /*  81301 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(81346), // Rule ID 1694 //
     /*  81306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81312 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81331 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  81334 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81338 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81344 */   GIR_RootConstrainSelectedInstOperands,
     /*  81345 */   // GIR_Coverage, 1694,
     /*  81345 */   GIR_EraseRootFromParent_Done,
     /*  81346 */ // Label 1734: @81346
     /*  81346 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(81391), // Rule ID 4616 //
     /*  81351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  81365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81376 */   // (st FR64X:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDZmr addr:{ *:[iPTR] }:$dst, FR64X:{ *:[f64] }:$src)
     /*  81376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZmr),
     /*  81379 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81383 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81389 */   GIR_RootConstrainSelectedInstOperands,
     /*  81390 */   // GIR_Coverage, 4616,
     /*  81390 */   GIR_EraseRootFromParent_Done,
     /*  81391 */ // Label 1735: @81391
     /*  81391 */ GIM_Reject,
     /*  81392 */ // Label 1477: @81392
     /*  81392 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(81550),
     /*  81397 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81400 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(81452), // Rule ID 1098 //
     /*  81405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81408 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81434 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp80m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m32),
     /*  81437 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81441 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81450 */     GIR_RootConstrainSelectedInstOperands,
     /*  81451 */     // GIR_Coverage, 1098,
     /*  81451 */     GIR_EraseRootFromParent_Done,
     /*  81452 */   // Label 1737: @81452
     /*  81452 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(81504), // Rule ID 1099 //
     /*  81457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81460 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81464 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81486 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref64>>  =>  (ST_Fp80m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m64),
     /*  81489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81493 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81502 */     GIR_RootConstrainSelectedInstOperands,
     /*  81503 */     // GIR_Coverage, 1099,
     /*  81503 */     GIR_EraseRootFromParent_Done,
     /*  81504 */   // Label 1738: @81504
     /*  81504 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(81549), // Rule ID 1100 //
     /*  81509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81531 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_FpP80m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_FpP80m),
     /*  81534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81538 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81547 */     GIR_RootConstrainSelectedInstOperands,
     /*  81548 */     // GIR_Coverage, 1100,
     /*  81548 */     GIR_EraseRootFromParent_Done,
     /*  81549 */   // Label 1739: @81549
     /*  81549 */   GIM_Reject,
     /*  81550 */ // Label 1736: @81550
     /*  81550 */ GIM_Reject,
     /*  81551 */ // Label 1478: @81551
     /*  81551 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(81804),
     /*  81556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81563 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(81605), // Rule ID 23142 //
     /*  81568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81590 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81597 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81603 */     GIR_RootConstrainSelectedInstOperands,
     /*  81604 */     // GIR_Coverage, 23142,
     /*  81604 */     GIR_EraseRootFromParent_Done,
     /*  81605 */   // Label 1741: @81605
     /*  81605 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(81643), // Rule ID 23143 //
     /*  81610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81628 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81635 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81641 */     GIR_RootConstrainSelectedInstOperands,
     /*  81642 */     // GIR_Coverage, 23143,
     /*  81642 */     GIR_EraseRootFromParent_Done,
     /*  81643 */   // Label 1742: @81643
     /*  81643 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(81685), // Rule ID 23146 //
     /*  81648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81670 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  81673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81677 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81683 */     GIR_RootConstrainSelectedInstOperands,
     /*  81684 */     // GIR_Coverage, 23146,
     /*  81684 */     GIR_EraseRootFromParent_Done,
     /*  81685 */   // Label 1743: @81685
     /*  81685 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(81723), // Rule ID 23147 //
     /*  81690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81708 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  81711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81715 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81721 */     GIR_RootConstrainSelectedInstOperands,
     /*  81722 */     // GIR_Coverage, 23147,
     /*  81722 */     GIR_EraseRootFromParent_Done,
     /*  81723 */   // Label 1744: @81723
     /*  81723 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(81765), // Rule ID 23150 //
     /*  81728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81750 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  81753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81757 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81763 */     GIR_RootConstrainSelectedInstOperands,
     /*  81764 */     // GIR_Coverage, 23150,
     /*  81764 */     GIR_EraseRootFromParent_Done,
     /*  81765 */   // Label 1745: @81765
     /*  81765 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(81803), // Rule ID 23151 //
     /*  81770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81788 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  81791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81795 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81801 */     GIR_RootConstrainSelectedInstOperands,
     /*  81802 */     // GIR_Coverage, 23151,
     /*  81802 */     GIR_EraseRootFromParent_Done,
     /*  81803 */   // Label 1746: @81803
     /*  81803 */   GIM_Reject,
     /*  81804 */ // Label 1740: @81804
     /*  81804 */ GIM_Reject,
     /*  81805 */ // Label 1479: @81805
     /*  81805 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(82298),
     /*  81810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81813 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81817 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(81859), // Rule ID 1716 //
     /*  81822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81844 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDmr),
     /*  81847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81851 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81857 */     GIR_RootConstrainSelectedInstOperands,
     /*  81858 */     // GIR_Coverage, 1716,
     /*  81858 */     GIR_EraseRootFromParent_Done,
     /*  81859 */   // Label 1748: @81859
     /*  81859 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(81897), // Rule ID 1718 //
     /*  81864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81882 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDmr),
     /*  81885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81889 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81895 */     GIR_RootConstrainSelectedInstOperands,
     /*  81896 */     // GIR_Coverage, 1718,
     /*  81896 */     GIR_EraseRootFromParent_Done,
     /*  81897 */   // Label 1749: @81897
     /*  81897 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(81939), // Rule ID 1724 //
     /*  81902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81924 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDmr),
     /*  81927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81931 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81937 */     GIR_RootConstrainSelectedInstOperands,
     /*  81938 */     // GIR_Coverage, 1724,
     /*  81938 */     GIR_EraseRootFromParent_Done,
     /*  81939 */   // Label 1750: @81939
     /*  81939 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(81977), // Rule ID 1726 //
     /*  81944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81962 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDmr),
     /*  81965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81969 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81975 */     GIR_RootConstrainSelectedInstOperands,
     /*  81976 */     // GIR_Coverage, 1726,
     /*  81976 */     GIR_EraseRootFromParent_Done,
     /*  81977 */   // Label 1751: @81977
     /*  81977 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(82019), // Rule ID 2520 //
     /*  81982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82004 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82011 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82017 */     GIR_RootConstrainSelectedInstOperands,
     /*  82018 */     // GIR_Coverage, 2520,
     /*  82018 */     GIR_EraseRootFromParent_Done,
     /*  82019 */   // Label 1752: @82019
     /*  82019 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(82057), // Rule ID 2521 //
     /*  82024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82042 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82049 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82055 */     GIR_RootConstrainSelectedInstOperands,
     /*  82056 */     // GIR_Coverage, 2521,
     /*  82056 */     GIR_EraseRootFromParent_Done,
     /*  82057 */   // Label 1753: @82057
     /*  82057 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(82099), // Rule ID 4496 //
     /*  82062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82084 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128mr),
     /*  82087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82091 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82097 */     GIR_RootConstrainSelectedInstOperands,
     /*  82098 */     // GIR_Coverage, 4496,
     /*  82098 */     GIR_EraseRootFromParent_Done,
     /*  82099 */   // Label 1754: @82099
     /*  82099 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(82137), // Rule ID 4520 //
     /*  82104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82122 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128mr),
     /*  82125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82129 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82135 */     GIR_RootConstrainSelectedInstOperands,
     /*  82136 */     // GIR_Coverage, 4520,
     /*  82136 */     GIR_EraseRootFromParent_Done,
     /*  82137 */   // Label 1755: @82137
     /*  82137 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(82179), // Rule ID 4550 //
     /*  82142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82164 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82171 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82177 */     GIR_RootConstrainSelectedInstOperands,
     /*  82178 */     // GIR_Coverage, 4550,
     /*  82178 */     GIR_EraseRootFromParent_Done,
     /*  82179 */   // Label 1756: @82179
     /*  82179 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(82217), // Rule ID 4592 //
     /*  82184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82202 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82209 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82215 */     GIR_RootConstrainSelectedInstOperands,
     /*  82216 */     // GIR_Coverage, 4592,
     /*  82216 */     GIR_EraseRootFromParent_Done,
     /*  82217 */   // Label 1757: @82217
     /*  82217 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(82259), // Rule ID 17947 //
     /*  82222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82244 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82251 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82257 */     GIR_RootConstrainSelectedInstOperands,
     /*  82258 */     // GIR_Coverage, 17947,
     /*  82258 */     GIR_EraseRootFromParent_Done,
     /*  82259 */   // Label 1758: @82259
     /*  82259 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(82297), // Rule ID 17951 //
     /*  82264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82282 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82289 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82295 */     GIR_RootConstrainSelectedInstOperands,
     /*  82296 */     // GIR_Coverage, 17951,
     /*  82296 */     GIR_EraseRootFromParent_Done,
     /*  82297 */   // Label 1759: @82297
     /*  82297 */   GIM_Reject,
     /*  82298 */ // Label 1747: @82298
     /*  82298 */ GIM_Reject,
     /*  82299 */ // Label 1480: @82299
     /*  82299 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(82792),
     /*  82304 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82307 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82311 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(82353), // Rule ID 1715 //
     /*  82316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82338 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  82341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82345 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82351 */     GIR_RootConstrainSelectedInstOperands,
     /*  82352 */     // GIR_Coverage, 1715,
     /*  82352 */     GIR_EraseRootFromParent_Done,
     /*  82353 */   // Label 1761: @82353
     /*  82353 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(82391), // Rule ID 1717 //
     /*  82358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82376 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  82379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82383 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82389 */     GIR_RootConstrainSelectedInstOperands,
     /*  82390 */     // GIR_Coverage, 1717,
     /*  82390 */     GIR_EraseRootFromParent_Done,
     /*  82391 */   // Label 1762: @82391
     /*  82391 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(82433), // Rule ID 1723 //
     /*  82396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82407 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82418 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82425 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82431 */     GIR_RootConstrainSelectedInstOperands,
     /*  82432 */     // GIR_Coverage, 1723,
     /*  82432 */     GIR_EraseRootFromParent_Done,
     /*  82433 */   // Label 1763: @82433
     /*  82433 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(82471), // Rule ID 1725 //
     /*  82438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82456 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82463 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82469 */     GIR_RootConstrainSelectedInstOperands,
     /*  82470 */     // GIR_Coverage, 1725,
     /*  82470 */     GIR_EraseRootFromParent_Done,
     /*  82471 */   // Label 1764: @82471
     /*  82471 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(82513), // Rule ID 4478 //
     /*  82476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82498 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  82501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82505 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82511 */     GIR_RootConstrainSelectedInstOperands,
     /*  82512 */     // GIR_Coverage, 4478,
     /*  82512 */     GIR_EraseRootFromParent_Done,
     /*  82513 */   // Label 1765: @82513
     /*  82513 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(82551), // Rule ID 4508 //
     /*  82518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82536 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82543 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82549 */     GIR_RootConstrainSelectedInstOperands,
     /*  82550 */     // GIR_Coverage, 4508,
     /*  82550 */     GIR_EraseRootFromParent_Done,
     /*  82551 */   // Label 1766: @82551
     /*  82551 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(82593), // Rule ID 17948 //
     /*  82556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82578 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82585 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82591 */     GIR_RootConstrainSelectedInstOperands,
     /*  82592 */     // GIR_Coverage, 17948,
     /*  82592 */     GIR_EraseRootFromParent_Done,
     /*  82593 */   // Label 1767: @82593
     /*  82593 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(82631), // Rule ID 17952 //
     /*  82598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82616 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82623 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82629 */     GIR_RootConstrainSelectedInstOperands,
     /*  82630 */     // GIR_Coverage, 17952,
     /*  82630 */     GIR_EraseRootFromParent_Done,
     /*  82631 */   // Label 1768: @82631
     /*  82631 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(82673), // Rule ID 18327 //
     /*  82636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82658 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82665 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82671 */     GIR_RootConstrainSelectedInstOperands,
     /*  82672 */     // GIR_Coverage, 18327,
     /*  82672 */     GIR_EraseRootFromParent_Done,
     /*  82673 */   // Label 1769: @82673
     /*  82673 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(82711), // Rule ID 18331 //
     /*  82678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82696 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82703 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82709 */     GIR_RootConstrainSelectedInstOperands,
     /*  82710 */     // GIR_Coverage, 18331,
     /*  82710 */     GIR_EraseRootFromParent_Done,
     /*  82711 */   // Label 1770: @82711
     /*  82711 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(82753), // Rule ID 19820 //
     /*  82716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82738 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82745 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82751 */     GIR_RootConstrainSelectedInstOperands,
     /*  82752 */     // GIR_Coverage, 19820,
     /*  82752 */     GIR_EraseRootFromParent_Done,
     /*  82753 */   // Label 1771: @82753
     /*  82753 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(82791), // Rule ID 19824 //
     /*  82758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82776 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82779 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82783 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82789 */     GIR_RootConstrainSelectedInstOperands,
     /*  82790 */     // GIR_Coverage, 19824,
     /*  82790 */     GIR_EraseRootFromParent_Done,
     /*  82791 */   // Label 1772: @82791
     /*  82791 */   GIM_Reject,
     /*  82792 */ // Label 1760: @82792
     /*  82792 */ GIM_Reject,
     /*  82793 */ // Label 1481: @82793
     /*  82793 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(83126),
     /*  82798 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82805 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(82847), // Rule ID 1720 //
     /*  82810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82832 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  82832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYmr),
     /*  82835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82839 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82845 */     GIR_RootConstrainSelectedInstOperands,
     /*  82846 */     // GIR_Coverage, 1720,
     /*  82846 */     GIR_EraseRootFromParent_Done,
     /*  82847 */   // Label 1774: @82847
     /*  82847 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(82885), // Rule ID 1722 //
     /*  82852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82870 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  82870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYmr),
     /*  82873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82877 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82883 */     GIR_RootConstrainSelectedInstOperands,
     /*  82884 */     // GIR_Coverage, 1722,
     /*  82884 */     GIR_EraseRootFromParent_Done,
     /*  82885 */   // Label 1775: @82885
     /*  82885 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(82927), // Rule ID 4495 //
     /*  82890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82912 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  82912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256mr),
     /*  82915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82919 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82925 */     GIR_RootConstrainSelectedInstOperands,
     /*  82926 */     // GIR_Coverage, 4495,
     /*  82926 */     GIR_EraseRootFromParent_Done,
     /*  82927 */   // Label 1776: @82927
     /*  82927 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(82965), // Rule ID 4519 //
     /*  82932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82950 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  82950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256mr),
     /*  82953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82957 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82963 */     GIR_RootConstrainSelectedInstOperands,
     /*  82964 */     // GIR_Coverage, 4519,
     /*  82964 */     GIR_EraseRootFromParent_Done,
     /*  82965 */   // Label 1777: @82965
     /*  82965 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(83007), // Rule ID 4549 //
     /*  82970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82992 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  82992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  82995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82999 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83005 */     GIR_RootConstrainSelectedInstOperands,
     /*  83006 */     // GIR_Coverage, 4549,
     /*  83006 */     GIR_EraseRootFromParent_Done,
     /*  83007 */   // Label 1778: @83007
     /*  83007 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(83045), // Rule ID 4591 //
     /*  83012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83030 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  83033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83037 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83043 */     GIR_RootConstrainSelectedInstOperands,
     /*  83044 */     // GIR_Coverage, 4591,
     /*  83044 */     GIR_EraseRootFromParent_Done,
     /*  83045 */   // Label 1779: @83045
     /*  83045 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(83087), // Rule ID 17923 //
     /*  83050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83072 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83079 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83085 */     GIR_RootConstrainSelectedInstOperands,
     /*  83086 */     // GIR_Coverage, 17923,
     /*  83086 */     GIR_EraseRootFromParent_Done,
     /*  83087 */   // Label 1780: @83087
     /*  83087 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(83125), // Rule ID 17927 //
     /*  83092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83110 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83117 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83123 */     GIR_RootConstrainSelectedInstOperands,
     /*  83124 */     // GIR_Coverage, 17927,
     /*  83124 */     GIR_EraseRootFromParent_Done,
     /*  83125 */   // Label 1781: @83125
     /*  83125 */   GIM_Reject,
     /*  83126 */ // Label 1773: @83126
     /*  83126 */ GIM_Reject,
     /*  83127 */ // Label 1482: @83127
     /*  83127 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(83208),
     /*  83132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  83143 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83147 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(83177), // Rule ID 4396 //
     /*  83152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  83155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83162 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk),
     /*  83165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83169 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83175 */     GIR_RootConstrainSelectedInstOperands,
     /*  83176 */     // GIR_Coverage, 4396,
     /*  83176 */     GIR_EraseRootFromParent_Done,
     /*  83177 */   // Label 1783: @83177
     /*  83177 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(83207), // Rule ID 4398 //
     /*  83182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  83185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83192 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk_EVEX addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk_EVEX),
     /*  83195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83199 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83205 */     GIR_RootConstrainSelectedInstOperands,
     /*  83206 */     // GIR_Coverage, 4398,
     /*  83206 */     GIR_EraseRootFromParent_Done,
     /*  83207 */   // Label 1784: @83207
     /*  83207 */   GIM_Reject,
     /*  83208 */ // Label 1782: @83208
     /*  83208 */ GIM_Reject,
     /*  83209 */ // Label 1483: @83209
     /*  83209 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(83782),
     /*  83214 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83217 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83221 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(83263), // Rule ID 17933 //
     /*  83226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83248 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  83251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83255 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83261 */     GIR_RootConstrainSelectedInstOperands,
     /*  83262 */     // GIR_Coverage, 17933,
     /*  83262 */     GIR_EraseRootFromParent_Done,
     /*  83263 */   // Label 1786: @83263
     /*  83263 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(83301), // Rule ID 17934 //
     /*  83268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83286 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  83289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83293 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83299 */     GIR_RootConstrainSelectedInstOperands,
     /*  83300 */     // GIR_Coverage, 17934,
     /*  83300 */     GIR_EraseRootFromParent_Done,
     /*  83301 */   // Label 1787: @83301
     /*  83301 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(83343), // Rule ID 17949 //
     /*  83306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83328 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83335 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83341 */     GIR_RootConstrainSelectedInstOperands,
     /*  83342 */     // GIR_Coverage, 17949,
     /*  83342 */     GIR_EraseRootFromParent_Done,
     /*  83343 */   // Label 1788: @83343
     /*  83343 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(83381), // Rule ID 17953 //
     /*  83348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83366 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83373 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83379 */     GIR_RootConstrainSelectedInstOperands,
     /*  83380 */     // GIR_Coverage, 17953,
     /*  83380 */     GIR_EraseRootFromParent_Done,
     /*  83381 */   // Label 1789: @83381
     /*  83381 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(83423), // Rule ID 17957 //
     /*  83386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83408 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83415 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83421 */     GIR_RootConstrainSelectedInstOperands,
     /*  83422 */     // GIR_Coverage, 17957,
     /*  83422 */     GIR_EraseRootFromParent_Done,
     /*  83423 */   // Label 1790: @83423
     /*  83423 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(83461), // Rule ID 17958 //
     /*  83428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83446 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83453 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83459 */     GIR_RootConstrainSelectedInstOperands,
     /*  83460 */     // GIR_Coverage, 17958,
     /*  83460 */     GIR_EraseRootFromParent_Done,
     /*  83461 */   // Label 1791: @83461
     /*  83461 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(83503), // Rule ID 18328 //
     /*  83466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83488 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83495 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83501 */     GIR_RootConstrainSelectedInstOperands,
     /*  83502 */     // GIR_Coverage, 18328,
     /*  83502 */     GIR_EraseRootFromParent_Done,
     /*  83503 */   // Label 1792: @83503
     /*  83503 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(83545), // Rule ID 18329 //
     /*  83508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83530 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83537 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83543 */     GIR_RootConstrainSelectedInstOperands,
     /*  83544 */     // GIR_Coverage, 18329,
     /*  83544 */     GIR_EraseRootFromParent_Done,
     /*  83545 */   // Label 1793: @83545
     /*  83545 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(83583), // Rule ID 18332 //
     /*  83550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83568 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83575 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83581 */     GIR_RootConstrainSelectedInstOperands,
     /*  83582 */     // GIR_Coverage, 18332,
     /*  83582 */     GIR_EraseRootFromParent_Done,
     /*  83583 */   // Label 1794: @83583
     /*  83583 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(83621), // Rule ID 18333 //
     /*  83588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83606 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83613 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83619 */     GIR_RootConstrainSelectedInstOperands,
     /*  83620 */     // GIR_Coverage, 18333,
     /*  83620 */     GIR_EraseRootFromParent_Done,
     /*  83621 */   // Label 1795: @83621
     /*  83621 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(83663), // Rule ID 19821 //
     /*  83626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83648 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  83651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83655 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83661 */     GIR_RootConstrainSelectedInstOperands,
     /*  83662 */     // GIR_Coverage, 19821,
     /*  83662 */     GIR_EraseRootFromParent_Done,
     /*  83663 */   // Label 1796: @83663
     /*  83663 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(83705), // Rule ID 19822 //
     /*  83668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83690 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  83693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83697 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83703 */     GIR_RootConstrainSelectedInstOperands,
     /*  83704 */     // GIR_Coverage, 19822,
     /*  83704 */     GIR_EraseRootFromParent_Done,
     /*  83705 */   // Label 1797: @83705
     /*  83705 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(83743), // Rule ID 19825 //
     /*  83710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83728 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  83731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83735 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83741 */     GIR_RootConstrainSelectedInstOperands,
     /*  83742 */     // GIR_Coverage, 19825,
     /*  83742 */     GIR_EraseRootFromParent_Done,
     /*  83743 */   // Label 1798: @83743
     /*  83743 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(83781), // Rule ID 19826 //
     /*  83748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83766 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  83769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83773 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83779 */     GIR_RootConstrainSelectedInstOperands,
     /*  83780 */     // GIR_Coverage, 19826,
     /*  83780 */     GIR_EraseRootFromParent_Done,
     /*  83781 */   // Label 1799: @83781
     /*  83781 */   GIM_Reject,
     /*  83782 */ // Label 1785: @83782
     /*  83782 */ GIM_Reject,
     /*  83783 */ // Label 1484: @83783
     /*  83783 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(84116),
     /*  83788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83791 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83795 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(83837), // Rule ID 1719 //
     /*  83800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83822 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  83822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83829 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83835 */     GIR_RootConstrainSelectedInstOperands,
     /*  83836 */     // GIR_Coverage, 1719,
     /*  83836 */     GIR_EraseRootFromParent_Done,
     /*  83837 */   // Label 1801: @83837
     /*  83837 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(83875), // Rule ID 1721 //
     /*  83842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83860 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  83860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83867 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83873 */     GIR_RootConstrainSelectedInstOperands,
     /*  83874 */     // GIR_Coverage, 1721,
     /*  83874 */     GIR_EraseRootFromParent_Done,
     /*  83875 */   // Label 1802: @83875
     /*  83875 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(83917), // Rule ID 4477 //
     /*  83880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83902 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  83902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  83905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83909 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83915 */     GIR_RootConstrainSelectedInstOperands,
     /*  83916 */     // GIR_Coverage, 4477,
     /*  83916 */     GIR_EraseRootFromParent_Done,
     /*  83917 */   // Label 1803: @83917
     /*  83917 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(83955), // Rule ID 4507 //
     /*  83922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83940 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  83940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  83943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83947 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83953 */     GIR_RootConstrainSelectedInstOperands,
     /*  83954 */     // GIR_Coverage, 4507,
     /*  83954 */     GIR_EraseRootFromParent_Done,
     /*  83955 */   // Label 1804: @83955
     /*  83955 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(83997), // Rule ID 17924 //
     /*  83960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83982 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  83982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83989 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83995 */     GIR_RootConstrainSelectedInstOperands,
     /*  83996 */     // GIR_Coverage, 17924,
     /*  83996 */     GIR_EraseRootFromParent_Done,
     /*  83997 */   // Label 1805: @83997
     /*  83997 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(84035), // Rule ID 17928 //
     /*  84002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84020 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84027 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84033 */     GIR_RootConstrainSelectedInstOperands,
     /*  84034 */     // GIR_Coverage, 17928,
     /*  84034 */     GIR_EraseRootFromParent_Done,
     /*  84035 */   // Label 1806: @84035
     /*  84035 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(84077), // Rule ID 19836 //
     /*  84040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84062 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84069 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84075 */     GIR_RootConstrainSelectedInstOperands,
     /*  84076 */     // GIR_Coverage, 19836,
     /*  84076 */     GIR_EraseRootFromParent_Done,
     /*  84077 */   // Label 1807: @84077
     /*  84077 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(84115), // Rule ID 19840 //
     /*  84082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84100 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84107 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84113 */     GIR_RootConstrainSelectedInstOperands,
     /*  84114 */     // GIR_Coverage, 19840,
     /*  84114 */     GIR_EraseRootFromParent_Done,
     /*  84115 */   // Label 1808: @84115
     /*  84115 */   GIM_Reject,
     /*  84116 */ // Label 1800: @84116
     /*  84116 */ GIM_Reject,
     /*  84117 */ // Label 1485: @84117
     /*  84117 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(84290),
     /*  84122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84125 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84129 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(84171), // Rule ID 4494 //
     /*  84134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84156 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZmr),
     /*  84159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84163 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84169 */     GIR_RootConstrainSelectedInstOperands,
     /*  84170 */     // GIR_Coverage, 4494,
     /*  84170 */     GIR_EraseRootFromParent_Done,
     /*  84171 */   // Label 1810: @84171
     /*  84171 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(84209), // Rule ID 4518 //
     /*  84176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84194 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZmr),
     /*  84197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84201 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84207 */     GIR_RootConstrainSelectedInstOperands,
     /*  84208 */     // GIR_Coverage, 4518,
     /*  84208 */     GIR_EraseRootFromParent_Done,
     /*  84209 */   // Label 1811: @84209
     /*  84209 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(84251), // Rule ID 4548 //
     /*  84214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84236 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  84239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84243 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84249 */     GIR_RootConstrainSelectedInstOperands,
     /*  84250 */     // GIR_Coverage, 4548,
     /*  84250 */     GIR_EraseRootFromParent_Done,
     /*  84251 */   // Label 1812: @84251
     /*  84251 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(84289), // Rule ID 4590 //
     /*  84256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84274 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  84277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84281 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84287 */     GIR_RootConstrainSelectedInstOperands,
     /*  84288 */     // GIR_Coverage, 4590,
     /*  84288 */     GIR_EraseRootFromParent_Done,
     /*  84289 */   // Label 1813: @84289
     /*  84289 */   GIM_Reject,
     /*  84290 */ // Label 1809: @84290
     /*  84290 */ GIM_Reject,
     /*  84291 */ // Label 1486: @84291
     /*  84291 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(84372),
     /*  84296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  84307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84311 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(84341), // Rule ID 4400 //
     /*  84316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  84319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84326 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk),
     /*  84329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84333 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84339 */     GIR_RootConstrainSelectedInstOperands,
     /*  84340 */     // GIR_Coverage, 4400,
     /*  84340 */     GIR_EraseRootFromParent_Done,
     /*  84341 */   // Label 1815: @84341
     /*  84341 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(84371), // Rule ID 4402 //
     /*  84346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  84349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84356 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk_EVEX addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk_EVEX),
     /*  84359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84363 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84369 */     GIR_RootConstrainSelectedInstOperands,
     /*  84370 */     // GIR_Coverage, 4402,
     /*  84370 */     GIR_EraseRootFromParent_Done,
     /*  84371 */   // Label 1816: @84371
     /*  84371 */   GIM_Reject,
     /*  84372 */ // Label 1814: @84372
     /*  84372 */ GIM_Reject,
     /*  84373 */ // Label 1487: @84373
     /*  84373 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(84626),
     /*  84378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84385 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(84427), // Rule ID 17950 //
     /*  84390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84412 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  84415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84419 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84425 */     GIR_RootConstrainSelectedInstOperands,
     /*  84426 */     // GIR_Coverage, 17950,
     /*  84426 */     GIR_EraseRootFromParent_Done,
     /*  84427 */   // Label 1818: @84427
     /*  84427 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(84465), // Rule ID 17954 //
     /*  84432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84450 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  84453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84457 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84463 */     GIR_RootConstrainSelectedInstOperands,
     /*  84464 */     // GIR_Coverage, 17954,
     /*  84464 */     GIR_EraseRootFromParent_Done,
     /*  84465 */   // Label 1819: @84465
     /*  84465 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(84507), // Rule ID 18330 //
     /*  84470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84492 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  84495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84499 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84505 */     GIR_RootConstrainSelectedInstOperands,
     /*  84506 */     // GIR_Coverage, 18330,
     /*  84506 */     GIR_EraseRootFromParent_Done,
     /*  84507 */   // Label 1820: @84507
     /*  84507 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(84545), // Rule ID 18334 //
     /*  84512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84530 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  84533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84537 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84543 */     GIR_RootConstrainSelectedInstOperands,
     /*  84544 */     // GIR_Coverage, 18334,
     /*  84544 */     GIR_EraseRootFromParent_Done,
     /*  84545 */   // Label 1821: @84545
     /*  84545 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(84587), // Rule ID 19823 //
     /*  84550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84572 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  84575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84579 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84585 */     GIR_RootConstrainSelectedInstOperands,
     /*  84586 */     // GIR_Coverage, 19823,
     /*  84586 */     GIR_EraseRootFromParent_Done,
     /*  84587 */   // Label 1822: @84587
     /*  84587 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(84625), // Rule ID 19827 //
     /*  84592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84610 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  84613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84617 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84623 */     GIR_RootConstrainSelectedInstOperands,
     /*  84624 */     // GIR_Coverage, 19827,
     /*  84624 */     GIR_EraseRootFromParent_Done,
     /*  84625 */   // Label 1823: @84625
     /*  84625 */   GIM_Reject,
     /*  84626 */ // Label 1817: @84626
     /*  84626 */ GIM_Reject,
     /*  84627 */ // Label 1488: @84627
     /*  84627 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(84960),
     /*  84632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84635 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84639 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(84681), // Rule ID 17925 //
     /*  84644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84666 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84673 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84679 */     GIR_RootConstrainSelectedInstOperands,
     /*  84680 */     // GIR_Coverage, 17925,
     /*  84680 */     GIR_EraseRootFromParent_Done,
     /*  84681 */   // Label 1825: @84681
     /*  84681 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(84719), // Rule ID 17929 //
     /*  84686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84704 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84711 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84717 */     GIR_RootConstrainSelectedInstOperands,
     /*  84718 */     // GIR_Coverage, 17929,
     /*  84718 */     GIR_EraseRootFromParent_Done,
     /*  84719 */   // Label 1826: @84719
     /*  84719 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(84761), // Rule ID 17937 //
     /*  84724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84746 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84753 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84759 */     GIR_RootConstrainSelectedInstOperands,
     /*  84760 */     // GIR_Coverage, 17937,
     /*  84760 */     GIR_EraseRootFromParent_Done,
     /*  84761 */   // Label 1827: @84761
     /*  84761 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(84799), // Rule ID 17938 //
     /*  84766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84784 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84787 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84791 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84797 */     GIR_RootConstrainSelectedInstOperands,
     /*  84798 */     // GIR_Coverage, 17938,
     /*  84798 */     GIR_EraseRootFromParent_Done,
     /*  84799 */   // Label 1828: @84799
     /*  84799 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(84841), // Rule ID 19837 //
     /*  84804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84826 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  84826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84833 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84839 */     GIR_RootConstrainSelectedInstOperands,
     /*  84840 */     // GIR_Coverage, 19837,
     /*  84840 */     GIR_EraseRootFromParent_Done,
     /*  84841 */   // Label 1829: @84841
     /*  84841 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(84883), // Rule ID 19838 //
     /*  84846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84868 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  84868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  84871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84875 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84881 */     GIR_RootConstrainSelectedInstOperands,
     /*  84882 */     // GIR_Coverage, 19838,
     /*  84882 */     GIR_EraseRootFromParent_Done,
     /*  84883 */   // Label 1830: @84883
     /*  84883 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(84921), // Rule ID 19841 //
     /*  84888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84906 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  84906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84913 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84919 */     GIR_RootConstrainSelectedInstOperands,
     /*  84920 */     // GIR_Coverage, 19841,
     /*  84920 */     GIR_EraseRootFromParent_Done,
     /*  84921 */   // Label 1831: @84921
     /*  84921 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(84959), // Rule ID 19842 //
     /*  84926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84944 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  84944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  84947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84951 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84957 */     GIR_RootConstrainSelectedInstOperands,
     /*  84958 */     // GIR_Coverage, 19842,
     /*  84958 */     GIR_EraseRootFromParent_Done,
     /*  84959 */   // Label 1832: @84959
     /*  84959 */   GIM_Reject,
     /*  84960 */ // Label 1824: @84960
     /*  84960 */ GIM_Reject,
     /*  84961 */ // Label 1489: @84961
     /*  84961 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(85134),
     /*  84966 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84969 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84973 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(85015), // Rule ID 4476 //
     /*  84978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85000 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85007 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85013 */     GIR_RootConstrainSelectedInstOperands,
     /*  85014 */     // GIR_Coverage, 4476,
     /*  85014 */     GIR_EraseRootFromParent_Done,
     /*  85015 */   // Label 1834: @85015
     /*  85015 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(85053), // Rule ID 4506 //
     /*  85020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85038 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85045 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85051 */     GIR_RootConstrainSelectedInstOperands,
     /*  85052 */     // GIR_Coverage, 4506,
     /*  85052 */     GIR_EraseRootFromParent_Done,
     /*  85053 */   // Label 1835: @85053
     /*  85053 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(85095), // Rule ID 19804 //
     /*  85058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85080 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85083 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85087 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85093 */     GIR_RootConstrainSelectedInstOperands,
     /*  85094 */     // GIR_Coverage, 19804,
     /*  85094 */     GIR_EraseRootFromParent_Done,
     /*  85095 */   // Label 1836: @85095
     /*  85095 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(85133), // Rule ID 19808 //
     /*  85100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85118 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85125 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85131 */     GIR_RootConstrainSelectedInstOperands,
     /*  85132 */     // GIR_Coverage, 19808,
     /*  85132 */     GIR_EraseRootFromParent_Done,
     /*  85133 */   // Label 1837: @85133
     /*  85133 */   GIM_Reject,
     /*  85134 */ // Label 1833: @85134
     /*  85134 */ GIM_Reject,
     /*  85135 */ // Label 1490: @85135
     /*  85135 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(85216),
     /*  85140 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85143 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  85151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85155 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(85185), // Rule ID 4404 //
     /*  85160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85170 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk),
     /*  85173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85177 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85183 */     GIR_RootConstrainSelectedInstOperands,
     /*  85184 */     // GIR_Coverage, 4404,
     /*  85184 */     GIR_EraseRootFromParent_Done,
     /*  85185 */   // Label 1839: @85185
     /*  85185 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(85215), // Rule ID 4408 //
     /*  85190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85200 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk_EVEX addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk_EVEX),
     /*  85203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85207 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85213 */     GIR_RootConstrainSelectedInstOperands,
     /*  85214 */     // GIR_Coverage, 4408,
     /*  85214 */     GIR_EraseRootFromParent_Done,
     /*  85215 */   // Label 1840: @85215
     /*  85215 */   GIM_Reject,
     /*  85216 */ // Label 1838: @85216
     /*  85216 */ GIM_Reject,
     /*  85217 */ // Label 1491: @85217
     /*  85217 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(85390),
     /*  85222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85225 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85229 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(85271), // Rule ID 17926 //
     /*  85234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85256 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  85259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85263 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85269 */     GIR_RootConstrainSelectedInstOperands,
     /*  85270 */     // GIR_Coverage, 17926,
     /*  85270 */     GIR_EraseRootFromParent_Done,
     /*  85271 */   // Label 1842: @85271
     /*  85271 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(85309), // Rule ID 17930 //
     /*  85276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85294 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  85297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85301 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85307 */     GIR_RootConstrainSelectedInstOperands,
     /*  85308 */     // GIR_Coverage, 17930,
     /*  85308 */     GIR_EraseRootFromParent_Done,
     /*  85309 */   // Label 1843: @85309
     /*  85309 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(85351), // Rule ID 19839 //
     /*  85314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85336 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85343 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85349 */     GIR_RootConstrainSelectedInstOperands,
     /*  85350 */     // GIR_Coverage, 19839,
     /*  85350 */     GIR_EraseRootFromParent_Done,
     /*  85351 */   // Label 1844: @85351
     /*  85351 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(85389), // Rule ID 19843 //
     /*  85356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85374 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85381 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85387 */     GIR_RootConstrainSelectedInstOperands,
     /*  85388 */     // GIR_Coverage, 19843,
     /*  85388 */     GIR_EraseRootFromParent_Done,
     /*  85389 */   // Label 1845: @85389
     /*  85389 */   GIM_Reject,
     /*  85390 */ // Label 1841: @85390
     /*  85390 */ GIM_Reject,
     /*  85391 */ // Label 1492: @85391
     /*  85391 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(85564),
     /*  85396 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85399 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85403 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(85445), // Rule ID 19805 //
     /*  85408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85430 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85437 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85443 */     GIR_RootConstrainSelectedInstOperands,
     /*  85444 */     // GIR_Coverage, 19805,
     /*  85444 */     GIR_EraseRootFromParent_Done,
     /*  85445 */   // Label 1847: @85445
     /*  85445 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(85487), // Rule ID 19806 //
     /*  85450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85472 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85479 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85485 */     GIR_RootConstrainSelectedInstOperands,
     /*  85486 */     // GIR_Coverage, 19806,
     /*  85486 */     GIR_EraseRootFromParent_Done,
     /*  85487 */   // Label 1848: @85487
     /*  85487 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(85525), // Rule ID 19809 //
     /*  85492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85510 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85517 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85523 */     GIR_RootConstrainSelectedInstOperands,
     /*  85524 */     // GIR_Coverage, 19809,
     /*  85524 */     GIR_EraseRootFromParent_Done,
     /*  85525 */   // Label 1849: @85525
     /*  85525 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(85563), // Rule ID 19810 //
     /*  85530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85548 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85555 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85561 */     GIR_RootConstrainSelectedInstOperands,
     /*  85562 */     // GIR_Coverage, 19810,
     /*  85562 */     GIR_EraseRootFromParent_Done,
     /*  85563 */   // Label 1850: @85563
     /*  85563 */   GIM_Reject,
     /*  85564 */ // Label 1846: @85564
     /*  85564 */ GIM_Reject,
     /*  85565 */ // Label 1493: @85565
     /*  85565 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(85646),
     /*  85570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  85581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85585 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(85615), // Rule ID 4406 //
     /*  85590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85600 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk),
     /*  85603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85607 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85613 */     GIR_RootConstrainSelectedInstOperands,
     /*  85614 */     // GIR_Coverage, 4406,
     /*  85614 */     GIR_EraseRootFromParent_Done,
     /*  85615 */   // Label 1852: @85615
     /*  85615 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(85645), // Rule ID 4410 //
     /*  85620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85630 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk_EVEX addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk_EVEX),
     /*  85633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85637 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85643 */     GIR_RootConstrainSelectedInstOperands,
     /*  85644 */     // GIR_Coverage, 4410,
     /*  85644 */     GIR_EraseRootFromParent_Done,
     /*  85645 */   // Label 1853: @85645
     /*  85645 */   GIM_Reject,
     /*  85646 */ // Label 1851: @85646
     /*  85646 */ GIM_Reject,
     /*  85647 */ // Label 1494: @85647
     /*  85647 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(85740),
     /*  85652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85655 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85659 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(85701), // Rule ID 19807 //
     /*  85664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85686 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85693 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85699 */     GIR_RootConstrainSelectedInstOperands,
     /*  85700 */     // GIR_Coverage, 19807,
     /*  85700 */     GIR_EraseRootFromParent_Done,
     /*  85701 */   // Label 1855: @85701
     /*  85701 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(85739), // Rule ID 19811 //
     /*  85706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85724 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85731 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85737 */     GIR_RootConstrainSelectedInstOperands,
     /*  85738 */     // GIR_Coverage, 19811,
     /*  85738 */     GIR_EraseRootFromParent_Done,
     /*  85739 */   // Label 1856: @85739
     /*  85739 */   GIM_Reject,
     /*  85740 */ // Label 1854: @85740
     /*  85740 */ GIM_Reject,
     /*  85741 */ // Label 1495: @85741
     /*  85741 */ GIM_Reject,
     /*  85742 */ // Label 14: @85742
     /*  85742 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1861*/ GIMT_Encode4(85977),
     /*  85753 */ /*GILLT_s8*//*Label 1857*/ GIMT_Encode4(85769),
     /*  85757 */ /*GILLT_s16*//*Label 1858*/ GIMT_Encode4(85821),
     /*  85761 */ /*GILLT_s32*//*Label 1859*/ GIMT_Encode4(85873),
     /*  85765 */ /*GILLT_s64*//*Label 1860*/ GIMT_Encode4(85925),
     /*  85769 */ // Label 1857: @85769
     /*  85769 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(85820), // Rule ID 45 //
     /*  85774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  85777 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85803 */   // (atomic_swap:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_swap_i8>>  =>  (XCHG8rm:{ *:[i8] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG8rm),
     /*  85806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85808 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85810 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85814 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85818 */   GIR_RootConstrainSelectedInstOperands,
     /*  85819 */   // GIR_Coverage, 45,
     /*  85819 */   GIR_EraseRootFromParent_Done,
     /*  85820 */ // Label 1862: @85820
     /*  85820 */ GIM_Reject,
     /*  85821 */ // Label 1858: @85821
     /*  85821 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(85872), // Rule ID 46 //
     /*  85826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  85829 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  85836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85855 */   // (atomic_swap:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_swap_i16>>  =>  (XCHG16rm:{ *:[i16] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG16rm),
     /*  85858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85860 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85862 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85866 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85870 */   GIR_RootConstrainSelectedInstOperands,
     /*  85871 */   // GIR_Coverage, 46,
     /*  85871 */   GIR_EraseRootFromParent_Done,
     /*  85872 */ // Label 1863: @85872
     /*  85872 */ GIM_Reject,
     /*  85873 */ // Label 1859: @85873
     /*  85873 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(85924), // Rule ID 47 //
     /*  85878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85881 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  85888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85900 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85907 */   // (atomic_swap:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>>  =>  (XCHG32rm:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG32rm),
     /*  85910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85912 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85914 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85922 */   GIR_RootConstrainSelectedInstOperands,
     /*  85923 */   // GIR_Coverage, 47,
     /*  85923 */   GIR_EraseRootFromParent_Done,
     /*  85924 */ // Label 1864: @85924
     /*  85924 */ GIM_Reject,
     /*  85925 */ // Label 1860: @85925
     /*  85925 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(85976), // Rule ID 48 //
     /*  85930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  85933 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  85940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85959 */   // (atomic_swap:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>>  =>  (XCHG64rm:{ *:[i64] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG64rm),
     /*  85962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85964 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85966 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85974 */   GIR_RootConstrainSelectedInstOperands,
     /*  85975 */   // GIR_Coverage, 48,
     /*  85975 */   GIR_EraseRootFromParent_Done,
     /*  85976 */ // Label 1865: @85976
     /*  85976 */ GIM_Reject,
     /*  85977 */ // Label 1861: @85977
     /*  85977 */ GIM_Reject,
     /*  85978 */ // Label 15: @85978
     /*  85978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1870*/ GIMT_Encode4(86225),
     /*  85989 */ /*GILLT_s8*//*Label 1866*/ GIMT_Encode4(86005),
     /*  85993 */ /*GILLT_s16*//*Label 1867*/ GIMT_Encode4(86060),
     /*  85997 */ /*GILLT_s32*//*Label 1868*/ GIMT_Encode4(86115),
     /*  86001 */ /*GILLT_s64*//*Label 1869*/ GIMT_Encode4(86170),
     /*  86005 */ // Label 1866: @86005
     /*  86005 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(86059), // Rule ID 17298 //
     /*  86010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  86013 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86024 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86039 */   // (atomic_load_add:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_load_add_i8>>  =>  (LXADD8:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD8),
     /*  86042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86044 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86046 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86050 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86053 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86057 */   GIR_RootConstrainSelectedInstOperands,
     /*  86058 */   // GIR_Coverage, 17298,
     /*  86058 */   GIR_EraseRootFromParent_Done,
     /*  86059 */ // Label 1871: @86059
     /*  86059 */ GIM_Reject,
     /*  86060 */ // Label 1867: @86060
     /*  86060 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(86114), // Rule ID 17299 //
     /*  86065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86068 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86094 */   // (atomic_load_add:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_load_add_i16>>  =>  (LXADD16:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD16),
     /*  86097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86099 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86101 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86105 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86112 */   GIR_RootConstrainSelectedInstOperands,
     /*  86113 */   // GIR_Coverage, 17299,
     /*  86113 */   GIR_EraseRootFromParent_Done,
     /*  86114 */ // Label 1872: @86114
     /*  86114 */ GIM_Reject,
     /*  86115 */ // Label 1868: @86115
     /*  86115 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(86169), // Rule ID 17300 //
     /*  86120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86123 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86142 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86149 */   // (atomic_load_add:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>>  =>  (LXADD32:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD32),
     /*  86152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86154 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86156 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86160 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86163 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86167 */   GIR_RootConstrainSelectedInstOperands,
     /*  86168 */   // GIR_Coverage, 17300,
     /*  86168 */   GIR_EraseRootFromParent_Done,
     /*  86169 */ // Label 1873: @86169
     /*  86169 */ GIM_Reject,
     /*  86170 */ // Label 1869: @86170
     /*  86170 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(86224), // Rule ID 17301 //
     /*  86175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86178 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86189 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86204 */   // (atomic_load_add:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>>  =>  (LXADD64:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD64),
     /*  86207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86209 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86211 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86215 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86222 */   GIR_RootConstrainSelectedInstOperands,
     /*  86223 */   // GIR_Coverage, 17301,
     /*  86223 */   GIR_EraseRootFromParent_Done,
     /*  86224 */ // Label 1874: @86224
     /*  86224 */ GIM_Reject,
     /*  86225 */ // Label 1870: @86225
     /*  86225 */ GIM_Reject,
     /*  86226 */ // Label 16: @86226
     /*  86226 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(86381),
     /*  86231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86234 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(86284), // Rule ID 156 //
     /*  86239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86271 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT0 addr:{ *:[iPTR] }:$src)
     /*  86271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT0),
     /*  86274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86282 */     GIR_RootConstrainSelectedInstOperands,
     /*  86283 */     // GIR_Coverage, 156,
     /*  86283 */     GIR_EraseRootFromParent_Done,
     /*  86284 */   // Label 1876: @86284
     /*  86284 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(86334), // Rule ID 157 //
     /*  86289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86321 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT1 addr:{ *:[iPTR] }:$src)
     /*  86321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT1),
     /*  86324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86332 */     GIR_RootConstrainSelectedInstOperands,
     /*  86333 */     // GIR_Coverage, 157,
     /*  86333 */     GIR_EraseRootFromParent_Done,
     /*  86334 */   // Label 1877: @86334
     /*  86334 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(86380), // Rule ID 16983 //
     /*  86339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrefetchW),
     /*  86342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /*  86353 */     // MIs[0] Operand 2
     /*  86353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  86356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86367 */     // (prefetch addr:{ *:[iPTR] }:$addr, 1:{ *:[i32] }, (timm:{ *:[i32] })<<P:Predicate_PrefetchWLevel>>, 1:{ *:[i32] })  =>  (PREFETCHW addr:{ *:[iPTR] }:$addr)
     /*  86367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHW),
     /*  86370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // addr
     /*  86374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86378 */     GIR_RootConstrainSelectedInstOperands,
     /*  86379 */     // GIR_Coverage, 16983,
     /*  86379 */     GIR_EraseRootFromParent_Done,
     /*  86380 */   // Label 1878: @86380
     /*  86380 */   GIM_Reject,
     /*  86381 */ // Label 1875: @86381
     /*  86381 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(86544),
     /*  86386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86396 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  86399 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(86435), // Rule ID 2505 //
     /*  86404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86422 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT0 addr:{ *:[iPTR] }:$src)
     /*  86422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT0),
     /*  86425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86433 */     GIR_RootConstrainSelectedInstOperands,
     /*  86434 */     // GIR_Coverage, 2505,
     /*  86434 */     GIR_EraseRootFromParent_Done,
     /*  86435 */   // Label 1880: @86435
     /*  86435 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(86471), // Rule ID 2506 //
     /*  86440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86458 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT1 addr:{ *:[iPTR] }:$src)
     /*  86458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT1),
     /*  86461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86469 */     GIR_RootConstrainSelectedInstOperands,
     /*  86470 */     // GIR_Coverage, 2506,
     /*  86470 */     GIR_EraseRootFromParent_Done,
     /*  86471 */   // Label 1881: @86471
     /*  86471 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(86507), // Rule ID 2507 //
     /*  86476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  86483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86494 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT2 addr:{ *:[iPTR] }:$src)
     /*  86494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT2),
     /*  86497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86505 */     GIR_RootConstrainSelectedInstOperands,
     /*  86506 */     // GIR_Coverage, 2507,
     /*  86506 */     GIR_EraseRootFromParent_Done,
     /*  86507 */   // Label 1882: @86507
     /*  86507 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(86543), // Rule ID 2508 //
     /*  86512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  86519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86530 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHNTA addr:{ *:[iPTR] }:$src)
     /*  86530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHNTA),
     /*  86533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86541 */     GIR_RootConstrainSelectedInstOperands,
     /*  86542 */     // GIR_Coverage, 2508,
     /*  86542 */     GIR_EraseRootFromParent_Done,
     /*  86543 */   // Label 1883: @86543
     /*  86543 */   GIM_Reject,
     /*  86544 */ // Label 1879: @86544
     /*  86544 */ GIM_Reject,
     /*  86545 */ // Label 17: @86545
     /*  86545 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(88874),
     /*  86550 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  86553 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(86620), // Rule ID 1530 //
     /*  86558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  86566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86604 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14985:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrm),
     /*  86607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86618 */     GIR_RootConstrainSelectedInstOperands,
     /*  86619 */     // GIR_Coverage, 1530,
     /*  86619 */     GIR_EraseRootFromParent_Done,
     /*  86620 */   // Label 1885: @86620
     /*  86620 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(86687), // Rule ID 1532 //
     /*  86625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  86633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86671 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14984:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrm),
     /*  86674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86685 */     GIR_RootConstrainSelectedInstOperands,
     /*  86686 */     // GIR_Coverage, 1532,
     /*  86686 */     GIR_EraseRootFromParent_Done,
     /*  86687 */   // Label 1886: @86687
     /*  86687 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(86754), // Rule ID 1534 //
     /*  86692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  86700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86738 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14983:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrm),
     /*  86741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86752 */     GIR_RootConstrainSelectedInstOperands,
     /*  86753 */     // GIR_Coverage, 1534,
     /*  86753 */     GIR_EraseRootFromParent_Done,
     /*  86754 */   // Label 1887: @86754
     /*  86754 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(86821), // Rule ID 1536 //
     /*  86759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  86767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86805 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14982:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrm),
     /*  86808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86819 */     GIR_RootConstrainSelectedInstOperands,
     /*  86820 */     // GIR_Coverage, 1536,
     /*  86820 */     GIR_EraseRootFromParent_Done,
     /*  86821 */   // Label 1888: @86821
     /*  86821 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(86888), // Rule ID 1538 //
     /*  86826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  86834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86872 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14981:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrm),
     /*  86875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86886 */     GIR_RootConstrainSelectedInstOperands,
     /*  86887 */     // GIR_Coverage, 1538,
     /*  86887 */     GIR_EraseRootFromParent_Done,
     /*  86888 */   // Label 1889: @86888
     /*  86888 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(86955), // Rule ID 1540 //
     /*  86893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  86901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86919 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86922 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86926 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86939 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14980:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrm),
     /*  86942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86953 */     GIR_RootConstrainSelectedInstOperands,
     /*  86954 */     // GIR_Coverage, 1540,
     /*  86954 */     GIR_EraseRootFromParent_Done,
     /*  86955 */   // Label 1890: @86955
     /*  86955 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(87022), // Rule ID 1542 //
     /*  86960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  86968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87006 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14979:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrm),
     /*  87009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87020 */     GIR_RootConstrainSelectedInstOperands,
     /*  87021 */     // GIR_Coverage, 1542,
     /*  87021 */     GIR_EraseRootFromParent_Done,
     /*  87022 */   // Label 1891: @87022
     /*  87022 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(87089), // Rule ID 1544 //
     /*  87027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  87035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87073 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14978:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrm),
     /*  87076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87087 */     GIR_RootConstrainSelectedInstOperands,
     /*  87088 */     // GIR_Coverage, 1544,
     /*  87088 */     GIR_EraseRootFromParent_Done,
     /*  87089 */   // Label 1892: @87089
     /*  87089 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(87156), // Rule ID 1546 //
     /*  87094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  87102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87140 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14977:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrm),
     /*  87143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87145 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87154 */     GIR_RootConstrainSelectedInstOperands,
     /*  87155 */     // GIR_Coverage, 1546,
     /*  87155 */     GIR_EraseRootFromParent_Done,
     /*  87156 */   // Label 1893: @87156
     /*  87156 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(87223), // Rule ID 1548 //
     /*  87161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  87169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87207 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14976:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrm),
     /*  87210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87221 */     GIR_RootConstrainSelectedInstOperands,
     /*  87222 */     // GIR_Coverage, 1548,
     /*  87222 */     GIR_EraseRootFromParent_Done,
     /*  87223 */   // Label 1894: @87223
     /*  87223 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(87290), // Rule ID 1550 //
     /*  87228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  87236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87254 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87257 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87261 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87274 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14975:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrm),
     /*  87277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87288 */     GIR_RootConstrainSelectedInstOperands,
     /*  87289 */     // GIR_Coverage, 1550,
     /*  87289 */     GIR_EraseRootFromParent_Done,
     /*  87290 */   // Label 1895: @87290
     /*  87290 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(87357), // Rule ID 1552 //
     /*  87295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  87303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87324 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87328 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87341 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14974:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrm),
     /*  87344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87355 */     GIR_RootConstrainSelectedInstOperands,
     /*  87356 */     // GIR_Coverage, 1552,
     /*  87356 */     GIR_EraseRootFromParent_Done,
     /*  87357 */   // Label 1896: @87357
     /*  87357 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(87424), // Rule ID 1554 //
     /*  87362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  87370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87408 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14973:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrm),
     /*  87411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87422 */     GIR_RootConstrainSelectedInstOperands,
     /*  87423 */     // GIR_Coverage, 1554,
     /*  87423 */     GIR_EraseRootFromParent_Done,
     /*  87424 */   // Label 1897: @87424
     /*  87424 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(87491), // Rule ID 1556 //
     /*  87429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  87437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87462 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87475 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14972:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrm),
     /*  87478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87489 */     GIR_RootConstrainSelectedInstOperands,
     /*  87490 */     // GIR_Coverage, 1556,
     /*  87490 */     GIR_EraseRootFromParent_Done,
     /*  87491 */   // Label 1898: @87491
     /*  87491 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(87558), // Rule ID 1558 //
     /*  87496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  87504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87542 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14971:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrm),
     /*  87545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87556 */     GIR_RootConstrainSelectedInstOperands,
     /*  87557 */     // GIR_Coverage, 1558,
     /*  87557 */     GIR_EraseRootFromParent_Done,
     /*  87558 */   // Label 1899: @87558
     /*  87558 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(87625), // Rule ID 1564 //
     /*  87563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  87571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87596 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87609 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14963:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  87609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrm),
     /*  87612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87623 */     GIR_RootConstrainSelectedInstOperands,
     /*  87624 */     // GIR_Coverage, 1564,
     /*  87624 */     GIR_EraseRootFromParent_Done,
     /*  87625 */   // Label 1900: @87625
     /*  87625 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(87692), // Rule ID 1566 //
     /*  87630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  87638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  87641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  87644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87676 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14964:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  87676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrm),
     /*  87679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87690 */     GIR_RootConstrainSelectedInstOperands,
     /*  87691 */     // GIR_Coverage, 1566,
     /*  87691 */     GIR_EraseRootFromParent_Done,
     /*  87692 */   // Label 1901: @87692
     /*  87692 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(87759), // Rule ID 1572 //
     /*  87697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  87705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87743 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14961:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  87743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrm),
     /*  87746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87757 */     GIR_RootConstrainSelectedInstOperands,
     /*  87758 */     // GIR_Coverage, 1572,
     /*  87758 */     GIR_EraseRootFromParent_Done,
     /*  87759 */   // Label 1902: @87759
     /*  87759 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(87826), // Rule ID 1574 //
     /*  87764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  87772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  87775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  87778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87810 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14962:{ *:[iPTR] }, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  87810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrm),
     /*  87813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87824 */     GIR_RootConstrainSelectedInstOperands,
     /*  87825 */     // GIR_Coverage, 1574,
     /*  87825 */     GIR_EraseRootFromParent_Done,
     /*  87826 */   // Label 1903: @87826
     /*  87826 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(87893), // Rule ID 3364 //
     /*  87831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  87834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  87839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87877 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13336:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESIMCrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /*  87877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrm),
     /*  87880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  87886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87891 */     GIR_RootConstrainSelectedInstOperands,
     /*  87892 */     // GIR_Coverage, 3364,
     /*  87892 */     GIR_EraseRootFromParent_Done,
     /*  87893 */   // Label 1904: @87893
     /*  87893 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(87929), // Rule ID 1529 //
     /*  87898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  87906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14985:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  87920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /*  87923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87927 */     GIR_RootConstrainSelectedInstOperands,
     /*  87928 */     // GIR_Coverage, 1529,
     /*  87928 */     GIR_EraseRootFromParent_Done,
     /*  87929 */   // Label 1905: @87929
     /*  87929 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(87965), // Rule ID 1531 //
     /*  87934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  87942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87956 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14984:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  87956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /*  87959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87963 */     GIR_RootConstrainSelectedInstOperands,
     /*  87964 */     // GIR_Coverage, 1531,
     /*  87964 */     GIR_EraseRootFromParent_Done,
     /*  87965 */   // Label 1906: @87965
     /*  87965 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(88001), // Rule ID 1533 //
     /*  87970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  87978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87992 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14983:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  87992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /*  87995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87999 */     GIR_RootConstrainSelectedInstOperands,
     /*  88000 */     // GIR_Coverage, 1533,
     /*  88000 */     GIR_EraseRootFromParent_Done,
     /*  88001 */   // Label 1907: @88001
     /*  88001 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(88037), // Rule ID 1535 //
     /*  88006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  88014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88028 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14982:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /*  88031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88035 */     GIR_RootConstrainSelectedInstOperands,
     /*  88036 */     // GIR_Coverage, 1535,
     /*  88036 */     GIR_EraseRootFromParent_Done,
     /*  88037 */   // Label 1908: @88037
     /*  88037 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(88073), // Rule ID 1537 //
     /*  88042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  88050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88064 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14981:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /*  88067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88071 */     GIR_RootConstrainSelectedInstOperands,
     /*  88072 */     // GIR_Coverage, 1537,
     /*  88072 */     GIR_EraseRootFromParent_Done,
     /*  88073 */   // Label 1909: @88073
     /*  88073 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(88109), // Rule ID 1539 //
     /*  88078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  88086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88100 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14980:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /*  88103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88107 */     GIR_RootConstrainSelectedInstOperands,
     /*  88108 */     // GIR_Coverage, 1539,
     /*  88108 */     GIR_EraseRootFromParent_Done,
     /*  88109 */   // Label 1910: @88109
     /*  88109 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(88145), // Rule ID 1541 //
     /*  88114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  88122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88136 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14979:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /*  88139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88141 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88143 */     GIR_RootConstrainSelectedInstOperands,
     /*  88144 */     // GIR_Coverage, 1541,
     /*  88144 */     GIR_EraseRootFromParent_Done,
     /*  88145 */   // Label 1911: @88145
     /*  88145 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(88181), // Rule ID 1543 //
     /*  88150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  88158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88172 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14978:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /*  88175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88177 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88179 */     GIR_RootConstrainSelectedInstOperands,
     /*  88180 */     // GIR_Coverage, 1543,
     /*  88180 */     GIR_EraseRootFromParent_Done,
     /*  88181 */   // Label 1912: @88181
     /*  88181 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(88217), // Rule ID 1545 //
     /*  88186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  88194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88208 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14977:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /*  88211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88215 */     GIR_RootConstrainSelectedInstOperands,
     /*  88216 */     // GIR_Coverage, 1545,
     /*  88216 */     GIR_EraseRootFromParent_Done,
     /*  88217 */   // Label 1913: @88217
     /*  88217 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(88253), // Rule ID 1547 //
     /*  88222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  88230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88244 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14976:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /*  88247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88249 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88251 */     GIR_RootConstrainSelectedInstOperands,
     /*  88252 */     // GIR_Coverage, 1547,
     /*  88252 */     GIR_EraseRootFromParent_Done,
     /*  88253 */   // Label 1914: @88253
     /*  88253 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(88289), // Rule ID 1549 //
     /*  88258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  88266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88280 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14975:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /*  88283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88287 */     GIR_RootConstrainSelectedInstOperands,
     /*  88288 */     // GIR_Coverage, 1549,
     /*  88288 */     GIR_EraseRootFromParent_Done,
     /*  88289 */   // Label 1915: @88289
     /*  88289 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(88325), // Rule ID 1551 //
     /*  88294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  88302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88316 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14974:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /*  88319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88323 */     GIR_RootConstrainSelectedInstOperands,
     /*  88324 */     // GIR_Coverage, 1551,
     /*  88324 */     GIR_EraseRootFromParent_Done,
     /*  88325 */   // Label 1916: @88325
     /*  88325 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(88361), // Rule ID 1553 //
     /*  88330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  88338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88352 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14973:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /*  88355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88359 */     GIR_RootConstrainSelectedInstOperands,
     /*  88360 */     // GIR_Coverage, 1553,
     /*  88360 */     GIR_EraseRootFromParent_Done,
     /*  88361 */   // Label 1917: @88361
     /*  88361 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(88397), // Rule ID 1555 //
     /*  88366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  88374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88388 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14972:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /*  88391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88393 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88395 */     GIR_RootConstrainSelectedInstOperands,
     /*  88396 */     // GIR_Coverage, 1555,
     /*  88396 */     GIR_EraseRootFromParent_Done,
     /*  88397 */   // Label 1918: @88397
     /*  88397 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(88433), // Rule ID 1557 //
     /*  88402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  88410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14971:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /*  88427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88431 */     GIR_RootConstrainSelectedInstOperands,
     /*  88432 */     // GIR_Coverage, 1557,
     /*  88432 */     GIR_EraseRootFromParent_Done,
     /*  88433 */   // Label 1919: @88433
     /*  88433 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(88469), // Rule ID 1559 //
     /*  88438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /*  88446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88460 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14966:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /*  88463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88465 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88467 */     GIR_RootConstrainSelectedInstOperands,
     /*  88468 */     // GIR_Coverage, 1559,
     /*  88468 */     GIR_EraseRootFromParent_Done,
     /*  88469 */   // Label 1920: @88469
     /*  88469 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(88505), // Rule ID 1563 //
     /*  88474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  88482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88496 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14963:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /*  88499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88501 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88503 */     GIR_RootConstrainSelectedInstOperands,
     /*  88504 */     // GIR_Coverage, 1563,
     /*  88504 */     GIR_EraseRootFromParent_Done,
     /*  88505 */   // Label 1921: @88505
     /*  88505 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(88541), // Rule ID 1565 //
     /*  88510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  88518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88532 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14964:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /*  88532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /*  88535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88539 */     GIR_RootConstrainSelectedInstOperands,
     /*  88540 */     // GIR_Coverage, 1565,
     /*  88540 */     GIR_EraseRootFromParent_Done,
     /*  88541 */   // Label 1922: @88541
     /*  88541 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(88577), // Rule ID 1567 //
     /*  88546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /*  88554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88568 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14965:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /*  88571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88575 */     GIR_RootConstrainSelectedInstOperands,
     /*  88576 */     // GIR_Coverage, 1567,
     /*  88576 */     GIR_EraseRootFromParent_Done,
     /*  88577 */   // Label 1923: @88577
     /*  88577 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(88613), // Rule ID 1571 //
     /*  88582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  88590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88604 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14961:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /*  88607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88611 */     GIR_RootConstrainSelectedInstOperands,
     /*  88612 */     // GIR_Coverage, 1571,
     /*  88612 */     GIR_EraseRootFromParent_Done,
     /*  88613 */   // Label 1924: @88613
     /*  88613 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(88649), // Rule ID 1573 //
     /*  88618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  88626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  88629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  88632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88640 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14962:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /*  88640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /*  88643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88647 */     GIR_RootConstrainSelectedInstOperands,
     /*  88648 */     // GIR_Coverage, 1573,
     /*  88648 */     GIR_EraseRootFromParent_Done,
     /*  88649 */   // Label 1925: @88649
     /*  88649 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(88685), // Rule ID 3363 //
     /*  88654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88676 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13336:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /*  88679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88683 */     GIR_RootConstrainSelectedInstOperands,
     /*  88684 */     // GIR_Coverage, 3363,
     /*  88684 */     GIR_EraseRootFromParent_Done,
     /*  88685 */   // Label 1926: @88685
     /*  88685 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(88721), // Rule ID 3365 //
     /*  88690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  88693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88712 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13336:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /*  88715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88717 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88719 */     GIR_RootConstrainSelectedInstOperands,
     /*  88720 */     // GIR_Coverage, 3365,
     /*  88720 */     GIR_EraseRootFromParent_Done,
     /*  88721 */   // Label 1927: @88721
     /*  88721 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(88759), // Rule ID 18266 //
     /*  88726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88748 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14671:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /*  88751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88755 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88757 */     GIR_RootConstrainSelectedInstOperands,
     /*  88758 */     // GIR_Coverage, 18266,
     /*  88758 */     GIR_EraseRootFromParent_Done,
     /*  88759 */   // Label 1928: @88759
     /*  88759 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(88797), // Rule ID 18270 //
     /*  88764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88786 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14671:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /*  88789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88793 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88795 */     GIR_RootConstrainSelectedInstOperands,
     /*  88796 */     // GIR_Coverage, 18270,
     /*  88796 */     GIR_EraseRootFromParent_Done,
     /*  88797 */   // Label 1929: @88797
     /*  88797 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(88835), // Rule ID 18286 //
     /*  88802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  88810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88824 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14669:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /*  88827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88831 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88833 */     GIR_RootConstrainSelectedInstOperands,
     /*  88834 */     // GIR_Coverage, 18286,
     /*  88834 */     GIR_EraseRootFromParent_Done,
     /*  88835 */   // Label 1930: @88835
     /*  88835 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(88873), // Rule ID 18290 //
     /*  88840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  88848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88862 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14669:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /*  88865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88867 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88871 */     GIR_RootConstrainSelectedInstOperands,
     /*  88872 */     // GIR_Coverage, 18290,
     /*  88872 */     GIR_EraseRootFromParent_Done,
     /*  88873 */   // Label 1931: @88873
     /*  88873 */   GIM_Reject,
     /*  88874 */ // Label 1884: @88874
     /*  88874 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(95655),
     /*  88879 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  88882 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(88954), // Rule ID 3368 //
     /*  88887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  88895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88924 */     // MIs[0] src2
     /*  88924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  88927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88936 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13337:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  88936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rm),
     /*  88939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  88945 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  88947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88952 */     GIR_RootConstrainSelectedInstOperands,
     /*  88953 */     // GIR_Coverage, 3368,
     /*  88953 */     GIR_EraseRootFromParent_Done,
     /*  88954 */   // Label 1933: @88954
     /*  88954 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(89030), // Rule ID 16790 //
     /*  88959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  88962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  88967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88992 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14940:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rm),
     /*  89015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89019 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89028 */     GIR_RootConstrainSelectedInstOperands,
     /*  89029 */     // GIR_Coverage, 16790,
     /*  89029 */     GIR_EraseRootFromParent_Done,
     /*  89030 */   // Label 1934: @89030
     /*  89030 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(89106), // Rule ID 16792 //
     /*  89035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  89043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89068 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89075 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89088 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14941:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rm),
     /*  89091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89104 */     GIR_RootConstrainSelectedInstOperands,
     /*  89105 */     // GIR_Coverage, 16792,
     /*  89105 */     GIR_EraseRootFromParent_Done,
     /*  89106 */   // Label 1935: @89106
     /*  89106 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(89182), // Rule ID 16796 //
     /*  89111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  89119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14943:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rm),
     /*  89167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89180 */     GIR_RootConstrainSelectedInstOperands,
     /*  89181 */     // GIR_Coverage, 16796,
     /*  89181 */     GIR_EraseRootFromParent_Done,
     /*  89182 */   // Label 1936: @89182
     /*  89182 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(89258), // Rule ID 16798 //
     /*  89187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  89195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89220 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89223 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89227 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89240 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14944:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rm),
     /*  89243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89256 */     GIR_RootConstrainSelectedInstOperands,
     /*  89257 */     // GIR_Coverage, 16798,
     /*  89257 */     GIR_EraseRootFromParent_Done,
     /*  89258 */   // Label 1937: @89258
     /*  89258 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(89334), // Rule ID 3023 //
     /*  89263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  89271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89316 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14809:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrm),
     /*  89319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89332 */     GIR_RootConstrainSelectedInstOperands,
     /*  89333 */     // GIR_Coverage, 3023,
     /*  89333 */     GIR_EraseRootFromParent_Done,
     /*  89334 */   // Label 1938: @89334
     /*  89334 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(89410), // Rule ID 3025 //
     /*  89339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  89347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89392 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14813:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrm),
     /*  89395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89408 */     GIR_RootConstrainSelectedInstOperands,
     /*  89409 */     // GIR_Coverage, 3025,
     /*  89409 */     GIR_EraseRootFromParent_Done,
     /*  89410 */   // Label 1939: @89410
     /*  89410 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(89486), // Rule ID 3027 //
     /*  89415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  89423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89468 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14811:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrm),
     /*  89471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89484 */     GIR_RootConstrainSelectedInstOperands,
     /*  89485 */     // GIR_Coverage, 3027,
     /*  89485 */     GIR_EraseRootFromParent_Done,
     /*  89486 */   // Label 1940: @89486
     /*  89486 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(89562), // Rule ID 3029 //
     /*  89491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  89499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89544 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14793:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrm),
     /*  89547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89549 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89560 */     GIR_RootConstrainSelectedInstOperands,
     /*  89561 */     // GIR_Coverage, 3029,
     /*  89561 */     GIR_EraseRootFromParent_Done,
     /*  89562 */   // Label 1941: @89562
     /*  89562 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(89638), // Rule ID 3031 //
     /*  89567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  89575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89620 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14799:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrm),
     /*  89623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89636 */     GIR_RootConstrainSelectedInstOperands,
     /*  89637 */     // GIR_Coverage, 3031,
     /*  89637 */     GIR_EraseRootFromParent_Done,
     /*  89638 */   // Label 1942: @89638
     /*  89638 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(89714), // Rule ID 3047 //
     /*  89643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  89651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  89654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  89657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  89660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89696 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13700:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrm),
     /*  89699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89712 */     GIR_RootConstrainSelectedInstOperands,
     /*  89713 */     // GIR_Coverage, 3047,
     /*  89713 */     GIR_EraseRootFromParent_Done,
     /*  89714 */   // Label 1943: @89714
     /*  89714 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(89790), // Rule ID 3049 //
     /*  89719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  89727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89772 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13702:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrm),
     /*  89775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89777 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89779 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89788 */     GIR_RootConstrainSelectedInstOperands,
     /*  89789 */     // GIR_Coverage, 3049,
     /*  89789 */     GIR_EraseRootFromParent_Done,
     /*  89790 */   // Label 1944: @89790
     /*  89790 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(89866), // Rule ID 3051 //
     /*  89795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  89803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89848 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13701:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrm),
     /*  89851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89864 */     GIR_RootConstrainSelectedInstOperands,
     /*  89865 */     // GIR_Coverage, 3051,
     /*  89865 */     GIR_EraseRootFromParent_Done,
     /*  89866 */   // Label 1945: @89866
     /*  89866 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(89942), // Rule ID 3053 //
     /*  89871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  89879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89924 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13687:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrm),
     /*  89927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89940 */     GIR_RootConstrainSelectedInstOperands,
     /*  89941 */     // GIR_Coverage, 3053,
     /*  89941 */     GIR_EraseRootFromParent_Done,
     /*  89942 */   // Label 1946: @89942
     /*  89942 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(90018), // Rule ID 3055 //
     /*  89947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  89955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90000 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13690:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrm),
     /*  90003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90016 */     GIR_RootConstrainSelectedInstOperands,
     /*  90017 */     // GIR_Coverage, 3055,
     /*  90017 */     GIR_EraseRootFromParent_Done,
     /*  90018 */   // Label 1947: @90018
     /*  90018 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(90094), // Rule ID 3310 //
     /*  90023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90056 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90063 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90076 */     // (intrinsic_wo_chain:{ *:[i32] } 14767:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8),
     /*  90079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90083 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90092 */     GIR_RootConstrainSelectedInstOperands,
     /*  90093 */     // GIR_Coverage, 3310,
     /*  90093 */     GIR_EraseRootFromParent_Done,
     /*  90094 */   // Label 1948: @90094
     /*  90094 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(90170), // Rule ID 3312 //
     /*  90099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90152 */     // (intrinsic_wo_chain:{ *:[i32] } 14765:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16),
     /*  90155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90168 */     GIR_RootConstrainSelectedInstOperands,
     /*  90169 */     // GIR_Coverage, 3312,
     /*  90169 */     GIR_EraseRootFromParent_Done,
     /*  90170 */   // Label 1949: @90170
     /*  90170 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(90246), // Rule ID 3314 //
     /*  90175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90208 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90211 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90228 */     // (intrinsic_wo_chain:{ *:[i32] } 14766:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32),
     /*  90231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90233 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90235 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90244 */     GIR_RootConstrainSelectedInstOperands,
     /*  90245 */     // GIR_Coverage, 3314,
     /*  90245 */     GIR_EraseRootFromParent_Done,
     /*  90246 */   // Label 1950: @90246
     /*  90246 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(90322), // Rule ID 3316 //
     /*  90251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90304 */     // (intrinsic_wo_chain:{ *:[i64] } 14768:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64),
     /*  90307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90309 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90311 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90320 */     GIR_RootConstrainSelectedInstOperands,
     /*  90321 */     // GIR_Coverage, 3316,
     /*  90321 */     GIR_EraseRootFromParent_Done,
     /*  90322 */   // Label 1951: @90322
     /*  90322 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(90398), // Rule ID 3318 //
     /*  90327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90380 */     // (intrinsic_wo_chain:{ *:[i32] } 14767:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8_EVEX),
     /*  90383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90396 */     GIR_RootConstrainSelectedInstOperands,
     /*  90397 */     // GIR_Coverage, 3318,
     /*  90397 */     GIR_EraseRootFromParent_Done,
     /*  90398 */   // Label 1952: @90398
     /*  90398 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(90474), // Rule ID 3320 //
     /*  90403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90456 */     // (intrinsic_wo_chain:{ *:[i32] } 14765:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16_EVEX),
     /*  90459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90472 */     GIR_RootConstrainSelectedInstOperands,
     /*  90473 */     // GIR_Coverage, 3320,
     /*  90473 */     GIR_EraseRootFromParent_Done,
     /*  90474 */   // Label 1953: @90474
     /*  90474 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(90550), // Rule ID 3322 //
     /*  90479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90532 */     // (intrinsic_wo_chain:{ *:[i32] } 14766:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32_EVEX),
     /*  90535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90548 */     GIR_RootConstrainSelectedInstOperands,
     /*  90549 */     // GIR_Coverage, 3322,
     /*  90549 */     GIR_EraseRootFromParent_Done,
     /*  90550 */   // Label 1954: @90550
     /*  90550 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(90626), // Rule ID 3324 //
     /*  90555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90608 */     // (intrinsic_wo_chain:{ *:[i64] } 14768:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64_EVEX),
     /*  90611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90624 */     GIR_RootConstrainSelectedInstOperands,
     /*  90625 */     // GIR_Coverage, 3324,
     /*  90625 */     GIR_EraseRootFromParent_Done,
     /*  90626 */   // Label 1955: @90626
     /*  90626 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(90702), // Rule ID 3340 //
     /*  90631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  90639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90684 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13330:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrm),
     /*  90687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90689 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90700 */     GIR_RootConstrainSelectedInstOperands,
     /*  90701 */     // GIR_Coverage, 3340,
     /*  90701 */     GIR_EraseRootFromParent_Done,
     /*  90702 */   // Label 1956: @90702
     /*  90702 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(90778), // Rule ID 3342 //
     /*  90707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  90715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90760 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13333:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrm),
     /*  90763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90776 */     GIR_RootConstrainSelectedInstOperands,
     /*  90777 */     // GIR_Coverage, 3342,
     /*  90777 */     GIR_EraseRootFromParent_Done,
     /*  90778 */   // Label 1957: @90778
     /*  90778 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(90854), // Rule ID 3344 //
     /*  90783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  90791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90836 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13324:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrm),
     /*  90839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90852 */     GIR_RootConstrainSelectedInstOperands,
     /*  90853 */     // GIR_Coverage, 3344,
     /*  90853 */     GIR_EraseRootFromParent_Done,
     /*  90854 */   // Label 1958: @90854
     /*  90854 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(90930), // Rule ID 3346 //
     /*  90859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  90867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90899 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90912 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13327:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrm),
     /*  90915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90928 */     GIR_RootConstrainSelectedInstOperands,
     /*  90929 */     // GIR_Coverage, 3346,
     /*  90929 */     GIR_EraseRootFromParent_Done,
     /*  90930 */   // Label 1959: @90930
     /*  90930 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(91006), // Rule ID 3348 //
     /*  90935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  90938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  90943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  90946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  90949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  90952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90968 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90988 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13331:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrm),
     /*  90991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91004 */     GIR_RootConstrainSelectedInstOperands,
     /*  91005 */     // GIR_Coverage, 3348,
     /*  91005 */     GIR_EraseRootFromParent_Done,
     /*  91006 */   // Label 1960: @91006
     /*  91006 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(91082), // Rule ID 3350 //
     /*  91011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91064 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13334:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrm),
     /*  91067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91080 */     GIR_RootConstrainSelectedInstOperands,
     /*  91081 */     // GIR_Coverage, 3350,
     /*  91081 */     GIR_EraseRootFromParent_Done,
     /*  91082 */   // Label 1961: @91082
     /*  91082 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(91158), // Rule ID 3352 //
     /*  91087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  91095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91140 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13325:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrm),
     /*  91143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91156 */     GIR_RootConstrainSelectedInstOperands,
     /*  91157 */     // GIR_Coverage, 3352,
     /*  91157 */     GIR_EraseRootFromParent_Done,
     /*  91158 */   // Label 1962: @91158
     /*  91158 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(91234), // Rule ID 3354 //
     /*  91163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  91171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91216 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13328:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrm),
     /*  91219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91221 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91232 */     GIR_RootConstrainSelectedInstOperands,
     /*  91233 */     // GIR_Coverage, 3354,
     /*  91233 */     GIR_EraseRootFromParent_Done,
     /*  91234 */   // Label 1963: @91234
     /*  91234 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(91310), // Rule ID 3565 //
     /*  91239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  91247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91272 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91275 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91292 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14940:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rm),
     /*  91295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91308 */     GIR_RootConstrainSelectedInstOperands,
     /*  91309 */     // GIR_Coverage, 3565,
     /*  91309 */     GIR_EraseRootFromParent_Done,
     /*  91310 */   // Label 1964: @91310
     /*  91310 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(91386), // Rule ID 3567 //
     /*  91315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  91323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91368 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14941:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrm),
     /*  91371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91373 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91375 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91384 */     GIR_RootConstrainSelectedInstOperands,
     /*  91385 */     // GIR_Coverage, 3567,
     /*  91385 */     GIR_EraseRootFromParent_Done,
     /*  91386 */   // Label 1965: @91386
     /*  91386 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(91462), // Rule ID 3569 //
     /*  91391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  91399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14943:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rm),
     /*  91447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91460 */     GIR_RootConstrainSelectedInstOperands,
     /*  91461 */     // GIR_Coverage, 3569,
     /*  91461 */     GIR_EraseRootFromParent_Done,
     /*  91462 */   // Label 1966: @91462
     /*  91462 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(91538), // Rule ID 3571 //
     /*  91467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  91475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91520 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14944:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrm),
     /*  91523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91525 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91527 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91536 */     GIR_RootConstrainSelectedInstOperands,
     /*  91537 */     // GIR_Coverage, 3571,
     /*  91537 */     GIR_EraseRootFromParent_Done,
     /*  91538 */   // Label 1967: @91538
     /*  91538 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(91614), // Rule ID 14061 //
     /*  91543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  91551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13330:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rm),
     /*  91599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91612 */     GIR_RootConstrainSelectedInstOperands,
     /*  91613 */     // GIR_Coverage, 14061,
     /*  91613 */     GIR_EraseRootFromParent_Done,
     /*  91614 */   // Label 1968: @91614
     /*  91614 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(91690), // Rule ID 14063 //
     /*  91619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91672 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13331:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rm),
     /*  91675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91688 */     GIR_RootConstrainSelectedInstOperands,
     /*  91689 */     // GIR_Coverage, 14063,
     /*  91689 */     GIR_EraseRootFromParent_Done,
     /*  91690 */   // Label 1969: @91690
     /*  91690 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(91766), // Rule ID 14065 //
     /*  91695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  91703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91748 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13332:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrm),
     /*  91751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91764 */     GIR_RootConstrainSelectedInstOperands,
     /*  91765 */     // GIR_Coverage, 14065,
     /*  91765 */     GIR_EraseRootFromParent_Done,
     /*  91766 */   // Label 1970: @91766
     /*  91766 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(91842), // Rule ID 14067 //
     /*  91771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  91779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91824 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13333:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rm),
     /*  91827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91840 */     GIR_RootConstrainSelectedInstOperands,
     /*  91841 */     // GIR_Coverage, 14067,
     /*  91841 */     GIR_EraseRootFromParent_Done,
     /*  91842 */   // Label 1971: @91842
     /*  91842 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(91918), // Rule ID 14069 //
     /*  91847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91900 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13334:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rm),
     /*  91903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91905 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91916 */     GIR_RootConstrainSelectedInstOperands,
     /*  91917 */     // GIR_Coverage, 14069,
     /*  91917 */     GIR_EraseRootFromParent_Done,
     /*  91918 */   // Label 1972: @91918
     /*  91918 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(91994), // Rule ID 14071 //
     /*  91923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  91931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91976 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13335:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrm),
     /*  91979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91992 */     GIR_RootConstrainSelectedInstOperands,
     /*  91993 */     // GIR_Coverage, 14071,
     /*  91993 */     GIR_EraseRootFromParent_Done,
     /*  91994 */   // Label 1973: @91994
     /*  91994 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(92070), // Rule ID 14073 //
     /*  91999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  92007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92052 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13324:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rm),
     /*  92055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92057 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92068 */     GIR_RootConstrainSelectedInstOperands,
     /*  92069 */     // GIR_Coverage, 14073,
     /*  92069 */     GIR_EraseRootFromParent_Done,
     /*  92070 */   // Label 1974: @92070
     /*  92070 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(92146), // Rule ID 14075 //
     /*  92075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  92083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92128 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13325:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rm),
     /*  92131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92144 */     GIR_RootConstrainSelectedInstOperands,
     /*  92145 */     // GIR_Coverage, 14075,
     /*  92145 */     GIR_EraseRootFromParent_Done,
     /*  92146 */   // Label 1975: @92146
     /*  92146 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(92222), // Rule ID 14077 //
     /*  92151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  92159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92191 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92204 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13326:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrm),
     /*  92207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92220 */     GIR_RootConstrainSelectedInstOperands,
     /*  92221 */     // GIR_Coverage, 14077,
     /*  92221 */     GIR_EraseRootFromParent_Done,
     /*  92222 */   // Label 1976: @92222
     /*  92222 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(92298), // Rule ID 14079 //
     /*  92227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  92235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92280 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13327:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rm),
     /*  92283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92296 */     GIR_RootConstrainSelectedInstOperands,
     /*  92297 */     // GIR_Coverage, 14079,
     /*  92297 */     GIR_EraseRootFromParent_Done,
     /*  92298 */   // Label 1977: @92298
     /*  92298 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(92374), // Rule ID 14081 //
     /*  92303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  92311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92356 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13328:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rm),
     /*  92359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92372 */     GIR_RootConstrainSelectedInstOperands,
     /*  92373 */     // GIR_Coverage, 14081,
     /*  92373 */     GIR_EraseRootFromParent_Done,
     /*  92374 */   // Label 1978: @92374
     /*  92374 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(92450), // Rule ID 14083 //
     /*  92379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  92387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92432 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13329:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrm),
     /*  92435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92448 */     GIR_RootConstrainSelectedInstOperands,
     /*  92449 */     // GIR_Coverage, 14083,
     /*  92449 */     GIR_EraseRootFromParent_Done,
     /*  92450 */   // Label 1979: @92450
     /*  92450 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(92526), // Rule ID 16794 //
     /*  92455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  92463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92508 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14942:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrm),
     /*  92511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92513 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92524 */     GIR_RootConstrainSelectedInstOperands,
     /*  92525 */     // GIR_Coverage, 16794,
     /*  92525 */     GIR_EraseRootFromParent_Done,
     /*  92526 */   // Label 1980: @92526
     /*  92526 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(92602), // Rule ID 16800 //
     /*  92531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  92539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92584 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14945:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrm),
     /*  92587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92600 */     GIR_RootConstrainSelectedInstOperands,
     /*  92601 */     // GIR_Coverage, 16800,
     /*  92601 */     GIR_EraseRootFromParent_Done,
     /*  92602 */   // Label 1981: @92602
     /*  92602 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(92643), // Rule ID 3367 //
     /*  92607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  92610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92629 */     // MIs[0] src2
     /*  92629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92632 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13337:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /*  92635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92639 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92641 */     GIR_RootConstrainSelectedInstOperands,
     /*  92642 */     // GIR_Coverage, 3367,
     /*  92642 */     GIR_EraseRootFromParent_Done,
     /*  92643 */   // Label 1982: @92643
     /*  92643 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(92684), // Rule ID 3369 //
     /*  92648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  92651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92670 */     // MIs[0] src2
     /*  92670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92673 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13337:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /*  92676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92680 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92682 */     GIR_RootConstrainSelectedInstOperands,
     /*  92683 */     // GIR_Coverage, 3369,
     /*  92683 */     GIR_EraseRootFromParent_Done,
     /*  92684 */   // Label 1983: @92684
     /*  92684 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(92729), // Rule ID 16789 //
     /*  92689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  92697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92718 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14940:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /*  92721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92725 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92727 */     GIR_RootConstrainSelectedInstOperands,
     /*  92728 */     // GIR_Coverage, 16789,
     /*  92728 */     GIR_EraseRootFromParent_Done,
     /*  92729 */   // Label 1984: @92729
     /*  92729 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(92774), // Rule ID 16791 //
     /*  92734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  92742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92763 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14941:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /*  92766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92768 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92770 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92772 */     GIR_RootConstrainSelectedInstOperands,
     /*  92773 */     // GIR_Coverage, 16791,
     /*  92773 */     GIR_EraseRootFromParent_Done,
     /*  92774 */   // Label 1985: @92774
     /*  92774 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(92819), // Rule ID 16795 //
     /*  92779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  92787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14943:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /*  92811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92817 */     GIR_RootConstrainSelectedInstOperands,
     /*  92818 */     // GIR_Coverage, 16795,
     /*  92818 */     GIR_EraseRootFromParent_Done,
     /*  92819 */   // Label 1986: @92819
     /*  92819 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(92864), // Rule ID 16797 //
     /*  92824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  92832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92853 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14944:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /*  92856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92860 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92862 */     GIR_RootConstrainSelectedInstOperands,
     /*  92863 */     // GIR_Coverage, 16797,
     /*  92863 */     GIR_EraseRootFromParent_Done,
     /*  92864 */   // Label 1987: @92864
     /*  92864 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(92909), // Rule ID 3022 //
     /*  92869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  92877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  92880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92898 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14809:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  92898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /*  92901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92903 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92905 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92907 */     GIR_RootConstrainSelectedInstOperands,
     /*  92908 */     // GIR_Coverage, 3022,
     /*  92908 */     GIR_EraseRootFromParent_Done,
     /*  92909 */   // Label 1988: @92909
     /*  92909 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(92954), // Rule ID 3024 //
     /*  92914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  92922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  92925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  92931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92943 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14813:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  92943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /*  92946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92950 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92952 */     GIR_RootConstrainSelectedInstOperands,
     /*  92953 */     // GIR_Coverage, 3024,
     /*  92953 */     GIR_EraseRootFromParent_Done,
     /*  92954 */   // Label 1989: @92954
     /*  92954 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(92999), // Rule ID 3026 //
     /*  92959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  92967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92988 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14811:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  92988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /*  92991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92995 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92997 */     GIR_RootConstrainSelectedInstOperands,
     /*  92998 */     // GIR_Coverage, 3026,
     /*  92998 */     GIR_EraseRootFromParent_Done,
     /*  92999 */   // Label 1990: @92999
     /*  92999 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(93044), // Rule ID 3028 //
     /*  93004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93033 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14793:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /*  93036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93040 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93042 */     GIR_RootConstrainSelectedInstOperands,
     /*  93043 */     // GIR_Coverage, 3028,
     /*  93043 */     GIR_EraseRootFromParent_Done,
     /*  93044 */   // Label 1991: @93044
     /*  93044 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(93089), // Rule ID 3030 //
     /*  93049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93078 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14799:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /*  93081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93083 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93085 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93087 */     GIR_RootConstrainSelectedInstOperands,
     /*  93088 */     // GIR_Coverage, 3030,
     /*  93088 */     GIR_EraseRootFromParent_Done,
     /*  93089 */   // Label 1992: @93089
     /*  93089 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(93134), // Rule ID 3046 //
     /*  93094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  93102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  93105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  93108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  93111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93123 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13700:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  93123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /*  93126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93128 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93130 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93132 */     GIR_RootConstrainSelectedInstOperands,
     /*  93133 */     // GIR_Coverage, 3046,
     /*  93133 */     GIR_EraseRootFromParent_Done,
     /*  93134 */   // Label 1993: @93134
     /*  93134 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(93179), // Rule ID 3048 //
     /*  93139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  93147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93168 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13702:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /*  93171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93175 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93177 */     GIR_RootConstrainSelectedInstOperands,
     /*  93178 */     // GIR_Coverage, 3048,
     /*  93178 */     GIR_EraseRootFromParent_Done,
     /*  93179 */   // Label 1994: @93179
     /*  93179 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(93224), // Rule ID 3050 //
     /*  93184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  93192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93213 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13701:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  93213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /*  93216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93220 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93222 */     GIR_RootConstrainSelectedInstOperands,
     /*  93223 */     // GIR_Coverage, 3050,
     /*  93223 */     GIR_EraseRootFromParent_Done,
     /*  93224 */   // Label 1995: @93224
     /*  93224 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(93269), // Rule ID 3052 //
     /*  93229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  93237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93258 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13687:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /*  93261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93265 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93267 */     GIR_RootConstrainSelectedInstOperands,
     /*  93268 */     // GIR_Coverage, 3052,
     /*  93268 */     GIR_EraseRootFromParent_Done,
     /*  93269 */   // Label 1996: @93269
     /*  93269 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(93314), // Rule ID 3054 //
     /*  93274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  93282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93303 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13690:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /*  93306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93308 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93310 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93312 */     GIR_RootConstrainSelectedInstOperands,
     /*  93313 */     // GIR_Coverage, 3054,
     /*  93313 */     GIR_EraseRootFromParent_Done,
     /*  93314 */   // Label 1997: @93314
     /*  93314 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(93359), // Rule ID 3064 //
     /*  93319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93348 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14809:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /*  93351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93355 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93357 */     GIR_RootConstrainSelectedInstOperands,
     /*  93358 */     // GIR_Coverage, 3064,
     /*  93358 */     GIR_EraseRootFromParent_Done,
     /*  93359 */   // Label 1998: @93359
     /*  93359 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(93404), // Rule ID 3066 //
     /*  93364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93393 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14813:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /*  93396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93400 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93402 */     GIR_RootConstrainSelectedInstOperands,
     /*  93403 */     // GIR_Coverage, 3066,
     /*  93403 */     GIR_EraseRootFromParent_Done,
     /*  93404 */   // Label 1999: @93404
     /*  93404 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(93449), // Rule ID 3068 //
     /*  93409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93438 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14811:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /*  93441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93443 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93445 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93447 */     GIR_RootConstrainSelectedInstOperands,
     /*  93448 */     // GIR_Coverage, 3068,
     /*  93448 */     GIR_EraseRootFromParent_Done,
     /*  93449 */   // Label 2000: @93449
     /*  93449 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(93494), // Rule ID 3072 //
     /*  93454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93483 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14793:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /*  93486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93490 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93492 */     GIR_RootConstrainSelectedInstOperands,
     /*  93493 */     // GIR_Coverage, 3072,
     /*  93493 */     GIR_EraseRootFromParent_Done,
     /*  93494 */   // Label 2001: @93494
     /*  93494 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(93539), // Rule ID 3074 //
     /*  93499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93528 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14799:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /*  93531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93535 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93537 */     GIR_RootConstrainSelectedInstOperands,
     /*  93538 */     // GIR_Coverage, 3074,
     /*  93538 */     GIR_EraseRootFromParent_Done,
     /*  93539 */   // Label 2002: @93539
     /*  93539 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(93584), // Rule ID 3309 //
     /*  93544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93573 */     // (intrinsic_wo_chain:{ *:[i32] } 14767:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /*  93576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93578 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93580 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93582 */     GIR_RootConstrainSelectedInstOperands,
     /*  93583 */     // GIR_Coverage, 3309,
     /*  93583 */     GIR_EraseRootFromParent_Done,
     /*  93584 */   // Label 2003: @93584
     /*  93584 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(93629), // Rule ID 3311 //
     /*  93589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93618 */     // (intrinsic_wo_chain:{ *:[i32] } 14765:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /*  93621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93625 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93627 */     GIR_RootConstrainSelectedInstOperands,
     /*  93628 */     // GIR_Coverage, 3311,
     /*  93628 */     GIR_EraseRootFromParent_Done,
     /*  93629 */   // Label 2004: @93629
     /*  93629 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(93674), // Rule ID 3313 //
     /*  93634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93663 */     // (intrinsic_wo_chain:{ *:[i32] } 14766:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /*  93666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93668 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93672 */     GIR_RootConstrainSelectedInstOperands,
     /*  93673 */     // GIR_Coverage, 3313,
     /*  93673 */     GIR_EraseRootFromParent_Done,
     /*  93674 */   // Label 2005: @93674
     /*  93674 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(93719), // Rule ID 3315 //
     /*  93679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93708 */     // (intrinsic_wo_chain:{ *:[i64] } 14768:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /*  93711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93713 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93715 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93717 */     GIR_RootConstrainSelectedInstOperands,
     /*  93718 */     // GIR_Coverage, 3315,
     /*  93718 */     GIR_EraseRootFromParent_Done,
     /*  93719 */   // Label 2006: @93719
     /*  93719 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(93764), // Rule ID 3317 //
     /*  93724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93753 */     // (intrinsic_wo_chain:{ *:[i32] } 14767:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /*  93756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93760 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93762 */     GIR_RootConstrainSelectedInstOperands,
     /*  93763 */     // GIR_Coverage, 3317,
     /*  93763 */     GIR_EraseRootFromParent_Done,
     /*  93764 */   // Label 2007: @93764
     /*  93764 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(93809), // Rule ID 3319 //
     /*  93769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93798 */     // (intrinsic_wo_chain:{ *:[i32] } 14765:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /*  93801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93805 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93807 */     GIR_RootConstrainSelectedInstOperands,
     /*  93808 */     // GIR_Coverage, 3319,
     /*  93808 */     GIR_EraseRootFromParent_Done,
     /*  93809 */   // Label 2008: @93809
     /*  93809 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(93854), // Rule ID 3321 //
     /*  93814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93843 */     // (intrinsic_wo_chain:{ *:[i32] } 14766:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /*  93846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93852 */     GIR_RootConstrainSelectedInstOperands,
     /*  93853 */     // GIR_Coverage, 3321,
     /*  93853 */     GIR_EraseRootFromParent_Done,
     /*  93854 */   // Label 2009: @93854
     /*  93854 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(93899), // Rule ID 3323 //
     /*  93859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93888 */     // (intrinsic_wo_chain:{ *:[i64] } 14768:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /*  93891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93895 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93897 */     GIR_RootConstrainSelectedInstOperands,
     /*  93898 */     // GIR_Coverage, 3323,
     /*  93898 */     GIR_EraseRootFromParent_Done,
     /*  93899 */   // Label 2010: @93899
     /*  93899 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(93944), // Rule ID 3327 //
     /*  93904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /*  93912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93933 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14637:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /*  93936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93940 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93942 */     GIR_RootConstrainSelectedInstOperands,
     /*  93943 */     // GIR_Coverage, 3327,
     /*  93943 */     GIR_EraseRootFromParent_Done,
     /*  93944 */   // Label 2011: @93944
     /*  93944 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(93989), // Rule ID 3329 //
     /*  93949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /*  93957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14635:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /*  93981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93985 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93987 */     GIR_RootConstrainSelectedInstOperands,
     /*  93988 */     // GIR_Coverage, 3329,
     /*  93988 */     GIR_EraseRootFromParent_Done,
     /*  93989 */   // Label 2012: @93989
     /*  93989 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(94034), // Rule ID 3331 //
     /*  93994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /*  94002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94023 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14636:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /*  94026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94028 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94030 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94032 */     GIR_RootConstrainSelectedInstOperands,
     /*  94033 */     // GIR_Coverage, 3331,
     /*  94033 */     GIR_EraseRootFromParent_Done,
     /*  94034 */   // Label 2013: @94034
     /*  94034 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(94079), // Rule ID 3335 //
     /*  94039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /*  94047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94068 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14639:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /*  94071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94073 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94075 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94077 */     GIR_RootConstrainSelectedInstOperands,
     /*  94078 */     // GIR_Coverage, 3335,
     /*  94078 */     GIR_EraseRootFromParent_Done,
     /*  94079 */   // Label 2014: @94079
     /*  94079 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(94124), // Rule ID 3337 //
     /*  94084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /*  94092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94113 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14640:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /*  94116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94120 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94122 */     GIR_RootConstrainSelectedInstOperands,
     /*  94123 */     // GIR_Coverage, 3337,
     /*  94123 */     GIR_EraseRootFromParent_Done,
     /*  94124 */   // Label 2015: @94124
     /*  94124 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(94169), // Rule ID 3339 //
     /*  94129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94158 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13330:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /*  94161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94163 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94165 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94167 */     GIR_RootConstrainSelectedInstOperands,
     /*  94168 */     // GIR_Coverage, 3339,
     /*  94168 */     GIR_EraseRootFromParent_Done,
     /*  94169 */   // Label 2016: @94169
     /*  94169 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(94214), // Rule ID 3341 //
     /*  94174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94203 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13333:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /*  94206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94208 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94210 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94212 */     GIR_RootConstrainSelectedInstOperands,
     /*  94213 */     // GIR_Coverage, 3341,
     /*  94213 */     GIR_EraseRootFromParent_Done,
     /*  94214 */   // Label 2017: @94214
     /*  94214 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(94259), // Rule ID 3343 //
     /*  94219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94248 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13324:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /*  94251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94255 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94257 */     GIR_RootConstrainSelectedInstOperands,
     /*  94258 */     // GIR_Coverage, 3343,
     /*  94258 */     GIR_EraseRootFromParent_Done,
     /*  94259 */   // Label 2018: @94259
     /*  94259 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(94304), // Rule ID 3345 //
     /*  94264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94293 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13327:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /*  94296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94300 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94302 */     GIR_RootConstrainSelectedInstOperands,
     /*  94303 */     // GIR_Coverage, 3345,
     /*  94303 */     GIR_EraseRootFromParent_Done,
     /*  94304 */   // Label 2019: @94304
     /*  94304 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(94349), // Rule ID 3347 //
     /*  94309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  94317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94338 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13331:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /*  94341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94345 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94347 */     GIR_RootConstrainSelectedInstOperands,
     /*  94348 */     // GIR_Coverage, 3347,
     /*  94348 */     GIR_EraseRootFromParent_Done,
     /*  94349 */   // Label 2020: @94349
     /*  94349 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(94394), // Rule ID 3349 //
     /*  94354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  94362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94383 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13334:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /*  94386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94388 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94390 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94392 */     GIR_RootConstrainSelectedInstOperands,
     /*  94393 */     // GIR_Coverage, 3349,
     /*  94393 */     GIR_EraseRootFromParent_Done,
     /*  94394 */   // Label 2021: @94394
     /*  94394 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(94439), // Rule ID 3351 //
     /*  94399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  94407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94428 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13325:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /*  94431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94435 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94437 */     GIR_RootConstrainSelectedInstOperands,
     /*  94438 */     // GIR_Coverage, 3351,
     /*  94438 */     GIR_EraseRootFromParent_Done,
     /*  94439 */   // Label 2022: @94439
     /*  94439 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(94484), // Rule ID 3353 //
     /*  94444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  94452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94473 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13328:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /*  94476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94480 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94482 */     GIR_RootConstrainSelectedInstOperands,
     /*  94483 */     // GIR_Coverage, 3353,
     /*  94483 */     GIR_EraseRootFromParent_Done,
     /*  94484 */   // Label 2023: @94484
     /*  94484 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(94529), // Rule ID 3355 //
     /*  94489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94518 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13330:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /*  94521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94523 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94525 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94527 */     GIR_RootConstrainSelectedInstOperands,
     /*  94528 */     // GIR_Coverage, 3355,
     /*  94528 */     GIR_EraseRootFromParent_Done,
     /*  94529 */   // Label 2024: @94529
     /*  94529 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(94574), // Rule ID 3357 //
     /*  94534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94563 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13333:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /*  94566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94570 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94572 */     GIR_RootConstrainSelectedInstOperands,
     /*  94573 */     // GIR_Coverage, 3357,
     /*  94573 */     GIR_EraseRootFromParent_Done,
     /*  94574 */   // Label 2025: @94574
     /*  94574 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(94619), // Rule ID 3359 //
     /*  94579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94608 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13324:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /*  94611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94615 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94617 */     GIR_RootConstrainSelectedInstOperands,
     /*  94618 */     // GIR_Coverage, 3359,
     /*  94618 */     GIR_EraseRootFromParent_Done,
     /*  94619 */   // Label 2026: @94619
     /*  94619 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(94664), // Rule ID 3361 //
     /*  94624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94653 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13327:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /*  94656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94660 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94662 */     GIR_RootConstrainSelectedInstOperands,
     /*  94663 */     // GIR_Coverage, 3361,
     /*  94663 */     GIR_EraseRootFromParent_Done,
     /*  94664 */   // Label 2027: @94664
     /*  94664 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(94709), // Rule ID 3378 //
     /*  94669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /*  94677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94698 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14783:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /*  94698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /*  94701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94703 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94705 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94707 */     GIR_RootConstrainSelectedInstOperands,
     /*  94708 */     // GIR_Coverage, 3378,
     /*  94708 */     GIR_EraseRootFromParent_Done,
     /*  94709 */   // Label 2028: @94709
     /*  94709 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(94754), // Rule ID 3380 //
     /*  94714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /*  94722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94743 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14785:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /*  94743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /*  94746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94748 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94750 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94752 */     GIR_RootConstrainSelectedInstOperands,
     /*  94753 */     // GIR_Coverage, 3380,
     /*  94753 */     GIR_EraseRootFromParent_Done,
     /*  94754 */   // Label 2029: @94754
     /*  94754 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(94799), // Rule ID 3555 //
     /*  94759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /*  94767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94788 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14934:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /*  94791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94793 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94795 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94797 */     GIR_RootConstrainSelectedInstOperands,
     /*  94798 */     // GIR_Coverage, 3555,
     /*  94798 */     GIR_EraseRootFromParent_Done,
     /*  94799 */   // Label 2030: @94799
     /*  94799 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(94844), // Rule ID 3556 //
     /*  94804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /*  94812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94833 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14935:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /*  94836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94840 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94842 */     GIR_RootConstrainSelectedInstOperands,
     /*  94843 */     // GIR_Coverage, 3556,
     /*  94843 */     GIR_EraseRootFromParent_Done,
     /*  94844 */   // Label 2031: @94844
     /*  94844 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(94889), // Rule ID 3564 //
     /*  94849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  94857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94878 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14940:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /*  94881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94885 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94887 */     GIR_RootConstrainSelectedInstOperands,
     /*  94888 */     // GIR_Coverage, 3564,
     /*  94888 */     GIR_EraseRootFromParent_Done,
     /*  94889 */   // Label 2032: @94889
     /*  94889 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(94934), // Rule ID 3566 //
     /*  94894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  94902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  94905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  94908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  94911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94923 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14941:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  94923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /*  94926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94928 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94930 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94932 */     GIR_RootConstrainSelectedInstOperands,
     /*  94933 */     // GIR_Coverage, 3566,
     /*  94933 */     GIR_EraseRootFromParent_Done,
     /*  94934 */   // Label 2033: @94934
     /*  94934 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(94979), // Rule ID 3568 //
     /*  94939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  94947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94968 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14943:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /*  94971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94975 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94977 */     GIR_RootConstrainSelectedInstOperands,
     /*  94978 */     // GIR_Coverage, 3568,
     /*  94978 */     GIR_EraseRootFromParent_Done,
     /*  94979 */   // Label 2034: @94979
     /*  94979 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(95024), // Rule ID 3570 //
     /*  94984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  94992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  94995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  94998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95013 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14944:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /*  95016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95018 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95020 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95022 */     GIR_RootConstrainSelectedInstOperands,
     /*  95023 */     // GIR_Coverage, 3570,
     /*  95023 */     GIR_EraseRootFromParent_Done,
     /*  95024 */   // Label 2035: @95024
     /*  95024 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(95069), // Rule ID 14060 //
     /*  95029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  95037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95058 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13330:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /*  95061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95065 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95067 */     GIR_RootConstrainSelectedInstOperands,
     /*  95068 */     // GIR_Coverage, 14060,
     /*  95068 */     GIR_EraseRootFromParent_Done,
     /*  95069 */   // Label 2036: @95069
     /*  95069 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(95114), // Rule ID 14062 //
     /*  95074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  95082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95103 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13331:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /*  95106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95110 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95112 */     GIR_RootConstrainSelectedInstOperands,
     /*  95113 */     // GIR_Coverage, 14062,
     /*  95113 */     GIR_EraseRootFromParent_Done,
     /*  95114 */   // Label 2037: @95114
     /*  95114 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(95159), // Rule ID 14064 //
     /*  95119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  95127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95148 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13332:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /*  95151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95155 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95157 */     GIR_RootConstrainSelectedInstOperands,
     /*  95158 */     // GIR_Coverage, 14064,
     /*  95158 */     GIR_EraseRootFromParent_Done,
     /*  95159 */   // Label 2038: @95159
     /*  95159 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(95204), // Rule ID 14066 //
     /*  95164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  95172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95193 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13333:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /*  95196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95198 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95200 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95202 */     GIR_RootConstrainSelectedInstOperands,
     /*  95203 */     // GIR_Coverage, 14066,
     /*  95203 */     GIR_EraseRootFromParent_Done,
     /*  95204 */   // Label 2039: @95204
     /*  95204 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(95249), // Rule ID 14068 //
     /*  95209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  95217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95238 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13334:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /*  95241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95243 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95245 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95247 */     GIR_RootConstrainSelectedInstOperands,
     /*  95248 */     // GIR_Coverage, 14068,
     /*  95248 */     GIR_EraseRootFromParent_Done,
     /*  95249 */   // Label 2040: @95249
     /*  95249 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(95294), // Rule ID 14070 //
     /*  95254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  95262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95283 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13335:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /*  95286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95288 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95290 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95292 */     GIR_RootConstrainSelectedInstOperands,
     /*  95293 */     // GIR_Coverage, 14070,
     /*  95293 */     GIR_EraseRootFromParent_Done,
     /*  95294 */   // Label 2041: @95294
     /*  95294 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(95339), // Rule ID 14072 //
     /*  95299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  95307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95328 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13324:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /*  95331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95335 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95337 */     GIR_RootConstrainSelectedInstOperands,
     /*  95338 */     // GIR_Coverage, 14072,
     /*  95338 */     GIR_EraseRootFromParent_Done,
     /*  95339 */   // Label 2042: @95339
     /*  95339 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(95384), // Rule ID 14074 //
     /*  95344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  95352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95373 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13325:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /*  95376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95378 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95380 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95382 */     GIR_RootConstrainSelectedInstOperands,
     /*  95383 */     // GIR_Coverage, 14074,
     /*  95383 */     GIR_EraseRootFromParent_Done,
     /*  95384 */   // Label 2043: @95384
     /*  95384 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(95429), // Rule ID 14076 //
     /*  95389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  95397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95418 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13326:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /*  95421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95425 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95427 */     GIR_RootConstrainSelectedInstOperands,
     /*  95428 */     // GIR_Coverage, 14076,
     /*  95428 */     GIR_EraseRootFromParent_Done,
     /*  95429 */   // Label 2044: @95429
     /*  95429 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(95474), // Rule ID 14078 //
     /*  95434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  95442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95463 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13327:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /*  95466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95470 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95472 */     GIR_RootConstrainSelectedInstOperands,
     /*  95473 */     // GIR_Coverage, 14078,
     /*  95473 */     GIR_EraseRootFromParent_Done,
     /*  95474 */   // Label 2045: @95474
     /*  95474 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(95519), // Rule ID 14080 //
     /*  95479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  95487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95508 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13328:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /*  95511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95513 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95515 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95517 */     GIR_RootConstrainSelectedInstOperands,
     /*  95518 */     // GIR_Coverage, 14080,
     /*  95518 */     GIR_EraseRootFromParent_Done,
     /*  95519 */   // Label 2046: @95519
     /*  95519 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(95564), // Rule ID 14082 //
     /*  95524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  95532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95553 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13329:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /*  95556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95558 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95560 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95562 */     GIR_RootConstrainSelectedInstOperands,
     /*  95563 */     // GIR_Coverage, 14082,
     /*  95563 */     GIR_EraseRootFromParent_Done,
     /*  95564 */   // Label 2047: @95564
     /*  95564 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(95609), // Rule ID 16793 //
     /*  95569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  95577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95598 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14942:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /*  95601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95605 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95607 */     GIR_RootConstrainSelectedInstOperands,
     /*  95608 */     // GIR_Coverage, 16793,
     /*  95608 */     GIR_EraseRootFromParent_Done,
     /*  95609 */   // Label 2048: @95609
     /*  95609 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(95654), // Rule ID 16799 //
     /*  95614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  95622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95643 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14945:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /*  95646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95650 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95652 */     GIR_RootConstrainSelectedInstOperands,
     /*  95653 */     // GIR_Coverage, 16799,
     /*  95653 */     GIR_EraseRootFromParent_Done,
     /*  95654 */   // Label 2049: @95654
     /*  95654 */   GIM_Reject,
     /*  95655 */ // Label 1932: @95655
     /*  95655 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(100241),
     /*  95660 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  95663 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(95744), // Rule ID 23534 //
     /*  95668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95712 */     // MIs[0] src3
     /*  95712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95724 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14752:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95729 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95735 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95742 */     GIR_RootConstrainSelectedInstOperands,
     /*  95743 */     // GIR_Coverage, 23534,
     /*  95743 */     GIR_EraseRootFromParent_Done,
     /*  95744 */   // Label 2051: @95744
     /*  95744 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(95825), // Rule ID 23535 //
     /*  95749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95793 */     // MIs[0] src3
     /*  95793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95805 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14751:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  95808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95810 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95816 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95823 */     GIR_RootConstrainSelectedInstOperands,
     /*  95824 */     // GIR_Coverage, 23535,
     /*  95824 */     GIR_EraseRootFromParent_Done,
     /*  95825 */   // Label 2052: @95825
     /*  95825 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(95906), // Rule ID 23536 //
     /*  95830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  95838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95874 */     // MIs[0] src3
     /*  95874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95886 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13362:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  95889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95891 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95897 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95904 */     GIR_RootConstrainSelectedInstOperands,
     /*  95905 */     // GIR_Coverage, 23536,
     /*  95905 */     GIR_EraseRootFromParent_Done,
     /*  95906 */   // Label 2053: @95906
     /*  95906 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(95987), // Rule ID 3254 //
     /*  95911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95955 */     // MIs[0] src3
     /*  95955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95967 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14752:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95972 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95978 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95985 */     GIR_RootConstrainSelectedInstOperands,
     /*  95986 */     // GIR_Coverage, 3254,
     /*  95986 */     GIR_EraseRootFromParent_Done,
     /*  95987 */   // Label 2054: @95987
     /*  95987 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(96068), // Rule ID 3256 //
     /*  95992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  96000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96032 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96036 */     // MIs[0] src3
     /*  96036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96048 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14751:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96059 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96066 */     GIR_RootConstrainSelectedInstOperands,
     /*  96067 */     // GIR_Coverage, 3256,
     /*  96067 */     GIR_EraseRootFromParent_Done,
     /*  96068 */   // Label 2055: @96068
     /*  96068 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(96149), // Rule ID 3258 //
     /*  96073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96106 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96113 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96117 */     // MIs[0] src3
     /*  96117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96129 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13362:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96140 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96147 */     GIR_RootConstrainSelectedInstOperands,
     /*  96148 */     // GIR_Coverage, 3258,
     /*  96148 */     GIR_EraseRootFromParent_Done,
     /*  96149 */   // Label 2056: @96149
     /*  96149 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(96230), // Rule ID 3374 //
     /*  96154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  96157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96198 */     // MIs[0] src3
     /*  96198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96210 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14603:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrmi:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrmi),
     /*  96213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96221 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96228 */     GIR_RootConstrainSelectedInstOperands,
     /*  96229 */     // GIR_Coverage, 3374,
     /*  96229 */     GIR_EraseRootFromParent_Done,
     /*  96230 */   // Label 2057: @96230
     /*  96230 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(96311), // Rule ID 3376 //
     /*  96235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  96238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96279 */     // MIs[0] src3
     /*  96279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96291 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14604:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrmi:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrmi),
     /*  96294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96302 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96309 */     GIR_RootConstrainSelectedInstOperands,
     /*  96310 */     // GIR_Coverage, 3376,
     /*  96310 */     GIR_EraseRootFromParent_Done,
     /*  96311 */   // Label 2058: @96311
     /*  96311 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(96392), // Rule ID 14085 //
     /*  96316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  96319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  96324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  96327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  96330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  96333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96349 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96356 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96360 */     // MIs[0] src3
     /*  96360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96372 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14605:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrmi:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrmi),
     /*  96375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96383 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96390 */     GIR_RootConstrainSelectedInstOperands,
     /*  96391 */     // GIR_Coverage, 14085,
     /*  96391 */     GIR_EraseRootFromParent_Done,
     /*  96392 */   // Label 2059: @96392
     /*  96392 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(96473), // Rule ID 14087 //
     /*  96397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96441 */     // MIs[0] src3
     /*  96441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96453 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14603:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rmi:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rmi),
     /*  96456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96458 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96464 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96471 */     GIR_RootConstrainSelectedInstOperands,
     /*  96472 */     // GIR_Coverage, 14087,
     /*  96472 */     GIR_EraseRootFromParent_Done,
     /*  96473 */   // Label 2060: @96473
     /*  96473 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(96554), // Rule ID 14089 //
     /*  96478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96514 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96518 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96522 */     // MIs[0] src3
     /*  96522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96534 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14604:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rmi:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rmi),
     /*  96537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96539 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96545 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96552 */     GIR_RootConstrainSelectedInstOperands,
     /*  96553 */     // GIR_Coverage, 14089,
     /*  96553 */     GIR_EraseRootFromParent_Done,
     /*  96554 */   // Label 2061: @96554
     /*  96554 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(96639), // Rule ID 23336 //
     /*  96559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  96567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96591 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96594 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96598 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96619 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14997:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  96622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96624 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96630 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96637 */     GIR_RootConstrainSelectedInstOperands,
     /*  96638 */     // GIR_Coverage, 23336,
     /*  96638 */     GIR_EraseRootFromParent_Done,
     /*  96639 */   // Label 2062: @96639
     /*  96639 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(96724), // Rule ID 23337 //
     /*  96644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  96652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96704 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14996:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  96707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96709 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96715 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96722 */     GIR_RootConstrainSelectedInstOperands,
     /*  96723 */     // GIR_Coverage, 23337,
     /*  96723 */     GIR_EraseRootFromParent_Done,
     /*  96724 */   // Label 2063: @96724
     /*  96724 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(96809), // Rule ID 23338 //
     /*  96729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  96737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96789 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14995:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  96789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  96792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96794 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96800 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96807 */     GIR_RootConstrainSelectedInstOperands,
     /*  96808 */     // GIR_Coverage, 23338,
     /*  96808 */     GIR_EraseRootFromParent_Done,
     /*  96809 */   // Label 2064: @96809
     /*  96809 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(96894), // Rule ID 23339 //
     /*  96814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  96822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96874 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14994:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  96877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96879 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96885 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96892 */     GIR_RootConstrainSelectedInstOperands,
     /*  96893 */     // GIR_Coverage, 23339,
     /*  96893 */     GIR_EraseRootFromParent_Done,
     /*  96894 */   // Label 2065: @96894
     /*  96894 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(96979), // Rule ID 23340 //
     /*  96899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  96907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96931 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96959 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14993:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  96959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  96962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96964 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96970 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96977 */     GIR_RootConstrainSelectedInstOperands,
     /*  96978 */     // GIR_Coverage, 23340,
     /*  96978 */     GIR_EraseRootFromParent_Done,
     /*  96979 */   // Label 2066: @96979
     /*  96979 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(97064), // Rule ID 23341 //
     /*  96984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  96992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97044 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14992:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  97047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97049 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97055 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97062 */     GIR_RootConstrainSelectedInstOperands,
     /*  97063 */     // GIR_Coverage, 23341,
     /*  97063 */     GIR_EraseRootFromParent_Done,
     /*  97064 */   // Label 2067: @97064
     /*  97064 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(97149), // Rule ID 23342 //
     /*  97069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  97077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97129 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14991:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  97132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97134 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97140 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97147 */     GIR_RootConstrainSelectedInstOperands,
     /*  97148 */     // GIR_Coverage, 23342,
     /*  97148 */     GIR_EraseRootFromParent_Done,
     /*  97149 */   // Label 2068: @97149
     /*  97149 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(97234), // Rule ID 23343 //
     /*  97154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  97162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97214 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14990:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  97217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97219 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97225 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97232 */     GIR_RootConstrainSelectedInstOperands,
     /*  97233 */     // GIR_Coverage, 23343,
     /*  97233 */     GIR_EraseRootFromParent_Done,
     /*  97234 */   // Label 2069: @97234
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(97319), // Rule ID 23344 //
     /*  97239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  97247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97271 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97274 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97278 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97299 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14989:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  97302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97304 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97310 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97317 */     GIR_RootConstrainSelectedInstOperands,
     /*  97318 */     // GIR_Coverage, 23344,
     /*  97318 */     GIR_EraseRootFromParent_Done,
     /*  97319 */   // Label 2070: @97319
     /*  97319 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(97404), // Rule ID 23345 //
     /*  97324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  97332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97384 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14988:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  97387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97389 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97395 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97402 */     GIR_RootConstrainSelectedInstOperands,
     /*  97403 */     // GIR_Coverage, 23345,
     /*  97403 */     GIR_EraseRootFromParent_Done,
     /*  97404 */   // Label 2071: @97404
     /*  97404 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(97489), // Rule ID 23346 //
     /*  97409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  97417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97469 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14987:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  97472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97474 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97480 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97487 */     GIR_RootConstrainSelectedInstOperands,
     /*  97488 */     // GIR_Coverage, 23346,
     /*  97488 */     GIR_EraseRootFromParent_Done,
     /*  97489 */   // Label 2072: @97489
     /*  97489 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(97574), // Rule ID 23347 //
     /*  97494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  97502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97526 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97533 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97554 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14986:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  97557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97559 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97565 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97572 */     GIR_RootConstrainSelectedInstOperands,
     /*  97573 */     // GIR_Coverage, 23347,
     /*  97573 */     GIR_EraseRootFromParent_Done,
     /*  97574 */   // Label 2073: @97574
     /*  97574 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(97659), // Rule ID 1620 //
     /*  97579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  97587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14997:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  97642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97650 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97657 */     GIR_RootConstrainSelectedInstOperands,
     /*  97658 */     // GIR_Coverage, 1620,
     /*  97658 */     GIR_EraseRootFromParent_Done,
     /*  97659 */   // Label 2074: @97659
     /*  97659 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(97744), // Rule ID 1622 //
     /*  97664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  97672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97700 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97707 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14996:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  97727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97735 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97742 */     GIR_RootConstrainSelectedInstOperands,
     /*  97743 */     // GIR_Coverage, 1622,
     /*  97743 */     GIR_EraseRootFromParent_Done,
     /*  97744 */   // Label 2075: @97744
     /*  97744 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(97829), // Rule ID 1624 //
     /*  97749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  97757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97809 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14995:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  97812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97820 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97827 */     GIR_RootConstrainSelectedInstOperands,
     /*  97828 */     // GIR_Coverage, 1624,
     /*  97828 */     GIR_EraseRootFromParent_Done,
     /*  97829 */   // Label 2076: @97829
     /*  97829 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(97914), // Rule ID 1626 //
     /*  97834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  97842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97894 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14994:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  97897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97899 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97905 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97912 */     GIR_RootConstrainSelectedInstOperands,
     /*  97913 */     // GIR_Coverage, 1626,
     /*  97913 */     GIR_EraseRootFromParent_Done,
     /*  97914 */   // Label 2077: @97914
     /*  97914 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(97999), // Rule ID 1628 //
     /*  97919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  97927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97979 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14993:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  97982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97990 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97997 */     GIR_RootConstrainSelectedInstOperands,
     /*  97998 */     // GIR_Coverage, 1628,
     /*  97998 */     GIR_EraseRootFromParent_Done,
     /*  97999 */   // Label 2078: @97999
     /*  97999 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(98084), // Rule ID 1630 //
     /*  98004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  98012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98064 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14992:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  98067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98075 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98082 */     GIR_RootConstrainSelectedInstOperands,
     /*  98083 */     // GIR_Coverage, 1630,
     /*  98083 */     GIR_EraseRootFromParent_Done,
     /*  98084 */   // Label 2079: @98084
     /*  98084 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(98169), // Rule ID 1632 //
     /*  98089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  98097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98149 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14991:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  98152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98160 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98167 */     GIR_RootConstrainSelectedInstOperands,
     /*  98168 */     // GIR_Coverage, 1632,
     /*  98168 */     GIR_EraseRootFromParent_Done,
     /*  98169 */   // Label 2080: @98169
     /*  98169 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(98254), // Rule ID 1634 //
     /*  98174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  98182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98234 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14990:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  98237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98239 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98245 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98252 */     GIR_RootConstrainSelectedInstOperands,
     /*  98253 */     // GIR_Coverage, 1634,
     /*  98253 */     GIR_EraseRootFromParent_Done,
     /*  98254 */   // Label 2081: @98254
     /*  98254 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(98339), // Rule ID 1636 //
     /*  98259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  98267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98319 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14989:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  98322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98330 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98337 */     GIR_RootConstrainSelectedInstOperands,
     /*  98338 */     // GIR_Coverage, 1636,
     /*  98338 */     GIR_EraseRootFromParent_Done,
     /*  98339 */   // Label 2082: @98339
     /*  98339 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(98424), // Rule ID 1638 //
     /*  98344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  98352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98404 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14988:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  98407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98415 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98422 */     GIR_RootConstrainSelectedInstOperands,
     /*  98423 */     // GIR_Coverage, 1638,
     /*  98423 */     GIR_EraseRootFromParent_Done,
     /*  98424 */   // Label 2083: @98424
     /*  98424 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(98509), // Rule ID 1640 //
     /*  98429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  98437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98489 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14987:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  98492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98500 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98507 */     GIR_RootConstrainSelectedInstOperands,
     /*  98508 */     // GIR_Coverage, 1640,
     /*  98508 */     GIR_EraseRootFromParent_Done,
     /*  98509 */   // Label 2084: @98509
     /*  98509 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(98594), // Rule ID 1642 //
     /*  98514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  98522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98574 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14986:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  98577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98585 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98592 */     GIR_RootConstrainSelectedInstOperands,
     /*  98593 */     // GIR_Coverage, 1642,
     /*  98593 */     GIR_EraseRootFromParent_Done,
     /*  98594 */   // Label 2085: @98594
     /*  98594 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(98679), // Rule ID 3559 //
     /*  98599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /*  98607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98639 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98642 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98646 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98659 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14937:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG1rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rm),
     /*  98662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98666 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98677 */     GIR_RootConstrainSelectedInstOperands,
     /*  98678 */     // GIR_Coverage, 3559,
     /*  98678 */     GIR_EraseRootFromParent_Done,
     /*  98679 */   // Label 2086: @98679
     /*  98679 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(98764), // Rule ID 3561 //
     /*  98684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /*  98692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14938:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG2rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rm),
     /*  98747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98751 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98762 */     GIR_RootConstrainSelectedInstOperands,
     /*  98763 */     // GIR_Coverage, 3561,
     /*  98763 */     GIR_EraseRootFromParent_Done,
     /*  98764 */   // Label 2087: @98764
     /*  98764 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(98814), // Rule ID 3253 //
     /*  98769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98798 */     // MIs[0] src3
     /*  98798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98801 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14752:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /*  98804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98808 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98810 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98812 */     GIR_RootConstrainSelectedInstOperands,
     /*  98813 */     // GIR_Coverage, 3253,
     /*  98813 */     GIR_EraseRootFromParent_Done,
     /*  98814 */   // Label 2088: @98814
     /*  98814 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(98864), // Rule ID 3255 //
     /*  98819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  98827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98848 */     // MIs[0] src3
     /*  98848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98851 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14751:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /*  98854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98858 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98860 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98862 */     GIR_RootConstrainSelectedInstOperands,
     /*  98863 */     // GIR_Coverage, 3255,
     /*  98863 */     GIR_EraseRootFromParent_Done,
     /*  98864 */   // Label 2089: @98864
     /*  98864 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(98914), // Rule ID 3257 //
     /*  98869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  98877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  98880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  98883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  98886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98898 */     // MIs[0] src3
     /*  98898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98901 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13362:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /*  98904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98908 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98910 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98912 */     GIR_RootConstrainSelectedInstOperands,
     /*  98913 */     // GIR_Coverage, 3257,
     /*  98913 */     GIR_EraseRootFromParent_Done,
     /*  98914 */   // Label 2090: @98914
     /*  98914 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(98964), // Rule ID 3263 //
     /*  98919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  98922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98948 */     // MIs[0] src3
     /*  98948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98951 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14752:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /*  98954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98956 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98958 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98960 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98962 */     GIR_RootConstrainSelectedInstOperands,
     /*  98963 */     // GIR_Coverage, 3263,
     /*  98963 */     GIR_EraseRootFromParent_Done,
     /*  98964 */   // Label 2091: @98964
     /*  98964 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(99014), // Rule ID 3265 //
     /*  98969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  98972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  98977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98998 */     // MIs[0] src3
     /*  98998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99001 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14751:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /*  99004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99008 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99010 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99012 */     GIR_RootConstrainSelectedInstOperands,
     /*  99013 */     // GIR_Coverage, 3265,
     /*  99013 */     GIR_EraseRootFromParent_Done,
     /*  99014 */   // Label 2092: @99014
     /*  99014 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(99064), // Rule ID 3325 //
     /*  99019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  99022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /*  99027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99048 */     // MIs[0] src3
     /*  99048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99051 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14638:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /*  99054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99058 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99060 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99062 */     GIR_RootConstrainSelectedInstOperands,
     /*  99063 */     // GIR_Coverage, 3325,
     /*  99063 */     GIR_EraseRootFromParent_Done,
     /*  99064 */   // Label 2093: @99064
     /*  99064 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(99114), // Rule ID 3371 //
     /*  99069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /*  99072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99098 */     // MIs[0] src3
     /*  99098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99101 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14603:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /*  99104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99108 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99110 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99112 */     GIR_RootConstrainSelectedInstOperands,
     /*  99113 */     // GIR_Coverage, 3371,
     /*  99113 */     GIR_EraseRootFromParent_Done,
     /*  99114 */   // Label 2094: @99114
     /*  99114 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(99164), // Rule ID 3373 //
     /*  99119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  99122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99148 */     // MIs[0] src3
     /*  99148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99151 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14603:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /*  99154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99158 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99160 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99162 */     GIR_RootConstrainSelectedInstOperands,
     /*  99163 */     // GIR_Coverage, 3373,
     /*  99163 */     GIR_EraseRootFromParent_Done,
     /*  99164 */   // Label 2095: @99164
     /*  99164 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(99214), // Rule ID 3375 //
     /*  99169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  99172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99198 */     // MIs[0] src3
     /*  99198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99201 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14604:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /*  99204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99206 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99208 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99210 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99212 */     GIR_RootConstrainSelectedInstOperands,
     /*  99213 */     // GIR_Coverage, 3375,
     /*  99213 */     GIR_EraseRootFromParent_Done,
     /*  99214 */   // Label 2096: @99214
     /*  99214 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(99264), // Rule ID 14084 //
     /*  99219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  99222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  99227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  99230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  99233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  99236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99248 */     // MIs[0] src3
     /*  99248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99251 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14605:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /*  99254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99258 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99260 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99262 */     GIR_RootConstrainSelectedInstOperands,
     /*  99263 */     // GIR_Coverage, 14084,
     /*  99263 */     GIR_EraseRootFromParent_Done,
     /*  99264 */   // Label 2097: @99264
     /*  99264 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(99314), // Rule ID 14086 //
     /*  99269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99298 */     // MIs[0] src3
     /*  99298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14603:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /*  99304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99306 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99308 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99310 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99312 */     GIR_RootConstrainSelectedInstOperands,
     /*  99313 */     // GIR_Coverage, 14086,
     /*  99313 */     GIR_EraseRootFromParent_Done,
     /*  99314 */   // Label 2098: @99314
     /*  99314 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(99364), // Rule ID 14088 //
     /*  99319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99348 */     // MIs[0] src3
     /*  99348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99351 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14604:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /*  99354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99358 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99360 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99362 */     GIR_RootConstrainSelectedInstOperands,
     /*  99363 */     // GIR_Coverage, 14088,
     /*  99363 */     GIR_EraseRootFromParent_Done,
     /*  99364 */   // Label 2099: @99364
     /*  99364 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(99418), // Rule ID 1619 //
     /*  99369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  99377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99405 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14997:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /*  99408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99410 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99412 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99414 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99416 */     GIR_RootConstrainSelectedInstOperands,
     /*  99417 */     // GIR_Coverage, 1619,
     /*  99417 */     GIR_EraseRootFromParent_Done,
     /*  99418 */   // Label 2100: @99418
     /*  99418 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(99472), // Rule ID 1621 //
     /*  99423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  99431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14996:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /*  99462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99466 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99468 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99470 */     GIR_RootConstrainSelectedInstOperands,
     /*  99471 */     // GIR_Coverage, 1621,
     /*  99471 */     GIR_EraseRootFromParent_Done,
     /*  99472 */   // Label 2101: @99472
     /*  99472 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(99526), // Rule ID 1623 //
     /*  99477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  99485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99513 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14995:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  99516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99518 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99520 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99522 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99524 */     GIR_RootConstrainSelectedInstOperands,
     /*  99525 */     // GIR_Coverage, 1623,
     /*  99525 */     GIR_EraseRootFromParent_Done,
     /*  99526 */   // Label 2102: @99526
     /*  99526 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(99580), // Rule ID 1625 //
     /*  99531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  99539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99567 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14994:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /*  99570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99574 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99576 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99578 */     GIR_RootConstrainSelectedInstOperands,
     /*  99579 */     // GIR_Coverage, 1625,
     /*  99579 */     GIR_EraseRootFromParent_Done,
     /*  99580 */   // Label 2103: @99580
     /*  99580 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(99634), // Rule ID 1627 //
     /*  99585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  99593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99621 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14993:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /*  99624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99628 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99630 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99632 */     GIR_RootConstrainSelectedInstOperands,
     /*  99633 */     // GIR_Coverage, 1627,
     /*  99633 */     GIR_EraseRootFromParent_Done,
     /*  99634 */   // Label 2104: @99634
     /*  99634 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(99688), // Rule ID 1629 //
     /*  99639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  99647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99675 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14992:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /*  99678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99684 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99686 */     GIR_RootConstrainSelectedInstOperands,
     /*  99687 */     // GIR_Coverage, 1629,
     /*  99687 */     GIR_EraseRootFromParent_Done,
     /*  99688 */   // Label 2105: @99688
     /*  99688 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(99742), // Rule ID 1631 //
     /*  99693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  99701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99729 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14991:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /*  99732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99736 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99738 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99740 */     GIR_RootConstrainSelectedInstOperands,
     /*  99741 */     // GIR_Coverage, 1631,
     /*  99741 */     GIR_EraseRootFromParent_Done,
     /*  99742 */   // Label 2106: @99742
     /*  99742 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(99796), // Rule ID 1633 //
     /*  99747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  99755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99783 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14990:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /*  99786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99790 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99792 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99794 */     GIR_RootConstrainSelectedInstOperands,
     /*  99795 */     // GIR_Coverage, 1633,
     /*  99795 */     GIR_EraseRootFromParent_Done,
     /*  99796 */   // Label 2107: @99796
     /*  99796 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(99850), // Rule ID 1635 //
     /*  99801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  99809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99837 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14989:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /*  99840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99842 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99844 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99846 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99848 */     GIR_RootConstrainSelectedInstOperands,
     /*  99849 */     // GIR_Coverage, 1635,
     /*  99849 */     GIR_EraseRootFromParent_Done,
     /*  99850 */   // Label 2108: @99850
     /*  99850 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(99904), // Rule ID 1637 //
     /*  99855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  99863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99891 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14988:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /*  99894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99898 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99900 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99902 */     GIR_RootConstrainSelectedInstOperands,
     /*  99903 */     // GIR_Coverage, 1637,
     /*  99903 */     GIR_EraseRootFromParent_Done,
     /*  99904 */   // Label 2109: @99904
     /*  99904 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(99958), // Rule ID 1639 //
     /*  99909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  99917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99945 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14987:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /*  99948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99950 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99952 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99954 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99956 */     GIR_RootConstrainSelectedInstOperands,
     /*  99957 */     // GIR_Coverage, 1639,
     /*  99957 */     GIR_EraseRootFromParent_Done,
     /*  99958 */   // Label 2110: @99958
     /*  99958 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(100012), // Rule ID 1641 //
     /*  99963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  99971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99999 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14986:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /* 100002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100006 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100008 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100010 */     GIR_RootConstrainSelectedInstOperands,
     /* 100011 */     // GIR_Coverage, 1641,
     /* 100011 */     GIR_EraseRootFromParent_Done,
     /* 100012 */   // Label 2111: @100012
     /* 100012 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(100078), // Rule ID 3333 //
     /* 100017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 100020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /* 100025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100053 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14641:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 100053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100057 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /* 100067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /* 100070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100074 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100076 */     GIR_RootConstrainSelectedInstOperands,
     /* 100077 */     // GIR_Coverage, 3333,
     /* 100077 */     GIR_EraseRootFromParent_Done,
     /* 100078 */   // Label 2112: @100078
     /* 100078 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(100132), // Rule ID 3557 //
     /* 100083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 100086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /* 100091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 100094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 100097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 100100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100119 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14936:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /* 100122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100126 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100128 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100130 */     GIR_RootConstrainSelectedInstOperands,
     /* 100131 */     // GIR_Coverage, 3557,
     /* 100131 */     GIR_EraseRootFromParent_Done,
     /* 100132 */   // Label 2113: @100132
     /* 100132 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(100186), // Rule ID 3558 //
     /* 100137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /* 100145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100173 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14937:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /* 100176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100178 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100180 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100182 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100184 */     GIR_RootConstrainSelectedInstOperands,
     /* 100185 */     // GIR_Coverage, 3558,
     /* 100185 */     GIR_EraseRootFromParent_Done,
     /* 100186 */   // Label 2114: @100186
     /* 100186 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(100240), // Rule ID 3560 //
     /* 100191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /* 100199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100227 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14938:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /* 100230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100234 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100236 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100238 */     GIR_RootConstrainSelectedInstOperands,
     /* 100239 */     // GIR_Coverage, 3560,
     /* 100239 */     GIR_EraseRootFromParent_Done,
     /* 100240 */   // Label 2115: @100240
     /* 100240 */   GIM_Reject,
     /* 100241 */ // Label 2050: @100241
     /* 100241 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(100370),
     /* 100246 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 100249 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /* 100254 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100263 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100274 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100278 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(100339), // Rule ID 3563 //
     /* 100283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 100290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100305 */     // MIs[0] src4
     /* 100305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100317 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14939:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rmi:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rmi),
     /* 100320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100322 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100324 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 100330 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100337 */     GIR_RootConstrainSelectedInstOperands,
     /* 100338 */     // GIR_Coverage, 3563,
     /* 100338 */     GIR_EraseRootFromParent_Done,
     /* 100339 */   // Label 2117: @100339
     /* 100339 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(100369), // Rule ID 3562 //
     /* 100344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100351 */     // MIs[0] src4
     /* 100351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14939:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rri),
     /* 100357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100361 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100363 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100365 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100367 */     GIR_RootConstrainSelectedInstOperands,
     /* 100368 */     // GIR_Coverage, 3562,
     /* 100368 */     GIR_EraseRootFromParent_Done,
     /* 100369 */   // Label 2118: @100369
     /* 100369 */   GIM_Reject,
     /* 100370 */ // Label 2116: @100370
     /* 100370 */ GIM_Reject,
     /* 100371 */ // Label 18: @100371
     /* 100371 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(100930),
     /* 100376 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 100379 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(100401), // Rule ID 149 //
     /* 100384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /* 100387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /* 100392 */     // (intrinsic_void 14633:{ *:[iPTR] })  =>  (SERIALIZE)
     /* 100392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /* 100395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100399 */     GIR_RootConstrainSelectedInstOperands,
     /* 100400 */     // GIR_Coverage, 149,
     /* 100400 */     GIR_EraseRootFromParent_Done,
     /* 100401 */   // Label 2120: @100401
     /* 100401 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(100423), // Rule ID 150 //
     /* 100406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /* 100414 */     // (intrinsic_void 15021:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /* 100414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /* 100417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100421 */     GIR_RootConstrainSelectedInstOperands,
     /* 100422 */     // GIR_Coverage, 150,
     /* 100422 */     GIR_EraseRootFromParent_Done,
     /* 100423 */   // Label 2121: @100423
     /* 100423 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(100445), // Rule ID 151 //
     /* 100428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /* 100436 */     // (intrinsic_void 15007:{ *:[iPTR] })  =>  (XRESLDTRK)
     /* 100436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /* 100439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100443 */     GIR_RootConstrainSelectedInstOperands,
     /* 100444 */     // GIR_Coverage, 151,
     /* 100444 */     GIR_EraseRootFromParent_Done,
     /* 100445 */   // Label 2122: @100445
     /* 100445 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(100467), // Rule ID 152 //
     /* 100450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /* 100458 */     // (intrinsic_void 14491:{ *:[iPTR] })  =>  (CLUI)
     /* 100458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /* 100461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100465 */     GIR_RootConstrainSelectedInstOperands,
     /* 100466 */     // GIR_Coverage, 152,
     /* 100466 */     GIR_EraseRootFromParent_Done,
     /* 100467 */   // Label 2123: @100467
     /* 100467 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(100489), // Rule ID 153 //
     /* 100472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /* 100480 */     // (intrinsic_void 14815:{ *:[iPTR] })  =>  (STUI)
     /* 100480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /* 100483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100487 */     GIR_RootConstrainSelectedInstOperands,
     /* 100488 */     // GIR_Coverage, 153,
     /* 100488 */     GIR_EraseRootFromParent_Done,
     /* 100489 */   // Label 2124: @100489
     /* 100489 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(100508), // Rule ID 2510 //
     /* 100494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /* 100499 */     // (intrinsic_void 14710:{ *:[iPTR] })  =>  (PAUSE)
     /* 100499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /* 100502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100506 */     GIR_RootConstrainSelectedInstOperands,
     /* 100507 */     // GIR_Coverage, 2510,
     /* 100507 */     GIR_EraseRootFromParent_Done,
     /* 100508 */   // Label 2125: @100508
     /* 100508 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(100530), // Rule ID 2511 //
     /* 100513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 100516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 100521 */     // (intrinsic_void 14672:{ *:[iPTR] })  =>  (SFENCE)
     /* 100521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 100524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100528 */     GIR_RootConstrainSelectedInstOperands,
     /* 100529 */     // GIR_Coverage, 2511,
     /* 100529 */     GIR_EraseRootFromParent_Done,
     /* 100530 */   // Label 2126: @100530
     /* 100530 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(100552), // Rule ID 2512 //
     /* 100535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 100538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 100543 */     // (intrinsic_void 14699:{ *:[iPTR] })  =>  (LFENCE)
     /* 100543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 100546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100550 */     GIR_RootConstrainSelectedInstOperands,
     /* 100551 */     // GIR_Coverage, 2512,
     /* 100551 */     GIR_EraseRootFromParent_Done,
     /* 100552 */   // Label 2127: @100552
     /* 100552 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(100574), // Rule ID 2513 //
     /* 100557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 100560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 100565 */     // (intrinsic_void 14703:{ *:[iPTR] })  =>  (MFENCE)
     /* 100565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 100568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100572 */     GIR_RootConstrainSelectedInstOperands,
     /* 100573 */     // GIR_Coverage, 2513,
     /* 100573 */     GIR_EraseRootFromParent_Done,
     /* 100574 */   // Label 2128: @100574
     /* 100574 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(100640), // Rule ID 3427 //
     /* 100579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 100587 */     // (intrinsic_void 13405:{ *:[iPTR] })  =>  (VZEROALL)
     /* 100587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 100590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100638 */     GIR_RootConstrainSelectedInstOperands,
     /* 100639 */     // GIR_Coverage, 3427,
     /* 100639 */     GIR_EraseRootFromParent_Done,
     /* 100640 */   // Label 2129: @100640
     /* 100640 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(100706), // Rule ID 3428 //
     /* 100645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 100653 */     // (intrinsic_void 13406:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 100653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 100656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100704 */     GIR_RootConstrainSelectedInstOperands,
     /* 100705 */     // GIR_Coverage, 3428,
     /* 100705 */     GIR_EraseRootFromParent_Done,
     /* 100706 */   // Label 2130: @100706
     /* 100706 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(100776), // Rule ID 16802 //
     /* 100711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 100714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 100719 */     // (intrinsic_void 14526:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 100719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 100722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 100725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 100728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 100731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 100734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 100737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 100740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 100743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 100746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 100749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 100752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 100755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 100758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 100761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 100764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 100767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 100770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100774 */     GIR_RootConstrainSelectedInstOperands,
     /* 100775 */     // GIR_Coverage, 16802,
     /* 100775 */     GIR_EraseRootFromParent_Done,
     /* 100776 */   // Label 2131: @100776
     /* 100776 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(100798), // Rule ID 16985 //
     /* 100781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 100784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 100789 */     // (intrinsic_void 14959:{ *:[iPTR] })  =>  (XEND)
     /* 100789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 100792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100796 */     GIR_RootConstrainSelectedInstOperands,
     /* 100797 */     // GIR_Coverage, 16985,
     /* 100797 */     GIR_EraseRootFromParent_Done,
     /* 100798 */   // Label 2132: @100798
     /* 100798 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(100844), // Rule ID 16997 //
     /* 100803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 100806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 100811 */     // (intrinsic_void 14885:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 100811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 100814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 100817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 100820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 100823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 100826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 100829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 100832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 100835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 100838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100842 */     GIR_RootConstrainSelectedInstOperands,
     /* 100843 */     // GIR_Coverage, 16997,
     /* 100843 */     GIR_EraseRootFromParent_Done,
     /* 100844 */   // Label 2133: @100844
     /* 100844 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(100863), // Rule ID 17086 //
     /* 100849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 100854 */     // (intrinsic_void 14946:{ *:[iPTR] })  =>  (WBINVD)
     /* 100854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 100857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100861 */     GIR_RootConstrainSelectedInstOperands,
     /* 100862 */     // GIR_Coverage, 17086,
     /* 100862 */     GIR_EraseRootFromParent_Done,
     /* 100863 */   // Label 2134: @100863
     /* 100863 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(100885), // Rule ID 17087 //
     /* 100868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 100871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 100876 */     // (intrinsic_void 14947:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 100876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 100879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100883 */     GIR_RootConstrainSelectedInstOperands,
     /* 100884 */     // GIR_Coverage, 17087,
     /* 100884 */     GIR_EraseRootFromParent_Done,
     /* 100885 */   // Label 2135: @100885
     /* 100885 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(100907), // Rule ID 17092 //
     /* 100890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 100895 */     // (intrinsic_void 14628:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 100895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 100898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 100901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100905 */     GIR_RootConstrainSelectedInstOperands,
     /* 100906 */     // GIR_Coverage, 17092,
     /* 100906 */     GIR_EraseRootFromParent_Done,
     /* 100907 */   // Label 2136: @100907
     /* 100907 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(100929), // Rule ID 17102 //
     /* 100912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 100917 */     // (intrinsic_void 14634:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 100917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 100920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 100923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100927 */     GIR_RootConstrainSelectedInstOperands,
     /* 100928 */     // GIR_Coverage, 17102,
     /* 100928 */     GIR_EraseRootFromParent_Done,
     /* 100929 */   // Label 2137: @100929
     /* 100929 */   GIM_Reject,
     /* 100930 */ // Label 2119: @100930
     /* 100930 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(102818),
     /* 100935 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 100938 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(100996), // Rule ID 17130 //
     /* 100943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 100946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 100951 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 100954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100982 */     // (intrinsic_void 14608:{ *:[iPTR] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (PTWRITE64m addr:{ *:[iPTR] }:$dst)
     /* 100982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64m),
     /* 100985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 100989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100994 */     GIR_RootConstrainSelectedInstOperands,
     /* 100995 */     // GIR_Coverage, 17130,
     /* 100995 */     GIR_EraseRootFromParent_Done,
     /* 100996 */   // Label 2139: @100996
     /* 100996 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(101054), // Rule ID 17129 //
     /* 101001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 101004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 101009 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101027 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 101031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101040 */     // (intrinsic_void 14607:{ *:[iPTR] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (PTWRITEm addr:{ *:[iPTR] }:$dst)
     /* 101040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEm),
     /* 101043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101052 */     GIR_RootConstrainSelectedInstOperands,
     /* 101053 */     // GIR_Coverage, 17129,
     /* 101053 */     GIR_EraseRootFromParent_Done,
     /* 101054 */   // Label 2140: @101054
     /* 101054 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(101091), // Rule ID 162 //
     /* 101059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSHOPT),
     /* 101062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clflushopt),
     /* 101067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101078 */     // (intrinsic_void 14489:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSHOPT addr:{ *:[iPTR] }:$src)
     /* 101078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSHOPT),
     /* 101081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101089 */     GIR_RootConstrainSelectedInstOperands,
     /* 101090 */     // GIR_Coverage, 162,
     /* 101090 */     GIR_EraseRootFromParent_Done,
     /* 101091 */   // Label 2141: @101091
     /* 101091 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(101128), // Rule ID 163 //
     /* 101096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLWB),
     /* 101099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clwb),
     /* 101104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101115 */     // (intrinsic_void 14492:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLWB addr:{ *:[iPTR] }:$src)
     /* 101115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLWB),
     /* 101118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101126 */     GIR_RootConstrainSelectedInstOperands,
     /* 101127 */     // GIR_Coverage, 163,
     /* 101127 */     GIR_EraseRootFromParent_Done,
     /* 101128 */   // Label 2142: @101128
     /* 101128 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(101165), // Rule ID 164 //
     /* 101133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLDEMOTE),
     /* 101136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_cldemote),
     /* 101141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101152 */     // (intrinsic_void 14488:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLDEMOTE addr:{ *:[iPTR] }:$src)
     /* 101152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLDEMOTE),
     /* 101155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101163 */     GIR_RootConstrainSelectedInstOperands,
     /* 101164 */     // GIR_Coverage, 164,
     /* 101164 */     GIR_EraseRootFromParent_Done,
     /* 101165 */   // Label 2143: @101165
     /* 101165 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(101202), // Rule ID 169 //
     /* 101170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS),
     /* 101173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_prefetchrs),
     /* 101178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101189 */     // (intrinsic_void 14606:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (PREFETCHRST2 addr:{ *:[iPTR] }:$src)
     /* 101189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHRST2),
     /* 101192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101200 */     GIR_RootConstrainSelectedInstOperands,
     /* 101201 */     // GIR_Coverage, 169,
     /* 101201 */     GIR_EraseRootFromParent_Done,
     /* 101202 */   // Label 2144: @101202
     /* 101202 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(101239), // Rule ID 1133 //
     /* 101207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave),
     /* 101215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101226 */     // (intrinsic_void 14512:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE addr:{ *:[iPTR] }:$dst)
     /* 101226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE),
     /* 101229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101237 */     GIR_RootConstrainSelectedInstOperands,
     /* 101238 */     // GIR_Coverage, 1133,
     /* 101238 */     GIR_EraseRootFromParent_Done,
     /* 101239 */   // Label 2145: @101239
     /* 101239 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(101276), // Rule ID 1134 //
     /* 101244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave64),
     /* 101252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101263 */     // (intrinsic_void 14513:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 101263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE64),
     /* 101266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101274 */     GIR_RootConstrainSelectedInstOperands,
     /* 101275 */     // GIR_Coverage, 1134,
     /* 101275 */     GIR_EraseRootFromParent_Done,
     /* 101276 */   // Label 2146: @101276
     /* 101276 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(101319), // Rule ID 1135 //
     /* 101281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor),
     /* 101289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101300 */     // (intrinsic_void 14510:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR),
     /* 101303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101317 */     GIR_RootConstrainSelectedInstOperands,
     /* 101318 */     // GIR_Coverage, 1135,
     /* 101318 */     GIR_EraseRootFromParent_Done,
     /* 101319 */   // Label 2147: @101319
     /* 101319 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(101362), // Rule ID 1136 //
     /* 101324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor64),
     /* 101332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101343 */     // (intrinsic_void 14511:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR64:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR64),
     /* 101346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101360 */     GIR_RootConstrainSelectedInstOperands,
     /* 101361 */     // GIR_Coverage, 1136,
     /* 101361 */     GIR_EraseRootFromParent_Done,
     /* 101362 */   // Label 2148: @101362
     /* 101362 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(101399), // Rule ID 2509 //
     /* 101367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSH),
     /* 101370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_clflush),
     /* 101375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101386 */     // (intrinsic_void 14680:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSH addr:{ *:[iPTR] }:$src)
     /* 101386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSH),
     /* 101389 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101397 */     GIR_RootConstrainSelectedInstOperands,
     /* 101398 */     // GIR_Coverage, 2509,
     /* 101398 */     GIR_EraseRootFromParent_Done,
     /* 101399 */   // Label 2149: @101399
     /* 101399 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(101439), // Rule ID 2514 //
     /* 101404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101423 */     // (intrinsic_void 14661:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDMXCSR),
     /* 101426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101437 */     GIR_RootConstrainSelectedInstOperands,
     /* 101438 */     // GIR_Coverage, 2514,
     /* 101438 */     GIR_EraseRootFromParent_Done,
     /* 101439 */   // Label 2150: @101439
     /* 101439 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(101476), // Rule ID 2515 //
     /* 101444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101463 */     // (intrinsic_void 14673:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (VSTMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSTMXCSR),
     /* 101466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101474 */     GIR_RootConstrainSelectedInstOperands,
     /* 101475 */     // GIR_Coverage, 2515,
     /* 101475 */     GIR_EraseRootFromParent_Done,
     /* 101476 */   // Label 2151: @101476
     /* 101476 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(101513), // Rule ID 2516 //
     /* 101481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101497 */     // (intrinsic_void 14661:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDMXCSR),
     /* 101500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101511 */     GIR_RootConstrainSelectedInstOperands,
     /* 101512 */     // GIR_Coverage, 2516,
     /* 101512 */     GIR_EraseRootFromParent_Done,
     /* 101513 */   // Label 2152: @101513
     /* 101513 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(101547), // Rule ID 2517 //
     /* 101518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101534 */     // (intrinsic_void 14673:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (STMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STMXCSR),
     /* 101537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101545 */     GIR_RootConstrainSelectedInstOperands,
     /* 101546 */     // GIR_Coverage, 2517,
     /* 101546 */     GIR_EraseRootFromParent_Done,
     /* 101547 */   // Label 2153: @101547
     /* 101547 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(101608), // Rule ID 16993 //
     /* 101552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101571 */     // (intrinsic_void 14518:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG),
     /* 101574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101606 */     GIR_RootConstrainSelectedInstOperands,
     /* 101607 */     // GIR_Coverage, 16993,
     /* 101607 */     GIR_EraseRootFromParent_Done,
     /* 101608 */   // Label 2154: @101608
     /* 101608 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(101645), // Rule ID 16994 //
     /* 101613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101632 */     // (intrinsic_void 14814:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG addr:{ *:[iPTR] }:$src)
     /* 101632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG),
     /* 101635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101643 */     GIR_RootConstrainSelectedInstOperands,
     /* 101644 */     // GIR_Coverage, 16994,
     /* 101644 */     GIR_EraseRootFromParent_Done,
     /* 101645 */   // Label 2155: @101645
     /* 101645 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(101706), // Rule ID 16995 //
     /* 101650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101669 */     // (intrinsic_void 14518:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG_EVEX:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG_EVEX),
     /* 101672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101704 */     GIR_RootConstrainSelectedInstOperands,
     /* 101705 */     // GIR_Coverage, 16995,
     /* 101705 */     GIR_EraseRootFromParent_Done,
     /* 101706 */   // Label 2156: @101706
     /* 101706 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(101743), // Rule ID 16996 //
     /* 101711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101730 */     // (intrinsic_void 14814:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG_EVEX addr:{ *:[iPTR] }:$src)
     /* 101730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG_EVEX),
     /* 101733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101741 */     GIR_RootConstrainSelectedInstOperands,
     /* 101742 */     // GIR_Coverage, 16996,
     /* 101742 */     GIR_EraseRootFromParent_Done,
     /* 101743 */   // Label 2157: @101743
     /* 101743 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(101780), // Rule ID 17093 //
     /* 101748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_rstorssp),
     /* 101753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101764 */     // (intrinsic_void 14627:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (RSTORSSP addr:{ *:[iPTR] }:$src)
     /* 101764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSTORSSP),
     /* 101767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101778 */     GIR_RootConstrainSelectedInstOperands,
     /* 101779 */     // GIR_Coverage, 17093,
     /* 101779 */     GIR_EraseRootFromParent_Done,
     /* 101780 */   // Label 2158: @101780
     /* 101780 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(101817), // Rule ID 17103 //
     /* 101785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clrssbsy),
     /* 101790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101801 */     // (intrinsic_void 14490:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLRSSBSY addr:{ *:[iPTR] }:$src)
     /* 101801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLRSSBSY),
     /* 101804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101815 */     GIR_RootConstrainSelectedInstOperands,
     /* 101816 */     // GIR_Coverage, 17103,
     /* 101816 */     GIR_EraseRootFromParent_Done,
     /* 101817 */   // Label 2159: @101817
     /* 101817 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(101847), // Rule ID 17075 //
     /* 101822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 101827 */     // MIs[0] Operand 1
     /* 101827 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 101838 */     // (intrinsic_void 14516:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 101838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 101841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101845 */     GIR_RootConstrainSelectedInstOperands,
     /* 101846 */     // GIR_Coverage, 17075,
     /* 101846 */     GIR_EraseRootFromParent_Done,
     /* 101847 */   // Label 2160: @101847
     /* 101847 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(101874), // Rule ID 16987 //
     /* 101852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 101855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 101860 */     // MIs[0] imm
     /* 101860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101863 */     // (intrinsic_void 14957:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 101863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 101866 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 101868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101872 */     GIR_RootConstrainSelectedInstOperands,
     /* 101873 */     // GIR_Coverage, 16987,
     /* 101873 */     GIR_EraseRootFromParent_Done,
     /* 101874 */   // Label 2161: @101874
     /* 101874 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(101901), // Rule ID 16999 //
     /* 101879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 101882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 101887 */     // MIs[0] src
     /* 101887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101890 */     // (intrinsic_void 14888:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 101890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 101893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101899 */     GIR_RootConstrainSelectedInstOperands,
     /* 101900 */     // GIR_Coverage, 16999,
     /* 101900 */     GIR_EraseRootFromParent_Done,
     /* 101901 */   // Label 2162: @101901
     /* 101901 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(101925), // Rule ID 17077 //
     /* 101906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 101911 */     // MIs[0] trap
     /* 101911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101914 */     // (intrinsic_void 14516:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 101914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 101917 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 101919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101923 */     GIR_RootConstrainSelectedInstOperands,
     /* 101924 */     // GIR_Coverage, 17077,
     /* 101924 */     GIR_EraseRootFromParent_Done,
     /* 101925 */   // Label 2163: @101925
     /* 101925 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(101959), // Rule ID 1 //
     /* 101930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 101933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 101938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101945 */     // (intrinsic_w_chain:{ *:[i32] } 14502:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 101945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 101948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 101953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101957 */     GIR_RootConstrainSelectedInstOperands,
     /* 101958 */     // GIR_Coverage, 1,
     /* 101958 */     GIR_EraseRootFromParent_Done,
     /* 101959 */   // Label 2164: @101959
     /* 101959 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(101993), // Rule ID 2 //
     /* 101964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 101967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 101972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 101975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101979 */     // (intrinsic_w_chain:{ *:[i64] } 14503:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 101979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 101982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 101987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101991 */     GIR_RootConstrainSelectedInstOperands,
     /* 101992 */     // GIR_Coverage, 2,
     /* 101992 */     GIR_EraseRootFromParent_Done,
     /* 101993 */   // Label 2165: @101993
     /* 101993 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(102024), // Rule ID 115 //
     /* 101998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102013 */     // (intrinsic_w_chain:{ *:[i32] } 14642:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 102013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 102016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102022 */     GIR_RootConstrainSelectedInstOperands,
     /* 102023 */     // GIR_Coverage, 115,
     /* 102023 */     GIR_EraseRootFromParent_Done,
     /* 102024 */   // Label 2166: @102024
     /* 102024 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(102055), // Rule ID 117 //
     /* 102029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102044 */     // (intrinsic_w_chain:{ *:[i64] } 14642:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 102044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 102047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102053 */     GIR_RootConstrainSelectedInstOperands,
     /* 102054 */     // GIR_Coverage, 117,
     /* 102054 */     GIR_EraseRootFromParent_Done,
     /* 102055 */   // Label 2167: @102055
     /* 102055 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(102086), // Rule ID 16984 //
     /* 102060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 102068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102075 */     // (intrinsic_w_chain:{ *:[i32] } 14958:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 102075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 102078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102084 */     GIR_RootConstrainSelectedInstOperands,
     /* 102085 */     // GIR_Coverage, 16984,
     /* 102085 */     GIR_EraseRootFromParent_Done,
     /* 102086 */   // Label 2168: @102086
     /* 102086 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(102117), // Rule ID 17119 //
     /* 102091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 102099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102106 */     // (intrinsic_w_chain:{ *:[i32] } 14609:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 102106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 102109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102115 */     GIR_RootConstrainSelectedInstOperands,
     /* 102116 */     // GIR_Coverage, 17119,
     /* 102116 */     GIR_EraseRootFromParent_Done,
     /* 102117 */   // Label 2169: @102117
     /* 102117 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(102148), // Rule ID 17120 //
     /* 102122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 102130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102137 */     // (intrinsic_w_chain:{ *:[i64] } 14610:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 102137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 102140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102146 */     GIR_RootConstrainSelectedInstOperands,
     /* 102147 */     // GIR_Coverage, 17120,
     /* 102147 */     GIR_EraseRootFromParent_Done,
     /* 102148 */   // Label 2170: @102148
     /* 102148 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(102179), // Rule ID 17121 //
     /* 102153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 102161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102168 */     // (intrinsic_w_chain:{ *:[i32] } 14611:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 102168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 102171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102177 */     GIR_RootConstrainSelectedInstOperands,
     /* 102178 */     // GIR_Coverage, 17121,
     /* 102178 */     GIR_EraseRootFromParent_Done,
     /* 102179 */   // Label 2171: @102179
     /* 102179 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(102210), // Rule ID 17122 //
     /* 102184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 102192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102199 */     // (intrinsic_w_chain:{ *:[i64] } 14612:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 102199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 102202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102208 */     GIR_RootConstrainSelectedInstOperands,
     /* 102209 */     // GIR_Coverage, 17122,
     /* 102209 */     GIR_EraseRootFromParent_Done,
     /* 102210 */   // Label 2172: @102210
     /* 102210 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(102241), // Rule ID 17128 //
     /* 102215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 102218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102230 */     // (intrinsic_w_chain:{ *:[i32] } 14613:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 102230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 102233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102239 */     GIR_RootConstrainSelectedInstOperands,
     /* 102240 */     // GIR_Coverage, 17128,
     /* 102240 */     GIR_EraseRootFromParent_Done,
     /* 102241 */   // Label 2173: @102241
     /* 102241 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(102298), // Rule ID 22381 //
     /* 102246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 102249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102261 */     // (intrinsic_w_chain:{ *:[i32] } 14613:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 102261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 102268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102280 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 102287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 102292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 102297 */     // GIR_Coverage, 22381,
     /* 102297 */     GIR_EraseRootFromParent_Done,
     /* 102298 */   // Label 2174: @102298
     /* 102298 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(102338), // Rule ID 3 //
     /* 102303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 102311 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102318 */     // (intrinsic_void 14504:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 102318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 102321 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102336 */     GIR_RootConstrainSelectedInstOperands,
     /* 102337 */     // GIR_Coverage, 3,
     /* 102337 */     GIR_EraseRootFromParent_Done,
     /* 102338 */   // Label 2175: @102338
     /* 102338 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(102378), // Rule ID 4 //
     /* 102343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 102351 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102358 */     // (intrinsic_void 14505:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 102358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 102361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 102366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102376 */     GIR_RootConstrainSelectedInstOperands,
     /* 102377 */     // GIR_Coverage, 4,
     /* 102377 */     GIR_EraseRootFromParent_Done,
     /* 102378 */   // Label 2176: @102378
     /* 102378 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(102409), // Rule ID 154 //
     /* 102383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 102386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 102391 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102398 */     // (intrinsic_void 14632:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 102398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 102401 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 102403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102407 */     GIR_RootConstrainSelectedInstOperands,
     /* 102408 */     // GIR_Coverage, 154,
     /* 102408 */     GIR_EraseRootFromParent_Done,
     /* 102409 */   // Label 2177: @102409
     /* 102409 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(102440), // Rule ID 17088 //
     /* 102414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 102419 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102426 */     // (intrinsic_void 14514:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 102426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 102429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102438 */     GIR_RootConstrainSelectedInstOperands,
     /* 102439 */     // GIR_Coverage, 17088,
     /* 102439 */     GIR_EraseRootFromParent_Done,
     /* 102440 */   // Label 2178: @102440
     /* 102440 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(102471), // Rule ID 17089 //
     /* 102445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 102450 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102457 */     // (intrinsic_void 14515:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 102457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 102460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102469 */     GIR_RootConstrainSelectedInstOperands,
     /* 102470 */     // GIR_Coverage, 17089,
     /* 102470 */     GIR_EraseRootFromParent_Done,
     /* 102471 */   // Label 2179: @102471
     /* 102471 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(102502), // Rule ID 17123 //
     /* 102476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 102484 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102491 */     // (intrinsic_void 14948:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 102491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 102494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102500 */     GIR_RootConstrainSelectedInstOperands,
     /* 102501 */     // GIR_Coverage, 17123,
     /* 102501 */     GIR_EraseRootFromParent_Done,
     /* 102502 */   // Label 2180: @102502
     /* 102502 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(102533), // Rule ID 17124 //
     /* 102507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 102515 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102522 */     // (intrinsic_void 14949:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 102522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 102525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102531 */     GIR_RootConstrainSelectedInstOperands,
     /* 102532 */     // GIR_Coverage, 17124,
     /* 102532 */     GIR_EraseRootFromParent_Done,
     /* 102533 */   // Label 2181: @102533
     /* 102533 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(102564), // Rule ID 17125 //
     /* 102538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 102546 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102553 */     // (intrinsic_void 14950:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 102553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 102556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102562 */     GIR_RootConstrainSelectedInstOperands,
     /* 102563 */     // GIR_Coverage, 17125,
     /* 102563 */     GIR_EraseRootFromParent_Done,
     /* 102564 */   // Label 2182: @102564
     /* 102564 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(102595), // Rule ID 17126 //
     /* 102569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 102577 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102584 */     // (intrinsic_void 14951:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 102584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 102587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102593 */     GIR_RootConstrainSelectedInstOperands,
     /* 102594 */     // GIR_Coverage, 17126,
     /* 102594 */     GIR_EraseRootFromParent_Done,
     /* 102595 */   // Label 2183: @102595
     /* 102595 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(102626), // Rule ID 17131 //
     /* 102600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 102603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 102608 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102615 */     // (intrinsic_void 14607:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 102615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 102618 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102624 */     GIR_RootConstrainSelectedInstOperands,
     /* 102625 */     // GIR_Coverage, 17131,
     /* 102625 */     GIR_EraseRootFromParent_Done,
     /* 102626 */   // Label 2184: @102626
     /* 102626 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(102657), // Rule ID 17132 //
     /* 102631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 102634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 102639 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102646 */     // (intrinsic_void 14608:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 102646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 102649 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102655 */     GIR_RootConstrainSelectedInstOperands,
     /* 102656 */     // GIR_Coverage, 17132,
     /* 102656 */     GIR_EraseRootFromParent_Done,
     /* 102657 */   // Label 2185: @102657
     /* 102657 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(102689), // Rule ID 114 //
     /* 102662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102670 */     // MIs[0] src
     /* 102670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102678 */     // (intrinsic_void 14520:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 102678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 102681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102687 */     GIR_RootConstrainSelectedInstOperands,
     /* 102688 */     // GIR_Coverage, 114,
     /* 102688 */     GIR_EraseRootFromParent_Done,
     /* 102689 */   // Label 2186: @102689
     /* 102689 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(102721), // Rule ID 116 //
     /* 102694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102702 */     // MIs[0] src
     /* 102702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102710 */     // (intrinsic_void 14520:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 102710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 102713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102719 */     GIR_RootConstrainSelectedInstOperands,
     /* 102720 */     // GIR_Coverage, 116,
     /* 102720 */     GIR_EraseRootFromParent_Done,
     /* 102721 */   // Label 2187: @102721
     /* 102721 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(102753), // Rule ID 126 //
     /* 102726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 102729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102734 */     // MIs[0] src
     /* 102734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 102738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102742 */     // (intrinsic_void 14905:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 102742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 102745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102751 */     GIR_RootConstrainSelectedInstOperands,
     /* 102752 */     // GIR_Coverage, 126,
     /* 102752 */     GIR_EraseRootFromParent_Done,
     /* 102753 */   // Label 2188: @102753
     /* 102753 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(102785), // Rule ID 127 //
     /* 102758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 102761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102766 */     // MIs[0] src
     /* 102766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102774 */     // (intrinsic_void 14905:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 102774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 102777 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102783 */     GIR_RootConstrainSelectedInstOperands,
     /* 102784 */     // GIR_Coverage, 127,
     /* 102784 */     GIR_EraseRootFromParent_Done,
     /* 102785 */   // Label 2189: @102785
     /* 102785 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(102817), // Rule ID 128 //
     /* 102790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 102793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102798 */     // MIs[0] src
     /* 102798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102806 */     // (intrinsic_void 14905:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 102806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 102809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102815 */     GIR_RootConstrainSelectedInstOperands,
     /* 102816 */     // GIR_Coverage, 128,
     /* 102816 */     GIR_EraseRootFromParent_Done,
     /* 102817 */   // Label 2190: @102817
     /* 102817 */   GIM_Reject,
     /* 102818 */ // Label 2138: @102818
     /* 102818 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(105812),
     /* 102823 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 102826 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(102872), // Rule ID 165 //
     /* 102831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 102839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 102842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 102846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102857 */     // (intrinsic_w_chain:{ *:[i8] } 14600:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 102857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm),
     /* 102860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102870 */     GIR_RootConstrainSelectedInstOperands,
     /* 102871 */     // GIR_Coverage, 165,
     /* 102871 */     GIR_EraseRootFromParent_Done,
     /* 102872 */   // Label 2192: @102872
     /* 102872 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(102918), // Rule ID 166 //
     /* 102877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 102885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 102888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102903 */     // (intrinsic_w_chain:{ *:[i16] } 14599:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 102903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm),
     /* 102906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102916 */     GIR_RootConstrainSelectedInstOperands,
     /* 102917 */     // GIR_Coverage, 166,
     /* 102917 */     GIR_EraseRootFromParent_Done,
     /* 102918 */   // Label 2193: @102918
     /* 102918 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(102964), // Rule ID 167 //
     /* 102923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 102931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102949 */     // (intrinsic_w_chain:{ *:[i32] } 14601:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 102949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm),
     /* 102952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102962 */     GIR_RootConstrainSelectedInstOperands,
     /* 102963 */     // GIR_Coverage, 167,
     /* 102963 */     GIR_EraseRootFromParent_Done,
     /* 102964 */   // Label 2194: @102964
     /* 102964 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(103010), // Rule ID 168 //
     /* 102969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 102977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102995 */     // (intrinsic_w_chain:{ *:[i64] } 14598:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 102995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm),
     /* 102998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103008 */     GIR_RootConstrainSelectedInstOperands,
     /* 103009 */     // GIR_Coverage, 168,
     /* 103009 */     GIR_EraseRootFromParent_Done,
     /* 103010 */   // Label 2195: @103010
     /* 103010 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(103056), // Rule ID 170 //
     /* 103015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103041 */     // (intrinsic_w_chain:{ *:[i8] } 14600:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm_EVEX:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm_EVEX),
     /* 103044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103054 */     GIR_RootConstrainSelectedInstOperands,
     /* 103055 */     // GIR_Coverage, 170,
     /* 103055 */     GIR_EraseRootFromParent_Done,
     /* 103056 */   // Label 2196: @103056
     /* 103056 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(103102), // Rule ID 171 //
     /* 103061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103087 */     // (intrinsic_w_chain:{ *:[i16] } 14599:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm_EVEX),
     /* 103090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103100 */     GIR_RootConstrainSelectedInstOperands,
     /* 103101 */     // GIR_Coverage, 171,
     /* 103101 */     GIR_EraseRootFromParent_Done,
     /* 103102 */   // Label 2197: @103102
     /* 103102 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(103148), // Rule ID 172 //
     /* 103107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103133 */     // (intrinsic_w_chain:{ *:[i32] } 14601:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm_EVEX),
     /* 103136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103146 */     GIR_RootConstrainSelectedInstOperands,
     /* 103147 */     // GIR_Coverage, 172,
     /* 103147 */     GIR_EraseRootFromParent_Done,
     /* 103148 */   // Label 2198: @103148
     /* 103148 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(103194), // Rule ID 173 //
     /* 103153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103179 */     // (intrinsic_w_chain:{ *:[i64] } 14598:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm_EVEX),
     /* 103182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103192 */     GIR_RootConstrainSelectedInstOperands,
     /* 103193 */     // GIR_Coverage, 173,
     /* 103193 */     GIR_EraseRootFromParent_Done,
     /* 103194 */   // Label 2199: @103194
     /* 103194 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(103240), // Rule ID 2951 //
     /* 103199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103225 */     // (intrinsic_w_chain:{ *:[v16i8] } 14746:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUrm),
     /* 103228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103238 */     GIR_RootConstrainSelectedInstOperands,
     /* 103239 */     // GIR_Coverage, 2951,
     /* 103239 */     GIR_EraseRootFromParent_Done,
     /* 103240 */   // Label 2200: @103240
     /* 103240 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(103286), // Rule ID 2952 //
     /* 103245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_ldu_dq_256),
     /* 103253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103271 */     // (intrinsic_w_chain:{ *:[v32i8] } 13367:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 103271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUYrm),
     /* 103274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103284 */     GIR_RootConstrainSelectedInstOperands,
     /* 103285 */     // GIR_Coverage, 2952,
     /* 103285 */     GIR_EraseRootFromParent_Done,
     /* 103286 */   // Label 2201: @103286
     /* 103286 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(103332), // Rule ID 2953 //
     /* 103291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE3),
     /* 103294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103317 */     // (intrinsic_w_chain:{ *:[v16i8] } 14746:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDDQUrm),
     /* 103320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103330 */     GIR_RootConstrainSelectedInstOperands,
     /* 103331 */     // GIR_Coverage, 2953,
     /* 103331 */     GIR_EraseRootFromParent_Done,
     /* 103332 */   // Label 2202: @103332
     /* 103332 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(103378), // Rule ID 3543 //
     /* 103337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps128),
     /* 103345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103363 */     // (intrinsic_w_chain:{ *:[v4f32] } 14909:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSrm),
     /* 103366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103376 */     GIR_RootConstrainSelectedInstOperands,
     /* 103377 */     // GIR_Coverage, 3543,
     /* 103377 */     GIR_EraseRootFromParent_Done,
     /* 103378 */   // Label 2203: @103378
     /* 103378 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(103424), // Rule ID 3544 //
     /* 103383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps256),
     /* 103391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103409 */     // (intrinsic_w_chain:{ *:[v8f32] } 14910:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSYrm),
     /* 103412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103422 */     GIR_RootConstrainSelectedInstOperands,
     /* 103423 */     // GIR_Coverage, 3544,
     /* 103423 */     GIR_EraseRootFromParent_Done,
     /* 103424 */   // Label 2204: @103424
     /* 103424 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(103470), // Rule ID 3545 //
     /* 103429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps128),
     /* 103437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103455 */     // (intrinsic_w_chain:{ *:[v4f32] } 14911:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSrm),
     /* 103458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103468 */     GIR_RootConstrainSelectedInstOperands,
     /* 103469 */     // GIR_Coverage, 3545,
     /* 103469 */     GIR_EraseRootFromParent_Done,
     /* 103470 */   // Label 2205: @103470
     /* 103470 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(103516), // Rule ID 3546 //
     /* 103475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps256),
     /* 103483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103501 */     // (intrinsic_w_chain:{ *:[v8f32] } 14912:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSYrm),
     /* 103504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103506 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103514 */     GIR_RootConstrainSelectedInstOperands,
     /* 103515 */     // GIR_Coverage, 3546,
     /* 103515 */     GIR_EraseRootFromParent_Done,
     /* 103516 */   // Label 2206: @103516
     /* 103516 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(103562), // Rule ID 3547 //
     /* 103521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps128),
     /* 103529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103547 */     // (intrinsic_w_chain:{ *:[v4f32] } 14913:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSrm),
     /* 103550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103552 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103560 */     GIR_RootConstrainSelectedInstOperands,
     /* 103561 */     // GIR_Coverage, 3547,
     /* 103561 */     GIR_EraseRootFromParent_Done,
     /* 103562 */   // Label 2207: @103562
     /* 103562 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(103608), // Rule ID 3548 //
     /* 103567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps256),
     /* 103575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103593 */     // (intrinsic_w_chain:{ *:[v8f32] } 14914:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSYrm),
     /* 103596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103606 */     GIR_RootConstrainSelectedInstOperands,
     /* 103607 */     // GIR_Coverage, 3548,
     /* 103607 */     GIR_EraseRootFromParent_Done,
     /* 103608 */   // Label 2208: @103608
     /* 103608 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(103654), // Rule ID 3549 //
     /* 103613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps128),
     /* 103621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103639 */     // (intrinsic_w_chain:{ *:[v4f32] } 14915:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSrm),
     /* 103642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103652 */     GIR_RootConstrainSelectedInstOperands,
     /* 103653 */     // GIR_Coverage, 3549,
     /* 103653 */     GIR_EraseRootFromParent_Done,
     /* 103654 */   // Label 2209: @103654
     /* 103654 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(103700), // Rule ID 3550 //
     /* 103659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps256),
     /* 103667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103685 */     // (intrinsic_w_chain:{ *:[v8f32] } 14916:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSYrm),
     /* 103688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103698 */     GIR_RootConstrainSelectedInstOperands,
     /* 103699 */     // GIR_Coverage, 3550,
     /* 103699 */     GIR_EraseRootFromParent_Done,
     /* 103700 */   // Label 2210: @103700
     /* 103700 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(103746), // Rule ID 3551 //
     /* 103705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps128),
     /* 103713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103731 */     // (intrinsic_w_chain:{ *:[v4f32] } 14917:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSrm),
     /* 103734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103744 */     GIR_RootConstrainSelectedInstOperands,
     /* 103745 */     // GIR_Coverage, 3551,
     /* 103745 */     GIR_EraseRootFromParent_Done,
     /* 103746 */   // Label 2211: @103746
     /* 103746 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(103792), // Rule ID 3552 //
     /* 103751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps256),
     /* 103759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103777 */     // (intrinsic_w_chain:{ *:[v8f32] } 14918:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSYrm),
     /* 103780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103790 */     GIR_RootConstrainSelectedInstOperands,
     /* 103791 */     // GIR_Coverage, 3552,
     /* 103791 */     GIR_EraseRootFromParent_Done,
     /* 103792 */   // Label 2212: @103792
     /* 103792 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(103838), // Rule ID 3553 //
     /* 103797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps128),
     /* 103805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103823 */     // (intrinsic_w_chain:{ *:[v4f32] } 14919:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSrm),
     /* 103826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103836 */     GIR_RootConstrainSelectedInstOperands,
     /* 103837 */     // GIR_Coverage, 3553,
     /* 103837 */     GIR_EraseRootFromParent_Done,
     /* 103838 */   // Label 2213: @103838
     /* 103838 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(103884), // Rule ID 3554 //
     /* 103843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps256),
     /* 103851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103869 */     // (intrinsic_w_chain:{ *:[v8f32] } 14920:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSYrm),
     /* 103872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103882 */     GIR_RootConstrainSelectedInstOperands,
     /* 103883 */     // GIR_Coverage, 3554,
     /* 103883 */     GIR_EraseRootFromParent_Done,
     /* 103884 */   // Label 2214: @103884
     /* 103884 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(103930), // Rule ID 16753 //
     /* 103889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 103892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb512),
     /* 103897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v64s8,
     /* 103900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 103904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103915 */     // (intrinsic_w_chain:{ *:[v64i8] } 13623:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /* 103915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZm),
     /* 103918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103928 */     GIR_RootConstrainSelectedInstOperands,
     /* 103929 */     // GIR_Coverage, 16753,
     /* 103929 */     GIR_EraseRootFromParent_Done,
     /* 103930 */   // Label 2215: @103930
     /* 103930 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(103976), // Rule ID 16756 //
     /* 103935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb128),
     /* 103943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 103950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103961 */     // (intrinsic_w_chain:{ *:[v16i8] } 13621:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ128m:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ128m),
     /* 103964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103974 */     GIR_RootConstrainSelectedInstOperands,
     /* 103975 */     // GIR_Coverage, 16756,
     /* 103975 */     GIR_EraseRootFromParent_Done,
     /* 103976 */   // Label 2216: @103976
     /* 103976 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(104022), // Rule ID 16759 //
     /* 103981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb256),
     /* 103989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 103996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104007 */     // (intrinsic_w_chain:{ *:[v32i8] } 13622:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ256m:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 104007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ256m),
     /* 104010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104020 */     GIR_RootConstrainSelectedInstOperands,
     /* 104021 */     // GIR_Coverage, 16759,
     /* 104021 */     GIR_EraseRootFromParent_Done,
     /* 104022 */   // Label 2217: @104022
     /* 104022 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(104068), // Rule ID 16762 //
     /* 104027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw512),
     /* 104035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 104038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104053 */     // (intrinsic_w_chain:{ *:[v32i16] } 13632:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 104053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZm),
     /* 104056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104066 */     GIR_RootConstrainSelectedInstOperands,
     /* 104067 */     // GIR_Coverage, 16762,
     /* 104067 */     GIR_EraseRootFromParent_Done,
     /* 104068 */   // Label 2218: @104068
     /* 104068 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(104114), // Rule ID 16765 //
     /* 104073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw128),
     /* 104081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 104084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104099 */     // (intrinsic_w_chain:{ *:[v8i16] } 13630:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ128m:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 104099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ128m),
     /* 104102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104112 */     GIR_RootConstrainSelectedInstOperands,
     /* 104113 */     // GIR_Coverage, 16765,
     /* 104113 */     GIR_EraseRootFromParent_Done,
     /* 104114 */   // Label 2219: @104114
     /* 104114 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(104160), // Rule ID 16768 //
     /* 104119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw256),
     /* 104127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 104130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104145 */     // (intrinsic_w_chain:{ *:[v16i16] } 13631:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ256m:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 104145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ256m),
     /* 104148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104158 */     GIR_RootConstrainSelectedInstOperands,
     /* 104159 */     // GIR_Coverage, 16768,
     /* 104159 */     GIR_EraseRootFromParent_Done,
     /* 104160 */   // Label 2220: @104160
     /* 104160 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(104206), // Rule ID 16771 //
     /* 104165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd512),
     /* 104173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 104176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104191 */     // (intrinsic_w_chain:{ *:[v16i32] } 13626:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 104191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZm),
     /* 104194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104204 */     GIR_RootConstrainSelectedInstOperands,
     /* 104205 */     // GIR_Coverage, 16771,
     /* 104205 */     GIR_EraseRootFromParent_Done,
     /* 104206 */   // Label 2221: @104206
     /* 104206 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(104252), // Rule ID 16774 //
     /* 104211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd128),
     /* 104219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104237 */     // (intrinsic_w_chain:{ *:[v4i32] } 13624:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ128m:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 104237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ128m),
     /* 104240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104250 */     GIR_RootConstrainSelectedInstOperands,
     /* 104251 */     // GIR_Coverage, 16774,
     /* 104251 */     GIR_EraseRootFromParent_Done,
     /* 104252 */   // Label 2222: @104252
     /* 104252 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(104298), // Rule ID 16777 //
     /* 104257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd256),
     /* 104265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104283 */     // (intrinsic_w_chain:{ *:[v8i32] } 13625:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ256m:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 104283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ256m),
     /* 104286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104296 */     GIR_RootConstrainSelectedInstOperands,
     /* 104297 */     // GIR_Coverage, 16777,
     /* 104297 */     GIR_EraseRootFromParent_Done,
     /* 104298 */   // Label 2223: @104298
     /* 104298 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(104344), // Rule ID 16780 //
     /* 104303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq512),
     /* 104311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 104314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104329 */     // (intrinsic_w_chain:{ *:[v8i64] } 13629:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 104329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZm),
     /* 104332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104342 */     GIR_RootConstrainSelectedInstOperands,
     /* 104343 */     // GIR_Coverage, 16780,
     /* 104343 */     GIR_EraseRootFromParent_Done,
     /* 104344 */   // Label 2224: @104344
     /* 104344 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(104390), // Rule ID 16783 //
     /* 104349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq128),
     /* 104357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 104360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104375 */     // (intrinsic_w_chain:{ *:[v2i64] } 13627:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ128m:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /* 104375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ128m),
     /* 104378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104388 */     GIR_RootConstrainSelectedInstOperands,
     /* 104389 */     // GIR_Coverage, 16783,
     /* 104389 */     GIR_EraseRootFromParent_Done,
     /* 104390 */   // Label 2225: @104390
     /* 104390 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(104436), // Rule ID 16786 //
     /* 104395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq256),
     /* 104403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 104406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104421 */     // (intrinsic_w_chain:{ *:[v4i64] } 13628:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ256m:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 104421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ256m),
     /* 104424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104434 */     GIR_RootConstrainSelectedInstOperands,
     /* 104435 */     // GIR_Coverage, 16786,
     /* 104435 */     GIR_EraseRootFromParent_Done,
     /* 104436 */   // Label 2226: @104436
     /* 104436 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(104482), // Rule ID 17094 //
     /* 104441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104449 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104467 */     // (intrinsic_void 14953:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD),
     /* 104470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104480 */     GIR_RootConstrainSelectedInstOperands,
     /* 104481 */     // GIR_Coverage, 17094,
     /* 104481 */     GIR_EraseRootFromParent_Done,
     /* 104482 */   // Label 2227: @104482
     /* 104482 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(104528), // Rule ID 17095 //
     /* 104487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104513 */     // (intrinsic_void 14954:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ),
     /* 104516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104526 */     GIR_RootConstrainSelectedInstOperands,
     /* 104527 */     // GIR_Coverage, 17095,
     /* 104527 */     GIR_EraseRootFromParent_Done,
     /* 104528 */   // Label 2228: @104528
     /* 104528 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(104574), // Rule ID 17096 //
     /* 104533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104541 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104559 */     // (intrinsic_void 14955:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD),
     /* 104562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104566 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104572 */     GIR_RootConstrainSelectedInstOperands,
     /* 104573 */     // GIR_Coverage, 17096,
     /* 104573 */     GIR_EraseRootFromParent_Done,
     /* 104574 */   // Label 2229: @104574
     /* 104574 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(104620), // Rule ID 17097 //
     /* 104579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104587 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104605 */     // (intrinsic_void 14956:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ),
     /* 104608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104612 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104618 */     GIR_RootConstrainSelectedInstOperands,
     /* 104619 */     // GIR_Coverage, 17097,
     /* 104619 */     GIR_EraseRootFromParent_Done,
     /* 104620 */   // Label 2230: @104620
     /* 104620 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(104666), // Rule ID 17098 //
     /* 104625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104633 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104651 */     // (intrinsic_void 14953:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD_EVEX),
     /* 104654 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104664 */     GIR_RootConstrainSelectedInstOperands,
     /* 104665 */     // GIR_Coverage, 17098,
     /* 104665 */     GIR_EraseRootFromParent_Done,
     /* 104666 */   // Label 2231: @104666
     /* 104666 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(104712), // Rule ID 17099 //
     /* 104671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104679 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104697 */     // (intrinsic_void 14954:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ_EVEX),
     /* 104700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104710 */     GIR_RootConstrainSelectedInstOperands,
     /* 104711 */     // GIR_Coverage, 17099,
     /* 104711 */     GIR_EraseRootFromParent_Done,
     /* 104712 */   // Label 2232: @104712
     /* 104712 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(104758), // Rule ID 17100 //
     /* 104717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104725 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104743 */     // (intrinsic_void 14955:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD_EVEX),
     /* 104746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104756 */     GIR_RootConstrainSelectedInstOperands,
     /* 104757 */     // GIR_Coverage, 17100,
     /* 104757 */     GIR_EraseRootFromParent_Done,
     /* 104758 */   // Label 2233: @104758
     /* 104758 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(104804), // Rule ID 17101 //
     /* 104763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104771 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104789 */     // (intrinsic_void 14956:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ_EVEX),
     /* 104792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104802 */     GIR_RootConstrainSelectedInstOperands,
     /* 104803 */     // GIR_Coverage, 17101,
     /* 104803 */     GIR_EraseRootFromParent_Done,
     /* 104804 */   // Label 2234: @104804
     /* 104804 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(104850), // Rule ID 17127 //
     /* 104809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_Not64BitMode),
     /* 104812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104817 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104835 */     // (intrinsic_void 14517:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID32 GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 104835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID32),
     /* 104838 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 104840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 104844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104848 */     GIR_RootConstrainSelectedInstOperands,
     /* 104849 */     // GIR_Coverage, 17127,
     /* 104849 */     GIR_EraseRootFromParent_Done,
     /* 104850 */   // Label 2235: @104850
     /* 104850 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(104942), // Rule ID 22379 //
     /* 104855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_NoEGPR),
     /* 104858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104863 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104881 */     // (intrinsic_void 14517:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64 (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 104881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 104888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 104897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104911 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104914 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 104920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 104925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 104930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64),
     /* 104933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 104940 */     GIR_RootConstrainSelectedInstOperands,
     /* 104941 */     // GIR_Coverage, 22379,
     /* 104941 */     GIR_EraseRootFromParent_Done,
     /* 104942 */   // Label 2236: @104942
     /* 104942 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(105034), // Rule ID 22380 //
     /* 104947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasINVPCID),
     /* 104950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104955 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104973 */     // (intrinsic_void 14517:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64_EVEX (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 104973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 104980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104985 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 104989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 105006 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64_EVEX),
     /* 105025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105032 */     GIR_RootConstrainSelectedInstOperands,
     /* 105033 */     // GIR_Coverage, 22380,
     /* 105033 */     GIR_EraseRootFromParent_Done,
     /* 105034 */   // Label 2237: @105034
     /* 105034 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(105080), // Rule ID 131 //
     /* 105039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_NoEGPR),
     /* 105042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105065 */     // (intrinsic_void 14496:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32 addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32),
     /* 105068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105078 */     GIR_RootConstrainSelectedInstOperands,
     /* 105079 */     // GIR_Coverage, 131,
     /* 105079 */     GIR_EraseRootFromParent_Done,
     /* 105080 */   // Label 2238: @105080
     /* 105080 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(105126), // Rule ID 132 //
     /* 105085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_In64BitMode_NoEGPR),
     /* 105088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105111 */     // (intrinsic_void 14497:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64 addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64),
     /* 105114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105124 */     GIR_RootConstrainSelectedInstOperands,
     /* 105125 */     // GIR_Coverage, 132,
     /* 105125 */     GIR_EraseRootFromParent_Done,
     /* 105126 */   // Label 2239: @105126
     /* 105126 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(105172), // Rule ID 133 //
     /* 105131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105157 */     // (intrinsic_void 14496:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32_EVEX),
     /* 105160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105170 */     GIR_RootConstrainSelectedInstOperands,
     /* 105171 */     // GIR_Coverage, 133,
     /* 105171 */     GIR_EraseRootFromParent_Done,
     /* 105172 */   // Label 2240: @105172
     /* 105172 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(105218), // Rule ID 134 //
     /* 105177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105203 */     // (intrinsic_void 14497:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64_EVEX),
     /* 105206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105216 */     GIR_RootConstrainSelectedInstOperands,
     /* 105217 */     // GIR_Coverage, 134,
     /* 105217 */     GIR_EraseRootFromParent_Done,
     /* 105218 */   // Label 2241: @105218
     /* 105218 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(105265), // Rule ID 135 //
     /* 105223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_NoEGPR),
     /* 105226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105231 */     // MIs[0] dst
     /* 105231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105250 */     // (intrinsic_void 14597:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32 GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32),
     /* 105253 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105263 */     GIR_RootConstrainSelectedInstOperands,
     /* 105264 */     // GIR_Coverage, 135,
     /* 105264 */     GIR_EraseRootFromParent_Done,
     /* 105265 */   // Label 2242: @105265
     /* 105265 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(105312), // Rule ID 136 //
     /* 105270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR),
     /* 105273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105278 */     // MIs[0] dst
     /* 105278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105297 */     // (intrinsic_void 14597:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64 GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64),
     /* 105300 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105310 */     GIR_RootConstrainSelectedInstOperands,
     /* 105311 */     // GIR_Coverage, 136,
     /* 105311 */     GIR_EraseRootFromParent_Done,
     /* 105312 */   // Label 2243: @105312
     /* 105312 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(105359), // Rule ID 137 //
     /* 105317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105325 */     // MIs[0] dst
     /* 105325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105344 */     // (intrinsic_void 14597:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32_EVEX GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32_EVEX),
     /* 105347 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105357 */     GIR_RootConstrainSelectedInstOperands,
     /* 105358 */     // GIR_Coverage, 137,
     /* 105358 */     GIR_EraseRootFromParent_Done,
     /* 105359 */   // Label 2244: @105359
     /* 105359 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(105406), // Rule ID 138 //
     /* 105364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105372 */     // MIs[0] dst
     /* 105372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105391 */     // (intrinsic_void 14597:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64_EVEX GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64_EVEX),
     /* 105394 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105404 */     GIR_RootConstrainSelectedInstOperands,
     /* 105405 */     // GIR_Coverage, 138,
     /* 105405 */     GIR_EraseRootFromParent_Done,
     /* 105406 */   // Label 2245: @105406
     /* 105406 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(105438), // Rule ID 17025 //
     /* 105411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 105414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 105419 */     // MIs[0] dst
     /* 105419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105422 */     // MIs[0] src
     /* 105422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105425 */     // (intrinsic_void 14903:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 105428 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105430 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105436 */     GIR_RootConstrainSelectedInstOperands,
     /* 105437 */     // GIR_Coverage, 17025,
     /* 105437 */     GIR_EraseRootFromParent_Done,
     /* 105438 */   // Label 2246: @105438
     /* 105438 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(105470), // Rule ID 17037 //
     /* 105443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 105446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 105451 */     // MIs[0] dst
     /* 105451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105454 */     // MIs[0] src
     /* 105454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105457 */     // (intrinsic_void 14842:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 105460 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105462 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105468 */     GIR_RootConstrainSelectedInstOperands,
     /* 105469 */     // GIR_Coverage, 17037,
     /* 105469 */     GIR_EraseRootFromParent_Done,
     /* 105470 */   // Label 2247: @105470
     /* 105470 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(105513), // Rule ID 17152 //
     /* 105475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 105480 */     // MIs[0] addr
     /* 105480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 105488 */     // MIs[0] accessinfo
     /* 105488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105491 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 105491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 105494 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 105496 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 105498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 105501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 105504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 105507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105511 */     GIR_RootConstrainSelectedInstOperands,
     /* 105512 */     // GIR_Coverage, 17152,
     /* 105512 */     GIR_EraseRootFromParent_Done,
     /* 105513 */   // Label 2248: @105513
     /* 105513 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(105553), // Rule ID 17078 //
     /* 105518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105540 */     // (intrinsic_w_chain:{ *:[i64] } 14907:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 105543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105551 */     GIR_RootConstrainSelectedInstOperands,
     /* 105552 */     // GIR_Coverage, 17078,
     /* 105552 */     GIR_EraseRootFromParent_Done,
     /* 105553 */   // Label 2249: @105553
     /* 105553 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(105593), // Rule ID 17082 //
     /* 105558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105580 */     // (intrinsic_w_chain:{ *:[i64] } 14907:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 105583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105591 */     GIR_RootConstrainSelectedInstOperands,
     /* 105592 */     // GIR_Coverage, 17082,
     /* 105592 */     GIR_EraseRootFromParent_Done,
     /* 105593 */   // Label 2250: @105593
     /* 105593 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(105630), // Rule ID 17090 //
     /* 105598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 105603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 105606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105617 */     // (intrinsic_w_chain:{ *:[i32] } 14623:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 105617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 105620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105622 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105628 */     GIR_RootConstrainSelectedInstOperands,
     /* 105629 */     // GIR_Coverage, 17090,
     /* 105629 */     GIR_EraseRootFromParent_Done,
     /* 105630 */   // Label 2251: @105630
     /* 105630 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(105667), // Rule ID 17091 //
     /* 105635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 105640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105654 */     // (intrinsic_w_chain:{ *:[i64] } 14624:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 105657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105659 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105665 */     GIR_RootConstrainSelectedInstOperands,
     /* 105666 */     // GIR_Coverage, 17091,
     /* 105666 */     GIR_EraseRootFromParent_Done,
     /* 105667 */   // Label 2252: @105667
     /* 105667 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(105731), // Rule ID 3086 //
     /* 105672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 105675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 105680 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 105690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 105694 */     // (intrinsic_void 14748:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 105694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105698 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105704 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 105708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105712 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 105722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 105725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105729 */     GIR_RootConstrainSelectedInstOperands,
     /* 105730 */     // GIR_Coverage, 3086,
     /* 105730 */     GIR_EraseRootFromParent_Done,
     /* 105731 */   // Label 2253: @105731
     /* 105731 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(105771), // Rule ID 17080 //
     /* 105736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105744 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105758 */     // (intrinsic_void 14908:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 105761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105769 */     GIR_RootConstrainSelectedInstOperands,
     /* 105770 */     // GIR_Coverage, 17080,
     /* 105770 */     GIR_EraseRootFromParent_Done,
     /* 105771 */   // Label 2254: @105771
     /* 105771 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(105811), // Rule ID 17084 //
     /* 105776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105784 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105798 */     // (intrinsic_void 14908:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 105801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105809 */     GIR_RootConstrainSelectedInstOperands,
     /* 105810 */     // GIR_Coverage, 17084,
     /* 105810 */     GIR_EraseRootFromParent_Done,
     /* 105811 */   // Label 2255: @105811
     /* 105811 */   GIM_Reject,
     /* 105812 */ // Label 2191: @105812
     /* 105812 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(109357),
     /* 105817 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 105820 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(105892), // Rule ID 123 //
     /* 105825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 105828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 105833 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105858 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 105862 */     // MIs[0] cntl
     /* 105862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 105865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105874 */     // (intrinsic_void 14524:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rmi GR32:{ *:[i32] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 105874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rmi),
     /* 105877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 105879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 105883 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 105885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105890 */     GIR_RootConstrainSelectedInstOperands,
     /* 105891 */     // GIR_Coverage, 123,
     /* 105891 */     GIR_EraseRootFromParent_Done,
     /* 105892 */   // Label 2257: @105892
     /* 105892 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(105964), // Rule ID 125 //
     /* 105897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 105900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 105905 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105926 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105930 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 105934 */     // MIs[0] cntl
     /* 105934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 105937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105946 */     // (intrinsic_void 14525:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rmi GR64:{ *:[i64] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 105946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rmi),
     /* 105949 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 105951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 105955 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 105957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105962 */     GIR_RootConstrainSelectedInstOperands,
     /* 105963 */     // GIR_Coverage, 125,
     /* 105963 */     GIR_EraseRootFromParent_Done,
     /* 105964 */   // Label 2258: @105964
     /* 105964 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(106019), // Rule ID 3387 //
     /* 105969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps),
     /* 105977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 105980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 105983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106002 */     // (intrinsic_w_chain:{ *:[v4f32] } 13370:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VMASKMOVPSrm:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSrm),
     /* 106005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106007 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106017 */     GIR_RootConstrainSelectedInstOperands,
     /* 106018 */     // GIR_Coverage, 3387,
     /* 106018 */     GIR_EraseRootFromParent_Done,
     /* 106019 */   // Label 2259: @106019
     /* 106019 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(106074), // Rule ID 3388 //
     /* 106024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps_256),
     /* 106032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106057 */     // (intrinsic_w_chain:{ *:[v8f32] } 13371:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VMASKMOVPSYrm:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYrm),
     /* 106060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106062 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106072 */     GIR_RootConstrainSelectedInstOperands,
     /* 106073 */     // GIR_Coverage, 3388,
     /* 106073 */     GIR_EraseRootFromParent_Done,
     /* 106074 */   // Label 2260: @106074
     /* 106074 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(106129), // Rule ID 3391 //
     /* 106079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd),
     /* 106087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106112 */     // (intrinsic_w_chain:{ *:[v2f64] } 13368:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VMASKMOVPDrm:{ *:[v2f64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDrm),
     /* 106115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106117 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106127 */     GIR_RootConstrainSelectedInstOperands,
     /* 106128 */     // GIR_Coverage, 3391,
     /* 106128 */     GIR_EraseRootFromParent_Done,
     /* 106129 */   // Label 2261: @106129
     /* 106129 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(106184), // Rule ID 3392 //
     /* 106134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd_256),
     /* 106142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106167 */     // (intrinsic_w_chain:{ *:[v4f64] } 13369:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VMASKMOVPDYrm:{ *:[v4f64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYrm),
     /* 106170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106172 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106182 */     GIR_RootConstrainSelectedInstOperands,
     /* 106183 */     // GIR_Coverage, 3392,
     /* 106183 */     GIR_EraseRootFromParent_Done,
     /* 106184 */   // Label 2262: @106184
     /* 106184 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(106239), // Rule ID 3465 //
     /* 106189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d),
     /* 106197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106222 */     // (intrinsic_w_chain:{ *:[v4i32] } 13668:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VPMASKMOVDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDrm),
     /* 106225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106227 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106237 */     GIR_RootConstrainSelectedInstOperands,
     /* 106238 */     // GIR_Coverage, 3465,
     /* 106238 */     GIR_EraseRootFromParent_Done,
     /* 106239 */   // Label 2263: @106239
     /* 106239 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(106294), // Rule ID 3466 //
     /* 106244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d_256),
     /* 106252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106277 */     // (intrinsic_w_chain:{ *:[v8i32] } 13669:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VPMASKMOVDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYrm),
     /* 106280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106282 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106292 */     GIR_RootConstrainSelectedInstOperands,
     /* 106293 */     // GIR_Coverage, 3466,
     /* 106293 */     GIR_EraseRootFromParent_Done,
     /* 106294 */   // Label 2264: @106294
     /* 106294 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(106349), // Rule ID 3469 //
     /* 106299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q),
     /* 106307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106332 */     // (intrinsic_w_chain:{ *:[v2i64] } 13670:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VPMASKMOVQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQrm),
     /* 106335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106347 */     GIR_RootConstrainSelectedInstOperands,
     /* 106348 */     // GIR_Coverage, 3469,
     /* 106348 */     GIR_EraseRootFromParent_Done,
     /* 106349 */   // Label 2265: @106349
     /* 106349 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(106404), // Rule ID 3470 //
     /* 106354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q_256),
     /* 106362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106387 */     // (intrinsic_w_chain:{ *:[v4i64] } 13671:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VPMASKMOVQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYrm),
     /* 106390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106392 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106402 */     GIR_RootConstrainSelectedInstOperands,
     /* 106403 */     // GIR_Coverage, 3470,
     /* 106403 */     GIR_EraseRootFromParent_Done,
     /* 106404 */   // Label 2266: @106404
     /* 106404 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(106459), // Rule ID 3389 //
     /* 106409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps),
     /* 106417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106442 */     // (intrinsic_void 13374:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMASKMOVPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 106442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSmr),
     /* 106445 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106451 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106457 */     GIR_RootConstrainSelectedInstOperands,
     /* 106458 */     // GIR_Coverage, 3389,
     /* 106458 */     GIR_EraseRootFromParent_Done,
     /* 106459 */   // Label 2267: @106459
     /* 106459 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(106514), // Rule ID 3390 //
     /* 106464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps_256),
     /* 106472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106497 */     // (intrinsic_void 13375:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMASKMOVPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 106497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYmr),
     /* 106500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106504 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106506 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106512 */     GIR_RootConstrainSelectedInstOperands,
     /* 106513 */     // GIR_Coverage, 3390,
     /* 106513 */     GIR_EraseRootFromParent_Done,
     /* 106514 */   // Label 2268: @106514
     /* 106514 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(106569), // Rule ID 3393 //
     /* 106519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd),
     /* 106527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106552 */     // (intrinsic_void 13372:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMASKMOVPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 106552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDmr),
     /* 106555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106561 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106567 */     GIR_RootConstrainSelectedInstOperands,
     /* 106568 */     // GIR_Coverage, 3393,
     /* 106568 */     GIR_EraseRootFromParent_Done,
     /* 106569 */   // Label 2269: @106569
     /* 106569 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(106624), // Rule ID 3394 //
     /* 106574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd_256),
     /* 106582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106607 */     // (intrinsic_void 13373:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMASKMOVPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 106607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYmr),
     /* 106610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106614 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106616 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106622 */     GIR_RootConstrainSelectedInstOperands,
     /* 106623 */     // GIR_Coverage, 3394,
     /* 106623 */     GIR_EraseRootFromParent_Done,
     /* 106624 */   // Label 2270: @106624
     /* 106624 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(106679), // Rule ID 3467 //
     /* 106629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d),
     /* 106637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106662 */     // (intrinsic_void 13672:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMASKMOVDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 106662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDmr),
     /* 106665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106671 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106677 */     GIR_RootConstrainSelectedInstOperands,
     /* 106678 */     // GIR_Coverage, 3467,
     /* 106678 */     GIR_EraseRootFromParent_Done,
     /* 106679 */   // Label 2271: @106679
     /* 106679 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(106734), // Rule ID 3468 //
     /* 106684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d_256),
     /* 106692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106717 */     // (intrinsic_void 13673:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMASKMOVDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 106717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYmr),
     /* 106720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106726 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106732 */     GIR_RootConstrainSelectedInstOperands,
     /* 106733 */     // GIR_Coverage, 3468,
     /* 106733 */     GIR_EraseRootFromParent_Done,
     /* 106734 */   // Label 2272: @106734
     /* 106734 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(106789), // Rule ID 3471 //
     /* 106739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q),
     /* 106747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106772 */     // (intrinsic_void 13674:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPMASKMOVQmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 106772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQmr),
     /* 106775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106781 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106787 */     GIR_RootConstrainSelectedInstOperands,
     /* 106788 */     // GIR_Coverage, 3471,
     /* 106788 */     GIR_EraseRootFromParent_Done,
     /* 106789 */   // Label 2273: @106789
     /* 106789 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(106844), // Rule ID 3472 //
     /* 106794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q_256),
     /* 106802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106827 */     // (intrinsic_void 13675:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPMASKMOVQYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 106827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYmr),
     /* 106830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106834 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106836 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106842 */     GIR_RootConstrainSelectedInstOperands,
     /* 106843 */     // GIR_Coverage, 3472,
     /* 106843 */     GIR_EraseRootFromParent_Done,
     /* 106844 */   // Label 2274: @106844
     /* 106844 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(106923), // Rule ID 17105 //
     /* 106849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 106852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave),
     /* 106857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106882 */     // (intrinsic_void 15012:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE addr:{ *:[iPTR] }:$dst)
     /* 106882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106886 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106892 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106900 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE),
     /* 106913 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106921 */     GIR_RootConstrainSelectedInstOperands,
     /* 106922 */     // GIR_Coverage, 17105,
     /* 106922 */     GIR_EraseRootFromParent_Done,
     /* 106923 */   // Label 2275: @106923
     /* 106923 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(107002), // Rule ID 17106 //
     /* 106928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 106931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave64),
     /* 106936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106961 */     // (intrinsic_void 15013:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 106961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106965 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106979 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE64),
     /* 106992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107000 */     GIR_RootConstrainSelectedInstOperands,
     /* 107001 */     // GIR_Coverage, 17106,
     /* 107001 */     GIR_EraseRootFromParent_Done,
     /* 107002 */   // Label 2276: @107002
     /* 107002 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(107081), // Rule ID 17107 //
     /* 107007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor),
     /* 107015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107040 */     // (intrinsic_void 15008:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR addr:{ *:[iPTR] }:$dst)
     /* 107040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107044 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107058 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR),
     /* 107071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107079 */     GIR_RootConstrainSelectedInstOperands,
     /* 107080 */     // GIR_Coverage, 17107,
     /* 107080 */     GIR_EraseRootFromParent_Done,
     /* 107081 */   // Label 2277: @107081
     /* 107081 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(107160), // Rule ID 17108 //
     /* 107086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor64),
     /* 107094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107119 */     // (intrinsic_void 15009:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR64 addr:{ *:[iPTR] }:$dst)
     /* 107119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107123 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107137 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR64),
     /* 107150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107158 */     GIR_RootConstrainSelectedInstOperands,
     /* 107159 */     // GIR_Coverage, 17108,
     /* 107159 */     GIR_EraseRootFromParent_Done,
     /* 107160 */   // Label 2278: @107160
     /* 107160 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(107239), // Rule ID 17109 //
     /* 107165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT),
     /* 107168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt),
     /* 107173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107198 */     // (intrinsic_void 15016:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT addr:{ *:[iPTR] }:$dst)
     /* 107198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107202 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107216 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT),
     /* 107229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107237 */     GIR_RootConstrainSelectedInstOperands,
     /* 107238 */     // GIR_Coverage, 17109,
     /* 107238 */     GIR_EraseRootFromParent_Done,
     /* 107239 */   // Label 2279: @107239
     /* 107239 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(107318), // Rule ID 17110 //
     /* 107244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT_In64BitMode),
     /* 107247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt64),
     /* 107252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107277 */     // (intrinsic_void 15017:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT64 addr:{ *:[iPTR] }:$dst)
     /* 107277 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107281 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107295 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT64),
     /* 107308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107316 */     GIR_RootConstrainSelectedInstOperands,
     /* 107317 */     // GIR_Coverage, 17110,
     /* 107317 */     GIR_EraseRootFromParent_Done,
     /* 107318 */   // Label 2280: @107318
     /* 107318 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(107397), // Rule ID 17111 //
     /* 107323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC),
     /* 107326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec),
     /* 107331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107356 */     // (intrinsic_void 15014:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC addr:{ *:[iPTR] }:$dst)
     /* 107356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107360 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107366 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107374 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC),
     /* 107387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107395 */     GIR_RootConstrainSelectedInstOperands,
     /* 107396 */     // GIR_Coverage, 17111,
     /* 107396 */     GIR_EraseRootFromParent_Done,
     /* 107397 */   // Label 2281: @107397
     /* 107397 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(107476), // Rule ID 17112 //
     /* 107402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC_In64BitMode),
     /* 107405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec64),
     /* 107410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107435 */     // (intrinsic_void 15015:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC64 addr:{ *:[iPTR] }:$dst)
     /* 107435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107439 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107453 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC64),
     /* 107466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107474 */     GIR_RootConstrainSelectedInstOperands,
     /* 107475 */     // GIR_Coverage, 17112,
     /* 107475 */     GIR_EraseRootFromParent_Done,
     /* 107476 */   // Label 2282: @107476
     /* 107476 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(107555), // Rule ID 17113 //
     /* 107481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves),
     /* 107489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107514 */     // (intrinsic_void 15018:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES addr:{ *:[iPTR] }:$dst)
     /* 107514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107518 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107524 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107532 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES),
     /* 107545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107553 */     GIR_RootConstrainSelectedInstOperands,
     /* 107554 */     // GIR_Coverage, 17113,
     /* 107554 */     GIR_EraseRootFromParent_Done,
     /* 107555 */   // Label 2283: @107555
     /* 107555 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(107634), // Rule ID 17114 //
     /* 107560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves64),
     /* 107568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107593 */     // (intrinsic_void 15019:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES64 addr:{ *:[iPTR] }:$dst)
     /* 107593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107597 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107611 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES64),
     /* 107624 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107632 */     GIR_RootConstrainSelectedInstOperands,
     /* 107633 */     // GIR_Coverage, 17114,
     /* 107633 */     GIR_EraseRootFromParent_Done,
     /* 107634 */   // Label 2284: @107634
     /* 107634 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(107713), // Rule ID 17115 //
     /* 107639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors),
     /* 107647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107672 */     // (intrinsic_void 15010:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS addr:{ *:[iPTR] }:$dst)
     /* 107672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107676 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107690 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS),
     /* 107703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107711 */     GIR_RootConstrainSelectedInstOperands,
     /* 107712 */     // GIR_Coverage, 17115,
     /* 107712 */     GIR_EraseRootFromParent_Done,
     /* 107713 */   // Label 2285: @107713
     /* 107713 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(107792), // Rule ID 17116 //
     /* 107718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES_In64BitMode),
     /* 107721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors64),
     /* 107726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107751 */     // (intrinsic_void 15011:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS64 addr:{ *:[iPTR] }:$dst)
     /* 107751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107755 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107761 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107769 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS64),
     /* 107782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107790 */     GIR_RootConstrainSelectedInstOperands,
     /* 107791 */     // GIR_Coverage, 17116,
     /* 107791 */     GIR_EraseRootFromParent_Done,
     /* 107792 */   // Label 2286: @107792
     /* 107792 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(107829), // Rule ID 17004 //
     /* 107797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 107805 */     // MIs[0] src1
     /* 107805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107808 */     // MIs[0] src2
     /* 107808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107811 */     // MIs[0] src3
     /* 107811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107814 */     // (intrinsic_void 14860:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 107817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107821 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107827 */     GIR_RootConstrainSelectedInstOperands,
     /* 107828 */     // GIR_Coverage, 17004,
     /* 107828 */     GIR_EraseRootFromParent_Done,
     /* 107829 */   // Label 2287: @107829
     /* 107829 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(107866), // Rule ID 17005 //
     /* 107834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 107842 */     // MIs[0] src1
     /* 107842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107845 */     // MIs[0] src2
     /* 107845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107848 */     // MIs[0] src3
     /* 107848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107851 */     // (intrinsic_void 14862:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 107854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107858 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107864 */     GIR_RootConstrainSelectedInstOperands,
     /* 107865 */     // GIR_Coverage, 17005,
     /* 107865 */     GIR_EraseRootFromParent_Done,
     /* 107866 */   // Label 2288: @107866
     /* 107866 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(107903), // Rule ID 17006 //
     /* 107871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 107879 */     // MIs[0] src1
     /* 107879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107882 */     // MIs[0] src2
     /* 107882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107885 */     // MIs[0] src3
     /* 107885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107888 */     // (intrinsic_void 14864:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 107891 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107895 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107901 */     GIR_RootConstrainSelectedInstOperands,
     /* 107902 */     // GIR_Coverage, 17006,
     /* 107902 */     GIR_EraseRootFromParent_Done,
     /* 107903 */   // Label 2289: @107903
     /* 107903 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(107940), // Rule ID 17007 //
     /* 107908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 107916 */     // MIs[0] src1
     /* 107916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107919 */     // MIs[0] src2
     /* 107919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107922 */     // MIs[0] src3
     /* 107922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107925 */     // (intrinsic_void 14866:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 107928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107932 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107938 */     GIR_RootConstrainSelectedInstOperands,
     /* 107939 */     // GIR_Coverage, 17007,
     /* 107939 */     GIR_EraseRootFromParent_Done,
     /* 107940 */   // Label 2290: @107940
     /* 107940 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(107977), // Rule ID 17009 //
     /* 107945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 107948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 107953 */     // MIs[0] src1
     /* 107953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107956 */     // MIs[0] src2
     /* 107956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107959 */     // MIs[0] src3
     /* 107959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107962 */     // (intrinsic_void 14854:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 107965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107969 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107975 */     GIR_RootConstrainSelectedInstOperands,
     /* 107976 */     // GIR_Coverage, 17009,
     /* 107976 */     GIR_EraseRootFromParent_Done,
     /* 107977 */   // Label 2291: @107977
     /* 107977 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(108014), // Rule ID 17011 //
     /* 107982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 107985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 107990 */     // MIs[0] src1
     /* 107990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107993 */     // MIs[0] src2
     /* 107993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107996 */     // MIs[0] src3
     /* 107996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107999 */     // (intrinsic_void 14868:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 108002 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108006 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108012 */     GIR_RootConstrainSelectedInstOperands,
     /* 108013 */     // GIR_Coverage, 17011,
     /* 108013 */     GIR_EraseRootFromParent_Done,
     /* 108014 */   // Label 2292: @108014
     /* 108014 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(108051), // Rule ID 17014 //
     /* 108019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 108027 */     // MIs[0] src1
     /* 108027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108030 */     // MIs[0] src2
     /* 108030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108033 */     // MIs[0] src3
     /* 108033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108036 */     // (intrinsic_void 14836:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 108039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108043 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108049 */     GIR_RootConstrainSelectedInstOperands,
     /* 108050 */     // GIR_Coverage, 17014,
     /* 108050 */     GIR_EraseRootFromParent_Done,
     /* 108051 */   // Label 2293: @108051
     /* 108051 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(108088), // Rule ID 17015 //
     /* 108056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 108064 */     // MIs[0] src1
     /* 108064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108067 */     // MIs[0] src2
     /* 108067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108070 */     // MIs[0] src3
     /* 108070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108073 */     // (intrinsic_void 14838:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 108076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108078 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108080 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108086 */     GIR_RootConstrainSelectedInstOperands,
     /* 108087 */     // GIR_Coverage, 17015,
     /* 108087 */     GIR_EraseRootFromParent_Done,
     /* 108088 */   // Label 2294: @108088
     /* 108088 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(108125), // Rule ID 17016 //
     /* 108093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 108101 */     // MIs[0] src1
     /* 108101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108104 */     // MIs[0] src2
     /* 108104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108107 */     // MIs[0] src3
     /* 108107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108110 */     // (intrinsic_void 14856:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 108113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108115 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108117 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108123 */     GIR_RootConstrainSelectedInstOperands,
     /* 108124 */     // GIR_Coverage, 17016,
     /* 108124 */     GIR_EraseRootFromParent_Done,
     /* 108125 */   // Label 2295: @108125
     /* 108125 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(108162), // Rule ID 17017 //
     /* 108130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 108138 */     // MIs[0] src1
     /* 108138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108141 */     // MIs[0] src2
     /* 108141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108144 */     // MIs[0] src3
     /* 108144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108147 */     // (intrinsic_void 14858:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 108150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108152 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108154 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108160 */     GIR_RootConstrainSelectedInstOperands,
     /* 108161 */     // GIR_Coverage, 17017,
     /* 108161 */     GIR_EraseRootFromParent_Done,
     /* 108162 */   // Label 2296: @108162
     /* 108162 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(108199), // Rule ID 17018 //
     /* 108167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 108175 */     // MIs[0] src1
     /* 108175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108178 */     // MIs[0] src2
     /* 108178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108181 */     // MIs[0] src3
     /* 108181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108184 */     // (intrinsic_void 14870:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 108187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108191 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108197 */     GIR_RootConstrainSelectedInstOperands,
     /* 108198 */     // GIR_Coverage, 17018,
     /* 108198 */     GIR_EraseRootFromParent_Done,
     /* 108199 */   // Label 2297: @108199
     /* 108199 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(108236), // Rule ID 17019 //
     /* 108204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 108212 */     // MIs[0] src1
     /* 108212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108215 */     // MIs[0] src2
     /* 108215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108218 */     // MIs[0] src3
     /* 108218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108221 */     // (intrinsic_void 14872:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 108224 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108228 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108234 */     GIR_RootConstrainSelectedInstOperands,
     /* 108235 */     // GIR_Coverage, 17019,
     /* 108235 */     GIR_EraseRootFromParent_Done,
     /* 108236 */   // Label 2298: @108236
     /* 108236 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(108273), // Rule ID 17027 //
     /* 108241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 108244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 108249 */     // MIs[0] src1
     /* 108249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108252 */     // MIs[0] src2
     /* 108252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108255 */     // MIs[0] src3
     /* 108255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108258 */     // (intrinsic_void 14897:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 108261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108265 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108271 */     GIR_RootConstrainSelectedInstOperands,
     /* 108272 */     // GIR_Coverage, 17027,
     /* 108272 */     GIR_EraseRootFromParent_Done,
     /* 108273 */   // Label 2299: @108273
     /* 108273 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(108310), // Rule ID 17029 //
     /* 108278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 108281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 108286 */     // MIs[0] src1
     /* 108286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108289 */     // MIs[0] src2
     /* 108289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108292 */     // MIs[0] src3
     /* 108292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108295 */     // (intrinsic_void 14899:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 108298 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108302 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108308 */     GIR_RootConstrainSelectedInstOperands,
     /* 108309 */     // GIR_Coverage, 17029,
     /* 108309 */     GIR_EraseRootFromParent_Done,
     /* 108310 */   // Label 2300: @108310
     /* 108310 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(108347), // Rule ID 17034 //
     /* 108315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 108323 */     // MIs[0] src1
     /* 108323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108326 */     // MIs[0] src2
     /* 108326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108329 */     // MIs[0] src3
     /* 108329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108332 */     // (intrinsic_void 14893:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 108335 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108339 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108345 */     GIR_RootConstrainSelectedInstOperands,
     /* 108346 */     // GIR_Coverage, 17034,
     /* 108346 */     GIR_EraseRootFromParent_Done,
     /* 108347 */   // Label 2301: @108347
     /* 108347 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(108384), // Rule ID 17035 //
     /* 108352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 108360 */     // MIs[0] src1
     /* 108360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108363 */     // MIs[0] src2
     /* 108363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108366 */     // MIs[0] src3
     /* 108366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108369 */     // (intrinsic_void 14895:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 108372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108376 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108382 */     GIR_RootConstrainSelectedInstOperands,
     /* 108383 */     // GIR_Coverage, 17035,
     /* 108383 */     GIR_EraseRootFromParent_Done,
     /* 108384 */   // Label 2302: @108384
     /* 108384 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(108421), // Rule ID 17036 //
     /* 108389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 108397 */     // MIs[0] src1
     /* 108397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108400 */     // MIs[0] src2
     /* 108400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108403 */     // MIs[0] src3
     /* 108403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108406 */     // (intrinsic_void 14840:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 108409 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108411 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108413 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108419 */     GIR_RootConstrainSelectedInstOperands,
     /* 108420 */     // GIR_Coverage, 17036,
     /* 108420 */     GIR_EraseRootFromParent_Done,
     /* 108421 */   // Label 2303: @108421
     /* 108421 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(108458), // Rule ID 17055 //
     /* 108426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 108429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 108434 */     // MIs[0] src1
     /* 108434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108437 */     // MIs[0] src2
     /* 108437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108440 */     // MIs[0] src3
     /* 108440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108443 */     // (intrinsic_void 14890:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 108446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108450 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108456 */     GIR_RootConstrainSelectedInstOperands,
     /* 108457 */     // GIR_Coverage, 17055,
     /* 108457 */     GIR_EraseRootFromParent_Done,
     /* 108458 */   // Label 2304: @108458
     /* 108458 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(108495), // Rule ID 17057 //
     /* 108463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 108466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 108471 */     // MIs[0] src1
     /* 108471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108474 */     // MIs[0] src2
     /* 108474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108477 */     // MIs[0] src3
     /* 108477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108480 */     // (intrinsic_void 14901:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 108483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108487 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108493 */     GIR_RootConstrainSelectedInstOperands,
     /* 108494 */     // GIR_Coverage, 17057,
     /* 108494 */     GIR_EraseRootFromParent_Done,
     /* 108495 */   // Label 2305: @108495
     /* 108495 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(108548), // Rule ID 17038 //
     /* 108500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108518 */     // MIs[0] src1
     /* 108518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108529 */     // MIs[1] Operand 1
     /* 108529 */     // No operand predicates
     /* 108529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108531 */     // (intrinsic_w_chain:{ *:[v16f32] } 14844:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 108534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108546 */     GIR_RootConstrainSelectedInstOperands,
     /* 108547 */     // GIR_Coverage, 17038,
     /* 108547 */     GIR_EraseRootFromParent_Done,
     /* 108548 */   // Label 2306: @108548
     /* 108548 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(108601), // Rule ID 17047 //
     /* 108553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108571 */     // MIs[0] src1
     /* 108571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108582 */     // MIs[1] Operand 1
     /* 108582 */     // No operand predicates
     /* 108582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108584 */     // (intrinsic_w_chain:{ *:[v32f16] } 14850:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 108587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108599 */     GIR_RootConstrainSelectedInstOperands,
     /* 108600 */     // GIR_Coverage, 17047,
     /* 108600 */     GIR_EraseRootFromParent_Done,
     /* 108601 */   // Label 2307: @108601
     /* 108601 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(108654), // Rule ID 17049 //
     /* 108606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108624 */     // MIs[0] src1
     /* 108624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108635 */     // MIs[1] Operand 1
     /* 108635 */     // No operand predicates
     /* 108635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108637 */     // (intrinsic_w_chain:{ *:[v32f16] } 14852:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 108640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108642 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108652 */     GIR_RootConstrainSelectedInstOperands,
     /* 108653 */     // GIR_Coverage, 17049,
     /* 108653 */     GIR_EraseRootFromParent_Done,
     /* 108654 */   // Label 2308: @108654
     /* 108654 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(108707), // Rule ID 17050 //
     /* 108659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108677 */     // MIs[0] src1
     /* 108677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108688 */     // MIs[1] Operand 1
     /* 108688 */     // No operand predicates
     /* 108688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108690 */     // (intrinsic_w_chain:{ *:[v16i32] } 14883:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 108693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108705 */     GIR_RootConstrainSelectedInstOperands,
     /* 108706 */     // GIR_Coverage, 17050,
     /* 108706 */     GIR_EraseRootFromParent_Done,
     /* 108707 */   // Label 2309: @108707
     /* 108707 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(108752), // Rule ID 17039 //
     /* 108712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108730 */     // MIs[0] src1
     /* 108730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108737 */     // (intrinsic_w_chain:{ *:[v16f32] } 14844:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 108740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108744 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108750 */     GIR_RootConstrainSelectedInstOperands,
     /* 108751 */     // GIR_Coverage, 17039,
     /* 108751 */     GIR_EraseRootFromParent_Done,
     /* 108752 */   // Label 2310: @108752
     /* 108752 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(108797), // Rule ID 17046 //
     /* 108757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108775 */     // MIs[0] src1
     /* 108775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108782 */     // (intrinsic_w_chain:{ *:[v32f16] } 14850:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 108785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108789 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108795 */     GIR_RootConstrainSelectedInstOperands,
     /* 108796 */     // GIR_Coverage, 17046,
     /* 108796 */     GIR_EraseRootFromParent_Done,
     /* 108797 */   // Label 2311: @108797
     /* 108797 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(108842), // Rule ID 17048 //
     /* 108802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108820 */     // MIs[0] src1
     /* 108820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108827 */     // (intrinsic_w_chain:{ *:[v32f16] } 14852:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 108830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108834 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108840 */     GIR_RootConstrainSelectedInstOperands,
     /* 108841 */     // GIR_Coverage, 17048,
     /* 108841 */     GIR_EraseRootFromParent_Done,
     /* 108842 */   // Label 2312: @108842
     /* 108842 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(108887), // Rule ID 17051 //
     /* 108847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108865 */     // MIs[0] src1
     /* 108865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108872 */     // (intrinsic_w_chain:{ *:[v16i32] } 14883:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 108875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108879 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108885 */     GIR_RootConstrainSelectedInstOperands,
     /* 108886 */     // GIR_Coverage, 17051,
     /* 108886 */     GIR_EraseRootFromParent_Done,
     /* 108887 */   // Label 2313: @108887
     /* 108887 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(108932), // Rule ID 122 //
     /* 108892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 108895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 108900 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108914 */     // MIs[0] cntl
     /* 108914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108917 */     // (intrinsic_void 14524:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 108917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 108920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 108922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108924 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 108926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108930 */     GIR_RootConstrainSelectedInstOperands,
     /* 108931 */     // GIR_Coverage, 122,
     /* 108931 */     GIR_EraseRootFromParent_Done,
     /* 108932 */   // Label 2314: @108932
     /* 108932 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(108977), // Rule ID 124 //
     /* 108937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 108940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 108945 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 108955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108959 */     // MIs[0] cntl
     /* 108959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108962 */     // (intrinsic_void 14525:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 108962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 108965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 108967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108969 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 108971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108975 */     GIR_RootConstrainSelectedInstOperands,
     /* 108976 */     // GIR_Coverage, 124,
     /* 108976 */     GIR_EraseRootFromParent_Done,
     /* 108977 */   // Label 2315: @108977
     /* 108977 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(109059), // Rule ID 17104 //
     /* 108982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 108987 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 109000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 109004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109008 */     // (intrinsic_void 15020:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 109008 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109012 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109018 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 109022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109026 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 109036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109040 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 109050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 109053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109057 */     GIR_RootConstrainSelectedInstOperands,
     /* 109058 */     // GIR_Coverage, 17104,
     /* 109058 */     GIR_EraseRootFromParent_Done,
     /* 109059 */   // Label 2316: @109059
     /* 109059 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(109108), // Rule ID 17293 //
     /* 109064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 109067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 109072 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109093 */     // (intrinsic_void 14602:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 109093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 109096 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 109098 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 109100 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 109102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109106 */     GIR_RootConstrainSelectedInstOperands,
     /* 109107 */     // GIR_Coverage, 17293,
     /* 109107 */     GIR_EraseRootFromParent_Done,
     /* 109108 */   // Label 2317: @109108
     /* 109108 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(109170), // Rule ID 2903 //
     /* 109113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 109116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109121 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109135 */     // MIs[0] Operand 3
     /* 109135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109143 */     // (intrinsic_void 14700:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109147 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 109160 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109162 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109168 */     GIR_RootConstrainSelectedInstOperands,
     /* 109169 */     // GIR_Coverage, 2903,
     /* 109169 */     GIR_EraseRootFromParent_Done,
     /* 109170 */   // Label 2318: @109170
     /* 109170 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(109232), // Rule ID 2904 //
     /* 109175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 109178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109183 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109197 */     // MIs[0] Operand 3
     /* 109197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109205 */     // (intrinsic_void 14700:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109209 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 109222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109224 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109230 */     GIR_RootConstrainSelectedInstOperands,
     /* 109231 */     // GIR_Coverage, 2904,
     /* 109231 */     GIR_EraseRootFromParent_Done,
     /* 109232 */   // Label 2319: @109232
     /* 109232 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(109294), // Rule ID 2905 //
     /* 109237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 109240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109245 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109259 */     // MIs[0] Operand 3
     /* 109259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109267 */     // (intrinsic_void 14700:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109271 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 109284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109286 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109292 */     GIR_RootConstrainSelectedInstOperands,
     /* 109293 */     // GIR_Coverage, 2905,
     /* 109293 */     GIR_EraseRootFromParent_Done,
     /* 109294 */   // Label 2320: @109294
     /* 109294 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(109356), // Rule ID 2906 //
     /* 109299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 109302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109321 */     // MIs[0] Operand 3
     /* 109321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109329 */     // (intrinsic_void 14700:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109333 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 109346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109348 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109354 */     GIR_RootConstrainSelectedInstOperands,
     /* 109355 */     // GIR_Coverage, 2906,
     /* 109355 */     GIR_EraseRootFromParent_Done,
     /* 109356 */   // Label 2321: @109356
     /* 109356 */   GIM_Reject,
     /* 109357 */ // Label 2256: @109357
     /* 109357 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(109445), // Rule ID 16988 //
     /* 109362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 109365 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 109368 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 109373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 109379 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 109382 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 109385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109397 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109401 */   // (intrinsic_void 14521:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 109401 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109405 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109411 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 109415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109419 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 109429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 109432 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109434 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109436 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 109439 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109443 */   GIR_RootConstrainSelectedInstOperands,
     /* 109444 */   // GIR_Coverage, 16988,
     /* 109444 */   GIR_EraseRootFromParent_Done,
     /* 109445 */ // Label 2322: @109445
     /* 109445 */ GIM_Reject,
     /* 109446 */ // Label 19: @109446
     /* 109446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2326*/ GIMT_Encode4(109880),
     /* 109457 */ /*GILLT_s16*//*Label 2323*/ GIMT_Encode4(109469),
     /* 109461 */ /*GILLT_s32*//*Label 2324*/ GIMT_Encode4(109527),
     /* 109465 */ /*GILLT_s64*//*Label 2325*/ GIMT_Encode4(109702),
     /* 109469 */ // Label 2323: @109469
     /* 109469 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(109526), // Rule ID 22590 //
     /* 109474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109485 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 109485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109508 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 109515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 109520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109525 */   // GIR_Coverage, 22590,
     /* 109525 */   GIR_EraseRootFromParent_Done,
     /* 109526 */ // Label 2327: @109526
     /* 109526 */ GIM_Reject,
     /* 109527 */ // Label 2324: @109527
     /* 109527 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(109573), // Rule ID 19437 //
     /* 109532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109547 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109551 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109558 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 109558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109563 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109572 */   // GIR_Coverage, 19437,
     /* 109572 */   GIR_EraseRootFromParent_Done,
     /* 109573 */ // Label 2328: @109573
     /* 109573 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(109619), // Rule ID 19440 //
     /* 109578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109593 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 109597 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 109602 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109604 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 109604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109609 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109618 */   // GIR_Coverage, 19440,
     /* 109618 */   GIR_EraseRootFromParent_Done,
     /* 109619 */ // Label 2329: @109619
     /* 109619 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(109642), // Rule ID 22591 //
     /* 109624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109635 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 109635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109640 */   GIR_RootConstrainSelectedInstOperands,
     /* 109641 */   // GIR_Coverage, 22591,
     /* 109641 */   GIR_Done,
     /* 109642 */ // Label 2330: @109642
     /* 109642 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(109701), // Rule ID 22592 //
     /* 109647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109658 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 109658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 109685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 109700 */   // GIR_Coverage, 22592,
     /* 109700 */   GIR_EraseRootFromParent_Done,
     /* 109701 */ // Label 2331: @109701
     /* 109701 */ GIM_Reject,
     /* 109702 */ // Label 2325: @109702
     /* 109702 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(109761), // Rule ID 22593 //
     /* 109707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109718 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 109718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109730 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109760 */   // GIR_Coverage, 22593,
     /* 109760 */   GIR_EraseRootFromParent_Done,
     /* 109761 */ // Label 2332: @109761
     /* 109761 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(109820), // Rule ID 22594 //
     /* 109766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109777 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 109777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 109784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109789 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109819 */   // GIR_Coverage, 22594,
     /* 109819 */   GIR_EraseRootFromParent_Done,
     /* 109820 */ // Label 2333: @109820
     /* 109820 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(109879), // Rule ID 22595 //
     /* 109825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109836 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 109836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109858 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109868 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 109873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109878 */   // GIR_Coverage, 22595,
     /* 109878 */   GIR_EraseRootFromParent_Done,
     /* 109879 */ // Label 2334: @109879
     /* 109879 */ GIM_Reject,
     /* 109880 */ // Label 2326: @109880
     /* 109880 */ GIM_Reject,
     /* 109881 */ // Label 20: @109881
     /* 109881 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 2343*/ GIMT_Encode4(110969),
     /* 109892 */ /*GILLT_s8*//*Label 2335*/ GIMT_Encode4(109976),
     /* 109896 */ /*GILLT_s16*//*Label 2336*/ GIMT_Encode4(110260), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109928 */ /*GILLT_v4s32*//*Label 2337*/ GIMT_Encode4(110299), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109940 */ /*GILLT_v8s16*//*Label 2338*/ GIMT_Encode4(110439),
     /* 109944 */ /*GILLT_v8s32*//*Label 2339*/ GIMT_Encode4(110602), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109956 */ /*GILLT_v16s8*//*Label 2340*/ GIMT_Encode4(110629),
     /* 109960 */ /*GILLT_v16s16*//*Label 2341*/ GIMT_Encode4(110915), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109972 */ /*GILLT_v32s8*//*Label 2342*/ GIMT_Encode4(110942),
     /* 109976 */ // Label 2335: @109976
     /* 109976 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(110051), // Rule ID 19432 //
     /* 109981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109996 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 110000 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 110005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110007 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 110023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 110028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110033 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110045 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110050 */   // GIR_Coverage, 19432,
     /* 110050 */   GIR_EraseRootFromParent_Done,
     /* 110051 */ // Label 2344: @110051
     /* 110051 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(110114), // Rule ID 22652 //
     /* 110056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110070 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110070 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110073 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110077 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110082 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110086 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110096 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110113 */   // GIR_Coverage, 22652,
     /* 110113 */   GIR_EraseRootFromParent_Done,
     /* 110114 */ // Label 2345: @110114
     /* 110114 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(110177), // Rule ID 22653 //
     /* 110119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110133 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110145 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110149 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110159 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110176 */   // GIR_Coverage, 22653,
     /* 110176 */   GIR_EraseRootFromParent_Done,
     /* 110177 */ // Label 2346: @110177
     /* 110177 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(110218), // Rule ID 22657 //
     /* 110182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110196 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 110196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110201 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110207 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110217 */   // GIR_Coverage, 22657,
     /* 110217 */   GIR_EraseRootFromParent_Done,
     /* 110218 */ // Label 2347: @110218
     /* 110218 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(110259), // Rule ID 22658 //
     /* 110223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110237 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 110237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110242 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 110258 */   // GIR_Coverage, 22658,
     /* 110258 */   GIR_EraseRootFromParent_Done,
     /* 110259 */ // Label 2348: @110259
     /* 110259 */ GIM_Reject,
     /* 110260 */ // Label 2336: @110260
     /* 110260 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(110298), // Rule ID 22651 //
     /* 110265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110276 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 110276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110281 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 110287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110297 */   // GIR_Coverage, 22651,
     /* 110297 */   GIR_EraseRootFromParent_Done,
     /* 110298 */ // Label 2349: @110298
     /* 110298 */ GIM_Reject,
     /* 110299 */ // Label 2337: @110299
     /* 110299 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(110438),
     /* 110304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 110307 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(110330), // Rule ID 12262 //
     /* 110312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110323 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 110323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 110328 */     GIR_RootConstrainSelectedInstOperands,
     /* 110329 */     // GIR_Coverage, 12262,
     /* 110329 */     GIR_Done,
     /* 110330 */   // Label 2351: @110330
     /* 110330 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(110437), // Rule ID 21557 //
     /* 110335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110346 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 110349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 110363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 110400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110419 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110436 */     // GIR_Coverage, 21557,
     /* 110436 */     GIR_EraseRootFromParent_Done,
     /* 110437 */   // Label 2352: @110437
     /* 110437 */   GIM_Reject,
     /* 110438 */ // Label 2350: @110438
     /* 110438 */ GIM_Reject,
     /* 110439 */ // Label 2338: @110439
     /* 110439 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(110465), // Rule ID 12238 //
     /* 110444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110458 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 110458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 110463 */   GIR_RootConstrainSelectedInstOperands,
     /* 110464 */   // GIR_Coverage, 12238,
     /* 110464 */   GIR_Done,
     /* 110465 */ // Label 2353: @110465
     /* 110465 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(110491), // Rule ID 12316 //
     /* 110470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110484 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 110484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 110489 */   GIR_RootConstrainSelectedInstOperands,
     /* 110490 */   // GIR_Coverage, 12316,
     /* 110490 */   GIR_Done,
     /* 110491 */ // Label 2354: @110491
     /* 110491 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(110601), // Rule ID 21556 //
     /* 110496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110510 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110510 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 110513 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110517 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110524 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 110527 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110531 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110536 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110539 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110543 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110546 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110551 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110556 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 110564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110573 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110583 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110595 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110600 */   // GIR_Coverage, 21556,
     /* 110600 */   GIR_EraseRootFromParent_Done,
     /* 110601 */ // Label 2355: @110601
     /* 110601 */ GIM_Reject,
     /* 110602 */ // Label 2339: @110602
     /* 110602 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(110628), // Rule ID 12265 //
     /* 110607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110621 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 110621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110626 */   GIR_RootConstrainSelectedInstOperands,
     /* 110627 */   // GIR_Coverage, 12265,
     /* 110627 */   GIR_Done,
     /* 110628 */ // Label 2356: @110628
     /* 110628 */ GIM_Reject,
     /* 110629 */ // Label 2340: @110629
     /* 110629 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(110705), // Rule ID 21650 //
     /* 110634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 110652 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110655 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 110659 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 110663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110665 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 110672 */   // (trunc:{ *:[v16i8] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src))
     /* 110672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 110679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110684 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /* 110688 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110703 */   GIR_RootConstrainSelectedInstOperands,
     /* 110704 */   // GIR_Coverage, 21650,
     /* 110704 */   GIR_EraseRootFromParent_Done,
     /* 110705 */ // Label 2357: @110705
     /* 110705 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(110731), // Rule ID 12292 //
     /* 110710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110724 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 110724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110729 */   GIR_RootConstrainSelectedInstOperands,
     /* 110730 */   // GIR_Coverage, 12292,
     /* 110730 */   GIR_Done,
     /* 110731 */ // Label 2358: @110731
     /* 110731 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(110757), // Rule ID 12343 //
     /* 110736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 110739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110750 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 110750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 110755 */   GIR_RootConstrainSelectedInstOperands,
     /* 110756 */   // GIR_Coverage, 12343,
     /* 110756 */   GIR_Done,
     /* 110757 */ // Label 2359: @110757
     /* 110757 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(110867), // Rule ID 21558 //
     /* 110762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 110765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110776 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110776 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 110779 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110783 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 110793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110802 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110805 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110809 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110812 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110817 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110822 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 110830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 110834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110839 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110849 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110866 */   // GIR_Coverage, 21558,
     /* 110866 */   GIR_EraseRootFromParent_Done,
     /* 110867 */ // Label 2360: @110867
     /* 110867 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(110914), // Rule ID 21649 //
     /* 110872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110886 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 110886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 110893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110898 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110912 */   GIR_RootConstrainSelectedInstOperands,
     /* 110913 */   // GIR_Coverage, 21649,
     /* 110913 */   GIR_EraseRootFromParent_Done,
     /* 110914 */ // Label 2361: @110914
     /* 110914 */ GIM_Reject,
     /* 110915 */ // Label 2341: @110915
     /* 110915 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(110941), // Rule ID 12319 //
     /* 110920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110934 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 110934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110939 */   GIR_RootConstrainSelectedInstOperands,
     /* 110940 */   // GIR_Coverage, 12319,
     /* 110940 */   GIR_Done,
     /* 110941 */ // Label 2362: @110941
     /* 110941 */ GIM_Reject,
     /* 110942 */ // Label 2342: @110942
     /* 110942 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(110968), // Rule ID 12346 //
     /* 110947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 110950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 110953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110961 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 110961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 110966 */   GIR_RootConstrainSelectedInstOperands,
     /* 110967 */   // GIR_Coverage, 12346,
     /* 110967 */   GIR_Done,
     /* 110968 */ // Label 2363: @110968
     /* 110968 */ GIM_Reject,
     /* 110969 */ // Label 2343: @110969
     /* 110969 */ GIM_Reject,
     /* 110970 */ // Label 21: @110970
     /* 110970 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2368*/ GIMT_Encode4(111575),
     /* 110981 */ /*GILLT_s8*//*Label 2364*/ GIMT_Encode4(110997),
     /* 110985 */ /*GILLT_s16*//*Label 2365*/ GIMT_Encode4(111079),
     /* 110989 */ /*GILLT_s32*//*Label 2366*/ GIMT_Encode4(111279),
     /* 110993 */ /*GILLT_s64*//*Label 2367*/ GIMT_Encode4(111421),
     /* 110997 */ // Label 2364: @110997
     /* 110997 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(111078),
     /* 111002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 111006 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(111062), // Rule ID 22384 //
     /* 111011 */     // MIs[0] Operand 1
     /* 111011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111022 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 111022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111034 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111044 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 111051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 111056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111061 */     // GIR_Coverage, 22384,
     /* 111061 */     GIR_EraseRootFromParent_Done,
     /* 111062 */   // Label 2370: @111062
     /* 111062 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(111077), // Rule ID 19 //
     /* 111067 */     // MIs[0] Operand 1
     /* 111067 */     // No operand predicates
     /* 111067 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 111067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 111070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111075 */     GIR_RootConstrainSelectedInstOperands,
     /* 111076 */     // GIR_Coverage, 19,
     /* 111076 */     GIR_EraseRootFromParent_Done,
     /* 111077 */   // Label 2371: @111077
     /* 111077 */   GIM_Reject,
     /* 111078 */ // Label 2369: @111078
     /* 111078 */ GIM_Reject,
     /* 111079 */ // Label 2365: @111079
     /* 111079 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(111278),
     /* 111084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111088 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(111144), // Rule ID 22385 //
     /* 111093 */     // MIs[0] Operand 1
     /* 111093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111104 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111116 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111126 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111143 */     // GIR_Coverage, 22385,
     /* 111143 */     GIR_EraseRootFromParent_Done,
     /* 111144 */   // Label 2373: @111144
     /* 111144 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(111203), // Rule ID 22387 //
     /* 111149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111152 */     // MIs[0] Operand 1
     /* 111152 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111163 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111175 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111202 */     // GIR_Coverage, 22387,
     /* 111202 */     GIR_EraseRootFromParent_Done,
     /* 111203 */   // Label 2374: @111203
     /* 111203 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(111262), // Rule ID 22388 //
     /* 111208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111211 */     // MIs[0] Operand 1
     /* 111211 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111222 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111234 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111244 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111261 */     // GIR_Coverage, 22388,
     /* 111261 */     GIR_EraseRootFromParent_Done,
     /* 111262 */   // Label 2375: @111262
     /* 111262 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(111277), // Rule ID 20 //
     /* 111267 */     // MIs[0] Operand 1
     /* 111267 */     // No operand predicates
     /* 111267 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 111267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 111270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111275 */     GIR_RootConstrainSelectedInstOperands,
     /* 111276 */     // GIR_Coverage, 20,
     /* 111276 */     GIR_EraseRootFromParent_Done,
     /* 111277 */   // Label 2376: @111277
     /* 111277 */   GIM_Reject,
     /* 111278 */ // Label 2372: @111278
     /* 111278 */ GIM_Reject,
     /* 111279 */ // Label 2366: @111279
     /* 111279 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(111309), // Rule ID 17153 //
     /* 111284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111288 */   // MIs[0] Operand 1
     /* 111288 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111299 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 111299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111304 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111307 */   GIR_RootConstrainSelectedInstOperands,
     /* 111308 */   // GIR_Coverage, 17153,
     /* 111308 */   GIR_EraseRootFromParent_Done,
     /* 111309 */ // Label 2377: @111309
     /* 111309 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(111342), // Rule ID 17154 //
     /* 111314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111321 */   // MIs[0] Operand 1
     /* 111321 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111332 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 111332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111337 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111340 */   GIR_RootConstrainSelectedInstOperands,
     /* 111341 */   // GIR_Coverage, 17154,
     /* 111341 */   GIR_EraseRootFromParent_Done,
     /* 111342 */ // Label 2378: @111342
     /* 111342 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(111375), // Rule ID 17155 //
     /* 111347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111354 */   // MIs[0] Operand 1
     /* 111354 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111365 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 111365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111370 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111373 */   GIR_RootConstrainSelectedInstOperands,
     /* 111374 */   // GIR_Coverage, 17155,
     /* 111374 */   GIR_EraseRootFromParent_Done,
     /* 111375 */ // Label 2379: @111375
     /* 111375 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(111401), // Rule ID 17156 //
     /* 111380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111383 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 111387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111391 */   // MIs[0] Operand 1
     /* 111391 */   // No operand predicates
     /* 111391 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 111394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111396 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111399 */   GIR_RootConstrainSelectedInstOperands,
     /* 111400 */   // GIR_Coverage, 17156,
     /* 111400 */   GIR_EraseRootFromParent_Done,
     /* 111401 */ // Label 2380: @111401
     /* 111401 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(111420), // Rule ID 21 //
     /* 111406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111410 */   // MIs[0] Operand 1
     /* 111410 */   // No operand predicates
     /* 111410 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 111413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111415 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111418 */   GIR_RootConstrainSelectedInstOperands,
     /* 111419 */   // GIR_Coverage, 21,
     /* 111419 */   GIR_EraseRootFromParent_Done,
     /* 111420 */ // Label 2381: @111420
     /* 111420 */ GIM_Reject,
     /* 111421 */ // Label 2367: @111421
     /* 111421 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(111483), // Rule ID 22386 //
     /* 111426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111430 */   // MIs[0] Operand 1
     /* 111430 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111441 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 111441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111453 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 111472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 111477 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 111482 */   // GIR_Coverage, 22386,
     /* 111482 */   GIR_EraseRootFromParent_Done,
     /* 111483 */ // Label 2382: @111483
     /* 111483 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(111509), // Rule ID 17157 //
     /* 111488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111491 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 111495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111499 */   // MIs[0] Operand 1
     /* 111499 */   // No operand predicates
     /* 111499 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 111502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111504 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111507 */   GIR_RootConstrainSelectedInstOperands,
     /* 111508 */   // GIR_Coverage, 17157,
     /* 111508 */   GIR_EraseRootFromParent_Done,
     /* 111509 */ // Label 2383: @111509
     /* 111509 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(111532), // Rule ID 17158 //
     /* 111514 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 111518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111522 */   // MIs[0] Operand 1
     /* 111522 */   // No operand predicates
     /* 111522 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 111525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111527 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111530 */   GIR_RootConstrainSelectedInstOperands,
     /* 111531 */   // GIR_Coverage, 17158,
     /* 111531 */   GIR_EraseRootFromParent_Done,
     /* 111532 */ // Label 2384: @111532
     /* 111532 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(111555), // Rule ID 22 //
     /* 111537 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 111541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111545 */   // MIs[0] Operand 1
     /* 111545 */   // No operand predicates
     /* 111545 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 111548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111550 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111553 */   GIR_RootConstrainSelectedInstOperands,
     /* 111554 */   // GIR_Coverage, 22,
     /* 111554 */   GIR_EraseRootFromParent_Done,
     /* 111555 */ // Label 2385: @111555
     /* 111555 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(111574), // Rule ID 23 //
     /* 111560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111564 */   // MIs[0] Operand 1
     /* 111564 */   // No operand predicates
     /* 111564 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 111567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111569 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111572 */   GIR_RootConstrainSelectedInstOperands,
     /* 111573 */   // GIR_Coverage, 23,
     /* 111573 */   GIR_EraseRootFromParent_Done,
     /* 111574 */ // Label 2386: @111574
     /* 111574 */ GIM_Reject,
     /* 111575 */ // Label 2368: @111575
     /* 111575 */ GIM_Reject,
     /* 111576 */ // Label 22: @111576
     /* 111576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2390*/ GIMT_Encode4(112028),
     /* 111587 */ /*GILLT_s32*//*Label 2387*/ GIMT_Encode4(111599),
     /* 111591 */ /*GILLT_s64*//*Label 2388*/ GIMT_Encode4(111744),
     /* 111595 */ /*GILLT_s80*//*Label 2389*/ GIMT_Encode4(111889),
     /* 111599 */ // Label 2387: @111599
     /* 111599 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(111625), // Rule ID 1116 //
     /* 111604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111607 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111615 */   // MIs[0] Operand 1
     /* 111615 */   // No operand predicates
     /* 111615 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 111615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111620 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111623 */   GIR_RootConstrainSelectedInstOperands,
     /* 111624 */   // GIR_Coverage, 1116,
     /* 111624 */   GIR_EraseRootFromParent_Done,
     /* 111625 */ // Label 2391: @111625
     /* 111625 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(111651), // Rule ID 1117 //
     /* 111630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111633 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111641 */   // MIs[0] Operand 1
     /* 111641 */   // No operand predicates
     /* 111641 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 111641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111646 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111649 */   GIR_RootConstrainSelectedInstOperands,
     /* 111650 */   // GIR_Coverage, 1117,
     /* 111650 */   GIR_EraseRootFromParent_Done,
     /* 111651 */ // Label 2392: @111651
     /* 111651 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(111697), // Rule ID 17720 //
     /* 111656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111659 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111667 */   // MIs[0] Operand 1
     /* 111667 */   // No operand predicates
     /* 111667 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 111667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111679 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111692 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111695 */   GIR_RootConstrainSelectedInstOperands,
     /* 111696 */   // GIR_Coverage, 17720,
     /* 111696 */   GIR_EraseRootFromParent_Done,
     /* 111697 */ // Label 2393: @111697
     /* 111697 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(111743), // Rule ID 17721 //
     /* 111702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111705 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111713 */   // MIs[0] Operand 1
     /* 111713 */   // No operand predicates
     /* 111713 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 111713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111725 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111738 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111741 */   GIR_RootConstrainSelectedInstOperands,
     /* 111742 */   // GIR_Coverage, 17721,
     /* 111742 */   GIR_EraseRootFromParent_Done,
     /* 111743 */ // Label 2394: @111743
     /* 111743 */ GIM_Reject,
     /* 111744 */ // Label 2388: @111744
     /* 111744 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(111770), // Rule ID 1118 //
     /* 111749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111752 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111760 */   // MIs[0] Operand 1
     /* 111760 */   // No operand predicates
     /* 111760 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 111760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111765 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111768 */   GIR_RootConstrainSelectedInstOperands,
     /* 111769 */   // GIR_Coverage, 1118,
     /* 111769 */   GIR_EraseRootFromParent_Done,
     /* 111770 */ // Label 2395: @111770
     /* 111770 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(111796), // Rule ID 1119 //
     /* 111775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111778 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111786 */   // MIs[0] Operand 1
     /* 111786 */   // No operand predicates
     /* 111786 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 111786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 111789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111791 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111794 */   GIR_RootConstrainSelectedInstOperands,
     /* 111795 */   // GIR_Coverage, 1119,
     /* 111795 */   GIR_EraseRootFromParent_Done,
     /* 111796 */ // Label 2396: @111796
     /* 111796 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(111842), // Rule ID 17722 //
     /* 111801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111804 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111812 */   // MIs[0] Operand 1
     /* 111812 */   // No operand predicates
     /* 111812 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 111812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111824 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 111832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111837 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111840 */   GIR_RootConstrainSelectedInstOperands,
     /* 111841 */   // GIR_Coverage, 17722,
     /* 111841 */   GIR_EraseRootFromParent_Done,
     /* 111842 */ // Label 2397: @111842
     /* 111842 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(111888), // Rule ID 17723 //
     /* 111847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111850 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111858 */   // MIs[0] Operand 1
     /* 111858 */   // No operand predicates
     /* 111858 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 111858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 111865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111870 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 111878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111883 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111886 */   GIR_RootConstrainSelectedInstOperands,
     /* 111887 */   // GIR_Coverage, 17723,
     /* 111887 */   GIR_EraseRootFromParent_Done,
     /* 111888 */ // Label 2398: @111888
     /* 111888 */ GIM_Reject,
     /* 111889 */ // Label 2389: @111889
     /* 111889 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(111915), // Rule ID 1120 //
     /* 111894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 111897 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111905 */   // MIs[0] Operand 1
     /* 111905 */   // No operand predicates
     /* 111905 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 111905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 111908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111910 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111913 */   GIR_RootConstrainSelectedInstOperands,
     /* 111914 */   // GIR_Coverage, 1120,
     /* 111914 */   GIR_EraseRootFromParent_Done,
     /* 111915 */ // Label 2399: @111915
     /* 111915 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(111941), // Rule ID 1121 //
     /* 111920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 111923 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111931 */   // MIs[0] Operand 1
     /* 111931 */   // No operand predicates
     /* 111931 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 111931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 111934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111936 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111939 */   GIR_RootConstrainSelectedInstOperands,
     /* 111940 */   // GIR_Coverage, 1121,
     /* 111940 */   GIR_EraseRootFromParent_Done,
     /* 111941 */ // Label 2400: @111941
     /* 111941 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(111984), // Rule ID 17724 //
     /* 111946 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111954 */   // MIs[0] Operand 1
     /* 111954 */   // No operand predicates
     /* 111954 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 111954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 111957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 111961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111966 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 111974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111979 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111982 */   GIR_RootConstrainSelectedInstOperands,
     /* 111983 */   // GIR_Coverage, 17724,
     /* 111983 */   GIR_EraseRootFromParent_Done,
     /* 111984 */ // Label 2401: @111984
     /* 111984 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(112027), // Rule ID 17725 //
     /* 111989 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111997 */   // MIs[0] Operand 1
     /* 111997 */   // No operand predicates
     /* 111997 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 111997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 112000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 112004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112009 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112022 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112025 */   GIR_RootConstrainSelectedInstOperands,
     /* 112026 */   // GIR_Coverage, 17725,
     /* 112026 */   GIR_EraseRootFromParent_Done,
     /* 112027 */ // Label 2402: @112027
     /* 112027 */ GIM_Reject,
     /* 112028 */ // Label 2390: @112028
     /* 112028 */ GIM_Reject,
     /* 112029 */ // Label 23: @112029
     /* 112029 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2418*/ GIMT_Encode4(113700),
     /* 112040 */ /*GILLT_s16*//*Label 2403*/ GIMT_Encode4(112132),
     /* 112044 */ /*GILLT_s32*//*Label 2404*/ GIMT_Encode4(112190),
     /* 112048 */ /*GILLT_s64*//*Label 2405*/ GIMT_Encode4(112237), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112064 */ /*GILLT_v2s64*//*Label 2406*/ GIMT_Encode4(112310), GIMT_Encode4(0),
     /* 112072 */ /*GILLT_v4s32*//*Label 2407*/ GIMT_Encode4(112337),
     /* 112076 */ /*GILLT_v4s64*//*Label 2408*/ GIMT_Encode4(112364), GIMT_Encode4(0),
     /* 112084 */ /*GILLT_v8s16*//*Label 2409*/ GIMT_Encode4(112561),
     /* 112088 */ /*GILLT_v8s32*//*Label 2410*/ GIMT_Encode4(112630),
     /* 112092 */ /*GILLT_v8s64*//*Label 2411*/ GIMT_Encode4(112827), GIMT_Encode4(0),
     /* 112100 */ /*GILLT_v16s8*//*Label 2412*/ GIMT_Encode4(113024),
     /* 112104 */ /*GILLT_v16s16*//*Label 2413*/ GIMT_Encode4(113093),
     /* 112108 */ /*GILLT_v16s32*//*Label 2414*/ GIMT_Encode4(113337), GIMT_Encode4(0),
     /* 112116 */ /*GILLT_v32s8*//*Label 2415*/ GIMT_Encode4(113534),
     /* 112120 */ /*GILLT_v32s16*//*Label 2416*/ GIMT_Encode4(113561), GIMT_Encode4(0),
     /* 112128 */ /*GILLT_v64s8*//*Label 2417*/ GIMT_Encode4(113673),
     /* 112132 */ // Label 2403: @112132
     /* 112132 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(112189), // Rule ID 22647 //
     /* 112137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112148 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 112148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112160 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112171 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 112178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 112183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 112188 */   // GIR_Coverage, 22647,
     /* 112188 */   GIR_EraseRootFromParent_Done,
     /* 112189 */ // Label 2419: @112189
     /* 112189 */ GIM_Reject,
     /* 112190 */ // Label 2404: @112190
     /* 112190 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(112213), // Rule ID 614 //
     /* 112195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112206 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 112206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112211 */   GIR_RootConstrainSelectedInstOperands,
     /* 112212 */   // GIR_Coverage, 614,
     /* 112212 */   GIR_Done,
     /* 112213 */ // Label 2420: @112213
     /* 112213 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(112236), // Rule ID 616 //
     /* 112218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112229 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 112229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 112234 */   GIR_RootConstrainSelectedInstOperands,
     /* 112235 */   // GIR_Coverage, 616,
     /* 112235 */   GIR_Done,
     /* 112236 */ // Label 2421: @112236
     /* 112236 */ GIM_Reject,
     /* 112237 */ // Label 2405: @112237
     /* 112237 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(112260), // Rule ID 622 //
     /* 112242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112253 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 112253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 112258 */   GIR_RootConstrainSelectedInstOperands,
     /* 112259 */   // GIR_Coverage, 622,
     /* 112259 */   GIR_Done,
     /* 112260 */ // Label 2422: @112260
     /* 112260 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(112283), // Rule ID 624 //
     /* 112265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112276 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 112276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 112281 */   GIR_RootConstrainSelectedInstOperands,
     /* 112282 */   // GIR_Coverage, 624,
     /* 112282 */   GIR_Done,
     /* 112283 */ // Label 2423: @112283
     /* 112283 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(112309), // Rule ID 626 //
     /* 112288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 112291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112302 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 112302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 112307 */   GIR_RootConstrainSelectedInstOperands,
     /* 112308 */   // GIR_Coverage, 626,
     /* 112308 */   GIR_Done,
     /* 112309 */ // Label 2424: @112309
     /* 112309 */ GIM_Reject,
     /* 112310 */ // Label 2406: @112310
     /* 112310 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(112336), // Rule ID 12594 //
     /* 112315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 112321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 112329 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 112329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 112334 */   GIR_RootConstrainSelectedInstOperands,
     /* 112335 */   // GIR_Coverage, 12594,
     /* 112335 */   GIR_Done,
     /* 112336 */ // Label 2425: @112336
     /* 112336 */ GIM_Reject,
     /* 112337 */ // Label 2407: @112337
     /* 112337 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(112363), // Rule ID 12591 //
     /* 112342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112356 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 112356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 112361 */   GIR_RootConstrainSelectedInstOperands,
     /* 112362 */   // GIR_Coverage, 12591,
     /* 112362 */   GIR_Done,
     /* 112363 */ // Label 2426: @112363
     /* 112363 */ GIM_Reject,
     /* 112364 */ // Label 2408: @112364
     /* 112364 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(112423), // Rule ID 18390 //
     /* 112369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112387 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112394 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112398 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112400 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112407 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrm),
     /* 112410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112412 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112421 */   GIR_RootConstrainSelectedInstOperands,
     /* 112422 */   // GIR_Coverage, 18390,
     /* 112422 */   GIR_EraseRootFromParent_Done,
     /* 112423 */ // Label 2427: @112423
     /* 112423 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(112482), // Rule ID 21585 //
     /* 112428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112438 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112446 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112449 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112453 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112459 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112466 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rm),
     /* 112469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112471 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112480 */   GIR_RootConstrainSelectedInstOperands,
     /* 112481 */   // GIR_Coverage, 21585,
     /* 112481 */   GIR_EraseRootFromParent_Done,
     /* 112482 */ // Label 2428: @112482
     /* 112482 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(112508), // Rule ID 12571 //
     /* 112487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112501 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 112501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 112506 */   GIR_RootConstrainSelectedInstOperands,
     /* 112507 */   // GIR_Coverage, 12571,
     /* 112507 */   GIR_Done,
     /* 112508 */ // Label 2429: @112508
     /* 112508 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(112534), // Rule ID 12593 //
     /* 112513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112527 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 112527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 112532 */   GIR_RootConstrainSelectedInstOperands,
     /* 112533 */   // GIR_Coverage, 12593,
     /* 112533 */   GIR_Done,
     /* 112534 */ // Label 2430: @112534
     /* 112534 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(112560), // Rule ID 18378 //
     /* 112539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112553 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 112553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 112558 */   GIR_RootConstrainSelectedInstOperands,
     /* 112559 */   // GIR_Coverage, 18378,
     /* 112559 */   GIR_Done,
     /* 112560 */ // Label 2431: @112560
     /* 112560 */ GIM_Reject,
     /* 112561 */ // Label 2409: @112561
     /* 112561 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(112629),
     /* 112566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112577 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(112592), // Rule ID 12588 //
     /* 112582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112585 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 112585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 112590 */     GIR_RootConstrainSelectedInstOperands,
     /* 112591 */     // GIR_Coverage, 12588,
     /* 112591 */     GIR_Done,
     /* 112592 */   // Label 2433: @112592
     /* 112592 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(112628), // Rule ID 21661 //
     /* 112597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 112600 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 112600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 112603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 112621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112626 */     GIR_RootConstrainSelectedInstOperands,
     /* 112627 */     // GIR_Coverage, 21661,
     /* 112627 */     GIR_EraseRootFromParent_Done,
     /* 112628 */   // Label 2434: @112628
     /* 112628 */   GIM_Reject,
     /* 112629 */ // Label 2432: @112629
     /* 112629 */ GIM_Reject,
     /* 112630 */ // Label 2410: @112630
     /* 112630 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(112689), // Rule ID 18386 //
     /* 112635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112645 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112653 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112660 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112666 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112673 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrm),
     /* 112676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112678 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112682 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112687 */   GIR_RootConstrainSelectedInstOperands,
     /* 112688 */   // GIR_Coverage, 18386,
     /* 112688 */   GIR_EraseRootFromParent_Done,
     /* 112689 */ // Label 2435: @112689
     /* 112689 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(112748), // Rule ID 21584 //
     /* 112694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112712 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112715 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112719 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112723 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112725 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112732 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rm),
     /* 112735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112737 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112741 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112746 */   GIR_RootConstrainSelectedInstOperands,
     /* 112747 */   // GIR_Coverage, 21584,
     /* 112747 */   GIR_EraseRootFromParent_Done,
     /* 112748 */ // Label 2436: @112748
     /* 112748 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(112774), // Rule ID 12535 //
     /* 112753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112767 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 112767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 112772 */   GIR_RootConstrainSelectedInstOperands,
     /* 112773 */   // GIR_Coverage, 12535,
     /* 112773 */   GIR_Done,
     /* 112774 */ // Label 2437: @112774
     /* 112774 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(112800), // Rule ID 12590 //
     /* 112779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112793 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 112793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112798 */   GIR_RootConstrainSelectedInstOperands,
     /* 112799 */   // GIR_Coverage, 12590,
     /* 112799 */   GIR_Done,
     /* 112800 */ // Label 2438: @112800
     /* 112800 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(112826), // Rule ID 18376 //
     /* 112805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112819 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 112819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 112824 */   GIR_RootConstrainSelectedInstOperands,
     /* 112825 */   // GIR_Coverage, 18376,
     /* 112825 */   GIR_Done,
     /* 112826 */ // Label 2439: @112826
     /* 112826 */ GIM_Reject,
     /* 112827 */ // Label 2411: @112827
     /* 112827 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(112886), // Rule ID 21589 //
     /* 112832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112850 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112857 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112861 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112863 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112870 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 112870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrm),
     /* 112873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112884 */   GIR_RootConstrainSelectedInstOperands,
     /* 112885 */   // GIR_Coverage, 21589,
     /* 112885 */   GIR_EraseRootFromParent_Done,
     /* 112886 */ // Label 2440: @112886
     /* 112886 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(112945), // Rule ID 21590 //
     /* 112891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 112897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112909 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112916 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112922 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112929 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 112929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrm),
     /* 112932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112934 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112943 */   GIR_RootConstrainSelectedInstOperands,
     /* 112944 */   // GIR_Coverage, 21590,
     /* 112944 */   GIR_EraseRootFromParent_Done,
     /* 112945 */ // Label 2441: @112945
     /* 112945 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(112971), // Rule ID 12559 //
     /* 112950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112964 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 112964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 112969 */   GIR_RootConstrainSelectedInstOperands,
     /* 112970 */   // GIR_Coverage, 12559,
     /* 112970 */   GIR_Done,
     /* 112971 */ // Label 2442: @112971
     /* 112971 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(112997), // Rule ID 12577 //
     /* 112976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 112982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112990 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 112990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 112995 */   GIR_RootConstrainSelectedInstOperands,
     /* 112996 */   // GIR_Coverage, 12577,
     /* 112996 */   GIR_Done,
     /* 112997 */ // Label 2443: @112997
     /* 112997 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(113023), // Rule ID 12592 //
     /* 113002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 113008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113016 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 113016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 113021 */   GIR_RootConstrainSelectedInstOperands,
     /* 113022 */   // GIR_Coverage, 12592,
     /* 113022 */   GIR_Done,
     /* 113023 */ // Label 2444: @113023
     /* 113023 */ GIM_Reject,
     /* 113024 */ // Label 2412: @113024
     /* 113024 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(113092),
     /* 113029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113040 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(113055), // Rule ID 12585 //
     /* 113045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113048 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 113048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 113053 */     GIR_RootConstrainSelectedInstOperands,
     /* 113054 */     // GIR_Coverage, 12585,
     /* 113054 */     GIR_Done,
     /* 113055 */   // Label 2446: @113055
     /* 113055 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(113091), // Rule ID 21659 //
     /* 113060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113063 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 113084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113089 */     GIR_RootConstrainSelectedInstOperands,
     /* 113090 */     // GIR_Coverage, 21659,
     /* 113090 */     GIR_EraseRootFromParent_Done,
     /* 113091 */   // Label 2447: @113091
     /* 113091 */   GIM_Reject,
     /* 113092 */ // Label 2445: @113092
     /* 113092 */ GIM_Reject,
     /* 113093 */ // Label 2413: @113093
     /* 113093 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(113152), // Rule ID 18380 //
     /* 113098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113116 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113119 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113123 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113129 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113136 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrm),
     /* 113139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113141 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113150 */   GIR_RootConstrainSelectedInstOperands,
     /* 113151 */   // GIR_Coverage, 18380,
     /* 113151 */   GIR_EraseRootFromParent_Done,
     /* 113152 */ // Label 2448: @113152
     /* 113152 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(113211), // Rule ID 21583 //
     /* 113157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113175 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113178 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113182 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113188 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113195 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rm),
     /* 113198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113200 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113209 */   GIR_RootConstrainSelectedInstOperands,
     /* 113210 */   // GIR_Coverage, 21583,
     /* 113210 */   GIR_EraseRootFromParent_Done,
     /* 113211 */ // Label 2449: @113211
     /* 113211 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(113237), // Rule ID 12481 //
     /* 113216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113230 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 113230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 113235 */   GIR_RootConstrainSelectedInstOperands,
     /* 113236 */   // GIR_Coverage, 12481,
     /* 113236 */   GIR_Done,
     /* 113237 */ // Label 2450: @113237
     /* 113237 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(113263), // Rule ID 12587 //
     /* 113242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113256 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 113256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 113261 */   GIR_RootConstrainSelectedInstOperands,
     /* 113262 */   // GIR_Coverage, 12587,
     /* 113262 */   GIR_Done,
     /* 113263 */ // Label 2451: @113263
     /* 113263 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(113289), // Rule ID 18373 //
     /* 113268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113282 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 113282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 113287 */   GIR_RootConstrainSelectedInstOperands,
     /* 113288 */   // GIR_Coverage, 18373,
     /* 113288 */   GIR_Done,
     /* 113289 */ // Label 2452: @113289
     /* 113289 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(113336), // Rule ID 21660 //
     /* 113294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113308 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113320 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 113329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113334 */   GIR_RootConstrainSelectedInstOperands,
     /* 113335 */   // GIR_Coverage, 21660,
     /* 113335 */   GIR_EraseRootFromParent_Done,
     /* 113336 */ // Label 2453: @113336
     /* 113336 */ GIM_Reject,
     /* 113337 */ // Label 2414: @113337
     /* 113337 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(113396), // Rule ID 21587 //
     /* 113342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113360 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113363 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113367 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113373 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113380 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrm),
     /* 113383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113385 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113394 */   GIR_RootConstrainSelectedInstOperands,
     /* 113395 */   // GIR_Coverage, 21587,
     /* 113395 */   GIR_EraseRootFromParent_Done,
     /* 113396 */ // Label 2454: @113396
     /* 113396 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(113455), // Rule ID 21588 //
     /* 113401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113419 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113426 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113430 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113432 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113439 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrm),
     /* 113442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113444 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113453 */   GIR_RootConstrainSelectedInstOperands,
     /* 113454 */   // GIR_Coverage, 21588,
     /* 113454 */   GIR_EraseRootFromParent_Done,
     /* 113455 */ // Label 2455: @113455
     /* 113455 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(113481), // Rule ID 12505 //
     /* 113460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113474 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 113474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 113479 */   GIR_RootConstrainSelectedInstOperands,
     /* 113480 */   // GIR_Coverage, 12505,
     /* 113480 */   GIR_Done,
     /* 113481 */ // Label 2456: @113481
     /* 113481 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(113507), // Rule ID 12541 //
     /* 113486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113500 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 113500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 113505 */   GIR_RootConstrainSelectedInstOperands,
     /* 113506 */   // GIR_Coverage, 12541,
     /* 113506 */   GIR_Done,
     /* 113507 */ // Label 2457: @113507
     /* 113507 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(113533), // Rule ID 12589 //
     /* 113512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113526 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 113526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113531 */   GIR_RootConstrainSelectedInstOperands,
     /* 113532 */   // GIR_Coverage, 12589,
     /* 113532 */   GIR_Done,
     /* 113533 */ // Label 2458: @113533
     /* 113533 */ GIM_Reject,
     /* 113534 */ // Label 2415: @113534
     /* 113534 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(113560), // Rule ID 12584 //
     /* 113539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113553 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 113553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 113558 */   GIR_RootConstrainSelectedInstOperands,
     /* 113559 */   // GIR_Coverage, 12584,
     /* 113559 */   GIR_Done,
     /* 113560 */ // Label 2459: @113560
     /* 113560 */ GIM_Reject,
     /* 113561 */ // Label 2416: @113561
     /* 113561 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(113620), // Rule ID 21586 //
     /* 113566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113576 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113584 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113587 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113591 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113597 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113604 */   // (sext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 113604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrm),
     /* 113607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113609 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113613 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113618 */   GIR_RootConstrainSelectedInstOperands,
     /* 113619 */   // GIR_Coverage, 21586,
     /* 113619 */   GIR_EraseRootFromParent_Done,
     /* 113620 */ // Label 2460: @113620
     /* 113620 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(113646), // Rule ID 12487 //
     /* 113625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113639 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 113639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 113644 */   GIR_RootConstrainSelectedInstOperands,
     /* 113645 */   // GIR_Coverage, 12487,
     /* 113645 */   GIR_Done,
     /* 113646 */ // Label 2461: @113646
     /* 113646 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(113672), // Rule ID 12586 //
     /* 113651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113665 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 113665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 113670 */   GIR_RootConstrainSelectedInstOperands,
     /* 113671 */   // GIR_Coverage, 12586,
     /* 113671 */   GIR_Done,
     /* 113672 */ // Label 2462: @113672
     /* 113672 */ GIM_Reject,
     /* 113673 */ // Label 2417: @113673
     /* 113673 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(113699), // Rule ID 12583 //
     /* 113678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 113684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 113692 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 113692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 113697 */   GIR_RootConstrainSelectedInstOperands,
     /* 113698 */   // GIR_Coverage, 12583,
     /* 113698 */   GIR_Done,
     /* 113699 */ // Label 2463: @113699
     /* 113699 */ GIM_Reject,
     /* 113700 */ // Label 2418: @113700
     /* 113700 */ GIM_Reject,
     /* 113701 */ // Label 24: @113701
     /* 113701 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2466*/ GIMT_Encode4(113942),
     /* 113712 */ /*GILLT_s16*//*Label 2464*/ GIMT_Encode4(113720),
     /* 113716 */ /*GILLT_s32*//*Label 2465*/ GIMT_Encode4(113816),
     /* 113720 */ // Label 2464: @113720
     /* 113720 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(113815), // Rule ID 22643 //
     /* 113725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113736 */   // MIs[0] Operand 2
     /* 113736 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113747 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 113747 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 113750 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113754 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113759 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113765 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113770 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 113775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113787 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113797 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 113804 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 113809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113814 */   // GIR_Coverage, 22643,
     /* 113814 */   GIR_EraseRootFromParent_Done,
     /* 113815 */ // Label 2467: @113815
     /* 113815 */ GIM_Reject,
     /* 113816 */ // Label 2465: @113816
     /* 113816 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(113941),
     /* 113821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113832 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(113886), // Rule ID 22641 //
     /* 113837 */     // MIs[0] Operand 2
     /* 113837 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 113848 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 113848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113860 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 113866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 113871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 113879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113884 */     GIR_RootConstrainSelectedInstOperands,
     /* 113885 */     // GIR_Coverage, 22641,
     /* 113885 */     GIR_EraseRootFromParent_Done,
     /* 113886 */   // Label 2469: @113886
     /* 113886 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(113940), // Rule ID 22642 //
     /* 113891 */     // MIs[0] Operand 2
     /* 113891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113902 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 113902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 113905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113914 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113938 */     GIR_RootConstrainSelectedInstOperands,
     /* 113939 */     // GIR_Coverage, 22642,
     /* 113939 */     GIR_EraseRootFromParent_Done,
     /* 113940 */   // Label 2470: @113940
     /* 113940 */   GIM_Reject,
     /* 113941 */ // Label 2468: @113941
     /* 113941 */ GIM_Reject,
     /* 113942 */ // Label 2466: @113942
     /* 113942 */ GIM_Reject,
     /* 113943 */ // Label 25: @113943
     /* 113943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2480*/ GIMT_Encode4(115926),
     /* 113954 */ /*GILLT_s16*//*Label 2471*/ GIMT_Encode4(114038),
     /* 113958 */ /*GILLT_s32*//*Label 2472*/ GIMT_Encode4(114096),
     /* 113962 */ /*GILLT_s64*//*Label 2473*/ GIMT_Encode4(114448), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113990 */ /*GILLT_v4s64*//*Label 2474*/ GIMT_Encode4(114995), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114002 */ /*GILLT_v8s32*//*Label 2475*/ GIMT_Encode4(115163),
     /* 114006 */ /*GILLT_v8s64*//*Label 2476*/ GIMT_Encode4(115331), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114018 */ /*GILLT_v16s16*//*Label 2477*/ GIMT_Encode4(115502),
     /* 114022 */ /*GILLT_v16s32*//*Label 2478*/ GIMT_Encode4(115670), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114034 */ /*GILLT_v32s16*//*Label 2479*/ GIMT_Encode4(115841),
     /* 114038 */ // Label 2471: @114038
     /* 114038 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(114095), // Rule ID 22649 //
     /* 114043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114054 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 114054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114066 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114077 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114089 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114094 */   // GIR_Coverage, 22649,
     /* 114094 */   GIR_EraseRootFromParent_Done,
     /* 114095 */ // Label 2481: @114095
     /* 114095 */ GIM_Reject,
     /* 114096 */ // Label 2472: @114096
     /* 114096 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(114219), // Rule ID 22973 //
     /* 114101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114119 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114123 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114127 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114131 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114135 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114138 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114142 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114146 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114150 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114154 */   // MIs[3] Operand 1
     /* 114154 */   // No operand predicates
     /* 114154 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114156 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114163 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114175 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114179 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114182 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114185 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114213 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114218 */   // GIR_Coverage, 22973,
     /* 114218 */   GIR_EraseRootFromParent_Done,
     /* 114219 */ // Label 2482: @114219
     /* 114219 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(114314), // Rule ID 22972 //
     /* 114224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114242 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114246 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114255 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114259 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114263 */   // MIs[2] Operand 1
     /* 114263 */   // No operand predicates
     /* 114263 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114265 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114277 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114281 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114284 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114313 */   // GIR_Coverage, 22972,
     /* 114313 */   GIR_EraseRootFromParent_Done,
     /* 114314 */ // Label 2483: @114314
     /* 114314 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(114356), // Rule ID 19435 //
     /* 114319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114326 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114330 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114334 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114338 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114345 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 114345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114350 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114354 */   GIR_RootConstrainSelectedInstOperands,
     /* 114355 */   // GIR_Coverage, 19435,
     /* 114355 */   GIR_EraseRootFromParent_Done,
     /* 114356 */ // Label 2484: @114356
     /* 114356 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(114401), // Rule ID 19438 //
     /* 114361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114379 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114383 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114390 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 114390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114399 */   GIR_RootConstrainSelectedInstOperands,
     /* 114400 */   // GIR_Coverage, 19438,
     /* 114400 */   GIR_EraseRootFromParent_Done,
     /* 114401 */ // Label 2485: @114401
     /* 114401 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(114424), // Rule ID 618 //
     /* 114406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114417 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 114417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114422 */   GIR_RootConstrainSelectedInstOperands,
     /* 114423 */   // GIR_Coverage, 618,
     /* 114423 */   GIR_Done,
     /* 114424 */ // Label 2486: @114424
     /* 114424 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(114447), // Rule ID 620 //
     /* 114429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114440 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 114440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114445 */   GIR_RootConstrainSelectedInstOperands,
     /* 114446 */   // GIR_Coverage, 620,
     /* 114446 */   GIR_Done,
     /* 114447 */ // Label 2487: @114447
     /* 114447 */ GIM_Reject,
     /* 114448 */ // Label 2473: @114448
     /* 114448 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(114571), // Rule ID 22975 //
     /* 114453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114471 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114479 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114483 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114487 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114490 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114494 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114498 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114502 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114506 */   // MIs[3] Operand 1
     /* 114506 */   // No operand predicates
     /* 114506 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114508 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114515 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114527 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114531 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114534 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114537 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114570 */   // GIR_Coverage, 22975,
     /* 114570 */   GIR_EraseRootFromParent_Done,
     /* 114571 */ // Label 2488: @114571
     /* 114571 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(114666), // Rule ID 22974 //
     /* 114576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114586 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114594 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114598 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114602 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114607 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114611 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114615 */   // MIs[2] Operand 1
     /* 114615 */   // No operand predicates
     /* 114615 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114617 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114629 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114633 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114636 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114655 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114665 */   // GIR_Coverage, 22974,
     /* 114665 */   GIR_EraseRootFromParent_Done,
     /* 114666 */ // Label 2489: @114666
     /* 114666 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(114740), // Rule ID 19436 //
     /* 114671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114686 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114690 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114695 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114697 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114734 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114739 */   // GIR_Coverage, 19436,
     /* 114739 */   GIR_EraseRootFromParent_Done,
     /* 114740 */ // Label 2490: @114740
     /* 114740 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(114817), // Rule ID 19439 //
     /* 114745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114763 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114767 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114772 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114774 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114786 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114816 */   // GIR_Coverage, 19439,
     /* 114816 */   GIR_EraseRootFromParent_Done,
     /* 114817 */ // Label 2491: @114817
     /* 114817 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(114876), // Rule ID 17590 //
     /* 114822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114833 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 114833 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114836 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114840 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114845 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114875 */   // GIR_Coverage, 17590,
     /* 114875 */   GIR_EraseRootFromParent_Done,
     /* 114876 */ // Label 2492: @114876
     /* 114876 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(114935), // Rule ID 17592 //
     /* 114881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114892 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 114892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114904 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114934 */   // GIR_Coverage, 17592,
     /* 114934 */   GIR_EraseRootFromParent_Done,
     /* 114935 */ // Label 2493: @114935
     /* 114935 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(114994), // Rule ID 17594 //
     /* 114940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114951 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 114951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 114958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114963 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114993 */   // GIR_Coverage, 17594,
     /* 114993 */   GIR_EraseRootFromParent_Done,
     /* 114994 */ // Label 2494: @114994
     /* 114994 */ GIM_Reject,
     /* 114995 */ // Label 2474: @114995
     /* 114995 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(115162),
     /* 115000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115003 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(115059), // Rule ID 18413 //
     /* 115008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115043 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrm),
     /* 115046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115057 */     GIR_RootConstrainSelectedInstOperands,
     /* 115058 */     // GIR_Coverage, 18413,
     /* 115058 */     GIR_EraseRootFromParent_Done,
     /* 115059 */   // Label 2496: @115059
     /* 115059 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(115115), // Rule ID 21618 //
     /* 115064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115099 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rm),
     /* 115102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115113 */     GIR_RootConstrainSelectedInstOperands,
     /* 115114 */     // GIR_Coverage, 21618,
     /* 115114 */     GIR_EraseRootFromParent_Done,
     /* 115115 */   // Label 2497: @115115
     /* 115115 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(115138), // Rule ID 12463 //
     /* 115120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115131 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 115131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 115136 */     GIR_RootConstrainSelectedInstOperands,
     /* 115137 */     // GIR_Coverage, 12463,
     /* 115137 */     GIR_Done,
     /* 115138 */   // Label 2498: @115138
     /* 115138 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(115161), // Rule ID 18401 //
     /* 115143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115154 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 115154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 115159 */     GIR_RootConstrainSelectedInstOperands,
     /* 115160 */     // GIR_Coverage, 18401,
     /* 115160 */     GIR_Done,
     /* 115161 */   // Label 2499: @115161
     /* 115161 */   GIM_Reject,
     /* 115162 */ // Label 2495: @115162
     /* 115162 */ GIM_Reject,
     /* 115163 */ // Label 2475: @115163
     /* 115163 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(115330),
     /* 115168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115171 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(115227), // Rule ID 18409 //
     /* 115176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115211 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrm),
     /* 115214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115225 */     GIR_RootConstrainSelectedInstOperands,
     /* 115226 */     // GIR_Coverage, 18409,
     /* 115226 */     GIR_EraseRootFromParent_Done,
     /* 115227 */   // Label 2501: @115227
     /* 115227 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(115283), // Rule ID 21617 //
     /* 115232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115247 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115267 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rm),
     /* 115270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115281 */     GIR_RootConstrainSelectedInstOperands,
     /* 115282 */     // GIR_Coverage, 21617,
     /* 115282 */     GIR_EraseRootFromParent_Done,
     /* 115283 */   // Label 2502: @115283
     /* 115283 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(115306), // Rule ID 12427 //
     /* 115288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115299 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 115299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 115304 */     GIR_RootConstrainSelectedInstOperands,
     /* 115305 */     // GIR_Coverage, 12427,
     /* 115305 */     GIR_Done,
     /* 115306 */   // Label 2503: @115306
     /* 115306 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(115329), // Rule ID 18399 //
     /* 115311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115322 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 115322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 115327 */     GIR_RootConstrainSelectedInstOperands,
     /* 115328 */     // GIR_Coverage, 18399,
     /* 115328 */     GIR_Done,
     /* 115329 */   // Label 2504: @115329
     /* 115329 */   GIM_Reject,
     /* 115330 */ // Label 2500: @115330
     /* 115330 */ GIM_Reject,
     /* 115331 */ // Label 2476: @115331
     /* 115331 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(115390), // Rule ID 21622 //
     /* 115336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115354 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115361 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115365 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115367 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115374 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrm),
     /* 115377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115379 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115388 */   GIR_RootConstrainSelectedInstOperands,
     /* 115389 */   // GIR_Coverage, 21622,
     /* 115389 */   GIR_EraseRootFromParent_Done,
     /* 115390 */ // Label 2505: @115390
     /* 115390 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(115449), // Rule ID 21623 //
     /* 115395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115413 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115416 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115420 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115426 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115433 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrm),
     /* 115436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115438 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115447 */   GIR_RootConstrainSelectedInstOperands,
     /* 115448 */   // GIR_Coverage, 21623,
     /* 115448 */   GIR_EraseRootFromParent_Done,
     /* 115449 */ // Label 2506: @115449
     /* 115449 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(115475), // Rule ID 12451 //
     /* 115454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115468 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 115468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 115473 */   GIR_RootConstrainSelectedInstOperands,
     /* 115474 */   // GIR_Coverage, 12451,
     /* 115474 */   GIR_Done,
     /* 115475 */ // Label 2507: @115475
     /* 115475 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(115501), // Rule ID 12469 //
     /* 115480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115494 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 115494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 115499 */   GIR_RootConstrainSelectedInstOperands,
     /* 115500 */   // GIR_Coverage, 12469,
     /* 115500 */   GIR_Done,
     /* 115501 */ // Label 2508: @115501
     /* 115501 */ GIM_Reject,
     /* 115502 */ // Label 2477: @115502
     /* 115502 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(115669),
     /* 115507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115510 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(115566), // Rule ID 18403 //
     /* 115515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115550 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrm),
     /* 115553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115564 */     GIR_RootConstrainSelectedInstOperands,
     /* 115565 */     // GIR_Coverage, 18403,
     /* 115565 */     GIR_EraseRootFromParent_Done,
     /* 115566 */   // Label 2510: @115566
     /* 115566 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(115622), // Rule ID 21616 //
     /* 115571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115606 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rm),
     /* 115609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115620 */     GIR_RootConstrainSelectedInstOperands,
     /* 115621 */     // GIR_Coverage, 21616,
     /* 115621 */     GIR_EraseRootFromParent_Done,
     /* 115622 */   // Label 2511: @115622
     /* 115622 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(115645), // Rule ID 12373 //
     /* 115627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115638 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 115638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 115643 */     GIR_RootConstrainSelectedInstOperands,
     /* 115644 */     // GIR_Coverage, 12373,
     /* 115644 */     GIR_Done,
     /* 115645 */   // Label 2512: @115645
     /* 115645 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(115668), // Rule ID 18396 //
     /* 115650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115661 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 115661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 115666 */     GIR_RootConstrainSelectedInstOperands,
     /* 115667 */     // GIR_Coverage, 18396,
     /* 115667 */     GIR_Done,
     /* 115668 */   // Label 2513: @115668
     /* 115668 */   GIM_Reject,
     /* 115669 */ // Label 2509: @115669
     /* 115669 */ GIM_Reject,
     /* 115670 */ // Label 2478: @115670
     /* 115670 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(115729), // Rule ID 21620 //
     /* 115675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115693 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115700 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115704 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115706 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115713 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrm),
     /* 115716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115718 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115727 */   GIR_RootConstrainSelectedInstOperands,
     /* 115728 */   // GIR_Coverage, 21620,
     /* 115728 */   GIR_EraseRootFromParent_Done,
     /* 115729 */ // Label 2514: @115729
     /* 115729 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(115788), // Rule ID 21621 //
     /* 115734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115752 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115759 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115765 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115772 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 115775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115777 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115781 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115786 */   GIR_RootConstrainSelectedInstOperands,
     /* 115787 */   // GIR_Coverage, 21621,
     /* 115787 */   GIR_EraseRootFromParent_Done,
     /* 115788 */ // Label 2515: @115788
     /* 115788 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(115814), // Rule ID 12397 //
     /* 115793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115807 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 115807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 115812 */   GIR_RootConstrainSelectedInstOperands,
     /* 115813 */   // GIR_Coverage, 12397,
     /* 115813 */   GIR_Done,
     /* 115814 */ // Label 2516: @115814
     /* 115814 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(115840), // Rule ID 12433 //
     /* 115819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115833 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 115833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 115838 */   GIR_RootConstrainSelectedInstOperands,
     /* 115839 */   // GIR_Coverage, 12433,
     /* 115839 */   GIR_Done,
     /* 115840 */ // Label 2517: @115840
     /* 115840 */ GIM_Reject,
     /* 115841 */ // Label 2479: @115841
     /* 115841 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(115925),
     /* 115846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 115849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115853 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(115905), // Rule ID 21619 //
     /* 115858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 115861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115889 */     // (zext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 115889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrm),
     /* 115892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115894 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115903 */     GIR_RootConstrainSelectedInstOperands,
     /* 115904 */     // GIR_Coverage, 21619,
     /* 115904 */     GIR_EraseRootFromParent_Done,
     /* 115905 */   // Label 2519: @115905
     /* 115905 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(115924), // Rule ID 12379 //
     /* 115910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 115913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115917 */     // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 115917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 115922 */     GIR_RootConstrainSelectedInstOperands,
     /* 115923 */     // GIR_Coverage, 12379,
     /* 115923 */     GIR_Done,
     /* 115924 */   // Label 2520: @115924
     /* 115924 */   GIM_Reject,
     /* 115925 */ // Label 2518: @115925
     /* 115925 */ GIM_Reject,
     /* 115926 */ // Label 2480: @115926
     /* 115926 */ GIM_Reject,
     /* 115927 */ // Label 26: @115927
     /* 115927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2525*/ GIMT_Encode4(118210),
     /* 115938 */ /*GILLT_s8*//*Label 2521*/ GIMT_Encode4(115954),
     /* 115942 */ /*GILLT_s16*//*Label 2522*/ GIMT_Encode4(116329),
     /* 115946 */ /*GILLT_s32*//*Label 2523*/ GIMT_Encode4(116704),
     /* 115950 */ /*GILLT_s64*//*Label 2524*/ GIMT_Encode4(117457),
     /* 115954 */ // Label 2521: @115954
     /* 115954 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(116328),
     /* 115959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 115962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 115965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115969 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(116036), // Rule ID 673 //
     /* 115974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115992 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 115996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116004 */     // MIs[2] Operand 1
     /* 116004 */     // No operand predicates
     /* 116004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116013 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi_ND),
     /* 116016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116034 */     GIR_RootConstrainSelectedInstOperands,
     /* 116035 */     // GIR_Coverage, 673,
     /* 116035 */     GIR_EraseRootFromParent_Done,
     /* 116036 */   // Label 2527: @116036
     /* 116036 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(116109), // Rule ID 689 //
     /* 116041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116059 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116076 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116080 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL_ND),
     /* 116093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116107 */     GIR_RootConstrainSelectedInstOperands,
     /* 116108 */     // GIR_Coverage, 689,
     /* 116108 */     GIR_EraseRootFromParent_Done,
     /* 116109 */   // Label 2528: @116109
     /* 116109 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(116139), // Rule ID 22674 //
     /* 116114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116125 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 116128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116137 */     GIR_RootConstrainSelectedInstOperands,
     /* 116138 */     // GIR_Coverage, 22674,
     /* 116138 */     GIR_EraseRootFromParent_Done,
     /* 116139 */   // Label 2529: @116139
     /* 116139 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(116169), // Rule ID 22678 //
     /* 116144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116155 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 116158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116160 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116167 */     GIR_RootConstrainSelectedInstOperands,
     /* 116168 */     // GIR_Coverage, 22678,
     /* 116168 */     GIR_EraseRootFromParent_Done,
     /* 116169 */   // Label 2530: @116169
     /* 116169 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(116206), // Rule ID 661 //
     /* 116174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116189 */     // MIs[1] Operand 1
     /* 116189 */     // No operand predicates
     /* 116189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116191 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 116194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116204 */     GIR_RootConstrainSelectedInstOperands,
     /* 116205 */     // GIR_Coverage, 661,
     /* 116205 */     GIR_EraseRootFromParent_Done,
     /* 116206 */   // Label 2531: @116206
     /* 116206 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(116243), // Rule ID 665 //
     /* 116211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116226 */     // MIs[1] Operand 1
     /* 116226 */     // No operand predicates
     /* 116226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116228 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 116231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116233 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116241 */     GIR_RootConstrainSelectedInstOperands,
     /* 116242 */     // GIR_Coverage, 665,
     /* 116242 */     GIR_EraseRootFromParent_Done,
     /* 116243 */   // Label 2532: @116243
     /* 116243 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(116285), // Rule ID 677 //
     /* 116248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116259 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116263 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 116276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116283 */     GIR_RootConstrainSelectedInstOperands,
     /* 116284 */     // GIR_Coverage, 677,
     /* 116284 */     GIR_EraseRootFromParent_Done,
     /* 116285 */   // Label 2533: @116285
     /* 116285 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(116327), // Rule ID 681 //
     /* 116290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116301 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116305 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 116318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116325 */     GIR_RootConstrainSelectedInstOperands,
     /* 116326 */     // GIR_Coverage, 681,
     /* 116326 */     GIR_EraseRootFromParent_Done,
     /* 116327 */   // Label 2534: @116327
     /* 116327 */   GIM_Reject,
     /* 116328 */ // Label 2526: @116328
     /* 116328 */ GIM_Reject,
     /* 116329 */ // Label 2522: @116329
     /* 116329 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(116703),
     /* 116334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116344 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(116411), // Rule ID 674 //
     /* 116349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116367 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116379 */     // MIs[2] Operand 1
     /* 116379 */     // No operand predicates
     /* 116379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116388 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi_ND),
     /* 116391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116409 */     GIR_RootConstrainSelectedInstOperands,
     /* 116410 */     // GIR_Coverage, 674,
     /* 116410 */     GIR_EraseRootFromParent_Done,
     /* 116411 */   // Label 2536: @116411
     /* 116411 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(116484), // Rule ID 690 //
     /* 116416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116427 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116430 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116434 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116451 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116455 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL_ND),
     /* 116468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116482 */     GIR_RootConstrainSelectedInstOperands,
     /* 116483 */     // GIR_Coverage, 690,
     /* 116483 */     GIR_EraseRootFromParent_Done,
     /* 116484 */   // Label 2537: @116484
     /* 116484 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(116514), // Rule ID 22675 //
     /* 116489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116500 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 116503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116505 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116512 */     GIR_RootConstrainSelectedInstOperands,
     /* 116513 */     // GIR_Coverage, 22675,
     /* 116513 */     GIR_EraseRootFromParent_Done,
     /* 116514 */   // Label 2538: @116514
     /* 116514 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(116544), // Rule ID 22679 //
     /* 116519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116530 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 116533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116542 */     GIR_RootConstrainSelectedInstOperands,
     /* 116543 */     // GIR_Coverage, 22679,
     /* 116543 */     GIR_EraseRootFromParent_Done,
     /* 116544 */   // Label 2539: @116544
     /* 116544 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(116581), // Rule ID 662 //
     /* 116549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116564 */     // MIs[1] Operand 1
     /* 116564 */     // No operand predicates
     /* 116564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116566 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 116569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116579 */     GIR_RootConstrainSelectedInstOperands,
     /* 116580 */     // GIR_Coverage, 662,
     /* 116580 */     GIR_EraseRootFromParent_Done,
     /* 116581 */   // Label 2540: @116581
     /* 116581 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(116618), // Rule ID 666 //
     /* 116586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116601 */     // MIs[1] Operand 1
     /* 116601 */     // No operand predicates
     /* 116601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116603 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 116606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116608 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116616 */     GIR_RootConstrainSelectedInstOperands,
     /* 116617 */     // GIR_Coverage, 666,
     /* 116617 */     GIR_EraseRootFromParent_Done,
     /* 116618 */   // Label 2541: @116618
     /* 116618 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(116660), // Rule ID 678 //
     /* 116623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116634 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116638 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 116651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116658 */     GIR_RootConstrainSelectedInstOperands,
     /* 116659 */     // GIR_Coverage, 678,
     /* 116659 */     GIR_EraseRootFromParent_Done,
     /* 116660 */   // Label 2542: @116660
     /* 116660 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(116702), // Rule ID 682 //
     /* 116665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116676 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116680 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 116693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116700 */     GIR_RootConstrainSelectedInstOperands,
     /* 116701 */     // GIR_Coverage, 682,
     /* 116701 */     GIR_EraseRootFromParent_Done,
     /* 116702 */   // Label 2543: @116702
     /* 116702 */   GIM_Reject,
     /* 116703 */ // Label 2535: @116703
     /* 116703 */ GIM_Reject,
     /* 116704 */ // Label 2523: @116704
     /* 116704 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(117456),
     /* 116709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116719 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(116786), // Rule ID 675 //
     /* 116724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116738 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116742 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116754 */     // MIs[2] Operand 1
     /* 116754 */     // No operand predicates
     /* 116754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116763 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi_ND),
     /* 116766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116784 */     GIR_RootConstrainSelectedInstOperands,
     /* 116785 */     // GIR_Coverage, 675,
     /* 116785 */     GIR_EraseRootFromParent_Done,
     /* 116786 */   // Label 2545: @116786
     /* 116786 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(116859), // Rule ID 691 //
     /* 116791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116802 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116809 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116826 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116830 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL_ND),
     /* 116843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116857 */     GIR_RootConstrainSelectedInstOperands,
     /* 116858 */     // GIR_Coverage, 691,
     /* 116858 */     GIR_EraseRootFromParent_Done,
     /* 116859 */   // Label 2546: @116859
     /* 116859 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(116969), // Rule ID 17672 //
     /* 116864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 116867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116875 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116882 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116899 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 116899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116925 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 116932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 116935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 116950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm),
     /* 116953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116967 */     GIR_RootConstrainSelectedInstOperands,
     /* 116968 */     // GIR_Coverage, 17672,
     /* 116968 */     GIR_EraseRootFromParent_Done,
     /* 116969 */   // Label 2547: @116969
     /* 116969 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(117079), // Rule ID 17704 //
     /* 116974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 116977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116992 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117009 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm_EVEX),
     /* 117063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117077 */     GIR_RootConstrainSelectedInstOperands,
     /* 117078 */     // GIR_Coverage, 17704,
     /* 117078 */     GIR_EraseRootFromParent_Done,
     /* 117079 */   // Label 2548: @117079
     /* 117079 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(117109), // Rule ID 22676 //
     /* 117084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117095 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 117098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117102 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117107 */     GIR_RootConstrainSelectedInstOperands,
     /* 117108 */     // GIR_Coverage, 22676,
     /* 117108 */     GIR_EraseRootFromParent_Done,
     /* 117109 */   // Label 2549: @117109
     /* 117109 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(117139), // Rule ID 22680 //
     /* 117114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117125 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 117128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117137 */     GIR_RootConstrainSelectedInstOperands,
     /* 117138 */     // GIR_Coverage, 22680,
     /* 117138 */     GIR_EraseRootFromParent_Done,
     /* 117139 */   // Label 2550: @117139
     /* 117139 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(117176), // Rule ID 663 //
     /* 117144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117159 */     // MIs[1] Operand 1
     /* 117159 */     // No operand predicates
     /* 117159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117161 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 117164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117174 */     GIR_RootConstrainSelectedInstOperands,
     /* 117175 */     // GIR_Coverage, 663,
     /* 117175 */     GIR_EraseRootFromParent_Done,
     /* 117176 */   // Label 2551: @117176
     /* 117176 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(117213), // Rule ID 667 //
     /* 117181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117196 */     // MIs[1] Operand 1
     /* 117196 */     // No operand predicates
     /* 117196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117198 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 117201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117211 */     GIR_RootConstrainSelectedInstOperands,
     /* 117212 */     // GIR_Coverage, 667,
     /* 117212 */     GIR_EraseRootFromParent_Done,
     /* 117213 */   // Label 2552: @117213
     /* 117213 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(117292), // Rule ID 17668 //
     /* 117218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117229 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 117283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117290 */     GIR_RootConstrainSelectedInstOperands,
     /* 117291 */     // GIR_Coverage, 17668,
     /* 117291 */     GIR_EraseRootFromParent_Done,
     /* 117292 */   // Label 2553: @117292
     /* 117292 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(117371), // Rule ID 17700 //
     /* 117297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117308 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117334 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117341 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 117362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117364 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117369 */     GIR_RootConstrainSelectedInstOperands,
     /* 117370 */     // GIR_Coverage, 17700,
     /* 117370 */     GIR_EraseRootFromParent_Done,
     /* 117371 */   // Label 2554: @117371
     /* 117371 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(117413), // Rule ID 679 //
     /* 117376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117387 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117391 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 117404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117411 */     GIR_RootConstrainSelectedInstOperands,
     /* 117412 */     // GIR_Coverage, 679,
     /* 117412 */     GIR_EraseRootFromParent_Done,
     /* 117413 */   // Label 2555: @117413
     /* 117413 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(117455), // Rule ID 683 //
     /* 117418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117429 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117433 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117439 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 117446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117453 */     GIR_RootConstrainSelectedInstOperands,
     /* 117454 */     // GIR_Coverage, 683,
     /* 117454 */     GIR_EraseRootFromParent_Done,
     /* 117455 */   // Label 2556: @117455
     /* 117455 */   GIM_Reject,
     /* 117456 */ // Label 2544: @117456
     /* 117456 */ GIM_Reject,
     /* 117457 */ // Label 2524: @117457
     /* 117457 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(118209),
     /* 117462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 117468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117472 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(117539), // Rule ID 676 //
     /* 117477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 117503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117507 */     // MIs[2] Operand 1
     /* 117507 */     // No operand predicates
     /* 117507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117516 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi_ND),
     /* 117519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 117528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117537 */     GIR_RootConstrainSelectedInstOperands,
     /* 117538 */     // GIR_Coverage, 676,
     /* 117538 */     GIR_EraseRootFromParent_Done,
     /* 117539 */   // Label 2558: @117539
     /* 117539 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(117612), // Rule ID 692 //
     /* 117544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117555 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117558 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117562 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117579 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117583 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL_ND),
     /* 117596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117610 */     GIR_RootConstrainSelectedInstOperands,
     /* 117611 */     // GIR_Coverage, 692,
     /* 117611 */     GIR_EraseRootFromParent_Done,
     /* 117612 */   // Label 2559: @117612
     /* 117612 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(117722), // Rule ID 17673 //
     /* 117617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117652 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117652 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117655 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117659 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117678 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm),
     /* 117706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117720 */     GIR_RootConstrainSelectedInstOperands,
     /* 117721 */     // GIR_Coverage, 17673,
     /* 117721 */     GIR_EraseRootFromParent_Done,
     /* 117722 */   // Label 2560: @117722
     /* 117722 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(117832), // Rule ID 17705 //
     /* 117727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117762 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117788 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117795 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm_EVEX),
     /* 117816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117830 */     GIR_RootConstrainSelectedInstOperands,
     /* 117831 */     // GIR_Coverage, 17705,
     /* 117831 */     GIR_EraseRootFromParent_Done,
     /* 117832 */   // Label 2561: @117832
     /* 117832 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(117862), // Rule ID 22677 //
     /* 117837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117848 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 117848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 117851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117855 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117860 */     GIR_RootConstrainSelectedInstOperands,
     /* 117861 */     // GIR_Coverage, 22677,
     /* 117861 */     GIR_EraseRootFromParent_Done,
     /* 117862 */   // Label 2562: @117862
     /* 117862 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(117892), // Rule ID 22681 //
     /* 117867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117878 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 117878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 117881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117890 */     GIR_RootConstrainSelectedInstOperands,
     /* 117891 */     // GIR_Coverage, 22681,
     /* 117891 */     GIR_EraseRootFromParent_Done,
     /* 117892 */   // Label 2563: @117892
     /* 117892 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(117929), // Rule ID 664 //
     /* 117897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117912 */     // MIs[1] Operand 1
     /* 117912 */     // No operand predicates
     /* 117912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117914 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 117917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117919 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117927 */     GIR_RootConstrainSelectedInstOperands,
     /* 117928 */     // GIR_Coverage, 664,
     /* 117928 */     GIR_EraseRootFromParent_Done,
     /* 117929 */   // Label 2564: @117929
     /* 117929 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(117966), // Rule ID 668 //
     /* 117934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117949 */     // MIs[1] Operand 1
     /* 117949 */     // No operand predicates
     /* 117949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117951 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 117954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117964 */     GIR_RootConstrainSelectedInstOperands,
     /* 117965 */     // GIR_Coverage, 668,
     /* 117965 */     GIR_EraseRootFromParent_Done,
     /* 117966 */   // Label 2565: @117966
     /* 117966 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(118045), // Rule ID 17669 //
     /* 117971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117982 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118008 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 118036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118038 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118043 */     GIR_RootConstrainSelectedInstOperands,
     /* 118044 */     // GIR_Coverage, 17669,
     /* 118044 */     GIR_EraseRootFromParent_Done,
     /* 118045 */   // Label 2566: @118045
     /* 118045 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(118124), // Rule ID 17701 //
     /* 118050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 118053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118061 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 118115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118122 */     GIR_RootConstrainSelectedInstOperands,
     /* 118123 */     // GIR_Coverage, 17701,
     /* 118123 */     GIR_EraseRootFromParent_Done,
     /* 118124 */   // Label 2567: @118124
     /* 118124 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(118166), // Rule ID 680 //
     /* 118129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118140 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118144 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 118157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118159 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118164 */     GIR_RootConstrainSelectedInstOperands,
     /* 118165 */     // GIR_Coverage, 680,
     /* 118165 */     GIR_EraseRootFromParent_Done,
     /* 118166 */   // Label 2568: @118166
     /* 118166 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(118208), // Rule ID 684 //
     /* 118171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118182 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118186 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 118199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118206 */     GIR_RootConstrainSelectedInstOperands,
     /* 118207 */     // GIR_Coverage, 684,
     /* 118207 */     GIR_EraseRootFromParent_Done,
     /* 118208 */   // Label 2569: @118208
     /* 118208 */   GIM_Reject,
     /* 118209 */ // Label 2557: @118209
     /* 118209 */ GIM_Reject,
     /* 118210 */ // Label 2525: @118210
     /* 118210 */ GIM_Reject,
     /* 118211 */ // Label 27: @118211
     /* 118211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2574*/ GIMT_Encode4(120254),
     /* 118222 */ /*GILLT_s8*//*Label 2570*/ GIMT_Encode4(118238),
     /* 118226 */ /*GILLT_s16*//*Label 2571*/ GIMT_Encode4(118553),
     /* 118230 */ /*GILLT_s32*//*Label 2572*/ GIMT_Encode4(118868),
     /* 118234 */ /*GILLT_s64*//*Label 2573*/ GIMT_Encode4(119561),
     /* 118238 */ // Label 2570: @118238
     /* 118238 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(118552),
     /* 118243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 118246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118253 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(118320), // Rule ID 705 //
     /* 118258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118276 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118288 */     // MIs[2] Operand 1
     /* 118288 */     // No operand predicates
     /* 118288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118297 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi_ND),
     /* 118300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118318 */     GIR_RootConstrainSelectedInstOperands,
     /* 118319 */     // GIR_Coverage, 705,
     /* 118319 */     GIR_EraseRootFromParent_Done,
     /* 118320 */   // Label 2576: @118320
     /* 118320 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(118393), // Rule ID 721 //
     /* 118325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118343 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118360 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118364 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL_ND),
     /* 118377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118391 */     GIR_RootConstrainSelectedInstOperands,
     /* 118392 */     // GIR_Coverage, 721,
     /* 118392 */     GIR_EraseRootFromParent_Done,
     /* 118393 */   // Label 2577: @118393
     /* 118393 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(118430), // Rule ID 693 //
     /* 118398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118413 */     // MIs[1] Operand 1
     /* 118413 */     // No operand predicates
     /* 118413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118415 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 118418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118428 */     GIR_RootConstrainSelectedInstOperands,
     /* 118429 */     // GIR_Coverage, 693,
     /* 118429 */     GIR_EraseRootFromParent_Done,
     /* 118430 */   // Label 2578: @118430
     /* 118430 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(118467), // Rule ID 697 //
     /* 118435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118450 */     // MIs[1] Operand 1
     /* 118450 */     // No operand predicates
     /* 118450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118452 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 118455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118465 */     GIR_RootConstrainSelectedInstOperands,
     /* 118466 */     // GIR_Coverage, 697,
     /* 118466 */     GIR_EraseRootFromParent_Done,
     /* 118467 */   // Label 2579: @118467
     /* 118467 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(118509), // Rule ID 709 //
     /* 118472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118483 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118487 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 118500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118507 */     GIR_RootConstrainSelectedInstOperands,
     /* 118508 */     // GIR_Coverage, 709,
     /* 118508 */     GIR_EraseRootFromParent_Done,
     /* 118509 */   // Label 2580: @118509
     /* 118509 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(118551), // Rule ID 713 //
     /* 118514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118525 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118529 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 118542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118549 */     GIR_RootConstrainSelectedInstOperands,
     /* 118550 */     // GIR_Coverage, 713,
     /* 118550 */     GIR_EraseRootFromParent_Done,
     /* 118551 */   // Label 2581: @118551
     /* 118551 */   GIM_Reject,
     /* 118552 */ // Label 2575: @118552
     /* 118552 */ GIM_Reject,
     /* 118553 */ // Label 2571: @118553
     /* 118553 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(118867),
     /* 118558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118568 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(118635), // Rule ID 706 //
     /* 118573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118591 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118603 */     // MIs[2] Operand 1
     /* 118603 */     // No operand predicates
     /* 118603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118612 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi_ND),
     /* 118615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118633 */     GIR_RootConstrainSelectedInstOperands,
     /* 118634 */     // GIR_Coverage, 706,
     /* 118634 */     GIR_EraseRootFromParent_Done,
     /* 118635 */   // Label 2583: @118635
     /* 118635 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(118708), // Rule ID 722 //
     /* 118640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118654 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118658 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118675 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118679 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL_ND),
     /* 118692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118706 */     GIR_RootConstrainSelectedInstOperands,
     /* 118707 */     // GIR_Coverage, 722,
     /* 118707 */     GIR_EraseRootFromParent_Done,
     /* 118708 */   // Label 2584: @118708
     /* 118708 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(118745), // Rule ID 694 //
     /* 118713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118728 */     // MIs[1] Operand 1
     /* 118728 */     // No operand predicates
     /* 118728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118730 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 118733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118743 */     GIR_RootConstrainSelectedInstOperands,
     /* 118744 */     // GIR_Coverage, 694,
     /* 118744 */     GIR_EraseRootFromParent_Done,
     /* 118745 */   // Label 2585: @118745
     /* 118745 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(118782), // Rule ID 698 //
     /* 118750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118765 */     // MIs[1] Operand 1
     /* 118765 */     // No operand predicates
     /* 118765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118767 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 118770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118780 */     GIR_RootConstrainSelectedInstOperands,
     /* 118781 */     // GIR_Coverage, 698,
     /* 118781 */     GIR_EraseRootFromParent_Done,
     /* 118782 */   // Label 2586: @118782
     /* 118782 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(118824), // Rule ID 710 //
     /* 118787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118798 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 118798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118802 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 118815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118822 */     GIR_RootConstrainSelectedInstOperands,
     /* 118823 */     // GIR_Coverage, 710,
     /* 118823 */     GIR_EraseRootFromParent_Done,
     /* 118824 */   // Label 2587: @118824
     /* 118824 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(118866), // Rule ID 714 //
     /* 118829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118840 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 118840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118844 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 118857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118864 */     GIR_RootConstrainSelectedInstOperands,
     /* 118865 */     // GIR_Coverage, 714,
     /* 118865 */     GIR_EraseRootFromParent_Done,
     /* 118866 */   // Label 2588: @118866
     /* 118866 */   GIM_Reject,
     /* 118867 */ // Label 2582: @118867
     /* 118867 */ GIM_Reject,
     /* 118868 */ // Label 2572: @118868
     /* 118868 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(119560),
     /* 118873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118883 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(118950), // Rule ID 707 //
     /* 118888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118899 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118906 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118918 */     // MIs[2] Operand 1
     /* 118918 */     // No operand predicates
     /* 118918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118927 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi_ND),
     /* 118930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118948 */     GIR_RootConstrainSelectedInstOperands,
     /* 118949 */     // GIR_Coverage, 707,
     /* 118949 */     GIR_EraseRootFromParent_Done,
     /* 118950 */   // Label 2590: @118950
     /* 118950 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(119023), // Rule ID 723 //
     /* 118955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118973 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118990 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118994 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL_ND),
     /* 119007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119021 */     GIR_RootConstrainSelectedInstOperands,
     /* 119022 */     // GIR_Coverage, 723,
     /* 119022 */     GIR_EraseRootFromParent_Done,
     /* 119023 */   // Label 2591: @119023
     /* 119023 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(119133), // Rule ID 17664 //
     /* 119028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119039 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119046 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119063 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm),
     /* 119117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119131 */     GIR_RootConstrainSelectedInstOperands,
     /* 119132 */     // GIR_Coverage, 17664,
     /* 119132 */     GIR_EraseRootFromParent_Done,
     /* 119133 */   // Label 2592: @119133
     /* 119133 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(119243), // Rule ID 17696 //
     /* 119138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119156 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119173 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm_EVEX),
     /* 119227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119241 */     GIR_RootConstrainSelectedInstOperands,
     /* 119242 */     // GIR_Coverage, 17696,
     /* 119242 */     GIR_EraseRootFromParent_Done,
     /* 119243 */   // Label 2593: @119243
     /* 119243 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(119280), // Rule ID 695 //
     /* 119248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119263 */     // MIs[1] Operand 1
     /* 119263 */     // No operand predicates
     /* 119263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119265 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 119268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119278 */     GIR_RootConstrainSelectedInstOperands,
     /* 119279 */     // GIR_Coverage, 695,
     /* 119279 */     GIR_EraseRootFromParent_Done,
     /* 119280 */   // Label 2594: @119280
     /* 119280 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(119317), // Rule ID 699 //
     /* 119285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119300 */     // MIs[1] Operand 1
     /* 119300 */     // No operand predicates
     /* 119300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119302 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 119305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119315 */     GIR_RootConstrainSelectedInstOperands,
     /* 119316 */     // GIR_Coverage, 699,
     /* 119316 */     GIR_EraseRootFromParent_Done,
     /* 119317 */   // Label 2595: @119317
     /* 119317 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(119396), // Rule ID 17660 //
     /* 119322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119333 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119359 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119366 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 119387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119394 */     GIR_RootConstrainSelectedInstOperands,
     /* 119395 */     // GIR_Coverage, 17660,
     /* 119395 */     GIR_EraseRootFromParent_Done,
     /* 119396 */   // Label 2596: @119396
     /* 119396 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(119475), // Rule ID 17692 //
     /* 119401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119412 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119445 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 119466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119473 */     GIR_RootConstrainSelectedInstOperands,
     /* 119474 */     // GIR_Coverage, 17692,
     /* 119474 */     GIR_EraseRootFromParent_Done,
     /* 119475 */   // Label 2597: @119475
     /* 119475 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(119517), // Rule ID 711 //
     /* 119480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119491 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119495 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 119508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119510 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119515 */     GIR_RootConstrainSelectedInstOperands,
     /* 119516 */     // GIR_Coverage, 711,
     /* 119516 */     GIR_EraseRootFromParent_Done,
     /* 119517 */   // Label 2598: @119517
     /* 119517 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(119559), // Rule ID 715 //
     /* 119522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119533 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119537 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 119550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119552 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119557 */     GIR_RootConstrainSelectedInstOperands,
     /* 119558 */     // GIR_Coverage, 715,
     /* 119558 */     GIR_EraseRootFromParent_Done,
     /* 119559 */   // Label 2599: @119559
     /* 119559 */   GIM_Reject,
     /* 119560 */ // Label 2589: @119560
     /* 119560 */ GIM_Reject,
     /* 119561 */ // Label 2573: @119561
     /* 119561 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(120253),
     /* 119566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119576 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(119643), // Rule ID 708 //
     /* 119581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119611 */     // MIs[2] Operand 1
     /* 119611 */     // No operand predicates
     /* 119611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119620 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi_ND),
     /* 119623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119641 */     GIR_RootConstrainSelectedInstOperands,
     /* 119642 */     // GIR_Coverage, 708,
     /* 119642 */     GIR_EraseRootFromParent_Done,
     /* 119643 */   // Label 2601: @119643
     /* 119643 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(119716), // Rule ID 724 //
     /* 119648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119659 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119666 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119683 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119687 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL_ND),
     /* 119700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119714 */     GIR_RootConstrainSelectedInstOperands,
     /* 119715 */     // GIR_Coverage, 724,
     /* 119715 */     GIR_EraseRootFromParent_Done,
     /* 119716 */   // Label 2602: @119716
     /* 119716 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(119826), // Rule ID 17665 //
     /* 119721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119756 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm),
     /* 119810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119824 */     GIR_RootConstrainSelectedInstOperands,
     /* 119825 */     // GIR_Coverage, 17665,
     /* 119825 */     GIR_EraseRootFromParent_Done,
     /* 119826 */   // Label 2603: @119826
     /* 119826 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(119936), // Rule ID 17697 //
     /* 119831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119866 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm_EVEX),
     /* 119920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119934 */     GIR_RootConstrainSelectedInstOperands,
     /* 119935 */     // GIR_Coverage, 17697,
     /* 119935 */     GIR_EraseRootFromParent_Done,
     /* 119936 */   // Label 2604: @119936
     /* 119936 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(119973), // Rule ID 696 //
     /* 119941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119956 */     // MIs[1] Operand 1
     /* 119956 */     // No operand predicates
     /* 119956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119958 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 119961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119971 */     GIR_RootConstrainSelectedInstOperands,
     /* 119972 */     // GIR_Coverage, 696,
     /* 119972 */     GIR_EraseRootFromParent_Done,
     /* 119973 */   // Label 2605: @119973
     /* 119973 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(120010), // Rule ID 700 //
     /* 119978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119993 */     // MIs[1] Operand 1
     /* 119993 */     // No operand predicates
     /* 119993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119995 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 119998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120008 */     GIR_RootConstrainSelectedInstOperands,
     /* 120009 */     // GIR_Coverage, 700,
     /* 120009 */     GIR_EraseRootFromParent_Done,
     /* 120010 */   // Label 2606: @120010
     /* 120010 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(120089), // Rule ID 17661 //
     /* 120015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 120018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120026 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120052 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120059 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 120080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120087 */     GIR_RootConstrainSelectedInstOperands,
     /* 120088 */     // GIR_Coverage, 17661,
     /* 120088 */     GIR_EraseRootFromParent_Done,
     /* 120089 */   // Label 2607: @120089
     /* 120089 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(120168), // Rule ID 17693 //
     /* 120094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120105 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120131 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 120159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120166 */     GIR_RootConstrainSelectedInstOperands,
     /* 120167 */     // GIR_Coverage, 17693,
     /* 120167 */     GIR_EraseRootFromParent_Done,
     /* 120168 */   // Label 2608: @120168
     /* 120168 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(120210), // Rule ID 712 //
     /* 120173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120184 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120188 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 120201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120208 */     GIR_RootConstrainSelectedInstOperands,
     /* 120209 */     // GIR_Coverage, 712,
     /* 120209 */     GIR_EraseRootFromParent_Done,
     /* 120210 */   // Label 2609: @120210
     /* 120210 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(120252), // Rule ID 716 //
     /* 120215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120226 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120230 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 120243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120245 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120250 */     GIR_RootConstrainSelectedInstOperands,
     /* 120251 */     // GIR_Coverage, 716,
     /* 120251 */     GIR_EraseRootFromParent_Done,
     /* 120252 */   // Label 2610: @120252
     /* 120252 */   GIM_Reject,
     /* 120253 */ // Label 2600: @120253
     /* 120253 */ GIM_Reject,
     /* 120254 */ // Label 2574: @120254
     /* 120254 */ GIM_Reject,
     /* 120255 */ // Label 28: @120255
     /* 120255 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2615*/ GIMT_Encode4(122298),
     /* 120266 */ /*GILLT_s8*//*Label 2611*/ GIMT_Encode4(120282),
     /* 120270 */ /*GILLT_s16*//*Label 2612*/ GIMT_Encode4(120597),
     /* 120274 */ /*GILLT_s32*//*Label 2613*/ GIMT_Encode4(120912),
     /* 120278 */ /*GILLT_s64*//*Label 2614*/ GIMT_Encode4(121605),
     /* 120282 */ // Label 2611: @120282
     /* 120282 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(120596),
     /* 120287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 120290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120297 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(120364), // Rule ID 737 //
     /* 120302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120320 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120332 */     // MIs[2] Operand 1
     /* 120332 */     // No operand predicates
     /* 120332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120341 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SAR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi_ND),
     /* 120344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120362 */     GIR_RootConstrainSelectedInstOperands,
     /* 120363 */     // GIR_Coverage, 737,
     /* 120363 */     GIR_EraseRootFromParent_Done,
     /* 120364 */   // Label 2617: @120364
     /* 120364 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(120437), // Rule ID 753 //
     /* 120369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120387 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120404 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SAR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120408 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL_ND),
     /* 120421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120435 */     GIR_RootConstrainSelectedInstOperands,
     /* 120436 */     // GIR_Coverage, 753,
     /* 120436 */     GIR_EraseRootFromParent_Done,
     /* 120437 */   // Label 2618: @120437
     /* 120437 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(120474), // Rule ID 725 //
     /* 120442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120457 */     // MIs[1] Operand 1
     /* 120457 */     // No operand predicates
     /* 120457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120459 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 120462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120464 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120472 */     GIR_RootConstrainSelectedInstOperands,
     /* 120473 */     // GIR_Coverage, 725,
     /* 120473 */     GIR_EraseRootFromParent_Done,
     /* 120474 */   // Label 2619: @120474
     /* 120474 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(120511), // Rule ID 729 //
     /* 120479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120494 */     // MIs[1] Operand 1
     /* 120494 */     // No operand predicates
     /* 120494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120496 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 120499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120509 */     GIR_RootConstrainSelectedInstOperands,
     /* 120510 */     // GIR_Coverage, 729,
     /* 120510 */     GIR_EraseRootFromParent_Done,
     /* 120511 */   // Label 2620: @120511
     /* 120511 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(120553), // Rule ID 741 //
     /* 120516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120527 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120531 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 120544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120551 */     GIR_RootConstrainSelectedInstOperands,
     /* 120552 */     // GIR_Coverage, 741,
     /* 120552 */     GIR_EraseRootFromParent_Done,
     /* 120553 */   // Label 2621: @120553
     /* 120553 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(120595), // Rule ID 745 //
     /* 120558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120569 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120573 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 120586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120588 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120593 */     GIR_RootConstrainSelectedInstOperands,
     /* 120594 */     // GIR_Coverage, 745,
     /* 120594 */     GIR_EraseRootFromParent_Done,
     /* 120595 */   // Label 2622: @120595
     /* 120595 */   GIM_Reject,
     /* 120596 */ // Label 2616: @120596
     /* 120596 */ GIM_Reject,
     /* 120597 */ // Label 2612: @120597
     /* 120597 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(120911),
     /* 120602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120612 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(120679), // Rule ID 738 //
     /* 120617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120635 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120647 */     // MIs[2] Operand 1
     /* 120647 */     // No operand predicates
     /* 120647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120656 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SAR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi_ND),
     /* 120659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120677 */     GIR_RootConstrainSelectedInstOperands,
     /* 120678 */     // GIR_Coverage, 738,
     /* 120678 */     GIR_EraseRootFromParent_Done,
     /* 120679 */   // Label 2624: @120679
     /* 120679 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(120752), // Rule ID 754 //
     /* 120684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120698 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120702 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120719 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SAR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120723 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL_ND),
     /* 120736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120750 */     GIR_RootConstrainSelectedInstOperands,
     /* 120751 */     // GIR_Coverage, 754,
     /* 120751 */     GIR_EraseRootFromParent_Done,
     /* 120752 */   // Label 2625: @120752
     /* 120752 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(120789), // Rule ID 726 //
     /* 120757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120772 */     // MIs[1] Operand 1
     /* 120772 */     // No operand predicates
     /* 120772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120774 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 120777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120779 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120787 */     GIR_RootConstrainSelectedInstOperands,
     /* 120788 */     // GIR_Coverage, 726,
     /* 120788 */     GIR_EraseRootFromParent_Done,
     /* 120789 */   // Label 2626: @120789
     /* 120789 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(120826), // Rule ID 730 //
     /* 120794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120809 */     // MIs[1] Operand 1
     /* 120809 */     // No operand predicates
     /* 120809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120811 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 120814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120824 */     GIR_RootConstrainSelectedInstOperands,
     /* 120825 */     // GIR_Coverage, 730,
     /* 120825 */     GIR_EraseRootFromParent_Done,
     /* 120826 */   // Label 2627: @120826
     /* 120826 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(120868), // Rule ID 742 //
     /* 120831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120842 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 120842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120846 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 120859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120866 */     GIR_RootConstrainSelectedInstOperands,
     /* 120867 */     // GIR_Coverage, 742,
     /* 120867 */     GIR_EraseRootFromParent_Done,
     /* 120868 */   // Label 2628: @120868
     /* 120868 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(120910), // Rule ID 746 //
     /* 120873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120884 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 120884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120888 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 120901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120908 */     GIR_RootConstrainSelectedInstOperands,
     /* 120909 */     // GIR_Coverage, 746,
     /* 120909 */     GIR_EraseRootFromParent_Done,
     /* 120910 */   // Label 2629: @120910
     /* 120910 */   GIM_Reject,
     /* 120911 */ // Label 2623: @120911
     /* 120911 */ GIM_Reject,
     /* 120912 */ // Label 2613: @120912
     /* 120912 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(121604),
     /* 120917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 120927 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(120994), // Rule ID 739 //
     /* 120932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120950 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 120954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120962 */     // MIs[2] Operand 1
     /* 120962 */     // No operand predicates
     /* 120962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120971 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SAR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi_ND),
     /* 120974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120976 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120992 */     GIR_RootConstrainSelectedInstOperands,
     /* 120993 */     // GIR_Coverage, 739,
     /* 120993 */     GIR_EraseRootFromParent_Done,
     /* 120994 */   // Label 2631: @120994
     /* 120994 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(121067), // Rule ID 755 //
     /* 120999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121017 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121034 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SAR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121038 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL_ND),
     /* 121051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121065 */     GIR_RootConstrainSelectedInstOperands,
     /* 121066 */     // GIR_Coverage, 755,
     /* 121066 */     GIR_EraseRootFromParent_Done,
     /* 121067 */   // Label 2632: @121067
     /* 121067 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(121177), // Rule ID 17656 //
     /* 121072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121083 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121090 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121107 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm),
     /* 121161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121175 */     GIR_RootConstrainSelectedInstOperands,
     /* 121176 */     // GIR_Coverage, 17656,
     /* 121176 */     GIR_EraseRootFromParent_Done,
     /* 121177 */   // Label 2633: @121177
     /* 121177 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(121287), // Rule ID 17688 //
     /* 121182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121193 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121200 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121217 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121217 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121220 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121224 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm_EVEX),
     /* 121271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121285 */     GIR_RootConstrainSelectedInstOperands,
     /* 121286 */     // GIR_Coverage, 17688,
     /* 121286 */     GIR_EraseRootFromParent_Done,
     /* 121287 */   // Label 2634: @121287
     /* 121287 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(121324), // Rule ID 727 //
     /* 121292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121307 */     // MIs[1] Operand 1
     /* 121307 */     // No operand predicates
     /* 121307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121309 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 121312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121322 */     GIR_RootConstrainSelectedInstOperands,
     /* 121323 */     // GIR_Coverage, 727,
     /* 121323 */     GIR_EraseRootFromParent_Done,
     /* 121324 */   // Label 2635: @121324
     /* 121324 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(121361), // Rule ID 731 //
     /* 121329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121344 */     // MIs[1] Operand 1
     /* 121344 */     // No operand predicates
     /* 121344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121346 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 121349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121359 */     GIR_RootConstrainSelectedInstOperands,
     /* 121360 */     // GIR_Coverage, 731,
     /* 121360 */     GIR_EraseRootFromParent_Done,
     /* 121361 */   // Label 2636: @121361
     /* 121361 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(121440), // Rule ID 17652 //
     /* 121366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121377 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121403 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 121431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121433 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121438 */     GIR_RootConstrainSelectedInstOperands,
     /* 121439 */     // GIR_Coverage, 17652,
     /* 121439 */     GIR_EraseRootFromParent_Done,
     /* 121440 */   // Label 2637: @121440
     /* 121440 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(121519), // Rule ID 17684 //
     /* 121445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121456 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 121510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121517 */     GIR_RootConstrainSelectedInstOperands,
     /* 121518 */     // GIR_Coverage, 17684,
     /* 121518 */     GIR_EraseRootFromParent_Done,
     /* 121519 */   // Label 2638: @121519
     /* 121519 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(121561), // Rule ID 743 //
     /* 121524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121535 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121539 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 121552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121554 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121559 */     GIR_RootConstrainSelectedInstOperands,
     /* 121560 */     // GIR_Coverage, 743,
     /* 121560 */     GIR_EraseRootFromParent_Done,
     /* 121561 */   // Label 2639: @121561
     /* 121561 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(121603), // Rule ID 747 //
     /* 121566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121577 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121581 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 121594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121596 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121601 */     GIR_RootConstrainSelectedInstOperands,
     /* 121602 */     // GIR_Coverage, 747,
     /* 121602 */     GIR_EraseRootFromParent_Done,
     /* 121603 */   // Label 2640: @121603
     /* 121603 */   GIM_Reject,
     /* 121604 */ // Label 2630: @121604
     /* 121604 */ GIM_Reject,
     /* 121605 */ // Label 2614: @121605
     /* 121605 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(122297),
     /* 121610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 121613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121620 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(121687), // Rule ID 740 //
     /* 121625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121655 */     // MIs[2] Operand 1
     /* 121655 */     // No operand predicates
     /* 121655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121664 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SAR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi_ND),
     /* 121667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121685 */     GIR_RootConstrainSelectedInstOperands,
     /* 121686 */     // GIR_Coverage, 740,
     /* 121686 */     GIR_EraseRootFromParent_Done,
     /* 121687 */   // Label 2642: @121687
     /* 121687 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(121760), // Rule ID 756 //
     /* 121692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121727 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SAR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121731 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL_ND),
     /* 121744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121758 */     GIR_RootConstrainSelectedInstOperands,
     /* 121759 */     // GIR_Coverage, 756,
     /* 121759 */     GIR_EraseRootFromParent_Done,
     /* 121760 */   // Label 2643: @121760
     /* 121760 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(121870), // Rule ID 17657 //
     /* 121765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121800 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121800 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121803 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121807 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121826 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121833 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm),
     /* 121854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121868 */     GIR_RootConstrainSelectedInstOperands,
     /* 121869 */     // GIR_Coverage, 17657,
     /* 121869 */     GIR_EraseRootFromParent_Done,
     /* 121870 */   // Label 2644: @121870
     /* 121870 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(121980), // Rule ID 17689 //
     /* 121875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121886 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121889 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121893 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121910 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm_EVEX),
     /* 121964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121978 */     GIR_RootConstrainSelectedInstOperands,
     /* 121979 */     // GIR_Coverage, 17689,
     /* 121979 */     GIR_EraseRootFromParent_Done,
     /* 121980 */   // Label 2645: @121980
     /* 121980 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(122017), // Rule ID 728 //
     /* 121985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122000 */     // MIs[1] Operand 1
     /* 122000 */     // No operand predicates
     /* 122000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122002 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 122005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122015 */     GIR_RootConstrainSelectedInstOperands,
     /* 122016 */     // GIR_Coverage, 728,
     /* 122016 */     GIR_EraseRootFromParent_Done,
     /* 122017 */   // Label 2646: @122017
     /* 122017 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(122054), // Rule ID 732 //
     /* 122022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122037 */     // MIs[1] Operand 1
     /* 122037 */     // No operand predicates
     /* 122037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122039 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 122042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122052 */     GIR_RootConstrainSelectedInstOperands,
     /* 122053 */     // GIR_Coverage, 732,
     /* 122053 */     GIR_EraseRootFromParent_Done,
     /* 122054 */   // Label 2647: @122054
     /* 122054 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(122133), // Rule ID 17653 //
     /* 122059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 122062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122070 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122096 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122103 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 122124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122126 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122131 */     GIR_RootConstrainSelectedInstOperands,
     /* 122132 */     // GIR_Coverage, 17653,
     /* 122132 */     GIR_EraseRootFromParent_Done,
     /* 122133 */   // Label 2648: @122133
     /* 122133 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(122212), // Rule ID 17685 //
     /* 122138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122149 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 122203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122210 */     GIR_RootConstrainSelectedInstOperands,
     /* 122211 */     // GIR_Coverage, 17685,
     /* 122211 */     GIR_EraseRootFromParent_Done,
     /* 122212 */   // Label 2649: @122212
     /* 122212 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(122254), // Rule ID 744 //
     /* 122217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122228 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122232 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 122245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122252 */     GIR_RootConstrainSelectedInstOperands,
     /* 122253 */     // GIR_Coverage, 744,
     /* 122253 */     GIR_EraseRootFromParent_Done,
     /* 122254 */   // Label 2650: @122254
     /* 122254 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(122296), // Rule ID 748 //
     /* 122259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122270 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122274 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 122287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122289 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122294 */     GIR_RootConstrainSelectedInstOperands,
     /* 122295 */     // GIR_Coverage, 748,
     /* 122295 */     GIR_EraseRootFromParent_Done,
     /* 122296 */   // Label 2651: @122296
     /* 122296 */   GIM_Reject,
     /* 122297 */ // Label 2641: @122297
     /* 122297 */ GIM_Reject,
     /* 122298 */ // Label 2615: @122298
     /* 122298 */ GIM_Reject,
     /* 122299 */ // Label 29: @122299
     /* 122299 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(123026),
     /* 122310 */ /*GILLT_s32*//*Label 2652*/ GIMT_Encode4(122318),
     /* 122314 */ /*GILLT_s64*//*Label 2653*/ GIMT_Encode4(122672),
     /* 122318 */ // Label 2652: @122318
     /* 122318 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(122671),
     /* 122323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122329 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122336 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(122409), // Rule ID 840 //
     /* 122341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122352 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122359 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122375 */     // MIs[2] Operand 1
     /* 122375 */     // No operand predicates
     /* 122375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122384 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8_ND),
     /* 122387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122389 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122393 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122407 */     GIR_RootConstrainSelectedInstOperands,
     /* 122408 */     // GIR_Coverage, 840,
     /* 122408 */     GIR_EraseRootFromParent_Done,
     /* 122409 */   // Label 2656: @122409
     /* 122409 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(122488), // Rule ID 843 //
     /* 122414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122425 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122428 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122432 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122453 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122457 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL_ND),
     /* 122470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122486 */     GIR_RootConstrainSelectedInstOperands,
     /* 122487 */     // GIR_Coverage, 843,
     /* 122487 */     GIR_EraseRootFromParent_Done,
     /* 122488 */   // Label 2657: @122488
     /* 122488 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(122531), // Rule ID 822 //
     /* 122493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122512 */     // MIs[1] Operand 1
     /* 122512 */     // No operand predicates
     /* 122512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122514 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 122517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122529 */     GIR_RootConstrainSelectedInstOperands,
     /* 122530 */     // GIR_Coverage, 822,
     /* 122530 */     GIR_EraseRootFromParent_Done,
     /* 122531 */   // Label 2658: @122531
     /* 122531 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(122574), // Rule ID 828 //
     /* 122536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122555 */     // MIs[1] Operand 1
     /* 122555 */     // No operand predicates
     /* 122555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122557 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 122560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122562 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122572 */     GIR_RootConstrainSelectedInstOperands,
     /* 122573 */     // GIR_Coverage, 828,
     /* 122573 */     GIR_EraseRootFromParent_Done,
     /* 122574 */   // Label 2659: @122574
     /* 122574 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(122622), // Rule ID 825 //
     /* 122579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122594 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122598 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 122611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122620 */     GIR_RootConstrainSelectedInstOperands,
     /* 122621 */     // GIR_Coverage, 825,
     /* 122621 */     GIR_EraseRootFromParent_Done,
     /* 122622 */   // Label 2660: @122622
     /* 122622 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(122670), // Rule ID 831 //
     /* 122627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122642 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122646 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 122659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122663 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122668 */     GIR_RootConstrainSelectedInstOperands,
     /* 122669 */     // GIR_Coverage, 831,
     /* 122669 */     GIR_EraseRootFromParent_Done,
     /* 122670 */   // Label 2661: @122670
     /* 122670 */   GIM_Reject,
     /* 122671 */ // Label 2655: @122671
     /* 122671 */ GIM_Reject,
     /* 122672 */ // Label 2653: @122672
     /* 122672 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(123025),
     /* 122677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 122680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122690 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(122763), // Rule ID 841 //
     /* 122695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122729 */     // MIs[2] Operand 1
     /* 122729 */     // No operand predicates
     /* 122729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122738 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8_ND),
     /* 122741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122761 */     GIR_RootConstrainSelectedInstOperands,
     /* 122762 */     // GIR_Coverage, 841,
     /* 122762 */     GIR_EraseRootFromParent_Done,
     /* 122763 */   // Label 2663: @122763
     /* 122763 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(122842), // Rule ID 844 //
     /* 122768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122807 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122811 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL_ND),
     /* 122824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122830 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122840 */     GIR_RootConstrainSelectedInstOperands,
     /* 122841 */     // GIR_Coverage, 844,
     /* 122841 */     GIR_EraseRootFromParent_Done,
     /* 122842 */   // Label 2664: @122842
     /* 122842 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(122885), // Rule ID 823 //
     /* 122847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122866 */     // MIs[1] Operand 1
     /* 122866 */     // No operand predicates
     /* 122866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122868 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 122871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122883 */     GIR_RootConstrainSelectedInstOperands,
     /* 122884 */     // GIR_Coverage, 823,
     /* 122884 */     GIR_EraseRootFromParent_Done,
     /* 122885 */   // Label 2665: @122885
     /* 122885 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(122928), // Rule ID 829 //
     /* 122890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122909 */     // MIs[1] Operand 1
     /* 122909 */     // No operand predicates
     /* 122909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122911 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 122914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122926 */     GIR_RootConstrainSelectedInstOperands,
     /* 122927 */     // GIR_Coverage, 829,
     /* 122927 */     GIR_EraseRootFromParent_Done,
     /* 122928 */   // Label 2666: @122928
     /* 122928 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(122976), // Rule ID 826 //
     /* 122933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122948 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122952 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 122965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122974 */     GIR_RootConstrainSelectedInstOperands,
     /* 122975 */     // GIR_Coverage, 826,
     /* 122975 */     GIR_EraseRootFromParent_Done,
     /* 122976 */   // Label 2667: @122976
     /* 122976 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(123024), // Rule ID 832 //
     /* 122981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122996 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123000 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 123013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123022 */     GIR_RootConstrainSelectedInstOperands,
     /* 123023 */     // GIR_Coverage, 832,
     /* 123023 */     GIR_EraseRootFromParent_Done,
     /* 123024 */   // Label 2668: @123024
     /* 123024 */   GIM_Reject,
     /* 123025 */ // Label 2662: @123025
     /* 123025 */ GIM_Reject,
     /* 123026 */ // Label 2654: @123026
     /* 123026 */ GIM_Reject,
     /* 123027 */ // Label 30: @123027
     /* 123027 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2671*/ GIMT_Encode4(123714),
     /* 123038 */ /*GILLT_s32*//*Label 2669*/ GIMT_Encode4(123046),
     /* 123042 */ /*GILLT_s64*//*Label 2670*/ GIMT_Encode4(123380),
     /* 123046 */ // Label 2669: @123046
     /* 123046 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(123379),
     /* 123051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 123054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123068 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(123137), // Rule ID 864 //
     /* 123073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123084 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123091 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123103 */     // MIs[2] Operand 1
     /* 123103 */     // No operand predicates
     /* 123103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123112 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8_ND),
     /* 123115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123135 */     GIR_RootConstrainSelectedInstOperands,
     /* 123136 */     // GIR_Coverage, 864,
     /* 123136 */     GIR_EraseRootFromParent_Done,
     /* 123137 */   // Label 2673: @123137
     /* 123137 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(123212), // Rule ID 867 //
     /* 123142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123160 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123177 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHRD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123181 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL_ND),
     /* 123194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123210 */     GIR_RootConstrainSelectedInstOperands,
     /* 123211 */     // GIR_Coverage, 867,
     /* 123211 */     GIR_EraseRootFromParent_Done,
     /* 123212 */   // Label 2674: @123212
     /* 123212 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(123251), // Rule ID 846 //
     /* 123217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123232 */     // MIs[1] Operand 1
     /* 123232 */     // No operand predicates
     /* 123232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123234 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 123237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123239 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123249 */     GIR_RootConstrainSelectedInstOperands,
     /* 123250 */     // GIR_Coverage, 846,
     /* 123250 */     GIR_EraseRootFromParent_Done,
     /* 123251 */   // Label 2675: @123251
     /* 123251 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(123290), // Rule ID 852 //
     /* 123256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123271 */     // MIs[1] Operand 1
     /* 123271 */     // No operand predicates
     /* 123271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123273 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 123276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123280 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123288 */     GIR_RootConstrainSelectedInstOperands,
     /* 123289 */     // GIR_Coverage, 852,
     /* 123289 */     GIR_EraseRootFromParent_Done,
     /* 123290 */   // Label 2676: @123290
     /* 123290 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(123334), // Rule ID 849 //
     /* 123295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123306 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123310 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 123323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123332 */     GIR_RootConstrainSelectedInstOperands,
     /* 123333 */     // GIR_Coverage, 849,
     /* 123333 */     GIR_EraseRootFromParent_Done,
     /* 123334 */   // Label 2677: @123334
     /* 123334 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(123378), // Rule ID 855 //
     /* 123339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123350 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123354 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 123367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123376 */     GIR_RootConstrainSelectedInstOperands,
     /* 123377 */     // GIR_Coverage, 855,
     /* 123377 */     GIR_EraseRootFromParent_Done,
     /* 123378 */   // Label 2678: @123378
     /* 123378 */   GIM_Reject,
     /* 123379 */ // Label 2672: @123379
     /* 123379 */ GIM_Reject,
     /* 123380 */ // Label 2670: @123380
     /* 123380 */ GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(123713),
     /* 123385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 123388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123402 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(123471), // Rule ID 865 //
     /* 123407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123437 */     // MIs[2] Operand 1
     /* 123437 */     // No operand predicates
     /* 123437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123446 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8_ND),
     /* 123449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123455 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123469 */     GIR_RootConstrainSelectedInstOperands,
     /* 123470 */     // GIR_Coverage, 865,
     /* 123470 */     GIR_EraseRootFromParent_Done,
     /* 123471 */   // Label 2680: @123471
     /* 123471 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(123546), // Rule ID 868 //
     /* 123476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123511 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHRD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123515 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL_ND),
     /* 123528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123544 */     GIR_RootConstrainSelectedInstOperands,
     /* 123545 */     // GIR_Coverage, 868,
     /* 123545 */     GIR_EraseRootFromParent_Done,
     /* 123546 */   // Label 2681: @123546
     /* 123546 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(123585), // Rule ID 847 //
     /* 123551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123566 */     // MIs[1] Operand 1
     /* 123566 */     // No operand predicates
     /* 123566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123568 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 123571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123583 */     GIR_RootConstrainSelectedInstOperands,
     /* 123584 */     // GIR_Coverage, 847,
     /* 123584 */     GIR_EraseRootFromParent_Done,
     /* 123585 */   // Label 2682: @123585
     /* 123585 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(123624), // Rule ID 853 //
     /* 123590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123605 */     // MIs[1] Operand 1
     /* 123605 */     // No operand predicates
     /* 123605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123607 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 123610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123612 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123614 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123622 */     GIR_RootConstrainSelectedInstOperands,
     /* 123623 */     // GIR_Coverage, 853,
     /* 123623 */     GIR_EraseRootFromParent_Done,
     /* 123624 */   // Label 2683: @123624
     /* 123624 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(123668), // Rule ID 850 //
     /* 123629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123640 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123644 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 123657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123659 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123666 */     GIR_RootConstrainSelectedInstOperands,
     /* 123667 */     // GIR_Coverage, 850,
     /* 123667 */     GIR_EraseRootFromParent_Done,
     /* 123668 */   // Label 2684: @123668
     /* 123668 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(123712), // Rule ID 856 //
     /* 123673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123684 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123688 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 123701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123703 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123710 */     GIR_RootConstrainSelectedInstOperands,
     /* 123711 */     // GIR_Coverage, 856,
     /* 123711 */     GIR_EraseRootFromParent_Done,
     /* 123712 */   // Label 2685: @123712
     /* 123712 */   GIM_Reject,
     /* 123713 */ // Label 2679: @123713
     /* 123713 */ GIM_Reject,
     /* 123714 */ // Label 2671: @123714
     /* 123714 */ GIM_Reject,
     /* 123715 */ // Label 31: @123715
     /* 123715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2696*/ GIMT_Encode4(127212),
     /* 123726 */ /*GILLT_s8*//*Label 2686*/ GIMT_Encode4(123802),
     /* 123730 */ /*GILLT_s16*//*Label 2687*/ GIMT_Encode4(124232),
     /* 123734 */ /*GILLT_s32*//*Label 2688*/ GIMT_Encode4(124662),
     /* 123738 */ /*GILLT_s64*//*Label 2689*/ GIMT_Encode4(125325), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123754 */ /*GILLT_v2s64*//*Label 2690*/ GIMT_Encode4(125988), GIMT_Encode4(0),
     /* 123762 */ /*GILLT_v4s32*//*Label 2691*/ GIMT_Encode4(126255),
     /* 123766 */ /*GILLT_v4s64*//*Label 2692*/ GIMT_Encode4(126522), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123778 */ /*GILLT_v8s32*//*Label 2693*/ GIMT_Encode4(126773),
     /* 123782 */ /*GILLT_v8s64*//*Label 2694*/ GIMT_Encode4(127024), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123798 */ /*GILLT_v16s32*//*Label 2695*/ GIMT_Encode4(127118),
     /* 123802 */ // Label 2686: @123802
     /* 123802 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(124231),
     /* 123807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 123810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 123813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123817 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(123876), // Rule ID 17624 //
     /* 123822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 123825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123840 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 123848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123857 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROL8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 123857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1_ND),
     /* 123860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 123866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123874 */     GIR_RootConstrainSelectedInstOperands,
     /* 123875 */     // GIR_Coverage, 17624,
     /* 123875 */     GIR_EraseRootFromParent_Done,
     /* 123876 */   // Label 2698: @123876
     /* 123876 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(123943), // Rule ID 801 //
     /* 123881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123899 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 123907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123911 */     // MIs[2] Operand 1
     /* 123911 */     // No operand predicates
     /* 123911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123920 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 123920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi_ND),
     /* 123923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 123932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123941 */     GIR_RootConstrainSelectedInstOperands,
     /* 123942 */     // GIR_Coverage, 801,
     /* 123942 */     GIR_EraseRootFromParent_Done,
     /* 123943 */   // Label 2699: @123943
     /* 123943 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(124016), // Rule ID 817 //
     /* 123948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123966 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123983 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 123983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123987 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 123997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL_ND),
     /* 124000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124014 */     GIR_RootConstrainSelectedInstOperands,
     /* 124015 */     // GIR_Coverage, 817,
     /* 124015 */     GIR_EraseRootFromParent_Done,
     /* 124016 */   // Label 2700: @124016
     /* 124016 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(124044), // Rule ID 17600 //
     /* 124021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124032 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 124035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124042 */     GIR_RootConstrainSelectedInstOperands,
     /* 124043 */     // GIR_Coverage, 17600,
     /* 124043 */     GIR_EraseRootFromParent_Done,
     /* 124044 */   // Label 2701: @124044
     /* 124044 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(124072), // Rule ID 17608 //
     /* 124049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124060 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 124063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124070 */     GIR_RootConstrainSelectedInstOperands,
     /* 124071 */     // GIR_Coverage, 17608,
     /* 124071 */     GIR_EraseRootFromParent_Done,
     /* 124072 */   // Label 2702: @124072
     /* 124072 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(124109), // Rule ID 789 //
     /* 124077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124092 */     // MIs[1] Operand 1
     /* 124092 */     // No operand predicates
     /* 124092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124094 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 124097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124107 */     GIR_RootConstrainSelectedInstOperands,
     /* 124108 */     // GIR_Coverage, 789,
     /* 124108 */     GIR_EraseRootFromParent_Done,
     /* 124109 */   // Label 2703: @124109
     /* 124109 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(124146), // Rule ID 793 //
     /* 124114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124129 */     // MIs[1] Operand 1
     /* 124129 */     // No operand predicates
     /* 124129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124131 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 124134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124144 */     GIR_RootConstrainSelectedInstOperands,
     /* 124145 */     // GIR_Coverage, 793,
     /* 124145 */     GIR_EraseRootFromParent_Done,
     /* 124146 */   // Label 2704: @124146
     /* 124146 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(124188), // Rule ID 805 //
     /* 124151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124162 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124166 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 124179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124186 */     GIR_RootConstrainSelectedInstOperands,
     /* 124187 */     // GIR_Coverage, 805,
     /* 124187 */     GIR_EraseRootFromParent_Done,
     /* 124188 */   // Label 2705: @124188
     /* 124188 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(124230), // Rule ID 809 //
     /* 124193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124204 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124208 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 124221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124223 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124228 */     GIR_RootConstrainSelectedInstOperands,
     /* 124229 */     // GIR_Coverage, 809,
     /* 124229 */     GIR_EraseRootFromParent_Done,
     /* 124230 */   // Label 2706: @124230
     /* 124230 */   GIM_Reject,
     /* 124231 */ // Label 2697: @124231
     /* 124231 */ GIM_Reject,
     /* 124232 */ // Label 2687: @124232
     /* 124232 */ GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(124661),
     /* 124237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 124240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124247 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(124306), // Rule ID 17625 //
     /* 124252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124270 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124287 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROL16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1_ND),
     /* 124290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124304 */     GIR_RootConstrainSelectedInstOperands,
     /* 124305 */     // GIR_Coverage, 17625,
     /* 124305 */     GIR_EraseRootFromParent_Done,
     /* 124306 */   // Label 2708: @124306
     /* 124306 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(124373), // Rule ID 802 //
     /* 124311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124329 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124341 */     // MIs[2] Operand 1
     /* 124341 */     // No operand predicates
     /* 124341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124350 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi_ND),
     /* 124353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124371 */     GIR_RootConstrainSelectedInstOperands,
     /* 124372 */     // GIR_Coverage, 802,
     /* 124372 */     GIR_EraseRootFromParent_Done,
     /* 124373 */   // Label 2709: @124373
     /* 124373 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(124446), // Rule ID 818 //
     /* 124378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124396 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124413 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124417 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL_ND),
     /* 124430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124444 */     GIR_RootConstrainSelectedInstOperands,
     /* 124445 */     // GIR_Coverage, 818,
     /* 124445 */     GIR_EraseRootFromParent_Done,
     /* 124446 */   // Label 2710: @124446
     /* 124446 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(124474), // Rule ID 17601 //
     /* 124451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124462 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 124465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124472 */     GIR_RootConstrainSelectedInstOperands,
     /* 124473 */     // GIR_Coverage, 17601,
     /* 124473 */     GIR_EraseRootFromParent_Done,
     /* 124474 */   // Label 2711: @124474
     /* 124474 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(124502), // Rule ID 17609 //
     /* 124479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124490 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 124493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124500 */     GIR_RootConstrainSelectedInstOperands,
     /* 124501 */     // GIR_Coverage, 17609,
     /* 124501 */     GIR_EraseRootFromParent_Done,
     /* 124502 */   // Label 2712: @124502
     /* 124502 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(124539), // Rule ID 790 //
     /* 124507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124522 */     // MIs[1] Operand 1
     /* 124522 */     // No operand predicates
     /* 124522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124524 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 124527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124537 */     GIR_RootConstrainSelectedInstOperands,
     /* 124538 */     // GIR_Coverage, 790,
     /* 124538 */     GIR_EraseRootFromParent_Done,
     /* 124539 */   // Label 2713: @124539
     /* 124539 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(124576), // Rule ID 794 //
     /* 124544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124559 */     // MIs[1] Operand 1
     /* 124559 */     // No operand predicates
     /* 124559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124561 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 124564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124566 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124574 */     GIR_RootConstrainSelectedInstOperands,
     /* 124575 */     // GIR_Coverage, 794,
     /* 124575 */     GIR_EraseRootFromParent_Done,
     /* 124576 */   // Label 2714: @124576
     /* 124576 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(124618), // Rule ID 806 //
     /* 124581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124592 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124596 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 124609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124616 */     GIR_RootConstrainSelectedInstOperands,
     /* 124617 */     // GIR_Coverage, 806,
     /* 124617 */     GIR_EraseRootFromParent_Done,
     /* 124618 */   // Label 2715: @124618
     /* 124618 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(124660), // Rule ID 810 //
     /* 124623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124634 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124638 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 124651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124658 */     GIR_RootConstrainSelectedInstOperands,
     /* 124659 */     // GIR_Coverage, 810,
     /* 124659 */     GIR_EraseRootFromParent_Done,
     /* 124660 */   // Label 2716: @124660
     /* 124660 */   GIM_Reject,
     /* 124661 */ // Label 2707: @124661
     /* 124661 */ GIM_Reject,
     /* 124662 */ // Label 2688: @124662
     /* 124662 */ GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(125324),
     /* 124667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 124670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124677 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(124736), // Rule ID 17626 //
     /* 124682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124693 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124700 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124717 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROL32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1_ND),
     /* 124720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124734 */     GIR_RootConstrainSelectedInstOperands,
     /* 124735 */     // GIR_Coverage, 17626,
     /* 124735 */     GIR_EraseRootFromParent_Done,
     /* 124736 */   // Label 2718: @124736
     /* 124736 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(124803), // Rule ID 803 //
     /* 124741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124755 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124759 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124771 */     // MIs[2] Operand 1
     /* 124771 */     // No operand predicates
     /* 124771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124780 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi_ND),
     /* 124783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124801 */     GIR_RootConstrainSelectedInstOperands,
     /* 124802 */     // GIR_Coverage, 803,
     /* 124802 */     GIR_EraseRootFromParent_Done,
     /* 124803 */   // Label 2719: @124803
     /* 124803 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(124867), // Rule ID 17648 //
     /* 124808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 124811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124819 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124826 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124838 */     // MIs[2] Operand 1
     /* 124838 */     // No operand predicates
     /* 124838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124847 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi),
     /* 124850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124852 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 124859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124865 */     GIR_RootConstrainSelectedInstOperands,
     /* 124866 */     // GIR_Coverage, 17648,
     /* 124866 */     GIR_EraseRootFromParent_Done,
     /* 124867 */   // Label 2720: @124867
     /* 124867 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(124931), // Rule ID 17680 //
     /* 124872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 124875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124890 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124902 */     // MIs[2] Operand 1
     /* 124902 */     // No operand predicates
     /* 124902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124911 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi_EVEX),
     /* 124914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 124923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124929 */     GIR_RootConstrainSelectedInstOperands,
     /* 124930 */     // GIR_Coverage, 17680,
     /* 124930 */     GIR_EraseRootFromParent_Done,
     /* 124931 */   // Label 2721: @124931
     /* 124931 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(125004), // Rule ID 819 //
     /* 124936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124954 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124971 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124975 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL_ND),
     /* 124988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125002 */     GIR_RootConstrainSelectedInstOperands,
     /* 125003 */     // GIR_Coverage, 819,
     /* 125003 */     GIR_EraseRootFromParent_Done,
     /* 125004 */   // Label 2722: @125004
     /* 125004 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(125038), // Rule ID 17644 //
     /* 125009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125024 */     // MIs[1] Operand 1
     /* 125024 */     // No operand predicates
     /* 125024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125026 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 125029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125036 */     GIR_RootConstrainSelectedInstOperands,
     /* 125037 */     // GIR_Coverage, 17644,
     /* 125037 */     GIR_EraseRootFromParent_Done,
     /* 125038 */   // Label 2723: @125038
     /* 125038 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(125072), // Rule ID 17676 //
     /* 125043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125058 */     // MIs[1] Operand 1
     /* 125058 */     // No operand predicates
     /* 125058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125060 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 125063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125070 */     GIR_RootConstrainSelectedInstOperands,
     /* 125071 */     // GIR_Coverage, 17676,
     /* 125071 */     GIR_EraseRootFromParent_Done,
     /* 125072 */   // Label 2724: @125072
     /* 125072 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(125109), // Rule ID 871 //
     /* 125077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125092 */     // MIs[1] Operand 1
     /* 125092 */     // No operand predicates
     /* 125092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125094 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 125097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125107 */     GIR_RootConstrainSelectedInstOperands,
     /* 125108 */     // GIR_Coverage, 871,
     /* 125108 */     GIR_EraseRootFromParent_Done,
     /* 125109 */   // Label 2725: @125109
     /* 125109 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(125137), // Rule ID 17602 //
     /* 125114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125125 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 125128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125135 */     GIR_RootConstrainSelectedInstOperands,
     /* 125136 */     // GIR_Coverage, 17602,
     /* 125136 */     GIR_EraseRootFromParent_Done,
     /* 125137 */   // Label 2726: @125137
     /* 125137 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(125165), // Rule ID 17610 //
     /* 125142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125153 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 125156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125163 */     GIR_RootConstrainSelectedInstOperands,
     /* 125164 */     // GIR_Coverage, 17610,
     /* 125164 */     GIR_EraseRootFromParent_Done,
     /* 125165 */   // Label 2727: @125165
     /* 125165 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(125202), // Rule ID 791 //
     /* 125170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125185 */     // MIs[1] Operand 1
     /* 125185 */     // No operand predicates
     /* 125185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125187 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 125190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125200 */     GIR_RootConstrainSelectedInstOperands,
     /* 125201 */     // GIR_Coverage, 791,
     /* 125201 */     GIR_EraseRootFromParent_Done,
     /* 125202 */   // Label 2728: @125202
     /* 125202 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(125239), // Rule ID 795 //
     /* 125207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125222 */     // MIs[1] Operand 1
     /* 125222 */     // No operand predicates
     /* 125222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125224 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 125227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125237 */     GIR_RootConstrainSelectedInstOperands,
     /* 125238 */     // GIR_Coverage, 795,
     /* 125238 */     GIR_EraseRootFromParent_Done,
     /* 125239 */   // Label 2729: @125239
     /* 125239 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(125281), // Rule ID 807 //
     /* 125244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125255 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125259 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125265 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 125272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125279 */     GIR_RootConstrainSelectedInstOperands,
     /* 125280 */     // GIR_Coverage, 807,
     /* 125280 */     GIR_EraseRootFromParent_Done,
     /* 125281 */   // Label 2730: @125281
     /* 125281 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(125323), // Rule ID 811 //
     /* 125286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125297 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125301 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 125314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125316 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125321 */     GIR_RootConstrainSelectedInstOperands,
     /* 125322 */     // GIR_Coverage, 811,
     /* 125322 */     GIR_EraseRootFromParent_Done,
     /* 125323 */   // Label 2731: @125323
     /* 125323 */   GIM_Reject,
     /* 125324 */ // Label 2717: @125324
     /* 125324 */ GIM_Reject,
     /* 125325 */ // Label 2689: @125325
     /* 125325 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(125987),
     /* 125330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 125333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 125336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125340 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(125399), // Rule ID 17627 //
     /* 125345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125380 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROL64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 125380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1_ND),
     /* 125383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125397 */     GIR_RootConstrainSelectedInstOperands,
     /* 125398 */     // GIR_Coverage, 17627,
     /* 125398 */     GIR_EraseRootFromParent_Done,
     /* 125399 */   // Label 2733: @125399
     /* 125399 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(125466), // Rule ID 804 //
     /* 125404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125415 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125434 */     // MIs[2] Operand 1
     /* 125434 */     // No operand predicates
     /* 125434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125443 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi_ND),
     /* 125446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 125455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125464 */     GIR_RootConstrainSelectedInstOperands,
     /* 125465 */     // GIR_Coverage, 804,
     /* 125465 */     GIR_EraseRootFromParent_Done,
     /* 125466 */   // Label 2734: @125466
     /* 125466 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(125530), // Rule ID 17649 //
     /* 125471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125501 */     // MIs[2] Operand 1
     /* 125501 */     // No operand predicates
     /* 125501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125510 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi),
     /* 125513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125528 */     GIR_RootConstrainSelectedInstOperands,
     /* 125529 */     // GIR_Coverage, 17649,
     /* 125529 */     GIR_EraseRootFromParent_Done,
     /* 125530 */   // Label 2735: @125530
     /* 125530 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(125594), // Rule ID 17681 //
     /* 125535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125565 */     // MIs[2] Operand 1
     /* 125565 */     // No operand predicates
     /* 125565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125574 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi_EVEX),
     /* 125577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125592 */     GIR_RootConstrainSelectedInstOperands,
     /* 125593 */     // GIR_Coverage, 17681,
     /* 125593 */     GIR_EraseRootFromParent_Done,
     /* 125594 */   // Label 2736: @125594
     /* 125594 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(125667), // Rule ID 820 //
     /* 125599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125617 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125634 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125638 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL_ND),
     /* 125651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125665 */     GIR_RootConstrainSelectedInstOperands,
     /* 125666 */     // GIR_Coverage, 820,
     /* 125666 */     GIR_EraseRootFromParent_Done,
     /* 125667 */   // Label 2737: @125667
     /* 125667 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(125701), // Rule ID 17645 //
     /* 125672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125687 */     // MIs[1] Operand 1
     /* 125687 */     // No operand predicates
     /* 125687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125689 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 125692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125699 */     GIR_RootConstrainSelectedInstOperands,
     /* 125700 */     // GIR_Coverage, 17645,
     /* 125700 */     GIR_EraseRootFromParent_Done,
     /* 125701 */   // Label 2738: @125701
     /* 125701 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(125735), // Rule ID 17677 //
     /* 125706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125721 */     // MIs[1] Operand 1
     /* 125721 */     // No operand predicates
     /* 125721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125723 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 125726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125728 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125733 */     GIR_RootConstrainSelectedInstOperands,
     /* 125734 */     // GIR_Coverage, 17677,
     /* 125734 */     GIR_EraseRootFromParent_Done,
     /* 125735 */   // Label 2739: @125735
     /* 125735 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(125772), // Rule ID 872 //
     /* 125740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125755 */     // MIs[1] Operand 1
     /* 125755 */     // No operand predicates
     /* 125755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125757 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 125760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125770 */     GIR_RootConstrainSelectedInstOperands,
     /* 125771 */     // GIR_Coverage, 872,
     /* 125771 */     GIR_EraseRootFromParent_Done,
     /* 125772 */   // Label 2740: @125772
     /* 125772 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(125800), // Rule ID 17603 //
     /* 125777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125788 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 125791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125793 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125798 */     GIR_RootConstrainSelectedInstOperands,
     /* 125799 */     // GIR_Coverage, 17603,
     /* 125799 */     GIR_EraseRootFromParent_Done,
     /* 125800 */   // Label 2741: @125800
     /* 125800 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(125828), // Rule ID 17611 //
     /* 125805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125816 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 125819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125826 */     GIR_RootConstrainSelectedInstOperands,
     /* 125827 */     // GIR_Coverage, 17611,
     /* 125827 */     GIR_EraseRootFromParent_Done,
     /* 125828 */   // Label 2742: @125828
     /* 125828 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(125865), // Rule ID 792 //
     /* 125833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125848 */     // MIs[1] Operand 1
     /* 125848 */     // No operand predicates
     /* 125848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125850 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 125853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125855 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125863 */     GIR_RootConstrainSelectedInstOperands,
     /* 125864 */     // GIR_Coverage, 792,
     /* 125864 */     GIR_EraseRootFromParent_Done,
     /* 125865 */   // Label 2743: @125865
     /* 125865 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(125902), // Rule ID 796 //
     /* 125870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125885 */     // MIs[1] Operand 1
     /* 125885 */     // No operand predicates
     /* 125885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125887 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 125890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125900 */     GIR_RootConstrainSelectedInstOperands,
     /* 125901 */     // GIR_Coverage, 796,
     /* 125901 */     GIR_EraseRootFromParent_Done,
     /* 125902 */   // Label 2744: @125902
     /* 125902 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(125944), // Rule ID 808 //
     /* 125907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125918 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125922 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 125935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125942 */     GIR_RootConstrainSelectedInstOperands,
     /* 125943 */     // GIR_Coverage, 808,
     /* 125943 */     GIR_EraseRootFromParent_Done,
     /* 125944 */   // Label 2745: @125944
     /* 125944 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(125986), // Rule ID 812 //
     /* 125949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125960 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125964 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 125977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125984 */     GIR_RootConstrainSelectedInstOperands,
     /* 125985 */     // GIR_Coverage, 812,
     /* 125985 */     GIR_EraseRootFromParent_Done,
     /* 125986 */   // Label 2746: @125986
     /* 125986 */   GIM_Reject,
     /* 125987 */ // Label 2732: @125987
     /* 125987 */ GIM_Reject,
     /* 125988 */ // Label 2690: @125988
     /* 125988 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(126254),
     /* 125993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 125996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 125999 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(126061), // Rule ID 8005 //
     /* 126004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126043 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rm),
     /* 126046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126048 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126059 */     GIR_RootConstrainSelectedInstOperands,
     /* 126060 */     // GIR_Coverage, 8005,
     /* 126060 */     GIR_EraseRootFromParent_Done,
     /* 126061 */   // Label 2748: @126061
     /* 126061 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(126088), // Rule ID 8002 //
     /* 126066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126081 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 126081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 126086 */     GIR_RootConstrainSelectedInstOperands,
     /* 126087 */     // GIR_Coverage, 8002,
     /* 126087 */     GIR_Done,
     /* 126088 */   // Label 2749: @126088
     /* 126088 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(126253), // Rule ID 20804 //
     /* 126093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126108 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126108 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126111 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126115 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126122 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126125 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126129 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126134 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126137 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126141 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126144 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126149 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126154 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126159 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126162 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126166 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126185 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126188 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126192 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126195 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126222 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126252 */     // GIR_Coverage, 20804,
     /* 126252 */     GIR_EraseRootFromParent_Done,
     /* 126253 */   // Label 2750: @126253
     /* 126253 */   GIM_Reject,
     /* 126254 */ // Label 2747: @126254
     /* 126254 */ GIM_Reject,
     /* 126255 */ // Label 2691: @126255
     /* 126255 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(126521),
     /* 126260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 126266 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(126328), // Rule ID 7978 //
     /* 126271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126290 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126297 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126310 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rm),
     /* 126313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126315 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126326 */     GIR_RootConstrainSelectedInstOperands,
     /* 126327 */     // GIR_Coverage, 7978,
     /* 126327 */     GIR_EraseRootFromParent_Done,
     /* 126328 */   // Label 2752: @126328
     /* 126328 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(126355), // Rule ID 7975 //
     /* 126333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126348 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 126348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 126353 */     GIR_RootConstrainSelectedInstOperands,
     /* 126354 */     // GIR_Coverage, 7975,
     /* 126354 */     GIR_Done,
     /* 126355 */   // Label 2753: @126355
     /* 126355 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(126520), // Rule ID 20806 //
     /* 126360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126375 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126375 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126378 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126382 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126389 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126392 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126396 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126401 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126404 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126408 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126411 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126416 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126421 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126452 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126459 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126462 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126489 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126502 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126519 */     // GIR_Coverage, 20806,
     /* 126519 */     GIR_EraseRootFromParent_Done,
     /* 126520 */   // Label 2754: @126520
     /* 126520 */   GIM_Reject,
     /* 126521 */ // Label 2751: @126521
     /* 126521 */ GIM_Reject,
     /* 126522 */ // Label 2692: @126522
     /* 126522 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(126772),
     /* 126527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 126530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 126533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126541 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(126595), // Rule ID 7996 //
     /* 126546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126557 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126564 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126577 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rm),
     /* 126580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126593 */     GIR_RootConstrainSelectedInstOperands,
     /* 126594 */     // GIR_Coverage, 7996,
     /* 126594 */     GIR_EraseRootFromParent_Done,
     /* 126595 */   // Label 2756: @126595
     /* 126595 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(126614), // Rule ID 7993 //
     /* 126600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126607 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 126607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 126612 */     GIR_RootConstrainSelectedInstOperands,
     /* 126613 */     // GIR_Coverage, 7993,
     /* 126613 */     GIR_Done,
     /* 126614 */   // Label 2757: @126614
     /* 126614 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(126771), // Rule ID 20805 //
     /* 126619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126626 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126626 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126629 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126633 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126640 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126643 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126647 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126652 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126655 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126659 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126662 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126667 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126672 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126703 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126706 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126710 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 126760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126770 */     // GIR_Coverage, 20805,
     /* 126770 */     GIR_EraseRootFromParent_Done,
     /* 126771 */   // Label 2758: @126771
     /* 126771 */   GIM_Reject,
     /* 126772 */ // Label 2755: @126772
     /* 126772 */ GIM_Reject,
     /* 126773 */ // Label 2693: @126773
     /* 126773 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(127023),
     /* 126778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 126781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 126784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126792 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(126846), // Rule ID 7969 //
     /* 126797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126828 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rm),
     /* 126831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126844 */     GIR_RootConstrainSelectedInstOperands,
     /* 126845 */     // GIR_Coverage, 7969,
     /* 126845 */     GIR_EraseRootFromParent_Done,
     /* 126846 */   // Label 2760: @126846
     /* 126846 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(126865), // Rule ID 7966 //
     /* 126851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126858 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 126858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 126863 */     GIR_RootConstrainSelectedInstOperands,
     /* 126864 */     // GIR_Coverage, 7966,
     /* 126864 */     GIR_Done,
     /* 126865 */   // Label 2761: @126865
     /* 126865 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(127022), // Rule ID 20807 //
     /* 126870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126877 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126877 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126880 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126884 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126891 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126894 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126898 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126903 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126906 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126910 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126913 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126918 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126923 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126928 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126931 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126935 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126954 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126957 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126961 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 127011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127021 */     // GIR_Coverage, 20807,
     /* 127021 */     GIR_EraseRootFromParent_Done,
     /* 127022 */   // Label 2762: @127022
     /* 127022 */   GIM_Reject,
     /* 127023 */ // Label 2759: @127023
     /* 127023 */ GIM_Reject,
     /* 127024 */ // Label 2694: @127024
     /* 127024 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(127117),
     /* 127029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 127032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 127035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127043 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(127097), // Rule ID 7987 //
     /* 127048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127079 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrm),
     /* 127082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127084 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127095 */     GIR_RootConstrainSelectedInstOperands,
     /* 127096 */     // GIR_Coverage, 7987,
     /* 127096 */     GIR_EraseRootFromParent_Done,
     /* 127097 */   // Label 2764: @127097
     /* 127097 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(127116), // Rule ID 7984 //
     /* 127102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127109 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 127109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 127114 */     GIR_RootConstrainSelectedInstOperands,
     /* 127115 */     // GIR_Coverage, 7984,
     /* 127115 */     GIR_Done,
     /* 127116 */   // Label 2765: @127116
     /* 127116 */   GIM_Reject,
     /* 127117 */ // Label 2763: @127117
     /* 127117 */ GIM_Reject,
     /* 127118 */ // Label 2695: @127118
     /* 127118 */ GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(127211),
     /* 127123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 127126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 127129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127137 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(127191), // Rule ID 7960 //
     /* 127142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127173 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrm),
     /* 127176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127189 */     GIR_RootConstrainSelectedInstOperands,
     /* 127190 */     // GIR_Coverage, 7960,
     /* 127190 */     GIR_EraseRootFromParent_Done,
     /* 127191 */   // Label 2767: @127191
     /* 127191 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(127210), // Rule ID 7957 //
     /* 127196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127203 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 127203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127208 */     GIR_RootConstrainSelectedInstOperands,
     /* 127209 */     // GIR_Coverage, 7957,
     /* 127209 */     GIR_Done,
     /* 127210 */   // Label 2768: @127210
     /* 127210 */   GIM_Reject,
     /* 127211 */ // Label 2766: @127211
     /* 127211 */ GIM_Reject,
     /* 127212 */ // Label 2696: @127212
     /* 127212 */ GIM_Reject,
     /* 127213 */ // Label 32: @127213
     /* 127213 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2781*/ GIMT_Encode4(130932),
     /* 127224 */ /*GILLT_s8*//*Label 2769*/ GIMT_Encode4(127300),
     /* 127228 */ /*GILLT_s16*//*Label 2770*/ GIMT_Encode4(127730),
     /* 127232 */ /*GILLT_s32*//*Label 2771*/ GIMT_Encode4(128160),
     /* 127236 */ /*GILLT_s64*//*Label 2772*/ GIMT_Encode4(128627), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127252 */ /*GILLT_v2s64*//*Label 2773*/ GIMT_Encode4(129094), GIMT_Encode4(0),
     /* 127260 */ /*GILLT_v4s32*//*Label 2774*/ GIMT_Encode4(129512),
     /* 127264 */ /*GILLT_v4s64*//*Label 2775*/ GIMT_Encode4(129930), GIMT_Encode4(0),
     /* 127272 */ /*GILLT_v8s16*//*Label 2776*/ GIMT_Encode4(130181),
     /* 127276 */ /*GILLT_v8s32*//*Label 2777*/ GIMT_Encode4(130337),
     /* 127280 */ /*GILLT_v8s64*//*Label 2778*/ GIMT_Encode4(130588), GIMT_Encode4(0),
     /* 127288 */ /*GILLT_v16s8*//*Label 2779*/ GIMT_Encode4(130682), GIMT_Encode4(0),
     /* 127296 */ /*GILLT_v16s32*//*Label 2780*/ GIMT_Encode4(130838),
     /* 127300 */ // Label 2769: @127300
     /* 127300 */ GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(127729),
     /* 127305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 127308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127315 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(127374), // Rule ID 17620 //
     /* 127320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127338 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127355 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROR8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1_ND),
     /* 127358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127372 */     GIR_RootConstrainSelectedInstOperands,
     /* 127373 */     // GIR_Coverage, 17620,
     /* 127373 */     GIR_EraseRootFromParent_Done,
     /* 127374 */   // Label 2783: @127374
     /* 127374 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(127441), // Rule ID 769 //
     /* 127379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127397 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127409 */     // MIs[2] Operand 1
     /* 127409 */     // No operand predicates
     /* 127409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127418 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi_ND),
     /* 127421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127439 */     GIR_RootConstrainSelectedInstOperands,
     /* 127440 */     // GIR_Coverage, 769,
     /* 127440 */     GIR_EraseRootFromParent_Done,
     /* 127441 */   // Label 2784: @127441
     /* 127441 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(127514), // Rule ID 785 //
     /* 127446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127464 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127481 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127485 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL_ND),
     /* 127498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127512 */     GIR_RootConstrainSelectedInstOperands,
     /* 127513 */     // GIR_Coverage, 785,
     /* 127513 */     GIR_EraseRootFromParent_Done,
     /* 127514 */   // Label 2785: @127514
     /* 127514 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(127542), // Rule ID 17596 //
     /* 127519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127530 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 127533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127540 */     GIR_RootConstrainSelectedInstOperands,
     /* 127541 */     // GIR_Coverage, 17596,
     /* 127541 */     GIR_EraseRootFromParent_Done,
     /* 127542 */   // Label 2786: @127542
     /* 127542 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(127570), // Rule ID 17604 //
     /* 127547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127558 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 127561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127568 */     GIR_RootConstrainSelectedInstOperands,
     /* 127569 */     // GIR_Coverage, 17604,
     /* 127569 */     GIR_EraseRootFromParent_Done,
     /* 127570 */   // Label 2787: @127570
     /* 127570 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(127607), // Rule ID 757 //
     /* 127575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127590 */     // MIs[1] Operand 1
     /* 127590 */     // No operand predicates
     /* 127590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127592 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 127595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127605 */     GIR_RootConstrainSelectedInstOperands,
     /* 127606 */     // GIR_Coverage, 757,
     /* 127606 */     GIR_EraseRootFromParent_Done,
     /* 127607 */   // Label 2788: @127607
     /* 127607 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(127644), // Rule ID 761 //
     /* 127612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127627 */     // MIs[1] Operand 1
     /* 127627 */     // No operand predicates
     /* 127627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127629 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 127632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127642 */     GIR_RootConstrainSelectedInstOperands,
     /* 127643 */     // GIR_Coverage, 761,
     /* 127643 */     GIR_EraseRootFromParent_Done,
     /* 127644 */   // Label 2789: @127644
     /* 127644 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(127686), // Rule ID 773 //
     /* 127649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127660 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127664 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 127677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127684 */     GIR_RootConstrainSelectedInstOperands,
     /* 127685 */     // GIR_Coverage, 773,
     /* 127685 */     GIR_EraseRootFromParent_Done,
     /* 127686 */   // Label 2790: @127686
     /* 127686 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(127728), // Rule ID 777 //
     /* 127691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127702 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127706 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 127719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127726 */     GIR_RootConstrainSelectedInstOperands,
     /* 127727 */     // GIR_Coverage, 777,
     /* 127727 */     GIR_EraseRootFromParent_Done,
     /* 127728 */   // Label 2791: @127728
     /* 127728 */   GIM_Reject,
     /* 127729 */ // Label 2782: @127729
     /* 127729 */ GIM_Reject,
     /* 127730 */ // Label 2770: @127730
     /* 127730 */ GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(128159),
     /* 127735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127745 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(127804), // Rule ID 17621 //
     /* 127750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127768 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127785 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROR16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1_ND),
     /* 127788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127802 */     GIR_RootConstrainSelectedInstOperands,
     /* 127803 */     // GIR_Coverage, 17621,
     /* 127803 */     GIR_EraseRootFromParent_Done,
     /* 127804 */   // Label 2793: @127804
     /* 127804 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(127871), // Rule ID 770 //
     /* 127809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127827 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127839 */     // MIs[2] Operand 1
     /* 127839 */     // No operand predicates
     /* 127839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127848 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi_ND),
     /* 127851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127869 */     GIR_RootConstrainSelectedInstOperands,
     /* 127870 */     // GIR_Coverage, 770,
     /* 127870 */     GIR_EraseRootFromParent_Done,
     /* 127871 */   // Label 2794: @127871
     /* 127871 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(127944), // Rule ID 786 //
     /* 127876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127887 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127894 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127911 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127915 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL_ND),
     /* 127928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127942 */     GIR_RootConstrainSelectedInstOperands,
     /* 127943 */     // GIR_Coverage, 786,
     /* 127943 */     GIR_EraseRootFromParent_Done,
     /* 127944 */   // Label 2795: @127944
     /* 127944 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(127972), // Rule ID 17597 //
     /* 127949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127960 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 127963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127970 */     GIR_RootConstrainSelectedInstOperands,
     /* 127971 */     // GIR_Coverage, 17597,
     /* 127971 */     GIR_EraseRootFromParent_Done,
     /* 127972 */   // Label 2796: @127972
     /* 127972 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(128000), // Rule ID 17605 //
     /* 127977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127988 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 127991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127993 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127998 */     GIR_RootConstrainSelectedInstOperands,
     /* 127999 */     // GIR_Coverage, 17605,
     /* 127999 */     GIR_EraseRootFromParent_Done,
     /* 128000 */   // Label 2797: @128000
     /* 128000 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(128037), // Rule ID 758 //
     /* 128005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128020 */     // MIs[1] Operand 1
     /* 128020 */     // No operand predicates
     /* 128020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128022 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 128025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128035 */     GIR_RootConstrainSelectedInstOperands,
     /* 128036 */     // GIR_Coverage, 758,
     /* 128036 */     GIR_EraseRootFromParent_Done,
     /* 128037 */   // Label 2798: @128037
     /* 128037 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(128074), // Rule ID 762 //
     /* 128042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128057 */     // MIs[1] Operand 1
     /* 128057 */     // No operand predicates
     /* 128057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128059 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 128062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128064 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128072 */     GIR_RootConstrainSelectedInstOperands,
     /* 128073 */     // GIR_Coverage, 762,
     /* 128073 */     GIR_EraseRootFromParent_Done,
     /* 128074 */   // Label 2799: @128074
     /* 128074 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(128116), // Rule ID 774 //
     /* 128079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128090 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128094 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 128107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128114 */     GIR_RootConstrainSelectedInstOperands,
     /* 128115 */     // GIR_Coverage, 774,
     /* 128115 */     GIR_EraseRootFromParent_Done,
     /* 128116 */   // Label 2800: @128116
     /* 128116 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(128158), // Rule ID 778 //
     /* 128121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128132 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128136 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 128149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128151 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128156 */     GIR_RootConstrainSelectedInstOperands,
     /* 128157 */     // GIR_Coverage, 778,
     /* 128157 */     GIR_EraseRootFromParent_Done,
     /* 128158 */   // Label 2801: @128158
     /* 128158 */   GIM_Reject,
     /* 128159 */ // Label 2792: @128159
     /* 128159 */ GIM_Reject,
     /* 128160 */ // Label 2771: @128160
     /* 128160 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(128626),
     /* 128165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128175 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(128234), // Rule ID 17622 //
     /* 128180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128198 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128215 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROR32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1_ND),
     /* 128218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128232 */     GIR_RootConstrainSelectedInstOperands,
     /* 128233 */     // GIR_Coverage, 17622,
     /* 128233 */     GIR_EraseRootFromParent_Done,
     /* 128234 */   // Label 2803: @128234
     /* 128234 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(128301), // Rule ID 771 //
     /* 128239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128257 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128269 */     // MIs[2] Operand 1
     /* 128269 */     // No operand predicates
     /* 128269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128278 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi_ND),
     /* 128281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128299 */     GIR_RootConstrainSelectedInstOperands,
     /* 128300 */     // GIR_Coverage, 771,
     /* 128300 */     GIR_EraseRootFromParent_Done,
     /* 128301 */   // Label 2804: @128301
     /* 128301 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(128374), // Rule ID 787 //
     /* 128306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128324 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128341 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128345 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL_ND),
     /* 128358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128372 */     GIR_RootConstrainSelectedInstOperands,
     /* 128373 */     // GIR_Coverage, 787,
     /* 128373 */     GIR_EraseRootFromParent_Done,
     /* 128374 */   // Label 2805: @128374
     /* 128374 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(128411), // Rule ID 869 //
     /* 128379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128394 */     // MIs[1] Operand 1
     /* 128394 */     // No operand predicates
     /* 128394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128396 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 128399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128409 */     GIR_RootConstrainSelectedInstOperands,
     /* 128410 */     // GIR_Coverage, 869,
     /* 128410 */     GIR_EraseRootFromParent_Done,
     /* 128411 */   // Label 2806: @128411
     /* 128411 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(128439), // Rule ID 17598 //
     /* 128416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128427 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 128430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128432 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128437 */     GIR_RootConstrainSelectedInstOperands,
     /* 128438 */     // GIR_Coverage, 17598,
     /* 128438 */     GIR_EraseRootFromParent_Done,
     /* 128439 */   // Label 2807: @128439
     /* 128439 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(128467), // Rule ID 17606 //
     /* 128444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128455 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 128458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128465 */     GIR_RootConstrainSelectedInstOperands,
     /* 128466 */     // GIR_Coverage, 17606,
     /* 128466 */     GIR_EraseRootFromParent_Done,
     /* 128467 */   // Label 2808: @128467
     /* 128467 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(128504), // Rule ID 759 //
     /* 128472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128487 */     // MIs[1] Operand 1
     /* 128487 */     // No operand predicates
     /* 128487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128489 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 128492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128502 */     GIR_RootConstrainSelectedInstOperands,
     /* 128503 */     // GIR_Coverage, 759,
     /* 128503 */     GIR_EraseRootFromParent_Done,
     /* 128504 */   // Label 2809: @128504
     /* 128504 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(128541), // Rule ID 763 //
     /* 128509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128524 */     // MIs[1] Operand 1
     /* 128524 */     // No operand predicates
     /* 128524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128526 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 128529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128539 */     GIR_RootConstrainSelectedInstOperands,
     /* 128540 */     // GIR_Coverage, 763,
     /* 128540 */     GIR_EraseRootFromParent_Done,
     /* 128541 */   // Label 2810: @128541
     /* 128541 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(128583), // Rule ID 775 //
     /* 128546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128557 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128561 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 128574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128581 */     GIR_RootConstrainSelectedInstOperands,
     /* 128582 */     // GIR_Coverage, 775,
     /* 128582 */     GIR_EraseRootFromParent_Done,
     /* 128583 */   // Label 2811: @128583
     /* 128583 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(128625), // Rule ID 779 //
     /* 128588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128599 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128603 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 128616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128623 */     GIR_RootConstrainSelectedInstOperands,
     /* 128624 */     // GIR_Coverage, 779,
     /* 128624 */     GIR_EraseRootFromParent_Done,
     /* 128625 */   // Label 2812: @128625
     /* 128625 */   GIM_Reject,
     /* 128626 */ // Label 2802: @128626
     /* 128626 */ GIM_Reject,
     /* 128627 */ // Label 2772: @128627
     /* 128627 */ GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(129093),
     /* 128632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128642 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(128701), // Rule ID 17623 //
     /* 128647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128682 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROR64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1_ND),
     /* 128685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128699 */     GIR_RootConstrainSelectedInstOperands,
     /* 128700 */     // GIR_Coverage, 17623,
     /* 128700 */     GIR_EraseRootFromParent_Done,
     /* 128701 */   // Label 2814: @128701
     /* 128701 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(128768), // Rule ID 772 //
     /* 128706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128717 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128724 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128736 */     // MIs[2] Operand 1
     /* 128736 */     // No operand predicates
     /* 128736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128745 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi_ND),
     /* 128748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128766 */     GIR_RootConstrainSelectedInstOperands,
     /* 128767 */     // GIR_Coverage, 772,
     /* 128767 */     GIR_EraseRootFromParent_Done,
     /* 128768 */   // Label 2815: @128768
     /* 128768 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(128841), // Rule ID 788 //
     /* 128773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128808 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128812 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL_ND),
     /* 128825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128839 */     GIR_RootConstrainSelectedInstOperands,
     /* 128840 */     // GIR_Coverage, 788,
     /* 128840 */     GIR_EraseRootFromParent_Done,
     /* 128841 */   // Label 2816: @128841
     /* 128841 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(128878), // Rule ID 870 //
     /* 128846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128861 */     // MIs[1] Operand 1
     /* 128861 */     // No operand predicates
     /* 128861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128863 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 128866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128876 */     GIR_RootConstrainSelectedInstOperands,
     /* 128877 */     // GIR_Coverage, 870,
     /* 128877 */     GIR_EraseRootFromParent_Done,
     /* 128878 */   // Label 2817: @128878
     /* 128878 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(128906), // Rule ID 17599 //
     /* 128883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128894 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 128897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128899 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128904 */     GIR_RootConstrainSelectedInstOperands,
     /* 128905 */     // GIR_Coverage, 17599,
     /* 128905 */     GIR_EraseRootFromParent_Done,
     /* 128906 */   // Label 2818: @128906
     /* 128906 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(128934), // Rule ID 17607 //
     /* 128911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128922 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 128925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128932 */     GIR_RootConstrainSelectedInstOperands,
     /* 128933 */     // GIR_Coverage, 17607,
     /* 128933 */     GIR_EraseRootFromParent_Done,
     /* 128934 */   // Label 2819: @128934
     /* 128934 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(128971), // Rule ID 760 //
     /* 128939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128954 */     // MIs[1] Operand 1
     /* 128954 */     // No operand predicates
     /* 128954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128956 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 128959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128969 */     GIR_RootConstrainSelectedInstOperands,
     /* 128970 */     // GIR_Coverage, 760,
     /* 128970 */     GIR_EraseRootFromParent_Done,
     /* 128971 */   // Label 2820: @128971
     /* 128971 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(129008), // Rule ID 764 //
     /* 128976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128991 */     // MIs[1] Operand 1
     /* 128991 */     // No operand predicates
     /* 128991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128993 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 128996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 129003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129006 */     GIR_RootConstrainSelectedInstOperands,
     /* 129007 */     // GIR_Coverage, 764,
     /* 129007 */     GIR_EraseRootFromParent_Done,
     /* 129008 */   // Label 2821: @129008
     /* 129008 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(129050), // Rule ID 776 //
     /* 129013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129024 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129028 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 129041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129043 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129048 */     GIR_RootConstrainSelectedInstOperands,
     /* 129049 */     // GIR_Coverage, 776,
     /* 129049 */     GIR_EraseRootFromParent_Done,
     /* 129050 */   // Label 2822: @129050
     /* 129050 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(129092), // Rule ID 780 //
     /* 129055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129066 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129070 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 129083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129090 */     GIR_RootConstrainSelectedInstOperands,
     /* 129091 */     // GIR_Coverage, 780,
     /* 129091 */     GIR_EraseRootFromParent_Done,
     /* 129092 */   // Label 2823: @129092
     /* 129092 */   GIM_Reject,
     /* 129093 */ // Label 2813: @129093
     /* 129093 */ GIM_Reject,
     /* 129094 */ // Label 2773: @129094
     /* 129094 */ GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(129511),
     /* 129099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 129102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 129105 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(129167), // Rule ID 1583 //
     /* 129110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129149 */     // (rotl:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQmr:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQmr),
     /* 129152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129165 */     GIR_RootConstrainSelectedInstOperands,
     /* 129166 */     // GIR_Coverage, 1583,
     /* 129166 */     GIR_EraseRootFromParent_Done,
     /* 129167 */   // Label 2825: @129167
     /* 129167 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(129229), // Rule ID 1582 //
     /* 129172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129211 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQrm),
     /* 129214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129227 */     GIR_RootConstrainSelectedInstOperands,
     /* 129228 */     // GIR_Coverage, 1582,
     /* 129228 */     GIR_EraseRootFromParent_Done,
     /* 129229 */   // Label 2826: @129229
     /* 129229 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(129291), // Rule ID 8059 //
     /* 129234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129273 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rm),
     /* 129276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129289 */     GIR_RootConstrainSelectedInstOperands,
     /* 129290 */     // GIR_Coverage, 8059,
     /* 129290 */     GIR_EraseRootFromParent_Done,
     /* 129291 */   // Label 2827: @129291
     /* 129291 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(129318), // Rule ID 1581 //
     /* 129296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129311 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 129316 */     GIR_RootConstrainSelectedInstOperands,
     /* 129317 */     // GIR_Coverage, 1581,
     /* 129317 */     GIR_Done,
     /* 129318 */   // Label 2828: @129318
     /* 129318 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(129345), // Rule ID 8056 //
     /* 129323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129338 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 129338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 129343 */     GIR_RootConstrainSelectedInstOperands,
     /* 129344 */     // GIR_Coverage, 8056,
     /* 129344 */     GIR_Done,
     /* 129345 */   // Label 2829: @129345
     /* 129345 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(129510), // Rule ID 20796 //
     /* 129350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129365 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129365 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 129368 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129372 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129379 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 129382 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129386 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129391 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129394 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129398 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129401 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129406 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129411 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129416 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 129419 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129423 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 129433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129442 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129449 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129452 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129457 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129462 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 129470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 129474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129479 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129492 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129509 */     // GIR_Coverage, 20796,
     /* 129509 */     GIR_EraseRootFromParent_Done,
     /* 129510 */   // Label 2830: @129510
     /* 129510 */   GIM_Reject,
     /* 129511 */ // Label 2824: @129511
     /* 129511 */ GIM_Reject,
     /* 129512 */ // Label 2774: @129512
     /* 129512 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(129929),
     /* 129517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129523 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(129585), // Rule ID 1580 //
     /* 129528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129543 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129546 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129550 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129567 */     // (rotl:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDmr:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDmr),
     /* 129570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129583 */     GIR_RootConstrainSelectedInstOperands,
     /* 129584 */     // GIR_Coverage, 1580,
     /* 129584 */     GIR_EraseRootFromParent_Done,
     /* 129585 */   // Label 2832: @129585
     /* 129585 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(129647), // Rule ID 1579 //
     /* 129590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129629 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDrm),
     /* 129632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129645 */     GIR_RootConstrainSelectedInstOperands,
     /* 129646 */     // GIR_Coverage, 1579,
     /* 129646 */     GIR_EraseRootFromParent_Done,
     /* 129647 */   // Label 2833: @129647
     /* 129647 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(129709), // Rule ID 8032 //
     /* 129652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129671 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129691 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rm),
     /* 129694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129707 */     GIR_RootConstrainSelectedInstOperands,
     /* 129708 */     // GIR_Coverage, 8032,
     /* 129708 */     GIR_EraseRootFromParent_Done,
     /* 129709 */   // Label 2834: @129709
     /* 129709 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(129736), // Rule ID 1578 //
     /* 129714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129729 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 129734 */     GIR_RootConstrainSelectedInstOperands,
     /* 129735 */     // GIR_Coverage, 1578,
     /* 129735 */     GIR_Done,
     /* 129736 */   // Label 2835: @129736
     /* 129736 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(129763), // Rule ID 8029 //
     /* 129741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129756 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 129756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 129761 */     GIR_RootConstrainSelectedInstOperands,
     /* 129762 */     // GIR_Coverage, 8029,
     /* 129762 */     GIR_Done,
     /* 129763 */   // Label 2836: @129763
     /* 129763 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(129928), // Rule ID 20798 //
     /* 129768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129783 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129783 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 129786 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129790 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129797 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 129800 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129804 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129809 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129812 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129816 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129819 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129824 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129829 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129834 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 129837 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129841 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129848 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 129851 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129855 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129860 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129863 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129867 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129880 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 129888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 129892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129910 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129927 */     // GIR_Coverage, 20798,
     /* 129927 */     GIR_EraseRootFromParent_Done,
     /* 129928 */   // Label 2837: @129928
     /* 129928 */   GIM_Reject,
     /* 129929 */ // Label 2831: @129929
     /* 129929 */ GIM_Reject,
     /* 129930 */ // Label 2775: @129930
     /* 129930 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(130180),
     /* 129935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 129938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 129941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129949 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(130003), // Rule ID 8050 //
     /* 129954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129972 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129985 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rm),
     /* 129988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130001 */     GIR_RootConstrainSelectedInstOperands,
     /* 130002 */     // GIR_Coverage, 8050,
     /* 130002 */     GIR_EraseRootFromParent_Done,
     /* 130003 */   // Label 2839: @130003
     /* 130003 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(130022), // Rule ID 8047 //
     /* 130008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130015 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 130015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 130020 */     GIR_RootConstrainSelectedInstOperands,
     /* 130021 */     // GIR_Coverage, 8047,
     /* 130021 */     GIR_Done,
     /* 130022 */   // Label 2840: @130022
     /* 130022 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(130179), // Rule ID 20797 //
     /* 130027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130034 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130034 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 130037 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130041 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130048 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 130051 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130055 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130060 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130063 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130067 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130070 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130075 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130080 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130085 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 130088 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130092 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 130102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130111 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130118 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 130139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130178 */     // GIR_Coverage, 20797,
     /* 130178 */     GIR_EraseRootFromParent_Done,
     /* 130179 */   // Label 2841: @130179
     /* 130179 */   GIM_Reject,
     /* 130180 */ // Label 2838: @130180
     /* 130180 */ GIM_Reject,
     /* 130181 */ // Label 2776: @130181
     /* 130181 */ GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(130336),
     /* 130186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 130192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130196 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(130254), // Rule ID 1586 //
     /* 130201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130236 */     // (rotl:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWmr:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWmr),
     /* 130239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130252 */     GIR_RootConstrainSelectedInstOperands,
     /* 130253 */     // GIR_Coverage, 1586,
     /* 130253 */     GIR_EraseRootFromParent_Done,
     /* 130254 */   // Label 2843: @130254
     /* 130254 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(130312), // Rule ID 1585 //
     /* 130259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130294 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWrm),
     /* 130297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130310 */     GIR_RootConstrainSelectedInstOperands,
     /* 130311 */     // GIR_Coverage, 1585,
     /* 130311 */     GIR_EraseRootFromParent_Done,
     /* 130312 */   // Label 2844: @130312
     /* 130312 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(130335), // Rule ID 1584 //
     /* 130317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130328 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 130333 */     GIR_RootConstrainSelectedInstOperands,
     /* 130334 */     // GIR_Coverage, 1584,
     /* 130334 */     GIR_Done,
     /* 130335 */   // Label 2845: @130335
     /* 130335 */   GIM_Reject,
     /* 130336 */ // Label 2842: @130336
     /* 130336 */ GIM_Reject,
     /* 130337 */ // Label 2777: @130337
     /* 130337 */ GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(130587),
     /* 130342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 130345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 130348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130356 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(130410), // Rule ID 8023 //
     /* 130361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130392 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rm),
     /* 130395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130408 */     GIR_RootConstrainSelectedInstOperands,
     /* 130409 */     // GIR_Coverage, 8023,
     /* 130409 */     GIR_EraseRootFromParent_Done,
     /* 130410 */   // Label 2847: @130410
     /* 130410 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(130429), // Rule ID 8020 //
     /* 130415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130422 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 130422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 130427 */     GIR_RootConstrainSelectedInstOperands,
     /* 130428 */     // GIR_Coverage, 8020,
     /* 130428 */     GIR_Done,
     /* 130429 */   // Label 2848: @130429
     /* 130429 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(130586), // Rule ID 20799 //
     /* 130434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130441 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130441 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 130444 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130448 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130455 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130458 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130462 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130467 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130470 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130474 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130477 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130482 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130487 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130555 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130558 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130568 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130585 */     // GIR_Coverage, 20799,
     /* 130585 */     GIR_EraseRootFromParent_Done,
     /* 130586 */   // Label 2849: @130586
     /* 130586 */   GIM_Reject,
     /* 130587 */ // Label 2846: @130587
     /* 130587 */ GIM_Reject,
     /* 130588 */ // Label 2778: @130588
     /* 130588 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(130681),
     /* 130593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 130596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 130599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130607 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(130661), // Rule ID 8041 //
     /* 130612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130643 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrm),
     /* 130646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130659 */     GIR_RootConstrainSelectedInstOperands,
     /* 130660 */     // GIR_Coverage, 8041,
     /* 130660 */     GIR_EraseRootFromParent_Done,
     /* 130661 */   // Label 2851: @130661
     /* 130661 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(130680), // Rule ID 8038 //
     /* 130666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130673 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 130673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130678 */     GIR_RootConstrainSelectedInstOperands,
     /* 130679 */     // GIR_Coverage, 8038,
     /* 130679 */     GIR_Done,
     /* 130680 */   // Label 2852: @130680
     /* 130680 */   GIM_Reject,
     /* 130681 */ // Label 2850: @130681
     /* 130681 */ GIM_Reject,
     /* 130682 */ // Label 2779: @130682
     /* 130682 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(130837),
     /* 130687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 130690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 130693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130697 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(130755), // Rule ID 1577 //
     /* 130702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130737 */     // (rotl:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBmr:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBmr),
     /* 130740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130746 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130753 */     GIR_RootConstrainSelectedInstOperands,
     /* 130754 */     // GIR_Coverage, 1577,
     /* 130754 */     GIR_EraseRootFromParent_Done,
     /* 130755 */   // Label 2854: @130755
     /* 130755 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(130813), // Rule ID 1576 //
     /* 130760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130795 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBrm),
     /* 130798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130800 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130811 */     GIR_RootConstrainSelectedInstOperands,
     /* 130812 */     // GIR_Coverage, 1576,
     /* 130812 */     GIR_EraseRootFromParent_Done,
     /* 130813 */   // Label 2855: @130813
     /* 130813 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(130836), // Rule ID 1575 //
     /* 130818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130829 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 130834 */     GIR_RootConstrainSelectedInstOperands,
     /* 130835 */     // GIR_Coverage, 1575,
     /* 130835 */     GIR_Done,
     /* 130836 */   // Label 2856: @130836
     /* 130836 */   GIM_Reject,
     /* 130837 */ // Label 2853: @130837
     /* 130837 */ GIM_Reject,
     /* 130838 */ // Label 2780: @130838
     /* 130838 */ GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(130931),
     /* 130843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 130846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 130849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130857 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(130911), // Rule ID 8014 //
     /* 130862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130893 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrm),
     /* 130896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130909 */     GIR_RootConstrainSelectedInstOperands,
     /* 130910 */     // GIR_Coverage, 8014,
     /* 130910 */     GIR_EraseRootFromParent_Done,
     /* 130911 */   // Label 2858: @130911
     /* 130911 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(130930), // Rule ID 8011 //
     /* 130916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130923 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 130923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130928 */     GIR_RootConstrainSelectedInstOperands,
     /* 130929 */     // GIR_Coverage, 8011,
     /* 130929 */     GIR_Done,
     /* 130930 */   // Label 2859: @130930
     /* 130930 */   GIM_Reject,
     /* 130931 */ // Label 2857: @130931
     /* 130931 */ GIM_Reject,
     /* 130932 */ // Label 2781: @130932
     /* 130932 */ GIM_Reject,
     /* 130933 */ // Label 33: @130933
     /* 130933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 2866*/ GIMT_Encode4(132589),
     /* 130944 */ /*GILLT_v2s1*//*Label 2860*/ GIMT_Encode4(131012), GIMT_Encode4(0),
     /* 130952 */ /*GILLT_v4s1*//*Label 2861*/ GIMT_Encode4(131173), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130964 */ /*GILLT_v8s1*//*Label 2862*/ GIMT_Encode4(131520), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130980 */ /*GILLT_v16s1*//*Label 2863*/ GIMT_Encode4(131917), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130996 */ /*GILLT_v32s1*//*Label 2864*/ GIMT_Encode4(132314), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131008 */ /*GILLT_v64s1*//*Label 2865*/ GIMT_Encode4(132538),
     /* 131012 */ // Label 2860: @131012
     /* 131012 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(131172),
     /* 131017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 131020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 131023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 131027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131036 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(131067), // Rule ID 12606 //
     /* 131041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131058 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 131058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 131061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131063 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131065 */     GIR_RootConstrainSelectedInstOperands,
     /* 131066 */     // GIR_Coverage, 12606,
     /* 131066 */     GIR_EraseRootFromParent_Done,
     /* 131067 */   // Label 2868: @131067
     /* 131067 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(131171), // Rule ID 21658 //
     /* 131072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131079 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131085 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131089 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 131089 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131092 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131096 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131115 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131118 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131122 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 131170 */     // GIR_Coverage, 21658,
     /* 131170 */     GIR_EraseRootFromParent_Done,
     /* 131171 */   // Label 2869: @131171
     /* 131171 */   GIM_Reject,
     /* 131172 */ // Label 2867: @131172
     /* 131172 */ GIM_Reject,
     /* 131173 */ // Label 2861: @131173
     /* 131173 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(131223), // Rule ID 12603 //
     /* 131178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131184 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131191 */   // MIs[0] Operand 1
     /* 131191 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131196 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131200 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131206 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131208 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131214 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 131214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 131217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131219 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131221 */   GIR_RootConstrainSelectedInstOperands,
     /* 131222 */   // GIR_Coverage, 12603,
     /* 131222 */   GIR_EraseRootFromParent_Done,
     /* 131223 */ // Label 2870: @131223
     /* 131223 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(131273), // Rule ID 12605 //
     /* 131228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131241 */   // MIs[0] Operand 1
     /* 131241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131250 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131256 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131264 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 131264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 131267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131269 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131271 */   GIR_RootConstrainSelectedInstOperands,
     /* 131272 */   // GIR_Coverage, 12605,
     /* 131272 */   GIR_EraseRootFromParent_Done,
     /* 131273 */ // Label 2871: @131273
     /* 131273 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(131396), // Rule ID 21656 //
     /* 131278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131291 */   // MIs[0] Operand 1
     /* 131291 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131300 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131306 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131312 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131314 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131314 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131317 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131321 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131328 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131331 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131335 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131340 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131343 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131347 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131350 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131355 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131360 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131395 */   // GIR_Coverage, 21656,
     /* 131395 */   GIR_EraseRootFromParent_Done,
     /* 131396 */ // Label 2872: @131396
     /* 131396 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(131519), // Rule ID 21657 //
     /* 131401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131414 */   // MIs[0] Operand 1
     /* 131414 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131423 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131429 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131431 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131437 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131437 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131440 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131444 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131451 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131454 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131458 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131463 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131466 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131470 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131473 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131478 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131483 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131500 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131518 */   // GIR_Coverage, 21657,
     /* 131518 */   GIR_EraseRootFromParent_Done,
     /* 131519 */ // Label 2873: @131519
     /* 131519 */ GIM_Reject,
     /* 131520 */ // Label 2862: @131520
     /* 131520 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(131570), // Rule ID 12600 //
     /* 131525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131538 */   // MIs[0] Operand 1
     /* 131538 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131547 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131553 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131561 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 131561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 131564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131566 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131568 */   GIR_RootConstrainSelectedInstOperands,
     /* 131569 */   // GIR_Coverage, 12600,
     /* 131569 */   GIR_EraseRootFromParent_Done,
     /* 131570 */ // Label 2874: @131570
     /* 131570 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(131620), // Rule ID 12602 //
     /* 131575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131581 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131588 */   // MIs[0] Operand 1
     /* 131588 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131597 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131603 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131605 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131611 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 131611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 131614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131616 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131618 */   GIR_RootConstrainSelectedInstOperands,
     /* 131619 */   // GIR_Coverage, 12602,
     /* 131619 */   GIR_EraseRootFromParent_Done,
     /* 131620 */ // Label 2875: @131620
     /* 131620 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(131670), // Rule ID 12604 //
     /* 131625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 131628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 131631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 131634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131638 */   // MIs[0] Operand 1
     /* 131638 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131647 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131653 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131661 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 131661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131666 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131668 */   GIR_RootConstrainSelectedInstOperands,
     /* 131669 */   // GIR_Coverage, 12604,
     /* 131669 */   GIR_EraseRootFromParent_Done,
     /* 131670 */ // Label 2876: @131670
     /* 131670 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(131793), // Rule ID 21654 //
     /* 131675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131681 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131688 */   // MIs[0] Operand 1
     /* 131688 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131697 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131703 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131711 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131711 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 131714 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131718 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131725 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 131728 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131732 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131737 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131740 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131744 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131747 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131752 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131757 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 131765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131774 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 131792 */   // GIR_Coverage, 21654,
     /* 131792 */   GIR_EraseRootFromParent_Done,
     /* 131793 */ // Label 2877: @131793
     /* 131793 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(131916), // Rule ID 21655 //
     /* 131798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131804 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131811 */   // MIs[0] Operand 1
     /* 131811 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131820 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131826 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131828 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131834 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131834 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131837 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131841 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131848 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131851 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131855 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131860 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131863 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131867 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131870 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131875 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131880 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131897 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 131915 */   // GIR_Coverage, 21655,
     /* 131915 */   GIR_EraseRootFromParent_Done,
     /* 131916 */ // Label 2878: @131916
     /* 131916 */ GIM_Reject,
     /* 131917 */ // Label 2863: @131917
     /* 131917 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(131967), // Rule ID 12597 //
     /* 131922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 131928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 131931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131935 */   // MIs[0] Operand 1
     /* 131935 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131944 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131950 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131956 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131958 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 131958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 131961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131963 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131965 */   GIR_RootConstrainSelectedInstOperands,
     /* 131966 */   // GIR_Coverage, 12597,
     /* 131966 */   GIR_EraseRootFromParent_Done,
     /* 131967 */ // Label 2879: @131967
     /* 131967 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(132017), // Rule ID 12599 //
     /* 131972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 131978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 131981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131985 */   // MIs[0] Operand 1
     /* 131985 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131990 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131994 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132000 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132002 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132006 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132008 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 132008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 132011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132013 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132015 */   GIR_RootConstrainSelectedInstOperands,
     /* 132016 */   // GIR_Coverage, 12599,
     /* 132016 */   GIR_EraseRootFromParent_Done,
     /* 132017 */ // Label 2880: @132017
     /* 132017 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(132067), // Rule ID 12601 //
     /* 132022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 132025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 132028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 132031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132035 */   // MIs[0] Operand 1
     /* 132035 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132044 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132050 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132052 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132058 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 132058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132063 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132065 */   GIR_RootConstrainSelectedInstOperands,
     /* 132066 */   // GIR_Coverage, 12601,
     /* 132066 */   GIR_EraseRootFromParent_Done,
     /* 132067 */ // Label 2881: @132067
     /* 132067 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(132190), // Rule ID 21652 //
     /* 132072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132078 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132085 */   // MIs[0] Operand 1
     /* 132085 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132094 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132100 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132102 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132108 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132108 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132111 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132115 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132122 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132125 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132129 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132134 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132137 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132141 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 132144 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132149 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132154 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132171 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132181 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132184 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132189 */   // GIR_Coverage, 21652,
     /* 132189 */   GIR_EraseRootFromParent_Done,
     /* 132190 */ // Label 2882: @132190
     /* 132190 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(132313), // Rule ID 21653 //
     /* 132195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132201 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132208 */   // MIs[0] Operand 1
     /* 132208 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132217 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132223 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132231 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132231 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 132234 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132238 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132245 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 132248 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132252 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132257 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132260 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132264 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132267 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132272 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132277 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 132285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132294 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132312 */   // GIR_Coverage, 21653,
     /* 132312 */   GIR_EraseRootFromParent_Done,
     /* 132313 */ // Label 2883: @132313
     /* 132313 */ GIM_Reject,
     /* 132314 */ // Label 2864: @132314
     /* 132314 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(132364), // Rule ID 12596 //
     /* 132319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132332 */   // MIs[0] Operand 1
     /* 132332 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132337 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132341 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132347 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132349 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132355 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 132355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 132358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132360 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132362 */   GIR_RootConstrainSelectedInstOperands,
     /* 132363 */   // GIR_Coverage, 12596,
     /* 132363 */   GIR_EraseRootFromParent_Done,
     /* 132364 */ // Label 2884: @132364
     /* 132364 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(132414), // Rule ID 12598 //
     /* 132369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 132375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 132378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132382 */   // MIs[0] Operand 1
     /* 132382 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132391 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132397 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132399 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132405 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 132405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132410 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132412 */   GIR_RootConstrainSelectedInstOperands,
     /* 132413 */   // GIR_Coverage, 12598,
     /* 132413 */   GIR_EraseRootFromParent_Done,
     /* 132414 */ // Label 2885: @132414
     /* 132414 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(132537), // Rule ID 21651 //
     /* 132419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132432 */   // MIs[0] Operand 1
     /* 132432 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132437 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132441 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132447 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132449 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132455 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 132455 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132458 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132462 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132469 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132472 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132476 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132481 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132484 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132488 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132491 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132496 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132501 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132518 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 132536 */   // GIR_Coverage, 21651,
     /* 132536 */   GIR_EraseRootFromParent_Done,
     /* 132537 */ // Label 2886: @132537
     /* 132537 */ GIM_Reject,
     /* 132538 */ // Label 2865: @132538
     /* 132538 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(132588), // Rule ID 12595 //
     /* 132543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 132549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 132552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 132556 */   // MIs[0] Operand 1
     /* 132556 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132561 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132565 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132571 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132573 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132579 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 132579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132584 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132586 */   GIR_RootConstrainSelectedInstOperands,
     /* 132587 */   // GIR_Coverage, 12595,
     /* 132587 */   GIR_EraseRootFromParent_Done,
     /* 132588 */ // Label 2887: @132588
     /* 132588 */ GIM_Reject,
     /* 132589 */ // Label 2866: @132589
     /* 132589 */ GIM_Reject,
     /* 132590 */ // Label 34: @132590
     /* 132590 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2900*/ GIMT_Encode4(140255),
     /* 132601 */ /*GILLT_v2s64*//*Label 2888*/ GIMT_Encode4(132669), GIMT_Encode4(0),
     /* 132609 */ /*GILLT_v4s32*//*Label 2889*/ GIMT_Encode4(133533),
     /* 132613 */ /*GILLT_v4s64*//*Label 2890*/ GIMT_Encode4(134397), GIMT_Encode4(0),
     /* 132621 */ /*GILLT_v8s16*//*Label 2891*/ GIMT_Encode4(135177),
     /* 132625 */ /*GILLT_v8s32*//*Label 2892*/ GIMT_Encode4(136335),
     /* 132629 */ /*GILLT_v8s64*//*Label 2893*/ GIMT_Encode4(137115), GIMT_Encode4(0),
     /* 132637 */ /*GILLT_v16s8*//*Label 2894*/ GIMT_Encode4(137496),
     /* 132641 */ /*GILLT_v16s16*//*Label 2895*/ GIMT_Encode4(137936),
     /* 132645 */ /*GILLT_v16s32*//*Label 2896*/ GIMT_Encode4(139006), GIMT_Encode4(0),
     /* 132653 */ /*GILLT_v32s8*//*Label 2897*/ GIMT_Encode4(139347),
     /* 132657 */ /*GILLT_v32s16*//*Label 2898*/ GIMT_Encode4(139751), GIMT_Encode4(0),
     /* 132665 */ /*GILLT_v64s8*//*Label 2899*/ GIMT_Encode4(140169),
     /* 132669 */ // Label 2888: @132669
     /* 132669 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(133532),
     /* 132674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 132677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 132680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 132683 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(132728), // Rule ID 4489 //
     /* 132688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132717 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 132717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 132720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132722 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132726 */     GIR_RootConstrainSelectedInstOperands,
     /* 132727 */     // GIR_Coverage, 4489,
     /* 132727 */     GIR_EraseRootFromParent_Done,
     /* 132728 */   // Label 2902: @132728
     /* 132728 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(132773), // Rule ID 4543 //
     /* 132733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132752 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132758 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132762 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 132762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 132765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132767 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132771 */     GIR_RootConstrainSelectedInstOperands,
     /* 132772 */     // GIR_Coverage, 4543,
     /* 132772 */     GIR_EraseRootFromParent_Done,
     /* 132773 */   // Label 2903: @132773
     /* 132773 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(132922), // Rule ID 19777 //
     /* 132778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132797 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132803 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132807 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132807 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 132810 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132814 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132821 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132824 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132828 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132833 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 132836 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132840 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 132843 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132848 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132853 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132858 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 132861 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132865 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132870 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 132874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 132879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 132882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 132886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132891 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 132897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132904 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 132911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 132916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132921 */     // GIR_Coverage, 19777,
     /* 132921 */     GIR_EraseRootFromParent_Done,
     /* 132922 */   // Label 2904: @132922
     /* 132922 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(133071), // Rule ID 19779 //
     /* 132927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132946 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132952 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132956 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132956 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 132959 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132963 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132982 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 132985 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132989 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 132992 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132997 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133002 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 133035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133070 */     // GIR_Coverage, 19779,
     /* 133070 */     GIR_EraseRootFromParent_Done,
     /* 133071 */   // Label 2905: @133071
     /* 133071 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(133108), // Rule ID 4491 //
     /* 133076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133095 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 133095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 133098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133100 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133102 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133106 */     GIR_RootConstrainSelectedInstOperands,
     /* 133107 */     // GIR_Coverage, 4491,
     /* 133107 */     GIR_EraseRootFromParent_Done,
     /* 133108 */   // Label 2906: @133108
     /* 133108 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(133145), // Rule ID 4545 //
     /* 133113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133132 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 133132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 133135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133137 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133139 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133141 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133143 */     GIR_RootConstrainSelectedInstOperands,
     /* 133144 */     // GIR_Coverage, 4545,
     /* 133144 */     GIR_EraseRootFromParent_Done,
     /* 133145 */   // Label 2907: @133145
     /* 133145 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(133338), // Rule ID 19776 //
     /* 133150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133169 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133169 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133172 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133176 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133183 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133186 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133190 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133195 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133198 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133202 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133205 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133210 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133215 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133220 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133223 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133227 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133232 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133236 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133241 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133244 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133248 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133267 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133274 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133287 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 133299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133337 */     // GIR_Coverage, 19776,
     /* 133337 */     GIR_EraseRootFromParent_Done,
     /* 133338 */   // Label 2908: @133338
     /* 133338 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(133531), // Rule ID 19778 //
     /* 133343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133362 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133362 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133365 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133369 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133376 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133379 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133383 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133388 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133391 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133395 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133398 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133403 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133408 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133413 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133416 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133420 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133425 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133429 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133434 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133437 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133441 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133448 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133451 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133455 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133460 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133467 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133470 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133475 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133480 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 133492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133500 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133530 */     // GIR_Coverage, 19778,
     /* 133530 */     GIR_EraseRootFromParent_Done,
     /* 133531 */   // Label 2909: @133531
     /* 133531 */   GIM_Reject,
     /* 133532 */ // Label 2901: @133532
     /* 133532 */ GIM_Reject,
     /* 133533 */ // Label 2889: @133533
     /* 133533 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(134396),
     /* 133538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 133541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 133544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 133547 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(133592), // Rule ID 4471 //
     /* 133552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133571 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133577 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133581 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 133581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 133584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133586 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133588 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133590 */     GIR_RootConstrainSelectedInstOperands,
     /* 133591 */     // GIR_Coverage, 4471,
     /* 133591 */     GIR_EraseRootFromParent_Done,
     /* 133592 */   // Label 2911: @133592
     /* 133592 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(133637), // Rule ID 4529 //
     /* 133597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133616 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133622 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133626 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 133626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 133629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133631 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133635 */     GIR_RootConstrainSelectedInstOperands,
     /* 133636 */     // GIR_Coverage, 4529,
     /* 133636 */     GIR_EraseRootFromParent_Done,
     /* 133637 */   // Label 2912: @133637
     /* 133637 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(133786), // Rule ID 19769 //
     /* 133642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133661 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133667 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133671 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133671 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133674 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133678 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133685 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133688 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133692 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133697 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133700 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133704 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133707 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133712 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133717 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133734 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 133750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133758 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133768 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133785 */     // GIR_Coverage, 19769,
     /* 133785 */     GIR_EraseRootFromParent_Done,
     /* 133786 */   // Label 2913: @133786
     /* 133786 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(133935), // Rule ID 19771 //
     /* 133791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133810 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133816 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133820 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133820 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133823 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133827 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133834 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133837 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133841 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133846 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133849 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133853 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133856 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133861 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133866 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 133899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133904 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133907 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133934 */     // GIR_Coverage, 19771,
     /* 133934 */     GIR_EraseRootFromParent_Done,
     /* 133935 */   // Label 2914: @133935
     /* 133935 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(133972), // Rule ID 4473 //
     /* 133940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133959 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 133959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 133962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133964 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133966 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133970 */     GIR_RootConstrainSelectedInstOperands,
     /* 133971 */     // GIR_Coverage, 4473,
     /* 133971 */     GIR_EraseRootFromParent_Done,
     /* 133972 */   // Label 2915: @133972
     /* 133972 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(134009), // Rule ID 4530 //
     /* 133977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133996 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 133996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 133999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134001 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134003 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134007 */     GIR_RootConstrainSelectedInstOperands,
     /* 134008 */     // GIR_Coverage, 4530,
     /* 134008 */     GIR_EraseRootFromParent_Done,
     /* 134009 */   // Label 2916: @134009
     /* 134009 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(134202), // Rule ID 19768 //
     /* 134014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134033 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134033 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134036 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134040 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134047 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134050 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134054 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134059 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134062 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134066 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134069 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134074 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134079 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134084 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134087 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134091 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134096 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134100 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134131 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134138 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134151 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 134163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134171 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134174 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134184 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134201 */     // GIR_Coverage, 19768,
     /* 134201 */     GIR_EraseRootFromParent_Done,
     /* 134202 */   // Label 2917: @134202
     /* 134202 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(134395), // Rule ID 19770 //
     /* 134207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134226 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134226 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134229 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134233 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134240 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134243 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134247 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134252 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134255 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134259 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134262 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134267 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134272 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134277 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134280 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134284 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134289 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134293 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 134356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134394 */     // GIR_Coverage, 19770,
     /* 134394 */     GIR_EraseRootFromParent_Done,
     /* 134395 */   // Label 2918: @134395
     /* 134395 */   GIM_Reject,
     /* 134396 */ // Label 2910: @134396
     /* 134396 */ GIM_Reject,
     /* 134397 */ // Label 2890: @134397
     /* 134397 */ GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(135176),
     /* 134402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 134405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 134408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 134411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134423 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(134456), // Rule ID 4484 //
     /* 134428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134441 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134445 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 134445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 134448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134450 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134454 */     GIR_RootConstrainSelectedInstOperands,
     /* 134455 */     // GIR_Coverage, 4484,
     /* 134455 */     GIR_EraseRootFromParent_Done,
     /* 134456 */   // Label 2920: @134456
     /* 134456 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(134489), // Rule ID 4538 //
     /* 134461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134468 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134474 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134478 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 134478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 134481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134483 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134487 */     GIR_RootConstrainSelectedInstOperands,
     /* 134488 */     // GIR_Coverage, 4538,
     /* 134488 */     GIR_EraseRootFromParent_Done,
     /* 134489 */   // Label 2921: @134489
     /* 134489 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(134626), // Rule ID 19781 //
     /* 134494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134511 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134511 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134514 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134518 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134525 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134528 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134532 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134537 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134540 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134544 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134547 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134552 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134557 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 134590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134608 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134625 */     // GIR_Coverage, 19781,
     /* 134625 */     GIR_EraseRootFromParent_Done,
     /* 134626 */   // Label 2922: @134626
     /* 134626 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(134763), // Rule ID 19783 //
     /* 134631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134638 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134644 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134648 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134648 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134651 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134655 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134674 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134677 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134681 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134684 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134689 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134694 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 134727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134762 */     // GIR_Coverage, 19783,
     /* 134762 */     GIR_EraseRootFromParent_Done,
     /* 134763 */   // Label 2923: @134763
     /* 134763 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(134788), // Rule ID 4486 //
     /* 134768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134775 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 134775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 134778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134782 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134786 */     GIR_RootConstrainSelectedInstOperands,
     /* 134787 */     // GIR_Coverage, 4486,
     /* 134787 */     GIR_EraseRootFromParent_Done,
     /* 134788 */   // Label 2924: @134788
     /* 134788 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(134813), // Rule ID 4540 //
     /* 134793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134800 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 134800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 134803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134805 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134807 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134811 */     GIR_RootConstrainSelectedInstOperands,
     /* 134812 */     // GIR_Coverage, 4540,
     /* 134812 */     GIR_EraseRootFromParent_Done,
     /* 134813 */   // Label 2925: @134813
     /* 134813 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(134994), // Rule ID 19780 //
     /* 134818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134825 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134825 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 134828 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134832 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134839 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 134842 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134846 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134851 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134854 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134858 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 134861 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134866 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134871 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134876 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 134879 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134883 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134888 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134892 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134897 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134900 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134904 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134911 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 134914 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134918 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134923 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134926 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134930 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 134933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 134955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134976 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134993 */     // GIR_Coverage, 19780,
     /* 134993 */     GIR_EraseRootFromParent_Done,
     /* 134994 */   // Label 2926: @134994
     /* 134994 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(135175), // Rule ID 19782 //
     /* 134999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135006 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135006 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135009 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135013 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135020 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135023 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135027 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135032 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135035 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135039 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135042 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135047 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135052 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135057 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135060 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135064 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135069 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135073 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135095 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135099 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135104 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135111 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 135136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135157 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135174 */     // GIR_Coverage, 19782,
     /* 135174 */     GIR_EraseRootFromParent_Done,
     /* 135175 */   // Label 2927: @135175
     /* 135175 */   GIM_Reject,
     /* 135176 */ // Label 2919: @135176
     /* 135176 */ GIM_Reject,
     /* 135177 */ // Label 2891: @135177
     /* 135177 */ GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(136334),
     /* 135182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 135185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 135188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 135191 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(135270), // Rule ID 19867 //
     /* 135196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135226 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135234 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135240 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135251 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135256 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135268 */     GIR_RootConstrainSelectedInstOperands,
     /* 135269 */     // GIR_Coverage, 19867,
     /* 135269 */     GIR_EraseRootFromParent_Done,
     /* 135270 */   // Label 2929: @135270
     /* 135270 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(135345), // Rule ID 19869 //
     /* 135275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135309 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135315 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135326 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135331 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135343 */     GIR_RootConstrainSelectedInstOperands,
     /* 135344 */     // GIR_Coverage, 19869,
     /* 135344 */     GIR_EraseRootFromParent_Done,
     /* 135345 */   // Label 2930: @135345
     /* 135345 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(135417), // Rule ID 19866 //
     /* 135350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135380 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135397 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135402 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135404 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135415 */     GIR_RootConstrainSelectedInstOperands,
     /* 135416 */     // GIR_Coverage, 19866,
     /* 135416 */     GIR_EraseRootFromParent_Done,
     /* 135417 */   // Label 2931: @135417
     /* 135417 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(135485), // Rule ID 19868 //
     /* 135422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135465 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135470 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135472 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135483 */     GIR_RootConstrainSelectedInstOperands,
     /* 135484 */     // GIR_Coverage, 19868,
     /* 135484 */     GIR_EraseRootFromParent_Done,
     /* 135485 */   // Label 2932: @135485
     /* 135485 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(135530), // Rule ID 4571 //
     /* 135490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135509 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135515 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135519 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 135519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135524 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135526 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135528 */     GIR_RootConstrainSelectedInstOperands,
     /* 135529 */     // GIR_Coverage, 4571,
     /* 135529 */     GIR_EraseRootFromParent_Done,
     /* 135530 */   // Label 2933: @135530
     /* 135530 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(135679), // Rule ID 19789 //
     /* 135535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135554 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135560 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135564 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135564 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135567 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135571 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135578 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135581 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135585 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135590 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135593 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135597 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135600 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135605 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135610 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135648 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135678 */     // GIR_Coverage, 19789,
     /* 135678 */     GIR_EraseRootFromParent_Done,
     /* 135679 */   // Label 2934: @135679
     /* 135679 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(135828), // Rule ID 19793 //
     /* 135684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135713 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135713 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135716 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135720 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135727 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135730 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135734 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135739 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135742 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135746 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135749 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135754 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135759 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135764 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135767 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135771 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135797 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135800 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135810 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135827 */     // GIR_Coverage, 19793,
     /* 135827 */     GIR_EraseRootFromParent_Done,
     /* 135828 */   // Label 2935: @135828
     /* 135828 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(135873), // Rule ID 19865 //
     /* 135833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135862 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 135862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135867 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135871 */     GIR_RootConstrainSelectedInstOperands,
     /* 135872 */     // GIR_Coverage, 19865,
     /* 135872 */     GIR_EraseRootFromParent_Done,
     /* 135873 */   // Label 2936: @135873
     /* 135873 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(135910), // Rule ID 4572 //
     /* 135878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135897 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 135897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 135900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135902 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135904 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135908 */     GIR_RootConstrainSelectedInstOperands,
     /* 135909 */     // GIR_Coverage, 4572,
     /* 135909 */     GIR_EraseRootFromParent_Done,
     /* 135910 */   // Label 2937: @135910
     /* 135910 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(136103), // Rule ID 19788 //
     /* 135915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135934 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135934 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 135937 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135941 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135948 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 135951 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135955 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135960 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135963 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135967 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 135970 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135975 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135980 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135985 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 135988 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135992 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135997 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136001 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136006 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136009 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136013 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136020 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136023 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136027 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136032 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136035 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136039 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136047 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136052 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136072 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136075 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136085 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136102 */     // GIR_Coverage, 19788,
     /* 136102 */     GIR_EraseRootFromParent_Done,
     /* 136103 */   // Label 2938: @136103
     /* 136103 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(136296), // Rule ID 19792 //
     /* 136108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136127 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136127 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136130 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136134 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136141 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136144 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136148 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136153 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136156 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136160 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136163 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136168 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136173 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136178 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136181 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136185 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136190 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136194 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136199 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136202 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136206 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136225 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136228 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136232 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136240 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136262 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136265 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136278 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136295 */     // GIR_Coverage, 19792,
     /* 136295 */     GIR_EraseRootFromParent_Done,
     /* 136296 */   // Label 2939: @136296
     /* 136296 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(136333), // Rule ID 19864 //
     /* 136301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136320 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136325 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136327 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136331 */     GIR_RootConstrainSelectedInstOperands,
     /* 136332 */     // GIR_Coverage, 19864,
     /* 136332 */     GIR_EraseRootFromParent_Done,
     /* 136333 */   // Label 2940: @136333
     /* 136333 */   GIM_Reject,
     /* 136334 */ // Label 2928: @136334
     /* 136334 */ GIM_Reject,
     /* 136335 */ // Label 2892: @136335
     /* 136335 */ GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(137114),
     /* 136340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 136343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 136346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 136349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136361 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(136394), // Rule ID 4466 //
     /* 136366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136373 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136379 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136383 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 136383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 136386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136388 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136390 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136392 */     GIR_RootConstrainSelectedInstOperands,
     /* 136393 */     // GIR_Coverage, 4466,
     /* 136393 */     GIR_EraseRootFromParent_Done,
     /* 136394 */   // Label 2942: @136394
     /* 136394 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(136427), // Rule ID 4525 //
     /* 136399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136406 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136412 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136416 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 136416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 136419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136421 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136425 */     GIR_RootConstrainSelectedInstOperands,
     /* 136426 */     // GIR_Coverage, 4525,
     /* 136426 */     GIR_EraseRootFromParent_Done,
     /* 136427 */   // Label 2943: @136427
     /* 136427 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(136564), // Rule ID 19773 //
     /* 136432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136439 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136445 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136449 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136449 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136452 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136456 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136463 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136466 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136470 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136475 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136478 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136482 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136485 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136490 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136495 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136500 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136503 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136507 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136512 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 136528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136533 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136536 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136546 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136563 */     // GIR_Coverage, 19773,
     /* 136563 */     GIR_EraseRootFromParent_Done,
     /* 136564 */   // Label 2944: @136564
     /* 136564 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(136701), // Rule ID 19775 //
     /* 136569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136576 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136582 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136586 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136586 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136589 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136593 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136600 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136603 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136607 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136612 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136615 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136619 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136622 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136627 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136632 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 136665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136673 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136683 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136700 */     // GIR_Coverage, 19775,
     /* 136700 */     GIR_EraseRootFromParent_Done,
     /* 136701 */   // Label 2945: @136701
     /* 136701 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(136726), // Rule ID 4468 //
     /* 136706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136713 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 136713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 136716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136718 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136720 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136722 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136724 */     GIR_RootConstrainSelectedInstOperands,
     /* 136725 */     // GIR_Coverage, 4468,
     /* 136725 */     GIR_EraseRootFromParent_Done,
     /* 136726 */   // Label 2946: @136726
     /* 136726 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(136751), // Rule ID 4526 //
     /* 136731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136738 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 136738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 136741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136745 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136749 */     GIR_RootConstrainSelectedInstOperands,
     /* 136750 */     // GIR_Coverage, 4526,
     /* 136750 */     GIR_EraseRootFromParent_Done,
     /* 136751 */   // Label 2947: @136751
     /* 136751 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(136932), // Rule ID 19772 //
     /* 136756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136763 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136763 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136766 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136770 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136777 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136780 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136784 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136789 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136792 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136796 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 136799 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136804 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136809 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136814 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 136817 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136821 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136826 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136830 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136835 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136838 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136842 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 136852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136861 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136864 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136868 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 136871 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 136893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136904 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136914 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136931 */     // GIR_Coverage, 19772,
     /* 136931 */     GIR_EraseRootFromParent_Done,
     /* 136932 */   // Label 2948: @136932
     /* 136932 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(137113), // Rule ID 19774 //
     /* 136937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136944 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136944 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136947 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136951 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136958 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136961 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136965 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136970 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136973 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136977 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 136980 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136985 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136990 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136995 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 136998 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137002 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137007 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137011 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137016 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137019 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137023 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137030 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137033 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137037 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137042 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137049 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137052 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 137074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137085 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137095 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137112 */     // GIR_Coverage, 19774,
     /* 137112 */     GIR_EraseRootFromParent_Done,
     /* 137113 */   // Label 2949: @137113
     /* 137113 */   GIM_Reject,
     /* 137114 */ // Label 2941: @137114
     /* 137114 */ GIM_Reject,
     /* 137115 */ // Label 2893: @137115
     /* 137115 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(137495),
     /* 137120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 137126 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 137129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137133 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(137202), // Rule ID 19766 //
     /* 137138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 137146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 137154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 137159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 137163 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137169 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 137171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 137175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137181 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 137183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 137189 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 137198 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137200 */     GIR_RootConstrainSelectedInstOperands,
     /* 137201 */     // GIR_Coverage, 19766,
     /* 137201 */     GIR_EraseRootFromParent_Done,
     /* 137202 */   // Label 2951: @137202
     /* 137202 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(137249), // Rule ID 3599 //
     /* 137207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137218 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 137226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137230 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137236 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137240 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 137240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 137243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137245 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137247 */     GIR_RootConstrainSelectedInstOperands,
     /* 137248 */     // GIR_Coverage, 3599,
     /* 137248 */     GIR_EraseRootFromParent_Done,
     /* 137249 */   // Label 2952: @137249
     /* 137249 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(137346), // Rule ID 19764 //
     /* 137254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137262 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137268 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137276 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 137276 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 137279 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137283 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137288 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137292 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 137297 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 137300 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 137304 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137309 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 137317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 137334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137342 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137344 */     GIR_RootConstrainSelectedInstOperands,
     /* 137345 */     // GIR_Coverage, 19764,
     /* 137345 */     GIR_EraseRootFromParent_Done,
     /* 137346 */   // Label 2953: @137346
     /* 137346 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(137387), // Rule ID 4479 //
     /* 137351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137366 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137372 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137376 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 137376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 137379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137381 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137385 */     GIR_RootConstrainSelectedInstOperands,
     /* 137386 */     // GIR_Coverage, 4479,
     /* 137386 */     GIR_EraseRootFromParent_Done,
     /* 137387 */   // Label 2954: @137387
     /* 137387 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(137428), // Rule ID 4533 //
     /* 137392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137413 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137417 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137422 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137426 */     GIR_RootConstrainSelectedInstOperands,
     /* 137427 */     // GIR_Coverage, 4533,
     /* 137427 */     GIR_EraseRootFromParent_Done,
     /* 137428 */   // Label 2955: @137428
     /* 137428 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(137461), // Rule ID 4481 //
     /* 137433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137448 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 137448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 137451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137453 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137455 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137457 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137459 */     GIR_RootConstrainSelectedInstOperands,
     /* 137460 */     // GIR_Coverage, 4481,
     /* 137460 */     GIR_EraseRootFromParent_Done,
     /* 137461 */   // Label 2956: @137461
     /* 137461 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(137494), // Rule ID 4535 //
     /* 137466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137481 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 137481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 137484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137486 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137488 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137490 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137492 */     GIR_RootConstrainSelectedInstOperands,
     /* 137493 */     // GIR_Coverage, 4535,
     /* 137493 */     GIR_EraseRootFromParent_Done,
     /* 137494 */   // Label 2957: @137494
     /* 137494 */   GIM_Reject,
     /* 137495 */ // Label 2950: @137495
     /* 137495 */ GIM_Reject,
     /* 137496 */ // Label 2894: @137496
     /* 137496 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(137935),
     /* 137501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 137507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 137510 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(137555), // Rule ID 4559 //
     /* 137515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137534 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137540 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137544 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 137544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 137547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137549 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137553 */     GIR_RootConstrainSelectedInstOperands,
     /* 137554 */     // GIR_Coverage, 4559,
     /* 137554 */     GIR_EraseRootFromParent_Done,
     /* 137555 */   // Label 2959: @137555
     /* 137555 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(137704), // Rule ID 19785 //
     /* 137560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137589 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137589 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 137592 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137596 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137603 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137606 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137610 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137615 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137618 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137622 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 137625 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137630 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137635 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 137643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137652 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 137668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137673 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137676 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 137679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137686 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137703 */     // GIR_Coverage, 19785,
     /* 137703 */     GIR_EraseRootFromParent_Done,
     /* 137704 */   // Label 2960: @137704
     /* 137704 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(137741), // Rule ID 4560 //
     /* 137709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137728 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 137728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 137731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137733 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137735 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137739 */     GIR_RootConstrainSelectedInstOperands,
     /* 137740 */     // GIR_Coverage, 4560,
     /* 137740 */     GIR_EraseRootFromParent_Done,
     /* 137741 */   // Label 2961: @137741
     /* 137741 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(137934), // Rule ID 19784 //
     /* 137746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137765 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137765 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 137768 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137772 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137779 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 137782 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137786 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137791 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137794 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137798 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 137801 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137806 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137811 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137816 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 137819 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137823 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137828 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137832 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137837 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137840 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137844 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 137854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137863 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137870 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 137873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 137895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137906 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137916 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137933 */     // GIR_Coverage, 19784,
     /* 137933 */     GIR_EraseRootFromParent_Done,
     /* 137934 */   // Label 2962: @137934
     /* 137934 */   GIM_Reject,
     /* 137935 */ // Label 2958: @137935
     /* 137935 */ GIM_Reject,
     /* 137936 */ // Label 2895: @137936
     /* 137936 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(139005),
     /* 137941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 137947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 137950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137958 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(138029), // Rule ID 19857 //
     /* 137963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 137974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 137981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 137985 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 137989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137993 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137999 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138010 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138015 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138027 */     GIR_RootConstrainSelectedInstOperands,
     /* 138028 */     // GIR_Coverage, 19857,
     /* 138028 */     GIR_EraseRootFromParent_Done,
     /* 138029 */   // Label 2964: @138029
     /* 138029 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(138096), // Rule ID 19859 //
     /* 138034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138060 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138077 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138082 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138094 */     GIR_RootConstrainSelectedInstOperands,
     /* 138095 */     // GIR_Coverage, 19859,
     /* 138095 */     GIR_EraseRootFromParent_Done,
     /* 138096 */   // Label 2965: @138096
     /* 138096 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(138160), // Rule ID 19856 //
     /* 138101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138123 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138140 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138145 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138147 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138158 */     GIR_RootConstrainSelectedInstOperands,
     /* 138159 */     // GIR_Coverage, 19856,
     /* 138159 */     GIR_EraseRootFromParent_Done,
     /* 138160 */   // Label 2966: @138160
     /* 138160 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(138220), // Rule ID 19858 //
     /* 138165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138200 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138205 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138207 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138218 */     GIR_RootConstrainSelectedInstOperands,
     /* 138219 */     // GIR_Coverage, 19858,
     /* 138219 */     GIR_EraseRootFromParent_Done,
     /* 138220 */   // Label 2967: @138220
     /* 138220 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(138257), // Rule ID 4567 //
     /* 138225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138236 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138242 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138246 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 138246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138251 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138255 */     GIR_RootConstrainSelectedInstOperands,
     /* 138256 */     // GIR_Coverage, 4567,
     /* 138256 */     GIR_EraseRootFromParent_Done,
     /* 138257 */   // Label 2968: @138257
     /* 138257 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(138398), // Rule ID 19791 //
     /* 138262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138279 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138283 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138283 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138286 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138290 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138309 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138312 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138316 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138319 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138324 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138329 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138334 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138337 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138341 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138380 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138397 */     // GIR_Coverage, 19791,
     /* 138397 */     GIR_EraseRootFromParent_Done,
     /* 138398 */   // Label 2969: @138398
     /* 138398 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(138539), // Rule ID 19795 //
     /* 138403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138414 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138420 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138424 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138424 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138427 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138431 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138438 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138441 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138445 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138450 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138453 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138457 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138460 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138465 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138470 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138491 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138511 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138521 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138538 */     // GIR_Coverage, 19795,
     /* 138538 */     GIR_EraseRootFromParent_Done,
     /* 138539 */   // Label 2970: @138539
     /* 138539 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(138576), // Rule ID 19855 //
     /* 138544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138555 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138561 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138565 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138570 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138574 */     GIR_RootConstrainSelectedInstOperands,
     /* 138575 */     // GIR_Coverage, 19855,
     /* 138575 */     GIR_EraseRootFromParent_Done,
     /* 138576 */   // Label 2971: @138576
     /* 138576 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(138605), // Rule ID 4568 //
     /* 138581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138592 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 138592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138597 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138599 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138603 */     GIR_RootConstrainSelectedInstOperands,
     /* 138604 */     // GIR_Coverage, 4568,
     /* 138604 */     GIR_EraseRootFromParent_Done,
     /* 138605 */   // Label 2972: @138605
     /* 138605 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(138790), // Rule ID 19790 //
     /* 138610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138621 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138621 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138624 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138628 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138635 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138638 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138642 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138647 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138650 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138654 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138657 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138662 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138667 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138672 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138675 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138679 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138684 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138688 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138693 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138696 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138700 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138719 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138726 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138756 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138772 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138789 */     // GIR_Coverage, 19790,
     /* 138789 */     GIR_EraseRootFromParent_Done,
     /* 138790 */   // Label 2973: @138790
     /* 138790 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(138975), // Rule ID 19794 //
     /* 138795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138806 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138806 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138809 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138813 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138820 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138823 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138827 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138832 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138835 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138839 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138842 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138847 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138852 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138857 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138860 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138864 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138869 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138873 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138878 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138881 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138885 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138892 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138895 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138899 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138904 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138911 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138941 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138944 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138957 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138974 */     // GIR_Coverage, 19794,
     /* 138974 */     GIR_EraseRootFromParent_Done,
     /* 138975 */   // Label 2974: @138975
     /* 138975 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(139004), // Rule ID 19854 //
     /* 138980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138991 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138996 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138998 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139002 */     GIR_RootConstrainSelectedInstOperands,
     /* 139003 */     // GIR_Coverage, 19854,
     /* 139003 */     GIR_EraseRootFromParent_Done,
     /* 139004 */   // Label 2975: @139004
     /* 139004 */   GIM_Reject,
     /* 139005 */ // Label 2963: @139005
     /* 139005 */ GIM_Reject,
     /* 139006 */ // Label 2896: @139006
     /* 139006 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(139346),
     /* 139011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 139017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 139020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139024 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(139093), // Rule ID 19767 //
     /* 139029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 139037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 139045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 139050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139054 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139060 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 139062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 139066 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139072 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 139074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 139080 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 139089 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139091 */     GIR_RootConstrainSelectedInstOperands,
     /* 139092 */     // GIR_Coverage, 19767,
     /* 139092 */     GIR_EraseRootFromParent_Done,
     /* 139093 */   // Label 2977: @139093
     /* 139093 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(139140), // Rule ID 3598 //
     /* 139098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139109 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139115 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 139117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139121 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139127 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139131 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 139131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 139134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139136 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139138 */     GIR_RootConstrainSelectedInstOperands,
     /* 139139 */     // GIR_Coverage, 3598,
     /* 139139 */     GIR_EraseRootFromParent_Done,
     /* 139140 */   // Label 2978: @139140
     /* 139140 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(139197), // Rule ID 19765 //
     /* 139145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139153 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139159 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139167 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 139167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 139170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 139174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139193 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139195 */     GIR_RootConstrainSelectedInstOperands,
     /* 139196 */     // GIR_Coverage, 19765,
     /* 139196 */     GIR_EraseRootFromParent_Done,
     /* 139197 */   // Label 2979: @139197
     /* 139197 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(139238), // Rule ID 4461 //
     /* 139202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139217 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139223 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139227 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 139227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 139230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139232 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139234 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139236 */     GIR_RootConstrainSelectedInstOperands,
     /* 139237 */     // GIR_Coverage, 4461,
     /* 139237 */     GIR_EraseRootFromParent_Done,
     /* 139238 */   // Label 2980: @139238
     /* 139238 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(139279), // Rule ID 4521 //
     /* 139243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139258 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139264 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139268 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139273 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139277 */     GIR_RootConstrainSelectedInstOperands,
     /* 139278 */     // GIR_Coverage, 4521,
     /* 139278 */     GIR_EraseRootFromParent_Done,
     /* 139279 */   // Label 2981: @139279
     /* 139279 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(139312), // Rule ID 4463 //
     /* 139284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139299 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 139299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 139302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139304 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139306 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139308 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139310 */     GIR_RootConstrainSelectedInstOperands,
     /* 139311 */     // GIR_Coverage, 4463,
     /* 139311 */     GIR_EraseRootFromParent_Done,
     /* 139312 */   // Label 2982: @139312
     /* 139312 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(139345), // Rule ID 4522 //
     /* 139317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139332 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 139332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 139335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139339 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139343 */     GIR_RootConstrainSelectedInstOperands,
     /* 139344 */     // GIR_Coverage, 4522,
     /* 139344 */     GIR_EraseRootFromParent_Done,
     /* 139345 */   // Label 2983: @139345
     /* 139345 */   GIM_Reject,
     /* 139346 */ // Label 2976: @139346
     /* 139346 */ GIM_Reject,
     /* 139347 */ // Label 2897: @139347
     /* 139347 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(139750),
     /* 139352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 139358 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 139361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139373 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(139406), // Rule ID 4555 //
     /* 139378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139385 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139391 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139395 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 139395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 139398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139400 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139402 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139404 */     GIR_RootConstrainSelectedInstOperands,
     /* 139405 */     // GIR_Coverage, 4555,
     /* 139405 */     GIR_EraseRootFromParent_Done,
     /* 139406 */   // Label 2985: @139406
     /* 139406 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(139543), // Rule ID 19787 //
     /* 139411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139424 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139428 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139428 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 139431 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139435 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139442 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139445 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139449 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139454 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 139457 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139461 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 139464 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139469 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139474 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 139482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 139507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 139518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139525 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139542 */     // GIR_Coverage, 19787,
     /* 139542 */     GIR_EraseRootFromParent_Done,
     /* 139543 */   // Label 2986: @139543
     /* 139543 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(139568), // Rule ID 4556 //
     /* 139548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139555 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 139555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 139558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139560 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139562 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139566 */     GIR_RootConstrainSelectedInstOperands,
     /* 139567 */     // GIR_Coverage, 4556,
     /* 139567 */     GIR_EraseRootFromParent_Done,
     /* 139568 */   // Label 2987: @139568
     /* 139568 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(139749), // Rule ID 19786 //
     /* 139573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139580 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139580 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 139583 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139587 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139594 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 139597 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139601 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139606 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139609 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139613 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139616 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139621 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139626 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139631 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 139634 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139638 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139643 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139647 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139652 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139655 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139659 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 139669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139678 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139685 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 139710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139718 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139721 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139731 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139748 */     // GIR_Coverage, 19786,
     /* 139748 */     GIR_EraseRootFromParent_Done,
     /* 139749 */   // Label 2988: @139749
     /* 139749 */   GIM_Reject,
     /* 139750 */ // Label 2984: @139750
     /* 139750 */ GIM_Reject,
     /* 139751 */ // Label 2898: @139751
     /* 139751 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(140168),
     /* 139756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 139762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 139765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139773 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(139844), // Rule ID 19847 //
     /* 139778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139789 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139796 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139800 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 139804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139808 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139814 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139825 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 139828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139830 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139842 */     GIR_RootConstrainSelectedInstOperands,
     /* 139843 */     // GIR_Coverage, 19847,
     /* 139843 */     GIR_EraseRootFromParent_Done,
     /* 139844 */   // Label 2990: @139844
     /* 139844 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(139911), // Rule ID 19849 //
     /* 139849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139875 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139892 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 139895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139897 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139909 */     GIR_RootConstrainSelectedInstOperands,
     /* 139910 */     // GIR_Coverage, 19849,
     /* 139910 */     GIR_EraseRootFromParent_Done,
     /* 139911 */   // Label 2991: @139911
     /* 139911 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(139975), // Rule ID 19846 //
     /* 139916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139927 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139930 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139934 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139938 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 139942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139955 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 139958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139960 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139962 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139973 */     GIR_RootConstrainSelectedInstOperands,
     /* 139974 */     // GIR_Coverage, 19846,
     /* 139974 */     GIR_EraseRootFromParent_Done,
     /* 139975 */   // Label 2992: @139975
     /* 139975 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(140035), // Rule ID 19848 //
     /* 139980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140015 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140020 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140022 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140033 */     GIR_RootConstrainSelectedInstOperands,
     /* 140034 */     // GIR_Coverage, 19848,
     /* 140034 */     GIR_EraseRootFromParent_Done,
     /* 140035 */   // Label 2993: @140035
     /* 140035 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(140072), // Rule ID 4563 //
     /* 140040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140051 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140057 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140061 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 140061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140066 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140070 */     GIR_RootConstrainSelectedInstOperands,
     /* 140071 */     // GIR_Coverage, 4563,
     /* 140071 */     GIR_EraseRootFromParent_Done,
     /* 140072 */   // Label 2994: @140072
     /* 140072 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(140109), // Rule ID 19845 //
     /* 140077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140088 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140094 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140098 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140103 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140107 */     GIR_RootConstrainSelectedInstOperands,
     /* 140108 */     // GIR_Coverage, 19845,
     /* 140108 */     GIR_EraseRootFromParent_Done,
     /* 140109 */   // Label 2995: @140109
     /* 140109 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(140138), // Rule ID 4564 //
     /* 140114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140125 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 140125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140130 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140132 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140136 */     GIR_RootConstrainSelectedInstOperands,
     /* 140137 */     // GIR_Coverage, 4564,
     /* 140137 */     GIR_EraseRootFromParent_Done,
     /* 140138 */   // Label 2996: @140138
     /* 140138 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(140167), // Rule ID 19844 //
     /* 140143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140154 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140159 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140161 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140163 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140165 */     GIR_RootConstrainSelectedInstOperands,
     /* 140166 */     // GIR_Coverage, 19844,
     /* 140166 */     GIR_EraseRootFromParent_Done,
     /* 140167 */   // Label 2997: @140167
     /* 140167 */   GIM_Reject,
     /* 140168 */ // Label 2989: @140168
     /* 140168 */ GIM_Reject,
     /* 140169 */ // Label 2899: @140169
     /* 140169 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(140254),
     /* 140174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 140177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 140180 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 140183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 140191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140195 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(140228), // Rule ID 4551 //
     /* 140200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140207 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140213 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140217 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 140217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 140220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140222 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140226 */     GIR_RootConstrainSelectedInstOperands,
     /* 140227 */     // GIR_Coverage, 4551,
     /* 140227 */     GIR_EraseRootFromParent_Done,
     /* 140228 */   // Label 2999: @140228
     /* 140228 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(140253), // Rule ID 4552 //
     /* 140233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140240 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 140240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 140243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140245 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140247 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140249 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140251 */     GIR_RootConstrainSelectedInstOperands,
     /* 140252 */     // GIR_Coverage, 4552,
     /* 140252 */     GIR_EraseRootFromParent_Done,
     /* 140253 */   // Label 3000: @140253
     /* 140253 */   GIM_Reject,
     /* 140254 */ // Label 2998: @140254
     /* 140254 */ GIM_Reject,
     /* 140255 */ // Label 2900: @140255
     /* 140255 */ GIM_Reject,
     /* 140256 */ // Label 35: @140256
     /* 140256 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3004*/ GIMT_Encode4(141120),
     /* 140267 */ /*GILLT_v8s16*//*Label 3001*/ GIMT_Encode4(140307), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140287 */ /*GILLT_v16s16*//*Label 3002*/ GIMT_Encode4(140649), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140303 */ /*GILLT_v32s16*//*Label 3003*/ GIMT_Encode4(140964),
     /* 140307 */ // Label 3001: @140307
     /* 140307 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(140648),
     /* 140312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140318 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(140380), // Rule ID 23456 //
     /* 140323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140362 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140378 */     GIR_RootConstrainSelectedInstOperands,
     /* 140379 */     // GIR_Coverage, 23456,
     /* 140379 */     GIR_EraseRootFromParent_Done,
     /* 140380 */   // Label 3006: @140380
     /* 140380 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(140442), // Rule ID 23846 //
     /* 140385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140424 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140440 */     GIR_RootConstrainSelectedInstOperands,
     /* 140441 */     // GIR_Coverage, 23846,
     /* 140441 */     GIR_EraseRootFromParent_Done,
     /* 140442 */   // Label 3007: @140442
     /* 140442 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(140504), // Rule ID 2577 //
     /* 140447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140486 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140502 */     GIR_RootConstrainSelectedInstOperands,
     /* 140503 */     // GIR_Coverage, 2577,
     /* 140503 */     GIR_EraseRootFromParent_Done,
     /* 140504 */   // Label 3008: @140504
     /* 140504 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(140566), // Rule ID 5062 //
     /* 140509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140528 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140548 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140564 */     GIR_RootConstrainSelectedInstOperands,
     /* 140565 */     // GIR_Coverage, 5062,
     /* 140565 */     GIR_EraseRootFromParent_Done,
     /* 140566 */   // Label 3009: @140566
     /* 140566 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(140593), // Rule ID 2576 //
     /* 140571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140586 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 140591 */     GIR_RootConstrainSelectedInstOperands,
     /* 140592 */     // GIR_Coverage, 2576,
     /* 140592 */     GIR_Done,
     /* 140593 */   // Label 3010: @140593
     /* 140593 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(140620), // Rule ID 2578 //
     /* 140598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 140601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140613 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 140618 */     GIR_RootConstrainSelectedInstOperands,
     /* 140619 */     // GIR_Coverage, 2578,
     /* 140619 */     GIR_Done,
     /* 140620 */   // Label 3011: @140620
     /* 140620 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(140647), // Rule ID 5059 //
     /* 140625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140640 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 140640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 140645 */     GIR_RootConstrainSelectedInstOperands,
     /* 140646 */     // GIR_Coverage, 5059,
     /* 140646 */     GIR_Done,
     /* 140647 */   // Label 3012: @140647
     /* 140647 */   GIM_Reject,
     /* 140648 */ // Label 3005: @140648
     /* 140648 */ GIM_Reject,
     /* 140649 */ // Label 3002: @140649
     /* 140649 */ GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(140963),
     /* 140654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 140657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 140660 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(140722), // Rule ID 23458 //
     /* 140665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140680 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140704 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140720 */     GIR_RootConstrainSelectedInstOperands,
     /* 140721 */     // GIR_Coverage, 23458,
     /* 140721 */     GIR_EraseRootFromParent_Done,
     /* 140722 */   // Label 3014: @140722
     /* 140722 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(140784), // Rule ID 23843 //
     /* 140727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140766 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140771 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140773 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140782 */     GIR_RootConstrainSelectedInstOperands,
     /* 140783 */     // GIR_Coverage, 23843,
     /* 140783 */     GIR_EraseRootFromParent_Done,
     /* 140784 */   // Label 3015: @140784
     /* 140784 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(140846), // Rule ID 2581 //
     /* 140789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140828 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140844 */     GIR_RootConstrainSelectedInstOperands,
     /* 140845 */     // GIR_Coverage, 2581,
     /* 140845 */     GIR_EraseRootFromParent_Done,
     /* 140846 */   // Label 3016: @140846
     /* 140846 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(140908), // Rule ID 5056 //
     /* 140851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140890 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140906 */     GIR_RootConstrainSelectedInstOperands,
     /* 140907 */     // GIR_Coverage, 5056,
     /* 140907 */     GIR_EraseRootFromParent_Done,
     /* 140908 */   // Label 3017: @140908
     /* 140908 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(140935), // Rule ID 2580 //
     /* 140913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140928 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 140928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 140933 */     GIR_RootConstrainSelectedInstOperands,
     /* 140934 */     // GIR_Coverage, 2580,
     /* 140934 */     GIR_Done,
     /* 140935 */   // Label 3018: @140935
     /* 140935 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(140962), // Rule ID 5053 //
     /* 140940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140955 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 140955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 140960 */     GIR_RootConstrainSelectedInstOperands,
     /* 140961 */     // GIR_Coverage, 5053,
     /* 140961 */     GIR_Done,
     /* 140962 */   // Label 3019: @140962
     /* 140962 */   GIM_Reject,
     /* 140963 */ // Label 3013: @140963
     /* 140963 */ GIM_Reject,
     /* 140964 */ // Label 3003: @140964
     /* 140964 */ GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(141119),
     /* 140969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 140972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 140975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140979 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(141037), // Rule ID 23840 //
     /* 140984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140995 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141019 */     // (mulhu:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141035 */     GIR_RootConstrainSelectedInstOperands,
     /* 141036 */     // GIR_Coverage, 23840,
     /* 141036 */     GIR_EraseRootFromParent_Done,
     /* 141037 */   // Label 3021: @141037
     /* 141037 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(141095), // Rule ID 5050 //
     /* 141042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141077 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141093 */     GIR_RootConstrainSelectedInstOperands,
     /* 141094 */     // GIR_Coverage, 5050,
     /* 141094 */     GIR_EraseRootFromParent_Done,
     /* 141095 */   // Label 3022: @141095
     /* 141095 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(141118), // Rule ID 5047 //
     /* 141100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141111 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 141116 */     GIR_RootConstrainSelectedInstOperands,
     /* 141117 */     // GIR_Coverage, 5047,
     /* 141117 */     GIR_Done,
     /* 141118 */   // Label 3023: @141118
     /* 141118 */   GIM_Reject,
     /* 141119 */ // Label 3020: @141119
     /* 141119 */ GIM_Reject,
     /* 141120 */ // Label 3004: @141120
     /* 141120 */ GIM_Reject,
     /* 141121 */ // Label 36: @141121
     /* 141121 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3027*/ GIMT_Encode4(141985),
     /* 141132 */ /*GILLT_v8s16*//*Label 3024*/ GIMT_Encode4(141172), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141152 */ /*GILLT_v16s16*//*Label 3025*/ GIMT_Encode4(141514), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141168 */ /*GILLT_v32s16*//*Label 3026*/ GIMT_Encode4(141829),
     /* 141172 */ // Label 3024: @141172
     /* 141172 */ GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(141513),
     /* 141177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 141180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141183 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(141245), // Rule ID 23459 //
     /* 141188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141227 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141243 */     GIR_RootConstrainSelectedInstOperands,
     /* 141244 */     // GIR_Coverage, 23459,
     /* 141244 */     GIR_EraseRootFromParent_Done,
     /* 141245 */   // Label 3029: @141245
     /* 141245 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(141307), // Rule ID 23837 //
     /* 141250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141289 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141294 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141305 */     GIR_RootConstrainSelectedInstOperands,
     /* 141306 */     // GIR_Coverage, 23837,
     /* 141306 */     GIR_EraseRootFromParent_Done,
     /* 141307 */   // Label 3030: @141307
     /* 141307 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(141369), // Rule ID 2583 //
     /* 141312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141351 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141367 */     GIR_RootConstrainSelectedInstOperands,
     /* 141368 */     // GIR_Coverage, 2583,
     /* 141368 */     GIR_EraseRootFromParent_Done,
     /* 141369 */   // Label 3031: @141369
     /* 141369 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(141431), // Rule ID 5044 //
     /* 141374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141393 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141396 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141400 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141413 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141429 */     GIR_RootConstrainSelectedInstOperands,
     /* 141430 */     // GIR_Coverage, 5044,
     /* 141430 */     GIR_EraseRootFromParent_Done,
     /* 141431 */   // Label 3032: @141431
     /* 141431 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(141458), // Rule ID 2582 //
     /* 141436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141451 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 141456 */     GIR_RootConstrainSelectedInstOperands,
     /* 141457 */     // GIR_Coverage, 2582,
     /* 141457 */     GIR_Done,
     /* 141458 */   // Label 3033: @141458
     /* 141458 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(141485), // Rule ID 2584 //
     /* 141463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 141466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141478 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 141483 */     GIR_RootConstrainSelectedInstOperands,
     /* 141484 */     // GIR_Coverage, 2584,
     /* 141484 */     GIR_Done,
     /* 141485 */   // Label 3034: @141485
     /* 141485 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(141512), // Rule ID 5041 //
     /* 141490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141505 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 141505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 141510 */     GIR_RootConstrainSelectedInstOperands,
     /* 141511 */     // GIR_Coverage, 5041,
     /* 141511 */     GIR_Done,
     /* 141512 */   // Label 3035: @141512
     /* 141512 */   GIM_Reject,
     /* 141513 */ // Label 3028: @141513
     /* 141513 */ GIM_Reject,
     /* 141514 */ // Label 3025: @141514
     /* 141514 */ GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(141828),
     /* 141519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 141522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 141525 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(141587), // Rule ID 23461 //
     /* 141530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141569 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141585 */     GIR_RootConstrainSelectedInstOperands,
     /* 141586 */     // GIR_Coverage, 23461,
     /* 141586 */     GIR_EraseRootFromParent_Done,
     /* 141587 */   // Label 3037: @141587
     /* 141587 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(141649), // Rule ID 23834 //
     /* 141592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141631 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141647 */     GIR_RootConstrainSelectedInstOperands,
     /* 141648 */     // GIR_Coverage, 23834,
     /* 141648 */     GIR_EraseRootFromParent_Done,
     /* 141649 */   // Label 3038: @141649
     /* 141649 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(141711), // Rule ID 2587 //
     /* 141654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141673 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141676 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141693 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141709 */     GIR_RootConstrainSelectedInstOperands,
     /* 141710 */     // GIR_Coverage, 2587,
     /* 141710 */     GIR_EraseRootFromParent_Done,
     /* 141711 */   // Label 3039: @141711
     /* 141711 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(141773), // Rule ID 5038 //
     /* 141716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141755 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141762 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141771 */     GIR_RootConstrainSelectedInstOperands,
     /* 141772 */     // GIR_Coverage, 5038,
     /* 141772 */     GIR_EraseRootFromParent_Done,
     /* 141773 */   // Label 3040: @141773
     /* 141773 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(141800), // Rule ID 2586 //
     /* 141778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141793 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 141793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 141798 */     GIR_RootConstrainSelectedInstOperands,
     /* 141799 */     // GIR_Coverage, 2586,
     /* 141799 */     GIR_Done,
     /* 141800 */   // Label 3041: @141800
     /* 141800 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(141827), // Rule ID 5035 //
     /* 141805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141820 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 141820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 141825 */     GIR_RootConstrainSelectedInstOperands,
     /* 141826 */     // GIR_Coverage, 5035,
     /* 141826 */     GIR_Done,
     /* 141827 */   // Label 3042: @141827
     /* 141827 */   GIM_Reject,
     /* 141828 */ // Label 3036: @141828
     /* 141828 */ GIM_Reject,
     /* 141829 */ // Label 3026: @141829
     /* 141829 */ GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(141984),
     /* 141834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 141837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 141840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141844 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(141902), // Rule ID 23831 //
     /* 141849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141884 */     // (mulhs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 141887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141889 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141900 */     GIR_RootConstrainSelectedInstOperands,
     /* 141901 */     // GIR_Coverage, 23831,
     /* 141901 */     GIR_EraseRootFromParent_Done,
     /* 141902 */   // Label 3044: @141902
     /* 141902 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(141960), // Rule ID 5032 //
     /* 141907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141922 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141925 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141929 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141942 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 141945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141958 */     GIR_RootConstrainSelectedInstOperands,
     /* 141959 */     // GIR_Coverage, 5032,
     /* 141959 */     GIR_EraseRootFromParent_Done,
     /* 141960 */   // Label 3045: @141960
     /* 141960 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(141983), // Rule ID 5029 //
     /* 141965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141976 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 141981 */     GIR_RootConstrainSelectedInstOperands,
     /* 141982 */     // GIR_Coverage, 5029,
     /* 141982 */     GIR_Done,
     /* 141983 */   // Label 3046: @141983
     /* 141983 */   GIM_Reject,
     /* 141984 */ // Label 3043: @141984
     /* 141984 */ GIM_Reject,
     /* 141985 */ // Label 3027: @141985
     /* 141985 */ GIM_Reject,
     /* 141986 */ // Label 37: @141986
     /* 141986 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3053*/ GIMT_Encode4(143671),
     /* 141997 */ /*GILLT_v8s16*//*Label 3047*/ GIMT_Encode4(142045), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142013 */ /*GILLT_v16s8*//*Label 3048*/ GIMT_Encode4(142387),
     /* 142017 */ /*GILLT_v16s16*//*Label 3049*/ GIMT_Encode4(142729), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142029 */ /*GILLT_v32s8*//*Label 3050*/ GIMT_Encode4(143044),
     /* 142033 */ /*GILLT_v32s16*//*Label 3051*/ GIMT_Encode4(143359), GIMT_Encode4(0),
     /* 142041 */ /*GILLT_v64s8*//*Label 3052*/ GIMT_Encode4(143515),
     /* 142045 */ // Label 3047: @142045
     /* 142045 */ GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(142386),
     /* 142050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 142053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142056 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(142118), // Rule ID 23450 //
     /* 142061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142100 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142116 */     GIR_RootConstrainSelectedInstOperands,
     /* 142117 */     // GIR_Coverage, 23450,
     /* 142117 */     GIR_EraseRootFromParent_Done,
     /* 142118 */   // Label 3055: @142118
     /* 142118 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(142180), // Rule ID 23774 //
     /* 142123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142162 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142167 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142178 */     GIR_RootConstrainSelectedInstOperands,
     /* 142179 */     // GIR_Coverage, 23774,
     /* 142179 */     GIR_EraseRootFromParent_Done,
     /* 142180 */   // Label 3056: @142180
     /* 142180 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(142242), // Rule ID 2565 //
     /* 142185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142224 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142240 */     GIR_RootConstrainSelectedInstOperands,
     /* 142241 */     // GIR_Coverage, 2565,
     /* 142241 */     GIR_EraseRootFromParent_Done,
     /* 142242 */   // Label 3057: @142242
     /* 142242 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(142304), // Rule ID 4900 //
     /* 142247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142286 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142302 */     GIR_RootConstrainSelectedInstOperands,
     /* 142303 */     // GIR_Coverage, 4900,
     /* 142303 */     GIR_EraseRootFromParent_Done,
     /* 142304 */   // Label 3058: @142304
     /* 142304 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(142331), // Rule ID 2564 //
     /* 142309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142324 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 142329 */     GIR_RootConstrainSelectedInstOperands,
     /* 142330 */     // GIR_Coverage, 2564,
     /* 142330 */     GIR_Done,
     /* 142331 */   // Label 3059: @142331
     /* 142331 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(142358), // Rule ID 2566 //
     /* 142336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142351 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 142356 */     GIR_RootConstrainSelectedInstOperands,
     /* 142357 */     // GIR_Coverage, 2566,
     /* 142357 */     GIR_Done,
     /* 142358 */   // Label 3060: @142358
     /* 142358 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(142385), // Rule ID 4897 //
     /* 142363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142378 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 142378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 142383 */     GIR_RootConstrainSelectedInstOperands,
     /* 142384 */     // GIR_Coverage, 4897,
     /* 142384 */     GIR_Done,
     /* 142385 */   // Label 3061: @142385
     /* 142385 */   GIM_Reject,
     /* 142386 */ // Label 3054: @142386
     /* 142386 */ GIM_Reject,
     /* 142387 */ // Label 3048: @142387
     /* 142387 */ GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(142728),
     /* 142392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 142395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142398 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(142460), // Rule ID 23447 //
     /* 142403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142442 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142447 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142458 */     GIR_RootConstrainSelectedInstOperands,
     /* 142459 */     // GIR_Coverage, 23447,
     /* 142459 */     GIR_EraseRootFromParent_Done,
     /* 142460 */   // Label 3063: @142460
     /* 142460 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(142522), // Rule ID 23783 //
     /* 142465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142504 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142520 */     GIR_RootConstrainSelectedInstOperands,
     /* 142521 */     // GIR_Coverage, 23783,
     /* 142521 */     GIR_EraseRootFromParent_Done,
     /* 142522 */   // Label 3064: @142522
     /* 142522 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(142584), // Rule ID 2559 //
     /* 142527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142566 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142582 */     GIR_RootConstrainSelectedInstOperands,
     /* 142583 */     // GIR_Coverage, 2559,
     /* 142583 */     GIR_EraseRootFromParent_Done,
     /* 142584 */   // Label 3065: @142584
     /* 142584 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(142646), // Rule ID 4918 //
     /* 142589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142628 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142644 */     GIR_RootConstrainSelectedInstOperands,
     /* 142645 */     // GIR_Coverage, 4918,
     /* 142645 */     GIR_EraseRootFromParent_Done,
     /* 142646 */   // Label 3066: @142646
     /* 142646 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(142673), // Rule ID 2558 //
     /* 142651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142666 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 142671 */     GIR_RootConstrainSelectedInstOperands,
     /* 142672 */     // GIR_Coverage, 2558,
     /* 142672 */     GIR_Done,
     /* 142673 */   // Label 3067: @142673
     /* 142673 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(142700), // Rule ID 2560 //
     /* 142678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142693 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 142698 */     GIR_RootConstrainSelectedInstOperands,
     /* 142699 */     // GIR_Coverage, 2560,
     /* 142699 */     GIR_Done,
     /* 142700 */   // Label 3068: @142700
     /* 142700 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(142727), // Rule ID 4915 //
     /* 142705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142720 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 142720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 142725 */     GIR_RootConstrainSelectedInstOperands,
     /* 142726 */     // GIR_Coverage, 4915,
     /* 142726 */     GIR_Done,
     /* 142727 */   // Label 3069: @142727
     /* 142727 */   GIM_Reject,
     /* 142728 */ // Label 3062: @142728
     /* 142728 */ GIM_Reject,
     /* 142729 */ // Label 3049: @142729
     /* 142729 */ GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(143043),
     /* 142734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 142737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 142740 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(142802), // Rule ID 23452 //
     /* 142745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142784 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142800 */     GIR_RootConstrainSelectedInstOperands,
     /* 142801 */     // GIR_Coverage, 23452,
     /* 142801 */     GIR_EraseRootFromParent_Done,
     /* 142802 */   // Label 3071: @142802
     /* 142802 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(142864), // Rule ID 23771 //
     /* 142807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142846 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 142849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142851 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142862 */     GIR_RootConstrainSelectedInstOperands,
     /* 142863 */     // GIR_Coverage, 23771,
     /* 142863 */     GIR_EraseRootFromParent_Done,
     /* 142864 */   // Label 3072: @142864
     /* 142864 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(142926), // Rule ID 2569 //
     /* 142869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142908 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142924 */     GIR_RootConstrainSelectedInstOperands,
     /* 142925 */     // GIR_Coverage, 2569,
     /* 142925 */     GIR_EraseRootFromParent_Done,
     /* 142926 */   // Label 3073: @142926
     /* 142926 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(142988), // Rule ID 4894 //
     /* 142931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142970 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 142973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142975 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142986 */     GIR_RootConstrainSelectedInstOperands,
     /* 142987 */     // GIR_Coverage, 4894,
     /* 142987 */     GIR_EraseRootFromParent_Done,
     /* 142988 */   // Label 3074: @142988
     /* 142988 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(143015), // Rule ID 2568 //
     /* 142993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143008 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 143008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 143013 */     GIR_RootConstrainSelectedInstOperands,
     /* 143014 */     // GIR_Coverage, 2568,
     /* 143014 */     GIR_Done,
     /* 143015 */   // Label 3075: @143015
     /* 143015 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(143042), // Rule ID 4891 //
     /* 143020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143035 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 143035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 143040 */     GIR_RootConstrainSelectedInstOperands,
     /* 143041 */     // GIR_Coverage, 4891,
     /* 143041 */     GIR_Done,
     /* 143042 */   // Label 3076: @143042
     /* 143042 */   GIM_Reject,
     /* 143043 */ // Label 3070: @143043
     /* 143043 */ GIM_Reject,
     /* 143044 */ // Label 3050: @143044
     /* 143044 */ GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(143358),
     /* 143049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 143052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 143055 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(143117), // Rule ID 23449 //
     /* 143060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143099 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143115 */     GIR_RootConstrainSelectedInstOperands,
     /* 143116 */     // GIR_Coverage, 23449,
     /* 143116 */     GIR_EraseRootFromParent_Done,
     /* 143117 */   // Label 3078: @143117
     /* 143117 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(143179), // Rule ID 23780 //
     /* 143122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143161 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143177 */     GIR_RootConstrainSelectedInstOperands,
     /* 143178 */     // GIR_Coverage, 23780,
     /* 143178 */     GIR_EraseRootFromParent_Done,
     /* 143179 */   // Label 3079: @143179
     /* 143179 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(143241), // Rule ID 2563 //
     /* 143184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143223 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143239 */     GIR_RootConstrainSelectedInstOperands,
     /* 143240 */     // GIR_Coverage, 2563,
     /* 143240 */     GIR_EraseRootFromParent_Done,
     /* 143241 */   // Label 3080: @143241
     /* 143241 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(143303), // Rule ID 4912 //
     /* 143246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143285 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143301 */     GIR_RootConstrainSelectedInstOperands,
     /* 143302 */     // GIR_Coverage, 4912,
     /* 143302 */     GIR_EraseRootFromParent_Done,
     /* 143303 */   // Label 3081: @143303
     /* 143303 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(143330), // Rule ID 2562 //
     /* 143308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143323 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 143323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 143328 */     GIR_RootConstrainSelectedInstOperands,
     /* 143329 */     // GIR_Coverage, 2562,
     /* 143329 */     GIR_Done,
     /* 143330 */   // Label 3082: @143330
     /* 143330 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(143357), // Rule ID 4909 //
     /* 143335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143350 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 143350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 143355 */     GIR_RootConstrainSelectedInstOperands,
     /* 143356 */     // GIR_Coverage, 4909,
     /* 143356 */     GIR_Done,
     /* 143357 */   // Label 3083: @143357
     /* 143357 */   GIM_Reject,
     /* 143358 */ // Label 3077: @143358
     /* 143358 */ GIM_Reject,
     /* 143359 */ // Label 3051: @143359
     /* 143359 */ GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(143514),
     /* 143364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 143367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 143370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143374 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(143432), // Rule ID 23768 //
     /* 143379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143397 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143414 */     // (uaddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143419 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143430 */     GIR_RootConstrainSelectedInstOperands,
     /* 143431 */     // GIR_Coverage, 23768,
     /* 143431 */     GIR_EraseRootFromParent_Done,
     /* 143432 */   // Label 3085: @143432
     /* 143432 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(143490), // Rule ID 4888 //
     /* 143437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143472 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143488 */     GIR_RootConstrainSelectedInstOperands,
     /* 143489 */     // GIR_Coverage, 4888,
     /* 143489 */     GIR_EraseRootFromParent_Done,
     /* 143490 */   // Label 3086: @143490
     /* 143490 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(143513), // Rule ID 4885 //
     /* 143495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143506 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 143506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 143511 */     GIR_RootConstrainSelectedInstOperands,
     /* 143512 */     // GIR_Coverage, 4885,
     /* 143512 */     GIR_Done,
     /* 143513 */   // Label 3087: @143513
     /* 143513 */   GIM_Reject,
     /* 143514 */ // Label 3084: @143514
     /* 143514 */ GIM_Reject,
     /* 143515 */ // Label 3052: @143515
     /* 143515 */ GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(143670),
     /* 143520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 143523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 143526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143530 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(143588), // Rule ID 23777 //
     /* 143535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143570 */     // (uaddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143575 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143586 */     GIR_RootConstrainSelectedInstOperands,
     /* 143587 */     // GIR_Coverage, 23777,
     /* 143587 */     GIR_EraseRootFromParent_Done,
     /* 143588 */   // Label 3089: @143588
     /* 143588 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(143646), // Rule ID 4906 //
     /* 143593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143628 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143644 */     GIR_RootConstrainSelectedInstOperands,
     /* 143645 */     // GIR_Coverage, 4906,
     /* 143645 */     GIR_EraseRootFromParent_Done,
     /* 143646 */   // Label 3090: @143646
     /* 143646 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(143669), // Rule ID 4903 //
     /* 143651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143662 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 143662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 143667 */     GIR_RootConstrainSelectedInstOperands,
     /* 143668 */     // GIR_Coverage, 4903,
     /* 143668 */     GIR_Done,
     /* 143669 */   // Label 3091: @143669
     /* 143669 */   GIM_Reject,
     /* 143670 */ // Label 3088: @143670
     /* 143670 */ GIM_Reject,
     /* 143671 */ // Label 3053: @143671
     /* 143671 */ GIM_Reject,
     /* 143672 */ // Label 38: @143672
     /* 143672 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3098*/ GIMT_Encode4(145357),
     /* 143683 */ /*GILLT_v8s16*//*Label 3092*/ GIMT_Encode4(143731), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143699 */ /*GILLT_v16s8*//*Label 3093*/ GIMT_Encode4(144073),
     /* 143703 */ /*GILLT_v16s16*//*Label 3094*/ GIMT_Encode4(144415), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143715 */ /*GILLT_v32s8*//*Label 3095*/ GIMT_Encode4(144730),
     /* 143719 */ /*GILLT_v32s16*//*Label 3096*/ GIMT_Encode4(145045), GIMT_Encode4(0),
     /* 143727 */ /*GILLT_v64s8*//*Label 3097*/ GIMT_Encode4(145201),
     /* 143731 */ // Label 3092: @143731
     /* 143731 */ GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(144072),
     /* 143736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 143739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143742 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(143804), // Rule ID 23444 //
     /* 143747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143762 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143786 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 143789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143802 */     GIR_RootConstrainSelectedInstOperands,
     /* 143803 */     // GIR_Coverage, 23444,
     /* 143803 */     GIR_EraseRootFromParent_Done,
     /* 143804 */   // Label 3100: @143804
     /* 143804 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(143866), // Rule ID 23756 //
     /* 143809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143824 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143827 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143831 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143848 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 143851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143864 */     GIR_RootConstrainSelectedInstOperands,
     /* 143865 */     // GIR_Coverage, 23756,
     /* 143865 */     GIR_EraseRootFromParent_Done,
     /* 143866 */   // Label 3101: @143866
     /* 143866 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(143928), // Rule ID 2553 //
     /* 143871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143890 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143893 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143897 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143910 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 143913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143915 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143926 */     GIR_RootConstrainSelectedInstOperands,
     /* 143927 */     // GIR_Coverage, 2553,
     /* 143927 */     GIR_EraseRootFromParent_Done,
     /* 143928 */   // Label 3102: @143928
     /* 143928 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(143990), // Rule ID 4828 //
     /* 143933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143972 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 143975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143977 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143988 */     GIR_RootConstrainSelectedInstOperands,
     /* 143989 */     // GIR_Coverage, 4828,
     /* 143989 */     GIR_EraseRootFromParent_Done,
     /* 143990 */   // Label 3103: @143990
     /* 143990 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(144017), // Rule ID 2552 //
     /* 143995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144010 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 144015 */     GIR_RootConstrainSelectedInstOperands,
     /* 144016 */     // GIR_Coverage, 2552,
     /* 144016 */     GIR_Done,
     /* 144017 */   // Label 3104: @144017
     /* 144017 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(144044), // Rule ID 2554 //
     /* 144022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144037 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 144042 */     GIR_RootConstrainSelectedInstOperands,
     /* 144043 */     // GIR_Coverage, 2554,
     /* 144043 */     GIR_Done,
     /* 144044 */   // Label 3105: @144044
     /* 144044 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(144071), // Rule ID 4825 //
     /* 144049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144064 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 144064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 144069 */     GIR_RootConstrainSelectedInstOperands,
     /* 144070 */     // GIR_Coverage, 4825,
     /* 144070 */     GIR_Done,
     /* 144071 */   // Label 3106: @144071
     /* 144071 */   GIM_Reject,
     /* 144072 */ // Label 3099: @144072
     /* 144072 */ GIM_Reject,
     /* 144073 */ // Label 3093: @144073
     /* 144073 */ GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(144414),
     /* 144078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 144081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144084 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(144146), // Rule ID 23441 //
     /* 144089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144128 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144144 */     GIR_RootConstrainSelectedInstOperands,
     /* 144145 */     // GIR_Coverage, 23441,
     /* 144145 */     GIR_EraseRootFromParent_Done,
     /* 144146 */   // Label 3108: @144146
     /* 144146 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(144208), // Rule ID 23765 //
     /* 144151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144190 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144206 */     GIR_RootConstrainSelectedInstOperands,
     /* 144207 */     // GIR_Coverage, 23765,
     /* 144207 */     GIR_EraseRootFromParent_Done,
     /* 144208 */   // Label 3109: @144208
     /* 144208 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(144270), // Rule ID 2547 //
     /* 144213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144252 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144268 */     GIR_RootConstrainSelectedInstOperands,
     /* 144269 */     // GIR_Coverage, 2547,
     /* 144269 */     GIR_EraseRootFromParent_Done,
     /* 144270 */   // Label 3110: @144270
     /* 144270 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(144332), // Rule ID 4846 //
     /* 144275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144314 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144330 */     GIR_RootConstrainSelectedInstOperands,
     /* 144331 */     // GIR_Coverage, 4846,
     /* 144331 */     GIR_EraseRootFromParent_Done,
     /* 144332 */   // Label 3111: @144332
     /* 144332 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(144359), // Rule ID 2546 //
     /* 144337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144352 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 144357 */     GIR_RootConstrainSelectedInstOperands,
     /* 144358 */     // GIR_Coverage, 2546,
     /* 144358 */     GIR_Done,
     /* 144359 */   // Label 3112: @144359
     /* 144359 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(144386), // Rule ID 2548 //
     /* 144364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144379 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 144384 */     GIR_RootConstrainSelectedInstOperands,
     /* 144385 */     // GIR_Coverage, 2548,
     /* 144385 */     GIR_Done,
     /* 144386 */   // Label 3113: @144386
     /* 144386 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(144413), // Rule ID 4843 //
     /* 144391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144406 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 144406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 144411 */     GIR_RootConstrainSelectedInstOperands,
     /* 144412 */     // GIR_Coverage, 4843,
     /* 144412 */     GIR_Done,
     /* 144413 */   // Label 3114: @144413
     /* 144413 */   GIM_Reject,
     /* 144414 */ // Label 3107: @144414
     /* 144414 */ GIM_Reject,
     /* 144415 */ // Label 3094: @144415
     /* 144415 */ GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(144729),
     /* 144420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 144423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 144426 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(144488), // Rule ID 23446 //
     /* 144431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144470 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144486 */     GIR_RootConstrainSelectedInstOperands,
     /* 144487 */     // GIR_Coverage, 23446,
     /* 144487 */     GIR_EraseRootFromParent_Done,
     /* 144488 */   // Label 3116: @144488
     /* 144488 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(144550), // Rule ID 23753 //
     /* 144493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144532 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144548 */     GIR_RootConstrainSelectedInstOperands,
     /* 144549 */     // GIR_Coverage, 23753,
     /* 144549 */     GIR_EraseRootFromParent_Done,
     /* 144550 */   // Label 3117: @144550
     /* 144550 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(144612), // Rule ID 2557 //
     /* 144555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144594 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144610 */     GIR_RootConstrainSelectedInstOperands,
     /* 144611 */     // GIR_Coverage, 2557,
     /* 144611 */     GIR_EraseRootFromParent_Done,
     /* 144612 */   // Label 3118: @144612
     /* 144612 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(144674), // Rule ID 4822 //
     /* 144617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144656 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144672 */     GIR_RootConstrainSelectedInstOperands,
     /* 144673 */     // GIR_Coverage, 4822,
     /* 144673 */     GIR_EraseRootFromParent_Done,
     /* 144674 */   // Label 3119: @144674
     /* 144674 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(144701), // Rule ID 2556 //
     /* 144679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144694 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 144694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 144699 */     GIR_RootConstrainSelectedInstOperands,
     /* 144700 */     // GIR_Coverage, 2556,
     /* 144700 */     GIR_Done,
     /* 144701 */   // Label 3120: @144701
     /* 144701 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(144728), // Rule ID 4819 //
     /* 144706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144721 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 144721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 144726 */     GIR_RootConstrainSelectedInstOperands,
     /* 144727 */     // GIR_Coverage, 4819,
     /* 144727 */     GIR_Done,
     /* 144728 */   // Label 3121: @144728
     /* 144728 */   GIM_Reject,
     /* 144729 */ // Label 3115: @144729
     /* 144729 */ GIM_Reject,
     /* 144730 */ // Label 3095: @144730
     /* 144730 */ GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(145044),
     /* 144735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 144738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 144741 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(144803), // Rule ID 23443 //
     /* 144746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144785 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 144788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144801 */     GIR_RootConstrainSelectedInstOperands,
     /* 144802 */     // GIR_Coverage, 23443,
     /* 144802 */     GIR_EraseRootFromParent_Done,
     /* 144803 */   // Label 3123: @144803
     /* 144803 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(144865), // Rule ID 23762 //
     /* 144808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144847 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 144850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144863 */     GIR_RootConstrainSelectedInstOperands,
     /* 144864 */     // GIR_Coverage, 23762,
     /* 144864 */     GIR_EraseRootFromParent_Done,
     /* 144865 */   // Label 3124: @144865
     /* 144865 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(144927), // Rule ID 2551 //
     /* 144870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144909 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 144912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144925 */     GIR_RootConstrainSelectedInstOperands,
     /* 144926 */     // GIR_Coverage, 2551,
     /* 144926 */     GIR_EraseRootFromParent_Done,
     /* 144927 */   // Label 3125: @144927
     /* 144927 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(144989), // Rule ID 4840 //
     /* 144932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144971 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 144974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144976 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144987 */     GIR_RootConstrainSelectedInstOperands,
     /* 144988 */     // GIR_Coverage, 4840,
     /* 144988 */     GIR_EraseRootFromParent_Done,
     /* 144989 */   // Label 3126: @144989
     /* 144989 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(145016), // Rule ID 2550 //
     /* 144994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145009 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 145009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 145014 */     GIR_RootConstrainSelectedInstOperands,
     /* 145015 */     // GIR_Coverage, 2550,
     /* 145015 */     GIR_Done,
     /* 145016 */   // Label 3127: @145016
     /* 145016 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(145043), // Rule ID 4837 //
     /* 145021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145036 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 145036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 145041 */     GIR_RootConstrainSelectedInstOperands,
     /* 145042 */     // GIR_Coverage, 4837,
     /* 145042 */     GIR_Done,
     /* 145043 */   // Label 3128: @145043
     /* 145043 */   GIM_Reject,
     /* 145044 */ // Label 3122: @145044
     /* 145044 */ GIM_Reject,
     /* 145045 */ // Label 3096: @145045
     /* 145045 */ GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(145200),
     /* 145050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 145053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 145056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145060 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(145118), // Rule ID 23750 //
     /* 145065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145100 */     // (saddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145116 */     GIR_RootConstrainSelectedInstOperands,
     /* 145117 */     // GIR_Coverage, 23750,
     /* 145117 */     GIR_EraseRootFromParent_Done,
     /* 145118 */   // Label 3130: @145118
     /* 145118 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(145176), // Rule ID 4816 //
     /* 145123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145158 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145174 */     GIR_RootConstrainSelectedInstOperands,
     /* 145175 */     // GIR_Coverage, 4816,
     /* 145175 */     GIR_EraseRootFromParent_Done,
     /* 145176 */   // Label 3131: @145176
     /* 145176 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(145199), // Rule ID 4813 //
     /* 145181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145192 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 145192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 145197 */     GIR_RootConstrainSelectedInstOperands,
     /* 145198 */     // GIR_Coverage, 4813,
     /* 145198 */     GIR_Done,
     /* 145199 */   // Label 3132: @145199
     /* 145199 */   GIM_Reject,
     /* 145200 */ // Label 3129: @145200
     /* 145200 */ GIM_Reject,
     /* 145201 */ // Label 3097: @145201
     /* 145201 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(145356),
     /* 145206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 145209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 145212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145216 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(145274), // Rule ID 23759 //
     /* 145221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145256 */     // (saddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145272 */     GIR_RootConstrainSelectedInstOperands,
     /* 145273 */     // GIR_Coverage, 23759,
     /* 145273 */     GIR_EraseRootFromParent_Done,
     /* 145274 */   // Label 3134: @145274
     /* 145274 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(145332), // Rule ID 4834 //
     /* 145279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145314 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145330 */     GIR_RootConstrainSelectedInstOperands,
     /* 145331 */     // GIR_Coverage, 4834,
     /* 145331 */     GIR_EraseRootFromParent_Done,
     /* 145332 */   // Label 3135: @145332
     /* 145332 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(145355), // Rule ID 4831 //
     /* 145337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145348 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 145348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 145353 */     GIR_RootConstrainSelectedInstOperands,
     /* 145354 */     // GIR_Coverage, 4831,
     /* 145354 */     GIR_Done,
     /* 145355 */   // Label 3136: @145355
     /* 145355 */   GIM_Reject,
     /* 145356 */ // Label 3133: @145356
     /* 145356 */ GIM_Reject,
     /* 145357 */ // Label 3098: @145357
     /* 145357 */ GIM_Reject,
     /* 145358 */ // Label 39: @145358
     /* 145358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3143*/ GIMT_Encode4(146423),
     /* 145369 */ /*GILLT_v8s16*//*Label 3137*/ GIMT_Encode4(145417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145385 */ /*GILLT_v16s8*//*Label 3138*/ GIMT_Encode4(145635),
     /* 145389 */ /*GILLT_v16s16*//*Label 3139*/ GIMT_Encode4(145853), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145401 */ /*GILLT_v32s8*//*Label 3140*/ GIMT_Encode4(146044),
     /* 145405 */ /*GILLT_v32s16*//*Label 3141*/ GIMT_Encode4(146235), GIMT_Encode4(0),
     /* 145413 */ /*GILLT_v64s8*//*Label 3142*/ GIMT_Encode4(146329),
     /* 145417 */ // Label 3137: @145417
     /* 145417 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(145634),
     /* 145422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145428 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(145490), // Rule ID 2631 //
     /* 145433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145472 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrm),
     /* 145475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145488 */     GIR_RootConstrainSelectedInstOperands,
     /* 145489 */     // GIR_Coverage, 2631,
     /* 145489 */     GIR_EraseRootFromParent_Done,
     /* 145490 */   // Label 3145: @145490
     /* 145490 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(145552), // Rule ID 4936 //
     /* 145495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145534 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rm),
     /* 145537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145550 */     GIR_RootConstrainSelectedInstOperands,
     /* 145551 */     // GIR_Coverage, 4936,
     /* 145551 */     GIR_EraseRootFromParent_Done,
     /* 145552 */   // Label 3146: @145552
     /* 145552 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(145579), // Rule ID 2630 //
     /* 145557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145572 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 145577 */     GIR_RootConstrainSelectedInstOperands,
     /* 145578 */     // GIR_Coverage, 2630,
     /* 145578 */     GIR_Done,
     /* 145579 */   // Label 3147: @145579
     /* 145579 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(145606), // Rule ID 2632 //
     /* 145584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145599 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 145604 */     GIR_RootConstrainSelectedInstOperands,
     /* 145605 */     // GIR_Coverage, 2632,
     /* 145605 */     GIR_Done,
     /* 145606 */   // Label 3148: @145606
     /* 145606 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(145633), // Rule ID 4933 //
     /* 145611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145626 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 145626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 145631 */     GIR_RootConstrainSelectedInstOperands,
     /* 145632 */     // GIR_Coverage, 4933,
     /* 145632 */     GIR_Done,
     /* 145633 */   // Label 3149: @145633
     /* 145633 */   GIM_Reject,
     /* 145634 */ // Label 3144: @145634
     /* 145634 */ GIM_Reject,
     /* 145635 */ // Label 3138: @145635
     /* 145635 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(145852),
     /* 145640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 145643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145646 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(145708), // Rule ID 2625 //
     /* 145651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145670 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145673 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145677 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145690 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrm),
     /* 145693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145706 */     GIR_RootConstrainSelectedInstOperands,
     /* 145707 */     // GIR_Coverage, 2625,
     /* 145707 */     GIR_EraseRootFromParent_Done,
     /* 145708 */   // Label 3151: @145708
     /* 145708 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(145770), // Rule ID 4954 //
     /* 145713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145752 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rm),
     /* 145755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145768 */     GIR_RootConstrainSelectedInstOperands,
     /* 145769 */     // GIR_Coverage, 4954,
     /* 145769 */     GIR_EraseRootFromParent_Done,
     /* 145770 */   // Label 3152: @145770
     /* 145770 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(145797), // Rule ID 2624 //
     /* 145775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145790 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 145790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 145795 */     GIR_RootConstrainSelectedInstOperands,
     /* 145796 */     // GIR_Coverage, 2624,
     /* 145796 */     GIR_Done,
     /* 145797 */   // Label 3153: @145797
     /* 145797 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(145824), // Rule ID 2626 //
     /* 145802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145817 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 145817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 145822 */     GIR_RootConstrainSelectedInstOperands,
     /* 145823 */     // GIR_Coverage, 2626,
     /* 145823 */     GIR_Done,
     /* 145824 */   // Label 3154: @145824
     /* 145824 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(145851), // Rule ID 4951 //
     /* 145829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145844 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 145844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 145849 */     GIR_RootConstrainSelectedInstOperands,
     /* 145850 */     // GIR_Coverage, 4951,
     /* 145850 */     GIR_Done,
     /* 145851 */   // Label 3155: @145851
     /* 145851 */   GIM_Reject,
     /* 145852 */ // Label 3150: @145852
     /* 145852 */ GIM_Reject,
     /* 145853 */ // Label 3139: @145853
     /* 145853 */ GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(146043),
     /* 145858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 145861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 145864 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(145926), // Rule ID 2635 //
     /* 145869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145908 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrm),
     /* 145911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145924 */     GIR_RootConstrainSelectedInstOperands,
     /* 145925 */     // GIR_Coverage, 2635,
     /* 145925 */     GIR_EraseRootFromParent_Done,
     /* 145926 */   // Label 3157: @145926
     /* 145926 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(145988), // Rule ID 4930 //
     /* 145931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145970 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rm),
     /* 145973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145975 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145986 */     GIR_RootConstrainSelectedInstOperands,
     /* 145987 */     // GIR_Coverage, 4930,
     /* 145987 */     GIR_EraseRootFromParent_Done,
     /* 145988 */   // Label 3158: @145988
     /* 145988 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(146015), // Rule ID 2634 //
     /* 145993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146008 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 146008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 146013 */     GIR_RootConstrainSelectedInstOperands,
     /* 146014 */     // GIR_Coverage, 2634,
     /* 146014 */     GIR_Done,
     /* 146015 */   // Label 3159: @146015
     /* 146015 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(146042), // Rule ID 4927 //
     /* 146020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146035 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 146035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 146040 */     GIR_RootConstrainSelectedInstOperands,
     /* 146041 */     // GIR_Coverage, 4927,
     /* 146041 */     GIR_Done,
     /* 146042 */   // Label 3160: @146042
     /* 146042 */   GIM_Reject,
     /* 146043 */ // Label 3156: @146043
     /* 146043 */ GIM_Reject,
     /* 146044 */ // Label 3140: @146044
     /* 146044 */ GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(146234),
     /* 146049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 146052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 146055 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(146117), // Rule ID 2629 //
     /* 146060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146099 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrm),
     /* 146102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146115 */     GIR_RootConstrainSelectedInstOperands,
     /* 146116 */     // GIR_Coverage, 2629,
     /* 146116 */     GIR_EraseRootFromParent_Done,
     /* 146117 */   // Label 3162: @146117
     /* 146117 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(146179), // Rule ID 4948 //
     /* 146122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146141 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146161 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rm),
     /* 146164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146177 */     GIR_RootConstrainSelectedInstOperands,
     /* 146178 */     // GIR_Coverage, 4948,
     /* 146178 */     GIR_EraseRootFromParent_Done,
     /* 146179 */   // Label 3163: @146179
     /* 146179 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(146206), // Rule ID 2628 //
     /* 146184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146199 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 146199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 146204 */     GIR_RootConstrainSelectedInstOperands,
     /* 146205 */     // GIR_Coverage, 2628,
     /* 146205 */     GIR_Done,
     /* 146206 */   // Label 3164: @146206
     /* 146206 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(146233), // Rule ID 4945 //
     /* 146211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146226 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 146226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 146231 */     GIR_RootConstrainSelectedInstOperands,
     /* 146232 */     // GIR_Coverage, 4945,
     /* 146232 */     GIR_Done,
     /* 146233 */   // Label 3165: @146233
     /* 146233 */   GIM_Reject,
     /* 146234 */ // Label 3161: @146234
     /* 146234 */ GIM_Reject,
     /* 146235 */ // Label 3141: @146235
     /* 146235 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(146328),
     /* 146240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 146243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 146246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146254 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(146308), // Rule ID 4924 //
     /* 146259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146290 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrm),
     /* 146293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146306 */     GIR_RootConstrainSelectedInstOperands,
     /* 146307 */     // GIR_Coverage, 4924,
     /* 146307 */     GIR_EraseRootFromParent_Done,
     /* 146308 */   // Label 3167: @146308
     /* 146308 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(146327), // Rule ID 4921 //
     /* 146313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146320 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 146320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 146325 */     GIR_RootConstrainSelectedInstOperands,
     /* 146326 */     // GIR_Coverage, 4921,
     /* 146326 */     GIR_Done,
     /* 146327 */   // Label 3168: @146327
     /* 146327 */   GIM_Reject,
     /* 146328 */ // Label 3166: @146328
     /* 146328 */ GIM_Reject,
     /* 146329 */ // Label 3142: @146329
     /* 146329 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(146422),
     /* 146334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 146337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 146340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146348 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(146402), // Rule ID 4942 //
     /* 146353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146384 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrm),
     /* 146387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146400 */     GIR_RootConstrainSelectedInstOperands,
     /* 146401 */     // GIR_Coverage, 4942,
     /* 146401 */     GIR_EraseRootFromParent_Done,
     /* 146402 */   // Label 3170: @146402
     /* 146402 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(146421), // Rule ID 4939 //
     /* 146407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146414 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 146414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 146419 */     GIR_RootConstrainSelectedInstOperands,
     /* 146420 */     // GIR_Coverage, 4939,
     /* 146420 */     GIR_Done,
     /* 146421 */   // Label 3171: @146421
     /* 146421 */   GIM_Reject,
     /* 146422 */ // Label 3169: @146422
     /* 146422 */ GIM_Reject,
     /* 146423 */ // Label 3143: @146423
     /* 146423 */ GIM_Reject,
     /* 146424 */ // Label 40: @146424
     /* 146424 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3178*/ GIMT_Encode4(147489),
     /* 146435 */ /*GILLT_v8s16*//*Label 3172*/ GIMT_Encode4(146483), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146451 */ /*GILLT_v16s8*//*Label 3173*/ GIMT_Encode4(146701),
     /* 146455 */ /*GILLT_v16s16*//*Label 3174*/ GIMT_Encode4(146919), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146467 */ /*GILLT_v32s8*//*Label 3175*/ GIMT_Encode4(147110),
     /* 146471 */ /*GILLT_v32s16*//*Label 3176*/ GIMT_Encode4(147301), GIMT_Encode4(0),
     /* 146479 */ /*GILLT_v64s8*//*Label 3177*/ GIMT_Encode4(147395),
     /* 146483 */ // Label 3172: @146483
     /* 146483 */ GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(146700),
     /* 146488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146494 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(146556), // Rule ID 2619 //
     /* 146499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146538 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrm),
     /* 146541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146554 */     GIR_RootConstrainSelectedInstOperands,
     /* 146555 */     // GIR_Coverage, 2619,
     /* 146555 */     GIR_EraseRootFromParent_Done,
     /* 146556 */   // Label 3180: @146556
     /* 146556 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(146618), // Rule ID 4864 //
     /* 146561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146600 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rm),
     /* 146603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146616 */     GIR_RootConstrainSelectedInstOperands,
     /* 146617 */     // GIR_Coverage, 4864,
     /* 146617 */     GIR_EraseRootFromParent_Done,
     /* 146618 */   // Label 3181: @146618
     /* 146618 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(146645), // Rule ID 2618 //
     /* 146623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146638 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 146643 */     GIR_RootConstrainSelectedInstOperands,
     /* 146644 */     // GIR_Coverage, 2618,
     /* 146644 */     GIR_Done,
     /* 146645 */   // Label 3182: @146645
     /* 146645 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(146672), // Rule ID 2620 //
     /* 146650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146665 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 146670 */     GIR_RootConstrainSelectedInstOperands,
     /* 146671 */     // GIR_Coverage, 2620,
     /* 146671 */     GIR_Done,
     /* 146672 */   // Label 3183: @146672
     /* 146672 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(146699), // Rule ID 4861 //
     /* 146677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146692 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 146692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 146697 */     GIR_RootConstrainSelectedInstOperands,
     /* 146698 */     // GIR_Coverage, 4861,
     /* 146698 */     GIR_Done,
     /* 146699 */   // Label 3184: @146699
     /* 146699 */   GIM_Reject,
     /* 146700 */ // Label 3179: @146700
     /* 146700 */ GIM_Reject,
     /* 146701 */ // Label 3173: @146701
     /* 146701 */ GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(146918),
     /* 146706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 146709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146712 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(146774), // Rule ID 2613 //
     /* 146717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146736 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146743 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146756 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrm),
     /* 146759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146772 */     GIR_RootConstrainSelectedInstOperands,
     /* 146773 */     // GIR_Coverage, 2613,
     /* 146773 */     GIR_EraseRootFromParent_Done,
     /* 146774 */   // Label 3186: @146774
     /* 146774 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(146836), // Rule ID 4882 //
     /* 146779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146818 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rm),
     /* 146821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146834 */     GIR_RootConstrainSelectedInstOperands,
     /* 146835 */     // GIR_Coverage, 4882,
     /* 146835 */     GIR_EraseRootFromParent_Done,
     /* 146836 */   // Label 3187: @146836
     /* 146836 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(146863), // Rule ID 2612 //
     /* 146841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146856 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 146861 */     GIR_RootConstrainSelectedInstOperands,
     /* 146862 */     // GIR_Coverage, 2612,
     /* 146862 */     GIR_Done,
     /* 146863 */   // Label 3188: @146863
     /* 146863 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(146890), // Rule ID 2614 //
     /* 146868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146883 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 146888 */     GIR_RootConstrainSelectedInstOperands,
     /* 146889 */     // GIR_Coverage, 2614,
     /* 146889 */     GIR_Done,
     /* 146890 */   // Label 3189: @146890
     /* 146890 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(146917), // Rule ID 4879 //
     /* 146895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146910 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 146910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 146915 */     GIR_RootConstrainSelectedInstOperands,
     /* 146916 */     // GIR_Coverage, 4879,
     /* 146916 */     GIR_Done,
     /* 146917 */   // Label 3190: @146917
     /* 146917 */   GIM_Reject,
     /* 146918 */ // Label 3185: @146918
     /* 146918 */ GIM_Reject,
     /* 146919 */ // Label 3174: @146919
     /* 146919 */ GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(147109),
     /* 146924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 146927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 146930 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(146992), // Rule ID 2623 //
     /* 146935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146974 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrm),
     /* 146977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146990 */     GIR_RootConstrainSelectedInstOperands,
     /* 146991 */     // GIR_Coverage, 2623,
     /* 146991 */     GIR_EraseRootFromParent_Done,
     /* 146992 */   // Label 3192: @146992
     /* 146992 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(147054), // Rule ID 4858 //
     /* 146997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147036 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rm),
     /* 147039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147052 */     GIR_RootConstrainSelectedInstOperands,
     /* 147053 */     // GIR_Coverage, 4858,
     /* 147053 */     GIR_EraseRootFromParent_Done,
     /* 147054 */   // Label 3193: @147054
     /* 147054 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(147081), // Rule ID 2622 //
     /* 147059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147074 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 147074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 147079 */     GIR_RootConstrainSelectedInstOperands,
     /* 147080 */     // GIR_Coverage, 2622,
     /* 147080 */     GIR_Done,
     /* 147081 */   // Label 3194: @147081
     /* 147081 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(147108), // Rule ID 4855 //
     /* 147086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147101 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 147101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 147106 */     GIR_RootConstrainSelectedInstOperands,
     /* 147107 */     // GIR_Coverage, 4855,
     /* 147107 */     GIR_Done,
     /* 147108 */   // Label 3195: @147108
     /* 147108 */   GIM_Reject,
     /* 147109 */ // Label 3191: @147109
     /* 147109 */ GIM_Reject,
     /* 147110 */ // Label 3175: @147110
     /* 147110 */ GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(147300),
     /* 147115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 147118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 147121 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(147183), // Rule ID 2617 //
     /* 147126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147165 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrm),
     /* 147168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147181 */     GIR_RootConstrainSelectedInstOperands,
     /* 147182 */     // GIR_Coverage, 2617,
     /* 147182 */     GIR_EraseRootFromParent_Done,
     /* 147183 */   // Label 3197: @147183
     /* 147183 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(147245), // Rule ID 4876 //
     /* 147188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147227 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rm),
     /* 147230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147243 */     GIR_RootConstrainSelectedInstOperands,
     /* 147244 */     // GIR_Coverage, 4876,
     /* 147244 */     GIR_EraseRootFromParent_Done,
     /* 147245 */   // Label 3198: @147245
     /* 147245 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(147272), // Rule ID 2616 //
     /* 147250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147265 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 147265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 147270 */     GIR_RootConstrainSelectedInstOperands,
     /* 147271 */     // GIR_Coverage, 2616,
     /* 147271 */     GIR_Done,
     /* 147272 */   // Label 3199: @147272
     /* 147272 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(147299), // Rule ID 4873 //
     /* 147277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147292 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 147292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 147297 */     GIR_RootConstrainSelectedInstOperands,
     /* 147298 */     // GIR_Coverage, 4873,
     /* 147298 */     GIR_Done,
     /* 147299 */   // Label 3200: @147299
     /* 147299 */   GIM_Reject,
     /* 147300 */ // Label 3196: @147300
     /* 147300 */ GIM_Reject,
     /* 147301 */ // Label 3176: @147301
     /* 147301 */ GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(147394),
     /* 147306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 147309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 147312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147320 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(147374), // Rule ID 4852 //
     /* 147325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147356 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrm),
     /* 147359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147372 */     GIR_RootConstrainSelectedInstOperands,
     /* 147373 */     // GIR_Coverage, 4852,
     /* 147373 */     GIR_EraseRootFromParent_Done,
     /* 147374 */   // Label 3202: @147374
     /* 147374 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(147393), // Rule ID 4849 //
     /* 147379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147386 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 147386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 147391 */     GIR_RootConstrainSelectedInstOperands,
     /* 147392 */     // GIR_Coverage, 4849,
     /* 147392 */     GIR_Done,
     /* 147393 */   // Label 3203: @147393
     /* 147393 */   GIM_Reject,
     /* 147394 */ // Label 3201: @147394
     /* 147394 */ GIM_Reject,
     /* 147395 */ // Label 3177: @147395
     /* 147395 */ GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(147488),
     /* 147400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 147403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 147406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147414 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(147468), // Rule ID 4870 //
     /* 147419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147450 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrm),
     /* 147453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147455 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147466 */     GIR_RootConstrainSelectedInstOperands,
     /* 147467 */     // GIR_Coverage, 4870,
     /* 147467 */     GIR_EraseRootFromParent_Done,
     /* 147468 */   // Label 3205: @147468
     /* 147468 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(147487), // Rule ID 4867 //
     /* 147473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147480 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 147480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 147485 */     GIR_RootConstrainSelectedInstOperands,
     /* 147486 */     // GIR_Coverage, 4867,
     /* 147486 */     GIR_Done,
     /* 147487 */   // Label 3206: @147487
     /* 147487 */   GIM_Reject,
     /* 147488 */ // Label 3204: @147488
     /* 147488 */ GIM_Reject,
     /* 147489 */ // Label 3178: @147489
     /* 147489 */ GIM_Reject,
     /* 147490 */ // Label 41: @147490
     /* 147490 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3220*/ GIMT_Encode4(152639),
     /* 147501 */ /*GILLT_s16*//*Label 3207*/ GIMT_Encode4(147585),
     /* 147505 */ /*GILLT_s32*//*Label 3208*/ GIMT_Encode4(147745),
     /* 147509 */ /*GILLT_s64*//*Label 3209*/ GIMT_Encode4(148882),
     /* 147513 */ /*GILLT_s80*//*Label 3210*/ GIMT_Encode4(150163), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147525 */ /*GILLT_v2s64*//*Label 3211*/ GIMT_Encode4(150485), GIMT_Encode4(0),
     /* 147533 */ /*GILLT_v4s32*//*Label 3212*/ GIMT_Encode4(150839),
     /* 147537 */ /*GILLT_v4s64*//*Label 3213*/ GIMT_Encode4(151193), GIMT_Encode4(0),
     /* 147545 */ /*GILLT_v8s16*//*Label 3214*/ GIMT_Encode4(151516),
     /* 147549 */ /*GILLT_v8s32*//*Label 3215*/ GIMT_Encode4(151676),
     /* 147553 */ /*GILLT_v8s64*//*Label 3216*/ GIMT_Encode4(151999), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147565 */ /*GILLT_v16s16*//*Label 3217*/ GIMT_Encode4(152159),
     /* 147569 */ /*GILLT_v16s32*//*Label 3218*/ GIMT_Encode4(152319), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147581 */ /*GILLT_v32s16*//*Label 3219*/ GIMT_Encode4(152479),
     /* 147585 */ // Label 3207: @147585
     /* 147585 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(147744),
     /* 147590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 147593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147600 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(147658), // Rule ID 24250 //
     /* 147605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147640 */     // (fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147656 */     GIR_RootConstrainSelectedInstOperands,
     /* 147657 */     // GIR_Coverage, 24250,
     /* 147657 */     GIR_EraseRootFromParent_Done,
     /* 147658 */   // Label 3222: @147658
     /* 147658 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(147716), // Rule ID 5955 //
     /* 147663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147698 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147714 */     GIR_RootConstrainSelectedInstOperands,
     /* 147715 */     // GIR_Coverage, 5955,
     /* 147715 */     GIR_EraseRootFromParent_Done,
     /* 147716 */   // Label 3223: @147716
     /* 147716 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(147743), // Rule ID 5953 //
     /* 147721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147732 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 147732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 147737 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 147741 */     GIR_RootConstrainSelectedInstOperands,
     /* 147742 */     // GIR_Coverage, 5953,
     /* 147742 */     GIR_Done,
     /* 147743 */   // Label 3224: @147743
     /* 147743 */   GIM_Reject,
     /* 147744 */ // Label 3221: @147744
     /* 147744 */ GIM_Reject,
     /* 147745 */ // Label 3208: @147745
     /* 147745 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(148881),
     /* 147750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 147753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147756 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(147838), // Rule ID 26018 //
     /* 147761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147788 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 147795 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147802 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147819 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 147822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147836 */     GIR_RootConstrainSelectedInstOperands,
     /* 147837 */     // GIR_Coverage, 26018,
     /* 147837 */     GIR_EraseRootFromParent_Done,
     /* 147838 */   // Label 3226: @147838
     /* 147838 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(147920), // Rule ID 26019 //
     /* 147843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 147846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147870 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 147877 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147884 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147901 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 147904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147918 */     GIR_RootConstrainSelectedInstOperands,
     /* 147919 */     // GIR_Coverage, 26019,
     /* 147919 */     GIR_EraseRootFromParent_Done,
     /* 147920 */   // Label 3227: @147920
     /* 147920 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(148002), // Rule ID 26020 //
     /* 147925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 147928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147952 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 147959 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147966 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147983 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 147986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148000 */     GIR_RootConstrainSelectedInstOperands,
     /* 148001 */     // GIR_Coverage, 26020,
     /* 148001 */     GIR_EraseRootFromParent_Done,
     /* 148002 */   // Label 3228: @148002
     /* 148002 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(148084), // Rule ID 22467 //
     /* 148007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148038 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148041 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148045 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148052 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148065 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148082 */     GIR_RootConstrainSelectedInstOperands,
     /* 148083 */     // GIR_Coverage, 22467,
     /* 148083 */     GIR_EraseRootFromParent_Done,
     /* 148084 */   // Label 3229: @148084
     /* 148084 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(148166), // Rule ID 22468 //
     /* 148089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148120 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148127 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148134 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148147 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148164 */     GIR_RootConstrainSelectedInstOperands,
     /* 148165 */     // GIR_Coverage, 22468,
     /* 148165 */     GIR_EraseRootFromParent_Done,
     /* 148166 */   // Label 3230: @148166
     /* 148166 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(148248), // Rule ID 22469 //
     /* 148171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148202 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148209 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148216 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148229 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148246 */     GIR_RootConstrainSelectedInstOperands,
     /* 148247 */     // GIR_Coverage, 22469,
     /* 148247 */     GIR_EraseRootFromParent_Done,
     /* 148248 */   // Label 3231: @148248
     /* 148248 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(148313), // Rule ID 23237 //
     /* 148253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148292 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148311 */     GIR_RootConstrainSelectedInstOperands,
     /* 148312 */     // GIR_Coverage, 23237,
     /* 148312 */     GIR_EraseRootFromParent_Done,
     /* 148313 */   // Label 3232: @148313
     /* 148313 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(148375), // Rule ID 23382 //
     /* 148318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148333 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148357 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148373 */     GIR_RootConstrainSelectedInstOperands,
     /* 148374 */     // GIR_Coverage, 23382,
     /* 148374 */     GIR_EraseRootFromParent_Done,
     /* 148375 */   // Label 3233: @148375
     /* 148375 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(148437), // Rule ID 23386 //
     /* 148380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148419 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148435 */     GIR_RootConstrainSelectedInstOperands,
     /* 148436 */     // GIR_Coverage, 23386,
     /* 148436 */     GIR_EraseRootFromParent_Done,
     /* 148437 */   // Label 3234: @148437
     /* 148437 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(148499), // Rule ID 24246 //
     /* 148442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148464 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148481 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148497 */     GIR_RootConstrainSelectedInstOperands,
     /* 148498 */     // GIR_Coverage, 24246,
     /* 148498 */     GIR_EraseRootFromParent_Done,
     /* 148499 */   // Label 3235: @148499
     /* 148499 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(148564), // Rule ID 911 //
     /* 148504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148523 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148526 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148530 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148543 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148548 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148562 */     GIR_RootConstrainSelectedInstOperands,
     /* 148563 */     // GIR_Coverage, 911,
     /* 148563 */     GIR_EraseRootFromParent_Done,
     /* 148564 */   // Label 3236: @148564
     /* 148564 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(148626), // Rule ID 2161 //
     /* 148569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148608 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148624 */     GIR_RootConstrainSelectedInstOperands,
     /* 148625 */     // GIR_Coverage, 2161,
     /* 148625 */     GIR_EraseRootFromParent_Done,
     /* 148626 */   // Label 3237: @148626
     /* 148626 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(148688), // Rule ID 2169 //
     /* 148631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148670 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148686 */     GIR_RootConstrainSelectedInstOperands,
     /* 148687 */     // GIR_Coverage, 2169,
     /* 148687 */     GIR_EraseRootFromParent_Done,
     /* 148688 */   // Label 3238: @148688
     /* 148688 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(148750), // Rule ID 5917 //
     /* 148693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148732 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148748 */     GIR_RootConstrainSelectedInstOperands,
     /* 148749 */     // GIR_Coverage, 5917,
     /* 148749 */     GIR_EraseRootFromParent_Done,
     /* 148750 */   // Label 3239: @148750
     /* 148750 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(148787), // Rule ID 887 //
     /* 148755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148770 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 148770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 148775 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 148781 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 148785 */     GIR_RootConstrainSelectedInstOperands,
     /* 148786 */     // GIR_Coverage, 887,
     /* 148786 */     GIR_Done,
     /* 148787 */   // Label 3240: @148787
     /* 148787 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(148818), // Rule ID 2159 //
     /* 148792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148807 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 148807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 148812 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148816 */     GIR_RootConstrainSelectedInstOperands,
     /* 148817 */     // GIR_Coverage, 2159,
     /* 148817 */     GIR_Done,
     /* 148818 */   // Label 3241: @148818
     /* 148818 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(148849), // Rule ID 2167 //
     /* 148823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148838 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 148838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 148843 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148847 */     GIR_RootConstrainSelectedInstOperands,
     /* 148848 */     // GIR_Coverage, 2167,
     /* 148848 */     GIR_Done,
     /* 148849 */   // Label 3242: @148849
     /* 148849 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(148880), // Rule ID 5915 //
     /* 148854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148869 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 148869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 148874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148878 */     GIR_RootConstrainSelectedInstOperands,
     /* 148879 */     // GIR_Coverage, 5915,
     /* 148879 */     GIR_Done,
     /* 148880 */   // Label 3243: @148880
     /* 148880 */   GIM_Reject,
     /* 148881 */ // Label 3225: @148881
     /* 148881 */ GIM_Reject,
     /* 148882 */ // Label 3209: @148882
     /* 148882 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(150162),
     /* 148887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 148890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148893 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(148975), // Rule ID 26021 //
     /* 148898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148925 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148932 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148939 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148956 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 148959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148973 */     GIR_RootConstrainSelectedInstOperands,
     /* 148974 */     // GIR_Coverage, 26021,
     /* 148974 */     GIR_EraseRootFromParent_Done,
     /* 148975 */   // Label 3245: @148975
     /* 148975 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(149057), // Rule ID 26022 //
     /* 148980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149007 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149014 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149021 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149038 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149055 */     GIR_RootConstrainSelectedInstOperands,
     /* 149056 */     // GIR_Coverage, 26022,
     /* 149056 */     GIR_EraseRootFromParent_Done,
     /* 149057 */   // Label 3246: @149057
     /* 149057 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(149139), // Rule ID 26023 //
     /* 149062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149089 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149096 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149103 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149120 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149137 */     GIR_RootConstrainSelectedInstOperands,
     /* 149138 */     // GIR_Coverage, 26023,
     /* 149138 */     GIR_EraseRootFromParent_Done,
     /* 149139 */   // Label 3247: @149139
     /* 149139 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(149221), // Rule ID 22470 //
     /* 149144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149175 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149182 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149195 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149202 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149219 */     GIR_RootConstrainSelectedInstOperands,
     /* 149220 */     // GIR_Coverage, 22470,
     /* 149220 */     GIR_EraseRootFromParent_Done,
     /* 149221 */   // Label 3248: @149221
     /* 149221 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(149303), // Rule ID 22471 //
     /* 149226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149257 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149264 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149271 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149284 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149289 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149301 */     GIR_RootConstrainSelectedInstOperands,
     /* 149302 */     // GIR_Coverage, 22471,
     /* 149302 */     GIR_EraseRootFromParent_Done,
     /* 149303 */   // Label 3249: @149303
     /* 149303 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(149385), // Rule ID 22472 //
     /* 149308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149339 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149346 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149353 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149366 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149383 */     GIR_RootConstrainSelectedInstOperands,
     /* 149384 */     // GIR_Coverage, 22472,
     /* 149384 */     GIR_EraseRootFromParent_Done,
     /* 149385 */   // Label 3250: @149385
     /* 149385 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(149450), // Rule ID 23239 //
     /* 149390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149405 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149412 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149429 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 149432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149434 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149448 */     GIR_RootConstrainSelectedInstOperands,
     /* 149449 */     // GIR_Coverage, 23239,
     /* 149449 */     GIR_EraseRootFromParent_Done,
     /* 149450 */   // Label 3251: @149450
     /* 149450 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(149522), // Rule ID 23241 //
     /* 149455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149473 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149477 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149501 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 149504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149520 */     GIR_RootConstrainSelectedInstOperands,
     /* 149521 */     // GIR_Coverage, 23241,
     /* 149521 */     GIR_EraseRootFromParent_Done,
     /* 149522 */   // Label 3252: @149522
     /* 149522 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(149584), // Rule ID 23384 //
     /* 149527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149566 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149582 */     GIR_RootConstrainSelectedInstOperands,
     /* 149583 */     // GIR_Coverage, 23384,
     /* 149583 */     GIR_EraseRootFromParent_Done,
     /* 149584 */   // Label 3253: @149584
     /* 149584 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(149646), // Rule ID 23388 //
     /* 149589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 149592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149604 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149611 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149628 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149644 */     GIR_RootConstrainSelectedInstOperands,
     /* 149645 */     // GIR_Coverage, 23388,
     /* 149645 */     GIR_EraseRootFromParent_Done,
     /* 149646 */   // Label 3254: @149646
     /* 149646 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(149708), // Rule ID 24248 //
     /* 149651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149690 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149706 */     GIR_RootConstrainSelectedInstOperands,
     /* 149707 */     // GIR_Coverage, 24248,
     /* 149707 */     GIR_EraseRootFromParent_Done,
     /* 149708 */   // Label 3255: @149708
     /* 149708 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(149773), // Rule ID 913 //
     /* 149713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149752 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 149755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149771 */     GIR_RootConstrainSelectedInstOperands,
     /* 149772 */     // GIR_Coverage, 913,
     /* 149772 */     GIR_EraseRootFromParent_Done,
     /* 149773 */   // Label 3256: @149773
     /* 149773 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(149845), // Rule ID 915 //
     /* 149778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149797 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149800 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149804 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149824 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 149827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149843 */     GIR_RootConstrainSelectedInstOperands,
     /* 149844 */     // GIR_Coverage, 915,
     /* 149844 */     GIR_EraseRootFromParent_Done,
     /* 149845 */   // Label 3257: @149845
     /* 149845 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(149907), // Rule ID 2165 //
     /* 149850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149889 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149905 */     GIR_RootConstrainSelectedInstOperands,
     /* 149906 */     // GIR_Coverage, 2165,
     /* 149906 */     GIR_EraseRootFromParent_Done,
     /* 149907 */   // Label 3258: @149907
     /* 149907 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(149969), // Rule ID 2173 //
     /* 149912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 149915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149931 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149951 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149967 */     GIR_RootConstrainSelectedInstOperands,
     /* 149968 */     // GIR_Coverage, 2173,
     /* 149968 */     GIR_EraseRootFromParent_Done,
     /* 149969 */   // Label 3259: @149969
     /* 149969 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(150031), // Rule ID 5936 //
     /* 149974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149993 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150000 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150013 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150018 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150020 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150029 */     GIR_RootConstrainSelectedInstOperands,
     /* 150030 */     // GIR_Coverage, 5936,
     /* 150030 */     GIR_EraseRootFromParent_Done,
     /* 150031 */   // Label 3260: @150031
     /* 150031 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(150068), // Rule ID 889 //
     /* 150036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150051 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 150051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 150056 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 150062 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 150066 */     GIR_RootConstrainSelectedInstOperands,
     /* 150067 */     // GIR_Coverage, 889,
     /* 150067 */     GIR_Done,
     /* 150068 */   // Label 3261: @150068
     /* 150068 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(150099), // Rule ID 2163 //
     /* 150073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150088 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 150093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150097 */     GIR_RootConstrainSelectedInstOperands,
     /* 150098 */     // GIR_Coverage, 2163,
     /* 150098 */     GIR_Done,
     /* 150099 */   // Label 3262: @150099
     /* 150099 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(150130), // Rule ID 2171 //
     /* 150104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150119 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 150124 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150128 */     GIR_RootConstrainSelectedInstOperands,
     /* 150129 */     // GIR_Coverage, 2171,
     /* 150129 */     GIR_Done,
     /* 150130 */   // Label 3263: @150130
     /* 150130 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(150161), // Rule ID 5934 //
     /* 150135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150150 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 150150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 150155 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150159 */     GIR_RootConstrainSelectedInstOperands,
     /* 150160 */     // GIR_Coverage, 5934,
     /* 150160 */     GIR_Done,
     /* 150161 */   // Label 3264: @150161
     /* 150161 */   GIM_Reject,
     /* 150162 */ // Label 3244: @150162
     /* 150162 */ GIM_Reject,
     /* 150163 */ // Label 3210: @150163
     /* 150163 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(150484),
     /* 150168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 150171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 150174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150178 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(150246), // Rule ID 23243 //
     /* 150183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150197 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150201 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150225 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 150228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150244 */     GIR_RootConstrainSelectedInstOperands,
     /* 150245 */     // GIR_Coverage, 23243,
     /* 150245 */     GIR_EraseRootFromParent_Done,
     /* 150246 */   // Label 3266: @150246
     /* 150246 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(150314), // Rule ID 23245 //
     /* 150251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150265 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150269 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150293 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 150296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150312 */     GIR_RootConstrainSelectedInstOperands,
     /* 150313 */     // GIR_Coverage, 23245,
     /* 150313 */     GIR_EraseRootFromParent_Done,
     /* 150314 */   // Label 3267: @150314
     /* 150314 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(150382), // Rule ID 917 //
     /* 150319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150337 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150341 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150348 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150361 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 150364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150380 */     GIR_RootConstrainSelectedInstOperands,
     /* 150381 */     // GIR_Coverage, 917,
     /* 150381 */     GIR_EraseRootFromParent_Done,
     /* 150382 */   // Label 3268: @150382
     /* 150382 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(150450), // Rule ID 919 //
     /* 150387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150402 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150405 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150409 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150416 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150429 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 150432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150448 */     GIR_RootConstrainSelectedInstOperands,
     /* 150449 */     // GIR_Coverage, 919,
     /* 150449 */     GIR_EraseRootFromParent_Done,
     /* 150450 */   // Label 3269: @150450
     /* 150450 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(150483), // Rule ID 891 //
     /* 150455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150466 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 150466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 150471 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 150477 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 150481 */     GIR_RootConstrainSelectedInstOperands,
     /* 150482 */     // GIR_Coverage, 891,
     /* 150482 */     GIR_Done,
     /* 150483 */   // Label 3270: @150483
     /* 150483 */   GIM_Reject,
     /* 150484 */ // Label 3265: @150484
     /* 150484 */ GIM_Reject,
     /* 150485 */ // Label 3211: @150485
     /* 150485 */ GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(150838),
     /* 150490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150496 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(150558), // Rule ID 23372 //
     /* 150501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150540 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 150543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150556 */     GIR_RootConstrainSelectedInstOperands,
     /* 150557 */     // GIR_Coverage, 23372,
     /* 150557 */     GIR_EraseRootFromParent_Done,
     /* 150558 */   // Label 3272: @150558
     /* 150558 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(150620), // Rule ID 24296 //
     /* 150563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150578 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150585 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150602 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 150605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150607 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150618 */     GIR_RootConstrainSelectedInstOperands,
     /* 150619 */     // GIR_Coverage, 24296,
     /* 150619 */     GIR_EraseRootFromParent_Done,
     /* 150620 */   // Label 3273: @150620
     /* 150620 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(150682), // Rule ID 2141 //
     /* 150625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150664 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 150667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150680 */     GIR_RootConstrainSelectedInstOperands,
     /* 150681 */     // GIR_Coverage, 2141,
     /* 150681 */     GIR_EraseRootFromParent_Done,
     /* 150682 */   // Label 3274: @150682
     /* 150682 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(150744), // Rule ID 6309 //
     /* 150687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150726 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 150729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150742 */     GIR_RootConstrainSelectedInstOperands,
     /* 150743 */     // GIR_Coverage, 6309,
     /* 150743 */     GIR_EraseRootFromParent_Done,
     /* 150744 */   // Label 3275: @150744
     /* 150744 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(150775), // Rule ID 2139 //
     /* 150749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150764 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 150764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 150769 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150773 */     GIR_RootConstrainSelectedInstOperands,
     /* 150774 */     // GIR_Coverage, 2139,
     /* 150774 */     GIR_Done,
     /* 150775 */   // Label 3276: @150775
     /* 150775 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(150806), // Rule ID 2155 //
     /* 150780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150795 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 150795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 150800 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150804 */     GIR_RootConstrainSelectedInstOperands,
     /* 150805 */     // GIR_Coverage, 2155,
     /* 150805 */     GIR_Done,
     /* 150806 */   // Label 3277: @150806
     /* 150806 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(150837), // Rule ID 6305 //
     /* 150811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150826 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 150826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 150831 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150835 */     GIR_RootConstrainSelectedInstOperands,
     /* 150836 */     // GIR_Coverage, 6305,
     /* 150836 */     GIR_Done,
     /* 150837 */   // Label 3278: @150837
     /* 150837 */   GIM_Reject,
     /* 150838 */ // Label 3271: @150838
     /* 150838 */ GIM_Reject,
     /* 150839 */ // Label 3212: @150839
     /* 150839 */ GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(151192),
     /* 150844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150850 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(150912), // Rule ID 23370 //
     /* 150855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150894 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 150897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150899 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150910 */     GIR_RootConstrainSelectedInstOperands,
     /* 150911 */     // GIR_Coverage, 23370,
     /* 150911 */     GIR_EraseRootFromParent_Done,
     /* 150912 */   // Label 3280: @150912
     /* 150912 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(150974), // Rule ID 24280 //
     /* 150917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150956 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 150959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150972 */     GIR_RootConstrainSelectedInstOperands,
     /* 150973 */     // GIR_Coverage, 24280,
     /* 150973 */     GIR_EraseRootFromParent_Done,
     /* 150974 */   // Label 3281: @150974
     /* 150974 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(151036), // Rule ID 2137 //
     /* 150979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150998 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151018 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 151021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151034 */     GIR_RootConstrainSelectedInstOperands,
     /* 151035 */     // GIR_Coverage, 2137,
     /* 151035 */     GIR_EraseRootFromParent_Done,
     /* 151036 */   // Label 3282: @151036
     /* 151036 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(151098), // Rule ID 6285 //
     /* 151041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151080 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 151083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151096 */     GIR_RootConstrainSelectedInstOperands,
     /* 151097 */     // GIR_Coverage, 6285,
     /* 151097 */     GIR_EraseRootFromParent_Done,
     /* 151098 */   // Label 3283: @151098
     /* 151098 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(151129), // Rule ID 2135 //
     /* 151103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151118 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 151118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 151123 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151127 */     GIR_RootConstrainSelectedInstOperands,
     /* 151128 */     // GIR_Coverage, 2135,
     /* 151128 */     GIR_Done,
     /* 151129 */   // Label 3284: @151129
     /* 151129 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(151160), // Rule ID 2151 //
     /* 151134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 151137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151149 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 151149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 151154 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151158 */     GIR_RootConstrainSelectedInstOperands,
     /* 151159 */     // GIR_Coverage, 2151,
     /* 151159 */     GIR_Done,
     /* 151160 */   // Label 3285: @151160
     /* 151160 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(151191), // Rule ID 6281 //
     /* 151165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151180 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 151180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 151185 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151189 */     GIR_RootConstrainSelectedInstOperands,
     /* 151190 */     // GIR_Coverage, 6281,
     /* 151190 */     GIR_Done,
     /* 151191 */   // Label 3286: @151191
     /* 151191 */   GIM_Reject,
     /* 151192 */ // Label 3279: @151192
     /* 151192 */ GIM_Reject,
     /* 151193 */ // Label 3213: @151193
     /* 151193 */ GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(151515),
     /* 151198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 151201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 151204 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(151266), // Rule ID 23376 //
     /* 151209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151248 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 151251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151264 */     GIR_RootConstrainSelectedInstOperands,
     /* 151265 */     // GIR_Coverage, 23376,
     /* 151265 */     GIR_EraseRootFromParent_Done,
     /* 151266 */   // Label 3288: @151266
     /* 151266 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(151328), // Rule ID 24304 //
     /* 151271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151310 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 151313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151326 */     GIR_RootConstrainSelectedInstOperands,
     /* 151327 */     // GIR_Coverage, 24304,
     /* 151327 */     GIR_EraseRootFromParent_Done,
     /* 151328 */   // Label 3289: @151328
     /* 151328 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(151390), // Rule ID 2149 //
     /* 151333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151352 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151359 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151372 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 151375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151377 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151388 */     GIR_RootConstrainSelectedInstOperands,
     /* 151389 */     // GIR_Coverage, 2149,
     /* 151389 */     GIR_EraseRootFromParent_Done,
     /* 151390 */   // Label 3290: @151390
     /* 151390 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(151452), // Rule ID 6321 //
     /* 151395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151434 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 151437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151450 */     GIR_RootConstrainSelectedInstOperands,
     /* 151451 */     // GIR_Coverage, 6321,
     /* 151451 */     GIR_EraseRootFromParent_Done,
     /* 151452 */   // Label 3291: @151452
     /* 151452 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(151483), // Rule ID 2147 //
     /* 151457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151472 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 151472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 151477 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151481 */     GIR_RootConstrainSelectedInstOperands,
     /* 151482 */     // GIR_Coverage, 2147,
     /* 151482 */     GIR_Done,
     /* 151483 */   // Label 3292: @151483
     /* 151483 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(151514), // Rule ID 6317 //
     /* 151488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151503 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 151503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 151508 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151512 */     GIR_RootConstrainSelectedInstOperands,
     /* 151513 */     // GIR_Coverage, 6317,
     /* 151513 */     GIR_Done,
     /* 151514 */   // Label 3293: @151514
     /* 151514 */   GIM_Reject,
     /* 151515 */ // Label 3287: @151515
     /* 151515 */ GIM_Reject,
     /* 151516 */ // Label 3214: @151516
     /* 151516 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(151675),
     /* 151521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151531 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(151589), // Rule ID 24320 //
     /* 151536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151547 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151554 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151571 */     // (fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 151574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151587 */     GIR_RootConstrainSelectedInstOperands,
     /* 151588 */     // GIR_Coverage, 24320,
     /* 151588 */     GIR_EraseRootFromParent_Done,
     /* 151589 */   // Label 3295: @151589
     /* 151589 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(151647), // Rule ID 6345 //
     /* 151594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151629 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 151632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151645 */     GIR_RootConstrainSelectedInstOperands,
     /* 151646 */     // GIR_Coverage, 6345,
     /* 151646 */     GIR_EraseRootFromParent_Done,
     /* 151647 */   // Label 3296: @151647
     /* 151647 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(151674), // Rule ID 6341 //
     /* 151652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151663 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 151663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 151668 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151672 */     GIR_RootConstrainSelectedInstOperands,
     /* 151673 */     // GIR_Coverage, 6341,
     /* 151673 */     GIR_Done,
     /* 151674 */   // Label 3297: @151674
     /* 151674 */   GIM_Reject,
     /* 151675 */ // Label 3294: @151675
     /* 151675 */ GIM_Reject,
     /* 151676 */ // Label 3215: @151676
     /* 151676 */ GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(151998),
     /* 151681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 151684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 151687 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(151749), // Rule ID 23374 //
     /* 151692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151707 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151714 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151731 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 151734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151747 */     GIR_RootConstrainSelectedInstOperands,
     /* 151748 */     // GIR_Coverage, 23374,
     /* 151748 */     GIR_EraseRootFromParent_Done,
     /* 151749 */   // Label 3299: @151749
     /* 151749 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(151811), // Rule ID 24288 //
     /* 151754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151793 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 151796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151809 */     GIR_RootConstrainSelectedInstOperands,
     /* 151810 */     // GIR_Coverage, 24288,
     /* 151810 */     GIR_EraseRootFromParent_Done,
     /* 151811 */   // Label 3300: @151811
     /* 151811 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(151873), // Rule ID 2145 //
     /* 151816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151855 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 151858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151871 */     GIR_RootConstrainSelectedInstOperands,
     /* 151872 */     // GIR_Coverage, 2145,
     /* 151872 */     GIR_EraseRootFromParent_Done,
     /* 151873 */   // Label 3301: @151873
     /* 151873 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(151935), // Rule ID 6297 //
     /* 151878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151917 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 151920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151933 */     GIR_RootConstrainSelectedInstOperands,
     /* 151934 */     // GIR_Coverage, 6297,
     /* 151934 */     GIR_EraseRootFromParent_Done,
     /* 151935 */   // Label 3302: @151935
     /* 151935 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(151966), // Rule ID 2143 //
     /* 151940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151955 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 151955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 151960 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151964 */     GIR_RootConstrainSelectedInstOperands,
     /* 151965 */     // GIR_Coverage, 2143,
     /* 151965 */     GIR_Done,
     /* 151966 */   // Label 3303: @151966
     /* 151966 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(151997), // Rule ID 6293 //
     /* 151971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151986 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 151986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 151991 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151995 */     GIR_RootConstrainSelectedInstOperands,
     /* 151996 */     // GIR_Coverage, 6293,
     /* 151996 */     GIR_Done,
     /* 151997 */   // Label 3304: @151997
     /* 151997 */   GIM_Reject,
     /* 151998 */ // Label 3298: @151998
     /* 151998 */ GIM_Reject,
     /* 151999 */ // Label 3216: @151999
     /* 151999 */ GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(152158),
     /* 152004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 152007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 152010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152014 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(152072), // Rule ID 24272 //
     /* 152019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152030 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152037 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152054 */     // (fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 152057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152070 */     GIR_RootConstrainSelectedInstOperands,
     /* 152071 */     // GIR_Coverage, 24272,
     /* 152071 */     GIR_EraseRootFromParent_Done,
     /* 152072 */   // Label 3306: @152072
     /* 152072 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(152130), // Rule ID 6273 //
     /* 152077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152112 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 152115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152128 */     GIR_RootConstrainSelectedInstOperands,
     /* 152129 */     // GIR_Coverage, 6273,
     /* 152129 */     GIR_EraseRootFromParent_Done,
     /* 152130 */   // Label 3307: @152130
     /* 152130 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(152157), // Rule ID 6269 //
     /* 152135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152146 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 152146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 152151 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152155 */     GIR_RootConstrainSelectedInstOperands,
     /* 152156 */     // GIR_Coverage, 6269,
     /* 152156 */     GIR_Done,
     /* 152157 */   // Label 3308: @152157
     /* 152157 */   GIM_Reject,
     /* 152158 */ // Label 3305: @152158
     /* 152158 */ GIM_Reject,
     /* 152159 */ // Label 3217: @152159
     /* 152159 */ GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(152318),
     /* 152164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 152167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 152170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152174 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(152232), // Rule ID 24328 //
     /* 152179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152214 */     // (fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 152217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152219 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152230 */     GIR_RootConstrainSelectedInstOperands,
     /* 152231 */     // GIR_Coverage, 24328,
     /* 152231 */     GIR_EraseRootFromParent_Done,
     /* 152232 */   // Label 3310: @152232
     /* 152232 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(152290), // Rule ID 6357 //
     /* 152237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152272 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 152275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152288 */     GIR_RootConstrainSelectedInstOperands,
     /* 152289 */     // GIR_Coverage, 6357,
     /* 152289 */     GIR_EraseRootFromParent_Done,
     /* 152290 */   // Label 3311: @152290
     /* 152290 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(152317), // Rule ID 6353 //
     /* 152295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152306 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 152306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 152311 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152315 */     GIR_RootConstrainSelectedInstOperands,
     /* 152316 */     // GIR_Coverage, 6353,
     /* 152316 */     GIR_Done,
     /* 152317 */   // Label 3312: @152317
     /* 152317 */   GIM_Reject,
     /* 152318 */ // Label 3309: @152318
     /* 152318 */ GIM_Reject,
     /* 152319 */ // Label 3218: @152319
     /* 152319 */ GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(152478),
     /* 152324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 152327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 152330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152334 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(152392), // Rule ID 24264 //
     /* 152339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152374 */     // (fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 152377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152379 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152390 */     GIR_RootConstrainSelectedInstOperands,
     /* 152391 */     // GIR_Coverage, 24264,
     /* 152391 */     GIR_EraseRootFromParent_Done,
     /* 152392 */   // Label 3314: @152392
     /* 152392 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(152450), // Rule ID 6261 //
     /* 152397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152432 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 152435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152437 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152448 */     GIR_RootConstrainSelectedInstOperands,
     /* 152449 */     // GIR_Coverage, 6261,
     /* 152449 */     GIR_EraseRootFromParent_Done,
     /* 152450 */   // Label 3315: @152450
     /* 152450 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(152477), // Rule ID 6257 //
     /* 152455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152466 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 152466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 152471 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152475 */     GIR_RootConstrainSelectedInstOperands,
     /* 152476 */     // GIR_Coverage, 6257,
     /* 152476 */     GIR_Done,
     /* 152477 */   // Label 3316: @152477
     /* 152477 */   GIM_Reject,
     /* 152478 */ // Label 3313: @152478
     /* 152478 */ GIM_Reject,
     /* 152479 */ // Label 3219: @152479
     /* 152479 */ GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(152638),
     /* 152484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 152487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 152490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152494 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(152552), // Rule ID 24312 //
     /* 152499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152534 */     // (fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 152537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152539 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152550 */     GIR_RootConstrainSelectedInstOperands,
     /* 152551 */     // GIR_Coverage, 24312,
     /* 152551 */     GIR_EraseRootFromParent_Done,
     /* 152552 */   // Label 3318: @152552
     /* 152552 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(152610), // Rule ID 6333 //
     /* 152557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152592 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 152595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152608 */     GIR_RootConstrainSelectedInstOperands,
     /* 152609 */     // GIR_Coverage, 6333,
     /* 152609 */     GIR_EraseRootFromParent_Done,
     /* 152610 */   // Label 3319: @152610
     /* 152610 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(152637), // Rule ID 6329 //
     /* 152615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152626 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 152626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 152631 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152635 */     GIR_RootConstrainSelectedInstOperands,
     /* 152636 */     // GIR_Coverage, 6329,
     /* 152636 */     GIR_Done,
     /* 152637 */   // Label 3320: @152637
     /* 152637 */   GIM_Reject,
     /* 152638 */ // Label 3317: @152638
     /* 152638 */ GIM_Reject,
     /* 152639 */ // Label 3220: @152639
     /* 152639 */ GIM_Reject,
     /* 152640 */ // Label 42: @152640
     /* 152640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3334*/ GIMT_Encode4(156057),
     /* 152651 */ /*GILLT_s16*//*Label 3321*/ GIMT_Encode4(152735),
     /* 152655 */ /*GILLT_s32*//*Label 3322*/ GIMT_Encode4(152833),
     /* 152659 */ /*GILLT_s64*//*Label 3323*/ GIMT_Encode4(153538),
     /* 152663 */ /*GILLT_s80*//*Label 3324*/ GIMT_Encode4(154387), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152675 */ /*GILLT_v2s64*//*Label 3325*/ GIMT_Encode4(154709), GIMT_Encode4(0),
     /* 152683 */ /*GILLT_v4s32*//*Label 3326*/ GIMT_Encode4(154939),
     /* 152687 */ /*GILLT_v4s64*//*Label 3327*/ GIMT_Encode4(155169), GIMT_Encode4(0),
     /* 152695 */ /*GILLT_v8s16*//*Label 3328*/ GIMT_Encode4(155368),
     /* 152699 */ /*GILLT_v8s32*//*Label 3329*/ GIMT_Encode4(155466),
     /* 152703 */ /*GILLT_v8s64*//*Label 3330*/ GIMT_Encode4(155665), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152715 */ /*GILLT_v16s16*//*Label 3331*/ GIMT_Encode4(155763),
     /* 152719 */ /*GILLT_v16s32*//*Label 3332*/ GIMT_Encode4(155861), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152731 */ /*GILLT_v32s16*//*Label 3333*/ GIMT_Encode4(155959),
     /* 152735 */ // Label 3321: @152735
     /* 152735 */ GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(152832),
     /* 152740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 152743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152754 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(152808), // Rule ID 6069 //
     /* 152759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152770 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152790 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 152793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152806 */     GIR_RootConstrainSelectedInstOperands,
     /* 152807 */     // GIR_Coverage, 6069,
     /* 152807 */     GIR_EraseRootFromParent_Done,
     /* 152808 */   // Label 3336: @152808
     /* 152808 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(152831), // Rule ID 6067 //
     /* 152813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152820 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 152820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 152825 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152829 */     GIR_RootConstrainSelectedInstOperands,
     /* 152830 */     // GIR_Coverage, 6067,
     /* 152830 */     GIR_Done,
     /* 152831 */   // Label 3337: @152831
     /* 152831 */   GIM_Reject,
     /* 152832 */ // Label 3335: @152832
     /* 152832 */ GIM_Reject,
     /* 152833 */ // Label 3322: @152833
     /* 152833 */ GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(153537),
     /* 152838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152844 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(152926), // Rule ID 22473 //
     /* 152849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 152868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152880 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 152887 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152894 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 152898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152907 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 152910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 152924 */     GIR_RootConstrainSelectedInstOperands,
     /* 152925 */     // GIR_Coverage, 22473,
     /* 152925 */     GIR_EraseRootFromParent_Done,
     /* 152926 */   // Label 3339: @152926
     /* 152926 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(153008), // Rule ID 22474 //
     /* 152931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 152934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 152950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152962 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 152969 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152976 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 152980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152989 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 152992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153006 */     GIR_RootConstrainSelectedInstOperands,
     /* 153007 */     // GIR_Coverage, 22474,
     /* 153007 */     GIR_EraseRootFromParent_Done,
     /* 153008 */   // Label 3340: @153008
     /* 153008 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(153090), // Rule ID 22475 //
     /* 153013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153044 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153051 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153058 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153071 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 153074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153088 */     GIR_RootConstrainSelectedInstOperands,
     /* 153089 */     // GIR_Coverage, 22475,
     /* 153089 */     GIR_EraseRootFromParent_Done,
     /* 153090 */   // Label 3341: @153090
     /* 153090 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(153155), // Rule ID 955 //
     /* 153095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 153098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153134 */     // (fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 153137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153153 */     GIR_RootConstrainSelectedInstOperands,
     /* 153154 */     // GIR_Coverage, 955,
     /* 153154 */     GIR_EraseRootFromParent_Done,
     /* 153155 */   // Label 3342: @153155
     /* 153155 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(153220), // Rule ID 933 //
     /* 153160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 153163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153199 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 153202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153218 */     GIR_RootConstrainSelectedInstOperands,
     /* 153219 */     // GIR_Coverage, 933,
     /* 153219 */     GIR_EraseRootFromParent_Done,
     /* 153220 */   // Label 3343: @153220
     /* 153220 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(153282), // Rule ID 2241 //
     /* 153225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153264 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 153267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153280 */     GIR_RootConstrainSelectedInstOperands,
     /* 153281 */     // GIR_Coverage, 2241,
     /* 153281 */     GIR_EraseRootFromParent_Done,
     /* 153282 */   // Label 3344: @153282
     /* 153282 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(153344), // Rule ID 2249 //
     /* 153287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153326 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 153329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153331 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153342 */     GIR_RootConstrainSelectedInstOperands,
     /* 153343 */     // GIR_Coverage, 2249,
     /* 153343 */     GIR_EraseRootFromParent_Done,
     /* 153344 */   // Label 3345: @153344
     /* 153344 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(153406), // Rule ID 6031 //
     /* 153349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153388 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 153391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153395 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153404 */     GIR_RootConstrainSelectedInstOperands,
     /* 153405 */     // GIR_Coverage, 6031,
     /* 153405 */     GIR_EraseRootFromParent_Done,
     /* 153406 */   // Label 3346: @153406
     /* 153406 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(153443), // Rule ID 893 //
     /* 153411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 153414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153426 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 153426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 153431 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 153437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 153441 */     GIR_RootConstrainSelectedInstOperands,
     /* 153442 */     // GIR_Coverage, 893,
     /* 153442 */     GIR_Done,
     /* 153443 */   // Label 3347: @153443
     /* 153443 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(153474), // Rule ID 2239 //
     /* 153448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153463 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 153463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 153468 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153472 */     GIR_RootConstrainSelectedInstOperands,
     /* 153473 */     // GIR_Coverage, 2239,
     /* 153473 */     GIR_Done,
     /* 153474 */   // Label 3348: @153474
     /* 153474 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(153505), // Rule ID 2247 //
     /* 153479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153494 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 153494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 153499 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153503 */     GIR_RootConstrainSelectedInstOperands,
     /* 153504 */     // GIR_Coverage, 2247,
     /* 153504 */     GIR_Done,
     /* 153505 */   // Label 3349: @153505
     /* 153505 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(153536), // Rule ID 6029 //
     /* 153510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153525 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 153525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 153530 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153534 */     GIR_RootConstrainSelectedInstOperands,
     /* 153535 */     // GIR_Coverage, 6029,
     /* 153535 */     GIR_Done,
     /* 153536 */   // Label 3350: @153536
     /* 153536 */   GIM_Reject,
     /* 153537 */ // Label 3338: @153537
     /* 153537 */ GIM_Reject,
     /* 153538 */ // Label 3323: @153538
     /* 153538 */ GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(154386),
     /* 153543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 153546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153549 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(153631), // Rule ID 22476 //
     /* 153554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153585 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153592 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153599 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153612 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 153615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153629 */     GIR_RootConstrainSelectedInstOperands,
     /* 153630 */     // GIR_Coverage, 22476,
     /* 153630 */     GIR_EraseRootFromParent_Done,
     /* 153631 */   // Label 3352: @153631
     /* 153631 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(153713), // Rule ID 22477 //
     /* 153636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153667 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153674 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153681 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153694 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 153697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153711 */     GIR_RootConstrainSelectedInstOperands,
     /* 153712 */     // GIR_Coverage, 22477,
     /* 153712 */     GIR_EraseRootFromParent_Done,
     /* 153713 */   // Label 3353: @153713
     /* 153713 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(153795), // Rule ID 22478 //
     /* 153718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153749 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153752 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153756 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153776 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 153779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153793 */     GIR_RootConstrainSelectedInstOperands,
     /* 153794 */     // GIR_Coverage, 22478,
     /* 153794 */     GIR_EraseRootFromParent_Done,
     /* 153795 */   // Label 3354: @153795
     /* 153795 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(153860), // Rule ID 957 //
     /* 153800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153839 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 153842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153858 */     GIR_RootConstrainSelectedInstOperands,
     /* 153859 */     // GIR_Coverage, 957,
     /* 153859 */     GIR_EraseRootFromParent_Done,
     /* 153860 */   // Label 3355: @153860
     /* 153860 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(153932), // Rule ID 959 //
     /* 153865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153883 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153887 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153894 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153911 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 153914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153916 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153930 */     GIR_RootConstrainSelectedInstOperands,
     /* 153931 */     // GIR_Coverage, 959,
     /* 153931 */     GIR_EraseRootFromParent_Done,
     /* 153932 */   // Label 3356: @153932
     /* 153932 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(153997), // Rule ID 935 //
     /* 153937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153976 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 153979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153995 */     GIR_RootConstrainSelectedInstOperands,
     /* 153996 */     // GIR_Coverage, 935,
     /* 153996 */     GIR_EraseRootFromParent_Done,
     /* 153997 */   // Label 3357: @153997
     /* 153997 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(154069), // Rule ID 937 //
     /* 154002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 154005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154021 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154024 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154028 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154048 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 154051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154067 */     GIR_RootConstrainSelectedInstOperands,
     /* 154068 */     // GIR_Coverage, 937,
     /* 154068 */     GIR_EraseRootFromParent_Done,
     /* 154069 */   // Label 3358: @154069
     /* 154069 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(154131), // Rule ID 2245 //
     /* 154074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154093 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154100 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154113 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 154116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154118 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154129 */     GIR_RootConstrainSelectedInstOperands,
     /* 154130 */     // GIR_Coverage, 2245,
     /* 154130 */     GIR_EraseRootFromParent_Done,
     /* 154131 */   // Label 3359: @154131
     /* 154131 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(154193), // Rule ID 2253 //
     /* 154136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 154139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154155 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154175 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 154178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154191 */     GIR_RootConstrainSelectedInstOperands,
     /* 154192 */     // GIR_Coverage, 2253,
     /* 154192 */     GIR_EraseRootFromParent_Done,
     /* 154193 */   // Label 3360: @154193
     /* 154193 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(154255), // Rule ID 6050 //
     /* 154198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154217 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154220 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154224 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154237 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 154240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154242 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154253 */     GIR_RootConstrainSelectedInstOperands,
     /* 154254 */     // GIR_Coverage, 6050,
     /* 154254 */     GIR_EraseRootFromParent_Done,
     /* 154255 */   // Label 3361: @154255
     /* 154255 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(154292), // Rule ID 895 //
     /* 154260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 154263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154275 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 154275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 154280 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154286 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154290 */     GIR_RootConstrainSelectedInstOperands,
     /* 154291 */     // GIR_Coverage, 895,
     /* 154291 */     GIR_Done,
     /* 154292 */   // Label 3362: @154292
     /* 154292 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(154323), // Rule ID 2243 //
     /* 154297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154312 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 154312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 154317 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154321 */     GIR_RootConstrainSelectedInstOperands,
     /* 154322 */     // GIR_Coverage, 2243,
     /* 154322 */     GIR_Done,
     /* 154323 */   // Label 3363: @154323
     /* 154323 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(154354), // Rule ID 2251 //
     /* 154328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 154331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154343 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 154343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 154348 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154352 */     GIR_RootConstrainSelectedInstOperands,
     /* 154353 */     // GIR_Coverage, 2251,
     /* 154353 */     GIR_Done,
     /* 154354 */   // Label 3364: @154354
     /* 154354 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(154385), // Rule ID 6048 //
     /* 154359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154374 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 154374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 154379 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154383 */     GIR_RootConstrainSelectedInstOperands,
     /* 154384 */     // GIR_Coverage, 6048,
     /* 154384 */     GIR_Done,
     /* 154385 */   // Label 3365: @154385
     /* 154385 */   GIM_Reject,
     /* 154386 */ // Label 3351: @154386
     /* 154386 */ GIM_Reject,
     /* 154387 */ // Label 3324: @154387
     /* 154387 */ GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(154708),
     /* 154392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 154395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 154398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154402 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(154470), // Rule ID 961 //
     /* 154407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154421 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154425 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154449 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 154452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154468 */     GIR_RootConstrainSelectedInstOperands,
     /* 154469 */     // GIR_Coverage, 961,
     /* 154469 */     GIR_EraseRootFromParent_Done,
     /* 154470 */   // Label 3367: @154470
     /* 154470 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(154538), // Rule ID 963 //
     /* 154475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154489 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154493 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154517 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 154520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154536 */     GIR_RootConstrainSelectedInstOperands,
     /* 154537 */     // GIR_Coverage, 963,
     /* 154537 */     GIR_EraseRootFromParent_Done,
     /* 154538 */   // Label 3368: @154538
     /* 154538 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(154606), // Rule ID 939 //
     /* 154543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154561 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154565 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154572 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154585 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 154588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154590 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154604 */     GIR_RootConstrainSelectedInstOperands,
     /* 154605 */     // GIR_Coverage, 939,
     /* 154605 */     GIR_EraseRootFromParent_Done,
     /* 154606 */   // Label 3369: @154606
     /* 154606 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(154674), // Rule ID 941 //
     /* 154611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154629 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154633 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154640 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154653 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 154656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154672 */     GIR_RootConstrainSelectedInstOperands,
     /* 154673 */     // GIR_Coverage, 941,
     /* 154673 */     GIR_EraseRootFromParent_Done,
     /* 154674 */   // Label 3370: @154674
     /* 154674 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(154707), // Rule ID 897 //
     /* 154679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154690 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 154690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 154695 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154701 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154705 */     GIR_RootConstrainSelectedInstOperands,
     /* 154706 */     // GIR_Coverage, 897,
     /* 154706 */     GIR_Done,
     /* 154707 */   // Label 3371: @154707
     /* 154707 */   GIM_Reject,
     /* 154708 */ // Label 3366: @154708
     /* 154708 */ GIM_Reject,
     /* 154709 */ // Label 3325: @154709
     /* 154709 */ GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(154938),
     /* 154714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 154717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154720 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(154782), // Rule ID 2221 //
     /* 154725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154751 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154764 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 154767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154780 */     GIR_RootConstrainSelectedInstOperands,
     /* 154781 */     // GIR_Coverage, 2221,
     /* 154781 */     GIR_EraseRootFromParent_Done,
     /* 154782 */   // Label 3373: @154782
     /* 154782 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(154844), // Rule ID 6543 //
     /* 154787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154826 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 154829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154842 */     GIR_RootConstrainSelectedInstOperands,
     /* 154843 */     // GIR_Coverage, 6543,
     /* 154843 */     GIR_EraseRootFromParent_Done,
     /* 154844 */   // Label 3374: @154844
     /* 154844 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(154875), // Rule ID 2219 //
     /* 154849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154864 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 154864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 154869 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154873 */     GIR_RootConstrainSelectedInstOperands,
     /* 154874 */     // GIR_Coverage, 2219,
     /* 154874 */     GIR_Done,
     /* 154875 */   // Label 3375: @154875
     /* 154875 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(154906), // Rule ID 2235 //
     /* 154880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 154883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154895 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 154895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 154900 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154904 */     GIR_RootConstrainSelectedInstOperands,
     /* 154905 */     // GIR_Coverage, 2235,
     /* 154905 */     GIR_Done,
     /* 154906 */   // Label 3376: @154906
     /* 154906 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(154937), // Rule ID 6539 //
     /* 154911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154926 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 154926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 154931 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154935 */     GIR_RootConstrainSelectedInstOperands,
     /* 154936 */     // GIR_Coverage, 6539,
     /* 154936 */     GIR_Done,
     /* 154937 */   // Label 3377: @154937
     /* 154937 */   GIM_Reject,
     /* 154938 */ // Label 3372: @154938
     /* 154938 */ GIM_Reject,
     /* 154939 */ // Label 3326: @154939
     /* 154939 */ GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(155168),
     /* 154944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154950 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(155012), // Rule ID 2217 //
     /* 154955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154994 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 154997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155010 */     GIR_RootConstrainSelectedInstOperands,
     /* 155011 */     // GIR_Coverage, 2217,
     /* 155011 */     GIR_EraseRootFromParent_Done,
     /* 155012 */   // Label 3379: @155012
     /* 155012 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(155074), // Rule ID 6519 //
     /* 155017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155056 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 155059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155061 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155072 */     GIR_RootConstrainSelectedInstOperands,
     /* 155073 */     // GIR_Coverage, 6519,
     /* 155073 */     GIR_EraseRootFromParent_Done,
     /* 155074 */   // Label 3380: @155074
     /* 155074 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(155105), // Rule ID 2215 //
     /* 155079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155094 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 155094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 155099 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155103 */     GIR_RootConstrainSelectedInstOperands,
     /* 155104 */     // GIR_Coverage, 2215,
     /* 155104 */     GIR_Done,
     /* 155105 */   // Label 3381: @155105
     /* 155105 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(155136), // Rule ID 2231 //
     /* 155110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 155113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155125 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 155125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 155130 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155134 */     GIR_RootConstrainSelectedInstOperands,
     /* 155135 */     // GIR_Coverage, 2231,
     /* 155135 */     GIR_Done,
     /* 155136 */   // Label 3382: @155136
     /* 155136 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(155167), // Rule ID 6515 //
     /* 155141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155156 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 155156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 155161 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155165 */     GIR_RootConstrainSelectedInstOperands,
     /* 155166 */     // GIR_Coverage, 6515,
     /* 155166 */     GIR_Done,
     /* 155167 */   // Label 3383: @155167
     /* 155167 */   GIM_Reject,
     /* 155168 */ // Label 3378: @155168
     /* 155168 */ GIM_Reject,
     /* 155169 */ // Label 3327: @155169
     /* 155169 */ GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(155367),
     /* 155174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 155177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 155180 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(155242), // Rule ID 2229 //
     /* 155185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155224 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 155227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155240 */     GIR_RootConstrainSelectedInstOperands,
     /* 155241 */     // GIR_Coverage, 2229,
     /* 155241 */     GIR_EraseRootFromParent_Done,
     /* 155242 */   // Label 3385: @155242
     /* 155242 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(155304), // Rule ID 6555 //
     /* 155247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155286 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 155289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155302 */     GIR_RootConstrainSelectedInstOperands,
     /* 155303 */     // GIR_Coverage, 6555,
     /* 155303 */     GIR_EraseRootFromParent_Done,
     /* 155304 */   // Label 3386: @155304
     /* 155304 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(155335), // Rule ID 2227 //
     /* 155309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155324 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 155324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 155329 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155333 */     GIR_RootConstrainSelectedInstOperands,
     /* 155334 */     // GIR_Coverage, 2227,
     /* 155334 */     GIR_Done,
     /* 155335 */   // Label 3387: @155335
     /* 155335 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(155366), // Rule ID 6551 //
     /* 155340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155355 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 155355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 155360 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155364 */     GIR_RootConstrainSelectedInstOperands,
     /* 155365 */     // GIR_Coverage, 6551,
     /* 155365 */     GIR_Done,
     /* 155366 */   // Label 3388: @155366
     /* 155366 */   GIM_Reject,
     /* 155367 */ // Label 3384: @155367
     /* 155367 */ GIM_Reject,
     /* 155368 */ // Label 3328: @155368
     /* 155368 */ GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(155465),
     /* 155373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 155379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155387 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(155441), // Rule ID 6579 //
     /* 155392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155423 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 155426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155439 */     GIR_RootConstrainSelectedInstOperands,
     /* 155440 */     // GIR_Coverage, 6579,
     /* 155440 */     GIR_EraseRootFromParent_Done,
     /* 155441 */   // Label 3390: @155441
     /* 155441 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(155464), // Rule ID 6575 //
     /* 155446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155453 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 155453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 155458 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155462 */     GIR_RootConstrainSelectedInstOperands,
     /* 155463 */     // GIR_Coverage, 6575,
     /* 155463 */     GIR_Done,
     /* 155464 */   // Label 3391: @155464
     /* 155464 */   GIM_Reject,
     /* 155465 */ // Label 3389: @155465
     /* 155465 */ GIM_Reject,
     /* 155466 */ // Label 3329: @155466
     /* 155466 */ GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(155664),
     /* 155471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 155474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 155477 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(155539), // Rule ID 2225 //
     /* 155482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155501 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155508 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155521 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 155524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155526 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155528 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155537 */     GIR_RootConstrainSelectedInstOperands,
     /* 155538 */     // GIR_Coverage, 2225,
     /* 155538 */     GIR_EraseRootFromParent_Done,
     /* 155539 */   // Label 3393: @155539
     /* 155539 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(155601), // Rule ID 6531 //
     /* 155544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155563 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155570 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155583 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 155586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155588 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155599 */     GIR_RootConstrainSelectedInstOperands,
     /* 155600 */     // GIR_Coverage, 6531,
     /* 155600 */     GIR_EraseRootFromParent_Done,
     /* 155601 */   // Label 3394: @155601
     /* 155601 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(155632), // Rule ID 2223 //
     /* 155606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155621 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 155621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 155626 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155630 */     GIR_RootConstrainSelectedInstOperands,
     /* 155631 */     // GIR_Coverage, 2223,
     /* 155631 */     GIR_Done,
     /* 155632 */   // Label 3395: @155632
     /* 155632 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(155663), // Rule ID 6527 //
     /* 155637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155652 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 155652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 155657 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155661 */     GIR_RootConstrainSelectedInstOperands,
     /* 155662 */     // GIR_Coverage, 6527,
     /* 155662 */     GIR_Done,
     /* 155663 */   // Label 3396: @155663
     /* 155663 */   GIM_Reject,
     /* 155664 */ // Label 3392: @155664
     /* 155664 */ GIM_Reject,
     /* 155665 */ // Label 3330: @155665
     /* 155665 */ GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(155762),
     /* 155670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 155673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 155676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155684 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(155738), // Rule ID 6507 //
     /* 155689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155700 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155707 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155720 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 155723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155736 */     GIR_RootConstrainSelectedInstOperands,
     /* 155737 */     // GIR_Coverage, 6507,
     /* 155737 */     GIR_EraseRootFromParent_Done,
     /* 155738 */   // Label 3398: @155738
     /* 155738 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(155761), // Rule ID 6503 //
     /* 155743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155750 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 155750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 155755 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155759 */     GIR_RootConstrainSelectedInstOperands,
     /* 155760 */     // GIR_Coverage, 6503,
     /* 155760 */     GIR_Done,
     /* 155761 */   // Label 3399: @155761
     /* 155761 */   GIM_Reject,
     /* 155762 */ // Label 3397: @155762
     /* 155762 */ GIM_Reject,
     /* 155763 */ // Label 3331: @155763
     /* 155763 */ GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(155860),
     /* 155768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 155771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 155774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155782 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(155836), // Rule ID 6591 //
     /* 155787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155818 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 155821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155834 */     GIR_RootConstrainSelectedInstOperands,
     /* 155835 */     // GIR_Coverage, 6591,
     /* 155835 */     GIR_EraseRootFromParent_Done,
     /* 155836 */   // Label 3401: @155836
     /* 155836 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(155859), // Rule ID 6587 //
     /* 155841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155848 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 155848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 155853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155857 */     GIR_RootConstrainSelectedInstOperands,
     /* 155858 */     // GIR_Coverage, 6587,
     /* 155858 */     GIR_Done,
     /* 155859 */   // Label 3402: @155859
     /* 155859 */   GIM_Reject,
     /* 155860 */ // Label 3400: @155860
     /* 155860 */ GIM_Reject,
     /* 155861 */ // Label 3332: @155861
     /* 155861 */ GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(155958),
     /* 155866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 155869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 155872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155880 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(155934), // Rule ID 6495 //
     /* 155885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155916 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 155919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155921 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155932 */     GIR_RootConstrainSelectedInstOperands,
     /* 155933 */     // GIR_Coverage, 6495,
     /* 155933 */     GIR_EraseRootFromParent_Done,
     /* 155934 */   // Label 3404: @155934
     /* 155934 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(155957), // Rule ID 6491 //
     /* 155939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155946 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 155946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 155951 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155955 */     GIR_RootConstrainSelectedInstOperands,
     /* 155956 */     // GIR_Coverage, 6491,
     /* 155956 */     GIR_Done,
     /* 155957 */   // Label 3405: @155957
     /* 155957 */   GIM_Reject,
     /* 155958 */ // Label 3403: @155958
     /* 155958 */ GIM_Reject,
     /* 155959 */ // Label 3333: @155959
     /* 155959 */ GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(156056),
     /* 155964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 155967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 155970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155978 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(156032), // Rule ID 6567 //
     /* 155983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 155986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156014 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 156017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156030 */     GIR_RootConstrainSelectedInstOperands,
     /* 156031 */     // GIR_Coverage, 6567,
     /* 156031 */     GIR_EraseRootFromParent_Done,
     /* 156032 */   // Label 3407: @156032
     /* 156032 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(156055), // Rule ID 6563 //
     /* 156037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 156044 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 156044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 156049 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156053 */     GIR_RootConstrainSelectedInstOperands,
     /* 156054 */     // GIR_Coverage, 6563,
     /* 156054 */     GIR_Done,
     /* 156055 */   // Label 3408: @156055
     /* 156055 */   GIM_Reject,
     /* 156056 */ // Label 3406: @156056
     /* 156056 */ GIM_Reject,
     /* 156057 */ // Label 3334: @156057
     /* 156057 */ GIM_Reject,
     /* 156058 */ // Label 43: @156058
     /* 156058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3422*/ GIMT_Encode4(161207),
     /* 156069 */ /*GILLT_s16*//*Label 3409*/ GIMT_Encode4(156153),
     /* 156073 */ /*GILLT_s32*//*Label 3410*/ GIMT_Encode4(156313),
     /* 156077 */ /*GILLT_s64*//*Label 3411*/ GIMT_Encode4(157450),
     /* 156081 */ /*GILLT_s80*//*Label 3412*/ GIMT_Encode4(158731), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 156093 */ /*GILLT_v2s64*//*Label 3413*/ GIMT_Encode4(159053), GIMT_Encode4(0),
     /* 156101 */ /*GILLT_v4s32*//*Label 3414*/ GIMT_Encode4(159407),
     /* 156105 */ /*GILLT_v4s64*//*Label 3415*/ GIMT_Encode4(159761), GIMT_Encode4(0),
     /* 156113 */ /*GILLT_v8s16*//*Label 3416*/ GIMT_Encode4(160084),
     /* 156117 */ /*GILLT_v8s32*//*Label 3417*/ GIMT_Encode4(160244),
     /* 156121 */ /*GILLT_v8s64*//*Label 3418*/ GIMT_Encode4(160567), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 156133 */ /*GILLT_v16s16*//*Label 3419*/ GIMT_Encode4(160727),
     /* 156137 */ /*GILLT_v16s32*//*Label 3420*/ GIMT_Encode4(160887), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 156149 */ /*GILLT_v32s16*//*Label 3421*/ GIMT_Encode4(161047),
     /* 156153 */ // Label 3409: @156153
     /* 156153 */ GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(156312),
     /* 156158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 156161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156168 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(156226), // Rule ID 24256 //
     /* 156173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156191 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156208 */     // (fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 156211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156224 */     GIR_RootConstrainSelectedInstOperands,
     /* 156225 */     // GIR_Coverage, 24256,
     /* 156225 */     GIR_EraseRootFromParent_Done,
     /* 156226 */   // Label 3424: @156226
     /* 156226 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(156284), // Rule ID 6012 //
     /* 156231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156266 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 156269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156282 */     GIR_RootConstrainSelectedInstOperands,
     /* 156283 */     // GIR_Coverage, 6012,
     /* 156283 */     GIR_EraseRootFromParent_Done,
     /* 156284 */   // Label 3425: @156284
     /* 156284 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(156311), // Rule ID 6010 //
     /* 156289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156300 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 156300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 156305 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156309 */     GIR_RootConstrainSelectedInstOperands,
     /* 156310 */     // GIR_Coverage, 6010,
     /* 156310 */     GIR_Done,
     /* 156311 */   // Label 3426: @156311
     /* 156311 */   GIM_Reject,
     /* 156312 */ // Label 3423: @156312
     /* 156312 */ GIM_Reject,
     /* 156313 */ // Label 3410: @156313
     /* 156313 */ GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(157449),
     /* 156318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 156321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156324 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(156406), // Rule ID 26024 //
     /* 156329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156356 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156363 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156370 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156387 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156404 */     GIR_RootConstrainSelectedInstOperands,
     /* 156405 */     // GIR_Coverage, 26024,
     /* 156405 */     GIR_EraseRootFromParent_Done,
     /* 156406 */   // Label 3428: @156406
     /* 156406 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(156488), // Rule ID 26025 //
     /* 156411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156438 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156445 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156452 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156469 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156486 */     GIR_RootConstrainSelectedInstOperands,
     /* 156487 */     // GIR_Coverage, 26025,
     /* 156487 */     GIR_EraseRootFromParent_Done,
     /* 156488 */   // Label 3429: @156488
     /* 156488 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(156570), // Rule ID 26026 //
     /* 156493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156520 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156527 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156551 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 156554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156568 */     GIR_RootConstrainSelectedInstOperands,
     /* 156569 */     // GIR_Coverage, 26026,
     /* 156569 */     GIR_EraseRootFromParent_Done,
     /* 156570 */   // Label 3430: @156570
     /* 156570 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(156652), // Rule ID 22479 //
     /* 156575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156606 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156613 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156620 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156633 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156650 */     GIR_RootConstrainSelectedInstOperands,
     /* 156651 */     // GIR_Coverage, 22479,
     /* 156651 */     GIR_EraseRootFromParent_Done,
     /* 156652 */   // Label 3431: @156652
     /* 156652 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(156734), // Rule ID 22480 //
     /* 156657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156688 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156695 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156702 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156715 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156732 */     GIR_RootConstrainSelectedInstOperands,
     /* 156733 */     // GIR_Coverage, 22480,
     /* 156733 */     GIR_EraseRootFromParent_Done,
     /* 156734 */   // Label 3432: @156734
     /* 156734 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(156816), // Rule ID 22481 //
     /* 156739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156770 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156777 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156784 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156797 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 156800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156814 */     GIR_RootConstrainSelectedInstOperands,
     /* 156815 */     // GIR_Coverage, 22481,
     /* 156815 */     GIR_EraseRootFromParent_Done,
     /* 156816 */   // Label 3433: @156816
     /* 156816 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(156881), // Rule ID 23259 //
     /* 156821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 156824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156860 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 156863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156879 */     GIR_RootConstrainSelectedInstOperands,
     /* 156880 */     // GIR_Coverage, 23259,
     /* 156880 */     GIR_EraseRootFromParent_Done,
     /* 156881 */   // Label 3434: @156881
     /* 156881 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(156943), // Rule ID 23402 //
     /* 156886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156901 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156925 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156941 */     GIR_RootConstrainSelectedInstOperands,
     /* 156942 */     // GIR_Coverage, 23402,
     /* 156942 */     GIR_EraseRootFromParent_Done,
     /* 156943 */   // Label 3435: @156943
     /* 156943 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(157005), // Rule ID 23406 //
     /* 156948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156963 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156966 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156970 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156987 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157003 */     GIR_RootConstrainSelectedInstOperands,
     /* 157004 */     // GIR_Coverage, 23406,
     /* 157004 */     GIR_EraseRootFromParent_Done,
     /* 157005 */   // Label 3436: @157005
     /* 157005 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(157067), // Rule ID 24252 //
     /* 157010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157032 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157049 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 157052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157065 */     GIR_RootConstrainSelectedInstOperands,
     /* 157066 */     // GIR_Coverage, 24252,
     /* 157066 */     GIR_EraseRootFromParent_Done,
     /* 157067 */   // Label 3437: @157067
     /* 157067 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(157132), // Rule ID 977 //
     /* 157072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 157075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157111 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 157114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 157125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157130 */     GIR_RootConstrainSelectedInstOperands,
     /* 157131 */     // GIR_Coverage, 977,
     /* 157131 */     GIR_EraseRootFromParent_Done,
     /* 157132 */   // Label 3438: @157132
     /* 157132 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(157194), // Rule ID 2201 //
     /* 157137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157176 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 157179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157192 */     GIR_RootConstrainSelectedInstOperands,
     /* 157193 */     // GIR_Coverage, 2201,
     /* 157193 */     GIR_EraseRootFromParent_Done,
     /* 157194 */   // Label 3439: @157194
     /* 157194 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(157256), // Rule ID 2209 //
     /* 157199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157238 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 157241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157254 */     GIR_RootConstrainSelectedInstOperands,
     /* 157255 */     // GIR_Coverage, 2209,
     /* 157255 */     GIR_EraseRootFromParent_Done,
     /* 157256 */   // Label 3440: @157256
     /* 157256 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(157318), // Rule ID 5974 //
     /* 157261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157300 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 157303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157305 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157316 */     GIR_RootConstrainSelectedInstOperands,
     /* 157317 */     // GIR_Coverage, 5974,
     /* 157317 */     GIR_EraseRootFromParent_Done,
     /* 157318 */   // Label 3441: @157318
     /* 157318 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(157355), // Rule ID 899 //
     /* 157323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 157326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157338 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 157338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 157343 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 157349 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 157353 */     GIR_RootConstrainSelectedInstOperands,
     /* 157354 */     // GIR_Coverage, 899,
     /* 157354 */     GIR_Done,
     /* 157355 */   // Label 3442: @157355
     /* 157355 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(157386), // Rule ID 2199 //
     /* 157360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157375 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 157375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 157380 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157384 */     GIR_RootConstrainSelectedInstOperands,
     /* 157385 */     // GIR_Coverage, 2199,
     /* 157385 */     GIR_Done,
     /* 157386 */   // Label 3443: @157386
     /* 157386 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(157417), // Rule ID 2207 //
     /* 157391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157406 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 157406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 157411 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157415 */     GIR_RootConstrainSelectedInstOperands,
     /* 157416 */     // GIR_Coverage, 2207,
     /* 157416 */     GIR_Done,
     /* 157417 */   // Label 3444: @157417
     /* 157417 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(157448), // Rule ID 5972 //
     /* 157422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157437 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 157437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 157442 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157446 */     GIR_RootConstrainSelectedInstOperands,
     /* 157447 */     // GIR_Coverage, 5972,
     /* 157447 */     GIR_Done,
     /* 157448 */   // Label 3445: @157448
     /* 157448 */   GIM_Reject,
     /* 157449 */ // Label 3427: @157449
     /* 157449 */ GIM_Reject,
     /* 157450 */ // Label 3411: @157450
     /* 157450 */ GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(158730),
     /* 157455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 157458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157461 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(157543), // Rule ID 26027 //
     /* 157466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157493 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157500 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157507 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157524 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 157527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157541 */     GIR_RootConstrainSelectedInstOperands,
     /* 157542 */     // GIR_Coverage, 26027,
     /* 157542 */     GIR_EraseRootFromParent_Done,
     /* 157543 */   // Label 3447: @157543
     /* 157543 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(157625), // Rule ID 26028 //
     /* 157548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157575 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157582 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157589 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157606 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 157609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157623 */     GIR_RootConstrainSelectedInstOperands,
     /* 157624 */     // GIR_Coverage, 26028,
     /* 157624 */     GIR_EraseRootFromParent_Done,
     /* 157625 */   // Label 3448: @157625
     /* 157625 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(157707), // Rule ID 26029 //
     /* 157630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157657 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157664 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157671 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157688 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157705 */     GIR_RootConstrainSelectedInstOperands,
     /* 157706 */     // GIR_Coverage, 26029,
     /* 157706 */     GIR_EraseRootFromParent_Done,
     /* 157707 */   // Label 3449: @157707
     /* 157707 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(157789), // Rule ID 22482 //
     /* 157712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157743 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157750 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157757 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157770 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 157773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157787 */     GIR_RootConstrainSelectedInstOperands,
     /* 157788 */     // GIR_Coverage, 22482,
     /* 157788 */     GIR_EraseRootFromParent_Done,
     /* 157789 */   // Label 3450: @157789
     /* 157789 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(157871), // Rule ID 22483 //
     /* 157794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157825 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157832 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157839 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157852 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 157855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157857 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157869 */     GIR_RootConstrainSelectedInstOperands,
     /* 157870 */     // GIR_Coverage, 22483,
     /* 157870 */     GIR_EraseRootFromParent_Done,
     /* 157871 */   // Label 3451: @157871
     /* 157871 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(157953), // Rule ID 22484 //
     /* 157876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157907 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157914 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157921 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157934 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157951 */     GIR_RootConstrainSelectedInstOperands,
     /* 157952 */     // GIR_Coverage, 22484,
     /* 157952 */     GIR_EraseRootFromParent_Done,
     /* 157953 */   // Label 3452: @157953
     /* 157953 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(158018), // Rule ID 23261 //
     /* 157958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 157961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157997 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 158000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158016 */     GIR_RootConstrainSelectedInstOperands,
     /* 158017 */     // GIR_Coverage, 23261,
     /* 158017 */     GIR_EraseRootFromParent_Done,
     /* 158018 */   // Label 3453: @158018
     /* 158018 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(158090), // Rule ID 23263 //
     /* 158023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158038 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158041 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158045 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158069 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 158072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158088 */     GIR_RootConstrainSelectedInstOperands,
     /* 158089 */     // GIR_Coverage, 23263,
     /* 158089 */     GIR_EraseRootFromParent_Done,
     /* 158090 */   // Label 3454: @158090
     /* 158090 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(158152), // Rule ID 23404 //
     /* 158095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158134 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 158137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158150 */     GIR_RootConstrainSelectedInstOperands,
     /* 158151 */     // GIR_Coverage, 23404,
     /* 158151 */     GIR_EraseRootFromParent_Done,
     /* 158152 */   // Label 3455: @158152
     /* 158152 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(158214), // Rule ID 23408 //
     /* 158157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158172 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158196 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 158199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158212 */     GIR_RootConstrainSelectedInstOperands,
     /* 158213 */     // GIR_Coverage, 23408,
     /* 158213 */     GIR_EraseRootFromParent_Done,
     /* 158214 */   // Label 3456: @158214
     /* 158214 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(158276), // Rule ID 24254 //
     /* 158219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158234 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158237 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158241 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158258 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 158261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158274 */     GIR_RootConstrainSelectedInstOperands,
     /* 158275 */     // GIR_Coverage, 24254,
     /* 158275 */     GIR_EraseRootFromParent_Done,
     /* 158276 */   // Label 3457: @158276
     /* 158276 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(158341), // Rule ID 979 //
     /* 158281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158320 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 158323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158339 */     GIR_RootConstrainSelectedInstOperands,
     /* 158340 */     // GIR_Coverage, 979,
     /* 158340 */     GIR_EraseRootFromParent_Done,
     /* 158341 */   // Label 3458: @158341
     /* 158341 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(158413), // Rule ID 981 //
     /* 158346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158368 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158372 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158392 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 158395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158411 */     GIR_RootConstrainSelectedInstOperands,
     /* 158412 */     // GIR_Coverage, 981,
     /* 158412 */     GIR_EraseRootFromParent_Done,
     /* 158413 */   // Label 3459: @158413
     /* 158413 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(158475), // Rule ID 2205 //
     /* 158418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158457 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 158460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158473 */     GIR_RootConstrainSelectedInstOperands,
     /* 158474 */     // GIR_Coverage, 2205,
     /* 158474 */     GIR_EraseRootFromParent_Done,
     /* 158475 */   // Label 3460: @158475
     /* 158475 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(158537), // Rule ID 2213 //
     /* 158480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158519 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 158522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158535 */     GIR_RootConstrainSelectedInstOperands,
     /* 158536 */     // GIR_Coverage, 2213,
     /* 158536 */     GIR_EraseRootFromParent_Done,
     /* 158537 */   // Label 3461: @158537
     /* 158537 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(158599), // Rule ID 5993 //
     /* 158542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158581 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 158584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158597 */     GIR_RootConstrainSelectedInstOperands,
     /* 158598 */     // GIR_Coverage, 5993,
     /* 158598 */     GIR_EraseRootFromParent_Done,
     /* 158599 */   // Label 3462: @158599
     /* 158599 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(158636), // Rule ID 901 //
     /* 158604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158619 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 158619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 158624 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 158630 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 158634 */     GIR_RootConstrainSelectedInstOperands,
     /* 158635 */     // GIR_Coverage, 901,
     /* 158635 */     GIR_Done,
     /* 158636 */   // Label 3463: @158636
     /* 158636 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(158667), // Rule ID 2203 //
     /* 158641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158656 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 158656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 158661 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158665 */     GIR_RootConstrainSelectedInstOperands,
     /* 158666 */     // GIR_Coverage, 2203,
     /* 158666 */     GIR_Done,
     /* 158667 */   // Label 3464: @158667
     /* 158667 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(158698), // Rule ID 2211 //
     /* 158672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158687 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 158687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 158692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158696 */     GIR_RootConstrainSelectedInstOperands,
     /* 158697 */     // GIR_Coverage, 2211,
     /* 158697 */     GIR_Done,
     /* 158698 */   // Label 3465: @158698
     /* 158698 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(158729), // Rule ID 5991 //
     /* 158703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158718 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 158718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 158723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158727 */     GIR_RootConstrainSelectedInstOperands,
     /* 158728 */     // GIR_Coverage, 5991,
     /* 158728 */     GIR_Done,
     /* 158729 */   // Label 3466: @158729
     /* 158729 */   GIM_Reject,
     /* 158730 */ // Label 3446: @158730
     /* 158730 */ GIM_Reject,
     /* 158731 */ // Label 3412: @158731
     /* 158731 */ GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(159052),
     /* 158736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 158739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 158742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158746 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(158814), // Rule ID 23265 //
     /* 158751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158762 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158765 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158769 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158793 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 158796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158812 */     GIR_RootConstrainSelectedInstOperands,
     /* 158813 */     // GIR_Coverage, 23265,
     /* 158813 */     GIR_EraseRootFromParent_Done,
     /* 158814 */   // Label 3468: @158814
     /* 158814 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(158882), // Rule ID 23267 //
     /* 158819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158830 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158833 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158837 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158861 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 158864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158866 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158880 */     GIR_RootConstrainSelectedInstOperands,
     /* 158881 */     // GIR_Coverage, 23267,
     /* 158881 */     GIR_EraseRootFromParent_Done,
     /* 158882 */   // Label 3469: @158882
     /* 158882 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(158950), // Rule ID 983 //
     /* 158887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158905 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158909 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158929 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 158932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158948 */     GIR_RootConstrainSelectedInstOperands,
     /* 158949 */     // GIR_Coverage, 983,
     /* 158949 */     GIR_EraseRootFromParent_Done,
     /* 158950 */   // Label 3470: @158950
     /* 158950 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(159018), // Rule ID 985 //
     /* 158955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158970 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158973 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158977 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158984 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158997 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 159000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159002 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159016 */     GIR_RootConstrainSelectedInstOperands,
     /* 159017 */     // GIR_Coverage, 985,
     /* 159017 */     GIR_EraseRootFromParent_Done,
     /* 159018 */   // Label 3471: @159018
     /* 159018 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(159051), // Rule ID 903 //
     /* 159023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 159026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 159030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 159034 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 159034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 159039 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 159045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 159049 */     GIR_RootConstrainSelectedInstOperands,
     /* 159050 */     // GIR_Coverage, 903,
     /* 159050 */     GIR_Done,
     /* 159051 */   // Label 3472: @159051
     /* 159051 */   GIM_Reject,
     /* 159052 */ // Label 3467: @159052
     /* 159052 */ GIM_Reject,
     /* 159053 */ // Label 3413: @159053
     /* 159053 */ GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(159406),
     /* 159058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159064 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(159126), // Rule ID 23392 //
     /* 159069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159084 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159091 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159108 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 159111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159113 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159124 */     GIR_RootConstrainSelectedInstOperands,
     /* 159125 */     // GIR_Coverage, 23392,
     /* 159125 */     GIR_EraseRootFromParent_Done,
     /* 159126 */   // Label 3474: @159126
     /* 159126 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(159188), // Rule ID 24368 //
     /* 159131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159170 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 159173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159175 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159186 */     GIR_RootConstrainSelectedInstOperands,
     /* 159187 */     // GIR_Coverage, 24368,
     /* 159187 */     GIR_EraseRootFromParent_Done,
     /* 159188 */   // Label 3475: @159188
     /* 159188 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(159250), // Rule ID 2181 //
     /* 159193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159232 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 159235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159237 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159248 */     GIR_RootConstrainSelectedInstOperands,
     /* 159249 */     // GIR_Coverage, 2181,
     /* 159249 */     GIR_EraseRootFromParent_Done,
     /* 159250 */   // Label 3476: @159250
     /* 159250 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(159312), // Rule ID 6426 //
     /* 159255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159294 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 159297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159310 */     GIR_RootConstrainSelectedInstOperands,
     /* 159311 */     // GIR_Coverage, 6426,
     /* 159311 */     GIR_EraseRootFromParent_Done,
     /* 159312 */   // Label 3477: @159312
     /* 159312 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(159343), // Rule ID 2179 //
     /* 159317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159332 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 159332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 159337 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159341 */     GIR_RootConstrainSelectedInstOperands,
     /* 159342 */     // GIR_Coverage, 2179,
     /* 159342 */     GIR_Done,
     /* 159343 */   // Label 3478: @159343
     /* 159343 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(159374), // Rule ID 2195 //
     /* 159348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 159351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159363 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 159363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 159368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159372 */     GIR_RootConstrainSelectedInstOperands,
     /* 159373 */     // GIR_Coverage, 2195,
     /* 159373 */     GIR_Done,
     /* 159374 */   // Label 3479: @159374
     /* 159374 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(159405), // Rule ID 6422 //
     /* 159379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159394 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 159394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 159399 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159403 */     GIR_RootConstrainSelectedInstOperands,
     /* 159404 */     // GIR_Coverage, 6422,
     /* 159404 */     GIR_Done,
     /* 159405 */   // Label 3480: @159405
     /* 159405 */   GIM_Reject,
     /* 159406 */ // Label 3473: @159406
     /* 159406 */ GIM_Reject,
     /* 159407 */ // Label 3414: @159407
     /* 159407 */ GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(159760),
     /* 159412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159418 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(159480), // Rule ID 23390 //
     /* 159423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159462 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 159465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159467 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159478 */     GIR_RootConstrainSelectedInstOperands,
     /* 159479 */     // GIR_Coverage, 23390,
     /* 159479 */     GIR_EraseRootFromParent_Done,
     /* 159480 */   // Label 3482: @159480
     /* 159480 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(159542), // Rule ID 24352 //
     /* 159485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159524 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 159527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159540 */     GIR_RootConstrainSelectedInstOperands,
     /* 159541 */     // GIR_Coverage, 24352,
     /* 159541 */     GIR_EraseRootFromParent_Done,
     /* 159542 */   // Label 3483: @159542
     /* 159542 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(159604), // Rule ID 2177 //
     /* 159547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159573 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159586 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 159589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159602 */     GIR_RootConstrainSelectedInstOperands,
     /* 159603 */     // GIR_Coverage, 2177,
     /* 159603 */     GIR_EraseRootFromParent_Done,
     /* 159604 */   // Label 3484: @159604
     /* 159604 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(159666), // Rule ID 6402 //
     /* 159609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159648 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 159651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159664 */     GIR_RootConstrainSelectedInstOperands,
     /* 159665 */     // GIR_Coverage, 6402,
     /* 159665 */     GIR_EraseRootFromParent_Done,
     /* 159666 */   // Label 3485: @159666
     /* 159666 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(159697), // Rule ID 2175 //
     /* 159671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159686 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 159686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 159691 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159695 */     GIR_RootConstrainSelectedInstOperands,
     /* 159696 */     // GIR_Coverage, 2175,
     /* 159696 */     GIR_Done,
     /* 159697 */   // Label 3486: @159697
     /* 159697 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(159728), // Rule ID 2191 //
     /* 159702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159717 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 159717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 159722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159726 */     GIR_RootConstrainSelectedInstOperands,
     /* 159727 */     // GIR_Coverage, 2191,
     /* 159727 */     GIR_Done,
     /* 159728 */   // Label 3487: @159728
     /* 159728 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(159759), // Rule ID 6398 //
     /* 159733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159748 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 159748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 159753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159757 */     GIR_RootConstrainSelectedInstOperands,
     /* 159758 */     // GIR_Coverage, 6398,
     /* 159758 */     GIR_Done,
     /* 159759 */   // Label 3488: @159759
     /* 159759 */   GIM_Reject,
     /* 159760 */ // Label 3481: @159760
     /* 159760 */ GIM_Reject,
     /* 159761 */ // Label 3415: @159761
     /* 159761 */ GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(160083),
     /* 159766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 159769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 159772 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(159834), // Rule ID 23396 //
     /* 159777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159816 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 159819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159832 */     GIR_RootConstrainSelectedInstOperands,
     /* 159833 */     // GIR_Coverage, 23396,
     /* 159833 */     GIR_EraseRootFromParent_Done,
     /* 159834 */   // Label 3490: @159834
     /* 159834 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(159896), // Rule ID 24376 //
     /* 159839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159878 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 159881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159894 */     GIR_RootConstrainSelectedInstOperands,
     /* 159895 */     // GIR_Coverage, 24376,
     /* 159895 */     GIR_EraseRootFromParent_Done,
     /* 159896 */   // Label 3491: @159896
     /* 159896 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(159958), // Rule ID 2189 //
     /* 159901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159940 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 159943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159956 */     GIR_RootConstrainSelectedInstOperands,
     /* 159957 */     // GIR_Coverage, 2189,
     /* 159957 */     GIR_EraseRootFromParent_Done,
     /* 159958 */   // Label 3492: @159958
     /* 159958 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(160020), // Rule ID 6438 //
     /* 159963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160002 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 160005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160018 */     GIR_RootConstrainSelectedInstOperands,
     /* 160019 */     // GIR_Coverage, 6438,
     /* 160019 */     GIR_EraseRootFromParent_Done,
     /* 160020 */   // Label 3493: @160020
     /* 160020 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(160051), // Rule ID 2187 //
     /* 160025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160040 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 160040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 160045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160049 */     GIR_RootConstrainSelectedInstOperands,
     /* 160050 */     // GIR_Coverage, 2187,
     /* 160050 */     GIR_Done,
     /* 160051 */   // Label 3494: @160051
     /* 160051 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(160082), // Rule ID 6434 //
     /* 160056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160071 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 160071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 160076 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160080 */     GIR_RootConstrainSelectedInstOperands,
     /* 160081 */     // GIR_Coverage, 6434,
     /* 160081 */     GIR_Done,
     /* 160082 */   // Label 3495: @160082
     /* 160082 */   GIM_Reject,
     /* 160083 */ // Label 3489: @160083
     /* 160083 */ GIM_Reject,
     /* 160084 */ // Label 3416: @160084
     /* 160084 */ GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(160243),
     /* 160089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160099 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(160157), // Rule ID 24392 //
     /* 160104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160139 */     // (fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 160142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160155 */     GIR_RootConstrainSelectedInstOperands,
     /* 160156 */     // GIR_Coverage, 24392,
     /* 160156 */     GIR_EraseRootFromParent_Done,
     /* 160157 */   // Label 3497: @160157
     /* 160157 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(160215), // Rule ID 6462 //
     /* 160162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160177 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160180 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160184 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160197 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 160200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160213 */     GIR_RootConstrainSelectedInstOperands,
     /* 160214 */     // GIR_Coverage, 6462,
     /* 160214 */     GIR_EraseRootFromParent_Done,
     /* 160215 */   // Label 3498: @160215
     /* 160215 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(160242), // Rule ID 6458 //
     /* 160220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160231 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 160231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 160236 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160240 */     GIR_RootConstrainSelectedInstOperands,
     /* 160241 */     // GIR_Coverage, 6458,
     /* 160241 */     GIR_Done,
     /* 160242 */   // Label 3499: @160242
     /* 160242 */   GIM_Reject,
     /* 160243 */ // Label 3496: @160243
     /* 160243 */ GIM_Reject,
     /* 160244 */ // Label 3417: @160244
     /* 160244 */ GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(160566),
     /* 160249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 160252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 160255 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(160317), // Rule ID 23394 //
     /* 160260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160275 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160282 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160299 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 160302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160315 */     GIR_RootConstrainSelectedInstOperands,
     /* 160316 */     // GIR_Coverage, 23394,
     /* 160316 */     GIR_EraseRootFromParent_Done,
     /* 160317 */   // Label 3501: @160317
     /* 160317 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(160379), // Rule ID 24360 //
     /* 160322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160361 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 160364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160377 */     GIR_RootConstrainSelectedInstOperands,
     /* 160378 */     // GIR_Coverage, 24360,
     /* 160378 */     GIR_EraseRootFromParent_Done,
     /* 160379 */   // Label 3502: @160379
     /* 160379 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(160441), // Rule ID 2185 //
     /* 160384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160423 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 160426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160439 */     GIR_RootConstrainSelectedInstOperands,
     /* 160440 */     // GIR_Coverage, 2185,
     /* 160440 */     GIR_EraseRootFromParent_Done,
     /* 160441 */   // Label 3503: @160441
     /* 160441 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(160503), // Rule ID 6414 //
     /* 160446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160485 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 160488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160501 */     GIR_RootConstrainSelectedInstOperands,
     /* 160502 */     // GIR_Coverage, 6414,
     /* 160502 */     GIR_EraseRootFromParent_Done,
     /* 160503 */   // Label 3504: @160503
     /* 160503 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(160534), // Rule ID 2183 //
     /* 160508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160523 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 160523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 160528 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160532 */     GIR_RootConstrainSelectedInstOperands,
     /* 160533 */     // GIR_Coverage, 2183,
     /* 160533 */     GIR_Done,
     /* 160534 */   // Label 3505: @160534
     /* 160534 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(160565), // Rule ID 6410 //
     /* 160539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160554 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 160554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 160559 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160563 */     GIR_RootConstrainSelectedInstOperands,
     /* 160564 */     // GIR_Coverage, 6410,
     /* 160564 */     GIR_Done,
     /* 160565 */   // Label 3506: @160565
     /* 160565 */   GIM_Reject,
     /* 160566 */ // Label 3500: @160566
     /* 160566 */ GIM_Reject,
     /* 160567 */ // Label 3418: @160567
     /* 160567 */ GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(160726),
     /* 160572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 160575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 160578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160582 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(160640), // Rule ID 24344 //
     /* 160587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160622 */     // (fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 160625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160627 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160629 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160638 */     GIR_RootConstrainSelectedInstOperands,
     /* 160639 */     // GIR_Coverage, 24344,
     /* 160639 */     GIR_EraseRootFromParent_Done,
     /* 160640 */   // Label 3508: @160640
     /* 160640 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(160698), // Rule ID 6390 //
     /* 160645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160680 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 160683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160696 */     GIR_RootConstrainSelectedInstOperands,
     /* 160697 */     // GIR_Coverage, 6390,
     /* 160697 */     GIR_EraseRootFromParent_Done,
     /* 160698 */   // Label 3509: @160698
     /* 160698 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(160725), // Rule ID 6386 //
     /* 160703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160714 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 160714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 160719 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160723 */     GIR_RootConstrainSelectedInstOperands,
     /* 160724 */     // GIR_Coverage, 6386,
     /* 160724 */     GIR_Done,
     /* 160725 */   // Label 3510: @160725
     /* 160725 */   GIM_Reject,
     /* 160726 */ // Label 3507: @160726
     /* 160726 */ GIM_Reject,
     /* 160727 */ // Label 3419: @160727
     /* 160727 */ GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(160886),
     /* 160732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 160735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 160738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160742 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(160800), // Rule ID 24400 //
     /* 160747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160782 */     // (fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 160785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160798 */     GIR_RootConstrainSelectedInstOperands,
     /* 160799 */     // GIR_Coverage, 24400,
     /* 160799 */     GIR_EraseRootFromParent_Done,
     /* 160800 */   // Label 3512: @160800
     /* 160800 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(160858), // Rule ID 6474 //
     /* 160805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160840 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 160843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160856 */     GIR_RootConstrainSelectedInstOperands,
     /* 160857 */     // GIR_Coverage, 6474,
     /* 160857 */     GIR_EraseRootFromParent_Done,
     /* 160858 */   // Label 3513: @160858
     /* 160858 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(160885), // Rule ID 6470 //
     /* 160863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160874 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 160874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 160879 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160883 */     GIR_RootConstrainSelectedInstOperands,
     /* 160884 */     // GIR_Coverage, 6470,
     /* 160884 */     GIR_Done,
     /* 160885 */   // Label 3514: @160885
     /* 160885 */   GIM_Reject,
     /* 160886 */ // Label 3511: @160886
     /* 160886 */ GIM_Reject,
     /* 160887 */ // Label 3420: @160887
     /* 160887 */ GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(161046),
     /* 160892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 160895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 160898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160902 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(160960), // Rule ID 24336 //
     /* 160907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160942 */     // (fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 160945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160947 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160958 */     GIR_RootConstrainSelectedInstOperands,
     /* 160959 */     // GIR_Coverage, 24336,
     /* 160959 */     GIR_EraseRootFromParent_Done,
     /* 160960 */   // Label 3516: @160960
     /* 160960 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(161018), // Rule ID 6378 //
     /* 160965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161000 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 161003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161016 */     GIR_RootConstrainSelectedInstOperands,
     /* 161017 */     // GIR_Coverage, 6378,
     /* 161017 */     GIR_EraseRootFromParent_Done,
     /* 161018 */   // Label 3517: @161018
     /* 161018 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(161045), // Rule ID 6374 //
     /* 161023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161034 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 161034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 161039 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161043 */     GIR_RootConstrainSelectedInstOperands,
     /* 161044 */     // GIR_Coverage, 6374,
     /* 161044 */     GIR_Done,
     /* 161045 */   // Label 3518: @161045
     /* 161045 */   GIM_Reject,
     /* 161046 */ // Label 3515: @161046
     /* 161046 */ GIM_Reject,
     /* 161047 */ // Label 3421: @161047
     /* 161047 */ GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(161206),
     /* 161052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 161055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 161058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161062 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(161120), // Rule ID 24384 //
     /* 161067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161102 */     // (fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 161105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161118 */     GIR_RootConstrainSelectedInstOperands,
     /* 161119 */     // GIR_Coverage, 24384,
     /* 161119 */     GIR_EraseRootFromParent_Done,
     /* 161120 */   // Label 3520: @161120
     /* 161120 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(161178), // Rule ID 6450 //
     /* 161125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161160 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 161163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161176 */     GIR_RootConstrainSelectedInstOperands,
     /* 161177 */     // GIR_Coverage, 6450,
     /* 161177 */     GIR_EraseRootFromParent_Done,
     /* 161178 */   // Label 3521: @161178
     /* 161178 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(161205), // Rule ID 6446 //
     /* 161183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161194 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 161194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 161199 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161203 */     GIR_RootConstrainSelectedInstOperands,
     /* 161204 */     // GIR_Coverage, 6446,
     /* 161204 */     GIR_Done,
     /* 161205 */   // Label 3522: @161205
     /* 161205 */   GIM_Reject,
     /* 161206 */ // Label 3519: @161206
     /* 161206 */ GIM_Reject,
     /* 161207 */ // Label 3422: @161207
     /* 161207 */ GIM_Reject,
     /* 161208 */ // Label 44: @161208
     /* 161208 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3535*/ GIMT_Encode4(167195),
     /* 161219 */ /*GILLT_s16*//*Label 3523*/ GIMT_Encode4(161303),
     /* 161223 */ /*GILLT_s32*//*Label 3524*/ GIMT_Encode4(161548),
     /* 161227 */ /*GILLT_s64*//*Label 3525*/ GIMT_Encode4(162285), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 161243 */ /*GILLT_v2s64*//*Label 3526*/ GIMT_Encode4(163022), GIMT_Encode4(0),
     /* 161251 */ /*GILLT_v4s32*//*Label 3527*/ GIMT_Encode4(163759),
     /* 161255 */ /*GILLT_v4s64*//*Label 3528*/ GIMT_Encode4(164496), GIMT_Encode4(0),
     /* 161263 */ /*GILLT_v8s16*//*Label 3529*/ GIMT_Encode4(165233),
     /* 161267 */ /*GILLT_v8s32*//*Label 3530*/ GIMT_Encode4(165478),
     /* 161271 */ /*GILLT_v8s64*//*Label 3531*/ GIMT_Encode4(166215), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 161283 */ /*GILLT_v16s16*//*Label 3532*/ GIMT_Encode4(166460),
     /* 161287 */ /*GILLT_v16s32*//*Label 3533*/ GIMT_Encode4(166705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 161299 */ /*GILLT_v32s16*//*Label 3534*/ GIMT_Encode4(166950),
     /* 161303 */ // Label 3523: @161303
     /* 161303 */ GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(161547),
     /* 161308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 161311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161321 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(161385), // Rule ID 10158 //
     /* 161326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161365 */     // (fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 161368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161372 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161383 */     GIR_RootConstrainSelectedInstOperands,
     /* 161384 */     // GIR_Coverage, 10158,
     /* 161384 */     GIR_EraseRootFromParent_Done,
     /* 161385 */   // Label 3537: @161385
     /* 161385 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(161449), // Rule ID 10156 //
     /* 161390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161405 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161412 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161429 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 161432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161434 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161447 */     GIR_RootConstrainSelectedInstOperands,
     /* 161448 */     // GIR_Coverage, 10156,
     /* 161448 */     GIR_EraseRootFromParent_Done,
     /* 161449 */   // Label 3538: @161449
     /* 161449 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(161513), // Rule ID 10153 //
     /* 161454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161493 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 161496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161500 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161511 */     GIR_RootConstrainSelectedInstOperands,
     /* 161512 */     // GIR_Coverage, 10153,
     /* 161512 */     GIR_EraseRootFromParent_Done,
     /* 161513 */   // Label 3539: @161513
     /* 161513 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(161546), // Rule ID 10151 //
     /* 161518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161533 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 161533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 161536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161538 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161540 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161542 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161544 */     GIR_RootConstrainSelectedInstOperands,
     /* 161545 */     // GIR_Coverage, 10151,
     /* 161545 */     GIR_EraseRootFromParent_Done,
     /* 161546 */   // Label 3540: @161546
     /* 161546 */   GIM_Reject,
     /* 161547 */ // Label 3536: @161547
     /* 161547 */ GIM_Reject,
     /* 161548 */ // Label 3524: @161548
     /* 161548 */ GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(162284),
     /* 161553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161562 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(161630), // Rule ID 1304 //
     /* 161567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161610 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 161613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161617 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161628 */     GIR_RootConstrainSelectedInstOperands,
     /* 161629 */     // GIR_Coverage, 1304,
     /* 161629 */     GIR_EraseRootFromParent_Done,
     /* 161630 */   // Label 3542: @161630
     /* 161630 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(161698), // Rule ID 10140 //
     /* 161635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161678 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 161681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161683 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161685 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161696 */     GIR_RootConstrainSelectedInstOperands,
     /* 161697 */     // GIR_Coverage, 10140,
     /* 161697 */     GIR_EraseRootFromParent_Done,
     /* 161698 */   // Label 3543: @161698
     /* 161698 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(161766), // Rule ID 23281 //
     /* 161703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161746 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 161749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161751 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161757 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161764 */     GIR_RootConstrainSelectedInstOperands,
     /* 161765 */     // GIR_Coverage, 23281,
     /* 161765 */     GIR_EraseRootFromParent_Done,
     /* 161766 */   // Label 3544: @161766
     /* 161766 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(161834), // Rule ID 1302 //
     /* 161771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161814 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 161817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161819 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161832 */     GIR_RootConstrainSelectedInstOperands,
     /* 161833 */     // GIR_Coverage, 1302,
     /* 161833 */     GIR_EraseRootFromParent_Done,
     /* 161834 */   // Label 3545: @161834
     /* 161834 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(161902), // Rule ID 1366 //
     /* 161839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161882 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 161885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161893 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161900 */     GIR_RootConstrainSelectedInstOperands,
     /* 161901 */     // GIR_Coverage, 1366,
     /* 161901 */     GIR_EraseRootFromParent_Done,
     /* 161902 */   // Label 3546: @161902
     /* 161902 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(161970), // Rule ID 10138 //
     /* 161907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161950 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 161953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161955 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161968 */     GIR_RootConstrainSelectedInstOperands,
     /* 161969 */     // GIR_Coverage, 10138,
     /* 161969 */     GIR_EraseRootFromParent_Done,
     /* 161970 */   // Label 3547: @161970
     /* 161970 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(162038), // Rule ID 1300 //
     /* 161975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161998 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162018 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 162021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162036 */     GIR_RootConstrainSelectedInstOperands,
     /* 162037 */     // GIR_Coverage, 1300,
     /* 162037 */     GIR_EraseRootFromParent_Done,
     /* 162038 */   // Label 3548: @162038
     /* 162038 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(162106), // Rule ID 1364 //
     /* 162043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162073 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162086 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 162089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 162095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162104 */     GIR_RootConstrainSelectedInstOperands,
     /* 162105 */     // GIR_Coverage, 1364,
     /* 162105 */     GIR_EraseRootFromParent_Done,
     /* 162106 */   // Label 3549: @162106
     /* 162106 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(162174), // Rule ID 10135 //
     /* 162111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162154 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 162157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162172 */     GIR_RootConstrainSelectedInstOperands,
     /* 162173 */     // GIR_Coverage, 10135,
     /* 162173 */     GIR_EraseRootFromParent_Done,
     /* 162174 */   // Label 3550: @162174
     /* 162174 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(162211), // Rule ID 1298 //
     /* 162179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162198 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 162198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 162201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162207 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162209 */     GIR_RootConstrainSelectedInstOperands,
     /* 162210 */     // GIR_Coverage, 1298,
     /* 162210 */     GIR_EraseRootFromParent_Done,
     /* 162211 */   // Label 3551: @162211
     /* 162211 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(162246), // Rule ID 1362 //
     /* 162216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162235 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 162235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 162240 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162244 */     GIR_RootConstrainSelectedInstOperands,
     /* 162245 */     // GIR_Coverage, 1362,
     /* 162245 */     GIR_Done,
     /* 162246 */   // Label 3552: @162246
     /* 162246 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(162283), // Rule ID 10133 //
     /* 162251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162270 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 162270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 162273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162279 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162281 */     GIR_RootConstrainSelectedInstOperands,
     /* 162282 */     // GIR_Coverage, 10133,
     /* 162282 */     GIR_EraseRootFromParent_Done,
     /* 162283 */   // Label 3553: @162283
     /* 162283 */   GIM_Reject,
     /* 162284 */ // Label 3541: @162284
     /* 162284 */ GIM_Reject,
     /* 162285 */ // Label 3525: @162285
     /* 162285 */ GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(163021),
     /* 162290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 162299 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(162367), // Rule ID 1312 //
     /* 162304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162319 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162326 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162347 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 162350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 162356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162365 */     GIR_RootConstrainSelectedInstOperands,
     /* 162366 */     // GIR_Coverage, 1312,
     /* 162366 */     GIR_EraseRootFromParent_Done,
     /* 162367 */   // Label 3555: @162367
     /* 162367 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(162435), // Rule ID 10149 //
     /* 162372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162415 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 162418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162422 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 162424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162433 */     GIR_RootConstrainSelectedInstOperands,
     /* 162434 */     // GIR_Coverage, 10149,
     /* 162434 */     GIR_EraseRootFromParent_Done,
     /* 162435 */   // Label 3556: @162435
     /* 162435 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(162503), // Rule ID 23309 //
     /* 162440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162462 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162483 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 162486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162494 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162501 */     GIR_RootConstrainSelectedInstOperands,
     /* 162502 */     // GIR_Coverage, 23309,
     /* 162502 */     GIR_EraseRootFromParent_Done,
     /* 162503 */   // Label 3557: @162503
     /* 162503 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(162571), // Rule ID 1310 //
     /* 162508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162527 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162534 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162551 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 162554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162556 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 162558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162560 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162569 */     GIR_RootConstrainSelectedInstOperands,
     /* 162570 */     // GIR_Coverage, 1310,
     /* 162570 */     GIR_EraseRootFromParent_Done,
     /* 162571 */   // Label 3558: @162571
     /* 162571 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(162639), // Rule ID 1450 //
     /* 162576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162595 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162602 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162619 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 162622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162630 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162637 */     GIR_RootConstrainSelectedInstOperands,
     /* 162638 */     // GIR_Coverage, 1450,
     /* 162638 */     GIR_EraseRootFromParent_Done,
     /* 162639 */   // Label 3559: @162639
     /* 162639 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(162707), // Rule ID 10147 //
     /* 162644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162687 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 162690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162692 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 162694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162705 */     GIR_RootConstrainSelectedInstOperands,
     /* 162706 */     // GIR_Coverage, 10147,
     /* 162706 */     GIR_EraseRootFromParent_Done,
     /* 162707 */   // Label 3560: @162707
     /* 162707 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(162775), // Rule ID 1308 //
     /* 162712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162755 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 162758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162760 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162773 */     GIR_RootConstrainSelectedInstOperands,
     /* 162774 */     // GIR_Coverage, 1308,
     /* 162774 */     GIR_EraseRootFromParent_Done,
     /* 162775 */   // Label 3561: @162775
     /* 162775 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(162843), // Rule ID 1448 //
     /* 162780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162823 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 162826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162830 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 162832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162841 */     GIR_RootConstrainSelectedInstOperands,
     /* 162842 */     // GIR_Coverage, 1448,
     /* 162842 */     GIR_EraseRootFromParent_Done,
     /* 162843 */   // Label 3562: @162843
     /* 162843 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(162911), // Rule ID 10144 //
     /* 162848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162891 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 162894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162909 */     GIR_RootConstrainSelectedInstOperands,
     /* 162910 */     // GIR_Coverage, 10144,
     /* 162910 */     GIR_EraseRootFromParent_Done,
     /* 162911 */   // Label 3563: @162911
     /* 162911 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(162948), // Rule ID 1306 //
     /* 162916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162935 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 162938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162940 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162942 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162946 */     GIR_RootConstrainSelectedInstOperands,
     /* 162947 */     // GIR_Coverage, 1306,
     /* 162947 */     GIR_EraseRootFromParent_Done,
     /* 162948 */   // Label 3564: @162948
     /* 162948 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(162983), // Rule ID 1446 //
     /* 162953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162972 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 162977 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162981 */     GIR_RootConstrainSelectedInstOperands,
     /* 162982 */     // GIR_Coverage, 1446,
     /* 162982 */     GIR_Done,
     /* 162983 */   // Label 3565: @162983
     /* 162983 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(163020), // Rule ID 10142 //
     /* 162988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 163003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 163007 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 163007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 163010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163014 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163016 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163018 */     GIR_RootConstrainSelectedInstOperands,
     /* 163019 */     // GIR_Coverage, 10142,
     /* 163019 */     GIR_EraseRootFromParent_Done,
     /* 163020 */   // Label 3566: @163020
     /* 163020 */   GIM_Reject,
     /* 163021 */ // Label 3554: @163021
     /* 163021 */ GIM_Reject,
     /* 163022 */ // Label 3526: @163022
     /* 163022 */ GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(163758),
     /* 163027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163036 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(163104), // Rule ID 1192 //
     /* 163041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163056 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163063 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163084 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 163087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163091 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163102 */     GIR_RootConstrainSelectedInstOperands,
     /* 163103 */     // GIR_Coverage, 1192,
     /* 163103 */     GIR_EraseRootFromParent_Done,
     /* 163104 */   // Label 3568: @163104
     /* 163104 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(163172), // Rule ID 9681 //
     /* 163109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163152 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 163155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163159 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163170 */     GIR_RootConstrainSelectedInstOperands,
     /* 163171 */     // GIR_Coverage, 9681,
     /* 163171 */     GIR_EraseRootFromParent_Done,
     /* 163172 */   // Label 3569: @163172
     /* 163172 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(163240), // Rule ID 23317 //
     /* 163177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163220 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 163223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163231 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163238 */     GIR_RootConstrainSelectedInstOperands,
     /* 163239 */     // GIR_Coverage, 23317,
     /* 163239 */     GIR_EraseRootFromParent_Done,
     /* 163240 */   // Label 3570: @163240
     /* 163240 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(163308), // Rule ID 1190 //
     /* 163245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163288 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 163291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163293 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163306 */     GIR_RootConstrainSelectedInstOperands,
     /* 163307 */     // GIR_Coverage, 1190,
     /* 163307 */     GIR_EraseRootFromParent_Done,
     /* 163308 */   // Label 3571: @163308
     /* 163308 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(163376), // Rule ID 1474 //
     /* 163313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163356 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 163359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163367 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163374 */     GIR_RootConstrainSelectedInstOperands,
     /* 163375 */     // GIR_Coverage, 1474,
     /* 163375 */     GIR_EraseRootFromParent_Done,
     /* 163376 */   // Label 3572: @163376
     /* 163376 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(163444), // Rule ID 9141 //
     /* 163381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163424 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 163427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163429 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163442 */     GIR_RootConstrainSelectedInstOperands,
     /* 163443 */     // GIR_Coverage, 9141,
     /* 163443 */     GIR_EraseRootFromParent_Done,
     /* 163444 */   // Label 3573: @163444
     /* 163444 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(163512), // Rule ID 1188 //
     /* 163449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163492 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 163495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163497 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163510 */     GIR_RootConstrainSelectedInstOperands,
     /* 163511 */     // GIR_Coverage, 1188,
     /* 163511 */     GIR_EraseRootFromParent_Done,
     /* 163512 */   // Label 3574: @163512
     /* 163512 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(163580), // Rule ID 1472 //
     /* 163517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163560 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 163563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 163569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163578 */     GIR_RootConstrainSelectedInstOperands,
     /* 163579 */     // GIR_Coverage, 1472,
     /* 163579 */     GIR_EraseRootFromParent_Done,
     /* 163580 */   // Label 3575: @163580
     /* 163580 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(163648), // Rule ID 8514 //
     /* 163585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163628 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 163631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163635 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163646 */     GIR_RootConstrainSelectedInstOperands,
     /* 163647 */     // GIR_Coverage, 8514,
     /* 163647 */     GIR_EraseRootFromParent_Done,
     /* 163648 */   // Label 3576: @163648
     /* 163648 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(163685), // Rule ID 1186 //
     /* 163653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163672 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 163675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163681 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163683 */     GIR_RootConstrainSelectedInstOperands,
     /* 163684 */     // GIR_Coverage, 1186,
     /* 163684 */     GIR_EraseRootFromParent_Done,
     /* 163685 */   // Label 3577: @163685
     /* 163685 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(163720), // Rule ID 1470 //
     /* 163690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163709 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 163714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163718 */     GIR_RootConstrainSelectedInstOperands,
     /* 163719 */     // GIR_Coverage, 1470,
     /* 163719 */     GIR_Done,
     /* 163720 */   // Label 3578: @163720
     /* 163720 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(163757), // Rule ID 8510 //
     /* 163725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163744 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 163744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 163747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163753 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163755 */     GIR_RootConstrainSelectedInstOperands,
     /* 163756 */     // GIR_Coverage, 8510,
     /* 163756 */     GIR_EraseRootFromParent_Done,
     /* 163757 */   // Label 3579: @163757
     /* 163757 */   GIM_Reject,
     /* 163758 */ // Label 3567: @163758
     /* 163758 */ GIM_Reject,
     /* 163759 */ // Label 3527: @163759
     /* 163759 */ GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(164495),
     /* 163764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163773 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(163841), // Rule ID 1144 //
     /* 163778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163793 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163800 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163821 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 163824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163839 */     GIR_RootConstrainSelectedInstOperands,
     /* 163840 */     // GIR_Coverage, 1144,
     /* 163840 */     GIR_EraseRootFromParent_Done,
     /* 163841 */   // Label 3581: @163841
     /* 163841 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(163909), // Rule ID 9649 //
     /* 163846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163889 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 163892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163894 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163896 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163907 */     GIR_RootConstrainSelectedInstOperands,
     /* 163908 */     // GIR_Coverage, 9649,
     /* 163908 */     GIR_EraseRootFromParent_Done,
     /* 163909 */   // Label 3582: @163909
     /* 163909 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(163977), // Rule ID 23289 //
     /* 163914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163957 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 163957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 163960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163962 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163968 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163975 */     GIR_RootConstrainSelectedInstOperands,
     /* 163976 */     // GIR_Coverage, 23289,
     /* 163976 */     GIR_EraseRootFromParent_Done,
     /* 163977 */   // Label 3583: @163977
     /* 163977 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(164045), // Rule ID 1142 //
     /* 163982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164001 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164025 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 164028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164030 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164034 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164043 */     GIR_RootConstrainSelectedInstOperands,
     /* 164044 */     // GIR_Coverage, 1142,
     /* 164044 */     GIR_EraseRootFromParent_Done,
     /* 164045 */   // Label 3584: @164045
     /* 164045 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(164113), // Rule ID 1390 //
     /* 164050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164093 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 164093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 164096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164104 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164111 */     GIR_RootConstrainSelectedInstOperands,
     /* 164112 */     // GIR_Coverage, 1390,
     /* 164112 */     GIR_EraseRootFromParent_Done,
     /* 164113 */   // Label 3585: @164113
     /* 164113 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(164181), // Rule ID 9109 //
     /* 164118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164161 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 164164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164166 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164179 */     GIR_RootConstrainSelectedInstOperands,
     /* 164180 */     // GIR_Coverage, 9109,
     /* 164180 */     GIR_EraseRootFromParent_Done,
     /* 164181 */   // Label 3586: @164181
     /* 164181 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(164249), // Rule ID 1140 //
     /* 164186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164209 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164229 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 164232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164234 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164236 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164238 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164247 */     GIR_RootConstrainSelectedInstOperands,
     /* 164248 */     // GIR_Coverage, 1140,
     /* 164248 */     GIR_EraseRootFromParent_Done,
     /* 164249 */   // Label 3587: @164249
     /* 164249 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(164317), // Rule ID 1388 //
     /* 164254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164277 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164297 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 164300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 164306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164315 */     GIR_RootConstrainSelectedInstOperands,
     /* 164316 */     // GIR_Coverage, 1388,
     /* 164316 */     GIR_EraseRootFromParent_Done,
     /* 164317 */   // Label 3588: @164317
     /* 164317 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(164385), // Rule ID 8475 //
     /* 164322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164365 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 164368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164383 */     GIR_RootConstrainSelectedInstOperands,
     /* 164384 */     // GIR_Coverage, 8475,
     /* 164384 */     GIR_EraseRootFromParent_Done,
     /* 164385 */   // Label 3589: @164385
     /* 164385 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(164422), // Rule ID 1138 //
     /* 164390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164409 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 164409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 164412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164414 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164416 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164418 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164420 */     GIR_RootConstrainSelectedInstOperands,
     /* 164421 */     // GIR_Coverage, 1138,
     /* 164421 */     GIR_EraseRootFromParent_Done,
     /* 164422 */   // Label 3590: @164422
     /* 164422 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(164457), // Rule ID 1386 //
     /* 164427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164446 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 164446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 164451 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 164455 */     GIR_RootConstrainSelectedInstOperands,
     /* 164456 */     // GIR_Coverage, 1386,
     /* 164456 */     GIR_Done,
     /* 164457 */   // Label 3591: @164457
     /* 164457 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(164494), // Rule ID 8471 //
     /* 164462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164481 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 164481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 164484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164490 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164492 */     GIR_RootConstrainSelectedInstOperands,
     /* 164493 */     // GIR_Coverage, 8471,
     /* 164493 */     GIR_EraseRootFromParent_Done,
     /* 164494 */   // Label 3592: @164494
     /* 164494 */   GIM_Reject,
     /* 164495 */ // Label 3580: @164495
     /* 164495 */ GIM_Reject,
     /* 164496 */ // Label 3528: @164496
     /* 164496 */ GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(165232),
     /* 164501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 164504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 164507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 164510 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(164578), // Rule ID 1200 //
     /* 164515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164558 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 164561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164565 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164567 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164576 */     GIR_RootConstrainSelectedInstOperands,
     /* 164577 */     // GIR_Coverage, 1200,
     /* 164577 */     GIR_EraseRootFromParent_Done,
     /* 164578 */   // Label 3594: @164578
     /* 164578 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(164646), // Rule ID 9671 //
     /* 164583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164626 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 164629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164633 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164644 */     GIR_RootConstrainSelectedInstOperands,
     /* 164645 */     // GIR_Coverage, 9671,
     /* 164645 */     GIR_EraseRootFromParent_Done,
     /* 164646 */   // Label 3595: @164646
     /* 164646 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(164714), // Rule ID 23319 //
     /* 164651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164694 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 164697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164705 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164712 */     GIR_RootConstrainSelectedInstOperands,
     /* 164713 */     // GIR_Coverage, 23319,
     /* 164713 */     GIR_EraseRootFromParent_Done,
     /* 164714 */   // Label 3596: @164714
     /* 164714 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(164782), // Rule ID 1198 //
     /* 164719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164762 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 164765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164767 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164780 */     GIR_RootConstrainSelectedInstOperands,
     /* 164781 */     // GIR_Coverage, 1198,
     /* 164781 */     GIR_EraseRootFromParent_Done,
     /* 164782 */   // Label 3597: @164782
     /* 164782 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(164850), // Rule ID 1480 //
     /* 164787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164830 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 164833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164835 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164841 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164848 */     GIR_RootConstrainSelectedInstOperands,
     /* 164849 */     // GIR_Coverage, 1480,
     /* 164849 */     GIR_EraseRootFromParent_Done,
     /* 164850 */   // Label 3598: @164850
     /* 164850 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(164918), // Rule ID 9131 //
     /* 164855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164874 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164881 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164898 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 164901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164903 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164916 */     GIR_RootConstrainSelectedInstOperands,
     /* 164917 */     // GIR_Coverage, 9131,
     /* 164917 */     GIR_EraseRootFromParent_Done,
     /* 164918 */   // Label 3599: @164918
     /* 164918 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(164986), // Rule ID 1196 //
     /* 164923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164966 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 164969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164984 */     GIR_RootConstrainSelectedInstOperands,
     /* 164985 */     // GIR_Coverage, 1196,
     /* 164985 */     GIR_EraseRootFromParent_Done,
     /* 164986 */   // Label 3600: @164986
     /* 164986 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(165054), // Rule ID 1478 //
     /* 164991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165034 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 165037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 165043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165052 */     GIR_RootConstrainSelectedInstOperands,
     /* 165053 */     // GIR_Coverage, 1478,
     /* 165053 */     GIR_EraseRootFromParent_Done,
     /* 165054 */   // Label 3601: @165054
     /* 165054 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(165122), // Rule ID 8502 //
     /* 165059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165102 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 165105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165120 */     GIR_RootConstrainSelectedInstOperands,
     /* 165121 */     // GIR_Coverage, 8502,
     /* 165121 */     GIR_EraseRootFromParent_Done,
     /* 165122 */   // Label 3602: @165122
     /* 165122 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(165159), // Rule ID 1194 //
     /* 165127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165146 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 165146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 165149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165151 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165155 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165157 */     GIR_RootConstrainSelectedInstOperands,
     /* 165158 */     // GIR_Coverage, 1194,
     /* 165158 */     GIR_EraseRootFromParent_Done,
     /* 165159 */   // Label 3603: @165159
     /* 165159 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(165194), // Rule ID 1476 //
     /* 165164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165183 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 165183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 165188 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 165192 */     GIR_RootConstrainSelectedInstOperands,
     /* 165193 */     // GIR_Coverage, 1476,
     /* 165193 */     GIR_Done,
     /* 165194 */   // Label 3604: @165194
     /* 165194 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(165231), // Rule ID 8498 //
     /* 165199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165218 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 165218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 165221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165227 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165229 */     GIR_RootConstrainSelectedInstOperands,
     /* 165230 */     // GIR_Coverage, 8498,
     /* 165230 */     GIR_EraseRootFromParent_Done,
     /* 165231 */   // Label 3605: @165231
     /* 165231 */   GIM_Reject,
     /* 165232 */ // Label 3593: @165232
     /* 165232 */ GIM_Reject,
     /* 165233 */ // Label 3529: @165233
     /* 165233 */ GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(165477),
     /* 165238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 165241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165251 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(165315), // Rule ID 9617 //
     /* 165256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165295 */     // (fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 165298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165302 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165313 */     GIR_RootConstrainSelectedInstOperands,
     /* 165314 */     // GIR_Coverage, 9617,
     /* 165314 */     GIR_EraseRootFromParent_Done,
     /* 165315 */   // Label 3607: @165315
     /* 165315 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(165379), // Rule ID 9077 //
     /* 165320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165335 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165338 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165342 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165359 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 165362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165364 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165377 */     GIR_RootConstrainSelectedInstOperands,
     /* 165378 */     // GIR_Coverage, 9077,
     /* 165378 */     GIR_EraseRootFromParent_Done,
     /* 165379 */   // Label 3608: @165379
     /* 165379 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(165443), // Rule ID 8436 //
     /* 165384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165423 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 165426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165428 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165430 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165441 */     GIR_RootConstrainSelectedInstOperands,
     /* 165442 */     // GIR_Coverage, 8436,
     /* 165442 */     GIR_EraseRootFromParent_Done,
     /* 165443 */   // Label 3609: @165443
     /* 165443 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(165476), // Rule ID 8432 //
     /* 165448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165463 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 165463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 165466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165472 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165474 */     GIR_RootConstrainSelectedInstOperands,
     /* 165475 */     // GIR_Coverage, 8432,
     /* 165475 */     GIR_EraseRootFromParent_Done,
     /* 165476 */   // Label 3610: @165476
     /* 165476 */   GIM_Reject,
     /* 165477 */ // Label 3606: @165477
     /* 165477 */ GIM_Reject,
     /* 165478 */ // Label 3530: @165478
     /* 165478 */ GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(166214),
     /* 165483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 165486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 165489 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 165492 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(165560), // Rule ID 1152 //
     /* 165497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165540 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 165543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165547 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165558 */     GIR_RootConstrainSelectedInstOperands,
     /* 165559 */     // GIR_Coverage, 1152,
     /* 165559 */     GIR_EraseRootFromParent_Done,
     /* 165560 */   // Label 3612: @165560
     /* 165560 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(165628), // Rule ID 9639 //
     /* 165565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165608 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 165611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165615 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165626 */     GIR_RootConstrainSelectedInstOperands,
     /* 165627 */     // GIR_Coverage, 9639,
     /* 165627 */     GIR_EraseRootFromParent_Done,
     /* 165628 */   // Label 3613: @165628
     /* 165628 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(165696), // Rule ID 23291 //
     /* 165633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165676 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 165679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165687 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165694 */     GIR_RootConstrainSelectedInstOperands,
     /* 165695 */     // GIR_Coverage, 23291,
     /* 165695 */     GIR_EraseRootFromParent_Done,
     /* 165696 */   // Label 3614: @165696
     /* 165696 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(165764), // Rule ID 1150 //
     /* 165701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165744 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 165747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165749 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165762 */     GIR_RootConstrainSelectedInstOperands,
     /* 165763 */     // GIR_Coverage, 1150,
     /* 165763 */     GIR_EraseRootFromParent_Done,
     /* 165764 */   // Label 3615: @165764
     /* 165764 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(165832), // Rule ID 1396 //
     /* 165769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165788 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165812 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 165815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165823 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165830 */     GIR_RootConstrainSelectedInstOperands,
     /* 165831 */     // GIR_Coverage, 1396,
     /* 165831 */     GIR_EraseRootFromParent_Done,
     /* 165832 */   // Label 3616: @165832
     /* 165832 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(165900), // Rule ID 9099 //
     /* 165837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165880 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 165883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165885 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165898 */     GIR_RootConstrainSelectedInstOperands,
     /* 165899 */     // GIR_Coverage, 9099,
     /* 165899 */     GIR_EraseRootFromParent_Done,
     /* 165900 */   // Label 3617: @165900
     /* 165900 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(165968), // Rule ID 1148 //
     /* 165905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165948 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 165951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165966 */     GIR_RootConstrainSelectedInstOperands,
     /* 165967 */     // GIR_Coverage, 1148,
     /* 165967 */     GIR_EraseRootFromParent_Done,
     /* 165968 */   // Label 3618: @165968
     /* 165968 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(166036), // Rule ID 1394 //
     /* 165973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166016 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 166019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166034 */     GIR_RootConstrainSelectedInstOperands,
     /* 166035 */     // GIR_Coverage, 1394,
     /* 166035 */     GIR_EraseRootFromParent_Done,
     /* 166036 */   // Label 3619: @166036
     /* 166036 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(166104), // Rule ID 8463 //
     /* 166041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166064 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166084 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 166087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166102 */     GIR_RootConstrainSelectedInstOperands,
     /* 166103 */     // GIR_Coverage, 8463,
     /* 166103 */     GIR_EraseRootFromParent_Done,
     /* 166104 */   // Label 3620: @166104
     /* 166104 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(166141), // Rule ID 1146 //
     /* 166109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166128 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 166128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 166131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166135 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166137 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166139 */     GIR_RootConstrainSelectedInstOperands,
     /* 166140 */     // GIR_Coverage, 1146,
     /* 166140 */     GIR_EraseRootFromParent_Done,
     /* 166141 */   // Label 3621: @166141
     /* 166141 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(166176), // Rule ID 1392 //
     /* 166146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166165 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 166165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 166170 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166174 */     GIR_RootConstrainSelectedInstOperands,
     /* 166175 */     // GIR_Coverage, 1392,
     /* 166175 */     GIR_Done,
     /* 166176 */   // Label 3622: @166176
     /* 166176 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(166213), // Rule ID 8459 //
     /* 166181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166200 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 166200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 166203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166209 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166211 */     GIR_RootConstrainSelectedInstOperands,
     /* 166212 */     // GIR_Coverage, 8459,
     /* 166212 */     GIR_EraseRootFromParent_Done,
     /* 166213 */   // Label 3623: @166213
     /* 166213 */   GIM_Reject,
     /* 166214 */ // Label 3611: @166214
     /* 166214 */ GIM_Reject,
     /* 166215 */ // Label 3531: @166215
     /* 166215 */ GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(166459),
     /* 166220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 166223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 166226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 166229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166233 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(166297), // Rule ID 9659 //
     /* 166238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166249 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166277 */     // (fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 166280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166284 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166295 */     GIR_RootConstrainSelectedInstOperands,
     /* 166296 */     // GIR_Coverage, 9659,
     /* 166296 */     GIR_EraseRootFromParent_Done,
     /* 166297 */   // Label 3625: @166297
     /* 166297 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(166361), // Rule ID 9119 //
     /* 166302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166341 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 166344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166346 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166359 */     GIR_RootConstrainSelectedInstOperands,
     /* 166360 */     // GIR_Coverage, 9119,
     /* 166360 */     GIR_EraseRootFromParent_Done,
     /* 166361 */   // Label 3626: @166361
     /* 166361 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(166425), // Rule ID 8487 //
     /* 166366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166405 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 166408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166410 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166423 */     GIR_RootConstrainSelectedInstOperands,
     /* 166424 */     // GIR_Coverage, 8487,
     /* 166424 */     GIR_EraseRootFromParent_Done,
     /* 166425 */   // Label 3627: @166425
     /* 166425 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(166458), // Rule ID 8483 //
     /* 166430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166445 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 166445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 166448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166450 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166454 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166456 */     GIR_RootConstrainSelectedInstOperands,
     /* 166457 */     // GIR_Coverage, 8483,
     /* 166457 */     GIR_EraseRootFromParent_Done,
     /* 166458 */   // Label 3628: @166458
     /* 166458 */   GIM_Reject,
     /* 166459 */ // Label 3624: @166459
     /* 166459 */ GIM_Reject,
     /* 166460 */ // Label 3532: @166460
     /* 166460 */ GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(166704),
     /* 166465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 166468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 166471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 166474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166478 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(166542), // Rule ID 9607 //
     /* 166483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166522 */     // (fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 166525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166527 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166529 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166540 */     GIR_RootConstrainSelectedInstOperands,
     /* 166541 */     // GIR_Coverage, 9607,
     /* 166541 */     GIR_EraseRootFromParent_Done,
     /* 166542 */   // Label 3630: @166542
     /* 166542 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(166606), // Rule ID 9067 //
     /* 166547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166586 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 166589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166591 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166604 */     GIR_RootConstrainSelectedInstOperands,
     /* 166605 */     // GIR_Coverage, 9067,
     /* 166605 */     GIR_EraseRootFromParent_Done,
     /* 166606 */   // Label 3631: @166606
     /* 166606 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(166670), // Rule ID 8424 //
     /* 166611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166650 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 166653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166668 */     GIR_RootConstrainSelectedInstOperands,
     /* 166669 */     // GIR_Coverage, 8424,
     /* 166669 */     GIR_EraseRootFromParent_Done,
     /* 166670 */   // Label 3632: @166670
     /* 166670 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(166703), // Rule ID 8420 //
     /* 166675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166690 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 166690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 166693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166699 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166701 */     GIR_RootConstrainSelectedInstOperands,
     /* 166702 */     // GIR_Coverage, 8420,
     /* 166702 */     GIR_EraseRootFromParent_Done,
     /* 166703 */   // Label 3633: @166703
     /* 166703 */   GIM_Reject,
     /* 166704 */ // Label 3629: @166704
     /* 166704 */ GIM_Reject,
     /* 166705 */ // Label 3533: @166705
     /* 166705 */ GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(166949),
     /* 166710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 166713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 166716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 166719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166723 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(166787), // Rule ID 9627 //
     /* 166728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166739 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166742 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166746 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166767 */     // (fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 166770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166774 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166785 */     GIR_RootConstrainSelectedInstOperands,
     /* 166786 */     // GIR_Coverage, 9627,
     /* 166786 */     GIR_EraseRootFromParent_Done,
     /* 166787 */   // Label 3635: @166787
     /* 166787 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(166851), // Rule ID 9087 //
     /* 166792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166831 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 166834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166836 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166838 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166849 */     GIR_RootConstrainSelectedInstOperands,
     /* 166850 */     // GIR_Coverage, 9087,
     /* 166850 */     GIR_EraseRootFromParent_Done,
     /* 166851 */   // Label 3636: @166851
     /* 166851 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(166915), // Rule ID 8448 //
     /* 166856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166875 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166882 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166895 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 166898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166913 */     GIR_RootConstrainSelectedInstOperands,
     /* 166914 */     // GIR_Coverage, 8448,
     /* 166914 */     GIR_EraseRootFromParent_Done,
     /* 166915 */   // Label 3637: @166915
     /* 166915 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(166948), // Rule ID 8444 //
     /* 166920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166935 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 166935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 166938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166940 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166942 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166946 */     GIR_RootConstrainSelectedInstOperands,
     /* 166947 */     // GIR_Coverage, 8444,
     /* 166947 */     GIR_EraseRootFromParent_Done,
     /* 166948 */   // Label 3638: @166948
     /* 166948 */   GIM_Reject,
     /* 166949 */ // Label 3634: @166949
     /* 166949 */ GIM_Reject,
     /* 166950 */ // Label 3534: @166950
     /* 166950 */ GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(167194),
     /* 166955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 166958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 166961 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 166964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166968 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(167032), // Rule ID 9595 //
     /* 166973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167012 */     // (fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 167015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167019 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167030 */     GIR_RootConstrainSelectedInstOperands,
     /* 167031 */     // GIR_Coverage, 9595,
     /* 167031 */     GIR_EraseRootFromParent_Done,
     /* 167032 */   // Label 3640: @167032
     /* 167032 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(167096), // Rule ID 9055 //
     /* 167037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167076 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 167079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167081 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167094 */     GIR_RootConstrainSelectedInstOperands,
     /* 167095 */     // GIR_Coverage, 9055,
     /* 167095 */     GIR_EraseRootFromParent_Done,
     /* 167096 */   // Label 3641: @167096
     /* 167096 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(167160), // Rule ID 8409 //
     /* 167101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167140 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 167143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167158 */     GIR_RootConstrainSelectedInstOperands,
     /* 167159 */     // GIR_Coverage, 8409,
     /* 167159 */     GIR_EraseRootFromParent_Done,
     /* 167160 */   // Label 3642: @167160
     /* 167160 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(167193), // Rule ID 8405 //
     /* 167165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167180 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 167180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 167183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167185 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167189 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167191 */     GIR_RootConstrainSelectedInstOperands,
     /* 167192 */     // GIR_Coverage, 8405,
     /* 167192 */     GIR_EraseRootFromParent_Done,
     /* 167193 */   // Label 3643: @167193
     /* 167193 */   GIM_Reject,
     /* 167194 */ // Label 3639: @167194
     /* 167194 */ GIM_Reject,
     /* 167195 */ // Label 3535: @167195
     /* 167195 */ GIM_Reject,
     /* 167196 */ // Label 45: @167196
     /* 167196 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3657*/ GIMT_Encode4(170613),
     /* 167207 */ /*GILLT_s16*//*Label 3644*/ GIMT_Encode4(167291),
     /* 167211 */ /*GILLT_s32*//*Label 3645*/ GIMT_Encode4(167389),
     /* 167215 */ /*GILLT_s64*//*Label 3646*/ GIMT_Encode4(168094),
     /* 167219 */ /*GILLT_s80*//*Label 3647*/ GIMT_Encode4(168943), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 167231 */ /*GILLT_v2s64*//*Label 3648*/ GIMT_Encode4(169265), GIMT_Encode4(0),
     /* 167239 */ /*GILLT_v4s32*//*Label 3649*/ GIMT_Encode4(169495),
     /* 167243 */ /*GILLT_v4s64*//*Label 3650*/ GIMT_Encode4(169725), GIMT_Encode4(0),
     /* 167251 */ /*GILLT_v8s16*//*Label 3651*/ GIMT_Encode4(169924),
     /* 167255 */ /*GILLT_v8s32*//*Label 3652*/ GIMT_Encode4(170022),
     /* 167259 */ /*GILLT_v8s64*//*Label 3653*/ GIMT_Encode4(170221), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 167271 */ /*GILLT_v16s16*//*Label 3654*/ GIMT_Encode4(170319),
     /* 167275 */ /*GILLT_v16s32*//*Label 3655*/ GIMT_Encode4(170417), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 167287 */ /*GILLT_v32s16*//*Label 3656*/ GIMT_Encode4(170515),
     /* 167291 */ // Label 3644: @167291
     /* 167291 */ GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(167388),
     /* 167296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 167299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 167306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 167310 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(167364), // Rule ID 6126 //
     /* 167315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167346 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 167349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167362 */     GIR_RootConstrainSelectedInstOperands,
     /* 167363 */     // GIR_Coverage, 6126,
     /* 167363 */     GIR_EraseRootFromParent_Done,
     /* 167364 */   // Label 3659: @167364
     /* 167364 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(167387), // Rule ID 6124 //
     /* 167369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 167376 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 167376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 167381 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167385 */     GIR_RootConstrainSelectedInstOperands,
     /* 167386 */     // GIR_Coverage, 6124,
     /* 167386 */     GIR_Done,
     /* 167387 */   // Label 3660: @167387
     /* 167387 */   GIM_Reject,
     /* 167388 */ // Label 3658: @167388
     /* 167388 */ GIM_Reject,
     /* 167389 */ // Label 3645: @167389
     /* 167389 */ GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(168093),
     /* 167394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167400 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(167482), // Rule ID 22485 //
     /* 167405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 167408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167436 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 167443 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167450 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167463 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 167466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167480 */     GIR_RootConstrainSelectedInstOperands,
     /* 167481 */     // GIR_Coverage, 22485,
     /* 167481 */     GIR_EraseRootFromParent_Done,
     /* 167482 */   // Label 3662: @167482
     /* 167482 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(167564), // Rule ID 22486 //
     /* 167487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167518 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 167525 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167545 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 167548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167550 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167552 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167562 */     GIR_RootConstrainSelectedInstOperands,
     /* 167563 */     // GIR_Coverage, 22486,
     /* 167563 */     GIR_EraseRootFromParent_Done,
     /* 167564 */   // Label 3663: @167564
     /* 167564 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(167646), // Rule ID 22487 //
     /* 167569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 167572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167600 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 167607 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167614 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167627 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 167630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167644 */     GIR_RootConstrainSelectedInstOperands,
     /* 167645 */     // GIR_Coverage, 22487,
     /* 167645 */     GIR_EraseRootFromParent_Done,
     /* 167646 */   // Label 3664: @167646
     /* 167646 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(167711), // Rule ID 1021 //
     /* 167651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167690 */     // (fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 167693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167709 */     GIR_RootConstrainSelectedInstOperands,
     /* 167710 */     // GIR_Coverage, 1021,
     /* 167710 */     GIR_EraseRootFromParent_Done,
     /* 167711 */   // Label 3665: @167711
     /* 167711 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(167776), // Rule ID 999 //
     /* 167716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167755 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 167758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167762 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167774 */     GIR_RootConstrainSelectedInstOperands,
     /* 167775 */     // GIR_Coverage, 999,
     /* 167775 */     GIR_EraseRootFromParent_Done,
     /* 167776 */   // Label 3666: @167776
     /* 167776 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(167838), // Rule ID 2281 //
     /* 167781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167820 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 167823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167836 */     GIR_RootConstrainSelectedInstOperands,
     /* 167837 */     // GIR_Coverage, 2281,
     /* 167837 */     GIR_EraseRootFromParent_Done,
     /* 167838 */   // Label 3667: @167838
     /* 167838 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(167900), // Rule ID 2289 //
     /* 167843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 167846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167882 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 167885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167898 */     GIR_RootConstrainSelectedInstOperands,
     /* 167899 */     // GIR_Coverage, 2289,
     /* 167899 */     GIR_EraseRootFromParent_Done,
     /* 167900 */   // Label 3668: @167900
     /* 167900 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(167962), // Rule ID 6088 //
     /* 167905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 167908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167944 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 167947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167949 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167960 */     GIR_RootConstrainSelectedInstOperands,
     /* 167961 */     // GIR_Coverage, 6088,
     /* 167961 */     GIR_EraseRootFromParent_Done,
     /* 167962 */   // Label 3669: @167962
     /* 167962 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(167999), // Rule ID 905 //
     /* 167967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167982 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 167982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 167987 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 167993 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 167997 */     GIR_RootConstrainSelectedInstOperands,
     /* 167998 */     // GIR_Coverage, 905,
     /* 167998 */     GIR_Done,
     /* 167999 */   // Label 3670: @167999
     /* 167999 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(168030), // Rule ID 2279 //
     /* 168004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168019 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 168019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 168024 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168028 */     GIR_RootConstrainSelectedInstOperands,
     /* 168029 */     // GIR_Coverage, 2279,
     /* 168029 */     GIR_Done,
     /* 168030 */   // Label 3671: @168030
     /* 168030 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(168061), // Rule ID 2287 //
     /* 168035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 168038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168050 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 168050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 168055 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168059 */     GIR_RootConstrainSelectedInstOperands,
     /* 168060 */     // GIR_Coverage, 2287,
     /* 168060 */     GIR_Done,
     /* 168061 */   // Label 3672: @168061
     /* 168061 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(168092), // Rule ID 6086 //
     /* 168066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 168073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 168077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 168081 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 168081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 168086 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168090 */     GIR_RootConstrainSelectedInstOperands,
     /* 168091 */     // GIR_Coverage, 6086,
     /* 168091 */     GIR_Done,
     /* 168092 */   // Label 3673: @168092
     /* 168092 */   GIM_Reject,
     /* 168093 */ // Label 3661: @168093
     /* 168093 */ GIM_Reject,
     /* 168094 */ // Label 3646: @168094
     /* 168094 */ GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(168942),
     /* 168099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168105 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(168187), // Rule ID 22488 //
     /* 168110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 168113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 168129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 168133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 168137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168141 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 168148 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 168159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168168 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 168171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 168185 */     GIR_RootConstrainSelectedInstOperands,
     /* 168186 */     // GIR_Coverage, 22488,
     /* 168186 */     GIR_EraseRootFromParent_Done,
     /* 168187 */   // Label 3675: @168187
     /* 168187 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(168269), // Rule ID 22489 //
     /* 168192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 168211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 168215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 168219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168223 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 168230 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168237 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 168241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168250 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 168253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 168267 */     GIR_RootConstrainSelectedInstOperands,
     /* 168268 */     // GIR_Coverage, 22489,
     /* 168268 */     GIR_EraseRootFromParent_Done,
     /* 168269 */   // Label 3676: @168269
     /* 168269 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(168351), // Rule ID 22490 //
     /* 168274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 168293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 168297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 168301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168305 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 168312 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168319 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 168323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168325 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168332 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 168335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 168349 */     GIR_RootConstrainSelectedInstOperands,
     /* 168350 */     // GIR_Coverage, 22490,
     /* 168350 */     GIR_EraseRootFromParent_Done,
     /* 168351 */   // Label 3677: @168351
     /* 168351 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(168416), // Rule ID 1023 //
     /* 168356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168371 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168374 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168378 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168395 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 168398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168414 */     GIR_RootConstrainSelectedInstOperands,
     /* 168415 */     // GIR_Coverage, 1023,
     /* 168415 */     GIR_EraseRootFromParent_Done,
     /* 168416 */   // Label 3678: @168416
     /* 168416 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(168488), // Rule ID 1025 //
     /* 168421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168439 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168443 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168450 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168467 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 168470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168486 */     GIR_RootConstrainSelectedInstOperands,
     /* 168487 */     // GIR_Coverage, 1025,
     /* 168487 */     GIR_EraseRootFromParent_Done,
     /* 168488 */   // Label 3679: @168488
     /* 168488 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(168553), // Rule ID 1001 //
     /* 168493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168532 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 168535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168551 */     GIR_RootConstrainSelectedInstOperands,
     /* 168552 */     // GIR_Coverage, 1001,
     /* 168552 */     GIR_EraseRootFromParent_Done,
     /* 168553 */   // Label 3680: @168553
     /* 168553 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(168625), // Rule ID 1003 //
     /* 168558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168580 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168584 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168604 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 168607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168623 */     GIR_RootConstrainSelectedInstOperands,
     /* 168624 */     // GIR_Coverage, 1003,
     /* 168624 */     GIR_EraseRootFromParent_Done,
     /* 168625 */   // Label 3681: @168625
     /* 168625 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(168687), // Rule ID 2285 //
     /* 168630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168669 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 168672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168685 */     GIR_RootConstrainSelectedInstOperands,
     /* 168686 */     // GIR_Coverage, 2285,
     /* 168686 */     GIR_EraseRootFromParent_Done,
     /* 168687 */   // Label 3682: @168687
     /* 168687 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(168749), // Rule ID 2293 //
     /* 168692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 168695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168731 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 168734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168747 */     GIR_RootConstrainSelectedInstOperands,
     /* 168748 */     // GIR_Coverage, 2293,
     /* 168748 */     GIR_EraseRootFromParent_Done,
     /* 168749 */   // Label 3683: @168749
     /* 168749 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(168811), // Rule ID 6107 //
     /* 168754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168793 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 168796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168809 */     GIR_RootConstrainSelectedInstOperands,
     /* 168810 */     // GIR_Coverage, 6107,
     /* 168810 */     GIR_EraseRootFromParent_Done,
     /* 168811 */   // Label 3684: @168811
     /* 168811 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(168848), // Rule ID 907 //
     /* 168816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168831 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 168831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 168836 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 168842 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 168846 */     GIR_RootConstrainSelectedInstOperands,
     /* 168847 */     // GIR_Coverage, 907,
     /* 168847 */     GIR_Done,
     /* 168848 */   // Label 3685: @168848
     /* 168848 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(168879), // Rule ID 2283 //
     /* 168853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168868 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 168868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 168873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168877 */     GIR_RootConstrainSelectedInstOperands,
     /* 168878 */     // GIR_Coverage, 2283,
     /* 168878 */     GIR_Done,
     /* 168879 */   // Label 3686: @168879
     /* 168879 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(168910), // Rule ID 2291 //
     /* 168884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 168887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168899 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 168899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 168904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168908 */     GIR_RootConstrainSelectedInstOperands,
     /* 168909 */     // GIR_Coverage, 2291,
     /* 168909 */     GIR_Done,
     /* 168910 */   // Label 3687: @168910
     /* 168910 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(168941), // Rule ID 6105 //
     /* 168915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168930 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 168930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 168935 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168939 */     GIR_RootConstrainSelectedInstOperands,
     /* 168940 */     // GIR_Coverage, 6105,
     /* 168940 */     GIR_Done,
     /* 168941 */   // Label 3688: @168941
     /* 168941 */   GIM_Reject,
     /* 168942 */ // Label 3674: @168942
     /* 168942 */ GIM_Reject,
     /* 168943 */ // Label 3647: @168943
     /* 168943 */ GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(169264),
     /* 168948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 168951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 168954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168958 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(169026), // Rule ID 1027 //
     /* 168963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 168966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168977 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168981 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169005 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 169008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169024 */     GIR_RootConstrainSelectedInstOperands,
     /* 169025 */     // GIR_Coverage, 1027,
     /* 169025 */     GIR_EraseRootFromParent_Done,
     /* 169026 */   // Label 3690: @169026
     /* 169026 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(169094), // Rule ID 1029 //
     /* 169031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169045 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169049 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 169056 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169073 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 169076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169078 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169092 */     GIR_RootConstrainSelectedInstOperands,
     /* 169093 */     // GIR_Coverage, 1029,
     /* 169093 */     GIR_EraseRootFromParent_Done,
     /* 169094 */   // Label 3691: @169094
     /* 169094 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(169162), // Rule ID 1005 //
     /* 169099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169114 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169117 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169121 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 169128 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169141 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 169144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169146 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169160 */     GIR_RootConstrainSelectedInstOperands,
     /* 169161 */     // GIR_Coverage, 1005,
     /* 169161 */     GIR_EraseRootFromParent_Done,
     /* 169162 */   // Label 3692: @169162
     /* 169162 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(169230), // Rule ID 1007 //
     /* 169167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169185 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169189 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 169196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169209 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 169212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169228 */     GIR_RootConstrainSelectedInstOperands,
     /* 169229 */     // GIR_Coverage, 1007,
     /* 169229 */     GIR_EraseRootFromParent_Done,
     /* 169230 */   // Label 3693: @169230
     /* 169230 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(169263), // Rule ID 909 //
     /* 169235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169246 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 169246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 169251 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 169257 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 169261 */     GIR_RootConstrainSelectedInstOperands,
     /* 169262 */     // GIR_Coverage, 909,
     /* 169262 */     GIR_Done,
     /* 169263 */   // Label 3694: @169263
     /* 169263 */   GIM_Reject,
     /* 169264 */ // Label 3689: @169264
     /* 169264 */ GIM_Reject,
     /* 169265 */ // Label 3648: @169265
     /* 169265 */ GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(169494),
     /* 169270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169276 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(169338), // Rule ID 2261 //
     /* 169281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169320 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 169323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169336 */     GIR_RootConstrainSelectedInstOperands,
     /* 169337 */     // GIR_Coverage, 2261,
     /* 169337 */     GIR_EraseRootFromParent_Done,
     /* 169338 */   // Label 3696: @169338
     /* 169338 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(169400), // Rule ID 6660 //
     /* 169343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169362 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169365 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169369 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169382 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 169385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169387 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169389 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169398 */     GIR_RootConstrainSelectedInstOperands,
     /* 169399 */     // GIR_Coverage, 6660,
     /* 169399 */     GIR_EraseRootFromParent_Done,
     /* 169400 */   // Label 3697: @169400
     /* 169400 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(169431), // Rule ID 2259 //
     /* 169405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169420 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 169420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 169425 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169429 */     GIR_RootConstrainSelectedInstOperands,
     /* 169430 */     // GIR_Coverage, 2259,
     /* 169430 */     GIR_Done,
     /* 169431 */   // Label 3698: @169431
     /* 169431 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(169462), // Rule ID 2275 //
     /* 169436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 169439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169451 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 169451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 169456 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169460 */     GIR_RootConstrainSelectedInstOperands,
     /* 169461 */     // GIR_Coverage, 2275,
     /* 169461 */     GIR_Done,
     /* 169462 */   // Label 3699: @169462
     /* 169462 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(169493), // Rule ID 6656 //
     /* 169467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169482 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 169482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 169487 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169491 */     GIR_RootConstrainSelectedInstOperands,
     /* 169492 */     // GIR_Coverage, 6656,
     /* 169492 */     GIR_Done,
     /* 169493 */   // Label 3700: @169493
     /* 169493 */   GIM_Reject,
     /* 169494 */ // Label 3695: @169494
     /* 169494 */ GIM_Reject,
     /* 169495 */ // Label 3649: @169495
     /* 169495 */ GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(169724),
     /* 169500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169506 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(169568), // Rule ID 2257 //
     /* 169511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169550 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 169553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169566 */     GIR_RootConstrainSelectedInstOperands,
     /* 169567 */     // GIR_Coverage, 2257,
     /* 169567 */     GIR_EraseRootFromParent_Done,
     /* 169568 */   // Label 3702: @169568
     /* 169568 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(169630), // Rule ID 6636 //
     /* 169573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169612 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 169615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169628 */     GIR_RootConstrainSelectedInstOperands,
     /* 169629 */     // GIR_Coverage, 6636,
     /* 169629 */     GIR_EraseRootFromParent_Done,
     /* 169630 */   // Label 3703: @169630
     /* 169630 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(169661), // Rule ID 2255 //
     /* 169635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169650 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 169650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 169655 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169659 */     GIR_RootConstrainSelectedInstOperands,
     /* 169660 */     // GIR_Coverage, 2255,
     /* 169660 */     GIR_Done,
     /* 169661 */   // Label 3704: @169661
     /* 169661 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(169692), // Rule ID 2271 //
     /* 169666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 169669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169681 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 169681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 169686 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169690 */     GIR_RootConstrainSelectedInstOperands,
     /* 169691 */     // GIR_Coverage, 2271,
     /* 169691 */     GIR_Done,
     /* 169692 */   // Label 3705: @169692
     /* 169692 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(169723), // Rule ID 6632 //
     /* 169697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169712 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 169712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 169717 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169721 */     GIR_RootConstrainSelectedInstOperands,
     /* 169722 */     // GIR_Coverage, 6632,
     /* 169722 */     GIR_Done,
     /* 169723 */   // Label 3706: @169723
     /* 169723 */   GIM_Reject,
     /* 169724 */ // Label 3701: @169724
     /* 169724 */ GIM_Reject,
     /* 169725 */ // Label 3650: @169725
     /* 169725 */ GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(169923),
     /* 169730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 169733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 169736 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(169798), // Rule ID 2269 //
     /* 169741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169780 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 169783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169785 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169787 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169796 */     GIR_RootConstrainSelectedInstOperands,
     /* 169797 */     // GIR_Coverage, 2269,
     /* 169797 */     GIR_EraseRootFromParent_Done,
     /* 169798 */   // Label 3708: @169798
     /* 169798 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(169860), // Rule ID 6672 //
     /* 169803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169842 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 169845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169858 */     GIR_RootConstrainSelectedInstOperands,
     /* 169859 */     // GIR_Coverage, 6672,
     /* 169859 */     GIR_EraseRootFromParent_Done,
     /* 169860 */   // Label 3709: @169860
     /* 169860 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(169891), // Rule ID 2267 //
     /* 169865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169880 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 169880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 169885 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169889 */     GIR_RootConstrainSelectedInstOperands,
     /* 169890 */     // GIR_Coverage, 2267,
     /* 169890 */     GIR_Done,
     /* 169891 */   // Label 3710: @169891
     /* 169891 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(169922), // Rule ID 6668 //
     /* 169896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169911 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 169911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 169916 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169920 */     GIR_RootConstrainSelectedInstOperands,
     /* 169921 */     // GIR_Coverage, 6668,
     /* 169921 */     GIR_Done,
     /* 169922 */   // Label 3711: @169922
     /* 169922 */   GIM_Reject,
     /* 169923 */ // Label 3707: @169923
     /* 169923 */ GIM_Reject,
     /* 169924 */ // Label 3651: @169924
     /* 169924 */ GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(170021),
     /* 169929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 169932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169943 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(169997), // Rule ID 6696 //
     /* 169948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169979 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 169982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169995 */     GIR_RootConstrainSelectedInstOperands,
     /* 169996 */     // GIR_Coverage, 6696,
     /* 169996 */     GIR_EraseRootFromParent_Done,
     /* 169997 */   // Label 3713: @169997
     /* 169997 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(170020), // Rule ID 6692 //
     /* 170002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 170005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 170009 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 170009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 170014 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170018 */     GIR_RootConstrainSelectedInstOperands,
     /* 170019 */     // GIR_Coverage, 6692,
     /* 170019 */     GIR_Done,
     /* 170020 */   // Label 3714: @170020
     /* 170020 */   GIM_Reject,
     /* 170021 */ // Label 3712: @170021
     /* 170021 */ GIM_Reject,
     /* 170022 */ // Label 3652: @170022
     /* 170022 */ GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(170220),
     /* 170027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 170030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 170033 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(170095), // Rule ID 2265 //
     /* 170038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 170041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170077 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 170080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170093 */     GIR_RootConstrainSelectedInstOperands,
     /* 170094 */     // GIR_Coverage, 2265,
     /* 170094 */     GIR_EraseRootFromParent_Done,
     /* 170095 */   // Label 3716: @170095
     /* 170095 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(170157), // Rule ID 6648 //
     /* 170100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 170103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170139 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 170142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170155 */     GIR_RootConstrainSelectedInstOperands,
     /* 170156 */     // GIR_Coverage, 6648,
     /* 170156 */     GIR_EraseRootFromParent_Done,
     /* 170157 */   // Label 3717: @170157
     /* 170157 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(170188), // Rule ID 2263 //
     /* 170162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 170165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170177 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 170177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 170182 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170186 */     GIR_RootConstrainSelectedInstOperands,
     /* 170187 */     // GIR_Coverage, 2263,
     /* 170187 */     GIR_Done,
     /* 170188 */   // Label 3718: @170188
     /* 170188 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(170219), // Rule ID 6644 //
     /* 170193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 170196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170208 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 170208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 170213 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170217 */     GIR_RootConstrainSelectedInstOperands,
     /* 170218 */     // GIR_Coverage, 6644,
     /* 170218 */     GIR_Done,
     /* 170219 */   // Label 3719: @170219
     /* 170219 */   GIM_Reject,
     /* 170220 */ // Label 3715: @170220
     /* 170220 */ GIM_Reject,
     /* 170221 */ // Label 3653: @170221
     /* 170221 */ GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(170318),
     /* 170226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 170229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 170232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170240 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(170294), // Rule ID 6624 //
     /* 170245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170276 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 170279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170292 */     GIR_RootConstrainSelectedInstOperands,
     /* 170293 */     // GIR_Coverage, 6624,
     /* 170293 */     GIR_EraseRootFromParent_Done,
     /* 170294 */   // Label 3721: @170294
     /* 170294 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(170317), // Rule ID 6620 //
     /* 170299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170306 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 170306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 170311 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170315 */     GIR_RootConstrainSelectedInstOperands,
     /* 170316 */     // GIR_Coverage, 6620,
     /* 170316 */     GIR_Done,
     /* 170317 */   // Label 3722: @170317
     /* 170317 */   GIM_Reject,
     /* 170318 */ // Label 3720: @170318
     /* 170318 */ GIM_Reject,
     /* 170319 */ // Label 3654: @170319
     /* 170319 */ GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(170416),
     /* 170324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 170327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 170330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170338 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(170392), // Rule ID 6708 //
     /* 170343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 170346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170374 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 170377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170390 */     GIR_RootConstrainSelectedInstOperands,
     /* 170391 */     // GIR_Coverage, 6708,
     /* 170391 */     GIR_EraseRootFromParent_Done,
     /* 170392 */   // Label 3724: @170392
     /* 170392 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(170415), // Rule ID 6704 //
     /* 170397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 170400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170404 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 170404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 170409 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170413 */     GIR_RootConstrainSelectedInstOperands,
     /* 170414 */     // GIR_Coverage, 6704,
     /* 170414 */     GIR_Done,
     /* 170415 */   // Label 3725: @170415
     /* 170415 */   GIM_Reject,
     /* 170416 */ // Label 3723: @170416
     /* 170416 */ GIM_Reject,
     /* 170417 */ // Label 3655: @170417
     /* 170417 */ GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(170514),
     /* 170422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 170425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 170428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170436 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(170490), // Rule ID 6612 //
     /* 170441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170472 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 170475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170488 */     GIR_RootConstrainSelectedInstOperands,
     /* 170489 */     // GIR_Coverage, 6612,
     /* 170489 */     GIR_EraseRootFromParent_Done,
     /* 170490 */   // Label 3727: @170490
     /* 170490 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(170513), // Rule ID 6608 //
     /* 170495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170502 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 170502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 170507 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170511 */     GIR_RootConstrainSelectedInstOperands,
     /* 170512 */     // GIR_Coverage, 6608,
     /* 170512 */     GIR_Done,
     /* 170513 */   // Label 3728: @170513
     /* 170513 */   GIM_Reject,
     /* 170514 */ // Label 3726: @170514
     /* 170514 */ GIM_Reject,
     /* 170515 */ // Label 3656: @170515
     /* 170515 */ GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(170612),
     /* 170520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 170523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 170526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170534 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(170588), // Rule ID 6684 //
     /* 170539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170570 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 170573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170586 */     GIR_RootConstrainSelectedInstOperands,
     /* 170587 */     // GIR_Coverage, 6684,
     /* 170587 */     GIR_EraseRootFromParent_Done,
     /* 170588 */   // Label 3730: @170588
     /* 170588 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(170611), // Rule ID 6680 //
     /* 170593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170600 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 170600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 170605 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170609 */     GIR_RootConstrainSelectedInstOperands,
     /* 170610 */     // GIR_Coverage, 6680,
     /* 170610 */     GIR_Done,
     /* 170611 */   // Label 3731: @170611
     /* 170611 */   GIM_Reject,
     /* 170612 */ // Label 3729: @170612
     /* 170612 */ GIM_Reject,
     /* 170613 */ // Label 3657: @170613
     /* 170613 */ GIM_Reject,
     /* 170614 */ // Label 46: @170614
     /* 170614 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3735*/ GIMT_Encode4(170736),
     /* 170625 */ /*GILLT_s32*//*Label 3732*/ GIMT_Encode4(170637),
     /* 170629 */ /*GILLT_s64*//*Label 3733*/ GIMT_Encode4(170670),
     /* 170633 */ /*GILLT_s80*//*Label 3734*/ GIMT_Encode4(170703),
     /* 170637 */ // Label 3732: @170637
     /* 170637 */ GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(170669), // Rule ID 1042 //
     /* 170642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170656 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 170656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 170661 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170667 */   GIR_RootConstrainSelectedInstOperands,
     /* 170668 */   // GIR_Coverage, 1042,
     /* 170668 */   GIR_Done,
     /* 170669 */ // Label 3736: @170669
     /* 170669 */ GIM_Reject,
     /* 170670 */ // Label 3733: @170670
     /* 170670 */ GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(170702), // Rule ID 1043 //
     /* 170675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 170678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170689 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 170689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 170694 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170700 */   GIR_RootConstrainSelectedInstOperands,
     /* 170701 */   // GIR_Coverage, 1043,
     /* 170701 */   GIR_Done,
     /* 170702 */ // Label 3737: @170702
     /* 170702 */ GIM_Reject,
     /* 170703 */ // Label 3734: @170703
     /* 170703 */ GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(170735), // Rule ID 1044 //
     /* 170708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 170711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 170714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170722 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 170722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 170727 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170733 */   GIR_RootConstrainSelectedInstOperands,
     /* 170734 */   // GIR_Coverage, 1044,
     /* 170734 */   GIR_Done,
     /* 170735 */ // Label 3738: @170735
     /* 170735 */ GIM_Reject,
     /* 170736 */ // Label 3735: @170736
     /* 170736 */ GIM_Reject,
     /* 170737 */ // Label 47: @170737
     /* 170737 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 3746*/ GIMT_Encode4(171668),
     /* 170748 */ /*GILLT_s32*//*Label 3739*/ GIMT_Encode4(170816),
     /* 170752 */ /*GILLT_s64*//*Label 3740*/ GIMT_Encode4(170937),
     /* 170756 */ /*GILLT_s80*//*Label 3741*/ GIMT_Encode4(171420), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170780 */ /*GILLT_v4s64*//*Label 3742*/ GIMT_Encode4(171481), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170792 */ /*GILLT_v8s32*//*Label 3743*/ GIMT_Encode4(171545),
     /* 170796 */ /*GILLT_v8s64*//*Label 3744*/ GIMT_Encode4(171576), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170812 */ /*GILLT_v16s32*//*Label 3745*/ GIMT_Encode4(171637),
     /* 170816 */ // Label 3739: @170816
     /* 170816 */ GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(170936),
     /* 170821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 170824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170828 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(170897), // Rule ID 21204 //
     /* 170833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 170836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170864 */     // (fpextend:{ *:[f32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 170864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 170867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrm),
     /* 170881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170895 */     GIR_RootConstrainSelectedInstOperands,
     /* 170896 */     // GIR_Coverage, 21204,
     /* 170896 */     GIR_EraseRootFromParent_Done,
     /* 170897 */   // Label 3748: @170897
     /* 170897 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(170935), // Rule ID 21202 //
     /* 170902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 170909 */     // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 170909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 170912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 170926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 170933 */     GIR_RootConstrainSelectedInstOperands,
     /* 170934 */     // GIR_Coverage, 21202,
     /* 170934 */     GIR_EraseRootFromParent_Done,
     /* 170935 */   // Label 3749: @170935
     /* 170935 */   GIM_Reject,
     /* 170936 */ // Label 3747: @170936
     /* 170936 */ GIM_Reject,
     /* 170937 */ // Label 3740: @170937
     /* 170937 */ GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(170996), // Rule ID 1894 //
     /* 170942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 170945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170960 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170967 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170973 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170980 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 170980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrm),
     /* 170983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170985 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170994 */   GIR_RootConstrainSelectedInstOperands,
     /* 170995 */   // GIR_Coverage, 1894,
     /* 170995 */   GIR_EraseRootFromParent_Done,
     /* 170996 */ // Label 3750: @170996
     /* 170996 */ GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(171072), // Rule ID 18002 //
     /* 171001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 171004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171019 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171022 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171026 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171032 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171039 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 171039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrm),
     /* 171056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171061 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171070 */   GIR_RootConstrainSelectedInstOperands,
     /* 171071 */   // GIR_Coverage, 18002,
     /* 171071 */   GIR_EraseRootFromParent_Done,
     /* 171072 */ // Label 3751: @171072
     /* 171072 */ GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(171148), // Rule ID 21198 //
     /* 171077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 171080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171095 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171102 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171108 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171115 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 171115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrm),
     /* 171132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171137 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171146 */   GIR_RootConstrainSelectedInstOperands,
     /* 171147 */   // GIR_Coverage, 21198,
     /* 171147 */   GIR_EraseRootFromParent_Done,
     /* 171148 */ // Label 3752: @171148
     /* 171148 */ GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(171224), // Rule ID 21208 //
     /* 171153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 171156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 171159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171171 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171174 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171178 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171184 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171191 */   // (fpextend:{ *:[f64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 171191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrm),
     /* 171208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171213 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171217 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171222 */   GIR_RootConstrainSelectedInstOperands,
     /* 171223 */   // GIR_Coverage, 21208,
     /* 171223 */   GIR_EraseRootFromParent_Done,
     /* 171224 */ // Label 3753: @171224
     /* 171224 */ GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(171254), // Rule ID 1892 //
     /* 171229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171243 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 171243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 171248 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171252 */   GIR_RootConstrainSelectedInstOperands,
     /* 171253 */   // GIR_Coverage, 1892,
     /* 171253 */   GIR_Done,
     /* 171254 */ // Label 3754: @171254
     /* 171254 */ GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(171284), // Rule ID 17727 //
     /* 171259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171273 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 171273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 171283 */   // GIR_Coverage, 17727,
     /* 171283 */   GIR_Done,
     /* 171284 */ // Label 3755: @171284
     /* 171284 */ GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(171329), // Rule ID 18000 //
     /* 171289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171303 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 171303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 171320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171327 */   GIR_RootConstrainSelectedInstOperands,
     /* 171328 */   // GIR_Coverage, 18000,
     /* 171328 */   GIR_EraseRootFromParent_Done,
     /* 171329 */ // Label 3756: @171329
     /* 171329 */ GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(171374), // Rule ID 21196 //
     /* 171334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171348 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 171348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 171365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171370 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171372 */   GIR_RootConstrainSelectedInstOperands,
     /* 171373 */   // GIR_Coverage, 21196,
     /* 171373 */   GIR_EraseRootFromParent_Done,
     /* 171374 */ // Label 3757: @171374
     /* 171374 */ GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(171419), // Rule ID 21206 //
     /* 171379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 171385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171393 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 171393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 171410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171415 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171417 */   GIR_RootConstrainSelectedInstOperands,
     /* 171418 */   // GIR_Coverage, 21206,
     /* 171418 */   GIR_EraseRootFromParent_Done,
     /* 171419 */ // Label 3758: @171419
     /* 171419 */ GIM_Reject,
     /* 171420 */ // Label 3741: @171420
     /* 171420 */ GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(171450), // Rule ID 17729 //
     /* 171425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171439 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 171439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 171449 */   // GIR_Coverage, 17729,
     /* 171449 */   GIR_Done,
     /* 171450 */ // Label 3759: @171450
     /* 171450 */ GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(171480), // Rule ID 17731 //
     /* 171455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171469 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 171469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 171479 */   // GIR_Coverage, 17731,
     /* 171479 */   GIR_Done,
     /* 171480 */ // Label 3760: @171480
     /* 171480 */ GIM_Reject,
     /* 171481 */ // Label 3742: @171481
     /* 171481 */ GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(171544),
     /* 171486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171489 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(171516), // Rule ID 1935 //
     /* 171494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 171497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 171501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 171505 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 171505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 171510 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171514 */     GIR_RootConstrainSelectedInstOperands,
     /* 171515 */     // GIR_Coverage, 1935,
     /* 171515 */     GIR_Done,
     /* 171516 */   // Label 3762: @171516
     /* 171516 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(171543), // Rule ID 10575 //
     /* 171521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 171524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 171532 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 171532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 171537 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171541 */     GIR_RootConstrainSelectedInstOperands,
     /* 171542 */     // GIR_Coverage, 10575,
     /* 171542 */     GIR_Done,
     /* 171543 */   // Label 3763: @171543
     /* 171543 */   GIM_Reject,
     /* 171544 */ // Label 3761: @171544
     /* 171544 */ GIM_Reject,
     /* 171545 */ // Label 3743: @171545
     /* 171545 */ GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(171575), // Rule ID 10638 //
     /* 171550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 171553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 171564 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 171564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 171569 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171573 */   GIR_RootConstrainSelectedInstOperands,
     /* 171574 */   // GIR_Coverage, 10638,
     /* 171574 */   GIR_Done,
     /* 171575 */ // Label 3764: @171575
     /* 171575 */ GIM_Reject,
     /* 171576 */ // Label 3744: @171576
     /* 171576 */ GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(171606), // Rule ID 10550 //
     /* 171581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 171587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 171591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171595 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 171595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 171600 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171604 */   GIR_RootConstrainSelectedInstOperands,
     /* 171605 */   // GIR_Coverage, 10550,
     /* 171605 */   GIR_Done,
     /* 171606 */ // Label 3765: @171606
     /* 171606 */ GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(171636), // Rule ID 10664 //
     /* 171611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 171621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 171625 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 171625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 171630 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171634 */   GIR_RootConstrainSelectedInstOperands,
     /* 171635 */   // GIR_Coverage, 10664,
     /* 171635 */   GIR_Done,
     /* 171636 */ // Label 3766: @171636
     /* 171636 */ GIM_Reject,
     /* 171637 */ // Label 3745: @171637
     /* 171637 */ GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(171667), // Rule ID 10613 //
     /* 171642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 171648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 171652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171656 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 171656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 171661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171665 */   GIR_RootConstrainSelectedInstOperands,
     /* 171666 */   // GIR_Coverage, 10613,
     /* 171666 */   GIR_Done,
     /* 171667 */ // Label 3767: @171667
     /* 171667 */ GIM_Reject,
     /* 171668 */ // Label 3746: @171668
     /* 171668 */ GIM_Reject,
     /* 171669 */ // Label 48: @171669
     /* 171669 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 3771*/ GIMT_Encode4(172054),
     /* 171680 */ /*GILLT_s16*//*Label 3768*/ GIMT_Encode4(171692),
     /* 171684 */ /*GILLT_s32*//*Label 3769*/ GIMT_Encode4(171783),
     /* 171688 */ /*GILLT_s64*//*Label 3770*/ GIMT_Encode4(172023),
     /* 171692 */ // Label 3768: @171692
     /* 171692 */ GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(171737), // Rule ID 21210 //
     /* 171697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171711 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 171711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 171728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171733 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171735 */   GIR_RootConstrainSelectedInstOperands,
     /* 171736 */   // GIR_Coverage, 21210,
     /* 171736 */   GIR_EraseRootFromParent_Done,
     /* 171737 */ // Label 3772: @171737
     /* 171737 */ GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(171782), // Rule ID 21212 //
     /* 171742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171756 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 171756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 171773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171775 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171780 */   GIR_RootConstrainSelectedInstOperands,
     /* 171781 */   // GIR_Coverage, 21212,
     /* 171781 */   GIR_EraseRootFromParent_Done,
     /* 171782 */ // Label 3773: @171782
     /* 171782 */ GIM_Reject,
     /* 171783 */ // Label 3769: @171783
     /* 171783 */ GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(171842), // Rule ID 1882 //
     /* 171788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 171791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171798 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171802 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171806 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171813 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171819 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171826 */   // (fpround:{ *:[f32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 171826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrm),
     /* 171829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171831 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171840 */   GIR_RootConstrainSelectedInstOperands,
     /* 171841 */   // GIR_Coverage, 1882,
     /* 171841 */   GIR_EraseRootFromParent_Done,
     /* 171842 */ // Label 3774: @171842
     /* 171842 */ GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(171872), // Rule ID 1880 //
     /* 171847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171861 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 171861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 171866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171870 */   GIR_RootConstrainSelectedInstOperands,
     /* 171871 */   // GIR_Coverage, 1880,
     /* 171871 */   GIR_Done,
     /* 171872 */ // Label 3775: @171872
     /* 171872 */ GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(171902), // Rule ID 17733 //
     /* 171877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171891 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 171891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 171901 */   // GIR_Coverage, 17733,
     /* 171901 */   GIR_Done,
     /* 171902 */ // Label 3776: @171902
     /* 171902 */ GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(171932), // Rule ID 17735 //
     /* 171907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 171913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171921 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 171921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 171931 */   // GIR_Coverage, 17735,
     /* 171931 */   GIR_Done,
     /* 171932 */ // Label 3777: @171932
     /* 171932 */ GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(171977), // Rule ID 17998 //
     /* 171937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171951 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 171951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 171968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171975 */   GIR_RootConstrainSelectedInstOperands,
     /* 171976 */   // GIR_Coverage, 17998,
     /* 171976 */   GIR_EraseRootFromParent_Done,
     /* 171977 */ // Label 3778: @171977
     /* 171977 */ GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(172022), // Rule ID 21200 //
     /* 171982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171996 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 171996 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171999 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 172003 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 172013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 172020 */   GIR_RootConstrainSelectedInstOperands,
     /* 172021 */   // GIR_Coverage, 21200,
     /* 172021 */   GIR_EraseRootFromParent_Done,
     /* 172022 */ // Label 3779: @172022
     /* 172022 */ GIM_Reject,
     /* 172023 */ // Label 3770: @172023
     /* 172023 */ GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(172053), // Rule ID 17737 //
     /* 172028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 172031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 172034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 172038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172042 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 172042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 172052 */   // GIR_Coverage, 17737,
     /* 172052 */   GIR_Done,
     /* 172053 */ // Label 3780: @172053
     /* 172053 */ GIM_Reject,
     /* 172054 */ // Label 3771: @172054
     /* 172054 */ GIM_Reject,
     /* 172055 */ // Label 49: @172055
     /* 172055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 3784*/ GIMT_Encode4(173435),
     /* 172066 */ /*GILLT_s32*//*Label 3781*/ GIMT_Encode4(172098),
     /* 172070 */ /*GILLT_s64*//*Label 3782*/ GIMT_Encode4(172722), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 172094 */ /*GILLT_v4s32*//*Label 3783*/ GIMT_Encode4(173346),
     /* 172098 */ // Label 3781: @172098
     /* 172098 */ GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(172157), // Rule ID 1742 //
     /* 172103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172121 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172128 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172134 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172141 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrm),
     /* 172144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172146 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172155 */   GIR_RootConstrainSelectedInstOperands,
     /* 172156 */   // GIR_Coverage, 1742,
     /* 172156 */   GIR_EraseRootFromParent_Done,
     /* 172157 */ // Label 3785: @172157
     /* 172157 */ GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(172216), // Rule ID 1750 //
     /* 172162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172180 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172187 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172193 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172200 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrm),
     /* 172203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172205 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172214 */   GIR_RootConstrainSelectedInstOperands,
     /* 172215 */   // GIR_Coverage, 1750,
     /* 172215 */   GIR_EraseRootFromParent_Done,
     /* 172216 */ // Label 3786: @172216
     /* 172216 */ GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(172275), // Rule ID 1766 //
     /* 172221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172239 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172242 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172246 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172252 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172259 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrm),
     /* 172262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172264 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172268 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172273 */   GIR_RootConstrainSelectedInstOperands,
     /* 172274 */   // GIR_Coverage, 1766,
     /* 172274 */   GIR_EraseRootFromParent_Done,
     /* 172275 */ // Label 3787: @172275
     /* 172275 */ GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(172334), // Rule ID 1774 //
     /* 172280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172290 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172294 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172298 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172301 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172305 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172309 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172311 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172318 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrm),
     /* 172321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172323 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172332 */   GIR_RootConstrainSelectedInstOperands,
     /* 172333 */   // GIR_Coverage, 1774,
     /* 172333 */   GIR_EraseRootFromParent_Done,
     /* 172334 */ // Label 3788: @172334
     /* 172334 */ GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(172393), // Rule ID 10363 //
     /* 172339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172349 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172353 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172357 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172364 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172370 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172377 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrm),
     /* 172380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172382 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172391 */   GIR_RootConstrainSelectedInstOperands,
     /* 172392 */   // GIR_Coverage, 10363,
     /* 172392 */   GIR_EraseRootFromParent_Done,
     /* 172393 */ // Label 3789: @172393
     /* 172393 */ GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(172452), // Rule ID 10381 //
     /* 172398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172416 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172423 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172429 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172436 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrm),
     /* 172439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172441 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172450 */   GIR_RootConstrainSelectedInstOperands,
     /* 172451 */   // GIR_Coverage, 10381,
     /* 172451 */   GIR_EraseRootFromParent_Done,
     /* 172452 */ // Label 3790: @172452
     /* 172452 */ GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(172511), // Rule ID 15171 //
     /* 172457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172475 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172478 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172482 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172486 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172488 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172495 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /* 172498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172500 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172509 */   GIR_RootConstrainSelectedInstOperands,
     /* 172510 */   // GIR_Coverage, 15171,
     /* 172510 */   GIR_EraseRootFromParent_Done,
     /* 172511 */ // Label 3791: @172511
     /* 172511 */ GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(172541), // Rule ID 1740 //
     /* 172516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 172530 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 172530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 172535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172539 */   GIR_RootConstrainSelectedInstOperands,
     /* 172540 */   // GIR_Coverage, 1740,
     /* 172540 */   GIR_Done,
     /* 172541 */ // Label 3792: @172541
     /* 172541 */ GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(172571), // Rule ID 1748 //
     /* 172546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 172560 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 172560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 172565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172569 */   GIR_RootConstrainSelectedInstOperands,
     /* 172570 */   // GIR_Coverage, 1748,
     /* 172570 */   GIR_Done,
     /* 172571 */ // Label 3793: @172571
     /* 172571 */ GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(172601), // Rule ID 1764 //
     /* 172576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 172590 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 172590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 172595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172599 */   GIR_RootConstrainSelectedInstOperands,
     /* 172600 */   // GIR_Coverage, 1764,
     /* 172600 */   GIR_Done,
     /* 172601 */ // Label 3794: @172601
     /* 172601 */ GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(172631), // Rule ID 1772 //
     /* 172606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 172620 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 172620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 172625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172629 */   GIR_RootConstrainSelectedInstOperands,
     /* 172630 */   // GIR_Coverage, 1772,
     /* 172630 */   GIR_Done,
     /* 172631 */ // Label 3795: @172631
     /* 172631 */ GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(172661), // Rule ID 10361 //
     /* 172636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 172650 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 172650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 172655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172659 */   GIR_RootConstrainSelectedInstOperands,
     /* 172660 */   // GIR_Coverage, 10361,
     /* 172660 */   GIR_Done,
     /* 172661 */ // Label 3796: @172661
     /* 172661 */ GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(172691), // Rule ID 10379 //
     /* 172666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 172680 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 172680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 172685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172689 */   GIR_RootConstrainSelectedInstOperands,
     /* 172690 */   // GIR_Coverage, 10379,
     /* 172690 */   GIR_Done,
     /* 172691 */ // Label 3797: @172691
     /* 172691 */ GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(172721), // Rule ID 15169 //
     /* 172696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 172710 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 172710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 172715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172719 */   GIR_RootConstrainSelectedInstOperands,
     /* 172720 */   // GIR_Coverage, 15169,
     /* 172720 */   GIR_Done,
     /* 172721 */ // Label 3798: @172721
     /* 172721 */ GIM_Reject,
     /* 172722 */ // Label 3782: @172722
     /* 172722 */ GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(172781), // Rule ID 1746 //
     /* 172727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172745 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172752 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172758 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172765 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rm),
     /* 172768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172770 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172779 */   GIR_RootConstrainSelectedInstOperands,
     /* 172780 */   // GIR_Coverage, 1746,
     /* 172780 */   GIR_EraseRootFromParent_Done,
     /* 172781 */ // Label 3799: @172781
     /* 172781 */ GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(172840), // Rule ID 1754 //
     /* 172786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172804 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172807 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172811 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172817 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172824 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rm),
     /* 172827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172829 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172838 */   GIR_RootConstrainSelectedInstOperands,
     /* 172839 */   // GIR_Coverage, 1754,
     /* 172839 */   GIR_EraseRootFromParent_Done,
     /* 172840 */ // Label 3800: @172840
     /* 172840 */ GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(172899), // Rule ID 1770 //
     /* 172845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172855 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172863 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172870 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172876 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172883 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rm),
     /* 172886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172888 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172897 */   GIR_RootConstrainSelectedInstOperands,
     /* 172898 */   // GIR_Coverage, 1770,
     /* 172898 */   GIR_EraseRootFromParent_Done,
     /* 172899 */ // Label 3801: @172899
     /* 172899 */ GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(172958), // Rule ID 1778 //
     /* 172904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172922 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172925 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172929 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172935 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172942 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rm),
     /* 172945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172947 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172956 */   GIR_RootConstrainSelectedInstOperands,
     /* 172957 */   // GIR_Coverage, 1778,
     /* 172957 */   GIR_EraseRootFromParent_Done,
     /* 172958 */ // Label 3802: @172958
     /* 172958 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(173017), // Rule ID 10372 //
     /* 172963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172981 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172988 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172994 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173001 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrm),
     /* 173004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173006 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173010 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173015 */   GIR_RootConstrainSelectedInstOperands,
     /* 173016 */   // GIR_Coverage, 10372,
     /* 173016 */   GIR_EraseRootFromParent_Done,
     /* 173017 */ // Label 3803: @173017
     /* 173017 */ GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(173076), // Rule ID 10390 //
     /* 173022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173040 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173043 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173047 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173053 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173060 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrm),
     /* 173063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173065 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173074 */   GIR_RootConstrainSelectedInstOperands,
     /* 173075 */   // GIR_Coverage, 10390,
     /* 173075 */   GIR_EraseRootFromParent_Done,
     /* 173076 */ // Label 3804: @173076
     /* 173076 */ GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(173135), // Rule ID 15180 //
     /* 173081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173099 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173106 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173112 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173119 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /* 173122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173124 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173133 */   GIR_RootConstrainSelectedInstOperands,
     /* 173134 */   // GIR_Coverage, 15180,
     /* 173134 */   GIR_EraseRootFromParent_Done,
     /* 173135 */ // Label 3805: @173135
     /* 173135 */ GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(173165), // Rule ID 1744 //
     /* 173140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 173143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173154 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 173154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 173159 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173163 */   GIR_RootConstrainSelectedInstOperands,
     /* 173164 */   // GIR_Coverage, 1744,
     /* 173164 */   GIR_Done,
     /* 173165 */ // Label 3806: @173165
     /* 173165 */ GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(173195), // Rule ID 1752 //
     /* 173170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 173173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 173184 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 173184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 173189 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173193 */   GIR_RootConstrainSelectedInstOperands,
     /* 173194 */   // GIR_Coverage, 1752,
     /* 173194 */   GIR_Done,
     /* 173195 */ // Label 3807: @173195
     /* 173195 */ GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(173225), // Rule ID 1768 //
     /* 173200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 173203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173214 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 173214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 173219 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173223 */   GIR_RootConstrainSelectedInstOperands,
     /* 173224 */   // GIR_Coverage, 1768,
     /* 173224 */   GIR_Done,
     /* 173225 */ // Label 3808: @173225
     /* 173225 */ GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(173255), // Rule ID 1776 //
     /* 173230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 173233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 173244 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 173244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 173249 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173253 */   GIR_RootConstrainSelectedInstOperands,
     /* 173254 */   // GIR_Coverage, 1776,
     /* 173254 */   GIR_Done,
     /* 173255 */ // Label 3809: @173255
     /* 173255 */ GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(173285), // Rule ID 10370 //
     /* 173260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173274 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 173274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 173279 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173283 */   GIR_RootConstrainSelectedInstOperands,
     /* 173284 */   // GIR_Coverage, 10370,
     /* 173284 */   GIR_Done,
     /* 173285 */ // Label 3810: @173285
     /* 173285 */ GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(173315), // Rule ID 10388 //
     /* 173290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173304 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 173304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 173309 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173313 */   GIR_RootConstrainSelectedInstOperands,
     /* 173314 */   // GIR_Coverage, 10388,
     /* 173314 */   GIR_Done,
     /* 173315 */ // Label 3811: @173315
     /* 173315 */ GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(173345), // Rule ID 15178 //
     /* 173320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173334 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 173334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 173339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173343 */   GIR_RootConstrainSelectedInstOperands,
     /* 173344 */   // GIR_Coverage, 15178,
     /* 173344 */   GIR_Done,
     /* 173345 */ // Label 3812: @173345
     /* 173345 */ GIM_Reject,
     /* 173346 */ // Label 3783: @173346
     /* 173346 */ GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(173434),
     /* 173351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 173354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 173358 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(173410), // Rule ID 18054 //
     /* 173363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173394 */     // (fp_to_sint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 173394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrm),
     /* 173397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173408 */     GIR_RootConstrainSelectedInstOperands,
     /* 173409 */     // GIR_Coverage, 18054,
     /* 173409 */     GIR_EraseRootFromParent_Done,
     /* 173410 */   // Label 3814: @173410
     /* 173410 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(173433), // Rule ID 18052 //
     /* 173415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173422 */     // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 173422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 173427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173431 */     GIR_RootConstrainSelectedInstOperands,
     /* 173432 */     // GIR_Coverage, 18052,
     /* 173432 */     GIR_Done,
     /* 173433 */   // Label 3815: @173433
     /* 173433 */   GIM_Reject,
     /* 173434 */ // Label 3813: @173434
     /* 173434 */ GIM_Reject,
     /* 173435 */ // Label 3784: @173435
     /* 173435 */ GIM_Reject,
     /* 173436 */ // Label 50: @173436
     /* 173436 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3818*/ GIMT_Encode4(173991),
     /* 173447 */ /*GILLT_s32*//*Label 3816*/ GIMT_Encode4(173455),
     /* 173451 */ /*GILLT_s64*//*Label 3817*/ GIMT_Encode4(173723),
     /* 173455 */ // Label 3816: @173455
     /* 173455 */ GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(173514), // Rule ID 10399 //
     /* 173460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173478 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173481 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173485 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173489 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173491 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173498 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 173498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrm),
     /* 173501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173503 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173512 */   GIR_RootConstrainSelectedInstOperands,
     /* 173513 */   // GIR_Coverage, 10399,
     /* 173513 */   GIR_EraseRootFromParent_Done,
     /* 173514 */ // Label 3819: @173514
     /* 173514 */ GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(173573), // Rule ID 10417 //
     /* 173519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173529 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173533 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173537 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173544 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173548 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173550 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173557 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 173557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrm),
     /* 173560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173562 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173566 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173571 */   GIR_RootConstrainSelectedInstOperands,
     /* 173572 */   // GIR_Coverage, 10417,
     /* 173572 */   GIR_EraseRootFromParent_Done,
     /* 173573 */ // Label 3820: @173573
     /* 173573 */ GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(173632), // Rule ID 15189 //
     /* 173578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173596 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173603 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173609 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173616 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 173616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrm),
     /* 173619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173621 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173630 */   GIR_RootConstrainSelectedInstOperands,
     /* 173631 */   // GIR_Coverage, 15189,
     /* 173631 */   GIR_EraseRootFromParent_Done,
     /* 173632 */ // Label 3821: @173632
     /* 173632 */ GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(173662), // Rule ID 10397 //
     /* 173637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173651 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 173651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 173656 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173660 */   GIR_RootConstrainSelectedInstOperands,
     /* 173661 */   // GIR_Coverage, 10397,
     /* 173661 */   GIR_Done,
     /* 173662 */ // Label 3822: @173662
     /* 173662 */ GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(173692), // Rule ID 10415 //
     /* 173667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173681 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 173681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 173686 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173690 */   GIR_RootConstrainSelectedInstOperands,
     /* 173691 */   // GIR_Coverage, 10415,
     /* 173691 */   GIR_Done,
     /* 173692 */ // Label 3823: @173692
     /* 173692 */ GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(173722), // Rule ID 15187 //
     /* 173697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173711 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 173711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 173716 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173720 */   GIR_RootConstrainSelectedInstOperands,
     /* 173721 */   // GIR_Coverage, 15187,
     /* 173721 */   GIR_Done,
     /* 173722 */ // Label 3824: @173722
     /* 173722 */ GIM_Reject,
     /* 173723 */ // Label 3817: @173723
     /* 173723 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(173782), // Rule ID 10408 //
     /* 173728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173746 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173749 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173753 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173759 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173766 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrm),
     /* 173769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173771 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173775 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173780 */   GIR_RootConstrainSelectedInstOperands,
     /* 173781 */   // GIR_Coverage, 10408,
     /* 173781 */   GIR_EraseRootFromParent_Done,
     /* 173782 */ // Label 3825: @173782
     /* 173782 */ GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(173841), // Rule ID 10426 //
     /* 173787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173805 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173808 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173812 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173818 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173825 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrm),
     /* 173828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173830 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173839 */   GIR_RootConstrainSelectedInstOperands,
     /* 173840 */   // GIR_Coverage, 10426,
     /* 173840 */   GIR_EraseRootFromParent_Done,
     /* 173841 */ // Label 3826: @173841
     /* 173841 */ GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(173900), // Rule ID 15198 //
     /* 173846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173864 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173871 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173877 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173884 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrm),
     /* 173887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173889 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173893 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173898 */   GIR_RootConstrainSelectedInstOperands,
     /* 173899 */   // GIR_Coverage, 15198,
     /* 173899 */   GIR_EraseRootFromParent_Done,
     /* 173900 */ // Label 3827: @173900
     /* 173900 */ GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(173930), // Rule ID 10406 //
     /* 173905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173919 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 173919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 173924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173928 */   GIR_RootConstrainSelectedInstOperands,
     /* 173929 */   // GIR_Coverage, 10406,
     /* 173929 */   GIR_Done,
     /* 173930 */ // Label 3828: @173930
     /* 173930 */ GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(173960), // Rule ID 10424 //
     /* 173935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173949 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 173949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 173954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173958 */   GIR_RootConstrainSelectedInstOperands,
     /* 173959 */   // GIR_Coverage, 10424,
     /* 173959 */   GIR_Done,
     /* 173960 */ // Label 3829: @173960
     /* 173960 */ GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(173990), // Rule ID 15196 //
     /* 173965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173979 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 173979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 173984 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173988 */   GIR_RootConstrainSelectedInstOperands,
     /* 173989 */   // GIR_Coverage, 15196,
     /* 173989 */   GIR_Done,
     /* 173990 */ // Label 3830: @173990
     /* 173990 */ GIM_Reject,
     /* 173991 */ // Label 3818: @173991
     /* 173991 */ GIM_Reject,
     /* 173992 */ // Label 51: @173992
     /* 173992 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3843*/ GIMT_Encode4(177367),
     /* 174003 */ /*GILLT_s16*//*Label 3831*/ GIMT_Encode4(174087),
     /* 174007 */ /*GILLT_s32*//*Label 3832*/ GIMT_Encode4(174330),
     /* 174011 */ /*GILLT_s64*//*Label 3833*/ GIMT_Encode4(174993), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174027 */ /*GILLT_v2s64*//*Label 3834*/ GIMT_Encode4(175652), GIMT_Encode4(0),
     /* 174035 */ /*GILLT_v4s32*//*Label 3835*/ GIMT_Encode4(175741),
     /* 174039 */ /*GILLT_v4s64*//*Label 3836*/ GIMT_Encode4(176039), GIMT_Encode4(0),
     /* 174047 */ /*GILLT_v8s16*//*Label 3837*/ GIMT_Encode4(176299),
     /* 174051 */ /*GILLT_v8s32*//*Label 3838*/ GIMT_Encode4(176567),
     /* 174055 */ /*GILLT_v8s64*//*Label 3839*/ GIMT_Encode4(176835), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174067 */ /*GILLT_v16s16*//*Label 3840*/ GIMT_Encode4(177010),
     /* 174071 */ /*GILLT_v16s32*//*Label 3841*/ GIMT_Encode4(177189), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174083 */ /*GILLT_v32s16*//*Label 3842*/ GIMT_Encode4(177278),
     /* 174087 */ // Label 3831: @174087
     /* 174087 */ GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(174163), // Rule ID 22179 //
     /* 174092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174110 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174113 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174117 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174123 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174130 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 174130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrm),
     /* 174147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174152 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174161 */   GIR_RootConstrainSelectedInstOperands,
     /* 174162 */   // GIR_Coverage, 22179,
     /* 174162 */   GIR_EraseRootFromParent_Done,
     /* 174163 */ // Label 3844: @174163
     /* 174163 */ GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(174239), // Rule ID 22177 //
     /* 174168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174186 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174189 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174193 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174199 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174206 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 174206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrm),
     /* 174223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174228 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174237 */   GIR_RootConstrainSelectedInstOperands,
     /* 174238 */   // GIR_Coverage, 22177,
     /* 174238 */   GIR_EraseRootFromParent_Done,
     /* 174239 */ // Label 3845: @174239
     /* 174239 */ GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(174284), // Rule ID 22181 //
     /* 174244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174258 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 174258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 174275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174280 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174282 */   GIR_RootConstrainSelectedInstOperands,
     /* 174283 */   // GIR_Coverage, 22181,
     /* 174283 */   GIR_EraseRootFromParent_Done,
     /* 174284 */ // Label 3846: @174284
     /* 174284 */ GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(174329), // Rule ID 22183 //
     /* 174289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174303 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 174303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 174320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174327 */   GIR_RootConstrainSelectedInstOperands,
     /* 174328 */   // GIR_Coverage, 22183,
     /* 174328 */   GIR_EraseRootFromParent_Done,
     /* 174329 */ // Label 3847: @174329
     /* 174329 */ GIM_Reject,
     /* 174330 */ // Label 3832: @174330
     /* 174330 */ GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(174389), // Rule ID 1794 //
     /* 174335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174353 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174356 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174360 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174364 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174366 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174373 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 174373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrm),
     /* 174376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174378 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174387 */   GIR_RootConstrainSelectedInstOperands,
     /* 174388 */   // GIR_Coverage, 1794,
     /* 174388 */   GIR_EraseRootFromParent_Done,
     /* 174389 */ // Label 3848: @174389
     /* 174389 */ GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(174465), // Rule ID 17976 //
     /* 174394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174412 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174415 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174419 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174423 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174425 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174432 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrm),
     /* 174449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174454 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174463 */   GIR_RootConstrainSelectedInstOperands,
     /* 174464 */   // GIR_Coverage, 17976,
     /* 174464 */   GIR_EraseRootFromParent_Done,
     /* 174465 */ // Label 3849: @174465
     /* 174465 */ GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(174541), // Rule ID 21130 //
     /* 174470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174488 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174491 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174495 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174501 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174508 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrm),
     /* 174525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174530 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174534 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174539 */   GIR_RootConstrainSelectedInstOperands,
     /* 174540 */   // GIR_Coverage, 21130,
     /* 174540 */   GIR_EraseRootFromParent_Done,
     /* 174541 */ // Label 3850: @174541
     /* 174541 */ GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(174600), // Rule ID 1790 //
     /* 174546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174564 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174567 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174571 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174577 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174584 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 174584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrm),
     /* 174587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174589 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174593 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174598 */   GIR_RootConstrainSelectedInstOperands,
     /* 174599 */   // GIR_Coverage, 1790,
     /* 174599 */   GIR_EraseRootFromParent_Done,
     /* 174600 */ // Label 3851: @174600
     /* 174600 */ GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(174676), // Rule ID 17974 //
     /* 174605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174623 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174626 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174630 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174636 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174643 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrm),
     /* 174660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174665 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174674 */   GIR_RootConstrainSelectedInstOperands,
     /* 174675 */   // GIR_Coverage, 17974,
     /* 174675 */   GIR_EraseRootFromParent_Done,
     /* 174676 */ // Label 3852: @174676
     /* 174676 */ GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(174752), // Rule ID 21128 //
     /* 174681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174699 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174702 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174706 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174710 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174712 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174719 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrm),
     /* 174736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174741 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174750 */   GIR_RootConstrainSelectedInstOperands,
     /* 174751 */   // GIR_Coverage, 21128,
     /* 174751 */   GIR_EraseRootFromParent_Done,
     /* 174752 */ // Label 3853: @174752
     /* 174752 */ GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(174782), // Rule ID 1788 //
     /* 174757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174771 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 174771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 174776 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174780 */   GIR_RootConstrainSelectedInstOperands,
     /* 174781 */   // GIR_Coverage, 1788,
     /* 174781 */   GIR_Done,
     /* 174782 */ // Label 3854: @174782
     /* 174782 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(174812), // Rule ID 1792 //
     /* 174787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174801 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 174801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 174806 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174810 */   GIR_RootConstrainSelectedInstOperands,
     /* 174811 */   // GIR_Coverage, 1792,
     /* 174811 */   GIR_Done,
     /* 174812 */ // Label 3855: @174812
     /* 174812 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(174857), // Rule ID 17982 //
     /* 174817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174831 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 174831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 174848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174855 */   GIR_RootConstrainSelectedInstOperands,
     /* 174856 */   // GIR_Coverage, 17982,
     /* 174856 */   GIR_EraseRootFromParent_Done,
     /* 174857 */ // Label 3856: @174857
     /* 174857 */ GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(174902), // Rule ID 17984 //
     /* 174862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174876 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 174876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 174893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174898 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174900 */   GIR_RootConstrainSelectedInstOperands,
     /* 174901 */   // GIR_Coverage, 17984,
     /* 174901 */   GIR_EraseRootFromParent_Done,
     /* 174902 */ // Label 3857: @174902
     /* 174902 */ GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(174947), // Rule ID 21136 //
     /* 174907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174921 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 174921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 174938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174943 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174945 */   GIR_RootConstrainSelectedInstOperands,
     /* 174946 */   // GIR_Coverage, 21136,
     /* 174946 */   GIR_EraseRootFromParent_Done,
     /* 174947 */ // Label 3858: @174947
     /* 174947 */ GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(174992), // Rule ID 21138 //
     /* 174952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174966 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 174966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 174983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174990 */   GIR_RootConstrainSelectedInstOperands,
     /* 174991 */   // GIR_Coverage, 21138,
     /* 174991 */   GIR_EraseRootFromParent_Done,
     /* 174992 */ // Label 3859: @174992
     /* 174992 */ GIM_Reject,
     /* 174993 */ // Label 3833: @174993
     /* 174993 */ GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(175052), // Rule ID 1802 //
     /* 174998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175008 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175012 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175016 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175019 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175023 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175029 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175036 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 175036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrm),
     /* 175039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175041 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175050 */   GIR_RootConstrainSelectedInstOperands,
     /* 175051 */   // GIR_Coverage, 1802,
     /* 175051 */   GIR_EraseRootFromParent_Done,
     /* 175052 */ // Label 3860: @175052
     /* 175052 */ GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(175128), // Rule ID 17980 //
     /* 175057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175075 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175082 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175088 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175095 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrm),
     /* 175112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175117 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175126 */   GIR_RootConstrainSelectedInstOperands,
     /* 175127 */   // GIR_Coverage, 17980,
     /* 175127 */   GIR_EraseRootFromParent_Done,
     /* 175128 */ // Label 3861: @175128
     /* 175128 */ GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(175204), // Rule ID 21134 //
     /* 175133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175151 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175154 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175158 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175164 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175171 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrm),
     /* 175188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175193 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175202 */   GIR_RootConstrainSelectedInstOperands,
     /* 175203 */   // GIR_Coverage, 21134,
     /* 175203 */   GIR_EraseRootFromParent_Done,
     /* 175204 */ // Label 3862: @175204
     /* 175204 */ GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(175263), // Rule ID 1798 //
     /* 175209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175227 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175230 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175234 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 175238 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175240 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175247 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 175247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrm),
     /* 175250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175252 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175261 */   GIR_RootConstrainSelectedInstOperands,
     /* 175262 */   // GIR_Coverage, 1798,
     /* 175262 */   GIR_EraseRootFromParent_Done,
     /* 175263 */ // Label 3863: @175263
     /* 175263 */ GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(175339), // Rule ID 17978 //
     /* 175268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175286 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175289 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175293 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 175297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175299 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175306 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrm),
     /* 175323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175328 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175337 */   GIR_RootConstrainSelectedInstOperands,
     /* 175338 */   // GIR_Coverage, 17978,
     /* 175338 */   GIR_EraseRootFromParent_Done,
     /* 175339 */ // Label 3864: @175339
     /* 175339 */ GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(175415), // Rule ID 21132 //
     /* 175344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175362 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175365 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175369 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 175373 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175375 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175382 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrm),
     /* 175399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175404 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175413 */   GIR_RootConstrainSelectedInstOperands,
     /* 175414 */   // GIR_Coverage, 21132,
     /* 175414 */   GIR_EraseRootFromParent_Done,
     /* 175415 */ // Label 3865: @175415
     /* 175415 */ GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(175441), // Rule ID 1796 //
     /* 175420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175434 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 175434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 175439 */   GIR_RootConstrainSelectedInstOperands,
     /* 175440 */   // GIR_Coverage, 1796,
     /* 175440 */   GIR_Done,
     /* 175441 */ // Label 3866: @175441
     /* 175441 */ GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(175471), // Rule ID 1800 //
     /* 175446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 175460 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 175460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 175465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175469 */   GIR_RootConstrainSelectedInstOperands,
     /* 175470 */   // GIR_Coverage, 1800,
     /* 175470 */   GIR_Done,
     /* 175471 */ // Label 3867: @175471
     /* 175471 */ GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(175516), // Rule ID 17986 //
     /* 175476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175490 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 175490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 175507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175514 */   GIR_RootConstrainSelectedInstOperands,
     /* 175515 */   // GIR_Coverage, 17986,
     /* 175515 */   GIR_EraseRootFromParent_Done,
     /* 175516 */ // Label 3868: @175516
     /* 175516 */ GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(175561), // Rule ID 17988 //
     /* 175521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 175535 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 175535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 175552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175557 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175559 */   GIR_RootConstrainSelectedInstOperands,
     /* 175560 */   // GIR_Coverage, 17988,
     /* 175560 */   GIR_EraseRootFromParent_Done,
     /* 175561 */ // Label 3869: @175561
     /* 175561 */ GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(175606), // Rule ID 21140 //
     /* 175566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175580 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 175580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 175597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175602 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175604 */   GIR_RootConstrainSelectedInstOperands,
     /* 175605 */   // GIR_Coverage, 21140,
     /* 175605 */   GIR_EraseRootFromParent_Done,
     /* 175606 */ // Label 3870: @175606
     /* 175606 */ GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(175651), // Rule ID 21142 //
     /* 175611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 175625 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 175625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 175642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175649 */   GIR_RootConstrainSelectedInstOperands,
     /* 175650 */   // GIR_Coverage, 21142,
     /* 175650 */   GIR_EraseRootFromParent_Done,
     /* 175651 */ // Label 3871: @175651
     /* 175651 */ GIM_Reject,
     /* 175652 */ // Label 3834: @175652
     /* 175652 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(175740),
     /* 175657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175664 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(175716), // Rule ID 11379 //
     /* 175669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175680 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175700 */     // (sint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 175700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rm),
     /* 175703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175714 */     GIR_RootConstrainSelectedInstOperands,
     /* 175715 */     // GIR_Coverage, 11379,
     /* 175715 */     GIR_EraseRootFromParent_Done,
     /* 175716 */   // Label 3873: @175716
     /* 175716 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(175739), // Rule ID 11375 //
     /* 175721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175728 */     // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 175728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 175733 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175737 */     GIR_RootConstrainSelectedInstOperands,
     /* 175738 */     // GIR_Coverage, 11375,
     /* 175738 */     GIR_Done,
     /* 175739 */   // Label 3874: @175739
     /* 175739 */   GIM_Reject,
     /* 175740 */ // Label 3872: @175740
     /* 175740 */ GIM_Reject,
     /* 175741 */ // Label 3835: @175741
     /* 175741 */ GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(175800), // Rule ID 1870 //
     /* 175746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175764 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175767 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175771 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175777 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175784 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrm),
     /* 175787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175789 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175798 */   GIR_RootConstrainSelectedInstOperands,
     /* 175799 */   // GIR_Coverage, 1870,
     /* 175799 */   GIR_EraseRootFromParent_Done,
     /* 175800 */ // Label 3875: @175800
     /* 175800 */ GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(175859), // Rule ID 10755 //
     /* 175805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175823 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175830 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175836 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175843 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rm),
     /* 175846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175848 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175857 */   GIR_RootConstrainSelectedInstOperands,
     /* 175858 */   // GIR_Coverage, 10755,
     /* 175858 */   GIR_EraseRootFromParent_Done,
     /* 175859 */ // Label 3876: @175859
     /* 175859 */ GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(175918), // Rule ID 11511 //
     /* 175864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 175870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175882 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175885 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175889 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175895 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175902 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rm),
     /* 175905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175907 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175911 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175916 */   GIR_RootConstrainSelectedInstOperands,
     /* 175917 */   // GIR_Coverage, 11511,
     /* 175917 */   GIR_EraseRootFromParent_Done,
     /* 175918 */ // Label 3877: @175918
     /* 175918 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(175948), // Rule ID 1868 //
     /* 175923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175937 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 175937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 175942 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175946 */   GIR_RootConstrainSelectedInstOperands,
     /* 175947 */   // GIR_Coverage, 1868,
     /* 175947 */   GIR_Done,
     /* 175948 */ // Label 3878: @175948
     /* 175948 */ GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(175978), // Rule ID 1876 //
     /* 175953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175967 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 175967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 175972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175976 */   GIR_RootConstrainSelectedInstOperands,
     /* 175977 */   // GIR_Coverage, 1876,
     /* 175977 */   GIR_Done,
     /* 175978 */ // Label 3879: @175978
     /* 175978 */ GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(176008), // Rule ID 10751 //
     /* 175983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175997 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 175997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 176002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176006 */   GIR_RootConstrainSelectedInstOperands,
     /* 176007 */   // GIR_Coverage, 10751,
     /* 176007 */   GIR_Done,
     /* 176008 */ // Label 3880: @176008
     /* 176008 */ GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(176038), // Rule ID 11507 //
     /* 176013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 176016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176027 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 176027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 176032 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176036 */   GIR_RootConstrainSelectedInstOperands,
     /* 176037 */   // GIR_Coverage, 11507,
     /* 176037 */   GIR_Done,
     /* 176038 */ // Label 3881: @176038
     /* 176038 */ GIM_Reject,
     /* 176039 */ // Label 3836: @176039
     /* 176039 */ GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(176098), // Rule ID 1945 //
     /* 176044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176062 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176065 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176069 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176075 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176082 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 176082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrm),
     /* 176085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176087 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176096 */   GIR_RootConstrainSelectedInstOperands,
     /* 176097 */   // GIR_Coverage, 1945,
     /* 176097 */   GIR_EraseRootFromParent_Done,
     /* 176098 */ // Label 3882: @176098
     /* 176098 */ GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(176157), // Rule ID 10728 //
     /* 176103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176121 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176128 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176134 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176141 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 176141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rm),
     /* 176144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176146 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176155 */   GIR_RootConstrainSelectedInstOperands,
     /* 176156 */   // GIR_Coverage, 10728,
     /* 176156 */   GIR_EraseRootFromParent_Done,
     /* 176157 */ // Label 3883: @176157
     /* 176157 */ GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(176216), // Rule ID 11391 //
     /* 176162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 176165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176180 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176187 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176193 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176200 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 176200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rm),
     /* 176203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176205 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176214 */   GIR_RootConstrainSelectedInstOperands,
     /* 176215 */   // GIR_Coverage, 11391,
     /* 176215 */   GIR_EraseRootFromParent_Done,
     /* 176216 */ // Label 3884: @176216
     /* 176216 */ GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(176242), // Rule ID 1947 //
     /* 176221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 176235 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 176235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 176240 */   GIR_RootConstrainSelectedInstOperands,
     /* 176241 */   // GIR_Coverage, 1947,
     /* 176241 */   GIR_Done,
     /* 176242 */ // Label 3885: @176242
     /* 176242 */ GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(176268), // Rule ID 10724 //
     /* 176247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176261 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 176261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 176266 */   GIR_RootConstrainSelectedInstOperands,
     /* 176267 */   // GIR_Coverage, 10724,
     /* 176267 */   GIR_Done,
     /* 176268 */ // Label 3886: @176268
     /* 176268 */ GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(176298), // Rule ID 11387 //
     /* 176273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 176276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176287 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 176287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 176292 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176296 */   GIR_RootConstrainSelectedInstOperands,
     /* 176297 */   // GIR_Coverage, 11387,
     /* 176297 */   GIR_Done,
     /* 176298 */ // Label 3887: @176298
     /* 176298 */ GIM_Reject,
     /* 176299 */ // Label 3837: @176299
     /* 176299 */ GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(176358), // Rule ID 11457 //
     /* 176304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176314 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176318 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176322 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176325 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176329 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176335 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176342 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 176342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rm),
     /* 176345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176347 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176356 */   GIR_RootConstrainSelectedInstOperands,
     /* 176357 */   // GIR_Coverage, 11457,
     /* 176357 */   GIR_EraseRootFromParent_Done,
     /* 176358 */ // Label 3888: @176358
     /* 176358 */ GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(176417), // Rule ID 14823 //
     /* 176363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176381 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176388 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176394 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176401 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 176401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rm),
     /* 176404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176406 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176415 */   GIR_RootConstrainSelectedInstOperands,
     /* 176416 */   // GIR_Coverage, 14823,
     /* 176416 */   GIR_EraseRootFromParent_Done,
     /* 176417 */ // Label 3889: @176417
     /* 176417 */ GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(176476), // Rule ID 15123 //
     /* 176422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176440 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176443 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176447 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176451 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176453 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176460 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 176460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrm),
     /* 176463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176465 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176474 */   GIR_RootConstrainSelectedInstOperands,
     /* 176475 */   // GIR_Coverage, 15123,
     /* 176475 */   GIR_EraseRootFromParent_Done,
     /* 176476 */ // Label 3890: @176476
     /* 176476 */ GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(176506), // Rule ID 11453 //
     /* 176481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176495 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 176495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 176500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176504 */   GIR_RootConstrainSelectedInstOperands,
     /* 176505 */   // GIR_Coverage, 11453,
     /* 176505 */   GIR_Done,
     /* 176506 */ // Label 3891: @176506
     /* 176506 */ GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(176536), // Rule ID 14819 //
     /* 176511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176525 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 176525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 176530 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176534 */   GIR_RootConstrainSelectedInstOperands,
     /* 176535 */   // GIR_Coverage, 14819,
     /* 176535 */   GIR_Done,
     /* 176536 */ // Label 3892: @176536
     /* 176536 */ GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(176566), // Rule ID 15119 //
     /* 176541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176555 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 176555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 176560 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176564 */   GIR_RootConstrainSelectedInstOperands,
     /* 176565 */   // GIR_Coverage, 15119,
     /* 176565 */   GIR_Done,
     /* 176566 */ // Label 3893: @176566
     /* 176566 */ GIM_Reject,
     /* 176567 */ // Label 3838: @176567
     /* 176567 */ GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(176626), // Rule ID 1874 //
     /* 176572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176590 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176597 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176603 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176610 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrm),
     /* 176613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176615 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176624 */   GIR_RootConstrainSelectedInstOperands,
     /* 176625 */   // GIR_Coverage, 1874,
     /* 176625 */   GIR_EraseRootFromParent_Done,
     /* 176626 */ // Label 3894: @176626
     /* 176626 */ GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(176685), // Rule ID 10767 //
     /* 176631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176649 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176656 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176662 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176669 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rm),
     /* 176672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176674 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176683 */   GIR_RootConstrainSelectedInstOperands,
     /* 176684 */   // GIR_Coverage, 10767,
     /* 176684 */   GIR_EraseRootFromParent_Done,
     /* 176685 */ // Label 3895: @176685
     /* 176685 */ GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(176744), // Rule ID 11496 //
     /* 176690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176708 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176711 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176715 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176721 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176728 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrm),
     /* 176731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176733 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176742 */   GIR_RootConstrainSelectedInstOperands,
     /* 176743 */   // GIR_Coverage, 11496,
     /* 176743 */   GIR_EraseRootFromParent_Done,
     /* 176744 */ // Label 3896: @176744
     /* 176744 */ GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(176774), // Rule ID 1872 //
     /* 176749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176763 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 176763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 176768 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176772 */   GIR_RootConstrainSelectedInstOperands,
     /* 176773 */   // GIR_Coverage, 1872,
     /* 176773 */   GIR_Done,
     /* 176774 */ // Label 3897: @176774
     /* 176774 */ GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(176804), // Rule ID 10763 //
     /* 176779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176793 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 176793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 176798 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176802 */   GIR_RootConstrainSelectedInstOperands,
     /* 176803 */   // GIR_Coverage, 10763,
     /* 176803 */   GIR_Done,
     /* 176804 */ // Label 3898: @176804
     /* 176804 */ GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(176834), // Rule ID 11492 //
     /* 176809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176823 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 176823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 176828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176832 */   GIR_RootConstrainSelectedInstOperands,
     /* 176833 */   // GIR_Coverage, 11492,
     /* 176833 */   GIR_Done,
     /* 176834 */ // Label 3899: @176834
     /* 176834 */ GIM_Reject,
     /* 176835 */ // Label 3839: @176835
     /* 176835 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(176894), // Rule ID 10704 //
     /* 176840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176858 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176865 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176871 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176878 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 176878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrm),
     /* 176881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176883 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176892 */   GIR_RootConstrainSelectedInstOperands,
     /* 176893 */   // GIR_Coverage, 10704,
     /* 176893 */   GIR_EraseRootFromParent_Done,
     /* 176894 */ // Label 3900: @176894
     /* 176894 */ GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(176953), // Rule ID 11364 //
     /* 176899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176917 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176924 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176930 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176937 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 176937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrm),
     /* 176940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176942 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176951 */   GIR_RootConstrainSelectedInstOperands,
     /* 176952 */   // GIR_Coverage, 11364,
     /* 176952 */   GIR_EraseRootFromParent_Done,
     /* 176953 */ // Label 3901: @176953
     /* 176953 */ GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(176979), // Rule ID 10700 //
     /* 176958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176972 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 176972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 176977 */   GIR_RootConstrainSelectedInstOperands,
     /* 176978 */   // GIR_Coverage, 10700,
     /* 176978 */   GIR_Done,
     /* 176979 */ // Label 3902: @176979
     /* 176979 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(177009), // Rule ID 11360 //
     /* 176984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176998 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 176998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 177003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177007 */   GIR_RootConstrainSelectedInstOperands,
     /* 177008 */   // GIR_Coverage, 11360,
     /* 177008 */   GIR_Done,
     /* 177009 */ // Label 3903: @177009
     /* 177009 */ GIM_Reject,
     /* 177010 */ // Label 3840: @177010
     /* 177010 */ GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(177069), // Rule ID 11442 //
     /* 177015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 177021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177033 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177040 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177046 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177053 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 177053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrm),
     /* 177056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177058 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177067 */   GIR_RootConstrainSelectedInstOperands,
     /* 177068 */   // GIR_Coverage, 11442,
     /* 177068 */   GIR_EraseRootFromParent_Done,
     /* 177069 */ // Label 3904: @177069
     /* 177069 */ GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(177128), // Rule ID 14835 //
     /* 177074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 177077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 177080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177092 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177099 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177105 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177112 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 177112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rm),
     /* 177115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177117 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177126 */   GIR_RootConstrainSelectedInstOperands,
     /* 177127 */   // GIR_Coverage, 14835,
     /* 177127 */   GIR_EraseRootFromParent_Done,
     /* 177128 */ // Label 3905: @177128
     /* 177128 */ GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(177158), // Rule ID 11438 //
     /* 177133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 177139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177147 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 177147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 177152 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177156 */   GIR_RootConstrainSelectedInstOperands,
     /* 177157 */   // GIR_Coverage, 11438,
     /* 177157 */   GIR_Done,
     /* 177158 */ // Label 3906: @177158
     /* 177158 */ GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(177188), // Rule ID 14831 //
     /* 177163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 177166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 177169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177177 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 177177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 177182 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177186 */   GIR_RootConstrainSelectedInstOperands,
     /* 177187 */   // GIR_Coverage, 14831,
     /* 177187 */   GIR_Done,
     /* 177188 */ // Label 3907: @177188
     /* 177188 */ GIM_Reject,
     /* 177189 */ // Label 3841: @177189
     /* 177189 */ GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(177277),
     /* 177194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 177197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177201 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(177253), // Rule ID 10740 //
     /* 177206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177217 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177220 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177224 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177237 */     // (sint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 177237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrm),
     /* 177240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177251 */     GIR_RootConstrainSelectedInstOperands,
     /* 177252 */     // GIR_Coverage, 10740,
     /* 177252 */     GIR_EraseRootFromParent_Done,
     /* 177253 */   // Label 3909: @177253
     /* 177253 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(177276), // Rule ID 10736 //
     /* 177258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177265 */     // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 177265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 177270 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177274 */     GIR_RootConstrainSelectedInstOperands,
     /* 177275 */     // GIR_Coverage, 10736,
     /* 177275 */     GIR_Done,
     /* 177276 */   // Label 3910: @177276
     /* 177276 */   GIM_Reject,
     /* 177277 */ // Label 3908: @177277
     /* 177277 */ GIM_Reject,
     /* 177278 */ // Label 3842: @177278
     /* 177278 */ GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(177366),
     /* 177283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 177286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177290 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(177342), // Rule ID 14808 //
     /* 177295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177326 */     // (sint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 177326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrm),
     /* 177329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177340 */     GIR_RootConstrainSelectedInstOperands,
     /* 177341 */     // GIR_Coverage, 14808,
     /* 177341 */     GIR_EraseRootFromParent_Done,
     /* 177342 */   // Label 3912: @177342
     /* 177342 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(177365), // Rule ID 14804 //
     /* 177347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177354 */     // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 177354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 177359 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177363 */     GIR_RootConstrainSelectedInstOperands,
     /* 177364 */     // GIR_Coverage, 14804,
     /* 177364 */     GIR_Done,
     /* 177365 */   // Label 3913: @177365
     /* 177365 */   GIM_Reject,
     /* 177366 */ // Label 3911: @177366
     /* 177366 */ GIM_Reject,
     /* 177367 */ // Label 3843: @177367
     /* 177367 */ GIM_Reject,
     /* 177368 */ // Label 52: @177368
     /* 177368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3926*/ GIMT_Encode4(179614),
     /* 177379 */ /*GILLT_s16*//*Label 3914*/ GIMT_Encode4(177463),
     /* 177383 */ /*GILLT_s32*//*Label 3915*/ GIMT_Encode4(177706),
     /* 177387 */ /*GILLT_s64*//*Label 3916*/ GIMT_Encode4(177949), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177403 */ /*GILLT_v2s64*//*Label 3917*/ GIMT_Encode4(178192), GIMT_Encode4(0),
     /* 177411 */ /*GILLT_v4s32*//*Label 3918*/ GIMT_Encode4(178281),
     /* 177415 */ /*GILLT_v4s64*//*Label 3919*/ GIMT_Encode4(178460), GIMT_Encode4(0),
     /* 177423 */ /*GILLT_v8s16*//*Label 3920*/ GIMT_Encode4(178635),
     /* 177427 */ /*GILLT_v8s32*//*Label 3921*/ GIMT_Encode4(178903),
     /* 177431 */ /*GILLT_v8s64*//*Label 3922*/ GIMT_Encode4(179082), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177443 */ /*GILLT_v16s16*//*Label 3923*/ GIMT_Encode4(179257),
     /* 177447 */ /*GILLT_v16s32*//*Label 3924*/ GIMT_Encode4(179436), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177459 */ /*GILLT_v32s16*//*Label 3925*/ GIMT_Encode4(179525),
     /* 177463 */ // Label 3914: @177463
     /* 177463 */ GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(177539), // Rule ID 22187 //
     /* 177468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177486 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177489 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177493 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177499 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177506 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrm),
     /* 177523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177528 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177537 */   GIR_RootConstrainSelectedInstOperands,
     /* 177538 */   // GIR_Coverage, 22187,
     /* 177538 */   GIR_EraseRootFromParent_Done,
     /* 177539 */ // Label 3927: @177539
     /* 177539 */ GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(177615), // Rule ID 22185 //
     /* 177544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177562 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177565 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177569 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177575 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177582 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrm),
     /* 177599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177604 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177613 */   GIR_RootConstrainSelectedInstOperands,
     /* 177614 */   // GIR_Coverage, 22185,
     /* 177614 */   GIR_EraseRootFromParent_Done,
     /* 177615 */ // Label 3928: @177615
     /* 177615 */ GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(177660), // Rule ID 22189 //
     /* 177620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177634 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 177634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 177651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177656 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177658 */   GIR_RootConstrainSelectedInstOperands,
     /* 177659 */   // GIR_Coverage, 22189,
     /* 177659 */   GIR_EraseRootFromParent_Done,
     /* 177660 */ // Label 3929: @177660
     /* 177660 */ GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(177705), // Rule ID 22191 //
     /* 177665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177679 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 177679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 177696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177701 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177703 */   GIR_RootConstrainSelectedInstOperands,
     /* 177704 */   // GIR_Coverage, 22191,
     /* 177704 */   GIR_EraseRootFromParent_Done,
     /* 177705 */ // Label 3930: @177705
     /* 177705 */ GIM_Reject,
     /* 177706 */ // Label 3915: @177706
     /* 177706 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(177782), // Rule ID 21146 //
     /* 177711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177729 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177732 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177736 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177742 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177749 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrm),
     /* 177766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177768 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177771 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177775 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177780 */   GIR_RootConstrainSelectedInstOperands,
     /* 177781 */   // GIR_Coverage, 21146,
     /* 177781 */   GIR_EraseRootFromParent_Done,
     /* 177782 */ // Label 3931: @177782
     /* 177782 */ GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(177858), // Rule ID 21144 //
     /* 177787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177805 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177808 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177812 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177818 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177825 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177825 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177828 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177832 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrm),
     /* 177842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177847 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177856 */   GIR_RootConstrainSelectedInstOperands,
     /* 177857 */   // GIR_Coverage, 21144,
     /* 177857 */   GIR_EraseRootFromParent_Done,
     /* 177858 */ // Label 3932: @177858
     /* 177858 */ GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(177903), // Rule ID 21152 //
     /* 177863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177877 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 177877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 177894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177901 */   GIR_RootConstrainSelectedInstOperands,
     /* 177902 */   // GIR_Coverage, 21152,
     /* 177902 */   GIR_EraseRootFromParent_Done,
     /* 177903 */ // Label 3933: @177903
     /* 177903 */ GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(177948), // Rule ID 21154 //
     /* 177908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177922 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 177922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 177939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177944 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177946 */   GIR_RootConstrainSelectedInstOperands,
     /* 177947 */   // GIR_Coverage, 21154,
     /* 177947 */   GIR_EraseRootFromParent_Done,
     /* 177948 */ // Label 3934: @177948
     /* 177948 */ GIM_Reject,
     /* 177949 */ // Label 3916: @177949
     /* 177949 */ GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(178025), // Rule ID 21150 //
     /* 177954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177964 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177968 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177972 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177979 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177985 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177992 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 177992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrm),
     /* 178009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178014 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178023 */   GIR_RootConstrainSelectedInstOperands,
     /* 178024 */   // GIR_Coverage, 21150,
     /* 178024 */   GIR_EraseRootFromParent_Done,
     /* 178025 */ // Label 3935: @178025
     /* 178025 */ GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(178101), // Rule ID 21148 //
     /* 178030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178048 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178051 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178055 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178061 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178068 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrm),
     /* 178085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178090 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178099 */   GIR_RootConstrainSelectedInstOperands,
     /* 178100 */   // GIR_Coverage, 21148,
     /* 178100 */   GIR_EraseRootFromParent_Done,
     /* 178101 */ // Label 3936: @178101
     /* 178101 */ GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(178146), // Rule ID 21156 //
     /* 178106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178120 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 178137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178142 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178144 */   GIR_RootConstrainSelectedInstOperands,
     /* 178145 */   // GIR_Coverage, 21156,
     /* 178145 */   GIR_EraseRootFromParent_Done,
     /* 178146 */ // Label 3937: @178146
     /* 178146 */ GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(178191), // Rule ID 21158 //
     /* 178151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178165 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 178182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178187 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178189 */   GIR_RootConstrainSelectedInstOperands,
     /* 178190 */   // GIR_Coverage, 21158,
     /* 178190 */   GIR_EraseRootFromParent_Done,
     /* 178191 */ // Label 3938: @178191
     /* 178191 */ GIM_Reject,
     /* 178192 */ // Label 3917: @178192
     /* 178192 */ GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(178280),
     /* 178197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178204 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(178256), // Rule ID 11418 //
     /* 178209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178220 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178223 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178227 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178240 */     // (uint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 178240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rm),
     /* 178243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178254 */     GIR_RootConstrainSelectedInstOperands,
     /* 178255 */     // GIR_Coverage, 11418,
     /* 178255 */     GIR_EraseRootFromParent_Done,
     /* 178256 */   // Label 3940: @178256
     /* 178256 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(178279), // Rule ID 11414 //
     /* 178261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178268 */     // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 178268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 178273 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178277 */     GIR_RootConstrainSelectedInstOperands,
     /* 178278 */     // GIR_Coverage, 11414,
     /* 178278 */     GIR_Done,
     /* 178279 */   // Label 3941: @178279
     /* 178279 */   GIM_Reject,
     /* 178280 */ // Label 3939: @178280
     /* 178280 */ GIM_Reject,
     /* 178281 */ // Label 3918: @178281
     /* 178281 */ GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(178340), // Rule ID 10962 //
     /* 178286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178304 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178307 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178311 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178317 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178324 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 178324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rm),
     /* 178327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178329 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178338 */   GIR_RootConstrainSelectedInstOperands,
     /* 178339 */   // GIR_Coverage, 10962,
     /* 178339 */   GIR_EraseRootFromParent_Done,
     /* 178340 */ // Label 3942: @178340
     /* 178340 */ GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(178399), // Rule ID 11538 //
     /* 178345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178363 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178370 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178376 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178383 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 178383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rm),
     /* 178386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178388 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178392 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178397 */   GIR_RootConstrainSelectedInstOperands,
     /* 178398 */   // GIR_Coverage, 11538,
     /* 178398 */   GIR_EraseRootFromParent_Done,
     /* 178399 */ // Label 3943: @178399
     /* 178399 */ GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(178429), // Rule ID 10958 //
     /* 178404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178418 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 178418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 178423 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178427 */   GIR_RootConstrainSelectedInstOperands,
     /* 178428 */   // GIR_Coverage, 10958,
     /* 178428 */   GIR_Done,
     /* 178429 */ // Label 3944: @178429
     /* 178429 */ GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(178459), // Rule ID 11534 //
     /* 178434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178448 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 178448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 178453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178457 */   GIR_RootConstrainSelectedInstOperands,
     /* 178458 */   // GIR_Coverage, 11534,
     /* 178458 */   GIR_Done,
     /* 178459 */ // Label 3945: @178459
     /* 178459 */ GIM_Reject,
     /* 178460 */ // Label 3919: @178460
     /* 178460 */ GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(178519), // Rule ID 10935 //
     /* 178465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178483 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178486 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178490 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178496 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178503 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 178503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rm),
     /* 178506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178508 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178517 */   GIR_RootConstrainSelectedInstOperands,
     /* 178518 */   // GIR_Coverage, 10935,
     /* 178518 */   GIR_EraseRootFromParent_Done,
     /* 178519 */ // Label 3946: @178519
     /* 178519 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(178578), // Rule ID 11430 //
     /* 178524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178542 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178545 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178549 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178555 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178562 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 178562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rm),
     /* 178565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178567 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178571 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178576 */   GIR_RootConstrainSelectedInstOperands,
     /* 178577 */   // GIR_Coverage, 11430,
     /* 178577 */   GIR_EraseRootFromParent_Done,
     /* 178578 */ // Label 3947: @178578
     /* 178578 */ GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(178604), // Rule ID 10931 //
     /* 178583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178597 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 178597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 178602 */   GIR_RootConstrainSelectedInstOperands,
     /* 178603 */   // GIR_Coverage, 10931,
     /* 178603 */   GIR_Done,
     /* 178604 */ // Label 3948: @178604
     /* 178604 */ GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(178634), // Rule ID 11426 //
     /* 178609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178623 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 178623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 178628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178632 */   GIR_RootConstrainSelectedInstOperands,
     /* 178633 */   // GIR_Coverage, 11426,
     /* 178633 */   GIR_Done,
     /* 178634 */ // Label 3949: @178634
     /* 178634 */ GIM_Reject,
     /* 178635 */ // Label 3920: @178635
     /* 178635 */ GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(178694), // Rule ID 11484 //
     /* 178640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178658 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178665 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178669 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178671 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178678 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rm),
     /* 178681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178683 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178687 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178692 */   GIR_RootConstrainSelectedInstOperands,
     /* 178693 */   // GIR_Coverage, 11484,
     /* 178693 */   GIR_EraseRootFromParent_Done,
     /* 178694 */ // Label 3950: @178694
     /* 178694 */ GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(178753), // Rule ID 14676 //
     /* 178699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178717 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178720 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178724 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178730 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178737 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rm),
     /* 178740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178742 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178746 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178751 */   GIR_RootConstrainSelectedInstOperands,
     /* 178752 */   // GIR_Coverage, 14676,
     /* 178752 */   GIR_EraseRootFromParent_Done,
     /* 178753 */ // Label 3951: @178753
     /* 178753 */ GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(178812), // Rule ID 15138 //
     /* 178758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178776 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178783 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178787 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178789 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178796 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrm),
     /* 178799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178801 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178810 */   GIR_RootConstrainSelectedInstOperands,
     /* 178811 */   // GIR_Coverage, 15138,
     /* 178811 */   GIR_EraseRootFromParent_Done,
     /* 178812 */ // Label 3952: @178812
     /* 178812 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(178842), // Rule ID 11480 //
     /* 178817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178831 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 178831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 178836 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178840 */   GIR_RootConstrainSelectedInstOperands,
     /* 178841 */   // GIR_Coverage, 11480,
     /* 178841 */   GIR_Done,
     /* 178842 */ // Label 3953: @178842
     /* 178842 */ GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(178872), // Rule ID 14672 //
     /* 178847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178861 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 178861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 178866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178870 */   GIR_RootConstrainSelectedInstOperands,
     /* 178871 */   // GIR_Coverage, 14672,
     /* 178871 */   GIR_Done,
     /* 178872 */ // Label 3954: @178872
     /* 178872 */ GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(178902), // Rule ID 15134 //
     /* 178877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178891 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 178891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 178896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178900 */   GIR_RootConstrainSelectedInstOperands,
     /* 178901 */   // GIR_Coverage, 15134,
     /* 178901 */   GIR_Done,
     /* 178902 */ // Label 3955: @178902
     /* 178902 */ GIM_Reject,
     /* 178903 */ // Label 3921: @178903
     /* 178903 */ GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(178962), // Rule ID 10974 //
     /* 178908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178926 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178929 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178933 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178939 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178946 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 178946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rm),
     /* 178949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178951 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178960 */   GIR_RootConstrainSelectedInstOperands,
     /* 178961 */   // GIR_Coverage, 10974,
     /* 178961 */   GIR_EraseRootFromParent_Done,
     /* 178962 */ // Label 3956: @178962
     /* 178962 */ GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(179021), // Rule ID 11523 //
     /* 178967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 178970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178985 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178992 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178998 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179005 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrm),
     /* 179008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179010 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179019 */   GIR_RootConstrainSelectedInstOperands,
     /* 179020 */   // GIR_Coverage, 11523,
     /* 179020 */   GIR_EraseRootFromParent_Done,
     /* 179021 */ // Label 3957: @179021
     /* 179021 */ GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(179051), // Rule ID 10970 //
     /* 179026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179040 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 179040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 179045 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179049 */   GIR_RootConstrainSelectedInstOperands,
     /* 179050 */   // GIR_Coverage, 10970,
     /* 179050 */   GIR_Done,
     /* 179051 */ // Label 3958: @179051
     /* 179051 */ GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(179081), // Rule ID 11519 //
     /* 179056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179070 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 179070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 179075 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179079 */   GIR_RootConstrainSelectedInstOperands,
     /* 179080 */   // GIR_Coverage, 11519,
     /* 179080 */   GIR_Done,
     /* 179081 */ // Label 3959: @179081
     /* 179081 */ GIM_Reject,
     /* 179082 */ // Label 3922: @179082
     /* 179082 */ GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(179141), // Rule ID 10911 //
     /* 179087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179097 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179101 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179105 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179108 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179112 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179118 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179125 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 179125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrm),
     /* 179128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179130 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179139 */   GIR_RootConstrainSelectedInstOperands,
     /* 179140 */   // GIR_Coverage, 10911,
     /* 179140 */   GIR_EraseRootFromParent_Done,
     /* 179141 */ // Label 3960: @179141
     /* 179141 */ GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(179200), // Rule ID 11403 //
     /* 179146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179156 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179164 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179171 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179177 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179184 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 179184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrm),
     /* 179187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179189 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179193 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179198 */   GIR_RootConstrainSelectedInstOperands,
     /* 179199 */   // GIR_Coverage, 11403,
     /* 179199 */   GIR_EraseRootFromParent_Done,
     /* 179200 */ // Label 3961: @179200
     /* 179200 */ GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(179226), // Rule ID 10907 //
     /* 179205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179219 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 179219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 179224 */   GIR_RootConstrainSelectedInstOperands,
     /* 179225 */   // GIR_Coverage, 10907,
     /* 179225 */   GIR_Done,
     /* 179226 */ // Label 3962: @179226
     /* 179226 */ GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(179256), // Rule ID 11399 //
     /* 179231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179245 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 179245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 179250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179254 */   GIR_RootConstrainSelectedInstOperands,
     /* 179255 */   // GIR_Coverage, 11399,
     /* 179255 */   GIR_Done,
     /* 179256 */ // Label 3963: @179256
     /* 179256 */ GIM_Reject,
     /* 179257 */ // Label 3923: @179257
     /* 179257 */ GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(179316), // Rule ID 11469 //
     /* 179262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 179268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179272 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179276 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179280 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179287 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179293 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179300 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 179300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrm),
     /* 179303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179305 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179314 */   GIR_RootConstrainSelectedInstOperands,
     /* 179315 */   // GIR_Coverage, 11469,
     /* 179315 */   GIR_EraseRootFromParent_Done,
     /* 179316 */ // Label 3964: @179316
     /* 179316 */ GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(179375), // Rule ID 14688 //
     /* 179321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 179327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179339 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179346 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179352 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179359 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 179359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rm),
     /* 179362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179364 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179373 */   GIR_RootConstrainSelectedInstOperands,
     /* 179374 */   // GIR_Coverage, 14688,
     /* 179374 */   GIR_EraseRootFromParent_Done,
     /* 179375 */ // Label 3965: @179375
     /* 179375 */ GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(179405), // Rule ID 11465 //
     /* 179380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 179386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179394 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 179394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 179399 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179403 */   GIR_RootConstrainSelectedInstOperands,
     /* 179404 */   // GIR_Coverage, 11465,
     /* 179404 */   GIR_Done,
     /* 179405 */ // Label 3966: @179405
     /* 179405 */ GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(179435), // Rule ID 14684 //
     /* 179410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 179416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179424 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 179424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 179429 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179433 */   GIR_RootConstrainSelectedInstOperands,
     /* 179434 */   // GIR_Coverage, 14684,
     /* 179434 */   GIR_Done,
     /* 179435 */ // Label 3967: @179435
     /* 179435 */ GIM_Reject,
     /* 179436 */ // Label 3924: @179436
     /* 179436 */ GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(179524),
     /* 179441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 179444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179448 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(179500), // Rule ID 10947 //
     /* 179453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179484 */     // (uint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 179484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrm),
     /* 179487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179498 */     GIR_RootConstrainSelectedInstOperands,
     /* 179499 */     // GIR_Coverage, 10947,
     /* 179499 */     GIR_EraseRootFromParent_Done,
     /* 179500 */   // Label 3969: @179500
     /* 179500 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(179523), // Rule ID 10943 //
     /* 179505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179512 */     // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 179512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 179517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179521 */     GIR_RootConstrainSelectedInstOperands,
     /* 179522 */     // GIR_Coverage, 10943,
     /* 179522 */     GIR_Done,
     /* 179523 */   // Label 3970: @179523
     /* 179523 */   GIM_Reject,
     /* 179524 */ // Label 3968: @179524
     /* 179524 */ GIM_Reject,
     /* 179525 */ // Label 3925: @179525
     /* 179525 */ GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(179613),
     /* 179530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 179533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179537 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(179589), // Rule ID 14661 //
     /* 179542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179573 */     // (uint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 179573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrm),
     /* 179576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179587 */     GIR_RootConstrainSelectedInstOperands,
     /* 179588 */     // GIR_Coverage, 14661,
     /* 179588 */     GIR_EraseRootFromParent_Done,
     /* 179589 */   // Label 3972: @179589
     /* 179589 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(179612), // Rule ID 14657 //
     /* 179594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179601 */     // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 179601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 179606 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179610 */     GIR_RootConstrainSelectedInstOperands,
     /* 179611 */     // GIR_Coverage, 14657,
     /* 179611 */     GIR_Done,
     /* 179612 */   // Label 3973: @179612
     /* 179612 */   GIM_Reject,
     /* 179613 */ // Label 3971: @179613
     /* 179613 */ GIM_Reject,
     /* 179614 */ // Label 3926: @179614
     /* 179614 */ GIM_Reject,
     /* 179615 */ // Label 53: @179615
     /* 179615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3977*/ GIMT_Encode4(179737),
     /* 179626 */ /*GILLT_s32*//*Label 3974*/ GIMT_Encode4(179638),
     /* 179630 */ /*GILLT_s64*//*Label 3975*/ GIMT_Encode4(179671),
     /* 179634 */ /*GILLT_s80*//*Label 3976*/ GIMT_Encode4(179704),
     /* 179638 */ // Label 3974: @179638
     /* 179638 */ GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(179670), // Rule ID 1045 //
     /* 179643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 179646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 179649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 179653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 179657 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 179657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 179662 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179668 */   GIR_RootConstrainSelectedInstOperands,
     /* 179669 */   // GIR_Coverage, 1045,
     /* 179669 */   GIR_Done,
     /* 179670 */ // Label 3978: @179670
     /* 179670 */ GIM_Reject,
     /* 179671 */ // Label 3975: @179671
     /* 179671 */ GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(179703), // Rule ID 1046 //
     /* 179676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 179679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 179682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 179686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 179690 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 179690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 179695 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179701 */   GIR_RootConstrainSelectedInstOperands,
     /* 179702 */   // GIR_Coverage, 1046,
     /* 179702 */   GIR_Done,
     /* 179703 */ // Label 3979: @179703
     /* 179703 */ GIM_Reject,
     /* 179704 */ // Label 3976: @179704
     /* 179704 */ GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(179736), // Rule ID 1047 //
     /* 179709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 179712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 179715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 179719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 179723 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 179723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 179728 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179734 */   GIR_RootConstrainSelectedInstOperands,
     /* 179735 */   // GIR_Coverage, 1047,
     /* 179735 */   GIR_Done,
     /* 179736 */ // Label 3980: @179736
     /* 179736 */ GIM_Reject,
     /* 179737 */ // Label 3977: @179737
     /* 179737 */ GIM_Reject,
     /* 179738 */ // Label 54: @179738
     /* 179738 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 3993*/ GIMT_Encode4(183058),
     /* 179749 */ /*GILLT_v2s64*//*Label 3981*/ GIMT_Encode4(179817), GIMT_Encode4(0),
     /* 179757 */ /*GILLT_v4s32*//*Label 3982*/ GIMT_Encode4(180146),
     /* 179761 */ /*GILLT_v4s64*//*Label 3983*/ GIMT_Encode4(180488), GIMT_Encode4(0),
     /* 179769 */ /*GILLT_v8s16*//*Label 3984*/ GIMT_Encode4(180805),
     /* 179773 */ /*GILLT_v8s32*//*Label 3985*/ GIMT_Encode4(181147),
     /* 179777 */ /*GILLT_v8s64*//*Label 3986*/ GIMT_Encode4(181462), GIMT_Encode4(0),
     /* 179785 */ /*GILLT_v16s8*//*Label 3987*/ GIMT_Encode4(181618),
     /* 179789 */ /*GILLT_v16s16*//*Label 3988*/ GIMT_Encode4(181960),
     /* 179793 */ /*GILLT_v16s32*//*Label 3989*/ GIMT_Encode4(182275), GIMT_Encode4(0),
     /* 179801 */ /*GILLT_v32s8*//*Label 3990*/ GIMT_Encode4(182431),
     /* 179805 */ /*GILLT_v32s16*//*Label 3991*/ GIMT_Encode4(182746), GIMT_Encode4(0),
     /* 179813 */ /*GILLT_v64s8*//*Label 3992*/ GIMT_Encode4(182902),
     /* 179817 */ // Label 3981: @179817
     /* 179817 */ GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(180145),
     /* 179822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179828 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(179890), // Rule ID 24077 //
     /* 179833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179872 */     // (smin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 179875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 179879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179888 */     GIR_RootConstrainSelectedInstOperands,
     /* 179889 */     // GIR_Coverage, 24077,
     /* 179889 */     GIR_EraseRootFromParent_Done,
     /* 179890 */   // Label 3995: @179890
     /* 179890 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(179952), // Rule ID 5590 //
     /* 179895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179914 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179917 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179934 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 179937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 179941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179950 */     GIR_RootConstrainSelectedInstOperands,
     /* 179951 */     // GIR_Coverage, 5590,
     /* 179951 */     GIR_EraseRootFromParent_Done,
     /* 179952 */   // Label 3996: @179952
     /* 179952 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(179979), // Rule ID 5587 //
     /* 179957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179972 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 179972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 179977 */     GIR_RootConstrainSelectedInstOperands,
     /* 179978 */     // GIR_Coverage, 5587,
     /* 179978 */     GIR_Done,
     /* 179979 */   // Label 3997: @179979
     /* 179979 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(180144), // Rule ID 20014 //
     /* 179984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 179987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 179991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179999 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 179999 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 180002 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180006 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 180013 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 180016 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180020 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180025 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 180028 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 180032 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 180035 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180040 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180045 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 180050 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 180053 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180057 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 180064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 180067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180076 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 180079 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 180083 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 180086 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 180101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 180104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 180108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 180116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 180119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180126 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 180133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 180138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180143 */     // GIR_Coverage, 20014,
     /* 180143 */     GIR_EraseRootFromParent_Done,
     /* 180144 */   // Label 3998: @180144
     /* 180144 */   GIM_Reject,
     /* 180145 */ // Label 3994: @180145
     /* 180145 */ GIM_Reject,
     /* 180146 */ // Label 3982: @180146
     /* 180146 */ GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(180487),
     /* 180151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180157 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(180219), // Rule ID 23501 //
     /* 180162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180177 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180180 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180184 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180201 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 180204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180206 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180217 */     GIR_RootConstrainSelectedInstOperands,
     /* 180218 */     // GIR_Coverage, 23501,
     /* 180218 */     GIR_EraseRootFromParent_Done,
     /* 180219 */   // Label 4000: @180219
     /* 180219 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(180281), // Rule ID 24059 //
     /* 180224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180263 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 180266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180268 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180279 */     GIR_RootConstrainSelectedInstOperands,
     /* 180280 */     // GIR_Coverage, 24059,
     /* 180280 */     GIR_EraseRootFromParent_Done,
     /* 180281 */   // Label 4001: @180281
     /* 180281 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(180343), // Rule ID 3186 //
     /* 180286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180325 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 180328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180341 */     GIR_RootConstrainSelectedInstOperands,
     /* 180342 */     // GIR_Coverage, 3186,
     /* 180342 */     GIR_EraseRootFromParent_Done,
     /* 180343 */   // Label 4002: @180343
     /* 180343 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(180405), // Rule ID 5563 //
     /* 180348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180367 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180370 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180374 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180387 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 180390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180403 */     GIR_RootConstrainSelectedInstOperands,
     /* 180404 */     // GIR_Coverage, 5563,
     /* 180404 */     GIR_EraseRootFromParent_Done,
     /* 180405 */   // Label 4003: @180405
     /* 180405 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(180432), // Rule ID 3185 //
     /* 180410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180425 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 180425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 180430 */     GIR_RootConstrainSelectedInstOperands,
     /* 180431 */     // GIR_Coverage, 3185,
     /* 180431 */     GIR_Done,
     /* 180432 */   // Label 4004: @180432
     /* 180432 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(180459), // Rule ID 3223 //
     /* 180437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 180440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180452 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 180452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 180457 */     GIR_RootConstrainSelectedInstOperands,
     /* 180458 */     // GIR_Coverage, 3223,
     /* 180458 */     GIR_Done,
     /* 180459 */   // Label 4005: @180459
     /* 180459 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(180486), // Rule ID 5560 //
     /* 180464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180479 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 180479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 180484 */     GIR_RootConstrainSelectedInstOperands,
     /* 180485 */     // GIR_Coverage, 5560,
     /* 180485 */     GIR_Done,
     /* 180486 */   // Label 4006: @180486
     /* 180486 */   GIM_Reject,
     /* 180487 */ // Label 3999: @180487
     /* 180487 */ GIM_Reject,
     /* 180488 */ // Label 3983: @180488
     /* 180488 */ GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(180804),
     /* 180493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 180496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 180499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180503 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(180561), // Rule ID 24071 //
     /* 180508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180519 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180526 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180543 */     // (smin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 180546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180559 */     GIR_RootConstrainSelectedInstOperands,
     /* 180560 */     // GIR_Coverage, 24071,
     /* 180560 */     GIR_EraseRootFromParent_Done,
     /* 180561 */   // Label 4008: @180561
     /* 180561 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(180619), // Rule ID 5581 //
     /* 180566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180601 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 180604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180617 */     GIR_RootConstrainSelectedInstOperands,
     /* 180618 */     // GIR_Coverage, 5581,
     /* 180618 */     GIR_EraseRootFromParent_Done,
     /* 180619 */   // Label 4009: @180619
     /* 180619 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(180642), // Rule ID 5578 //
     /* 180624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180635 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 180635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 180640 */     GIR_RootConstrainSelectedInstOperands,
     /* 180641 */     // GIR_Coverage, 5578,
     /* 180641 */     GIR_Done,
     /* 180642 */   // Label 4010: @180642
     /* 180642 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(180803), // Rule ID 20012 //
     /* 180647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 180650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180658 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 180658 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 180661 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180665 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 180672 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 180675 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180679 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180684 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 180687 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 180691 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 180694 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180699 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180704 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180709 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 180712 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180716 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 180723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 180726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180735 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 180738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 180742 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 180745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 180763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 180767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180772 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 180775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 180778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 180792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180802 */     // GIR_Coverage, 20012,
     /* 180802 */     GIR_EraseRootFromParent_Done,
     /* 180803 */   // Label 4011: @180803
     /* 180803 */   GIM_Reject,
     /* 180804 */ // Label 4007: @180804
     /* 180804 */ GIM_Reject,
     /* 180805 */ // Label 3984: @180805
     /* 180805 */ GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(181146),
     /* 180810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180816 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(180878), // Rule ID 23465 //
     /* 180821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180860 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 180863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180876 */     GIR_RootConstrainSelectedInstOperands,
     /* 180877 */     // GIR_Coverage, 23465,
     /* 180877 */     GIR_EraseRootFromParent_Done,
     /* 180878 */   // Label 4013: @180878
     /* 180878 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(180940), // Rule ID 24044 //
     /* 180883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 180886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180898 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180905 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180922 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 180925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180927 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180938 */     GIR_RootConstrainSelectedInstOperands,
     /* 180939 */     // GIR_Coverage, 24044,
     /* 180939 */     GIR_EraseRootFromParent_Done,
     /* 180940 */   // Label 4014: @180940
     /* 180940 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(181002), // Rule ID 2643 //
     /* 180945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180984 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 180987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181000 */     GIR_RootConstrainSelectedInstOperands,
     /* 181001 */     // GIR_Coverage, 2643,
     /* 181001 */     GIR_EraseRootFromParent_Done,
     /* 181002 */   // Label 4015: @181002
     /* 181002 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(181064), // Rule ID 5539 //
     /* 181007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181026 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181029 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181046 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 181049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181051 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181062 */     GIR_RootConstrainSelectedInstOperands,
     /* 181063 */     // GIR_Coverage, 5539,
     /* 181063 */     GIR_EraseRootFromParent_Done,
     /* 181064 */   // Label 4016: @181064
     /* 181064 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(181091), // Rule ID 2642 //
     /* 181069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181084 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 181084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 181089 */     GIR_RootConstrainSelectedInstOperands,
     /* 181090 */     // GIR_Coverage, 2642,
     /* 181090 */     GIR_Done,
     /* 181091 */   // Label 4017: @181091
     /* 181091 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(181118), // Rule ID 2644 //
     /* 181096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 181099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181111 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 181111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 181116 */     GIR_RootConstrainSelectedInstOperands,
     /* 181117 */     // GIR_Coverage, 2644,
     /* 181117 */     GIR_Done,
     /* 181118 */   // Label 4018: @181118
     /* 181118 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(181145), // Rule ID 5536 //
     /* 181123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181138 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 181138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 181143 */     GIR_RootConstrainSelectedInstOperands,
     /* 181144 */     // GIR_Coverage, 5536,
     /* 181144 */     GIR_Done,
     /* 181145 */   // Label 4019: @181145
     /* 181145 */   GIM_Reject,
     /* 181146 */ // Label 4012: @181146
     /* 181146 */ GIM_Reject,
     /* 181147 */ // Label 3985: @181147
     /* 181147 */ GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(181461),
     /* 181152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 181155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 181158 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(181220), // Rule ID 23510 //
     /* 181163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 181166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181202 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 181205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181207 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181218 */     GIR_RootConstrainSelectedInstOperands,
     /* 181219 */     // GIR_Coverage, 23510,
     /* 181219 */     GIR_EraseRootFromParent_Done,
     /* 181220 */   // Label 4021: @181220
     /* 181220 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(181282), // Rule ID 24053 //
     /* 181225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 181228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181264 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 181267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181280 */     GIR_RootConstrainSelectedInstOperands,
     /* 181281 */     // GIR_Coverage, 24053,
     /* 181281 */     GIR_EraseRootFromParent_Done,
     /* 181282 */   // Label 4022: @181282
     /* 181282 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(181344), // Rule ID 3204 //
     /* 181287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 181290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181326 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 181329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181331 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181342 */     GIR_RootConstrainSelectedInstOperands,
     /* 181343 */     // GIR_Coverage, 3204,
     /* 181343 */     GIR_EraseRootFromParent_Done,
     /* 181344 */   // Label 4023: @181344
     /* 181344 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(181406), // Rule ID 5554 //
     /* 181349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 181352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181388 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 181391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181395 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181404 */     GIR_RootConstrainSelectedInstOperands,
     /* 181405 */     // GIR_Coverage, 5554,
     /* 181405 */     GIR_EraseRootFromParent_Done,
     /* 181406 */   // Label 4024: @181406
     /* 181406 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(181433), // Rule ID 3203 //
     /* 181411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 181414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181426 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 181426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 181431 */     GIR_RootConstrainSelectedInstOperands,
     /* 181432 */     // GIR_Coverage, 3203,
     /* 181432 */     GIR_Done,
     /* 181433 */   // Label 4025: @181433
     /* 181433 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(181460), // Rule ID 5551 //
     /* 181438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 181441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181453 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 181453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 181458 */     GIR_RootConstrainSelectedInstOperands,
     /* 181459 */     // GIR_Coverage, 5551,
     /* 181459 */     GIR_Done,
     /* 181460 */   // Label 4026: @181460
     /* 181460 */   GIM_Reject,
     /* 181461 */ // Label 4020: @181461
     /* 181461 */ GIM_Reject,
     /* 181462 */ // Label 3986: @181462
     /* 181462 */ GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(181617),
     /* 181467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 181470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 181473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181477 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(181535), // Rule ID 24065 //
     /* 181482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181493 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181517 */     // (smin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 181520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181533 */     GIR_RootConstrainSelectedInstOperands,
     /* 181534 */     // GIR_Coverage, 24065,
     /* 181534 */     GIR_EraseRootFromParent_Done,
     /* 181535 */   // Label 4028: @181535
     /* 181535 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(181593), // Rule ID 5572 //
     /* 181540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181555 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181558 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181562 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181575 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 181578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181580 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181591 */     GIR_RootConstrainSelectedInstOperands,
     /* 181592 */     // GIR_Coverage, 5572,
     /* 181592 */     GIR_EraseRootFromParent_Done,
     /* 181593 */   // Label 4029: @181593
     /* 181593 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(181616), // Rule ID 5569 //
     /* 181598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181609 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 181609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 181614 */     GIR_RootConstrainSelectedInstOperands,
     /* 181615 */     // GIR_Coverage, 5569,
     /* 181615 */     GIR_Done,
     /* 181616 */   // Label 4030: @181616
     /* 181616 */   GIM_Reject,
     /* 181617 */ // Label 4027: @181617
     /* 181617 */ GIM_Reject,
     /* 181618 */ // Label 3987: @181618
     /* 181618 */ GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(181959),
     /* 181623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 181626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181629 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(181691), // Rule ID 23506 //
     /* 181634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181673 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 181676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181689 */     GIR_RootConstrainSelectedInstOperands,
     /* 181690 */     // GIR_Coverage, 23506,
     /* 181690 */     GIR_EraseRootFromParent_Done,
     /* 181691 */   // Label 4032: @181691
     /* 181691 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(181753), // Rule ID 24035 //
     /* 181696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181735 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 181738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181740 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181751 */     GIR_RootConstrainSelectedInstOperands,
     /* 181752 */     // GIR_Coverage, 24035,
     /* 181752 */     GIR_EraseRootFromParent_Done,
     /* 181753 */   // Label 4033: @181753
     /* 181753 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(181815), // Rule ID 3196 //
     /* 181758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181797 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 181800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181813 */     GIR_RootConstrainSelectedInstOperands,
     /* 181814 */     // GIR_Coverage, 3196,
     /* 181814 */     GIR_EraseRootFromParent_Done,
     /* 181815 */   // Label 4034: @181815
     /* 181815 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(181877), // Rule ID 5521 //
     /* 181820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181859 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 181862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181864 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181875 */     GIR_RootConstrainSelectedInstOperands,
     /* 181876 */     // GIR_Coverage, 5521,
     /* 181876 */     GIR_EraseRootFromParent_Done,
     /* 181877 */   // Label 4035: @181877
     /* 181877 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(181904), // Rule ID 3195 //
     /* 181882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181897 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 181897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 181902 */     GIR_RootConstrainSelectedInstOperands,
     /* 181903 */     // GIR_Coverage, 3195,
     /* 181903 */     GIR_Done,
     /* 181904 */   // Label 4036: @181904
     /* 181904 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(181931), // Rule ID 3221 //
     /* 181909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 181912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181924 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 181924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 181929 */     GIR_RootConstrainSelectedInstOperands,
     /* 181930 */     // GIR_Coverage, 3221,
     /* 181930 */     GIR_Done,
     /* 181931 */   // Label 4037: @181931
     /* 181931 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(181958), // Rule ID 5518 //
     /* 181936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181951 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 181951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 181956 */     GIR_RootConstrainSelectedInstOperands,
     /* 181957 */     // GIR_Coverage, 5518,
     /* 181957 */     GIR_Done,
     /* 181958 */   // Label 4038: @181958
     /* 181958 */   GIM_Reject,
     /* 181959 */ // Label 4031: @181959
     /* 181959 */ GIM_Reject,
     /* 181960 */ // Label 3988: @181960
     /* 181960 */ GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(182274),
     /* 181965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 181968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 181971 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(182033), // Rule ID 23467 //
     /* 181976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 181979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182015 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 182018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182020 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182031 */     GIR_RootConstrainSelectedInstOperands,
     /* 182032 */     // GIR_Coverage, 23467,
     /* 182032 */     GIR_EraseRootFromParent_Done,
     /* 182033 */   // Label 4040: @182033
     /* 182033 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(182095), // Rule ID 24041 //
     /* 182038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182077 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 182080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182093 */     GIR_RootConstrainSelectedInstOperands,
     /* 182094 */     // GIR_Coverage, 24041,
     /* 182094 */     GIR_EraseRootFromParent_Done,
     /* 182095 */   // Label 4041: @182095
     /* 182095 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(182157), // Rule ID 2647 //
     /* 182100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182139 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 182142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182155 */     GIR_RootConstrainSelectedInstOperands,
     /* 182156 */     // GIR_Coverage, 2647,
     /* 182156 */     GIR_EraseRootFromParent_Done,
     /* 182157 */   // Label 4042: @182157
     /* 182157 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(182219), // Rule ID 5533 //
     /* 182162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182201 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 182204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182217 */     GIR_RootConstrainSelectedInstOperands,
     /* 182218 */     // GIR_Coverage, 5533,
     /* 182218 */     GIR_EraseRootFromParent_Done,
     /* 182219 */   // Label 4043: @182219
     /* 182219 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(182246), // Rule ID 2646 //
     /* 182224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182239 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 182239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 182244 */     GIR_RootConstrainSelectedInstOperands,
     /* 182245 */     // GIR_Coverage, 2646,
     /* 182245 */     GIR_Done,
     /* 182246 */   // Label 4044: @182246
     /* 182246 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(182273), // Rule ID 5530 //
     /* 182251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182266 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 182266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 182271 */     GIR_RootConstrainSelectedInstOperands,
     /* 182272 */     // GIR_Coverage, 5530,
     /* 182272 */     GIR_Done,
     /* 182273 */   // Label 4045: @182273
     /* 182273 */   GIM_Reject,
     /* 182274 */ // Label 4039: @182274
     /* 182274 */ GIM_Reject,
     /* 182275 */ // Label 3989: @182275
     /* 182275 */ GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(182430),
     /* 182280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 182286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182290 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(182348), // Rule ID 24047 //
     /* 182295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182330 */     // (smin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 182333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182346 */     GIR_RootConstrainSelectedInstOperands,
     /* 182347 */     // GIR_Coverage, 24047,
     /* 182347 */     GIR_EraseRootFromParent_Done,
     /* 182348 */   // Label 4047: @182348
     /* 182348 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(182406), // Rule ID 5545 //
     /* 182353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182388 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 182391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182395 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182404 */     GIR_RootConstrainSelectedInstOperands,
     /* 182405 */     // GIR_Coverage, 5545,
     /* 182405 */     GIR_EraseRootFromParent_Done,
     /* 182406 */   // Label 4048: @182406
     /* 182406 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(182429), // Rule ID 5542 //
     /* 182411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182422 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 182422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 182427 */     GIR_RootConstrainSelectedInstOperands,
     /* 182428 */     // GIR_Coverage, 5542,
     /* 182428 */     GIR_Done,
     /* 182429 */   // Label 4049: @182429
     /* 182429 */   GIM_Reject,
     /* 182430 */ // Label 4046: @182430
     /* 182430 */ GIM_Reject,
     /* 182431 */ // Label 3990: @182431
     /* 182431 */ GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(182745),
     /* 182436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 182439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 182442 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(182504), // Rule ID 23515 //
     /* 182447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182486 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 182489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182491 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182502 */     GIR_RootConstrainSelectedInstOperands,
     /* 182503 */     // GIR_Coverage, 23515,
     /* 182503 */     GIR_EraseRootFromParent_Done,
     /* 182504 */   // Label 4051: @182504
     /* 182504 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(182566), // Rule ID 24032 //
     /* 182509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182548 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 182551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182564 */     GIR_RootConstrainSelectedInstOperands,
     /* 182565 */     // GIR_Coverage, 24032,
     /* 182565 */     GIR_EraseRootFromParent_Done,
     /* 182566 */   // Label 4052: @182566
     /* 182566 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(182628), // Rule ID 3214 //
     /* 182571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182610 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 182613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182626 */     GIR_RootConstrainSelectedInstOperands,
     /* 182627 */     // GIR_Coverage, 3214,
     /* 182627 */     GIR_EraseRootFromParent_Done,
     /* 182628 */   // Label 4053: @182628
     /* 182628 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(182690), // Rule ID 5515 //
     /* 182633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182672 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 182675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182688 */     GIR_RootConstrainSelectedInstOperands,
     /* 182689 */     // GIR_Coverage, 5515,
     /* 182689 */     GIR_EraseRootFromParent_Done,
     /* 182690 */   // Label 4054: @182690
     /* 182690 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(182717), // Rule ID 3213 //
     /* 182695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182710 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 182710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 182715 */     GIR_RootConstrainSelectedInstOperands,
     /* 182716 */     // GIR_Coverage, 3213,
     /* 182716 */     GIR_Done,
     /* 182717 */   // Label 4055: @182717
     /* 182717 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(182744), // Rule ID 5512 //
     /* 182722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182737 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 182737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 182742 */     GIR_RootConstrainSelectedInstOperands,
     /* 182743 */     // GIR_Coverage, 5512,
     /* 182743 */     GIR_Done,
     /* 182744 */   // Label 4056: @182744
     /* 182744 */   GIM_Reject,
     /* 182745 */ // Label 4050: @182745
     /* 182745 */ GIM_Reject,
     /* 182746 */ // Label 3991: @182746
     /* 182746 */ GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(182901),
     /* 182751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 182754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 182757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182761 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(182819), // Rule ID 24038 //
     /* 182766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182801 */     // (smin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 182804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182817 */     GIR_RootConstrainSelectedInstOperands,
     /* 182818 */     // GIR_Coverage, 24038,
     /* 182818 */     GIR_EraseRootFromParent_Done,
     /* 182819 */   // Label 4058: @182819
     /* 182819 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(182877), // Rule ID 5527 //
     /* 182824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182859 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 182862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182864 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182875 */     GIR_RootConstrainSelectedInstOperands,
     /* 182876 */     // GIR_Coverage, 5527,
     /* 182876 */     GIR_EraseRootFromParent_Done,
     /* 182877 */   // Label 4059: @182877
     /* 182877 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(182900), // Rule ID 5524 //
     /* 182882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182893 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 182893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 182898 */     GIR_RootConstrainSelectedInstOperands,
     /* 182899 */     // GIR_Coverage, 5524,
     /* 182899 */     GIR_Done,
     /* 182900 */   // Label 4060: @182900
     /* 182900 */   GIM_Reject,
     /* 182901 */ // Label 4057: @182901
     /* 182901 */ GIM_Reject,
     /* 182902 */ // Label 3992: @182902
     /* 182902 */ GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(183057),
     /* 182907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 182910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 182913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182917 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(182975), // Rule ID 24029 //
     /* 182922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182933 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182957 */     // (smin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 182960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182962 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182973 */     GIR_RootConstrainSelectedInstOperands,
     /* 182974 */     // GIR_Coverage, 24029,
     /* 182974 */     GIR_EraseRootFromParent_Done,
     /* 182975 */   // Label 4062: @182975
     /* 182975 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(183033), // Rule ID 5509 //
     /* 182980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182995 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183015 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 183018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183020 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183031 */     GIR_RootConstrainSelectedInstOperands,
     /* 183032 */     // GIR_Coverage, 5509,
     /* 183032 */     GIR_EraseRootFromParent_Done,
     /* 183033 */   // Label 4063: @183033
     /* 183033 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(183056), // Rule ID 5506 //
     /* 183038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 183041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 183045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 183049 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 183049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 183054 */     GIR_RootConstrainSelectedInstOperands,
     /* 183055 */     // GIR_Coverage, 5506,
     /* 183055 */     GIR_Done,
     /* 183056 */   // Label 4064: @183056
     /* 183056 */   GIM_Reject,
     /* 183057 */ // Label 4061: @183057
     /* 183057 */ GIM_Reject,
     /* 183058 */ // Label 3993: @183058
     /* 183058 */ GIM_Reject,
     /* 183059 */ // Label 55: @183059
     /* 183059 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4077*/ GIMT_Encode4(186379),
     /* 183070 */ /*GILLT_v2s64*//*Label 4065*/ GIMT_Encode4(183138), GIMT_Encode4(0),
     /* 183078 */ /*GILLT_v4s32*//*Label 4066*/ GIMT_Encode4(183467),
     /* 183082 */ /*GILLT_v4s64*//*Label 4067*/ GIMT_Encode4(183809), GIMT_Encode4(0),
     /* 183090 */ /*GILLT_v8s16*//*Label 4068*/ GIMT_Encode4(184126),
     /* 183094 */ /*GILLT_v8s32*//*Label 4069*/ GIMT_Encode4(184468),
     /* 183098 */ /*GILLT_v8s64*//*Label 4070*/ GIMT_Encode4(184783), GIMT_Encode4(0),
     /* 183106 */ /*GILLT_v16s8*//*Label 4071*/ GIMT_Encode4(184939),
     /* 183110 */ /*GILLT_v16s16*//*Label 4072*/ GIMT_Encode4(185281),
     /* 183114 */ /*GILLT_v16s32*//*Label 4073*/ GIMT_Encode4(185596), GIMT_Encode4(0),
     /* 183122 */ /*GILLT_v32s8*//*Label 4074*/ GIMT_Encode4(185752),
     /* 183126 */ /*GILLT_v32s16*//*Label 4075*/ GIMT_Encode4(186067), GIMT_Encode4(0),
     /* 183134 */ /*GILLT_v64s8*//*Label 4076*/ GIMT_Encode4(186223),
     /* 183138 */ // Label 4065: @183138
     /* 183138 */ GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(183466),
     /* 183143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 183146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183149 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(183211), // Rule ID 23969 //
     /* 183154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183193 */     // (smax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 183196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183198 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183209 */     GIR_RootConstrainSelectedInstOperands,
     /* 183210 */     // GIR_Coverage, 23969,
     /* 183210 */     GIR_EraseRootFromParent_Done,
     /* 183211 */   // Label 4079: @183211
     /* 183211 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(183273), // Rule ID 5410 //
     /* 183216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183255 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 183258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183260 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183271 */     GIR_RootConstrainSelectedInstOperands,
     /* 183272 */     // GIR_Coverage, 5410,
     /* 183272 */     GIR_EraseRootFromParent_Done,
     /* 183273 */   // Label 4080: @183273
     /* 183273 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(183300), // Rule ID 5407 //
     /* 183278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183293 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 183293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 183298 */     GIR_RootConstrainSelectedInstOperands,
     /* 183299 */     // GIR_Coverage, 5407,
     /* 183299 */     GIR_Done,
     /* 183300 */   // Label 4081: @183300
     /* 183300 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(183465), // Rule ID 20010 //
     /* 183305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 183312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183320 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 183320 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183323 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183327 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183334 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183337 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183341 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183346 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183349 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183353 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 183356 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183361 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183366 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183371 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183374 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183378 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183397 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 183400 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 183404 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 183407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 183425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 183429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183434 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 183437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 183440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183447 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 183454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 183459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183464 */     // GIR_Coverage, 20010,
     /* 183464 */     GIR_EraseRootFromParent_Done,
     /* 183465 */   // Label 4082: @183465
     /* 183465 */   GIM_Reject,
     /* 183466 */ // Label 4078: @183466
     /* 183466 */ GIM_Reject,
     /* 183467 */ // Label 4066: @183467
     /* 183467 */ GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(183808),
     /* 183472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 183475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183478 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(183540), // Rule ID 23503 //
     /* 183483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183498 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183501 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183505 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183522 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 183525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183527 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183538 */     GIR_RootConstrainSelectedInstOperands,
     /* 183539 */     // GIR_Coverage, 23503,
     /* 183539 */     GIR_EraseRootFromParent_Done,
     /* 183540 */   // Label 4084: @183540
     /* 183540 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(183602), // Rule ID 23951 //
     /* 183545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183584 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 183587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183600 */     GIR_RootConstrainSelectedInstOperands,
     /* 183601 */     // GIR_Coverage, 23951,
     /* 183601 */     GIR_EraseRootFromParent_Done,
     /* 183602 */   // Label 4085: @183602
     /* 183602 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(183664), // Rule ID 3190 //
     /* 183607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183629 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183633 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183646 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 183649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183662 */     GIR_RootConstrainSelectedInstOperands,
     /* 183663 */     // GIR_Coverage, 3190,
     /* 183663 */     GIR_EraseRootFromParent_Done,
     /* 183664 */   // Label 4086: @183664
     /* 183664 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(183726), // Rule ID 5383 //
     /* 183669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183708 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 183711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183715 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183724 */     GIR_RootConstrainSelectedInstOperands,
     /* 183725 */     // GIR_Coverage, 5383,
     /* 183725 */     GIR_EraseRootFromParent_Done,
     /* 183726 */   // Label 4087: @183726
     /* 183726 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(183753), // Rule ID 3189 //
     /* 183731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183746 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 183751 */     GIR_RootConstrainSelectedInstOperands,
     /* 183752 */     // GIR_Coverage, 3189,
     /* 183752 */     GIR_Done,
     /* 183753 */   // Label 4088: @183753
     /* 183753 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(183780), // Rule ID 3231 //
     /* 183758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 183761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183773 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 183778 */     GIR_RootConstrainSelectedInstOperands,
     /* 183779 */     // GIR_Coverage, 3231,
     /* 183779 */     GIR_Done,
     /* 183780 */   // Label 4089: @183780
     /* 183780 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(183807), // Rule ID 5380 //
     /* 183785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183800 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 183800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 183805 */     GIR_RootConstrainSelectedInstOperands,
     /* 183806 */     // GIR_Coverage, 5380,
     /* 183806 */     GIR_Done,
     /* 183807 */   // Label 4090: @183807
     /* 183807 */   GIM_Reject,
     /* 183808 */ // Label 4083: @183808
     /* 183808 */ GIM_Reject,
     /* 183809 */ // Label 4067: @183809
     /* 183809 */ GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(184125),
     /* 183814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 183817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 183820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183824 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(183882), // Rule ID 23963 //
     /* 183829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183864 */     // (smax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 183867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183880 */     GIR_RootConstrainSelectedInstOperands,
     /* 183881 */     // GIR_Coverage, 23963,
     /* 183881 */     GIR_EraseRootFromParent_Done,
     /* 183882 */   // Label 4092: @183882
     /* 183882 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(183940), // Rule ID 5401 //
     /* 183887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183922 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 183925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183938 */     GIR_RootConstrainSelectedInstOperands,
     /* 183939 */     // GIR_Coverage, 5401,
     /* 183939 */     GIR_EraseRootFromParent_Done,
     /* 183940 */   // Label 4093: @183940
     /* 183940 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(183963), // Rule ID 5398 //
     /* 183945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183956 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 183956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 183961 */     GIR_RootConstrainSelectedInstOperands,
     /* 183962 */     // GIR_Coverage, 5398,
     /* 183962 */     GIR_Done,
     /* 183963 */   // Label 4094: @183963
     /* 183963 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(184124), // Rule ID 20008 //
     /* 183968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183979 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 183979 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183982 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183986 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184005 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 184008 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 184012 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 184015 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 184020 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184025 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184030 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 184033 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184037 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 184044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 184047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184056 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 184059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 184063 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 184066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 184071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184076 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 184084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 184088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184093 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 184096 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 184099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 184101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184106 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 184113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184123 */     // GIR_Coverage, 20008,
     /* 184123 */     GIR_EraseRootFromParent_Done,
     /* 184124 */   // Label 4095: @184124
     /* 184124 */   GIM_Reject,
     /* 184125 */ // Label 4091: @184125
     /* 184125 */ GIM_Reject,
     /* 184126 */ // Label 4068: @184126
     /* 184126 */ GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(184467),
     /* 184131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 184134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184137 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(184199), // Rule ID 23471 //
     /* 184142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184181 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 184184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184186 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184197 */     GIR_RootConstrainSelectedInstOperands,
     /* 184198 */     // GIR_Coverage, 23471,
     /* 184198 */     GIR_EraseRootFromParent_Done,
     /* 184199 */   // Label 4097: @184199
     /* 184199 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(184261), // Rule ID 23936 //
     /* 184204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184219 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184222 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184226 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184243 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 184246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184248 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184259 */     GIR_RootConstrainSelectedInstOperands,
     /* 184260 */     // GIR_Coverage, 23936,
     /* 184260 */     GIR_EraseRootFromParent_Done,
     /* 184261 */   // Label 4098: @184261
     /* 184261 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(184323), // Rule ID 2655 //
     /* 184266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184285 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184305 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 184308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184321 */     GIR_RootConstrainSelectedInstOperands,
     /* 184322 */     // GIR_Coverage, 2655,
     /* 184322 */     GIR_EraseRootFromParent_Done,
     /* 184323 */   // Label 4099: @184323
     /* 184323 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(184385), // Rule ID 5359 //
     /* 184328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184347 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184350 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184354 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184367 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 184370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184383 */     GIR_RootConstrainSelectedInstOperands,
     /* 184384 */     // GIR_Coverage, 5359,
     /* 184384 */     GIR_EraseRootFromParent_Done,
     /* 184385 */   // Label 4100: @184385
     /* 184385 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(184412), // Rule ID 2654 //
     /* 184390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184405 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 184410 */     GIR_RootConstrainSelectedInstOperands,
     /* 184411 */     // GIR_Coverage, 2654,
     /* 184411 */     GIR_Done,
     /* 184412 */   // Label 4101: @184412
     /* 184412 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(184439), // Rule ID 2656 //
     /* 184417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 184420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184432 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 184437 */     GIR_RootConstrainSelectedInstOperands,
     /* 184438 */     // GIR_Coverage, 2656,
     /* 184438 */     GIR_Done,
     /* 184439 */   // Label 4102: @184439
     /* 184439 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(184466), // Rule ID 5356 //
     /* 184444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184459 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 184459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 184464 */     GIR_RootConstrainSelectedInstOperands,
     /* 184465 */     // GIR_Coverage, 5356,
     /* 184465 */     GIR_Done,
     /* 184466 */   // Label 4103: @184466
     /* 184466 */   GIM_Reject,
     /* 184467 */ // Label 4096: @184467
     /* 184467 */ GIM_Reject,
     /* 184468 */ // Label 4069: @184468
     /* 184468 */ GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(184782),
     /* 184473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 184476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 184479 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(184541), // Rule ID 23512 //
     /* 184484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184523 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 184526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184539 */     GIR_RootConstrainSelectedInstOperands,
     /* 184540 */     // GIR_Coverage, 23512,
     /* 184540 */     GIR_EraseRootFromParent_Done,
     /* 184541 */   // Label 4105: @184541
     /* 184541 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(184603), // Rule ID 23945 //
     /* 184546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184585 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 184588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184590 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184601 */     GIR_RootConstrainSelectedInstOperands,
     /* 184602 */     // GIR_Coverage, 23945,
     /* 184602 */     GIR_EraseRootFromParent_Done,
     /* 184603 */   // Label 4106: @184603
     /* 184603 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(184665), // Rule ID 3208 //
     /* 184608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184634 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184647 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 184650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184652 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184654 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184663 */     GIR_RootConstrainSelectedInstOperands,
     /* 184664 */     // GIR_Coverage, 3208,
     /* 184664 */     GIR_EraseRootFromParent_Done,
     /* 184665 */   // Label 4107: @184665
     /* 184665 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(184727), // Rule ID 5374 //
     /* 184670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184709 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 184712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184725 */     GIR_RootConstrainSelectedInstOperands,
     /* 184726 */     // GIR_Coverage, 5374,
     /* 184726 */     GIR_EraseRootFromParent_Done,
     /* 184727 */   // Label 4108: @184727
     /* 184727 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(184754), // Rule ID 3207 //
     /* 184732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184747 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 184747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 184752 */     GIR_RootConstrainSelectedInstOperands,
     /* 184753 */     // GIR_Coverage, 3207,
     /* 184753 */     GIR_Done,
     /* 184754 */   // Label 4109: @184754
     /* 184754 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(184781), // Rule ID 5371 //
     /* 184759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184774 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 184774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 184779 */     GIR_RootConstrainSelectedInstOperands,
     /* 184780 */     // GIR_Coverage, 5371,
     /* 184780 */     GIR_Done,
     /* 184781 */   // Label 4110: @184781
     /* 184781 */   GIM_Reject,
     /* 184782 */ // Label 4104: @184782
     /* 184782 */ GIM_Reject,
     /* 184783 */ // Label 4070: @184783
     /* 184783 */ GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(184938),
     /* 184788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 184791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 184794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184798 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(184856), // Rule ID 23957 //
     /* 184803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184838 */     // (smax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 184841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184843 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184854 */     GIR_RootConstrainSelectedInstOperands,
     /* 184855 */     // GIR_Coverage, 23957,
     /* 184855 */     GIR_EraseRootFromParent_Done,
     /* 184856 */   // Label 4112: @184856
     /* 184856 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(184914), // Rule ID 5392 //
     /* 184861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184896 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 184899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184912 */     GIR_RootConstrainSelectedInstOperands,
     /* 184913 */     // GIR_Coverage, 5392,
     /* 184913 */     GIR_EraseRootFromParent_Done,
     /* 184914 */   // Label 4113: @184914
     /* 184914 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(184937), // Rule ID 5389 //
     /* 184919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184930 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 184930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 184935 */     GIR_RootConstrainSelectedInstOperands,
     /* 184936 */     // GIR_Coverage, 5389,
     /* 184936 */     GIR_Done,
     /* 184937 */   // Label 4114: @184937
     /* 184937 */   GIM_Reject,
     /* 184938 */ // Label 4111: @184938
     /* 184938 */ GIM_Reject,
     /* 184939 */ // Label 4071: @184939
     /* 184939 */ GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(185280),
     /* 184944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 184947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184950 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(185012), // Rule ID 23508 //
     /* 184955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184970 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184973 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184977 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184994 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 184997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185010 */     GIR_RootConstrainSelectedInstOperands,
     /* 185011 */     // GIR_Coverage, 23508,
     /* 185011 */     GIR_EraseRootFromParent_Done,
     /* 185012 */   // Label 4116: @185012
     /* 185012 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(185074), // Rule ID 23927 //
     /* 185017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185056 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 185059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185072 */     GIR_RootConstrainSelectedInstOperands,
     /* 185073 */     // GIR_Coverage, 23927,
     /* 185073 */     GIR_EraseRootFromParent_Done,
     /* 185074 */   // Label 4117: @185074
     /* 185074 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(185136), // Rule ID 3200 //
     /* 185079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185118 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 185121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185123 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185134 */     GIR_RootConstrainSelectedInstOperands,
     /* 185135 */     // GIR_Coverage, 3200,
     /* 185135 */     GIR_EraseRootFromParent_Done,
     /* 185136 */   // Label 4118: @185136
     /* 185136 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(185198), // Rule ID 5341 //
     /* 185141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185167 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185180 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 185183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185196 */     GIR_RootConstrainSelectedInstOperands,
     /* 185197 */     // GIR_Coverage, 5341,
     /* 185197 */     GIR_EraseRootFromParent_Done,
     /* 185198 */   // Label 4119: @185198
     /* 185198 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(185225), // Rule ID 3199 //
     /* 185203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185218 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 185223 */     GIR_RootConstrainSelectedInstOperands,
     /* 185224 */     // GIR_Coverage, 3199,
     /* 185224 */     GIR_Done,
     /* 185225 */   // Label 4120: @185225
     /* 185225 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(185252), // Rule ID 3229 //
     /* 185230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 185233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185245 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 185250 */     GIR_RootConstrainSelectedInstOperands,
     /* 185251 */     // GIR_Coverage, 3229,
     /* 185251 */     GIR_Done,
     /* 185252 */   // Label 4121: @185252
     /* 185252 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(185279), // Rule ID 5338 //
     /* 185257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185272 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 185272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 185277 */     GIR_RootConstrainSelectedInstOperands,
     /* 185278 */     // GIR_Coverage, 5338,
     /* 185278 */     GIR_Done,
     /* 185279 */   // Label 4122: @185279
     /* 185279 */   GIM_Reject,
     /* 185280 */ // Label 4115: @185280
     /* 185280 */ GIM_Reject,
     /* 185281 */ // Label 4072: @185281
     /* 185281 */ GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(185595),
     /* 185286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 185289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 185292 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(185354), // Rule ID 23473 //
     /* 185297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185336 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 185339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185352 */     GIR_RootConstrainSelectedInstOperands,
     /* 185353 */     // GIR_Coverage, 23473,
     /* 185353 */     GIR_EraseRootFromParent_Done,
     /* 185354 */   // Label 4124: @185354
     /* 185354 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(185416), // Rule ID 23933 //
     /* 185359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185398 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 185401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185403 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185414 */     GIR_RootConstrainSelectedInstOperands,
     /* 185415 */     // GIR_Coverage, 23933,
     /* 185415 */     GIR_EraseRootFromParent_Done,
     /* 185416 */   // Label 4125: @185416
     /* 185416 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(185478), // Rule ID 2659 //
     /* 185421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185460 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 185463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185476 */     GIR_RootConstrainSelectedInstOperands,
     /* 185477 */     // GIR_Coverage, 2659,
     /* 185477 */     GIR_EraseRootFromParent_Done,
     /* 185478 */   // Label 4126: @185478
     /* 185478 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(185540), // Rule ID 5353 //
     /* 185483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185502 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185522 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 185525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185538 */     GIR_RootConstrainSelectedInstOperands,
     /* 185539 */     // GIR_Coverage, 5353,
     /* 185539 */     GIR_EraseRootFromParent_Done,
     /* 185540 */   // Label 4127: @185540
     /* 185540 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(185567), // Rule ID 2658 //
     /* 185545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185560 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 185560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 185565 */     GIR_RootConstrainSelectedInstOperands,
     /* 185566 */     // GIR_Coverage, 2658,
     /* 185566 */     GIR_Done,
     /* 185567 */   // Label 4128: @185567
     /* 185567 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(185594), // Rule ID 5350 //
     /* 185572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185587 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 185587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 185592 */     GIR_RootConstrainSelectedInstOperands,
     /* 185593 */     // GIR_Coverage, 5350,
     /* 185593 */     GIR_Done,
     /* 185594 */   // Label 4129: @185594
     /* 185594 */   GIM_Reject,
     /* 185595 */ // Label 4123: @185595
     /* 185595 */ GIM_Reject,
     /* 185596 */ // Label 4073: @185596
     /* 185596 */ GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(185751),
     /* 185601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 185604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 185607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185611 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(185669), // Rule ID 23939 //
     /* 185616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185634 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185651 */     // (smax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 185654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185656 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185658 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185667 */     GIR_RootConstrainSelectedInstOperands,
     /* 185668 */     // GIR_Coverage, 23939,
     /* 185668 */     GIR_EraseRootFromParent_Done,
     /* 185669 */   // Label 4131: @185669
     /* 185669 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(185727), // Rule ID 5365 //
     /* 185674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185709 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 185712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185725 */     GIR_RootConstrainSelectedInstOperands,
     /* 185726 */     // GIR_Coverage, 5365,
     /* 185726 */     GIR_EraseRootFromParent_Done,
     /* 185727 */   // Label 4132: @185727
     /* 185727 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(185750), // Rule ID 5362 //
     /* 185732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185743 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 185743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 185748 */     GIR_RootConstrainSelectedInstOperands,
     /* 185749 */     // GIR_Coverage, 5362,
     /* 185749 */     GIR_Done,
     /* 185750 */   // Label 4133: @185750
     /* 185750 */   GIM_Reject,
     /* 185751 */ // Label 4130: @185751
     /* 185751 */ GIM_Reject,
     /* 185752 */ // Label 4074: @185752
     /* 185752 */ GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(186066),
     /* 185757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 185760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 185763 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(185825), // Rule ID 23517 //
     /* 185768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185783 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185790 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185807 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 185810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185814 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185823 */     GIR_RootConstrainSelectedInstOperands,
     /* 185824 */     // GIR_Coverage, 23517,
     /* 185824 */     GIR_EraseRootFromParent_Done,
     /* 185825 */   // Label 4135: @185825
     /* 185825 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(185887), // Rule ID 23924 //
     /* 185830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185845 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185848 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185852 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185869 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 185872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185885 */     GIR_RootConstrainSelectedInstOperands,
     /* 185886 */     // GIR_Coverage, 23924,
     /* 185886 */     GIR_EraseRootFromParent_Done,
     /* 185887 */   // Label 4136: @185887
     /* 185887 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(185949), // Rule ID 3218 //
     /* 185892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185911 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185931 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 185934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185947 */     GIR_RootConstrainSelectedInstOperands,
     /* 185948 */     // GIR_Coverage, 3218,
     /* 185948 */     GIR_EraseRootFromParent_Done,
     /* 185949 */   // Label 4137: @185949
     /* 185949 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(186011), // Rule ID 5335 //
     /* 185954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185993 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 185996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186009 */     GIR_RootConstrainSelectedInstOperands,
     /* 186010 */     // GIR_Coverage, 5335,
     /* 186010 */     GIR_EraseRootFromParent_Done,
     /* 186011 */   // Label 4138: @186011
     /* 186011 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(186038), // Rule ID 3217 //
     /* 186016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 186019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 186023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 186027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 186031 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 186031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 186036 */     GIR_RootConstrainSelectedInstOperands,
     /* 186037 */     // GIR_Coverage, 3217,
     /* 186037 */     GIR_Done,
     /* 186038 */   // Label 4139: @186038
     /* 186038 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(186065), // Rule ID 5332 //
     /* 186043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 186046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186058 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 186058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 186063 */     GIR_RootConstrainSelectedInstOperands,
     /* 186064 */     // GIR_Coverage, 5332,
     /* 186064 */     GIR_Done,
     /* 186065 */   // Label 4140: @186065
     /* 186065 */   GIM_Reject,
     /* 186066 */ // Label 4134: @186066
     /* 186066 */ GIM_Reject,
     /* 186067 */ // Label 4075: @186067
     /* 186067 */ GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(186222),
     /* 186072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 186075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 186078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186082 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(186140), // Rule ID 23930 //
     /* 186087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186122 */     // (smax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 186125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186127 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186138 */     GIR_RootConstrainSelectedInstOperands,
     /* 186139 */     // GIR_Coverage, 23930,
     /* 186139 */     GIR_EraseRootFromParent_Done,
     /* 186140 */   // Label 4142: @186140
     /* 186140 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(186198), // Rule ID 5347 //
     /* 186145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186167 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186180 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 186183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186196 */     GIR_RootConstrainSelectedInstOperands,
     /* 186197 */     // GIR_Coverage, 5347,
     /* 186197 */     GIR_EraseRootFromParent_Done,
     /* 186198 */   // Label 4143: @186198
     /* 186198 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(186221), // Rule ID 5344 //
     /* 186203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186214 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 186214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 186219 */     GIR_RootConstrainSelectedInstOperands,
     /* 186220 */     // GIR_Coverage, 5344,
     /* 186220 */     GIR_Done,
     /* 186221 */   // Label 4144: @186221
     /* 186221 */   GIM_Reject,
     /* 186222 */ // Label 4141: @186222
     /* 186222 */ GIM_Reject,
     /* 186223 */ // Label 4076: @186223
     /* 186223 */ GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(186378),
     /* 186228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 186231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 186234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186238 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(186296), // Rule ID 23921 //
     /* 186243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186254 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186257 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186261 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186278 */     // (smax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 186281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186283 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186294 */     GIR_RootConstrainSelectedInstOperands,
     /* 186295 */     // GIR_Coverage, 23921,
     /* 186295 */     GIR_EraseRootFromParent_Done,
     /* 186296 */   // Label 4146: @186296
     /* 186296 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(186354), // Rule ID 5329 //
     /* 186301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186336 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 186339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186352 */     GIR_RootConstrainSelectedInstOperands,
     /* 186353 */     // GIR_Coverage, 5329,
     /* 186353 */     GIR_EraseRootFromParent_Done,
     /* 186354 */   // Label 4147: @186354
     /* 186354 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(186377), // Rule ID 5326 //
     /* 186359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186370 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 186370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 186375 */     GIR_RootConstrainSelectedInstOperands,
     /* 186376 */     // GIR_Coverage, 5326,
     /* 186376 */     GIR_Done,
     /* 186377 */   // Label 4148: @186377
     /* 186377 */   GIM_Reject,
     /* 186378 */ // Label 4145: @186378
     /* 186378 */ GIM_Reject,
     /* 186379 */ // Label 4077: @186379
     /* 186379 */ GIM_Reject,
     /* 186380 */ // Label 56: @186380
     /* 186380 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4161*/ GIMT_Encode4(189700),
     /* 186391 */ /*GILLT_v2s64*//*Label 4149*/ GIMT_Encode4(186459), GIMT_Encode4(0),
     /* 186399 */ /*GILLT_v4s32*//*Label 4150*/ GIMT_Encode4(186788),
     /* 186403 */ /*GILLT_v4s64*//*Label 4151*/ GIMT_Encode4(187130), GIMT_Encode4(0),
     /* 186411 */ /*GILLT_v8s16*//*Label 4152*/ GIMT_Encode4(187447),
     /* 186415 */ /*GILLT_v8s32*//*Label 4153*/ GIMT_Encode4(187789),
     /* 186419 */ /*GILLT_v8s64*//*Label 4154*/ GIMT_Encode4(188104), GIMT_Encode4(0),
     /* 186427 */ /*GILLT_v16s8*//*Label 4155*/ GIMT_Encode4(188260),
     /* 186431 */ /*GILLT_v16s16*//*Label 4156*/ GIMT_Encode4(188602),
     /* 186435 */ /*GILLT_v16s32*//*Label 4157*/ GIMT_Encode4(188917), GIMT_Encode4(0),
     /* 186443 */ /*GILLT_v32s8*//*Label 4158*/ GIMT_Encode4(189073),
     /* 186447 */ /*GILLT_v32s16*//*Label 4159*/ GIMT_Encode4(189388), GIMT_Encode4(0),
     /* 186455 */ /*GILLT_v64s8*//*Label 4160*/ GIMT_Encode4(189544),
     /* 186459 */ // Label 4149: @186459
     /* 186459 */ GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(186787),
     /* 186464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 186467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186470 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(186532), // Rule ID 24131 //
     /* 186475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186490 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186497 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186514 */     // (umin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 186517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186519 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186530 */     GIR_RootConstrainSelectedInstOperands,
     /* 186531 */     // GIR_Coverage, 24131,
     /* 186531 */     GIR_EraseRootFromParent_Done,
     /* 186532 */   // Label 4163: @186532
     /* 186532 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(186594), // Rule ID 5680 //
     /* 186537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186576 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 186579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186592 */     GIR_RootConstrainSelectedInstOperands,
     /* 186593 */     // GIR_Coverage, 5680,
     /* 186593 */     GIR_EraseRootFromParent_Done,
     /* 186594 */   // Label 4164: @186594
     /* 186594 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(186621), // Rule ID 5677 //
     /* 186599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186614 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 186614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 186619 */     GIR_RootConstrainSelectedInstOperands,
     /* 186620 */     // GIR_Coverage, 5677,
     /* 186620 */     GIR_Done,
     /* 186621 */   // Label 4165: @186621
     /* 186621 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(186786), // Rule ID 20006 //
     /* 186626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 186629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 186633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186641 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 186641 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 186644 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186648 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 186655 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 186658 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186662 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186667 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 186670 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 186674 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 186677 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186682 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186687 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 186695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 186706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 186709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 186721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 186725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 186728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 186746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 186750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 186758 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 186761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 186763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186768 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 186775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 186780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186785 */     // GIR_Coverage, 20006,
     /* 186785 */     GIR_EraseRootFromParent_Done,
     /* 186786 */   // Label 4166: @186786
     /* 186786 */   GIM_Reject,
     /* 186787 */ // Label 4162: @186787
     /* 186787 */ GIM_Reject,
     /* 186788 */ // Label 4150: @186788
     /* 186788 */ GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(187129),
     /* 186793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 186796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186799 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(186861), // Rule ID 23502 //
     /* 186804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186819 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186826 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186843 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 186846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186859 */     GIR_RootConstrainSelectedInstOperands,
     /* 186860 */     // GIR_Coverage, 23502,
     /* 186860 */     GIR_EraseRootFromParent_Done,
     /* 186861 */   // Label 4168: @186861
     /* 186861 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(186923), // Rule ID 24113 //
     /* 186866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186888 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186905 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 186908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186910 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186921 */     GIR_RootConstrainSelectedInstOperands,
     /* 186922 */     // GIR_Coverage, 24113,
     /* 186922 */     GIR_EraseRootFromParent_Done,
     /* 186923 */   // Label 4169: @186923
     /* 186923 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(186985), // Rule ID 3188 //
     /* 186928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186950 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186967 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 186970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186972 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186983 */     GIR_RootConstrainSelectedInstOperands,
     /* 186984 */     // GIR_Coverage, 3188,
     /* 186984 */     GIR_EraseRootFromParent_Done,
     /* 186985 */   // Label 4170: @186985
     /* 186985 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(187047), // Rule ID 5653 //
     /* 186990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187009 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187029 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 187032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187045 */     GIR_RootConstrainSelectedInstOperands,
     /* 187046 */     // GIR_Coverage, 5653,
     /* 187046 */     GIR_EraseRootFromParent_Done,
     /* 187047 */   // Label 4171: @187047
     /* 187047 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(187074), // Rule ID 3187 //
     /* 187052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 187055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187067 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 187072 */     GIR_RootConstrainSelectedInstOperands,
     /* 187073 */     // GIR_Coverage, 3187,
     /* 187073 */     GIR_Done,
     /* 187074 */   // Label 4172: @187074
     /* 187074 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(187101), // Rule ID 3225 //
     /* 187079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187094 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 187099 */     GIR_RootConstrainSelectedInstOperands,
     /* 187100 */     // GIR_Coverage, 3225,
     /* 187100 */     GIR_Done,
     /* 187101 */   // Label 4173: @187101
     /* 187101 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(187128), // Rule ID 5650 //
     /* 187106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187121 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 187121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 187126 */     GIR_RootConstrainSelectedInstOperands,
     /* 187127 */     // GIR_Coverage, 5650,
     /* 187127 */     GIR_Done,
     /* 187128 */   // Label 4174: @187128
     /* 187128 */   GIM_Reject,
     /* 187129 */ // Label 4167: @187129
     /* 187129 */ GIM_Reject,
     /* 187130 */ // Label 4151: @187130
     /* 187130 */ GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(187446),
     /* 187135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 187138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 187141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187145 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(187203), // Rule ID 24125 //
     /* 187150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187185 */     // (umin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 187188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187201 */     GIR_RootConstrainSelectedInstOperands,
     /* 187202 */     // GIR_Coverage, 24125,
     /* 187202 */     GIR_EraseRootFromParent_Done,
     /* 187203 */   // Label 4176: @187203
     /* 187203 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(187261), // Rule ID 5671 //
     /* 187208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187243 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 187246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187259 */     GIR_RootConstrainSelectedInstOperands,
     /* 187260 */     // GIR_Coverage, 5671,
     /* 187260 */     GIR_EraseRootFromParent_Done,
     /* 187261 */   // Label 4177: @187261
     /* 187261 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(187284), // Rule ID 5668 //
     /* 187266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187277 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 187277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 187282 */     GIR_RootConstrainSelectedInstOperands,
     /* 187283 */     // GIR_Coverage, 5668,
     /* 187283 */     GIR_Done,
     /* 187284 */   // Label 4178: @187284
     /* 187284 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(187445), // Rule ID 20004 //
     /* 187289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 187292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187300 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 187300 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 187303 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187307 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 187314 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 187317 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187321 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187326 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 187329 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 187333 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 187336 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187341 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187346 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187351 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 187354 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187358 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 187365 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 187368 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187372 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187377 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 187380 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 187384 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 187387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187397 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 187405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 187409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 187417 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 187420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 187422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 187434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187444 */     // GIR_Coverage, 20004,
     /* 187444 */     GIR_EraseRootFromParent_Done,
     /* 187445 */   // Label 4179: @187445
     /* 187445 */   GIM_Reject,
     /* 187446 */ // Label 4175: @187446
     /* 187446 */ GIM_Reject,
     /* 187447 */ // Label 4152: @187447
     /* 187447 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(187788),
     /* 187452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 187455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187458 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(187520), // Rule ID 23507 //
     /* 187463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187502 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 187505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187507 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187518 */     GIR_RootConstrainSelectedInstOperands,
     /* 187519 */     // GIR_Coverage, 23507,
     /* 187519 */     GIR_EraseRootFromParent_Done,
     /* 187520 */   // Label 4181: @187520
     /* 187520 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(187582), // Rule ID 24098 //
     /* 187525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187564 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 187567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187580 */     GIR_RootConstrainSelectedInstOperands,
     /* 187581 */     // GIR_Coverage, 24098,
     /* 187581 */     GIR_EraseRootFromParent_Done,
     /* 187582 */   // Label 4182: @187582
     /* 187582 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(187644), // Rule ID 3198 //
     /* 187587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187626 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 187629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187642 */     GIR_RootConstrainSelectedInstOperands,
     /* 187643 */     // GIR_Coverage, 3198,
     /* 187643 */     GIR_EraseRootFromParent_Done,
     /* 187644 */   // Label 4183: @187644
     /* 187644 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(187706), // Rule ID 5629 //
     /* 187649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187688 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 187691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187704 */     GIR_RootConstrainSelectedInstOperands,
     /* 187705 */     // GIR_Coverage, 5629,
     /* 187705 */     GIR_EraseRootFromParent_Done,
     /* 187706 */   // Label 4184: @187706
     /* 187706 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(187733), // Rule ID 3197 //
     /* 187711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187726 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 187731 */     GIR_RootConstrainSelectedInstOperands,
     /* 187732 */     // GIR_Coverage, 3197,
     /* 187732 */     GIR_Done,
     /* 187733 */   // Label 4185: @187733
     /* 187733 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(187760), // Rule ID 3227 //
     /* 187738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187753 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 187758 */     GIR_RootConstrainSelectedInstOperands,
     /* 187759 */     // GIR_Coverage, 3227,
     /* 187759 */     GIR_Done,
     /* 187760 */   // Label 4186: @187760
     /* 187760 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(187787), // Rule ID 5626 //
     /* 187765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187780 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 187780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 187785 */     GIR_RootConstrainSelectedInstOperands,
     /* 187786 */     // GIR_Coverage, 5626,
     /* 187786 */     GIR_Done,
     /* 187787 */   // Label 4187: @187787
     /* 187787 */   GIM_Reject,
     /* 187788 */ // Label 4180: @187788
     /* 187788 */ GIM_Reject,
     /* 187789 */ // Label 4153: @187789
     /* 187789 */ GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(188103),
     /* 187794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 187797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 187800 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(187862), // Rule ID 23511 //
     /* 187805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187844 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 187847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187849 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187860 */     GIR_RootConstrainSelectedInstOperands,
     /* 187861 */     // GIR_Coverage, 23511,
     /* 187861 */     GIR_EraseRootFromParent_Done,
     /* 187862 */   // Label 4189: @187862
     /* 187862 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(187924), // Rule ID 24107 //
     /* 187867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187882 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187906 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 187909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187913 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187922 */     GIR_RootConstrainSelectedInstOperands,
     /* 187923 */     // GIR_Coverage, 24107,
     /* 187923 */     GIR_EraseRootFromParent_Done,
     /* 187924 */   // Label 4190: @187924
     /* 187924 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(187986), // Rule ID 3206 //
     /* 187929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187968 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 187971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187984 */     GIR_RootConstrainSelectedInstOperands,
     /* 187985 */     // GIR_Coverage, 3206,
     /* 187985 */     GIR_EraseRootFromParent_Done,
     /* 187986 */   // Label 4191: @187986
     /* 187986 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(188048), // Rule ID 5644 //
     /* 187991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188030 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 188033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188046 */     GIR_RootConstrainSelectedInstOperands,
     /* 188047 */     // GIR_Coverage, 5644,
     /* 188047 */     GIR_EraseRootFromParent_Done,
     /* 188048 */   // Label 4192: @188048
     /* 188048 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(188075), // Rule ID 3205 //
     /* 188053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 188056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188068 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 188068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 188073 */     GIR_RootConstrainSelectedInstOperands,
     /* 188074 */     // GIR_Coverage, 3205,
     /* 188074 */     GIR_Done,
     /* 188075 */   // Label 4193: @188075
     /* 188075 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(188102), // Rule ID 5641 //
     /* 188080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 188083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188095 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 188095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 188100 */     GIR_RootConstrainSelectedInstOperands,
     /* 188101 */     // GIR_Coverage, 5641,
     /* 188101 */     GIR_Done,
     /* 188102 */   // Label 4194: @188102
     /* 188102 */   GIM_Reject,
     /* 188103 */ // Label 4188: @188103
     /* 188103 */ GIM_Reject,
     /* 188104 */ // Label 4154: @188104
     /* 188104 */ GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(188259),
     /* 188109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 188112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 188115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188119 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(188177), // Rule ID 24119 //
     /* 188124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188159 */     // (umin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 188162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188175 */     GIR_RootConstrainSelectedInstOperands,
     /* 188176 */     // GIR_Coverage, 24119,
     /* 188176 */     GIR_EraseRootFromParent_Done,
     /* 188177 */   // Label 4196: @188177
     /* 188177 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(188235), // Rule ID 5662 //
     /* 188182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188197 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188200 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188204 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188217 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 188220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188233 */     GIR_RootConstrainSelectedInstOperands,
     /* 188234 */     // GIR_Coverage, 5662,
     /* 188234 */     GIR_EraseRootFromParent_Done,
     /* 188235 */   // Label 4197: @188235
     /* 188235 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(188258), // Rule ID 5659 //
     /* 188240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188251 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 188251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 188256 */     GIR_RootConstrainSelectedInstOperands,
     /* 188257 */     // GIR_Coverage, 5659,
     /* 188257 */     GIR_Done,
     /* 188258 */   // Label 4198: @188258
     /* 188258 */   GIM_Reject,
     /* 188259 */ // Label 4195: @188259
     /* 188259 */ GIM_Reject,
     /* 188260 */ // Label 4155: @188260
     /* 188260 */ GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(188601),
     /* 188265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 188268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188271 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(188333), // Rule ID 23462 //
     /* 188276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188315 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 188318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188331 */     GIR_RootConstrainSelectedInstOperands,
     /* 188332 */     // GIR_Coverage, 23462,
     /* 188332 */     GIR_EraseRootFromParent_Done,
     /* 188333 */   // Label 4200: @188333
     /* 188333 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(188395), // Rule ID 24089 //
     /* 188338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188356 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188377 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 188380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188382 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188393 */     GIR_RootConstrainSelectedInstOperands,
     /* 188394 */     // GIR_Coverage, 24089,
     /* 188394 */     GIR_EraseRootFromParent_Done,
     /* 188395 */   // Label 4201: @188395
     /* 188395 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(188457), // Rule ID 2637 //
     /* 188400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188419 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188422 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188426 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188439 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 188442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188455 */     GIR_RootConstrainSelectedInstOperands,
     /* 188456 */     // GIR_Coverage, 2637,
     /* 188456 */     GIR_EraseRootFromParent_Done,
     /* 188457 */   // Label 4202: @188457
     /* 188457 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(188519), // Rule ID 5611 //
     /* 188462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188481 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188488 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188501 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 188504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188517 */     GIR_RootConstrainSelectedInstOperands,
     /* 188518 */     // GIR_Coverage, 5611,
     /* 188518 */     GIR_EraseRootFromParent_Done,
     /* 188519 */   // Label 4203: @188519
     /* 188519 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(188546), // Rule ID 2636 //
     /* 188524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188539 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 188544 */     GIR_RootConstrainSelectedInstOperands,
     /* 188545 */     // GIR_Coverage, 2636,
     /* 188545 */     GIR_Done,
     /* 188546 */   // Label 4204: @188546
     /* 188546 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(188573), // Rule ID 2638 //
     /* 188551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 188554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188566 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 188571 */     GIR_RootConstrainSelectedInstOperands,
     /* 188572 */     // GIR_Coverage, 2638,
     /* 188572 */     GIR_Done,
     /* 188573 */   // Label 4205: @188573
     /* 188573 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(188600), // Rule ID 5608 //
     /* 188578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188593 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 188593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 188598 */     GIR_RootConstrainSelectedInstOperands,
     /* 188599 */     // GIR_Coverage, 5608,
     /* 188599 */     GIR_Done,
     /* 188600 */   // Label 4206: @188600
     /* 188600 */   GIM_Reject,
     /* 188601 */ // Label 4199: @188601
     /* 188601 */ GIM_Reject,
     /* 188602 */ // Label 4156: @188602
     /* 188602 */ GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(188916),
     /* 188607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 188610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 188613 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(188675), // Rule ID 23516 //
     /* 188618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188633 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188640 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188657 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 188660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188662 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188664 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188673 */     GIR_RootConstrainSelectedInstOperands,
     /* 188674 */     // GIR_Coverage, 23516,
     /* 188674 */     GIR_EraseRootFromParent_Done,
     /* 188675 */   // Label 4208: @188675
     /* 188675 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(188737), // Rule ID 24095 //
     /* 188680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188702 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188719 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 188722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188726 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188735 */     GIR_RootConstrainSelectedInstOperands,
     /* 188736 */     // GIR_Coverage, 24095,
     /* 188736 */     GIR_EraseRootFromParent_Done,
     /* 188737 */   // Label 4209: @188737
     /* 188737 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(188799), // Rule ID 3216 //
     /* 188742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188781 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 188784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188797 */     GIR_RootConstrainSelectedInstOperands,
     /* 188798 */     // GIR_Coverage, 3216,
     /* 188798 */     GIR_EraseRootFromParent_Done,
     /* 188799 */   // Label 4210: @188799
     /* 188799 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(188861), // Rule ID 5623 //
     /* 188804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188843 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 188846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188859 */     GIR_RootConstrainSelectedInstOperands,
     /* 188860 */     // GIR_Coverage, 5623,
     /* 188860 */     GIR_EraseRootFromParent_Done,
     /* 188861 */   // Label 4211: @188861
     /* 188861 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(188888), // Rule ID 3215 //
     /* 188866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188881 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 188881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 188886 */     GIR_RootConstrainSelectedInstOperands,
     /* 188887 */     // GIR_Coverage, 3215,
     /* 188887 */     GIR_Done,
     /* 188888 */   // Label 4212: @188888
     /* 188888 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(188915), // Rule ID 5620 //
     /* 188893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188908 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 188908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 188913 */     GIR_RootConstrainSelectedInstOperands,
     /* 188914 */     // GIR_Coverage, 5620,
     /* 188914 */     GIR_Done,
     /* 188915 */   // Label 4213: @188915
     /* 188915 */   GIM_Reject,
     /* 188916 */ // Label 4207: @188916
     /* 188916 */ GIM_Reject,
     /* 188917 */ // Label 4157: @188917
     /* 188917 */ GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(189072),
     /* 188922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 188925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 188928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188932 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(188990), // Rule ID 24101 //
     /* 188937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188972 */     // (umin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 188975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188977 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188988 */     GIR_RootConstrainSelectedInstOperands,
     /* 188989 */     // GIR_Coverage, 24101,
     /* 188989 */     GIR_EraseRootFromParent_Done,
     /* 188990 */   // Label 4215: @188990
     /* 188990 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(189048), // Rule ID 5635 //
     /* 188995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189030 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 189033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189046 */     GIR_RootConstrainSelectedInstOperands,
     /* 189047 */     // GIR_Coverage, 5635,
     /* 189047 */     GIR_EraseRootFromParent_Done,
     /* 189048 */   // Label 4216: @189048
     /* 189048 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(189071), // Rule ID 5632 //
     /* 189053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 189056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189064 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 189064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 189069 */     GIR_RootConstrainSelectedInstOperands,
     /* 189070 */     // GIR_Coverage, 5632,
     /* 189070 */     GIR_Done,
     /* 189071 */   // Label 4217: @189071
     /* 189071 */   GIM_Reject,
     /* 189072 */ // Label 4214: @189072
     /* 189072 */ GIM_Reject,
     /* 189073 */ // Label 4158: @189073
     /* 189073 */ GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(189387),
     /* 189078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 189081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 189084 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(189146), // Rule ID 23464 //
     /* 189089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189128 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 189131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189144 */     GIR_RootConstrainSelectedInstOperands,
     /* 189145 */     // GIR_Coverage, 23464,
     /* 189145 */     GIR_EraseRootFromParent_Done,
     /* 189146 */   // Label 4219: @189146
     /* 189146 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(189208), // Rule ID 24086 //
     /* 189151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189190 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 189193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189206 */     GIR_RootConstrainSelectedInstOperands,
     /* 189207 */     // GIR_Coverage, 24086,
     /* 189207 */     GIR_EraseRootFromParent_Done,
     /* 189208 */   // Label 4220: @189208
     /* 189208 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(189270), // Rule ID 2641 //
     /* 189213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189252 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 189255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189268 */     GIR_RootConstrainSelectedInstOperands,
     /* 189269 */     // GIR_Coverage, 2641,
     /* 189269 */     GIR_EraseRootFromParent_Done,
     /* 189270 */   // Label 4221: @189270
     /* 189270 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(189332), // Rule ID 5605 //
     /* 189275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189314 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 189317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189330 */     GIR_RootConstrainSelectedInstOperands,
     /* 189331 */     // GIR_Coverage, 5605,
     /* 189331 */     GIR_EraseRootFromParent_Done,
     /* 189332 */   // Label 4222: @189332
     /* 189332 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(189359), // Rule ID 2640 //
     /* 189337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189352 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 189352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 189357 */     GIR_RootConstrainSelectedInstOperands,
     /* 189358 */     // GIR_Coverage, 2640,
     /* 189358 */     GIR_Done,
     /* 189359 */   // Label 4223: @189359
     /* 189359 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(189386), // Rule ID 5602 //
     /* 189364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189379 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 189379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 189384 */     GIR_RootConstrainSelectedInstOperands,
     /* 189385 */     // GIR_Coverage, 5602,
     /* 189385 */     GIR_Done,
     /* 189386 */   // Label 4224: @189386
     /* 189386 */   GIM_Reject,
     /* 189387 */ // Label 4218: @189387
     /* 189387 */ GIM_Reject,
     /* 189388 */ // Label 4159: @189388
     /* 189388 */ GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(189543),
     /* 189393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 189396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 189399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189403 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(189461), // Rule ID 24092 //
     /* 189408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189419 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189422 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189426 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189443 */     // (umin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 189446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189459 */     GIR_RootConstrainSelectedInstOperands,
     /* 189460 */     // GIR_Coverage, 24092,
     /* 189460 */     GIR_EraseRootFromParent_Done,
     /* 189461 */   // Label 4226: @189461
     /* 189461 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(189519), // Rule ID 5617 //
     /* 189466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189481 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189488 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189501 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 189504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189517 */     GIR_RootConstrainSelectedInstOperands,
     /* 189518 */     // GIR_Coverage, 5617,
     /* 189518 */     GIR_EraseRootFromParent_Done,
     /* 189519 */   // Label 4227: @189519
     /* 189519 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(189542), // Rule ID 5614 //
     /* 189524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189535 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 189535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 189540 */     GIR_RootConstrainSelectedInstOperands,
     /* 189541 */     // GIR_Coverage, 5614,
     /* 189541 */     GIR_Done,
     /* 189542 */   // Label 4228: @189542
     /* 189542 */   GIM_Reject,
     /* 189543 */ // Label 4225: @189543
     /* 189543 */ GIM_Reject,
     /* 189544 */ // Label 4160: @189544
     /* 189544 */ GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(189699),
     /* 189549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 189552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 189555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189559 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(189617), // Rule ID 24083 //
     /* 189564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189575 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189582 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189599 */     // (umin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 189602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189604 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189615 */     GIR_RootConstrainSelectedInstOperands,
     /* 189616 */     // GIR_Coverage, 24083,
     /* 189616 */     GIR_EraseRootFromParent_Done,
     /* 189617 */   // Label 4230: @189617
     /* 189617 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(189675), // Rule ID 5599 //
     /* 189622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189637 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189640 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189644 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189657 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 189660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189662 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189664 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189673 */     GIR_RootConstrainSelectedInstOperands,
     /* 189674 */     // GIR_Coverage, 5599,
     /* 189674 */     GIR_EraseRootFromParent_Done,
     /* 189675 */   // Label 4231: @189675
     /* 189675 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(189698), // Rule ID 5596 //
     /* 189680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189691 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 189691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 189696 */     GIR_RootConstrainSelectedInstOperands,
     /* 189697 */     // GIR_Coverage, 5596,
     /* 189697 */     GIR_Done,
     /* 189698 */   // Label 4232: @189698
     /* 189698 */   GIM_Reject,
     /* 189699 */ // Label 4229: @189699
     /* 189699 */ GIM_Reject,
     /* 189700 */ // Label 4161: @189700
     /* 189700 */ GIM_Reject,
     /* 189701 */ // Label 57: @189701
     /* 189701 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4245*/ GIMT_Encode4(193021),
     /* 189712 */ /*GILLT_v2s64*//*Label 4233*/ GIMT_Encode4(189780), GIMT_Encode4(0),
     /* 189720 */ /*GILLT_v4s32*//*Label 4234*/ GIMT_Encode4(190109),
     /* 189724 */ /*GILLT_v4s64*//*Label 4235*/ GIMT_Encode4(190451), GIMT_Encode4(0),
     /* 189732 */ /*GILLT_v8s16*//*Label 4236*/ GIMT_Encode4(190768),
     /* 189736 */ /*GILLT_v8s32*//*Label 4237*/ GIMT_Encode4(191110),
     /* 189740 */ /*GILLT_v8s64*//*Label 4238*/ GIMT_Encode4(191425), GIMT_Encode4(0),
     /* 189748 */ /*GILLT_v16s8*//*Label 4239*/ GIMT_Encode4(191581),
     /* 189752 */ /*GILLT_v16s16*//*Label 4240*/ GIMT_Encode4(191923),
     /* 189756 */ /*GILLT_v16s32*//*Label 4241*/ GIMT_Encode4(192238), GIMT_Encode4(0),
     /* 189764 */ /*GILLT_v32s8*//*Label 4242*/ GIMT_Encode4(192394),
     /* 189768 */ /*GILLT_v32s16*//*Label 4243*/ GIMT_Encode4(192709), GIMT_Encode4(0),
     /* 189776 */ /*GILLT_v64s8*//*Label 4244*/ GIMT_Encode4(192865),
     /* 189780 */ // Label 4233: @189780
     /* 189780 */ GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(190108),
     /* 189785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 189788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189791 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(189853), // Rule ID 24023 //
     /* 189796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189835 */     // (umax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 189838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189851 */     GIR_RootConstrainSelectedInstOperands,
     /* 189852 */     // GIR_Coverage, 24023,
     /* 189852 */     GIR_EraseRootFromParent_Done,
     /* 189853 */   // Label 4247: @189853
     /* 189853 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(189915), // Rule ID 5500 //
     /* 189858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189897 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 189900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189913 */     GIR_RootConstrainSelectedInstOperands,
     /* 189914 */     // GIR_Coverage, 5500,
     /* 189914 */     GIR_EraseRootFromParent_Done,
     /* 189915 */   // Label 4248: @189915
     /* 189915 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(189942), // Rule ID 5497 //
     /* 189920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189935 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 189935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 189940 */     GIR_RootConstrainSelectedInstOperands,
     /* 189941 */     // GIR_Coverage, 5497,
     /* 189941 */     GIR_Done,
     /* 189942 */   // Label 4249: @189942
     /* 189942 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(190107), // Rule ID 20002 //
     /* 189947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 189950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 189954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189962 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 189962 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 189965 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189969 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 189976 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 189979 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189983 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189988 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 189991 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 189995 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 189998 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190003 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190008 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 190013 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190016 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190020 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190039 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190046 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 190049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 190064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 190071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 190096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 190101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190106 */     // GIR_Coverage, 20002,
     /* 190106 */     GIR_EraseRootFromParent_Done,
     /* 190107 */   // Label 4250: @190107
     /* 190107 */   GIM_Reject,
     /* 190108 */ // Label 4246: @190108
     /* 190108 */ GIM_Reject,
     /* 190109 */ // Label 4234: @190109
     /* 190109 */ GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(190450),
     /* 190114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 190117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190120 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(190182), // Rule ID 23504 //
     /* 190125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190164 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 190167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190180 */     GIR_RootConstrainSelectedInstOperands,
     /* 190181 */     // GIR_Coverage, 23504,
     /* 190181 */     GIR_EraseRootFromParent_Done,
     /* 190182 */   // Label 4252: @190182
     /* 190182 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(190244), // Rule ID 24005 //
     /* 190187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190226 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 190229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190242 */     GIR_RootConstrainSelectedInstOperands,
     /* 190243 */     // GIR_Coverage, 24005,
     /* 190243 */     GIR_EraseRootFromParent_Done,
     /* 190244 */   // Label 4253: @190244
     /* 190244 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(190306), // Rule ID 3192 //
     /* 190249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190288 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 190291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190293 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190304 */     GIR_RootConstrainSelectedInstOperands,
     /* 190305 */     // GIR_Coverage, 3192,
     /* 190305 */     GIR_EraseRootFromParent_Done,
     /* 190306 */   // Label 4254: @190306
     /* 190306 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(190368), // Rule ID 5473 //
     /* 190311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190350 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 190353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190357 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190366 */     GIR_RootConstrainSelectedInstOperands,
     /* 190367 */     // GIR_Coverage, 5473,
     /* 190367 */     GIR_EraseRootFromParent_Done,
     /* 190368 */   // Label 4255: @190368
     /* 190368 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(190395), // Rule ID 3191 //
     /* 190373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190388 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 190393 */     GIR_RootConstrainSelectedInstOperands,
     /* 190394 */     // GIR_Coverage, 3191,
     /* 190394 */     GIR_Done,
     /* 190395 */   // Label 4256: @190395
     /* 190395 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(190422), // Rule ID 3233 //
     /* 190400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 190403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190415 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 190420 */     GIR_RootConstrainSelectedInstOperands,
     /* 190421 */     // GIR_Coverage, 3233,
     /* 190421 */     GIR_Done,
     /* 190422 */   // Label 4257: @190422
     /* 190422 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(190449), // Rule ID 5470 //
     /* 190427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190442 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 190442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 190447 */     GIR_RootConstrainSelectedInstOperands,
     /* 190448 */     // GIR_Coverage, 5470,
     /* 190448 */     GIR_Done,
     /* 190449 */   // Label 4258: @190449
     /* 190449 */   GIM_Reject,
     /* 190450 */ // Label 4251: @190450
     /* 190450 */ GIM_Reject,
     /* 190451 */ // Label 4235: @190451
     /* 190451 */ GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(190767),
     /* 190456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 190459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 190462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190466 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(190524), // Rule ID 24017 //
     /* 190471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190506 */     // (umax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 190509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190511 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190522 */     GIR_RootConstrainSelectedInstOperands,
     /* 190523 */     // GIR_Coverage, 24017,
     /* 190523 */     GIR_EraseRootFromParent_Done,
     /* 190524 */   // Label 4260: @190524
     /* 190524 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(190582), // Rule ID 5491 //
     /* 190529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190564 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 190567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190580 */     GIR_RootConstrainSelectedInstOperands,
     /* 190581 */     // GIR_Coverage, 5491,
     /* 190581 */     GIR_EraseRootFromParent_Done,
     /* 190582 */   // Label 4261: @190582
     /* 190582 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(190605), // Rule ID 5488 //
     /* 190587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190598 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 190598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 190603 */     GIR_RootConstrainSelectedInstOperands,
     /* 190604 */     // GIR_Coverage, 5488,
     /* 190604 */     GIR_Done,
     /* 190605 */   // Label 4262: @190605
     /* 190605 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(190766), // Rule ID 20000 //
     /* 190610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 190613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190621 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 190621 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 190624 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190628 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 190635 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 190638 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190642 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190647 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 190650 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 190654 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 190657 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190662 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190667 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190672 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190675 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190679 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190686 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190693 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190698 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190701 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190705 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 190708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 190730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190748 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 190755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190765 */     // GIR_Coverage, 20000,
     /* 190765 */     GIR_EraseRootFromParent_Done,
     /* 190766 */   // Label 4263: @190766
     /* 190766 */   GIM_Reject,
     /* 190767 */ // Label 4259: @190767
     /* 190767 */ GIM_Reject,
     /* 190768 */ // Label 4236: @190768
     /* 190768 */ GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(191109),
     /* 190773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 190776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190779 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(190841), // Rule ID 23509 //
     /* 190784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190823 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 190826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190828 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190839 */     GIR_RootConstrainSelectedInstOperands,
     /* 190840 */     // GIR_Coverage, 23509,
     /* 190840 */     GIR_EraseRootFromParent_Done,
     /* 190841 */   // Label 4265: @190841
     /* 190841 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(190903), // Rule ID 23990 //
     /* 190846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190885 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 190888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190901 */     GIR_RootConstrainSelectedInstOperands,
     /* 190902 */     // GIR_Coverage, 23990,
     /* 190902 */     GIR_EraseRootFromParent_Done,
     /* 190903 */   // Label 4266: @190903
     /* 190903 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(190965), // Rule ID 3202 //
     /* 190908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190927 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190930 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190934 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190947 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 190950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190952 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190963 */     GIR_RootConstrainSelectedInstOperands,
     /* 190964 */     // GIR_Coverage, 3202,
     /* 190964 */     GIR_EraseRootFromParent_Done,
     /* 190965 */   // Label 4267: @190965
     /* 190965 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(191027), // Rule ID 5449 //
     /* 190970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190989 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190992 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190996 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191009 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 191012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191014 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191025 */     GIR_RootConstrainSelectedInstOperands,
     /* 191026 */     // GIR_Coverage, 5449,
     /* 191026 */     GIR_EraseRootFromParent_Done,
     /* 191027 */   // Label 4268: @191027
     /* 191027 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(191054), // Rule ID 3201 //
     /* 191032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191047 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 191052 */     GIR_RootConstrainSelectedInstOperands,
     /* 191053 */     // GIR_Coverage, 3201,
     /* 191053 */     GIR_Done,
     /* 191054 */   // Label 4269: @191054
     /* 191054 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(191081), // Rule ID 3235 //
     /* 191059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 191062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191074 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 191079 */     GIR_RootConstrainSelectedInstOperands,
     /* 191080 */     // GIR_Coverage, 3235,
     /* 191080 */     GIR_Done,
     /* 191081 */   // Label 4270: @191081
     /* 191081 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(191108), // Rule ID 5446 //
     /* 191086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191101 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 191101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 191106 */     GIR_RootConstrainSelectedInstOperands,
     /* 191107 */     // GIR_Coverage, 5446,
     /* 191107 */     GIR_Done,
     /* 191108 */   // Label 4271: @191108
     /* 191108 */   GIM_Reject,
     /* 191109 */ // Label 4264: @191109
     /* 191109 */ GIM_Reject,
     /* 191110 */ // Label 4237: @191110
     /* 191110 */ GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(191424),
     /* 191115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 191118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 191121 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(191183), // Rule ID 23513 //
     /* 191126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191141 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191165 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 191168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191181 */     GIR_RootConstrainSelectedInstOperands,
     /* 191182 */     // GIR_Coverage, 23513,
     /* 191182 */     GIR_EraseRootFromParent_Done,
     /* 191183 */   // Label 4273: @191183
     /* 191183 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(191245), // Rule ID 23999 //
     /* 191188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191227 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 191230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191243 */     GIR_RootConstrainSelectedInstOperands,
     /* 191244 */     // GIR_Coverage, 23999,
     /* 191244 */     GIR_EraseRootFromParent_Done,
     /* 191245 */   // Label 4274: @191245
     /* 191245 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(191307), // Rule ID 3210 //
     /* 191250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191289 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 191292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191305 */     GIR_RootConstrainSelectedInstOperands,
     /* 191306 */     // GIR_Coverage, 3210,
     /* 191306 */     GIR_EraseRootFromParent_Done,
     /* 191307 */   // Label 4275: @191307
     /* 191307 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(191369), // Rule ID 5464 //
     /* 191312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191351 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 191354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191367 */     GIR_RootConstrainSelectedInstOperands,
     /* 191368 */     // GIR_Coverage, 5464,
     /* 191368 */     GIR_EraseRootFromParent_Done,
     /* 191369 */   // Label 4276: @191369
     /* 191369 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(191396), // Rule ID 3209 //
     /* 191374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191389 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 191389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 191394 */     GIR_RootConstrainSelectedInstOperands,
     /* 191395 */     // GIR_Coverage, 3209,
     /* 191395 */     GIR_Done,
     /* 191396 */   // Label 4277: @191396
     /* 191396 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(191423), // Rule ID 5461 //
     /* 191401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191416 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 191416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 191421 */     GIR_RootConstrainSelectedInstOperands,
     /* 191422 */     // GIR_Coverage, 5461,
     /* 191422 */     GIR_Done,
     /* 191423 */   // Label 4278: @191423
     /* 191423 */   GIM_Reject,
     /* 191424 */ // Label 4272: @191424
     /* 191424 */ GIM_Reject,
     /* 191425 */ // Label 4238: @191425
     /* 191425 */ GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(191580),
     /* 191430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 191433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 191436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191440 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(191498), // Rule ID 24011 //
     /* 191445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191480 */     // (umax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 191483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191496 */     GIR_RootConstrainSelectedInstOperands,
     /* 191497 */     // GIR_Coverage, 24011,
     /* 191497 */     GIR_EraseRootFromParent_Done,
     /* 191498 */   // Label 4280: @191498
     /* 191498 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(191556), // Rule ID 5482 //
     /* 191503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191538 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 191541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191554 */     GIR_RootConstrainSelectedInstOperands,
     /* 191555 */     // GIR_Coverage, 5482,
     /* 191555 */     GIR_EraseRootFromParent_Done,
     /* 191556 */   // Label 4281: @191556
     /* 191556 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(191579), // Rule ID 5479 //
     /* 191561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191572 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 191572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 191577 */     GIR_RootConstrainSelectedInstOperands,
     /* 191578 */     // GIR_Coverage, 5479,
     /* 191578 */     GIR_Done,
     /* 191579 */   // Label 4282: @191579
     /* 191579 */   GIM_Reject,
     /* 191580 */ // Label 4279: @191580
     /* 191580 */ GIM_Reject,
     /* 191581 */ // Label 4239: @191581
     /* 191581 */ GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(191922),
     /* 191586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 191589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191592 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(191654), // Rule ID 23468 //
     /* 191597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191615 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191619 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191636 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 191639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191652 */     GIR_RootConstrainSelectedInstOperands,
     /* 191653 */     // GIR_Coverage, 23468,
     /* 191653 */     GIR_EraseRootFromParent_Done,
     /* 191654 */   // Label 4284: @191654
     /* 191654 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(191716), // Rule ID 23981 //
     /* 191659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191674 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191681 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191698 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 191701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191703 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191714 */     GIR_RootConstrainSelectedInstOperands,
     /* 191715 */     // GIR_Coverage, 23981,
     /* 191715 */     GIR_EraseRootFromParent_Done,
     /* 191716 */   // Label 4285: @191716
     /* 191716 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(191778), // Rule ID 2649 //
     /* 191721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191760 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 191763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191776 */     GIR_RootConstrainSelectedInstOperands,
     /* 191777 */     // GIR_Coverage, 2649,
     /* 191777 */     GIR_EraseRootFromParent_Done,
     /* 191778 */   // Label 4286: @191778
     /* 191778 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(191840), // Rule ID 5431 //
     /* 191783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191802 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191805 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191809 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191822 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 191825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191838 */     GIR_RootConstrainSelectedInstOperands,
     /* 191839 */     // GIR_Coverage, 5431,
     /* 191839 */     GIR_EraseRootFromParent_Done,
     /* 191840 */   // Label 4287: @191840
     /* 191840 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(191867), // Rule ID 2648 //
     /* 191845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191860 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 191865 */     GIR_RootConstrainSelectedInstOperands,
     /* 191866 */     // GIR_Coverage, 2648,
     /* 191866 */     GIR_Done,
     /* 191867 */   // Label 4288: @191867
     /* 191867 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(191894), // Rule ID 2650 //
     /* 191872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 191875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191887 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 191892 */     GIR_RootConstrainSelectedInstOperands,
     /* 191893 */     // GIR_Coverage, 2650,
     /* 191893 */     GIR_Done,
     /* 191894 */   // Label 4289: @191894
     /* 191894 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(191921), // Rule ID 5428 //
     /* 191899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191914 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 191914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 191919 */     GIR_RootConstrainSelectedInstOperands,
     /* 191920 */     // GIR_Coverage, 5428,
     /* 191920 */     GIR_Done,
     /* 191921 */   // Label 4290: @191921
     /* 191921 */   GIM_Reject,
     /* 191922 */ // Label 4283: @191922
     /* 191922 */ GIM_Reject,
     /* 191923 */ // Label 4240: @191923
     /* 191923 */ GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(192237),
     /* 191928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 191931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 191934 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(191996), // Rule ID 23518 //
     /* 191939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191978 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 191981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191994 */     GIR_RootConstrainSelectedInstOperands,
     /* 191995 */     // GIR_Coverage, 23518,
     /* 191995 */     GIR_EraseRootFromParent_Done,
     /* 191996 */   // Label 4292: @191996
     /* 191996 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(192058), // Rule ID 23987 //
     /* 192001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192040 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 192043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192056 */     GIR_RootConstrainSelectedInstOperands,
     /* 192057 */     // GIR_Coverage, 23987,
     /* 192057 */     GIR_EraseRootFromParent_Done,
     /* 192058 */   // Label 4293: @192058
     /* 192058 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(192120), // Rule ID 3220 //
     /* 192063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192102 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 192105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192118 */     GIR_RootConstrainSelectedInstOperands,
     /* 192119 */     // GIR_Coverage, 3220,
     /* 192119 */     GIR_EraseRootFromParent_Done,
     /* 192120 */   // Label 4294: @192120
     /* 192120 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(192182), // Rule ID 5443 //
     /* 192125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192164 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 192167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192180 */     GIR_RootConstrainSelectedInstOperands,
     /* 192181 */     // GIR_Coverage, 5443,
     /* 192181 */     GIR_EraseRootFromParent_Done,
     /* 192182 */   // Label 4295: @192182
     /* 192182 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(192209), // Rule ID 3219 //
     /* 192187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192202 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 192202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 192207 */     GIR_RootConstrainSelectedInstOperands,
     /* 192208 */     // GIR_Coverage, 3219,
     /* 192208 */     GIR_Done,
     /* 192209 */   // Label 4296: @192209
     /* 192209 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(192236), // Rule ID 5440 //
     /* 192214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192229 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 192229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 192234 */     GIR_RootConstrainSelectedInstOperands,
     /* 192235 */     // GIR_Coverage, 5440,
     /* 192235 */     GIR_Done,
     /* 192236 */   // Label 4297: @192236
     /* 192236 */   GIM_Reject,
     /* 192237 */ // Label 4291: @192237
     /* 192237 */ GIM_Reject,
     /* 192238 */ // Label 4241: @192238
     /* 192238 */ GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(192393),
     /* 192243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 192246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 192249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192253 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(192311), // Rule ID 23993 //
     /* 192258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192293 */     // (umax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 192296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192309 */     GIR_RootConstrainSelectedInstOperands,
     /* 192310 */     // GIR_Coverage, 23993,
     /* 192310 */     GIR_EraseRootFromParent_Done,
     /* 192311 */   // Label 4299: @192311
     /* 192311 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(192369), // Rule ID 5455 //
     /* 192316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192351 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 192354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192367 */     GIR_RootConstrainSelectedInstOperands,
     /* 192368 */     // GIR_Coverage, 5455,
     /* 192368 */     GIR_EraseRootFromParent_Done,
     /* 192369 */   // Label 4300: @192369
     /* 192369 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(192392), // Rule ID 5452 //
     /* 192374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192385 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 192385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 192390 */     GIR_RootConstrainSelectedInstOperands,
     /* 192391 */     // GIR_Coverage, 5452,
     /* 192391 */     GIR_Done,
     /* 192392 */   // Label 4301: @192392
     /* 192392 */   GIM_Reject,
     /* 192393 */ // Label 4298: @192393
     /* 192393 */ GIM_Reject,
     /* 192394 */ // Label 4242: @192394
     /* 192394 */ GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(192708),
     /* 192399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 192402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 192405 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(192467), // Rule ID 23470 //
     /* 192410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192425 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192449 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 192452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192465 */     GIR_RootConstrainSelectedInstOperands,
     /* 192466 */     // GIR_Coverage, 23470,
     /* 192466 */     GIR_EraseRootFromParent_Done,
     /* 192467 */   // Label 4303: @192467
     /* 192467 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(192529), // Rule ID 23978 //
     /* 192472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192511 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 192514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192527 */     GIR_RootConstrainSelectedInstOperands,
     /* 192528 */     // GIR_Coverage, 23978,
     /* 192528 */     GIR_EraseRootFromParent_Done,
     /* 192529 */   // Label 4304: @192529
     /* 192529 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(192591), // Rule ID 2653 //
     /* 192534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192573 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 192576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192589 */     GIR_RootConstrainSelectedInstOperands,
     /* 192590 */     // GIR_Coverage, 2653,
     /* 192590 */     GIR_EraseRootFromParent_Done,
     /* 192591 */   // Label 4305: @192591
     /* 192591 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(192653), // Rule ID 5425 //
     /* 192596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192635 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 192638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192642 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192651 */     GIR_RootConstrainSelectedInstOperands,
     /* 192652 */     // GIR_Coverage, 5425,
     /* 192652 */     GIR_EraseRootFromParent_Done,
     /* 192653 */   // Label 4306: @192653
     /* 192653 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(192680), // Rule ID 2652 //
     /* 192658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192673 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 192673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 192678 */     GIR_RootConstrainSelectedInstOperands,
     /* 192679 */     // GIR_Coverage, 2652,
     /* 192679 */     GIR_Done,
     /* 192680 */   // Label 4307: @192680
     /* 192680 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(192707), // Rule ID 5422 //
     /* 192685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192700 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 192700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 192705 */     GIR_RootConstrainSelectedInstOperands,
     /* 192706 */     // GIR_Coverage, 5422,
     /* 192706 */     GIR_Done,
     /* 192707 */   // Label 4308: @192707
     /* 192707 */   GIM_Reject,
     /* 192708 */ // Label 4302: @192708
     /* 192708 */ GIM_Reject,
     /* 192709 */ // Label 4243: @192709
     /* 192709 */ GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(192864),
     /* 192714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 192717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 192720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192724 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(192782), // Rule ID 23984 //
     /* 192729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192764 */     // (umax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 192767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192780 */     GIR_RootConstrainSelectedInstOperands,
     /* 192781 */     // GIR_Coverage, 23984,
     /* 192781 */     GIR_EraseRootFromParent_Done,
     /* 192782 */   // Label 4310: @192782
     /* 192782 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(192840), // Rule ID 5437 //
     /* 192787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192802 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192805 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192809 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192822 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 192825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192838 */     GIR_RootConstrainSelectedInstOperands,
     /* 192839 */     // GIR_Coverage, 5437,
     /* 192839 */     GIR_EraseRootFromParent_Done,
     /* 192840 */   // Label 4311: @192840
     /* 192840 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(192863), // Rule ID 5434 //
     /* 192845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192856 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 192856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 192861 */     GIR_RootConstrainSelectedInstOperands,
     /* 192862 */     // GIR_Coverage, 5434,
     /* 192862 */     GIR_Done,
     /* 192863 */   // Label 4312: @192863
     /* 192863 */   GIM_Reject,
     /* 192864 */ // Label 4309: @192864
     /* 192864 */ GIM_Reject,
     /* 192865 */ // Label 4244: @192865
     /* 192865 */ GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(193020),
     /* 192870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 192873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 192876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192880 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(192938), // Rule ID 23975 //
     /* 192885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192920 */     // (umax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 192923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192936 */     GIR_RootConstrainSelectedInstOperands,
     /* 192937 */     // GIR_Coverage, 23975,
     /* 192937 */     GIR_EraseRootFromParent_Done,
     /* 192938 */   // Label 4314: @192938
     /* 192938 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(192996), // Rule ID 5419 //
     /* 192943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192978 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 192981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192983 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192994 */     GIR_RootConstrainSelectedInstOperands,
     /* 192995 */     // GIR_Coverage, 5419,
     /* 192995 */     GIR_EraseRootFromParent_Done,
     /* 192996 */   // Label 4315: @192996
     /* 192996 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(193019), // Rule ID 5416 //
     /* 193001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 193004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193012 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 193012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 193017 */     GIR_RootConstrainSelectedInstOperands,
     /* 193018 */     // GIR_Coverage, 5416,
     /* 193018 */     GIR_Done,
     /* 193019 */   // Label 4316: @193019
     /* 193019 */   GIM_Reject,
     /* 193020 */ // Label 4313: @193020
     /* 193020 */ GIM_Reject,
     /* 193021 */ // Label 4245: @193021
     /* 193021 */ GIM_Reject,
     /* 193022 */ // Label 58: @193022
     /* 193022 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4329*/ GIMT_Encode4(194902),
     /* 193033 */ /*GILLT_v2s64*//*Label 4317*/ GIMT_Encode4(193101), GIMT_Encode4(0),
     /* 193041 */ /*GILLT_v4s32*//*Label 4318*/ GIMT_Encode4(193297),
     /* 193045 */ /*GILLT_v4s64*//*Label 4319*/ GIMT_Encode4(193488), GIMT_Encode4(0),
     /* 193053 */ /*GILLT_v8s16*//*Label 4320*/ GIMT_Encode4(193676),
     /* 193057 */ /*GILLT_v8s32*//*Label 4321*/ GIMT_Encode4(193867),
     /* 193061 */ /*GILLT_v8s64*//*Label 4322*/ GIMT_Encode4(194035), GIMT_Encode4(0),
     /* 193069 */ /*GILLT_v16s8*//*Label 4323*/ GIMT_Encode4(194120),
     /* 193073 */ /*GILLT_v16s16*//*Label 4324*/ GIMT_Encode4(194311),
     /* 193077 */ /*GILLT_v16s32*//*Label 4325*/ GIMT_Encode4(194479), GIMT_Encode4(0),
     /* 193085 */ /*GILLT_v32s8*//*Label 4326*/ GIMT_Encode4(194564),
     /* 193089 */ /*GILLT_v32s16*//*Label 4327*/ GIMT_Encode4(194732), GIMT_Encode4(0),
     /* 193097 */ /*GILLT_v64s8*//*Label 4328*/ GIMT_Encode4(194817),
     /* 193101 */ // Label 4317: @193101
     /* 193101 */ GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(193296),
     /* 193106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193109 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(193165), // Rule ID 13267 //
     /* 193114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193149 */     // (abs:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 193149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rm),
     /* 193152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193163 */     GIR_RootConstrainSelectedInstOperands,
     /* 193164 */     // GIR_Coverage, 13267,
     /* 193164 */     GIR_EraseRootFromParent_Done,
     /* 193165 */   // Label 4331: @193165
     /* 193165 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(193188), // Rule ID 13264 //
     /* 193170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193181 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 193181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 193186 */     GIR_RootConstrainSelectedInstOperands,
     /* 193187 */     // GIR_Coverage, 13264,
     /* 193187 */     GIR_Done,
     /* 193188 */   // Label 4332: @193188
     /* 193188 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(193295), // Rule ID 21824 //
     /* 193193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 193200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193204 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 193204 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193207 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193211 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193230 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193233 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 193237 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 193240 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 193262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193267 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 193284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 193289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193294 */     // GIR_Coverage, 21824,
     /* 193294 */     GIR_EraseRootFromParent_Done,
     /* 193295 */   // Label 4333: @193295
     /* 193295 */   GIM_Reject,
     /* 193296 */ // Label 4330: @193296
     /* 193296 */ GIM_Reject,
     /* 193297 */ // Label 4318: @193297
     /* 193297 */ GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(193487),
     /* 193302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193305 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(193361), // Rule ID 2995 //
     /* 193310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193345 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 193345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDrm),
     /* 193348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193359 */     GIR_RootConstrainSelectedInstOperands,
     /* 193360 */     // GIR_Coverage, 2995,
     /* 193360 */     GIR_EraseRootFromParent_Done,
     /* 193361 */   // Label 4335: @193361
     /* 193361 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(193417), // Rule ID 13294 //
     /* 193366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193401 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 193401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rm),
     /* 193404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193415 */     GIR_RootConstrainSelectedInstOperands,
     /* 193416 */     // GIR_Coverage, 13294,
     /* 193416 */     GIR_EraseRootFromParent_Done,
     /* 193417 */   // Label 4336: @193417
     /* 193417 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(193440), // Rule ID 2994 //
     /* 193422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193433 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 193433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 193438 */     GIR_RootConstrainSelectedInstOperands,
     /* 193439 */     // GIR_Coverage, 2994,
     /* 193439 */     GIR_Done,
     /* 193440 */   // Label 4337: @193440
     /* 193440 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(193463), // Rule ID 3006 //
     /* 193445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 193448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193456 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 193456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 193461 */     GIR_RootConstrainSelectedInstOperands,
     /* 193462 */     // GIR_Coverage, 3006,
     /* 193462 */     GIR_Done,
     /* 193463 */   // Label 4338: @193463
     /* 193463 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(193486), // Rule ID 13291 //
     /* 193468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193479 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 193479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 193484 */     GIR_RootConstrainSelectedInstOperands,
     /* 193485 */     // GIR_Coverage, 13291,
     /* 193485 */     GIR_Done,
     /* 193486 */   // Label 4339: @193486
     /* 193486 */   GIM_Reject,
     /* 193487 */ // Label 4334: @193487
     /* 193487 */ GIM_Reject,
     /* 193488 */ // Label 4319: @193488
     /* 193488 */ GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(193675),
     /* 193493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 193496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193500 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(193552), // Rule ID 13258 //
     /* 193505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193536 */     // (abs:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 193536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rm),
     /* 193539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193550 */     GIR_RootConstrainSelectedInstOperands,
     /* 193551 */     // GIR_Coverage, 13258,
     /* 193551 */     GIR_EraseRootFromParent_Done,
     /* 193552 */   // Label 4341: @193552
     /* 193552 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(193571), // Rule ID 13255 //
     /* 193557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193564 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 193564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 193569 */     GIR_RootConstrainSelectedInstOperands,
     /* 193570 */     // GIR_Coverage, 13255,
     /* 193570 */     GIR_Done,
     /* 193571 */   // Label 4342: @193571
     /* 193571 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(193674), // Rule ID 21823 //
     /* 193576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193583 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 193583 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193586 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193590 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193609 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193612 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 193616 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 193619 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193624 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 193641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193656 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 193663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193673 */     // GIR_Coverage, 21823,
     /* 193673 */     GIR_EraseRootFromParent_Done,
     /* 193674 */   // Label 4343: @193674
     /* 193674 */   GIM_Reject,
     /* 193675 */ // Label 4340: @193675
     /* 193675 */ GIM_Reject,
     /* 193676 */ // Label 4320: @193676
     /* 193676 */ GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(193866),
     /* 193681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 193684 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(193740), // Rule ID 2993 //
     /* 193689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193724 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 193724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWrm),
     /* 193727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193738 */     GIR_RootConstrainSelectedInstOperands,
     /* 193739 */     // GIR_Coverage, 2993,
     /* 193739 */     GIR_EraseRootFromParent_Done,
     /* 193740 */   // Label 4345: @193740
     /* 193740 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(193796), // Rule ID 13315 //
     /* 193745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193780 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 193780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rm),
     /* 193783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193794 */     GIR_RootConstrainSelectedInstOperands,
     /* 193795 */     // GIR_Coverage, 13315,
     /* 193795 */     GIR_EraseRootFromParent_Done,
     /* 193796 */   // Label 4346: @193796
     /* 193796 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(193819), // Rule ID 2992 //
     /* 193801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193812 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 193812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 193817 */     GIR_RootConstrainSelectedInstOperands,
     /* 193818 */     // GIR_Coverage, 2992,
     /* 193818 */     GIR_Done,
     /* 193819 */   // Label 4347: @193819
     /* 193819 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(193842), // Rule ID 3004 //
     /* 193824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 193827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193835 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 193835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 193840 */     GIR_RootConstrainSelectedInstOperands,
     /* 193841 */     // GIR_Coverage, 3004,
     /* 193841 */     GIR_Done,
     /* 193842 */   // Label 4348: @193842
     /* 193842 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(193865), // Rule ID 13312 //
     /* 193847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193858 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 193858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 193863 */     GIR_RootConstrainSelectedInstOperands,
     /* 193864 */     // GIR_Coverage, 13312,
     /* 193864 */     GIR_Done,
     /* 193865 */   // Label 4349: @193865
     /* 193865 */   GIM_Reject,
     /* 193866 */ // Label 4344: @193866
     /* 193866 */ GIM_Reject,
     /* 193867 */ // Label 4321: @193867
     /* 193867 */ GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(194034),
     /* 193872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 193875 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(193931), // Rule ID 3001 //
     /* 193880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 193883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193915 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 193915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDYrm),
     /* 193918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193929 */     GIR_RootConstrainSelectedInstOperands,
     /* 193930 */     // GIR_Coverage, 3001,
     /* 193930 */     GIR_EraseRootFromParent_Done,
     /* 193931 */   // Label 4351: @193931
     /* 193931 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(193987), // Rule ID 13285 //
     /* 193936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193971 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 193971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rm),
     /* 193974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193976 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193985 */     GIR_RootConstrainSelectedInstOperands,
     /* 193986 */     // GIR_Coverage, 13285,
     /* 193986 */     GIR_EraseRootFromParent_Done,
     /* 193987 */   // Label 4352: @193987
     /* 193987 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(194010), // Rule ID 3000 //
     /* 193992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 193995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194003 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 194003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 194008 */     GIR_RootConstrainSelectedInstOperands,
     /* 194009 */     // GIR_Coverage, 3000,
     /* 194009 */     GIR_Done,
     /* 194010 */   // Label 4353: @194010
     /* 194010 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(194033), // Rule ID 13282 //
     /* 194015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194026 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 194026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 194031 */     GIR_RootConstrainSelectedInstOperands,
     /* 194032 */     // GIR_Coverage, 13282,
     /* 194032 */     GIR_Done,
     /* 194033 */   // Label 4354: @194033
     /* 194033 */   GIM_Reject,
     /* 194034 */ // Label 4350: @194034
     /* 194034 */ GIM_Reject,
     /* 194035 */ // Label 4322: @194035
     /* 194035 */ GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(194119),
     /* 194040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194047 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(194099), // Rule ID 13249 //
     /* 194052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194063 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194070 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194083 */     // (abs:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 194083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZrm),
     /* 194086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194088 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194097 */     GIR_RootConstrainSelectedInstOperands,
     /* 194098 */     // GIR_Coverage, 13249,
     /* 194098 */     GIR_EraseRootFromParent_Done,
     /* 194099 */   // Label 4356: @194099
     /* 194099 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(194118), // Rule ID 13246 //
     /* 194104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194111 */     // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 194111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 194116 */     GIR_RootConstrainSelectedInstOperands,
     /* 194117 */     // GIR_Coverage, 13246,
     /* 194117 */     GIR_Done,
     /* 194118 */   // Label 4357: @194118
     /* 194118 */   GIM_Reject,
     /* 194119 */ // Label 4355: @194119
     /* 194119 */ GIM_Reject,
     /* 194120 */ // Label 4323: @194120
     /* 194120 */ GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(194310),
     /* 194125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 194128 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(194184), // Rule ID 2991 //
     /* 194133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194168 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 194168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBrm),
     /* 194171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 194177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194182 */     GIR_RootConstrainSelectedInstOperands,
     /* 194183 */     // GIR_Coverage, 2991,
     /* 194183 */     GIR_EraseRootFromParent_Done,
     /* 194184 */   // Label 4359: @194184
     /* 194184 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(194240), // Rule ID 13333 //
     /* 194189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194224 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 194224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rm),
     /* 194227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194238 */     GIR_RootConstrainSelectedInstOperands,
     /* 194239 */     // GIR_Coverage, 13333,
     /* 194239 */     GIR_EraseRootFromParent_Done,
     /* 194240 */   // Label 4360: @194240
     /* 194240 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(194263), // Rule ID 2990 //
     /* 194245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194256 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 194256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 194261 */     GIR_RootConstrainSelectedInstOperands,
     /* 194262 */     // GIR_Coverage, 2990,
     /* 194262 */     GIR_Done,
     /* 194263 */   // Label 4361: @194263
     /* 194263 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(194286), // Rule ID 3002 //
     /* 194268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 194271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194279 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 194279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 194284 */     GIR_RootConstrainSelectedInstOperands,
     /* 194285 */     // GIR_Coverage, 3002,
     /* 194285 */     GIR_Done,
     /* 194286 */   // Label 4362: @194286
     /* 194286 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(194309), // Rule ID 13330 //
     /* 194291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194302 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 194302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 194307 */     GIR_RootConstrainSelectedInstOperands,
     /* 194308 */     // GIR_Coverage, 13330,
     /* 194308 */     GIR_Done,
     /* 194309 */   // Label 4363: @194309
     /* 194309 */   GIM_Reject,
     /* 194310 */ // Label 4358: @194310
     /* 194310 */ GIM_Reject,
     /* 194311 */ // Label 4324: @194311
     /* 194311 */ GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(194478),
     /* 194316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 194319 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(194375), // Rule ID 2999 //
     /* 194324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194339 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194346 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194359 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 194359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWYrm),
     /* 194362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 194368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194373 */     GIR_RootConstrainSelectedInstOperands,
     /* 194374 */     // GIR_Coverage, 2999,
     /* 194374 */     GIR_EraseRootFromParent_Done,
     /* 194375 */   // Label 4365: @194375
     /* 194375 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(194431), // Rule ID 13309 //
     /* 194380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194415 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 194415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rm),
     /* 194418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194429 */     GIR_RootConstrainSelectedInstOperands,
     /* 194430 */     // GIR_Coverage, 13309,
     /* 194430 */     GIR_EraseRootFromParent_Done,
     /* 194431 */   // Label 4366: @194431
     /* 194431 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(194454), // Rule ID 2998 //
     /* 194436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194447 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 194447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 194452 */     GIR_RootConstrainSelectedInstOperands,
     /* 194453 */     // GIR_Coverage, 2998,
     /* 194453 */     GIR_Done,
     /* 194454 */   // Label 4367: @194454
     /* 194454 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(194477), // Rule ID 13306 //
     /* 194459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194470 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 194470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 194475 */     GIR_RootConstrainSelectedInstOperands,
     /* 194476 */     // GIR_Coverage, 13306,
     /* 194476 */     GIR_Done,
     /* 194477 */   // Label 4368: @194477
     /* 194477 */   GIM_Reject,
     /* 194478 */ // Label 4364: @194478
     /* 194478 */ GIM_Reject,
     /* 194479 */ // Label 4325: @194479
     /* 194479 */ GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(194563),
     /* 194484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 194487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194491 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(194543), // Rule ID 13276 //
     /* 194496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194527 */     // (abs:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 194527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZrm),
     /* 194530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194541 */     GIR_RootConstrainSelectedInstOperands,
     /* 194542 */     // GIR_Coverage, 13276,
     /* 194542 */     GIR_EraseRootFromParent_Done,
     /* 194543 */   // Label 4370: @194543
     /* 194543 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(194562), // Rule ID 13273 //
     /* 194548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194555 */     // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 194555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 194560 */     GIR_RootConstrainSelectedInstOperands,
     /* 194561 */     // GIR_Coverage, 13273,
     /* 194561 */     GIR_Done,
     /* 194562 */   // Label 4371: @194562
     /* 194562 */   GIM_Reject,
     /* 194563 */ // Label 4369: @194563
     /* 194563 */ GIM_Reject,
     /* 194564 */ // Label 4326: @194564
     /* 194564 */ GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(194731),
     /* 194569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 194572 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(194628), // Rule ID 2997 //
     /* 194577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194612 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 194612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBYrm),
     /* 194615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 194621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194626 */     GIR_RootConstrainSelectedInstOperands,
     /* 194627 */     // GIR_Coverage, 2997,
     /* 194627 */     GIR_EraseRootFromParent_Done,
     /* 194628 */   // Label 4373: @194628
     /* 194628 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(194684), // Rule ID 13327 //
     /* 194633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194668 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 194668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rm),
     /* 194671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194682 */     GIR_RootConstrainSelectedInstOperands,
     /* 194683 */     // GIR_Coverage, 13327,
     /* 194683 */     GIR_EraseRootFromParent_Done,
     /* 194684 */   // Label 4374: @194684
     /* 194684 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(194707), // Rule ID 2996 //
     /* 194689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194700 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 194700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 194705 */     GIR_RootConstrainSelectedInstOperands,
     /* 194706 */     // GIR_Coverage, 2996,
     /* 194706 */     GIR_Done,
     /* 194707 */   // Label 4375: @194707
     /* 194707 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(194730), // Rule ID 13324 //
     /* 194712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194723 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 194723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 194728 */     GIR_RootConstrainSelectedInstOperands,
     /* 194729 */     // GIR_Coverage, 13324,
     /* 194729 */     GIR_Done,
     /* 194730 */   // Label 4376: @194730
     /* 194730 */   GIM_Reject,
     /* 194731 */ // Label 4372: @194731
     /* 194731 */ GIM_Reject,
     /* 194732 */ // Label 4327: @194732
     /* 194732 */ GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(194816),
     /* 194737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 194740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194744 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(194796), // Rule ID 13303 //
     /* 194749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194780 */     // (abs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 194780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZrm),
     /* 194783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194794 */     GIR_RootConstrainSelectedInstOperands,
     /* 194795 */     // GIR_Coverage, 13303,
     /* 194795 */     GIR_EraseRootFromParent_Done,
     /* 194796 */   // Label 4378: @194796
     /* 194796 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(194815), // Rule ID 13300 //
     /* 194801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194808 */     // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 194808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 194813 */     GIR_RootConstrainSelectedInstOperands,
     /* 194814 */     // GIR_Coverage, 13300,
     /* 194814 */     GIR_Done,
     /* 194815 */   // Label 4379: @194815
     /* 194815 */   GIM_Reject,
     /* 194816 */ // Label 4377: @194816
     /* 194816 */ GIM_Reject,
     /* 194817 */ // Label 4328: @194817
     /* 194817 */ GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(194901),
     /* 194822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 194825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194829 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(194881), // Rule ID 13321 //
     /* 194834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194845 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194848 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194852 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194865 */     // (abs:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 194865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZrm),
     /* 194868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194879 */     GIR_RootConstrainSelectedInstOperands,
     /* 194880 */     // GIR_Coverage, 13321,
     /* 194880 */     GIR_EraseRootFromParent_Done,
     /* 194881 */   // Label 4381: @194881
     /* 194881 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(194900), // Rule ID 13318 //
     /* 194886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194893 */     // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 194893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 194898 */     GIR_RootConstrainSelectedInstOperands,
     /* 194899 */     // GIR_Coverage, 13318,
     /* 194899 */     GIR_Done,
     /* 194900 */   // Label 4382: @194900
     /* 194900 */   GIM_Reject,
     /* 194901 */ // Label 4380: @194901
     /* 194901 */ GIM_Reject,
     /* 194902 */ // Label 4329: @194902
     /* 194902 */ GIM_Reject,
     /* 194903 */ // Label 59: @194903
     /* 194903 */ GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(194918), // Rule ID 630 //
     /* 194908 */   // MIs[0] dst
     /* 194908 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 194911 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 194911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 194916 */   GIR_RootConstrainSelectedInstOperands,
     /* 194917 */   // GIR_Coverage, 630,
     /* 194917 */   GIR_Done,
     /* 194918 */ // Label 4383: @194918
     /* 194918 */ GIM_Reject,
     /* 194919 */ // Label 60: @194919
     /* 194919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 4398*/ GIMT_Encode4(197847),
     /* 194930 */ /*GILLT_s1*//*Label 4384*/ GIMT_Encode4(195018), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 194958 */ /*GILLT_v2s1*//*Label 4385*/ GIMT_Encode4(195259),
     /* 194962 */ /*GILLT_v2s64*//*Label 4386*/ GIMT_Encode4(195460),
     /* 194966 */ /*GILLT_v4s1*//*Label 4387*/ GIMT_Encode4(195941),
     /* 194970 */ /*GILLT_v4s32*//*Label 4388*/ GIMT_Encode4(196102),
     /* 194974 */ /*GILLT_v4s64*//*Label 4389*/ GIMT_Encode4(196583),
     /* 194978 */ /*GILLT_v8s1*//*Label 4390*/ GIMT_Encode4(196666),
     /* 194982 */ /*GILLT_v8s16*//*Label 4391*/ GIMT_Encode4(196787),
     /* 194986 */ /*GILLT_v8s32*//*Label 4392*/ GIMT_Encode4(197268), GIMT_Encode4(0),
     /* 194994 */ /*GILLT_v16s1*//*Label 4393*/ GIMT_Encode4(197351),
     /* 194998 */ /*GILLT_v16s8*//*Label 4394*/ GIMT_Encode4(197432),
     /* 195002 */ /*GILLT_v16s16*//*Label 4395*/ GIMT_Encode4(197673), GIMT_Encode4(0),
     /* 195010 */ /*GILLT_v32s1*//*Label 4396*/ GIMT_Encode4(197756),
     /* 195014 */ /*GILLT_v32s8*//*Label 4397*/ GIMT_Encode4(197797),
     /* 195018 */ // Label 4384: @195018
     /* 195018 */ GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(195058), // Rule ID 19602 //
     /* 195023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 195026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195034 */   // MIs[0] Operand 2
     /* 195034 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195045 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 195045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195057 */   // GIR_Coverage, 19602,
     /* 195057 */   GIR_EraseRootFromParent_Done,
     /* 195058 */ // Label 4399: @195058
     /* 195058 */ GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(195098), // Rule ID 19604 //
     /* 195063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 195066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195074 */   // MIs[0] Operand 2
     /* 195074 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195085 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 195085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195090 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195097 */   // GIR_Coverage, 19604,
     /* 195097 */   GIR_EraseRootFromParent_Done,
     /* 195098 */ // Label 4400: @195098
     /* 195098 */ GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(195138), // Rule ID 19606 //
     /* 195103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 195106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 195114 */   // MIs[0] Operand 2
     /* 195114 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195125 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 195125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195130 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195137 */   // GIR_Coverage, 19606,
     /* 195137 */   GIR_EraseRootFromParent_Done,
     /* 195138 */ // Label 4401: @195138
     /* 195138 */ GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(195178), // Rule ID 19608 //
     /* 195143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 195146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 195154 */   // MIs[0] Operand 2
     /* 195154 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195165 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 195165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195170 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195177 */   // GIR_Coverage, 19608,
     /* 195177 */   GIR_EraseRootFromParent_Done,
     /* 195178 */ // Label 4402: @195178
     /* 195178 */ GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(195218), // Rule ID 19610 //
     /* 195183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 195186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 195194 */   // MIs[0] Operand 2
     /* 195194 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195205 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 195205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195210 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195217 */   // GIR_Coverage, 19610,
     /* 195217 */   GIR_EraseRootFromParent_Done,
     /* 195218 */ // Label 4403: @195218
     /* 195218 */ GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(195258), // Rule ID 19612 //
     /* 195223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 195226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 195234 */   // MIs[0] Operand 2
     /* 195234 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195245 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 195245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195250 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195257 */   // GIR_Coverage, 19612,
     /* 195257 */   GIR_EraseRootFromParent_Done,
     /* 195258 */ // Label 4404: @195258
     /* 195258 */ GIM_Reject,
     /* 195259 */ // Label 4385: @195259
     /* 195259 */ GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(195299), // Rule ID 19614 //
     /* 195264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 195267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195275 */   // MIs[0] Operand 2
     /* 195275 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195286 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 195286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195291 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195293 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195298 */   // GIR_Coverage, 19614,
     /* 195298 */   GIR_EraseRootFromParent_Done,
     /* 195299 */ // Label 4405: @195299
     /* 195299 */ GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(195339), // Rule ID 19616 //
     /* 195304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 195307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 195315 */   // MIs[0] Operand 2
     /* 195315 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195326 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 195326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195338 */   // GIR_Coverage, 19616,
     /* 195338 */   GIR_EraseRootFromParent_Done,
     /* 195339 */ // Label 4406: @195339
     /* 195339 */ GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(195379), // Rule ID 19618 //
     /* 195344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 195347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 195355 */   // MIs[0] Operand 2
     /* 195355 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195366 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 195366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195378 */   // GIR_Coverage, 19618,
     /* 195378 */   GIR_EraseRootFromParent_Done,
     /* 195379 */ // Label 4407: @195379
     /* 195379 */ GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(195419), // Rule ID 19620 //
     /* 195384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 195387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 195395 */   // MIs[0] Operand 2
     /* 195395 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195406 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 195406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195411 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195418 */   // GIR_Coverage, 19620,
     /* 195418 */   GIR_EraseRootFromParent_Done,
     /* 195419 */ // Label 4408: @195419
     /* 195419 */ GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(195459), // Rule ID 19622 //
     /* 195424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 195427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 195435 */   // MIs[0] Operand 2
     /* 195435 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195446 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 195446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195458 */   // GIR_Coverage, 19622,
     /* 195458 */   GIR_EraseRootFromParent_Done,
     /* 195459 */ // Label 4409: @195459
     /* 195459 */ GIM_Reject,
     /* 195460 */ // Label 4386: @195460
     /* 195460 */ GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(195531), // Rule ID 19053 //
     /* 195465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 195468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195479 */   // MIs[0] Operand 2
     /* 195479 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195490 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195502 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 195521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195529 */   GIR_RootConstrainSelectedInstOperands,
     /* 195530 */   // GIR_Coverage, 19053,
     /* 195530 */   GIR_EraseRootFromParent_Done,
     /* 195531 */ // Label 4410: @195531
     /* 195531 */ GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(195602), // Rule ID 19054 //
     /* 195536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 195539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195550 */   // MIs[0] Operand 2
     /* 195550 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195561 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195573 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 195592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195600 */   GIR_RootConstrainSelectedInstOperands,
     /* 195601 */   // GIR_Coverage, 19054,
     /* 195601 */   GIR_EraseRootFromParent_Done,
     /* 195602 */ // Label 4411: @195602
     /* 195602 */ GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(195673), // Rule ID 19060 //
     /* 195607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 195610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195621 */   // MIs[0] Operand 2
     /* 195621 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195632 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195644 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195650 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195655 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 195663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195671 */   GIR_RootConstrainSelectedInstOperands,
     /* 195672 */   // GIR_Coverage, 19060,
     /* 195672 */   GIR_EraseRootFromParent_Done,
     /* 195673 */ // Label 4412: @195673
     /* 195673 */ GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(195744), // Rule ID 19061 //
     /* 195678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 195681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195692 */   // MIs[0] Operand 2
     /* 195692 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195703 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195715 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 195734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195742 */   GIR_RootConstrainSelectedInstOperands,
     /* 195743 */   // GIR_Coverage, 19061,
     /* 195743 */   GIR_EraseRootFromParent_Done,
     /* 195744 */ // Label 4413: @195744
     /* 195744 */ GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(195793), // Rule ID 23007 //
     /* 195749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 195752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195760 */   // MIs[0] Operand 2
     /* 195760 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195771 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 195771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195776 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195792 */   // GIR_Coverage, 23007,
     /* 195792 */   GIR_EraseRootFromParent_Done,
     /* 195793 */ // Label 4414: @195793
     /* 195793 */ GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(195842), // Rule ID 23010 //
     /* 195798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 195801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195809 */   // MIs[0] Operand 2
     /* 195809 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195820 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 195820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195825 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195841 */   // GIR_Coverage, 23010,
     /* 195841 */   GIR_EraseRootFromParent_Done,
     /* 195842 */ // Label 4415: @195842
     /* 195842 */ GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(195891), // Rule ID 23028 //
     /* 195847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195858 */   // MIs[0] Operand 2
     /* 195858 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195869 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 195869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195874 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195890 */   // GIR_Coverage, 23028,
     /* 195890 */   GIR_EraseRootFromParent_Done,
     /* 195891 */ // Label 4416: @195891
     /* 195891 */ GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(195940), // Rule ID 23031 //
     /* 195896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195907 */   // MIs[0] Operand 2
     /* 195907 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195918 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 195918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195923 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195939 */   // GIR_Coverage, 23031,
     /* 195939 */   GIR_EraseRootFromParent_Done,
     /* 195940 */ // Label 4417: @195940
     /* 195940 */ GIM_Reject,
     /* 195941 */ // Label 4387: @195941
     /* 195941 */ GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(195981), // Rule ID 19624 //
     /* 195946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 195949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 195957 */   // MIs[0] Operand 2
     /* 195957 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195968 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 195968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 195980 */   // GIR_Coverage, 19624,
     /* 195980 */   GIR_EraseRootFromParent_Done,
     /* 195981 */ // Label 4418: @195981
     /* 195981 */ GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(196021), // Rule ID 19626 //
     /* 195986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 195989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 195997 */   // MIs[0] Operand 2
     /* 195997 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196008 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 196008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196013 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 196020 */   // GIR_Coverage, 19626,
     /* 196020 */   GIR_EraseRootFromParent_Done,
     /* 196021 */ // Label 4419: @196021
     /* 196021 */ GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(196061), // Rule ID 19628 //
     /* 196026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 196029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 196033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 196037 */   // MIs[0] Operand 2
     /* 196037 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196048 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 196048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196053 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 196060 */   // GIR_Coverage, 19628,
     /* 196060 */   GIR_EraseRootFromParent_Done,
     /* 196061 */ // Label 4420: @196061
     /* 196061 */ GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(196101), // Rule ID 19630 //
     /* 196066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 196069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 196073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 196077 */   // MIs[0] Operand 2
     /* 196077 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196088 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 196088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196093 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196095 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 196100 */   // GIR_Coverage, 19630,
     /* 196100 */   GIR_EraseRootFromParent_Done,
     /* 196101 */ // Label 4421: @196101
     /* 196101 */ GIM_Reject,
     /* 196102 */ // Label 4388: @196102
     /* 196102 */ GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(196173), // Rule ID 19055 //
     /* 196107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196121 */   // MIs[0] Operand 2
     /* 196121 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196132 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196144 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196150 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 196163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196171 */   GIR_RootConstrainSelectedInstOperands,
     /* 196172 */   // GIR_Coverage, 19055,
     /* 196172 */   GIR_EraseRootFromParent_Done,
     /* 196173 */ // Label 4422: @196173
     /* 196173 */ GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(196244), // Rule ID 19056 //
     /* 196178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196192 */   // MIs[0] Operand 2
     /* 196192 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196203 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196215 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196221 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196226 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 196234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196242 */   GIR_RootConstrainSelectedInstOperands,
     /* 196243 */   // GIR_Coverage, 19056,
     /* 196243 */   GIR_EraseRootFromParent_Done,
     /* 196244 */ // Label 4423: @196244
     /* 196244 */ GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(196315), // Rule ID 19062 //
     /* 196249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196263 */   // MIs[0] Operand 2
     /* 196263 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196274 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196286 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196292 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 196305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196313 */   GIR_RootConstrainSelectedInstOperands,
     /* 196314 */   // GIR_Coverage, 19062,
     /* 196314 */   GIR_EraseRootFromParent_Done,
     /* 196315 */ // Label 4424: @196315
     /* 196315 */ GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(196386), // Rule ID 19063 //
     /* 196320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196334 */   // MIs[0] Operand 2
     /* 196334 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196345 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196357 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196363 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196368 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 196376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196384 */   GIR_RootConstrainSelectedInstOperands,
     /* 196385 */   // GIR_Coverage, 19063,
     /* 196385 */   GIR_EraseRootFromParent_Done,
     /* 196386 */ // Label 4425: @196386
     /* 196386 */ GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(196435), // Rule ID 23001 //
     /* 196391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 196394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 196398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 196402 */   // MIs[0] Operand 2
     /* 196402 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196413 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 196413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196418 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 196429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 196434 */   // GIR_Coverage, 23001,
     /* 196434 */   GIR_EraseRootFromParent_Done,
     /* 196435 */ // Label 4426: @196435
     /* 196435 */ GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(196484), // Rule ID 23004 //
     /* 196440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 196443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 196447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 196451 */   // MIs[0] Operand 2
     /* 196451 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196462 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 196462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196467 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 196478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 196483 */   // GIR_Coverage, 23004,
     /* 196483 */   GIR_EraseRootFromParent_Done,
     /* 196484 */ // Label 4427: @196484
     /* 196484 */ GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(196533), // Rule ID 23022 //
     /* 196489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196500 */   // MIs[0] Operand 2
     /* 196500 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196511 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 196511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196516 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196532 */   // GIR_Coverage, 23022,
     /* 196532 */   GIR_EraseRootFromParent_Done,
     /* 196533 */ // Label 4428: @196533
     /* 196533 */ GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(196582), // Rule ID 23025 //
     /* 196538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196549 */   // MIs[0] Operand 2
     /* 196549 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196560 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 196560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196565 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196581 */   // GIR_Coverage, 23025,
     /* 196581 */   GIR_EraseRootFromParent_Done,
     /* 196582 */ // Label 4429: @196582
     /* 196582 */ GIM_Reject,
     /* 196583 */ // Label 4389: @196583
     /* 196583 */ GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(196665),
     /* 196588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 196591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196599 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196610 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(196637), // Rule ID 23049 //
     /* 196615 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 196615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196620 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196636 */     // GIR_Coverage, 23049,
     /* 196636 */     GIR_EraseRootFromParent_Done,
     /* 196637 */   // Label 4431: @196637
     /* 196637 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(196664), // Rule ID 23052 //
     /* 196642 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 196642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196647 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196663 */     // GIR_Coverage, 23052,
     /* 196663 */     GIR_EraseRootFromParent_Done,
     /* 196664 */   // Label 4432: @196664
     /* 196664 */   GIM_Reject,
     /* 196665 */ // Label 4430: @196665
     /* 196665 */ GIM_Reject,
     /* 196666 */ // Label 4390: @196666
     /* 196666 */ GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(196706), // Rule ID 19632 //
     /* 196671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 196674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 196682 */   // MIs[0] Operand 2
     /* 196682 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196693 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 196693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196698 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196700 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196705 */   // GIR_Coverage, 19632,
     /* 196705 */   GIR_EraseRootFromParent_Done,
     /* 196706 */ // Label 4433: @196706
     /* 196706 */ GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(196746), // Rule ID 19634 //
     /* 196711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 196714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 196722 */   // MIs[0] Operand 2
     /* 196722 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196733 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 196733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196738 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196745 */   // GIR_Coverage, 19634,
     /* 196745 */   GIR_EraseRootFromParent_Done,
     /* 196746 */ // Label 4434: @196746
     /* 196746 */ GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(196786), // Rule ID 19636 //
     /* 196751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 196754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 196762 */   // MIs[0] Operand 2
     /* 196762 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196773 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 196773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196785 */   // GIR_Coverage, 19636,
     /* 196785 */   GIR_EraseRootFromParent_Done,
     /* 196786 */ // Label 4435: @196786
     /* 196786 */ GIM_Reject,
     /* 196787 */ // Label 4391: @196787
     /* 196787 */ GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(196858), // Rule ID 19057 //
     /* 196792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196806 */   // MIs[0] Operand 2
     /* 196806 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196817 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196817 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196820 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196824 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196829 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 196848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196856 */   GIR_RootConstrainSelectedInstOperands,
     /* 196857 */   // GIR_Coverage, 19057,
     /* 196857 */   GIR_EraseRootFromParent_Done,
     /* 196858 */ // Label 4436: @196858
     /* 196858 */ GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(196929), // Rule ID 19058 //
     /* 196863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196877 */   // MIs[0] Operand 2
     /* 196877 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196888 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196900 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196906 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196911 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 196919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196927 */   GIR_RootConstrainSelectedInstOperands,
     /* 196928 */   // GIR_Coverage, 19058,
     /* 196928 */   GIR_EraseRootFromParent_Done,
     /* 196929 */ // Label 4437: @196929
     /* 196929 */ GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(197000), // Rule ID 19064 //
     /* 196934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196948 */   // MIs[0] Operand 2
     /* 196948 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196959 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196971 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 196990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196998 */   GIR_RootConstrainSelectedInstOperands,
     /* 196999 */   // GIR_Coverage, 19064,
     /* 196999 */   GIR_EraseRootFromParent_Done,
     /* 197000 */ // Label 4438: @197000
     /* 197000 */ GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(197071), // Rule ID 19065 //
     /* 197005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 197008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197019 */   // MIs[0] Operand 2
     /* 197019 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 197030 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 197030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 197033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197042 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197048 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 197061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 197066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197069 */   GIR_RootConstrainSelectedInstOperands,
     /* 197070 */   // GIR_Coverage, 19065,
     /* 197070 */   GIR_EraseRootFromParent_Done,
     /* 197071 */ // Label 4439: @197071
     /* 197071 */ GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(197120), // Rule ID 23013 //
     /* 197076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 197079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 197083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197087 */   // MIs[0] Operand 2
     /* 197087 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197098 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 197098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197103 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 197114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 197119 */   // GIR_Coverage, 23013,
     /* 197119 */   GIR_EraseRootFromParent_Done,
     /* 197120 */ // Label 4440: @197120
     /* 197120 */ GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(197169), // Rule ID 23019 //
     /* 197125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 197128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 197132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197136 */   // MIs[0] Operand 2
     /* 197136 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197147 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 197147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197152 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 197163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 197168 */   // GIR_Coverage, 23019,
     /* 197168 */   GIR_EraseRootFromParent_Done,
     /* 197169 */ // Label 4441: @197169
     /* 197169 */ GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(197218), // Rule ID 23034 //
     /* 197174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 197181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197185 */   // MIs[0] Operand 2
     /* 197185 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197196 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 197196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197201 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197207 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 197212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197217 */   // GIR_Coverage, 23034,
     /* 197217 */   GIR_EraseRootFromParent_Done,
     /* 197218 */ // Label 4442: @197218
     /* 197218 */ GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(197267), // Rule ID 23040 //
     /* 197223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 197230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197234 */   // MIs[0] Operand 2
     /* 197234 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197245 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 197245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197250 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 197261 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197266 */   // GIR_Coverage, 23040,
     /* 197266 */   GIR_EraseRootFromParent_Done,
     /* 197267 */ // Label 4443: @197267
     /* 197267 */ GIM_Reject,
     /* 197268 */ // Label 4392: @197268
     /* 197268 */ GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(197350),
     /* 197273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 197276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197284 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197295 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(197322), // Rule ID 23043 //
     /* 197300 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 197300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197305 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197321 */     // GIR_Coverage, 23043,
     /* 197321 */     GIR_EraseRootFromParent_Done,
     /* 197322 */   // Label 4445: @197322
     /* 197322 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(197349), // Rule ID 23046 //
     /* 197327 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 197327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197332 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197348 */     // GIR_Coverage, 23046,
     /* 197348 */     GIR_EraseRootFromParent_Done,
     /* 197349 */   // Label 4446: @197349
     /* 197349 */   GIM_Reject,
     /* 197350 */ // Label 4444: @197350
     /* 197350 */ GIM_Reject,
     /* 197351 */ // Label 4393: @197351
     /* 197351 */ GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(197391), // Rule ID 19638 //
     /* 197356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 197359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 197363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 197367 */   // MIs[0] Operand 2
     /* 197367 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197378 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 197378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197383 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 197390 */   // GIR_Coverage, 19638,
     /* 197390 */   GIR_EraseRootFromParent_Done,
     /* 197391 */ // Label 4447: @197391
     /* 197391 */ GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(197431), // Rule ID 19640 //
     /* 197396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 197399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 197403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 197407 */   // MIs[0] Operand 2
     /* 197407 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197418 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 197418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197423 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 197430 */   // GIR_Coverage, 19640,
     /* 197430 */   GIR_EraseRootFromParent_Done,
     /* 197431 */ // Label 4448: @197431
     /* 197431 */ GIM_Reject,
     /* 197432 */ // Label 4394: @197432
     /* 197432 */ GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(197503), // Rule ID 19059 //
     /* 197437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 197440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197451 */   // MIs[0] Operand 2
     /* 197451 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 197462 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 197462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 197465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197474 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 197493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 197498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197501 */   GIR_RootConstrainSelectedInstOperands,
     /* 197502 */   // GIR_Coverage, 19059,
     /* 197502 */   GIR_EraseRootFromParent_Done,
     /* 197503 */ // Label 4449: @197503
     /* 197503 */ GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(197574), // Rule ID 19066 //
     /* 197508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 197511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197522 */   // MIs[0] Operand 2
     /* 197522 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 197533 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 197533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 197536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197545 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 197564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 197569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197572 */   GIR_RootConstrainSelectedInstOperands,
     /* 197573 */   // GIR_Coverage, 19066,
     /* 197573 */   GIR_EraseRootFromParent_Done,
     /* 197574 */ // Label 4450: @197574
     /* 197574 */ GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(197623), // Rule ID 23016 //
     /* 197579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 197582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 197586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197590 */   // MIs[0] Operand 2
     /* 197590 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197601 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 197601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197606 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 197617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 197622 */   // GIR_Coverage, 23016,
     /* 197622 */   GIR_EraseRootFromParent_Done,
     /* 197623 */ // Label 4451: @197623
     /* 197623 */ GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(197672), // Rule ID 23037 //
     /* 197628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 197635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197639 */   // MIs[0] Operand 2
     /* 197639 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197650 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 197650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197655 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 197666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197671 */   // GIR_Coverage, 23037,
     /* 197671 */   GIR_EraseRootFromParent_Done,
     /* 197672 */ // Label 4452: @197672
     /* 197672 */ GIM_Reject,
     /* 197673 */ // Label 4395: @197673
     /* 197673 */ GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(197755),
     /* 197678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197689 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197700 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(197727), // Rule ID 23055 //
     /* 197705 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 197705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197710 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197726 */     // GIR_Coverage, 23055,
     /* 197726 */     GIR_EraseRootFromParent_Done,
     /* 197727 */   // Label 4454: @197727
     /* 197727 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(197754), // Rule ID 23061 //
     /* 197732 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 197732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197737 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197753 */     // GIR_Coverage, 23061,
     /* 197753 */     GIR_EraseRootFromParent_Done,
     /* 197754 */   // Label 4455: @197754
     /* 197754 */   GIM_Reject,
     /* 197755 */ // Label 4453: @197755
     /* 197755 */ GIM_Reject,
     /* 197756 */ // Label 4396: @197756
     /* 197756 */ GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(197796), // Rule ID 19642 //
     /* 197761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 197764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 197768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 197772 */   // MIs[0] Operand 2
     /* 197772 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197783 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 197783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197788 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 197795 */   // GIR_Coverage, 19642,
     /* 197795 */   GIR_EraseRootFromParent_Done,
     /* 197796 */ // Label 4456: @197796
     /* 197796 */ GIM_Reject,
     /* 197797 */ // Label 4397: @197797
     /* 197797 */ GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(197846), // Rule ID 23058 //
     /* 197802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197813 */   // MIs[0] Operand 2
     /* 197813 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197824 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 197824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197829 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197845 */   // GIR_Coverage, 23058,
     /* 197845 */   GIR_EraseRootFromParent_Done,
     /* 197846 */ // Label 4457: @197846
     /* 197846 */ GIM_Reject,
     /* 197847 */ // Label 4398: @197847
     /* 197847 */ GIM_Reject,
     /* 197848 */ // Label 61: @197848
     /* 197848 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4470*/ GIMT_Encode4(199829),
     /* 197859 */ /*GILLT_v2s64*//*Label 4458*/ GIMT_Encode4(197927), GIMT_Encode4(0),
     /* 197867 */ /*GILLT_v4s32*//*Label 4459*/ GIMT_Encode4(198129),
     /* 197871 */ /*GILLT_v4s64*//*Label 4460*/ GIMT_Encode4(198331), GIMT_Encode4(0),
     /* 197879 */ /*GILLT_v8s16*//*Label 4461*/ GIMT_Encode4(198533),
     /* 197883 */ /*GILLT_v8s32*//*Label 4462*/ GIMT_Encode4(198648),
     /* 197887 */ /*GILLT_v8s64*//*Label 4463*/ GIMT_Encode4(198850), GIMT_Encode4(0),
     /* 197895 */ /*GILLT_v16s8*//*Label 4464*/ GIMT_Encode4(199052),
     /* 197899 */ /*GILLT_v16s16*//*Label 4465*/ GIMT_Encode4(199167),
     /* 197903 */ /*GILLT_v16s32*//*Label 4466*/ GIMT_Encode4(199282), GIMT_Encode4(0),
     /* 197911 */ /*GILLT_v32s8*//*Label 4467*/ GIMT_Encode4(199484),
     /* 197915 */ /*GILLT_v32s16*//*Label 4468*/ GIMT_Encode4(199599), GIMT_Encode4(0),
     /* 197923 */ /*GILLT_v64s8*//*Label 4469*/ GIMT_Encode4(199714),
     /* 197927 */ // Label 4458: @197927
     /* 197927 */ GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(198128),
     /* 197932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 197935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 197938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 197953 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(197986), // Rule ID 21696 //
     /* 197958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197965 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197971 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197975 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 197975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 197978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197980 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197984 */     GIR_RootConstrainSelectedInstOperands,
     /* 197985 */     // GIR_Coverage, 21696,
     /* 197985 */     GIR_EraseRootFromParent_Done,
     /* 197986 */   // Label 4472: @197986
     /* 197986 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(198019), // Rule ID 21732 //
     /* 197991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197998 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198004 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198008 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 198008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 198011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198013 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198017 */     GIR_RootConstrainSelectedInstOperands,
     /* 198018 */     // GIR_Coverage, 21732,
     /* 198018 */     GIR_EraseRootFromParent_Done,
     /* 198019 */   // Label 4473: @198019
     /* 198019 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(198048), // Rule ID 21695 //
     /* 198024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198037 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 198037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 198040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198042 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198046 */     GIR_RootConstrainSelectedInstOperands,
     /* 198047 */     // GIR_Coverage, 21695,
     /* 198047 */     GIR_EraseRootFromParent_Done,
     /* 198048 */   // Label 4474: @198048
     /* 198048 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(198077), // Rule ID 21731 //
     /* 198053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198066 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 198066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 198069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198071 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198073 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198075 */     GIR_RootConstrainSelectedInstOperands,
     /* 198076 */     // GIR_Coverage, 21731,
     /* 198076 */     GIR_EraseRootFromParent_Done,
     /* 198077 */   // Label 4475: @198077
     /* 198077 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(198102), // Rule ID 21697 //
     /* 198082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198089 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 198089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 198092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198094 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198096 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198100 */     GIR_RootConstrainSelectedInstOperands,
     /* 198101 */     // GIR_Coverage, 21697,
     /* 198101 */     GIR_EraseRootFromParent_Done,
     /* 198102 */   // Label 4476: @198102
     /* 198102 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(198127), // Rule ID 21733 //
     /* 198107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198114 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 198114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 198117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198119 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198121 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198123 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198125 */     GIR_RootConstrainSelectedInstOperands,
     /* 198126 */     // GIR_Coverage, 21733,
     /* 198126 */     GIR_EraseRootFromParent_Done,
     /* 198127 */   // Label 4477: @198127
     /* 198127 */   GIM_Reject,
     /* 198128 */ // Label 4471: @198128
     /* 198128 */ GIM_Reject,
     /* 198129 */ // Label 4459: @198129
     /* 198129 */ GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(198330),
     /* 198134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 198140 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 198155 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(198188), // Rule ID 21678 //
     /* 198160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198167 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198177 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 198177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 198180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198182 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198186 */     GIR_RootConstrainSelectedInstOperands,
     /* 198187 */     // GIR_Coverage, 21678,
     /* 198187 */     GIR_EraseRootFromParent_Done,
     /* 198188 */   // Label 4479: @198188
     /* 198188 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(198221), // Rule ID 21714 //
     /* 198193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198210 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 198210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 198213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198215 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198219 */     GIR_RootConstrainSelectedInstOperands,
     /* 198220 */     // GIR_Coverage, 21714,
     /* 198220 */     GIR_EraseRootFromParent_Done,
     /* 198221 */   // Label 4480: @198221
     /* 198221 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(198250), // Rule ID 21677 //
     /* 198226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198239 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 198239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 198242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198244 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198248 */     GIR_RootConstrainSelectedInstOperands,
     /* 198249 */     // GIR_Coverage, 21677,
     /* 198249 */     GIR_EraseRootFromParent_Done,
     /* 198250 */   // Label 4481: @198250
     /* 198250 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(198279), // Rule ID 21713 //
     /* 198255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198268 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 198268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 198271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198273 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198275 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198277 */     GIR_RootConstrainSelectedInstOperands,
     /* 198278 */     // GIR_Coverage, 21713,
     /* 198278 */     GIR_EraseRootFromParent_Done,
     /* 198279 */   // Label 4482: @198279
     /* 198279 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(198304), // Rule ID 21679 //
     /* 198284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198291 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 198291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 198294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198296 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198298 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198302 */     GIR_RootConstrainSelectedInstOperands,
     /* 198303 */     // GIR_Coverage, 21679,
     /* 198303 */     GIR_EraseRootFromParent_Done,
     /* 198304 */   // Label 4483: @198304
     /* 198304 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(198329), // Rule ID 21715 //
     /* 198309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198316 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 198316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 198319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198321 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198323 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198327 */     GIR_RootConstrainSelectedInstOperands,
     /* 198328 */     // GIR_Coverage, 21715,
     /* 198328 */     GIR_EraseRootFromParent_Done,
     /* 198329 */   // Label 4484: @198329
     /* 198329 */   GIM_Reject,
     /* 198330 */ // Label 4478: @198330
     /* 198330 */ GIM_Reject,
     /* 198331 */ // Label 4460: @198331
     /* 198331 */ GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(198532),
     /* 198336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 198339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 198342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 198345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 198357 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(198390), // Rule ID 21690 //
     /* 198362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198369 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198375 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198379 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 198379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 198382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198384 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198388 */     GIR_RootConstrainSelectedInstOperands,
     /* 198389 */     // GIR_Coverage, 21690,
     /* 198389 */     GIR_EraseRootFromParent_Done,
     /* 198390 */   // Label 4486: @198390
     /* 198390 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(198423), // Rule ID 21726 //
     /* 198395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198402 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198408 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198412 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 198412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 198415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198417 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198421 */     GIR_RootConstrainSelectedInstOperands,
     /* 198422 */     // GIR_Coverage, 21726,
     /* 198422 */     GIR_EraseRootFromParent_Done,
     /* 198423 */   // Label 4487: @198423
     /* 198423 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(198452), // Rule ID 21689 //
     /* 198428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198441 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 198441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 198444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198446 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198450 */     GIR_RootConstrainSelectedInstOperands,
     /* 198451 */     // GIR_Coverage, 21689,
     /* 198451 */     GIR_EraseRootFromParent_Done,
     /* 198452 */   // Label 4488: @198452
     /* 198452 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(198481), // Rule ID 21725 //
     /* 198457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198470 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 198470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 198473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198475 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198479 */     GIR_RootConstrainSelectedInstOperands,
     /* 198480 */     // GIR_Coverage, 21725,
     /* 198480 */     GIR_EraseRootFromParent_Done,
     /* 198481 */   // Label 4489: @198481
     /* 198481 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(198506), // Rule ID 21691 //
     /* 198486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198493 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 198493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 198496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198498 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198500 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198504 */     GIR_RootConstrainSelectedInstOperands,
     /* 198505 */     // GIR_Coverage, 21691,
     /* 198505 */     GIR_EraseRootFromParent_Done,
     /* 198506 */   // Label 4490: @198506
     /* 198506 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(198531), // Rule ID 21727 //
     /* 198511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198518 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 198518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 198521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198523 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198525 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198529 */     GIR_RootConstrainSelectedInstOperands,
     /* 198530 */     // GIR_Coverage, 21727,
     /* 198530 */     GIR_EraseRootFromParent_Done,
     /* 198531 */   // Label 4491: @198531
     /* 198531 */   GIM_Reject,
     /* 198532 */ // Label 4485: @198532
     /* 198532 */ GIM_Reject,
     /* 198533 */ // Label 4461: @198533
     /* 198533 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(198647),
     /* 198538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198559 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(198592), // Rule ID 22098 //
     /* 198564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198571 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198577 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198581 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 198581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 198584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198586 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198588 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198590 */     GIR_RootConstrainSelectedInstOperands,
     /* 198591 */     // GIR_Coverage, 22098,
     /* 198591 */     GIR_EraseRootFromParent_Done,
     /* 198592 */   // Label 4493: @198592
     /* 198592 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(198621), // Rule ID 22097 //
     /* 198597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198610 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 198610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 198613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198615 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198619 */     GIR_RootConstrainSelectedInstOperands,
     /* 198620 */     // GIR_Coverage, 22097,
     /* 198620 */     GIR_EraseRootFromParent_Done,
     /* 198621 */   // Label 4494: @198621
     /* 198621 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(198646), // Rule ID 22099 //
     /* 198626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198633 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 198633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 198636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198638 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198640 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198644 */     GIR_RootConstrainSelectedInstOperands,
     /* 198645 */     // GIR_Coverage, 22099,
     /* 198645 */     GIR_EraseRootFromParent_Done,
     /* 198646 */   // Label 4495: @198646
     /* 198646 */   GIM_Reject,
     /* 198647 */ // Label 4492: @198647
     /* 198647 */ GIM_Reject,
     /* 198648 */ // Label 4462: @198648
     /* 198648 */ GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(198849),
     /* 198653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 198656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 198662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198674 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(198707), // Rule ID 21672 //
     /* 198679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198686 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198692 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198696 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 198699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198701 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198705 */     GIR_RootConstrainSelectedInstOperands,
     /* 198706 */     // GIR_Coverage, 21672,
     /* 198706 */     GIR_EraseRootFromParent_Done,
     /* 198707 */   // Label 4497: @198707
     /* 198707 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(198740), // Rule ID 21708 //
     /* 198712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198719 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198725 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198729 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 198732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198734 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198738 */     GIR_RootConstrainSelectedInstOperands,
     /* 198739 */     // GIR_Coverage, 21708,
     /* 198739 */     GIR_EraseRootFromParent_Done,
     /* 198740 */   // Label 4498: @198740
     /* 198740 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(198769), // Rule ID 21671 //
     /* 198745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198758 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 198761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198763 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198767 */     GIR_RootConstrainSelectedInstOperands,
     /* 198768 */     // GIR_Coverage, 21671,
     /* 198768 */     GIR_EraseRootFromParent_Done,
     /* 198769 */   // Label 4499: @198769
     /* 198769 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(198798), // Rule ID 21707 //
     /* 198774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198787 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 198790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198792 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198796 */     GIR_RootConstrainSelectedInstOperands,
     /* 198797 */     // GIR_Coverage, 21707,
     /* 198797 */     GIR_EraseRootFromParent_Done,
     /* 198798 */   // Label 4500: @198798
     /* 198798 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(198823), // Rule ID 21673 //
     /* 198803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198810 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 198813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198815 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198817 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198821 */     GIR_RootConstrainSelectedInstOperands,
     /* 198822 */     // GIR_Coverage, 21673,
     /* 198822 */     GIR_EraseRootFromParent_Done,
     /* 198823 */   // Label 4501: @198823
     /* 198823 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(198848), // Rule ID 21709 //
     /* 198828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198835 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 198838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198840 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198842 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198846 */     GIR_RootConstrainSelectedInstOperands,
     /* 198847 */     // GIR_Coverage, 21709,
     /* 198847 */     GIR_EraseRootFromParent_Done,
     /* 198848 */   // Label 4502: @198848
     /* 198848 */   GIM_Reject,
     /* 198849 */ // Label 4496: @198849
     /* 198849 */ GIM_Reject,
     /* 198850 */ // Label 4463: @198850
     /* 198850 */ GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(199051),
     /* 198855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 198864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198876 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(198909), // Rule ID 21684 //
     /* 198881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198894 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198898 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 198898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 198901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198903 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198907 */     GIR_RootConstrainSelectedInstOperands,
     /* 198908 */     // GIR_Coverage, 21684,
     /* 198908 */     GIR_EraseRootFromParent_Done,
     /* 198909 */   // Label 4504: @198909
     /* 198909 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(198942), // Rule ID 21720 //
     /* 198914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198921 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198927 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198931 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 198931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 198934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198936 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198940 */     GIR_RootConstrainSelectedInstOperands,
     /* 198941 */     // GIR_Coverage, 21720,
     /* 198941 */     GIR_EraseRootFromParent_Done,
     /* 198942 */   // Label 4505: @198942
     /* 198942 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(198971), // Rule ID 21683 //
     /* 198947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198960 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 198960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 198963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198965 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198969 */     GIR_RootConstrainSelectedInstOperands,
     /* 198970 */     // GIR_Coverage, 21683,
     /* 198970 */     GIR_EraseRootFromParent_Done,
     /* 198971 */   // Label 4506: @198971
     /* 198971 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(199000), // Rule ID 21719 //
     /* 198976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198989 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 198989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 198992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198994 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198996 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198998 */     GIR_RootConstrainSelectedInstOperands,
     /* 198999 */     // GIR_Coverage, 21719,
     /* 198999 */     GIR_EraseRootFromParent_Done,
     /* 199000 */   // Label 4507: @199000
     /* 199000 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(199025), // Rule ID 21685 //
     /* 199005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199012 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 199012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 199015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199017 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199019 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199023 */     GIR_RootConstrainSelectedInstOperands,
     /* 199024 */     // GIR_Coverage, 21685,
     /* 199024 */     GIR_EraseRootFromParent_Done,
     /* 199025 */   // Label 4508: @199025
     /* 199025 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(199050), // Rule ID 21721 //
     /* 199030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199037 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 199037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 199040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199042 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199044 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199046 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199048 */     GIR_RootConstrainSelectedInstOperands,
     /* 199049 */     // GIR_Coverage, 21721,
     /* 199049 */     GIR_EraseRootFromParent_Done,
     /* 199050 */   // Label 4509: @199050
     /* 199050 */   GIM_Reject,
     /* 199051 */ // Label 4503: @199051
     /* 199051 */ GIM_Reject,
     /* 199052 */ // Label 4464: @199052
     /* 199052 */ GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(199166),
     /* 199057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 199060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 199063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 199066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 199078 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(199111), // Rule ID 22080 //
     /* 199083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199090 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199096 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199100 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 199100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 199103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199105 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199109 */     GIR_RootConstrainSelectedInstOperands,
     /* 199110 */     // GIR_Coverage, 22080,
     /* 199110 */     GIR_EraseRootFromParent_Done,
     /* 199111 */   // Label 4511: @199111
     /* 199111 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(199140), // Rule ID 22079 //
     /* 199116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199129 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 199129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 199132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199134 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199138 */     GIR_RootConstrainSelectedInstOperands,
     /* 199139 */     // GIR_Coverage, 22079,
     /* 199139 */     GIR_EraseRootFromParent_Done,
     /* 199140 */   // Label 4512: @199140
     /* 199140 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(199165), // Rule ID 22081 //
     /* 199145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199152 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 199152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 199155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199157 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199159 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199163 */     GIR_RootConstrainSelectedInstOperands,
     /* 199164 */     // GIR_Coverage, 22081,
     /* 199164 */     GIR_EraseRootFromParent_Done,
     /* 199165 */   // Label 4513: @199165
     /* 199165 */   GIM_Reject,
     /* 199166 */ // Label 4510: @199166
     /* 199166 */ GIM_Reject,
     /* 199167 */ // Label 4465: @199167
     /* 199167 */ GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(199281),
     /* 199172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 199175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 199178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 199181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 199193 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(199226), // Rule ID 22092 //
     /* 199198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199205 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199211 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199215 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 199215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 199218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199220 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199224 */     GIR_RootConstrainSelectedInstOperands,
     /* 199225 */     // GIR_Coverage, 22092,
     /* 199225 */     GIR_EraseRootFromParent_Done,
     /* 199226 */   // Label 4515: @199226
     /* 199226 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(199255), // Rule ID 22091 //
     /* 199231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199244 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 199244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 199247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199249 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199253 */     GIR_RootConstrainSelectedInstOperands,
     /* 199254 */     // GIR_Coverage, 22091,
     /* 199254 */     GIR_EraseRootFromParent_Done,
     /* 199255 */   // Label 4516: @199255
     /* 199255 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(199280), // Rule ID 22093 //
     /* 199260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199267 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 199267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 199270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199272 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199274 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199278 */     GIR_RootConstrainSelectedInstOperands,
     /* 199279 */     // GIR_Coverage, 22093,
     /* 199279 */     GIR_EraseRootFromParent_Done,
     /* 199280 */   // Label 4517: @199280
     /* 199280 */   GIM_Reject,
     /* 199281 */ // Label 4514: @199281
     /* 199281 */ GIM_Reject,
     /* 199282 */ // Label 4466: @199282
     /* 199282 */ GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(199483),
     /* 199287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 199293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 199296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 199308 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(199341), // Rule ID 21666 //
     /* 199313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199320 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199326 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199330 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 199330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 199333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199335 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199339 */     GIR_RootConstrainSelectedInstOperands,
     /* 199340 */     // GIR_Coverage, 21666,
     /* 199340 */     GIR_EraseRootFromParent_Done,
     /* 199341 */   // Label 4519: @199341
     /* 199341 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(199374), // Rule ID 21702 //
     /* 199346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199359 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199363 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 199363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 199366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199368 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199372 */     GIR_RootConstrainSelectedInstOperands,
     /* 199373 */     // GIR_Coverage, 21702,
     /* 199373 */     GIR_EraseRootFromParent_Done,
     /* 199374 */   // Label 4520: @199374
     /* 199374 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(199403), // Rule ID 21665 //
     /* 199379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199392 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 199392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 199395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199397 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199401 */     GIR_RootConstrainSelectedInstOperands,
     /* 199402 */     // GIR_Coverage, 21665,
     /* 199402 */     GIR_EraseRootFromParent_Done,
     /* 199403 */   // Label 4521: @199403
     /* 199403 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(199432), // Rule ID 21701 //
     /* 199408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199421 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 199421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 199424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199426 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199430 */     GIR_RootConstrainSelectedInstOperands,
     /* 199431 */     // GIR_Coverage, 21701,
     /* 199431 */     GIR_EraseRootFromParent_Done,
     /* 199432 */   // Label 4522: @199432
     /* 199432 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(199457), // Rule ID 21667 //
     /* 199437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199444 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 199444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 199447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199449 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199451 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199455 */     GIR_RootConstrainSelectedInstOperands,
     /* 199456 */     // GIR_Coverage, 21667,
     /* 199456 */     GIR_EraseRootFromParent_Done,
     /* 199457 */   // Label 4523: @199457
     /* 199457 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(199482), // Rule ID 21703 //
     /* 199462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199469 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 199469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 199472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199474 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199476 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199480 */     GIR_RootConstrainSelectedInstOperands,
     /* 199481 */     // GIR_Coverage, 21703,
     /* 199481 */     GIR_EraseRootFromParent_Done,
     /* 199482 */   // Label 4524: @199482
     /* 199482 */   GIM_Reject,
     /* 199483 */ // Label 4518: @199483
     /* 199483 */ GIM_Reject,
     /* 199484 */ // Label 4467: @199484
     /* 199484 */ GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(199598),
     /* 199489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 199492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 199495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 199498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 199510 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(199543), // Rule ID 22074 //
     /* 199515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199522 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199528 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199532 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 199532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 199535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199537 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199541 */     GIR_RootConstrainSelectedInstOperands,
     /* 199542 */     // GIR_Coverage, 22074,
     /* 199542 */     GIR_EraseRootFromParent_Done,
     /* 199543 */   // Label 4526: @199543
     /* 199543 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(199572), // Rule ID 22073 //
     /* 199548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199561 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 199561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 199564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199566 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199570 */     GIR_RootConstrainSelectedInstOperands,
     /* 199571 */     // GIR_Coverage, 22073,
     /* 199571 */     GIR_EraseRootFromParent_Done,
     /* 199572 */   // Label 4527: @199572
     /* 199572 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(199597), // Rule ID 22075 //
     /* 199577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199584 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 199584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 199587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199589 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199591 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199595 */     GIR_RootConstrainSelectedInstOperands,
     /* 199596 */     // GIR_Coverage, 22075,
     /* 199596 */     GIR_EraseRootFromParent_Done,
     /* 199597 */   // Label 4528: @199597
     /* 199597 */   GIM_Reject,
     /* 199598 */ // Label 4525: @199598
     /* 199598 */ GIM_Reject,
     /* 199599 */ // Label 4468: @199599
     /* 199599 */ GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(199713),
     /* 199604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 199607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 199610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 199613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 199625 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(199658), // Rule ID 22086 //
     /* 199630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199647 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 199650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199652 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199656 */     GIR_RootConstrainSelectedInstOperands,
     /* 199657 */     // GIR_Coverage, 22086,
     /* 199657 */     GIR_EraseRootFromParent_Done,
     /* 199658 */   // Label 4530: @199658
     /* 199658 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(199687), // Rule ID 22085 //
     /* 199663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199676 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 199679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199681 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199685 */     GIR_RootConstrainSelectedInstOperands,
     /* 199686 */     // GIR_Coverage, 22085,
     /* 199686 */     GIR_EraseRootFromParent_Done,
     /* 199687 */   // Label 4531: @199687
     /* 199687 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(199712), // Rule ID 22087 //
     /* 199692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199699 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 199702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199704 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199706 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199708 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199710 */     GIR_RootConstrainSelectedInstOperands,
     /* 199711 */     // GIR_Coverage, 22087,
     /* 199711 */     GIR_EraseRootFromParent_Done,
     /* 199712 */   // Label 4532: @199712
     /* 199712 */   GIM_Reject,
     /* 199713 */ // Label 4529: @199713
     /* 199713 */ GIM_Reject,
     /* 199714 */ // Label 4469: @199714
     /* 199714 */ GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(199828),
     /* 199719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 199722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 199725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 199728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 199740 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(199773), // Rule ID 22068 //
     /* 199745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199752 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199758 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199762 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 199765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199767 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199771 */     GIR_RootConstrainSelectedInstOperands,
     /* 199772 */     // GIR_Coverage, 22068,
     /* 199772 */     GIR_EraseRootFromParent_Done,
     /* 199773 */   // Label 4534: @199773
     /* 199773 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(199802), // Rule ID 22067 //
     /* 199778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199791 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 199794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199796 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199800 */     GIR_RootConstrainSelectedInstOperands,
     /* 199801 */     // GIR_Coverage, 22067,
     /* 199801 */     GIR_EraseRootFromParent_Done,
     /* 199802 */   // Label 4535: @199802
     /* 199802 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(199827), // Rule ID 22069 //
     /* 199807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199814 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 199817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199819 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199821 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199825 */     GIR_RootConstrainSelectedInstOperands,
     /* 199826 */     // GIR_Coverage, 22069,
     /* 199826 */     GIR_EraseRootFromParent_Done,
     /* 199827 */   // Label 4536: @199827
     /* 199827 */   GIM_Reject,
     /* 199828 */ // Label 4533: @199828
     /* 199828 */ GIM_Reject,
     /* 199829 */ // Label 4470: @199829
     /* 199829 */ GIM_Reject,
     /* 199830 */ // Label 62: @199830
     /* 199830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4540*/ GIMT_Encode4(200135),
     /* 199841 */ /*GILLT_s16*//*Label 4537*/ GIMT_Encode4(199853),
     /* 199845 */ /*GILLT_s32*//*Label 4538*/ GIMT_Encode4(199947),
     /* 199849 */ /*GILLT_s64*//*Label 4539*/ GIMT_Encode4(200041),
     /* 199853 */ // Label 4537: @199853
     /* 199853 */ GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(199946),
     /* 199858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 199861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199865 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(199920), // Rule ID 77 //
     /* 199870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199888 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 199892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199901 */     // (cttz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (TZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 199901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT16rm),
     /* 199904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 199910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199918 */     GIR_RootConstrainSelectedInstOperands,
     /* 199919 */     // GIR_Coverage, 77,
     /* 199919 */     GIR_EraseRootFromParent_Done,
     /* 199920 */   // Label 4542: @199920
     /* 199920 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(199945), // Rule ID 76 //
     /* 199925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199932 */     // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 199932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 199937 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 199943 */     GIR_RootConstrainSelectedInstOperands,
     /* 199944 */     // GIR_Coverage, 76,
     /* 199944 */     GIR_Done,
     /* 199945 */   // Label 4543: @199945
     /* 199945 */   GIM_Reject,
     /* 199946 */ // Label 4541: @199946
     /* 199946 */ GIM_Reject,
     /* 199947 */ // Label 4538: @199947
     /* 199947 */ GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(200040),
     /* 199952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 199955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 199959 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(200014), // Rule ID 79 //
     /* 199964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199982 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 199986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199995 */     // (cttz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (TZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 199995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT32rm),
     /* 199998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200012 */     GIR_RootConstrainSelectedInstOperands,
     /* 200013 */     // GIR_Coverage, 79,
     /* 200013 */     GIR_EraseRootFromParent_Done,
     /* 200014 */   // Label 4545: @200014
     /* 200014 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(200039), // Rule ID 78 //
     /* 200019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 200022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200026 */     // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 200026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 200031 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200037 */     GIR_RootConstrainSelectedInstOperands,
     /* 200038 */     // GIR_Coverage, 78,
     /* 200038 */     GIR_Done,
     /* 200039 */   // Label 4546: @200039
     /* 200039 */   GIM_Reject,
     /* 200040 */ // Label 4544: @200040
     /* 200040 */ GIM_Reject,
     /* 200041 */ // Label 4539: @200041
     /* 200041 */ GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(200134),
     /* 200046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 200049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200053 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(200108), // Rule ID 81 //
     /* 200058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 200061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200089 */     // (cttz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (TZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT64rm),
     /* 200092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200106 */     GIR_RootConstrainSelectedInstOperands,
     /* 200107 */     // GIR_Coverage, 81,
     /* 200107 */     GIR_EraseRootFromParent_Done,
     /* 200108 */   // Label 4548: @200108
     /* 200108 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(200133), // Rule ID 80 //
     /* 200113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 200116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200120 */     // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 200120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 200125 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200131 */     GIR_RootConstrainSelectedInstOperands,
     /* 200132 */     // GIR_Coverage, 80,
     /* 200132 */     GIR_Done,
     /* 200133 */   // Label 4549: @200133
     /* 200133 */   GIM_Reject,
     /* 200134 */ // Label 4547: @200134
     /* 200134 */ GIM_Reject,
     /* 200135 */ // Label 4540: @200135
     /* 200135 */ GIM_Reject,
     /* 200136 */ // Label 63: @200136
     /* 200136 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4553*/ GIMT_Encode4(200522),
     /* 200147 */ /*GILLT_s16*//*Label 4550*/ GIMT_Encode4(200159),
     /* 200151 */ /*GILLT_s32*//*Label 4551*/ GIMT_Encode4(200280),
     /* 200155 */ /*GILLT_s64*//*Label 4552*/ GIMT_Encode4(200401),
     /* 200159 */ // Label 4550: @200159
     /* 200159 */ GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(200279),
     /* 200164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 200167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200171 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(200240), // Rule ID 22985 //
     /* 200176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200191 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 200195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200204 */     // (cttz_zero_undef:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (BSF16rm:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), addr:{ *:[iPTR] }:$src)
     /* 200204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 200207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rm),
     /* 200221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 200230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200238 */     GIR_RootConstrainSelectedInstOperands,
     /* 200239 */     // GIR_Coverage, 22985,
     /* 200239 */     GIR_EraseRootFromParent_Done,
     /* 200240 */   // Label 4555: @200240
     /* 200240 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(200278), // Rule ID 22982 //
     /* 200245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200249 */     // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 200249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 200252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 200266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200276 */     GIR_RootConstrainSelectedInstOperands,
     /* 200277 */     // GIR_Coverage, 22982,
     /* 200277 */     GIR_EraseRootFromParent_Done,
     /* 200278 */   // Label 4556: @200278
     /* 200278 */   GIM_Reject,
     /* 200279 */ // Label 4554: @200279
     /* 200279 */ GIM_Reject,
     /* 200280 */ // Label 4551: @200280
     /* 200280 */ GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(200400),
     /* 200285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 200288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200292 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(200361), // Rule ID 22986 //
     /* 200297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200312 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 200316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200325 */     // (cttz_zero_undef:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (BSF32rm:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), addr:{ *:[iPTR] }:$src)
     /* 200325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rm),
     /* 200342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 200351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200359 */     GIR_RootConstrainSelectedInstOperands,
     /* 200360 */     // GIR_Coverage, 22986,
     /* 200360 */     GIR_EraseRootFromParent_Done,
     /* 200361 */   // Label 4558: @200361
     /* 200361 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(200399), // Rule ID 22983 //
     /* 200366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200370 */     // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 200370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 200387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200397 */     GIR_RootConstrainSelectedInstOperands,
     /* 200398 */     // GIR_Coverage, 22983,
     /* 200398 */     GIR_EraseRootFromParent_Done,
     /* 200399 */   // Label 4559: @200399
     /* 200399 */   GIM_Reject,
     /* 200400 */ // Label 4557: @200400
     /* 200400 */ GIM_Reject,
     /* 200401 */ // Label 4552: @200401
     /* 200401 */ GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(200521),
     /* 200406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 200409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200413 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(200482), // Rule ID 22987 //
     /* 200418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200446 */     // (cttz_zero_undef:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (BSF64rm:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), addr:{ *:[iPTR] }:$src)
     /* 200446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 200449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rm),
     /* 200463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 200472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200480 */     GIR_RootConstrainSelectedInstOperands,
     /* 200481 */     // GIR_Coverage, 22987,
     /* 200481 */     GIR_EraseRootFromParent_Done,
     /* 200482 */   // Label 4561: @200482
     /* 200482 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(200520), // Rule ID 22984 //
     /* 200487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200491 */     // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 200491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 200494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 200508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200518 */     GIR_RootConstrainSelectedInstOperands,
     /* 200519 */     // GIR_Coverage, 22984,
     /* 200519 */     GIR_EraseRootFromParent_Done,
     /* 200520 */   // Label 4562: @200520
     /* 200520 */   GIM_Reject,
     /* 200521 */ // Label 4560: @200521
     /* 200521 */ GIM_Reject,
     /* 200522 */ // Label 4553: @200522
     /* 200522 */ GIM_Reject,
     /* 200523 */ // Label 64: @200523
     /* 200523 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 4572*/ GIMT_Encode4(201826),
     /* 200534 */ /*GILLT_s16*//*Label 4563*/ GIMT_Encode4(200606),
     /* 200538 */ /*GILLT_s32*//*Label 4564*/ GIMT_Encode4(200700),
     /* 200542 */ /*GILLT_s64*//*Label 4565*/ GIMT_Encode4(200794), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 200558 */ /*GILLT_v2s64*//*Label 4566*/ GIMT_Encode4(200888), GIMT_Encode4(0),
     /* 200566 */ /*GILLT_v4s32*//*Label 4567*/ GIMT_Encode4(201084),
     /* 200570 */ /*GILLT_v4s64*//*Label 4568*/ GIMT_Encode4(201280), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 200582 */ /*GILLT_v8s32*//*Label 4569*/ GIMT_Encode4(201468),
     /* 200586 */ /*GILLT_v8s64*//*Label 4570*/ GIMT_Encode4(201656), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 200602 */ /*GILLT_v16s32*//*Label 4571*/ GIMT_Encode4(201741),
     /* 200606 */ // Label 4563: @200606
     /* 200606 */ GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(200699),
     /* 200611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 200614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200618 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(200673), // Rule ID 71 //
     /* 200623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200634 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200641 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 200645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200654 */     // (ctlz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (LZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT16rm),
     /* 200657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200671 */     GIR_RootConstrainSelectedInstOperands,
     /* 200672 */     // GIR_Coverage, 71,
     /* 200672 */     GIR_EraseRootFromParent_Done,
     /* 200673 */   // Label 4574: @200673
     /* 200673 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(200698), // Rule ID 70 //
     /* 200678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200685 */     // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 200685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 200690 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200696 */     GIR_RootConstrainSelectedInstOperands,
     /* 200697 */     // GIR_Coverage, 70,
     /* 200697 */     GIR_Done,
     /* 200698 */   // Label 4575: @200698
     /* 200698 */   GIM_Reject,
     /* 200699 */ // Label 4573: @200699
     /* 200699 */ GIM_Reject,
     /* 200700 */ // Label 4564: @200700
     /* 200700 */ GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(200793),
     /* 200705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 200708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200712 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(200767), // Rule ID 73 //
     /* 200717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200735 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 200739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200748 */     // (ctlz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (LZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT32rm),
     /* 200751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200765 */     GIR_RootConstrainSelectedInstOperands,
     /* 200766 */     // GIR_Coverage, 73,
     /* 200766 */     GIR_EraseRootFromParent_Done,
     /* 200767 */   // Label 4577: @200767
     /* 200767 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(200792), // Rule ID 72 //
     /* 200772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200779 */     // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 200779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 200784 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200790 */     GIR_RootConstrainSelectedInstOperands,
     /* 200791 */     // GIR_Coverage, 72,
     /* 200791 */     GIR_Done,
     /* 200792 */   // Label 4578: @200792
     /* 200792 */   GIM_Reject,
     /* 200793 */ // Label 4576: @200793
     /* 200793 */ GIM_Reject,
     /* 200794 */ // Label 4565: @200794
     /* 200794 */ GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(200887),
     /* 200799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 200802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200806 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(200861), // Rule ID 75 //
     /* 200811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200842 */     // (ctlz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT64rm),
     /* 200845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200859 */     GIR_RootConstrainSelectedInstOperands,
     /* 200860 */     // GIR_Coverage, 75,
     /* 200860 */     GIR_EraseRootFromParent_Done,
     /* 200861 */   // Label 4580: @200861
     /* 200861 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(200886), // Rule ID 74 //
     /* 200866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200873 */     // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 200873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 200878 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200884 */     GIR_RootConstrainSelectedInstOperands,
     /* 200885 */     // GIR_Coverage, 74,
     /* 200885 */     GIR_Done,
     /* 200886 */   // Label 4581: @200886
     /* 200886 */   GIM_Reject,
     /* 200887 */ // Label 4579: @200887
     /* 200887 */ GIM_Reject,
     /* 200888 */ // Label 4566: @200888
     /* 200888 */ GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(201083),
     /* 200893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200896 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(200952), // Rule ID 13357 //
     /* 200901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200916 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200923 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200936 */     // (ctlz:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 200936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rm),
     /* 200939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200950 */     GIR_RootConstrainSelectedInstOperands,
     /* 200951 */     // GIR_Coverage, 13357,
     /* 200951 */     GIR_EraseRootFromParent_Done,
     /* 200952 */   // Label 4583: @200952
     /* 200952 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(200975), // Rule ID 13354 //
     /* 200957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200968 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 200968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 200973 */     GIR_RootConstrainSelectedInstOperands,
     /* 200974 */     // GIR_Coverage, 13354,
     /* 200974 */     GIR_Done,
     /* 200975 */   // Label 4584: @200975
     /* 200975 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(201082), // Rule ID 21826 //
     /* 200980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 200983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200991 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 200991 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 200994 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200998 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201005 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 201008 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201012 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201017 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201020 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201024 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 201027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201032 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 201042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 201049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201064 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 201071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 201076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201081 */     // GIR_Coverage, 21826,
     /* 201081 */     GIR_EraseRootFromParent_Done,
     /* 201082 */   // Label 4585: @201082
     /* 201082 */   GIM_Reject,
     /* 201083 */ // Label 4582: @201083
     /* 201083 */ GIM_Reject,
     /* 201084 */ // Label 4567: @201084
     /* 201084 */ GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(201279),
     /* 201089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201092 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(201148), // Rule ID 13384 //
     /* 201097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201132 */     // (ctlz:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 201132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rm),
     /* 201135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201137 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201146 */     GIR_RootConstrainSelectedInstOperands,
     /* 201147 */     // GIR_Coverage, 13384,
     /* 201147 */     GIR_EraseRootFromParent_Done,
     /* 201148 */   // Label 4587: @201148
     /* 201148 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(201171), // Rule ID 13381 //
     /* 201153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201164 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 201164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 201169 */     GIR_RootConstrainSelectedInstOperands,
     /* 201170 */     // GIR_Coverage, 13381,
     /* 201170 */     GIR_Done,
     /* 201171 */   // Label 4588: @201171
     /* 201171 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(201278), // Rule ID 21828 //
     /* 201176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 201179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 201183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201187 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 201187 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 201190 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201194 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 201204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201213 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201216 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201220 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 201223 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 201238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 201245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201260 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 201267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 201272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201277 */     // GIR_Coverage, 21828,
     /* 201277 */     GIR_EraseRootFromParent_Done,
     /* 201278 */   // Label 4589: @201278
     /* 201278 */   GIM_Reject,
     /* 201279 */ // Label 4586: @201279
     /* 201279 */ GIM_Reject,
     /* 201280 */ // Label 4568: @201280
     /* 201280 */ GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(201467),
     /* 201285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 201288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201292 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(201344), // Rule ID 13348 //
     /* 201297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201328 */     // (ctlz:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 201328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rm),
     /* 201331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201342 */     GIR_RootConstrainSelectedInstOperands,
     /* 201343 */     // GIR_Coverage, 13348,
     /* 201343 */     GIR_EraseRootFromParent_Done,
     /* 201344 */   // Label 4591: @201344
     /* 201344 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(201363), // Rule ID 13345 //
     /* 201349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201356 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 201356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 201361 */     GIR_RootConstrainSelectedInstOperands,
     /* 201362 */     // GIR_Coverage, 13345,
     /* 201362 */     GIR_Done,
     /* 201363 */   // Label 4592: @201363
     /* 201363 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(201466), // Rule ID 21825 //
     /* 201368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 201371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201375 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 201375 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 201378 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201382 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201389 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 201392 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201396 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201401 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201404 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201408 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 201411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 201433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201448 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 201455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201465 */     // GIR_Coverage, 21825,
     /* 201465 */     GIR_EraseRootFromParent_Done,
     /* 201466 */   // Label 4593: @201466
     /* 201466 */   GIM_Reject,
     /* 201467 */ // Label 4590: @201467
     /* 201467 */ GIM_Reject,
     /* 201468 */ // Label 4569: @201468
     /* 201468 */ GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(201655),
     /* 201473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 201476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201480 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(201532), // Rule ID 13375 //
     /* 201485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201516 */     // (ctlz:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 201516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rm),
     /* 201519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201530 */     GIR_RootConstrainSelectedInstOperands,
     /* 201531 */     // GIR_Coverage, 13375,
     /* 201531 */     GIR_EraseRootFromParent_Done,
     /* 201532 */   // Label 4595: @201532
     /* 201532 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(201551), // Rule ID 13372 //
     /* 201537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201544 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 201544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 201549 */     GIR_RootConstrainSelectedInstOperands,
     /* 201550 */     // GIR_Coverage, 13372,
     /* 201550 */     GIR_Done,
     /* 201551 */   // Label 4596: @201551
     /* 201551 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(201654), // Rule ID 21827 //
     /* 201556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 201559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201563 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 201563 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 201566 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201570 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 201580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201589 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201592 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201596 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 201599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201609 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 201621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201636 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 201643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201653 */     // GIR_Coverage, 21827,
     /* 201653 */     GIR_EraseRootFromParent_Done,
     /* 201654 */   // Label 4597: @201654
     /* 201654 */   GIM_Reject,
     /* 201655 */ // Label 4594: @201655
     /* 201655 */ GIM_Reject,
     /* 201656 */ // Label 4570: @201656
     /* 201656 */ GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(201740),
     /* 201661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 201664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201668 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(201720), // Rule ID 13339 //
     /* 201673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201684 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201687 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201691 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201704 */     // (ctlz:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 201704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrm),
     /* 201707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201718 */     GIR_RootConstrainSelectedInstOperands,
     /* 201719 */     // GIR_Coverage, 13339,
     /* 201719 */     GIR_EraseRootFromParent_Done,
     /* 201720 */   // Label 4599: @201720
     /* 201720 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(201739), // Rule ID 13336 //
     /* 201725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201732 */     // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 201732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 201737 */     GIR_RootConstrainSelectedInstOperands,
     /* 201738 */     // GIR_Coverage, 13336,
     /* 201738 */     GIR_Done,
     /* 201739 */   // Label 4600: @201739
     /* 201739 */   GIM_Reject,
     /* 201740 */ // Label 4598: @201740
     /* 201740 */ GIM_Reject,
     /* 201741 */ // Label 4571: @201741
     /* 201741 */ GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(201825),
     /* 201746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 201749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201753 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(201805), // Rule ID 13366 //
     /* 201758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201789 */     // (ctlz:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 201789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrm),
     /* 201792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201803 */     GIR_RootConstrainSelectedInstOperands,
     /* 201804 */     // GIR_Coverage, 13366,
     /* 201804 */     GIR_EraseRootFromParent_Done,
     /* 201805 */   // Label 4602: @201805
     /* 201805 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(201824), // Rule ID 13363 //
     /* 201810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201817 */     // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 201817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 201822 */     GIR_RootConstrainSelectedInstOperands,
     /* 201823 */     // GIR_Coverage, 13363,
     /* 201823 */     GIR_Done,
     /* 201824 */   // Label 4603: @201824
     /* 201824 */   GIM_Reject,
     /* 201825 */ // Label 4601: @201825
     /* 201825 */ GIM_Reject,
     /* 201826 */ // Label 4572: @201826
     /* 201826 */ GIM_Reject,
     /* 201827 */ // Label 65: @201827
     /* 201827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 4619*/ GIMT_Encode4(204088),
     /* 201838 */ /*GILLT_s16*//*Label 4604*/ GIMT_Encode4(201930),
     /* 201842 */ /*GILLT_s32*//*Label 4605*/ GIMT_Encode4(202024),
     /* 201846 */ /*GILLT_s64*//*Label 4606*/ GIMT_Encode4(202118), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 201862 */ /*GILLT_v2s64*//*Label 4607*/ GIMT_Encode4(202212), GIMT_Encode4(0),
     /* 201870 */ /*GILLT_v4s32*//*Label 4608*/ GIMT_Encode4(202408),
     /* 201874 */ /*GILLT_v4s64*//*Label 4609*/ GIMT_Encode4(202604), GIMT_Encode4(0),
     /* 201882 */ /*GILLT_v8s16*//*Label 4610*/ GIMT_Encode4(202792),
     /* 201886 */ /*GILLT_v8s32*//*Label 4611*/ GIMT_Encode4(202988),
     /* 201890 */ /*GILLT_v8s64*//*Label 4612*/ GIMT_Encode4(203176), GIMT_Encode4(0),
     /* 201898 */ /*GILLT_v16s8*//*Label 4613*/ GIMT_Encode4(203261),
     /* 201902 */ /*GILLT_v16s16*//*Label 4614*/ GIMT_Encode4(203457),
     /* 201906 */ /*GILLT_v16s32*//*Label 4615*/ GIMT_Encode4(203645), GIMT_Encode4(0),
     /* 201914 */ /*GILLT_v32s8*//*Label 4616*/ GIMT_Encode4(203730),
     /* 201918 */ /*GILLT_v32s16*//*Label 4617*/ GIMT_Encode4(203918), GIMT_Encode4(0),
     /* 201926 */ /*GILLT_v64s8*//*Label 4618*/ GIMT_Encode4(204003),
     /* 201930 */ // Label 4604: @201930
     /* 201930 */ GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(202023),
     /* 201935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 201938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 201942 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(201997), // Rule ID 3176 //
     /* 201947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201965 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 201969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201978 */     // (ctpop:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (POPCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 201978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT16rm),
     /* 201981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 201990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201995 */     GIR_RootConstrainSelectedInstOperands,
     /* 201996 */     // GIR_Coverage, 3176,
     /* 201996 */     GIR_EraseRootFromParent_Done,
     /* 201997 */   // Label 4621: @201997
     /* 201997 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(202022), // Rule ID 3175 //
     /* 202002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 202009 */     // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 202009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 202014 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 202020 */     GIR_RootConstrainSelectedInstOperands,
     /* 202021 */     // GIR_Coverage, 3175,
     /* 202021 */     GIR_Done,
     /* 202022 */   // Label 4622: @202022
     /* 202022 */   GIM_Reject,
     /* 202023 */ // Label 4620: @202023
     /* 202023 */ GIM_Reject,
     /* 202024 */ // Label 4605: @202024
     /* 202024 */ GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(202117),
     /* 202029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 202032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 202036 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(202091), // Rule ID 3178 //
     /* 202041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202059 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 202063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202072 */     // (ctpop:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (POPCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 202072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT32rm),
     /* 202075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 202084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202089 */     GIR_RootConstrainSelectedInstOperands,
     /* 202090 */     // GIR_Coverage, 3178,
     /* 202090 */     GIR_EraseRootFromParent_Done,
     /* 202091 */   // Label 4624: @202091
     /* 202091 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(202116), // Rule ID 3177 //
     /* 202096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 202103 */     // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 202103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 202108 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 202114 */     GIR_RootConstrainSelectedInstOperands,
     /* 202115 */     // GIR_Coverage, 3177,
     /* 202115 */     GIR_Done,
     /* 202116 */   // Label 4625: @202116
     /* 202116 */   GIM_Reject,
     /* 202117 */ // Label 4623: @202117
     /* 202117 */ GIM_Reject,
     /* 202118 */ // Label 4606: @202118
     /* 202118 */ GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(202211),
     /* 202123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 202126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 202130 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(202185), // Rule ID 3180 //
     /* 202135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202166 */     // (ctpop:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (POPCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 202166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT64rm),
     /* 202169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 202178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202183 */     GIR_RootConstrainSelectedInstOperands,
     /* 202184 */     // GIR_Coverage, 3180,
     /* 202184 */     GIR_EraseRootFromParent_Done,
     /* 202185 */   // Label 4627: @202185
     /* 202185 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(202210), // Rule ID 3179 //
     /* 202190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 202197 */     // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 202197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 202202 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 202208 */     GIR_RootConstrainSelectedInstOperands,
     /* 202209 */     // GIR_Coverage, 3179,
     /* 202209 */     GIR_Done,
     /* 202210 */   // Label 4628: @202210
     /* 202210 */   GIM_Reject,
     /* 202211 */ // Label 4626: @202211
     /* 202211 */ GIM_Reject,
     /* 202212 */ // Label 4607: @202212
     /* 202212 */ GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(202407),
     /* 202217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202220 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(202276), // Rule ID 13465 //
     /* 202225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202260 */     // (ctpop:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 202260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rm),
     /* 202263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202274 */     GIR_RootConstrainSelectedInstOperands,
     /* 202275 */     // GIR_Coverage, 13465,
     /* 202275 */     GIR_EraseRootFromParent_Done,
     /* 202276 */   // Label 4630: @202276
     /* 202276 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(202299), // Rule ID 13462 //
     /* 202281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202292 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 202292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 202297 */     GIR_RootConstrainSelectedInstOperands,
     /* 202298 */     // GIR_Coverage, 13462,
     /* 202298 */     GIR_Done,
     /* 202299 */   // Label 4631: @202299
     /* 202299 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(202406), // Rule ID 21830 //
     /* 202304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202315 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202315 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 202318 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202322 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 202332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202341 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202344 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202348 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 202373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202388 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202405 */     // GIR_Coverage, 21830,
     /* 202405 */     GIR_EraseRootFromParent_Done,
     /* 202406 */   // Label 4632: @202406
     /* 202406 */   GIM_Reject,
     /* 202407 */ // Label 4629: @202407
     /* 202407 */ GIM_Reject,
     /* 202408 */ // Label 4608: @202408
     /* 202408 */ GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(202603),
     /* 202413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 202416 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(202472), // Rule ID 13492 //
     /* 202421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202456 */     // (ctpop:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 202456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rm),
     /* 202459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202470 */     GIR_RootConstrainSelectedInstOperands,
     /* 202471 */     // GIR_Coverage, 13492,
     /* 202471 */     GIR_EraseRootFromParent_Done,
     /* 202472 */   // Label 4634: @202472
     /* 202472 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(202495), // Rule ID 13489 //
     /* 202477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202488 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 202488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 202493 */     GIR_RootConstrainSelectedInstOperands,
     /* 202494 */     // GIR_Coverage, 13489,
     /* 202494 */     GIR_Done,
     /* 202495 */   // Label 4635: @202495
     /* 202495 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(202602), // Rule ID 21832 //
     /* 202500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202511 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202511 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 202514 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202518 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 202528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202537 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202540 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202544 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 202569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202584 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202601 */     // GIR_Coverage, 21832,
     /* 202601 */     GIR_EraseRootFromParent_Done,
     /* 202602 */   // Label 4636: @202602
     /* 202602 */   GIM_Reject,
     /* 202603 */ // Label 4633: @202603
     /* 202603 */ GIM_Reject,
     /* 202604 */ // Label 4609: @202604
     /* 202604 */ GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(202791),
     /* 202609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 202612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202616 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(202668), // Rule ID 13456 //
     /* 202621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202652 */     // (ctpop:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 202652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rm),
     /* 202655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202666 */     GIR_RootConstrainSelectedInstOperands,
     /* 202667 */     // GIR_Coverage, 13456,
     /* 202667 */     GIR_EraseRootFromParent_Done,
     /* 202668 */   // Label 4638: @202668
     /* 202668 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(202687), // Rule ID 13453 //
     /* 202673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202680 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 202680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 202685 */     GIR_RootConstrainSelectedInstOperands,
     /* 202686 */     // GIR_Coverage, 13453,
     /* 202686 */     GIR_Done,
     /* 202687 */   // Label 4639: @202687
     /* 202687 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(202790), // Rule ID 21829 //
     /* 202692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202699 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 202699 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 202702 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202706 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202713 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 202716 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202720 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202725 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202728 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202732 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 202735 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 202757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202772 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 202779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202789 */     // GIR_Coverage, 21829,
     /* 202789 */     GIR_EraseRootFromParent_Done,
     /* 202790 */   // Label 4640: @202790
     /* 202790 */   GIM_Reject,
     /* 202791 */ // Label 4637: @202791
     /* 202791 */ GIM_Reject,
     /* 202792 */ // Label 4610: @202792
     /* 202792 */ GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(202987),
     /* 202797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202800 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(202856), // Rule ID 14519 //
     /* 202805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202840 */     // (ctpop:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 202840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rm),
     /* 202843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202854 */     GIR_RootConstrainSelectedInstOperands,
     /* 202855 */     // GIR_Coverage, 14519,
     /* 202855 */     GIR_EraseRootFromParent_Done,
     /* 202856 */   // Label 4642: @202856
     /* 202856 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(202879), // Rule ID 14516 //
     /* 202861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202872 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 202872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 202877 */     GIR_RootConstrainSelectedInstOperands,
     /* 202878 */     // GIR_Coverage, 14516,
     /* 202878 */     GIR_Done,
     /* 202879 */   // Label 4643: @202879
     /* 202879 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(202986), // Rule ID 22139 //
     /* 202884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 202887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202895 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202895 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 202898 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202902 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202909 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 202912 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202916 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202921 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202928 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202931 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202936 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 202953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202968 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202985 */     // GIR_Coverage, 22139,
     /* 202985 */     GIR_EraseRootFromParent_Done,
     /* 202986 */   // Label 4644: @202986
     /* 202986 */   GIM_Reject,
     /* 202987 */ // Label 4641: @202987
     /* 202987 */ GIM_Reject,
     /* 202988 */ // Label 4611: @202988
     /* 202988 */ GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(203175),
     /* 202993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 202996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203000 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(203052), // Rule ID 13483 //
     /* 203005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 203008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203036 */     // (ctpop:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 203036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rm),
     /* 203039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203050 */     GIR_RootConstrainSelectedInstOperands,
     /* 203051 */     // GIR_Coverage, 13483,
     /* 203051 */     GIR_EraseRootFromParent_Done,
     /* 203052 */   // Label 4646: @203052
     /* 203052 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(203071), // Rule ID 13480 //
     /* 203057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 203060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203064 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 203064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 203069 */     GIR_RootConstrainSelectedInstOperands,
     /* 203070 */     // GIR_Coverage, 13480,
     /* 203070 */     GIR_Done,
     /* 203071 */   // Label 4647: @203071
     /* 203071 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(203174), // Rule ID 21831 //
     /* 203076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 203079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203083 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 203083 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 203086 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203090 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203097 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 203100 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203104 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203109 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203112 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203116 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 203119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203129 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 203141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203146 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203156 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 203163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203173 */     // GIR_Coverage, 21831,
     /* 203173 */     GIR_EraseRootFromParent_Done,
     /* 203174 */   // Label 4648: @203174
     /* 203174 */   GIM_Reject,
     /* 203175 */ // Label 4645: @203175
     /* 203175 */ GIM_Reject,
     /* 203176 */ // Label 4612: @203176
     /* 203176 */ GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(203260),
     /* 203181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 203184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203188 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(203240), // Rule ID 13447 //
     /* 203193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203224 */     // (ctpop:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 203224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrm),
     /* 203227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203238 */     GIR_RootConstrainSelectedInstOperands,
     /* 203239 */     // GIR_Coverage, 13447,
     /* 203239 */     GIR_EraseRootFromParent_Done,
     /* 203240 */   // Label 4650: @203240
     /* 203240 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(203259), // Rule ID 13444 //
     /* 203245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203252 */     // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 203252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 203257 */     GIR_RootConstrainSelectedInstOperands,
     /* 203258 */     // GIR_Coverage, 13444,
     /* 203258 */     GIR_Done,
     /* 203259 */   // Label 4651: @203259
     /* 203259 */   GIM_Reject,
     /* 203260 */ // Label 4649: @203260
     /* 203260 */ GIM_Reject,
     /* 203261 */ // Label 4613: @203261
     /* 203261 */ GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(203456),
     /* 203266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 203269 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(203325), // Rule ID 14501 //
     /* 203274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203289 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203296 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203309 */     // (ctpop:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 203309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rm),
     /* 203312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203323 */     GIR_RootConstrainSelectedInstOperands,
     /* 203324 */     // GIR_Coverage, 14501,
     /* 203324 */     GIR_EraseRootFromParent_Done,
     /* 203325 */   // Label 4653: @203325
     /* 203325 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(203348), // Rule ID 14498 //
     /* 203330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203341 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 203341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 203346 */     GIR_RootConstrainSelectedInstOperands,
     /* 203347 */     // GIR_Coverage, 14498,
     /* 203347 */     GIR_Done,
     /* 203348 */   // Label 4654: @203348
     /* 203348 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(203455), // Rule ID 22137 //
     /* 203353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 203360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203364 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 203364 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 203367 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203371 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 203381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203390 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 203400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 203415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 203422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203437 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 203444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 203449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203454 */     // GIR_Coverage, 22137,
     /* 203454 */     GIR_EraseRootFromParent_Done,
     /* 203455 */   // Label 4655: @203455
     /* 203455 */   GIM_Reject,
     /* 203456 */ // Label 4652: @203456
     /* 203456 */ GIM_Reject,
     /* 203457 */ // Label 4614: @203457
     /* 203457 */ GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(203644),
     /* 203462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 203465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203469 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(203521), // Rule ID 14513 //
     /* 203474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203505 */     // (ctpop:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 203505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rm),
     /* 203508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203519 */     GIR_RootConstrainSelectedInstOperands,
     /* 203520 */     // GIR_Coverage, 14513,
     /* 203520 */     GIR_EraseRootFromParent_Done,
     /* 203521 */   // Label 4657: @203521
     /* 203521 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(203540), // Rule ID 14510 //
     /* 203526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203533 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 203533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 203538 */     GIR_RootConstrainSelectedInstOperands,
     /* 203539 */     // GIR_Coverage, 14510,
     /* 203539 */     GIR_Done,
     /* 203540 */   // Label 4658: @203540
     /* 203540 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(203643), // Rule ID 22138 //
     /* 203545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 203548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203552 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 203552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 203555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 203569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 203588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 203610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203625 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 203632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203642 */     // GIR_Coverage, 22138,
     /* 203642 */     GIR_EraseRootFromParent_Done,
     /* 203643 */   // Label 4659: @203643
     /* 203643 */   GIM_Reject,
     /* 203644 */ // Label 4656: @203644
     /* 203644 */ GIM_Reject,
     /* 203645 */ // Label 4615: @203645
     /* 203645 */ GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(203729),
     /* 203650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 203653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203657 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(203709), // Rule ID 13474 //
     /* 203662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203673 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203676 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203693 */     // (ctpop:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 203693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrm),
     /* 203696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203707 */     GIR_RootConstrainSelectedInstOperands,
     /* 203708 */     // GIR_Coverage, 13474,
     /* 203708 */     GIR_EraseRootFromParent_Done,
     /* 203709 */   // Label 4661: @203709
     /* 203709 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(203728), // Rule ID 13471 //
     /* 203714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203721 */     // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 203721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 203726 */     GIR_RootConstrainSelectedInstOperands,
     /* 203727 */     // GIR_Coverage, 13471,
     /* 203727 */     GIR_Done,
     /* 203728 */   // Label 4662: @203728
     /* 203728 */   GIM_Reject,
     /* 203729 */ // Label 4660: @203729
     /* 203729 */ GIM_Reject,
     /* 203730 */ // Label 4616: @203730
     /* 203730 */ GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(203917),
     /* 203735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 203738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203742 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(203794), // Rule ID 14495 //
     /* 203747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203778 */     // (ctpop:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 203778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rm),
     /* 203781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203792 */     GIR_RootConstrainSelectedInstOperands,
     /* 203793 */     // GIR_Coverage, 14495,
     /* 203793 */     GIR_EraseRootFromParent_Done,
     /* 203794 */   // Label 4664: @203794
     /* 203794 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(203813), // Rule ID 14492 //
     /* 203799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203806 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 203806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 203811 */     GIR_RootConstrainSelectedInstOperands,
     /* 203812 */     // GIR_Coverage, 14492,
     /* 203812 */     GIR_Done,
     /* 203813 */   // Label 4665: @203813
     /* 203813 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(203916), // Rule ID 22136 //
     /* 203818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 203821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203825 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 203825 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 203828 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203832 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 203842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203851 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203854 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203858 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 203861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203871 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 203883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203888 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203898 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 203905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203915 */     // GIR_Coverage, 22136,
     /* 203915 */     GIR_EraseRootFromParent_Done,
     /* 203916 */   // Label 4666: @203916
     /* 203916 */   GIM_Reject,
     /* 203917 */ // Label 4663: @203917
     /* 203917 */ GIM_Reject,
     /* 203918 */ // Label 4617: @203918
     /* 203918 */ GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(204002),
     /* 203923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 203926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203930 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(203982), // Rule ID 14507 //
     /* 203935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203966 */     // (ctpop:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 203966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrm),
     /* 203969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203980 */     GIR_RootConstrainSelectedInstOperands,
     /* 203981 */     // GIR_Coverage, 14507,
     /* 203981 */     GIR_EraseRootFromParent_Done,
     /* 203982 */   // Label 4668: @203982
     /* 203982 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(204001), // Rule ID 14504 //
     /* 203987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203994 */     // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 203994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 203999 */     GIR_RootConstrainSelectedInstOperands,
     /* 204000 */     // GIR_Coverage, 14504,
     /* 204000 */     GIR_Done,
     /* 204001 */   // Label 4669: @204001
     /* 204001 */   GIM_Reject,
     /* 204002 */ // Label 4667: @204002
     /* 204002 */ GIM_Reject,
     /* 204003 */ // Label 4618: @204003
     /* 204003 */ GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(204087),
     /* 204008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 204011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204015 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(204067), // Rule ID 14489 //
     /* 204020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 204023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204038 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204051 */     // (ctpop:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 204051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrm),
     /* 204054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204065 */     GIR_RootConstrainSelectedInstOperands,
     /* 204066 */     // GIR_Coverage, 14489,
     /* 204066 */     GIR_EraseRootFromParent_Done,
     /* 204067 */   // Label 4671: @204067
     /* 204067 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(204086), // Rule ID 14486 //
     /* 204072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 204075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204079 */     // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 204079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 204084 */     GIR_RootConstrainSelectedInstOperands,
     /* 204085 */     // GIR_Coverage, 14486,
     /* 204085 */     GIR_Done,
     /* 204086 */   // Label 4672: @204086
     /* 204086 */   GIM_Reject,
     /* 204087 */ // Label 4670: @204087
     /* 204087 */ GIM_Reject,
     /* 204088 */ // Label 4619: @204088
     /* 204088 */ GIM_Reject,
     /* 204089 */ // Label 66: @204089
     /* 204089 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4676*/ GIMT_Encode4(204588),
     /* 204100 */ /*GILLT_s16*//*Label 4673*/ GIMT_Encode4(204112),
     /* 204104 */ /*GILLT_s32*//*Label 4674*/ GIMT_Encode4(204276),
     /* 204108 */ /*GILLT_s64*//*Label 4675*/ GIMT_Encode4(204432),
     /* 204112 */ // Label 4673: @204112
     /* 204112 */ GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(204275),
     /* 204117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 204120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 204124 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(204176), // Rule ID 49 //
     /* 204129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 204132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204147 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 204151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204160 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 204160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm),
     /* 204163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204174 */     GIR_RootConstrainSelectedInstOperands,
     /* 204175 */     // GIR_Coverage, 49,
     /* 204175 */     GIR_EraseRootFromParent_Done,
     /* 204176 */   // Label 4678: @204176
     /* 204176 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(204228), // Rule ID 55 //
     /* 204181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 204184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204199 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 204203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204212 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 204212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm_EVEX),
     /* 204215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204226 */     GIR_RootConstrainSelectedInstOperands,
     /* 204227 */     // GIR_Coverage, 55,
     /* 204227 */     GIR_EraseRootFromParent_Done,
     /* 204228 */   // Label 4679: @204228
     /* 204228 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(204247), // Rule ID 61 //
     /* 204233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 204236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 204240 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 204240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 204245 */     GIR_RootConstrainSelectedInstOperands,
     /* 204246 */     // GIR_Coverage, 61,
     /* 204246 */     GIR_Done,
     /* 204247 */   // Label 4680: @204247
     /* 204247 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(204274), // Rule ID 22988 //
     /* 204252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 204255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 204259 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 204259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 204262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 204269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204272 */     GIR_RootConstrainSelectedInstOperands,
     /* 204273 */     // GIR_Coverage, 22988,
     /* 204273 */     GIR_EraseRootFromParent_Done,
     /* 204274 */   // Label 4681: @204274
     /* 204274 */   GIM_Reject,
     /* 204275 */ // Label 4677: @204275
     /* 204275 */ GIM_Reject,
     /* 204276 */ // Label 4674: @204276
     /* 204276 */ GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(204431),
     /* 204281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 204284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204288 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(204340), // Rule ID 51 //
     /* 204293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 204296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204304 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204311 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 204315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204324 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm),
     /* 204327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204338 */     GIR_RootConstrainSelectedInstOperands,
     /* 204339 */     // GIR_Coverage, 51,
     /* 204339 */     GIR_EraseRootFromParent_Done,
     /* 204340 */   // Label 4683: @204340
     /* 204340 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(204392), // Rule ID 57 //
     /* 204345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 204348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204359 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204363 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 204367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204376 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm_EVEX),
     /* 204379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204390 */     GIR_RootConstrainSelectedInstOperands,
     /* 204391 */     // GIR_Coverage, 57,
     /* 204391 */     GIR_EraseRootFromParent_Done,
     /* 204392 */   // Label 4684: @204392
     /* 204392 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(204411), // Rule ID 5 //
     /* 204397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 204400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204404 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 204404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 204409 */     GIR_RootConstrainSelectedInstOperands,
     /* 204410 */     // GIR_Coverage, 5,
     /* 204410 */     GIR_Done,
     /* 204411 */   // Label 4685: @204411
     /* 204411 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(204430), // Rule ID 62 //
     /* 204416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 204419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204423 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 204423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 204428 */     GIR_RootConstrainSelectedInstOperands,
     /* 204429 */     // GIR_Coverage, 62,
     /* 204429 */     GIR_Done,
     /* 204430 */   // Label 4686: @204430
     /* 204430 */   GIM_Reject,
     /* 204431 */ // Label 4682: @204431
     /* 204431 */ GIM_Reject,
     /* 204432 */ // Label 4675: @204432
     /* 204432 */ GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(204587),
     /* 204437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 204440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204444 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(204496), // Rule ID 53 //
     /* 204449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 204452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204480 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 204480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm),
     /* 204483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204494 */     GIR_RootConstrainSelectedInstOperands,
     /* 204495 */     // GIR_Coverage, 53,
     /* 204495 */     GIR_EraseRootFromParent_Done,
     /* 204496 */   // Label 4688: @204496
     /* 204496 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(204548), // Rule ID 59 //
     /* 204501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 204504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204532 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 204532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm_EVEX),
     /* 204535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204546 */     GIR_RootConstrainSelectedInstOperands,
     /* 204547 */     // GIR_Coverage, 59,
     /* 204547 */     GIR_EraseRootFromParent_Done,
     /* 204548 */   // Label 4689: @204548
     /* 204548 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(204567), // Rule ID 6 //
     /* 204553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 204556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204560 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 204560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 204565 */     GIR_RootConstrainSelectedInstOperands,
     /* 204566 */     // GIR_Coverage, 6,
     /* 204566 */     GIR_Done,
     /* 204567 */   // Label 4690: @204567
     /* 204567 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(204586), // Rule ID 63 //
     /* 204572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 204575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204579 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 204579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 204584 */     GIR_RootConstrainSelectedInstOperands,
     /* 204585 */     // GIR_Coverage, 63,
     /* 204585 */     GIR_Done,
     /* 204586 */   // Label 4691: @204586
     /* 204586 */   GIM_Reject,
     /* 204587 */ // Label 4687: @204587
     /* 204587 */ GIM_Reject,
     /* 204588 */ // Label 4676: @204588
     /* 204588 */ GIM_Reject,
     /* 204589 */ // Label 67: @204589
     /* 204589 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4705*/ GIMT_Encode4(206757),
     /* 204600 */ /*GILLT_s16*//*Label 4692*/ GIMT_Encode4(204684),
     /* 204604 */ /*GILLT_s32*//*Label 4693*/ GIMT_Encode4(204805),
     /* 204608 */ /*GILLT_s64*//*Label 4694*/ GIMT_Encode4(205161),
     /* 204612 */ /*GILLT_s80*//*Label 4695*/ GIMT_Encode4(205517), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204624 */ /*GILLT_v2s64*//*Label 4696*/ GIMT_Encode4(205554), GIMT_Encode4(0),
     /* 204632 */ /*GILLT_v4s32*//*Label 4697*/ GIMT_Encode4(205757),
     /* 204636 */ /*GILLT_v4s64*//*Label 4698*/ GIMT_Encode4(205960), GIMT_Encode4(0),
     /* 204644 */ /*GILLT_v8s16*//*Label 4699*/ GIMT_Encode4(206136),
     /* 204648 */ /*GILLT_v8s32*//*Label 4700*/ GIMT_Encode4(206225),
     /* 204652 */ /*GILLT_v8s64*//*Label 4701*/ GIMT_Encode4(206401), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204664 */ /*GILLT_v16s16*//*Label 4702*/ GIMT_Encode4(206490),
     /* 204668 */ /*GILLT_v16s32*//*Label 4703*/ GIMT_Encode4(206579), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204680 */ /*GILLT_v32s16*//*Label 4704*/ GIMT_Encode4(206668),
     /* 204684 */ // Label 4692: @204684
     /* 204684 */ GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(204804),
     /* 204689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 204692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204696 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(204765), // Rule ID 21421 //
     /* 204701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 204704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204732 */     // (fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 204732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 204735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 204749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204763 */     GIR_RootConstrainSelectedInstOperands,
     /* 204764 */     // GIR_Coverage, 21421,
     /* 204764 */     GIR_EraseRootFromParent_Done,
     /* 204765 */   // Label 4707: @204765
     /* 204765 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(204803), // Rule ID 21419 //
     /* 204770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 204773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204777 */     // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 204777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 204780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 204794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204801 */     GIR_RootConstrainSelectedInstOperands,
     /* 204802 */     // GIR_Coverage, 21419,
     /* 204802 */     GIR_EraseRootFromParent_Done,
     /* 204803 */   // Label 4708: @204803
     /* 204803 */   GIM_Reject,
     /* 204804 */ // Label 4706: @204804
     /* 204804 */ GIM_Reject,
     /* 204805 */ // Label 4693: @204805
     /* 204805 */ GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(205160),
     /* 204810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 204813 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(204869), // Rule ID 2449 //
     /* 204818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 204821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204853 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 204853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 204856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204867 */     GIR_RootConstrainSelectedInstOperands,
     /* 204868 */     // GIR_Coverage, 2449,
     /* 204868 */     GIR_EraseRootFromParent_Done,
     /* 204869 */   // Label 4710: @204869
     /* 204869 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(204942), // Rule ID 18277 //
     /* 204874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 204877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204909 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 204909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 204926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204940 */     GIR_RootConstrainSelectedInstOperands,
     /* 204941 */     // GIR_Coverage, 18277,
     /* 204941 */     GIR_EraseRootFromParent_Done,
     /* 204942 */   // Label 4711: @204942
     /* 204942 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(205015), // Rule ID 21425 //
     /* 204947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 204950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 204954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204982 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 204982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 204999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205013 */     GIR_RootConstrainSelectedInstOperands,
     /* 205014 */     // GIR_Coverage, 21425,
     /* 205014 */     GIR_EraseRootFromParent_Done,
     /* 205015 */   // Label 4712: @205015
     /* 205015 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(205048), // Rule ID 1049 //
     /* 205020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 205023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 205027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 205031 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 205031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 205036 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 205042 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 205046 */     GIR_RootConstrainSelectedInstOperands,
     /* 205047 */     // GIR_Coverage, 1049,
     /* 205047 */     GIR_Done,
     /* 205048 */   // Label 4713: @205048
     /* 205048 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(205075), // Rule ID 2447 //
     /* 205053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 205056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205064 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 205064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 205069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205073 */     GIR_RootConstrainSelectedInstOperands,
     /* 205074 */     // GIR_Coverage, 2447,
     /* 205074 */     GIR_Done,
     /* 205075 */   // Label 4714: @205075
     /* 205075 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(205117), // Rule ID 18275 //
     /* 205080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 205083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205091 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 205091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 205094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 205108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205115 */     GIR_RootConstrainSelectedInstOperands,
     /* 205116 */     // GIR_Coverage, 18275,
     /* 205116 */     GIR_EraseRootFromParent_Done,
     /* 205117 */   // Label 4715: @205117
     /* 205117 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(205159), // Rule ID 21423 //
     /* 205122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 205129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 205133 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 205133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 205136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 205150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205157 */     GIR_RootConstrainSelectedInstOperands,
     /* 205158 */     // GIR_Coverage, 21423,
     /* 205158 */     GIR_EraseRootFromParent_Done,
     /* 205159 */   // Label 4716: @205159
     /* 205159 */   GIM_Reject,
     /* 205160 */ // Label 4709: @205160
     /* 205160 */ GIM_Reject,
     /* 205161 */ // Label 4694: @205161
     /* 205161 */ GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(205516),
     /* 205166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 205169 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(205225), // Rule ID 2465 //
     /* 205174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 205177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205209 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 205209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 205212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205223 */     GIR_RootConstrainSelectedInstOperands,
     /* 205224 */     // GIR_Coverage, 2465,
     /* 205224 */     GIR_EraseRootFromParent_Done,
     /* 205225 */   // Label 4718: @205225
     /* 205225 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(205298), // Rule ID 18281 //
     /* 205230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 205233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205265 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 205265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 205282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205296 */     GIR_RootConstrainSelectedInstOperands,
     /* 205297 */     // GIR_Coverage, 18281,
     /* 205297 */     GIR_EraseRootFromParent_Done,
     /* 205298 */   // Label 4719: @205298
     /* 205298 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(205371), // Rule ID 21429 //
     /* 205303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 205306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 205310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205338 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 205338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 205355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205369 */     GIR_RootConstrainSelectedInstOperands,
     /* 205370 */     // GIR_Coverage, 21429,
     /* 205370 */     GIR_EraseRootFromParent_Done,
     /* 205371 */   // Label 4720: @205371
     /* 205371 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(205404), // Rule ID 1051 //
     /* 205376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 205379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 205383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 205387 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 205387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 205392 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 205398 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 205402 */     GIR_RootConstrainSelectedInstOperands,
     /* 205403 */     // GIR_Coverage, 1051,
     /* 205403 */     GIR_Done,
     /* 205404 */   // Label 4721: @205404
     /* 205404 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(205431), // Rule ID 2463 //
     /* 205409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 205412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205420 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 205420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 205425 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205429 */     GIR_RootConstrainSelectedInstOperands,
     /* 205430 */     // GIR_Coverage, 2463,
     /* 205430 */     GIR_Done,
     /* 205431 */   // Label 4722: @205431
     /* 205431 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(205473), // Rule ID 18279 //
     /* 205436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 205439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205447 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 205447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 205464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205471 */     GIR_RootConstrainSelectedInstOperands,
     /* 205472 */     // GIR_Coverage, 18279,
     /* 205472 */     GIR_EraseRootFromParent_Done,
     /* 205473 */   // Label 4723: @205473
     /* 205473 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(205515), // Rule ID 21427 //
     /* 205478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 205485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 205489 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 205489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 205506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205513 */     GIR_RootConstrainSelectedInstOperands,
     /* 205514 */     // GIR_Coverage, 21427,
     /* 205514 */     GIR_EraseRootFromParent_Done,
     /* 205515 */   // Label 4724: @205515
     /* 205515 */   GIM_Reject,
     /* 205516 */ // Label 4717: @205516
     /* 205516 */ GIM_Reject,
     /* 205517 */ // Label 4695: @205517
     /* 205517 */ GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(205553), // Rule ID 1053 //
     /* 205522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 205525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 205528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 205532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 205536 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 205536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 205541 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 205547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 205551 */   GIR_RootConstrainSelectedInstOperands,
     /* 205552 */   // GIR_Coverage, 1053,
     /* 205552 */   GIR_Done,
     /* 205553 */ // Label 4725: @205553
     /* 205553 */ GIM_Reject,
     /* 205554 */ // Label 4696: @205554
     /* 205554 */ GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(205756),
     /* 205559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 205562 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(205618), // Rule ID 2469 //
     /* 205567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205602 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 205602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 205605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205616 */     GIR_RootConstrainSelectedInstOperands,
     /* 205617 */     // GIR_Coverage, 2469,
     /* 205617 */     GIR_EraseRootFromParent_Done,
     /* 205618 */   // Label 4727: @205618
     /* 205618 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(205674), // Rule ID 12087 //
     /* 205623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205658 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 205658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 205661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205672 */     GIR_RootConstrainSelectedInstOperands,
     /* 205673 */     // GIR_Coverage, 12087,
     /* 205673 */     GIR_EraseRootFromParent_Done,
     /* 205674 */   // Label 4728: @205674
     /* 205674 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(205701), // Rule ID 2467 //
     /* 205679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205690 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 205690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 205695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205699 */     GIR_RootConstrainSelectedInstOperands,
     /* 205700 */     // GIR_Coverage, 2467,
     /* 205700 */     GIR_Done,
     /* 205701 */   // Label 4729: @205701
     /* 205701 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(205728), // Rule ID 2475 //
     /* 205706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 205709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205717 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 205717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 205722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205726 */     GIR_RootConstrainSelectedInstOperands,
     /* 205727 */     // GIR_Coverage, 2475,
     /* 205727 */     GIR_Done,
     /* 205728 */   // Label 4730: @205728
     /* 205728 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(205755), // Rule ID 12083 //
     /* 205733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205744 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 205744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 205749 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205753 */     GIR_RootConstrainSelectedInstOperands,
     /* 205754 */     // GIR_Coverage, 12083,
     /* 205754 */     GIR_Done,
     /* 205755 */   // Label 4731: @205755
     /* 205755 */   GIM_Reject,
     /* 205756 */ // Label 4726: @205756
     /* 205756 */ GIM_Reject,
     /* 205757 */ // Label 4697: @205757
     /* 205757 */ GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(205959),
     /* 205762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205765 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(205821), // Rule ID 2453 //
     /* 205770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205805 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 205805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 205808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205819 */     GIR_RootConstrainSelectedInstOperands,
     /* 205820 */     // GIR_Coverage, 2453,
     /* 205820 */     GIR_EraseRootFromParent_Done,
     /* 205821 */   // Label 4733: @205821
     /* 205821 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(205877), // Rule ID 12063 //
     /* 205826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205861 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 205861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 205864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205875 */     GIR_RootConstrainSelectedInstOperands,
     /* 205876 */     // GIR_Coverage, 12063,
     /* 205876 */     GIR_EraseRootFromParent_Done,
     /* 205877 */   // Label 4734: @205877
     /* 205877 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(205904), // Rule ID 2451 //
     /* 205882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205893 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 205893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 205898 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205902 */     GIR_RootConstrainSelectedInstOperands,
     /* 205903 */     // GIR_Coverage, 2451,
     /* 205903 */     GIR_Done,
     /* 205904 */   // Label 4735: @205904
     /* 205904 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(205931), // Rule ID 2459 //
     /* 205909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 205912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205920 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 205920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 205925 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205929 */     GIR_RootConstrainSelectedInstOperands,
     /* 205930 */     // GIR_Coverage, 2459,
     /* 205930 */     GIR_Done,
     /* 205931 */   // Label 4736: @205931
     /* 205931 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(205958), // Rule ID 12059 //
     /* 205936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205947 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 205947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 205952 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205956 */     GIR_RootConstrainSelectedInstOperands,
     /* 205957 */     // GIR_Coverage, 12059,
     /* 205957 */     GIR_Done,
     /* 205958 */   // Label 4737: @205958
     /* 205958 */   GIM_Reject,
     /* 205959 */ // Label 4732: @205959
     /* 205959 */ GIM_Reject,
     /* 205960 */ // Label 4698: @205960
     /* 205960 */ GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(206135),
     /* 205965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 205968 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(206024), // Rule ID 2473 //
     /* 205973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205988 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205995 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206008 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 206008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 206011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206022 */     GIR_RootConstrainSelectedInstOperands,
     /* 206023 */     // GIR_Coverage, 2473,
     /* 206023 */     GIR_EraseRootFromParent_Done,
     /* 206024 */   // Label 4739: @206024
     /* 206024 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(206080), // Rule ID 12099 //
     /* 206029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206064 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 206064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 206067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206078 */     GIR_RootConstrainSelectedInstOperands,
     /* 206079 */     // GIR_Coverage, 12099,
     /* 206079 */     GIR_EraseRootFromParent_Done,
     /* 206080 */   // Label 4740: @206080
     /* 206080 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(206107), // Rule ID 2471 //
     /* 206085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 206088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206096 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 206096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 206101 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206105 */     GIR_RootConstrainSelectedInstOperands,
     /* 206106 */     // GIR_Coverage, 2471,
     /* 206106 */     GIR_Done,
     /* 206107 */   // Label 4741: @206107
     /* 206107 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(206134), // Rule ID 12095 //
     /* 206112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206123 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 206123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 206128 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206132 */     GIR_RootConstrainSelectedInstOperands,
     /* 206133 */     // GIR_Coverage, 12095,
     /* 206133 */     GIR_Done,
     /* 206134 */   // Label 4742: @206134
     /* 206134 */   GIM_Reject,
     /* 206135 */ // Label 4738: @206135
     /* 206135 */ GIM_Reject,
     /* 206136 */ // Label 4699: @206136
     /* 206136 */ GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(206224),
     /* 206141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 206144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206148 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(206200), // Rule ID 12015 //
     /* 206153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206184 */     // (fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 206184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 206187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206198 */     GIR_RootConstrainSelectedInstOperands,
     /* 206199 */     // GIR_Coverage, 12015,
     /* 206199 */     GIR_EraseRootFromParent_Done,
     /* 206200 */   // Label 4744: @206200
     /* 206200 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(206223), // Rule ID 12011 //
     /* 206205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206212 */     // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 206212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 206217 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206221 */     GIR_RootConstrainSelectedInstOperands,
     /* 206222 */     // GIR_Coverage, 12011,
     /* 206222 */     GIR_Done,
     /* 206223 */   // Label 4745: @206223
     /* 206223 */   GIM_Reject,
     /* 206224 */ // Label 4743: @206224
     /* 206224 */ GIM_Reject,
     /* 206225 */ // Label 4700: @206225
     /* 206225 */ GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(206400),
     /* 206230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 206233 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(206289), // Rule ID 2457 //
     /* 206238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 206241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206273 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 206273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 206276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206287 */     GIR_RootConstrainSelectedInstOperands,
     /* 206288 */     // GIR_Coverage, 2457,
     /* 206288 */     GIR_EraseRootFromParent_Done,
     /* 206289 */   // Label 4747: @206289
     /* 206289 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(206345), // Rule ID 12075 //
     /* 206294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206329 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 206329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 206332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206343 */     GIR_RootConstrainSelectedInstOperands,
     /* 206344 */     // GIR_Coverage, 12075,
     /* 206344 */     GIR_EraseRootFromParent_Done,
     /* 206345 */   // Label 4748: @206345
     /* 206345 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(206372), // Rule ID 2455 //
     /* 206350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 206353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206361 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 206361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 206366 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206370 */     GIR_RootConstrainSelectedInstOperands,
     /* 206371 */     // GIR_Coverage, 2455,
     /* 206371 */     GIR_Done,
     /* 206372 */   // Label 4749: @206372
     /* 206372 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(206399), // Rule ID 12071 //
     /* 206377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206388 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 206388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 206393 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206397 */     GIR_RootConstrainSelectedInstOperands,
     /* 206398 */     // GIR_Coverage, 12071,
     /* 206398 */     GIR_Done,
     /* 206399 */   // Label 4750: @206399
     /* 206399 */   GIM_Reject,
     /* 206400 */ // Label 4746: @206400
     /* 206400 */ GIM_Reject,
     /* 206401 */ // Label 4701: @206401
     /* 206401 */ GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(206489),
     /* 206406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 206409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206413 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(206465), // Rule ID 12051 //
     /* 206418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206429 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206436 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206449 */     // (fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 206449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 206452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206463 */     GIR_RootConstrainSelectedInstOperands,
     /* 206464 */     // GIR_Coverage, 12051,
     /* 206464 */     GIR_EraseRootFromParent_Done,
     /* 206465 */   // Label 4752: @206465
     /* 206465 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(206488), // Rule ID 12047 //
     /* 206470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206477 */     // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 206477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 206482 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206486 */     GIR_RootConstrainSelectedInstOperands,
     /* 206487 */     // GIR_Coverage, 12047,
     /* 206487 */     GIR_Done,
     /* 206488 */   // Label 4753: @206488
     /* 206488 */   GIM_Reject,
     /* 206489 */ // Label 4751: @206489
     /* 206489 */ GIM_Reject,
     /* 206490 */ // Label 4702: @206490
     /* 206490 */ GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(206578),
     /* 206495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 206498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206502 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(206554), // Rule ID 12027 //
     /* 206507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206538 */     // (fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 206538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 206541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206552 */     GIR_RootConstrainSelectedInstOperands,
     /* 206553 */     // GIR_Coverage, 12027,
     /* 206553 */     GIR_EraseRootFromParent_Done,
     /* 206554 */   // Label 4755: @206554
     /* 206554 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(206577), // Rule ID 12023 //
     /* 206559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206566 */     // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 206566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 206571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206575 */     GIR_RootConstrainSelectedInstOperands,
     /* 206576 */     // GIR_Coverage, 12023,
     /* 206576 */     GIR_Done,
     /* 206577 */   // Label 4756: @206577
     /* 206577 */   GIM_Reject,
     /* 206578 */ // Label 4754: @206578
     /* 206578 */ GIM_Reject,
     /* 206579 */ // Label 4703: @206579
     /* 206579 */ GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(206667),
     /* 206584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 206587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206591 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(206643), // Rule ID 12039 //
     /* 206596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206627 */     // (fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 206627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 206630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206641 */     GIR_RootConstrainSelectedInstOperands,
     /* 206642 */     // GIR_Coverage, 12039,
     /* 206642 */     GIR_EraseRootFromParent_Done,
     /* 206643 */   // Label 4758: @206643
     /* 206643 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(206666), // Rule ID 12035 //
     /* 206648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206655 */     // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 206655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 206660 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206664 */     GIR_RootConstrainSelectedInstOperands,
     /* 206665 */     // GIR_Coverage, 12035,
     /* 206665 */     GIR_Done,
     /* 206666 */   // Label 4759: @206666
     /* 206666 */   GIM_Reject,
     /* 206667 */ // Label 4757: @206667
     /* 206667 */ GIM_Reject,
     /* 206668 */ // Label 4704: @206668
     /* 206668 */ GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(206756),
     /* 206673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 206676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206680 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(206732), // Rule ID 12003 //
     /* 206685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206716 */     // (fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 206716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 206719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206730 */     GIR_RootConstrainSelectedInstOperands,
     /* 206731 */     // GIR_Coverage, 12003,
     /* 206731 */     GIR_EraseRootFromParent_Done,
     /* 206732 */   // Label 4761: @206732
     /* 206732 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(206755), // Rule ID 11999 //
     /* 206737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206744 */     // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 206744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 206749 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206753 */     GIR_RootConstrainSelectedInstOperands,
     /* 206754 */     // GIR_Coverage, 11999,
     /* 206754 */     GIR_Done,
     /* 206755 */   // Label 4762: @206755
     /* 206755 */   GIM_Reject,
     /* 206756 */ // Label 4760: @206756
     /* 206756 */ GIM_Reject,
     /* 206757 */ // Label 4705: @206757
     /* 206757 */ GIM_Reject,
     /* 206758 */ // Label 68: @206758
     /* 206758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4776*/ GIMT_Encode4(210923),
     /* 206769 */ /*GILLT_s16*//*Label 4763*/ GIMT_Encode4(206853),
     /* 206773 */ /*GILLT_s32*//*Label 4764*/ GIMT_Encode4(207013),
     /* 206777 */ /*GILLT_s64*//*Label 4765*/ GIMT_Encode4(207658),
     /* 206781 */ /*GILLT_s80*//*Label 4766*/ GIMT_Encode4(208447), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206793 */ /*GILLT_v2s64*//*Label 4767*/ GIMT_Encode4(208769), GIMT_Encode4(0),
     /* 206801 */ /*GILLT_v4s32*//*Label 4768*/ GIMT_Encode4(209123),
     /* 206805 */ /*GILLT_v4s64*//*Label 4769*/ GIMT_Encode4(209477), GIMT_Encode4(0),
     /* 206813 */ /*GILLT_v8s16*//*Label 4770*/ GIMT_Encode4(209800),
     /* 206817 */ /*GILLT_v8s32*//*Label 4771*/ GIMT_Encode4(209960),
     /* 206821 */ /*GILLT_v8s64*//*Label 4772*/ GIMT_Encode4(210283), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206833 */ /*GILLT_v16s16*//*Label 4773*/ GIMT_Encode4(210443),
     /* 206837 */ /*GILLT_v16s32*//*Label 4774*/ GIMT_Encode4(210603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206849 */ /*GILLT_v32s16*//*Label 4775*/ GIMT_Encode4(210763),
     /* 206853 */ // Label 4763: @206853
     /* 206853 */ GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(207012),
     /* 206858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 206861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 206864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206868 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(206926), // Rule ID 24249 //
     /* 206873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206887 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206908 */     // (strict_fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 206911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206913 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 206915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206924 */     GIR_RootConstrainSelectedInstOperands,
     /* 206925 */     // GIR_Coverage, 24249,
     /* 206925 */     GIR_EraseRootFromParent_Done,
     /* 206926 */   // Label 4778: @206926
     /* 206926 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(206984), // Rule ID 5954 //
     /* 206931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206966 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 206969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 206973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206982 */     GIR_RootConstrainSelectedInstOperands,
     /* 206983 */     // GIR_Coverage, 5954,
     /* 206983 */     GIR_EraseRootFromParent_Done,
     /* 206984 */   // Label 4779: @206984
     /* 206984 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(207011), // Rule ID 5952 //
     /* 206989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 207000 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 207000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 207005 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207009 */     GIR_RootConstrainSelectedInstOperands,
     /* 207010 */     // GIR_Coverage, 5952,
     /* 207010 */     GIR_Done,
     /* 207011 */   // Label 4780: @207011
     /* 207011 */   GIM_Reject,
     /* 207012 */ // Label 4777: @207012
     /* 207012 */ GIM_Reject,
     /* 207013 */ // Label 4764: @207013
     /* 207013 */ GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(207657),
     /* 207018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207024 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(207089), // Rule ID 23236 //
     /* 207029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 207032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207068 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 207071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207073 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207087 */     GIR_RootConstrainSelectedInstOperands,
     /* 207088 */     // GIR_Coverage, 23236,
     /* 207088 */     GIR_EraseRootFromParent_Done,
     /* 207089 */   // Label 4782: @207089
     /* 207089 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(207151), // Rule ID 23381 //
     /* 207094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207109 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207133 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 207136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207149 */     GIR_RootConstrainSelectedInstOperands,
     /* 207150 */     // GIR_Coverage, 23381,
     /* 207150 */     GIR_EraseRootFromParent_Done,
     /* 207151 */   // Label 4783: @207151
     /* 207151 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(207213), // Rule ID 23385 //
     /* 207156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 207159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207195 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 207198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207211 */     GIR_RootConstrainSelectedInstOperands,
     /* 207212 */     // GIR_Coverage, 23385,
     /* 207212 */     GIR_EraseRootFromParent_Done,
     /* 207213 */   // Label 4784: @207213
     /* 207213 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(207275), // Rule ID 24245 //
     /* 207218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207233 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207257 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 207260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207262 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207273 */     GIR_RootConstrainSelectedInstOperands,
     /* 207274 */     // GIR_Coverage, 24245,
     /* 207274 */     GIR_EraseRootFromParent_Done,
     /* 207275 */   // Label 4785: @207275
     /* 207275 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(207340), // Rule ID 910 //
     /* 207280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 207283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207319 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 207322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207324 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207338 */     GIR_RootConstrainSelectedInstOperands,
     /* 207339 */     // GIR_Coverage, 910,
     /* 207339 */     GIR_EraseRootFromParent_Done,
     /* 207340 */   // Label 4786: @207340
     /* 207340 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(207402), // Rule ID 2160 //
     /* 207345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207384 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 207387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207400 */     GIR_RootConstrainSelectedInstOperands,
     /* 207401 */     // GIR_Coverage, 2160,
     /* 207401 */     GIR_EraseRootFromParent_Done,
     /* 207402 */   // Label 4787: @207402
     /* 207402 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(207464), // Rule ID 2168 //
     /* 207407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 207410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207446 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 207449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207462 */     GIR_RootConstrainSelectedInstOperands,
     /* 207463 */     // GIR_Coverage, 2168,
     /* 207463 */     GIR_EraseRootFromParent_Done,
     /* 207464 */   // Label 4788: @207464
     /* 207464 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(207526), // Rule ID 5916 //
     /* 207469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207508 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 207511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207524 */     GIR_RootConstrainSelectedInstOperands,
     /* 207525 */     // GIR_Coverage, 5916,
     /* 207525 */     GIR_EraseRootFromParent_Done,
     /* 207526 */   // Label 4789: @207526
     /* 207526 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(207563), // Rule ID 886 //
     /* 207531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 207534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207546 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 207546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 207551 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 207557 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 207561 */     GIR_RootConstrainSelectedInstOperands,
     /* 207562 */     // GIR_Coverage, 886,
     /* 207562 */     GIR_Done,
     /* 207563 */   // Label 4790: @207563
     /* 207563 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(207594), // Rule ID 2158 //
     /* 207568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207583 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 207583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 207588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207592 */     GIR_RootConstrainSelectedInstOperands,
     /* 207593 */     // GIR_Coverage, 2158,
     /* 207593 */     GIR_Done,
     /* 207594 */   // Label 4791: @207594
     /* 207594 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(207625), // Rule ID 2166 //
     /* 207599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 207602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207614 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 207614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 207619 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207623 */     GIR_RootConstrainSelectedInstOperands,
     /* 207624 */     // GIR_Coverage, 2166,
     /* 207624 */     GIR_Done,
     /* 207625 */   // Label 4792: @207625
     /* 207625 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(207656), // Rule ID 5914 //
     /* 207630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207645 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 207645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 207650 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207654 */     GIR_RootConstrainSelectedInstOperands,
     /* 207655 */     // GIR_Coverage, 5914,
     /* 207655 */     GIR_Done,
     /* 207656 */   // Label 4793: @207656
     /* 207656 */   GIM_Reject,
     /* 207657 */ // Label 4781: @207657
     /* 207657 */ GIM_Reject,
     /* 207658 */ // Label 4765: @207658
     /* 207658 */ GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(208446),
     /* 207663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207669 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(207734), // Rule ID 23238 //
     /* 207674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207713 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 207716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207718 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207732 */     GIR_RootConstrainSelectedInstOperands,
     /* 207733 */     // GIR_Coverage, 23238,
     /* 207733 */     GIR_EraseRootFromParent_Done,
     /* 207734 */   // Label 4795: @207734
     /* 207734 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(207806), // Rule ID 23240 //
     /* 207739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207757 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207761 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 207768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207785 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 207788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207804 */     GIR_RootConstrainSelectedInstOperands,
     /* 207805 */     // GIR_Coverage, 23240,
     /* 207805 */     GIR_EraseRootFromParent_Done,
     /* 207806 */   // Label 4796: @207806
     /* 207806 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(207868), // Rule ID 23383 //
     /* 207811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207850 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 207853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207857 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207866 */     GIR_RootConstrainSelectedInstOperands,
     /* 207867 */     // GIR_Coverage, 23383,
     /* 207867 */     GIR_EraseRootFromParent_Done,
     /* 207868 */   // Label 4797: @207868
     /* 207868 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(207930), // Rule ID 23387 //
     /* 207873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 207876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207912 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 207915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207928 */     GIR_RootConstrainSelectedInstOperands,
     /* 207929 */     // GIR_Coverage, 23387,
     /* 207929 */     GIR_EraseRootFromParent_Done,
     /* 207930 */   // Label 4798: @207930
     /* 207930 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(207992), // Rule ID 24247 //
     /* 207935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207974 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 207977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207990 */     GIR_RootConstrainSelectedInstOperands,
     /* 207991 */     // GIR_Coverage, 24247,
     /* 207991 */     GIR_EraseRootFromParent_Done,
     /* 207992 */   // Label 4799: @207992
     /* 207992 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(208057), // Rule ID 912 //
     /* 207997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208036 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 208039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208055 */     GIR_RootConstrainSelectedInstOperands,
     /* 208056 */     // GIR_Coverage, 912,
     /* 208056 */     GIR_EraseRootFromParent_Done,
     /* 208057 */   // Label 4800: @208057
     /* 208057 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(208129), // Rule ID 914 //
     /* 208062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208081 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208084 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208088 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 208095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208108 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 208111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208127 */     GIR_RootConstrainSelectedInstOperands,
     /* 208128 */     // GIR_Coverage, 914,
     /* 208128 */     GIR_EraseRootFromParent_Done,
     /* 208129 */   // Label 4801: @208129
     /* 208129 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(208191), // Rule ID 2164 //
     /* 208134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208173 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 208176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208189 */     GIR_RootConstrainSelectedInstOperands,
     /* 208190 */     // GIR_Coverage, 2164,
     /* 208190 */     GIR_EraseRootFromParent_Done,
     /* 208191 */   // Label 4802: @208191
     /* 208191 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(208253), // Rule ID 2172 //
     /* 208196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208235 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 208238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208240 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208251 */     GIR_RootConstrainSelectedInstOperands,
     /* 208252 */     // GIR_Coverage, 2172,
     /* 208252 */     GIR_EraseRootFromParent_Done,
     /* 208253 */   // Label 4803: @208253
     /* 208253 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(208315), // Rule ID 5935 //
     /* 208258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208277 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208297 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 208300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208313 */     GIR_RootConstrainSelectedInstOperands,
     /* 208314 */     // GIR_Coverage, 5935,
     /* 208314 */     GIR_EraseRootFromParent_Done,
     /* 208315 */   // Label 4804: @208315
     /* 208315 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(208352), // Rule ID 888 //
     /* 208320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208335 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 208335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 208340 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208346 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208350 */     GIR_RootConstrainSelectedInstOperands,
     /* 208351 */     // GIR_Coverage, 888,
     /* 208351 */     GIR_Done,
     /* 208352 */   // Label 4805: @208352
     /* 208352 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(208383), // Rule ID 2162 //
     /* 208357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208372 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 208372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 208377 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208381 */     GIR_RootConstrainSelectedInstOperands,
     /* 208382 */     // GIR_Coverage, 2162,
     /* 208382 */     GIR_Done,
     /* 208383 */   // Label 4806: @208383
     /* 208383 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(208414), // Rule ID 2170 //
     /* 208388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208403 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 208403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 208408 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208412 */     GIR_RootConstrainSelectedInstOperands,
     /* 208413 */     // GIR_Coverage, 2170,
     /* 208413 */     GIR_Done,
     /* 208414 */   // Label 4807: @208414
     /* 208414 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(208445), // Rule ID 5933 //
     /* 208419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208434 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 208434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 208439 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208443 */     GIR_RootConstrainSelectedInstOperands,
     /* 208444 */     // GIR_Coverage, 5933,
     /* 208444 */     GIR_Done,
     /* 208445 */   // Label 4808: @208445
     /* 208445 */   GIM_Reject,
     /* 208446 */ // Label 4794: @208446
     /* 208446 */ GIM_Reject,
     /* 208447 */ // Label 4766: @208447
     /* 208447 */ GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(208768),
     /* 208452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 208455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 208458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208462 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(208530), // Rule ID 23242 //
     /* 208467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208481 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208485 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 208492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208509 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 208512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208528 */     GIR_RootConstrainSelectedInstOperands,
     /* 208529 */     // GIR_Coverage, 23242,
     /* 208529 */     GIR_EraseRootFromParent_Done,
     /* 208530 */   // Label 4810: @208530
     /* 208530 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(208598), // Rule ID 23244 //
     /* 208535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208549 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208553 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 208560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208577 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 208580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208582 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208596 */     GIR_RootConstrainSelectedInstOperands,
     /* 208597 */     // GIR_Coverage, 23244,
     /* 208597 */     GIR_EraseRootFromParent_Done,
     /* 208598 */   // Label 4811: @208598
     /* 208598 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(208666), // Rule ID 916 //
     /* 208603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208621 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208625 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 208632 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208645 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 208648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208652 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208664 */     GIR_RootConstrainSelectedInstOperands,
     /* 208665 */     // GIR_Coverage, 916,
     /* 208665 */     GIR_EraseRootFromParent_Done,
     /* 208666 */   // Label 4812: @208666
     /* 208666 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(208734), // Rule ID 918 //
     /* 208671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208686 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208689 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208693 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 208700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208713 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 208716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208732 */     GIR_RootConstrainSelectedInstOperands,
     /* 208733 */     // GIR_Coverage, 918,
     /* 208733 */     GIR_EraseRootFromParent_Done,
     /* 208734 */   // Label 4813: @208734
     /* 208734 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(208767), // Rule ID 890 //
     /* 208739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208750 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 208750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 208755 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208765 */     GIR_RootConstrainSelectedInstOperands,
     /* 208766 */     // GIR_Coverage, 890,
     /* 208766 */     GIR_Done,
     /* 208767 */   // Label 4814: @208767
     /* 208767 */   GIM_Reject,
     /* 208768 */ // Label 4809: @208768
     /* 208768 */ GIM_Reject,
     /* 208769 */ // Label 4767: @208769
     /* 208769 */ GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(209122),
     /* 208774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208780 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(208842), // Rule ID 23371 //
     /* 208785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208824 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 208827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208840 */     GIR_RootConstrainSelectedInstOperands,
     /* 208841 */     // GIR_Coverage, 23371,
     /* 208841 */     GIR_EraseRootFromParent_Done,
     /* 208842 */   // Label 4816: @208842
     /* 208842 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(208904), // Rule ID 24295 //
     /* 208847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208886 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 208889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208902 */     GIR_RootConstrainSelectedInstOperands,
     /* 208903 */     // GIR_Coverage, 24295,
     /* 208903 */     GIR_EraseRootFromParent_Done,
     /* 208904 */   // Label 4817: @208904
     /* 208904 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(208966), // Rule ID 2140 //
     /* 208909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208948 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 208951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208964 */     GIR_RootConstrainSelectedInstOperands,
     /* 208965 */     // GIR_Coverage, 2140,
     /* 208965 */     GIR_EraseRootFromParent_Done,
     /* 208966 */   // Label 4818: @208966
     /* 208966 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(209028), // Rule ID 6308 //
     /* 208971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209010 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 209013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209026 */     GIR_RootConstrainSelectedInstOperands,
     /* 209027 */     // GIR_Coverage, 6308,
     /* 209027 */     GIR_EraseRootFromParent_Done,
     /* 209028 */   // Label 4819: @209028
     /* 209028 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(209059), // Rule ID 2138 //
     /* 209033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209048 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 209048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 209053 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209057 */     GIR_RootConstrainSelectedInstOperands,
     /* 209058 */     // GIR_Coverage, 2138,
     /* 209058 */     GIR_Done,
     /* 209059 */   // Label 4820: @209059
     /* 209059 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(209090), // Rule ID 2154 //
     /* 209064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 209067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209079 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 209079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 209084 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209088 */     GIR_RootConstrainSelectedInstOperands,
     /* 209089 */     // GIR_Coverage, 2154,
     /* 209089 */     GIR_Done,
     /* 209090 */   // Label 4821: @209090
     /* 209090 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(209121), // Rule ID 6304 //
     /* 209095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209110 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 209110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 209115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209119 */     GIR_RootConstrainSelectedInstOperands,
     /* 209120 */     // GIR_Coverage, 6304,
     /* 209120 */     GIR_Done,
     /* 209121 */   // Label 4822: @209121
     /* 209121 */   GIM_Reject,
     /* 209122 */ // Label 4815: @209122
     /* 209122 */ GIM_Reject,
     /* 209123 */ // Label 4768: @209123
     /* 209123 */ GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(209476),
     /* 209128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209134 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(209196), // Rule ID 23369 //
     /* 209139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209178 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 209181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209183 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209194 */     GIR_RootConstrainSelectedInstOperands,
     /* 209195 */     // GIR_Coverage, 23369,
     /* 209195 */     GIR_EraseRootFromParent_Done,
     /* 209196 */   // Label 4824: @209196
     /* 209196 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(209258), // Rule ID 24279 //
     /* 209201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209240 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 209243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209256 */     GIR_RootConstrainSelectedInstOperands,
     /* 209257 */     // GIR_Coverage, 24279,
     /* 209257 */     GIR_EraseRootFromParent_Done,
     /* 209258 */   // Label 4825: @209258
     /* 209258 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(209320), // Rule ID 2136 //
     /* 209263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209282 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209302 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 209305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209318 */     GIR_RootConstrainSelectedInstOperands,
     /* 209319 */     // GIR_Coverage, 2136,
     /* 209319 */     GIR_EraseRootFromParent_Done,
     /* 209320 */   // Label 4826: @209320
     /* 209320 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(209382), // Rule ID 6284 //
     /* 209325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209364 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 209367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209380 */     GIR_RootConstrainSelectedInstOperands,
     /* 209381 */     // GIR_Coverage, 6284,
     /* 209381 */     GIR_EraseRootFromParent_Done,
     /* 209382 */   // Label 4827: @209382
     /* 209382 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(209413), // Rule ID 2134 //
     /* 209387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209402 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 209402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 209407 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209411 */     GIR_RootConstrainSelectedInstOperands,
     /* 209412 */     // GIR_Coverage, 2134,
     /* 209412 */     GIR_Done,
     /* 209413 */   // Label 4828: @209413
     /* 209413 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(209444), // Rule ID 2150 //
     /* 209418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 209421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209433 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 209433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 209438 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209442 */     GIR_RootConstrainSelectedInstOperands,
     /* 209443 */     // GIR_Coverage, 2150,
     /* 209443 */     GIR_Done,
     /* 209444 */   // Label 4829: @209444
     /* 209444 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(209475), // Rule ID 6280 //
     /* 209449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209464 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 209464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 209469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209473 */     GIR_RootConstrainSelectedInstOperands,
     /* 209474 */     // GIR_Coverage, 6280,
     /* 209474 */     GIR_Done,
     /* 209475 */   // Label 4830: @209475
     /* 209475 */   GIM_Reject,
     /* 209476 */ // Label 4823: @209476
     /* 209476 */ GIM_Reject,
     /* 209477 */ // Label 4769: @209477
     /* 209477 */ GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(209799),
     /* 209482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 209485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 209488 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(209550), // Rule ID 23375 //
     /* 209493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209532 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 209535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209548 */     GIR_RootConstrainSelectedInstOperands,
     /* 209549 */     // GIR_Coverage, 23375,
     /* 209549 */     GIR_EraseRootFromParent_Done,
     /* 209550 */   // Label 4832: @209550
     /* 209550 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(209612), // Rule ID 24303 //
     /* 209555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209594 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 209597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209599 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209610 */     GIR_RootConstrainSelectedInstOperands,
     /* 209611 */     // GIR_Coverage, 24303,
     /* 209611 */     GIR_EraseRootFromParent_Done,
     /* 209612 */   // Label 4833: @209612
     /* 209612 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(209674), // Rule ID 2148 //
     /* 209617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209656 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 209659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209672 */     GIR_RootConstrainSelectedInstOperands,
     /* 209673 */     // GIR_Coverage, 2148,
     /* 209673 */     GIR_EraseRootFromParent_Done,
     /* 209674 */   // Label 4834: @209674
     /* 209674 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(209736), // Rule ID 6320 //
     /* 209679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209718 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 209721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209723 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209734 */     GIR_RootConstrainSelectedInstOperands,
     /* 209735 */     // GIR_Coverage, 6320,
     /* 209735 */     GIR_EraseRootFromParent_Done,
     /* 209736 */   // Label 4835: @209736
     /* 209736 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(209767), // Rule ID 2146 //
     /* 209741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209756 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 209756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 209761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209765 */     GIR_RootConstrainSelectedInstOperands,
     /* 209766 */     // GIR_Coverage, 2146,
     /* 209766 */     GIR_Done,
     /* 209767 */   // Label 4836: @209767
     /* 209767 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(209798), // Rule ID 6316 //
     /* 209772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209787 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 209787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 209792 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209796 */     GIR_RootConstrainSelectedInstOperands,
     /* 209797 */     // GIR_Coverage, 6316,
     /* 209797 */     GIR_Done,
     /* 209798 */   // Label 4837: @209798
     /* 209798 */   GIM_Reject,
     /* 209799 */ // Label 4831: @209799
     /* 209799 */ GIM_Reject,
     /* 209800 */ // Label 4770: @209800
     /* 209800 */ GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(209959),
     /* 209805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 209808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209815 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(209873), // Rule ID 24319 //
     /* 209820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209831 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209855 */     // (strict_fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 209858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209871 */     GIR_RootConstrainSelectedInstOperands,
     /* 209872 */     // GIR_Coverage, 24319,
     /* 209872 */     GIR_EraseRootFromParent_Done,
     /* 209873 */   // Label 4839: @209873
     /* 209873 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(209931), // Rule ID 6344 //
     /* 209878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209893 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209900 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209913 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 209916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209929 */     GIR_RootConstrainSelectedInstOperands,
     /* 209930 */     // GIR_Coverage, 6344,
     /* 209930 */     GIR_EraseRootFromParent_Done,
     /* 209931 */   // Label 4840: @209931
     /* 209931 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(209958), // Rule ID 6340 //
     /* 209936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209947 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 209947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 209952 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209956 */     GIR_RootConstrainSelectedInstOperands,
     /* 209957 */     // GIR_Coverage, 6340,
     /* 209957 */     GIR_Done,
     /* 209958 */   // Label 4841: @209958
     /* 209958 */   GIM_Reject,
     /* 209959 */ // Label 4838: @209959
     /* 209959 */ GIM_Reject,
     /* 209960 */ // Label 4771: @209960
     /* 209960 */ GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(210282),
     /* 209965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 209968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 209971 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(210033), // Rule ID 23373 //
     /* 209976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210015 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 210018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210020 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210031 */     GIR_RootConstrainSelectedInstOperands,
     /* 210032 */     // GIR_Coverage, 23373,
     /* 210032 */     GIR_EraseRootFromParent_Done,
     /* 210033 */   // Label 4843: @210033
     /* 210033 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(210095), // Rule ID 24287 //
     /* 210038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 210041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210077 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 210080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210093 */     GIR_RootConstrainSelectedInstOperands,
     /* 210094 */     // GIR_Coverage, 24287,
     /* 210094 */     GIR_EraseRootFromParent_Done,
     /* 210095 */   // Label 4844: @210095
     /* 210095 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(210157), // Rule ID 2144 //
     /* 210100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 210103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210139 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 210142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210155 */     GIR_RootConstrainSelectedInstOperands,
     /* 210156 */     // GIR_Coverage, 2144,
     /* 210156 */     GIR_EraseRootFromParent_Done,
     /* 210157 */   // Label 4845: @210157
     /* 210157 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(210219), // Rule ID 6296 //
     /* 210162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 210165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210201 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 210204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210217 */     GIR_RootConstrainSelectedInstOperands,
     /* 210218 */     // GIR_Coverage, 6296,
     /* 210218 */     GIR_EraseRootFromParent_Done,
     /* 210219 */   // Label 4846: @210219
     /* 210219 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(210250), // Rule ID 2142 //
     /* 210224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 210227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210239 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 210239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 210244 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210248 */     GIR_RootConstrainSelectedInstOperands,
     /* 210249 */     // GIR_Coverage, 2142,
     /* 210249 */     GIR_Done,
     /* 210250 */   // Label 4847: @210250
     /* 210250 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(210281), // Rule ID 6292 //
     /* 210255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 210258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210270 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 210270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 210275 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210279 */     GIR_RootConstrainSelectedInstOperands,
     /* 210280 */     // GIR_Coverage, 6292,
     /* 210280 */     GIR_Done,
     /* 210281 */   // Label 4848: @210281
     /* 210281 */   GIM_Reject,
     /* 210282 */ // Label 4842: @210282
     /* 210282 */ GIM_Reject,
     /* 210283 */ // Label 4772: @210283
     /* 210283 */ GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(210442),
     /* 210288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 210291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 210294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210298 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(210356), // Rule ID 24271 //
     /* 210303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210338 */     // (strict_fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 210341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210354 */     GIR_RootConstrainSelectedInstOperands,
     /* 210355 */     // GIR_Coverage, 24271,
     /* 210355 */     GIR_EraseRootFromParent_Done,
     /* 210356 */   // Label 4850: @210356
     /* 210356 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(210414), // Rule ID 6272 //
     /* 210361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210396 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 210399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210412 */     GIR_RootConstrainSelectedInstOperands,
     /* 210413 */     // GIR_Coverage, 6272,
     /* 210413 */     GIR_EraseRootFromParent_Done,
     /* 210414 */   // Label 4851: @210414
     /* 210414 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(210441), // Rule ID 6268 //
     /* 210419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210430 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 210430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 210435 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210439 */     GIR_RootConstrainSelectedInstOperands,
     /* 210440 */     // GIR_Coverage, 6268,
     /* 210440 */     GIR_Done,
     /* 210441 */   // Label 4852: @210441
     /* 210441 */   GIM_Reject,
     /* 210442 */ // Label 4849: @210442
     /* 210442 */ GIM_Reject,
     /* 210443 */ // Label 4773: @210443
     /* 210443 */ GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(210602),
     /* 210448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 210451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 210454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210458 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(210516), // Rule ID 24327 //
     /* 210463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 210466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210498 */     // (strict_fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 210501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210514 */     GIR_RootConstrainSelectedInstOperands,
     /* 210515 */     // GIR_Coverage, 24327,
     /* 210515 */     GIR_EraseRootFromParent_Done,
     /* 210516 */   // Label 4854: @210516
     /* 210516 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(210574), // Rule ID 6356 //
     /* 210521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 210524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210556 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 210559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210572 */     GIR_RootConstrainSelectedInstOperands,
     /* 210573 */     // GIR_Coverage, 6356,
     /* 210573 */     GIR_EraseRootFromParent_Done,
     /* 210574 */   // Label 4855: @210574
     /* 210574 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(210601), // Rule ID 6352 //
     /* 210579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 210582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210590 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 210590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 210595 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210599 */     GIR_RootConstrainSelectedInstOperands,
     /* 210600 */     // GIR_Coverage, 6352,
     /* 210600 */     GIR_Done,
     /* 210601 */   // Label 4856: @210601
     /* 210601 */   GIM_Reject,
     /* 210602 */ // Label 4853: @210602
     /* 210602 */ GIM_Reject,
     /* 210603 */ // Label 4774: @210603
     /* 210603 */ GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(210762),
     /* 210608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 210611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 210614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210618 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(210676), // Rule ID 24263 //
     /* 210623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210634 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210641 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210658 */     // (strict_fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 210661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210663 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210674 */     GIR_RootConstrainSelectedInstOperands,
     /* 210675 */     // GIR_Coverage, 24263,
     /* 210675 */     GIR_EraseRootFromParent_Done,
     /* 210676 */   // Label 4858: @210676
     /* 210676 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(210734), // Rule ID 6260 //
     /* 210681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210716 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 210719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210732 */     GIR_RootConstrainSelectedInstOperands,
     /* 210733 */     // GIR_Coverage, 6260,
     /* 210733 */     GIR_EraseRootFromParent_Done,
     /* 210734 */   // Label 4859: @210734
     /* 210734 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(210761), // Rule ID 6256 //
     /* 210739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210750 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 210750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 210755 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210759 */     GIR_RootConstrainSelectedInstOperands,
     /* 210760 */     // GIR_Coverage, 6256,
     /* 210760 */     GIR_Done,
     /* 210761 */   // Label 4860: @210761
     /* 210761 */   GIM_Reject,
     /* 210762 */ // Label 4857: @210762
     /* 210762 */ GIM_Reject,
     /* 210763 */ // Label 4775: @210763
     /* 210763 */ GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(210922),
     /* 210768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 210771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 210774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210778 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(210836), // Rule ID 24311 //
     /* 210783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210818 */     // (strict_fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 210821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210834 */     GIR_RootConstrainSelectedInstOperands,
     /* 210835 */     // GIR_Coverage, 24311,
     /* 210835 */     GIR_EraseRootFromParent_Done,
     /* 210836 */   // Label 4862: @210836
     /* 210836 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(210894), // Rule ID 6332 //
     /* 210841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210876 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 210879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210892 */     GIR_RootConstrainSelectedInstOperands,
     /* 210893 */     // GIR_Coverage, 6332,
     /* 210893 */     GIR_EraseRootFromParent_Done,
     /* 210894 */   // Label 4863: @210894
     /* 210894 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(210921), // Rule ID 6328 //
     /* 210899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210910 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 210910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 210915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210919 */     GIR_RootConstrainSelectedInstOperands,
     /* 210920 */     // GIR_Coverage, 6328,
     /* 210920 */     GIR_Done,
     /* 210921 */   // Label 4864: @210921
     /* 210921 */   GIM_Reject,
     /* 210922 */ // Label 4861: @210922
     /* 210922 */ GIM_Reject,
     /* 210923 */ // Label 4776: @210923
     /* 210923 */ GIM_Reject,
     /* 210924 */ // Label 69: @210924
     /* 210924 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4878*/ GIMT_Encode4(213849),
     /* 210935 */ /*GILLT_s16*//*Label 4865*/ GIMT_Encode4(211019),
     /* 210939 */ /*GILLT_s32*//*Label 4866*/ GIMT_Encode4(211117),
     /* 210943 */ /*GILLT_s64*//*Label 4867*/ GIMT_Encode4(211576),
     /* 210947 */ /*GILLT_s80*//*Label 4868*/ GIMT_Encode4(212179), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210959 */ /*GILLT_v2s64*//*Label 4869*/ GIMT_Encode4(212501), GIMT_Encode4(0),
     /* 210967 */ /*GILLT_v4s32*//*Label 4870*/ GIMT_Encode4(212731),
     /* 210971 */ /*GILLT_v4s64*//*Label 4871*/ GIMT_Encode4(212961), GIMT_Encode4(0),
     /* 210979 */ /*GILLT_v8s16*//*Label 4872*/ GIMT_Encode4(213160),
     /* 210983 */ /*GILLT_v8s32*//*Label 4873*/ GIMT_Encode4(213258),
     /* 210987 */ /*GILLT_v8s64*//*Label 4874*/ GIMT_Encode4(213457), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210999 */ /*GILLT_v16s16*//*Label 4875*/ GIMT_Encode4(213555),
     /* 211003 */ /*GILLT_v16s32*//*Label 4876*/ GIMT_Encode4(213653), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 211015 */ /*GILLT_v32s16*//*Label 4877*/ GIMT_Encode4(213751),
     /* 211019 */ // Label 4865: @211019
     /* 211019 */ GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(211116),
     /* 211024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 211027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 211030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 211034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 211038 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(211092), // Rule ID 6068 //
     /* 211043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 211046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211054 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211061 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211074 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 211077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211090 */     GIR_RootConstrainSelectedInstOperands,
     /* 211091 */     // GIR_Coverage, 6068,
     /* 211091 */     GIR_EraseRootFromParent_Done,
     /* 211092 */   // Label 4880: @211092
     /* 211092 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(211115), // Rule ID 6066 //
     /* 211097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 211100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 211104 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 211104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 211109 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211113 */     GIR_RootConstrainSelectedInstOperands,
     /* 211114 */     // GIR_Coverage, 6066,
     /* 211114 */     GIR_Done,
     /* 211115 */   // Label 4881: @211115
     /* 211115 */   GIM_Reject,
     /* 211116 */ // Label 4879: @211116
     /* 211116 */ GIM_Reject,
     /* 211117 */ // Label 4866: @211117
     /* 211117 */ GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(211575),
     /* 211122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 211125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211128 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(211193), // Rule ID 954 //
     /* 211133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211172 */     // (strict_fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 211175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211177 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211191 */     GIR_RootConstrainSelectedInstOperands,
     /* 211192 */     // GIR_Coverage, 954,
     /* 211192 */     GIR_EraseRootFromParent_Done,
     /* 211193 */   // Label 4883: @211193
     /* 211193 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(211258), // Rule ID 932 //
     /* 211198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211217 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211220 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211224 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211237 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 211240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211242 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211256 */     GIR_RootConstrainSelectedInstOperands,
     /* 211257 */     // GIR_Coverage, 932,
     /* 211257 */     GIR_EraseRootFromParent_Done,
     /* 211258 */   // Label 4884: @211258
     /* 211258 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(211320), // Rule ID 2240 //
     /* 211263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211282 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211302 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 211305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211318 */     GIR_RootConstrainSelectedInstOperands,
     /* 211319 */     // GIR_Coverage, 2240,
     /* 211319 */     GIR_EraseRootFromParent_Done,
     /* 211320 */   // Label 4885: @211320
     /* 211320 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(211382), // Rule ID 2248 //
     /* 211325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 211328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211364 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 211367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211380 */     GIR_RootConstrainSelectedInstOperands,
     /* 211381 */     // GIR_Coverage, 2248,
     /* 211381 */     GIR_EraseRootFromParent_Done,
     /* 211382 */   // Label 4886: @211382
     /* 211382 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(211444), // Rule ID 6030 //
     /* 211387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211426 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 211429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211442 */     GIR_RootConstrainSelectedInstOperands,
     /* 211443 */     // GIR_Coverage, 6030,
     /* 211443 */     GIR_EraseRootFromParent_Done,
     /* 211444 */   // Label 4887: @211444
     /* 211444 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(211481), // Rule ID 892 //
     /* 211449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211464 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 211464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 211469 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 211475 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 211479 */     GIR_RootConstrainSelectedInstOperands,
     /* 211480 */     // GIR_Coverage, 892,
     /* 211480 */     GIR_Done,
     /* 211481 */   // Label 4888: @211481
     /* 211481 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(211512), // Rule ID 2238 //
     /* 211486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211501 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 211506 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211510 */     GIR_RootConstrainSelectedInstOperands,
     /* 211511 */     // GIR_Coverage, 2238,
     /* 211511 */     GIR_Done,
     /* 211512 */   // Label 4889: @211512
     /* 211512 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(211543), // Rule ID 2246 //
     /* 211517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 211520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211532 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 211537 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211541 */     GIR_RootConstrainSelectedInstOperands,
     /* 211542 */     // GIR_Coverage, 2246,
     /* 211542 */     GIR_Done,
     /* 211543 */   // Label 4890: @211543
     /* 211543 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(211574), // Rule ID 6028 //
     /* 211548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211563 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 211563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 211568 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211572 */     GIR_RootConstrainSelectedInstOperands,
     /* 211573 */     // GIR_Coverage, 6028,
     /* 211573 */     GIR_Done,
     /* 211574 */   // Label 4891: @211574
     /* 211574 */   GIM_Reject,
     /* 211575 */ // Label 4882: @211575
     /* 211575 */ GIM_Reject,
     /* 211576 */ // Label 4867: @211576
     /* 211576 */ GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(212178),
     /* 211581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211587 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(211652), // Rule ID 956 //
     /* 211592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211631 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 211634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211650 */     GIR_RootConstrainSelectedInstOperands,
     /* 211651 */     // GIR_Coverage, 956,
     /* 211651 */     GIR_EraseRootFromParent_Done,
     /* 211652 */   // Label 4893: @211652
     /* 211652 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(211724), // Rule ID 958 //
     /* 211657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211675 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211679 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211686 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211703 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 211706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211710 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211722 */     GIR_RootConstrainSelectedInstOperands,
     /* 211723 */     // GIR_Coverage, 958,
     /* 211723 */     GIR_EraseRootFromParent_Done,
     /* 211724 */   // Label 4894: @211724
     /* 211724 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(211789), // Rule ID 934 //
     /* 211729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211748 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211755 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211768 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 211771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211787 */     GIR_RootConstrainSelectedInstOperands,
     /* 211788 */     // GIR_Coverage, 934,
     /* 211788 */     GIR_EraseRootFromParent_Done,
     /* 211789 */   // Label 4895: @211789
     /* 211789 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(211861), // Rule ID 936 //
     /* 211794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211813 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211816 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211820 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211840 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 211843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211859 */     GIR_RootConstrainSelectedInstOperands,
     /* 211860 */     // GIR_Coverage, 936,
     /* 211860 */     GIR_EraseRootFromParent_Done,
     /* 211861 */   // Label 4896: @211861
     /* 211861 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(211923), // Rule ID 2244 //
     /* 211866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211885 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211905 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 211908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211921 */     GIR_RootConstrainSelectedInstOperands,
     /* 211922 */     // GIR_Coverage, 2244,
     /* 211922 */     GIR_EraseRootFromParent_Done,
     /* 211923 */   // Label 4897: @211923
     /* 211923 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(211985), // Rule ID 2252 //
     /* 211928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211950 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211967 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 211970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211972 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211983 */     GIR_RootConstrainSelectedInstOperands,
     /* 211984 */     // GIR_Coverage, 2252,
     /* 211984 */     GIR_EraseRootFromParent_Done,
     /* 211985 */   // Label 4898: @211985
     /* 211985 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(212047), // Rule ID 6049 //
     /* 211990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212009 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212029 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 212032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212045 */     GIR_RootConstrainSelectedInstOperands,
     /* 212046 */     // GIR_Coverage, 6049,
     /* 212046 */     GIR_EraseRootFromParent_Done,
     /* 212047 */   // Label 4899: @212047
     /* 212047 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(212084), // Rule ID 894 //
     /* 212052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 212055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212067 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 212067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 212072 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212082 */     GIR_RootConstrainSelectedInstOperands,
     /* 212083 */     // GIR_Coverage, 894,
     /* 212083 */     GIR_Done,
     /* 212084 */   // Label 4900: @212084
     /* 212084 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(212115), // Rule ID 2242 //
     /* 212089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 212092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212104 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 212109 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212113 */     GIR_RootConstrainSelectedInstOperands,
     /* 212114 */     // GIR_Coverage, 2242,
     /* 212114 */     GIR_Done,
     /* 212115 */   // Label 4901: @212115
     /* 212115 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(212146), // Rule ID 2250 //
     /* 212120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212135 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 212140 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212144 */     GIR_RootConstrainSelectedInstOperands,
     /* 212145 */     // GIR_Coverage, 2250,
     /* 212145 */     GIR_Done,
     /* 212146 */   // Label 4902: @212146
     /* 212146 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(212177), // Rule ID 6047 //
     /* 212151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212166 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 212166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 212171 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212175 */     GIR_RootConstrainSelectedInstOperands,
     /* 212176 */     // GIR_Coverage, 6047,
     /* 212176 */     GIR_Done,
     /* 212177 */   // Label 4903: @212177
     /* 212177 */   GIM_Reject,
     /* 212178 */ // Label 4892: @212178
     /* 212178 */ GIM_Reject,
     /* 212179 */ // Label 4868: @212179
     /* 212179 */ GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(212500),
     /* 212184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 212187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 212190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212194 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(212262), // Rule ID 960 //
     /* 212199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212213 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212217 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212224 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212241 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 212244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212246 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212260 */     GIR_RootConstrainSelectedInstOperands,
     /* 212261 */     // GIR_Coverage, 960,
     /* 212261 */     GIR_EraseRootFromParent_Done,
     /* 212262 */   // Label 4905: @212262
     /* 212262 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(212330), // Rule ID 962 //
     /* 212267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212281 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212285 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212309 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 212312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212328 */     GIR_RootConstrainSelectedInstOperands,
     /* 212329 */     // GIR_Coverage, 962,
     /* 212329 */     GIR_EraseRootFromParent_Done,
     /* 212330 */   // Label 4906: @212330
     /* 212330 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(212398), // Rule ID 938 //
     /* 212335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212353 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212357 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212377 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 212380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212396 */     GIR_RootConstrainSelectedInstOperands,
     /* 212397 */     // GIR_Coverage, 938,
     /* 212397 */     GIR_EraseRootFromParent_Done,
     /* 212398 */   // Label 4907: @212398
     /* 212398 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(212466), // Rule ID 940 //
     /* 212403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212421 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212425 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212445 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 212448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212464 */     GIR_RootConstrainSelectedInstOperands,
     /* 212465 */     // GIR_Coverage, 940,
     /* 212465 */     GIR_EraseRootFromParent_Done,
     /* 212466 */   // Label 4908: @212466
     /* 212466 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(212499), // Rule ID 896 //
     /* 212471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212482 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 212482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 212487 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212493 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212497 */     GIR_RootConstrainSelectedInstOperands,
     /* 212498 */     // GIR_Coverage, 896,
     /* 212498 */     GIR_Done,
     /* 212499 */   // Label 4909: @212499
     /* 212499 */   GIM_Reject,
     /* 212500 */ // Label 4904: @212500
     /* 212500 */ GIM_Reject,
     /* 212501 */ // Label 4869: @212501
     /* 212501 */ GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(212730),
     /* 212506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 212509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212512 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(212574), // Rule ID 2220 //
     /* 212517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212556 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 212559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212572 */     GIR_RootConstrainSelectedInstOperands,
     /* 212573 */     // GIR_Coverage, 2220,
     /* 212573 */     GIR_EraseRootFromParent_Done,
     /* 212574 */   // Label 4911: @212574
     /* 212574 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(212636), // Rule ID 6542 //
     /* 212579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212618 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 212621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212634 */     GIR_RootConstrainSelectedInstOperands,
     /* 212635 */     // GIR_Coverage, 6542,
     /* 212635 */     GIR_EraseRootFromParent_Done,
     /* 212636 */   // Label 4912: @212636
     /* 212636 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(212667), // Rule ID 2218 //
     /* 212641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212656 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 212656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 212661 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212665 */     GIR_RootConstrainSelectedInstOperands,
     /* 212666 */     // GIR_Coverage, 2218,
     /* 212666 */     GIR_Done,
     /* 212667 */   // Label 4913: @212667
     /* 212667 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(212698), // Rule ID 2234 //
     /* 212672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212687 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 212687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 212692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212696 */     GIR_RootConstrainSelectedInstOperands,
     /* 212697 */     // GIR_Coverage, 2234,
     /* 212697 */     GIR_Done,
     /* 212698 */   // Label 4914: @212698
     /* 212698 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(212729), // Rule ID 6538 //
     /* 212703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212718 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 212718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 212723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212727 */     GIR_RootConstrainSelectedInstOperands,
     /* 212728 */     // GIR_Coverage, 6538,
     /* 212728 */     GIR_Done,
     /* 212729 */   // Label 4915: @212729
     /* 212729 */   GIM_Reject,
     /* 212730 */ // Label 4910: @212730
     /* 212730 */ GIM_Reject,
     /* 212731 */ // Label 4870: @212731
     /* 212731 */ GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(212960),
     /* 212736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 212739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212742 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(212804), // Rule ID 2216 //
     /* 212747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212786 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 212789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212802 */     GIR_RootConstrainSelectedInstOperands,
     /* 212803 */     // GIR_Coverage, 2216,
     /* 212803 */     GIR_EraseRootFromParent_Done,
     /* 212804 */   // Label 4917: @212804
     /* 212804 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(212866), // Rule ID 6518 //
     /* 212809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212848 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 212851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212864 */     GIR_RootConstrainSelectedInstOperands,
     /* 212865 */     // GIR_Coverage, 6518,
     /* 212865 */     GIR_EraseRootFromParent_Done,
     /* 212866 */   // Label 4918: @212866
     /* 212866 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(212897), // Rule ID 2214 //
     /* 212871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212886 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 212886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 212891 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212895 */     GIR_RootConstrainSelectedInstOperands,
     /* 212896 */     // GIR_Coverage, 2214,
     /* 212896 */     GIR_Done,
     /* 212897 */   // Label 4919: @212897
     /* 212897 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(212928), // Rule ID 2230 //
     /* 212902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 212905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212917 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 212917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 212922 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212926 */     GIR_RootConstrainSelectedInstOperands,
     /* 212927 */     // GIR_Coverage, 2230,
     /* 212927 */     GIR_Done,
     /* 212928 */   // Label 4920: @212928
     /* 212928 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(212959), // Rule ID 6514 //
     /* 212933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212948 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 212948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 212953 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212957 */     GIR_RootConstrainSelectedInstOperands,
     /* 212958 */     // GIR_Coverage, 6514,
     /* 212958 */     GIR_Done,
     /* 212959 */   // Label 4921: @212959
     /* 212959 */   GIM_Reject,
     /* 212960 */ // Label 4916: @212960
     /* 212960 */ GIM_Reject,
     /* 212961 */ // Label 4871: @212961
     /* 212961 */ GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(213159),
     /* 212966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 212969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 212972 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(213034), // Rule ID 2228 //
     /* 212977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213016 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 213019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213032 */     GIR_RootConstrainSelectedInstOperands,
     /* 213033 */     // GIR_Coverage, 2228,
     /* 213033 */     GIR_EraseRootFromParent_Done,
     /* 213034 */   // Label 4923: @213034
     /* 213034 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(213096), // Rule ID 6554 //
     /* 213039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213078 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 213081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213094 */     GIR_RootConstrainSelectedInstOperands,
     /* 213095 */     // GIR_Coverage, 6554,
     /* 213095 */     GIR_EraseRootFromParent_Done,
     /* 213096 */   // Label 4924: @213096
     /* 213096 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(213127), // Rule ID 2226 //
     /* 213101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213116 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 213116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 213121 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213125 */     GIR_RootConstrainSelectedInstOperands,
     /* 213126 */     // GIR_Coverage, 2226,
     /* 213126 */     GIR_Done,
     /* 213127 */   // Label 4925: @213127
     /* 213127 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(213158), // Rule ID 6550 //
     /* 213132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213147 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 213147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 213152 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213156 */     GIR_RootConstrainSelectedInstOperands,
     /* 213157 */     // GIR_Coverage, 6550,
     /* 213157 */     GIR_Done,
     /* 213158 */   // Label 4926: @213158
     /* 213158 */   GIM_Reject,
     /* 213159 */ // Label 4922: @213159
     /* 213159 */ GIM_Reject,
     /* 213160 */ // Label 4872: @213160
     /* 213160 */ GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(213257),
     /* 213165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 213168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213179 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(213233), // Rule ID 6578 //
     /* 213184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213215 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 213218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213231 */     GIR_RootConstrainSelectedInstOperands,
     /* 213232 */     // GIR_Coverage, 6578,
     /* 213232 */     GIR_EraseRootFromParent_Done,
     /* 213233 */   // Label 4928: @213233
     /* 213233 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(213256), // Rule ID 6574 //
     /* 213238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213245 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 213245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 213250 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213254 */     GIR_RootConstrainSelectedInstOperands,
     /* 213255 */     // GIR_Coverage, 6574,
     /* 213255 */     GIR_Done,
     /* 213256 */   // Label 4929: @213256
     /* 213256 */   GIM_Reject,
     /* 213257 */ // Label 4927: @213257
     /* 213257 */ GIM_Reject,
     /* 213258 */ // Label 4873: @213258
     /* 213258 */ GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(213456),
     /* 213263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 213266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 213269 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(213331), // Rule ID 2224 //
     /* 213274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213293 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213296 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213300 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213313 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 213316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213318 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213329 */     GIR_RootConstrainSelectedInstOperands,
     /* 213330 */     // GIR_Coverage, 2224,
     /* 213330 */     GIR_EraseRootFromParent_Done,
     /* 213331 */   // Label 4931: @213331
     /* 213331 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(213393), // Rule ID 6530 //
     /* 213336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213355 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213362 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213375 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 213378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213380 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213382 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213391 */     GIR_RootConstrainSelectedInstOperands,
     /* 213392 */     // GIR_Coverage, 6530,
     /* 213392 */     GIR_EraseRootFromParent_Done,
     /* 213393 */   // Label 4932: @213393
     /* 213393 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(213424), // Rule ID 2222 //
     /* 213398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213413 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 213413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 213418 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213422 */     GIR_RootConstrainSelectedInstOperands,
     /* 213423 */     // GIR_Coverage, 2222,
     /* 213423 */     GIR_Done,
     /* 213424 */   // Label 4933: @213424
     /* 213424 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(213455), // Rule ID 6526 //
     /* 213429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213444 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 213444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 213449 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213453 */     GIR_RootConstrainSelectedInstOperands,
     /* 213454 */     // GIR_Coverage, 6526,
     /* 213454 */     GIR_Done,
     /* 213455 */   // Label 4934: @213455
     /* 213455 */   GIM_Reject,
     /* 213456 */ // Label 4930: @213456
     /* 213456 */ GIM_Reject,
     /* 213457 */ // Label 4874: @213457
     /* 213457 */ GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(213554),
     /* 213462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 213465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 213468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213476 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(213530), // Rule ID 6506 //
     /* 213481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213512 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 213515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213528 */     GIR_RootConstrainSelectedInstOperands,
     /* 213529 */     // GIR_Coverage, 6506,
     /* 213529 */     GIR_EraseRootFromParent_Done,
     /* 213530 */   // Label 4936: @213530
     /* 213530 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(213553), // Rule ID 6502 //
     /* 213535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213542 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 213542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 213547 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213551 */     GIR_RootConstrainSelectedInstOperands,
     /* 213552 */     // GIR_Coverage, 6502,
     /* 213552 */     GIR_Done,
     /* 213553 */   // Label 4937: @213553
     /* 213553 */   GIM_Reject,
     /* 213554 */ // Label 4935: @213554
     /* 213554 */ GIM_Reject,
     /* 213555 */ // Label 4875: @213555
     /* 213555 */ GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(213652),
     /* 213560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 213563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 213566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213574 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(213628), // Rule ID 6590 //
     /* 213579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213610 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 213613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213626 */     GIR_RootConstrainSelectedInstOperands,
     /* 213627 */     // GIR_Coverage, 6590,
     /* 213627 */     GIR_EraseRootFromParent_Done,
     /* 213628 */   // Label 4939: @213628
     /* 213628 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(213651), // Rule ID 6586 //
     /* 213633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213640 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 213640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 213645 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213649 */     GIR_RootConstrainSelectedInstOperands,
     /* 213650 */     // GIR_Coverage, 6586,
     /* 213650 */     GIR_Done,
     /* 213651 */   // Label 4940: @213651
     /* 213651 */   GIM_Reject,
     /* 213652 */ // Label 4938: @213652
     /* 213652 */ GIM_Reject,
     /* 213653 */ // Label 4876: @213653
     /* 213653 */ GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(213750),
     /* 213658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 213661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 213664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213672 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(213726), // Rule ID 6494 //
     /* 213677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213708 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 213711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213715 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213724 */     GIR_RootConstrainSelectedInstOperands,
     /* 213725 */     // GIR_Coverage, 6494,
     /* 213725 */     GIR_EraseRootFromParent_Done,
     /* 213726 */   // Label 4942: @213726
     /* 213726 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(213749), // Rule ID 6490 //
     /* 213731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213738 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 213738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 213743 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213747 */     GIR_RootConstrainSelectedInstOperands,
     /* 213748 */     // GIR_Coverage, 6490,
     /* 213748 */     GIR_Done,
     /* 213749 */   // Label 4943: @213749
     /* 213749 */   GIM_Reject,
     /* 213750 */ // Label 4941: @213750
     /* 213750 */ GIM_Reject,
     /* 213751 */ // Label 4877: @213751
     /* 213751 */ GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(213848),
     /* 213756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 213759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 213762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213770 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(213824), // Rule ID 6566 //
     /* 213775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213806 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 213809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213822 */     GIR_RootConstrainSelectedInstOperands,
     /* 213823 */     // GIR_Coverage, 6566,
     /* 213823 */     GIR_EraseRootFromParent_Done,
     /* 213824 */   // Label 4945: @213824
     /* 213824 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(213847), // Rule ID 6562 //
     /* 213829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213836 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 213836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 213841 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213845 */     GIR_RootConstrainSelectedInstOperands,
     /* 213846 */     // GIR_Coverage, 6562,
     /* 213846 */     GIR_Done,
     /* 213847 */   // Label 4946: @213847
     /* 213847 */   GIM_Reject,
     /* 213848 */ // Label 4944: @213848
     /* 213848 */ GIM_Reject,
     /* 213849 */ // Label 4878: @213849
     /* 213849 */ GIM_Reject,
     /* 213850 */ // Label 70: @213850
     /* 213850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4960*/ GIMT_Encode4(218015),
     /* 213861 */ /*GILLT_s16*//*Label 4947*/ GIMT_Encode4(213945),
     /* 213865 */ /*GILLT_s32*//*Label 4948*/ GIMT_Encode4(214105),
     /* 213869 */ /*GILLT_s64*//*Label 4949*/ GIMT_Encode4(214750),
     /* 213873 */ /*GILLT_s80*//*Label 4950*/ GIMT_Encode4(215539), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213885 */ /*GILLT_v2s64*//*Label 4951*/ GIMT_Encode4(215861), GIMT_Encode4(0),
     /* 213893 */ /*GILLT_v4s32*//*Label 4952*/ GIMT_Encode4(216215),
     /* 213897 */ /*GILLT_v4s64*//*Label 4953*/ GIMT_Encode4(216569), GIMT_Encode4(0),
     /* 213905 */ /*GILLT_v8s16*//*Label 4954*/ GIMT_Encode4(216892),
     /* 213909 */ /*GILLT_v8s32*//*Label 4955*/ GIMT_Encode4(217052),
     /* 213913 */ /*GILLT_v8s64*//*Label 4956*/ GIMT_Encode4(217375), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213925 */ /*GILLT_v16s16*//*Label 4957*/ GIMT_Encode4(217535),
     /* 213929 */ /*GILLT_v16s32*//*Label 4958*/ GIMT_Encode4(217695), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213941 */ /*GILLT_v32s16*//*Label 4959*/ GIMT_Encode4(217855),
     /* 213945 */ // Label 4947: @213945
     /* 213945 */ GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(214104),
     /* 213950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 213953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 213956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213960 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(214018), // Rule ID 24255 //
     /* 213965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213976 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213983 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214000 */     // (strict_fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 214003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214016 */     GIR_RootConstrainSelectedInstOperands,
     /* 214017 */     // GIR_Coverage, 24255,
     /* 214017 */     GIR_EraseRootFromParent_Done,
     /* 214018 */   // Label 4962: @214018
     /* 214018 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(214076), // Rule ID 6011 //
     /* 214023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 214030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214038 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214041 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214045 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214058 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 214061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214063 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214074 */     GIR_RootConstrainSelectedInstOperands,
     /* 214075 */     // GIR_Coverage, 6011,
     /* 214075 */     GIR_EraseRootFromParent_Done,
     /* 214076 */   // Label 4963: @214076
     /* 214076 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(214103), // Rule ID 6009 //
     /* 214081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 214088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 214092 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 214092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 214097 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214101 */     GIR_RootConstrainSelectedInstOperands,
     /* 214102 */     // GIR_Coverage, 6009,
     /* 214102 */     GIR_Done,
     /* 214103 */   // Label 4964: @214103
     /* 214103 */   GIM_Reject,
     /* 214104 */ // Label 4961: @214104
     /* 214104 */ GIM_Reject,
     /* 214105 */ // Label 4948: @214105
     /* 214105 */ GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(214749),
     /* 214110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 214113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214116 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(214181), // Rule ID 23258 //
     /* 214121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 214124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214136 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214160 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 214163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214165 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214179 */     GIR_RootConstrainSelectedInstOperands,
     /* 214180 */     // GIR_Coverage, 23258,
     /* 214180 */     GIR_EraseRootFromParent_Done,
     /* 214181 */   // Label 4966: @214181
     /* 214181 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(214243), // Rule ID 23401 //
     /* 214186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214201 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214225 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 214228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214241 */     GIR_RootConstrainSelectedInstOperands,
     /* 214242 */     // GIR_Coverage, 23401,
     /* 214242 */     GIR_EraseRootFromParent_Done,
     /* 214243 */   // Label 4967: @214243
     /* 214243 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(214305), // Rule ID 23405 //
     /* 214248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 214251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214270 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214287 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 214290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214303 */     GIR_RootConstrainSelectedInstOperands,
     /* 214304 */     // GIR_Coverage, 23405,
     /* 214304 */     GIR_EraseRootFromParent_Done,
     /* 214305 */   // Label 4968: @214305
     /* 214305 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(214367), // Rule ID 24251 //
     /* 214310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214349 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 214352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214365 */     GIR_RootConstrainSelectedInstOperands,
     /* 214366 */     // GIR_Coverage, 24251,
     /* 214366 */     GIR_EraseRootFromParent_Done,
     /* 214367 */   // Label 4969: @214367
     /* 214367 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(214432), // Rule ID 976 //
     /* 214372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 214375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214411 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 214414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214416 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214430 */     GIR_RootConstrainSelectedInstOperands,
     /* 214431 */     // GIR_Coverage, 976,
     /* 214431 */     GIR_EraseRootFromParent_Done,
     /* 214432 */   // Label 4970: @214432
     /* 214432 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(214494), // Rule ID 2200 //
     /* 214437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214476 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 214479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214492 */     GIR_RootConstrainSelectedInstOperands,
     /* 214493 */     // GIR_Coverage, 2200,
     /* 214493 */     GIR_EraseRootFromParent_Done,
     /* 214494 */   // Label 4971: @214494
     /* 214494 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(214556), // Rule ID 2208 //
     /* 214499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 214502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214538 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 214541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214554 */     GIR_RootConstrainSelectedInstOperands,
     /* 214555 */     // GIR_Coverage, 2208,
     /* 214555 */     GIR_EraseRootFromParent_Done,
     /* 214556 */   // Label 4972: @214556
     /* 214556 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(214618), // Rule ID 5973 //
     /* 214561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214600 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 214603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214616 */     GIR_RootConstrainSelectedInstOperands,
     /* 214617 */     // GIR_Coverage, 5973,
     /* 214617 */     GIR_EraseRootFromParent_Done,
     /* 214618 */   // Label 4973: @214618
     /* 214618 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(214655), // Rule ID 898 //
     /* 214623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 214626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214638 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 214638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 214643 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 214649 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 214653 */     GIR_RootConstrainSelectedInstOperands,
     /* 214654 */     // GIR_Coverage, 898,
     /* 214654 */     GIR_Done,
     /* 214655 */   // Label 4974: @214655
     /* 214655 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(214686), // Rule ID 2198 //
     /* 214660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214675 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 214675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 214680 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214684 */     GIR_RootConstrainSelectedInstOperands,
     /* 214685 */     // GIR_Coverage, 2198,
     /* 214685 */     GIR_Done,
     /* 214686 */   // Label 4975: @214686
     /* 214686 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(214717), // Rule ID 2206 //
     /* 214691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 214694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214706 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 214706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 214711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214715 */     GIR_RootConstrainSelectedInstOperands,
     /* 214716 */     // GIR_Coverage, 2206,
     /* 214716 */     GIR_Done,
     /* 214717 */   // Label 4976: @214717
     /* 214717 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(214748), // Rule ID 5971 //
     /* 214722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214737 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 214737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 214742 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214746 */     GIR_RootConstrainSelectedInstOperands,
     /* 214747 */     // GIR_Coverage, 5971,
     /* 214747 */     GIR_Done,
     /* 214748 */   // Label 4977: @214748
     /* 214748 */   GIM_Reject,
     /* 214749 */ // Label 4965: @214749
     /* 214749 */ GIM_Reject,
     /* 214750 */ // Label 4949: @214750
     /* 214750 */ GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(215538),
     /* 214755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 214758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214761 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(214826), // Rule ID 23260 //
     /* 214766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214805 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 214808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214810 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214824 */     GIR_RootConstrainSelectedInstOperands,
     /* 214825 */     // GIR_Coverage, 23260,
     /* 214825 */     GIR_EraseRootFromParent_Done,
     /* 214826 */   // Label 4979: @214826
     /* 214826 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(214898), // Rule ID 23262 //
     /* 214831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214849 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214853 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 214860 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214877 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 214880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214896 */     GIR_RootConstrainSelectedInstOperands,
     /* 214897 */     // GIR_Coverage, 23262,
     /* 214897 */     GIR_EraseRootFromParent_Done,
     /* 214898 */   // Label 4980: @214898
     /* 214898 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(214960), // Rule ID 23403 //
     /* 214903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214942 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 214945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214947 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214958 */     GIR_RootConstrainSelectedInstOperands,
     /* 214959 */     // GIR_Coverage, 23403,
     /* 214959 */     GIR_EraseRootFromParent_Done,
     /* 214960 */   // Label 4981: @214960
     /* 214960 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(215022), // Rule ID 23407 //
     /* 214965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 214968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215004 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 215007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215020 */     GIR_RootConstrainSelectedInstOperands,
     /* 215021 */     // GIR_Coverage, 23407,
     /* 215021 */     GIR_EraseRootFromParent_Done,
     /* 215022 */   // Label 4982: @215022
     /* 215022 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(215084), // Rule ID 24253 //
     /* 215027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215066 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 215069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215082 */     GIR_RootConstrainSelectedInstOperands,
     /* 215083 */     // GIR_Coverage, 24253,
     /* 215083 */     GIR_EraseRootFromParent_Done,
     /* 215084 */   // Label 4983: @215084
     /* 215084 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(215149), // Rule ID 978 //
     /* 215089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215128 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 215131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215147 */     GIR_RootConstrainSelectedInstOperands,
     /* 215148 */     // GIR_Coverage, 978,
     /* 215148 */     GIR_EraseRootFromParent_Done,
     /* 215149 */   // Label 4984: @215149
     /* 215149 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(215221), // Rule ID 980 //
     /* 215154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215176 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215180 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215200 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 215203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215219 */     GIR_RootConstrainSelectedInstOperands,
     /* 215220 */     // GIR_Coverage, 980,
     /* 215220 */     GIR_EraseRootFromParent_Done,
     /* 215221 */   // Label 4985: @215221
     /* 215221 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(215283), // Rule ID 2204 //
     /* 215226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215265 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 215268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215281 */     GIR_RootConstrainSelectedInstOperands,
     /* 215282 */     // GIR_Coverage, 2204,
     /* 215282 */     GIR_EraseRootFromParent_Done,
     /* 215283 */   // Label 4986: @215283
     /* 215283 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(215345), // Rule ID 2212 //
     /* 215288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 215291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215307 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215327 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 215330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215343 */     GIR_RootConstrainSelectedInstOperands,
     /* 215344 */     // GIR_Coverage, 2212,
     /* 215344 */     GIR_EraseRootFromParent_Done,
     /* 215345 */   // Label 4987: @215345
     /* 215345 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(215407), // Rule ID 5992 //
     /* 215350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215389 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 215392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215405 */     GIR_RootConstrainSelectedInstOperands,
     /* 215406 */     // GIR_Coverage, 5992,
     /* 215406 */     GIR_EraseRootFromParent_Done,
     /* 215407 */   // Label 4988: @215407
     /* 215407 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(215444), // Rule ID 900 //
     /* 215412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215427 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 215427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 215432 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215438 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215442 */     GIR_RootConstrainSelectedInstOperands,
     /* 215443 */     // GIR_Coverage, 900,
     /* 215443 */     GIR_Done,
     /* 215444 */   // Label 4989: @215444
     /* 215444 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(215475), // Rule ID 2202 //
     /* 215449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215464 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 215464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 215469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215473 */     GIR_RootConstrainSelectedInstOperands,
     /* 215474 */     // GIR_Coverage, 2202,
     /* 215474 */     GIR_Done,
     /* 215475 */   // Label 4990: @215475
     /* 215475 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(215506), // Rule ID 2210 //
     /* 215480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 215483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215495 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 215495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 215500 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215504 */     GIR_RootConstrainSelectedInstOperands,
     /* 215505 */     // GIR_Coverage, 2210,
     /* 215505 */     GIR_Done,
     /* 215506 */   // Label 4991: @215506
     /* 215506 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(215537), // Rule ID 5990 //
     /* 215511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215526 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 215526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 215531 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215535 */     GIR_RootConstrainSelectedInstOperands,
     /* 215536 */     // GIR_Coverage, 5990,
     /* 215536 */     GIR_Done,
     /* 215537 */   // Label 4992: @215537
     /* 215537 */   GIM_Reject,
     /* 215538 */ // Label 4978: @215538
     /* 215538 */ GIM_Reject,
     /* 215539 */ // Label 4950: @215539
     /* 215539 */ GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(215860),
     /* 215544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 215547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 215550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215554 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(215622), // Rule ID 23264 //
     /* 215559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215573 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215577 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215601 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 215604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215620 */     GIR_RootConstrainSelectedInstOperands,
     /* 215621 */     // GIR_Coverage, 23264,
     /* 215621 */     GIR_EraseRootFromParent_Done,
     /* 215622 */   // Label 4994: @215622
     /* 215622 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(215690), // Rule ID 23266 //
     /* 215627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215641 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215645 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 215652 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215669 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 215672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215688 */     GIR_RootConstrainSelectedInstOperands,
     /* 215689 */     // GIR_Coverage, 23266,
     /* 215689 */     GIR_EraseRootFromParent_Done,
     /* 215690 */   // Label 4995: @215690
     /* 215690 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(215758), // Rule ID 982 //
     /* 215695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215710 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215713 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215717 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215724 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215737 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 215740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215756 */     GIR_RootConstrainSelectedInstOperands,
     /* 215757 */     // GIR_Coverage, 982,
     /* 215757 */     GIR_EraseRootFromParent_Done,
     /* 215758 */   // Label 4996: @215758
     /* 215758 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(215826), // Rule ID 984 //
     /* 215763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215781 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215785 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 215792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215805 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 215808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215824 */     GIR_RootConstrainSelectedInstOperands,
     /* 215825 */     // GIR_Coverage, 984,
     /* 215825 */     GIR_EraseRootFromParent_Done,
     /* 215826 */   // Label 4997: @215826
     /* 215826 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(215859), // Rule ID 902 //
     /* 215831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215842 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 215842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 215847 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215857 */     GIR_RootConstrainSelectedInstOperands,
     /* 215858 */     // GIR_Coverage, 902,
     /* 215858 */     GIR_Done,
     /* 215859 */   // Label 4998: @215859
     /* 215859 */   GIM_Reject,
     /* 215860 */ // Label 4993: @215860
     /* 215860 */ GIM_Reject,
     /* 215861 */ // Label 4951: @215861
     /* 215861 */ GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(216214),
     /* 215866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215872 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(215934), // Rule ID 23391 //
     /* 215877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215899 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215916 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 215919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215932 */     GIR_RootConstrainSelectedInstOperands,
     /* 215933 */     // GIR_Coverage, 23391,
     /* 215933 */     GIR_EraseRootFromParent_Done,
     /* 215934 */   // Label 5000: @215934
     /* 215934 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(215996), // Rule ID 24367 //
     /* 215939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215978 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 215981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215994 */     GIR_RootConstrainSelectedInstOperands,
     /* 215995 */     // GIR_Coverage, 24367,
     /* 215995 */     GIR_EraseRootFromParent_Done,
     /* 215996 */   // Label 5001: @215996
     /* 215996 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(216058), // Rule ID 2180 //
     /* 216001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216040 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 216043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216056 */     GIR_RootConstrainSelectedInstOperands,
     /* 216057 */     // GIR_Coverage, 2180,
     /* 216057 */     GIR_EraseRootFromParent_Done,
     /* 216058 */   // Label 5002: @216058
     /* 216058 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(216120), // Rule ID 6425 //
     /* 216063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216102 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 216105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216118 */     GIR_RootConstrainSelectedInstOperands,
     /* 216119 */     // GIR_Coverage, 6425,
     /* 216119 */     GIR_EraseRootFromParent_Done,
     /* 216120 */   // Label 5003: @216120
     /* 216120 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(216151), // Rule ID 2178 //
     /* 216125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216140 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 216140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 216145 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216149 */     GIR_RootConstrainSelectedInstOperands,
     /* 216150 */     // GIR_Coverage, 2178,
     /* 216150 */     GIR_Done,
     /* 216151 */   // Label 5004: @216151
     /* 216151 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(216182), // Rule ID 2194 //
     /* 216156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216171 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 216171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 216176 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216180 */     GIR_RootConstrainSelectedInstOperands,
     /* 216181 */     // GIR_Coverage, 2194,
     /* 216181 */     GIR_Done,
     /* 216182 */   // Label 5005: @216182
     /* 216182 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(216213), // Rule ID 6421 //
     /* 216187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216202 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 216202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 216207 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216211 */     GIR_RootConstrainSelectedInstOperands,
     /* 216212 */     // GIR_Coverage, 6421,
     /* 216212 */     GIR_Done,
     /* 216213 */   // Label 5006: @216213
     /* 216213 */   GIM_Reject,
     /* 216214 */ // Label 4999: @216214
     /* 216214 */ GIM_Reject,
     /* 216215 */ // Label 4952: @216215
     /* 216215 */ GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(216568),
     /* 216220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216226 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(216288), // Rule ID 23389 //
     /* 216231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216270 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 216273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216286 */     GIR_RootConstrainSelectedInstOperands,
     /* 216287 */     // GIR_Coverage, 23389,
     /* 216287 */     GIR_EraseRootFromParent_Done,
     /* 216288 */   // Label 5008: @216288
     /* 216288 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(216350), // Rule ID 24351 //
     /* 216293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216332 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 216335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216348 */     GIR_RootConstrainSelectedInstOperands,
     /* 216349 */     // GIR_Coverage, 24351,
     /* 216349 */     GIR_EraseRootFromParent_Done,
     /* 216350 */   // Label 5009: @216350
     /* 216350 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(216412), // Rule ID 2176 //
     /* 216355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216394 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 216397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216410 */     GIR_RootConstrainSelectedInstOperands,
     /* 216411 */     // GIR_Coverage, 2176,
     /* 216411 */     GIR_EraseRootFromParent_Done,
     /* 216412 */   // Label 5010: @216412
     /* 216412 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(216474), // Rule ID 6401 //
     /* 216417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216456 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 216459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216472 */     GIR_RootConstrainSelectedInstOperands,
     /* 216473 */     // GIR_Coverage, 6401,
     /* 216473 */     GIR_EraseRootFromParent_Done,
     /* 216474 */   // Label 5011: @216474
     /* 216474 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(216505), // Rule ID 2174 //
     /* 216479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216494 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 216494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 216499 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216503 */     GIR_RootConstrainSelectedInstOperands,
     /* 216504 */     // GIR_Coverage, 2174,
     /* 216504 */     GIR_Done,
     /* 216505 */   // Label 5012: @216505
     /* 216505 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(216536), // Rule ID 2190 //
     /* 216510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 216513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216525 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 216525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 216530 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216534 */     GIR_RootConstrainSelectedInstOperands,
     /* 216535 */     // GIR_Coverage, 2190,
     /* 216535 */     GIR_Done,
     /* 216536 */   // Label 5013: @216536
     /* 216536 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(216567), // Rule ID 6397 //
     /* 216541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216556 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 216556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 216561 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216565 */     GIR_RootConstrainSelectedInstOperands,
     /* 216566 */     // GIR_Coverage, 6397,
     /* 216566 */     GIR_Done,
     /* 216567 */   // Label 5014: @216567
     /* 216567 */   GIM_Reject,
     /* 216568 */ // Label 5007: @216568
     /* 216568 */ GIM_Reject,
     /* 216569 */ // Label 4953: @216569
     /* 216569 */ GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(216891),
     /* 216574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 216577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 216580 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(216642), // Rule ID 23395 //
     /* 216585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216624 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 216627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216640 */     GIR_RootConstrainSelectedInstOperands,
     /* 216641 */     // GIR_Coverage, 23395,
     /* 216641 */     GIR_EraseRootFromParent_Done,
     /* 216642 */   // Label 5016: @216642
     /* 216642 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(216704), // Rule ID 24375 //
     /* 216647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216686 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 216689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216691 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216702 */     GIR_RootConstrainSelectedInstOperands,
     /* 216703 */     // GIR_Coverage, 24375,
     /* 216703 */     GIR_EraseRootFromParent_Done,
     /* 216704 */   // Label 5017: @216704
     /* 216704 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(216766), // Rule ID 2188 //
     /* 216709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216748 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 216751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216764 */     GIR_RootConstrainSelectedInstOperands,
     /* 216765 */     // GIR_Coverage, 2188,
     /* 216765 */     GIR_EraseRootFromParent_Done,
     /* 216766 */   // Label 5018: @216766
     /* 216766 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(216828), // Rule ID 6437 //
     /* 216771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216810 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 216813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216826 */     GIR_RootConstrainSelectedInstOperands,
     /* 216827 */     // GIR_Coverage, 6437,
     /* 216827 */     GIR_EraseRootFromParent_Done,
     /* 216828 */   // Label 5019: @216828
     /* 216828 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(216859), // Rule ID 2186 //
     /* 216833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216848 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 216848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 216853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216857 */     GIR_RootConstrainSelectedInstOperands,
     /* 216858 */     // GIR_Coverage, 2186,
     /* 216858 */     GIR_Done,
     /* 216859 */   // Label 5020: @216859
     /* 216859 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(216890), // Rule ID 6433 //
     /* 216864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216879 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 216879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 216884 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216888 */     GIR_RootConstrainSelectedInstOperands,
     /* 216889 */     // GIR_Coverage, 6433,
     /* 216889 */     GIR_Done,
     /* 216890 */   // Label 5021: @216890
     /* 216890 */   GIM_Reject,
     /* 216891 */ // Label 5015: @216891
     /* 216891 */ GIM_Reject,
     /* 216892 */ // Label 4954: @216892
     /* 216892 */ GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(217051),
     /* 216897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 216900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216907 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(216965), // Rule ID 24391 //
     /* 216912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216930 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216947 */     // (strict_fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 216950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216952 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216963 */     GIR_RootConstrainSelectedInstOperands,
     /* 216964 */     // GIR_Coverage, 24391,
     /* 216964 */     GIR_EraseRootFromParent_Done,
     /* 216965 */   // Label 5023: @216965
     /* 216965 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(217023), // Rule ID 6461 //
     /* 216970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217005 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 217008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217010 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217021 */     GIR_RootConstrainSelectedInstOperands,
     /* 217022 */     // GIR_Coverage, 6461,
     /* 217022 */     GIR_EraseRootFromParent_Done,
     /* 217023 */   // Label 5024: @217023
     /* 217023 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(217050), // Rule ID 6457 //
     /* 217028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217039 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 217039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 217044 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217048 */     GIR_RootConstrainSelectedInstOperands,
     /* 217049 */     // GIR_Coverage, 6457,
     /* 217049 */     GIR_Done,
     /* 217050 */   // Label 5025: @217050
     /* 217050 */   GIM_Reject,
     /* 217051 */ // Label 5022: @217051
     /* 217051 */ GIM_Reject,
     /* 217052 */ // Label 4955: @217052
     /* 217052 */ GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(217374),
     /* 217057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 217060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 217063 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(217125), // Rule ID 23393 //
     /* 217068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217083 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217107 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 217110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217123 */     GIR_RootConstrainSelectedInstOperands,
     /* 217124 */     // GIR_Coverage, 23393,
     /* 217124 */     GIR_EraseRootFromParent_Done,
     /* 217125 */   // Label 5027: @217125
     /* 217125 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(217187), // Rule ID 24359 //
     /* 217130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217169 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 217172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217185 */     GIR_RootConstrainSelectedInstOperands,
     /* 217186 */     // GIR_Coverage, 24359,
     /* 217186 */     GIR_EraseRootFromParent_Done,
     /* 217187 */   // Label 5028: @217187
     /* 217187 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(217249), // Rule ID 2184 //
     /* 217192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217211 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217214 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217218 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217231 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 217234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217236 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217238 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217247 */     GIR_RootConstrainSelectedInstOperands,
     /* 217248 */     // GIR_Coverage, 2184,
     /* 217248 */     GIR_EraseRootFromParent_Done,
     /* 217249 */   // Label 5029: @217249
     /* 217249 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(217311), // Rule ID 6413 //
     /* 217254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217273 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217276 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217280 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217293 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 217296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217298 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217309 */     GIR_RootConstrainSelectedInstOperands,
     /* 217310 */     // GIR_Coverage, 6413,
     /* 217310 */     GIR_EraseRootFromParent_Done,
     /* 217311 */   // Label 5030: @217311
     /* 217311 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(217342), // Rule ID 2182 //
     /* 217316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217331 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 217331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 217336 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217340 */     GIR_RootConstrainSelectedInstOperands,
     /* 217341 */     // GIR_Coverage, 2182,
     /* 217341 */     GIR_Done,
     /* 217342 */   // Label 5031: @217342
     /* 217342 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(217373), // Rule ID 6409 //
     /* 217347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217362 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 217362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 217367 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217371 */     GIR_RootConstrainSelectedInstOperands,
     /* 217372 */     // GIR_Coverage, 6409,
     /* 217372 */     GIR_Done,
     /* 217373 */   // Label 5032: @217373
     /* 217373 */   GIM_Reject,
     /* 217374 */ // Label 5026: @217374
     /* 217374 */ GIM_Reject,
     /* 217375 */ // Label 4956: @217375
     /* 217375 */ GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(217534),
     /* 217380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 217383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 217386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217390 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(217448), // Rule ID 24343 //
     /* 217395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217430 */     // (strict_fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 217433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217435 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217437 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217446 */     GIR_RootConstrainSelectedInstOperands,
     /* 217447 */     // GIR_Coverage, 24343,
     /* 217447 */     GIR_EraseRootFromParent_Done,
     /* 217448 */   // Label 5034: @217448
     /* 217448 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(217506), // Rule ID 6389 //
     /* 217453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217468 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217475 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217488 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 217491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217504 */     GIR_RootConstrainSelectedInstOperands,
     /* 217505 */     // GIR_Coverage, 6389,
     /* 217505 */     GIR_EraseRootFromParent_Done,
     /* 217506 */   // Label 5035: @217506
     /* 217506 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(217533), // Rule ID 6385 //
     /* 217511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217522 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 217522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 217527 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217531 */     GIR_RootConstrainSelectedInstOperands,
     /* 217532 */     // GIR_Coverage, 6385,
     /* 217532 */     GIR_Done,
     /* 217533 */   // Label 5036: @217533
     /* 217533 */   GIM_Reject,
     /* 217534 */ // Label 5033: @217534
     /* 217534 */ GIM_Reject,
     /* 217535 */ // Label 4957: @217535
     /* 217535 */ GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(217694),
     /* 217540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 217543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 217546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217550 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(217608), // Rule ID 24399 //
     /* 217555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217573 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217590 */     // (strict_fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 217593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217606 */     GIR_RootConstrainSelectedInstOperands,
     /* 217607 */     // GIR_Coverage, 24399,
     /* 217607 */     GIR_EraseRootFromParent_Done,
     /* 217608 */   // Label 5038: @217608
     /* 217608 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(217666), // Rule ID 6473 //
     /* 217613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217648 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 217651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217664 */     GIR_RootConstrainSelectedInstOperands,
     /* 217665 */     // GIR_Coverage, 6473,
     /* 217665 */     GIR_EraseRootFromParent_Done,
     /* 217666 */   // Label 5039: @217666
     /* 217666 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(217693), // Rule ID 6469 //
     /* 217671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217682 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 217682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 217687 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217691 */     GIR_RootConstrainSelectedInstOperands,
     /* 217692 */     // GIR_Coverage, 6469,
     /* 217692 */     GIR_Done,
     /* 217693 */   // Label 5040: @217693
     /* 217693 */   GIM_Reject,
     /* 217694 */ // Label 5037: @217694
     /* 217694 */ GIM_Reject,
     /* 217695 */ // Label 4958: @217695
     /* 217695 */ GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(217854),
     /* 217700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 217703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 217706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217710 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(217768), // Rule ID 24335 //
     /* 217715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217726 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217729 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217733 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217750 */     // (strict_fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 217753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217755 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217766 */     GIR_RootConstrainSelectedInstOperands,
     /* 217767 */     // GIR_Coverage, 24335,
     /* 217767 */     GIR_EraseRootFromParent_Done,
     /* 217768 */   // Label 5042: @217768
     /* 217768 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(217826), // Rule ID 6377 //
     /* 217773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217788 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217808 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 217811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217824 */     GIR_RootConstrainSelectedInstOperands,
     /* 217825 */     // GIR_Coverage, 6377,
     /* 217825 */     GIR_EraseRootFromParent_Done,
     /* 217826 */   // Label 5043: @217826
     /* 217826 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(217853), // Rule ID 6373 //
     /* 217831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217842 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 217842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 217847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217851 */     GIR_RootConstrainSelectedInstOperands,
     /* 217852 */     // GIR_Coverage, 6373,
     /* 217852 */     GIR_Done,
     /* 217853 */   // Label 5044: @217853
     /* 217853 */   GIM_Reject,
     /* 217854 */ // Label 5041: @217854
     /* 217854 */ GIM_Reject,
     /* 217855 */ // Label 4959: @217855
     /* 217855 */ GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(218014),
     /* 217860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 217863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 217866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217870 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(217928), // Rule ID 24383 //
     /* 217875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217886 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217889 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217893 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217910 */     // (strict_fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 217913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217926 */     GIR_RootConstrainSelectedInstOperands,
     /* 217927 */     // GIR_Coverage, 24383,
     /* 217927 */     GIR_EraseRootFromParent_Done,
     /* 217928 */   // Label 5046: @217928
     /* 217928 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(217986), // Rule ID 6449 //
     /* 217933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217968 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 217971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217984 */     GIR_RootConstrainSelectedInstOperands,
     /* 217985 */     // GIR_Coverage, 6449,
     /* 217985 */     GIR_EraseRootFromParent_Done,
     /* 217986 */   // Label 5047: @217986
     /* 217986 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(218013), // Rule ID 6445 //
     /* 217991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218002 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 218002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 218007 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218011 */     GIR_RootConstrainSelectedInstOperands,
     /* 218012 */     // GIR_Coverage, 6445,
     /* 218012 */     GIR_Done,
     /* 218013 */   // Label 5048: @218013
     /* 218013 */   GIM_Reject,
     /* 218014 */ // Label 5045: @218014
     /* 218014 */ GIM_Reject,
     /* 218015 */ // Label 4960: @218015
     /* 218015 */ GIM_Reject,
     /* 218016 */ // Label 71: @218016
     /* 218016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5062*/ GIMT_Encode4(220941),
     /* 218027 */ /*GILLT_s16*//*Label 5049*/ GIMT_Encode4(218111),
     /* 218031 */ /*GILLT_s32*//*Label 5050*/ GIMT_Encode4(218209),
     /* 218035 */ /*GILLT_s64*//*Label 5051*/ GIMT_Encode4(218668),
     /* 218039 */ /*GILLT_s80*//*Label 5052*/ GIMT_Encode4(219271), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218051 */ /*GILLT_v2s64*//*Label 5053*/ GIMT_Encode4(219593), GIMT_Encode4(0),
     /* 218059 */ /*GILLT_v4s32*//*Label 5054*/ GIMT_Encode4(219823),
     /* 218063 */ /*GILLT_v4s64*//*Label 5055*/ GIMT_Encode4(220053), GIMT_Encode4(0),
     /* 218071 */ /*GILLT_v8s16*//*Label 5056*/ GIMT_Encode4(220252),
     /* 218075 */ /*GILLT_v8s32*//*Label 5057*/ GIMT_Encode4(220350),
     /* 218079 */ /*GILLT_v8s64*//*Label 5058*/ GIMT_Encode4(220549), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218091 */ /*GILLT_v16s16*//*Label 5059*/ GIMT_Encode4(220647),
     /* 218095 */ /*GILLT_v16s32*//*Label 5060*/ GIMT_Encode4(220745), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218107 */ /*GILLT_v32s16*//*Label 5061*/ GIMT_Encode4(220843),
     /* 218111 */ // Label 5049: @218111
     /* 218111 */ GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(218208),
     /* 218116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 218119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 218122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218130 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(218184), // Rule ID 6125 //
     /* 218135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218166 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 218169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218171 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218182 */     GIR_RootConstrainSelectedInstOperands,
     /* 218183 */     // GIR_Coverage, 6125,
     /* 218183 */     GIR_EraseRootFromParent_Done,
     /* 218184 */   // Label 5064: @218184
     /* 218184 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(218207), // Rule ID 6123 //
     /* 218189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218196 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 218196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 218201 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218205 */     GIR_RootConstrainSelectedInstOperands,
     /* 218206 */     // GIR_Coverage, 6123,
     /* 218206 */     GIR_Done,
     /* 218207 */   // Label 5065: @218207
     /* 218207 */   GIM_Reject,
     /* 218208 */ // Label 5063: @218208
     /* 218208 */ GIM_Reject,
     /* 218209 */ // Label 5050: @218209
     /* 218209 */ GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(218667),
     /* 218214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 218217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218220 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(218285), // Rule ID 1020 //
     /* 218225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218264 */     // (strict_fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 218267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218283 */     GIR_RootConstrainSelectedInstOperands,
     /* 218284 */     // GIR_Coverage, 1020,
     /* 218284 */     GIR_EraseRootFromParent_Done,
     /* 218285 */   // Label 5067: @218285
     /* 218285 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(218350), // Rule ID 998 //
     /* 218290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218329 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 218332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218334 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218348 */     GIR_RootConstrainSelectedInstOperands,
     /* 218349 */     // GIR_Coverage, 998,
     /* 218349 */     GIR_EraseRootFromParent_Done,
     /* 218350 */   // Label 5068: @218350
     /* 218350 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(218412), // Rule ID 2280 //
     /* 218355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218394 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 218397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218410 */     GIR_RootConstrainSelectedInstOperands,
     /* 218411 */     // GIR_Coverage, 2280,
     /* 218411 */     GIR_EraseRootFromParent_Done,
     /* 218412 */   // Label 5069: @218412
     /* 218412 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(218474), // Rule ID 2288 //
     /* 218417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 218420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218456 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 218459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218472 */     GIR_RootConstrainSelectedInstOperands,
     /* 218473 */     // GIR_Coverage, 2288,
     /* 218473 */     GIR_EraseRootFromParent_Done,
     /* 218474 */   // Label 5070: @218474
     /* 218474 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(218536), // Rule ID 6087 //
     /* 218479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218498 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218501 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218505 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218518 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 218521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218534 */     GIR_RootConstrainSelectedInstOperands,
     /* 218535 */     // GIR_Coverage, 6087,
     /* 218535 */     GIR_EraseRootFromParent_Done,
     /* 218536 */   // Label 5071: @218536
     /* 218536 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(218573), // Rule ID 904 //
     /* 218541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218556 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 218556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 218561 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 218567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 218571 */     GIR_RootConstrainSelectedInstOperands,
     /* 218572 */     // GIR_Coverage, 904,
     /* 218572 */     GIR_Done,
     /* 218573 */   // Label 5072: @218573
     /* 218573 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(218604), // Rule ID 2278 //
     /* 218578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218593 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 218593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 218598 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218602 */     GIR_RootConstrainSelectedInstOperands,
     /* 218603 */     // GIR_Coverage, 2278,
     /* 218603 */     GIR_Done,
     /* 218604 */   // Label 5073: @218604
     /* 218604 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(218635), // Rule ID 2286 //
     /* 218609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 218612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218624 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 218624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 218629 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218633 */     GIR_RootConstrainSelectedInstOperands,
     /* 218634 */     // GIR_Coverage, 2286,
     /* 218634 */     GIR_Done,
     /* 218635 */   // Label 5074: @218635
     /* 218635 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(218666), // Rule ID 6085 //
     /* 218640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218655 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 218655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 218660 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218664 */     GIR_RootConstrainSelectedInstOperands,
     /* 218665 */     // GIR_Coverage, 6085,
     /* 218665 */     GIR_Done,
     /* 218666 */   // Label 5075: @218666
     /* 218666 */   GIM_Reject,
     /* 218667 */ // Label 5066: @218667
     /* 218667 */ GIM_Reject,
     /* 218668 */ // Label 5051: @218668
     /* 218668 */ GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(219270),
     /* 218673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 218676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218679 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(218744), // Rule ID 1022 //
     /* 218684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218699 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218702 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218706 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218723 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 218726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218742 */     GIR_RootConstrainSelectedInstOperands,
     /* 218743 */     // GIR_Coverage, 1022,
     /* 218743 */     GIR_EraseRootFromParent_Done,
     /* 218744 */   // Label 5077: @218744
     /* 218744 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(218816), // Rule ID 1024 //
     /* 218749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218764 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218767 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218771 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218795 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 218798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218814 */     GIR_RootConstrainSelectedInstOperands,
     /* 218815 */     // GIR_Coverage, 1024,
     /* 218815 */     GIR_EraseRootFromParent_Done,
     /* 218816 */   // Label 5078: @218816
     /* 218816 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(218881), // Rule ID 1000 //
     /* 218821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218860 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 218863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218865 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218879 */     GIR_RootConstrainSelectedInstOperands,
     /* 218880 */     // GIR_Coverage, 1000,
     /* 218880 */     GIR_EraseRootFromParent_Done,
     /* 218881 */   // Label 5079: @218881
     /* 218881 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(218953), // Rule ID 1002 //
     /* 218886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218908 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218912 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218932 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 218935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218951 */     GIR_RootConstrainSelectedInstOperands,
     /* 218952 */     // GIR_Coverage, 1002,
     /* 218952 */     GIR_EraseRootFromParent_Done,
     /* 218953 */   // Label 5080: @218953
     /* 218953 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(219015), // Rule ID 2284 //
     /* 218958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218977 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218984 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218997 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 219000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219002 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219013 */     GIR_RootConstrainSelectedInstOperands,
     /* 219014 */     // GIR_Coverage, 2284,
     /* 219014 */     GIR_EraseRootFromParent_Done,
     /* 219015 */   // Label 5081: @219015
     /* 219015 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(219077), // Rule ID 2292 //
     /* 219020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 219023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219039 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219042 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219046 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219059 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 219062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219064 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219075 */     GIR_RootConstrainSelectedInstOperands,
     /* 219076 */     // GIR_Coverage, 2292,
     /* 219076 */     GIR_EraseRootFromParent_Done,
     /* 219077 */   // Label 5082: @219077
     /* 219077 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(219139), // Rule ID 6106 //
     /* 219082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219121 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 219124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219126 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219137 */     GIR_RootConstrainSelectedInstOperands,
     /* 219138 */     // GIR_Coverage, 6106,
     /* 219138 */     GIR_EraseRootFromParent_Done,
     /* 219139 */   // Label 5083: @219139
     /* 219139 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(219176), // Rule ID 906 //
     /* 219144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219159 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 219159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 219164 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 219170 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 219174 */     GIR_RootConstrainSelectedInstOperands,
     /* 219175 */     // GIR_Coverage, 906,
     /* 219175 */     GIR_Done,
     /* 219176 */   // Label 5084: @219176
     /* 219176 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(219207), // Rule ID 2282 //
     /* 219181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219196 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 219196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 219201 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219205 */     GIR_RootConstrainSelectedInstOperands,
     /* 219206 */     // GIR_Coverage, 2282,
     /* 219206 */     GIR_Done,
     /* 219207 */   // Label 5085: @219207
     /* 219207 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(219238), // Rule ID 2290 //
     /* 219212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 219215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219227 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 219227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 219232 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219236 */     GIR_RootConstrainSelectedInstOperands,
     /* 219237 */     // GIR_Coverage, 2290,
     /* 219237 */     GIR_Done,
     /* 219238 */   // Label 5086: @219238
     /* 219238 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(219269), // Rule ID 6104 //
     /* 219243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219258 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 219258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 219263 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219267 */     GIR_RootConstrainSelectedInstOperands,
     /* 219268 */     // GIR_Coverage, 6104,
     /* 219268 */     GIR_Done,
     /* 219269 */   // Label 5087: @219269
     /* 219269 */   GIM_Reject,
     /* 219270 */ // Label 5076: @219270
     /* 219270 */ GIM_Reject,
     /* 219271 */ // Label 5052: @219271
     /* 219271 */ GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(219592),
     /* 219276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 219279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 219282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219286 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(219354), // Rule ID 1026 //
     /* 219291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219302 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219305 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219309 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219333 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 219336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219338 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219340 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219352 */     GIR_RootConstrainSelectedInstOperands,
     /* 219353 */     // GIR_Coverage, 1026,
     /* 219353 */     GIR_EraseRootFromParent_Done,
     /* 219354 */   // Label 5089: @219354
     /* 219354 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(219422), // Rule ID 1028 //
     /* 219359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219370 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219373 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219377 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 219384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219401 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 219404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219420 */     GIR_RootConstrainSelectedInstOperands,
     /* 219421 */     // GIR_Coverage, 1028,
     /* 219421 */     GIR_EraseRootFromParent_Done,
     /* 219422 */   // Label 5090: @219422
     /* 219422 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(219490), // Rule ID 1004 //
     /* 219427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219445 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219449 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219469 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 219472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219488 */     GIR_RootConstrainSelectedInstOperands,
     /* 219489 */     // GIR_Coverage, 1004,
     /* 219489 */     GIR_EraseRootFromParent_Done,
     /* 219490 */   // Label 5091: @219490
     /* 219490 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(219558), // Rule ID 1006 //
     /* 219495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219513 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219517 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 219524 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219537 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 219540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219556 */     GIR_RootConstrainSelectedInstOperands,
     /* 219557 */     // GIR_Coverage, 1006,
     /* 219557 */     GIR_EraseRootFromParent_Done,
     /* 219558 */   // Label 5092: @219558
     /* 219558 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(219591), // Rule ID 908 //
     /* 219563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219574 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 219574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 219579 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 219585 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 219589 */     GIR_RootConstrainSelectedInstOperands,
     /* 219590 */     // GIR_Coverage, 908,
     /* 219590 */     GIR_Done,
     /* 219591 */   // Label 5093: @219591
     /* 219591 */   GIM_Reject,
     /* 219592 */ // Label 5088: @219592
     /* 219592 */ GIM_Reject,
     /* 219593 */ // Label 5053: @219593
     /* 219593 */ GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(219822),
     /* 219598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 219604 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(219666), // Rule ID 2260 //
     /* 219609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219648 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 219651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219664 */     GIR_RootConstrainSelectedInstOperands,
     /* 219665 */     // GIR_Coverage, 2260,
     /* 219665 */     GIR_EraseRootFromParent_Done,
     /* 219666 */   // Label 5095: @219666
     /* 219666 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(219728), // Rule ID 6659 //
     /* 219671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219710 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 219713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219726 */     GIR_RootConstrainSelectedInstOperands,
     /* 219727 */     // GIR_Coverage, 6659,
     /* 219727 */     GIR_EraseRootFromParent_Done,
     /* 219728 */   // Label 5096: @219728
     /* 219728 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(219759), // Rule ID 2258 //
     /* 219733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219748 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 219748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 219753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219757 */     GIR_RootConstrainSelectedInstOperands,
     /* 219758 */     // GIR_Coverage, 2258,
     /* 219758 */     GIR_Done,
     /* 219759 */   // Label 5097: @219759
     /* 219759 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(219790), // Rule ID 2274 //
     /* 219764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 219767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219779 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 219779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 219784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219788 */     GIR_RootConstrainSelectedInstOperands,
     /* 219789 */     // GIR_Coverage, 2274,
     /* 219789 */     GIR_Done,
     /* 219790 */   // Label 5098: @219790
     /* 219790 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(219821), // Rule ID 6655 //
     /* 219795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219810 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 219810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 219815 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219819 */     GIR_RootConstrainSelectedInstOperands,
     /* 219820 */     // GIR_Coverage, 6655,
     /* 219820 */     GIR_Done,
     /* 219821 */   // Label 5099: @219821
     /* 219821 */   GIM_Reject,
     /* 219822 */ // Label 5094: @219822
     /* 219822 */ GIM_Reject,
     /* 219823 */ // Label 5054: @219823
     /* 219823 */ GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(220052),
     /* 219828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219834 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(219896), // Rule ID 2256 //
     /* 219839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219878 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 219881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219894 */     GIR_RootConstrainSelectedInstOperands,
     /* 219895 */     // GIR_Coverage, 2256,
     /* 219895 */     GIR_EraseRootFromParent_Done,
     /* 219896 */   // Label 5101: @219896
     /* 219896 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(219958), // Rule ID 6635 //
     /* 219901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219940 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 219943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219956 */     GIR_RootConstrainSelectedInstOperands,
     /* 219957 */     // GIR_Coverage, 6635,
     /* 219957 */     GIR_EraseRootFromParent_Done,
     /* 219958 */   // Label 5102: @219958
     /* 219958 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(219989), // Rule ID 2254 //
     /* 219963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219978 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 219978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 219983 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219987 */     GIR_RootConstrainSelectedInstOperands,
     /* 219988 */     // GIR_Coverage, 2254,
     /* 219988 */     GIR_Done,
     /* 219989 */   // Label 5103: @219989
     /* 219989 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(220020), // Rule ID 2270 //
     /* 219994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 220001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 220005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 220009 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 220009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 220014 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220018 */     GIR_RootConstrainSelectedInstOperands,
     /* 220019 */     // GIR_Coverage, 2270,
     /* 220019 */     GIR_Done,
     /* 220020 */   // Label 5104: @220020
     /* 220020 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(220051), // Rule ID 6631 //
     /* 220025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220040 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 220040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 220045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220049 */     GIR_RootConstrainSelectedInstOperands,
     /* 220050 */     // GIR_Coverage, 6631,
     /* 220050 */     GIR_Done,
     /* 220051 */   // Label 5105: @220051
     /* 220051 */   GIM_Reject,
     /* 220052 */ // Label 5100: @220052
     /* 220052 */ GIM_Reject,
     /* 220053 */ // Label 5055: @220053
     /* 220053 */ GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(220251),
     /* 220058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 220061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 220064 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(220126), // Rule ID 2268 //
     /* 220069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220108 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 220111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220124 */     GIR_RootConstrainSelectedInstOperands,
     /* 220125 */     // GIR_Coverage, 2268,
     /* 220125 */     GIR_EraseRootFromParent_Done,
     /* 220126 */   // Label 5107: @220126
     /* 220126 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(220188), // Rule ID 6671 //
     /* 220131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220170 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 220173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220186 */     GIR_RootConstrainSelectedInstOperands,
     /* 220187 */     // GIR_Coverage, 6671,
     /* 220187 */     GIR_EraseRootFromParent_Done,
     /* 220188 */   // Label 5108: @220188
     /* 220188 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(220219), // Rule ID 2266 //
     /* 220193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220208 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 220208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 220213 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220217 */     GIR_RootConstrainSelectedInstOperands,
     /* 220218 */     // GIR_Coverage, 2266,
     /* 220218 */     GIR_Done,
     /* 220219 */   // Label 5109: @220219
     /* 220219 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(220250), // Rule ID 6667 //
     /* 220224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220239 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 220239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 220244 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220248 */     GIR_RootConstrainSelectedInstOperands,
     /* 220249 */     // GIR_Coverage, 6667,
     /* 220249 */     GIR_Done,
     /* 220250 */   // Label 5110: @220250
     /* 220250 */   GIM_Reject,
     /* 220251 */ // Label 5106: @220251
     /* 220251 */ GIM_Reject,
     /* 220252 */ // Label 5056: @220252
     /* 220252 */ GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(220349),
     /* 220257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220271 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(220325), // Rule ID 6695 //
     /* 220276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220287 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220294 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220307 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 220310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220323 */     GIR_RootConstrainSelectedInstOperands,
     /* 220324 */     // GIR_Coverage, 6695,
     /* 220324 */     GIR_EraseRootFromParent_Done,
     /* 220325 */   // Label 5112: @220325
     /* 220325 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(220348), // Rule ID 6691 //
     /* 220330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220337 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 220337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 220342 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220346 */     GIR_RootConstrainSelectedInstOperands,
     /* 220347 */     // GIR_Coverage, 6691,
     /* 220347 */     GIR_Done,
     /* 220348 */   // Label 5113: @220348
     /* 220348 */   GIM_Reject,
     /* 220349 */ // Label 5111: @220349
     /* 220349 */ GIM_Reject,
     /* 220350 */ // Label 5057: @220350
     /* 220350 */ GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(220548),
     /* 220355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 220358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 220361 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(220423), // Rule ID 2264 //
     /* 220366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220405 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 220408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220421 */     GIR_RootConstrainSelectedInstOperands,
     /* 220422 */     // GIR_Coverage, 2264,
     /* 220422 */     GIR_EraseRootFromParent_Done,
     /* 220423 */   // Label 5115: @220423
     /* 220423 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(220485), // Rule ID 6647 //
     /* 220428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220447 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220467 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 220470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220472 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220483 */     GIR_RootConstrainSelectedInstOperands,
     /* 220484 */     // GIR_Coverage, 6647,
     /* 220484 */     GIR_EraseRootFromParent_Done,
     /* 220485 */   // Label 5116: @220485
     /* 220485 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(220516), // Rule ID 2262 //
     /* 220490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220505 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 220505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 220510 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220514 */     GIR_RootConstrainSelectedInstOperands,
     /* 220515 */     // GIR_Coverage, 2262,
     /* 220515 */     GIR_Done,
     /* 220516 */   // Label 5117: @220516
     /* 220516 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(220547), // Rule ID 6643 //
     /* 220521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220536 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 220536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 220541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220545 */     GIR_RootConstrainSelectedInstOperands,
     /* 220546 */     // GIR_Coverage, 6643,
     /* 220546 */     GIR_Done,
     /* 220547 */   // Label 5118: @220547
     /* 220547 */   GIM_Reject,
     /* 220548 */ // Label 5114: @220548
     /* 220548 */ GIM_Reject,
     /* 220549 */ // Label 5058: @220549
     /* 220549 */ GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(220646),
     /* 220554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 220557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 220560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220568 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(220622), // Rule ID 6623 //
     /* 220573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220604 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 220607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220620 */     GIR_RootConstrainSelectedInstOperands,
     /* 220621 */     // GIR_Coverage, 6623,
     /* 220621 */     GIR_EraseRootFromParent_Done,
     /* 220622 */   // Label 5120: @220622
     /* 220622 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(220645), // Rule ID 6619 //
     /* 220627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220634 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 220634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 220639 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220643 */     GIR_RootConstrainSelectedInstOperands,
     /* 220644 */     // GIR_Coverage, 6619,
     /* 220644 */     GIR_Done,
     /* 220645 */   // Label 5121: @220645
     /* 220645 */   GIM_Reject,
     /* 220646 */ // Label 5119: @220646
     /* 220646 */ GIM_Reject,
     /* 220647 */ // Label 5059: @220647
     /* 220647 */ GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(220744),
     /* 220652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 220655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 220658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220666 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(220720), // Rule ID 6707 //
     /* 220671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220702 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 220705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220718 */     GIR_RootConstrainSelectedInstOperands,
     /* 220719 */     // GIR_Coverage, 6707,
     /* 220719 */     GIR_EraseRootFromParent_Done,
     /* 220720 */   // Label 5123: @220720
     /* 220720 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(220743), // Rule ID 6703 //
     /* 220725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220732 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 220732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 220737 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220741 */     GIR_RootConstrainSelectedInstOperands,
     /* 220742 */     // GIR_Coverage, 6703,
     /* 220742 */     GIR_Done,
     /* 220743 */   // Label 5124: @220743
     /* 220743 */   GIM_Reject,
     /* 220744 */ // Label 5122: @220744
     /* 220744 */ GIM_Reject,
     /* 220745 */ // Label 5060: @220745
     /* 220745 */ GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(220842),
     /* 220750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 220753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 220756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220764 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(220818), // Rule ID 6611 //
     /* 220769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220800 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 220803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220805 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220816 */     GIR_RootConstrainSelectedInstOperands,
     /* 220817 */     // GIR_Coverage, 6611,
     /* 220817 */     GIR_EraseRootFromParent_Done,
     /* 220818 */   // Label 5126: @220818
     /* 220818 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(220841), // Rule ID 6607 //
     /* 220823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220830 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 220830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 220835 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220839 */     GIR_RootConstrainSelectedInstOperands,
     /* 220840 */     // GIR_Coverage, 6607,
     /* 220840 */     GIR_Done,
     /* 220841 */   // Label 5127: @220841
     /* 220841 */   GIM_Reject,
     /* 220842 */ // Label 5125: @220842
     /* 220842 */ GIM_Reject,
     /* 220843 */ // Label 5061: @220843
     /* 220843 */ GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(220940),
     /* 220848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 220851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 220854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220862 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(220916), // Rule ID 6683 //
     /* 220867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220878 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220881 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220885 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220898 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 220901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220914 */     GIR_RootConstrainSelectedInstOperands,
     /* 220915 */     // GIR_Coverage, 6683,
     /* 220915 */     GIR_EraseRootFromParent_Done,
     /* 220916 */   // Label 5129: @220916
     /* 220916 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(220939), // Rule ID 6679 //
     /* 220921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220928 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 220928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 220933 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220937 */     GIR_RootConstrainSelectedInstOperands,
     /* 220938 */     // GIR_Coverage, 6679,
     /* 220938 */     GIR_Done,
     /* 220939 */   // Label 5130: @220939
     /* 220939 */   GIM_Reject,
     /* 220940 */ // Label 5128: @220940
     /* 220940 */ GIM_Reject,
     /* 220941 */ // Label 5062: @220941
     /* 220941 */ GIM_Reject,
     /* 220942 */ // Label 72: @220942
     /* 220942 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5143*/ GIMT_Encode4(226929),
     /* 220953 */ /*GILLT_s16*//*Label 5131*/ GIMT_Encode4(221037),
     /* 220957 */ /*GILLT_s32*//*Label 5132*/ GIMT_Encode4(221282),
     /* 220961 */ /*GILLT_s64*//*Label 5133*/ GIMT_Encode4(222019), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 220977 */ /*GILLT_v2s64*//*Label 5134*/ GIMT_Encode4(222756), GIMT_Encode4(0),
     /* 220985 */ /*GILLT_v4s32*//*Label 5135*/ GIMT_Encode4(223493),
     /* 220989 */ /*GILLT_v4s64*//*Label 5136*/ GIMT_Encode4(224230), GIMT_Encode4(0),
     /* 220997 */ /*GILLT_v8s16*//*Label 5137*/ GIMT_Encode4(224967),
     /* 221001 */ /*GILLT_v8s32*//*Label 5138*/ GIMT_Encode4(225212),
     /* 221005 */ /*GILLT_v8s64*//*Label 5139*/ GIMT_Encode4(225949), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 221017 */ /*GILLT_v16s16*//*Label 5140*/ GIMT_Encode4(226194),
     /* 221021 */ /*GILLT_v16s32*//*Label 5141*/ GIMT_Encode4(226439), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 221033 */ /*GILLT_v32s16*//*Label 5142*/ GIMT_Encode4(226684),
     /* 221037 */ // Label 5131: @221037
     /* 221037 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(221281),
     /* 221042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 221045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 221048 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 221051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221055 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(221119), // Rule ID 10157 //
     /* 221060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221099 */     // (strict_fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 221102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221106 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221117 */     GIR_RootConstrainSelectedInstOperands,
     /* 221118 */     // GIR_Coverage, 10157,
     /* 221118 */     GIR_EraseRootFromParent_Done,
     /* 221119 */   // Label 5145: @221119
     /* 221119 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(221183), // Rule ID 10155 //
     /* 221124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221139 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221163 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 221166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221168 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221181 */     GIR_RootConstrainSelectedInstOperands,
     /* 221182 */     // GIR_Coverage, 10155,
     /* 221182 */     GIR_EraseRootFromParent_Done,
     /* 221183 */   // Label 5146: @221183
     /* 221183 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(221247), // Rule ID 10152 //
     /* 221188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221227 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 221230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221245 */     GIR_RootConstrainSelectedInstOperands,
     /* 221246 */     // GIR_Coverage, 10152,
     /* 221246 */     GIR_EraseRootFromParent_Done,
     /* 221247 */   // Label 5147: @221247
     /* 221247 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(221280), // Rule ID 10150 //
     /* 221252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221267 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 221267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 221270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221276 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221278 */     GIR_RootConstrainSelectedInstOperands,
     /* 221279 */     // GIR_Coverage, 10150,
     /* 221279 */     GIR_EraseRootFromParent_Done,
     /* 221280 */   // Label 5148: @221280
     /* 221280 */   GIM_Reject,
     /* 221281 */ // Label 5144: @221281
     /* 221281 */ GIM_Reject,
     /* 221282 */ // Label 5132: @221282
     /* 221282 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(222018),
     /* 221287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 221290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 221296 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(221364), // Rule ID 1303 //
     /* 221301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221344 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 221347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221351 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221362 */     GIR_RootConstrainSelectedInstOperands,
     /* 221363 */     // GIR_Coverage, 1303,
     /* 221363 */     GIR_EraseRootFromParent_Done,
     /* 221364 */   // Label 5150: @221364
     /* 221364 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(221432), // Rule ID 10139 //
     /* 221369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221384 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221391 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221412 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 221415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221417 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221419 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221430 */     GIR_RootConstrainSelectedInstOperands,
     /* 221431 */     // GIR_Coverage, 10139,
     /* 221431 */     GIR_EraseRootFromParent_Done,
     /* 221432 */   // Label 5151: @221432
     /* 221432 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(221500), // Rule ID 23280 //
     /* 221437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221480 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 221483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221491 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221498 */     GIR_RootConstrainSelectedInstOperands,
     /* 221499 */     // GIR_Coverage, 23280,
     /* 221499 */     GIR_EraseRootFromParent_Done,
     /* 221500 */   // Label 5152: @221500
     /* 221500 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(221568), // Rule ID 1301 //
     /* 221505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221548 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 221551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221566 */     GIR_RootConstrainSelectedInstOperands,
     /* 221567 */     // GIR_Coverage, 1301,
     /* 221567 */     GIR_EraseRootFromParent_Done,
     /* 221568 */   // Label 5153: @221568
     /* 221568 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(221636), // Rule ID 1365 //
     /* 221573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221616 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 221619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221627 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221634 */     GIR_RootConstrainSelectedInstOperands,
     /* 221635 */     // GIR_Coverage, 1365,
     /* 221635 */     GIR_EraseRootFromParent_Done,
     /* 221636 */   // Label 5154: @221636
     /* 221636 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(221704), // Rule ID 10137 //
     /* 221641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221684 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 221687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221689 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221702 */     GIR_RootConstrainSelectedInstOperands,
     /* 221703 */     // GIR_Coverage, 10137,
     /* 221703 */     GIR_EraseRootFromParent_Done,
     /* 221704 */   // Label 5155: @221704
     /* 221704 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(221772), // Rule ID 1299 //
     /* 221709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221752 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 221755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221770 */     GIR_RootConstrainSelectedInstOperands,
     /* 221771 */     // GIR_Coverage, 1299,
     /* 221771 */     GIR_EraseRootFromParent_Done,
     /* 221772 */   // Label 5156: @221772
     /* 221772 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(221840), // Rule ID 1363 //
     /* 221777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221820 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 221823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221827 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 221829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221838 */     GIR_RootConstrainSelectedInstOperands,
     /* 221839 */     // GIR_Coverage, 1363,
     /* 221839 */     GIR_EraseRootFromParent_Done,
     /* 221840 */   // Label 5157: @221840
     /* 221840 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(221908), // Rule ID 10134 //
     /* 221845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221888 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 221891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221906 */     GIR_RootConstrainSelectedInstOperands,
     /* 221907 */     // GIR_Coverage, 10134,
     /* 221907 */     GIR_EraseRootFromParent_Done,
     /* 221908 */   // Label 5158: @221908
     /* 221908 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(221945), // Rule ID 1297 //
     /* 221913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221932 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 221935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221941 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221943 */     GIR_RootConstrainSelectedInstOperands,
     /* 221944 */     // GIR_Coverage, 1297,
     /* 221944 */     GIR_EraseRootFromParent_Done,
     /* 221945 */   // Label 5159: @221945
     /* 221945 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(221980), // Rule ID 1361 //
     /* 221950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221969 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 221974 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221978 */     GIR_RootConstrainSelectedInstOperands,
     /* 221979 */     // GIR_Coverage, 1361,
     /* 221979 */     GIR_Done,
     /* 221980 */   // Label 5160: @221980
     /* 221980 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(222017), // Rule ID 10132 //
     /* 221985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 222000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 222004 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 222004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 222007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222013 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222015 */     GIR_RootConstrainSelectedInstOperands,
     /* 222016 */     // GIR_Coverage, 10132,
     /* 222016 */     GIR_EraseRootFromParent_Done,
     /* 222017 */   // Label 5161: @222017
     /* 222017 */   GIM_Reject,
     /* 222018 */ // Label 5149: @222018
     /* 222018 */ GIM_Reject,
     /* 222019 */ // Label 5133: @222019
     /* 222019 */ GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(222755),
     /* 222024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 222027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 222030 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 222033 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(222101), // Rule ID 1311 //
     /* 222038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222081 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 222084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222086 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222088 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222099 */     GIR_RootConstrainSelectedInstOperands,
     /* 222100 */     // GIR_Coverage, 1311,
     /* 222100 */     GIR_EraseRootFromParent_Done,
     /* 222101 */   // Label 5163: @222101
     /* 222101 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(222169), // Rule ID 10148 //
     /* 222106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222121 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222124 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222128 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222149 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 222152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222156 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222167 */     GIR_RootConstrainSelectedInstOperands,
     /* 222168 */     // GIR_Coverage, 10148,
     /* 222168 */     GIR_EraseRootFromParent_Done,
     /* 222169 */   // Label 5164: @222169
     /* 222169 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(222237), // Rule ID 23308 //
     /* 222174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222217 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 222220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222228 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222235 */     GIR_RootConstrainSelectedInstOperands,
     /* 222236 */     // GIR_Coverage, 23308,
     /* 222236 */     GIR_EraseRootFromParent_Done,
     /* 222237 */   // Label 5165: @222237
     /* 222237 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(222305), // Rule ID 1309 //
     /* 222242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222285 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 222288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222290 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 222292 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222303 */     GIR_RootConstrainSelectedInstOperands,
     /* 222304 */     // GIR_Coverage, 1309,
     /* 222304 */     GIR_EraseRootFromParent_Done,
     /* 222305 */   // Label 5166: @222305
     /* 222305 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(222373), // Rule ID 1449 //
     /* 222310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222329 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222353 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 222356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222364 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222371 */     GIR_RootConstrainSelectedInstOperands,
     /* 222372 */     // GIR_Coverage, 1449,
     /* 222372 */     GIR_EraseRootFromParent_Done,
     /* 222373 */   // Label 5167: @222373
     /* 222373 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(222441), // Rule ID 10146 //
     /* 222378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222397 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222421 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 222424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222426 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 222428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222439 */     GIR_RootConstrainSelectedInstOperands,
     /* 222440 */     // GIR_Coverage, 10146,
     /* 222440 */     GIR_EraseRootFromParent_Done,
     /* 222441 */   // Label 5168: @222441
     /* 222441 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(222509), // Rule ID 1307 //
     /* 222446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222469 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222472 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222476 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222489 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 222492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222507 */     GIR_RootConstrainSelectedInstOperands,
     /* 222508 */     // GIR_Coverage, 1307,
     /* 222508 */     GIR_EraseRootFromParent_Done,
     /* 222509 */   // Label 5169: @222509
     /* 222509 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(222577), // Rule ID 1447 //
     /* 222514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222540 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222544 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222557 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 222560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222562 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 222566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222575 */     GIR_RootConstrainSelectedInstOperands,
     /* 222576 */     // GIR_Coverage, 1447,
     /* 222576 */     GIR_EraseRootFromParent_Done,
     /* 222577 */   // Label 5170: @222577
     /* 222577 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(222645), // Rule ID 10143 //
     /* 222582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222612 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222625 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 222628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222630 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222643 */     GIR_RootConstrainSelectedInstOperands,
     /* 222644 */     // GIR_Coverage, 10143,
     /* 222644 */     GIR_EraseRootFromParent_Done,
     /* 222645 */   // Label 5171: @222645
     /* 222645 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(222682), // Rule ID 1305 //
     /* 222650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222669 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 222672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222676 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222678 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222680 */     GIR_RootConstrainSelectedInstOperands,
     /* 222681 */     // GIR_Coverage, 1305,
     /* 222681 */     GIR_EraseRootFromParent_Done,
     /* 222682 */   // Label 5172: @222682
     /* 222682 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(222717), // Rule ID 1445 //
     /* 222687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222706 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 222711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222715 */     GIR_RootConstrainSelectedInstOperands,
     /* 222716 */     // GIR_Coverage, 1445,
     /* 222716 */     GIR_Done,
     /* 222717 */   // Label 5173: @222717
     /* 222717 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(222754), // Rule ID 10141 //
     /* 222722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222741 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 222741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 222744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222746 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222750 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222752 */     GIR_RootConstrainSelectedInstOperands,
     /* 222753 */     // GIR_Coverage, 10141,
     /* 222753 */     GIR_EraseRootFromParent_Done,
     /* 222754 */   // Label 5174: @222754
     /* 222754 */   GIM_Reject,
     /* 222755 */ // Label 5162: @222755
     /* 222755 */ GIM_Reject,
     /* 222756 */ // Label 5134: @222756
     /* 222756 */ GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(223492),
     /* 222761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 222764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 222767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 222770 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(222838), // Rule ID 1191 //
     /* 222775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222818 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 222821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222825 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222836 */     GIR_RootConstrainSelectedInstOperands,
     /* 222837 */     // GIR_Coverage, 1191,
     /* 222837 */     GIR_EraseRootFromParent_Done,
     /* 222838 */   // Label 5176: @222838
     /* 222838 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(222906), // Rule ID 9680 //
     /* 222843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222886 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 222889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222893 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222904 */     GIR_RootConstrainSelectedInstOperands,
     /* 222905 */     // GIR_Coverage, 9680,
     /* 222905 */     GIR_EraseRootFromParent_Done,
     /* 222906 */   // Label 5177: @222906
     /* 222906 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(222974), // Rule ID 23316 //
     /* 222911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 222914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222954 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 222954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 222957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222965 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222972 */     GIR_RootConstrainSelectedInstOperands,
     /* 222973 */     // GIR_Coverage, 23316,
     /* 222973 */     GIR_EraseRootFromParent_Done,
     /* 222974 */   // Label 5178: @222974
     /* 222974 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(223042), // Rule ID 1189 //
     /* 222979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222998 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223022 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 223025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223027 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223031 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223040 */     GIR_RootConstrainSelectedInstOperands,
     /* 223041 */     // GIR_Coverage, 1189,
     /* 223041 */     GIR_EraseRootFromParent_Done,
     /* 223042 */   // Label 5179: @223042
     /* 223042 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(223110), // Rule ID 1473 //
     /* 223047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223073 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223090 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 223090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 223093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223101 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223108 */     GIR_RootConstrainSelectedInstOperands,
     /* 223109 */     // GIR_Coverage, 1473,
     /* 223109 */     GIR_EraseRootFromParent_Done,
     /* 223110 */   // Label 5180: @223110
     /* 223110 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(223178), // Rule ID 9140 //
     /* 223115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223158 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 223161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223163 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223176 */     GIR_RootConstrainSelectedInstOperands,
     /* 223177 */     // GIR_Coverage, 9140,
     /* 223177 */     GIR_EraseRootFromParent_Done,
     /* 223178 */   // Label 5181: @223178
     /* 223178 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(223246), // Rule ID 1187 //
     /* 223183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223206 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223226 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 223229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223233 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223235 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223244 */     GIR_RootConstrainSelectedInstOperands,
     /* 223245 */     // GIR_Coverage, 1187,
     /* 223245 */     GIR_EraseRootFromParent_Done,
     /* 223246 */   // Label 5182: @223246
     /* 223246 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(223314), // Rule ID 1471 //
     /* 223251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223294 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 223297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223301 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 223303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223312 */     GIR_RootConstrainSelectedInstOperands,
     /* 223313 */     // GIR_Coverage, 1471,
     /* 223313 */     GIR_EraseRootFromParent_Done,
     /* 223314 */   // Label 5183: @223314
     /* 223314 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(223382), // Rule ID 8513 //
     /* 223319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223349 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223362 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 223365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223380 */     GIR_RootConstrainSelectedInstOperands,
     /* 223381 */     // GIR_Coverage, 8513,
     /* 223381 */     GIR_EraseRootFromParent_Done,
     /* 223382 */   // Label 5184: @223382
     /* 223382 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(223419), // Rule ID 1185 //
     /* 223387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223406 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 223406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 223409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223411 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223415 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223417 */     GIR_RootConstrainSelectedInstOperands,
     /* 223418 */     // GIR_Coverage, 1185,
     /* 223418 */     GIR_EraseRootFromParent_Done,
     /* 223419 */   // Label 5185: @223419
     /* 223419 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(223454), // Rule ID 1469 //
     /* 223424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223443 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 223443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 223448 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223452 */     GIR_RootConstrainSelectedInstOperands,
     /* 223453 */     // GIR_Coverage, 1469,
     /* 223453 */     GIR_Done,
     /* 223454 */   // Label 5186: @223454
     /* 223454 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(223491), // Rule ID 8509 //
     /* 223459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223478 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 223478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 223481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223487 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223489 */     GIR_RootConstrainSelectedInstOperands,
     /* 223490 */     // GIR_Coverage, 8509,
     /* 223490 */     GIR_EraseRootFromParent_Done,
     /* 223491 */   // Label 5187: @223491
     /* 223491 */   GIM_Reject,
     /* 223492 */ // Label 5175: @223492
     /* 223492 */ GIM_Reject,
     /* 223493 */ // Label 5135: @223493
     /* 223493 */ GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(224229),
     /* 223498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 223504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 223507 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(223575), // Rule ID 1143 //
     /* 223512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223527 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223534 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223555 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 223558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223562 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 223564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223573 */     GIR_RootConstrainSelectedInstOperands,
     /* 223574 */     // GIR_Coverage, 1143,
     /* 223574 */     GIR_EraseRootFromParent_Done,
     /* 223575 */   // Label 5189: @223575
     /* 223575 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(223643), // Rule ID 9648 //
     /* 223580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223595 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223602 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223623 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 223626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223630 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 223632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223641 */     GIR_RootConstrainSelectedInstOperands,
     /* 223642 */     // GIR_Coverage, 9648,
     /* 223642 */     GIR_EraseRootFromParent_Done,
     /* 223643 */   // Label 5190: @223643
     /* 223643 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(223711), // Rule ID 23288 //
     /* 223648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223691 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 223694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223696 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223702 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223709 */     GIR_RootConstrainSelectedInstOperands,
     /* 223710 */     // GIR_Coverage, 23288,
     /* 223710 */     GIR_EraseRootFromParent_Done,
     /* 223711 */   // Label 5191: @223711
     /* 223711 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(223779), // Rule ID 1141 //
     /* 223716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223759 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 223762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223764 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223777 */     GIR_RootConstrainSelectedInstOperands,
     /* 223778 */     // GIR_Coverage, 1141,
     /* 223778 */     GIR_EraseRootFromParent_Done,
     /* 223779 */   // Label 5192: @223779
     /* 223779 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(223847), // Rule ID 1389 //
     /* 223784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223827 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 223830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223832 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223838 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223845 */     GIR_RootConstrainSelectedInstOperands,
     /* 223846 */     // GIR_Coverage, 1389,
     /* 223846 */     GIR_EraseRootFromParent_Done,
     /* 223847 */   // Label 5193: @223847
     /* 223847 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(223915), // Rule ID 9108 //
     /* 223852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223895 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 223898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223900 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223913 */     GIR_RootConstrainSelectedInstOperands,
     /* 223914 */     // GIR_Coverage, 9108,
     /* 223914 */     GIR_EraseRootFromParent_Done,
     /* 223915 */   // Label 5194: @223915
     /* 223915 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(223983), // Rule ID 1139 //
     /* 223920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223963 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 223966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223981 */     GIR_RootConstrainSelectedInstOperands,
     /* 223982 */     // GIR_Coverage, 1139,
     /* 223982 */     GIR_EraseRootFromParent_Done,
     /* 223983 */   // Label 5195: @223983
     /* 223983 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(224051), // Rule ID 1387 //
     /* 223988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224011 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224014 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224018 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224031 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 224034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 224040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224049 */     GIR_RootConstrainSelectedInstOperands,
     /* 224050 */     // GIR_Coverage, 1387,
     /* 224050 */     GIR_EraseRootFromParent_Done,
     /* 224051 */   // Label 5196: @224051
     /* 224051 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(224119), // Rule ID 8474 //
     /* 224056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224099 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 224102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224106 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224117 */     GIR_RootConstrainSelectedInstOperands,
     /* 224118 */     // GIR_Coverage, 8474,
     /* 224118 */     GIR_EraseRootFromParent_Done,
     /* 224119 */   // Label 5197: @224119
     /* 224119 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(224156), // Rule ID 1137 //
     /* 224124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224143 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 224143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 224146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224152 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224154 */     GIR_RootConstrainSelectedInstOperands,
     /* 224155 */     // GIR_Coverage, 1137,
     /* 224155 */     GIR_EraseRootFromParent_Done,
     /* 224156 */   // Label 5198: @224156
     /* 224156 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(224191), // Rule ID 1385 //
     /* 224161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224180 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 224180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 224185 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224189 */     GIR_RootConstrainSelectedInstOperands,
     /* 224190 */     // GIR_Coverage, 1385,
     /* 224190 */     GIR_Done,
     /* 224191 */   // Label 5199: @224191
     /* 224191 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(224228), // Rule ID 8470 //
     /* 224196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224215 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 224215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 224218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224220 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224224 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224226 */     GIR_RootConstrainSelectedInstOperands,
     /* 224227 */     // GIR_Coverage, 8470,
     /* 224227 */     GIR_EraseRootFromParent_Done,
     /* 224228 */   // Label 5200: @224228
     /* 224228 */   GIM_Reject,
     /* 224229 */ // Label 5188: @224229
     /* 224229 */ GIM_Reject,
     /* 224230 */ // Label 5136: @224230
     /* 224230 */ GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(224966),
     /* 224235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 224238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 224241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 224244 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(224312), // Rule ID 1199 //
     /* 224249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224292 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 224295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224299 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 224301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224310 */     GIR_RootConstrainSelectedInstOperands,
     /* 224311 */     // GIR_Coverage, 1199,
     /* 224311 */     GIR_EraseRootFromParent_Done,
     /* 224312 */   // Label 5202: @224312
     /* 224312 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(224380), // Rule ID 9670 //
     /* 224317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224360 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 224363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224367 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 224369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224378 */     GIR_RootConstrainSelectedInstOperands,
     /* 224379 */     // GIR_Coverage, 9670,
     /* 224379 */     GIR_EraseRootFromParent_Done,
     /* 224380 */   // Label 5203: @224380
     /* 224380 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(224448), // Rule ID 23318 //
     /* 224385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224428 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 224431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224439 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224446 */     GIR_RootConstrainSelectedInstOperands,
     /* 224447 */     // GIR_Coverage, 23318,
     /* 224447 */     GIR_EraseRootFromParent_Done,
     /* 224448 */   // Label 5204: @224448
     /* 224448 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(224516), // Rule ID 1197 //
     /* 224453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224496 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 224499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224501 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 224503 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224514 */     GIR_RootConstrainSelectedInstOperands,
     /* 224515 */     // GIR_Coverage, 1197,
     /* 224515 */     GIR_EraseRootFromParent_Done,
     /* 224516 */   // Label 5205: @224516
     /* 224516 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(224584), // Rule ID 1479 //
     /* 224521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224564 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 224567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224575 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224582 */     GIR_RootConstrainSelectedInstOperands,
     /* 224583 */     // GIR_Coverage, 1479,
     /* 224583 */     GIR_EraseRootFromParent_Done,
     /* 224584 */   // Label 5206: @224584
     /* 224584 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(224652), // Rule ID 9130 //
     /* 224589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224632 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 224635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224637 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 224639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224650 */     GIR_RootConstrainSelectedInstOperands,
     /* 224651 */     // GIR_Coverage, 9130,
     /* 224651 */     GIR_EraseRootFromParent_Done,
     /* 224652 */   // Label 5207: @224652
     /* 224652 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(224720), // Rule ID 1195 //
     /* 224657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224680 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224700 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 224703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224718 */     GIR_RootConstrainSelectedInstOperands,
     /* 224719 */     // GIR_Coverage, 1195,
     /* 224719 */     GIR_EraseRootFromParent_Done,
     /* 224720 */   // Label 5208: @224720
     /* 224720 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(224788), // Rule ID 1477 //
     /* 224725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224748 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224755 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224768 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 224771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 224777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224786 */     GIR_RootConstrainSelectedInstOperands,
     /* 224787 */     // GIR_Coverage, 1477,
     /* 224787 */     GIR_EraseRootFromParent_Done,
     /* 224788 */   // Label 5209: @224788
     /* 224788 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(224856), // Rule ID 8501 //
     /* 224793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224836 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 224839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224854 */     GIR_RootConstrainSelectedInstOperands,
     /* 224855 */     // GIR_Coverage, 8501,
     /* 224855 */     GIR_EraseRootFromParent_Done,
     /* 224856 */   // Label 5210: @224856
     /* 224856 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(224893), // Rule ID 1193 //
     /* 224861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224880 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 224883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224889 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224891 */     GIR_RootConstrainSelectedInstOperands,
     /* 224892 */     // GIR_Coverage, 1193,
     /* 224892 */     GIR_EraseRootFromParent_Done,
     /* 224893 */   // Label 5211: @224893
     /* 224893 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(224928), // Rule ID 1475 //
     /* 224898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224917 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 224922 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224926 */     GIR_RootConstrainSelectedInstOperands,
     /* 224927 */     // GIR_Coverage, 1475,
     /* 224927 */     GIR_Done,
     /* 224928 */   // Label 5212: @224928
     /* 224928 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(224965), // Rule ID 8497 //
     /* 224933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224952 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 224952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 224955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224957 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224961 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224963 */     GIR_RootConstrainSelectedInstOperands,
     /* 224964 */     // GIR_Coverage, 8497,
     /* 224964 */     GIR_EraseRootFromParent_Done,
     /* 224965 */   // Label 5213: @224965
     /* 224965 */   GIM_Reject,
     /* 224966 */ // Label 5201: @224966
     /* 224966 */ GIM_Reject,
     /* 224967 */ // Label 5137: @224967
     /* 224967 */ GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(225211),
     /* 224972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 224975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 224978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 224981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224985 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(225049), // Rule ID 9616 //
     /* 224990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 224993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225001 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225029 */     // (strict_fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 225032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225036 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225047 */     GIR_RootConstrainSelectedInstOperands,
     /* 225048 */     // GIR_Coverage, 9616,
     /* 225048 */     GIR_EraseRootFromParent_Done,
     /* 225049 */   // Label 5215: @225049
     /* 225049 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(225113), // Rule ID 9076 //
     /* 225054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225093 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 225096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225098 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225111 */     GIR_RootConstrainSelectedInstOperands,
     /* 225112 */     // GIR_Coverage, 9076,
     /* 225112 */     GIR_EraseRootFromParent_Done,
     /* 225113 */   // Label 5216: @225113
     /* 225113 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(225177), // Rule ID 8435 //
     /* 225118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225157 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 225160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225175 */     GIR_RootConstrainSelectedInstOperands,
     /* 225176 */     // GIR_Coverage, 8435,
     /* 225176 */     GIR_EraseRootFromParent_Done,
     /* 225177 */   // Label 5217: @225177
     /* 225177 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(225210), // Rule ID 8431 //
     /* 225182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225197 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 225197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 225200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225206 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225208 */     GIR_RootConstrainSelectedInstOperands,
     /* 225209 */     // GIR_Coverage, 8431,
     /* 225209 */     GIR_EraseRootFromParent_Done,
     /* 225210 */   // Label 5218: @225210
     /* 225210 */   GIM_Reject,
     /* 225211 */ // Label 5214: @225211
     /* 225211 */ GIM_Reject,
     /* 225212 */ // Label 5138: @225212
     /* 225212 */ GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(225948),
     /* 225217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 225220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 225223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 225226 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(225294), // Rule ID 1151 //
     /* 225231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225274 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 225277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225281 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225292 */     GIR_RootConstrainSelectedInstOperands,
     /* 225293 */     // GIR_Coverage, 1151,
     /* 225293 */     GIR_EraseRootFromParent_Done,
     /* 225294 */   // Label 5220: @225294
     /* 225294 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(225362), // Rule ID 9638 //
     /* 225299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225342 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 225345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225347 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225349 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225360 */     GIR_RootConstrainSelectedInstOperands,
     /* 225361 */     // GIR_Coverage, 9638,
     /* 225361 */     GIR_EraseRootFromParent_Done,
     /* 225362 */   // Label 5221: @225362
     /* 225362 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(225430), // Rule ID 23290 //
     /* 225367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225385 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225389 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225410 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 225413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225421 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225428 */     GIR_RootConstrainSelectedInstOperands,
     /* 225429 */     // GIR_Coverage, 23290,
     /* 225429 */     GIR_EraseRootFromParent_Done,
     /* 225430 */   // Label 5222: @225430
     /* 225430 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(225498), // Rule ID 1149 //
     /* 225435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225454 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225478 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 225481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225483 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225496 */     GIR_RootConstrainSelectedInstOperands,
     /* 225497 */     // GIR_Coverage, 1149,
     /* 225497 */     GIR_EraseRootFromParent_Done,
     /* 225498 */   // Label 5223: @225498
     /* 225498 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(225566), // Rule ID 1395 //
     /* 225503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225546 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 225549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225557 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225564 */     GIR_RootConstrainSelectedInstOperands,
     /* 225565 */     // GIR_Coverage, 1395,
     /* 225565 */     GIR_EraseRootFromParent_Done,
     /* 225566 */   // Label 5224: @225566
     /* 225566 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(225634), // Rule ID 9098 //
     /* 225571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225614 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 225617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225619 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225632 */     GIR_RootConstrainSelectedInstOperands,
     /* 225633 */     // GIR_Coverage, 9098,
     /* 225633 */     GIR_EraseRootFromParent_Done,
     /* 225634 */   // Label 5225: @225634
     /* 225634 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(225702), // Rule ID 1147 //
     /* 225639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225682 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 225685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225689 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225700 */     GIR_RootConstrainSelectedInstOperands,
     /* 225701 */     // GIR_Coverage, 1147,
     /* 225701 */     GIR_EraseRootFromParent_Done,
     /* 225702 */   // Label 5226: @225702
     /* 225702 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(225770), // Rule ID 1393 //
     /* 225707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225750 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 225753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 225759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225768 */     GIR_RootConstrainSelectedInstOperands,
     /* 225769 */     // GIR_Coverage, 1393,
     /* 225769 */     GIR_EraseRootFromParent_Done,
     /* 225770 */   // Label 5227: @225770
     /* 225770 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(225838), // Rule ID 8462 //
     /* 225775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225818 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 225821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225836 */     GIR_RootConstrainSelectedInstOperands,
     /* 225837 */     // GIR_Coverage, 8462,
     /* 225837 */     GIR_EraseRootFromParent_Done,
     /* 225838 */   // Label 5228: @225838
     /* 225838 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(225875), // Rule ID 1145 //
     /* 225843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225862 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 225865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225867 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225873 */     GIR_RootConstrainSelectedInstOperands,
     /* 225874 */     // GIR_Coverage, 1145,
     /* 225874 */     GIR_EraseRootFromParent_Done,
     /* 225875 */   // Label 5229: @225875
     /* 225875 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(225910), // Rule ID 1391 //
     /* 225880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225899 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 225904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225908 */     GIR_RootConstrainSelectedInstOperands,
     /* 225909 */     // GIR_Coverage, 1391,
     /* 225909 */     GIR_Done,
     /* 225910 */   // Label 5230: @225910
     /* 225910 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(225947), // Rule ID 8458 //
     /* 225915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225934 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 225934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 225937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225943 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225945 */     GIR_RootConstrainSelectedInstOperands,
     /* 225946 */     // GIR_Coverage, 8458,
     /* 225946 */     GIR_EraseRootFromParent_Done,
     /* 225947 */   // Label 5231: @225947
     /* 225947 */   GIM_Reject,
     /* 225948 */ // Label 5219: @225948
     /* 225948 */ GIM_Reject,
     /* 225949 */ // Label 5139: @225949
     /* 225949 */ GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(226193),
     /* 225954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 225957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 225960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 225963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225967 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(226031), // Rule ID 9658 //
     /* 225972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226011 */     // (strict_fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 226014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226016 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226018 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226020 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226029 */     GIR_RootConstrainSelectedInstOperands,
     /* 226030 */     // GIR_Coverage, 9658,
     /* 226030 */     GIR_EraseRootFromParent_Done,
     /* 226031 */   // Label 5233: @226031
     /* 226031 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(226095), // Rule ID 9118 //
     /* 226036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226051 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226075 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 226078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226080 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226093 */     GIR_RootConstrainSelectedInstOperands,
     /* 226094 */     // GIR_Coverage, 9118,
     /* 226094 */     GIR_EraseRootFromParent_Done,
     /* 226095 */   // Label 5234: @226095
     /* 226095 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(226159), // Rule ID 8486 //
     /* 226100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226139 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 226142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226146 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226157 */     GIR_RootConstrainSelectedInstOperands,
     /* 226158 */     // GIR_Coverage, 8486,
     /* 226158 */     GIR_EraseRootFromParent_Done,
     /* 226159 */   // Label 5235: @226159
     /* 226159 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(226192), // Rule ID 8482 //
     /* 226164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226179 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 226179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 226182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226184 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226188 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226190 */     GIR_RootConstrainSelectedInstOperands,
     /* 226191 */     // GIR_Coverage, 8482,
     /* 226191 */     GIR_EraseRootFromParent_Done,
     /* 226192 */   // Label 5236: @226192
     /* 226192 */   GIM_Reject,
     /* 226193 */ // Label 5232: @226193
     /* 226193 */ GIM_Reject,
     /* 226194 */ // Label 5140: @226194
     /* 226194 */ GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(226438),
     /* 226199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 226202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 226205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 226208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226212 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(226276), // Rule ID 9606 //
     /* 226217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226231 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226256 */     // (strict_fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 226259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226263 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226274 */     GIR_RootConstrainSelectedInstOperands,
     /* 226275 */     // GIR_Coverage, 9606,
     /* 226275 */     GIR_EraseRootFromParent_Done,
     /* 226276 */   // Label 5238: @226276
     /* 226276 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(226340), // Rule ID 9066 //
     /* 226281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226320 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 226323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226325 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226338 */     GIR_RootConstrainSelectedInstOperands,
     /* 226339 */     // GIR_Coverage, 9066,
     /* 226339 */     GIR_EraseRootFromParent_Done,
     /* 226340 */   // Label 5239: @226340
     /* 226340 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(226404), // Rule ID 8423 //
     /* 226345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226384 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 226387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226402 */     GIR_RootConstrainSelectedInstOperands,
     /* 226403 */     // GIR_Coverage, 8423,
     /* 226403 */     GIR_EraseRootFromParent_Done,
     /* 226404 */   // Label 5240: @226404
     /* 226404 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(226437), // Rule ID 8419 //
     /* 226409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226424 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 226424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 226427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226433 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226435 */     GIR_RootConstrainSelectedInstOperands,
     /* 226436 */     // GIR_Coverage, 8419,
     /* 226436 */     GIR_EraseRootFromParent_Done,
     /* 226437 */   // Label 5241: @226437
     /* 226437 */   GIM_Reject,
     /* 226438 */ // Label 5237: @226438
     /* 226438 */ GIM_Reject,
     /* 226439 */ // Label 5141: @226439
     /* 226439 */ GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(226683),
     /* 226444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 226447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 226450 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 226453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226457 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(226521), // Rule ID 9626 //
     /* 226462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226501 */     // (strict_fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 226504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226519 */     GIR_RootConstrainSelectedInstOperands,
     /* 226520 */     // GIR_Coverage, 9626,
     /* 226520 */     GIR_EraseRootFromParent_Done,
     /* 226521 */   // Label 5243: @226521
     /* 226521 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(226585), // Rule ID 9086 //
     /* 226526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226541 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226544 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226548 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226565 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 226568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226570 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226572 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226583 */     GIR_RootConstrainSelectedInstOperands,
     /* 226584 */     // GIR_Coverage, 9086,
     /* 226584 */     GIR_EraseRootFromParent_Done,
     /* 226585 */   // Label 5244: @226585
     /* 226585 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(226649), // Rule ID 8447 //
     /* 226590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226629 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 226632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226647 */     GIR_RootConstrainSelectedInstOperands,
     /* 226648 */     // GIR_Coverage, 8447,
     /* 226648 */     GIR_EraseRootFromParent_Done,
     /* 226649 */   // Label 5245: @226649
     /* 226649 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(226682), // Rule ID 8443 //
     /* 226654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226669 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 226669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 226672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226676 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226678 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226680 */     GIR_RootConstrainSelectedInstOperands,
     /* 226681 */     // GIR_Coverage, 8443,
     /* 226681 */     GIR_EraseRootFromParent_Done,
     /* 226682 */   // Label 5246: @226682
     /* 226682 */   GIM_Reject,
     /* 226683 */ // Label 5242: @226683
     /* 226683 */ GIM_Reject,
     /* 226684 */ // Label 5142: @226684
     /* 226684 */ GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(226928),
     /* 226689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 226692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 226695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 226698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226702 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(226766), // Rule ID 9594 //
     /* 226707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226746 */     // (strict_fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 226749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226751 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226753 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226764 */     GIR_RootConstrainSelectedInstOperands,
     /* 226765 */     // GIR_Coverage, 9594,
     /* 226765 */     GIR_EraseRootFromParent_Done,
     /* 226766 */   // Label 5248: @226766
     /* 226766 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(226830), // Rule ID 9054 //
     /* 226771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226810 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 226813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226828 */     GIR_RootConstrainSelectedInstOperands,
     /* 226829 */     // GIR_Coverage, 9054,
     /* 226829 */     GIR_EraseRootFromParent_Done,
     /* 226830 */   // Label 5249: @226830
     /* 226830 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(226894), // Rule ID 8408 //
     /* 226835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226874 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 226877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226879 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226892 */     GIR_RootConstrainSelectedInstOperands,
     /* 226893 */     // GIR_Coverage, 8408,
     /* 226893 */     GIR_EraseRootFromParent_Done,
     /* 226894 */   // Label 5250: @226894
     /* 226894 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(226927), // Rule ID 8404 //
     /* 226899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226914 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 226914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 226917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226919 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226921 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226923 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226925 */     GIR_RootConstrainSelectedInstOperands,
     /* 226926 */     // GIR_Coverage, 8404,
     /* 226926 */     GIR_EraseRootFromParent_Done,
     /* 226927 */   // Label 5251: @226927
     /* 226927 */   GIM_Reject,
     /* 226928 */ // Label 5247: @226928
     /* 226928 */ GIM_Reject,
     /* 226929 */ // Label 5143: @226929
     /* 226929 */ GIM_Reject,
     /* 226930 */ // Label 73: @226930
     /* 226930 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5265*/ GIMT_Encode4(229098),
     /* 226941 */ /*GILLT_s16*//*Label 5252*/ GIMT_Encode4(227025),
     /* 226945 */ /*GILLT_s32*//*Label 5253*/ GIMT_Encode4(227146),
     /* 226949 */ /*GILLT_s64*//*Label 5254*/ GIMT_Encode4(227502),
     /* 226953 */ /*GILLT_s80*//*Label 5255*/ GIMT_Encode4(227858), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 226965 */ /*GILLT_v2s64*//*Label 5256*/ GIMT_Encode4(227895), GIMT_Encode4(0),
     /* 226973 */ /*GILLT_v4s32*//*Label 5257*/ GIMT_Encode4(228098),
     /* 226977 */ /*GILLT_v4s64*//*Label 5258*/ GIMT_Encode4(228301), GIMT_Encode4(0),
     /* 226985 */ /*GILLT_v8s16*//*Label 5259*/ GIMT_Encode4(228477),
     /* 226989 */ /*GILLT_v8s32*//*Label 5260*/ GIMT_Encode4(228566),
     /* 226993 */ /*GILLT_v8s64*//*Label 5261*/ GIMT_Encode4(228742), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227005 */ /*GILLT_v16s16*//*Label 5262*/ GIMT_Encode4(228831),
     /* 227009 */ /*GILLT_v16s32*//*Label 5263*/ GIMT_Encode4(228920), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227021 */ /*GILLT_v32s16*//*Label 5264*/ GIMT_Encode4(229009),
     /* 227025 */ // Label 5252: @227025
     /* 227025 */ GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(227145),
     /* 227030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 227033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227037 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(227106), // Rule ID 21420 //
     /* 227042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 227045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227073 */     // (strict_fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 227073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 227076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 227090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227104 */     GIR_RootConstrainSelectedInstOperands,
     /* 227105 */     // GIR_Coverage, 21420,
     /* 227105 */     GIR_EraseRootFromParent_Done,
     /* 227106 */   // Label 5267: @227106
     /* 227106 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(227144), // Rule ID 21418 //
     /* 227111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227118 */     // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 227118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 227121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 227135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227142 */     GIR_RootConstrainSelectedInstOperands,
     /* 227143 */     // GIR_Coverage, 21418,
     /* 227143 */     GIR_EraseRootFromParent_Done,
     /* 227144 */   // Label 5268: @227144
     /* 227144 */   GIM_Reject,
     /* 227145 */ // Label 5266: @227145
     /* 227145 */ GIM_Reject,
     /* 227146 */ // Label 5253: @227146
     /* 227146 */ GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(227501),
     /* 227151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 227154 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(227210), // Rule ID 2448 //
     /* 227159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 227162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227194 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 227194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 227197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 227203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227208 */     GIR_RootConstrainSelectedInstOperands,
     /* 227209 */     // GIR_Coverage, 2448,
     /* 227209 */     GIR_EraseRootFromParent_Done,
     /* 227210 */   // Label 5270: @227210
     /* 227210 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(227283), // Rule ID 18276 //
     /* 227215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 227218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227250 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 227250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 227267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227281 */     GIR_RootConstrainSelectedInstOperands,
     /* 227282 */     // GIR_Coverage, 18276,
     /* 227282 */     GIR_EraseRootFromParent_Done,
     /* 227283 */   // Label 5271: @227283
     /* 227283 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(227356), // Rule ID 21424 //
     /* 227288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 227291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227303 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227306 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227310 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227323 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 227323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 227340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227354 */     GIR_RootConstrainSelectedInstOperands,
     /* 227355 */     // GIR_Coverage, 21424,
     /* 227355 */     GIR_EraseRootFromParent_Done,
     /* 227356 */   // Label 5272: @227356
     /* 227356 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(227389), // Rule ID 1048 //
     /* 227361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 227364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 227368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 227372 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 227372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 227377 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227383 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227387 */     GIR_RootConstrainSelectedInstOperands,
     /* 227388 */     // GIR_Coverage, 1048,
     /* 227388 */     GIR_Done,
     /* 227389 */   // Label 5273: @227389
     /* 227389 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(227416), // Rule ID 2446 //
     /* 227394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 227397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227405 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 227405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 227410 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227414 */     GIR_RootConstrainSelectedInstOperands,
     /* 227415 */     // GIR_Coverage, 2446,
     /* 227415 */     GIR_Done,
     /* 227416 */   // Label 5274: @227416
     /* 227416 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(227458), // Rule ID 18274 //
     /* 227421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 227424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227432 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 227432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 227449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227456 */     GIR_RootConstrainSelectedInstOperands,
     /* 227457 */     // GIR_Coverage, 18274,
     /* 227457 */     GIR_EraseRootFromParent_Done,
     /* 227458 */   // Label 5275: @227458
     /* 227458 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(227500), // Rule ID 21422 //
     /* 227463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227474 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 227474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 227491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227498 */     GIR_RootConstrainSelectedInstOperands,
     /* 227499 */     // GIR_Coverage, 21422,
     /* 227499 */     GIR_EraseRootFromParent_Done,
     /* 227500 */   // Label 5276: @227500
     /* 227500 */   GIM_Reject,
     /* 227501 */ // Label 5269: @227501
     /* 227501 */ GIM_Reject,
     /* 227502 */ // Label 5254: @227502
     /* 227502 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(227857),
     /* 227507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 227510 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(227566), // Rule ID 2464 //
     /* 227515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 227518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227550 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 227550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 227553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 227559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227564 */     GIR_RootConstrainSelectedInstOperands,
     /* 227565 */     // GIR_Coverage, 2464,
     /* 227565 */     GIR_EraseRootFromParent_Done,
     /* 227566 */   // Label 5278: @227566
     /* 227566 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(227639), // Rule ID 18280 //
     /* 227571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 227574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227606 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 227606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 227623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227637 */     GIR_RootConstrainSelectedInstOperands,
     /* 227638 */     // GIR_Coverage, 18280,
     /* 227638 */     GIR_EraseRootFromParent_Done,
     /* 227639 */   // Label 5279: @227639
     /* 227639 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(227712), // Rule ID 21428 //
     /* 227644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 227647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227659 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227666 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227679 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 227679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 227696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227710 */     GIR_RootConstrainSelectedInstOperands,
     /* 227711 */     // GIR_Coverage, 21428,
     /* 227711 */     GIR_EraseRootFromParent_Done,
     /* 227712 */   // Label 5280: @227712
     /* 227712 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(227745), // Rule ID 1050 //
     /* 227717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 227720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 227724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 227728 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 227728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 227733 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227739 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227743 */     GIR_RootConstrainSelectedInstOperands,
     /* 227744 */     // GIR_Coverage, 1050,
     /* 227744 */     GIR_Done,
     /* 227745 */   // Label 5281: @227745
     /* 227745 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(227772), // Rule ID 2462 //
     /* 227750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 227753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227761 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 227761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 227766 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227770 */     GIR_RootConstrainSelectedInstOperands,
     /* 227771 */     // GIR_Coverage, 2462,
     /* 227771 */     GIR_Done,
     /* 227772 */   // Label 5282: @227772
     /* 227772 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(227814), // Rule ID 18278 //
     /* 227777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 227780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227788 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 227788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 227805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227812 */     GIR_RootConstrainSelectedInstOperands,
     /* 227813 */     // GIR_Coverage, 18278,
     /* 227813 */     GIR_EraseRootFromParent_Done,
     /* 227814 */   // Label 5283: @227814
     /* 227814 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(227856), // Rule ID 21426 //
     /* 227819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227830 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 227830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 227847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227854 */     GIR_RootConstrainSelectedInstOperands,
     /* 227855 */     // GIR_Coverage, 21426,
     /* 227855 */     GIR_EraseRootFromParent_Done,
     /* 227856 */   // Label 5284: @227856
     /* 227856 */   GIM_Reject,
     /* 227857 */ // Label 5277: @227857
     /* 227857 */ GIM_Reject,
     /* 227858 */ // Label 5255: @227858
     /* 227858 */ GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(227894), // Rule ID 1052 //
     /* 227863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 227866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 227869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 227873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 227877 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 227877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 227882 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227892 */   GIR_RootConstrainSelectedInstOperands,
     /* 227893 */   // GIR_Coverage, 1052,
     /* 227893 */   GIR_Done,
     /* 227894 */ // Label 5285: @227894
     /* 227894 */ GIM_Reject,
     /* 227895 */ // Label 5256: @227895
     /* 227895 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(228097),
     /* 227900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 227903 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(227959), // Rule ID 2468 //
     /* 227908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227930 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227943 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 227943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 227946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227957 */     GIR_RootConstrainSelectedInstOperands,
     /* 227958 */     // GIR_Coverage, 2468,
     /* 227958 */     GIR_EraseRootFromParent_Done,
     /* 227959 */   // Label 5287: @227959
     /* 227959 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(228015), // Rule ID 12086 //
     /* 227964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227999 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 227999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 228002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228013 */     GIR_RootConstrainSelectedInstOperands,
     /* 228014 */     // GIR_Coverage, 12086,
     /* 228014 */     GIR_EraseRootFromParent_Done,
     /* 228015 */   // Label 5288: @228015
     /* 228015 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(228042), // Rule ID 2466 //
     /* 228020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228031 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 228031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 228036 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228040 */     GIR_RootConstrainSelectedInstOperands,
     /* 228041 */     // GIR_Coverage, 2466,
     /* 228041 */     GIR_Done,
     /* 228042 */   // Label 5289: @228042
     /* 228042 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(228069), // Rule ID 2474 //
     /* 228047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 228050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228058 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 228058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 228063 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228067 */     GIR_RootConstrainSelectedInstOperands,
     /* 228068 */     // GIR_Coverage, 2474,
     /* 228068 */     GIR_Done,
     /* 228069 */   // Label 5290: @228069
     /* 228069 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(228096), // Rule ID 12082 //
     /* 228074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228085 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 228085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 228090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228094 */     GIR_RootConstrainSelectedInstOperands,
     /* 228095 */     // GIR_Coverage, 12082,
     /* 228095 */     GIR_Done,
     /* 228096 */   // Label 5291: @228096
     /* 228096 */   GIM_Reject,
     /* 228097 */ // Label 5286: @228097
     /* 228097 */ GIM_Reject,
     /* 228098 */ // Label 5257: @228098
     /* 228098 */ GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(228300),
     /* 228103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 228106 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(228162), // Rule ID 2452 //
     /* 228111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228126 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228133 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228146 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 228146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 228149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228160 */     GIR_RootConstrainSelectedInstOperands,
     /* 228161 */     // GIR_Coverage, 2452,
     /* 228161 */     GIR_EraseRootFromParent_Done,
     /* 228162 */   // Label 5293: @228162
     /* 228162 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(228218), // Rule ID 12062 //
     /* 228167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228202 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 228202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 228205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228216 */     GIR_RootConstrainSelectedInstOperands,
     /* 228217 */     // GIR_Coverage, 12062,
     /* 228217 */     GIR_EraseRootFromParent_Done,
     /* 228218 */   // Label 5294: @228218
     /* 228218 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(228245), // Rule ID 2450 //
     /* 228223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228234 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 228234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 228239 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228243 */     GIR_RootConstrainSelectedInstOperands,
     /* 228244 */     // GIR_Coverage, 2450,
     /* 228244 */     GIR_Done,
     /* 228245 */   // Label 5295: @228245
     /* 228245 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(228272), // Rule ID 2458 //
     /* 228250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 228253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228261 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 228261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 228266 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228270 */     GIR_RootConstrainSelectedInstOperands,
     /* 228271 */     // GIR_Coverage, 2458,
     /* 228271 */     GIR_Done,
     /* 228272 */   // Label 5296: @228272
     /* 228272 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(228299), // Rule ID 12058 //
     /* 228277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228288 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 228288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 228293 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228297 */     GIR_RootConstrainSelectedInstOperands,
     /* 228298 */     // GIR_Coverage, 12058,
     /* 228298 */     GIR_Done,
     /* 228299 */   // Label 5297: @228299
     /* 228299 */   GIM_Reject,
     /* 228300 */ // Label 5292: @228300
     /* 228300 */ GIM_Reject,
     /* 228301 */ // Label 5258: @228301
     /* 228301 */ GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(228476),
     /* 228306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 228309 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(228365), // Rule ID 2472 //
     /* 228314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228329 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228349 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 228349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 228352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228363 */     GIR_RootConstrainSelectedInstOperands,
     /* 228364 */     // GIR_Coverage, 2472,
     /* 228364 */     GIR_EraseRootFromParent_Done,
     /* 228365 */   // Label 5299: @228365
     /* 228365 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(228421), // Rule ID 12098 //
     /* 228370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228405 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 228405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 228408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228419 */     GIR_RootConstrainSelectedInstOperands,
     /* 228420 */     // GIR_Coverage, 12098,
     /* 228420 */     GIR_EraseRootFromParent_Done,
     /* 228421 */   // Label 5300: @228421
     /* 228421 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(228448), // Rule ID 2470 //
     /* 228426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228437 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 228437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 228442 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228446 */     GIR_RootConstrainSelectedInstOperands,
     /* 228447 */     // GIR_Coverage, 2470,
     /* 228447 */     GIR_Done,
     /* 228448 */   // Label 5301: @228448
     /* 228448 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(228475), // Rule ID 12094 //
     /* 228453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228464 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 228464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 228469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228473 */     GIR_RootConstrainSelectedInstOperands,
     /* 228474 */     // GIR_Coverage, 12094,
     /* 228474 */     GIR_Done,
     /* 228475 */   // Label 5302: @228475
     /* 228475 */   GIM_Reject,
     /* 228476 */ // Label 5298: @228476
     /* 228476 */ GIM_Reject,
     /* 228477 */ // Label 5259: @228477
     /* 228477 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(228565),
     /* 228482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 228485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228489 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(228541), // Rule ID 12014 //
     /* 228494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228505 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228512 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228525 */     // (strict_fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 228525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 228528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228539 */     GIR_RootConstrainSelectedInstOperands,
     /* 228540 */     // GIR_Coverage, 12014,
     /* 228540 */     GIR_EraseRootFromParent_Done,
     /* 228541 */   // Label 5304: @228541
     /* 228541 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(228564), // Rule ID 12010 //
     /* 228546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228553 */     // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 228553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 228558 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228562 */     GIR_RootConstrainSelectedInstOperands,
     /* 228563 */     // GIR_Coverage, 12010,
     /* 228563 */     GIR_Done,
     /* 228564 */   // Label 5305: @228564
     /* 228564 */   GIM_Reject,
     /* 228565 */ // Label 5303: @228565
     /* 228565 */ GIM_Reject,
     /* 228566 */ // Label 5260: @228566
     /* 228566 */ GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(228741),
     /* 228571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 228574 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(228630), // Rule ID 2456 //
     /* 228579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228594 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228601 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228614 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 228614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 228617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228628 */     GIR_RootConstrainSelectedInstOperands,
     /* 228629 */     // GIR_Coverage, 2456,
     /* 228629 */     GIR_EraseRootFromParent_Done,
     /* 228630 */   // Label 5307: @228630
     /* 228630 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(228686), // Rule ID 12074 //
     /* 228635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228670 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 228670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 228673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228684 */     GIR_RootConstrainSelectedInstOperands,
     /* 228685 */     // GIR_Coverage, 12074,
     /* 228685 */     GIR_EraseRootFromParent_Done,
     /* 228686 */   // Label 5308: @228686
     /* 228686 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(228713), // Rule ID 2454 //
     /* 228691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228702 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 228702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 228707 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228711 */     GIR_RootConstrainSelectedInstOperands,
     /* 228712 */     // GIR_Coverage, 2454,
     /* 228712 */     GIR_Done,
     /* 228713 */   // Label 5309: @228713
     /* 228713 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(228740), // Rule ID 12070 //
     /* 228718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228729 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 228729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 228734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228738 */     GIR_RootConstrainSelectedInstOperands,
     /* 228739 */     // GIR_Coverage, 12070,
     /* 228739 */     GIR_Done,
     /* 228740 */   // Label 5310: @228740
     /* 228740 */   GIM_Reject,
     /* 228741 */ // Label 5306: @228741
     /* 228741 */ GIM_Reject,
     /* 228742 */ // Label 5261: @228742
     /* 228742 */ GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(228830),
     /* 228747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 228750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228754 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(228806), // Rule ID 12050 //
     /* 228759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228770 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228790 */     // (strict_fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 228790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 228793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228795 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228804 */     GIR_RootConstrainSelectedInstOperands,
     /* 228805 */     // GIR_Coverage, 12050,
     /* 228805 */     GIR_EraseRootFromParent_Done,
     /* 228806 */   // Label 5312: @228806
     /* 228806 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(228829), // Rule ID 12046 //
     /* 228811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228818 */     // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 228818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 228823 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228827 */     GIR_RootConstrainSelectedInstOperands,
     /* 228828 */     // GIR_Coverage, 12046,
     /* 228828 */     GIR_Done,
     /* 228829 */   // Label 5313: @228829
     /* 228829 */   GIM_Reject,
     /* 228830 */ // Label 5311: @228830
     /* 228830 */ GIM_Reject,
     /* 228831 */ // Label 5262: @228831
     /* 228831 */ GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(228919),
     /* 228836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 228839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228843 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(228895), // Rule ID 12026 //
     /* 228848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228879 */     // (strict_fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 228879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 228882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228893 */     GIR_RootConstrainSelectedInstOperands,
     /* 228894 */     // GIR_Coverage, 12026,
     /* 228894 */     GIR_EraseRootFromParent_Done,
     /* 228895 */   // Label 5315: @228895
     /* 228895 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(228918), // Rule ID 12022 //
     /* 228900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228907 */     // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 228907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 228912 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228916 */     GIR_RootConstrainSelectedInstOperands,
     /* 228917 */     // GIR_Coverage, 12022,
     /* 228917 */     GIR_Done,
     /* 228918 */   // Label 5316: @228918
     /* 228918 */   GIM_Reject,
     /* 228919 */ // Label 5314: @228919
     /* 228919 */ GIM_Reject,
     /* 228920 */ // Label 5263: @228920
     /* 228920 */ GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(229008),
     /* 228925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 228928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228932 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(228984), // Rule ID 12038 //
     /* 228937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228968 */     // (strict_fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 228968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 228971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228982 */     GIR_RootConstrainSelectedInstOperands,
     /* 228983 */     // GIR_Coverage, 12038,
     /* 228983 */     GIR_EraseRootFromParent_Done,
     /* 228984 */   // Label 5318: @228984
     /* 228984 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(229007), // Rule ID 12034 //
     /* 228989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228996 */     // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 228996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 229001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229005 */     GIR_RootConstrainSelectedInstOperands,
     /* 229006 */     // GIR_Coverage, 12034,
     /* 229006 */     GIR_Done,
     /* 229007 */   // Label 5319: @229007
     /* 229007 */   GIM_Reject,
     /* 229008 */ // Label 5317: @229008
     /* 229008 */ GIM_Reject,
     /* 229009 */ // Label 5264: @229009
     /* 229009 */ GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(229097),
     /* 229014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 229017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 229021 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(229073), // Rule ID 12002 //
     /* 229026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 229029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229057 */     // (strict_fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 229057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 229060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 229066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229071 */     GIR_RootConstrainSelectedInstOperands,
     /* 229072 */     // GIR_Coverage, 12002,
     /* 229072 */     GIR_EraseRootFromParent_Done,
     /* 229073 */   // Label 5321: @229073
     /* 229073 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(229096), // Rule ID 11998 //
     /* 229078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 229081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 229085 */     // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 229085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 229090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229094 */     GIR_RootConstrainSelectedInstOperands,
     /* 229095 */     // GIR_Coverage, 11998,
     /* 229095 */     GIR_Done,
     /* 229096 */   // Label 5322: @229096
     /* 229096 */   GIM_Reject,
     /* 229097 */ // Label 5320: @229097
     /* 229097 */ GIM_Reject,
     /* 229098 */ // Label 5265: @229098
     /* 229098 */ GIM_Reject,
     /* 229099 */ // Label 74: @229099
     /* 229099 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(229111), // Rule ID 17074 //
     /* 229104 */   // (trap)  =>  (TRAP)
     /* 229104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 229109 */   GIR_RootConstrainSelectedInstOperands,
     /* 229110 */   // GIR_Coverage, 17074,
     /* 229110 */   GIR_Done,
     /* 229111 */ // Label 5323: @229111
     /* 229111 */ GIM_Reject,
     /* 229112 */ // Label 75: @229112
     /* 229112 */ GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(229127), // Rule ID 22377 //
     /* 229117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 229120 */   // (debugtrap)  =>  (INT3)
     /* 229120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 229125 */   GIR_RootConstrainSelectedInstOperands,
     /* 229126 */   // GIR_Coverage, 22377,
     /* 229126 */   GIR_Done,
     /* 229127 */ // Label 5324: @229127
     /* 229127 */ GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(229147), // Rule ID 22378 //
     /* 229132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 229135 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 229135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 229138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 229141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229145 */   GIR_RootConstrainSelectedInstOperands,
     /* 229146 */   // GIR_Coverage, 22378,
     /* 229146 */   GIR_EraseRootFromParent_Done,
     /* 229147 */ // Label 5325: @229147
     /* 229147 */ GIM_Reject,
     /* 229148 */ // Label 76: @229148
     /* 229148 */ GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(229163), // Rule ID 17076 //
     /* 229153 */   // MIs[0] kind
     /* 229153 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 229156 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 229156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 229161 */   GIR_RootConstrainSelectedInstOperands,
     /* 229162 */   // GIR_Coverage, 17076,
     /* 229162 */   GIR_Done,
     /* 229163 */ // Label 5326: @229163
     /* 229163 */ GIM_Reject,
     /* 229164 */ // Label 77: @229164
     /* 229164 */ GIM_Reject,
     /* 229165 */ }; // Size: 229165 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
